"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __esm = (fn, res) => function __init() {
  return fn && (res = (0, fn[__getOwnPropNames(fn)[0]])(fn = 0)), res;
};
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// ../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/utils.js
var require_utils = __commonJS({
  "../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/utils.js"(exports2) {
    "use strict";
    exports2.removeLeadingAndTrailingHTTPWhitespace = (string3) => {
      return string3.replace(/^[ \t\n\r]+/u, "").replace(/[ \t\n\r]+$/u, "");
    };
    exports2.removeTrailingHTTPWhitespace = (string3) => {
      return string3.replace(/[ \t\n\r]+$/u, "");
    };
    exports2.isHTTPWhitespaceChar = (char) => {
      return char === " " || char === "	" || char === "\n" || char === "\r";
    };
    exports2.solelyContainsHTTPTokenCodePoints = (string3) => {
      return /^[-!#$%&'*+.^_`|~A-Za-z0-9]*$/u.test(string3);
    };
    exports2.soleyContainsHTTPQuotedStringTokenCodePoints = (string3) => {
      return /^[\t\u0020-\u007E\u0080-\u00FF]*$/u.test(string3);
    };
    exports2.asciiLowercase = (string3) => {
      return string3.replace(/[A-Z]/ug, (l) => l.toLowerCase());
    };
    exports2.collectAnHTTPQuotedString = (input, position) => {
      let value = "";
      position++;
      while (true) {
        while (position < input.length && input[position] !== '"' && input[position] !== "\\") {
          value += input[position];
          ++position;
        }
        if (position >= input.length) {
          break;
        }
        const quoteOrBackslash = input[position];
        ++position;
        if (quoteOrBackslash === "\\") {
          if (position >= input.length) {
            value += "\\";
            break;
          }
          value += input[position];
          ++position;
        } else {
          break;
        }
      }
      return [value, position];
    };
  }
});

// ../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/mime-type-parameters.js
var require_mime_type_parameters = __commonJS({
  "../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/mime-type-parameters.js"(exports2, module2) {
    "use strict";
    var {
      asciiLowercase,
      solelyContainsHTTPTokenCodePoints,
      soleyContainsHTTPQuotedStringTokenCodePoints
    } = require_utils();
    module2.exports = class MIMETypeParameters {
      constructor(map2) {
        this._map = map2;
      }
      get size() {
        return this._map.size;
      }
      get(name) {
        name = asciiLowercase(String(name));
        return this._map.get(name);
      }
      has(name) {
        name = asciiLowercase(String(name));
        return this._map.has(name);
      }
      set(name, value) {
        name = asciiLowercase(String(name));
        value = String(value);
        if (!solelyContainsHTTPTokenCodePoints(name)) {
          throw new Error(`Invalid MIME type parameter name "${name}": only HTTP token code points are valid.`);
        }
        if (!soleyContainsHTTPQuotedStringTokenCodePoints(value)) {
          throw new Error(`Invalid MIME type parameter value "${value}": only HTTP quoted-string token code points are valid.`);
        }
        return this._map.set(name, value);
      }
      clear() {
        this._map.clear();
      }
      delete(name) {
        name = asciiLowercase(String(name));
        return this._map.delete(name);
      }
      forEach(callbackFn, thisArg) {
        this._map.forEach(callbackFn, thisArg);
      }
      keys() {
        return this._map.keys();
      }
      values() {
        return this._map.values();
      }
      entries() {
        return this._map.entries();
      }
      [Symbol.iterator]() {
        return this._map[Symbol.iterator]();
      }
    };
  }
});

// ../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/parser.js
var require_parser = __commonJS({
  "../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/parser.js"(exports2, module2) {
    "use strict";
    var {
      removeLeadingAndTrailingHTTPWhitespace,
      removeTrailingHTTPWhitespace,
      isHTTPWhitespaceChar,
      solelyContainsHTTPTokenCodePoints,
      soleyContainsHTTPQuotedStringTokenCodePoints,
      asciiLowercase,
      collectAnHTTPQuotedString
    } = require_utils();
    module2.exports = (input) => {
      input = removeLeadingAndTrailingHTTPWhitespace(input);
      let position = 0;
      let type2 = "";
      while (position < input.length && input[position] !== "/") {
        type2 += input[position];
        ++position;
      }
      if (type2.length === 0 || !solelyContainsHTTPTokenCodePoints(type2)) {
        return null;
      }
      if (position >= input.length) {
        return null;
      }
      ++position;
      let subtype = "";
      while (position < input.length && input[position] !== ";") {
        subtype += input[position];
        ++position;
      }
      subtype = removeTrailingHTTPWhitespace(subtype);
      if (subtype.length === 0 || !solelyContainsHTTPTokenCodePoints(subtype)) {
        return null;
      }
      const mimeType = {
        type: asciiLowercase(type2),
        subtype: asciiLowercase(subtype),
        parameters: /* @__PURE__ */ new Map()
      };
      while (position < input.length) {
        ++position;
        while (isHTTPWhitespaceChar(input[position])) {
          ++position;
        }
        let parameterName = "";
        while (position < input.length && input[position] !== ";" && input[position] !== "=") {
          parameterName += input[position];
          ++position;
        }
        parameterName = asciiLowercase(parameterName);
        if (position < input.length) {
          if (input[position] === ";") {
            continue;
          }
          ++position;
        }
        let parameterValue = null;
        if (input[position] === '"') {
          [parameterValue, position] = collectAnHTTPQuotedString(input, position);
          while (position < input.length && input[position] !== ";") {
            ++position;
          }
        } else {
          parameterValue = "";
          while (position < input.length && input[position] !== ";") {
            parameterValue += input[position];
            ++position;
          }
          parameterValue = removeTrailingHTTPWhitespace(parameterValue);
          if (parameterValue === "") {
            continue;
          }
        }
        if (parameterName.length > 0 && solelyContainsHTTPTokenCodePoints(parameterName) && soleyContainsHTTPQuotedStringTokenCodePoints(parameterValue) && !mimeType.parameters.has(parameterName)) {
          mimeType.parameters.set(parameterName, parameterValue);
        }
      }
      return mimeType;
    };
  }
});

// ../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/serializer.js
var require_serializer = __commonJS({
  "../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/serializer.js"(exports2, module2) {
    "use strict";
    var { solelyContainsHTTPTokenCodePoints } = require_utils();
    module2.exports = (mimeType) => {
      let serialization = `${mimeType.type}/${mimeType.subtype}`;
      if (mimeType.parameters.size === 0) {
        return serialization;
      }
      for (let [name, value] of mimeType.parameters) {
        serialization += ";";
        serialization += name;
        serialization += "=";
        if (!solelyContainsHTTPTokenCodePoints(value) || value.length === 0) {
          value = value.replace(/(["\\])/ug, "\\$1");
          value = `"${value}"`;
        }
        serialization += value;
      }
      return serialization;
    };
  }
});

// ../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/mime-type.js
var require_mime_type = __commonJS({
  "../../../node_modules/.pnpm/whatwg-mimetype@4.0.0/node_modules/whatwg-mimetype/lib/mime-type.js"(exports2, module2) {
    "use strict";
    var MIMETypeParameters = require_mime_type_parameters();
    var parse2 = require_parser();
    var serialize = require_serializer();
    var {
      asciiLowercase,
      solelyContainsHTTPTokenCodePoints
    } = require_utils();
    module2.exports = class MIMEType {
      constructor(string3) {
        string3 = String(string3);
        const result = parse2(string3);
        if (result === null) {
          throw new Error(`Could not parse MIME type string "${string3}"`);
        }
        this._type = result.type;
        this._subtype = result.subtype;
        this._parameters = new MIMETypeParameters(result.parameters);
      }
      static parse(string3) {
        try {
          return new this(string3);
        } catch (e) {
          return null;
        }
      }
      get essence() {
        return `${this.type}/${this.subtype}`;
      }
      get type() {
        return this._type;
      }
      set type(value) {
        value = asciiLowercase(String(value));
        if (value.length === 0) {
          throw new Error("Invalid type: must be a non-empty string");
        }
        if (!solelyContainsHTTPTokenCodePoints(value)) {
          throw new Error(`Invalid type ${value}: must contain only HTTP token code points`);
        }
        this._type = value;
      }
      get subtype() {
        return this._subtype;
      }
      set subtype(value) {
        value = asciiLowercase(String(value));
        if (value.length === 0) {
          throw new Error("Invalid subtype: must be a non-empty string");
        }
        if (!solelyContainsHTTPTokenCodePoints(value)) {
          throw new Error(`Invalid subtype ${value}: must contain only HTTP token code points`);
        }
        this._subtype = value;
      }
      get parameters() {
        return this._parameters;
      }
      toString() {
        return serialize(this);
      }
      isJavaScript({ prohibitParameters = false } = {}) {
        switch (this._type) {
          case "text": {
            switch (this._subtype) {
              case "ecmascript":
              case "javascript":
              case "javascript1.0":
              case "javascript1.1":
              case "javascript1.2":
              case "javascript1.3":
              case "javascript1.4":
              case "javascript1.5":
              case "jscript":
              case "livescript":
              case "x-ecmascript":
              case "x-javascript": {
                return !prohibitParameters || this._parameters.size === 0;
              }
              default: {
                return false;
              }
            }
          }
          case "application": {
            switch (this._subtype) {
              case "ecmascript":
              case "javascript":
              case "x-ecmascript":
              case "x-javascript": {
                return !prohibitParameters || this._parameters.size === 0;
              }
              default: {
                return false;
              }
            }
          }
          default: {
            return false;
          }
        }
      }
      isXML() {
        return this._subtype === "xml" && (this._type === "text" || this._type === "application") || this._subtype.endsWith("+xml");
      }
      isHTML() {
        return this._subtype === "html" && this._type === "text";
      }
    };
  }
});

// ../../../node_modules/.pnpm/minimatch@5.1.0/node_modules/minimatch/lib/path.js
var require_path = __commonJS({
  "../../../node_modules/.pnpm/minimatch@5.1.0/node_modules/minimatch/lib/path.js"(exports2, module2) {
    "use strict";
    var isWindows = typeof process === "object" && process && process.platform === "win32";
    module2.exports = isWindows ? { sep: "\\" } : { sep: "/" };
  }
});

// ../../../node_modules/.pnpm/balanced-match@1.0.2/node_modules/balanced-match/index.js
var require_balanced_match = __commonJS({
  "../../../node_modules/.pnpm/balanced-match@1.0.2/node_modules/balanced-match/index.js"(exports2, module2) {
    "use strict";
    module2.exports = balanced;
    function balanced(a, b, str2) {
      if (a instanceof RegExp) a = maybeMatch(a, str2);
      if (b instanceof RegExp) b = maybeMatch(b, str2);
      var r = range(a, b, str2);
      return r && {
        start: r[0],
        end: r[1],
        pre: str2.slice(0, r[0]),
        body: str2.slice(r[0] + a.length, r[1]),
        post: str2.slice(r[1] + b.length)
      };
    }
    function maybeMatch(reg, str2) {
      var m = str2.match(reg);
      return m ? m[0] : null;
    }
    balanced.range = range;
    function range(a, b, str2) {
      var begs, beg, left, right, result;
      var ai = str2.indexOf(a);
      var bi = str2.indexOf(b, ai + 1);
      var i = ai;
      if (ai >= 0 && bi > 0) {
        if (a === b) {
          return [ai, bi];
        }
        begs = [];
        left = str2.length;
        while (i >= 0 && !result) {
          if (i == ai) {
            begs.push(i);
            ai = str2.indexOf(a, i + 1);
          } else if (begs.length == 1) {
            result = [begs.pop(), bi];
          } else {
            beg = begs.pop();
            if (beg < left) {
              left = beg;
              right = bi;
            }
            bi = str2.indexOf(b, i + 1);
          }
          i = ai < bi && ai >= 0 ? ai : bi;
        }
        if (begs.length) {
          result = [left, right];
        }
      }
      return result;
    }
  }
});

// ../../../node_modules/.pnpm/brace-expansion@2.0.1/node_modules/brace-expansion/index.js
var require_brace_expansion = __commonJS({
  "../../../node_modules/.pnpm/brace-expansion@2.0.1/node_modules/brace-expansion/index.js"(exports2, module2) {
    "use strict";
    var balanced = require_balanced_match();
    module2.exports = expandTop;
    var escSlash = "\0SLASH" + Math.random() + "\0";
    var escOpen = "\0OPEN" + Math.random() + "\0";
    var escClose = "\0CLOSE" + Math.random() + "\0";
    var escComma = "\0COMMA" + Math.random() + "\0";
    var escPeriod = "\0PERIOD" + Math.random() + "\0";
    function numeric(str2) {
      return parseInt(str2, 10) == str2 ? parseInt(str2, 10) : str2.charCodeAt(0);
    }
    function escapeBraces(str2) {
      return str2.split("\\\\").join(escSlash).split("\\{").join(escOpen).split("\\}").join(escClose).split("\\,").join(escComma).split("\\.").join(escPeriod);
    }
    function unescapeBraces(str2) {
      return str2.split(escSlash).join("\\").split(escOpen).join("{").split(escClose).join("}").split(escComma).join(",").split(escPeriod).join(".");
    }
    function parseCommaParts(str2) {
      if (!str2)
        return [""];
      var parts = [];
      var m = balanced("{", "}", str2);
      if (!m)
        return str2.split(",");
      var pre = m.pre;
      var body = m.body;
      var post = m.post;
      var p = pre.split(",");
      p[p.length - 1] += "{" + body + "}";
      var postParts = parseCommaParts(post);
      if (post.length) {
        p[p.length - 1] += postParts.shift();
        p.push.apply(p, postParts);
      }
      parts.push.apply(parts, p);
      return parts;
    }
    function expandTop(str2) {
      if (!str2)
        return [];
      if (str2.substr(0, 2) === "{}") {
        str2 = "\\{\\}" + str2.substr(2);
      }
      return expand(escapeBraces(str2), true).map(unescapeBraces);
    }
    function embrace(str2) {
      return "{" + str2 + "}";
    }
    function isPadded(el) {
      return /^-?0\d/.test(el);
    }
    function lte(i, y) {
      return i <= y;
    }
    function gte(i, y) {
      return i >= y;
    }
    function expand(str2, isTop) {
      var expansions = [];
      var m = balanced("{", "}", str2);
      if (!m) return [str2];
      var pre = m.pre;
      var post = m.post.length ? expand(m.post, false) : [""];
      if (/\$$/.test(m.pre)) {
        for (var k = 0; k < post.length; k++) {
          var expansion = pre + "{" + m.body + "}" + post[k];
          expansions.push(expansion);
        }
      } else {
        var isNumericSequence = /^-?\d+\.\.-?\d+(?:\.\.-?\d+)?$/.test(m.body);
        var isAlphaSequence = /^[a-zA-Z]\.\.[a-zA-Z](?:\.\.-?\d+)?$/.test(m.body);
        var isSequence = isNumericSequence || isAlphaSequence;
        var isOptions = m.body.indexOf(",") >= 0;
        if (!isSequence && !isOptions) {
          if (m.post.match(/,.*\}/)) {
            str2 = m.pre + "{" + m.body + escClose + m.post;
            return expand(str2);
          }
          return [str2];
        }
        var n;
        if (isSequence) {
          n = m.body.split(/\.\./);
        } else {
          n = parseCommaParts(m.body);
          if (n.length === 1) {
            n = expand(n[0], false).map(embrace);
            if (n.length === 1) {
              return post.map(function (p) {
                return m.pre + n[0] + p;
              });
            }
          }
        }
        var N;
        if (isSequence) {
          var x = numeric(n[0]);
          var y = numeric(n[1]);
          var width = Math.max(n[0].length, n[1].length);
          var incr = n.length == 3 ? Math.abs(numeric(n[2])) : 1;
          var test = lte;
          var reverse = y < x;
          if (reverse) {
            incr *= -1;
            test = gte;
          }
          var pad = n.some(isPadded);
          N = [];
          for (var i = x; test(i, y); i += incr) {
            var c;
            if (isAlphaSequence) {
              c = String.fromCharCode(i);
              if (c === "\\")
                c = "";
            } else {
              c = String(i);
              if (pad) {
                var need = width - c.length;
                if (need > 0) {
                  var z2 = new Array(need + 1).join("0");
                  if (i < 0)
                    c = "-" + z2 + c.slice(1);
                  else
                    c = z2 + c;
                }
              }
            }
            N.push(c);
          }
        } else {
          N = [];
          for (var j = 0; j < n.length; j++) {
            N.push.apply(N, expand(n[j], false));
          }
        }
        for (var j = 0; j < N.length; j++) {
          for (var k = 0; k < post.length; k++) {
            var expansion = pre + N[j] + post[k];
            if (!isTop || isSequence || expansion)
              expansions.push(expansion);
          }
        }
      }
      return expansions;
    }
  }
});

// ../../../node_modules/.pnpm/minimatch@5.1.0/node_modules/minimatch/minimatch.js
var require_minimatch = __commonJS({
  "../../../node_modules/.pnpm/minimatch@5.1.0/node_modules/minimatch/minimatch.js"(exports2, module2) {
    "use strict";
    var minimatch = module2.exports = (p, pattern, options = {}) => {
      assertValidPattern(pattern);
      if (!options.nocomment && pattern.charAt(0) === "#") {
        return false;
      }
      return new Minimatch(pattern, options).match(p);
    };
    module2.exports = minimatch;
    var path5 = require_path();
    minimatch.sep = path5.sep;
    var GLOBSTAR = Symbol("globstar **");
    minimatch.GLOBSTAR = GLOBSTAR;
    var expand = require_brace_expansion();
    var plTypes = {
      "!": { open: "(?:(?!(?:", close: "))[^/]*?)" },
      "?": { open: "(?:", close: ")?" },
      "+": { open: "(?:", close: ")+" },
      "*": { open: "(?:", close: ")*" },
      "@": { open: "(?:", close: ")" }
    };
    var qmark = "[^/]";
    var star = qmark + "*?";
    var twoStarDot = "(?:(?!(?:\\/|^)(?:\\.{1,2})($|\\/)).)*?";
    var twoStarNoDot = "(?:(?!(?:\\/|^)\\.).)*?";
    var charSet = (s) => s.split("").reduce((set4, c) => {
      set4[c] = true;
      return set4;
    }, {});
    var reSpecials = charSet("().*{}+?[]^$\\!");
    var addPatternStartSet = charSet("[.(");
    var slashSplit = /\/+/;
    minimatch.filter = (pattern, options = {}) => (p, i, list3) => minimatch(p, pattern, options);
    var ext = (a, b = {}) => {
      const t = {};
      Object.keys(a).forEach((k) => t[k] = a[k]);
      Object.keys(b).forEach((k) => t[k] = b[k]);
      return t;
    };
    minimatch.defaults = (def) => {
      if (!def || typeof def !== "object" || !Object.keys(def).length) {
        return minimatch;
      }
      const orig = minimatch;
      const m = (p, pattern, options) => orig(p, pattern, ext(def, options));
      m.Minimatch = class Minimatch extends orig.Minimatch {
        constructor(pattern, options) {
          super(pattern, ext(def, options));
        }
      };
      m.Minimatch.defaults = (options) => orig.defaults(ext(def, options)).Minimatch;
      m.filter = (pattern, options) => orig.filter(pattern, ext(def, options));
      m.defaults = (options) => orig.defaults(ext(def, options));
      m.makeRe = (pattern, options) => orig.makeRe(pattern, ext(def, options));
      m.braceExpand = (pattern, options) => orig.braceExpand(pattern, ext(def, options));
      m.match = (list3, pattern, options) => orig.match(list3, pattern, ext(def, options));
      return m;
    };
    minimatch.braceExpand = (pattern, options) => braceExpand(pattern, options);
    var braceExpand = (pattern, options = {}) => {
      assertValidPattern(pattern);
      if (options.nobrace || !/\{(?:(?!\{).)*\}/.test(pattern)) {
        return [pattern];
      }
      return expand(pattern);
    };
    var MAX_PATTERN_LENGTH = 1024 * 64;
    var assertValidPattern = (pattern) => {
      if (typeof pattern !== "string") {
        throw new TypeError("invalid pattern");
      }
      if (pattern.length > MAX_PATTERN_LENGTH) {
        throw new TypeError("pattern is too long");
      }
    };
    var SUBPARSE = Symbol("subparse");
    minimatch.makeRe = (pattern, options) => new Minimatch(pattern, options || {}).makeRe();
    minimatch.match = (list3, pattern, options = {}) => {
      const mm = new Minimatch(pattern, options);
      list3 = list3.filter((f) => mm.match(f));
      if (mm.options.nonull && !list3.length) {
        list3.push(pattern);
      }
      return list3;
    };
    var globUnescape = (s) => s.replace(/\\(.)/g, "$1");
    var regExpEscape = (s) => s.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
    var Minimatch = class {
      constructor(pattern, options) {
        assertValidPattern(pattern);
        if (!options) options = {};
        this.options = options;
        this.set = [];
        this.pattern = pattern;
        this.windowsPathsNoEscape = !!options.windowsPathsNoEscape || options.allowWindowsEscape === false;
        if (this.windowsPathsNoEscape) {
          this.pattern = this.pattern.replace(/\\/g, "/");
        }
        this.regexp = null;
        this.negate = false;
        this.comment = false;
        this.empty = false;
        this.partial = !!options.partial;
        this.make();
      }
      debug() {
      }
      make() {
        const pattern = this.pattern;
        const options = this.options;
        if (!options.nocomment && pattern.charAt(0) === "#") {
          this.comment = true;
          return;
        }
        if (!pattern) {
          this.empty = true;
          return;
        }
        this.parseNegate();
        let set4 = this.globSet = this.braceExpand();
        if (options.debug) this.debug = (...args) => console.error(...args);
        this.debug(this.pattern, set4);
        set4 = this.globParts = set4.map((s) => s.split(slashSplit));
        this.debug(this.pattern, set4);
        set4 = set4.map((s, si, set5) => s.map(this.parse, this));
        this.debug(this.pattern, set4);
        set4 = set4.filter((s) => s.indexOf(false) === -1);
        this.debug(this.pattern, set4);
        this.set = set4;
      }
      parseNegate() {
        if (this.options.nonegate) return;
        const pattern = this.pattern;
        let negate2 = false;
        let negateOffset = 0;
        for (let i = 0; i < pattern.length && pattern.charAt(i) === "!"; i++) {
          negate2 = !negate2;
          negateOffset++;
        }
        if (negateOffset) this.pattern = pattern.substr(negateOffset);
        this.negate = negate2;
      }
      // set partial to true to test if, for example,
      // "/a/b" matches the start of "/*/b/*/d"
      // Partial means, if you run out of file before you run
      // out of pattern, then that's fine, as long as all
      // the parts match.
      matchOne(file, pattern, partial) {
        var options = this.options;
        this.debug(
          "matchOne",
          { "this": this, file, pattern }
        );
        this.debug("matchOne", file.length, pattern.length);
        for (var fi = 0, pi = 0, fl = file.length, pl = pattern.length; fi < fl && pi < pl; fi++, pi++) {
          this.debug("matchOne loop");
          var p = pattern[pi];
          var f = file[fi];
          this.debug(pattern, p, f);
          if (p === false) return false;
          if (p === GLOBSTAR) {
            this.debug("GLOBSTAR", [pattern, p, f]);
            var fr = fi;
            var pr = pi + 1;
            if (pr === pl) {
              this.debug("** at the end");
              for (; fi < fl; fi++) {
                if (file[fi] === "." || file[fi] === ".." || !options.dot && file[fi].charAt(0) === ".") return false;
              }
              return true;
            }
            while (fr < fl) {
              var swallowee = file[fr];
              this.debug("\nglobstar while", file, fr, pattern, pr, swallowee);
              if (this.matchOne(file.slice(fr), pattern.slice(pr), partial)) {
                this.debug("globstar found match!", fr, fl, swallowee);
                return true;
              } else {
                if (swallowee === "." || swallowee === ".." || !options.dot && swallowee.charAt(0) === ".") {
                  this.debug("dot detected!", file, fr, pattern, pr);
                  break;
                }
                this.debug("globstar swallow a segment, and continue");
                fr++;
              }
            }
            if (partial) {
              this.debug("\n>>> no match, partial?", file, fr, pattern, pr);
              if (fr === fl) return true;
            }
            return false;
          }
          var hit;
          if (typeof p === "string") {
            hit = f === p;
            this.debug("string match", p, f, hit);
          } else {
            hit = f.match(p);
            this.debug("pattern match", p, f, hit);
          }
          if (!hit) return false;
        }
        if (fi === fl && pi === pl) {
          return true;
        } else if (fi === fl) {
          return partial;
        } else if (pi === pl) {
          return fi === fl - 1 && file[fi] === "";
        }
        throw new Error("wtf?");
      }
      braceExpand() {
        return braceExpand(this.pattern, this.options);
      }
      parse(pattern, isSub) {
        assertValidPattern(pattern);
        const options = this.options;
        if (pattern === "**") {
          if (!options.noglobstar)
            return GLOBSTAR;
          else
            pattern = "*";
        }
        if (pattern === "") return "";
        let re = "";
        let hasMagic = !!options.nocase;
        let escaping = false;
        const patternListStack = [];
        const negativeLists = [];
        let stateChar;
        let inClass = false;
        let reClassStart = -1;
        let classStart = -1;
        let cs;
        let pl;
        let sp;
        const patternStart = pattern.charAt(0) === "." ? "" : options.dot ? "(?!(?:^|\\/)\\.{1,2}(?:$|\\/))" : "(?!\\.)";
        const clearStateChar = () => {
          if (stateChar) {
            switch (stateChar) {
              case "*":
                re += star;
                hasMagic = true;
                break;
              case "?":
                re += qmark;
                hasMagic = true;
                break;
              default:
                re += "\\" + stateChar;
                break;
            }
            this.debug("clearStateChar %j %j", stateChar, re);
            stateChar = false;
          }
        };
        for (let i = 0, c; i < pattern.length && (c = pattern.charAt(i)); i++) {
          this.debug("%s	%s %s %j", pattern, i, re, c);
          if (escaping) {
            if (c === "/") {
              return false;
            }
            if (reSpecials[c]) {
              re += "\\";
            }
            re += c;
            escaping = false;
            continue;
          }
          switch (c) {
            /* istanbul ignore next */
            case "/": {
              return false;
            }
            case "\\":
              clearStateChar();
              escaping = true;
              continue;
            // the various stateChar values
            // for the "extglob" stuff.
            case "?":
            case "*":
            case "+":
            case "@":
            case "!":
              this.debug("%s	%s %s %j <-- stateChar", pattern, i, re, c);
              if (inClass) {
                this.debug("  in class");
                if (c === "!" && i === classStart + 1) c = "^";
                re += c;
                continue;
              }
              this.debug("call clearStateChar %j", stateChar);
              clearStateChar();
              stateChar = c;
              if (options.noext) clearStateChar();
              continue;
            case "(":
              if (inClass) {
                re += "(";
                continue;
              }
              if (!stateChar) {
                re += "\\(";
                continue;
              }
              patternListStack.push({
                type: stateChar,
                start: i - 1,
                reStart: re.length,
                open: plTypes[stateChar].open,
                close: plTypes[stateChar].close
              });
              re += stateChar === "!" ? "(?:(?!(?:" : "(?:";
              this.debug("plType %j %j", stateChar, re);
              stateChar = false;
              continue;
            case ")":
              if (inClass || !patternListStack.length) {
                re += "\\)";
                continue;
              }
              clearStateChar();
              hasMagic = true;
              pl = patternListStack.pop();
              re += pl.close;
              if (pl.type === "!") {
                negativeLists.push(pl);
              }
              pl.reEnd = re.length;
              continue;
            case "|":
              if (inClass || !patternListStack.length) {
                re += "\\|";
                continue;
              }
              clearStateChar();
              re += "|";
              continue;
            // these are mostly the same in regexp and glob
            case "[":
              clearStateChar();
              if (inClass) {
                re += "\\" + c;
                continue;
              }
              inClass = true;
              classStart = i;
              reClassStart = re.length;
              re += c;
              continue;
            case "]":
              if (i === classStart + 1 || !inClass) {
                re += "\\" + c;
                continue;
              }
              cs = pattern.substring(classStart + 1, i);
              try {
                RegExp("[" + cs + "]");
              } catch (er) {
                sp = this.parse(cs, SUBPARSE);
                re = re.substr(0, reClassStart) + "\\[" + sp[0] + "\\]";
                hasMagic = hasMagic || sp[1];
                inClass = false;
                continue;
              }
              hasMagic = true;
              inClass = false;
              re += c;
              continue;
            default:
              clearStateChar();
              if (reSpecials[c] && !(c === "^" && inClass)) {
                re += "\\";
              }
              re += c;
              break;
          }
        }
        if (inClass) {
          cs = pattern.substr(classStart + 1);
          sp = this.parse(cs, SUBPARSE);
          re = re.substr(0, reClassStart) + "\\[" + sp[0];
          hasMagic = hasMagic || sp[1];
        }
        for (pl = patternListStack.pop(); pl; pl = patternListStack.pop()) {
          let tail;
          tail = re.slice(pl.reStart + pl.open.length);
          this.debug("setting tail", re, pl);
          tail = tail.replace(/((?:\\{2}){0,64})(\\?)\|/g, (_, $1, $2) => {
            if (!$2) {
              $2 = "\\";
            }
            return $1 + $1 + $2 + "|";
          });
          this.debug("tail=%j\n   %s", tail, tail, pl, re);
          const t = pl.type === "*" ? star : pl.type === "?" ? qmark : "\\" + pl.type;
          hasMagic = true;
          re = re.slice(0, pl.reStart) + t + "\\(" + tail;
        }
        clearStateChar();
        if (escaping) {
          re += "\\\\";
        }
        const addPatternStart = addPatternStartSet[re.charAt(0)];
        for (let n = negativeLists.length - 1; n > -1; n--) {
          const nl = negativeLists[n];
          const nlBefore = re.slice(0, nl.reStart);
          const nlFirst = re.slice(nl.reStart, nl.reEnd - 8);
          let nlAfter = re.slice(nl.reEnd);
          const nlLast = re.slice(nl.reEnd - 8, nl.reEnd) + nlAfter;
          const openParensBefore = nlBefore.split("(").length - 1;
          let cleanAfter = nlAfter;
          for (let i = 0; i < openParensBefore; i++) {
            cleanAfter = cleanAfter.replace(/\)[+*?]?/, "");
          }
          nlAfter = cleanAfter;
          const dollar = nlAfter === "" && isSub !== SUBPARSE ? "$" : "";
          re = nlBefore + nlFirst + nlAfter + dollar + nlLast;
        }
        if (re !== "" && hasMagic) {
          re = "(?=.)" + re;
        }
        if (addPatternStart) {
          re = patternStart + re;
        }
        if (isSub === SUBPARSE) {
          return [re, hasMagic];
        }
        if (!hasMagic) {
          return globUnescape(pattern);
        }
        const flags = options.nocase ? "i" : "";
        try {
          return Object.assign(new RegExp("^" + re + "$", flags), {
            _glob: pattern,
            _src: re
          });
        } catch (er) {
          return new RegExp("$.");
        }
      }
      makeRe() {
        if (this.regexp || this.regexp === false) return this.regexp;
        const set4 = this.set;
        if (!set4.length) {
          this.regexp = false;
          return this.regexp;
        }
        const options = this.options;
        const twoStar = options.noglobstar ? star : options.dot ? twoStarDot : twoStarNoDot;
        const flags = options.nocase ? "i" : "";
        let re = set4.map((pattern) => {
          pattern = pattern.map(
            (p) => typeof p === "string" ? regExpEscape(p) : p === GLOBSTAR ? GLOBSTAR : p._src
          ).reduce((set5, p) => {
            if (!(set5[set5.length - 1] === GLOBSTAR && p === GLOBSTAR)) {
              set5.push(p);
            }
            return set5;
          }, []);
          pattern.forEach((p, i) => {
            if (p !== GLOBSTAR || pattern[i - 1] === GLOBSTAR) {
              return;
            }
            if (i === 0) {
              if (pattern.length > 1) {
                pattern[i + 1] = "(?:\\/|" + twoStar + "\\/)?" + pattern[i + 1];
              } else {
                pattern[i] = twoStar;
              }
            } else if (i === pattern.length - 1) {
              pattern[i - 1] += "(?:\\/|" + twoStar + ")?";
            } else {
              pattern[i - 1] += "(?:\\/|\\/" + twoStar + "\\/)" + pattern[i + 1];
              pattern[i + 1] = GLOBSTAR;
            }
          });
          return pattern.filter((p) => p !== GLOBSTAR).join("/");
        }).join("|");
        re = "^(?:" + re + ")$";
        if (this.negate) re = "^(?!" + re + ").*$";
        try {
          this.regexp = new RegExp(re, flags);
        } catch (ex) {
          this.regexp = false;
        }
        return this.regexp;
      }
      match(f, partial = this.partial) {
        this.debug("match", f, this.pattern);
        if (this.comment) return false;
        if (this.empty) return f === "";
        if (f === "/" && partial) return true;
        const options = this.options;
        if (path5.sep !== "/") {
          f = f.split(path5.sep).join("/");
        }
        f = f.split(slashSplit);
        this.debug(this.pattern, "split", f);
        const set4 = this.set;
        this.debug(this.pattern, "set", set4);
        let filename;
        for (let i = f.length - 1; i >= 0; i--) {
          filename = f[i];
          if (filename) break;
        }
        for (let i = 0; i < set4.length; i++) {
          const pattern = set4[i];
          let file = f;
          if (options.matchBase && pattern.length === 1) {
            file = [filename];
          }
          const hit = this.matchOne(file, pattern, partial);
          if (hit) {
            if (options.flipNegate) return true;
            return !this.negate;
          }
        }
        if (options.flipNegate) return false;
        return this.negate;
      }
      static defaults(def) {
        return minimatch.defaults(def).Minimatch;
      }
    };
    minimatch.Minimatch = Minimatch;
  }
});

// ../../../node_modules/.pnpm/webidl-conversions@3.0.1/node_modules/webidl-conversions/lib/index.js
var require_lib = __commonJS({
  "../../../node_modules/.pnpm/webidl-conversions@3.0.1/node_modules/webidl-conversions/lib/index.js"(exports2, module2) {
    "use strict";
    var conversions = {};
    module2.exports = conversions;
    function sign(x) {
      return x < 0 ? -1 : 1;
    }
    function evenRound(x) {
      if (x % 1 === 0.5 && (x & 1) === 0) {
        return Math.floor(x);
      } else {
        return Math.round(x);
      }
    }
    function createNumberConversion(bitLength, typeOpts) {
      if (!typeOpts.unsigned) {
        --bitLength;
      }
      const lowerBound = typeOpts.unsigned ? 0 : -Math.pow(2, bitLength);
      const upperBound = Math.pow(2, bitLength) - 1;
      const moduloVal = typeOpts.moduloBitLength ? Math.pow(2, typeOpts.moduloBitLength) : Math.pow(2, bitLength);
      const moduloBound = typeOpts.moduloBitLength ? Math.pow(2, typeOpts.moduloBitLength - 1) : Math.pow(2, bitLength - 1);
      return function (V, opts) {
        if (!opts) opts = {};
        let x = +V;
        if (opts.enforceRange) {
          if (!Number.isFinite(x)) {
            throw new TypeError("Argument is not a finite number");
          }
          x = sign(x) * Math.floor(Math.abs(x));
          if (x < lowerBound || x > upperBound) {
            throw new TypeError("Argument is not in byte range");
          }
          return x;
        }
        if (!isNaN(x) && opts.clamp) {
          x = evenRound(x);
          if (x < lowerBound) x = lowerBound;
          if (x > upperBound) x = upperBound;
          return x;
        }
        if (!Number.isFinite(x) || x === 0) {
          return 0;
        }
        x = sign(x) * Math.floor(Math.abs(x));
        x = x % moduloVal;
        if (!typeOpts.unsigned && x >= moduloBound) {
          return x - moduloVal;
        } else if (typeOpts.unsigned) {
          if (x < 0) {
            x += moduloVal;
          } else if (x === -0) {
            return 0;
          }
        }
        return x;
      };
    }
    conversions["void"] = function () {
      return void 0;
    };
    conversions["boolean"] = function (val) {
      return !!val;
    };
    conversions["byte"] = createNumberConversion(8, { unsigned: false });
    conversions["octet"] = createNumberConversion(8, { unsigned: true });
    conversions["short"] = createNumberConversion(16, { unsigned: false });
    conversions["unsigned short"] = createNumberConversion(16, { unsigned: true });
    conversions["long"] = createNumberConversion(32, { unsigned: false });
    conversions["unsigned long"] = createNumberConversion(32, { unsigned: true });
    conversions["long long"] = createNumberConversion(32, { unsigned: false, moduloBitLength: 64 });
    conversions["unsigned long long"] = createNumberConversion(32, { unsigned: true, moduloBitLength: 64 });
    conversions["double"] = function (V) {
      const x = +V;
      if (!Number.isFinite(x)) {
        throw new TypeError("Argument is not a finite floating-point value");
      }
      return x;
    };
    conversions["unrestricted double"] = function (V) {
      const x = +V;
      if (isNaN(x)) {
        throw new TypeError("Argument is NaN");
      }
      return x;
    };
    conversions["float"] = conversions["double"];
    conversions["unrestricted float"] = conversions["unrestricted double"];
    conversions["DOMString"] = function (V, opts) {
      if (!opts) opts = {};
      if (opts.treatNullAsEmptyString && V === null) {
        return "";
      }
      return String(V);
    };
    conversions["ByteString"] = function (V, opts) {
      const x = String(V);
      let c = void 0;
      for (let i = 0; (c = x.codePointAt(i)) !== void 0; ++i) {
        if (c > 255) {
          throw new TypeError("Argument is not a valid bytestring");
        }
      }
      return x;
    };
    conversions["USVString"] = function (V) {
      const S = String(V);
      const n = S.length;
      const U = [];
      for (let i = 0; i < n; ++i) {
        const c = S.charCodeAt(i);
        if (c < 55296 || c > 57343) {
          U.push(String.fromCodePoint(c));
        } else if (56320 <= c && c <= 57343) {
          U.push(String.fromCodePoint(65533));
        } else {
          if (i === n - 1) {
            U.push(String.fromCodePoint(65533));
          } else {
            const d = S.charCodeAt(i + 1);
            if (56320 <= d && d <= 57343) {
              const a = c & 1023;
              const b = d & 1023;
              U.push(String.fromCodePoint((2 << 15) + (2 << 9) * a + b));
              ++i;
            } else {
              U.push(String.fromCodePoint(65533));
            }
          }
        }
      }
      return U.join("");
    };
    conversions["Date"] = function (V, opts) {
      if (!(V instanceof Date)) {
        throw new TypeError("Argument is not a Date object");
      }
      if (isNaN(V)) {
        return void 0;
      }
      return V;
    };
    conversions["RegExp"] = function (V, opts) {
      if (!(V instanceof RegExp)) {
        V = new RegExp(V);
      }
      return V;
    };
  }
});

// ../../../node_modules/.pnpm/whatwg-url@5.0.0/node_modules/whatwg-url/lib/utils.js
var require_utils2 = __commonJS({
  "../../../node_modules/.pnpm/whatwg-url@5.0.0/node_modules/whatwg-url/lib/utils.js"(exports2, module2) {
    "use strict";
    module2.exports.mixin = function mixin(target, source) {
      const keys5 = Object.getOwnPropertyNames(source);
      for (let i = 0; i < keys5.length; ++i) {
        Object.defineProperty(target, keys5[i], Object.getOwnPropertyDescriptor(source, keys5[i]));
      }
    };
    module2.exports.wrapperSymbol = Symbol("wrapper");
    module2.exports.implSymbol = Symbol("impl");
    module2.exports.wrapperForImpl = function (impl) {
      return impl[module2.exports.wrapperSymbol];
    };
    module2.exports.implForWrapper = function (wrapper) {
      return wrapper[module2.exports.implSymbol];
    };
  }
});

// ../../../node_modules/.pnpm/tr46@0.0.3/node_modules/tr46/lib/mappingTable.json
var require_mappingTable = __commonJS({
  "../../../node_modules/.pnpm/tr46@0.0.3/node_modules/tr46/lib/mappingTable.json"(exports2, module2) {
    module2.exports = [[[0, 44], "disallowed_STD3_valid"], [[45, 46], "valid"], [[47, 47], "disallowed_STD3_valid"], [[48, 57], "valid"], [[58, 64], "disallowed_STD3_valid"], [[65, 65], "mapped", [97]], [[66, 66], "mapped", [98]], [[67, 67], "mapped", [99]], [[68, 68], "mapped", [100]], [[69, 69], "mapped", [101]], [[70, 70], "mapped", [102]], [[71, 71], "mapped", [103]], [[72, 72], "mapped", [104]], [[73, 73], "mapped", [105]], [[74, 74], "mapped", [106]], [[75, 75], "mapped", [107]], [[76, 76], "mapped", [108]], [[77, 77], "mapped", [109]], [[78, 78], "mapped", [110]], [[79, 79], "mapped", [111]], [[80, 80], "mapped", [112]], [[81, 81], "mapped", [113]], [[82, 82], "mapped", [114]], [[83, 83], "mapped", [115]], [[84, 84], "mapped", [116]], [[85, 85], "mapped", [117]], [[86, 86], "mapped", [118]], [[87, 87], "mapped", [119]], [[88, 88], "mapped", [120]], [[89, 89], "mapped", [121]], [[90, 90], "mapped", [122]], [[91, 96], "disallowed_STD3_valid"], [[97, 122], "valid"], [[123, 127], "disallowed_STD3_valid"], [[128, 159], "disallowed"], [[160, 160], "disallowed_STD3_mapped", [32]], [[161, 167], "valid", [], "NV8"], [[168, 168], "disallowed_STD3_mapped", [32, 776]], [[169, 169], "valid", [], "NV8"], [[170, 170], "mapped", [97]], [[171, 172], "valid", [], "NV8"], [[173, 173], "ignored"], [[174, 174], "valid", [], "NV8"], [[175, 175], "disallowed_STD3_mapped", [32, 772]], [[176, 177], "valid", [], "NV8"], [[178, 178], "mapped", [50]], [[179, 179], "mapped", [51]], [[180, 180], "disallowed_STD3_mapped", [32, 769]], [[181, 181], "mapped", [956]], [[182, 182], "valid", [], "NV8"], [[183, 183], "valid"], [[184, 184], "disallowed_STD3_mapped", [32, 807]], [[185, 185], "mapped", [49]], [[186, 186], "mapped", [111]], [[187, 187], "valid", [], "NV8"], [[188, 188], "mapped", [49, 8260, 52]], [[189, 189], "mapped", [49, 8260, 50]], [[190, 190], "mapped", [51, 8260, 52]], [[191, 191], "valid", [], "NV8"], [[192, 192], "mapped", [224]], [[193, 193], "mapped", [225]], [[194, 194], "mapped", [226]], [[195, 195], "mapped", [227]], [[196, 196], "mapped", [228]], [[197, 197], "mapped", [229]], [[198, 198], "mapped", [230]], [[199, 199], "mapped", [231]], [[200, 200], "mapped", [232]], [[201, 201], "mapped", [233]], [[202, 202], "mapped", [234]], [[203, 203], "mapped", [235]], [[204, 204], "mapped", [236]], [[205, 205], "mapped", [237]], [[206, 206], "mapped", [238]], [[207, 207], "mapped", [239]], [[208, 208], "mapped", [240]], [[209, 209], "mapped", [241]], [[210, 210], "mapped", [242]], [[211, 211], "mapped", [243]], [[212, 212], "mapped", [244]], [[213, 213], "mapped", [245]], [[214, 214], "mapped", [246]], [[215, 215], "valid", [], "NV8"], [[216, 216], "mapped", [248]], [[217, 217], "mapped", [249]], [[218, 218], "mapped", [250]], [[219, 219], "mapped", [251]], [[220, 220], "mapped", [252]], [[221, 221], "mapped", [253]], [[222, 222], "mapped", [254]], [[223, 223], "deviation", [115, 115]], [[224, 246], "valid"], [[247, 247], "valid", [], "NV8"], [[248, 255], "valid"], [[256, 256], "mapped", [257]], [[257, 257], "valid"], [[258, 258], "mapped", [259]], [[259, 259], "valid"], [[260, 260], "mapped", [261]], [[261, 261], "valid"], [[262, 262], "mapped", [263]], [[263, 263], "valid"], [[264, 264], "mapped", [265]], [[265, 265], "valid"], [[266, 266], "mapped", [267]], [[267, 267], "valid"], [[268, 268], "mapped", [269]], [[269, 269], "valid"], [[270, 270], "mapped", [271]], [[271, 271], "valid"], [[272, 272], "mapped", [273]], [[273, 273], "valid"], [[274, 274], "mapped", [275]], [[275, 275], "valid"], [[276, 276], "mapped", [277]], [[277, 277], "valid"], [[278, 278], "mapped", [279]], [[279, 279], "valid"], [[280, 280], "mapped", [281]], [[281, 281], "valid"], [[282, 282], "mapped", [283]], [[283, 283], "valid"], [[284, 284], "mapped", [285]], [[285, 285], "valid"], [[286, 286], "mapped", [287]], [[287, 287], "valid"], [[288, 288], "mapped", [289]], [[289, 289], "valid"], [[290, 290], "mapped", [291]], [[291, 291], "valid"], [[292, 292], "mapped", [293]], [[293, 293], "valid"], [[294, 294], "mapped", [295]], [[295, 295], "valid"], [[296, 296], "mapped", [297]], [[297, 297], "valid"], [[298, 298], "mapped", [299]], [[299, 299], "valid"], [[300, 300], "mapped", [301]], [[301, 301], "valid"], [[302, 302], "mapped", [303]], [[303, 303], "valid"], [[304, 304], "mapped", [105, 775]], [[305, 305], "valid"], [[306, 307], "mapped", [105, 106]], [[308, 308], "mapped", [309]], [[309, 309], "valid"], [[310, 310], "mapped", [311]], [[311, 312], "valid"], [[313, 313], "mapped", [314]], [[314, 314], "valid"], [[315, 315], "mapped", [316]], [[316, 316], "valid"], [[317, 317], "mapped", [318]], [[318, 318], "valid"], [[319, 320], "mapped", [108, 183]], [[321, 321], "mapped", [322]], [[322, 322], "valid"], [[323, 323], "mapped", [324]], [[324, 324], "valid"], [[325, 325], "mapped", [326]], [[326, 326], "valid"], [[327, 327], "mapped", [328]], [[328, 328], "valid"], [[329, 329], "mapped", [700, 110]], [[330, 330], "mapped", [331]], [[331, 331], "valid"], [[332, 332], "mapped", [333]], [[333, 333], "valid"], [[334, 334], "mapped", [335]], [[335, 335], "valid"], [[336, 336], "mapped", [337]], [[337, 337], "valid"], [[338, 338], "mapped", [339]], [[339, 339], "valid"], [[340, 340], "mapped", [341]], [[341, 341], "valid"], [[342, 342], "mapped", [343]], [[343, 343], "valid"], [[344, 344], "mapped", [345]], [[345, 345], "valid"], [[346, 346], "mapped", [347]], [[347, 347], "valid"], [[348, 348], "mapped", [349]], [[349, 349], "valid"], [[350, 350], "mapped", [351]], [[351, 351], "valid"], [[352, 352], "mapped", [353]], [[353, 353], "valid"], [[354, 354], "mapped", [355]], [[355, 355], "valid"], [[356, 356], "mapped", [357]], [[357, 357], "valid"], [[358, 358], "mapped", [359]], [[359, 359], "valid"], [[360, 360], "mapped", [361]], [[361, 361], "valid"], [[362, 362], "mapped", [363]], [[363, 363], "valid"], [[364, 364], "mapped", [365]], [[365, 365], "valid"], [[366, 366], "mapped", [367]], [[367, 367], "valid"], [[368, 368], "mapped", [369]], [[369, 369], "valid"], [[370, 370], "mapped", [371]], [[371, 371], "valid"], [[372, 372], "mapped", [373]], [[373, 373], "valid"], [[374, 374], "mapped", [375]], [[375, 375], "valid"], [[376, 376], "mapped", [255]], [[377, 377], "mapped", [378]], [[378, 378], "valid"], [[379, 379], "mapped", [380]], [[380, 380], "valid"], [[381, 381], "mapped", [382]], [[382, 382], "valid"], [[383, 383], "mapped", [115]], [[384, 384], "valid"], [[385, 385], "mapped", [595]], [[386, 386], "mapped", [387]], [[387, 387], "valid"], [[388, 388], "mapped", [389]], [[389, 389], "valid"], [[390, 390], "mapped", [596]], [[391, 391], "mapped", [392]], [[392, 392], "valid"], [[393, 393], "mapped", [598]], [[394, 394], "mapped", [599]], [[395, 395], "mapped", [396]], [[396, 397], "valid"], [[398, 398], "mapped", [477]], [[399, 399], "mapped", [601]], [[400, 400], "mapped", [603]], [[401, 401], "mapped", [402]], [[402, 402], "valid"], [[403, 403], "mapped", [608]], [[404, 404], "mapped", [611]], [[405, 405], "valid"], [[406, 406], "mapped", [617]], [[407, 407], "mapped", [616]], [[408, 408], "mapped", [409]], [[409, 411], "valid"], [[412, 412], "mapped", [623]], [[413, 413], "mapped", [626]], [[414, 414], "valid"], [[415, 415], "mapped", [629]], [[416, 416], "mapped", [417]], [[417, 417], "valid"], [[418, 418], "mapped", [419]], [[419, 419], "valid"], [[420, 420], "mapped", [421]], [[421, 421], "valid"], [[422, 422], "mapped", [640]], [[423, 423], "mapped", [424]], [[424, 424], "valid"], [[425, 425], "mapped", [643]], [[426, 427], "valid"], [[428, 428], "mapped", [429]], [[429, 429], "valid"], [[430, 430], "mapped", [648]], [[431, 431], "mapped", [432]], [[432, 432], "valid"], [[433, 433], "mapped", [650]], [[434, 434], "mapped", [651]], [[435, 435], "mapped", [436]], [[436, 436], "valid"], [[437, 437], "mapped", [438]], [[438, 438], "valid"], [[439, 439], "mapped", [658]], [[440, 440], "mapped", [441]], [[441, 443], "valid"], [[444, 444], "mapped", [445]], [[445, 451], "valid"], [[452, 454], "mapped", [100, 382]], [[455, 457], "mapped", [108, 106]], [[458, 460], "mapped", [110, 106]], [[461, 461], "mapped", [462]], [[462, 462], "valid"], [[463, 463], "mapped", [464]], [[464, 464], "valid"], [[465, 465], "mapped", [466]], [[466, 466], "valid"], [[467, 467], "mapped", [468]], [[468, 468], "valid"], [[469, 469], "mapped", [470]], [[470, 470], "valid"], [[471, 471], "mapped", [472]], [[472, 472], "valid"], [[473, 473], "mapped", [474]], [[474, 474], "valid"], [[475, 475], "mapped", [476]], [[476, 477], "valid"], [[478, 478], "mapped", [479]], [[479, 479], "valid"], [[480, 480], "mapped", [481]], [[481, 481], "valid"], [[482, 482], "mapped", [483]], [[483, 483], "valid"], [[484, 484], "mapped", [485]], [[485, 485], "valid"], [[486, 486], "mapped", [487]], [[487, 487], "valid"], [[488, 488], "mapped", [489]], [[489, 489], "valid"], [[490, 490], "mapped", [491]], [[491, 491], "valid"], [[492, 492], "mapped", [493]], [[493, 493], "valid"], [[494, 494], "mapped", [495]], [[495, 496], "valid"], [[497, 499], "mapped", [100, 122]], [[500, 500], "mapped", [501]], [[501, 501], "valid"], [[502, 502], "mapped", [405]], [[503, 503], "mapped", [447]], [[504, 504], "mapped", [505]], [[505, 505], "valid"], [[506, 506], "mapped", [507]], [[507, 507], "valid"], [[508, 508], "mapped", [509]], [[509, 509], "valid"], [[510, 510], "mapped", [511]], [[511, 511], "valid"], [[512, 512], "mapped", [513]], [[513, 513], "valid"], [[514, 514], "mapped", [515]], [[515, 515], "valid"], [[516, 516], "mapped", [517]], [[517, 517], "valid"], [[518, 518], "mapped", [519]], [[519, 519], "valid"], [[520, 520], "mapped", [521]], [[521, 521], "valid"], [[522, 522], "mapped", [523]], [[523, 523], "valid"], [[524, 524], "mapped", [525]], [[525, 525], "valid"], [[526, 526], "mapped", [527]], [[527, 527], "valid"], [[528, 528], "mapped", [529]], [[529, 529], "valid"], [[530, 530], "mapped", [531]], [[531, 531], "valid"], [[532, 532], "mapped", [533]], [[533, 533], "valid"], [[534, 534], "mapped", [535]], [[535, 535], "valid"], [[536, 536], "mapped", [537]], [[537, 537], "valid"], [[538, 538], "mapped", [539]], [[539, 539], "valid"], [[540, 540], "mapped", [541]], [[541, 541], "valid"], [[542, 542], "mapped", [543]], [[543, 543], "valid"], [[544, 544], "mapped", [414]], [[545, 545], "valid"], [[546, 546], "mapped", [547]], [[547, 547], "valid"], [[548, 548], "mapped", [549]], [[549, 549], "valid"], [[550, 550], "mapped", [551]], [[551, 551], "valid"], [[552, 552], "mapped", [553]], [[553, 553], "valid"], [[554, 554], "mapped", [555]], [[555, 555], "valid"], [[556, 556], "mapped", [557]], [[557, 557], "valid"], [[558, 558], "mapped", [559]], [[559, 559], "valid"], [[560, 560], "mapped", [561]], [[561, 561], "valid"], [[562, 562], "mapped", [563]], [[563, 563], "valid"], [[564, 566], "valid"], [[567, 569], "valid"], [[570, 570], "mapped", [11365]], [[571, 571], "mapped", [572]], [[572, 572], "valid"], [[573, 573], "mapped", [410]], [[574, 574], "mapped", [11366]], [[575, 576], "valid"], [[577, 577], "mapped", [578]], [[578, 578], "valid"], [[579, 579], "mapped", [384]], [[580, 580], "mapped", [649]], [[581, 581], "mapped", [652]], [[582, 582], "mapped", [583]], [[583, 583], "valid"], [[584, 584], "mapped", [585]], [[585, 585], "valid"], [[586, 586], "mapped", [587]], [[587, 587], "valid"], [[588, 588], "mapped", [589]], [[589, 589], "valid"], [[590, 590], "mapped", [591]], [[591, 591], "valid"], [[592, 680], "valid"], [[681, 685], "valid"], [[686, 687], "valid"], [[688, 688], "mapped", [104]], [[689, 689], "mapped", [614]], [[690, 690], "mapped", [106]], [[691, 691], "mapped", [114]], [[692, 692], "mapped", [633]], [[693, 693], "mapped", [635]], [[694, 694], "mapped", [641]], [[695, 695], "mapped", [119]], [[696, 696], "mapped", [121]], [[697, 705], "valid"], [[706, 709], "valid", [], "NV8"], [[710, 721], "valid"], [[722, 727], "valid", [], "NV8"], [[728, 728], "disallowed_STD3_mapped", [32, 774]], [[729, 729], "disallowed_STD3_mapped", [32, 775]], [[730, 730], "disallowed_STD3_mapped", [32, 778]], [[731, 731], "disallowed_STD3_mapped", [32, 808]], [[732, 732], "disallowed_STD3_mapped", [32, 771]], [[733, 733], "disallowed_STD3_mapped", [32, 779]], [[734, 734], "valid", [], "NV8"], [[735, 735], "valid", [], "NV8"], [[736, 736], "mapped", [611]], [[737, 737], "mapped", [108]], [[738, 738], "mapped", [115]], [[739, 739], "mapped", [120]], [[740, 740], "mapped", [661]], [[741, 745], "valid", [], "NV8"], [[746, 747], "valid", [], "NV8"], [[748, 748], "valid"], [[749, 749], "valid", [], "NV8"], [[750, 750], "valid"], [[751, 767], "valid", [], "NV8"], [[768, 831], "valid"], [[832, 832], "mapped", [768]], [[833, 833], "mapped", [769]], [[834, 834], "valid"], [[835, 835], "mapped", [787]], [[836, 836], "mapped", [776, 769]], [[837, 837], "mapped", [953]], [[838, 846], "valid"], [[847, 847], "ignored"], [[848, 855], "valid"], [[856, 860], "valid"], [[861, 863], "valid"], [[864, 865], "valid"], [[866, 866], "valid"], [[867, 879], "valid"], [[880, 880], "mapped", [881]], [[881, 881], "valid"], [[882, 882], "mapped", [883]], [[883, 883], "valid"], [[884, 884], "mapped", [697]], [[885, 885], "valid"], [[886, 886], "mapped", [887]], [[887, 887], "valid"], [[888, 889], "disallowed"], [[890, 890], "disallowed_STD3_mapped", [32, 953]], [[891, 893], "valid"], [[894, 894], "disallowed_STD3_mapped", [59]], [[895, 895], "mapped", [1011]], [[896, 899], "disallowed"], [[900, 900], "disallowed_STD3_mapped", [32, 769]], [[901, 901], "disallowed_STD3_mapped", [32, 776, 769]], [[902, 902], "mapped", [940]], [[903, 903], "mapped", [183]], [[904, 904], "mapped", [941]], [[905, 905], "mapped", [942]], [[906, 906], "mapped", [943]], [[907, 907], "disallowed"], [[908, 908], "mapped", [972]], [[909, 909], "disallowed"], [[910, 910], "mapped", [973]], [[911, 911], "mapped", [974]], [[912, 912], "valid"], [[913, 913], "mapped", [945]], [[914, 914], "mapped", [946]], [[915, 915], "mapped", [947]], [[916, 916], "mapped", [948]], [[917, 917], "mapped", [949]], [[918, 918], "mapped", [950]], [[919, 919], "mapped", [951]], [[920, 920], "mapped", [952]], [[921, 921], "mapped", [953]], [[922, 922], "mapped", [954]], [[923, 923], "mapped", [955]], [[924, 924], "mapped", [956]], [[925, 925], "mapped", [957]], [[926, 926], "mapped", [958]], [[927, 927], "mapped", [959]], [[928, 928], "mapped", [960]], [[929, 929], "mapped", [961]], [[930, 930], "disallowed"], [[931, 931], "mapped", [963]], [[932, 932], "mapped", [964]], [[933, 933], "mapped", [965]], [[934, 934], "mapped", [966]], [[935, 935], "mapped", [967]], [[936, 936], "mapped", [968]], [[937, 937], "mapped", [969]], [[938, 938], "mapped", [970]], [[939, 939], "mapped", [971]], [[940, 961], "valid"], [[962, 962], "deviation", [963]], [[963, 974], "valid"], [[975, 975], "mapped", [983]], [[976, 976], "mapped", [946]], [[977, 977], "mapped", [952]], [[978, 978], "mapped", [965]], [[979, 979], "mapped", [973]], [[980, 980], "mapped", [971]], [[981, 981], "mapped", [966]], [[982, 982], "mapped", [960]], [[983, 983], "valid"], [[984, 984], "mapped", [985]], [[985, 985], "valid"], [[986, 986], "mapped", [987]], [[987, 987], "valid"], [[988, 988], "mapped", [989]], [[989, 989], "valid"], [[990, 990], "mapped", [991]], [[991, 991], "valid"], [[992, 992], "mapped", [993]], [[993, 993], "valid"], [[994, 994], "mapped", [995]], [[995, 995], "valid"], [[996, 996], "mapped", [997]], [[997, 997], "valid"], [[998, 998], "mapped", [999]], [[999, 999], "valid"], [[1e3, 1e3], "mapped", [1001]], [[1001, 1001], "valid"], [[1002, 1002], "mapped", [1003]], [[1003, 1003], "valid"], [[1004, 1004], "mapped", [1005]], [[1005, 1005], "valid"], [[1006, 1006], "mapped", [1007]], [[1007, 1007], "valid"], [[1008, 1008], "mapped", [954]], [[1009, 1009], "mapped", [961]], [[1010, 1010], "mapped", [963]], [[1011, 1011], "valid"], [[1012, 1012], "mapped", [952]], [[1013, 1013], "mapped", [949]], [[1014, 1014], "valid", [], "NV8"], [[1015, 1015], "mapped", [1016]], [[1016, 1016], "valid"], [[1017, 1017], "mapped", [963]], [[1018, 1018], "mapped", [1019]], [[1019, 1019], "valid"], [[1020, 1020], "valid"], [[1021, 1021], "mapped", [891]], [[1022, 1022], "mapped", [892]], [[1023, 1023], "mapped", [893]], [[1024, 1024], "mapped", [1104]], [[1025, 1025], "mapped", [1105]], [[1026, 1026], "mapped", [1106]], [[1027, 1027], "mapped", [1107]], [[1028, 1028], "mapped", [1108]], [[1029, 1029], "mapped", [1109]], [[1030, 1030], "mapped", [1110]], [[1031, 1031], "mapped", [1111]], [[1032, 1032], "mapped", [1112]], [[1033, 1033], "mapped", [1113]], [[1034, 1034], "mapped", [1114]], [[1035, 1035], "mapped", [1115]], [[1036, 1036], "mapped", [1116]], [[1037, 1037], "mapped", [1117]], [[1038, 1038], "mapped", [1118]], [[1039, 1039], "mapped", [1119]], [[1040, 1040], "mapped", [1072]], [[1041, 1041], "mapped", [1073]], [[1042, 1042], "mapped", [1074]], [[1043, 1043], "mapped", [1075]], [[1044, 1044], "mapped", [1076]], [[1045, 1045], "mapped", [1077]], [[1046, 1046], "mapped", [1078]], [[1047, 1047], "mapped", [1079]], [[1048, 1048], "mapped", [1080]], [[1049, 1049], "mapped", [1081]], [[1050, 1050], "mapped", [1082]], [[1051, 1051], "mapped", [1083]], [[1052, 1052], "mapped", [1084]], [[1053, 1053], "mapped", [1085]], [[1054, 1054], "mapped", [1086]], [[1055, 1055], "mapped", [1087]], [[1056, 1056], "mapped", [1088]], [[1057, 1057], "mapped", [1089]], [[1058, 1058], "mapped", [1090]], [[1059, 1059], "mapped", [1091]], [[1060, 1060], "mapped", [1092]], [[1061, 1061], "mapped", [1093]], [[1062, 1062], "mapped", [1094]], [[1063, 1063], "mapped", [1095]], [[1064, 1064], "mapped", [1096]], [[1065, 1065], "mapped", [1097]], [[1066, 1066], "mapped", [1098]], [[1067, 1067], "mapped", [1099]], [[1068, 1068], "mapped", [1100]], [[1069, 1069], "mapped", [1101]], [[1070, 1070], "mapped", [1102]], [[1071, 1071], "mapped", [1103]], [[1072, 1103], "valid"], [[1104, 1104], "valid"], [[1105, 1116], "valid"], [[1117, 1117], "valid"], [[1118, 1119], "valid"], [[1120, 1120], "mapped", [1121]], [[1121, 1121], "valid"], [[1122, 1122], "mapped", [1123]], [[1123, 1123], "valid"], [[1124, 1124], "mapped", [1125]], [[1125, 1125], "valid"], [[1126, 1126], "mapped", [1127]], [[1127, 1127], "valid"], [[1128, 1128], "mapped", [1129]], [[1129, 1129], "valid"], [[1130, 1130], "mapped", [1131]], [[1131, 1131], "valid"], [[1132, 1132], "mapped", [1133]], [[1133, 1133], "valid"], [[1134, 1134], "mapped", [1135]], [[1135, 1135], "valid"], [[1136, 1136], "mapped", [1137]], [[1137, 1137], "valid"], [[1138, 1138], "mapped", [1139]], [[1139, 1139], "valid"], [[1140, 1140], "mapped", [1141]], [[1141, 1141], "valid"], [[1142, 1142], "mapped", [1143]], [[1143, 1143], "valid"], [[1144, 1144], "mapped", [1145]], [[1145, 1145], "valid"], [[1146, 1146], "mapped", [1147]], [[1147, 1147], "valid"], [[1148, 1148], "mapped", [1149]], [[1149, 1149], "valid"], [[1150, 1150], "mapped", [1151]], [[1151, 1151], "valid"], [[1152, 1152], "mapped", [1153]], [[1153, 1153], "valid"], [[1154, 1154], "valid", [], "NV8"], [[1155, 1158], "valid"], [[1159, 1159], "valid"], [[1160, 1161], "valid", [], "NV8"], [[1162, 1162], "mapped", [1163]], [[1163, 1163], "valid"], [[1164, 1164], "mapped", [1165]], [[1165, 1165], "valid"], [[1166, 1166], "mapped", [1167]], [[1167, 1167], "valid"], [[1168, 1168], "mapped", [1169]], [[1169, 1169], "valid"], [[1170, 1170], "mapped", [1171]], [[1171, 1171], "valid"], [[1172, 1172], "mapped", [1173]], [[1173, 1173], "valid"], [[1174, 1174], "mapped", [1175]], [[1175, 1175], "valid"], [[1176, 1176], "mapped", [1177]], [[1177, 1177], "valid"], [[1178, 1178], "mapped", [1179]], [[1179, 1179], "valid"], [[1180, 1180], "mapped", [1181]], [[1181, 1181], "valid"], [[1182, 1182], "mapped", [1183]], [[1183, 1183], "valid"], [[1184, 1184], "mapped", [1185]], [[1185, 1185], "valid"], [[1186, 1186], "mapped", [1187]], [[1187, 1187], "valid"], [[1188, 1188], "mapped", [1189]], [[1189, 1189], "valid"], [[1190, 1190], "mapped", [1191]], [[1191, 1191], "valid"], [[1192, 1192], "mapped", [1193]], [[1193, 1193], "valid"], [[1194, 1194], "mapped", [1195]], [[1195, 1195], "valid"], [[1196, 1196], "mapped", [1197]], [[1197, 1197], "valid"], [[1198, 1198], "mapped", [1199]], [[1199, 1199], "valid"], [[1200, 1200], "mapped", [1201]], [[1201, 1201], "valid"], [[1202, 1202], "mapped", [1203]], [[1203, 1203], "valid"], [[1204, 1204], "mapped", [1205]], [[1205, 1205], "valid"], [[1206, 1206], "mapped", [1207]], [[1207, 1207], "valid"], [[1208, 1208], "mapped", [1209]], [[1209, 1209], "valid"], [[1210, 1210], "mapped", [1211]], [[1211, 1211], "valid"], [[1212, 1212], "mapped", [1213]], [[1213, 1213], "valid"], [[1214, 1214], "mapped", [1215]], [[1215, 1215], "valid"], [[1216, 1216], "disallowed"], [[1217, 1217], "mapped", [1218]], [[1218, 1218], "valid"], [[1219, 1219], "mapped", [1220]], [[1220, 1220], "valid"], [[1221, 1221], "mapped", [1222]], [[1222, 1222], "valid"], [[1223, 1223], "mapped", [1224]], [[1224, 1224], "valid"], [[1225, 1225], "mapped", [1226]], [[1226, 1226], "valid"], [[1227, 1227], "mapped", [1228]], [[1228, 1228], "valid"], [[1229, 1229], "mapped", [1230]], [[1230, 1230], "valid"], [[1231, 1231], "valid"], [[1232, 1232], "mapped", [1233]], [[1233, 1233], "valid"], [[1234, 1234], "mapped", [1235]], [[1235, 1235], "valid"], [[1236, 1236], "mapped", [1237]], [[1237, 1237], "valid"], [[1238, 1238], "mapped", [1239]], [[1239, 1239], "valid"], [[1240, 1240], "mapped", [1241]], [[1241, 1241], "valid"], [[1242, 1242], "mapped", [1243]], [[1243, 1243], "valid"], [[1244, 1244], "mapped", [1245]], [[1245, 1245], "valid"], [[1246, 1246], "mapped", [1247]], [[1247, 1247], "valid"], [[1248, 1248], "mapped", [1249]], [[1249, 1249], "valid"], [[1250, 1250], "mapped", [1251]], [[1251, 1251], "valid"], [[1252, 1252], "mapped", [1253]], [[1253, 1253], "valid"], [[1254, 1254], "mapped", [1255]], [[1255, 1255], "valid"], [[1256, 1256], "mapped", [1257]], [[1257, 1257], "valid"], [[1258, 1258], "mapped", [1259]], [[1259, 1259], "valid"], [[1260, 1260], "mapped", [1261]], [[1261, 1261], "valid"], [[1262, 1262], "mapped", [1263]], [[1263, 1263], "valid"], [[1264, 1264], "mapped", [1265]], [[1265, 1265], "valid"], [[1266, 1266], "mapped", [1267]], [[1267, 1267], "valid"], [[1268, 1268], "mapped", [1269]], [[1269, 1269], "valid"], [[1270, 1270], "mapped", [1271]], [[1271, 1271], "valid"], [[1272, 1272], "mapped", [1273]], [[1273, 1273], "valid"], [[1274, 1274], "mapped", [1275]], [[1275, 1275], "valid"], [[1276, 1276], "mapped", [1277]], [[1277, 1277], "valid"], [[1278, 1278], "mapped", [1279]], [[1279, 1279], "valid"], [[1280, 1280], "mapped", [1281]], [[1281, 1281], "valid"], [[1282, 1282], "mapped", [1283]], [[1283, 1283], "valid"], [[1284, 1284], "mapped", [1285]], [[1285, 1285], "valid"], [[1286, 1286], "mapped", [1287]], [[1287, 1287], "valid"], [[1288, 1288], "mapped", [1289]], [[1289, 1289], "valid"], [[1290, 1290], "mapped", [1291]], [[1291, 1291], "valid"], [[1292, 1292], "mapped", [1293]], [[1293, 1293], "valid"], [[1294, 1294], "mapped", [1295]], [[1295, 1295], "valid"], [[1296, 1296], "mapped", [1297]], [[1297, 1297], "valid"], [[1298, 1298], "mapped", [1299]], [[1299, 1299], "valid"], [[1300, 1300], "mapped", [1301]], [[1301, 1301], "valid"], [[1302, 1302], "mapped", [1303]], [[1303, 1303], "valid"], [[1304, 1304], "mapped", [1305]], [[1305, 1305], "valid"], [[1306, 1306], "mapped", [1307]], [[1307, 1307], "valid"], [[1308, 1308], "mapped", [1309]], [[1309, 1309], "valid"], [[1310, 1310], "mapped", [1311]], [[1311, 1311], "valid"], [[1312, 1312], "mapped", [1313]], [[1313, 1313], "valid"], [[1314, 1314], "mapped", [1315]], [[1315, 1315], "valid"], [[1316, 1316], "mapped", [1317]], [[1317, 1317], "valid"], [[1318, 1318], "mapped", [1319]], [[1319, 1319], "valid"], [[1320, 1320], "mapped", [1321]], [[1321, 1321], "valid"], [[1322, 1322], "mapped", [1323]], [[1323, 1323], "valid"], [[1324, 1324], "mapped", [1325]], [[1325, 1325], "valid"], [[1326, 1326], "mapped", [1327]], [[1327, 1327], "valid"], [[1328, 1328], "disallowed"], [[1329, 1329], "mapped", [1377]], [[1330, 1330], "mapped", [1378]], [[1331, 1331], "mapped", [1379]], [[1332, 1332], "mapped", [1380]], [[1333, 1333], "mapped", [1381]], [[1334, 1334], "mapped", [1382]], [[1335, 1335], "mapped", [1383]], [[1336, 1336], "mapped", [1384]], [[1337, 1337], "mapped", [1385]], [[1338, 1338], "mapped", [1386]], [[1339, 1339], "mapped", [1387]], [[1340, 1340], "mapped", [1388]], [[1341, 1341], "mapped", [1389]], [[1342, 1342], "mapped", [1390]], [[1343, 1343], "mapped", [1391]], [[1344, 1344], "mapped", [1392]], [[1345, 1345], "mapped", [1393]], [[1346, 1346], "mapped", [1394]], [[1347, 1347], "mapped", [1395]], [[1348, 1348], "mapped", [1396]], [[1349, 1349], "mapped", [1397]], [[1350, 1350], "mapped", [1398]], [[1351, 1351], "mapped", [1399]], [[1352, 1352], "mapped", [1400]], [[1353, 1353], "mapped", [1401]], [[1354, 1354], "mapped", [1402]], [[1355, 1355], "mapped", [1403]], [[1356, 1356], "mapped", [1404]], [[1357, 1357], "mapped", [1405]], [[1358, 1358], "mapped", [1406]], [[1359, 1359], "mapped", [1407]], [[1360, 1360], "mapped", [1408]], [[1361, 1361], "mapped", [1409]], [[1362, 1362], "mapped", [1410]], [[1363, 1363], "mapped", [1411]], [[1364, 1364], "mapped", [1412]], [[1365, 1365], "mapped", [1413]], [[1366, 1366], "mapped", [1414]], [[1367, 1368], "disallowed"], [[1369, 1369], "valid"], [[1370, 1375], "valid", [], "NV8"], [[1376, 1376], "disallowed"], [[1377, 1414], "valid"], [[1415, 1415], "mapped", [1381, 1410]], [[1416, 1416], "disallowed"], [[1417, 1417], "valid", [], "NV8"], [[1418, 1418], "valid", [], "NV8"], [[1419, 1420], "disallowed"], [[1421, 1422], "valid", [], "NV8"], [[1423, 1423], "valid", [], "NV8"], [[1424, 1424], "disallowed"], [[1425, 1441], "valid"], [[1442, 1442], "valid"], [[1443, 1455], "valid"], [[1456, 1465], "valid"], [[1466, 1466], "valid"], [[1467, 1469], "valid"], [[1470, 1470], "valid", [], "NV8"], [[1471, 1471], "valid"], [[1472, 1472], "valid", [], "NV8"], [[1473, 1474], "valid"], [[1475, 1475], "valid", [], "NV8"], [[1476, 1476], "valid"], [[1477, 1477], "valid"], [[1478, 1478], "valid", [], "NV8"], [[1479, 1479], "valid"], [[1480, 1487], "disallowed"], [[1488, 1514], "valid"], [[1515, 1519], "disallowed"], [[1520, 1524], "valid"], [[1525, 1535], "disallowed"], [[1536, 1539], "disallowed"], [[1540, 1540], "disallowed"], [[1541, 1541], "disallowed"], [[1542, 1546], "valid", [], "NV8"], [[1547, 1547], "valid", [], "NV8"], [[1548, 1548], "valid", [], "NV8"], [[1549, 1551], "valid", [], "NV8"], [[1552, 1557], "valid"], [[1558, 1562], "valid"], [[1563, 1563], "valid", [], "NV8"], [[1564, 1564], "disallowed"], [[1565, 1565], "disallowed"], [[1566, 1566], "valid", [], "NV8"], [[1567, 1567], "valid", [], "NV8"], [[1568, 1568], "valid"], [[1569, 1594], "valid"], [[1595, 1599], "valid"], [[1600, 1600], "valid", [], "NV8"], [[1601, 1618], "valid"], [[1619, 1621], "valid"], [[1622, 1624], "valid"], [[1625, 1630], "valid"], [[1631, 1631], "valid"], [[1632, 1641], "valid"], [[1642, 1645], "valid", [], "NV8"], [[1646, 1647], "valid"], [[1648, 1652], "valid"], [[1653, 1653], "mapped", [1575, 1652]], [[1654, 1654], "mapped", [1608, 1652]], [[1655, 1655], "mapped", [1735, 1652]], [[1656, 1656], "mapped", [1610, 1652]], [[1657, 1719], "valid"], [[1720, 1721], "valid"], [[1722, 1726], "valid"], [[1727, 1727], "valid"], [[1728, 1742], "valid"], [[1743, 1743], "valid"], [[1744, 1747], "valid"], [[1748, 1748], "valid", [], "NV8"], [[1749, 1756], "valid"], [[1757, 1757], "disallowed"], [[1758, 1758], "valid", [], "NV8"], [[1759, 1768], "valid"], [[1769, 1769], "valid", [], "NV8"], [[1770, 1773], "valid"], [[1774, 1775], "valid"], [[1776, 1785], "valid"], [[1786, 1790], "valid"], [[1791, 1791], "valid"], [[1792, 1805], "valid", [], "NV8"], [[1806, 1806], "disallowed"], [[1807, 1807], "disallowed"], [[1808, 1836], "valid"], [[1837, 1839], "valid"], [[1840, 1866], "valid"], [[1867, 1868], "disallowed"], [[1869, 1871], "valid"], [[1872, 1901], "valid"], [[1902, 1919], "valid"], [[1920, 1968], "valid"], [[1969, 1969], "valid"], [[1970, 1983], "disallowed"], [[1984, 2037], "valid"], [[2038, 2042], "valid", [], "NV8"], [[2043, 2047], "disallowed"], [[2048, 2093], "valid"], [[2094, 2095], "disallowed"], [[2096, 2110], "valid", [], "NV8"], [[2111, 2111], "disallowed"], [[2112, 2139], "valid"], [[2140, 2141], "disallowed"], [[2142, 2142], "valid", [], "NV8"], [[2143, 2207], "disallowed"], [[2208, 2208], "valid"], [[2209, 2209], "valid"], [[2210, 2220], "valid"], [[2221, 2226], "valid"], [[2227, 2228], "valid"], [[2229, 2274], "disallowed"], [[2275, 2275], "valid"], [[2276, 2302], "valid"], [[2303, 2303], "valid"], [[2304, 2304], "valid"], [[2305, 2307], "valid"], [[2308, 2308], "valid"], [[2309, 2361], "valid"], [[2362, 2363], "valid"], [[2364, 2381], "valid"], [[2382, 2382], "valid"], [[2383, 2383], "valid"], [[2384, 2388], "valid"], [[2389, 2389], "valid"], [[2390, 2391], "valid"], [[2392, 2392], "mapped", [2325, 2364]], [[2393, 2393], "mapped", [2326, 2364]], [[2394, 2394], "mapped", [2327, 2364]], [[2395, 2395], "mapped", [2332, 2364]], [[2396, 2396], "mapped", [2337, 2364]], [[2397, 2397], "mapped", [2338, 2364]], [[2398, 2398], "mapped", [2347, 2364]], [[2399, 2399], "mapped", [2351, 2364]], [[2400, 2403], "valid"], [[2404, 2405], "valid", [], "NV8"], [[2406, 2415], "valid"], [[2416, 2416], "valid", [], "NV8"], [[2417, 2418], "valid"], [[2419, 2423], "valid"], [[2424, 2424], "valid"], [[2425, 2426], "valid"], [[2427, 2428], "valid"], [[2429, 2429], "valid"], [[2430, 2431], "valid"], [[2432, 2432], "valid"], [[2433, 2435], "valid"], [[2436, 2436], "disallowed"], [[2437, 2444], "valid"], [[2445, 2446], "disallowed"], [[2447, 2448], "valid"], [[2449, 2450], "disallowed"], [[2451, 2472], "valid"], [[2473, 2473], "disallowed"], [[2474, 2480], "valid"], [[2481, 2481], "disallowed"], [[2482, 2482], "valid"], [[2483, 2485], "disallowed"], [[2486, 2489], "valid"], [[2490, 2491], "disallowed"], [[2492, 2492], "valid"], [[2493, 2493], "valid"], [[2494, 2500], "valid"], [[2501, 2502], "disallowed"], [[2503, 2504], "valid"], [[2505, 2506], "disallowed"], [[2507, 2509], "valid"], [[2510, 2510], "valid"], [[2511, 2518], "disallowed"], [[2519, 2519], "valid"], [[2520, 2523], "disallowed"], [[2524, 2524], "mapped", [2465, 2492]], [[2525, 2525], "mapped", [2466, 2492]], [[2526, 2526], "disallowed"], [[2527, 2527], "mapped", [2479, 2492]], [[2528, 2531], "valid"], [[2532, 2533], "disallowed"], [[2534, 2545], "valid"], [[2546, 2554], "valid", [], "NV8"], [[2555, 2555], "valid", [], "NV8"], [[2556, 2560], "disallowed"], [[2561, 2561], "valid"], [[2562, 2562], "valid"], [[2563, 2563], "valid"], [[2564, 2564], "disallowed"], [[2565, 2570], "valid"], [[2571, 2574], "disallowed"], [[2575, 2576], "valid"], [[2577, 2578], "disallowed"], [[2579, 2600], "valid"], [[2601, 2601], "disallowed"], [[2602, 2608], "valid"], [[2609, 2609], "disallowed"], [[2610, 2610], "valid"], [[2611, 2611], "mapped", [2610, 2620]], [[2612, 2612], "disallowed"], [[2613, 2613], "valid"], [[2614, 2614], "mapped", [2616, 2620]], [[2615, 2615], "disallowed"], [[2616, 2617], "valid"], [[2618, 2619], "disallowed"], [[2620, 2620], "valid"], [[2621, 2621], "disallowed"], [[2622, 2626], "valid"], [[2627, 2630], "disallowed"], [[2631, 2632], "valid"], [[2633, 2634], "disallowed"], [[2635, 2637], "valid"], [[2638, 2640], "disallowed"], [[2641, 2641], "valid"], [[2642, 2648], "disallowed"], [[2649, 2649], "mapped", [2582, 2620]], [[2650, 2650], "mapped", [2583, 2620]], [[2651, 2651], "mapped", [2588, 2620]], [[2652, 2652], "valid"], [[2653, 2653], "disallowed"], [[2654, 2654], "mapped", [2603, 2620]], [[2655, 2661], "disallowed"], [[2662, 2676], "valid"], [[2677, 2677], "valid"], [[2678, 2688], "disallowed"], [[2689, 2691], "valid"], [[2692, 2692], "disallowed"], [[2693, 2699], "valid"], [[2700, 2700], "valid"], [[2701, 2701], "valid"], [[2702, 2702], "disallowed"], [[2703, 2705], "valid"], [[2706, 2706], "disallowed"], [[2707, 2728], "valid"], [[2729, 2729], "disallowed"], [[2730, 2736], "valid"], [[2737, 2737], "disallowed"], [[2738, 2739], "valid"], [[2740, 2740], "disallowed"], [[2741, 2745], "valid"], [[2746, 2747], "disallowed"], [[2748, 2757], "valid"], [[2758, 2758], "disallowed"], [[2759, 2761], "valid"], [[2762, 2762], "disallowed"], [[2763, 2765], "valid"], [[2766, 2767], "disallowed"], [[2768, 2768], "valid"], [[2769, 2783], "disallowed"], [[2784, 2784], "valid"], [[2785, 2787], "valid"], [[2788, 2789], "disallowed"], [[2790, 2799], "valid"], [[2800, 2800], "valid", [], "NV8"], [[2801, 2801], "valid", [], "NV8"], [[2802, 2808], "disallowed"], [[2809, 2809], "valid"], [[2810, 2816], "disallowed"], [[2817, 2819], "valid"], [[2820, 2820], "disallowed"], [[2821, 2828], "valid"], [[2829, 2830], "disallowed"], [[2831, 2832], "valid"], [[2833, 2834], "disallowed"], [[2835, 2856], "valid"], [[2857, 2857], "disallowed"], [[2858, 2864], "valid"], [[2865, 2865], "disallowed"], [[2866, 2867], "valid"], [[2868, 2868], "disallowed"], [[2869, 2869], "valid"], [[2870, 2873], "valid"], [[2874, 2875], "disallowed"], [[2876, 2883], "valid"], [[2884, 2884], "valid"], [[2885, 2886], "disallowed"], [[2887, 2888], "valid"], [[2889, 2890], "disallowed"], [[2891, 2893], "valid"], [[2894, 2901], "disallowed"], [[2902, 2903], "valid"], [[2904, 2907], "disallowed"], [[2908, 2908], "mapped", [2849, 2876]], [[2909, 2909], "mapped", [2850, 2876]], [[2910, 2910], "disallowed"], [[2911, 2913], "valid"], [[2914, 2915], "valid"], [[2916, 2917], "disallowed"], [[2918, 2927], "valid"], [[2928, 2928], "valid", [], "NV8"], [[2929, 2929], "valid"], [[2930, 2935], "valid", [], "NV8"], [[2936, 2945], "disallowed"], [[2946, 2947], "valid"], [[2948, 2948], "disallowed"], [[2949, 2954], "valid"], [[2955, 2957], "disallowed"], [[2958, 2960], "valid"], [[2961, 2961], "disallowed"], [[2962, 2965], "valid"], [[2966, 2968], "disallowed"], [[2969, 2970], "valid"], [[2971, 2971], "disallowed"], [[2972, 2972], "valid"], [[2973, 2973], "disallowed"], [[2974, 2975], "valid"], [[2976, 2978], "disallowed"], [[2979, 2980], "valid"], [[2981, 2983], "disallowed"], [[2984, 2986], "valid"], [[2987, 2989], "disallowed"], [[2990, 2997], "valid"], [[2998, 2998], "valid"], [[2999, 3001], "valid"], [[3002, 3005], "disallowed"], [[3006, 3010], "valid"], [[3011, 3013], "disallowed"], [[3014, 3016], "valid"], [[3017, 3017], "disallowed"], [[3018, 3021], "valid"], [[3022, 3023], "disallowed"], [[3024, 3024], "valid"], [[3025, 3030], "disallowed"], [[3031, 3031], "valid"], [[3032, 3045], "disallowed"], [[3046, 3046], "valid"], [[3047, 3055], "valid"], [[3056, 3058], "valid", [], "NV8"], [[3059, 3066], "valid", [], "NV8"], [[3067, 3071], "disallowed"], [[3072, 3072], "valid"], [[3073, 3075], "valid"], [[3076, 3076], "disallowed"], [[3077, 3084], "valid"], [[3085, 3085], "disallowed"], [[3086, 3088], "valid"], [[3089, 3089], "disallowed"], [[3090, 3112], "valid"], [[3113, 3113], "disallowed"], [[3114, 3123], "valid"], [[3124, 3124], "valid"], [[3125, 3129], "valid"], [[3130, 3132], "disallowed"], [[3133, 3133], "valid"], [[3134, 3140], "valid"], [[3141, 3141], "disallowed"], [[3142, 3144], "valid"], [[3145, 3145], "disallowed"], [[3146, 3149], "valid"], [[3150, 3156], "disallowed"], [[3157, 3158], "valid"], [[3159, 3159], "disallowed"], [[3160, 3161], "valid"], [[3162, 3162], "valid"], [[3163, 3167], "disallowed"], [[3168, 3169], "valid"], [[3170, 3171], "valid"], [[3172, 3173], "disallowed"], [[3174, 3183], "valid"], [[3184, 3191], "disallowed"], [[3192, 3199], "valid", [], "NV8"], [[3200, 3200], "disallowed"], [[3201, 3201], "valid"], [[3202, 3203], "valid"], [[3204, 3204], "disallowed"], [[3205, 3212], "valid"], [[3213, 3213], "disallowed"], [[3214, 3216], "valid"], [[3217, 3217], "disallowed"], [[3218, 3240], "valid"], [[3241, 3241], "disallowed"], [[3242, 3251], "valid"], [[3252, 3252], "disallowed"], [[3253, 3257], "valid"], [[3258, 3259], "disallowed"], [[3260, 3261], "valid"], [[3262, 3268], "valid"], [[3269, 3269], "disallowed"], [[3270, 3272], "valid"], [[3273, 3273], "disallowed"], [[3274, 3277], "valid"], [[3278, 3284], "disallowed"], [[3285, 3286], "valid"], [[3287, 3293], "disallowed"], [[3294, 3294], "valid"], [[3295, 3295], "disallowed"], [[3296, 3297], "valid"], [[3298, 3299], "valid"], [[3300, 3301], "disallowed"], [[3302, 3311], "valid"], [[3312, 3312], "disallowed"], [[3313, 3314], "valid"], [[3315, 3328], "disallowed"], [[3329, 3329], "valid"], [[3330, 3331], "valid"], [[3332, 3332], "disallowed"], [[3333, 3340], "valid"], [[3341, 3341], "disallowed"], [[3342, 3344], "valid"], [[3345, 3345], "disallowed"], [[3346, 3368], "valid"], [[3369, 3369], "valid"], [[3370, 3385], "valid"], [[3386, 3386], "valid"], [[3387, 3388], "disallowed"], [[3389, 3389], "valid"], [[3390, 3395], "valid"], [[3396, 3396], "valid"], [[3397, 3397], "disallowed"], [[3398, 3400], "valid"], [[3401, 3401], "disallowed"], [[3402, 3405], "valid"], [[3406, 3406], "valid"], [[3407, 3414], "disallowed"], [[3415, 3415], "valid"], [[3416, 3422], "disallowed"], [[3423, 3423], "valid"], [[3424, 3425], "valid"], [[3426, 3427], "valid"], [[3428, 3429], "disallowed"], [[3430, 3439], "valid"], [[3440, 3445], "valid", [], "NV8"], [[3446, 3448], "disallowed"], [[3449, 3449], "valid", [], "NV8"], [[3450, 3455], "valid"], [[3456, 3457], "disallowed"], [[3458, 3459], "valid"], [[3460, 3460], "disallowed"], [[3461, 3478], "valid"], [[3479, 3481], "disallowed"], [[3482, 3505], "valid"], [[3506, 3506], "disallowed"], [[3507, 3515], "valid"], [[3516, 3516], "disallowed"], [[3517, 3517], "valid"], [[3518, 3519], "disallowed"], [[3520, 3526], "valid"], [[3527, 3529], "disallowed"], [[3530, 3530], "valid"], [[3531, 3534], "disallowed"], [[3535, 3540], "valid"], [[3541, 3541], "disallowed"], [[3542, 3542], "valid"], [[3543, 3543], "disallowed"], [[3544, 3551], "valid"], [[3552, 3557], "disallowed"], [[3558, 3567], "valid"], [[3568, 3569], "disallowed"], [[3570, 3571], "valid"], [[3572, 3572], "valid", [], "NV8"], [[3573, 3584], "disallowed"], [[3585, 3634], "valid"], [[3635, 3635], "mapped", [3661, 3634]], [[3636, 3642], "valid"], [[3643, 3646], "disallowed"], [[3647, 3647], "valid", [], "NV8"], [[3648, 3662], "valid"], [[3663, 3663], "valid", [], "NV8"], [[3664, 3673], "valid"], [[3674, 3675], "valid", [], "NV8"], [[3676, 3712], "disallowed"], [[3713, 3714], "valid"], [[3715, 3715], "disallowed"], [[3716, 3716], "valid"], [[3717, 3718], "disallowed"], [[3719, 3720], "valid"], [[3721, 3721], "disallowed"], [[3722, 3722], "valid"], [[3723, 3724], "disallowed"], [[3725, 3725], "valid"], [[3726, 3731], "disallowed"], [[3732, 3735], "valid"], [[3736, 3736], "disallowed"], [[3737, 3743], "valid"], [[3744, 3744], "disallowed"], [[3745, 3747], "valid"], [[3748, 3748], "disallowed"], [[3749, 3749], "valid"], [[3750, 3750], "disallowed"], [[3751, 3751], "valid"], [[3752, 3753], "disallowed"], [[3754, 3755], "valid"], [[3756, 3756], "disallowed"], [[3757, 3762], "valid"], [[3763, 3763], "mapped", [3789, 3762]], [[3764, 3769], "valid"], [[3770, 3770], "disallowed"], [[3771, 3773], "valid"], [[3774, 3775], "disallowed"], [[3776, 3780], "valid"], [[3781, 3781], "disallowed"], [[3782, 3782], "valid"], [[3783, 3783], "disallowed"], [[3784, 3789], "valid"], [[3790, 3791], "disallowed"], [[3792, 3801], "valid"], [[3802, 3803], "disallowed"], [[3804, 3804], "mapped", [3755, 3737]], [[3805, 3805], "mapped", [3755, 3745]], [[3806, 3807], "valid"], [[3808, 3839], "disallowed"], [[3840, 3840], "valid"], [[3841, 3850], "valid", [], "NV8"], [[3851, 3851], "valid"], [[3852, 3852], "mapped", [3851]], [[3853, 3863], "valid", [], "NV8"], [[3864, 3865], "valid"], [[3866, 3871], "valid", [], "NV8"], [[3872, 3881], "valid"], [[3882, 3892], "valid", [], "NV8"], [[3893, 3893], "valid"], [[3894, 3894], "valid", [], "NV8"], [[3895, 3895], "valid"], [[3896, 3896], "valid", [], "NV8"], [[3897, 3897], "valid"], [[3898, 3901], "valid", [], "NV8"], [[3902, 3906], "valid"], [[3907, 3907], "mapped", [3906, 4023]], [[3908, 3911], "valid"], [[3912, 3912], "disallowed"], [[3913, 3916], "valid"], [[3917, 3917], "mapped", [3916, 4023]], [[3918, 3921], "valid"], [[3922, 3922], "mapped", [3921, 4023]], [[3923, 3926], "valid"], [[3927, 3927], "mapped", [3926, 4023]], [[3928, 3931], "valid"], [[3932, 3932], "mapped", [3931, 4023]], [[3933, 3944], "valid"], [[3945, 3945], "mapped", [3904, 4021]], [[3946, 3946], "valid"], [[3947, 3948], "valid"], [[3949, 3952], "disallowed"], [[3953, 3954], "valid"], [[3955, 3955], "mapped", [3953, 3954]], [[3956, 3956], "valid"], [[3957, 3957], "mapped", [3953, 3956]], [[3958, 3958], "mapped", [4018, 3968]], [[3959, 3959], "mapped", [4018, 3953, 3968]], [[3960, 3960], "mapped", [4019, 3968]], [[3961, 3961], "mapped", [4019, 3953, 3968]], [[3962, 3968], "valid"], [[3969, 3969], "mapped", [3953, 3968]], [[3970, 3972], "valid"], [[3973, 3973], "valid", [], "NV8"], [[3974, 3979], "valid"], [[3980, 3983], "valid"], [[3984, 3986], "valid"], [[3987, 3987], "mapped", [3986, 4023]], [[3988, 3989], "valid"], [[3990, 3990], "valid"], [[3991, 3991], "valid"], [[3992, 3992], "disallowed"], [[3993, 3996], "valid"], [[3997, 3997], "mapped", [3996, 4023]], [[3998, 4001], "valid"], [[4002, 4002], "mapped", [4001, 4023]], [[4003, 4006], "valid"], [[4007, 4007], "mapped", [4006, 4023]], [[4008, 4011], "valid"], [[4012, 4012], "mapped", [4011, 4023]], [[4013, 4013], "valid"], [[4014, 4016], "valid"], [[4017, 4023], "valid"], [[4024, 4024], "valid"], [[4025, 4025], "mapped", [3984, 4021]], [[4026, 4028], "valid"], [[4029, 4029], "disallowed"], [[4030, 4037], "valid", [], "NV8"], [[4038, 4038], "valid"], [[4039, 4044], "valid", [], "NV8"], [[4045, 4045], "disallowed"], [[4046, 4046], "valid", [], "NV8"], [[4047, 4047], "valid", [], "NV8"], [[4048, 4049], "valid", [], "NV8"], [[4050, 4052], "valid", [], "NV8"], [[4053, 4056], "valid", [], "NV8"], [[4057, 4058], "valid", [], "NV8"], [[4059, 4095], "disallowed"], [[4096, 4129], "valid"], [[4130, 4130], "valid"], [[4131, 4135], "valid"], [[4136, 4136], "valid"], [[4137, 4138], "valid"], [[4139, 4139], "valid"], [[4140, 4146], "valid"], [[4147, 4149], "valid"], [[4150, 4153], "valid"], [[4154, 4159], "valid"], [[4160, 4169], "valid"], [[4170, 4175], "valid", [], "NV8"], [[4176, 4185], "valid"], [[4186, 4249], "valid"], [[4250, 4253], "valid"], [[4254, 4255], "valid", [], "NV8"], [[4256, 4293], "disallowed"], [[4294, 4294], "disallowed"], [[4295, 4295], "mapped", [11559]], [[4296, 4300], "disallowed"], [[4301, 4301], "mapped", [11565]], [[4302, 4303], "disallowed"], [[4304, 4342], "valid"], [[4343, 4344], "valid"], [[4345, 4346], "valid"], [[4347, 4347], "valid", [], "NV8"], [[4348, 4348], "mapped", [4316]], [[4349, 4351], "valid"], [[4352, 4441], "valid", [], "NV8"], [[4442, 4446], "valid", [], "NV8"], [[4447, 4448], "disallowed"], [[4449, 4514], "valid", [], "NV8"], [[4515, 4519], "valid", [], "NV8"], [[4520, 4601], "valid", [], "NV8"], [[4602, 4607], "valid", [], "NV8"], [[4608, 4614], "valid"], [[4615, 4615], "valid"], [[4616, 4678], "valid"], [[4679, 4679], "valid"], [[4680, 4680], "valid"], [[4681, 4681], "disallowed"], [[4682, 4685], "valid"], [[4686, 4687], "disallowed"], [[4688, 4694], "valid"], [[4695, 4695], "disallowed"], [[4696, 4696], "valid"], [[4697, 4697], "disallowed"], [[4698, 4701], "valid"], [[4702, 4703], "disallowed"], [[4704, 4742], "valid"], [[4743, 4743], "valid"], [[4744, 4744], "valid"], [[4745, 4745], "disallowed"], [[4746, 4749], "valid"], [[4750, 4751], "disallowed"], [[4752, 4782], "valid"], [[4783, 4783], "valid"], [[4784, 4784], "valid"], [[4785, 4785], "disallowed"], [[4786, 4789], "valid"], [[4790, 4791], "disallowed"], [[4792, 4798], "valid"], [[4799, 4799], "disallowed"], [[4800, 4800], "valid"], [[4801, 4801], "disallowed"], [[4802, 4805], "valid"], [[4806, 4807], "disallowed"], [[4808, 4814], "valid"], [[4815, 4815], "valid"], [[4816, 4822], "valid"], [[4823, 4823], "disallowed"], [[4824, 4846], "valid"], [[4847, 4847], "valid"], [[4848, 4878], "valid"], [[4879, 4879], "valid"], [[4880, 4880], "valid"], [[4881, 4881], "disallowed"], [[4882, 4885], "valid"], [[4886, 4887], "disallowed"], [[4888, 4894], "valid"], [[4895, 4895], "valid"], [[4896, 4934], "valid"], [[4935, 4935], "valid"], [[4936, 4954], "valid"], [[4955, 4956], "disallowed"], [[4957, 4958], "valid"], [[4959, 4959], "valid"], [[4960, 4960], "valid", [], "NV8"], [[4961, 4988], "valid", [], "NV8"], [[4989, 4991], "disallowed"], [[4992, 5007], "valid"], [[5008, 5017], "valid", [], "NV8"], [[5018, 5023], "disallowed"], [[5024, 5108], "valid"], [[5109, 5109], "valid"], [[5110, 5111], "disallowed"], [[5112, 5112], "mapped", [5104]], [[5113, 5113], "mapped", [5105]], [[5114, 5114], "mapped", [5106]], [[5115, 5115], "mapped", [5107]], [[5116, 5116], "mapped", [5108]], [[5117, 5117], "mapped", [5109]], [[5118, 5119], "disallowed"], [[5120, 5120], "valid", [], "NV8"], [[5121, 5740], "valid"], [[5741, 5742], "valid", [], "NV8"], [[5743, 5750], "valid"], [[5751, 5759], "valid"], [[5760, 5760], "disallowed"], [[5761, 5786], "valid"], [[5787, 5788], "valid", [], "NV8"], [[5789, 5791], "disallowed"], [[5792, 5866], "valid"], [[5867, 5872], "valid", [], "NV8"], [[5873, 5880], "valid"], [[5881, 5887], "disallowed"], [[5888, 5900], "valid"], [[5901, 5901], "disallowed"], [[5902, 5908], "valid"], [[5909, 5919], "disallowed"], [[5920, 5940], "valid"], [[5941, 5942], "valid", [], "NV8"], [[5943, 5951], "disallowed"], [[5952, 5971], "valid"], [[5972, 5983], "disallowed"], [[5984, 5996], "valid"], [[5997, 5997], "disallowed"], [[5998, 6e3], "valid"], [[6001, 6001], "disallowed"], [[6002, 6003], "valid"], [[6004, 6015], "disallowed"], [[6016, 6067], "valid"], [[6068, 6069], "disallowed"], [[6070, 6099], "valid"], [[6100, 6102], "valid", [], "NV8"], [[6103, 6103], "valid"], [[6104, 6107], "valid", [], "NV8"], [[6108, 6108], "valid"], [[6109, 6109], "valid"], [[6110, 6111], "disallowed"], [[6112, 6121], "valid"], [[6122, 6127], "disallowed"], [[6128, 6137], "valid", [], "NV8"], [[6138, 6143], "disallowed"], [[6144, 6149], "valid", [], "NV8"], [[6150, 6150], "disallowed"], [[6151, 6154], "valid", [], "NV8"], [[6155, 6157], "ignored"], [[6158, 6158], "disallowed"], [[6159, 6159], "disallowed"], [[6160, 6169], "valid"], [[6170, 6175], "disallowed"], [[6176, 6263], "valid"], [[6264, 6271], "disallowed"], [[6272, 6313], "valid"], [[6314, 6314], "valid"], [[6315, 6319], "disallowed"], [[6320, 6389], "valid"], [[6390, 6399], "disallowed"], [[6400, 6428], "valid"], [[6429, 6430], "valid"], [[6431, 6431], "disallowed"], [[6432, 6443], "valid"], [[6444, 6447], "disallowed"], [[6448, 6459], "valid"], [[6460, 6463], "disallowed"], [[6464, 6464], "valid", [], "NV8"], [[6465, 6467], "disallowed"], [[6468, 6469], "valid", [], "NV8"], [[6470, 6509], "valid"], [[6510, 6511], "disallowed"], [[6512, 6516], "valid"], [[6517, 6527], "disallowed"], [[6528, 6569], "valid"], [[6570, 6571], "valid"], [[6572, 6575], "disallowed"], [[6576, 6601], "valid"], [[6602, 6607], "disallowed"], [[6608, 6617], "valid"], [[6618, 6618], "valid", [], "XV8"], [[6619, 6621], "disallowed"], [[6622, 6623], "valid", [], "NV8"], [[6624, 6655], "valid", [], "NV8"], [[6656, 6683], "valid"], [[6684, 6685], "disallowed"], [[6686, 6687], "valid", [], "NV8"], [[6688, 6750], "valid"], [[6751, 6751], "disallowed"], [[6752, 6780], "valid"], [[6781, 6782], "disallowed"], [[6783, 6793], "valid"], [[6794, 6799], "disallowed"], [[6800, 6809], "valid"], [[6810, 6815], "disallowed"], [[6816, 6822], "valid", [], "NV8"], [[6823, 6823], "valid"], [[6824, 6829], "valid", [], "NV8"], [[6830, 6831], "disallowed"], [[6832, 6845], "valid"], [[6846, 6846], "valid", [], "NV8"], [[6847, 6911], "disallowed"], [[6912, 6987], "valid"], [[6988, 6991], "disallowed"], [[6992, 7001], "valid"], [[7002, 7018], "valid", [], "NV8"], [[7019, 7027], "valid"], [[7028, 7036], "valid", [], "NV8"], [[7037, 7039], "disallowed"], [[7040, 7082], "valid"], [[7083, 7085], "valid"], [[7086, 7097], "valid"], [[7098, 7103], "valid"], [[7104, 7155], "valid"], [[7156, 7163], "disallowed"], [[7164, 7167], "valid", [], "NV8"], [[7168, 7223], "valid"], [[7224, 7226], "disallowed"], [[7227, 7231], "valid", [], "NV8"], [[7232, 7241], "valid"], [[7242, 7244], "disallowed"], [[7245, 7293], "valid"], [[7294, 7295], "valid", [], "NV8"], [[7296, 7359], "disallowed"], [[7360, 7367], "valid", [], "NV8"], [[7368, 7375], "disallowed"], [[7376, 7378], "valid"], [[7379, 7379], "valid", [], "NV8"], [[7380, 7410], "valid"], [[7411, 7414], "valid"], [[7415, 7415], "disallowed"], [[7416, 7417], "valid"], [[7418, 7423], "disallowed"], [[7424, 7467], "valid"], [[7468, 7468], "mapped", [97]], [[7469, 7469], "mapped", [230]], [[7470, 7470], "mapped", [98]], [[7471, 7471], "valid"], [[7472, 7472], "mapped", [100]], [[7473, 7473], "mapped", [101]], [[7474, 7474], "mapped", [477]], [[7475, 7475], "mapped", [103]], [[7476, 7476], "mapped", [104]], [[7477, 7477], "mapped", [105]], [[7478, 7478], "mapped", [106]], [[7479, 7479], "mapped", [107]], [[7480, 7480], "mapped", [108]], [[7481, 7481], "mapped", [109]], [[7482, 7482], "mapped", [110]], [[7483, 7483], "valid"], [[7484, 7484], "mapped", [111]], [[7485, 7485], "mapped", [547]], [[7486, 7486], "mapped", [112]], [[7487, 7487], "mapped", [114]], [[7488, 7488], "mapped", [116]], [[7489, 7489], "mapped", [117]], [[7490, 7490], "mapped", [119]], [[7491, 7491], "mapped", [97]], [[7492, 7492], "mapped", [592]], [[7493, 7493], "mapped", [593]], [[7494, 7494], "mapped", [7426]], [[7495, 7495], "mapped", [98]], [[7496, 7496], "mapped", [100]], [[7497, 7497], "mapped", [101]], [[7498, 7498], "mapped", [601]], [[7499, 7499], "mapped", [603]], [[7500, 7500], "mapped", [604]], [[7501, 7501], "mapped", [103]], [[7502, 7502], "valid"], [[7503, 7503], "mapped", [107]], [[7504, 7504], "mapped", [109]], [[7505, 7505], "mapped", [331]], [[7506, 7506], "mapped", [111]], [[7507, 7507], "mapped", [596]], [[7508, 7508], "mapped", [7446]], [[7509, 7509], "mapped", [7447]], [[7510, 7510], "mapped", [112]], [[7511, 7511], "mapped", [116]], [[7512, 7512], "mapped", [117]], [[7513, 7513], "mapped", [7453]], [[7514, 7514], "mapped", [623]], [[7515, 7515], "mapped", [118]], [[7516, 7516], "mapped", [7461]], [[7517, 7517], "mapped", [946]], [[7518, 7518], "mapped", [947]], [[7519, 7519], "mapped", [948]], [[7520, 7520], "mapped", [966]], [[7521, 7521], "mapped", [967]], [[7522, 7522], "mapped", [105]], [[7523, 7523], "mapped", [114]], [[7524, 7524], "mapped", [117]], [[7525, 7525], "mapped", [118]], [[7526, 7526], "mapped", [946]], [[7527, 7527], "mapped", [947]], [[7528, 7528], "mapped", [961]], [[7529, 7529], "mapped", [966]], [[7530, 7530], "mapped", [967]], [[7531, 7531], "valid"], [[7532, 7543], "valid"], [[7544, 7544], "mapped", [1085]], [[7545, 7578], "valid"], [[7579, 7579], "mapped", [594]], [[7580, 7580], "mapped", [99]], [[7581, 7581], "mapped", [597]], [[7582, 7582], "mapped", [240]], [[7583, 7583], "mapped", [604]], [[7584, 7584], "mapped", [102]], [[7585, 7585], "mapped", [607]], [[7586, 7586], "mapped", [609]], [[7587, 7587], "mapped", [613]], [[7588, 7588], "mapped", [616]], [[7589, 7589], "mapped", [617]], [[7590, 7590], "mapped", [618]], [[7591, 7591], "mapped", [7547]], [[7592, 7592], "mapped", [669]], [[7593, 7593], "mapped", [621]], [[7594, 7594], "mapped", [7557]], [[7595, 7595], "mapped", [671]], [[7596, 7596], "mapped", [625]], [[7597, 7597], "mapped", [624]], [[7598, 7598], "mapped", [626]], [[7599, 7599], "mapped", [627]], [[7600, 7600], "mapped", [628]], [[7601, 7601], "mapped", [629]], [[7602, 7602], "mapped", [632]], [[7603, 7603], "mapped", [642]], [[7604, 7604], "mapped", [643]], [[7605, 7605], "mapped", [427]], [[7606, 7606], "mapped", [649]], [[7607, 7607], "mapped", [650]], [[7608, 7608], "mapped", [7452]], [[7609, 7609], "mapped", [651]], [[7610, 7610], "mapped", [652]], [[7611, 7611], "mapped", [122]], [[7612, 7612], "mapped", [656]], [[7613, 7613], "mapped", [657]], [[7614, 7614], "mapped", [658]], [[7615, 7615], "mapped", [952]], [[7616, 7619], "valid"], [[7620, 7626], "valid"], [[7627, 7654], "valid"], [[7655, 7669], "valid"], [[7670, 7675], "disallowed"], [[7676, 7676], "valid"], [[7677, 7677], "valid"], [[7678, 7679], "valid"], [[7680, 7680], "mapped", [7681]], [[7681, 7681], "valid"], [[7682, 7682], "mapped", [7683]], [[7683, 7683], "valid"], [[7684, 7684], "mapped", [7685]], [[7685, 7685], "valid"], [[7686, 7686], "mapped", [7687]], [[7687, 7687], "valid"], [[7688, 7688], "mapped", [7689]], [[7689, 7689], "valid"], [[7690, 7690], "mapped", [7691]], [[7691, 7691], "valid"], [[7692, 7692], "mapped", [7693]], [[7693, 7693], "valid"], [[7694, 7694], "mapped", [7695]], [[7695, 7695], "valid"], [[7696, 7696], "mapped", [7697]], [[7697, 7697], "valid"], [[7698, 7698], "mapped", [7699]], [[7699, 7699], "valid"], [[7700, 7700], "mapped", [7701]], [[7701, 7701], "valid"], [[7702, 7702], "mapped", [7703]], [[7703, 7703], "valid"], [[7704, 7704], "mapped", [7705]], [[7705, 7705], "valid"], [[7706, 7706], "mapped", [7707]], [[7707, 7707], "valid"], [[7708, 7708], "mapped", [7709]], [[7709, 7709], "valid"], [[7710, 7710], "mapped", [7711]], [[7711, 7711], "valid"], [[7712, 7712], "mapped", [7713]], [[7713, 7713], "valid"], [[7714, 7714], "mapped", [7715]], [[7715, 7715], "valid"], [[7716, 7716], "mapped", [7717]], [[7717, 7717], "valid"], [[7718, 7718], "mapped", [7719]], [[7719, 7719], "valid"], [[7720, 7720], "mapped", [7721]], [[7721, 7721], "valid"], [[7722, 7722], "mapped", [7723]], [[7723, 7723], "valid"], [[7724, 7724], "mapped", [7725]], [[7725, 7725], "valid"], [[7726, 7726], "mapped", [7727]], [[7727, 7727], "valid"], [[7728, 7728], "mapped", [7729]], [[7729, 7729], "valid"], [[7730, 7730], "mapped", [7731]], [[7731, 7731], "valid"], [[7732, 7732], "mapped", [7733]], [[7733, 7733], "valid"], [[7734, 7734], "mapped", [7735]], [[7735, 7735], "valid"], [[7736, 7736], "mapped", [7737]], [[7737, 7737], "valid"], [[7738, 7738], "mapped", [7739]], [[7739, 7739], "valid"], [[7740, 7740], "mapped", [7741]], [[7741, 7741], "valid"], [[7742, 7742], "mapped", [7743]], [[7743, 7743], "valid"], [[7744, 7744], "mapped", [7745]], [[7745, 7745], "valid"], [[7746, 7746], "mapped", [7747]], [[7747, 7747], "valid"], [[7748, 7748], "mapped", [7749]], [[7749, 7749], "valid"], [[7750, 7750], "mapped", [7751]], [[7751, 7751], "valid"], [[7752, 7752], "mapped", [7753]], [[7753, 7753], "valid"], [[7754, 7754], "mapped", [7755]], [[7755, 7755], "valid"], [[7756, 7756], "mapped", [7757]], [[7757, 7757], "valid"], [[7758, 7758], "mapped", [7759]], [[7759, 7759], "valid"], [[7760, 7760], "mapped", [7761]], [[7761, 7761], "valid"], [[7762, 7762], "mapped", [7763]], [[7763, 7763], "valid"], [[7764, 7764], "mapped", [7765]], [[7765, 7765], "valid"], [[7766, 7766], "mapped", [7767]], [[7767, 7767], "valid"], [[7768, 7768], "mapped", [7769]], [[7769, 7769], "valid"], [[7770, 7770], "mapped", [7771]], [[7771, 7771], "valid"], [[7772, 7772], "mapped", [7773]], [[7773, 7773], "valid"], [[7774, 7774], "mapped", [7775]], [[7775, 7775], "valid"], [[7776, 7776], "mapped", [7777]], [[7777, 7777], "valid"], [[7778, 7778], "mapped", [7779]], [[7779, 7779], "valid"], [[7780, 7780], "mapped", [7781]], [[7781, 7781], "valid"], [[7782, 7782], "mapped", [7783]], [[7783, 7783], "valid"], [[7784, 7784], "mapped", [7785]], [[7785, 7785], "valid"], [[7786, 7786], "mapped", [7787]], [[7787, 7787], "valid"], [[7788, 7788], "mapped", [7789]], [[7789, 7789], "valid"], [[7790, 7790], "mapped", [7791]], [[7791, 7791], "valid"], [[7792, 7792], "mapped", [7793]], [[7793, 7793], "valid"], [[7794, 7794], "mapped", [7795]], [[7795, 7795], "valid"], [[7796, 7796], "mapped", [7797]], [[7797, 7797], "valid"], [[7798, 7798], "mapped", [7799]], [[7799, 7799], "valid"], [[7800, 7800], "mapped", [7801]], [[7801, 7801], "valid"], [[7802, 7802], "mapped", [7803]], [[7803, 7803], "valid"], [[7804, 7804], "mapped", [7805]], [[7805, 7805], "valid"], [[7806, 7806], "mapped", [7807]], [[7807, 7807], "valid"], [[7808, 7808], "mapped", [7809]], [[7809, 7809], "valid"], [[7810, 7810], "mapped", [7811]], [[7811, 7811], "valid"], [[7812, 7812], "mapped", [7813]], [[7813, 7813], "valid"], [[7814, 7814], "mapped", [7815]], [[7815, 7815], "valid"], [[7816, 7816], "mapped", [7817]], [[7817, 7817], "valid"], [[7818, 7818], "mapped", [7819]], [[7819, 7819], "valid"], [[7820, 7820], "mapped", [7821]], [[7821, 7821], "valid"], [[7822, 7822], "mapped", [7823]], [[7823, 7823], "valid"], [[7824, 7824], "mapped", [7825]], [[7825, 7825], "valid"], [[7826, 7826], "mapped", [7827]], [[7827, 7827], "valid"], [[7828, 7828], "mapped", [7829]], [[7829, 7833], "valid"], [[7834, 7834], "mapped", [97, 702]], [[7835, 7835], "mapped", [7777]], [[7836, 7837], "valid"], [[7838, 7838], "mapped", [115, 115]], [[7839, 7839], "valid"], [[7840, 7840], "mapped", [7841]], [[7841, 7841], "valid"], [[7842, 7842], "mapped", [7843]], [[7843, 7843], "valid"], [[7844, 7844], "mapped", [7845]], [[7845, 7845], "valid"], [[7846, 7846], "mapped", [7847]], [[7847, 7847], "valid"], [[7848, 7848], "mapped", [7849]], [[7849, 7849], "valid"], [[7850, 7850], "mapped", [7851]], [[7851, 7851], "valid"], [[7852, 7852], "mapped", [7853]], [[7853, 7853], "valid"], [[7854, 7854], "mapped", [7855]], [[7855, 7855], "valid"], [[7856, 7856], "mapped", [7857]], [[7857, 7857], "valid"], [[7858, 7858], "mapped", [7859]], [[7859, 7859], "valid"], [[7860, 7860], "mapped", [7861]], [[7861, 7861], "valid"], [[7862, 7862], "mapped", [7863]], [[7863, 7863], "valid"], [[7864, 7864], "mapped", [7865]], [[7865, 7865], "valid"], [[7866, 7866], "mapped", [7867]], [[7867, 7867], "valid"], [[7868, 7868], "mapped", [7869]], [[7869, 7869], "valid"], [[7870, 7870], "mapped", [7871]], [[7871, 7871], "valid"], [[7872, 7872], "mapped", [7873]], [[7873, 7873], "valid"], [[7874, 7874], "mapped", [7875]], [[7875, 7875], "valid"], [[7876, 7876], "mapped", [7877]], [[7877, 7877], "valid"], [[7878, 7878], "mapped", [7879]], [[7879, 7879], "valid"], [[7880, 7880], "mapped", [7881]], [[7881, 7881], "valid"], [[7882, 7882], "mapped", [7883]], [[7883, 7883], "valid"], [[7884, 7884], "mapped", [7885]], [[7885, 7885], "valid"], [[7886, 7886], "mapped", [7887]], [[7887, 7887], "valid"], [[7888, 7888], "mapped", [7889]], [[7889, 7889], "valid"], [[7890, 7890], "mapped", [7891]], [[7891, 7891], "valid"], [[7892, 7892], "mapped", [7893]], [[7893, 7893], "valid"], [[7894, 7894], "mapped", [7895]], [[7895, 7895], "valid"], [[7896, 7896], "mapped", [7897]], [[7897, 7897], "valid"], [[7898, 7898], "mapped", [7899]], [[7899, 7899], "valid"], [[7900, 7900], "mapped", [7901]], [[7901, 7901], "valid"], [[7902, 7902], "mapped", [7903]], [[7903, 7903], "valid"], [[7904, 7904], "mapped", [7905]], [[7905, 7905], "valid"], [[7906, 7906], "mapped", [7907]], [[7907, 7907], "valid"], [[7908, 7908], "mapped", [7909]], [[7909, 7909], "valid"], [[7910, 7910], "mapped", [7911]], [[7911, 7911], "valid"], [[7912, 7912], "mapped", [7913]], [[7913, 7913], "valid"], [[7914, 7914], "mapped", [7915]], [[7915, 7915], "valid"], [[7916, 7916], "mapped", [7917]], [[7917, 7917], "valid"], [[7918, 7918], "mapped", [7919]], [[7919, 7919], "valid"], [[7920, 7920], "mapped", [7921]], [[7921, 7921], "valid"], [[7922, 7922], "mapped", [7923]], [[7923, 7923], "valid"], [[7924, 7924], "mapped", [7925]], [[7925, 7925], "valid"], [[7926, 7926], "mapped", [7927]], [[7927, 7927], "valid"], [[7928, 7928], "mapped", [7929]], [[7929, 7929], "valid"], [[7930, 7930], "mapped", [7931]], [[7931, 7931], "valid"], [[7932, 7932], "mapped", [7933]], [[7933, 7933], "valid"], [[7934, 7934], "mapped", [7935]], [[7935, 7935], "valid"], [[7936, 7943], "valid"], [[7944, 7944], "mapped", [7936]], [[7945, 7945], "mapped", [7937]], [[7946, 7946], "mapped", [7938]], [[7947, 7947], "mapped", [7939]], [[7948, 7948], "mapped", [7940]], [[7949, 7949], "mapped", [7941]], [[7950, 7950], "mapped", [7942]], [[7951, 7951], "mapped", [7943]], [[7952, 7957], "valid"], [[7958, 7959], "disallowed"], [[7960, 7960], "mapped", [7952]], [[7961, 7961], "mapped", [7953]], [[7962, 7962], "mapped", [7954]], [[7963, 7963], "mapped", [7955]], [[7964, 7964], "mapped", [7956]], [[7965, 7965], "mapped", [7957]], [[7966, 7967], "disallowed"], [[7968, 7975], "valid"], [[7976, 7976], "mapped", [7968]], [[7977, 7977], "mapped", [7969]], [[7978, 7978], "mapped", [7970]], [[7979, 7979], "mapped", [7971]], [[7980, 7980], "mapped", [7972]], [[7981, 7981], "mapped", [7973]], [[7982, 7982], "mapped", [7974]], [[7983, 7983], "mapped", [7975]], [[7984, 7991], "valid"], [[7992, 7992], "mapped", [7984]], [[7993, 7993], "mapped", [7985]], [[7994, 7994], "mapped", [7986]], [[7995, 7995], "mapped", [7987]], [[7996, 7996], "mapped", [7988]], [[7997, 7997], "mapped", [7989]], [[7998, 7998], "mapped", [7990]], [[7999, 7999], "mapped", [7991]], [[8e3, 8005], "valid"], [[8006, 8007], "disallowed"], [[8008, 8008], "mapped", [8e3]], [[8009, 8009], "mapped", [8001]], [[8010, 8010], "mapped", [8002]], [[8011, 8011], "mapped", [8003]], [[8012, 8012], "mapped", [8004]], [[8013, 8013], "mapped", [8005]], [[8014, 8015], "disallowed"], [[8016, 8023], "valid"], [[8024, 8024], "disallowed"], [[8025, 8025], "mapped", [8017]], [[8026, 8026], "disallowed"], [[8027, 8027], "mapped", [8019]], [[8028, 8028], "disallowed"], [[8029, 8029], "mapped", [8021]], [[8030, 8030], "disallowed"], [[8031, 8031], "mapped", [8023]], [[8032, 8039], "valid"], [[8040, 8040], "mapped", [8032]], [[8041, 8041], "mapped", [8033]], [[8042, 8042], "mapped", [8034]], [[8043, 8043], "mapped", [8035]], [[8044, 8044], "mapped", [8036]], [[8045, 8045], "mapped", [8037]], [[8046, 8046], "mapped", [8038]], [[8047, 8047], "mapped", [8039]], [[8048, 8048], "valid"], [[8049, 8049], "mapped", [940]], [[8050, 8050], "valid"], [[8051, 8051], "mapped", [941]], [[8052, 8052], "valid"], [[8053, 8053], "mapped", [942]], [[8054, 8054], "valid"], [[8055, 8055], "mapped", [943]], [[8056, 8056], "valid"], [[8057, 8057], "mapped", [972]], [[8058, 8058], "valid"], [[8059, 8059], "mapped", [973]], [[8060, 8060], "valid"], [[8061, 8061], "mapped", [974]], [[8062, 8063], "disallowed"], [[8064, 8064], "mapped", [7936, 953]], [[8065, 8065], "mapped", [7937, 953]], [[8066, 8066], "mapped", [7938, 953]], [[8067, 8067], "mapped", [7939, 953]], [[8068, 8068], "mapped", [7940, 953]], [[8069, 8069], "mapped", [7941, 953]], [[8070, 8070], "mapped", [7942, 953]], [[8071, 8071], "mapped", [7943, 953]], [[8072, 8072], "mapped", [7936, 953]], [[8073, 8073], "mapped", [7937, 953]], [[8074, 8074], "mapped", [7938, 953]], [[8075, 8075], "mapped", [7939, 953]], [[8076, 8076], "mapped", [7940, 953]], [[8077, 8077], "mapped", [7941, 953]], [[8078, 8078], "mapped", [7942, 953]], [[8079, 8079], "mapped", [7943, 953]], [[8080, 8080], "mapped", [7968, 953]], [[8081, 8081], "mapped", [7969, 953]], [[8082, 8082], "mapped", [7970, 953]], [[8083, 8083], "mapped", [7971, 953]], [[8084, 8084], "mapped", [7972, 953]], [[8085, 8085], "mapped", [7973, 953]], [[8086, 8086], "mapped", [7974, 953]], [[8087, 8087], "mapped", [7975, 953]], [[8088, 8088], "mapped", [7968, 953]], [[8089, 8089], "mapped", [7969, 953]], [[8090, 8090], "mapped", [7970, 953]], [[8091, 8091], "mapped", [7971, 953]], [[8092, 8092], "mapped", [7972, 953]], [[8093, 8093], "mapped", [7973, 953]], [[8094, 8094], "mapped", [7974, 953]], [[8095, 8095], "mapped", [7975, 953]], [[8096, 8096], "mapped", [8032, 953]], [[8097, 8097], "mapped", [8033, 953]], [[8098, 8098], "mapped", [8034, 953]], [[8099, 8099], "mapped", [8035, 953]], [[8100, 8100], "mapped", [8036, 953]], [[8101, 8101], "mapped", [8037, 953]], [[8102, 8102], "mapped", [8038, 953]], [[8103, 8103], "mapped", [8039, 953]], [[8104, 8104], "mapped", [8032, 953]], [[8105, 8105], "mapped", [8033, 953]], [[8106, 8106], "mapped", [8034, 953]], [[8107, 8107], "mapped", [8035, 953]], [[8108, 8108], "mapped", [8036, 953]], [[8109, 8109], "mapped", [8037, 953]], [[8110, 8110], "mapped", [8038, 953]], [[8111, 8111], "mapped", [8039, 953]], [[8112, 8113], "valid"], [[8114, 8114], "mapped", [8048, 953]], [[8115, 8115], "mapped", [945, 953]], [[8116, 8116], "mapped", [940, 953]], [[8117, 8117], "disallowed"], [[8118, 8118], "valid"], [[8119, 8119], "mapped", [8118, 953]], [[8120, 8120], "mapped", [8112]], [[8121, 8121], "mapped", [8113]], [[8122, 8122], "mapped", [8048]], [[8123, 8123], "mapped", [940]], [[8124, 8124], "mapped", [945, 953]], [[8125, 8125], "disallowed_STD3_mapped", [32, 787]], [[8126, 8126], "mapped", [953]], [[8127, 8127], "disallowed_STD3_mapped", [32, 787]], [[8128, 8128], "disallowed_STD3_mapped", [32, 834]], [[8129, 8129], "disallowed_STD3_mapped", [32, 776, 834]], [[8130, 8130], "mapped", [8052, 953]], [[8131, 8131], "mapped", [951, 953]], [[8132, 8132], "mapped", [942, 953]], [[8133, 8133], "disallowed"], [[8134, 8134], "valid"], [[8135, 8135], "mapped", [8134, 953]], [[8136, 8136], "mapped", [8050]], [[8137, 8137], "mapped", [941]], [[8138, 8138], "mapped", [8052]], [[8139, 8139], "mapped", [942]], [[8140, 8140], "mapped", [951, 953]], [[8141, 8141], "disallowed_STD3_mapped", [32, 787, 768]], [[8142, 8142], "disallowed_STD3_mapped", [32, 787, 769]], [[8143, 8143], "disallowed_STD3_mapped", [32, 787, 834]], [[8144, 8146], "valid"], [[8147, 8147], "mapped", [912]], [[8148, 8149], "disallowed"], [[8150, 8151], "valid"], [[8152, 8152], "mapped", [8144]], [[8153, 8153], "mapped", [8145]], [[8154, 8154], "mapped", [8054]], [[8155, 8155], "mapped", [943]], [[8156, 8156], "disallowed"], [[8157, 8157], "disallowed_STD3_mapped", [32, 788, 768]], [[8158, 8158], "disallowed_STD3_mapped", [32, 788, 769]], [[8159, 8159], "disallowed_STD3_mapped", [32, 788, 834]], [[8160, 8162], "valid"], [[8163, 8163], "mapped", [944]], [[8164, 8167], "valid"], [[8168, 8168], "mapped", [8160]], [[8169, 8169], "mapped", [8161]], [[8170, 8170], "mapped", [8058]], [[8171, 8171], "mapped", [973]], [[8172, 8172], "mapped", [8165]], [[8173, 8173], "disallowed_STD3_mapped", [32, 776, 768]], [[8174, 8174], "disallowed_STD3_mapped", [32, 776, 769]], [[8175, 8175], "disallowed_STD3_mapped", [96]], [[8176, 8177], "disallowed"], [[8178, 8178], "mapped", [8060, 953]], [[8179, 8179], "mapped", [969, 953]], [[8180, 8180], "mapped", [974, 953]], [[8181, 8181], "disallowed"], [[8182, 8182], "valid"], [[8183, 8183], "mapped", [8182, 953]], [[8184, 8184], "mapped", [8056]], [[8185, 8185], "mapped", [972]], [[8186, 8186], "mapped", [8060]], [[8187, 8187], "mapped", [974]], [[8188, 8188], "mapped", [969, 953]], [[8189, 8189], "disallowed_STD3_mapped", [32, 769]], [[8190, 8190], "disallowed_STD3_mapped", [32, 788]], [[8191, 8191], "disallowed"], [[8192, 8202], "disallowed_STD3_mapped", [32]], [[8203, 8203], "ignored"], [[8204, 8205], "deviation", []], [[8206, 8207], "disallowed"], [[8208, 8208], "valid", [], "NV8"], [[8209, 8209], "mapped", [8208]], [[8210, 8214], "valid", [], "NV8"], [[8215, 8215], "disallowed_STD3_mapped", [32, 819]], [[8216, 8227], "valid", [], "NV8"], [[8228, 8230], "disallowed"], [[8231, 8231], "valid", [], "NV8"], [[8232, 8238], "disallowed"], [[8239, 8239], "disallowed_STD3_mapped", [32]], [[8240, 8242], "valid", [], "NV8"], [[8243, 8243], "mapped", [8242, 8242]], [[8244, 8244], "mapped", [8242, 8242, 8242]], [[8245, 8245], "valid", [], "NV8"], [[8246, 8246], "mapped", [8245, 8245]], [[8247, 8247], "mapped", [8245, 8245, 8245]], [[8248, 8251], "valid", [], "NV8"], [[8252, 8252], "disallowed_STD3_mapped", [33, 33]], [[8253, 8253], "valid", [], "NV8"], [[8254, 8254], "disallowed_STD3_mapped", [32, 773]], [[8255, 8262], "valid", [], "NV8"], [[8263, 8263], "disallowed_STD3_mapped", [63, 63]], [[8264, 8264], "disallowed_STD3_mapped", [63, 33]], [[8265, 8265], "disallowed_STD3_mapped", [33, 63]], [[8266, 8269], "valid", [], "NV8"], [[8270, 8274], "valid", [], "NV8"], [[8275, 8276], "valid", [], "NV8"], [[8277, 8278], "valid", [], "NV8"], [[8279, 8279], "mapped", [8242, 8242, 8242, 8242]], [[8280, 8286], "valid", [], "NV8"], [[8287, 8287], "disallowed_STD3_mapped", [32]], [[8288, 8288], "ignored"], [[8289, 8291], "disallowed"], [[8292, 8292], "ignored"], [[8293, 8293], "disallowed"], [[8294, 8297], "disallowed"], [[8298, 8303], "disallowed"], [[8304, 8304], "mapped", [48]], [[8305, 8305], "mapped", [105]], [[8306, 8307], "disallowed"], [[8308, 8308], "mapped", [52]], [[8309, 8309], "mapped", [53]], [[8310, 8310], "mapped", [54]], [[8311, 8311], "mapped", [55]], [[8312, 8312], "mapped", [56]], [[8313, 8313], "mapped", [57]], [[8314, 8314], "disallowed_STD3_mapped", [43]], [[8315, 8315], "mapped", [8722]], [[8316, 8316], "disallowed_STD3_mapped", [61]], [[8317, 8317], "disallowed_STD3_mapped", [40]], [[8318, 8318], "disallowed_STD3_mapped", [41]], [[8319, 8319], "mapped", [110]], [[8320, 8320], "mapped", [48]], [[8321, 8321], "mapped", [49]], [[8322, 8322], "mapped", [50]], [[8323, 8323], "mapped", [51]], [[8324, 8324], "mapped", [52]], [[8325, 8325], "mapped", [53]], [[8326, 8326], "mapped", [54]], [[8327, 8327], "mapped", [55]], [[8328, 8328], "mapped", [56]], [[8329, 8329], "mapped", [57]], [[8330, 8330], "disallowed_STD3_mapped", [43]], [[8331, 8331], "mapped", [8722]], [[8332, 8332], "disallowed_STD3_mapped", [61]], [[8333, 8333], "disallowed_STD3_mapped", [40]], [[8334, 8334], "disallowed_STD3_mapped", [41]], [[8335, 8335], "disallowed"], [[8336, 8336], "mapped", [97]], [[8337, 8337], "mapped", [101]], [[8338, 8338], "mapped", [111]], [[8339, 8339], "mapped", [120]], [[8340, 8340], "mapped", [601]], [[8341, 8341], "mapped", [104]], [[8342, 8342], "mapped", [107]], [[8343, 8343], "mapped", [108]], [[8344, 8344], "mapped", [109]], [[8345, 8345], "mapped", [110]], [[8346, 8346], "mapped", [112]], [[8347, 8347], "mapped", [115]], [[8348, 8348], "mapped", [116]], [[8349, 8351], "disallowed"], [[8352, 8359], "valid", [], "NV8"], [[8360, 8360], "mapped", [114, 115]], [[8361, 8362], "valid", [], "NV8"], [[8363, 8363], "valid", [], "NV8"], [[8364, 8364], "valid", [], "NV8"], [[8365, 8367], "valid", [], "NV8"], [[8368, 8369], "valid", [], "NV8"], [[8370, 8373], "valid", [], "NV8"], [[8374, 8376], "valid", [], "NV8"], [[8377, 8377], "valid", [], "NV8"], [[8378, 8378], "valid", [], "NV8"], [[8379, 8381], "valid", [], "NV8"], [[8382, 8382], "valid", [], "NV8"], [[8383, 8399], "disallowed"], [[8400, 8417], "valid", [], "NV8"], [[8418, 8419], "valid", [], "NV8"], [[8420, 8426], "valid", [], "NV8"], [[8427, 8427], "valid", [], "NV8"], [[8428, 8431], "valid", [], "NV8"], [[8432, 8432], "valid", [], "NV8"], [[8433, 8447], "disallowed"], [[8448, 8448], "disallowed_STD3_mapped", [97, 47, 99]], [[8449, 8449], "disallowed_STD3_mapped", [97, 47, 115]], [[8450, 8450], "mapped", [99]], [[8451, 8451], "mapped", [176, 99]], [[8452, 8452], "valid", [], "NV8"], [[8453, 8453], "disallowed_STD3_mapped", [99, 47, 111]], [[8454, 8454], "disallowed_STD3_mapped", [99, 47, 117]], [[8455, 8455], "mapped", [603]], [[8456, 8456], "valid", [], "NV8"], [[8457, 8457], "mapped", [176, 102]], [[8458, 8458], "mapped", [103]], [[8459, 8462], "mapped", [104]], [[8463, 8463], "mapped", [295]], [[8464, 8465], "mapped", [105]], [[8466, 8467], "mapped", [108]], [[8468, 8468], "valid", [], "NV8"], [[8469, 8469], "mapped", [110]], [[8470, 8470], "mapped", [110, 111]], [[8471, 8472], "valid", [], "NV8"], [[8473, 8473], "mapped", [112]], [[8474, 8474], "mapped", [113]], [[8475, 8477], "mapped", [114]], [[8478, 8479], "valid", [], "NV8"], [[8480, 8480], "mapped", [115, 109]], [[8481, 8481], "mapped", [116, 101, 108]], [[8482, 8482], "mapped", [116, 109]], [[8483, 8483], "valid", [], "NV8"], [[8484, 8484], "mapped", [122]], [[8485, 8485], "valid", [], "NV8"], [[8486, 8486], "mapped", [969]], [[8487, 8487], "valid", [], "NV8"], [[8488, 8488], "mapped", [122]], [[8489, 8489], "valid", [], "NV8"], [[8490, 8490], "mapped", [107]], [[8491, 8491], "mapped", [229]], [[8492, 8492], "mapped", [98]], [[8493, 8493], "mapped", [99]], [[8494, 8494], "valid", [], "NV8"], [[8495, 8496], "mapped", [101]], [[8497, 8497], "mapped", [102]], [[8498, 8498], "disallowed"], [[8499, 8499], "mapped", [109]], [[8500, 8500], "mapped", [111]], [[8501, 8501], "mapped", [1488]], [[8502, 8502], "mapped", [1489]], [[8503, 8503], "mapped", [1490]], [[8504, 8504], "mapped", [1491]], [[8505, 8505], "mapped", [105]], [[8506, 8506], "valid", [], "NV8"], [[8507, 8507], "mapped", [102, 97, 120]], [[8508, 8508], "mapped", [960]], [[8509, 8510], "mapped", [947]], [[8511, 8511], "mapped", [960]], [[8512, 8512], "mapped", [8721]], [[8513, 8516], "valid", [], "NV8"], [[8517, 8518], "mapped", [100]], [[8519, 8519], "mapped", [101]], [[8520, 8520], "mapped", [105]], [[8521, 8521], "mapped", [106]], [[8522, 8523], "valid", [], "NV8"], [[8524, 8524], "valid", [], "NV8"], [[8525, 8525], "valid", [], "NV8"], [[8526, 8526], "valid"], [[8527, 8527], "valid", [], "NV8"], [[8528, 8528], "mapped", [49, 8260, 55]], [[8529, 8529], "mapped", [49, 8260, 57]], [[8530, 8530], "mapped", [49, 8260, 49, 48]], [[8531, 8531], "mapped", [49, 8260, 51]], [[8532, 8532], "mapped", [50, 8260, 51]], [[8533, 8533], "mapped", [49, 8260, 53]], [[8534, 8534], "mapped", [50, 8260, 53]], [[8535, 8535], "mapped", [51, 8260, 53]], [[8536, 8536], "mapped", [52, 8260, 53]], [[8537, 8537], "mapped", [49, 8260, 54]], [[8538, 8538], "mapped", [53, 8260, 54]], [[8539, 8539], "mapped", [49, 8260, 56]], [[8540, 8540], "mapped", [51, 8260, 56]], [[8541, 8541], "mapped", [53, 8260, 56]], [[8542, 8542], "mapped", [55, 8260, 56]], [[8543, 8543], "mapped", [49, 8260]], [[8544, 8544], "mapped", [105]], [[8545, 8545], "mapped", [105, 105]], [[8546, 8546], "mapped", [105, 105, 105]], [[8547, 8547], "mapped", [105, 118]], [[8548, 8548], "mapped", [118]], [[8549, 8549], "mapped", [118, 105]], [[8550, 8550], "mapped", [118, 105, 105]], [[8551, 8551], "mapped", [118, 105, 105, 105]], [[8552, 8552], "mapped", [105, 120]], [[8553, 8553], "mapped", [120]], [[8554, 8554], "mapped", [120, 105]], [[8555, 8555], "mapped", [120, 105, 105]], [[8556, 8556], "mapped", [108]], [[8557, 8557], "mapped", [99]], [[8558, 8558], "mapped", [100]], [[8559, 8559], "mapped", [109]], [[8560, 8560], "mapped", [105]], [[8561, 8561], "mapped", [105, 105]], [[8562, 8562], "mapped", [105, 105, 105]], [[8563, 8563], "mapped", [105, 118]], [[8564, 8564], "mapped", [118]], [[8565, 8565], "mapped", [118, 105]], [[8566, 8566], "mapped", [118, 105, 105]], [[8567, 8567], "mapped", [118, 105, 105, 105]], [[8568, 8568], "mapped", [105, 120]], [[8569, 8569], "mapped", [120]], [[8570, 8570], "mapped", [120, 105]], [[8571, 8571], "mapped", [120, 105, 105]], [[8572, 8572], "mapped", [108]], [[8573, 8573], "mapped", [99]], [[8574, 8574], "mapped", [100]], [[8575, 8575], "mapped", [109]], [[8576, 8578], "valid", [], "NV8"], [[8579, 8579], "disallowed"], [[8580, 8580], "valid"], [[8581, 8584], "valid", [], "NV8"], [[8585, 8585], "mapped", [48, 8260, 51]], [[8586, 8587], "valid", [], "NV8"], [[8588, 8591], "disallowed"], [[8592, 8682], "valid", [], "NV8"], [[8683, 8691], "valid", [], "NV8"], [[8692, 8703], "valid", [], "NV8"], [[8704, 8747], "valid", [], "NV8"], [[8748, 8748], "mapped", [8747, 8747]], [[8749, 8749], "mapped", [8747, 8747, 8747]], [[8750, 8750], "valid", [], "NV8"], [[8751, 8751], "mapped", [8750, 8750]], [[8752, 8752], "mapped", [8750, 8750, 8750]], [[8753, 8799], "valid", [], "NV8"], [[8800, 8800], "disallowed_STD3_valid"], [[8801, 8813], "valid", [], "NV8"], [[8814, 8815], "disallowed_STD3_valid"], [[8816, 8945], "valid", [], "NV8"], [[8946, 8959], "valid", [], "NV8"], [[8960, 8960], "valid", [], "NV8"], [[8961, 8961], "valid", [], "NV8"], [[8962, 9e3], "valid", [], "NV8"], [[9001, 9001], "mapped", [12296]], [[9002, 9002], "mapped", [12297]], [[9003, 9082], "valid", [], "NV8"], [[9083, 9083], "valid", [], "NV8"], [[9084, 9084], "valid", [], "NV8"], [[9085, 9114], "valid", [], "NV8"], [[9115, 9166], "valid", [], "NV8"], [[9167, 9168], "valid", [], "NV8"], [[9169, 9179], "valid", [], "NV8"], [[9180, 9191], "valid", [], "NV8"], [[9192, 9192], "valid", [], "NV8"], [[9193, 9203], "valid", [], "NV8"], [[9204, 9210], "valid", [], "NV8"], [[9211, 9215], "disallowed"], [[9216, 9252], "valid", [], "NV8"], [[9253, 9254], "valid", [], "NV8"], [[9255, 9279], "disallowed"], [[9280, 9290], "valid", [], "NV8"], [[9291, 9311], "disallowed"], [[9312, 9312], "mapped", [49]], [[9313, 9313], "mapped", [50]], [[9314, 9314], "mapped", [51]], [[9315, 9315], "mapped", [52]], [[9316, 9316], "mapped", [53]], [[9317, 9317], "mapped", [54]], [[9318, 9318], "mapped", [55]], [[9319, 9319], "mapped", [56]], [[9320, 9320], "mapped", [57]], [[9321, 9321], "mapped", [49, 48]], [[9322, 9322], "mapped", [49, 49]], [[9323, 9323], "mapped", [49, 50]], [[9324, 9324], "mapped", [49, 51]], [[9325, 9325], "mapped", [49, 52]], [[9326, 9326], "mapped", [49, 53]], [[9327, 9327], "mapped", [49, 54]], [[9328, 9328], "mapped", [49, 55]], [[9329, 9329], "mapped", [49, 56]], [[9330, 9330], "mapped", [49, 57]], [[9331, 9331], "mapped", [50, 48]], [[9332, 9332], "disallowed_STD3_mapped", [40, 49, 41]], [[9333, 9333], "disallowed_STD3_mapped", [40, 50, 41]], [[9334, 9334], "disallowed_STD3_mapped", [40, 51, 41]], [[9335, 9335], "disallowed_STD3_mapped", [40, 52, 41]], [[9336, 9336], "disallowed_STD3_mapped", [40, 53, 41]], [[9337, 9337], "disallowed_STD3_mapped", [40, 54, 41]], [[9338, 9338], "disallowed_STD3_mapped", [40, 55, 41]], [[9339, 9339], "disallowed_STD3_mapped", [40, 56, 41]], [[9340, 9340], "disallowed_STD3_mapped", [40, 57, 41]], [[9341, 9341], "disallowed_STD3_mapped", [40, 49, 48, 41]], [[9342, 9342], "disallowed_STD3_mapped", [40, 49, 49, 41]], [[9343, 9343], "disallowed_STD3_mapped", [40, 49, 50, 41]], [[9344, 9344], "disallowed_STD3_mapped", [40, 49, 51, 41]], [[9345, 9345], "disallowed_STD3_mapped", [40, 49, 52, 41]], [[9346, 9346], "disallowed_STD3_mapped", [40, 49, 53, 41]], [[9347, 9347], "disallowed_STD3_mapped", [40, 49, 54, 41]], [[9348, 9348], "disallowed_STD3_mapped", [40, 49, 55, 41]], [[9349, 9349], "disallowed_STD3_mapped", [40, 49, 56, 41]], [[9350, 9350], "disallowed_STD3_mapped", [40, 49, 57, 41]], [[9351, 9351], "disallowed_STD3_mapped", [40, 50, 48, 41]], [[9352, 9371], "disallowed"], [[9372, 9372], "disallowed_STD3_mapped", [40, 97, 41]], [[9373, 9373], "disallowed_STD3_mapped", [40, 98, 41]], [[9374, 9374], "disallowed_STD3_mapped", [40, 99, 41]], [[9375, 9375], "disallowed_STD3_mapped", [40, 100, 41]], [[9376, 9376], "disallowed_STD3_mapped", [40, 101, 41]], [[9377, 9377], "disallowed_STD3_mapped", [40, 102, 41]], [[9378, 9378], "disallowed_STD3_mapped", [40, 103, 41]], [[9379, 9379], "disallowed_STD3_mapped", [40, 104, 41]], [[9380, 9380], "disallowed_STD3_mapped", [40, 105, 41]], [[9381, 9381], "disallowed_STD3_mapped", [40, 106, 41]], [[9382, 9382], "disallowed_STD3_mapped", [40, 107, 41]], [[9383, 9383], "disallowed_STD3_mapped", [40, 108, 41]], [[9384, 9384], "disallowed_STD3_mapped", [40, 109, 41]], [[9385, 9385], "disallowed_STD3_mapped", [40, 110, 41]], [[9386, 9386], "disallowed_STD3_mapped", [40, 111, 41]], [[9387, 9387], "disallowed_STD3_mapped", [40, 112, 41]], [[9388, 9388], "disallowed_STD3_mapped", [40, 113, 41]], [[9389, 9389], "disallowed_STD3_mapped", [40, 114, 41]], [[9390, 9390], "disallowed_STD3_mapped", [40, 115, 41]], [[9391, 9391], "disallowed_STD3_mapped", [40, 116, 41]], [[9392, 9392], "disallowed_STD3_mapped", [40, 117, 41]], [[9393, 9393], "disallowed_STD3_mapped", [40, 118, 41]], [[9394, 9394], "disallowed_STD3_mapped", [40, 119, 41]], [[9395, 9395], "disallowed_STD3_mapped", [40, 120, 41]], [[9396, 9396], "disallowed_STD3_mapped", [40, 121, 41]], [[9397, 9397], "disallowed_STD3_mapped", [40, 122, 41]], [[9398, 9398], "mapped", [97]], [[9399, 9399], "mapped", [98]], [[9400, 9400], "mapped", [99]], [[9401, 9401], "mapped", [100]], [[9402, 9402], "mapped", [101]], [[9403, 9403], "mapped", [102]], [[9404, 9404], "mapped", [103]], [[9405, 9405], "mapped", [104]], [[9406, 9406], "mapped", [105]], [[9407, 9407], "mapped", [106]], [[9408, 9408], "mapped", [107]], [[9409, 9409], "mapped", [108]], [[9410, 9410], "mapped", [109]], [[9411, 9411], "mapped", [110]], [[9412, 9412], "mapped", [111]], [[9413, 9413], "mapped", [112]], [[9414, 9414], "mapped", [113]], [[9415, 9415], "mapped", [114]], [[9416, 9416], "mapped", [115]], [[9417, 9417], "mapped", [116]], [[9418, 9418], "mapped", [117]], [[9419, 9419], "mapped", [118]], [[9420, 9420], "mapped", [119]], [[9421, 9421], "mapped", [120]], [[9422, 9422], "mapped", [121]], [[9423, 9423], "mapped", [122]], [[9424, 9424], "mapped", [97]], [[9425, 9425], "mapped", [98]], [[9426, 9426], "mapped", [99]], [[9427, 9427], "mapped", [100]], [[9428, 9428], "mapped", [101]], [[9429, 9429], "mapped", [102]], [[9430, 9430], "mapped", [103]], [[9431, 9431], "mapped", [104]], [[9432, 9432], "mapped", [105]], [[9433, 9433], "mapped", [106]], [[9434, 9434], "mapped", [107]], [[9435, 9435], "mapped", [108]], [[9436, 9436], "mapped", [109]], [[9437, 9437], "mapped", [110]], [[9438, 9438], "mapped", [111]], [[9439, 9439], "mapped", [112]], [[9440, 9440], "mapped", [113]], [[9441, 9441], "mapped", [114]], [[9442, 9442], "mapped", [115]], [[9443, 9443], "mapped", [116]], [[9444, 9444], "mapped", [117]], [[9445, 9445], "mapped", [118]], [[9446, 9446], "mapped", [119]], [[9447, 9447], "mapped", [120]], [[9448, 9448], "mapped", [121]], [[9449, 9449], "mapped", [122]], [[9450, 9450], "mapped", [48]], [[9451, 9470], "valid", [], "NV8"], [[9471, 9471], "valid", [], "NV8"], [[9472, 9621], "valid", [], "NV8"], [[9622, 9631], "valid", [], "NV8"], [[9632, 9711], "valid", [], "NV8"], [[9712, 9719], "valid", [], "NV8"], [[9720, 9727], "valid", [], "NV8"], [[9728, 9747], "valid", [], "NV8"], [[9748, 9749], "valid", [], "NV8"], [[9750, 9751], "valid", [], "NV8"], [[9752, 9752], "valid", [], "NV8"], [[9753, 9753], "valid", [], "NV8"], [[9754, 9839], "valid", [], "NV8"], [[9840, 9841], "valid", [], "NV8"], [[9842, 9853], "valid", [], "NV8"], [[9854, 9855], "valid", [], "NV8"], [[9856, 9865], "valid", [], "NV8"], [[9866, 9873], "valid", [], "NV8"], [[9874, 9884], "valid", [], "NV8"], [[9885, 9885], "valid", [], "NV8"], [[9886, 9887], "valid", [], "NV8"], [[9888, 9889], "valid", [], "NV8"], [[9890, 9905], "valid", [], "NV8"], [[9906, 9906], "valid", [], "NV8"], [[9907, 9916], "valid", [], "NV8"], [[9917, 9919], "valid", [], "NV8"], [[9920, 9923], "valid", [], "NV8"], [[9924, 9933], "valid", [], "NV8"], [[9934, 9934], "valid", [], "NV8"], [[9935, 9953], "valid", [], "NV8"], [[9954, 9954], "valid", [], "NV8"], [[9955, 9955], "valid", [], "NV8"], [[9956, 9959], "valid", [], "NV8"], [[9960, 9983], "valid", [], "NV8"], [[9984, 9984], "valid", [], "NV8"], [[9985, 9988], "valid", [], "NV8"], [[9989, 9989], "valid", [], "NV8"], [[9990, 9993], "valid", [], "NV8"], [[9994, 9995], "valid", [], "NV8"], [[9996, 10023], "valid", [], "NV8"], [[10024, 10024], "valid", [], "NV8"], [[10025, 10059], "valid", [], "NV8"], [[10060, 10060], "valid", [], "NV8"], [[10061, 10061], "valid", [], "NV8"], [[10062, 10062], "valid", [], "NV8"], [[10063, 10066], "valid", [], "NV8"], [[10067, 10069], "valid", [], "NV8"], [[10070, 10070], "valid", [], "NV8"], [[10071, 10071], "valid", [], "NV8"], [[10072, 10078], "valid", [], "NV8"], [[10079, 10080], "valid", [], "NV8"], [[10081, 10087], "valid", [], "NV8"], [[10088, 10101], "valid", [], "NV8"], [[10102, 10132], "valid", [], "NV8"], [[10133, 10135], "valid", [], "NV8"], [[10136, 10159], "valid", [], "NV8"], [[10160, 10160], "valid", [], "NV8"], [[10161, 10174], "valid", [], "NV8"], [[10175, 10175], "valid", [], "NV8"], [[10176, 10182], "valid", [], "NV8"], [[10183, 10186], "valid", [], "NV8"], [[10187, 10187], "valid", [], "NV8"], [[10188, 10188], "valid", [], "NV8"], [[10189, 10189], "valid", [], "NV8"], [[10190, 10191], "valid", [], "NV8"], [[10192, 10219], "valid", [], "NV8"], [[10220, 10223], "valid", [], "NV8"], [[10224, 10239], "valid", [], "NV8"], [[10240, 10495], "valid", [], "NV8"], [[10496, 10763], "valid", [], "NV8"], [[10764, 10764], "mapped", [8747, 8747, 8747, 8747]], [[10765, 10867], "valid", [], "NV8"], [[10868, 10868], "disallowed_STD3_mapped", [58, 58, 61]], [[10869, 10869], "disallowed_STD3_mapped", [61, 61]], [[10870, 10870], "disallowed_STD3_mapped", [61, 61, 61]], [[10871, 10971], "valid", [], "NV8"], [[10972, 10972], "mapped", [10973, 824]], [[10973, 11007], "valid", [], "NV8"], [[11008, 11021], "valid", [], "NV8"], [[11022, 11027], "valid", [], "NV8"], [[11028, 11034], "valid", [], "NV8"], [[11035, 11039], "valid", [], "NV8"], [[11040, 11043], "valid", [], "NV8"], [[11044, 11084], "valid", [], "NV8"], [[11085, 11087], "valid", [], "NV8"], [[11088, 11092], "valid", [], "NV8"], [[11093, 11097], "valid", [], "NV8"], [[11098, 11123], "valid", [], "NV8"], [[11124, 11125], "disallowed"], [[11126, 11157], "valid", [], "NV8"], [[11158, 11159], "disallowed"], [[11160, 11193], "valid", [], "NV8"], [[11194, 11196], "disallowed"], [[11197, 11208], "valid", [], "NV8"], [[11209, 11209], "disallowed"], [[11210, 11217], "valid", [], "NV8"], [[11218, 11243], "disallowed"], [[11244, 11247], "valid", [], "NV8"], [[11248, 11263], "disallowed"], [[11264, 11264], "mapped", [11312]], [[11265, 11265], "mapped", [11313]], [[11266, 11266], "mapped", [11314]], [[11267, 11267], "mapped", [11315]], [[11268, 11268], "mapped", [11316]], [[11269, 11269], "mapped", [11317]], [[11270, 11270], "mapped", [11318]], [[11271, 11271], "mapped", [11319]], [[11272, 11272], "mapped", [11320]], [[11273, 11273], "mapped", [11321]], [[11274, 11274], "mapped", [11322]], [[11275, 11275], "mapped", [11323]], [[11276, 11276], "mapped", [11324]], [[11277, 11277], "mapped", [11325]], [[11278, 11278], "mapped", [11326]], [[11279, 11279], "mapped", [11327]], [[11280, 11280], "mapped", [11328]], [[11281, 11281], "mapped", [11329]], [[11282, 11282], "mapped", [11330]], [[11283, 11283], "mapped", [11331]], [[11284, 11284], "mapped", [11332]], [[11285, 11285], "mapped", [11333]], [[11286, 11286], "mapped", [11334]], [[11287, 11287], "mapped", [11335]], [[11288, 11288], "mapped", [11336]], [[11289, 11289], "mapped", [11337]], [[11290, 11290], "mapped", [11338]], [[11291, 11291], "mapped", [11339]], [[11292, 11292], "mapped", [11340]], [[11293, 11293], "mapped", [11341]], [[11294, 11294], "mapped", [11342]], [[11295, 11295], "mapped", [11343]], [[11296, 11296], "mapped", [11344]], [[11297, 11297], "mapped", [11345]], [[11298, 11298], "mapped", [11346]], [[11299, 11299], "mapped", [11347]], [[11300, 11300], "mapped", [11348]], [[11301, 11301], "mapped", [11349]], [[11302, 11302], "mapped", [11350]], [[11303, 11303], "mapped", [11351]], [[11304, 11304], "mapped", [11352]], [[11305, 11305], "mapped", [11353]], [[11306, 11306], "mapped", [11354]], [[11307, 11307], "mapped", [11355]], [[11308, 11308], "mapped", [11356]], [[11309, 11309], "mapped", [11357]], [[11310, 11310], "mapped", [11358]], [[11311, 11311], "disallowed"], [[11312, 11358], "valid"], [[11359, 11359], "disallowed"], [[11360, 11360], "mapped", [11361]], [[11361, 11361], "valid"], [[11362, 11362], "mapped", [619]], [[11363, 11363], "mapped", [7549]], [[11364, 11364], "mapped", [637]], [[11365, 11366], "valid"], [[11367, 11367], "mapped", [11368]], [[11368, 11368], "valid"], [[11369, 11369], "mapped", [11370]], [[11370, 11370], "valid"], [[11371, 11371], "mapped", [11372]], [[11372, 11372], "valid"], [[11373, 11373], "mapped", [593]], [[11374, 11374], "mapped", [625]], [[11375, 11375], "mapped", [592]], [[11376, 11376], "mapped", [594]], [[11377, 11377], "valid"], [[11378, 11378], "mapped", [11379]], [[11379, 11379], "valid"], [[11380, 11380], "valid"], [[11381, 11381], "mapped", [11382]], [[11382, 11383], "valid"], [[11384, 11387], "valid"], [[11388, 11388], "mapped", [106]], [[11389, 11389], "mapped", [118]], [[11390, 11390], "mapped", [575]], [[11391, 11391], "mapped", [576]], [[11392, 11392], "mapped", [11393]], [[11393, 11393], "valid"], [[11394, 11394], "mapped", [11395]], [[11395, 11395], "valid"], [[11396, 11396], "mapped", [11397]], [[11397, 11397], "valid"], [[11398, 11398], "mapped", [11399]], [[11399, 11399], "valid"], [[11400, 11400], "mapped", [11401]], [[11401, 11401], "valid"], [[11402, 11402], "mapped", [11403]], [[11403, 11403], "valid"], [[11404, 11404], "mapped", [11405]], [[11405, 11405], "valid"], [[11406, 11406], "mapped", [11407]], [[11407, 11407], "valid"], [[11408, 11408], "mapped", [11409]], [[11409, 11409], "valid"], [[11410, 11410], "mapped", [11411]], [[11411, 11411], "valid"], [[11412, 11412], "mapped", [11413]], [[11413, 11413], "valid"], [[11414, 11414], "mapped", [11415]], [[11415, 11415], "valid"], [[11416, 11416], "mapped", [11417]], [[11417, 11417], "valid"], [[11418, 11418], "mapped", [11419]], [[11419, 11419], "valid"], [[11420, 11420], "mapped", [11421]], [[11421, 11421], "valid"], [[11422, 11422], "mapped", [11423]], [[11423, 11423], "valid"], [[11424, 11424], "mapped", [11425]], [[11425, 11425], "valid"], [[11426, 11426], "mapped", [11427]], [[11427, 11427], "valid"], [[11428, 11428], "mapped", [11429]], [[11429, 11429], "valid"], [[11430, 11430], "mapped", [11431]], [[11431, 11431], "valid"], [[11432, 11432], "mapped", [11433]], [[11433, 11433], "valid"], [[11434, 11434], "mapped", [11435]], [[11435, 11435], "valid"], [[11436, 11436], "mapped", [11437]], [[11437, 11437], "valid"], [[11438, 11438], "mapped", [11439]], [[11439, 11439], "valid"], [[11440, 11440], "mapped", [11441]], [[11441, 11441], "valid"], [[11442, 11442], "mapped", [11443]], [[11443, 11443], "valid"], [[11444, 11444], "mapped", [11445]], [[11445, 11445], "valid"], [[11446, 11446], "mapped", [11447]], [[11447, 11447], "valid"], [[11448, 11448], "mapped", [11449]], [[11449, 11449], "valid"], [[11450, 11450], "mapped", [11451]], [[11451, 11451], "valid"], [[11452, 11452], "mapped", [11453]], [[11453, 11453], "valid"], [[11454, 11454], "mapped", [11455]], [[11455, 11455], "valid"], [[11456, 11456], "mapped", [11457]], [[11457, 11457], "valid"], [[11458, 11458], "mapped", [11459]], [[11459, 11459], "valid"], [[11460, 11460], "mapped", [11461]], [[11461, 11461], "valid"], [[11462, 11462], "mapped", [11463]], [[11463, 11463], "valid"], [[11464, 11464], "mapped", [11465]], [[11465, 11465], "valid"], [[11466, 11466], "mapped", [11467]], [[11467, 11467], "valid"], [[11468, 11468], "mapped", [11469]], [[11469, 11469], "valid"], [[11470, 11470], "mapped", [11471]], [[11471, 11471], "valid"], [[11472, 11472], "mapped", [11473]], [[11473, 11473], "valid"], [[11474, 11474], "mapped", [11475]], [[11475, 11475], "valid"], [[11476, 11476], "mapped", [11477]], [[11477, 11477], "valid"], [[11478, 11478], "mapped", [11479]], [[11479, 11479], "valid"], [[11480, 11480], "mapped", [11481]], [[11481, 11481], "valid"], [[11482, 11482], "mapped", [11483]], [[11483, 11483], "valid"], [[11484, 11484], "mapped", [11485]], [[11485, 11485], "valid"], [[11486, 11486], "mapped", [11487]], [[11487, 11487], "valid"], [[11488, 11488], "mapped", [11489]], [[11489, 11489], "valid"], [[11490, 11490], "mapped", [11491]], [[11491, 11492], "valid"], [[11493, 11498], "valid", [], "NV8"], [[11499, 11499], "mapped", [11500]], [[11500, 11500], "valid"], [[11501, 11501], "mapped", [11502]], [[11502, 11505], "valid"], [[11506, 11506], "mapped", [11507]], [[11507, 11507], "valid"], [[11508, 11512], "disallowed"], [[11513, 11519], "valid", [], "NV8"], [[11520, 11557], "valid"], [[11558, 11558], "disallowed"], [[11559, 11559], "valid"], [[11560, 11564], "disallowed"], [[11565, 11565], "valid"], [[11566, 11567], "disallowed"], [[11568, 11621], "valid"], [[11622, 11623], "valid"], [[11624, 11630], "disallowed"], [[11631, 11631], "mapped", [11617]], [[11632, 11632], "valid", [], "NV8"], [[11633, 11646], "disallowed"], [[11647, 11647], "valid"], [[11648, 11670], "valid"], [[11671, 11679], "disallowed"], [[11680, 11686], "valid"], [[11687, 11687], "disallowed"], [[11688, 11694], "valid"], [[11695, 11695], "disallowed"], [[11696, 11702], "valid"], [[11703, 11703], "disallowed"], [[11704, 11710], "valid"], [[11711, 11711], "disallowed"], [[11712, 11718], "valid"], [[11719, 11719], "disallowed"], [[11720, 11726], "valid"], [[11727, 11727], "disallowed"], [[11728, 11734], "valid"], [[11735, 11735], "disallowed"], [[11736, 11742], "valid"], [[11743, 11743], "disallowed"], [[11744, 11775], "valid"], [[11776, 11799], "valid", [], "NV8"], [[11800, 11803], "valid", [], "NV8"], [[11804, 11805], "valid", [], "NV8"], [[11806, 11822], "valid", [], "NV8"], [[11823, 11823], "valid"], [[11824, 11824], "valid", [], "NV8"], [[11825, 11825], "valid", [], "NV8"], [[11826, 11835], "valid", [], "NV8"], [[11836, 11842], "valid", [], "NV8"], [[11843, 11903], "disallowed"], [[11904, 11929], "valid", [], "NV8"], [[11930, 11930], "disallowed"], [[11931, 11934], "valid", [], "NV8"], [[11935, 11935], "mapped", [27597]], [[11936, 12018], "valid", [], "NV8"], [[12019, 12019], "mapped", [40863]], [[12020, 12031], "disallowed"], [[12032, 12032], "mapped", [19968]], [[12033, 12033], "mapped", [20008]], [[12034, 12034], "mapped", [20022]], [[12035, 12035], "mapped", [20031]], [[12036, 12036], "mapped", [20057]], [[12037, 12037], "mapped", [20101]], [[12038, 12038], "mapped", [20108]], [[12039, 12039], "mapped", [20128]], [[12040, 12040], "mapped", [20154]], [[12041, 12041], "mapped", [20799]], [[12042, 12042], "mapped", [20837]], [[12043, 12043], "mapped", [20843]], [[12044, 12044], "mapped", [20866]], [[12045, 12045], "mapped", [20886]], [[12046, 12046], "mapped", [20907]], [[12047, 12047], "mapped", [20960]], [[12048, 12048], "mapped", [20981]], [[12049, 12049], "mapped", [20992]], [[12050, 12050], "mapped", [21147]], [[12051, 12051], "mapped", [21241]], [[12052, 12052], "mapped", [21269]], [[12053, 12053], "mapped", [21274]], [[12054, 12054], "mapped", [21304]], [[12055, 12055], "mapped", [21313]], [[12056, 12056], "mapped", [21340]], [[12057, 12057], "mapped", [21353]], [[12058, 12058], "mapped", [21378]], [[12059, 12059], "mapped", [21430]], [[12060, 12060], "mapped", [21448]], [[12061, 12061], "mapped", [21475]], [[12062, 12062], "mapped", [22231]], [[12063, 12063], "mapped", [22303]], [[12064, 12064], "mapped", [22763]], [[12065, 12065], "mapped", [22786]], [[12066, 12066], "mapped", [22794]], [[12067, 12067], "mapped", [22805]], [[12068, 12068], "mapped", [22823]], [[12069, 12069], "mapped", [22899]], [[12070, 12070], "mapped", [23376]], [[12071, 12071], "mapped", [23424]], [[12072, 12072], "mapped", [23544]], [[12073, 12073], "mapped", [23567]], [[12074, 12074], "mapped", [23586]], [[12075, 12075], "mapped", [23608]], [[12076, 12076], "mapped", [23662]], [[12077, 12077], "mapped", [23665]], [[12078, 12078], "mapped", [24027]], [[12079, 12079], "mapped", [24037]], [[12080, 12080], "mapped", [24049]], [[12081, 12081], "mapped", [24062]], [[12082, 12082], "mapped", [24178]], [[12083, 12083], "mapped", [24186]], [[12084, 12084], "mapped", [24191]], [[12085, 12085], "mapped", [24308]], [[12086, 12086], "mapped", [24318]], [[12087, 12087], "mapped", [24331]], [[12088, 12088], "mapped", [24339]], [[12089, 12089], "mapped", [24400]], [[12090, 12090], "mapped", [24417]], [[12091, 12091], "mapped", [24435]], [[12092, 12092], "mapped", [24515]], [[12093, 12093], "mapped", [25096]], [[12094, 12094], "mapped", [25142]], [[12095, 12095], "mapped", [25163]], [[12096, 12096], "mapped", [25903]], [[12097, 12097], "mapped", [25908]], [[12098, 12098], "mapped", [25991]], [[12099, 12099], "mapped", [26007]], [[12100, 12100], "mapped", [26020]], [[12101, 12101], "mapped", [26041]], [[12102, 12102], "mapped", [26080]], [[12103, 12103], "mapped", [26085]], [[12104, 12104], "mapped", [26352]], [[12105, 12105], "mapped", [26376]], [[12106, 12106], "mapped", [26408]], [[12107, 12107], "mapped", [27424]], [[12108, 12108], "mapped", [27490]], [[12109, 12109], "mapped", [27513]], [[12110, 12110], "mapped", [27571]], [[12111, 12111], "mapped", [27595]], [[12112, 12112], "mapped", [27604]], [[12113, 12113], "mapped", [27611]], [[12114, 12114], "mapped", [27663]], [[12115, 12115], "mapped", [27668]], [[12116, 12116], "mapped", [27700]], [[12117, 12117], "mapped", [28779]], [[12118, 12118], "mapped", [29226]], [[12119, 12119], "mapped", [29238]], [[12120, 12120], "mapped", [29243]], [[12121, 12121], "mapped", [29247]], [[12122, 12122], "mapped", [29255]], [[12123, 12123], "mapped", [29273]], [[12124, 12124], "mapped", [29275]], [[12125, 12125], "mapped", [29356]], [[12126, 12126], "mapped", [29572]], [[12127, 12127], "mapped", [29577]], [[12128, 12128], "mapped", [29916]], [[12129, 12129], "mapped", [29926]], [[12130, 12130], "mapped", [29976]], [[12131, 12131], "mapped", [29983]], [[12132, 12132], "mapped", [29992]], [[12133, 12133], "mapped", [3e4]], [[12134, 12134], "mapped", [30091]], [[12135, 12135], "mapped", [30098]], [[12136, 12136], "mapped", [30326]], [[12137, 12137], "mapped", [30333]], [[12138, 12138], "mapped", [30382]], [[12139, 12139], "mapped", [30399]], [[12140, 12140], "mapped", [30446]], [[12141, 12141], "mapped", [30683]], [[12142, 12142], "mapped", [30690]], [[12143, 12143], "mapped", [30707]], [[12144, 12144], "mapped", [31034]], [[12145, 12145], "mapped", [31160]], [[12146, 12146], "mapped", [31166]], [[12147, 12147], "mapped", [31348]], [[12148, 12148], "mapped", [31435]], [[12149, 12149], "mapped", [31481]], [[12150, 12150], "mapped", [31859]], [[12151, 12151], "mapped", [31992]], [[12152, 12152], "mapped", [32566]], [[12153, 12153], "mapped", [32593]], [[12154, 12154], "mapped", [32650]], [[12155, 12155], "mapped", [32701]], [[12156, 12156], "mapped", [32769]], [[12157, 12157], "mapped", [32780]], [[12158, 12158], "mapped", [32786]], [[12159, 12159], "mapped", [32819]], [[12160, 12160], "mapped", [32895]], [[12161, 12161], "mapped", [32905]], [[12162, 12162], "mapped", [33251]], [[12163, 12163], "mapped", [33258]], [[12164, 12164], "mapped", [33267]], [[12165, 12165], "mapped", [33276]], [[12166, 12166], "mapped", [33292]], [[12167, 12167], "mapped", [33307]], [[12168, 12168], "mapped", [33311]], [[12169, 12169], "mapped", [33390]], [[12170, 12170], "mapped", [33394]], [[12171, 12171], "mapped", [33400]], [[12172, 12172], "mapped", [34381]], [[12173, 12173], "mapped", [34411]], [[12174, 12174], "mapped", [34880]], [[12175, 12175], "mapped", [34892]], [[12176, 12176], "mapped", [34915]], [[12177, 12177], "mapped", [35198]], [[12178, 12178], "mapped", [35211]], [[12179, 12179], "mapped", [35282]], [[12180, 12180], "mapped", [35328]], [[12181, 12181], "mapped", [35895]], [[12182, 12182], "mapped", [35910]], [[12183, 12183], "mapped", [35925]], [[12184, 12184], "mapped", [35960]], [[12185, 12185], "mapped", [35997]], [[12186, 12186], "mapped", [36196]], [[12187, 12187], "mapped", [36208]], [[12188, 12188], "mapped", [36275]], [[12189, 12189], "mapped", [36523]], [[12190, 12190], "mapped", [36554]], [[12191, 12191], "mapped", [36763]], [[12192, 12192], "mapped", [36784]], [[12193, 12193], "mapped", [36789]], [[12194, 12194], "mapped", [37009]], [[12195, 12195], "mapped", [37193]], [[12196, 12196], "mapped", [37318]], [[12197, 12197], "mapped", [37324]], [[12198, 12198], "mapped", [37329]], [[12199, 12199], "mapped", [38263]], [[12200, 12200], "mapped", [38272]], [[12201, 12201], "mapped", [38428]], [[12202, 12202], "mapped", [38582]], [[12203, 12203], "mapped", [38585]], [[12204, 12204], "mapped", [38632]], [[12205, 12205], "mapped", [38737]], [[12206, 12206], "mapped", [38750]], [[12207, 12207], "mapped", [38754]], [[12208, 12208], "mapped", [38761]], [[12209, 12209], "mapped", [38859]], [[12210, 12210], "mapped", [38893]], [[12211, 12211], "mapped", [38899]], [[12212, 12212], "mapped", [38913]], [[12213, 12213], "mapped", [39080]], [[12214, 12214], "mapped", [39131]], [[12215, 12215], "mapped", [39135]], [[12216, 12216], "mapped", [39318]], [[12217, 12217], "mapped", [39321]], [[12218, 12218], "mapped", [39340]], [[12219, 12219], "mapped", [39592]], [[12220, 12220], "mapped", [39640]], [[12221, 12221], "mapped", [39647]], [[12222, 12222], "mapped", [39717]], [[12223, 12223], "mapped", [39727]], [[12224, 12224], "mapped", [39730]], [[12225, 12225], "mapped", [39740]], [[12226, 12226], "mapped", [39770]], [[12227, 12227], "mapped", [40165]], [[12228, 12228], "mapped", [40565]], [[12229, 12229], "mapped", [40575]], [[12230, 12230], "mapped", [40613]], [[12231, 12231], "mapped", [40635]], [[12232, 12232], "mapped", [40643]], [[12233, 12233], "mapped", [40653]], [[12234, 12234], "mapped", [40657]], [[12235, 12235], "mapped", [40697]], [[12236, 12236], "mapped", [40701]], [[12237, 12237], "mapped", [40718]], [[12238, 12238], "mapped", [40723]], [[12239, 12239], "mapped", [40736]], [[12240, 12240], "mapped", [40763]], [[12241, 12241], "mapped", [40778]], [[12242, 12242], "mapped", [40786]], [[12243, 12243], "mapped", [40845]], [[12244, 12244], "mapped", [40860]], [[12245, 12245], "mapped", [40864]], [[12246, 12271], "disallowed"], [[12272, 12283], "disallowed"], [[12284, 12287], "disallowed"], [[12288, 12288], "disallowed_STD3_mapped", [32]], [[12289, 12289], "valid", [], "NV8"], [[12290, 12290], "mapped", [46]], [[12291, 12292], "valid", [], "NV8"], [[12293, 12295], "valid"], [[12296, 12329], "valid", [], "NV8"], [[12330, 12333], "valid"], [[12334, 12341], "valid", [], "NV8"], [[12342, 12342], "mapped", [12306]], [[12343, 12343], "valid", [], "NV8"], [[12344, 12344], "mapped", [21313]], [[12345, 12345], "mapped", [21316]], [[12346, 12346], "mapped", [21317]], [[12347, 12347], "valid", [], "NV8"], [[12348, 12348], "valid"], [[12349, 12349], "valid", [], "NV8"], [[12350, 12350], "valid", [], "NV8"], [[12351, 12351], "valid", [], "NV8"], [[12352, 12352], "disallowed"], [[12353, 12436], "valid"], [[12437, 12438], "valid"], [[12439, 12440], "disallowed"], [[12441, 12442], "valid"], [[12443, 12443], "disallowed_STD3_mapped", [32, 12441]], [[12444, 12444], "disallowed_STD3_mapped", [32, 12442]], [[12445, 12446], "valid"], [[12447, 12447], "mapped", [12424, 12426]], [[12448, 12448], "valid", [], "NV8"], [[12449, 12542], "valid"], [[12543, 12543], "mapped", [12467, 12488]], [[12544, 12548], "disallowed"], [[12549, 12588], "valid"], [[12589, 12589], "valid"], [[12590, 12592], "disallowed"], [[12593, 12593], "mapped", [4352]], [[12594, 12594], "mapped", [4353]], [[12595, 12595], "mapped", [4522]], [[12596, 12596], "mapped", [4354]], [[12597, 12597], "mapped", [4524]], [[12598, 12598], "mapped", [4525]], [[12599, 12599], "mapped", [4355]], [[12600, 12600], "mapped", [4356]], [[12601, 12601], "mapped", [4357]], [[12602, 12602], "mapped", [4528]], [[12603, 12603], "mapped", [4529]], [[12604, 12604], "mapped", [4530]], [[12605, 12605], "mapped", [4531]], [[12606, 12606], "mapped", [4532]], [[12607, 12607], "mapped", [4533]], [[12608, 12608], "mapped", [4378]], [[12609, 12609], "mapped", [4358]], [[12610, 12610], "mapped", [4359]], [[12611, 12611], "mapped", [4360]], [[12612, 12612], "mapped", [4385]], [[12613, 12613], "mapped", [4361]], [[12614, 12614], "mapped", [4362]], [[12615, 12615], "mapped", [4363]], [[12616, 12616], "mapped", [4364]], [[12617, 12617], "mapped", [4365]], [[12618, 12618], "mapped", [4366]], [[12619, 12619], "mapped", [4367]], [[12620, 12620], "mapped", [4368]], [[12621, 12621], "mapped", [4369]], [[12622, 12622], "mapped", [4370]], [[12623, 12623], "mapped", [4449]], [[12624, 12624], "mapped", [4450]], [[12625, 12625], "mapped", [4451]], [[12626, 12626], "mapped", [4452]], [[12627, 12627], "mapped", [4453]], [[12628, 12628], "mapped", [4454]], [[12629, 12629], "mapped", [4455]], [[12630, 12630], "mapped", [4456]], [[12631, 12631], "mapped", [4457]], [[12632, 12632], "mapped", [4458]], [[12633, 12633], "mapped", [4459]], [[12634, 12634], "mapped", [4460]], [[12635, 12635], "mapped", [4461]], [[12636, 12636], "mapped", [4462]], [[12637, 12637], "mapped", [4463]], [[12638, 12638], "mapped", [4464]], [[12639, 12639], "mapped", [4465]], [[12640, 12640], "mapped", [4466]], [[12641, 12641], "mapped", [4467]], [[12642, 12642], "mapped", [4468]], [[12643, 12643], "mapped", [4469]], [[12644, 12644], "disallowed"], [[12645, 12645], "mapped", [4372]], [[12646, 12646], "mapped", [4373]], [[12647, 12647], "mapped", [4551]], [[12648, 12648], "mapped", [4552]], [[12649, 12649], "mapped", [4556]], [[12650, 12650], "mapped", [4558]], [[12651, 12651], "mapped", [4563]], [[12652, 12652], "mapped", [4567]], [[12653, 12653], "mapped", [4569]], [[12654, 12654], "mapped", [4380]], [[12655, 12655], "mapped", [4573]], [[12656, 12656], "mapped", [4575]], [[12657, 12657], "mapped", [4381]], [[12658, 12658], "mapped", [4382]], [[12659, 12659], "mapped", [4384]], [[12660, 12660], "mapped", [4386]], [[12661, 12661], "mapped", [4387]], [[12662, 12662], "mapped", [4391]], [[12663, 12663], "mapped", [4393]], [[12664, 12664], "mapped", [4395]], [[12665, 12665], "mapped", [4396]], [[12666, 12666], "mapped", [4397]], [[12667, 12667], "mapped", [4398]], [[12668, 12668], "mapped", [4399]], [[12669, 12669], "mapped", [4402]], [[12670, 12670], "mapped", [4406]], [[12671, 12671], "mapped", [4416]], [[12672, 12672], "mapped", [4423]], [[12673, 12673], "mapped", [4428]], [[12674, 12674], "mapped", [4593]], [[12675, 12675], "mapped", [4594]], [[12676, 12676], "mapped", [4439]], [[12677, 12677], "mapped", [4440]], [[12678, 12678], "mapped", [4441]], [[12679, 12679], "mapped", [4484]], [[12680, 12680], "mapped", [4485]], [[12681, 12681], "mapped", [4488]], [[12682, 12682], "mapped", [4497]], [[12683, 12683], "mapped", [4498]], [[12684, 12684], "mapped", [4500]], [[12685, 12685], "mapped", [4510]], [[12686, 12686], "mapped", [4513]], [[12687, 12687], "disallowed"], [[12688, 12689], "valid", [], "NV8"], [[12690, 12690], "mapped", [19968]], [[12691, 12691], "mapped", [20108]], [[12692, 12692], "mapped", [19977]], [[12693, 12693], "mapped", [22235]], [[12694, 12694], "mapped", [19978]], [[12695, 12695], "mapped", [20013]], [[12696, 12696], "mapped", [19979]], [[12697, 12697], "mapped", [30002]], [[12698, 12698], "mapped", [20057]], [[12699, 12699], "mapped", [19993]], [[12700, 12700], "mapped", [19969]], [[12701, 12701], "mapped", [22825]], [[12702, 12702], "mapped", [22320]], [[12703, 12703], "mapped", [20154]], [[12704, 12727], "valid"], [[12728, 12730], "valid"], [[12731, 12735], "disallowed"], [[12736, 12751], "valid", [], "NV8"], [[12752, 12771], "valid", [], "NV8"], [[12772, 12783], "disallowed"], [[12784, 12799], "valid"], [[12800, 12800], "disallowed_STD3_mapped", [40, 4352, 41]], [[12801, 12801], "disallowed_STD3_mapped", [40, 4354, 41]], [[12802, 12802], "disallowed_STD3_mapped", [40, 4355, 41]], [[12803, 12803], "disallowed_STD3_mapped", [40, 4357, 41]], [[12804, 12804], "disallowed_STD3_mapped", [40, 4358, 41]], [[12805, 12805], "disallowed_STD3_mapped", [40, 4359, 41]], [[12806, 12806], "disallowed_STD3_mapped", [40, 4361, 41]], [[12807, 12807], "disallowed_STD3_mapped", [40, 4363, 41]], [[12808, 12808], "disallowed_STD3_mapped", [40, 4364, 41]], [[12809, 12809], "disallowed_STD3_mapped", [40, 4366, 41]], [[12810, 12810], "disallowed_STD3_mapped", [40, 4367, 41]], [[12811, 12811], "disallowed_STD3_mapped", [40, 4368, 41]], [[12812, 12812], "disallowed_STD3_mapped", [40, 4369, 41]], [[12813, 12813], "disallowed_STD3_mapped", [40, 4370, 41]], [[12814, 12814], "disallowed_STD3_mapped", [40, 44032, 41]], [[12815, 12815], "disallowed_STD3_mapped", [40, 45208, 41]], [[12816, 12816], "disallowed_STD3_mapped", [40, 45796, 41]], [[12817, 12817], "disallowed_STD3_mapped", [40, 46972, 41]], [[12818, 12818], "disallowed_STD3_mapped", [40, 47560, 41]], [[12819, 12819], "disallowed_STD3_mapped", [40, 48148, 41]], [[12820, 12820], "disallowed_STD3_mapped", [40, 49324, 41]], [[12821, 12821], "disallowed_STD3_mapped", [40, 50500, 41]], [[12822, 12822], "disallowed_STD3_mapped", [40, 51088, 41]], [[12823, 12823], "disallowed_STD3_mapped", [40, 52264, 41]], [[12824, 12824], "disallowed_STD3_mapped", [40, 52852, 41]], [[12825, 12825], "disallowed_STD3_mapped", [40, 53440, 41]], [[12826, 12826], "disallowed_STD3_mapped", [40, 54028, 41]], [[12827, 12827], "disallowed_STD3_mapped", [40, 54616, 41]], [[12828, 12828], "disallowed_STD3_mapped", [40, 51452, 41]], [[12829, 12829], "disallowed_STD3_mapped", [40, 50724, 51204, 41]], [[12830, 12830], "disallowed_STD3_mapped", [40, 50724, 54980, 41]], [[12831, 12831], "disallowed"], [[12832, 12832], "disallowed_STD3_mapped", [40, 19968, 41]], [[12833, 12833], "disallowed_STD3_mapped", [40, 20108, 41]], [[12834, 12834], "disallowed_STD3_mapped", [40, 19977, 41]], [[12835, 12835], "disallowed_STD3_mapped", [40, 22235, 41]], [[12836, 12836], "disallowed_STD3_mapped", [40, 20116, 41]], [[12837, 12837], "disallowed_STD3_mapped", [40, 20845, 41]], [[12838, 12838], "disallowed_STD3_mapped", [40, 19971, 41]], [[12839, 12839], "disallowed_STD3_mapped", [40, 20843, 41]], [[12840, 12840], "disallowed_STD3_mapped", [40, 20061, 41]], [[12841, 12841], "disallowed_STD3_mapped", [40, 21313, 41]], [[12842, 12842], "disallowed_STD3_mapped", [40, 26376, 41]], [[12843, 12843], "disallowed_STD3_mapped", [40, 28779, 41]], [[12844, 12844], "disallowed_STD3_mapped", [40, 27700, 41]], [[12845, 12845], "disallowed_STD3_mapped", [40, 26408, 41]], [[12846, 12846], "disallowed_STD3_mapped", [40, 37329, 41]], [[12847, 12847], "disallowed_STD3_mapped", [40, 22303, 41]], [[12848, 12848], "disallowed_STD3_mapped", [40, 26085, 41]], [[12849, 12849], "disallowed_STD3_mapped", [40, 26666, 41]], [[12850, 12850], "disallowed_STD3_mapped", [40, 26377, 41]], [[12851, 12851], "disallowed_STD3_mapped", [40, 31038, 41]], [[12852, 12852], "disallowed_STD3_mapped", [40, 21517, 41]], [[12853, 12853], "disallowed_STD3_mapped", [40, 29305, 41]], [[12854, 12854], "disallowed_STD3_mapped", [40, 36001, 41]], [[12855, 12855], "disallowed_STD3_mapped", [40, 31069, 41]], [[12856, 12856], "disallowed_STD3_mapped", [40, 21172, 41]], [[12857, 12857], "disallowed_STD3_mapped", [40, 20195, 41]], [[12858, 12858], "disallowed_STD3_mapped", [40, 21628, 41]], [[12859, 12859], "disallowed_STD3_mapped", [40, 23398, 41]], [[12860, 12860], "disallowed_STD3_mapped", [40, 30435, 41]], [[12861, 12861], "disallowed_STD3_mapped", [40, 20225, 41]], [[12862, 12862], "disallowed_STD3_mapped", [40, 36039, 41]], [[12863, 12863], "disallowed_STD3_mapped", [40, 21332, 41]], [[12864, 12864], "disallowed_STD3_mapped", [40, 31085, 41]], [[12865, 12865], "disallowed_STD3_mapped", [40, 20241, 41]], [[12866, 12866], "disallowed_STD3_mapped", [40, 33258, 41]], [[12867, 12867], "disallowed_STD3_mapped", [40, 33267, 41]], [[12868, 12868], "mapped", [21839]], [[12869, 12869], "mapped", [24188]], [[12870, 12870], "mapped", [25991]], [[12871, 12871], "mapped", [31631]], [[12872, 12879], "valid", [], "NV8"], [[12880, 12880], "mapped", [112, 116, 101]], [[12881, 12881], "mapped", [50, 49]], [[12882, 12882], "mapped", [50, 50]], [[12883, 12883], "mapped", [50, 51]], [[12884, 12884], "mapped", [50, 52]], [[12885, 12885], "mapped", [50, 53]], [[12886, 12886], "mapped", [50, 54]], [[12887, 12887], "mapped", [50, 55]], [[12888, 12888], "mapped", [50, 56]], [[12889, 12889], "mapped", [50, 57]], [[12890, 12890], "mapped", [51, 48]], [[12891, 12891], "mapped", [51, 49]], [[12892, 12892], "mapped", [51, 50]], [[12893, 12893], "mapped", [51, 51]], [[12894, 12894], "mapped", [51, 52]], [[12895, 12895], "mapped", [51, 53]], [[12896, 12896], "mapped", [4352]], [[12897, 12897], "mapped", [4354]], [[12898, 12898], "mapped", [4355]], [[12899, 12899], "mapped", [4357]], [[12900, 12900], "mapped", [4358]], [[12901, 12901], "mapped", [4359]], [[12902, 12902], "mapped", [4361]], [[12903, 12903], "mapped", [4363]], [[12904, 12904], "mapped", [4364]], [[12905, 12905], "mapped", [4366]], [[12906, 12906], "mapped", [4367]], [[12907, 12907], "mapped", [4368]], [[12908, 12908], "mapped", [4369]], [[12909, 12909], "mapped", [4370]], [[12910, 12910], "mapped", [44032]], [[12911, 12911], "mapped", [45208]], [[12912, 12912], "mapped", [45796]], [[12913, 12913], "mapped", [46972]], [[12914, 12914], "mapped", [47560]], [[12915, 12915], "mapped", [48148]], [[12916, 12916], "mapped", [49324]], [[12917, 12917], "mapped", [50500]], [[12918, 12918], "mapped", [51088]], [[12919, 12919], "mapped", [52264]], [[12920, 12920], "mapped", [52852]], [[12921, 12921], "mapped", [53440]], [[12922, 12922], "mapped", [54028]], [[12923, 12923], "mapped", [54616]], [[12924, 12924], "mapped", [52280, 44256]], [[12925, 12925], "mapped", [51452, 51032]], [[12926, 12926], "mapped", [50864]], [[12927, 12927], "valid", [], "NV8"], [[12928, 12928], "mapped", [19968]], [[12929, 12929], "mapped", [20108]], [[12930, 12930], "mapped", [19977]], [[12931, 12931], "mapped", [22235]], [[12932, 12932], "mapped", [20116]], [[12933, 12933], "mapped", [20845]], [[12934, 12934], "mapped", [19971]], [[12935, 12935], "mapped", [20843]], [[12936, 12936], "mapped", [20061]], [[12937, 12937], "mapped", [21313]], [[12938, 12938], "mapped", [26376]], [[12939, 12939], "mapped", [28779]], [[12940, 12940], "mapped", [27700]], [[12941, 12941], "mapped", [26408]], [[12942, 12942], "mapped", [37329]], [[12943, 12943], "mapped", [22303]], [[12944, 12944], "mapped", [26085]], [[12945, 12945], "mapped", [26666]], [[12946, 12946], "mapped", [26377]], [[12947, 12947], "mapped", [31038]], [[12948, 12948], "mapped", [21517]], [[12949, 12949], "mapped", [29305]], [[12950, 12950], "mapped", [36001]], [[12951, 12951], "mapped", [31069]], [[12952, 12952], "mapped", [21172]], [[12953, 12953], "mapped", [31192]], [[12954, 12954], "mapped", [30007]], [[12955, 12955], "mapped", [22899]], [[12956, 12956], "mapped", [36969]], [[12957, 12957], "mapped", [20778]], [[12958, 12958], "mapped", [21360]], [[12959, 12959], "mapped", [27880]], [[12960, 12960], "mapped", [38917]], [[12961, 12961], "mapped", [20241]], [[12962, 12962], "mapped", [20889]], [[12963, 12963], "mapped", [27491]], [[12964, 12964], "mapped", [19978]], [[12965, 12965], "mapped", [20013]], [[12966, 12966], "mapped", [19979]], [[12967, 12967], "mapped", [24038]], [[12968, 12968], "mapped", [21491]], [[12969, 12969], "mapped", [21307]], [[12970, 12970], "mapped", [23447]], [[12971, 12971], "mapped", [23398]], [[12972, 12972], "mapped", [30435]], [[12973, 12973], "mapped", [20225]], [[12974, 12974], "mapped", [36039]], [[12975, 12975], "mapped", [21332]], [[12976, 12976], "mapped", [22812]], [[12977, 12977], "mapped", [51, 54]], [[12978, 12978], "mapped", [51, 55]], [[12979, 12979], "mapped", [51, 56]], [[12980, 12980], "mapped", [51, 57]], [[12981, 12981], "mapped", [52, 48]], [[12982, 12982], "mapped", [52, 49]], [[12983, 12983], "mapped", [52, 50]], [[12984, 12984], "mapped", [52, 51]], [[12985, 12985], "mapped", [52, 52]], [[12986, 12986], "mapped", [52, 53]], [[12987, 12987], "mapped", [52, 54]], [[12988, 12988], "mapped", [52, 55]], [[12989, 12989], "mapped", [52, 56]], [[12990, 12990], "mapped", [52, 57]], [[12991, 12991], "mapped", [53, 48]], [[12992, 12992], "mapped", [49, 26376]], [[12993, 12993], "mapped", [50, 26376]], [[12994, 12994], "mapped", [51, 26376]], [[12995, 12995], "mapped", [52, 26376]], [[12996, 12996], "mapped", [53, 26376]], [[12997, 12997], "mapped", [54, 26376]], [[12998, 12998], "mapped", [55, 26376]], [[12999, 12999], "mapped", [56, 26376]], [[13e3, 13e3], "mapped", [57, 26376]], [[13001, 13001], "mapped", [49, 48, 26376]], [[13002, 13002], "mapped", [49, 49, 26376]], [[13003, 13003], "mapped", [49, 50, 26376]], [[13004, 13004], "mapped", [104, 103]], [[13005, 13005], "mapped", [101, 114, 103]], [[13006, 13006], "mapped", [101, 118]], [[13007, 13007], "mapped", [108, 116, 100]], [[13008, 13008], "mapped", [12450]], [[13009, 13009], "mapped", [12452]], [[13010, 13010], "mapped", [12454]], [[13011, 13011], "mapped", [12456]], [[13012, 13012], "mapped", [12458]], [[13013, 13013], "mapped", [12459]], [[13014, 13014], "mapped", [12461]], [[13015, 13015], "mapped", [12463]], [[13016, 13016], "mapped", [12465]], [[13017, 13017], "mapped", [12467]], [[13018, 13018], "mapped", [12469]], [[13019, 13019], "mapped", [12471]], [[13020, 13020], "mapped", [12473]], [[13021, 13021], "mapped", [12475]], [[13022, 13022], "mapped", [12477]], [[13023, 13023], "mapped", [12479]], [[13024, 13024], "mapped", [12481]], [[13025, 13025], "mapped", [12484]], [[13026, 13026], "mapped", [12486]], [[13027, 13027], "mapped", [12488]], [[13028, 13028], "mapped", [12490]], [[13029, 13029], "mapped", [12491]], [[13030, 13030], "mapped", [12492]], [[13031, 13031], "mapped", [12493]], [[13032, 13032], "mapped", [12494]], [[13033, 13033], "mapped", [12495]], [[13034, 13034], "mapped", [12498]], [[13035, 13035], "mapped", [12501]], [[13036, 13036], "mapped", [12504]], [[13037, 13037], "mapped", [12507]], [[13038, 13038], "mapped", [12510]], [[13039, 13039], "mapped", [12511]], [[13040, 13040], "mapped", [12512]], [[13041, 13041], "mapped", [12513]], [[13042, 13042], "mapped", [12514]], [[13043, 13043], "mapped", [12516]], [[13044, 13044], "mapped", [12518]], [[13045, 13045], "mapped", [12520]], [[13046, 13046], "mapped", [12521]], [[13047, 13047], "mapped", [12522]], [[13048, 13048], "mapped", [12523]], [[13049, 13049], "mapped", [12524]], [[13050, 13050], "mapped", [12525]], [[13051, 13051], "mapped", [12527]], [[13052, 13052], "mapped", [12528]], [[13053, 13053], "mapped", [12529]], [[13054, 13054], "mapped", [12530]], [[13055, 13055], "disallowed"], [[13056, 13056], "mapped", [12450, 12497, 12540, 12488]], [[13057, 13057], "mapped", [12450, 12523, 12501, 12449]], [[13058, 13058], "mapped", [12450, 12531, 12506, 12450]], [[13059, 13059], "mapped", [12450, 12540, 12523]], [[13060, 13060], "mapped", [12452, 12491, 12531, 12464]], [[13061, 13061], "mapped", [12452, 12531, 12481]], [[13062, 13062], "mapped", [12454, 12457, 12531]], [[13063, 13063], "mapped", [12456, 12473, 12463, 12540, 12489]], [[13064, 13064], "mapped", [12456, 12540, 12459, 12540]], [[13065, 13065], "mapped", [12458, 12531, 12473]], [[13066, 13066], "mapped", [12458, 12540, 12512]], [[13067, 13067], "mapped", [12459, 12452, 12522]], [[13068, 13068], "mapped", [12459, 12521, 12483, 12488]], [[13069, 13069], "mapped", [12459, 12525, 12522, 12540]], [[13070, 13070], "mapped", [12460, 12525, 12531]], [[13071, 13071], "mapped", [12460, 12531, 12510]], [[13072, 13072], "mapped", [12462, 12460]], [[13073, 13073], "mapped", [12462, 12491, 12540]], [[13074, 13074], "mapped", [12461, 12517, 12522, 12540]], [[13075, 13075], "mapped", [12462, 12523, 12480, 12540]], [[13076, 13076], "mapped", [12461, 12525]], [[13077, 13077], "mapped", [12461, 12525, 12464, 12521, 12512]], [[13078, 13078], "mapped", [12461, 12525, 12513, 12540, 12488, 12523]], [[13079, 13079], "mapped", [12461, 12525, 12527, 12483, 12488]], [[13080, 13080], "mapped", [12464, 12521, 12512]], [[13081, 13081], "mapped", [12464, 12521, 12512, 12488, 12531]], [[13082, 13082], "mapped", [12463, 12523, 12476, 12452, 12525]], [[13083, 13083], "mapped", [12463, 12525, 12540, 12493]], [[13084, 13084], "mapped", [12465, 12540, 12473]], [[13085, 13085], "mapped", [12467, 12523, 12490]], [[13086, 13086], "mapped", [12467, 12540, 12509]], [[13087, 13087], "mapped", [12469, 12452, 12463, 12523]], [[13088, 13088], "mapped", [12469, 12531, 12481, 12540, 12512]], [[13089, 13089], "mapped", [12471, 12522, 12531, 12464]], [[13090, 13090], "mapped", [12475, 12531, 12481]], [[13091, 13091], "mapped", [12475, 12531, 12488]], [[13092, 13092], "mapped", [12480, 12540, 12473]], [[13093, 13093], "mapped", [12487, 12471]], [[13094, 13094], "mapped", [12489, 12523]], [[13095, 13095], "mapped", [12488, 12531]], [[13096, 13096], "mapped", [12490, 12494]], [[13097, 13097], "mapped", [12494, 12483, 12488]], [[13098, 13098], "mapped", [12495, 12452, 12484]], [[13099, 13099], "mapped", [12497, 12540, 12475, 12531, 12488]], [[13100, 13100], "mapped", [12497, 12540, 12484]], [[13101, 13101], "mapped", [12496, 12540, 12524, 12523]], [[13102, 13102], "mapped", [12500, 12450, 12473, 12488, 12523]], [[13103, 13103], "mapped", [12500, 12463, 12523]], [[13104, 13104], "mapped", [12500, 12467]], [[13105, 13105], "mapped", [12499, 12523]], [[13106, 13106], "mapped", [12501, 12449, 12521, 12483, 12489]], [[13107, 13107], "mapped", [12501, 12451, 12540, 12488]], [[13108, 13108], "mapped", [12502, 12483, 12471, 12455, 12523]], [[13109, 13109], "mapped", [12501, 12521, 12531]], [[13110, 13110], "mapped", [12504, 12463, 12479, 12540, 12523]], [[13111, 13111], "mapped", [12506, 12477]], [[13112, 13112], "mapped", [12506, 12491, 12498]], [[13113, 13113], "mapped", [12504, 12523, 12484]], [[13114, 13114], "mapped", [12506, 12531, 12473]], [[13115, 13115], "mapped", [12506, 12540, 12472]], [[13116, 13116], "mapped", [12505, 12540, 12479]], [[13117, 13117], "mapped", [12509, 12452, 12531, 12488]], [[13118, 13118], "mapped", [12508, 12523, 12488]], [[13119, 13119], "mapped", [12507, 12531]], [[13120, 13120], "mapped", [12509, 12531, 12489]], [[13121, 13121], "mapped", [12507, 12540, 12523]], [[13122, 13122], "mapped", [12507, 12540, 12531]], [[13123, 13123], "mapped", [12510, 12452, 12463, 12525]], [[13124, 13124], "mapped", [12510, 12452, 12523]], [[13125, 13125], "mapped", [12510, 12483, 12495]], [[13126, 13126], "mapped", [12510, 12523, 12463]], [[13127, 13127], "mapped", [12510, 12531, 12471, 12519, 12531]], [[13128, 13128], "mapped", [12511, 12463, 12525, 12531]], [[13129, 13129], "mapped", [12511, 12522]], [[13130, 13130], "mapped", [12511, 12522, 12496, 12540, 12523]], [[13131, 13131], "mapped", [12513, 12460]], [[13132, 13132], "mapped", [12513, 12460, 12488, 12531]], [[13133, 13133], "mapped", [12513, 12540, 12488, 12523]], [[13134, 13134], "mapped", [12516, 12540, 12489]], [[13135, 13135], "mapped", [12516, 12540, 12523]], [[13136, 13136], "mapped", [12518, 12450, 12531]], [[13137, 13137], "mapped", [12522, 12483, 12488, 12523]], [[13138, 13138], "mapped", [12522, 12521]], [[13139, 13139], "mapped", [12523, 12500, 12540]], [[13140, 13140], "mapped", [12523, 12540, 12502, 12523]], [[13141, 13141], "mapped", [12524, 12512]], [[13142, 13142], "mapped", [12524, 12531, 12488, 12466, 12531]], [[13143, 13143], "mapped", [12527, 12483, 12488]], [[13144, 13144], "mapped", [48, 28857]], [[13145, 13145], "mapped", [49, 28857]], [[13146, 13146], "mapped", [50, 28857]], [[13147, 13147], "mapped", [51, 28857]], [[13148, 13148], "mapped", [52, 28857]], [[13149, 13149], "mapped", [53, 28857]], [[13150, 13150], "mapped", [54, 28857]], [[13151, 13151], "mapped", [55, 28857]], [[13152, 13152], "mapped", [56, 28857]], [[13153, 13153], "mapped", [57, 28857]], [[13154, 13154], "mapped", [49, 48, 28857]], [[13155, 13155], "mapped", [49, 49, 28857]], [[13156, 13156], "mapped", [49, 50, 28857]], [[13157, 13157], "mapped", [49, 51, 28857]], [[13158, 13158], "mapped", [49, 52, 28857]], [[13159, 13159], "mapped", [49, 53, 28857]], [[13160, 13160], "mapped", [49, 54, 28857]], [[13161, 13161], "mapped", [49, 55, 28857]], [[13162, 13162], "mapped", [49, 56, 28857]], [[13163, 13163], "mapped", [49, 57, 28857]], [[13164, 13164], "mapped", [50, 48, 28857]], [[13165, 13165], "mapped", [50, 49, 28857]], [[13166, 13166], "mapped", [50, 50, 28857]], [[13167, 13167], "mapped", [50, 51, 28857]], [[13168, 13168], "mapped", [50, 52, 28857]], [[13169, 13169], "mapped", [104, 112, 97]], [[13170, 13170], "mapped", [100, 97]], [[13171, 13171], "mapped", [97, 117]], [[13172, 13172], "mapped", [98, 97, 114]], [[13173, 13173], "mapped", [111, 118]], [[13174, 13174], "mapped", [112, 99]], [[13175, 13175], "mapped", [100, 109]], [[13176, 13176], "mapped", [100, 109, 50]], [[13177, 13177], "mapped", [100, 109, 51]], [[13178, 13178], "mapped", [105, 117]], [[13179, 13179], "mapped", [24179, 25104]], [[13180, 13180], "mapped", [26157, 21644]], [[13181, 13181], "mapped", [22823, 27491]], [[13182, 13182], "mapped", [26126, 27835]], [[13183, 13183], "mapped", [26666, 24335, 20250, 31038]], [[13184, 13184], "mapped", [112, 97]], [[13185, 13185], "mapped", [110, 97]], [[13186, 13186], "mapped", [956, 97]], [[13187, 13187], "mapped", [109, 97]], [[13188, 13188], "mapped", [107, 97]], [[13189, 13189], "mapped", [107, 98]], [[13190, 13190], "mapped", [109, 98]], [[13191, 13191], "mapped", [103, 98]], [[13192, 13192], "mapped", [99, 97, 108]], [[13193, 13193], "mapped", [107, 99, 97, 108]], [[13194, 13194], "mapped", [112, 102]], [[13195, 13195], "mapped", [110, 102]], [[13196, 13196], "mapped", [956, 102]], [[13197, 13197], "mapped", [956, 103]], [[13198, 13198], "mapped", [109, 103]], [[13199, 13199], "mapped", [107, 103]], [[13200, 13200], "mapped", [104, 122]], [[13201, 13201], "mapped", [107, 104, 122]], [[13202, 13202], "mapped", [109, 104, 122]], [[13203, 13203], "mapped", [103, 104, 122]], [[13204, 13204], "mapped", [116, 104, 122]], [[13205, 13205], "mapped", [956, 108]], [[13206, 13206], "mapped", [109, 108]], [[13207, 13207], "mapped", [100, 108]], [[13208, 13208], "mapped", [107, 108]], [[13209, 13209], "mapped", [102, 109]], [[13210, 13210], "mapped", [110, 109]], [[13211, 13211], "mapped", [956, 109]], [[13212, 13212], "mapped", [109, 109]], [[13213, 13213], "mapped", [99, 109]], [[13214, 13214], "mapped", [107, 109]], [[13215, 13215], "mapped", [109, 109, 50]], [[13216, 13216], "mapped", [99, 109, 50]], [[13217, 13217], "mapped", [109, 50]], [[13218, 13218], "mapped", [107, 109, 50]], [[13219, 13219], "mapped", [109, 109, 51]], [[13220, 13220], "mapped", [99, 109, 51]], [[13221, 13221], "mapped", [109, 51]], [[13222, 13222], "mapped", [107, 109, 51]], [[13223, 13223], "mapped", [109, 8725, 115]], [[13224, 13224], "mapped", [109, 8725, 115, 50]], [[13225, 13225], "mapped", [112, 97]], [[13226, 13226], "mapped", [107, 112, 97]], [[13227, 13227], "mapped", [109, 112, 97]], [[13228, 13228], "mapped", [103, 112, 97]], [[13229, 13229], "mapped", [114, 97, 100]], [[13230, 13230], "mapped", [114, 97, 100, 8725, 115]], [[13231, 13231], "mapped", [114, 97, 100, 8725, 115, 50]], [[13232, 13232], "mapped", [112, 115]], [[13233, 13233], "mapped", [110, 115]], [[13234, 13234], "mapped", [956, 115]], [[13235, 13235], "mapped", [109, 115]], [[13236, 13236], "mapped", [112, 118]], [[13237, 13237], "mapped", [110, 118]], [[13238, 13238], "mapped", [956, 118]], [[13239, 13239], "mapped", [109, 118]], [[13240, 13240], "mapped", [107, 118]], [[13241, 13241], "mapped", [109, 118]], [[13242, 13242], "mapped", [112, 119]], [[13243, 13243], "mapped", [110, 119]], [[13244, 13244], "mapped", [956, 119]], [[13245, 13245], "mapped", [109, 119]], [[13246, 13246], "mapped", [107, 119]], [[13247, 13247], "mapped", [109, 119]], [[13248, 13248], "mapped", [107, 969]], [[13249, 13249], "mapped", [109, 969]], [[13250, 13250], "disallowed"], [[13251, 13251], "mapped", [98, 113]], [[13252, 13252], "mapped", [99, 99]], [[13253, 13253], "mapped", [99, 100]], [[13254, 13254], "mapped", [99, 8725, 107, 103]], [[13255, 13255], "disallowed"], [[13256, 13256], "mapped", [100, 98]], [[13257, 13257], "mapped", [103, 121]], [[13258, 13258], "mapped", [104, 97]], [[13259, 13259], "mapped", [104, 112]], [[13260, 13260], "mapped", [105, 110]], [[13261, 13261], "mapped", [107, 107]], [[13262, 13262], "mapped", [107, 109]], [[13263, 13263], "mapped", [107, 116]], [[13264, 13264], "mapped", [108, 109]], [[13265, 13265], "mapped", [108, 110]], [[13266, 13266], "mapped", [108, 111, 103]], [[13267, 13267], "mapped", [108, 120]], [[13268, 13268], "mapped", [109, 98]], [[13269, 13269], "mapped", [109, 105, 108]], [[13270, 13270], "mapped", [109, 111, 108]], [[13271, 13271], "mapped", [112, 104]], [[13272, 13272], "disallowed"], [[13273, 13273], "mapped", [112, 112, 109]], [[13274, 13274], "mapped", [112, 114]], [[13275, 13275], "mapped", [115, 114]], [[13276, 13276], "mapped", [115, 118]], [[13277, 13277], "mapped", [119, 98]], [[13278, 13278], "mapped", [118, 8725, 109]], [[13279, 13279], "mapped", [97, 8725, 109]], [[13280, 13280], "mapped", [49, 26085]], [[13281, 13281], "mapped", [50, 26085]], [[13282, 13282], "mapped", [51, 26085]], [[13283, 13283], "mapped", [52, 26085]], [[13284, 13284], "mapped", [53, 26085]], [[13285, 13285], "mapped", [54, 26085]], [[13286, 13286], "mapped", [55, 26085]], [[13287, 13287], "mapped", [56, 26085]], [[13288, 13288], "mapped", [57, 26085]], [[13289, 13289], "mapped", [49, 48, 26085]], [[13290, 13290], "mapped", [49, 49, 26085]], [[13291, 13291], "mapped", [49, 50, 26085]], [[13292, 13292], "mapped", [49, 51, 26085]], [[13293, 13293], "mapped", [49, 52, 26085]], [[13294, 13294], "mapped", [49, 53, 26085]], [[13295, 13295], "mapped", [49, 54, 26085]], [[13296, 13296], "mapped", [49, 55, 26085]], [[13297, 13297], "mapped", [49, 56, 26085]], [[13298, 13298], "mapped", [49, 57, 26085]], [[13299, 13299], "mapped", [50, 48, 26085]], [[13300, 13300], "mapped", [50, 49, 26085]], [[13301, 13301], "mapped", [50, 50, 26085]], [[13302, 13302], "mapped", [50, 51, 26085]], [[13303, 13303], "mapped", [50, 52, 26085]], [[13304, 13304], "mapped", [50, 53, 26085]], [[13305, 13305], "mapped", [50, 54, 26085]], [[13306, 13306], "mapped", [50, 55, 26085]], [[13307, 13307], "mapped", [50, 56, 26085]], [[13308, 13308], "mapped", [50, 57, 26085]], [[13309, 13309], "mapped", [51, 48, 26085]], [[13310, 13310], "mapped", [51, 49, 26085]], [[13311, 13311], "mapped", [103, 97, 108]], [[13312, 19893], "valid"], [[19894, 19903], "disallowed"], [[19904, 19967], "valid", [], "NV8"], [[19968, 40869], "valid"], [[40870, 40891], "valid"], [[40892, 40899], "valid"], [[40900, 40907], "valid"], [[40908, 40908], "valid"], [[40909, 40917], "valid"], [[40918, 40959], "disallowed"], [[40960, 42124], "valid"], [[42125, 42127], "disallowed"], [[42128, 42145], "valid", [], "NV8"], [[42146, 42147], "valid", [], "NV8"], [[42148, 42163], "valid", [], "NV8"], [[42164, 42164], "valid", [], "NV8"], [[42165, 42176], "valid", [], "NV8"], [[42177, 42177], "valid", [], "NV8"], [[42178, 42180], "valid", [], "NV8"], [[42181, 42181], "valid", [], "NV8"], [[42182, 42182], "valid", [], "NV8"], [[42183, 42191], "disallowed"], [[42192, 42237], "valid"], [[42238, 42239], "valid", [], "NV8"], [[42240, 42508], "valid"], [[42509, 42511], "valid", [], "NV8"], [[42512, 42539], "valid"], [[42540, 42559], "disallowed"], [[42560, 42560], "mapped", [42561]], [[42561, 42561], "valid"], [[42562, 42562], "mapped", [42563]], [[42563, 42563], "valid"], [[42564, 42564], "mapped", [42565]], [[42565, 42565], "valid"], [[42566, 42566], "mapped", [42567]], [[42567, 42567], "valid"], [[42568, 42568], "mapped", [42569]], [[42569, 42569], "valid"], [[42570, 42570], "mapped", [42571]], [[42571, 42571], "valid"], [[42572, 42572], "mapped", [42573]], [[42573, 42573], "valid"], [[42574, 42574], "mapped", [42575]], [[42575, 42575], "valid"], [[42576, 42576], "mapped", [42577]], [[42577, 42577], "valid"], [[42578, 42578], "mapped", [42579]], [[42579, 42579], "valid"], [[42580, 42580], "mapped", [42581]], [[42581, 42581], "valid"], [[42582, 42582], "mapped", [42583]], [[42583, 42583], "valid"], [[42584, 42584], "mapped", [42585]], [[42585, 42585], "valid"], [[42586, 42586], "mapped", [42587]], [[42587, 42587], "valid"], [[42588, 42588], "mapped", [42589]], [[42589, 42589], "valid"], [[42590, 42590], "mapped", [42591]], [[42591, 42591], "valid"], [[42592, 42592], "mapped", [42593]], [[42593, 42593], "valid"], [[42594, 42594], "mapped", [42595]], [[42595, 42595], "valid"], [[42596, 42596], "mapped", [42597]], [[42597, 42597], "valid"], [[42598, 42598], "mapped", [42599]], [[42599, 42599], "valid"], [[42600, 42600], "mapped", [42601]], [[42601, 42601], "valid"], [[42602, 42602], "mapped", [42603]], [[42603, 42603], "valid"], [[42604, 42604], "mapped", [42605]], [[42605, 42607], "valid"], [[42608, 42611], "valid", [], "NV8"], [[42612, 42619], "valid"], [[42620, 42621], "valid"], [[42622, 42622], "valid", [], "NV8"], [[42623, 42623], "valid"], [[42624, 42624], "mapped", [42625]], [[42625, 42625], "valid"], [[42626, 42626], "mapped", [42627]], [[42627, 42627], "valid"], [[42628, 42628], "mapped", [42629]], [[42629, 42629], "valid"], [[42630, 42630], "mapped", [42631]], [[42631, 42631], "valid"], [[42632, 42632], "mapped", [42633]], [[42633, 42633], "valid"], [[42634, 42634], "mapped", [42635]], [[42635, 42635], "valid"], [[42636, 42636], "mapped", [42637]], [[42637, 42637], "valid"], [[42638, 42638], "mapped", [42639]], [[42639, 42639], "valid"], [[42640, 42640], "mapped", [42641]], [[42641, 42641], "valid"], [[42642, 42642], "mapped", [42643]], [[42643, 42643], "valid"], [[42644, 42644], "mapped", [42645]], [[42645, 42645], "valid"], [[42646, 42646], "mapped", [42647]], [[42647, 42647], "valid"], [[42648, 42648], "mapped", [42649]], [[42649, 42649], "valid"], [[42650, 42650], "mapped", [42651]], [[42651, 42651], "valid"], [[42652, 42652], "mapped", [1098]], [[42653, 42653], "mapped", [1100]], [[42654, 42654], "valid"], [[42655, 42655], "valid"], [[42656, 42725], "valid"], [[42726, 42735], "valid", [], "NV8"], [[42736, 42737], "valid"], [[42738, 42743], "valid", [], "NV8"], [[42744, 42751], "disallowed"], [[42752, 42774], "valid", [], "NV8"], [[42775, 42778], "valid"], [[42779, 42783], "valid"], [[42784, 42785], "valid", [], "NV8"], [[42786, 42786], "mapped", [42787]], [[42787, 42787], "valid"], [[42788, 42788], "mapped", [42789]], [[42789, 42789], "valid"], [[42790, 42790], "mapped", [42791]], [[42791, 42791], "valid"], [[42792, 42792], "mapped", [42793]], [[42793, 42793], "valid"], [[42794, 42794], "mapped", [42795]], [[42795, 42795], "valid"], [[42796, 42796], "mapped", [42797]], [[42797, 42797], "valid"], [[42798, 42798], "mapped", [42799]], [[42799, 42801], "valid"], [[42802, 42802], "mapped", [42803]], [[42803, 42803], "valid"], [[42804, 42804], "mapped", [42805]], [[42805, 42805], "valid"], [[42806, 42806], "mapped", [42807]], [[42807, 42807], "valid"], [[42808, 42808], "mapped", [42809]], [[42809, 42809], "valid"], [[42810, 42810], "mapped", [42811]], [[42811, 42811], "valid"], [[42812, 42812], "mapped", [42813]], [[42813, 42813], "valid"], [[42814, 42814], "mapped", [42815]], [[42815, 42815], "valid"], [[42816, 42816], "mapped", [42817]], [[42817, 42817], "valid"], [[42818, 42818], "mapped", [42819]], [[42819, 42819], "valid"], [[42820, 42820], "mapped", [42821]], [[42821, 42821], "valid"], [[42822, 42822], "mapped", [42823]], [[42823, 42823], "valid"], [[42824, 42824], "mapped", [42825]], [[42825, 42825], "valid"], [[42826, 42826], "mapped", [42827]], [[42827, 42827], "valid"], [[42828, 42828], "mapped", [42829]], [[42829, 42829], "valid"], [[42830, 42830], "mapped", [42831]], [[42831, 42831], "valid"], [[42832, 42832], "mapped", [42833]], [[42833, 42833], "valid"], [[42834, 42834], "mapped", [42835]], [[42835, 42835], "valid"], [[42836, 42836], "mapped", [42837]], [[42837, 42837], "valid"], [[42838, 42838], "mapped", [42839]], [[42839, 42839], "valid"], [[42840, 42840], "mapped", [42841]], [[42841, 42841], "valid"], [[42842, 42842], "mapped", [42843]], [[42843, 42843], "valid"], [[42844, 42844], "mapped", [42845]], [[42845, 42845], "valid"], [[42846, 42846], "mapped", [42847]], [[42847, 42847], "valid"], [[42848, 42848], "mapped", [42849]], [[42849, 42849], "valid"], [[42850, 42850], "mapped", [42851]], [[42851, 42851], "valid"], [[42852, 42852], "mapped", [42853]], [[42853, 42853], "valid"], [[42854, 42854], "mapped", [42855]], [[42855, 42855], "valid"], [[42856, 42856], "mapped", [42857]], [[42857, 42857], "valid"], [[42858, 42858], "mapped", [42859]], [[42859, 42859], "valid"], [[42860, 42860], "mapped", [42861]], [[42861, 42861], "valid"], [[42862, 42862], "mapped", [42863]], [[42863, 42863], "valid"], [[42864, 42864], "mapped", [42863]], [[42865, 42872], "valid"], [[42873, 42873], "mapped", [42874]], [[42874, 42874], "valid"], [[42875, 42875], "mapped", [42876]], [[42876, 42876], "valid"], [[42877, 42877], "mapped", [7545]], [[42878, 42878], "mapped", [42879]], [[42879, 42879], "valid"], [[42880, 42880], "mapped", [42881]], [[42881, 42881], "valid"], [[42882, 42882], "mapped", [42883]], [[42883, 42883], "valid"], [[42884, 42884], "mapped", [42885]], [[42885, 42885], "valid"], [[42886, 42886], "mapped", [42887]], [[42887, 42888], "valid"], [[42889, 42890], "valid", [], "NV8"], [[42891, 42891], "mapped", [42892]], [[42892, 42892], "valid"], [[42893, 42893], "mapped", [613]], [[42894, 42894], "valid"], [[42895, 42895], "valid"], [[42896, 42896], "mapped", [42897]], [[42897, 42897], "valid"], [[42898, 42898], "mapped", [42899]], [[42899, 42899], "valid"], [[42900, 42901], "valid"], [[42902, 42902], "mapped", [42903]], [[42903, 42903], "valid"], [[42904, 42904], "mapped", [42905]], [[42905, 42905], "valid"], [[42906, 42906], "mapped", [42907]], [[42907, 42907], "valid"], [[42908, 42908], "mapped", [42909]], [[42909, 42909], "valid"], [[42910, 42910], "mapped", [42911]], [[42911, 42911], "valid"], [[42912, 42912], "mapped", [42913]], [[42913, 42913], "valid"], [[42914, 42914], "mapped", [42915]], [[42915, 42915], "valid"], [[42916, 42916], "mapped", [42917]], [[42917, 42917], "valid"], [[42918, 42918], "mapped", [42919]], [[42919, 42919], "valid"], [[42920, 42920], "mapped", [42921]], [[42921, 42921], "valid"], [[42922, 42922], "mapped", [614]], [[42923, 42923], "mapped", [604]], [[42924, 42924], "mapped", [609]], [[42925, 42925], "mapped", [620]], [[42926, 42927], "disallowed"], [[42928, 42928], "mapped", [670]], [[42929, 42929], "mapped", [647]], [[42930, 42930], "mapped", [669]], [[42931, 42931], "mapped", [43859]], [[42932, 42932], "mapped", [42933]], [[42933, 42933], "valid"], [[42934, 42934], "mapped", [42935]], [[42935, 42935], "valid"], [[42936, 42998], "disallowed"], [[42999, 42999], "valid"], [[43e3, 43e3], "mapped", [295]], [[43001, 43001], "mapped", [339]], [[43002, 43002], "valid"], [[43003, 43007], "valid"], [[43008, 43047], "valid"], [[43048, 43051], "valid", [], "NV8"], [[43052, 43055], "disallowed"], [[43056, 43065], "valid", [], "NV8"], [[43066, 43071], "disallowed"], [[43072, 43123], "valid"], [[43124, 43127], "valid", [], "NV8"], [[43128, 43135], "disallowed"], [[43136, 43204], "valid"], [[43205, 43213], "disallowed"], [[43214, 43215], "valid", [], "NV8"], [[43216, 43225], "valid"], [[43226, 43231], "disallowed"], [[43232, 43255], "valid"], [[43256, 43258], "valid", [], "NV8"], [[43259, 43259], "valid"], [[43260, 43260], "valid", [], "NV8"], [[43261, 43261], "valid"], [[43262, 43263], "disallowed"], [[43264, 43309], "valid"], [[43310, 43311], "valid", [], "NV8"], [[43312, 43347], "valid"], [[43348, 43358], "disallowed"], [[43359, 43359], "valid", [], "NV8"], [[43360, 43388], "valid", [], "NV8"], [[43389, 43391], "disallowed"], [[43392, 43456], "valid"], [[43457, 43469], "valid", [], "NV8"], [[43470, 43470], "disallowed"], [[43471, 43481], "valid"], [[43482, 43485], "disallowed"], [[43486, 43487], "valid", [], "NV8"], [[43488, 43518], "valid"], [[43519, 43519], "disallowed"], [[43520, 43574], "valid"], [[43575, 43583], "disallowed"], [[43584, 43597], "valid"], [[43598, 43599], "disallowed"], [[43600, 43609], "valid"], [[43610, 43611], "disallowed"], [[43612, 43615], "valid", [], "NV8"], [[43616, 43638], "valid"], [[43639, 43641], "valid", [], "NV8"], [[43642, 43643], "valid"], [[43644, 43647], "valid"], [[43648, 43714], "valid"], [[43715, 43738], "disallowed"], [[43739, 43741], "valid"], [[43742, 43743], "valid", [], "NV8"], [[43744, 43759], "valid"], [[43760, 43761], "valid", [], "NV8"], [[43762, 43766], "valid"], [[43767, 43776], "disallowed"], [[43777, 43782], "valid"], [[43783, 43784], "disallowed"], [[43785, 43790], "valid"], [[43791, 43792], "disallowed"], [[43793, 43798], "valid"], [[43799, 43807], "disallowed"], [[43808, 43814], "valid"], [[43815, 43815], "disallowed"], [[43816, 43822], "valid"], [[43823, 43823], "disallowed"], [[43824, 43866], "valid"], [[43867, 43867], "valid", [], "NV8"], [[43868, 43868], "mapped", [42791]], [[43869, 43869], "mapped", [43831]], [[43870, 43870], "mapped", [619]], [[43871, 43871], "mapped", [43858]], [[43872, 43875], "valid"], [[43876, 43877], "valid"], [[43878, 43887], "disallowed"], [[43888, 43888], "mapped", [5024]], [[43889, 43889], "mapped", [5025]], [[43890, 43890], "mapped", [5026]], [[43891, 43891], "mapped", [5027]], [[43892, 43892], "mapped", [5028]], [[43893, 43893], "mapped", [5029]], [[43894, 43894], "mapped", [5030]], [[43895, 43895], "mapped", [5031]], [[43896, 43896], "mapped", [5032]], [[43897, 43897], "mapped", [5033]], [[43898, 43898], "mapped", [5034]], [[43899, 43899], "mapped", [5035]], [[43900, 43900], "mapped", [5036]], [[43901, 43901], "mapped", [5037]], [[43902, 43902], "mapped", [5038]], [[43903, 43903], "mapped", [5039]], [[43904, 43904], "mapped", [5040]], [[43905, 43905], "mapped", [5041]], [[43906, 43906], "mapped", [5042]], [[43907, 43907], "mapped", [5043]], [[43908, 43908], "mapped", [5044]], [[43909, 43909], "mapped", [5045]], [[43910, 43910], "mapped", [5046]], [[43911, 43911], "mapped", [5047]], [[43912, 43912], "mapped", [5048]], [[43913, 43913], "mapped", [5049]], [[43914, 43914], "mapped", [5050]], [[43915, 43915], "mapped", [5051]], [[43916, 43916], "mapped", [5052]], [[43917, 43917], "mapped", [5053]], [[43918, 43918], "mapped", [5054]], [[43919, 43919], "mapped", [5055]], [[43920, 43920], "mapped", [5056]], [[43921, 43921], "mapped", [5057]], [[43922, 43922], "mapped", [5058]], [[43923, 43923], "mapped", [5059]], [[43924, 43924], "mapped", [5060]], [[43925, 43925], "mapped", [5061]], [[43926, 43926], "mapped", [5062]], [[43927, 43927], "mapped", [5063]], [[43928, 43928], "mapped", [5064]], [[43929, 43929], "mapped", [5065]], [[43930, 43930], "mapped", [5066]], [[43931, 43931], "mapped", [5067]], [[43932, 43932], "mapped", [5068]], [[43933, 43933], "mapped", [5069]], [[43934, 43934], "mapped", [5070]], [[43935, 43935], "mapped", [5071]], [[43936, 43936], "mapped", [5072]], [[43937, 43937], "mapped", [5073]], [[43938, 43938], "mapped", [5074]], [[43939, 43939], "mapped", [5075]], [[43940, 43940], "mapped", [5076]], [[43941, 43941], "mapped", [5077]], [[43942, 43942], "mapped", [5078]], [[43943, 43943], "mapped", [5079]], [[43944, 43944], "mapped", [5080]], [[43945, 43945], "mapped", [5081]], [[43946, 43946], "mapped", [5082]], [[43947, 43947], "mapped", [5083]], [[43948, 43948], "mapped", [5084]], [[43949, 43949], "mapped", [5085]], [[43950, 43950], "mapped", [5086]], [[43951, 43951], "mapped", [5087]], [[43952, 43952], "mapped", [5088]], [[43953, 43953], "mapped", [5089]], [[43954, 43954], "mapped", [5090]], [[43955, 43955], "mapped", [5091]], [[43956, 43956], "mapped", [5092]], [[43957, 43957], "mapped", [5093]], [[43958, 43958], "mapped", [5094]], [[43959, 43959], "mapped", [5095]], [[43960, 43960], "mapped", [5096]], [[43961, 43961], "mapped", [5097]], [[43962, 43962], "mapped", [5098]], [[43963, 43963], "mapped", [5099]], [[43964, 43964], "mapped", [5100]], [[43965, 43965], "mapped", [5101]], [[43966, 43966], "mapped", [5102]], [[43967, 43967], "mapped", [5103]], [[43968, 44010], "valid"], [[44011, 44011], "valid", [], "NV8"], [[44012, 44013], "valid"], [[44014, 44015], "disallowed"], [[44016, 44025], "valid"], [[44026, 44031], "disallowed"], [[44032, 55203], "valid"], [[55204, 55215], "disallowed"], [[55216, 55238], "valid", [], "NV8"], [[55239, 55242], "disallowed"], [[55243, 55291], "valid", [], "NV8"], [[55292, 55295], "disallowed"], [[55296, 57343], "disallowed"], [[57344, 63743], "disallowed"], [[63744, 63744], "mapped", [35912]], [[63745, 63745], "mapped", [26356]], [[63746, 63746], "mapped", [36554]], [[63747, 63747], "mapped", [36040]], [[63748, 63748], "mapped", [28369]], [[63749, 63749], "mapped", [20018]], [[63750, 63750], "mapped", [21477]], [[63751, 63752], "mapped", [40860]], [[63753, 63753], "mapped", [22865]], [[63754, 63754], "mapped", [37329]], [[63755, 63755], "mapped", [21895]], [[63756, 63756], "mapped", [22856]], [[63757, 63757], "mapped", [25078]], [[63758, 63758], "mapped", [30313]], [[63759, 63759], "mapped", [32645]], [[63760, 63760], "mapped", [34367]], [[63761, 63761], "mapped", [34746]], [[63762, 63762], "mapped", [35064]], [[63763, 63763], "mapped", [37007]], [[63764, 63764], "mapped", [27138]], [[63765, 63765], "mapped", [27931]], [[63766, 63766], "mapped", [28889]], [[63767, 63767], "mapped", [29662]], [[63768, 63768], "mapped", [33853]], [[63769, 63769], "mapped", [37226]], [[63770, 63770], "mapped", [39409]], [[63771, 63771], "mapped", [20098]], [[63772, 63772], "mapped", [21365]], [[63773, 63773], "mapped", [27396]], [[63774, 63774], "mapped", [29211]], [[63775, 63775], "mapped", [34349]], [[63776, 63776], "mapped", [40478]], [[63777, 63777], "mapped", [23888]], [[63778, 63778], "mapped", [28651]], [[63779, 63779], "mapped", [34253]], [[63780, 63780], "mapped", [35172]], [[63781, 63781], "mapped", [25289]], [[63782, 63782], "mapped", [33240]], [[63783, 63783], "mapped", [34847]], [[63784, 63784], "mapped", [24266]], [[63785, 63785], "mapped", [26391]], [[63786, 63786], "mapped", [28010]], [[63787, 63787], "mapped", [29436]], [[63788, 63788], "mapped", [37070]], [[63789, 63789], "mapped", [20358]], [[63790, 63790], "mapped", [20919]], [[63791, 63791], "mapped", [21214]], [[63792, 63792], "mapped", [25796]], [[63793, 63793], "mapped", [27347]], [[63794, 63794], "mapped", [29200]], [[63795, 63795], "mapped", [30439]], [[63796, 63796], "mapped", [32769]], [[63797, 63797], "mapped", [34310]], [[63798, 63798], "mapped", [34396]], [[63799, 63799], "mapped", [36335]], [[63800, 63800], "mapped", [38706]], [[63801, 63801], "mapped", [39791]], [[63802, 63802], "mapped", [40442]], [[63803, 63803], "mapped", [30860]], [[63804, 63804], "mapped", [31103]], [[63805, 63805], "mapped", [32160]], [[63806, 63806], "mapped", [33737]], [[63807, 63807], "mapped", [37636]], [[63808, 63808], "mapped", [40575]], [[63809, 63809], "mapped", [35542]], [[63810, 63810], "mapped", [22751]], [[63811, 63811], "mapped", [24324]], [[63812, 63812], "mapped", [31840]], [[63813, 63813], "mapped", [32894]], [[63814, 63814], "mapped", [29282]], [[63815, 63815], "mapped", [30922]], [[63816, 63816], "mapped", [36034]], [[63817, 63817], "mapped", [38647]], [[63818, 63818], "mapped", [22744]], [[63819, 63819], "mapped", [23650]], [[63820, 63820], "mapped", [27155]], [[63821, 63821], "mapped", [28122]], [[63822, 63822], "mapped", [28431]], [[63823, 63823], "mapped", [32047]], [[63824, 63824], "mapped", [32311]], [[63825, 63825], "mapped", [38475]], [[63826, 63826], "mapped", [21202]], [[63827, 63827], "mapped", [32907]], [[63828, 63828], "mapped", [20956]], [[63829, 63829], "mapped", [20940]], [[63830, 63830], "mapped", [31260]], [[63831, 63831], "mapped", [32190]], [[63832, 63832], "mapped", [33777]], [[63833, 63833], "mapped", [38517]], [[63834, 63834], "mapped", [35712]], [[63835, 63835], "mapped", [25295]], [[63836, 63836], "mapped", [27138]], [[63837, 63837], "mapped", [35582]], [[63838, 63838], "mapped", [20025]], [[63839, 63839], "mapped", [23527]], [[63840, 63840], "mapped", [24594]], [[63841, 63841], "mapped", [29575]], [[63842, 63842], "mapped", [30064]], [[63843, 63843], "mapped", [21271]], [[63844, 63844], "mapped", [30971]], [[63845, 63845], "mapped", [20415]], [[63846, 63846], "mapped", [24489]], [[63847, 63847], "mapped", [19981]], [[63848, 63848], "mapped", [27852]], [[63849, 63849], "mapped", [25976]], [[63850, 63850], "mapped", [32034]], [[63851, 63851], "mapped", [21443]], [[63852, 63852], "mapped", [22622]], [[63853, 63853], "mapped", [30465]], [[63854, 63854], "mapped", [33865]], [[63855, 63855], "mapped", [35498]], [[63856, 63856], "mapped", [27578]], [[63857, 63857], "mapped", [36784]], [[63858, 63858], "mapped", [27784]], [[63859, 63859], "mapped", [25342]], [[63860, 63860], "mapped", [33509]], [[63861, 63861], "mapped", [25504]], [[63862, 63862], "mapped", [30053]], [[63863, 63863], "mapped", [20142]], [[63864, 63864], "mapped", [20841]], [[63865, 63865], "mapped", [20937]], [[63866, 63866], "mapped", [26753]], [[63867, 63867], "mapped", [31975]], [[63868, 63868], "mapped", [33391]], [[63869, 63869], "mapped", [35538]], [[63870, 63870], "mapped", [37327]], [[63871, 63871], "mapped", [21237]], [[63872, 63872], "mapped", [21570]], [[63873, 63873], "mapped", [22899]], [[63874, 63874], "mapped", [24300]], [[63875, 63875], "mapped", [26053]], [[63876, 63876], "mapped", [28670]], [[63877, 63877], "mapped", [31018]], [[63878, 63878], "mapped", [38317]], [[63879, 63879], "mapped", [39530]], [[63880, 63880], "mapped", [40599]], [[63881, 63881], "mapped", [40654]], [[63882, 63882], "mapped", [21147]], [[63883, 63883], "mapped", [26310]], [[63884, 63884], "mapped", [27511]], [[63885, 63885], "mapped", [36706]], [[63886, 63886], "mapped", [24180]], [[63887, 63887], "mapped", [24976]], [[63888, 63888], "mapped", [25088]], [[63889, 63889], "mapped", [25754]], [[63890, 63890], "mapped", [28451]], [[63891, 63891], "mapped", [29001]], [[63892, 63892], "mapped", [29833]], [[63893, 63893], "mapped", [31178]], [[63894, 63894], "mapped", [32244]], [[63895, 63895], "mapped", [32879]], [[63896, 63896], "mapped", [36646]], [[63897, 63897], "mapped", [34030]], [[63898, 63898], "mapped", [36899]], [[63899, 63899], "mapped", [37706]], [[63900, 63900], "mapped", [21015]], [[63901, 63901], "mapped", [21155]], [[63902, 63902], "mapped", [21693]], [[63903, 63903], "mapped", [28872]], [[63904, 63904], "mapped", [35010]], [[63905, 63905], "mapped", [35498]], [[63906, 63906], "mapped", [24265]], [[63907, 63907], "mapped", [24565]], [[63908, 63908], "mapped", [25467]], [[63909, 63909], "mapped", [27566]], [[63910, 63910], "mapped", [31806]], [[63911, 63911], "mapped", [29557]], [[63912, 63912], "mapped", [20196]], [[63913, 63913], "mapped", [22265]], [[63914, 63914], "mapped", [23527]], [[63915, 63915], "mapped", [23994]], [[63916, 63916], "mapped", [24604]], [[63917, 63917], "mapped", [29618]], [[63918, 63918], "mapped", [29801]], [[63919, 63919], "mapped", [32666]], [[63920, 63920], "mapped", [32838]], [[63921, 63921], "mapped", [37428]], [[63922, 63922], "mapped", [38646]], [[63923, 63923], "mapped", [38728]], [[63924, 63924], "mapped", [38936]], [[63925, 63925], "mapped", [20363]], [[63926, 63926], "mapped", [31150]], [[63927, 63927], "mapped", [37300]], [[63928, 63928], "mapped", [38584]], [[63929, 63929], "mapped", [24801]], [[63930, 63930], "mapped", [20102]], [[63931, 63931], "mapped", [20698]], [[63932, 63932], "mapped", [23534]], [[63933, 63933], "mapped", [23615]], [[63934, 63934], "mapped", [26009]], [[63935, 63935], "mapped", [27138]], [[63936, 63936], "mapped", [29134]], [[63937, 63937], "mapped", [30274]], [[63938, 63938], "mapped", [34044]], [[63939, 63939], "mapped", [36988]], [[63940, 63940], "mapped", [40845]], [[63941, 63941], "mapped", [26248]], [[63942, 63942], "mapped", [38446]], [[63943, 63943], "mapped", [21129]], [[63944, 63944], "mapped", [26491]], [[63945, 63945], "mapped", [26611]], [[63946, 63946], "mapped", [27969]], [[63947, 63947], "mapped", [28316]], [[63948, 63948], "mapped", [29705]], [[63949, 63949], "mapped", [30041]], [[63950, 63950], "mapped", [30827]], [[63951, 63951], "mapped", [32016]], [[63952, 63952], "mapped", [39006]], [[63953, 63953], "mapped", [20845]], [[63954, 63954], "mapped", [25134]], [[63955, 63955], "mapped", [38520]], [[63956, 63956], "mapped", [20523]], [[63957, 63957], "mapped", [23833]], [[63958, 63958], "mapped", [28138]], [[63959, 63959], "mapped", [36650]], [[63960, 63960], "mapped", [24459]], [[63961, 63961], "mapped", [24900]], [[63962, 63962], "mapped", [26647]], [[63963, 63963], "mapped", [29575]], [[63964, 63964], "mapped", [38534]], [[63965, 63965], "mapped", [21033]], [[63966, 63966], "mapped", [21519]], [[63967, 63967], "mapped", [23653]], [[63968, 63968], "mapped", [26131]], [[63969, 63969], "mapped", [26446]], [[63970, 63970], "mapped", [26792]], [[63971, 63971], "mapped", [27877]], [[63972, 63972], "mapped", [29702]], [[63973, 63973], "mapped", [30178]], [[63974, 63974], "mapped", [32633]], [[63975, 63975], "mapped", [35023]], [[63976, 63976], "mapped", [35041]], [[63977, 63977], "mapped", [37324]], [[63978, 63978], "mapped", [38626]], [[63979, 63979], "mapped", [21311]], [[63980, 63980], "mapped", [28346]], [[63981, 63981], "mapped", [21533]], [[63982, 63982], "mapped", [29136]], [[63983, 63983], "mapped", [29848]], [[63984, 63984], "mapped", [34298]], [[63985, 63985], "mapped", [38563]], [[63986, 63986], "mapped", [40023]], [[63987, 63987], "mapped", [40607]], [[63988, 63988], "mapped", [26519]], [[63989, 63989], "mapped", [28107]], [[63990, 63990], "mapped", [33256]], [[63991, 63991], "mapped", [31435]], [[63992, 63992], "mapped", [31520]], [[63993, 63993], "mapped", [31890]], [[63994, 63994], "mapped", [29376]], [[63995, 63995], "mapped", [28825]], [[63996, 63996], "mapped", [35672]], [[63997, 63997], "mapped", [20160]], [[63998, 63998], "mapped", [33590]], [[63999, 63999], "mapped", [21050]], [[64e3, 64e3], "mapped", [20999]], [[64001, 64001], "mapped", [24230]], [[64002, 64002], "mapped", [25299]], [[64003, 64003], "mapped", [31958]], [[64004, 64004], "mapped", [23429]], [[64005, 64005], "mapped", [27934]], [[64006, 64006], "mapped", [26292]], [[64007, 64007], "mapped", [36667]], [[64008, 64008], "mapped", [34892]], [[64009, 64009], "mapped", [38477]], [[64010, 64010], "mapped", [35211]], [[64011, 64011], "mapped", [24275]], [[64012, 64012], "mapped", [20800]], [[64013, 64013], "mapped", [21952]], [[64014, 64015], "valid"], [[64016, 64016], "mapped", [22618]], [[64017, 64017], "valid"], [[64018, 64018], "mapped", [26228]], [[64019, 64020], "valid"], [[64021, 64021], "mapped", [20958]], [[64022, 64022], "mapped", [29482]], [[64023, 64023], "mapped", [30410]], [[64024, 64024], "mapped", [31036]], [[64025, 64025], "mapped", [31070]], [[64026, 64026], "mapped", [31077]], [[64027, 64027], "mapped", [31119]], [[64028, 64028], "mapped", [38742]], [[64029, 64029], "mapped", [31934]], [[64030, 64030], "mapped", [32701]], [[64031, 64031], "valid"], [[64032, 64032], "mapped", [34322]], [[64033, 64033], "valid"], [[64034, 64034], "mapped", [35576]], [[64035, 64036], "valid"], [[64037, 64037], "mapped", [36920]], [[64038, 64038], "mapped", [37117]], [[64039, 64041], "valid"], [[64042, 64042], "mapped", [39151]], [[64043, 64043], "mapped", [39164]], [[64044, 64044], "mapped", [39208]], [[64045, 64045], "mapped", [40372]], [[64046, 64046], "mapped", [37086]], [[64047, 64047], "mapped", [38583]], [[64048, 64048], "mapped", [20398]], [[64049, 64049], "mapped", [20711]], [[64050, 64050], "mapped", [20813]], [[64051, 64051], "mapped", [21193]], [[64052, 64052], "mapped", [21220]], [[64053, 64053], "mapped", [21329]], [[64054, 64054], "mapped", [21917]], [[64055, 64055], "mapped", [22022]], [[64056, 64056], "mapped", [22120]], [[64057, 64057], "mapped", [22592]], [[64058, 64058], "mapped", [22696]], [[64059, 64059], "mapped", [23652]], [[64060, 64060], "mapped", [23662]], [[64061, 64061], "mapped", [24724]], [[64062, 64062], "mapped", [24936]], [[64063, 64063], "mapped", [24974]], [[64064, 64064], "mapped", [25074]], [[64065, 64065], "mapped", [25935]], [[64066, 64066], "mapped", [26082]], [[64067, 64067], "mapped", [26257]], [[64068, 64068], "mapped", [26757]], [[64069, 64069], "mapped", [28023]], [[64070, 64070], "mapped", [28186]], [[64071, 64071], "mapped", [28450]], [[64072, 64072], "mapped", [29038]], [[64073, 64073], "mapped", [29227]], [[64074, 64074], "mapped", [29730]], [[64075, 64075], "mapped", [30865]], [[64076, 64076], "mapped", [31038]], [[64077, 64077], "mapped", [31049]], [[64078, 64078], "mapped", [31048]], [[64079, 64079], "mapped", [31056]], [[64080, 64080], "mapped", [31062]], [[64081, 64081], "mapped", [31069]], [[64082, 64082], "mapped", [31117]], [[64083, 64083], "mapped", [31118]], [[64084, 64084], "mapped", [31296]], [[64085, 64085], "mapped", [31361]], [[64086, 64086], "mapped", [31680]], [[64087, 64087], "mapped", [32244]], [[64088, 64088], "mapped", [32265]], [[64089, 64089], "mapped", [32321]], [[64090, 64090], "mapped", [32626]], [[64091, 64091], "mapped", [32773]], [[64092, 64092], "mapped", [33261]], [[64093, 64094], "mapped", [33401]], [[64095, 64095], "mapped", [33879]], [[64096, 64096], "mapped", [35088]], [[64097, 64097], "mapped", [35222]], [[64098, 64098], "mapped", [35585]], [[64099, 64099], "mapped", [35641]], [[64100, 64100], "mapped", [36051]], [[64101, 64101], "mapped", [36104]], [[64102, 64102], "mapped", [36790]], [[64103, 64103], "mapped", [36920]], [[64104, 64104], "mapped", [38627]], [[64105, 64105], "mapped", [38911]], [[64106, 64106], "mapped", [38971]], [[64107, 64107], "mapped", [24693]], [[64108, 64108], "mapped", [148206]], [[64109, 64109], "mapped", [33304]], [[64110, 64111], "disallowed"], [[64112, 64112], "mapped", [20006]], [[64113, 64113], "mapped", [20917]], [[64114, 64114], "mapped", [20840]], [[64115, 64115], "mapped", [20352]], [[64116, 64116], "mapped", [20805]], [[64117, 64117], "mapped", [20864]], [[64118, 64118], "mapped", [21191]], [[64119, 64119], "mapped", [21242]], [[64120, 64120], "mapped", [21917]], [[64121, 64121], "mapped", [21845]], [[64122, 64122], "mapped", [21913]], [[64123, 64123], "mapped", [21986]], [[64124, 64124], "mapped", [22618]], [[64125, 64125], "mapped", [22707]], [[64126, 64126], "mapped", [22852]], [[64127, 64127], "mapped", [22868]], [[64128, 64128], "mapped", [23138]], [[64129, 64129], "mapped", [23336]], [[64130, 64130], "mapped", [24274]], [[64131, 64131], "mapped", [24281]], [[64132, 64132], "mapped", [24425]], [[64133, 64133], "mapped", [24493]], [[64134, 64134], "mapped", [24792]], [[64135, 64135], "mapped", [24910]], [[64136, 64136], "mapped", [24840]], [[64137, 64137], "mapped", [24974]], [[64138, 64138], "mapped", [24928]], [[64139, 64139], "mapped", [25074]], [[64140, 64140], "mapped", [25140]], [[64141, 64141], "mapped", [25540]], [[64142, 64142], "mapped", [25628]], [[64143, 64143], "mapped", [25682]], [[64144, 64144], "mapped", [25942]], [[64145, 64145], "mapped", [26228]], [[64146, 64146], "mapped", [26391]], [[64147, 64147], "mapped", [26395]], [[64148, 64148], "mapped", [26454]], [[64149, 64149], "mapped", [27513]], [[64150, 64150], "mapped", [27578]], [[64151, 64151], "mapped", [27969]], [[64152, 64152], "mapped", [28379]], [[64153, 64153], "mapped", [28363]], [[64154, 64154], "mapped", [28450]], [[64155, 64155], "mapped", [28702]], [[64156, 64156], "mapped", [29038]], [[64157, 64157], "mapped", [30631]], [[64158, 64158], "mapped", [29237]], [[64159, 64159], "mapped", [29359]], [[64160, 64160], "mapped", [29482]], [[64161, 64161], "mapped", [29809]], [[64162, 64162], "mapped", [29958]], [[64163, 64163], "mapped", [30011]], [[64164, 64164], "mapped", [30237]], [[64165, 64165], "mapped", [30239]], [[64166, 64166], "mapped", [30410]], [[64167, 64167], "mapped", [30427]], [[64168, 64168], "mapped", [30452]], [[64169, 64169], "mapped", [30538]], [[64170, 64170], "mapped", [30528]], [[64171, 64171], "mapped", [30924]], [[64172, 64172], "mapped", [31409]], [[64173, 64173], "mapped", [31680]], [[64174, 64174], "mapped", [31867]], [[64175, 64175], "mapped", [32091]], [[64176, 64176], "mapped", [32244]], [[64177, 64177], "mapped", [32574]], [[64178, 64178], "mapped", [32773]], [[64179, 64179], "mapped", [33618]], [[64180, 64180], "mapped", [33775]], [[64181, 64181], "mapped", [34681]], [[64182, 64182], "mapped", [35137]], [[64183, 64183], "mapped", [35206]], [[64184, 64184], "mapped", [35222]], [[64185, 64185], "mapped", [35519]], [[64186, 64186], "mapped", [35576]], [[64187, 64187], "mapped", [35531]], [[64188, 64188], "mapped", [35585]], [[64189, 64189], "mapped", [35582]], [[64190, 64190], "mapped", [35565]], [[64191, 64191], "mapped", [35641]], [[64192, 64192], "mapped", [35722]], [[64193, 64193], "mapped", [36104]], [[64194, 64194], "mapped", [36664]], [[64195, 64195], "mapped", [36978]], [[64196, 64196], "mapped", [37273]], [[64197, 64197], "mapped", [37494]], [[64198, 64198], "mapped", [38524]], [[64199, 64199], "mapped", [38627]], [[64200, 64200], "mapped", [38742]], [[64201, 64201], "mapped", [38875]], [[64202, 64202], "mapped", [38911]], [[64203, 64203], "mapped", [38923]], [[64204, 64204], "mapped", [38971]], [[64205, 64205], "mapped", [39698]], [[64206, 64206], "mapped", [40860]], [[64207, 64207], "mapped", [141386]], [[64208, 64208], "mapped", [141380]], [[64209, 64209], "mapped", [144341]], [[64210, 64210], "mapped", [15261]], [[64211, 64211], "mapped", [16408]], [[64212, 64212], "mapped", [16441]], [[64213, 64213], "mapped", [152137]], [[64214, 64214], "mapped", [154832]], [[64215, 64215], "mapped", [163539]], [[64216, 64216], "mapped", [40771]], [[64217, 64217], "mapped", [40846]], [[64218, 64255], "disallowed"], [[64256, 64256], "mapped", [102, 102]], [[64257, 64257], "mapped", [102, 105]], [[64258, 64258], "mapped", [102, 108]], [[64259, 64259], "mapped", [102, 102, 105]], [[64260, 64260], "mapped", [102, 102, 108]], [[64261, 64262], "mapped", [115, 116]], [[64263, 64274], "disallowed"], [[64275, 64275], "mapped", [1396, 1398]], [[64276, 64276], "mapped", [1396, 1381]], [[64277, 64277], "mapped", [1396, 1387]], [[64278, 64278], "mapped", [1406, 1398]], [[64279, 64279], "mapped", [1396, 1389]], [[64280, 64284], "disallowed"], [[64285, 64285], "mapped", [1497, 1460]], [[64286, 64286], "valid"], [[64287, 64287], "mapped", [1522, 1463]], [[64288, 64288], "mapped", [1506]], [[64289, 64289], "mapped", [1488]], [[64290, 64290], "mapped", [1491]], [[64291, 64291], "mapped", [1492]], [[64292, 64292], "mapped", [1499]], [[64293, 64293], "mapped", [1500]], [[64294, 64294], "mapped", [1501]], [[64295, 64295], "mapped", [1512]], [[64296, 64296], "mapped", [1514]], [[64297, 64297], "disallowed_STD3_mapped", [43]], [[64298, 64298], "mapped", [1513, 1473]], [[64299, 64299], "mapped", [1513, 1474]], [[64300, 64300], "mapped", [1513, 1468, 1473]], [[64301, 64301], "mapped", [1513, 1468, 1474]], [[64302, 64302], "mapped", [1488, 1463]], [[64303, 64303], "mapped", [1488, 1464]], [[64304, 64304], "mapped", [1488, 1468]], [[64305, 64305], "mapped", [1489, 1468]], [[64306, 64306], "mapped", [1490, 1468]], [[64307, 64307], "mapped", [1491, 1468]], [[64308, 64308], "mapped", [1492, 1468]], [[64309, 64309], "mapped", [1493, 1468]], [[64310, 64310], "mapped", [1494, 1468]], [[64311, 64311], "disallowed"], [[64312, 64312], "mapped", [1496, 1468]], [[64313, 64313], "mapped", [1497, 1468]], [[64314, 64314], "mapped", [1498, 1468]], [[64315, 64315], "mapped", [1499, 1468]], [[64316, 64316], "mapped", [1500, 1468]], [[64317, 64317], "disallowed"], [[64318, 64318], "mapped", [1502, 1468]], [[64319, 64319], "disallowed"], [[64320, 64320], "mapped", [1504, 1468]], [[64321, 64321], "mapped", [1505, 1468]], [[64322, 64322], "disallowed"], [[64323, 64323], "mapped", [1507, 1468]], [[64324, 64324], "mapped", [1508, 1468]], [[64325, 64325], "disallowed"], [[64326, 64326], "mapped", [1510, 1468]], [[64327, 64327], "mapped", [1511, 1468]], [[64328, 64328], "mapped", [1512, 1468]], [[64329, 64329], "mapped", [1513, 1468]], [[64330, 64330], "mapped", [1514, 1468]], [[64331, 64331], "mapped", [1493, 1465]], [[64332, 64332], "mapped", [1489, 1471]], [[64333, 64333], "mapped", [1499, 1471]], [[64334, 64334], "mapped", [1508, 1471]], [[64335, 64335], "mapped", [1488, 1500]], [[64336, 64337], "mapped", [1649]], [[64338, 64341], "mapped", [1659]], [[64342, 64345], "mapped", [1662]], [[64346, 64349], "mapped", [1664]], [[64350, 64353], "mapped", [1658]], [[64354, 64357], "mapped", [1663]], [[64358, 64361], "mapped", [1657]], [[64362, 64365], "mapped", [1700]], [[64366, 64369], "mapped", [1702]], [[64370, 64373], "mapped", [1668]], [[64374, 64377], "mapped", [1667]], [[64378, 64381], "mapped", [1670]], [[64382, 64385], "mapped", [1671]], [[64386, 64387], "mapped", [1677]], [[64388, 64389], "mapped", [1676]], [[64390, 64391], "mapped", [1678]], [[64392, 64393], "mapped", [1672]], [[64394, 64395], "mapped", [1688]], [[64396, 64397], "mapped", [1681]], [[64398, 64401], "mapped", [1705]], [[64402, 64405], "mapped", [1711]], [[64406, 64409], "mapped", [1715]], [[64410, 64413], "mapped", [1713]], [[64414, 64415], "mapped", [1722]], [[64416, 64419], "mapped", [1723]], [[64420, 64421], "mapped", [1728]], [[64422, 64425], "mapped", [1729]], [[64426, 64429], "mapped", [1726]], [[64430, 64431], "mapped", [1746]], [[64432, 64433], "mapped", [1747]], [[64434, 64449], "valid", [], "NV8"], [[64450, 64466], "disallowed"], [[64467, 64470], "mapped", [1709]], [[64471, 64472], "mapped", [1735]], [[64473, 64474], "mapped", [1734]], [[64475, 64476], "mapped", [1736]], [[64477, 64477], "mapped", [1735, 1652]], [[64478, 64479], "mapped", [1739]], [[64480, 64481], "mapped", [1733]], [[64482, 64483], "mapped", [1737]], [[64484, 64487], "mapped", [1744]], [[64488, 64489], "mapped", [1609]], [[64490, 64491], "mapped", [1574, 1575]], [[64492, 64493], "mapped", [1574, 1749]], [[64494, 64495], "mapped", [1574, 1608]], [[64496, 64497], "mapped", [1574, 1735]], [[64498, 64499], "mapped", [1574, 1734]], [[64500, 64501], "mapped", [1574, 1736]], [[64502, 64504], "mapped", [1574, 1744]], [[64505, 64507], "mapped", [1574, 1609]], [[64508, 64511], "mapped", [1740]], [[64512, 64512], "mapped", [1574, 1580]], [[64513, 64513], "mapped", [1574, 1581]], [[64514, 64514], "mapped", [1574, 1605]], [[64515, 64515], "mapped", [1574, 1609]], [[64516, 64516], "mapped", [1574, 1610]], [[64517, 64517], "mapped", [1576, 1580]], [[64518, 64518], "mapped", [1576, 1581]], [[64519, 64519], "mapped", [1576, 1582]], [[64520, 64520], "mapped", [1576, 1605]], [[64521, 64521], "mapped", [1576, 1609]], [[64522, 64522], "mapped", [1576, 1610]], [[64523, 64523], "mapped", [1578, 1580]], [[64524, 64524], "mapped", [1578, 1581]], [[64525, 64525], "mapped", [1578, 1582]], [[64526, 64526], "mapped", [1578, 1605]], [[64527, 64527], "mapped", [1578, 1609]], [[64528, 64528], "mapped", [1578, 1610]], [[64529, 64529], "mapped", [1579, 1580]], [[64530, 64530], "mapped", [1579, 1605]], [[64531, 64531], "mapped", [1579, 1609]], [[64532, 64532], "mapped", [1579, 1610]], [[64533, 64533], "mapped", [1580, 1581]], [[64534, 64534], "mapped", [1580, 1605]], [[64535, 64535], "mapped", [1581, 1580]], [[64536, 64536], "mapped", [1581, 1605]], [[64537, 64537], "mapped", [1582, 1580]], [[64538, 64538], "mapped", [1582, 1581]], [[64539, 64539], "mapped", [1582, 1605]], [[64540, 64540], "mapped", [1587, 1580]], [[64541, 64541], "mapped", [1587, 1581]], [[64542, 64542], "mapped", [1587, 1582]], [[64543, 64543], "mapped", [1587, 1605]], [[64544, 64544], "mapped", [1589, 1581]], [[64545, 64545], "mapped", [1589, 1605]], [[64546, 64546], "mapped", [1590, 1580]], [[64547, 64547], "mapped", [1590, 1581]], [[64548, 64548], "mapped", [1590, 1582]], [[64549, 64549], "mapped", [1590, 1605]], [[64550, 64550], "mapped", [1591, 1581]], [[64551, 64551], "mapped", [1591, 1605]], [[64552, 64552], "mapped", [1592, 1605]], [[64553, 64553], "mapped", [1593, 1580]], [[64554, 64554], "mapped", [1593, 1605]], [[64555, 64555], "mapped", [1594, 1580]], [[64556, 64556], "mapped", [1594, 1605]], [[64557, 64557], "mapped", [1601, 1580]], [[64558, 64558], "mapped", [1601, 1581]], [[64559, 64559], "mapped", [1601, 1582]], [[64560, 64560], "mapped", [1601, 1605]], [[64561, 64561], "mapped", [1601, 1609]], [[64562, 64562], "mapped", [1601, 1610]], [[64563, 64563], "mapped", [1602, 1581]], [[64564, 64564], "mapped", [1602, 1605]], [[64565, 64565], "mapped", [1602, 1609]], [[64566, 64566], "mapped", [1602, 1610]], [[64567, 64567], "mapped", [1603, 1575]], [[64568, 64568], "mapped", [1603, 1580]], [[64569, 64569], "mapped", [1603, 1581]], [[64570, 64570], "mapped", [1603, 1582]], [[64571, 64571], "mapped", [1603, 1604]], [[64572, 64572], "mapped", [1603, 1605]], [[64573, 64573], "mapped", [1603, 1609]], [[64574, 64574], "mapped", [1603, 1610]], [[64575, 64575], "mapped", [1604, 1580]], [[64576, 64576], "mapped", [1604, 1581]], [[64577, 64577], "mapped", [1604, 1582]], [[64578, 64578], "mapped", [1604, 1605]], [[64579, 64579], "mapped", [1604, 1609]], [[64580, 64580], "mapped", [1604, 1610]], [[64581, 64581], "mapped", [1605, 1580]], [[64582, 64582], "mapped", [1605, 1581]], [[64583, 64583], "mapped", [1605, 1582]], [[64584, 64584], "mapped", [1605, 1605]], [[64585, 64585], "mapped", [1605, 1609]], [[64586, 64586], "mapped", [1605, 1610]], [[64587, 64587], "mapped", [1606, 1580]], [[64588, 64588], "mapped", [1606, 1581]], [[64589, 64589], "mapped", [1606, 1582]], [[64590, 64590], "mapped", [1606, 1605]], [[64591, 64591], "mapped", [1606, 1609]], [[64592, 64592], "mapped", [1606, 1610]], [[64593, 64593], "mapped", [1607, 1580]], [[64594, 64594], "mapped", [1607, 1605]], [[64595, 64595], "mapped", [1607, 1609]], [[64596, 64596], "mapped", [1607, 1610]], [[64597, 64597], "mapped", [1610, 1580]], [[64598, 64598], "mapped", [1610, 1581]], [[64599, 64599], "mapped", [1610, 1582]], [[64600, 64600], "mapped", [1610, 1605]], [[64601, 64601], "mapped", [1610, 1609]], [[64602, 64602], "mapped", [1610, 1610]], [[64603, 64603], "mapped", [1584, 1648]], [[64604, 64604], "mapped", [1585, 1648]], [[64605, 64605], "mapped", [1609, 1648]], [[64606, 64606], "disallowed_STD3_mapped", [32, 1612, 1617]], [[64607, 64607], "disallowed_STD3_mapped", [32, 1613, 1617]], [[64608, 64608], "disallowed_STD3_mapped", [32, 1614, 1617]], [[64609, 64609], "disallowed_STD3_mapped", [32, 1615, 1617]], [[64610, 64610], "disallowed_STD3_mapped", [32, 1616, 1617]], [[64611, 64611], "disallowed_STD3_mapped", [32, 1617, 1648]], [[64612, 64612], "mapped", [1574, 1585]], [[64613, 64613], "mapped", [1574, 1586]], [[64614, 64614], "mapped", [1574, 1605]], [[64615, 64615], "mapped", [1574, 1606]], [[64616, 64616], "mapped", [1574, 1609]], [[64617, 64617], "mapped", [1574, 1610]], [[64618, 64618], "mapped", [1576, 1585]], [[64619, 64619], "mapped", [1576, 1586]], [[64620, 64620], "mapped", [1576, 1605]], [[64621, 64621], "mapped", [1576, 1606]], [[64622, 64622], "mapped", [1576, 1609]], [[64623, 64623], "mapped", [1576, 1610]], [[64624, 64624], "mapped", [1578, 1585]], [[64625, 64625], "mapped", [1578, 1586]], [[64626, 64626], "mapped", [1578, 1605]], [[64627, 64627], "mapped", [1578, 1606]], [[64628, 64628], "mapped", [1578, 1609]], [[64629, 64629], "mapped", [1578, 1610]], [[64630, 64630], "mapped", [1579, 1585]], [[64631, 64631], "mapped", [1579, 1586]], [[64632, 64632], "mapped", [1579, 1605]], [[64633, 64633], "mapped", [1579, 1606]], [[64634, 64634], "mapped", [1579, 1609]], [[64635, 64635], "mapped", [1579, 1610]], [[64636, 64636], "mapped", [1601, 1609]], [[64637, 64637], "mapped", [1601, 1610]], [[64638, 64638], "mapped", [1602, 1609]], [[64639, 64639], "mapped", [1602, 1610]], [[64640, 64640], "mapped", [1603, 1575]], [[64641, 64641], "mapped", [1603, 1604]], [[64642, 64642], "mapped", [1603, 1605]], [[64643, 64643], "mapped", [1603, 1609]], [[64644, 64644], "mapped", [1603, 1610]], [[64645, 64645], "mapped", [1604, 1605]], [[64646, 64646], "mapped", [1604, 1609]], [[64647, 64647], "mapped", [1604, 1610]], [[64648, 64648], "mapped", [1605, 1575]], [[64649, 64649], "mapped", [1605, 1605]], [[64650, 64650], "mapped", [1606, 1585]], [[64651, 64651], "mapped", [1606, 1586]], [[64652, 64652], "mapped", [1606, 1605]], [[64653, 64653], "mapped", [1606, 1606]], [[64654, 64654], "mapped", [1606, 1609]], [[64655, 64655], "mapped", [1606, 1610]], [[64656, 64656], "mapped", [1609, 1648]], [[64657, 64657], "mapped", [1610, 1585]], [[64658, 64658], "mapped", [1610, 1586]], [[64659, 64659], "mapped", [1610, 1605]], [[64660, 64660], "mapped", [1610, 1606]], [[64661, 64661], "mapped", [1610, 1609]], [[64662, 64662], "mapped", [1610, 1610]], [[64663, 64663], "mapped", [1574, 1580]], [[64664, 64664], "mapped", [1574, 1581]], [[64665, 64665], "mapped", [1574, 1582]], [[64666, 64666], "mapped", [1574, 1605]], [[64667, 64667], "mapped", [1574, 1607]], [[64668, 64668], "mapped", [1576, 1580]], [[64669, 64669], "mapped", [1576, 1581]], [[64670, 64670], "mapped", [1576, 1582]], [[64671, 64671], "mapped", [1576, 1605]], [[64672, 64672], "mapped", [1576, 1607]], [[64673, 64673], "mapped", [1578, 1580]], [[64674, 64674], "mapped", [1578, 1581]], [[64675, 64675], "mapped", [1578, 1582]], [[64676, 64676], "mapped", [1578, 1605]], [[64677, 64677], "mapped", [1578, 1607]], [[64678, 64678], "mapped", [1579, 1605]], [[64679, 64679], "mapped", [1580, 1581]], [[64680, 64680], "mapped", [1580, 1605]], [[64681, 64681], "mapped", [1581, 1580]], [[64682, 64682], "mapped", [1581, 1605]], [[64683, 64683], "mapped", [1582, 1580]], [[64684, 64684], "mapped", [1582, 1605]], [[64685, 64685], "mapped", [1587, 1580]], [[64686, 64686], "mapped", [1587, 1581]], [[64687, 64687], "mapped", [1587, 1582]], [[64688, 64688], "mapped", [1587, 1605]], [[64689, 64689], "mapped", [1589, 1581]], [[64690, 64690], "mapped", [1589, 1582]], [[64691, 64691], "mapped", [1589, 1605]], [[64692, 64692], "mapped", [1590, 1580]], [[64693, 64693], "mapped", [1590, 1581]], [[64694, 64694], "mapped", [1590, 1582]], [[64695, 64695], "mapped", [1590, 1605]], [[64696, 64696], "mapped", [1591, 1581]], [[64697, 64697], "mapped", [1592, 1605]], [[64698, 64698], "mapped", [1593, 1580]], [[64699, 64699], "mapped", [1593, 1605]], [[64700, 64700], "mapped", [1594, 1580]], [[64701, 64701], "mapped", [1594, 1605]], [[64702, 64702], "mapped", [1601, 1580]], [[64703, 64703], "mapped", [1601, 1581]], [[64704, 64704], "mapped", [1601, 1582]], [[64705, 64705], "mapped", [1601, 1605]], [[64706, 64706], "mapped", [1602, 1581]], [[64707, 64707], "mapped", [1602, 1605]], [[64708, 64708], "mapped", [1603, 1580]], [[64709, 64709], "mapped", [1603, 1581]], [[64710, 64710], "mapped", [1603, 1582]], [[64711, 64711], "mapped", [1603, 1604]], [[64712, 64712], "mapped", [1603, 1605]], [[64713, 64713], "mapped", [1604, 1580]], [[64714, 64714], "mapped", [1604, 1581]], [[64715, 64715], "mapped", [1604, 1582]], [[64716, 64716], "mapped", [1604, 1605]], [[64717, 64717], "mapped", [1604, 1607]], [[64718, 64718], "mapped", [1605, 1580]], [[64719, 64719], "mapped", [1605, 1581]], [[64720, 64720], "mapped", [1605, 1582]], [[64721, 64721], "mapped", [1605, 1605]], [[64722, 64722], "mapped", [1606, 1580]], [[64723, 64723], "mapped", [1606, 1581]], [[64724, 64724], "mapped", [1606, 1582]], [[64725, 64725], "mapped", [1606, 1605]], [[64726, 64726], "mapped", [1606, 1607]], [[64727, 64727], "mapped", [1607, 1580]], [[64728, 64728], "mapped", [1607, 1605]], [[64729, 64729], "mapped", [1607, 1648]], [[64730, 64730], "mapped", [1610, 1580]], [[64731, 64731], "mapped", [1610, 1581]], [[64732, 64732], "mapped", [1610, 1582]], [[64733, 64733], "mapped", [1610, 1605]], [[64734, 64734], "mapped", [1610, 1607]], [[64735, 64735], "mapped", [1574, 1605]], [[64736, 64736], "mapped", [1574, 1607]], [[64737, 64737], "mapped", [1576, 1605]], [[64738, 64738], "mapped", [1576, 1607]], [[64739, 64739], "mapped", [1578, 1605]], [[64740, 64740], "mapped", [1578, 1607]], [[64741, 64741], "mapped", [1579, 1605]], [[64742, 64742], "mapped", [1579, 1607]], [[64743, 64743], "mapped", [1587, 1605]], [[64744, 64744], "mapped", [1587, 1607]], [[64745, 64745], "mapped", [1588, 1605]], [[64746, 64746], "mapped", [1588, 1607]], [[64747, 64747], "mapped", [1603, 1604]], [[64748, 64748], "mapped", [1603, 1605]], [[64749, 64749], "mapped", [1604, 1605]], [[64750, 64750], "mapped", [1606, 1605]], [[64751, 64751], "mapped", [1606, 1607]], [[64752, 64752], "mapped", [1610, 1605]], [[64753, 64753], "mapped", [1610, 1607]], [[64754, 64754], "mapped", [1600, 1614, 1617]], [[64755, 64755], "mapped", [1600, 1615, 1617]], [[64756, 64756], "mapped", [1600, 1616, 1617]], [[64757, 64757], "mapped", [1591, 1609]], [[64758, 64758], "mapped", [1591, 1610]], [[64759, 64759], "mapped", [1593, 1609]], [[64760, 64760], "mapped", [1593, 1610]], [[64761, 64761], "mapped", [1594, 1609]], [[64762, 64762], "mapped", [1594, 1610]], [[64763, 64763], "mapped", [1587, 1609]], [[64764, 64764], "mapped", [1587, 1610]], [[64765, 64765], "mapped", [1588, 1609]], [[64766, 64766], "mapped", [1588, 1610]], [[64767, 64767], "mapped", [1581, 1609]], [[64768, 64768], "mapped", [1581, 1610]], [[64769, 64769], "mapped", [1580, 1609]], [[64770, 64770], "mapped", [1580, 1610]], [[64771, 64771], "mapped", [1582, 1609]], [[64772, 64772], "mapped", [1582, 1610]], [[64773, 64773], "mapped", [1589, 1609]], [[64774, 64774], "mapped", [1589, 1610]], [[64775, 64775], "mapped", [1590, 1609]], [[64776, 64776], "mapped", [1590, 1610]], [[64777, 64777], "mapped", [1588, 1580]], [[64778, 64778], "mapped", [1588, 1581]], [[64779, 64779], "mapped", [1588, 1582]], [[64780, 64780], "mapped", [1588, 1605]], [[64781, 64781], "mapped", [1588, 1585]], [[64782, 64782], "mapped", [1587, 1585]], [[64783, 64783], "mapped", [1589, 1585]], [[64784, 64784], "mapped", [1590, 1585]], [[64785, 64785], "mapped", [1591, 1609]], [[64786, 64786], "mapped", [1591, 1610]], [[64787, 64787], "mapped", [1593, 1609]], [[64788, 64788], "mapped", [1593, 1610]], [[64789, 64789], "mapped", [1594, 1609]], [[64790, 64790], "mapped", [1594, 1610]], [[64791, 64791], "mapped", [1587, 1609]], [[64792, 64792], "mapped", [1587, 1610]], [[64793, 64793], "mapped", [1588, 1609]], [[64794, 64794], "mapped", [1588, 1610]], [[64795, 64795], "mapped", [1581, 1609]], [[64796, 64796], "mapped", [1581, 1610]], [[64797, 64797], "mapped", [1580, 1609]], [[64798, 64798], "mapped", [1580, 1610]], [[64799, 64799], "mapped", [1582, 1609]], [[64800, 64800], "mapped", [1582, 1610]], [[64801, 64801], "mapped", [1589, 1609]], [[64802, 64802], "mapped", [1589, 1610]], [[64803, 64803], "mapped", [1590, 1609]], [[64804, 64804], "mapped", [1590, 1610]], [[64805, 64805], "mapped", [1588, 1580]], [[64806, 64806], "mapped", [1588, 1581]], [[64807, 64807], "mapped", [1588, 1582]], [[64808, 64808], "mapped", [1588, 1605]], [[64809, 64809], "mapped", [1588, 1585]], [[64810, 64810], "mapped", [1587, 1585]], [[64811, 64811], "mapped", [1589, 1585]], [[64812, 64812], "mapped", [1590, 1585]], [[64813, 64813], "mapped", [1588, 1580]], [[64814, 64814], "mapped", [1588, 1581]], [[64815, 64815], "mapped", [1588, 1582]], [[64816, 64816], "mapped", [1588, 1605]], [[64817, 64817], "mapped", [1587, 1607]], [[64818, 64818], "mapped", [1588, 1607]], [[64819, 64819], "mapped", [1591, 1605]], [[64820, 64820], "mapped", [1587, 1580]], [[64821, 64821], "mapped", [1587, 1581]], [[64822, 64822], "mapped", [1587, 1582]], [[64823, 64823], "mapped", [1588, 1580]], [[64824, 64824], "mapped", [1588, 1581]], [[64825, 64825], "mapped", [1588, 1582]], [[64826, 64826], "mapped", [1591, 1605]], [[64827, 64827], "mapped", [1592, 1605]], [[64828, 64829], "mapped", [1575, 1611]], [[64830, 64831], "valid", [], "NV8"], [[64832, 64847], "disallowed"], [[64848, 64848], "mapped", [1578, 1580, 1605]], [[64849, 64850], "mapped", [1578, 1581, 1580]], [[64851, 64851], "mapped", [1578, 1581, 1605]], [[64852, 64852], "mapped", [1578, 1582, 1605]], [[64853, 64853], "mapped", [1578, 1605, 1580]], [[64854, 64854], "mapped", [1578, 1605, 1581]], [[64855, 64855], "mapped", [1578, 1605, 1582]], [[64856, 64857], "mapped", [1580, 1605, 1581]], [[64858, 64858], "mapped", [1581, 1605, 1610]], [[64859, 64859], "mapped", [1581, 1605, 1609]], [[64860, 64860], "mapped", [1587, 1581, 1580]], [[64861, 64861], "mapped", [1587, 1580, 1581]], [[64862, 64862], "mapped", [1587, 1580, 1609]], [[64863, 64864], "mapped", [1587, 1605, 1581]], [[64865, 64865], "mapped", [1587, 1605, 1580]], [[64866, 64867], "mapped", [1587, 1605, 1605]], [[64868, 64869], "mapped", [1589, 1581, 1581]], [[64870, 64870], "mapped", [1589, 1605, 1605]], [[64871, 64872], "mapped", [1588, 1581, 1605]], [[64873, 64873], "mapped", [1588, 1580, 1610]], [[64874, 64875], "mapped", [1588, 1605, 1582]], [[64876, 64877], "mapped", [1588, 1605, 1605]], [[64878, 64878], "mapped", [1590, 1581, 1609]], [[64879, 64880], "mapped", [1590, 1582, 1605]], [[64881, 64882], "mapped", [1591, 1605, 1581]], [[64883, 64883], "mapped", [1591, 1605, 1605]], [[64884, 64884], "mapped", [1591, 1605, 1610]], [[64885, 64885], "mapped", [1593, 1580, 1605]], [[64886, 64887], "mapped", [1593, 1605, 1605]], [[64888, 64888], "mapped", [1593, 1605, 1609]], [[64889, 64889], "mapped", [1594, 1605, 1605]], [[64890, 64890], "mapped", [1594, 1605, 1610]], [[64891, 64891], "mapped", [1594, 1605, 1609]], [[64892, 64893], "mapped", [1601, 1582, 1605]], [[64894, 64894], "mapped", [1602, 1605, 1581]], [[64895, 64895], "mapped", [1602, 1605, 1605]], [[64896, 64896], "mapped", [1604, 1581, 1605]], [[64897, 64897], "mapped", [1604, 1581, 1610]], [[64898, 64898], "mapped", [1604, 1581, 1609]], [[64899, 64900], "mapped", [1604, 1580, 1580]], [[64901, 64902], "mapped", [1604, 1582, 1605]], [[64903, 64904], "mapped", [1604, 1605, 1581]], [[64905, 64905], "mapped", [1605, 1581, 1580]], [[64906, 64906], "mapped", [1605, 1581, 1605]], [[64907, 64907], "mapped", [1605, 1581, 1610]], [[64908, 64908], "mapped", [1605, 1580, 1581]], [[64909, 64909], "mapped", [1605, 1580, 1605]], [[64910, 64910], "mapped", [1605, 1582, 1580]], [[64911, 64911], "mapped", [1605, 1582, 1605]], [[64912, 64913], "disallowed"], [[64914, 64914], "mapped", [1605, 1580, 1582]], [[64915, 64915], "mapped", [1607, 1605, 1580]], [[64916, 64916], "mapped", [1607, 1605, 1605]], [[64917, 64917], "mapped", [1606, 1581, 1605]], [[64918, 64918], "mapped", [1606, 1581, 1609]], [[64919, 64920], "mapped", [1606, 1580, 1605]], [[64921, 64921], "mapped", [1606, 1580, 1609]], [[64922, 64922], "mapped", [1606, 1605, 1610]], [[64923, 64923], "mapped", [1606, 1605, 1609]], [[64924, 64925], "mapped", [1610, 1605, 1605]], [[64926, 64926], "mapped", [1576, 1582, 1610]], [[64927, 64927], "mapped", [1578, 1580, 1610]], [[64928, 64928], "mapped", [1578, 1580, 1609]], [[64929, 64929], "mapped", [1578, 1582, 1610]], [[64930, 64930], "mapped", [1578, 1582, 1609]], [[64931, 64931], "mapped", [1578, 1605, 1610]], [[64932, 64932], "mapped", [1578, 1605, 1609]], [[64933, 64933], "mapped", [1580, 1605, 1610]], [[64934, 64934], "mapped", [1580, 1581, 1609]], [[64935, 64935], "mapped", [1580, 1605, 1609]], [[64936, 64936], "mapped", [1587, 1582, 1609]], [[64937, 64937], "mapped", [1589, 1581, 1610]], [[64938, 64938], "mapped", [1588, 1581, 1610]], [[64939, 64939], "mapped", [1590, 1581, 1610]], [[64940, 64940], "mapped", [1604, 1580, 1610]], [[64941, 64941], "mapped", [1604, 1605, 1610]], [[64942, 64942], "mapped", [1610, 1581, 1610]], [[64943, 64943], "mapped", [1610, 1580, 1610]], [[64944, 64944], "mapped", [1610, 1605, 1610]], [[64945, 64945], "mapped", [1605, 1605, 1610]], [[64946, 64946], "mapped", [1602, 1605, 1610]], [[64947, 64947], "mapped", [1606, 1581, 1610]], [[64948, 64948], "mapped", [1602, 1605, 1581]], [[64949, 64949], "mapped", [1604, 1581, 1605]], [[64950, 64950], "mapped", [1593, 1605, 1610]], [[64951, 64951], "mapped", [1603, 1605, 1610]], [[64952, 64952], "mapped", [1606, 1580, 1581]], [[64953, 64953], "mapped", [1605, 1582, 1610]], [[64954, 64954], "mapped", [1604, 1580, 1605]], [[64955, 64955], "mapped", [1603, 1605, 1605]], [[64956, 64956], "mapped", [1604, 1580, 1605]], [[64957, 64957], "mapped", [1606, 1580, 1581]], [[64958, 64958], "mapped", [1580, 1581, 1610]], [[64959, 64959], "mapped", [1581, 1580, 1610]], [[64960, 64960], "mapped", [1605, 1580, 1610]], [[64961, 64961], "mapped", [1601, 1605, 1610]], [[64962, 64962], "mapped", [1576, 1581, 1610]], [[64963, 64963], "mapped", [1603, 1605, 1605]], [[64964, 64964], "mapped", [1593, 1580, 1605]], [[64965, 64965], "mapped", [1589, 1605, 1605]], [[64966, 64966], "mapped", [1587, 1582, 1610]], [[64967, 64967], "mapped", [1606, 1580, 1610]], [[64968, 64975], "disallowed"], [[64976, 65007], "disallowed"], [[65008, 65008], "mapped", [1589, 1604, 1746]], [[65009, 65009], "mapped", [1602, 1604, 1746]], [[65010, 65010], "mapped", [1575, 1604, 1604, 1607]], [[65011, 65011], "mapped", [1575, 1603, 1576, 1585]], [[65012, 65012], "mapped", [1605, 1581, 1605, 1583]], [[65013, 65013], "mapped", [1589, 1604, 1593, 1605]], [[65014, 65014], "mapped", [1585, 1587, 1608, 1604]], [[65015, 65015], "mapped", [1593, 1604, 1610, 1607]], [[65016, 65016], "mapped", [1608, 1587, 1604, 1605]], [[65017, 65017], "mapped", [1589, 1604, 1609]], [[65018, 65018], "disallowed_STD3_mapped", [1589, 1604, 1609, 32, 1575, 1604, 1604, 1607, 32, 1593, 1604, 1610, 1607, 32, 1608, 1587, 1604, 1605]], [[65019, 65019], "disallowed_STD3_mapped", [1580, 1604, 32, 1580, 1604, 1575, 1604, 1607]], [[65020, 65020], "mapped", [1585, 1740, 1575, 1604]], [[65021, 65021], "valid", [], "NV8"], [[65022, 65023], "disallowed"], [[65024, 65039], "ignored"], [[65040, 65040], "disallowed_STD3_mapped", [44]], [[65041, 65041], "mapped", [12289]], [[65042, 65042], "disallowed"], [[65043, 65043], "disallowed_STD3_mapped", [58]], [[65044, 65044], "disallowed_STD3_mapped", [59]], [[65045, 65045], "disallowed_STD3_mapped", [33]], [[65046, 65046], "disallowed_STD3_mapped", [63]], [[65047, 65047], "mapped", [12310]], [[65048, 65048], "mapped", [12311]], [[65049, 65049], "disallowed"], [[65050, 65055], "disallowed"], [[65056, 65059], "valid"], [[65060, 65062], "valid"], [[65063, 65069], "valid"], [[65070, 65071], "valid"], [[65072, 65072], "disallowed"], [[65073, 65073], "mapped", [8212]], [[65074, 65074], "mapped", [8211]], [[65075, 65076], "disallowed_STD3_mapped", [95]], [[65077, 65077], "disallowed_STD3_mapped", [40]], [[65078, 65078], "disallowed_STD3_mapped", [41]], [[65079, 65079], "disallowed_STD3_mapped", [123]], [[65080, 65080], "disallowed_STD3_mapped", [125]], [[65081, 65081], "mapped", [12308]], [[65082, 65082], "mapped", [12309]], [[65083, 65083], "mapped", [12304]], [[65084, 65084], "mapped", [12305]], [[65085, 65085], "mapped", [12298]], [[65086, 65086], "mapped", [12299]], [[65087, 65087], "mapped", [12296]], [[65088, 65088], "mapped", [12297]], [[65089, 65089], "mapped", [12300]], [[65090, 65090], "mapped", [12301]], [[65091, 65091], "mapped", [12302]], [[65092, 65092], "mapped", [12303]], [[65093, 65094], "valid", [], "NV8"], [[65095, 65095], "disallowed_STD3_mapped", [91]], [[65096, 65096], "disallowed_STD3_mapped", [93]], [[65097, 65100], "disallowed_STD3_mapped", [32, 773]], [[65101, 65103], "disallowed_STD3_mapped", [95]], [[65104, 65104], "disallowed_STD3_mapped", [44]], [[65105, 65105], "mapped", [12289]], [[65106, 65106], "disallowed"], [[65107, 65107], "disallowed"], [[65108, 65108], "disallowed_STD3_mapped", [59]], [[65109, 65109], "disallowed_STD3_mapped", [58]], [[65110, 65110], "disallowed_STD3_mapped", [63]], [[65111, 65111], "disallowed_STD3_mapped", [33]], [[65112, 65112], "mapped", [8212]], [[65113, 65113], "disallowed_STD3_mapped", [40]], [[65114, 65114], "disallowed_STD3_mapped", [41]], [[65115, 65115], "disallowed_STD3_mapped", [123]], [[65116, 65116], "disallowed_STD3_mapped", [125]], [[65117, 65117], "mapped", [12308]], [[65118, 65118], "mapped", [12309]], [[65119, 65119], "disallowed_STD3_mapped", [35]], [[65120, 65120], "disallowed_STD3_mapped", [38]], [[65121, 65121], "disallowed_STD3_mapped", [42]], [[65122, 65122], "disallowed_STD3_mapped", [43]], [[65123, 65123], "mapped", [45]], [[65124, 65124], "disallowed_STD3_mapped", [60]], [[65125, 65125], "disallowed_STD3_mapped", [62]], [[65126, 65126], "disallowed_STD3_mapped", [61]], [[65127, 65127], "disallowed"], [[65128, 65128], "disallowed_STD3_mapped", [92]], [[65129, 65129], "disallowed_STD3_mapped", [36]], [[65130, 65130], "disallowed_STD3_mapped", [37]], [[65131, 65131], "disallowed_STD3_mapped", [64]], [[65132, 65135], "disallowed"], [[65136, 65136], "disallowed_STD3_mapped", [32, 1611]], [[65137, 65137], "mapped", [1600, 1611]], [[65138, 65138], "disallowed_STD3_mapped", [32, 1612]], [[65139, 65139], "valid"], [[65140, 65140], "disallowed_STD3_mapped", [32, 1613]], [[65141, 65141], "disallowed"], [[65142, 65142], "disallowed_STD3_mapped", [32, 1614]], [[65143, 65143], "mapped", [1600, 1614]], [[65144, 65144], "disallowed_STD3_mapped", [32, 1615]], [[65145, 65145], "mapped", [1600, 1615]], [[65146, 65146], "disallowed_STD3_mapped", [32, 1616]], [[65147, 65147], "mapped", [1600, 1616]], [[65148, 65148], "disallowed_STD3_mapped", [32, 1617]], [[65149, 65149], "mapped", [1600, 1617]], [[65150, 65150], "disallowed_STD3_mapped", [32, 1618]], [[65151, 65151], "mapped", [1600, 1618]], [[65152, 65152], "mapped", [1569]], [[65153, 65154], "mapped", [1570]], [[65155, 65156], "mapped", [1571]], [[65157, 65158], "mapped", [1572]], [[65159, 65160], "mapped", [1573]], [[65161, 65164], "mapped", [1574]], [[65165, 65166], "mapped", [1575]], [[65167, 65170], "mapped", [1576]], [[65171, 65172], "mapped", [1577]], [[65173, 65176], "mapped", [1578]], [[65177, 65180], "mapped", [1579]], [[65181, 65184], "mapped", [1580]], [[65185, 65188], "mapped", [1581]], [[65189, 65192], "mapped", [1582]], [[65193, 65194], "mapped", [1583]], [[65195, 65196], "mapped", [1584]], [[65197, 65198], "mapped", [1585]], [[65199, 65200], "mapped", [1586]], [[65201, 65204], "mapped", [1587]], [[65205, 65208], "mapped", [1588]], [[65209, 65212], "mapped", [1589]], [[65213, 65216], "mapped", [1590]], [[65217, 65220], "mapped", [1591]], [[65221, 65224], "mapped", [1592]], [[65225, 65228], "mapped", [1593]], [[65229, 65232], "mapped", [1594]], [[65233, 65236], "mapped", [1601]], [[65237, 65240], "mapped", [1602]], [[65241, 65244], "mapped", [1603]], [[65245, 65248], "mapped", [1604]], [[65249, 65252], "mapped", [1605]], [[65253, 65256], "mapped", [1606]], [[65257, 65260], "mapped", [1607]], [[65261, 65262], "mapped", [1608]], [[65263, 65264], "mapped", [1609]], [[65265, 65268], "mapped", [1610]], [[65269, 65270], "mapped", [1604, 1570]], [[65271, 65272], "mapped", [1604, 1571]], [[65273, 65274], "mapped", [1604, 1573]], [[65275, 65276], "mapped", [1604, 1575]], [[65277, 65278], "disallowed"], [[65279, 65279], "ignored"], [[65280, 65280], "disallowed"], [[65281, 65281], "disallowed_STD3_mapped", [33]], [[65282, 65282], "disallowed_STD3_mapped", [34]], [[65283, 65283], "disallowed_STD3_mapped", [35]], [[65284, 65284], "disallowed_STD3_mapped", [36]], [[65285, 65285], "disallowed_STD3_mapped", [37]], [[65286, 65286], "disallowed_STD3_mapped", [38]], [[65287, 65287], "disallowed_STD3_mapped", [39]], [[65288, 65288], "disallowed_STD3_mapped", [40]], [[65289, 65289], "disallowed_STD3_mapped", [41]], [[65290, 65290], "disallowed_STD3_mapped", [42]], [[65291, 65291], "disallowed_STD3_mapped", [43]], [[65292, 65292], "disallowed_STD3_mapped", [44]], [[65293, 65293], "mapped", [45]], [[65294, 65294], "mapped", [46]], [[65295, 65295], "disallowed_STD3_mapped", [47]], [[65296, 65296], "mapped", [48]], [[65297, 65297], "mapped", [49]], [[65298, 65298], "mapped", [50]], [[65299, 65299], "mapped", [51]], [[65300, 65300], "mapped", [52]], [[65301, 65301], "mapped", [53]], [[65302, 65302], "mapped", [54]], [[65303, 65303], "mapped", [55]], [[65304, 65304], "mapped", [56]], [[65305, 65305], "mapped", [57]], [[65306, 65306], "disallowed_STD3_mapped", [58]], [[65307, 65307], "disallowed_STD3_mapped", [59]], [[65308, 65308], "disallowed_STD3_mapped", [60]], [[65309, 65309], "disallowed_STD3_mapped", [61]], [[65310, 65310], "disallowed_STD3_mapped", [62]], [[65311, 65311], "disallowed_STD3_mapped", [63]], [[65312, 65312], "disallowed_STD3_mapped", [64]], [[65313, 65313], "mapped", [97]], [[65314, 65314], "mapped", [98]], [[65315, 65315], "mapped", [99]], [[65316, 65316], "mapped", [100]], [[65317, 65317], "mapped", [101]], [[65318, 65318], "mapped", [102]], [[65319, 65319], "mapped", [103]], [[65320, 65320], "mapped", [104]], [[65321, 65321], "mapped", [105]], [[65322, 65322], "mapped", [106]], [[65323, 65323], "mapped", [107]], [[65324, 65324], "mapped", [108]], [[65325, 65325], "mapped", [109]], [[65326, 65326], "mapped", [110]], [[65327, 65327], "mapped", [111]], [[65328, 65328], "mapped", [112]], [[65329, 65329], "mapped", [113]], [[65330, 65330], "mapped", [114]], [[65331, 65331], "mapped", [115]], [[65332, 65332], "mapped", [116]], [[65333, 65333], "mapped", [117]], [[65334, 65334], "mapped", [118]], [[65335, 65335], "mapped", [119]], [[65336, 65336], "mapped", [120]], [[65337, 65337], "mapped", [121]], [[65338, 65338], "mapped", [122]], [[65339, 65339], "disallowed_STD3_mapped", [91]], [[65340, 65340], "disallowed_STD3_mapped", [92]], [[65341, 65341], "disallowed_STD3_mapped", [93]], [[65342, 65342], "disallowed_STD3_mapped", [94]], [[65343, 65343], "disallowed_STD3_mapped", [95]], [[65344, 65344], "disallowed_STD3_mapped", [96]], [[65345, 65345], "mapped", [97]], [[65346, 65346], "mapped", [98]], [[65347, 65347], "mapped", [99]], [[65348, 65348], "mapped", [100]], [[65349, 65349], "mapped", [101]], [[65350, 65350], "mapped", [102]], [[65351, 65351], "mapped", [103]], [[65352, 65352], "mapped", [104]], [[65353, 65353], "mapped", [105]], [[65354, 65354], "mapped", [106]], [[65355, 65355], "mapped", [107]], [[65356, 65356], "mapped", [108]], [[65357, 65357], "mapped", [109]], [[65358, 65358], "mapped", [110]], [[65359, 65359], "mapped", [111]], [[65360, 65360], "mapped", [112]], [[65361, 65361], "mapped", [113]], [[65362, 65362], "mapped", [114]], [[65363, 65363], "mapped", [115]], [[65364, 65364], "mapped", [116]], [[65365, 65365], "mapped", [117]], [[65366, 65366], "mapped", [118]], [[65367, 65367], "mapped", [119]], [[65368, 65368], "mapped", [120]], [[65369, 65369], "mapped", [121]], [[65370, 65370], "mapped", [122]], [[65371, 65371], "disallowed_STD3_mapped", [123]], [[65372, 65372], "disallowed_STD3_mapped", [124]], [[65373, 65373], "disallowed_STD3_mapped", [125]], [[65374, 65374], "disallowed_STD3_mapped", [126]], [[65375, 65375], "mapped", [10629]], [[65376, 65376], "mapped", [10630]], [[65377, 65377], "mapped", [46]], [[65378, 65378], "mapped", [12300]], [[65379, 65379], "mapped", [12301]], [[65380, 65380], "mapped", [12289]], [[65381, 65381], "mapped", [12539]], [[65382, 65382], "mapped", [12530]], [[65383, 65383], "mapped", [12449]], [[65384, 65384], "mapped", [12451]], [[65385, 65385], "mapped", [12453]], [[65386, 65386], "mapped", [12455]], [[65387, 65387], "mapped", [12457]], [[65388, 65388], "mapped", [12515]], [[65389, 65389], "mapped", [12517]], [[65390, 65390], "mapped", [12519]], [[65391, 65391], "mapped", [12483]], [[65392, 65392], "mapped", [12540]], [[65393, 65393], "mapped", [12450]], [[65394, 65394], "mapped", [12452]], [[65395, 65395], "mapped", [12454]], [[65396, 65396], "mapped", [12456]], [[65397, 65397], "mapped", [12458]], [[65398, 65398], "mapped", [12459]], [[65399, 65399], "mapped", [12461]], [[65400, 65400], "mapped", [12463]], [[65401, 65401], "mapped", [12465]], [[65402, 65402], "mapped", [12467]], [[65403, 65403], "mapped", [12469]], [[65404, 65404], "mapped", [12471]], [[65405, 65405], "mapped", [12473]], [[65406, 65406], "mapped", [12475]], [[65407, 65407], "mapped", [12477]], [[65408, 65408], "mapped", [12479]], [[65409, 65409], "mapped", [12481]], [[65410, 65410], "mapped", [12484]], [[65411, 65411], "mapped", [12486]], [[65412, 65412], "mapped", [12488]], [[65413, 65413], "mapped", [12490]], [[65414, 65414], "mapped", [12491]], [[65415, 65415], "mapped", [12492]], [[65416, 65416], "mapped", [12493]], [[65417, 65417], "mapped", [12494]], [[65418, 65418], "mapped", [12495]], [[65419, 65419], "mapped", [12498]], [[65420, 65420], "mapped", [12501]], [[65421, 65421], "mapped", [12504]], [[65422, 65422], "mapped", [12507]], [[65423, 65423], "mapped", [12510]], [[65424, 65424], "mapped", [12511]], [[65425, 65425], "mapped", [12512]], [[65426, 65426], "mapped", [12513]], [[65427, 65427], "mapped", [12514]], [[65428, 65428], "mapped", [12516]], [[65429, 65429], "mapped", [12518]], [[65430, 65430], "mapped", [12520]], [[65431, 65431], "mapped", [12521]], [[65432, 65432], "mapped", [12522]], [[65433, 65433], "mapped", [12523]], [[65434, 65434], "mapped", [12524]], [[65435, 65435], "mapped", [12525]], [[65436, 65436], "mapped", [12527]], [[65437, 65437], "mapped", [12531]], [[65438, 65438], "mapped", [12441]], [[65439, 65439], "mapped", [12442]], [[65440, 65440], "disallowed"], [[65441, 65441], "mapped", [4352]], [[65442, 65442], "mapped", [4353]], [[65443, 65443], "mapped", [4522]], [[65444, 65444], "mapped", [4354]], [[65445, 65445], "mapped", [4524]], [[65446, 65446], "mapped", [4525]], [[65447, 65447], "mapped", [4355]], [[65448, 65448], "mapped", [4356]], [[65449, 65449], "mapped", [4357]], [[65450, 65450], "mapped", [4528]], [[65451, 65451], "mapped", [4529]], [[65452, 65452], "mapped", [4530]], [[65453, 65453], "mapped", [4531]], [[65454, 65454], "mapped", [4532]], [[65455, 65455], "mapped", [4533]], [[65456, 65456], "mapped", [4378]], [[65457, 65457], "mapped", [4358]], [[65458, 65458], "mapped", [4359]], [[65459, 65459], "mapped", [4360]], [[65460, 65460], "mapped", [4385]], [[65461, 65461], "mapped", [4361]], [[65462, 65462], "mapped", [4362]], [[65463, 65463], "mapped", [4363]], [[65464, 65464], "mapped", [4364]], [[65465, 65465], "mapped", [4365]], [[65466, 65466], "mapped", [4366]], [[65467, 65467], "mapped", [4367]], [[65468, 65468], "mapped", [4368]], [[65469, 65469], "mapped", [4369]], [[65470, 65470], "mapped", [4370]], [[65471, 65473], "disallowed"], [[65474, 65474], "mapped", [4449]], [[65475, 65475], "mapped", [4450]], [[65476, 65476], "mapped", [4451]], [[65477, 65477], "mapped", [4452]], [[65478, 65478], "mapped", [4453]], [[65479, 65479], "mapped", [4454]], [[65480, 65481], "disallowed"], [[65482, 65482], "mapped", [4455]], [[65483, 65483], "mapped", [4456]], [[65484, 65484], "mapped", [4457]], [[65485, 65485], "mapped", [4458]], [[65486, 65486], "mapped", [4459]], [[65487, 65487], "mapped", [4460]], [[65488, 65489], "disallowed"], [[65490, 65490], "mapped", [4461]], [[65491, 65491], "mapped", [4462]], [[65492, 65492], "mapped", [4463]], [[65493, 65493], "mapped", [4464]], [[65494, 65494], "mapped", [4465]], [[65495, 65495], "mapped", [4466]], [[65496, 65497], "disallowed"], [[65498, 65498], "mapped", [4467]], [[65499, 65499], "mapped", [4468]], [[65500, 65500], "mapped", [4469]], [[65501, 65503], "disallowed"], [[65504, 65504], "mapped", [162]], [[65505, 65505], "mapped", [163]], [[65506, 65506], "mapped", [172]], [[65507, 65507], "disallowed_STD3_mapped", [32, 772]], [[65508, 65508], "mapped", [166]], [[65509, 65509], "mapped", [165]], [[65510, 65510], "mapped", [8361]], [[65511, 65511], "disallowed"], [[65512, 65512], "mapped", [9474]], [[65513, 65513], "mapped", [8592]], [[65514, 65514], "mapped", [8593]], [[65515, 65515], "mapped", [8594]], [[65516, 65516], "mapped", [8595]], [[65517, 65517], "mapped", [9632]], [[65518, 65518], "mapped", [9675]], [[65519, 65528], "disallowed"], [[65529, 65531], "disallowed"], [[65532, 65532], "disallowed"], [[65533, 65533], "disallowed"], [[65534, 65535], "disallowed"], [[65536, 65547], "valid"], [[65548, 65548], "disallowed"], [[65549, 65574], "valid"], [[65575, 65575], "disallowed"], [[65576, 65594], "valid"], [[65595, 65595], "disallowed"], [[65596, 65597], "valid"], [[65598, 65598], "disallowed"], [[65599, 65613], "valid"], [[65614, 65615], "disallowed"], [[65616, 65629], "valid"], [[65630, 65663], "disallowed"], [[65664, 65786], "valid"], [[65787, 65791], "disallowed"], [[65792, 65794], "valid", [], "NV8"], [[65795, 65798], "disallowed"], [[65799, 65843], "valid", [], "NV8"], [[65844, 65846], "disallowed"], [[65847, 65855], "valid", [], "NV8"], [[65856, 65930], "valid", [], "NV8"], [[65931, 65932], "valid", [], "NV8"], [[65933, 65935], "disallowed"], [[65936, 65947], "valid", [], "NV8"], [[65948, 65951], "disallowed"], [[65952, 65952], "valid", [], "NV8"], [[65953, 65999], "disallowed"], [[66e3, 66044], "valid", [], "NV8"], [[66045, 66045], "valid"], [[66046, 66175], "disallowed"], [[66176, 66204], "valid"], [[66205, 66207], "disallowed"], [[66208, 66256], "valid"], [[66257, 66271], "disallowed"], [[66272, 66272], "valid"], [[66273, 66299], "valid", [], "NV8"], [[66300, 66303], "disallowed"], [[66304, 66334], "valid"], [[66335, 66335], "valid"], [[66336, 66339], "valid", [], "NV8"], [[66340, 66351], "disallowed"], [[66352, 66368], "valid"], [[66369, 66369], "valid", [], "NV8"], [[66370, 66377], "valid"], [[66378, 66378], "valid", [], "NV8"], [[66379, 66383], "disallowed"], [[66384, 66426], "valid"], [[66427, 66431], "disallowed"], [[66432, 66461], "valid"], [[66462, 66462], "disallowed"], [[66463, 66463], "valid", [], "NV8"], [[66464, 66499], "valid"], [[66500, 66503], "disallowed"], [[66504, 66511], "valid"], [[66512, 66517], "valid", [], "NV8"], [[66518, 66559], "disallowed"], [[66560, 66560], "mapped", [66600]], [[66561, 66561], "mapped", [66601]], [[66562, 66562], "mapped", [66602]], [[66563, 66563], "mapped", [66603]], [[66564, 66564], "mapped", [66604]], [[66565, 66565], "mapped", [66605]], [[66566, 66566], "mapped", [66606]], [[66567, 66567], "mapped", [66607]], [[66568, 66568], "mapped", [66608]], [[66569, 66569], "mapped", [66609]], [[66570, 66570], "mapped", [66610]], [[66571, 66571], "mapped", [66611]], [[66572, 66572], "mapped", [66612]], [[66573, 66573], "mapped", [66613]], [[66574, 66574], "mapped", [66614]], [[66575, 66575], "mapped", [66615]], [[66576, 66576], "mapped", [66616]], [[66577, 66577], "mapped", [66617]], [[66578, 66578], "mapped", [66618]], [[66579, 66579], "mapped", [66619]], [[66580, 66580], "mapped", [66620]], [[66581, 66581], "mapped", [66621]], [[66582, 66582], "mapped", [66622]], [[66583, 66583], "mapped", [66623]], [[66584, 66584], "mapped", [66624]], [[66585, 66585], "mapped", [66625]], [[66586, 66586], "mapped", [66626]], [[66587, 66587], "mapped", [66627]], [[66588, 66588], "mapped", [66628]], [[66589, 66589], "mapped", [66629]], [[66590, 66590], "mapped", [66630]], [[66591, 66591], "mapped", [66631]], [[66592, 66592], "mapped", [66632]], [[66593, 66593], "mapped", [66633]], [[66594, 66594], "mapped", [66634]], [[66595, 66595], "mapped", [66635]], [[66596, 66596], "mapped", [66636]], [[66597, 66597], "mapped", [66637]], [[66598, 66598], "mapped", [66638]], [[66599, 66599], "mapped", [66639]], [[66600, 66637], "valid"], [[66638, 66717], "valid"], [[66718, 66719], "disallowed"], [[66720, 66729], "valid"], [[66730, 66815], "disallowed"], [[66816, 66855], "valid"], [[66856, 66863], "disallowed"], [[66864, 66915], "valid"], [[66916, 66926], "disallowed"], [[66927, 66927], "valid", [], "NV8"], [[66928, 67071], "disallowed"], [[67072, 67382], "valid"], [[67383, 67391], "disallowed"], [[67392, 67413], "valid"], [[67414, 67423], "disallowed"], [[67424, 67431], "valid"], [[67432, 67583], "disallowed"], [[67584, 67589], "valid"], [[67590, 67591], "disallowed"], [[67592, 67592], "valid"], [[67593, 67593], "disallowed"], [[67594, 67637], "valid"], [[67638, 67638], "disallowed"], [[67639, 67640], "valid"], [[67641, 67643], "disallowed"], [[67644, 67644], "valid"], [[67645, 67646], "disallowed"], [[67647, 67647], "valid"], [[67648, 67669], "valid"], [[67670, 67670], "disallowed"], [[67671, 67679], "valid", [], "NV8"], [[67680, 67702], "valid"], [[67703, 67711], "valid", [], "NV8"], [[67712, 67742], "valid"], [[67743, 67750], "disallowed"], [[67751, 67759], "valid", [], "NV8"], [[67760, 67807], "disallowed"], [[67808, 67826], "valid"], [[67827, 67827], "disallowed"], [[67828, 67829], "valid"], [[67830, 67834], "disallowed"], [[67835, 67839], "valid", [], "NV8"], [[67840, 67861], "valid"], [[67862, 67865], "valid", [], "NV8"], [[67866, 67867], "valid", [], "NV8"], [[67868, 67870], "disallowed"], [[67871, 67871], "valid", [], "NV8"], [[67872, 67897], "valid"], [[67898, 67902], "disallowed"], [[67903, 67903], "valid", [], "NV8"], [[67904, 67967], "disallowed"], [[67968, 68023], "valid"], [[68024, 68027], "disallowed"], [[68028, 68029], "valid", [], "NV8"], [[68030, 68031], "valid"], [[68032, 68047], "valid", [], "NV8"], [[68048, 68049], "disallowed"], [[68050, 68095], "valid", [], "NV8"], [[68096, 68099], "valid"], [[68100, 68100], "disallowed"], [[68101, 68102], "valid"], [[68103, 68107], "disallowed"], [[68108, 68115], "valid"], [[68116, 68116], "disallowed"], [[68117, 68119], "valid"], [[68120, 68120], "disallowed"], [[68121, 68147], "valid"], [[68148, 68151], "disallowed"], [[68152, 68154], "valid"], [[68155, 68158], "disallowed"], [[68159, 68159], "valid"], [[68160, 68167], "valid", [], "NV8"], [[68168, 68175], "disallowed"], [[68176, 68184], "valid", [], "NV8"], [[68185, 68191], "disallowed"], [[68192, 68220], "valid"], [[68221, 68223], "valid", [], "NV8"], [[68224, 68252], "valid"], [[68253, 68255], "valid", [], "NV8"], [[68256, 68287], "disallowed"], [[68288, 68295], "valid"], [[68296, 68296], "valid", [], "NV8"], [[68297, 68326], "valid"], [[68327, 68330], "disallowed"], [[68331, 68342], "valid", [], "NV8"], [[68343, 68351], "disallowed"], [[68352, 68405], "valid"], [[68406, 68408], "disallowed"], [[68409, 68415], "valid", [], "NV8"], [[68416, 68437], "valid"], [[68438, 68439], "disallowed"], [[68440, 68447], "valid", [], "NV8"], [[68448, 68466], "valid"], [[68467, 68471], "disallowed"], [[68472, 68479], "valid", [], "NV8"], [[68480, 68497], "valid"], [[68498, 68504], "disallowed"], [[68505, 68508], "valid", [], "NV8"], [[68509, 68520], "disallowed"], [[68521, 68527], "valid", [], "NV8"], [[68528, 68607], "disallowed"], [[68608, 68680], "valid"], [[68681, 68735], "disallowed"], [[68736, 68736], "mapped", [68800]], [[68737, 68737], "mapped", [68801]], [[68738, 68738], "mapped", [68802]], [[68739, 68739], "mapped", [68803]], [[68740, 68740], "mapped", [68804]], [[68741, 68741], "mapped", [68805]], [[68742, 68742], "mapped", [68806]], [[68743, 68743], "mapped", [68807]], [[68744, 68744], "mapped", [68808]], [[68745, 68745], "mapped", [68809]], [[68746, 68746], "mapped", [68810]], [[68747, 68747], "mapped", [68811]], [[68748, 68748], "mapped", [68812]], [[68749, 68749], "mapped", [68813]], [[68750, 68750], "mapped", [68814]], [[68751, 68751], "mapped", [68815]], [[68752, 68752], "mapped", [68816]], [[68753, 68753], "mapped", [68817]], [[68754, 68754], "mapped", [68818]], [[68755, 68755], "mapped", [68819]], [[68756, 68756], "mapped", [68820]], [[68757, 68757], "mapped", [68821]], [[68758, 68758], "mapped", [68822]], [[68759, 68759], "mapped", [68823]], [[68760, 68760], "mapped", [68824]], [[68761, 68761], "mapped", [68825]], [[68762, 68762], "mapped", [68826]], [[68763, 68763], "mapped", [68827]], [[68764, 68764], "mapped", [68828]], [[68765, 68765], "mapped", [68829]], [[68766, 68766], "mapped", [68830]], [[68767, 68767], "mapped", [68831]], [[68768, 68768], "mapped", [68832]], [[68769, 68769], "mapped", [68833]], [[68770, 68770], "mapped", [68834]], [[68771, 68771], "mapped", [68835]], [[68772, 68772], "mapped", [68836]], [[68773, 68773], "mapped", [68837]], [[68774, 68774], "mapped", [68838]], [[68775, 68775], "mapped", [68839]], [[68776, 68776], "mapped", [68840]], [[68777, 68777], "mapped", [68841]], [[68778, 68778], "mapped", [68842]], [[68779, 68779], "mapped", [68843]], [[68780, 68780], "mapped", [68844]], [[68781, 68781], "mapped", [68845]], [[68782, 68782], "mapped", [68846]], [[68783, 68783], "mapped", [68847]], [[68784, 68784], "mapped", [68848]], [[68785, 68785], "mapped", [68849]], [[68786, 68786], "mapped", [68850]], [[68787, 68799], "disallowed"], [[68800, 68850], "valid"], [[68851, 68857], "disallowed"], [[68858, 68863], "valid", [], "NV8"], [[68864, 69215], "disallowed"], [[69216, 69246], "valid", [], "NV8"], [[69247, 69631], "disallowed"], [[69632, 69702], "valid"], [[69703, 69709], "valid", [], "NV8"], [[69710, 69713], "disallowed"], [[69714, 69733], "valid", [], "NV8"], [[69734, 69743], "valid"], [[69744, 69758], "disallowed"], [[69759, 69759], "valid"], [[69760, 69818], "valid"], [[69819, 69820], "valid", [], "NV8"], [[69821, 69821], "disallowed"], [[69822, 69825], "valid", [], "NV8"], [[69826, 69839], "disallowed"], [[69840, 69864], "valid"], [[69865, 69871], "disallowed"], [[69872, 69881], "valid"], [[69882, 69887], "disallowed"], [[69888, 69940], "valid"], [[69941, 69941], "disallowed"], [[69942, 69951], "valid"], [[69952, 69955], "valid", [], "NV8"], [[69956, 69967], "disallowed"], [[69968, 70003], "valid"], [[70004, 70005], "valid", [], "NV8"], [[70006, 70006], "valid"], [[70007, 70015], "disallowed"], [[70016, 70084], "valid"], [[70085, 70088], "valid", [], "NV8"], [[70089, 70089], "valid", [], "NV8"], [[70090, 70092], "valid"], [[70093, 70093], "valid", [], "NV8"], [[70094, 70095], "disallowed"], [[70096, 70105], "valid"], [[70106, 70106], "valid"], [[70107, 70107], "valid", [], "NV8"], [[70108, 70108], "valid"], [[70109, 70111], "valid", [], "NV8"], [[70112, 70112], "disallowed"], [[70113, 70132], "valid", [], "NV8"], [[70133, 70143], "disallowed"], [[70144, 70161], "valid"], [[70162, 70162], "disallowed"], [[70163, 70199], "valid"], [[70200, 70205], "valid", [], "NV8"], [[70206, 70271], "disallowed"], [[70272, 70278], "valid"], [[70279, 70279], "disallowed"], [[70280, 70280], "valid"], [[70281, 70281], "disallowed"], [[70282, 70285], "valid"], [[70286, 70286], "disallowed"], [[70287, 70301], "valid"], [[70302, 70302], "disallowed"], [[70303, 70312], "valid"], [[70313, 70313], "valid", [], "NV8"], [[70314, 70319], "disallowed"], [[70320, 70378], "valid"], [[70379, 70383], "disallowed"], [[70384, 70393], "valid"], [[70394, 70399], "disallowed"], [[70400, 70400], "valid"], [[70401, 70403], "valid"], [[70404, 70404], "disallowed"], [[70405, 70412], "valid"], [[70413, 70414], "disallowed"], [[70415, 70416], "valid"], [[70417, 70418], "disallowed"], [[70419, 70440], "valid"], [[70441, 70441], "disallowed"], [[70442, 70448], "valid"], [[70449, 70449], "disallowed"], [[70450, 70451], "valid"], [[70452, 70452], "disallowed"], [[70453, 70457], "valid"], [[70458, 70459], "disallowed"], [[70460, 70468], "valid"], [[70469, 70470], "disallowed"], [[70471, 70472], "valid"], [[70473, 70474], "disallowed"], [[70475, 70477], "valid"], [[70478, 70479], "disallowed"], [[70480, 70480], "valid"], [[70481, 70486], "disallowed"], [[70487, 70487], "valid"], [[70488, 70492], "disallowed"], [[70493, 70499], "valid"], [[70500, 70501], "disallowed"], [[70502, 70508], "valid"], [[70509, 70511], "disallowed"], [[70512, 70516], "valid"], [[70517, 70783], "disallowed"], [[70784, 70853], "valid"], [[70854, 70854], "valid", [], "NV8"], [[70855, 70855], "valid"], [[70856, 70863], "disallowed"], [[70864, 70873], "valid"], [[70874, 71039], "disallowed"], [[71040, 71093], "valid"], [[71094, 71095], "disallowed"], [[71096, 71104], "valid"], [[71105, 71113], "valid", [], "NV8"], [[71114, 71127], "valid", [], "NV8"], [[71128, 71133], "valid"], [[71134, 71167], "disallowed"], [[71168, 71232], "valid"], [[71233, 71235], "valid", [], "NV8"], [[71236, 71236], "valid"], [[71237, 71247], "disallowed"], [[71248, 71257], "valid"], [[71258, 71295], "disallowed"], [[71296, 71351], "valid"], [[71352, 71359], "disallowed"], [[71360, 71369], "valid"], [[71370, 71423], "disallowed"], [[71424, 71449], "valid"], [[71450, 71452], "disallowed"], [[71453, 71467], "valid"], [[71468, 71471], "disallowed"], [[71472, 71481], "valid"], [[71482, 71487], "valid", [], "NV8"], [[71488, 71839], "disallowed"], [[71840, 71840], "mapped", [71872]], [[71841, 71841], "mapped", [71873]], [[71842, 71842], "mapped", [71874]], [[71843, 71843], "mapped", [71875]], [[71844, 71844], "mapped", [71876]], [[71845, 71845], "mapped", [71877]], [[71846, 71846], "mapped", [71878]], [[71847, 71847], "mapped", [71879]], [[71848, 71848], "mapped", [71880]], [[71849, 71849], "mapped", [71881]], [[71850, 71850], "mapped", [71882]], [[71851, 71851], "mapped", [71883]], [[71852, 71852], "mapped", [71884]], [[71853, 71853], "mapped", [71885]], [[71854, 71854], "mapped", [71886]], [[71855, 71855], "mapped", [71887]], [[71856, 71856], "mapped", [71888]], [[71857, 71857], "mapped", [71889]], [[71858, 71858], "mapped", [71890]], [[71859, 71859], "mapped", [71891]], [[71860, 71860], "mapped", [71892]], [[71861, 71861], "mapped", [71893]], [[71862, 71862], "mapped", [71894]], [[71863, 71863], "mapped", [71895]], [[71864, 71864], "mapped", [71896]], [[71865, 71865], "mapped", [71897]], [[71866, 71866], "mapped", [71898]], [[71867, 71867], "mapped", [71899]], [[71868, 71868], "mapped", [71900]], [[71869, 71869], "mapped", [71901]], [[71870, 71870], "mapped", [71902]], [[71871, 71871], "mapped", [71903]], [[71872, 71913], "valid"], [[71914, 71922], "valid", [], "NV8"], [[71923, 71934], "disallowed"], [[71935, 71935], "valid"], [[71936, 72383], "disallowed"], [[72384, 72440], "valid"], [[72441, 73727], "disallowed"], [[73728, 74606], "valid"], [[74607, 74648], "valid"], [[74649, 74649], "valid"], [[74650, 74751], "disallowed"], [[74752, 74850], "valid", [], "NV8"], [[74851, 74862], "valid", [], "NV8"], [[74863, 74863], "disallowed"], [[74864, 74867], "valid", [], "NV8"], [[74868, 74868], "valid", [], "NV8"], [[74869, 74879], "disallowed"], [[74880, 75075], "valid"], [[75076, 77823], "disallowed"], [[77824, 78894], "valid"], [[78895, 82943], "disallowed"], [[82944, 83526], "valid"], [[83527, 92159], "disallowed"], [[92160, 92728], "valid"], [[92729, 92735], "disallowed"], [[92736, 92766], "valid"], [[92767, 92767], "disallowed"], [[92768, 92777], "valid"], [[92778, 92781], "disallowed"], [[92782, 92783], "valid", [], "NV8"], [[92784, 92879], "disallowed"], [[92880, 92909], "valid"], [[92910, 92911], "disallowed"], [[92912, 92916], "valid"], [[92917, 92917], "valid", [], "NV8"], [[92918, 92927], "disallowed"], [[92928, 92982], "valid"], [[92983, 92991], "valid", [], "NV8"], [[92992, 92995], "valid"], [[92996, 92997], "valid", [], "NV8"], [[92998, 93007], "disallowed"], [[93008, 93017], "valid"], [[93018, 93018], "disallowed"], [[93019, 93025], "valid", [], "NV8"], [[93026, 93026], "disallowed"], [[93027, 93047], "valid"], [[93048, 93052], "disallowed"], [[93053, 93071], "valid"], [[93072, 93951], "disallowed"], [[93952, 94020], "valid"], [[94021, 94031], "disallowed"], [[94032, 94078], "valid"], [[94079, 94094], "disallowed"], [[94095, 94111], "valid"], [[94112, 110591], "disallowed"], [[110592, 110593], "valid"], [[110594, 113663], "disallowed"], [[113664, 113770], "valid"], [[113771, 113775], "disallowed"], [[113776, 113788], "valid"], [[113789, 113791], "disallowed"], [[113792, 113800], "valid"], [[113801, 113807], "disallowed"], [[113808, 113817], "valid"], [[113818, 113819], "disallowed"], [[113820, 113820], "valid", [], "NV8"], [[113821, 113822], "valid"], [[113823, 113823], "valid", [], "NV8"], [[113824, 113827], "ignored"], [[113828, 118783], "disallowed"], [[118784, 119029], "valid", [], "NV8"], [[119030, 119039], "disallowed"], [[119040, 119078], "valid", [], "NV8"], [[119079, 119080], "disallowed"], [[119081, 119081], "valid", [], "NV8"], [[119082, 119133], "valid", [], "NV8"], [[119134, 119134], "mapped", [119127, 119141]], [[119135, 119135], "mapped", [119128, 119141]], [[119136, 119136], "mapped", [119128, 119141, 119150]], [[119137, 119137], "mapped", [119128, 119141, 119151]], [[119138, 119138], "mapped", [119128, 119141, 119152]], [[119139, 119139], "mapped", [119128, 119141, 119153]], [[119140, 119140], "mapped", [119128, 119141, 119154]], [[119141, 119154], "valid", [], "NV8"], [[119155, 119162], "disallowed"], [[119163, 119226], "valid", [], "NV8"], [[119227, 119227], "mapped", [119225, 119141]], [[119228, 119228], "mapped", [119226, 119141]], [[119229, 119229], "mapped", [119225, 119141, 119150]], [[119230, 119230], "mapped", [119226, 119141, 119150]], [[119231, 119231], "mapped", [119225, 119141, 119151]], [[119232, 119232], "mapped", [119226, 119141, 119151]], [[119233, 119261], "valid", [], "NV8"], [[119262, 119272], "valid", [], "NV8"], [[119273, 119295], "disallowed"], [[119296, 119365], "valid", [], "NV8"], [[119366, 119551], "disallowed"], [[119552, 119638], "valid", [], "NV8"], [[119639, 119647], "disallowed"], [[119648, 119665], "valid", [], "NV8"], [[119666, 119807], "disallowed"], [[119808, 119808], "mapped", [97]], [[119809, 119809], "mapped", [98]], [[119810, 119810], "mapped", [99]], [[119811, 119811], "mapped", [100]], [[119812, 119812], "mapped", [101]], [[119813, 119813], "mapped", [102]], [[119814, 119814], "mapped", [103]], [[119815, 119815], "mapped", [104]], [[119816, 119816], "mapped", [105]], [[119817, 119817], "mapped", [106]], [[119818, 119818], "mapped", [107]], [[119819, 119819], "mapped", [108]], [[119820, 119820], "mapped", [109]], [[119821, 119821], "mapped", [110]], [[119822, 119822], "mapped", [111]], [[119823, 119823], "mapped", [112]], [[119824, 119824], "mapped", [113]], [[119825, 119825], "mapped", [114]], [[119826, 119826], "mapped", [115]], [[119827, 119827], "mapped", [116]], [[119828, 119828], "mapped", [117]], [[119829, 119829], "mapped", [118]], [[119830, 119830], "mapped", [119]], [[119831, 119831], "mapped", [120]], [[119832, 119832], "mapped", [121]], [[119833, 119833], "mapped", [122]], [[119834, 119834], "mapped", [97]], [[119835, 119835], "mapped", [98]], [[119836, 119836], "mapped", [99]], [[119837, 119837], "mapped", [100]], [[119838, 119838], "mapped", [101]], [[119839, 119839], "mapped", [102]], [[119840, 119840], "mapped", [103]], [[119841, 119841], "mapped", [104]], [[119842, 119842], "mapped", [105]], [[119843, 119843], "mapped", [106]], [[119844, 119844], "mapped", [107]], [[119845, 119845], "mapped", [108]], [[119846, 119846], "mapped", [109]], [[119847, 119847], "mapped", [110]], [[119848, 119848], "mapped", [111]], [[119849, 119849], "mapped", [112]], [[119850, 119850], "mapped", [113]], [[119851, 119851], "mapped", [114]], [[119852, 119852], "mapped", [115]], [[119853, 119853], "mapped", [116]], [[119854, 119854], "mapped", [117]], [[119855, 119855], "mapped", [118]], [[119856, 119856], "mapped", [119]], [[119857, 119857], "mapped", [120]], [[119858, 119858], "mapped", [121]], [[119859, 119859], "mapped", [122]], [[119860, 119860], "mapped", [97]], [[119861, 119861], "mapped", [98]], [[119862, 119862], "mapped", [99]], [[119863, 119863], "mapped", [100]], [[119864, 119864], "mapped", [101]], [[119865, 119865], "mapped", [102]], [[119866, 119866], "mapped", [103]], [[119867, 119867], "mapped", [104]], [[119868, 119868], "mapped", [105]], [[119869, 119869], "mapped", [106]], [[119870, 119870], "mapped", [107]], [[119871, 119871], "mapped", [108]], [[119872, 119872], "mapped", [109]], [[119873, 119873], "mapped", [110]], [[119874, 119874], "mapped", [111]], [[119875, 119875], "mapped", [112]], [[119876, 119876], "mapped", [113]], [[119877, 119877], "mapped", [114]], [[119878, 119878], "mapped", [115]], [[119879, 119879], "mapped", [116]], [[119880, 119880], "mapped", [117]], [[119881, 119881], "mapped", [118]], [[119882, 119882], "mapped", [119]], [[119883, 119883], "mapped", [120]], [[119884, 119884], "mapped", [121]], [[119885, 119885], "mapped", [122]], [[119886, 119886], "mapped", [97]], [[119887, 119887], "mapped", [98]], [[119888, 119888], "mapped", [99]], [[119889, 119889], "mapped", [100]], [[119890, 119890], "mapped", [101]], [[119891, 119891], "mapped", [102]], [[119892, 119892], "mapped", [103]], [[119893, 119893], "disallowed"], [[119894, 119894], "mapped", [105]], [[119895, 119895], "mapped", [106]], [[119896, 119896], "mapped", [107]], [[119897, 119897], "mapped", [108]], [[119898, 119898], "mapped", [109]], [[119899, 119899], "mapped", [110]], [[119900, 119900], "mapped", [111]], [[119901, 119901], "mapped", [112]], [[119902, 119902], "mapped", [113]], [[119903, 119903], "mapped", [114]], [[119904, 119904], "mapped", [115]], [[119905, 119905], "mapped", [116]], [[119906, 119906], "mapped", [117]], [[119907, 119907], "mapped", [118]], [[119908, 119908], "mapped", [119]], [[119909, 119909], "mapped", [120]], [[119910, 119910], "mapped", [121]], [[119911, 119911], "mapped", [122]], [[119912, 119912], "mapped", [97]], [[119913, 119913], "mapped", [98]], [[119914, 119914], "mapped", [99]], [[119915, 119915], "mapped", [100]], [[119916, 119916], "mapped", [101]], [[119917, 119917], "mapped", [102]], [[119918, 119918], "mapped", [103]], [[119919, 119919], "mapped", [104]], [[119920, 119920], "mapped", [105]], [[119921, 119921], "mapped", [106]], [[119922, 119922], "mapped", [107]], [[119923, 119923], "mapped", [108]], [[119924, 119924], "mapped", [109]], [[119925, 119925], "mapped", [110]], [[119926, 119926], "mapped", [111]], [[119927, 119927], "mapped", [112]], [[119928, 119928], "mapped", [113]], [[119929, 119929], "mapped", [114]], [[119930, 119930], "mapped", [115]], [[119931, 119931], "mapped", [116]], [[119932, 119932], "mapped", [117]], [[119933, 119933], "mapped", [118]], [[119934, 119934], "mapped", [119]], [[119935, 119935], "mapped", [120]], [[119936, 119936], "mapped", [121]], [[119937, 119937], "mapped", [122]], [[119938, 119938], "mapped", [97]], [[119939, 119939], "mapped", [98]], [[119940, 119940], "mapped", [99]], [[119941, 119941], "mapped", [100]], [[119942, 119942], "mapped", [101]], [[119943, 119943], "mapped", [102]], [[119944, 119944], "mapped", [103]], [[119945, 119945], "mapped", [104]], [[119946, 119946], "mapped", [105]], [[119947, 119947], "mapped", [106]], [[119948, 119948], "mapped", [107]], [[119949, 119949], "mapped", [108]], [[119950, 119950], "mapped", [109]], [[119951, 119951], "mapped", [110]], [[119952, 119952], "mapped", [111]], [[119953, 119953], "mapped", [112]], [[119954, 119954], "mapped", [113]], [[119955, 119955], "mapped", [114]], [[119956, 119956], "mapped", [115]], [[119957, 119957], "mapped", [116]], [[119958, 119958], "mapped", [117]], [[119959, 119959], "mapped", [118]], [[119960, 119960], "mapped", [119]], [[119961, 119961], "mapped", [120]], [[119962, 119962], "mapped", [121]], [[119963, 119963], "mapped", [122]], [[119964, 119964], "mapped", [97]], [[119965, 119965], "disallowed"], [[119966, 119966], "mapped", [99]], [[119967, 119967], "mapped", [100]], [[119968, 119969], "disallowed"], [[119970, 119970], "mapped", [103]], [[119971, 119972], "disallowed"], [[119973, 119973], "mapped", [106]], [[119974, 119974], "mapped", [107]], [[119975, 119976], "disallowed"], [[119977, 119977], "mapped", [110]], [[119978, 119978], "mapped", [111]], [[119979, 119979], "mapped", [112]], [[119980, 119980], "mapped", [113]], [[119981, 119981], "disallowed"], [[119982, 119982], "mapped", [115]], [[119983, 119983], "mapped", [116]], [[119984, 119984], "mapped", [117]], [[119985, 119985], "mapped", [118]], [[119986, 119986], "mapped", [119]], [[119987, 119987], "mapped", [120]], [[119988, 119988], "mapped", [121]], [[119989, 119989], "mapped", [122]], [[119990, 119990], "mapped", [97]], [[119991, 119991], "mapped", [98]], [[119992, 119992], "mapped", [99]], [[119993, 119993], "mapped", [100]], [[119994, 119994], "disallowed"], [[119995, 119995], "mapped", [102]], [[119996, 119996], "disallowed"], [[119997, 119997], "mapped", [104]], [[119998, 119998], "mapped", [105]], [[119999, 119999], "mapped", [106]], [[12e4, 12e4], "mapped", [107]], [[120001, 120001], "mapped", [108]], [[120002, 120002], "mapped", [109]], [[120003, 120003], "mapped", [110]], [[120004, 120004], "disallowed"], [[120005, 120005], "mapped", [112]], [[120006, 120006], "mapped", [113]], [[120007, 120007], "mapped", [114]], [[120008, 120008], "mapped", [115]], [[120009, 120009], "mapped", [116]], [[120010, 120010], "mapped", [117]], [[120011, 120011], "mapped", [118]], [[120012, 120012], "mapped", [119]], [[120013, 120013], "mapped", [120]], [[120014, 120014], "mapped", [121]], [[120015, 120015], "mapped", [122]], [[120016, 120016], "mapped", [97]], [[120017, 120017], "mapped", [98]], [[120018, 120018], "mapped", [99]], [[120019, 120019], "mapped", [100]], [[120020, 120020], "mapped", [101]], [[120021, 120021], "mapped", [102]], [[120022, 120022], "mapped", [103]], [[120023, 120023], "mapped", [104]], [[120024, 120024], "mapped", [105]], [[120025, 120025], "mapped", [106]], [[120026, 120026], "mapped", [107]], [[120027, 120027], "mapped", [108]], [[120028, 120028], "mapped", [109]], [[120029, 120029], "mapped", [110]], [[120030, 120030], "mapped", [111]], [[120031, 120031], "mapped", [112]], [[120032, 120032], "mapped", [113]], [[120033, 120033], "mapped", [114]], [[120034, 120034], "mapped", [115]], [[120035, 120035], "mapped", [116]], [[120036, 120036], "mapped", [117]], [[120037, 120037], "mapped", [118]], [[120038, 120038], "mapped", [119]], [[120039, 120039], "mapped", [120]], [[120040, 120040], "mapped", [121]], [[120041, 120041], "mapped", [122]], [[120042, 120042], "mapped", [97]], [[120043, 120043], "mapped", [98]], [[120044, 120044], "mapped", [99]], [[120045, 120045], "mapped", [100]], [[120046, 120046], "mapped", [101]], [[120047, 120047], "mapped", [102]], [[120048, 120048], "mapped", [103]], [[120049, 120049], "mapped", [104]], [[120050, 120050], "mapped", [105]], [[120051, 120051], "mapped", [106]], [[120052, 120052], "mapped", [107]], [[120053, 120053], "mapped", [108]], [[120054, 120054], "mapped", [109]], [[120055, 120055], "mapped", [110]], [[120056, 120056], "mapped", [111]], [[120057, 120057], "mapped", [112]], [[120058, 120058], "mapped", [113]], [[120059, 120059], "mapped", [114]], [[120060, 120060], "mapped", [115]], [[120061, 120061], "mapped", [116]], [[120062, 120062], "mapped", [117]], [[120063, 120063], "mapped", [118]], [[120064, 120064], "mapped", [119]], [[120065, 120065], "mapped", [120]], [[120066, 120066], "mapped", [121]], [[120067, 120067], "mapped", [122]], [[120068, 120068], "mapped", [97]], [[120069, 120069], "mapped", [98]], [[120070, 120070], "disallowed"], [[120071, 120071], "mapped", [100]], [[120072, 120072], "mapped", [101]], [[120073, 120073], "mapped", [102]], [[120074, 120074], "mapped", [103]], [[120075, 120076], "disallowed"], [[120077, 120077], "mapped", [106]], [[120078, 120078], "mapped", [107]], [[120079, 120079], "mapped", [108]], [[120080, 120080], "mapped", [109]], [[120081, 120081], "mapped", [110]], [[120082, 120082], "mapped", [111]], [[120083, 120083], "mapped", [112]], [[120084, 120084], "mapped", [113]], [[120085, 120085], "disallowed"], [[120086, 120086], "mapped", [115]], [[120087, 120087], "mapped", [116]], [[120088, 120088], "mapped", [117]], [[120089, 120089], "mapped", [118]], [[120090, 120090], "mapped", [119]], [[120091, 120091], "mapped", [120]], [[120092, 120092], "mapped", [121]], [[120093, 120093], "disallowed"], [[120094, 120094], "mapped", [97]], [[120095, 120095], "mapped", [98]], [[120096, 120096], "mapped", [99]], [[120097, 120097], "mapped", [100]], [[120098, 120098], "mapped", [101]], [[120099, 120099], "mapped", [102]], [[120100, 120100], "mapped", [103]], [[120101, 120101], "mapped", [104]], [[120102, 120102], "mapped", [105]], [[120103, 120103], "mapped", [106]], [[120104, 120104], "mapped", [107]], [[120105, 120105], "mapped", [108]], [[120106, 120106], "mapped", [109]], [[120107, 120107], "mapped", [110]], [[120108, 120108], "mapped", [111]], [[120109, 120109], "mapped", [112]], [[120110, 120110], "mapped", [113]], [[120111, 120111], "mapped", [114]], [[120112, 120112], "mapped", [115]], [[120113, 120113], "mapped", [116]], [[120114, 120114], "mapped", [117]], [[120115, 120115], "mapped", [118]], [[120116, 120116], "mapped", [119]], [[120117, 120117], "mapped", [120]], [[120118, 120118], "mapped", [121]], [[120119, 120119], "mapped", [122]], [[120120, 120120], "mapped", [97]], [[120121, 120121], "mapped", [98]], [[120122, 120122], "disallowed"], [[120123, 120123], "mapped", [100]], [[120124, 120124], "mapped", [101]], [[120125, 120125], "mapped", [102]], [[120126, 120126], "mapped", [103]], [[120127, 120127], "disallowed"], [[120128, 120128], "mapped", [105]], [[120129, 120129], "mapped", [106]], [[120130, 120130], "mapped", [107]], [[120131, 120131], "mapped", [108]], [[120132, 120132], "mapped", [109]], [[120133, 120133], "disallowed"], [[120134, 120134], "mapped", [111]], [[120135, 120137], "disallowed"], [[120138, 120138], "mapped", [115]], [[120139, 120139], "mapped", [116]], [[120140, 120140], "mapped", [117]], [[120141, 120141], "mapped", [118]], [[120142, 120142], "mapped", [119]], [[120143, 120143], "mapped", [120]], [[120144, 120144], "mapped", [121]], [[120145, 120145], "disallowed"], [[120146, 120146], "mapped", [97]], [[120147, 120147], "mapped", [98]], [[120148, 120148], "mapped", [99]], [[120149, 120149], "mapped", [100]], [[120150, 120150], "mapped", [101]], [[120151, 120151], "mapped", [102]], [[120152, 120152], "mapped", [103]], [[120153, 120153], "mapped", [104]], [[120154, 120154], "mapped", [105]], [[120155, 120155], "mapped", [106]], [[120156, 120156], "mapped", [107]], [[120157, 120157], "mapped", [108]], [[120158, 120158], "mapped", [109]], [[120159, 120159], "mapped", [110]], [[120160, 120160], "mapped", [111]], [[120161, 120161], "mapped", [112]], [[120162, 120162], "mapped", [113]], [[120163, 120163], "mapped", [114]], [[120164, 120164], "mapped", [115]], [[120165, 120165], "mapped", [116]], [[120166, 120166], "mapped", [117]], [[120167, 120167], "mapped", [118]], [[120168, 120168], "mapped", [119]], [[120169, 120169], "mapped", [120]], [[120170, 120170], "mapped", [121]], [[120171, 120171], "mapped", [122]], [[120172, 120172], "mapped", [97]], [[120173, 120173], "mapped", [98]], [[120174, 120174], "mapped", [99]], [[120175, 120175], "mapped", [100]], [[120176, 120176], "mapped", [101]], [[120177, 120177], "mapped", [102]], [[120178, 120178], "mapped", [103]], [[120179, 120179], "mapped", [104]], [[120180, 120180], "mapped", [105]], [[120181, 120181], "mapped", [106]], [[120182, 120182], "mapped", [107]], [[120183, 120183], "mapped", [108]], [[120184, 120184], "mapped", [109]], [[120185, 120185], "mapped", [110]], [[120186, 120186], "mapped", [111]], [[120187, 120187], "mapped", [112]], [[120188, 120188], "mapped", [113]], [[120189, 120189], "mapped", [114]], [[120190, 120190], "mapped", [115]], [[120191, 120191], "mapped", [116]], [[120192, 120192], "mapped", [117]], [[120193, 120193], "mapped", [118]], [[120194, 120194], "mapped", [119]], [[120195, 120195], "mapped", [120]], [[120196, 120196], "mapped", [121]], [[120197, 120197], "mapped", [122]], [[120198, 120198], "mapped", [97]], [[120199, 120199], "mapped", [98]], [[120200, 120200], "mapped", [99]], [[120201, 120201], "mapped", [100]], [[120202, 120202], "mapped", [101]], [[120203, 120203], "mapped", [102]], [[120204, 120204], "mapped", [103]], [[120205, 120205], "mapped", [104]], [[120206, 120206], "mapped", [105]], [[120207, 120207], "mapped", [106]], [[120208, 120208], "mapped", [107]], [[120209, 120209], "mapped", [108]], [[120210, 120210], "mapped", [109]], [[120211, 120211], "mapped", [110]], [[120212, 120212], "mapped", [111]], [[120213, 120213], "mapped", [112]], [[120214, 120214], "mapped", [113]], [[120215, 120215], "mapped", [114]], [[120216, 120216], "mapped", [115]], [[120217, 120217], "mapped", [116]], [[120218, 120218], "mapped", [117]], [[120219, 120219], "mapped", [118]], [[120220, 120220], "mapped", [119]], [[120221, 120221], "mapped", [120]], [[120222, 120222], "mapped", [121]], [[120223, 120223], "mapped", [122]], [[120224, 120224], "mapped", [97]], [[120225, 120225], "mapped", [98]], [[120226, 120226], "mapped", [99]], [[120227, 120227], "mapped", [100]], [[120228, 120228], "mapped", [101]], [[120229, 120229], "mapped", [102]], [[120230, 120230], "mapped", [103]], [[120231, 120231], "mapped", [104]], [[120232, 120232], "mapped", [105]], [[120233, 120233], "mapped", [106]], [[120234, 120234], "mapped", [107]], [[120235, 120235], "mapped", [108]], [[120236, 120236], "mapped", [109]], [[120237, 120237], "mapped", [110]], [[120238, 120238], "mapped", [111]], [[120239, 120239], "mapped", [112]], [[120240, 120240], "mapped", [113]], [[120241, 120241], "mapped", [114]], [[120242, 120242], "mapped", [115]], [[120243, 120243], "mapped", [116]], [[120244, 120244], "mapped", [117]], [[120245, 120245], "mapped", [118]], [[120246, 120246], "mapped", [119]], [[120247, 120247], "mapped", [120]], [[120248, 120248], "mapped", [121]], [[120249, 120249], "mapped", [122]], [[120250, 120250], "mapped", [97]], [[120251, 120251], "mapped", [98]], [[120252, 120252], "mapped", [99]], [[120253, 120253], "mapped", [100]], [[120254, 120254], "mapped", [101]], [[120255, 120255], "mapped", [102]], [[120256, 120256], "mapped", [103]], [[120257, 120257], "mapped", [104]], [[120258, 120258], "mapped", [105]], [[120259, 120259], "mapped", [106]], [[120260, 120260], "mapped", [107]], [[120261, 120261], "mapped", [108]], [[120262, 120262], "mapped", [109]], [[120263, 120263], "mapped", [110]], [[120264, 120264], "mapped", [111]], [[120265, 120265], "mapped", [112]], [[120266, 120266], "mapped", [113]], [[120267, 120267], "mapped", [114]], [[120268, 120268], "mapped", [115]], [[120269, 120269], "mapped", [116]], [[120270, 120270], "mapped", [117]], [[120271, 120271], "mapped", [118]], [[120272, 120272], "mapped", [119]], [[120273, 120273], "mapped", [120]], [[120274, 120274], "mapped", [121]], [[120275, 120275], "mapped", [122]], [[120276, 120276], "mapped", [97]], [[120277, 120277], "mapped", [98]], [[120278, 120278], "mapped", [99]], [[120279, 120279], "mapped", [100]], [[120280, 120280], "mapped", [101]], [[120281, 120281], "mapped", [102]], [[120282, 120282], "mapped", [103]], [[120283, 120283], "mapped", [104]], [[120284, 120284], "mapped", [105]], [[120285, 120285], "mapped", [106]], [[120286, 120286], "mapped", [107]], [[120287, 120287], "mapped", [108]], [[120288, 120288], "mapped", [109]], [[120289, 120289], "mapped", [110]], [[120290, 120290], "mapped", [111]], [[120291, 120291], "mapped", [112]], [[120292, 120292], "mapped", [113]], [[120293, 120293], "mapped", [114]], [[120294, 120294], "mapped", [115]], [[120295, 120295], "mapped", [116]], [[120296, 120296], "mapped", [117]], [[120297, 120297], "mapped", [118]], [[120298, 120298], "mapped", [119]], [[120299, 120299], "mapped", [120]], [[120300, 120300], "mapped", [121]], [[120301, 120301], "mapped", [122]], [[120302, 120302], "mapped", [97]], [[120303, 120303], "mapped", [98]], [[120304, 120304], "mapped", [99]], [[120305, 120305], "mapped", [100]], [[120306, 120306], "mapped", [101]], [[120307, 120307], "mapped", [102]], [[120308, 120308], "mapped", [103]], [[120309, 120309], "mapped", [104]], [[120310, 120310], "mapped", [105]], [[120311, 120311], "mapped", [106]], [[120312, 120312], "mapped", [107]], [[120313, 120313], "mapped", [108]], [[120314, 120314], "mapped", [109]], [[120315, 120315], "mapped", [110]], [[120316, 120316], "mapped", [111]], [[120317, 120317], "mapped", [112]], [[120318, 120318], "mapped", [113]], [[120319, 120319], "mapped", [114]], [[120320, 120320], "mapped", [115]], [[120321, 120321], "mapped", [116]], [[120322, 120322], "mapped", [117]], [[120323, 120323], "mapped", [118]], [[120324, 120324], "mapped", [119]], [[120325, 120325], "mapped", [120]], [[120326, 120326], "mapped", [121]], [[120327, 120327], "mapped", [122]], [[120328, 120328], "mapped", [97]], [[120329, 120329], "mapped", [98]], [[120330, 120330], "mapped", [99]], [[120331, 120331], "mapped", [100]], [[120332, 120332], "mapped", [101]], [[120333, 120333], "mapped", [102]], [[120334, 120334], "mapped", [103]], [[120335, 120335], "mapped", [104]], [[120336, 120336], "mapped", [105]], [[120337, 120337], "mapped", [106]], [[120338, 120338], "mapped", [107]], [[120339, 120339], "mapped", [108]], [[120340, 120340], "mapped", [109]], [[120341, 120341], "mapped", [110]], [[120342, 120342], "mapped", [111]], [[120343, 120343], "mapped", [112]], [[120344, 120344], "mapped", [113]], [[120345, 120345], "mapped", [114]], [[120346, 120346], "mapped", [115]], [[120347, 120347], "mapped", [116]], [[120348, 120348], "mapped", [117]], [[120349, 120349], "mapped", [118]], [[120350, 120350], "mapped", [119]], [[120351, 120351], "mapped", [120]], [[120352, 120352], "mapped", [121]], [[120353, 120353], "mapped", [122]], [[120354, 120354], "mapped", [97]], [[120355, 120355], "mapped", [98]], [[120356, 120356], "mapped", [99]], [[120357, 120357], "mapped", [100]], [[120358, 120358], "mapped", [101]], [[120359, 120359], "mapped", [102]], [[120360, 120360], "mapped", [103]], [[120361, 120361], "mapped", [104]], [[120362, 120362], "mapped", [105]], [[120363, 120363], "mapped", [106]], [[120364, 120364], "mapped", [107]], [[120365, 120365], "mapped", [108]], [[120366, 120366], "mapped", [109]], [[120367, 120367], "mapped", [110]], [[120368, 120368], "mapped", [111]], [[120369, 120369], "mapped", [112]], [[120370, 120370], "mapped", [113]], [[120371, 120371], "mapped", [114]], [[120372, 120372], "mapped", [115]], [[120373, 120373], "mapped", [116]], [[120374, 120374], "mapped", [117]], [[120375, 120375], "mapped", [118]], [[120376, 120376], "mapped", [119]], [[120377, 120377], "mapped", [120]], [[120378, 120378], "mapped", [121]], [[120379, 120379], "mapped", [122]], [[120380, 120380], "mapped", [97]], [[120381, 120381], "mapped", [98]], [[120382, 120382], "mapped", [99]], [[120383, 120383], "mapped", [100]], [[120384, 120384], "mapped", [101]], [[120385, 120385], "mapped", [102]], [[120386, 120386], "mapped", [103]], [[120387, 120387], "mapped", [104]], [[120388, 120388], "mapped", [105]], [[120389, 120389], "mapped", [106]], [[120390, 120390], "mapped", [107]], [[120391, 120391], "mapped", [108]], [[120392, 120392], "mapped", [109]], [[120393, 120393], "mapped", [110]], [[120394, 120394], "mapped", [111]], [[120395, 120395], "mapped", [112]], [[120396, 120396], "mapped", [113]], [[120397, 120397], "mapped", [114]], [[120398, 120398], "mapped", [115]], [[120399, 120399], "mapped", [116]], [[120400, 120400], "mapped", [117]], [[120401, 120401], "mapped", [118]], [[120402, 120402], "mapped", [119]], [[120403, 120403], "mapped", [120]], [[120404, 120404], "mapped", [121]], [[120405, 120405], "mapped", [122]], [[120406, 120406], "mapped", [97]], [[120407, 120407], "mapped", [98]], [[120408, 120408], "mapped", [99]], [[120409, 120409], "mapped", [100]], [[120410, 120410], "mapped", [101]], [[120411, 120411], "mapped", [102]], [[120412, 120412], "mapped", [103]], [[120413, 120413], "mapped", [104]], [[120414, 120414], "mapped", [105]], [[120415, 120415], "mapped", [106]], [[120416, 120416], "mapped", [107]], [[120417, 120417], "mapped", [108]], [[120418, 120418], "mapped", [109]], [[120419, 120419], "mapped", [110]], [[120420, 120420], "mapped", [111]], [[120421, 120421], "mapped", [112]], [[120422, 120422], "mapped", [113]], [[120423, 120423], "mapped", [114]], [[120424, 120424], "mapped", [115]], [[120425, 120425], "mapped", [116]], [[120426, 120426], "mapped", [117]], [[120427, 120427], "mapped", [118]], [[120428, 120428], "mapped", [119]], [[120429, 120429], "mapped", [120]], [[120430, 120430], "mapped", [121]], [[120431, 120431], "mapped", [122]], [[120432, 120432], "mapped", [97]], [[120433, 120433], "mapped", [98]], [[120434, 120434], "mapped", [99]], [[120435, 120435], "mapped", [100]], [[120436, 120436], "mapped", [101]], [[120437, 120437], "mapped", [102]], [[120438, 120438], "mapped", [103]], [[120439, 120439], "mapped", [104]], [[120440, 120440], "mapped", [105]], [[120441, 120441], "mapped", [106]], [[120442, 120442], "mapped", [107]], [[120443, 120443], "mapped", [108]], [[120444, 120444], "mapped", [109]], [[120445, 120445], "mapped", [110]], [[120446, 120446], "mapped", [111]], [[120447, 120447], "mapped", [112]], [[120448, 120448], "mapped", [113]], [[120449, 120449], "mapped", [114]], [[120450, 120450], "mapped", [115]], [[120451, 120451], "mapped", [116]], [[120452, 120452], "mapped", [117]], [[120453, 120453], "mapped", [118]], [[120454, 120454], "mapped", [119]], [[120455, 120455], "mapped", [120]], [[120456, 120456], "mapped", [121]], [[120457, 120457], "mapped", [122]], [[120458, 120458], "mapped", [97]], [[120459, 120459], "mapped", [98]], [[120460, 120460], "mapped", [99]], [[120461, 120461], "mapped", [100]], [[120462, 120462], "mapped", [101]], [[120463, 120463], "mapped", [102]], [[120464, 120464], "mapped", [103]], [[120465, 120465], "mapped", [104]], [[120466, 120466], "mapped", [105]], [[120467, 120467], "mapped", [106]], [[120468, 120468], "mapped", [107]], [[120469, 120469], "mapped", [108]], [[120470, 120470], "mapped", [109]], [[120471, 120471], "mapped", [110]], [[120472, 120472], "mapped", [111]], [[120473, 120473], "mapped", [112]], [[120474, 120474], "mapped", [113]], [[120475, 120475], "mapped", [114]], [[120476, 120476], "mapped", [115]], [[120477, 120477], "mapped", [116]], [[120478, 120478], "mapped", [117]], [[120479, 120479], "mapped", [118]], [[120480, 120480], "mapped", [119]], [[120481, 120481], "mapped", [120]], [[120482, 120482], "mapped", [121]], [[120483, 120483], "mapped", [122]], [[120484, 120484], "mapped", [305]], [[120485, 120485], "mapped", [567]], [[120486, 120487], "disallowed"], [[120488, 120488], "mapped", [945]], [[120489, 120489], "mapped", [946]], [[120490, 120490], "mapped", [947]], [[120491, 120491], "mapped", [948]], [[120492, 120492], "mapped", [949]], [[120493, 120493], "mapped", [950]], [[120494, 120494], "mapped", [951]], [[120495, 120495], "mapped", [952]], [[120496, 120496], "mapped", [953]], [[120497, 120497], "mapped", [954]], [[120498, 120498], "mapped", [955]], [[120499, 120499], "mapped", [956]], [[120500, 120500], "mapped", [957]], [[120501, 120501], "mapped", [958]], [[120502, 120502], "mapped", [959]], [[120503, 120503], "mapped", [960]], [[120504, 120504], "mapped", [961]], [[120505, 120505], "mapped", [952]], [[120506, 120506], "mapped", [963]], [[120507, 120507], "mapped", [964]], [[120508, 120508], "mapped", [965]], [[120509, 120509], "mapped", [966]], [[120510, 120510], "mapped", [967]], [[120511, 120511], "mapped", [968]], [[120512, 120512], "mapped", [969]], [[120513, 120513], "mapped", [8711]], [[120514, 120514], "mapped", [945]], [[120515, 120515], "mapped", [946]], [[120516, 120516], "mapped", [947]], [[120517, 120517], "mapped", [948]], [[120518, 120518], "mapped", [949]], [[120519, 120519], "mapped", [950]], [[120520, 120520], "mapped", [951]], [[120521, 120521], "mapped", [952]], [[120522, 120522], "mapped", [953]], [[120523, 120523], "mapped", [954]], [[120524, 120524], "mapped", [955]], [[120525, 120525], "mapped", [956]], [[120526, 120526], "mapped", [957]], [[120527, 120527], "mapped", [958]], [[120528, 120528], "mapped", [959]], [[120529, 120529], "mapped", [960]], [[120530, 120530], "mapped", [961]], [[120531, 120532], "mapped", [963]], [[120533, 120533], "mapped", [964]], [[120534, 120534], "mapped", [965]], [[120535, 120535], "mapped", [966]], [[120536, 120536], "mapped", [967]], [[120537, 120537], "mapped", [968]], [[120538, 120538], "mapped", [969]], [[120539, 120539], "mapped", [8706]], [[120540, 120540], "mapped", [949]], [[120541, 120541], "mapped", [952]], [[120542, 120542], "mapped", [954]], [[120543, 120543], "mapped", [966]], [[120544, 120544], "mapped", [961]], [[120545, 120545], "mapped", [960]], [[120546, 120546], "mapped", [945]], [[120547, 120547], "mapped", [946]], [[120548, 120548], "mapped", [947]], [[120549, 120549], "mapped", [948]], [[120550, 120550], "mapped", [949]], [[120551, 120551], "mapped", [950]], [[120552, 120552], "mapped", [951]], [[120553, 120553], "mapped", [952]], [[120554, 120554], "mapped", [953]], [[120555, 120555], "mapped", [954]], [[120556, 120556], "mapped", [955]], [[120557, 120557], "mapped", [956]], [[120558, 120558], "mapped", [957]], [[120559, 120559], "mapped", [958]], [[120560, 120560], "mapped", [959]], [[120561, 120561], "mapped", [960]], [[120562, 120562], "mapped", [961]], [[120563, 120563], "mapped", [952]], [[120564, 120564], "mapped", [963]], [[120565, 120565], "mapped", [964]], [[120566, 120566], "mapped", [965]], [[120567, 120567], "mapped", [966]], [[120568, 120568], "mapped", [967]], [[120569, 120569], "mapped", [968]], [[120570, 120570], "mapped", [969]], [[120571, 120571], "mapped", [8711]], [[120572, 120572], "mapped", [945]], [[120573, 120573], "mapped", [946]], [[120574, 120574], "mapped", [947]], [[120575, 120575], "mapped", [948]], [[120576, 120576], "mapped", [949]], [[120577, 120577], "mapped", [950]], [[120578, 120578], "mapped", [951]], [[120579, 120579], "mapped", [952]], [[120580, 120580], "mapped", [953]], [[120581, 120581], "mapped", [954]], [[120582, 120582], "mapped", [955]], [[120583, 120583], "mapped", [956]], [[120584, 120584], "mapped", [957]], [[120585, 120585], "mapped", [958]], [[120586, 120586], "mapped", [959]], [[120587, 120587], "mapped", [960]], [[120588, 120588], "mapped", [961]], [[120589, 120590], "mapped", [963]], [[120591, 120591], "mapped", [964]], [[120592, 120592], "mapped", [965]], [[120593, 120593], "mapped", [966]], [[120594, 120594], "mapped", [967]], [[120595, 120595], "mapped", [968]], [[120596, 120596], "mapped", [969]], [[120597, 120597], "mapped", [8706]], [[120598, 120598], "mapped", [949]], [[120599, 120599], "mapped", [952]], [[120600, 120600], "mapped", [954]], [[120601, 120601], "mapped", [966]], [[120602, 120602], "mapped", [961]], [[120603, 120603], "mapped", [960]], [[120604, 120604], "mapped", [945]], [[120605, 120605], "mapped", [946]], [[120606, 120606], "mapped", [947]], [[120607, 120607], "mapped", [948]], [[120608, 120608], "mapped", [949]], [[120609, 120609], "mapped", [950]], [[120610, 120610], "mapped", [951]], [[120611, 120611], "mapped", [952]], [[120612, 120612], "mapped", [953]], [[120613, 120613], "mapped", [954]], [[120614, 120614], "mapped", [955]], [[120615, 120615], "mapped", [956]], [[120616, 120616], "mapped", [957]], [[120617, 120617], "mapped", [958]], [[120618, 120618], "mapped", [959]], [[120619, 120619], "mapped", [960]], [[120620, 120620], "mapped", [961]], [[120621, 120621], "mapped", [952]], [[120622, 120622], "mapped", [963]], [[120623, 120623], "mapped", [964]], [[120624, 120624], "mapped", [965]], [[120625, 120625], "mapped", [966]], [[120626, 120626], "mapped", [967]], [[120627, 120627], "mapped", [968]], [[120628, 120628], "mapped", [969]], [[120629, 120629], "mapped", [8711]], [[120630, 120630], "mapped", [945]], [[120631, 120631], "mapped", [946]], [[120632, 120632], "mapped", [947]], [[120633, 120633], "mapped", [948]], [[120634, 120634], "mapped", [949]], [[120635, 120635], "mapped", [950]], [[120636, 120636], "mapped", [951]], [[120637, 120637], "mapped", [952]], [[120638, 120638], "mapped", [953]], [[120639, 120639], "mapped", [954]], [[120640, 120640], "mapped", [955]], [[120641, 120641], "mapped", [956]], [[120642, 120642], "mapped", [957]], [[120643, 120643], "mapped", [958]], [[120644, 120644], "mapped", [959]], [[120645, 120645], "mapped", [960]], [[120646, 120646], "mapped", [961]], [[120647, 120648], "mapped", [963]], [[120649, 120649], "mapped", [964]], [[120650, 120650], "mapped", [965]], [[120651, 120651], "mapped", [966]], [[120652, 120652], "mapped", [967]], [[120653, 120653], "mapped", [968]], [[120654, 120654], "mapped", [969]], [[120655, 120655], "mapped", [8706]], [[120656, 120656], "mapped", [949]], [[120657, 120657], "mapped", [952]], [[120658, 120658], "mapped", [954]], [[120659, 120659], "mapped", [966]], [[120660, 120660], "mapped", [961]], [[120661, 120661], "mapped", [960]], [[120662, 120662], "mapped", [945]], [[120663, 120663], "mapped", [946]], [[120664, 120664], "mapped", [947]], [[120665, 120665], "mapped", [948]], [[120666, 120666], "mapped", [949]], [[120667, 120667], "mapped", [950]], [[120668, 120668], "mapped", [951]], [[120669, 120669], "mapped", [952]], [[120670, 120670], "mapped", [953]], [[120671, 120671], "mapped", [954]], [[120672, 120672], "mapped", [955]], [[120673, 120673], "mapped", [956]], [[120674, 120674], "mapped", [957]], [[120675, 120675], "mapped", [958]], [[120676, 120676], "mapped", [959]], [[120677, 120677], "mapped", [960]], [[120678, 120678], "mapped", [961]], [[120679, 120679], "mapped", [952]], [[120680, 120680], "mapped", [963]], [[120681, 120681], "mapped", [964]], [[120682, 120682], "mapped", [965]], [[120683, 120683], "mapped", [966]], [[120684, 120684], "mapped", [967]], [[120685, 120685], "mapped", [968]], [[120686, 120686], "mapped", [969]], [[120687, 120687], "mapped", [8711]], [[120688, 120688], "mapped", [945]], [[120689, 120689], "mapped", [946]], [[120690, 120690], "mapped", [947]], [[120691, 120691], "mapped", [948]], [[120692, 120692], "mapped", [949]], [[120693, 120693], "mapped", [950]], [[120694, 120694], "mapped", [951]], [[120695, 120695], "mapped", [952]], [[120696, 120696], "mapped", [953]], [[120697, 120697], "mapped", [954]], [[120698, 120698], "mapped", [955]], [[120699, 120699], "mapped", [956]], [[120700, 120700], "mapped", [957]], [[120701, 120701], "mapped", [958]], [[120702, 120702], "mapped", [959]], [[120703, 120703], "mapped", [960]], [[120704, 120704], "mapped", [961]], [[120705, 120706], "mapped", [963]], [[120707, 120707], "mapped", [964]], [[120708, 120708], "mapped", [965]], [[120709, 120709], "mapped", [966]], [[120710, 120710], "mapped", [967]], [[120711, 120711], "mapped", [968]], [[120712, 120712], "mapped", [969]], [[120713, 120713], "mapped", [8706]], [[120714, 120714], "mapped", [949]], [[120715, 120715], "mapped", [952]], [[120716, 120716], "mapped", [954]], [[120717, 120717], "mapped", [966]], [[120718, 120718], "mapped", [961]], [[120719, 120719], "mapped", [960]], [[120720, 120720], "mapped", [945]], [[120721, 120721], "mapped", [946]], [[120722, 120722], "mapped", [947]], [[120723, 120723], "mapped", [948]], [[120724, 120724], "mapped", [949]], [[120725, 120725], "mapped", [950]], [[120726, 120726], "mapped", [951]], [[120727, 120727], "mapped", [952]], [[120728, 120728], "mapped", [953]], [[120729, 120729], "mapped", [954]], [[120730, 120730], "mapped", [955]], [[120731, 120731], "mapped", [956]], [[120732, 120732], "mapped", [957]], [[120733, 120733], "mapped", [958]], [[120734, 120734], "mapped", [959]], [[120735, 120735], "mapped", [960]], [[120736, 120736], "mapped", [961]], [[120737, 120737], "mapped", [952]], [[120738, 120738], "mapped", [963]], [[120739, 120739], "mapped", [964]], [[120740, 120740], "mapped", [965]], [[120741, 120741], "mapped", [966]], [[120742, 120742], "mapped", [967]], [[120743, 120743], "mapped", [968]], [[120744, 120744], "mapped", [969]], [[120745, 120745], "mapped", [8711]], [[120746, 120746], "mapped", [945]], [[120747, 120747], "mapped", [946]], [[120748, 120748], "mapped", [947]], [[120749, 120749], "mapped", [948]], [[120750, 120750], "mapped", [949]], [[120751, 120751], "mapped", [950]], [[120752, 120752], "mapped", [951]], [[120753, 120753], "mapped", [952]], [[120754, 120754], "mapped", [953]], [[120755, 120755], "mapped", [954]], [[120756, 120756], "mapped", [955]], [[120757, 120757], "mapped", [956]], [[120758, 120758], "mapped", [957]], [[120759, 120759], "mapped", [958]], [[120760, 120760], "mapped", [959]], [[120761, 120761], "mapped", [960]], [[120762, 120762], "mapped", [961]], [[120763, 120764], "mapped", [963]], [[120765, 120765], "mapped", [964]], [[120766, 120766], "mapped", [965]], [[120767, 120767], "mapped", [966]], [[120768, 120768], "mapped", [967]], [[120769, 120769], "mapped", [968]], [[120770, 120770], "mapped", [969]], [[120771, 120771], "mapped", [8706]], [[120772, 120772], "mapped", [949]], [[120773, 120773], "mapped", [952]], [[120774, 120774], "mapped", [954]], [[120775, 120775], "mapped", [966]], [[120776, 120776], "mapped", [961]], [[120777, 120777], "mapped", [960]], [[120778, 120779], "mapped", [989]], [[120780, 120781], "disallowed"], [[120782, 120782], "mapped", [48]], [[120783, 120783], "mapped", [49]], [[120784, 120784], "mapped", [50]], [[120785, 120785], "mapped", [51]], [[120786, 120786], "mapped", [52]], [[120787, 120787], "mapped", [53]], [[120788, 120788], "mapped", [54]], [[120789, 120789], "mapped", [55]], [[120790, 120790], "mapped", [56]], [[120791, 120791], "mapped", [57]], [[120792, 120792], "mapped", [48]], [[120793, 120793], "mapped", [49]], [[120794, 120794], "mapped", [50]], [[120795, 120795], "mapped", [51]], [[120796, 120796], "mapped", [52]], [[120797, 120797], "mapped", [53]], [[120798, 120798], "mapped", [54]], [[120799, 120799], "mapped", [55]], [[120800, 120800], "mapped", [56]], [[120801, 120801], "mapped", [57]], [[120802, 120802], "mapped", [48]], [[120803, 120803], "mapped", [49]], [[120804, 120804], "mapped", [50]], [[120805, 120805], "mapped", [51]], [[120806, 120806], "mapped", [52]], [[120807, 120807], "mapped", [53]], [[120808, 120808], "mapped", [54]], [[120809, 120809], "mapped", [55]], [[120810, 120810], "mapped", [56]], [[120811, 120811], "mapped", [57]], [[120812, 120812], "mapped", [48]], [[120813, 120813], "mapped", [49]], [[120814, 120814], "mapped", [50]], [[120815, 120815], "mapped", [51]], [[120816, 120816], "mapped", [52]], [[120817, 120817], "mapped", [53]], [[120818, 120818], "mapped", [54]], [[120819, 120819], "mapped", [55]], [[120820, 120820], "mapped", [56]], [[120821, 120821], "mapped", [57]], [[120822, 120822], "mapped", [48]], [[120823, 120823], "mapped", [49]], [[120824, 120824], "mapped", [50]], [[120825, 120825], "mapped", [51]], [[120826, 120826], "mapped", [52]], [[120827, 120827], "mapped", [53]], [[120828, 120828], "mapped", [54]], [[120829, 120829], "mapped", [55]], [[120830, 120830], "mapped", [56]], [[120831, 120831], "mapped", [57]], [[120832, 121343], "valid", [], "NV8"], [[121344, 121398], "valid"], [[121399, 121402], "valid", [], "NV8"], [[121403, 121452], "valid"], [[121453, 121460], "valid", [], "NV8"], [[121461, 121461], "valid"], [[121462, 121475], "valid", [], "NV8"], [[121476, 121476], "valid"], [[121477, 121483], "valid", [], "NV8"], [[121484, 121498], "disallowed"], [[121499, 121503], "valid"], [[121504, 121504], "disallowed"], [[121505, 121519], "valid"], [[121520, 124927], "disallowed"], [[124928, 125124], "valid"], [[125125, 125126], "disallowed"], [[125127, 125135], "valid", [], "NV8"], [[125136, 125142], "valid"], [[125143, 126463], "disallowed"], [[126464, 126464], "mapped", [1575]], [[126465, 126465], "mapped", [1576]], [[126466, 126466], "mapped", [1580]], [[126467, 126467], "mapped", [1583]], [[126468, 126468], "disallowed"], [[126469, 126469], "mapped", [1608]], [[126470, 126470], "mapped", [1586]], [[126471, 126471], "mapped", [1581]], [[126472, 126472], "mapped", [1591]], [[126473, 126473], "mapped", [1610]], [[126474, 126474], "mapped", [1603]], [[126475, 126475], "mapped", [1604]], [[126476, 126476], "mapped", [1605]], [[126477, 126477], "mapped", [1606]], [[126478, 126478], "mapped", [1587]], [[126479, 126479], "mapped", [1593]], [[126480, 126480], "mapped", [1601]], [[126481, 126481], "mapped", [1589]], [[126482, 126482], "mapped", [1602]], [[126483, 126483], "mapped", [1585]], [[126484, 126484], "mapped", [1588]], [[126485, 126485], "mapped", [1578]], [[126486, 126486], "mapped", [1579]], [[126487, 126487], "mapped", [1582]], [[126488, 126488], "mapped", [1584]], [[126489, 126489], "mapped", [1590]], [[126490, 126490], "mapped", [1592]], [[126491, 126491], "mapped", [1594]], [[126492, 126492], "mapped", [1646]], [[126493, 126493], "mapped", [1722]], [[126494, 126494], "mapped", [1697]], [[126495, 126495], "mapped", [1647]], [[126496, 126496], "disallowed"], [[126497, 126497], "mapped", [1576]], [[126498, 126498], "mapped", [1580]], [[126499, 126499], "disallowed"], [[126500, 126500], "mapped", [1607]], [[126501, 126502], "disallowed"], [[126503, 126503], "mapped", [1581]], [[126504, 126504], "disallowed"], [[126505, 126505], "mapped", [1610]], [[126506, 126506], "mapped", [1603]], [[126507, 126507], "mapped", [1604]], [[126508, 126508], "mapped", [1605]], [[126509, 126509], "mapped", [1606]], [[126510, 126510], "mapped", [1587]], [[126511, 126511], "mapped", [1593]], [[126512, 126512], "mapped", [1601]], [[126513, 126513], "mapped", [1589]], [[126514, 126514], "mapped", [1602]], [[126515, 126515], "disallowed"], [[126516, 126516], "mapped", [1588]], [[126517, 126517], "mapped", [1578]], [[126518, 126518], "mapped", [1579]], [[126519, 126519], "mapped", [1582]], [[126520, 126520], "disallowed"], [[126521, 126521], "mapped", [1590]], [[126522, 126522], "disallowed"], [[126523, 126523], "mapped", [1594]], [[126524, 126529], "disallowed"], [[126530, 126530], "mapped", [1580]], [[126531, 126534], "disallowed"], [[126535, 126535], "mapped", [1581]], [[126536, 126536], "disallowed"], [[126537, 126537], "mapped", [1610]], [[126538, 126538], "disallowed"], [[126539, 126539], "mapped", [1604]], [[126540, 126540], "disallowed"], [[126541, 126541], "mapped", [1606]], [[126542, 126542], "mapped", [1587]], [[126543, 126543], "mapped", [1593]], [[126544, 126544], "disallowed"], [[126545, 126545], "mapped", [1589]], [[126546, 126546], "mapped", [1602]], [[126547, 126547], "disallowed"], [[126548, 126548], "mapped", [1588]], [[126549, 126550], "disallowed"], [[126551, 126551], "mapped", [1582]], [[126552, 126552], "disallowed"], [[126553, 126553], "mapped", [1590]], [[126554, 126554], "disallowed"], [[126555, 126555], "mapped", [1594]], [[126556, 126556], "disallowed"], [[126557, 126557], "mapped", [1722]], [[126558, 126558], "disallowed"], [[126559, 126559], "mapped", [1647]], [[126560, 126560], "disallowed"], [[126561, 126561], "mapped", [1576]], [[126562, 126562], "mapped", [1580]], [[126563, 126563], "disallowed"], [[126564, 126564], "mapped", [1607]], [[126565, 126566], "disallowed"], [[126567, 126567], "mapped", [1581]], [[126568, 126568], "mapped", [1591]], [[126569, 126569], "mapped", [1610]], [[126570, 126570], "mapped", [1603]], [[126571, 126571], "disallowed"], [[126572, 126572], "mapped", [1605]], [[126573, 126573], "mapped", [1606]], [[126574, 126574], "mapped", [1587]], [[126575, 126575], "mapped", [1593]], [[126576, 126576], "mapped", [1601]], [[126577, 126577], "mapped", [1589]], [[126578, 126578], "mapped", [1602]], [[126579, 126579], "disallowed"], [[126580, 126580], "mapped", [1588]], [[126581, 126581], "mapped", [1578]], [[126582, 126582], "mapped", [1579]], [[126583, 126583], "mapped", [1582]], [[126584, 126584], "disallowed"], [[126585, 126585], "mapped", [1590]], [[126586, 126586], "mapped", [1592]], [[126587, 126587], "mapped", [1594]], [[126588, 126588], "mapped", [1646]], [[126589, 126589], "disallowed"], [[126590, 126590], "mapped", [1697]], [[126591, 126591], "disallowed"], [[126592, 126592], "mapped", [1575]], [[126593, 126593], "mapped", [1576]], [[126594, 126594], "mapped", [1580]], [[126595, 126595], "mapped", [1583]], [[126596, 126596], "mapped", [1607]], [[126597, 126597], "mapped", [1608]], [[126598, 126598], "mapped", [1586]], [[126599, 126599], "mapped", [1581]], [[126600, 126600], "mapped", [1591]], [[126601, 126601], "mapped", [1610]], [[126602, 126602], "disallowed"], [[126603, 126603], "mapped", [1604]], [[126604, 126604], "mapped", [1605]], [[126605, 126605], "mapped", [1606]], [[126606, 126606], "mapped", [1587]], [[126607, 126607], "mapped", [1593]], [[126608, 126608], "mapped", [1601]], [[126609, 126609], "mapped", [1589]], [[126610, 126610], "mapped", [1602]], [[126611, 126611], "mapped", [1585]], [[126612, 126612], "mapped", [1588]], [[126613, 126613], "mapped", [1578]], [[126614, 126614], "mapped", [1579]], [[126615, 126615], "mapped", [1582]], [[126616, 126616], "mapped", [1584]], [[126617, 126617], "mapped", [1590]], [[126618, 126618], "mapped", [1592]], [[126619, 126619], "mapped", [1594]], [[126620, 126624], "disallowed"], [[126625, 126625], "mapped", [1576]], [[126626, 126626], "mapped", [1580]], [[126627, 126627], "mapped", [1583]], [[126628, 126628], "disallowed"], [[126629, 126629], "mapped", [1608]], [[126630, 126630], "mapped", [1586]], [[126631, 126631], "mapped", [1581]], [[126632, 126632], "mapped", [1591]], [[126633, 126633], "mapped", [1610]], [[126634, 126634], "disallowed"], [[126635, 126635], "mapped", [1604]], [[126636, 126636], "mapped", [1605]], [[126637, 126637], "mapped", [1606]], [[126638, 126638], "mapped", [1587]], [[126639, 126639], "mapped", [1593]], [[126640, 126640], "mapped", [1601]], [[126641, 126641], "mapped", [1589]], [[126642, 126642], "mapped", [1602]], [[126643, 126643], "mapped", [1585]], [[126644, 126644], "mapped", [1588]], [[126645, 126645], "mapped", [1578]], [[126646, 126646], "mapped", [1579]], [[126647, 126647], "mapped", [1582]], [[126648, 126648], "mapped", [1584]], [[126649, 126649], "mapped", [1590]], [[126650, 126650], "mapped", [1592]], [[126651, 126651], "mapped", [1594]], [[126652, 126703], "disallowed"], [[126704, 126705], "valid", [], "NV8"], [[126706, 126975], "disallowed"], [[126976, 127019], "valid", [], "NV8"], [[127020, 127023], "disallowed"], [[127024, 127123], "valid", [], "NV8"], [[127124, 127135], "disallowed"], [[127136, 127150], "valid", [], "NV8"], [[127151, 127152], "disallowed"], [[127153, 127166], "valid", [], "NV8"], [[127167, 127167], "valid", [], "NV8"], [[127168, 127168], "disallowed"], [[127169, 127183], "valid", [], "NV8"], [[127184, 127184], "disallowed"], [[127185, 127199], "valid", [], "NV8"], [[127200, 127221], "valid", [], "NV8"], [[127222, 127231], "disallowed"], [[127232, 127232], "disallowed"], [[127233, 127233], "disallowed_STD3_mapped", [48, 44]], [[127234, 127234], "disallowed_STD3_mapped", [49, 44]], [[127235, 127235], "disallowed_STD3_mapped", [50, 44]], [[127236, 127236], "disallowed_STD3_mapped", [51, 44]], [[127237, 127237], "disallowed_STD3_mapped", [52, 44]], [[127238, 127238], "disallowed_STD3_mapped", [53, 44]], [[127239, 127239], "disallowed_STD3_mapped", [54, 44]], [[127240, 127240], "disallowed_STD3_mapped", [55, 44]], [[127241, 127241], "disallowed_STD3_mapped", [56, 44]], [[127242, 127242], "disallowed_STD3_mapped", [57, 44]], [[127243, 127244], "valid", [], "NV8"], [[127245, 127247], "disallowed"], [[127248, 127248], "disallowed_STD3_mapped", [40, 97, 41]], [[127249, 127249], "disallowed_STD3_mapped", [40, 98, 41]], [[127250, 127250], "disallowed_STD3_mapped", [40, 99, 41]], [[127251, 127251], "disallowed_STD3_mapped", [40, 100, 41]], [[127252, 127252], "disallowed_STD3_mapped", [40, 101, 41]], [[127253, 127253], "disallowed_STD3_mapped", [40, 102, 41]], [[127254, 127254], "disallowed_STD3_mapped", [40, 103, 41]], [[127255, 127255], "disallowed_STD3_mapped", [40, 104, 41]], [[127256, 127256], "disallowed_STD3_mapped", [40, 105, 41]], [[127257, 127257], "disallowed_STD3_mapped", [40, 106, 41]], [[127258, 127258], "disallowed_STD3_mapped", [40, 107, 41]], [[127259, 127259], "disallowed_STD3_mapped", [40, 108, 41]], [[127260, 127260], "disallowed_STD3_mapped", [40, 109, 41]], [[127261, 127261], "disallowed_STD3_mapped", [40, 110, 41]], [[127262, 127262], "disallowed_STD3_mapped", [40, 111, 41]], [[127263, 127263], "disallowed_STD3_mapped", [40, 112, 41]], [[127264, 127264], "disallowed_STD3_mapped", [40, 113, 41]], [[127265, 127265], "disallowed_STD3_mapped", [40, 114, 41]], [[127266, 127266], "disallowed_STD3_mapped", [40, 115, 41]], [[127267, 127267], "disallowed_STD3_mapped", [40, 116, 41]], [[127268, 127268], "disallowed_STD3_mapped", [40, 117, 41]], [[127269, 127269], "disallowed_STD3_mapped", [40, 118, 41]], [[127270, 127270], "disallowed_STD3_mapped", [40, 119, 41]], [[127271, 127271], "disallowed_STD3_mapped", [40, 120, 41]], [[127272, 127272], "disallowed_STD3_mapped", [40, 121, 41]], [[127273, 127273], "disallowed_STD3_mapped", [40, 122, 41]], [[127274, 127274], "mapped", [12308, 115, 12309]], [[127275, 127275], "mapped", [99]], [[127276, 127276], "mapped", [114]], [[127277, 127277], "mapped", [99, 100]], [[127278, 127278], "mapped", [119, 122]], [[127279, 127279], "disallowed"], [[127280, 127280], "mapped", [97]], [[127281, 127281], "mapped", [98]], [[127282, 127282], "mapped", [99]], [[127283, 127283], "mapped", [100]], [[127284, 127284], "mapped", [101]], [[127285, 127285], "mapped", [102]], [[127286, 127286], "mapped", [103]], [[127287, 127287], "mapped", [104]], [[127288, 127288], "mapped", [105]], [[127289, 127289], "mapped", [106]], [[127290, 127290], "mapped", [107]], [[127291, 127291], "mapped", [108]], [[127292, 127292], "mapped", [109]], [[127293, 127293], "mapped", [110]], [[127294, 127294], "mapped", [111]], [[127295, 127295], "mapped", [112]], [[127296, 127296], "mapped", [113]], [[127297, 127297], "mapped", [114]], [[127298, 127298], "mapped", [115]], [[127299, 127299], "mapped", [116]], [[127300, 127300], "mapped", [117]], [[127301, 127301], "mapped", [118]], [[127302, 127302], "mapped", [119]], [[127303, 127303], "mapped", [120]], [[127304, 127304], "mapped", [121]], [[127305, 127305], "mapped", [122]], [[127306, 127306], "mapped", [104, 118]], [[127307, 127307], "mapped", [109, 118]], [[127308, 127308], "mapped", [115, 100]], [[127309, 127309], "mapped", [115, 115]], [[127310, 127310], "mapped", [112, 112, 118]], [[127311, 127311], "mapped", [119, 99]], [[127312, 127318], "valid", [], "NV8"], [[127319, 127319], "valid", [], "NV8"], [[127320, 127326], "valid", [], "NV8"], [[127327, 127327], "valid", [], "NV8"], [[127328, 127337], "valid", [], "NV8"], [[127338, 127338], "mapped", [109, 99]], [[127339, 127339], "mapped", [109, 100]], [[127340, 127343], "disallowed"], [[127344, 127352], "valid", [], "NV8"], [[127353, 127353], "valid", [], "NV8"], [[127354, 127354], "valid", [], "NV8"], [[127355, 127356], "valid", [], "NV8"], [[127357, 127358], "valid", [], "NV8"], [[127359, 127359], "valid", [], "NV8"], [[127360, 127369], "valid", [], "NV8"], [[127370, 127373], "valid", [], "NV8"], [[127374, 127375], "valid", [], "NV8"], [[127376, 127376], "mapped", [100, 106]], [[127377, 127386], "valid", [], "NV8"], [[127387, 127461], "disallowed"], [[127462, 127487], "valid", [], "NV8"], [[127488, 127488], "mapped", [12411, 12363]], [[127489, 127489], "mapped", [12467, 12467]], [[127490, 127490], "mapped", [12469]], [[127491, 127503], "disallowed"], [[127504, 127504], "mapped", [25163]], [[127505, 127505], "mapped", [23383]], [[127506, 127506], "mapped", [21452]], [[127507, 127507], "mapped", [12487]], [[127508, 127508], "mapped", [20108]], [[127509, 127509], "mapped", [22810]], [[127510, 127510], "mapped", [35299]], [[127511, 127511], "mapped", [22825]], [[127512, 127512], "mapped", [20132]], [[127513, 127513], "mapped", [26144]], [[127514, 127514], "mapped", [28961]], [[127515, 127515], "mapped", [26009]], [[127516, 127516], "mapped", [21069]], [[127517, 127517], "mapped", [24460]], [[127518, 127518], "mapped", [20877]], [[127519, 127519], "mapped", [26032]], [[127520, 127520], "mapped", [21021]], [[127521, 127521], "mapped", [32066]], [[127522, 127522], "mapped", [29983]], [[127523, 127523], "mapped", [36009]], [[127524, 127524], "mapped", [22768]], [[127525, 127525], "mapped", [21561]], [[127526, 127526], "mapped", [28436]], [[127527, 127527], "mapped", [25237]], [[127528, 127528], "mapped", [25429]], [[127529, 127529], "mapped", [19968]], [[127530, 127530], "mapped", [19977]], [[127531, 127531], "mapped", [36938]], [[127532, 127532], "mapped", [24038]], [[127533, 127533], "mapped", [20013]], [[127534, 127534], "mapped", [21491]], [[127535, 127535], "mapped", [25351]], [[127536, 127536], "mapped", [36208]], [[127537, 127537], "mapped", [25171]], [[127538, 127538], "mapped", [31105]], [[127539, 127539], "mapped", [31354]], [[127540, 127540], "mapped", [21512]], [[127541, 127541], "mapped", [28288]], [[127542, 127542], "mapped", [26377]], [[127543, 127543], "mapped", [26376]], [[127544, 127544], "mapped", [30003]], [[127545, 127545], "mapped", [21106]], [[127546, 127546], "mapped", [21942]], [[127547, 127551], "disallowed"], [[127552, 127552], "mapped", [12308, 26412, 12309]], [[127553, 127553], "mapped", [12308, 19977, 12309]], [[127554, 127554], "mapped", [12308, 20108, 12309]], [[127555, 127555], "mapped", [12308, 23433, 12309]], [[127556, 127556], "mapped", [12308, 28857, 12309]], [[127557, 127557], "mapped", [12308, 25171, 12309]], [[127558, 127558], "mapped", [12308, 30423, 12309]], [[127559, 127559], "mapped", [12308, 21213, 12309]], [[127560, 127560], "mapped", [12308, 25943, 12309]], [[127561, 127567], "disallowed"], [[127568, 127568], "mapped", [24471]], [[127569, 127569], "mapped", [21487]], [[127570, 127743], "disallowed"], [[127744, 127776], "valid", [], "NV8"], [[127777, 127788], "valid", [], "NV8"], [[127789, 127791], "valid", [], "NV8"], [[127792, 127797], "valid", [], "NV8"], [[127798, 127798], "valid", [], "NV8"], [[127799, 127868], "valid", [], "NV8"], [[127869, 127869], "valid", [], "NV8"], [[127870, 127871], "valid", [], "NV8"], [[127872, 127891], "valid", [], "NV8"], [[127892, 127903], "valid", [], "NV8"], [[127904, 127940], "valid", [], "NV8"], [[127941, 127941], "valid", [], "NV8"], [[127942, 127946], "valid", [], "NV8"], [[127947, 127950], "valid", [], "NV8"], [[127951, 127955], "valid", [], "NV8"], [[127956, 127967], "valid", [], "NV8"], [[127968, 127984], "valid", [], "NV8"], [[127985, 127991], "valid", [], "NV8"], [[127992, 127999], "valid", [], "NV8"], [[128e3, 128062], "valid", [], "NV8"], [[128063, 128063], "valid", [], "NV8"], [[128064, 128064], "valid", [], "NV8"], [[128065, 128065], "valid", [], "NV8"], [[128066, 128247], "valid", [], "NV8"], [[128248, 128248], "valid", [], "NV8"], [[128249, 128252], "valid", [], "NV8"], [[128253, 128254], "valid", [], "NV8"], [[128255, 128255], "valid", [], "NV8"], [[128256, 128317], "valid", [], "NV8"], [[128318, 128319], "valid", [], "NV8"], [[128320, 128323], "valid", [], "NV8"], [[128324, 128330], "valid", [], "NV8"], [[128331, 128335], "valid", [], "NV8"], [[128336, 128359], "valid", [], "NV8"], [[128360, 128377], "valid", [], "NV8"], [[128378, 128378], "disallowed"], [[128379, 128419], "valid", [], "NV8"], [[128420, 128420], "disallowed"], [[128421, 128506], "valid", [], "NV8"], [[128507, 128511], "valid", [], "NV8"], [[128512, 128512], "valid", [], "NV8"], [[128513, 128528], "valid", [], "NV8"], [[128529, 128529], "valid", [], "NV8"], [[128530, 128532], "valid", [], "NV8"], [[128533, 128533], "valid", [], "NV8"], [[128534, 128534], "valid", [], "NV8"], [[128535, 128535], "valid", [], "NV8"], [[128536, 128536], "valid", [], "NV8"], [[128537, 128537], "valid", [], "NV8"], [[128538, 128538], "valid", [], "NV8"], [[128539, 128539], "valid", [], "NV8"], [[128540, 128542], "valid", [], "NV8"], [[128543, 128543], "valid", [], "NV8"], [[128544, 128549], "valid", [], "NV8"], [[128550, 128551], "valid", [], "NV8"], [[128552, 128555], "valid", [], "NV8"], [[128556, 128556], "valid", [], "NV8"], [[128557, 128557], "valid", [], "NV8"], [[128558, 128559], "valid", [], "NV8"], [[128560, 128563], "valid", [], "NV8"], [[128564, 128564], "valid", [], "NV8"], [[128565, 128576], "valid", [], "NV8"], [[128577, 128578], "valid", [], "NV8"], [[128579, 128580], "valid", [], "NV8"], [[128581, 128591], "valid", [], "NV8"], [[128592, 128639], "valid", [], "NV8"], [[128640, 128709], "valid", [], "NV8"], [[128710, 128719], "valid", [], "NV8"], [[128720, 128720], "valid", [], "NV8"], [[128721, 128735], "disallowed"], [[128736, 128748], "valid", [], "NV8"], [[128749, 128751], "disallowed"], [[128752, 128755], "valid", [], "NV8"], [[128756, 128767], "disallowed"], [[128768, 128883], "valid", [], "NV8"], [[128884, 128895], "disallowed"], [[128896, 128980], "valid", [], "NV8"], [[128981, 129023], "disallowed"], [[129024, 129035], "valid", [], "NV8"], [[129036, 129039], "disallowed"], [[129040, 129095], "valid", [], "NV8"], [[129096, 129103], "disallowed"], [[129104, 129113], "valid", [], "NV8"], [[129114, 129119], "disallowed"], [[129120, 129159], "valid", [], "NV8"], [[129160, 129167], "disallowed"], [[129168, 129197], "valid", [], "NV8"], [[129198, 129295], "disallowed"], [[129296, 129304], "valid", [], "NV8"], [[129305, 129407], "disallowed"], [[129408, 129412], "valid", [], "NV8"], [[129413, 129471], "disallowed"], [[129472, 129472], "valid", [], "NV8"], [[129473, 131069], "disallowed"], [[131070, 131071], "disallowed"], [[131072, 173782], "valid"], [[173783, 173823], "disallowed"], [[173824, 177972], "valid"], [[177973, 177983], "disallowed"], [[177984, 178205], "valid"], [[178206, 178207], "disallowed"], [[178208, 183969], "valid"], [[183970, 194559], "disallowed"], [[194560, 194560], "mapped", [20029]], [[194561, 194561], "mapped", [20024]], [[194562, 194562], "mapped", [20033]], [[194563, 194563], "mapped", [131362]], [[194564, 194564], "mapped", [20320]], [[194565, 194565], "mapped", [20398]], [[194566, 194566], "mapped", [20411]], [[194567, 194567], "mapped", [20482]], [[194568, 194568], "mapped", [20602]], [[194569, 194569], "mapped", [20633]], [[194570, 194570], "mapped", [20711]], [[194571, 194571], "mapped", [20687]], [[194572, 194572], "mapped", [13470]], [[194573, 194573], "mapped", [132666]], [[194574, 194574], "mapped", [20813]], [[194575, 194575], "mapped", [20820]], [[194576, 194576], "mapped", [20836]], [[194577, 194577], "mapped", [20855]], [[194578, 194578], "mapped", [132380]], [[194579, 194579], "mapped", [13497]], [[194580, 194580], "mapped", [20839]], [[194581, 194581], "mapped", [20877]], [[194582, 194582], "mapped", [132427]], [[194583, 194583], "mapped", [20887]], [[194584, 194584], "mapped", [20900]], [[194585, 194585], "mapped", [20172]], [[194586, 194586], "mapped", [20908]], [[194587, 194587], "mapped", [20917]], [[194588, 194588], "mapped", [168415]], [[194589, 194589], "mapped", [20981]], [[194590, 194590], "mapped", [20995]], [[194591, 194591], "mapped", [13535]], [[194592, 194592], "mapped", [21051]], [[194593, 194593], "mapped", [21062]], [[194594, 194594], "mapped", [21106]], [[194595, 194595], "mapped", [21111]], [[194596, 194596], "mapped", [13589]], [[194597, 194597], "mapped", [21191]], [[194598, 194598], "mapped", [21193]], [[194599, 194599], "mapped", [21220]], [[194600, 194600], "mapped", [21242]], [[194601, 194601], "mapped", [21253]], [[194602, 194602], "mapped", [21254]], [[194603, 194603], "mapped", [21271]], [[194604, 194604], "mapped", [21321]], [[194605, 194605], "mapped", [21329]], [[194606, 194606], "mapped", [21338]], [[194607, 194607], "mapped", [21363]], [[194608, 194608], "mapped", [21373]], [[194609, 194611], "mapped", [21375]], [[194612, 194612], "mapped", [133676]], [[194613, 194613], "mapped", [28784]], [[194614, 194614], "mapped", [21450]], [[194615, 194615], "mapped", [21471]], [[194616, 194616], "mapped", [133987]], [[194617, 194617], "mapped", [21483]], [[194618, 194618], "mapped", [21489]], [[194619, 194619], "mapped", [21510]], [[194620, 194620], "mapped", [21662]], [[194621, 194621], "mapped", [21560]], [[194622, 194622], "mapped", [21576]], [[194623, 194623], "mapped", [21608]], [[194624, 194624], "mapped", [21666]], [[194625, 194625], "mapped", [21750]], [[194626, 194626], "mapped", [21776]], [[194627, 194627], "mapped", [21843]], [[194628, 194628], "mapped", [21859]], [[194629, 194630], "mapped", [21892]], [[194631, 194631], "mapped", [21913]], [[194632, 194632], "mapped", [21931]], [[194633, 194633], "mapped", [21939]], [[194634, 194634], "mapped", [21954]], [[194635, 194635], "mapped", [22294]], [[194636, 194636], "mapped", [22022]], [[194637, 194637], "mapped", [22295]], [[194638, 194638], "mapped", [22097]], [[194639, 194639], "mapped", [22132]], [[194640, 194640], "mapped", [20999]], [[194641, 194641], "mapped", [22766]], [[194642, 194642], "mapped", [22478]], [[194643, 194643], "mapped", [22516]], [[194644, 194644], "mapped", [22541]], [[194645, 194645], "mapped", [22411]], [[194646, 194646], "mapped", [22578]], [[194647, 194647], "mapped", [22577]], [[194648, 194648], "mapped", [22700]], [[194649, 194649], "mapped", [136420]], [[194650, 194650], "mapped", [22770]], [[194651, 194651], "mapped", [22775]], [[194652, 194652], "mapped", [22790]], [[194653, 194653], "mapped", [22810]], [[194654, 194654], "mapped", [22818]], [[194655, 194655], "mapped", [22882]], [[194656, 194656], "mapped", [136872]], [[194657, 194657], "mapped", [136938]], [[194658, 194658], "mapped", [23020]], [[194659, 194659], "mapped", [23067]], [[194660, 194660], "mapped", [23079]], [[194661, 194661], "mapped", [23e3]], [[194662, 194662], "mapped", [23142]], [[194663, 194663], "mapped", [14062]], [[194664, 194664], "disallowed"], [[194665, 194665], "mapped", [23304]], [[194666, 194667], "mapped", [23358]], [[194668, 194668], "mapped", [137672]], [[194669, 194669], "mapped", [23491]], [[194670, 194670], "mapped", [23512]], [[194671, 194671], "mapped", [23527]], [[194672, 194672], "mapped", [23539]], [[194673, 194673], "mapped", [138008]], [[194674, 194674], "mapped", [23551]], [[194675, 194675], "mapped", [23558]], [[194676, 194676], "disallowed"], [[194677, 194677], "mapped", [23586]], [[194678, 194678], "mapped", [14209]], [[194679, 194679], "mapped", [23648]], [[194680, 194680], "mapped", [23662]], [[194681, 194681], "mapped", [23744]], [[194682, 194682], "mapped", [23693]], [[194683, 194683], "mapped", [138724]], [[194684, 194684], "mapped", [23875]], [[194685, 194685], "mapped", [138726]], [[194686, 194686], "mapped", [23918]], [[194687, 194687], "mapped", [23915]], [[194688, 194688], "mapped", [23932]], [[194689, 194689], "mapped", [24033]], [[194690, 194690], "mapped", [24034]], [[194691, 194691], "mapped", [14383]], [[194692, 194692], "mapped", [24061]], [[194693, 194693], "mapped", [24104]], [[194694, 194694], "mapped", [24125]], [[194695, 194695], "mapped", [24169]], [[194696, 194696], "mapped", [14434]], [[194697, 194697], "mapped", [139651]], [[194698, 194698], "mapped", [14460]], [[194699, 194699], "mapped", [24240]], [[194700, 194700], "mapped", [24243]], [[194701, 194701], "mapped", [24246]], [[194702, 194702], "mapped", [24266]], [[194703, 194703], "mapped", [172946]], [[194704, 194704], "mapped", [24318]], [[194705, 194706], "mapped", [140081]], [[194707, 194707], "mapped", [33281]], [[194708, 194709], "mapped", [24354]], [[194710, 194710], "mapped", [14535]], [[194711, 194711], "mapped", [144056]], [[194712, 194712], "mapped", [156122]], [[194713, 194713], "mapped", [24418]], [[194714, 194714], "mapped", [24427]], [[194715, 194715], "mapped", [14563]], [[194716, 194716], "mapped", [24474]], [[194717, 194717], "mapped", [24525]], [[194718, 194718], "mapped", [24535]], [[194719, 194719], "mapped", [24569]], [[194720, 194720], "mapped", [24705]], [[194721, 194721], "mapped", [14650]], [[194722, 194722], "mapped", [14620]], [[194723, 194723], "mapped", [24724]], [[194724, 194724], "mapped", [141012]], [[194725, 194725], "mapped", [24775]], [[194726, 194726], "mapped", [24904]], [[194727, 194727], "mapped", [24908]], [[194728, 194728], "mapped", [24910]], [[194729, 194729], "mapped", [24908]], [[194730, 194730], "mapped", [24954]], [[194731, 194731], "mapped", [24974]], [[194732, 194732], "mapped", [25010]], [[194733, 194733], "mapped", [24996]], [[194734, 194734], "mapped", [25007]], [[194735, 194735], "mapped", [25054]], [[194736, 194736], "mapped", [25074]], [[194737, 194737], "mapped", [25078]], [[194738, 194738], "mapped", [25104]], [[194739, 194739], "mapped", [25115]], [[194740, 194740], "mapped", [25181]], [[194741, 194741], "mapped", [25265]], [[194742, 194742], "mapped", [25300]], [[194743, 194743], "mapped", [25424]], [[194744, 194744], "mapped", [142092]], [[194745, 194745], "mapped", [25405]], [[194746, 194746], "mapped", [25340]], [[194747, 194747], "mapped", [25448]], [[194748, 194748], "mapped", [25475]], [[194749, 194749], "mapped", [25572]], [[194750, 194750], "mapped", [142321]], [[194751, 194751], "mapped", [25634]], [[194752, 194752], "mapped", [25541]], [[194753, 194753], "mapped", [25513]], [[194754, 194754], "mapped", [14894]], [[194755, 194755], "mapped", [25705]], [[194756, 194756], "mapped", [25726]], [[194757, 194757], "mapped", [25757]], [[194758, 194758], "mapped", [25719]], [[194759, 194759], "mapped", [14956]], [[194760, 194760], "mapped", [25935]], [[194761, 194761], "mapped", [25964]], [[194762, 194762], "mapped", [143370]], [[194763, 194763], "mapped", [26083]], [[194764, 194764], "mapped", [26360]], [[194765, 194765], "mapped", [26185]], [[194766, 194766], "mapped", [15129]], [[194767, 194767], "mapped", [26257]], [[194768, 194768], "mapped", [15112]], [[194769, 194769], "mapped", [15076]], [[194770, 194770], "mapped", [20882]], [[194771, 194771], "mapped", [20885]], [[194772, 194772], "mapped", [26368]], [[194773, 194773], "mapped", [26268]], [[194774, 194774], "mapped", [32941]], [[194775, 194775], "mapped", [17369]], [[194776, 194776], "mapped", [26391]], [[194777, 194777], "mapped", [26395]], [[194778, 194778], "mapped", [26401]], [[194779, 194779], "mapped", [26462]], [[194780, 194780], "mapped", [26451]], [[194781, 194781], "mapped", [144323]], [[194782, 194782], "mapped", [15177]], [[194783, 194783], "mapped", [26618]], [[194784, 194784], "mapped", [26501]], [[194785, 194785], "mapped", [26706]], [[194786, 194786], "mapped", [26757]], [[194787, 194787], "mapped", [144493]], [[194788, 194788], "mapped", [26766]], [[194789, 194789], "mapped", [26655]], [[194790, 194790], "mapped", [26900]], [[194791, 194791], "mapped", [15261]], [[194792, 194792], "mapped", [26946]], [[194793, 194793], "mapped", [27043]], [[194794, 194794], "mapped", [27114]], [[194795, 194795], "mapped", [27304]], [[194796, 194796], "mapped", [145059]], [[194797, 194797], "mapped", [27355]], [[194798, 194798], "mapped", [15384]], [[194799, 194799], "mapped", [27425]], [[194800, 194800], "mapped", [145575]], [[194801, 194801], "mapped", [27476]], [[194802, 194802], "mapped", [15438]], [[194803, 194803], "mapped", [27506]], [[194804, 194804], "mapped", [27551]], [[194805, 194805], "mapped", [27578]], [[194806, 194806], "mapped", [27579]], [[194807, 194807], "mapped", [146061]], [[194808, 194808], "mapped", [138507]], [[194809, 194809], "mapped", [146170]], [[194810, 194810], "mapped", [27726]], [[194811, 194811], "mapped", [146620]], [[194812, 194812], "mapped", [27839]], [[194813, 194813], "mapped", [27853]], [[194814, 194814], "mapped", [27751]], [[194815, 194815], "mapped", [27926]], [[194816, 194816], "mapped", [27966]], [[194817, 194817], "mapped", [28023]], [[194818, 194818], "mapped", [27969]], [[194819, 194819], "mapped", [28009]], [[194820, 194820], "mapped", [28024]], [[194821, 194821], "mapped", [28037]], [[194822, 194822], "mapped", [146718]], [[194823, 194823], "mapped", [27956]], [[194824, 194824], "mapped", [28207]], [[194825, 194825], "mapped", [28270]], [[194826, 194826], "mapped", [15667]], [[194827, 194827], "mapped", [28363]], [[194828, 194828], "mapped", [28359]], [[194829, 194829], "mapped", [147153]], [[194830, 194830], "mapped", [28153]], [[194831, 194831], "mapped", [28526]], [[194832, 194832], "mapped", [147294]], [[194833, 194833], "mapped", [147342]], [[194834, 194834], "mapped", [28614]], [[194835, 194835], "mapped", [28729]], [[194836, 194836], "mapped", [28702]], [[194837, 194837], "mapped", [28699]], [[194838, 194838], "mapped", [15766]], [[194839, 194839], "mapped", [28746]], [[194840, 194840], "mapped", [28797]], [[194841, 194841], "mapped", [28791]], [[194842, 194842], "mapped", [28845]], [[194843, 194843], "mapped", [132389]], [[194844, 194844], "mapped", [28997]], [[194845, 194845], "mapped", [148067]], [[194846, 194846], "mapped", [29084]], [[194847, 194847], "disallowed"], [[194848, 194848], "mapped", [29224]], [[194849, 194849], "mapped", [29237]], [[194850, 194850], "mapped", [29264]], [[194851, 194851], "mapped", [149e3]], [[194852, 194852], "mapped", [29312]], [[194853, 194853], "mapped", [29333]], [[194854, 194854], "mapped", [149301]], [[194855, 194855], "mapped", [149524]], [[194856, 194856], "mapped", [29562]], [[194857, 194857], "mapped", [29579]], [[194858, 194858], "mapped", [16044]], [[194859, 194859], "mapped", [29605]], [[194860, 194861], "mapped", [16056]], [[194862, 194862], "mapped", [29767]], [[194863, 194863], "mapped", [29788]], [[194864, 194864], "mapped", [29809]], [[194865, 194865], "mapped", [29829]], [[194866, 194866], "mapped", [29898]], [[194867, 194867], "mapped", [16155]], [[194868, 194868], "mapped", [29988]], [[194869, 194869], "mapped", [150582]], [[194870, 194870], "mapped", [30014]], [[194871, 194871], "mapped", [150674]], [[194872, 194872], "mapped", [30064]], [[194873, 194873], "mapped", [139679]], [[194874, 194874], "mapped", [30224]], [[194875, 194875], "mapped", [151457]], [[194876, 194876], "mapped", [151480]], [[194877, 194877], "mapped", [151620]], [[194878, 194878], "mapped", [16380]], [[194879, 194879], "mapped", [16392]], [[194880, 194880], "mapped", [30452]], [[194881, 194881], "mapped", [151795]], [[194882, 194882], "mapped", [151794]], [[194883, 194883], "mapped", [151833]], [[194884, 194884], "mapped", [151859]], [[194885, 194885], "mapped", [30494]], [[194886, 194887], "mapped", [30495]], [[194888, 194888], "mapped", [30538]], [[194889, 194889], "mapped", [16441]], [[194890, 194890], "mapped", [30603]], [[194891, 194891], "mapped", [16454]], [[194892, 194892], "mapped", [16534]], [[194893, 194893], "mapped", [152605]], [[194894, 194894], "mapped", [30798]], [[194895, 194895], "mapped", [30860]], [[194896, 194896], "mapped", [30924]], [[194897, 194897], "mapped", [16611]], [[194898, 194898], "mapped", [153126]], [[194899, 194899], "mapped", [31062]], [[194900, 194900], "mapped", [153242]], [[194901, 194901], "mapped", [153285]], [[194902, 194902], "mapped", [31119]], [[194903, 194903], "mapped", [31211]], [[194904, 194904], "mapped", [16687]], [[194905, 194905], "mapped", [31296]], [[194906, 194906], "mapped", [31306]], [[194907, 194907], "mapped", [31311]], [[194908, 194908], "mapped", [153980]], [[194909, 194910], "mapped", [154279]], [[194911, 194911], "disallowed"], [[194912, 194912], "mapped", [16898]], [[194913, 194913], "mapped", [154539]], [[194914, 194914], "mapped", [31686]], [[194915, 194915], "mapped", [31689]], [[194916, 194916], "mapped", [16935]], [[194917, 194917], "mapped", [154752]], [[194918, 194918], "mapped", [31954]], [[194919, 194919], "mapped", [17056]], [[194920, 194920], "mapped", [31976]], [[194921, 194921], "mapped", [31971]], [[194922, 194922], "mapped", [32e3]], [[194923, 194923], "mapped", [155526]], [[194924, 194924], "mapped", [32099]], [[194925, 194925], "mapped", [17153]], [[194926, 194926], "mapped", [32199]], [[194927, 194927], "mapped", [32258]], [[194928, 194928], "mapped", [32325]], [[194929, 194929], "mapped", [17204]], [[194930, 194930], "mapped", [156200]], [[194931, 194931], "mapped", [156231]], [[194932, 194932], "mapped", [17241]], [[194933, 194933], "mapped", [156377]], [[194934, 194934], "mapped", [32634]], [[194935, 194935], "mapped", [156478]], [[194936, 194936], "mapped", [32661]], [[194937, 194937], "mapped", [32762]], [[194938, 194938], "mapped", [32773]], [[194939, 194939], "mapped", [156890]], [[194940, 194940], "mapped", [156963]], [[194941, 194941], "mapped", [32864]], [[194942, 194942], "mapped", [157096]], [[194943, 194943], "mapped", [32880]], [[194944, 194944], "mapped", [144223]], [[194945, 194945], "mapped", [17365]], [[194946, 194946], "mapped", [32946]], [[194947, 194947], "mapped", [33027]], [[194948, 194948], "mapped", [17419]], [[194949, 194949], "mapped", [33086]], [[194950, 194950], "mapped", [23221]], [[194951, 194951], "mapped", [157607]], [[194952, 194952], "mapped", [157621]], [[194953, 194953], "mapped", [144275]], [[194954, 194954], "mapped", [144284]], [[194955, 194955], "mapped", [33281]], [[194956, 194956], "mapped", [33284]], [[194957, 194957], "mapped", [36766]], [[194958, 194958], "mapped", [17515]], [[194959, 194959], "mapped", [33425]], [[194960, 194960], "mapped", [33419]], [[194961, 194961], "mapped", [33437]], [[194962, 194962], "mapped", [21171]], [[194963, 194963], "mapped", [33457]], [[194964, 194964], "mapped", [33459]], [[194965, 194965], "mapped", [33469]], [[194966, 194966], "mapped", [33510]], [[194967, 194967], "mapped", [158524]], [[194968, 194968], "mapped", [33509]], [[194969, 194969], "mapped", [33565]], [[194970, 194970], "mapped", [33635]], [[194971, 194971], "mapped", [33709]], [[194972, 194972], "mapped", [33571]], [[194973, 194973], "mapped", [33725]], [[194974, 194974], "mapped", [33767]], [[194975, 194975], "mapped", [33879]], [[194976, 194976], "mapped", [33619]], [[194977, 194977], "mapped", [33738]], [[194978, 194978], "mapped", [33740]], [[194979, 194979], "mapped", [33756]], [[194980, 194980], "mapped", [158774]], [[194981, 194981], "mapped", [159083]], [[194982, 194982], "mapped", [158933]], [[194983, 194983], "mapped", [17707]], [[194984, 194984], "mapped", [34033]], [[194985, 194985], "mapped", [34035]], [[194986, 194986], "mapped", [34070]], [[194987, 194987], "mapped", [160714]], [[194988, 194988], "mapped", [34148]], [[194989, 194989], "mapped", [159532]], [[194990, 194990], "mapped", [17757]], [[194991, 194991], "mapped", [17761]], [[194992, 194992], "mapped", [159665]], [[194993, 194993], "mapped", [159954]], [[194994, 194994], "mapped", [17771]], [[194995, 194995], "mapped", [34384]], [[194996, 194996], "mapped", [34396]], [[194997, 194997], "mapped", [34407]], [[194998, 194998], "mapped", [34409]], [[194999, 194999], "mapped", [34473]], [[195e3, 195e3], "mapped", [34440]], [[195001, 195001], "mapped", [34574]], [[195002, 195002], "mapped", [34530]], [[195003, 195003], "mapped", [34681]], [[195004, 195004], "mapped", [34600]], [[195005, 195005], "mapped", [34667]], [[195006, 195006], "mapped", [34694]], [[195007, 195007], "disallowed"], [[195008, 195008], "mapped", [34785]], [[195009, 195009], "mapped", [34817]], [[195010, 195010], "mapped", [17913]], [[195011, 195011], "mapped", [34912]], [[195012, 195012], "mapped", [34915]], [[195013, 195013], "mapped", [161383]], [[195014, 195014], "mapped", [35031]], [[195015, 195015], "mapped", [35038]], [[195016, 195016], "mapped", [17973]], [[195017, 195017], "mapped", [35066]], [[195018, 195018], "mapped", [13499]], [[195019, 195019], "mapped", [161966]], [[195020, 195020], "mapped", [162150]], [[195021, 195021], "mapped", [18110]], [[195022, 195022], "mapped", [18119]], [[195023, 195023], "mapped", [35488]], [[195024, 195024], "mapped", [35565]], [[195025, 195025], "mapped", [35722]], [[195026, 195026], "mapped", [35925]], [[195027, 195027], "mapped", [162984]], [[195028, 195028], "mapped", [36011]], [[195029, 195029], "mapped", [36033]], [[195030, 195030], "mapped", [36123]], [[195031, 195031], "mapped", [36215]], [[195032, 195032], "mapped", [163631]], [[195033, 195033], "mapped", [133124]], [[195034, 195034], "mapped", [36299]], [[195035, 195035], "mapped", [36284]], [[195036, 195036], "mapped", [36336]], [[195037, 195037], "mapped", [133342]], [[195038, 195038], "mapped", [36564]], [[195039, 195039], "mapped", [36664]], [[195040, 195040], "mapped", [165330]], [[195041, 195041], "mapped", [165357]], [[195042, 195042], "mapped", [37012]], [[195043, 195043], "mapped", [37105]], [[195044, 195044], "mapped", [37137]], [[195045, 195045], "mapped", [165678]], [[195046, 195046], "mapped", [37147]], [[195047, 195047], "mapped", [37432]], [[195048, 195048], "mapped", [37591]], [[195049, 195049], "mapped", [37592]], [[195050, 195050], "mapped", [37500]], [[195051, 195051], "mapped", [37881]], [[195052, 195052], "mapped", [37909]], [[195053, 195053], "mapped", [166906]], [[195054, 195054], "mapped", [38283]], [[195055, 195055], "mapped", [18837]], [[195056, 195056], "mapped", [38327]], [[195057, 195057], "mapped", [167287]], [[195058, 195058], "mapped", [18918]], [[195059, 195059], "mapped", [38595]], [[195060, 195060], "mapped", [23986]], [[195061, 195061], "mapped", [38691]], [[195062, 195062], "mapped", [168261]], [[195063, 195063], "mapped", [168474]], [[195064, 195064], "mapped", [19054]], [[195065, 195065], "mapped", [19062]], [[195066, 195066], "mapped", [38880]], [[195067, 195067], "mapped", [168970]], [[195068, 195068], "mapped", [19122]], [[195069, 195069], "mapped", [169110]], [[195070, 195071], "mapped", [38923]], [[195072, 195072], "mapped", [38953]], [[195073, 195073], "mapped", [169398]], [[195074, 195074], "mapped", [39138]], [[195075, 195075], "mapped", [19251]], [[195076, 195076], "mapped", [39209]], [[195077, 195077], "mapped", [39335]], [[195078, 195078], "mapped", [39362]], [[195079, 195079], "mapped", [39422]], [[195080, 195080], "mapped", [19406]], [[195081, 195081], "mapped", [170800]], [[195082, 195082], "mapped", [39698]], [[195083, 195083], "mapped", [4e4]], [[195084, 195084], "mapped", [40189]], [[195085, 195085], "mapped", [19662]], [[195086, 195086], "mapped", [19693]], [[195087, 195087], "mapped", [40295]], [[195088, 195088], "mapped", [172238]], [[195089, 195089], "mapped", [19704]], [[195090, 195090], "mapped", [172293]], [[195091, 195091], "mapped", [172558]], [[195092, 195092], "mapped", [172689]], [[195093, 195093], "mapped", [40635]], [[195094, 195094], "mapped", [19798]], [[195095, 195095], "mapped", [40697]], [[195096, 195096], "mapped", [40702]], [[195097, 195097], "mapped", [40709]], [[195098, 195098], "mapped", [40719]], [[195099, 195099], "mapped", [40726]], [[195100, 195100], "mapped", [40763]], [[195101, 195101], "mapped", [173568]], [[195102, 196605], "disallowed"], [[196606, 196607], "disallowed"], [[196608, 262141], "disallowed"], [[262142, 262143], "disallowed"], [[262144, 327677], "disallowed"], [[327678, 327679], "disallowed"], [[327680, 393213], "disallowed"], [[393214, 393215], "disallowed"], [[393216, 458749], "disallowed"], [[458750, 458751], "disallowed"], [[458752, 524285], "disallowed"], [[524286, 524287], "disallowed"], [[524288, 589821], "disallowed"], [[589822, 589823], "disallowed"], [[589824, 655357], "disallowed"], [[655358, 655359], "disallowed"], [[655360, 720893], "disallowed"], [[720894, 720895], "disallowed"], [[720896, 786429], "disallowed"], [[786430, 786431], "disallowed"], [[786432, 851965], "disallowed"], [[851966, 851967], "disallowed"], [[851968, 917501], "disallowed"], [[917502, 917503], "disallowed"], [[917504, 917504], "disallowed"], [[917505, 917505], "disallowed"], [[917506, 917535], "disallowed"], [[917536, 917631], "disallowed"], [[917632, 917759], "disallowed"], [[917760, 917999], "ignored"], [[918e3, 983037], "disallowed"], [[983038, 983039], "disallowed"], [[983040, 1048573], "disallowed"], [[1048574, 1048575], "disallowed"], [[1048576, 1114109], "disallowed"], [[1114110, 1114111], "disallowed"]];
  }
});

// ../../../node_modules/.pnpm/tr46@0.0.3/node_modules/tr46/index.js
var require_tr46 = __commonJS({
  "../../../node_modules/.pnpm/tr46@0.0.3/node_modules/tr46/index.js"(exports2, module2) {
    "use strict";
    var punycode = require("punycode");
    var mappingTable = require_mappingTable();
    var PROCESSING_OPTIONS = {
      TRANSITIONAL: 0,
      NONTRANSITIONAL: 1
    };
    function normalize2(str2) {
      return str2.split("\0").map(function (s) {
        return s.normalize("NFC");
      }).join("\0");
    }
    function findStatus(val) {
      var start = 0;
      var end = mappingTable.length - 1;
      while (start <= end) {
        var mid = Math.floor((start + end) / 2);
        var target = mappingTable[mid];
        if (target[0][0] <= val && target[0][1] >= val) {
          return target;
        } else if (target[0][0] > val) {
          end = mid - 1;
        } else {
          start = mid + 1;
        }
      }
      return null;
    }
    var regexAstralSymbols = /[\uD800-\uDBFF][\uDC00-\uDFFF]/g;
    function countSymbols(string3) {
      return string3.replace(regexAstralSymbols, "_").length;
    }
    function mapChars(domain_name, useSTD3, processing_option) {
      var hasError = false;
      var processed = "";
      var len = countSymbols(domain_name);
      for (var i = 0; i < len; ++i) {
        var codePoint = domain_name.codePointAt(i);
        var status = findStatus(codePoint);
        switch (status[1]) {
          case "disallowed":
            hasError = true;
            processed += String.fromCodePoint(codePoint);
            break;
          case "ignored":
            break;
          case "mapped":
            processed += String.fromCodePoint.apply(String, status[2]);
            break;
          case "deviation":
            if (processing_option === PROCESSING_OPTIONS.TRANSITIONAL) {
              processed += String.fromCodePoint.apply(String, status[2]);
            } else {
              processed += String.fromCodePoint(codePoint);
            }
            break;
          case "valid":
            processed += String.fromCodePoint(codePoint);
            break;
          case "disallowed_STD3_mapped":
            if (useSTD3) {
              hasError = true;
              processed += String.fromCodePoint(codePoint);
            } else {
              processed += String.fromCodePoint.apply(String, status[2]);
            }
            break;
          case "disallowed_STD3_valid":
            if (useSTD3) {
              hasError = true;
            }
            processed += String.fromCodePoint(codePoint);
            break;
        }
      }
      return {
        string: processed,
        error: hasError
      };
    }
    var combiningMarksRegex = /[\u0300-\u036F\u0483-\u0489\u0591-\u05BD\u05BF\u05C1\u05C2\u05C4\u05C5\u05C7\u0610-\u061A\u064B-\u065F\u0670\u06D6-\u06DC\u06DF-\u06E4\u06E7\u06E8\u06EA-\u06ED\u0711\u0730-\u074A\u07A6-\u07B0\u07EB-\u07F3\u0816-\u0819\u081B-\u0823\u0825-\u0827\u0829-\u082D\u0859-\u085B\u08E4-\u0903\u093A-\u093C\u093E-\u094F\u0951-\u0957\u0962\u0963\u0981-\u0983\u09BC\u09BE-\u09C4\u09C7\u09C8\u09CB-\u09CD\u09D7\u09E2\u09E3\u0A01-\u0A03\u0A3C\u0A3E-\u0A42\u0A47\u0A48\u0A4B-\u0A4D\u0A51\u0A70\u0A71\u0A75\u0A81-\u0A83\u0ABC\u0ABE-\u0AC5\u0AC7-\u0AC9\u0ACB-\u0ACD\u0AE2\u0AE3\u0B01-\u0B03\u0B3C\u0B3E-\u0B44\u0B47\u0B48\u0B4B-\u0B4D\u0B56\u0B57\u0B62\u0B63\u0B82\u0BBE-\u0BC2\u0BC6-\u0BC8\u0BCA-\u0BCD\u0BD7\u0C00-\u0C03\u0C3E-\u0C44\u0C46-\u0C48\u0C4A-\u0C4D\u0C55\u0C56\u0C62\u0C63\u0C81-\u0C83\u0CBC\u0CBE-\u0CC4\u0CC6-\u0CC8\u0CCA-\u0CCD\u0CD5\u0CD6\u0CE2\u0CE3\u0D01-\u0D03\u0D3E-\u0D44\u0D46-\u0D48\u0D4A-\u0D4D\u0D57\u0D62\u0D63\u0D82\u0D83\u0DCA\u0DCF-\u0DD4\u0DD6\u0DD8-\u0DDF\u0DF2\u0DF3\u0E31\u0E34-\u0E3A\u0E47-\u0E4E\u0EB1\u0EB4-\u0EB9\u0EBB\u0EBC\u0EC8-\u0ECD\u0F18\u0F19\u0F35\u0F37\u0F39\u0F3E\u0F3F\u0F71-\u0F84\u0F86\u0F87\u0F8D-\u0F97\u0F99-\u0FBC\u0FC6\u102B-\u103E\u1056-\u1059\u105E-\u1060\u1062-\u1064\u1067-\u106D\u1071-\u1074\u1082-\u108D\u108F\u109A-\u109D\u135D-\u135F\u1712-\u1714\u1732-\u1734\u1752\u1753\u1772\u1773\u17B4-\u17D3\u17DD\u180B-\u180D\u18A9\u1920-\u192B\u1930-\u193B\u19B0-\u19C0\u19C8\u19C9\u1A17-\u1A1B\u1A55-\u1A5E\u1A60-\u1A7C\u1A7F\u1AB0-\u1ABE\u1B00-\u1B04\u1B34-\u1B44\u1B6B-\u1B73\u1B80-\u1B82\u1BA1-\u1BAD\u1BE6-\u1BF3\u1C24-\u1C37\u1CD0-\u1CD2\u1CD4-\u1CE8\u1CED\u1CF2-\u1CF4\u1CF8\u1CF9\u1DC0-\u1DF5\u1DFC-\u1DFF\u20D0-\u20F0\u2CEF-\u2CF1\u2D7F\u2DE0-\u2DFF\u302A-\u302F\u3099\u309A\uA66F-\uA672\uA674-\uA67D\uA69F\uA6F0\uA6F1\uA802\uA806\uA80B\uA823-\uA827\uA880\uA881\uA8B4-\uA8C4\uA8E0-\uA8F1\uA926-\uA92D\uA947-\uA953\uA980-\uA983\uA9B3-\uA9C0\uA9E5\uAA29-\uAA36\uAA43\uAA4C\uAA4D\uAA7B-\uAA7D\uAAB0\uAAB2-\uAAB4\uAAB7\uAAB8\uAABE\uAABF\uAAC1\uAAEB-\uAAEF\uAAF5\uAAF6\uABE3-\uABEA\uABEC\uABED\uFB1E\uFE00-\uFE0F\uFE20-\uFE2D]|\uD800[\uDDFD\uDEE0\uDF76-\uDF7A]|\uD802[\uDE01-\uDE03\uDE05\uDE06\uDE0C-\uDE0F\uDE38-\uDE3A\uDE3F\uDEE5\uDEE6]|\uD804[\uDC00-\uDC02\uDC38-\uDC46\uDC7F-\uDC82\uDCB0-\uDCBA\uDD00-\uDD02\uDD27-\uDD34\uDD73\uDD80-\uDD82\uDDB3-\uDDC0\uDE2C-\uDE37\uDEDF-\uDEEA\uDF01-\uDF03\uDF3C\uDF3E-\uDF44\uDF47\uDF48\uDF4B-\uDF4D\uDF57\uDF62\uDF63\uDF66-\uDF6C\uDF70-\uDF74]|\uD805[\uDCB0-\uDCC3\uDDAF-\uDDB5\uDDB8-\uDDC0\uDE30-\uDE40\uDEAB-\uDEB7]|\uD81A[\uDEF0-\uDEF4\uDF30-\uDF36]|\uD81B[\uDF51-\uDF7E\uDF8F-\uDF92]|\uD82F[\uDC9D\uDC9E]|\uD834[\uDD65-\uDD69\uDD6D-\uDD72\uDD7B-\uDD82\uDD85-\uDD8B\uDDAA-\uDDAD\uDE42-\uDE44]|\uD83A[\uDCD0-\uDCD6]|\uDB40[\uDD00-\uDDEF]/;
    function validateLabel(label, processing_option) {
      if (label.substr(0, 4) === "xn--") {
        label = punycode.toUnicode(label);
        processing_option = PROCESSING_OPTIONS.NONTRANSITIONAL;
      }
      var error = false;
      if (normalize2(label) !== label || label[3] === "-" && label[4] === "-" || label[0] === "-" || label[label.length - 1] === "-" || label.indexOf(".") !== -1 || label.search(combiningMarksRegex) === 0) {
        error = true;
      }
      var len = countSymbols(label);
      for (var i = 0; i < len; ++i) {
        var status = findStatus(label.codePointAt(i));
        if (processing === PROCESSING_OPTIONS.TRANSITIONAL && status[1] !== "valid" || processing === PROCESSING_OPTIONS.NONTRANSITIONAL && status[1] !== "valid" && status[1] !== "deviation") {
          error = true;
          break;
        }
      }
      return {
        label,
        error
      };
    }
    function processing(domain_name, useSTD3, processing_option) {
      var result = mapChars(domain_name, useSTD3, processing_option);
      result.string = normalize2(result.string);
      var labels = result.string.split(".");
      for (var i = 0; i < labels.length; ++i) {
        try {
          var validation = validateLabel(labels[i]);
          labels[i] = validation.label;
          result.error = result.error || validation.error;
        } catch (e) {
          result.error = true;
        }
      }
      return {
        string: labels.join("."),
        error: result.error
      };
    }
    module2.exports.toASCII = function (domain_name, useSTD3, processing_option, verifyDnsLength) {
      var result = processing(domain_name, useSTD3, processing_option);
      var labels = result.string.split(".");
      labels = labels.map(function (l) {
        try {
          return punycode.toASCII(l);
        } catch (e) {
          result.error = true;
          return l;
        }
      });
      if (verifyDnsLength) {
        var total = labels.slice(0, labels.length - 1).join(".").length;
        if (total.length > 253 || total.length === 0) {
          result.error = true;
        }
        for (var i = 0; i < labels.length; ++i) {
          if (labels.length > 63 || labels.length === 0) {
            result.error = true;
            break;
          }
        }
      }
      if (result.error) return null;
      return labels.join(".");
    };
    module2.exports.toUnicode = function (domain_name, useSTD3) {
      var result = processing(domain_name, useSTD3, PROCESSING_OPTIONS.NONTRANSITIONAL);
      return {
        domain: result.string,
        error: result.error
      };
    };
    module2.exports.PROCESSING_OPTIONS = PROCESSING_OPTIONS;
  }
});

// ../../../node_modules/.pnpm/whatwg-url@5.0.0/node_modules/whatwg-url/lib/url-state-machine.js
var require_url_state_machine = __commonJS({
  "../../../node_modules/.pnpm/whatwg-url@5.0.0/node_modules/whatwg-url/lib/url-state-machine.js"(exports2, module2) {
    "use strict";
    var punycode = require("punycode");
    var tr46 = require_tr46();
    var specialSchemes = {
      ftp: 21,
      file: null,
      gopher: 70,
      http: 80,
      https: 443,
      ws: 80,
      wss: 443
    };
    var failure = Symbol("failure");
    function countSymbols(str2) {
      return punycode.ucs2.decode(str2).length;
    }
    function at(input, idx) {
      const c = input[idx];
      return isNaN(c) ? void 0 : String.fromCodePoint(c);
    }
    function isASCIIDigit(c) {
      return c >= 48 && c <= 57;
    }
    function isASCIIAlpha(c) {
      return c >= 65 && c <= 90 || c >= 97 && c <= 122;
    }
    function isASCIIAlphanumeric(c) {
      return isASCIIAlpha(c) || isASCIIDigit(c);
    }
    function isASCIIHex(c) {
      return isASCIIDigit(c) || c >= 65 && c <= 70 || c >= 97 && c <= 102;
    }
    function isSingleDot(buffer) {
      return buffer === "." || buffer.toLowerCase() === "%2e";
    }
    function isDoubleDot(buffer) {
      buffer = buffer.toLowerCase();
      return buffer === ".." || buffer === "%2e." || buffer === ".%2e" || buffer === "%2e%2e";
    }
    function isWindowsDriveLetterCodePoints(cp1, cp2) {
      return isASCIIAlpha(cp1) && (cp2 === 58 || cp2 === 124);
    }
    function isWindowsDriveLetterString(string3) {
      return string3.length === 2 && isASCIIAlpha(string3.codePointAt(0)) && (string3[1] === ":" || string3[1] === "|");
    }
    function isNormalizedWindowsDriveLetterString(string3) {
      return string3.length === 2 && isASCIIAlpha(string3.codePointAt(0)) && string3[1] === ":";
    }
    function containsForbiddenHostCodePoint(string3) {
      return string3.search(/\u0000|\u0009|\u000A|\u000D|\u0020|#|%|\/|:|\?|@|\[|\\|\]/) !== -1;
    }
    function containsForbiddenHostCodePointExcludingPercent(string3) {
      return string3.search(/\u0000|\u0009|\u000A|\u000D|\u0020|#|\/|:|\?|@|\[|\\|\]/) !== -1;
    }
    function isSpecialScheme(scheme) {
      return specialSchemes[scheme] !== void 0;
    }
    function isSpecial(url) {
      return isSpecialScheme(url.scheme);
    }
    function defaultPort(scheme) {
      return specialSchemes[scheme];
    }
    function percentEncode(c) {
      let hex = c.toString(16).toUpperCase();
      if (hex.length === 1) {
        hex = "0" + hex;
      }
      return "%" + hex;
    }
    function utf8PercentEncode(c) {
      const buf = new Buffer(c);
      let str2 = "";
      for (let i = 0; i < buf.length; ++i) {
        str2 += percentEncode(buf[i]);
      }
      return str2;
    }
    function utf8PercentDecode(str2) {
      const input = new Buffer(str2);
      const output = [];
      for (let i = 0; i < input.length; ++i) {
        if (input[i] !== 37) {
          output.push(input[i]);
        } else if (input[i] === 37 && isASCIIHex(input[i + 1]) && isASCIIHex(input[i + 2])) {
          output.push(parseInt(input.slice(i + 1, i + 3).toString(), 16));
          i += 2;
        } else {
          output.push(input[i]);
        }
      }
      return new Buffer(output).toString();
    }
    function isC0ControlPercentEncode(c) {
      return c <= 31 || c > 126;
    }
    var extraPathPercentEncodeSet = /* @__PURE__ */ new Set([32, 34, 35, 60, 62, 63, 96, 123, 125]);
    function isPathPercentEncode(c) {
      return isC0ControlPercentEncode(c) || extraPathPercentEncodeSet.has(c);
    }
    var extraUserinfoPercentEncodeSet = /* @__PURE__ */ new Set([47, 58, 59, 61, 64, 91, 92, 93, 94, 124]);
    function isUserinfoPercentEncode(c) {
      return isPathPercentEncode(c) || extraUserinfoPercentEncodeSet.has(c);
    }
    function percentEncodeChar(c, encodeSetPredicate) {
      const cStr = String.fromCodePoint(c);
      if (encodeSetPredicate(c)) {
        return utf8PercentEncode(cStr);
      }
      return cStr;
    }
    function parseIPv4Number(input) {
      let R = 10;
      if (input.length >= 2 && input.charAt(0) === "0" && input.charAt(1).toLowerCase() === "x") {
        input = input.substring(2);
        R = 16;
      } else if (input.length >= 2 && input.charAt(0) === "0") {
        input = input.substring(1);
        R = 8;
      }
      if (input === "") {
        return 0;
      }
      const regex = R === 10 ? /[^0-9]/ : R === 16 ? /[^0-9A-Fa-f]/ : /[^0-7]/;
      if (regex.test(input)) {
        return failure;
      }
      return parseInt(input, R);
    }
    function parseIPv4(input) {
      const parts = input.split(".");
      if (parts[parts.length - 1] === "") {
        if (parts.length > 1) {
          parts.pop();
        }
      }
      if (parts.length > 4) {
        return input;
      }
      const numbers = [];
      for (const part of parts) {
        if (part === "") {
          return input;
        }
        const n = parseIPv4Number(part);
        if (n === failure) {
          return input;
        }
        numbers.push(n);
      }
      for (let i = 0; i < numbers.length - 1; ++i) {
        if (numbers[i] > 255) {
          return failure;
        }
      }
      if (numbers[numbers.length - 1] >= Math.pow(256, 5 - numbers.length)) {
        return failure;
      }
      let ipv4 = numbers.pop();
      let counter = 0;
      for (const n of numbers) {
        ipv4 += n * Math.pow(256, 3 - counter);
        ++counter;
      }
      return ipv4;
    }
    function serializeIPv4(address) {
      let output = "";
      let n = address;
      for (let i = 1; i <= 4; ++i) {
        output = String(n % 256) + output;
        if (i !== 4) {
          output = "." + output;
        }
        n = Math.floor(n / 256);
      }
      return output;
    }
    function parseIPv6(input) {
      const address = [0, 0, 0, 0, 0, 0, 0, 0];
      let pieceIndex = 0;
      let compress = null;
      let pointer = 0;
      input = punycode.ucs2.decode(input);
      if (input[pointer] === 58) {
        if (input[pointer + 1] !== 58) {
          return failure;
        }
        pointer += 2;
        ++pieceIndex;
        compress = pieceIndex;
      }
      while (pointer < input.length) {
        if (pieceIndex === 8) {
          return failure;
        }
        if (input[pointer] === 58) {
          if (compress !== null) {
            return failure;
          }
          ++pointer;
          ++pieceIndex;
          compress = pieceIndex;
          continue;
        }
        let value = 0;
        let length = 0;
        while (length < 4 && isASCIIHex(input[pointer])) {
          value = value * 16 + parseInt(at(input, pointer), 16);
          ++pointer;
          ++length;
        }
        if (input[pointer] === 46) {
          if (length === 0) {
            return failure;
          }
          pointer -= length;
          if (pieceIndex > 6) {
            return failure;
          }
          let numbersSeen = 0;
          while (input[pointer] !== void 0) {
            let ipv4Piece = null;
            if (numbersSeen > 0) {
              if (input[pointer] === 46 && numbersSeen < 4) {
                ++pointer;
              } else {
                return failure;
              }
            }
            if (!isASCIIDigit(input[pointer])) {
              return failure;
            }
            while (isASCIIDigit(input[pointer])) {
              const number3 = parseInt(at(input, pointer));
              if (ipv4Piece === null) {
                ipv4Piece = number3;
              } else if (ipv4Piece === 0) {
                return failure;
              } else {
                ipv4Piece = ipv4Piece * 10 + number3;
              }
              if (ipv4Piece > 255) {
                return failure;
              }
              ++pointer;
            }
            address[pieceIndex] = address[pieceIndex] * 256 + ipv4Piece;
            ++numbersSeen;
            if (numbersSeen === 2 || numbersSeen === 4) {
              ++pieceIndex;
            }
          }
          if (numbersSeen !== 4) {
            return failure;
          }
          break;
        } else if (input[pointer] === 58) {
          ++pointer;
          if (input[pointer] === void 0) {
            return failure;
          }
        } else if (input[pointer] !== void 0) {
          return failure;
        }
        address[pieceIndex] = value;
        ++pieceIndex;
      }
      if (compress !== null) {
        let swaps = pieceIndex - compress;
        pieceIndex = 7;
        while (pieceIndex !== 0 && swaps > 0) {
          const temp = address[compress + swaps - 1];
          address[compress + swaps - 1] = address[pieceIndex];
          address[pieceIndex] = temp;
          --pieceIndex;
          --swaps;
        }
      } else if (compress === null && pieceIndex !== 8) {
        return failure;
      }
      return address;
    }
    function serializeIPv6(address) {
      let output = "";
      const seqResult = findLongestZeroSequence(address);
      const compress = seqResult.idx;
      let ignore0 = false;
      for (let pieceIndex = 0; pieceIndex <= 7; ++pieceIndex) {
        if (ignore0 && address[pieceIndex] === 0) {
          continue;
        } else if (ignore0) {
          ignore0 = false;
        }
        if (compress === pieceIndex) {
          const separator = pieceIndex === 0 ? "::" : ":";
          output += separator;
          ignore0 = true;
          continue;
        }
        output += address[pieceIndex].toString(16);
        if (pieceIndex !== 7) {
          output += ":";
        }
      }
      return output;
    }
    function parseHost(input, isSpecialArg) {
      if (input[0] === "[") {
        if (input[input.length - 1] !== "]") {
          return failure;
        }
        return parseIPv6(input.substring(1, input.length - 1));
      }
      if (!isSpecialArg) {
        return parseOpaqueHost(input);
      }
      const domain = utf8PercentDecode(input);
      const asciiDomain = tr46.toASCII(domain, false, tr46.PROCESSING_OPTIONS.NONTRANSITIONAL, false);
      if (asciiDomain === null) {
        return failure;
      }
      if (containsForbiddenHostCodePoint(asciiDomain)) {
        return failure;
      }
      const ipv4Host = parseIPv4(asciiDomain);
      if (typeof ipv4Host === "number" || ipv4Host === failure) {
        return ipv4Host;
      }
      return asciiDomain;
    }
    function parseOpaqueHost(input) {
      if (containsForbiddenHostCodePointExcludingPercent(input)) {
        return failure;
      }
      let output = "";
      const decoded = punycode.ucs2.decode(input);
      for (let i = 0; i < decoded.length; ++i) {
        output += percentEncodeChar(decoded[i], isC0ControlPercentEncode);
      }
      return output;
    }
    function findLongestZeroSequence(arr) {
      let maxIdx = null;
      let maxLen = 1;
      let currStart = null;
      let currLen = 0;
      for (let i = 0; i < arr.length; ++i) {
        if (arr[i] !== 0) {
          if (currLen > maxLen) {
            maxIdx = currStart;
            maxLen = currLen;
          }
          currStart = null;
          currLen = 0;
        } else {
          if (currStart === null) {
            currStart = i;
          }
          ++currLen;
        }
      }
      if (currLen > maxLen) {
        maxIdx = currStart;
        maxLen = currLen;
      }
      return {
        idx: maxIdx,
        len: maxLen
      };
    }
    function serializeHost(host) {
      if (typeof host === "number") {
        return serializeIPv4(host);
      }
      if (host instanceof Array) {
        return "[" + serializeIPv6(host) + "]";
      }
      return host;
    }
    function trimControlChars(url) {
      return url.replace(/^[\u0000-\u001F\u0020]+|[\u0000-\u001F\u0020]+$/g, "");
    }
    function trimTabAndNewline(url) {
      return url.replace(/\u0009|\u000A|\u000D/g, "");
    }
    function shortenPath(url) {
      const path5 = url.path;
      if (path5.length === 0) {
        return;
      }
      if (url.scheme === "file" && path5.length === 1 && isNormalizedWindowsDriveLetter(path5[0])) {
        return;
      }
      path5.pop();
    }
    function includesCredentials(url) {
      return url.username !== "" || url.password !== "";
    }
    function cannotHaveAUsernamePasswordPort(url) {
      return url.host === null || url.host === "" || url.cannotBeABaseURL || url.scheme === "file";
    }
    function isNormalizedWindowsDriveLetter(string3) {
      return /^[A-Za-z]:$/.test(string3);
    }
    function URLStateMachine(input, base, encodingOverride, url, stateOverride) {
      this.pointer = 0;
      this.input = input;
      this.base = base || null;
      this.encodingOverride = encodingOverride || "utf-8";
      this.stateOverride = stateOverride;
      this.url = url;
      this.failure = false;
      this.parseError = false;
      if (!this.url) {
        this.url = {
          scheme: "",
          username: "",
          password: "",
          host: null,
          port: null,
          path: [],
          query: null,
          fragment: null,
          cannotBeABaseURL: false
        };
        const res2 = trimControlChars(this.input);
        if (res2 !== this.input) {
          this.parseError = true;
        }
        this.input = res2;
      }
      const res = trimTabAndNewline(this.input);
      if (res !== this.input) {
        this.parseError = true;
      }
      this.input = res;
      this.state = stateOverride || "scheme start";
      this.buffer = "";
      this.atFlag = false;
      this.arrFlag = false;
      this.passwordTokenSeenFlag = false;
      this.input = punycode.ucs2.decode(this.input);
      for (; this.pointer <= this.input.length; ++this.pointer) {
        const c = this.input[this.pointer];
        const cStr = isNaN(c) ? void 0 : String.fromCodePoint(c);
        const ret = this["parse " + this.state](c, cStr);
        if (!ret) {
          break;
        } else if (ret === failure) {
          this.failure = true;
          break;
        }
      }
    }
    URLStateMachine.prototype["parse scheme start"] = function parseSchemeStart(c, cStr) {
      if (isASCIIAlpha(c)) {
        this.buffer += cStr.toLowerCase();
        this.state = "scheme";
      } else if (!this.stateOverride) {
        this.state = "no scheme";
        --this.pointer;
      } else {
        this.parseError = true;
        return failure;
      }
      return true;
    };
    URLStateMachine.prototype["parse scheme"] = function parseScheme(c, cStr) {
      if (isASCIIAlphanumeric(c) || c === 43 || c === 45 || c === 46) {
        this.buffer += cStr.toLowerCase();
      } else if (c === 58) {
        if (this.stateOverride) {
          if (isSpecial(this.url) && !isSpecialScheme(this.buffer)) {
            return false;
          }
          if (!isSpecial(this.url) && isSpecialScheme(this.buffer)) {
            return false;
          }
          if ((includesCredentials(this.url) || this.url.port !== null) && this.buffer === "file") {
            return false;
          }
          if (this.url.scheme === "file" && (this.url.host === "" || this.url.host === null)) {
            return false;
          }
        }
        this.url.scheme = this.buffer;
        this.buffer = "";
        if (this.stateOverride) {
          return false;
        }
        if (this.url.scheme === "file") {
          if (this.input[this.pointer + 1] !== 47 || this.input[this.pointer + 2] !== 47) {
            this.parseError = true;
          }
          this.state = "file";
        } else if (isSpecial(this.url) && this.base !== null && this.base.scheme === this.url.scheme) {
          this.state = "special relative or authority";
        } else if (isSpecial(this.url)) {
          this.state = "special authority slashes";
        } else if (this.input[this.pointer + 1] === 47) {
          this.state = "path or authority";
          ++this.pointer;
        } else {
          this.url.cannotBeABaseURL = true;
          this.url.path.push("");
          this.state = "cannot-be-a-base-URL path";
        }
      } else if (!this.stateOverride) {
        this.buffer = "";
        this.state = "no scheme";
        this.pointer = -1;
      } else {
        this.parseError = true;
        return failure;
      }
      return true;
    };
    URLStateMachine.prototype["parse no scheme"] = function parseNoScheme(c) {
      if (this.base === null || this.base.cannotBeABaseURL && c !== 35) {
        return failure;
      } else if (this.base.cannotBeABaseURL && c === 35) {
        this.url.scheme = this.base.scheme;
        this.url.path = this.base.path.slice();
        this.url.query = this.base.query;
        this.url.fragment = "";
        this.url.cannotBeABaseURL = true;
        this.state = "fragment";
      } else if (this.base.scheme === "file") {
        this.state = "file";
        --this.pointer;
      } else {
        this.state = "relative";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse special relative or authority"] = function parseSpecialRelativeOrAuthority(c) {
      if (c === 47 && this.input[this.pointer + 1] === 47) {
        this.state = "special authority ignore slashes";
        ++this.pointer;
      } else {
        this.parseError = true;
        this.state = "relative";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse path or authority"] = function parsePathOrAuthority(c) {
      if (c === 47) {
        this.state = "authority";
      } else {
        this.state = "path";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse relative"] = function parseRelative(c) {
      this.url.scheme = this.base.scheme;
      if (isNaN(c)) {
        this.url.username = this.base.username;
        this.url.password = this.base.password;
        this.url.host = this.base.host;
        this.url.port = this.base.port;
        this.url.path = this.base.path.slice();
        this.url.query = this.base.query;
      } else if (c === 47) {
        this.state = "relative slash";
      } else if (c === 63) {
        this.url.username = this.base.username;
        this.url.password = this.base.password;
        this.url.host = this.base.host;
        this.url.port = this.base.port;
        this.url.path = this.base.path.slice();
        this.url.query = "";
        this.state = "query";
      } else if (c === 35) {
        this.url.username = this.base.username;
        this.url.password = this.base.password;
        this.url.host = this.base.host;
        this.url.port = this.base.port;
        this.url.path = this.base.path.slice();
        this.url.query = this.base.query;
        this.url.fragment = "";
        this.state = "fragment";
      } else if (isSpecial(this.url) && c === 92) {
        this.parseError = true;
        this.state = "relative slash";
      } else {
        this.url.username = this.base.username;
        this.url.password = this.base.password;
        this.url.host = this.base.host;
        this.url.port = this.base.port;
        this.url.path = this.base.path.slice(0, this.base.path.length - 1);
        this.state = "path";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse relative slash"] = function parseRelativeSlash(c) {
      if (isSpecial(this.url) && (c === 47 || c === 92)) {
        if (c === 92) {
          this.parseError = true;
        }
        this.state = "special authority ignore slashes";
      } else if (c === 47) {
        this.state = "authority";
      } else {
        this.url.username = this.base.username;
        this.url.password = this.base.password;
        this.url.host = this.base.host;
        this.url.port = this.base.port;
        this.state = "path";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse special authority slashes"] = function parseSpecialAuthoritySlashes(c) {
      if (c === 47 && this.input[this.pointer + 1] === 47) {
        this.state = "special authority ignore slashes";
        ++this.pointer;
      } else {
        this.parseError = true;
        this.state = "special authority ignore slashes";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse special authority ignore slashes"] = function parseSpecialAuthorityIgnoreSlashes(c) {
      if (c !== 47 && c !== 92) {
        this.state = "authority";
        --this.pointer;
      } else {
        this.parseError = true;
      }
      return true;
    };
    URLStateMachine.prototype["parse authority"] = function parseAuthority(c, cStr) {
      if (c === 64) {
        this.parseError = true;
        if (this.atFlag) {
          this.buffer = "%40" + this.buffer;
        }
        this.atFlag = true;
        const len = countSymbols(this.buffer);
        for (let pointer = 0; pointer < len; ++pointer) {
          const codePoint = this.buffer.codePointAt(pointer);
          if (codePoint === 58 && !this.passwordTokenSeenFlag) {
            this.passwordTokenSeenFlag = true;
            continue;
          }
          const encodedCodePoints = percentEncodeChar(codePoint, isUserinfoPercentEncode);
          if (this.passwordTokenSeenFlag) {
            this.url.password += encodedCodePoints;
          } else {
            this.url.username += encodedCodePoints;
          }
        }
        this.buffer = "";
      } else if (isNaN(c) || c === 47 || c === 63 || c === 35 || isSpecial(this.url) && c === 92) {
        if (this.atFlag && this.buffer === "") {
          this.parseError = true;
          return failure;
        }
        this.pointer -= countSymbols(this.buffer) + 1;
        this.buffer = "";
        this.state = "host";
      } else {
        this.buffer += cStr;
      }
      return true;
    };
    URLStateMachine.prototype["parse hostname"] = URLStateMachine.prototype["parse host"] = function parseHostName(c, cStr) {
      if (this.stateOverride && this.url.scheme === "file") {
        --this.pointer;
        this.state = "file host";
      } else if (c === 58 && !this.arrFlag) {
        if (this.buffer === "") {
          this.parseError = true;
          return failure;
        }
        const host = parseHost(this.buffer, isSpecial(this.url));
        if (host === failure) {
          return failure;
        }
        this.url.host = host;
        this.buffer = "";
        this.state = "port";
        if (this.stateOverride === "hostname") {
          return false;
        }
      } else if (isNaN(c) || c === 47 || c === 63 || c === 35 || isSpecial(this.url) && c === 92) {
        --this.pointer;
        if (isSpecial(this.url) && this.buffer === "") {
          this.parseError = true;
          return failure;
        } else if (this.stateOverride && this.buffer === "" && (includesCredentials(this.url) || this.url.port !== null)) {
          this.parseError = true;
          return false;
        }
        const host = parseHost(this.buffer, isSpecial(this.url));
        if (host === failure) {
          return failure;
        }
        this.url.host = host;
        this.buffer = "";
        this.state = "path start";
        if (this.stateOverride) {
          return false;
        }
      } else {
        if (c === 91) {
          this.arrFlag = true;
        } else if (c === 93) {
          this.arrFlag = false;
        }
        this.buffer += cStr;
      }
      return true;
    };
    URLStateMachine.prototype["parse port"] = function parsePort(c, cStr) {
      if (isASCIIDigit(c)) {
        this.buffer += cStr;
      } else if (isNaN(c) || c === 47 || c === 63 || c === 35 || isSpecial(this.url) && c === 92 || this.stateOverride) {
        if (this.buffer !== "") {
          const port = parseInt(this.buffer);
          if (port > Math.pow(2, 16) - 1) {
            this.parseError = true;
            return failure;
          }
          this.url.port = port === defaultPort(this.url.scheme) ? null : port;
          this.buffer = "";
        }
        if (this.stateOverride) {
          return false;
        }
        this.state = "path start";
        --this.pointer;
      } else {
        this.parseError = true;
        return failure;
      }
      return true;
    };
    var fileOtherwiseCodePoints = /* @__PURE__ */ new Set([47, 92, 63, 35]);
    URLStateMachine.prototype["parse file"] = function parseFile(c) {
      this.url.scheme = "file";
      if (c === 47 || c === 92) {
        if (c === 92) {
          this.parseError = true;
        }
        this.state = "file slash";
      } else if (this.base !== null && this.base.scheme === "file") {
        if (isNaN(c)) {
          this.url.host = this.base.host;
          this.url.path = this.base.path.slice();
          this.url.query = this.base.query;
        } else if (c === 63) {
          this.url.host = this.base.host;
          this.url.path = this.base.path.slice();
          this.url.query = "";
          this.state = "query";
        } else if (c === 35) {
          this.url.host = this.base.host;
          this.url.path = this.base.path.slice();
          this.url.query = this.base.query;
          this.url.fragment = "";
          this.state = "fragment";
        } else {
          if (this.input.length - this.pointer - 1 === 0 || // remaining consists of 0 code points
            !isWindowsDriveLetterCodePoints(c, this.input[this.pointer + 1]) || this.input.length - this.pointer - 1 >= 2 && // remaining has at least 2 code points
            !fileOtherwiseCodePoints.has(this.input[this.pointer + 2])) {
            this.url.host = this.base.host;
            this.url.path = this.base.path.slice();
            shortenPath(this.url);
          } else {
            this.parseError = true;
          }
          this.state = "path";
          --this.pointer;
        }
      } else {
        this.state = "path";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse file slash"] = function parseFileSlash(c) {
      if (c === 47 || c === 92) {
        if (c === 92) {
          this.parseError = true;
        }
        this.state = "file host";
      } else {
        if (this.base !== null && this.base.scheme === "file") {
          if (isNormalizedWindowsDriveLetterString(this.base.path[0])) {
            this.url.path.push(this.base.path[0]);
          } else {
            this.url.host = this.base.host;
          }
        }
        this.state = "path";
        --this.pointer;
      }
      return true;
    };
    URLStateMachine.prototype["parse file host"] = function parseFileHost(c, cStr) {
      if (isNaN(c) || c === 47 || c === 92 || c === 63 || c === 35) {
        --this.pointer;
        if (!this.stateOverride && isWindowsDriveLetterString(this.buffer)) {
          this.parseError = true;
          this.state = "path";
        } else if (this.buffer === "") {
          this.url.host = "";
          if (this.stateOverride) {
            return false;
          }
          this.state = "path start";
        } else {
          let host = parseHost(this.buffer, isSpecial(this.url));
          if (host === failure) {
            return failure;
          }
          if (host === "localhost") {
            host = "";
          }
          this.url.host = host;
          if (this.stateOverride) {
            return false;
          }
          this.buffer = "";
          this.state = "path start";
        }
      } else {
        this.buffer += cStr;
      }
      return true;
    };
    URLStateMachine.prototype["parse path start"] = function parsePathStart(c) {
      if (isSpecial(this.url)) {
        if (c === 92) {
          this.parseError = true;
        }
        this.state = "path";
        if (c !== 47 && c !== 92) {
          --this.pointer;
        }
      } else if (!this.stateOverride && c === 63) {
        this.url.query = "";
        this.state = "query";
      } else if (!this.stateOverride && c === 35) {
        this.url.fragment = "";
        this.state = "fragment";
      } else if (c !== void 0) {
        this.state = "path";
        if (c !== 47) {
          --this.pointer;
        }
      }
      return true;
    };
    URLStateMachine.prototype["parse path"] = function parsePath(c) {
      if (isNaN(c) || c === 47 || isSpecial(this.url) && c === 92 || !this.stateOverride && (c === 63 || c === 35)) {
        if (isSpecial(this.url) && c === 92) {
          this.parseError = true;
        }
        if (isDoubleDot(this.buffer)) {
          shortenPath(this.url);
          if (c !== 47 && !(isSpecial(this.url) && c === 92)) {
            this.url.path.push("");
          }
        } else if (isSingleDot(this.buffer) && c !== 47 && !(isSpecial(this.url) && c === 92)) {
          this.url.path.push("");
        } else if (!isSingleDot(this.buffer)) {
          if (this.url.scheme === "file" && this.url.path.length === 0 && isWindowsDriveLetterString(this.buffer)) {
            if (this.url.host !== "" && this.url.host !== null) {
              this.parseError = true;
              this.url.host = "";
            }
            this.buffer = this.buffer[0] + ":";
          }
          this.url.path.push(this.buffer);
        }
        this.buffer = "";
        if (this.url.scheme === "file" && (c === void 0 || c === 63 || c === 35)) {
          while (this.url.path.length > 1 && this.url.path[0] === "") {
            this.parseError = true;
            this.url.path.shift();
          }
        }
        if (c === 63) {
          this.url.query = "";
          this.state = "query";
        }
        if (c === 35) {
          this.url.fragment = "";
          this.state = "fragment";
        }
      } else {
        if (c === 37 && (!isASCIIHex(this.input[this.pointer + 1]) || !isASCIIHex(this.input[this.pointer + 2]))) {
          this.parseError = true;
        }
        this.buffer += percentEncodeChar(c, isPathPercentEncode);
      }
      return true;
    };
    URLStateMachine.prototype["parse cannot-be-a-base-URL path"] = function parseCannotBeABaseURLPath(c) {
      if (c === 63) {
        this.url.query = "";
        this.state = "query";
      } else if (c === 35) {
        this.url.fragment = "";
        this.state = "fragment";
      } else {
        if (!isNaN(c) && c !== 37) {
          this.parseError = true;
        }
        if (c === 37 && (!isASCIIHex(this.input[this.pointer + 1]) || !isASCIIHex(this.input[this.pointer + 2]))) {
          this.parseError = true;
        }
        if (!isNaN(c)) {
          this.url.path[0] = this.url.path[0] + percentEncodeChar(c, isC0ControlPercentEncode);
        }
      }
      return true;
    };
    URLStateMachine.prototype["parse query"] = function parseQuery(c, cStr) {
      if (isNaN(c) || !this.stateOverride && c === 35) {
        if (!isSpecial(this.url) || this.url.scheme === "ws" || this.url.scheme === "wss") {
          this.encodingOverride = "utf-8";
        }
        const buffer = new Buffer(this.buffer);
        for (let i = 0; i < buffer.length; ++i) {
          if (buffer[i] < 33 || buffer[i] > 126 || buffer[i] === 34 || buffer[i] === 35 || buffer[i] === 60 || buffer[i] === 62) {
            this.url.query += percentEncode(buffer[i]);
          } else {
            this.url.query += String.fromCodePoint(buffer[i]);
          }
        }
        this.buffer = "";
        if (c === 35) {
          this.url.fragment = "";
          this.state = "fragment";
        }
      } else {
        if (c === 37 && (!isASCIIHex(this.input[this.pointer + 1]) || !isASCIIHex(this.input[this.pointer + 2]))) {
          this.parseError = true;
        }
        this.buffer += cStr;
      }
      return true;
    };
    URLStateMachine.prototype["parse fragment"] = function parseFragment(c) {
      if (isNaN(c)) {
      } else if (c === 0) {
        this.parseError = true;
      } else {
        if (c === 37 && (!isASCIIHex(this.input[this.pointer + 1]) || !isASCIIHex(this.input[this.pointer + 2]))) {
          this.parseError = true;
        }
        this.url.fragment += percentEncodeChar(c, isC0ControlPercentEncode);
      }
      return true;
    };
    function serializeURL(url, excludeFragment) {
      let output = url.scheme + ":";
      if (url.host !== null) {
        output += "//";
        if (url.username !== "" || url.password !== "") {
          output += url.username;
          if (url.password !== "") {
            output += ":" + url.password;
          }
          output += "@";
        }
        output += serializeHost(url.host);
        if (url.port !== null) {
          output += ":" + url.port;
        }
      } else if (url.host === null && url.scheme === "file") {
        output += "//";
      }
      if (url.cannotBeABaseURL) {
        output += url.path[0];
      } else {
        for (const string3 of url.path) {
          output += "/" + string3;
        }
      }
      if (url.query !== null) {
        output += "?" + url.query;
      }
      if (!excludeFragment && url.fragment !== null) {
        output += "#" + url.fragment;
      }
      return output;
    }
    function serializeOrigin(tuple) {
      let result = tuple.scheme + "://";
      result += serializeHost(tuple.host);
      if (tuple.port !== null) {
        result += ":" + tuple.port;
      }
      return result;
    }
    module2.exports.serializeURL = serializeURL;
    module2.exports.serializeURLOrigin = function (url) {
      switch (url.scheme) {
        case "blob":
          try {
            return module2.exports.serializeURLOrigin(module2.exports.parseURL(url.path[0]));
          } catch (e) {
            return "null";
          }
        case "ftp":
        case "gopher":
        case "http":
        case "https":
        case "ws":
        case "wss":
          return serializeOrigin({
            scheme: url.scheme,
            host: url.host,
            port: url.port
          });
        case "file":
          return "file://";
        default:
          return "null";
      }
    };
    module2.exports.basicURLParse = function (input, options) {
      if (options === void 0) {
        options = {};
      }
      const usm = new URLStateMachine(input, options.baseURL, options.encodingOverride, options.url, options.stateOverride);
      if (usm.failure) {
        return "failure";
      }
      return usm.url;
    };
    module2.exports.setTheUsername = function (url, username) {
      url.username = "";
      const decoded = punycode.ucs2.decode(username);
      for (let i = 0; i < decoded.length; ++i) {
        url.username += percentEncodeChar(decoded[i], isUserinfoPercentEncode);
      }
    };
    module2.exports.setThePassword = function (url, password) {
      url.password = "";
      const decoded = punycode.ucs2.decode(password);
      for (let i = 0; i < decoded.length; ++i) {
        url.password += percentEncodeChar(decoded[i], isUserinfoPercentEncode);
      }
    };
    module2.exports.serializeHost = serializeHost;
    module2.exports.cannotHaveAUsernamePasswordPort = cannotHaveAUsernamePasswordPort;
    module2.exports.serializeInteger = function (integer) {
      return String(integer);
    };
    module2.exports.parseURL = function (input, options) {
      if (options === void 0) {
        options = {};
      }
      return module2.exports.basicURLParse(input, { baseURL: options.baseURL, encodingOverride: options.encodingOverride });
    };
  }
});

// ../../../node_modules/.pnpm/whatwg-url@5.0.0/node_modules/whatwg-url/lib/URL-impl.js
var require_URL_impl = __commonJS({
  "../../../node_modules/.pnpm/whatwg-url@5.0.0/node_modules/whatwg-url/lib/URL-impl.js"(exports2) {
    "use strict";
    var usm = require_url_state_machine();
    exports2.implementation = class URLImpl {
      constructor(constructorArgs) {
        const url = constructorArgs[0];
        const base = constructorArgs[1];
        let parsedBase = null;
        if (base !== void 0) {
          parsedBase = usm.basicURLParse(base);
          if (parsedBase === "failure") {
            throw new TypeError("Invalid base URL");
          }
        }
        const parsedURL = usm.basicURLParse(url, { baseURL: parsedBase });
        if (parsedURL === "failure") {
          throw new TypeError("Invalid URL");
        }
        this._url = parsedURL;
      }
      get href() {
        return usm.serializeURL(this._url);
      }
      set href(v) {
        const parsedURL = usm.basicURLParse(v);
        if (parsedURL === "failure") {
          throw new TypeError("Invalid URL");
        }
        this._url = parsedURL;
      }
      get origin() {
        return usm.serializeURLOrigin(this._url);
      }
      get protocol() {
        return this._url.scheme + ":";
      }
      set protocol(v) {
        usm.basicURLParse(v + ":", { url: this._url, stateOverride: "scheme start" });
      }
      get username() {
        return this._url.username;
      }
      set username(v) {
        if (usm.cannotHaveAUsernamePasswordPort(this._url)) {
          return;
        }
        usm.setTheUsername(this._url, v);
      }
      get password() {
        return this._url.password;
      }
      set password(v) {
        if (usm.cannotHaveAUsernamePasswordPort(this._url)) {
          return;
        }
        usm.setThePassword(this._url, v);
      }
      get host() {
        const url = this._url;
        if (url.host === null) {
          return "";
        }
        if (url.port === null) {
          return usm.serializeHost(url.host);
        }
        return usm.serializeHost(url.host) + ":" + usm.serializeInteger(url.port);
      }
      set host(v) {
        if (this._url.cannotBeABaseURL) {
          return;
        }
        usm.basicURLParse(v, { url: this._url, stateOverride: "host" });
      }
      get hostname() {
        if (this._url.host === null) {
          return "";
        }
        return usm.serializeHost(this._url.host);
      }
      set hostname(v) {
        if (this._url.cannotBeABaseURL) {
          return;
        }
        usm.basicURLParse(v, { url: this._url, stateOverride: "hostname" });
      }
      get port() {
        if (this._url.port === null) {
          return "";
        }
        return usm.serializeInteger(this._url.port);
      }
      set port(v) {
        if (usm.cannotHaveAUsernamePasswordPort(this._url)) {
          return;
        }
        if (v === "") {
          this._url.port = null;
        } else {
          usm.basicURLParse(v, { url: this._url, stateOverride: "port" });
        }
      }
      get pathname() {
        if (this._url.cannotBeABaseURL) {
          return this._url.path[0];
        }
        if (this._url.path.length === 0) {
          return "";
        }
        return "/" + this._url.path.join("/");
      }
      set pathname(v) {
        if (this._url.cannotBeABaseURL) {
          return;
        }
        this._url.path = [];
        usm.basicURLParse(v, { url: this._url, stateOverride: "path start" });
      }
      get search() {
        if (this._url.query === null || this._url.query === "") {
          return "";
        }
        return "?" + this._url.query;
      }
      set search(v) {
        const url = this._url;
        if (v === "") {
          url.query = null;
          return;
        }
        const input = v[0] === "?" ? v.substring(1) : v;
        url.query = "";
        usm.basicURLParse(input, { url, stateOverride: "query" });
      }
      get hash() {
        if (this._url.fragment === null || this._url.fragment === "") {
          return "";
        }
        return "#" + this._url.fragment;
      }
      set hash(v) {
        if (v === "") {
          this._url.fragment = null;
          return;
        }
        const input = v[0] === "#" ? v.substring(1) : v;
        this._url.fragment = "";
        usm.basicURLParse(input, { url: this._url, stateOverride: "fragment" });
      }
      toJSON() {
        return this.href;
      }
    };
  }
});

// ../../../node_modules/.pnpm/whatwg-url@5.0.0/node_modules/whatwg-url/lib/URL.js
var require_URL = __commonJS({
  "../../../node_modules/.pnpm/whatwg-url@5.0.0/node_modules/whatwg-url/lib/URL.js"(exports2, module2) {
    "use strict";
    var conversions = require_lib();
    var utils = require_utils2();
    var Impl = require_URL_impl();
    var impl = utils.implSymbol;
    function URL3(url) {
      if (!this || this[impl] || !(this instanceof URL3)) {
        throw new TypeError("Failed to construct 'URL': Please use the 'new' operator, this DOM object constructor cannot be called as a function.");
      }
      if (arguments.length < 1) {
        throw new TypeError("Failed to construct 'URL': 1 argument required, but only " + arguments.length + " present.");
      }
      const args = [];
      for (let i = 0; i < arguments.length && i < 2; ++i) {
        args[i] = arguments[i];
      }
      args[0] = conversions["USVString"](args[0]);
      if (args[1] !== void 0) {
        args[1] = conversions["USVString"](args[1]);
      }
      module2.exports.setup(this, args);
    }
    URL3.prototype.toJSON = function toJSON() {
      if (!this || !module2.exports.is(this)) {
        throw new TypeError("Illegal invocation");
      }
      const args = [];
      for (let i = 0; i < arguments.length && i < 0; ++i) {
        args[i] = arguments[i];
      }
      return this[impl].toJSON.apply(this[impl], args);
    };
    Object.defineProperty(URL3.prototype, "href", {
      get() {
        return this[impl].href;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].href = V;
      },
      enumerable: true,
      configurable: true
    });
    URL3.prototype.toString = function () {
      if (!this || !module2.exports.is(this)) {
        throw new TypeError("Illegal invocation");
      }
      return this.href;
    };
    Object.defineProperty(URL3.prototype, "origin", {
      get() {
        return this[impl].origin;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "protocol", {
      get() {
        return this[impl].protocol;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].protocol = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "username", {
      get() {
        return this[impl].username;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].username = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "password", {
      get() {
        return this[impl].password;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].password = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "host", {
      get() {
        return this[impl].host;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].host = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "hostname", {
      get() {
        return this[impl].hostname;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].hostname = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "port", {
      get() {
        return this[impl].port;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].port = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "pathname", {
      get() {
        return this[impl].pathname;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].pathname = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "search", {
      get() {
        return this[impl].search;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].search = V;
      },
      enumerable: true,
      configurable: true
    });
    Object.defineProperty(URL3.prototype, "hash", {
      get() {
        return this[impl].hash;
      },
      set(V) {
        V = conversions["USVString"](V);
        this[impl].hash = V;
      },
      enumerable: true,
      configurable: true
    });
    module2.exports = {
      is(obj) {
        return !!obj && obj[impl] instanceof Impl.implementation;
      },
      create(constructorArgs, privateData) {
        let obj = Object.create(URL3.prototype);
        this.setup(obj, constructorArgs, privateData);
        return obj;
      },
      setup(obj, constructorArgs, privateData) {
        if (!privateData) privateData = {};
        privateData.wrapper = obj;
        obj[impl] = new Impl.implementation(constructorArgs, privateData);
        obj[impl][utils.wrapperSymbol] = obj;
      },
      interface: URL3,
      expose: {
        Window: { URL: URL3 },
        Worker: { URL: URL3 }
      }
    };
  }
});

// ../../../node_modules/.pnpm/whatwg-url@5.0.0/node_modules/whatwg-url/lib/public-api.js
var require_public_api = __commonJS({
  "../../../node_modules/.pnpm/whatwg-url@5.0.0/node_modules/whatwg-url/lib/public-api.js"(exports2) {
    "use strict";
    exports2.URL = require_URL().interface;
    exports2.serializeURL = require_url_state_machine().serializeURL;
    exports2.serializeURLOrigin = require_url_state_machine().serializeURLOrigin;
    exports2.basicURLParse = require_url_state_machine().basicURLParse;
    exports2.setTheUsername = require_url_state_machine().setTheUsername;
    exports2.setThePassword = require_url_state_machine().setThePassword;
    exports2.serializeHost = require_url_state_machine().serializeHost;
    exports2.serializeInteger = require_url_state_machine().serializeInteger;
    exports2.parseURL = require_url_state_machine().parseURL;
  }
});

// ../../../node_modules/.pnpm/node-fetch@2.7.0/node_modules/node-fetch/lib/index.mjs
var lib_exports = {};
__export(lib_exports, {
  AbortError: () => AbortError,
  FetchError: () => FetchError,
  Headers: () => Headers,
  Request: () => Request2,
  Response: () => Response2,
  default: () => lib_default
});
function FetchError(message, type2, systemError) {
  Error.call(this, message);
  this.message = message;
  this.type = type2;
  if (systemError) {
    this.code = this.errno = systemError.code;
  }
  Error.captureStackTrace(this, this.constructor);
}
function Body(body) {
  var _this = this;
  var _ref = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {}, _ref$size = _ref.size;
  let size2 = _ref$size === void 0 ? 0 : _ref$size;
  var _ref$timeout = _ref.timeout;
  let timeout = _ref$timeout === void 0 ? 0 : _ref$timeout;
  if (body == null) {
    body = null;
  } else if (isURLSearchParams(body)) {
    body = Buffer.from(body.toString());
  } else if (isBlob(body));
  else if (Buffer.isBuffer(body));
  else if (Object.prototype.toString.call(body) === "[object ArrayBuffer]") {
    body = Buffer.from(body);
  } else if (ArrayBuffer.isView(body)) {
    body = Buffer.from(body.buffer, body.byteOffset, body.byteLength);
  } else if (body instanceof import_stream.default);
  else {
    body = Buffer.from(String(body));
  }
  this[INTERNALS] = {
    body,
    disturbed: false,
    error: null
  };
  this.size = size2;
  this.timeout = timeout;
  if (body instanceof import_stream.default) {
    body.on("error", function (err) {
      const error = err.name === "AbortError" ? err : new FetchError(`Invalid response body while trying to fetch ${_this.url}: ${err.message}`, "system", err);
      _this[INTERNALS].error = error;
    });
  }
}
function consumeBody() {
  var _this4 = this;
  if (this[INTERNALS].disturbed) {
    return Body.Promise.reject(new TypeError(`body used already for: ${this.url}`));
  }
  this[INTERNALS].disturbed = true;
  if (this[INTERNALS].error) {
    return Body.Promise.reject(this[INTERNALS].error);
  }
  let body = this.body;
  if (body === null) {
    return Body.Promise.resolve(Buffer.alloc(0));
  }
  if (isBlob(body)) {
    body = body.stream();
  }
  if (Buffer.isBuffer(body)) {
    return Body.Promise.resolve(body);
  }
  if (!(body instanceof import_stream.default)) {
    return Body.Promise.resolve(Buffer.alloc(0));
  }
  let accum = [];
  let accumBytes = 0;
  let abort = false;
  return new Body.Promise(function (resolve, reject) {
    let resTimeout;
    if (_this4.timeout) {
      resTimeout = setTimeout(function () {
        abort = true;
        reject(new FetchError(`Response timeout while trying to fetch ${_this4.url} (over ${_this4.timeout}ms)`, "body-timeout"));
      }, _this4.timeout);
    }
    body.on("error", function (err) {
      if (err.name === "AbortError") {
        abort = true;
        reject(err);
      } else {
        reject(new FetchError(`Invalid response body while trying to fetch ${_this4.url}: ${err.message}`, "system", err));
      }
    });
    body.on("data", function (chunk) {
      if (abort || chunk === null) {
        return;
      }
      if (_this4.size && accumBytes + chunk.length > _this4.size) {
        abort = true;
        reject(new FetchError(`content size at ${_this4.url} over limit: ${_this4.size}`, "max-size"));
        return;
      }
      accumBytes += chunk.length;
      accum.push(chunk);
    });
    body.on("end", function () {
      if (abort) {
        return;
      }
      clearTimeout(resTimeout);
      try {
        resolve(Buffer.concat(accum, accumBytes));
      } catch (err) {
        reject(new FetchError(`Could not create Buffer from response body for ${_this4.url}: ${err.message}`, "system", err));
      }
    });
  });
}
function convertBody(buffer, headers) {
  if (typeof convert2 !== "function") {
    throw new Error("The package `encoding` must be installed to use the textConverted() function");
  }
  const ct = headers.get("content-type");
  let charset = "utf-8";
  let res, str2;
  if (ct) {
    res = /charset=([^;]*)/i.exec(ct);
  }
  str2 = buffer.slice(0, 1024).toString();
  if (!res && str2) {
    res = /<meta.+?charset=(['"])(.+?)\1/i.exec(str2);
  }
  if (!res && str2) {
    res = /<meta[\s]+?http-equiv=(['"])content-type\1[\s]+?content=(['"])(.+?)\2/i.exec(str2);
    if (!res) {
      res = /<meta[\s]+?content=(['"])(.+?)\1[\s]+?http-equiv=(['"])content-type\3/i.exec(str2);
      if (res) {
        res.pop();
      }
    }
    if (res) {
      res = /charset=(.*)/i.exec(res.pop());
    }
  }
  if (!res && str2) {
    res = /<\?xml.+?encoding=(['"])(.+?)\1/i.exec(str2);
  }
  if (res) {
    charset = res.pop();
    if (charset === "gb2312" || charset === "gbk") {
      charset = "gb18030";
    }
  }
  return convert2(buffer, "UTF-8", charset).toString();
}
function isURLSearchParams(obj) {
  if (typeof obj !== "object" || typeof obj.append !== "function" || typeof obj.delete !== "function" || typeof obj.get !== "function" || typeof obj.getAll !== "function" || typeof obj.has !== "function" || typeof obj.set !== "function") {
    return false;
  }
  return obj.constructor.name === "URLSearchParams" || Object.prototype.toString.call(obj) === "[object URLSearchParams]" || typeof obj.sort === "function";
}
function isBlob(obj) {
  return typeof obj === "object" && typeof obj.arrayBuffer === "function" && typeof obj.type === "string" && typeof obj.stream === "function" && typeof obj.constructor === "function" && typeof obj.constructor.name === "string" && /^(Blob|File)$/.test(obj.constructor.name) && /^(Blob|File)$/.test(obj[Symbol.toStringTag]);
}
function clone(instance) {
  let p1, p2;
  let body = instance.body;
  if (instance.bodyUsed) {
    throw new Error("cannot clone body after it is used");
  }
  if (body instanceof import_stream.default && typeof body.getBoundary !== "function") {
    p1 = new PassThrough();
    p2 = new PassThrough();
    body.pipe(p1);
    body.pipe(p2);
    instance[INTERNALS].body = p1;
    body = p2;
  }
  return body;
}
function extractContentType(body) {
  if (body === null) {
    return null;
  } else if (typeof body === "string") {
    return "text/plain;charset=UTF-8";
  } else if (isURLSearchParams(body)) {
    return "application/x-www-form-urlencoded;charset=UTF-8";
  } else if (isBlob(body)) {
    return body.type || null;
  } else if (Buffer.isBuffer(body)) {
    return null;
  } else if (Object.prototype.toString.call(body) === "[object ArrayBuffer]") {
    return null;
  } else if (ArrayBuffer.isView(body)) {
    return null;
  } else if (typeof body.getBoundary === "function") {
    return `multipart/form-data;boundary=${body.getBoundary()}`;
  } else if (body instanceof import_stream.default) {
    return null;
  } else {
    return "text/plain;charset=UTF-8";
  }
}
function getTotalBytes(instance) {
  const body = instance.body;
  if (body === null) {
    return 0;
  } else if (isBlob(body)) {
    return body.size;
  } else if (Buffer.isBuffer(body)) {
    return body.length;
  } else if (body && typeof body.getLengthSync === "function") {
    if (body._lengthRetrievers && body._lengthRetrievers.length == 0 || // 1.x
      body.hasKnownLength && body.hasKnownLength()) {
      return body.getLengthSync();
    }
    return null;
  } else {
    return null;
  }
}
function writeToStream(dest, instance) {
  const body = instance.body;
  if (body === null) {
    dest.end();
  } else if (isBlob(body)) {
    body.stream().pipe(dest);
  } else if (Buffer.isBuffer(body)) {
    dest.write(body);
    dest.end();
  } else {
    body.pipe(dest);
  }
}
function validateName(name) {
  name = `${name}`;
  if (invalidTokenRegex.test(name) || name === "") {
    throw new TypeError(`${name} is not a legal HTTP header name`);
  }
}
function validateValue(value) {
  value = `${value}`;
  if (invalidHeaderCharRegex.test(value)) {
    throw new TypeError(`${value} is not a legal HTTP header value`);
  }
}
function find(map2, name) {
  name = name.toLowerCase();
  for (const key in map2) {
    if (key.toLowerCase() === name) {
      return key;
    }
  }
  return void 0;
}
function getHeaders(headers) {
  let kind = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : "key+value";
  const keys5 = Object.keys(headers[MAP]).sort();
  return keys5.map(kind === "key" ? function (k) {
    return k.toLowerCase();
  } : kind === "value" ? function (k) {
    return headers[MAP][k].join(", ");
  } : function (k) {
    return [k.toLowerCase(), headers[MAP][k].join(", ")];
  });
}
function createHeadersIterator(target, kind) {
  const iterator = Object.create(HeadersIteratorPrototype);
  iterator[INTERNAL] = {
    target,
    kind,
    index: 0
  };
  return iterator;
}
function exportNodeCompatibleHeaders(headers) {
  const obj = Object.assign({ __proto__: null }, headers[MAP]);
  const hostHeaderKey = find(headers[MAP], "Host");
  if (hostHeaderKey !== void 0) {
    obj[hostHeaderKey] = obj[hostHeaderKey][0];
  }
  return obj;
}
function createHeadersLenient(obj) {
  const headers = new Headers();
  for (const name of Object.keys(obj)) {
    if (invalidTokenRegex.test(name)) {
      continue;
    }
    if (Array.isArray(obj[name])) {
      for (const val of obj[name]) {
        if (invalidHeaderCharRegex.test(val)) {
          continue;
        }
        if (headers[MAP][name] === void 0) {
          headers[MAP][name] = [val];
        } else {
          headers[MAP][name].push(val);
        }
      }
    } else if (!invalidHeaderCharRegex.test(obj[name])) {
      headers[MAP][name] = [obj[name]];
    }
  }
  return headers;
}
function parseURL(urlStr) {
  if (/^[a-zA-Z][a-zA-Z\d+\-.]*:/.exec(urlStr)) {
    urlStr = new URL2(urlStr).toString();
  }
  return parse_url(urlStr);
}
function isRequest(input) {
  return typeof input === "object" && typeof input[INTERNALS$2] === "object";
}
function isAbortSignal(signal) {
  const proto = signal && typeof signal === "object" && Object.getPrototypeOf(signal);
  return !!(proto && proto.constructor.name === "AbortSignal");
}
function getNodeRequestOptions(request) {
  const parsedURL = request[INTERNALS$2].parsedURL;
  const headers = new Headers(request[INTERNALS$2].headers);
  if (!headers.has("Accept")) {
    headers.set("Accept", "*/*");
  }
  if (!parsedURL.protocol || !parsedURL.hostname) {
    throw new TypeError("Only absolute URLs are supported");
  }
  if (!/^https?:$/.test(parsedURL.protocol)) {
    throw new TypeError("Only HTTP(S) protocols are supported");
  }
  if (request.signal && request.body instanceof import_stream.default.Readable && !streamDestructionSupported) {
    throw new Error("Cancellation of streamed requests with AbortSignal is not supported in node < 8");
  }
  let contentLengthValue = null;
  if (request.body == null && /^(POST|PUT)$/i.test(request.method)) {
    contentLengthValue = "0";
  }
  if (request.body != null) {
    const totalBytes = getTotalBytes(request);
    if (typeof totalBytes === "number") {
      contentLengthValue = String(totalBytes);
    }
  }
  if (contentLengthValue) {
    headers.set("Content-Length", contentLengthValue);
  }
  if (!headers.has("User-Agent")) {
    headers.set("User-Agent", "node-fetch/1.0 (+https://github.com/bitinn/node-fetch)");
  }
  if (request.compress && !headers.has("Accept-Encoding")) {
    headers.set("Accept-Encoding", "gzip,deflate");
  }
  let agent = request.agent;
  if (typeof agent === "function") {
    agent = agent(parsedURL);
  }
  return Object.assign({}, parsedURL, {
    method: request.method,
    headers: exportNodeCompatibleHeaders(headers),
    agent
  });
}
function AbortError(message) {
  Error.call(this, message);
  this.type = "aborted";
  this.message = message;
  Error.captureStackTrace(this, this.constructor);
}
function fetch(url, opts) {
  if (!fetch.Promise) {
    throw new Error("native promise missing, set fetch.Promise to your favorite alternative");
  }
  Body.Promise = fetch.Promise;
  return new fetch.Promise(function (resolve, reject) {
    const request = new Request2(url, opts);
    const options = getNodeRequestOptions(request);
    const send = (options.protocol === "https:" ? import_https.default : import_http.default).request;
    const signal = request.signal;
    let response = null;
    const abort = function abort2() {
      let error = new AbortError("The user aborted a request.");
      reject(error);
      if (request.body && request.body instanceof import_stream.default.Readable) {
        destroyStream(request.body, error);
      }
      if (!response || !response.body) return;
      response.body.emit("error", error);
    };
    if (signal && signal.aborted) {
      abort();
      return;
    }
    const abortAndFinalize = function abortAndFinalize2() {
      abort();
      finalize();
    };
    const req = send(options);
    let reqTimeout;
    if (signal) {
      signal.addEventListener("abort", abortAndFinalize);
    }
    function finalize() {
      req.abort();
      if (signal) signal.removeEventListener("abort", abortAndFinalize);
      clearTimeout(reqTimeout);
    }
    if (request.timeout) {
      req.once("socket", function (socket) {
        reqTimeout = setTimeout(function () {
          reject(new FetchError(`network timeout at: ${request.url}`, "request-timeout"));
          finalize();
        }, request.timeout);
      });
    }
    req.on("error", function (err) {
      reject(new FetchError(`request to ${request.url} failed, reason: ${err.message}`, "system", err));
      if (response && response.body) {
        destroyStream(response.body, err);
      }
      finalize();
    });
    fixResponseChunkedTransferBadEnding(req, function (err) {
      if (signal && signal.aborted) {
        return;
      }
      if (response && response.body) {
        destroyStream(response.body, err);
      }
    });
    if (parseInt(process.version.substring(1)) < 14) {
      req.on("socket", function (s) {
        s.addListener("close", function (hadError) {
          const hasDataListener = s.listenerCount("data") > 0;
          if (response && hasDataListener && !hadError && !(signal && signal.aborted)) {
            const err = new Error("Premature close");
            err.code = "ERR_STREAM_PREMATURE_CLOSE";
            response.body.emit("error", err);
          }
        });
      });
    }
    req.on("response", function (res) {
      clearTimeout(reqTimeout);
      const headers = createHeadersLenient(res.headers);
      if (fetch.isRedirect(res.statusCode)) {
        const location = headers.get("Location");
        let locationURL = null;
        try {
          locationURL = location === null ? null : new URL$1(location, request.url).toString();
        } catch (err) {
          if (request.redirect !== "manual") {
            reject(new FetchError(`uri requested responds with an invalid redirect URL: ${location}`, "invalid-redirect"));
            finalize();
            return;
          }
        }
        switch (request.redirect) {
          case "error":
            reject(new FetchError(`uri requested responds with a redirect, redirect mode is set to error: ${request.url}`, "no-redirect"));
            finalize();
            return;
          case "manual":
            if (locationURL !== null) {
              try {
                headers.set("Location", locationURL);
              } catch (err) {
                reject(err);
              }
            }
            break;
          case "follow":
            if (locationURL === null) {
              break;
            }
            if (request.counter >= request.follow) {
              reject(new FetchError(`maximum redirect reached at: ${request.url}`, "max-redirect"));
              finalize();
              return;
            }
            const requestOpts = {
              headers: new Headers(request.headers),
              follow: request.follow,
              counter: request.counter + 1,
              agent: request.agent,
              compress: request.compress,
              method: request.method,
              body: request.body,
              signal: request.signal,
              timeout: request.timeout,
              size: request.size
            };
            if (!isDomainOrSubdomain(request.url, locationURL) || !isSameProtocol(request.url, locationURL)) {
              for (const name of ["authorization", "www-authenticate", "cookie", "cookie2"]) {
                requestOpts.headers.delete(name);
              }
            }
            if (res.statusCode !== 303 && request.body && getTotalBytes(request) === null) {
              reject(new FetchError("Cannot follow redirect with body being a readable stream", "unsupported-redirect"));
              finalize();
              return;
            }
            if (res.statusCode === 303 || (res.statusCode === 301 || res.statusCode === 302) && request.method === "POST") {
              requestOpts.method = "GET";
              requestOpts.body = void 0;
              requestOpts.headers.delete("content-length");
            }
            resolve(fetch(new Request2(locationURL, requestOpts)));
            finalize();
            return;
        }
      }
      res.once("end", function () {
        if (signal) signal.removeEventListener("abort", abortAndFinalize);
      });
      let body = res.pipe(new PassThrough$1());
      const response_options = {
        url: request.url,
        status: res.statusCode,
        statusText: res.statusMessage,
        headers,
        size: request.size,
        timeout: request.timeout,
        counter: request.counter
      };
      const codings = headers.get("Content-Encoding");
      if (!request.compress || request.method === "HEAD" || codings === null || res.statusCode === 204 || res.statusCode === 304) {
        response = new Response2(body, response_options);
        resolve(response);
        return;
      }
      const zlibOptions = {
        flush: import_zlib.default.Z_SYNC_FLUSH,
        finishFlush: import_zlib.default.Z_SYNC_FLUSH
      };
      if (codings == "gzip" || codings == "x-gzip") {
        body = body.pipe(import_zlib.default.createGunzip(zlibOptions));
        response = new Response2(body, response_options);
        resolve(response);
        return;
      }
      if (codings == "deflate" || codings == "x-deflate") {
        const raw = res.pipe(new PassThrough$1());
        raw.once("data", function (chunk) {
          if ((chunk[0] & 15) === 8) {
            body = body.pipe(import_zlib.default.createInflate());
          } else {
            body = body.pipe(import_zlib.default.createInflateRaw());
          }
          response = new Response2(body, response_options);
          resolve(response);
        });
        raw.on("end", function () {
          if (!response) {
            response = new Response2(body, response_options);
            resolve(response);
          }
        });
        return;
      }
      if (codings == "br" && typeof import_zlib.default.createBrotliDecompress === "function") {
        body = body.pipe(import_zlib.default.createBrotliDecompress());
        response = new Response2(body, response_options);
        resolve(response);
        return;
      }
      response = new Response2(body, response_options);
      resolve(response);
    });
    writeToStream(req, request);
  });
}
function fixResponseChunkedTransferBadEnding(request, errorCallback) {
  let socket;
  request.on("socket", function (s) {
    socket = s;
  });
  request.on("response", function (response) {
    const headers = response.headers;
    if (headers["transfer-encoding"] === "chunked" && !headers["content-length"]) {
      response.once("close", function (hadError) {
        const hasDataListener = socket && socket.listenerCount("data") > 0;
        if (hasDataListener && !hadError) {
          const err = new Error("Premature close");
          err.code = "ERR_STREAM_PREMATURE_CLOSE";
          errorCallback(err);
        }
      });
    }
  });
}
function destroyStream(stream, err) {
  if (stream.destroy) {
    stream.destroy(err);
  } else {
    stream.emit("error", err);
    stream.end();
  }
}
var import_stream, import_http, import_url, import_whatwg_url, import_https, import_zlib, Readable, BUFFER, TYPE, Blob, convert2, INTERNALS, PassThrough, invalidTokenRegex, invalidHeaderCharRegex, MAP, Headers, INTERNAL, HeadersIteratorPrototype, INTERNALS$1, STATUS_CODES, Response2, INTERNALS$2, URL2, parse_url, format_url, streamDestructionSupported, Request2, URL$1, PassThrough$1, isDomainOrSubdomain, isSameProtocol, lib_default;
var init_lib = __esm({
  "../../../node_modules/.pnpm/node-fetch@2.7.0/node_modules/node-fetch/lib/index.mjs"() {
    "use strict";
    import_stream = __toESM(require("stream"), 1);
    import_http = __toESM(require("http"), 1);
    import_url = __toESM(require("url"), 1);
    import_whatwg_url = __toESM(require_public_api(), 1);
    import_https = __toESM(require("https"), 1);
    import_zlib = __toESM(require("zlib"), 1);
    Readable = import_stream.default.Readable;
    BUFFER = Symbol("buffer");
    TYPE = Symbol("type");
    Blob = class _Blob {
      constructor() {
        this[TYPE] = "";
        const blobParts = arguments[0];
        const options = arguments[1];
        const buffers = [];
        let size2 = 0;
        if (blobParts) {
          const a = blobParts;
          const length = Number(a.length);
          for (let i = 0; i < length; i++) {
            const element = a[i];
            let buffer;
            if (element instanceof Buffer) {
              buffer = element;
            } else if (ArrayBuffer.isView(element)) {
              buffer = Buffer.from(element.buffer, element.byteOffset, element.byteLength);
            } else if (element instanceof ArrayBuffer) {
              buffer = Buffer.from(element);
            } else if (element instanceof _Blob) {
              buffer = element[BUFFER];
            } else {
              buffer = Buffer.from(typeof element === "string" ? element : String(element));
            }
            size2 += buffer.length;
            buffers.push(buffer);
          }
        }
        this[BUFFER] = Buffer.concat(buffers);
        let type2 = options && options.type !== void 0 && String(options.type).toLowerCase();
        if (type2 && !/[^\u0020-\u007E]/.test(type2)) {
          this[TYPE] = type2;
        }
      }
      get size() {
        return this[BUFFER].length;
      }
      get type() {
        return this[TYPE];
      }
      text() {
        return Promise.resolve(this[BUFFER].toString());
      }
      arrayBuffer() {
        const buf = this[BUFFER];
        const ab = buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength);
        return Promise.resolve(ab);
      }
      stream() {
        const readable = new Readable();
        readable._read = function () {
        };
        readable.push(this[BUFFER]);
        readable.push(null);
        return readable;
      }
      toString() {
        return "[object Blob]";
      }
      slice() {
        const size2 = this.size;
        const start = arguments[0];
        const end = arguments[1];
        let relativeStart, relativeEnd;
        if (start === void 0) {
          relativeStart = 0;
        } else if (start < 0) {
          relativeStart = Math.max(size2 + start, 0);
        } else {
          relativeStart = Math.min(start, size2);
        }
        if (end === void 0) {
          relativeEnd = size2;
        } else if (end < 0) {
          relativeEnd = Math.max(size2 + end, 0);
        } else {
          relativeEnd = Math.min(end, size2);
        }
        const span = Math.max(relativeEnd - relativeStart, 0);
        const buffer = this[BUFFER];
        const slicedBuffer = buffer.slice(relativeStart, relativeStart + span);
        const blob = new _Blob([], { type: arguments[2] });
        blob[BUFFER] = slicedBuffer;
        return blob;
      }
    };
    Object.defineProperties(Blob.prototype, {
      size: { enumerable: true },
      type: { enumerable: true },
      slice: { enumerable: true }
    });
    Object.defineProperty(Blob.prototype, Symbol.toStringTag, {
      value: "Blob",
      writable: false,
      enumerable: false,
      configurable: true
    });
    FetchError.prototype = Object.create(Error.prototype);
    FetchError.prototype.constructor = FetchError;
    FetchError.prototype.name = "FetchError";
    try {
      convert2 = require("encoding").convert;
    } catch (e) {
    }
    INTERNALS = Symbol("Body internals");
    PassThrough = import_stream.default.PassThrough;
    Body.prototype = {
      get body() {
        return this[INTERNALS].body;
      },
      get bodyUsed() {
        return this[INTERNALS].disturbed;
      },
      /**
       * Decode response as ArrayBuffer
       *
       * @return  Promise
       */
      arrayBuffer() {
        return consumeBody.call(this).then(function (buf) {
          return buf.buffer.slice(buf.byteOffset, buf.byteOffset + buf.byteLength);
        });
      },
      /**
       * Return raw response as Blob
       *
       * @return Promise
       */
      blob() {
        let ct = this.headers && this.headers.get("content-type") || "";
        return consumeBody.call(this).then(function (buf) {
          return Object.assign(
            // Prevent copying
            new Blob([], {
              type: ct.toLowerCase()
            }),
            {
              [BUFFER]: buf
            }
          );
        });
      },
      /**
       * Decode response as json
       *
       * @return  Promise
       */
      json() {
        var _this2 = this;
        return consumeBody.call(this).then(function (buffer) {
          try {
            return JSON.parse(buffer.toString());
          } catch (err) {
            return Body.Promise.reject(new FetchError(`invalid json response body at ${_this2.url} reason: ${err.message}`, "invalid-json"));
          }
        });
      },
      /**
       * Decode response as text
       *
       * @return  Promise
       */
      text() {
        return consumeBody.call(this).then(function (buffer) {
          return buffer.toString();
        });
      },
      /**
       * Decode response as buffer (non-spec api)
       *
       * @return  Promise
       */
      buffer() {
        return consumeBody.call(this);
      },
      /**
       * Decode response as text, while automatically detecting the encoding and
       * trying to decode to UTF-8 (non-spec api)
       *
       * @return  Promise
       */
      textConverted() {
        var _this3 = this;
        return consumeBody.call(this).then(function (buffer) {
          return convertBody(buffer, _this3.headers);
        });
      }
    };
    Object.defineProperties(Body.prototype, {
      body: { enumerable: true },
      bodyUsed: { enumerable: true },
      arrayBuffer: { enumerable: true },
      blob: { enumerable: true },
      json: { enumerable: true },
      text: { enumerable: true }
    });
    Body.mixIn = function (proto) {
      for (const name of Object.getOwnPropertyNames(Body.prototype)) {
        if (!(name in proto)) {
          const desc = Object.getOwnPropertyDescriptor(Body.prototype, name);
          Object.defineProperty(proto, name, desc);
        }
      }
    };
    Body.Promise = global.Promise;
    invalidTokenRegex = /[^\^_`a-zA-Z\-0-9!#$%&'*+.|~]/;
    invalidHeaderCharRegex = /[^\t\x20-\x7e\x80-\xff]/;
    MAP = Symbol("map");
    Headers = class _Headers {
      /**
       * Headers class
       *
       * @param   Object  headers  Response headers
       * @return  Void
       */
      constructor() {
        let init = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : void 0;
        this[MAP] = /* @__PURE__ */ Object.create(null);
        if (init instanceof _Headers) {
          const rawHeaders = init.raw();
          const headerNames = Object.keys(rawHeaders);
          for (const headerName of headerNames) {
            for (const value of rawHeaders[headerName]) {
              this.append(headerName, value);
            }
          }
          return;
        }
        if (init == null);
        else if (typeof init === "object") {
          const method = init[Symbol.iterator];
          if (method != null) {
            if (typeof method !== "function") {
              throw new TypeError("Header pairs must be iterable");
            }
            const pairs2 = [];
            for (const pair of init) {
              if (typeof pair !== "object" || typeof pair[Symbol.iterator] !== "function") {
                throw new TypeError("Each header pair must be iterable");
              }
              pairs2.push(Array.from(pair));
            }
            for (const pair of pairs2) {
              if (pair.length !== 2) {
                throw new TypeError("Each header pair must be a name/value tuple");
              }
              this.append(pair[0], pair[1]);
            }
          } else {
            for (const key of Object.keys(init)) {
              const value = init[key];
              this.append(key, value);
            }
          }
        } else {
          throw new TypeError("Provided initializer must be an object");
        }
      }
      /**
       * Return combined header value given name
       *
       * @param   String  name  Header name
       * @return  Mixed
       */
      get(name) {
        name = `${name}`;
        validateName(name);
        const key = find(this[MAP], name);
        if (key === void 0) {
          return null;
        }
        return this[MAP][key].join(", ");
      }
      /**
       * Iterate over all headers
       *
       * @param   Function  callback  Executed for each item with parameters (value, name, thisArg)
       * @param   Boolean   thisArg   `this` context for callback function
       * @return  Void
       */
      forEach(callback) {
        let thisArg = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : void 0;
        let pairs2 = getHeaders(this);
        let i = 0;
        while (i < pairs2.length) {
          var _pairs$i = pairs2[i];
          const name = _pairs$i[0], value = _pairs$i[1];
          callback.call(thisArg, value, name, this);
          pairs2 = getHeaders(this);
          i++;
        }
      }
      /**
       * Overwrite header values given name
       *
       * @param   String  name   Header name
       * @param   String  value  Header value
       * @return  Void
       */
      set(name, value) {
        name = `${name}`;
        value = `${value}`;
        validateName(name);
        validateValue(value);
        const key = find(this[MAP], name);
        this[MAP][key !== void 0 ? key : name] = [value];
      }
      /**
       * Append a value onto existing header
       *
       * @param   String  name   Header name
       * @param   String  value  Header value
       * @return  Void
       */
      append(name, value) {
        name = `${name}`;
        value = `${value}`;
        validateName(name);
        validateValue(value);
        const key = find(this[MAP], name);
        if (key !== void 0) {
          this[MAP][key].push(value);
        } else {
          this[MAP][name] = [value];
        }
      }
      /**
       * Check for header name existence
       *
       * @param   String   name  Header name
       * @return  Boolean
       */
      has(name) {
        name = `${name}`;
        validateName(name);
        return find(this[MAP], name) !== void 0;
      }
      /**
       * Delete all header values given name
       *
       * @param   String  name  Header name
       * @return  Void
       */
      delete(name) {
        name = `${name}`;
        validateName(name);
        const key = find(this[MAP], name);
        if (key !== void 0) {
          delete this[MAP][key];
        }
      }
      /**
       * Return raw headers (non-spec api)
       *
       * @return  Object
       */
      raw() {
        return this[MAP];
      }
      /**
       * Get an iterator on keys.
       *
       * @return  Iterator
       */
      keys() {
        return createHeadersIterator(this, "key");
      }
      /**
       * Get an iterator on values.
       *
       * @return  Iterator
       */
      values() {
        return createHeadersIterator(this, "value");
      }
      /**
       * Get an iterator on entries.
       *
       * This is the default iterator of the Headers object.
       *
       * @return  Iterator
       */
      [Symbol.iterator]() {
        return createHeadersIterator(this, "key+value");
      }
    };
    Headers.prototype.entries = Headers.prototype[Symbol.iterator];
    Object.defineProperty(Headers.prototype, Symbol.toStringTag, {
      value: "Headers",
      writable: false,
      enumerable: false,
      configurable: true
    });
    Object.defineProperties(Headers.prototype, {
      get: { enumerable: true },
      forEach: { enumerable: true },
      set: { enumerable: true },
      append: { enumerable: true },
      has: { enumerable: true },
      delete: { enumerable: true },
      keys: { enumerable: true },
      values: { enumerable: true },
      entries: { enumerable: true }
    });
    INTERNAL = Symbol("internal");
    HeadersIteratorPrototype = Object.setPrototypeOf({
      next() {
        if (!this || Object.getPrototypeOf(this) !== HeadersIteratorPrototype) {
          throw new TypeError("Value of `this` is not a HeadersIterator");
        }
        var _INTERNAL = this[INTERNAL];
        const target = _INTERNAL.target, kind = _INTERNAL.kind, index = _INTERNAL.index;
        const values = getHeaders(target, kind);
        const len = values.length;
        if (index >= len) {
          return {
            value: void 0,
            done: true
          };
        }
        this[INTERNAL].index = index + 1;
        return {
          value: values[index],
          done: false
        };
      }
    }, Object.getPrototypeOf(Object.getPrototypeOf([][Symbol.iterator]())));
    Object.defineProperty(HeadersIteratorPrototype, Symbol.toStringTag, {
      value: "HeadersIterator",
      writable: false,
      enumerable: false,
      configurable: true
    });
    INTERNALS$1 = Symbol("Response internals");
    STATUS_CODES = import_http.default.STATUS_CODES;
    Response2 = class _Response {
      constructor() {
        let body = arguments.length > 0 && arguments[0] !== void 0 ? arguments[0] : null;
        let opts = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        Body.call(this, body, opts);
        const status = opts.status || 200;
        const headers = new Headers(opts.headers);
        if (body != null && !headers.has("Content-Type")) {
          const contentType = extractContentType(body);
          if (contentType) {
            headers.append("Content-Type", contentType);
          }
        }
        this[INTERNALS$1] = {
          url: opts.url,
          status,
          statusText: opts.statusText || STATUS_CODES[status],
          headers,
          counter: opts.counter
        };
      }
      get url() {
        return this[INTERNALS$1].url || "";
      }
      get status() {
        return this[INTERNALS$1].status;
      }
      /**
       * Convenience property representing if the request ended normally
       */
      get ok() {
        return this[INTERNALS$1].status >= 200 && this[INTERNALS$1].status < 300;
      }
      get redirected() {
        return this[INTERNALS$1].counter > 0;
      }
      get statusText() {
        return this[INTERNALS$1].statusText;
      }
      get headers() {
        return this[INTERNALS$1].headers;
      }
      /**
       * Clone this response
       *
       * @return  Response
       */
      clone() {
        return new _Response(clone(this), {
          url: this.url,
          status: this.status,
          statusText: this.statusText,
          headers: this.headers,
          ok: this.ok,
          redirected: this.redirected
        });
      }
    };
    Body.mixIn(Response2.prototype);
    Object.defineProperties(Response2.prototype, {
      url: { enumerable: true },
      status: { enumerable: true },
      ok: { enumerable: true },
      redirected: { enumerable: true },
      statusText: { enumerable: true },
      headers: { enumerable: true },
      clone: { enumerable: true }
    });
    Object.defineProperty(Response2.prototype, Symbol.toStringTag, {
      value: "Response",
      writable: false,
      enumerable: false,
      configurable: true
    });
    INTERNALS$2 = Symbol("Request internals");
    URL2 = import_url.default.URL || import_whatwg_url.default.URL;
    parse_url = import_url.default.parse;
    format_url = import_url.default.format;
    streamDestructionSupported = "destroy" in import_stream.default.Readable.prototype;
    Request2 = class _Request {
      constructor(input) {
        let init = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        let parsedURL;
        if (!isRequest(input)) {
          if (input && input.href) {
            parsedURL = parseURL(input.href);
          } else {
            parsedURL = parseURL(`${input}`);
          }
          input = {};
        } else {
          parsedURL = parseURL(input.url);
        }
        let method = init.method || input.method || "GET";
        method = method.toUpperCase();
        if ((init.body != null || isRequest(input) && input.body !== null) && (method === "GET" || method === "HEAD")) {
          throw new TypeError("Request with GET/HEAD method cannot have body");
        }
        let inputBody = init.body != null ? init.body : isRequest(input) && input.body !== null ? clone(input) : null;
        Body.call(this, inputBody, {
          timeout: init.timeout || input.timeout || 0,
          size: init.size || input.size || 0
        });
        const headers = new Headers(init.headers || input.headers || {});
        if (inputBody != null && !headers.has("Content-Type")) {
          const contentType = extractContentType(inputBody);
          if (contentType) {
            headers.append("Content-Type", contentType);
          }
        }
        let signal = isRequest(input) ? input.signal : null;
        if ("signal" in init) signal = init.signal;
        if (signal != null && !isAbortSignal(signal)) {
          throw new TypeError("Expected signal to be an instanceof AbortSignal");
        }
        this[INTERNALS$2] = {
          method,
          redirect: init.redirect || input.redirect || "follow",
          headers,
          parsedURL,
          signal
        };
        this.follow = init.follow !== void 0 ? init.follow : input.follow !== void 0 ? input.follow : 20;
        this.compress = init.compress !== void 0 ? init.compress : input.compress !== void 0 ? input.compress : true;
        this.counter = init.counter || input.counter || 0;
        this.agent = init.agent || input.agent;
      }
      get method() {
        return this[INTERNALS$2].method;
      }
      get url() {
        return format_url(this[INTERNALS$2].parsedURL);
      }
      get headers() {
        return this[INTERNALS$2].headers;
      }
      get redirect() {
        return this[INTERNALS$2].redirect;
      }
      get signal() {
        return this[INTERNALS$2].signal;
      }
      /**
       * Clone this request
       *
       * @return  Request
       */
      clone() {
        return new _Request(this);
      }
    };
    Body.mixIn(Request2.prototype);
    Object.defineProperty(Request2.prototype, Symbol.toStringTag, {
      value: "Request",
      writable: false,
      enumerable: false,
      configurable: true
    });
    Object.defineProperties(Request2.prototype, {
      method: { enumerable: true },
      url: { enumerable: true },
      headers: { enumerable: true },
      redirect: { enumerable: true },
      clone: { enumerable: true },
      signal: { enumerable: true }
    });
    AbortError.prototype = Object.create(Error.prototype);
    AbortError.prototype.constructor = AbortError;
    AbortError.prototype.name = "AbortError";
    URL$1 = import_url.default.URL || import_whatwg_url.default.URL;
    PassThrough$1 = import_stream.default.PassThrough;
    isDomainOrSubdomain = function isDomainOrSubdomain2(destination, original) {
      const orig = new URL$1(original).hostname;
      const dest = new URL$1(destination).hostname;
      return orig === dest || orig[orig.length - dest.length - 1] === "." && orig.endsWith(dest);
    };
    isSameProtocol = function isSameProtocol2(destination, original) {
      const orig = new URL$1(original).protocol;
      const dest = new URL$1(destination).protocol;
      return orig === dest;
    };
    fetch.isRedirect = function (code) {
      return code === 301 || code === 302 || code === 303 || code === 307 || code === 308;
    };
    fetch.Promise = global.Promise;
    lib_default = fetch;
  }
});

// ../../../node_modules/.pnpm/pluralize@8.0.0/node_modules/pluralize/pluralize.js
var require_pluralize = __commonJS({
  "../../../node_modules/.pnpm/pluralize@8.0.0/node_modules/pluralize/pluralize.js"(exports2, module2) {
    "use strict";
    (function (root2, pluralize) {
      if (typeof require === "function" && typeof exports2 === "object" && typeof module2 === "object") {
        module2.exports = pluralize();
      } else if (typeof define === "function" && define.amd) {
        define(function () {
          return pluralize();
        });
      } else {
        root2.pluralize = pluralize();
      }
    })(exports2, function () {
      var pluralRules = [];
      var singularRules = [];
      var uncountables = {};
      var irregularPlurals = {};
      var irregularSingles = {};
      function sanitizeRule(rule) {
        if (typeof rule === "string") {
          return new RegExp("^" + rule + "$", "i");
        }
        return rule;
      }
      function restoreCase(word, token) {
        if (word === token) return token;
        if (word === word.toLowerCase()) return token.toLowerCase();
        if (word === word.toUpperCase()) return token.toUpperCase();
        if (word[0] === word[0].toUpperCase()) {
          return token.charAt(0).toUpperCase() + token.substr(1).toLowerCase();
        }
        return token.toLowerCase();
      }
      function interpolate(str2, args) {
        return str2.replace(/\$(\d{1,2})/g, function (match, index) {
          return args[index] || "";
        });
      }
      function replace(word, rule) {
        return word.replace(rule[0], function (match, index) {
          var result = interpolate(rule[1], arguments);
          if (match === "") {
            return restoreCase(word[index - 1], result);
          }
          return restoreCase(match, result);
        });
      }
      function sanitizeWord(token, word, rules) {
        if (!token.length || uncountables.hasOwnProperty(token)) {
          return word;
        }
        var len = rules.length;
        while (len--) {
          var rule = rules[len];
          if (rule[0].test(word)) return replace(word, rule);
        }
        return word;
      }
      function replaceWord(replaceMap, keepMap, rules) {
        return function (word) {
          var token = word.toLowerCase();
          if (keepMap.hasOwnProperty(token)) {
            return restoreCase(word, token);
          }
          if (replaceMap.hasOwnProperty(token)) {
            return restoreCase(word, replaceMap[token]);
          }
          return sanitizeWord(token, word, rules);
        };
      }
      function checkWord(replaceMap, keepMap, rules, bool2) {
        return function (word) {
          var token = word.toLowerCase();
          if (keepMap.hasOwnProperty(token)) return true;
          if (replaceMap.hasOwnProperty(token)) return false;
          return sanitizeWord(token, token, rules) === token;
        };
      }
      function pluralize(word, count, inclusive) {
        var pluralized = count === 1 ? pluralize.singular(word) : pluralize.plural(word);
        return (inclusive ? count + " " : "") + pluralized;
      }
      pluralize.plural = replaceWord(
        irregularSingles,
        irregularPlurals,
        pluralRules
      );
      pluralize.isPlural = checkWord(
        irregularSingles,
        irregularPlurals,
        pluralRules
      );
      pluralize.singular = replaceWord(
        irregularPlurals,
        irregularSingles,
        singularRules
      );
      pluralize.isSingular = checkWord(
        irregularPlurals,
        irregularSingles,
        singularRules
      );
      pluralize.addPluralRule = function (rule, replacement) {
        pluralRules.push([sanitizeRule(rule), replacement]);
      };
      pluralize.addSingularRule = function (rule, replacement) {
        singularRules.push([sanitizeRule(rule), replacement]);
      };
      pluralize.addUncountableRule = function (word) {
        if (typeof word === "string") {
          uncountables[word.toLowerCase()] = true;
          return;
        }
        pluralize.addPluralRule(word, "$0");
        pluralize.addSingularRule(word, "$0");
      };
      pluralize.addIrregularRule = function (single, plural) {
        plural = plural.toLowerCase();
        single = single.toLowerCase();
        irregularSingles[single] = plural;
        irregularPlurals[plural] = single;
      };
      [
        // Pronouns.
        ["I", "we"],
        ["me", "us"],
        ["he", "they"],
        ["she", "they"],
        ["them", "them"],
        ["myself", "ourselves"],
        ["yourself", "yourselves"],
        ["itself", "themselves"],
        ["herself", "themselves"],
        ["himself", "themselves"],
        ["themself", "themselves"],
        ["is", "are"],
        ["was", "were"],
        ["has", "have"],
        ["this", "these"],
        ["that", "those"],
        // Words ending in with a consonant and `o`.
        ["echo", "echoes"],
        ["dingo", "dingoes"],
        ["volcano", "volcanoes"],
        ["tornado", "tornadoes"],
        ["torpedo", "torpedoes"],
        // Ends with `us`.
        ["genus", "genera"],
        ["viscus", "viscera"],
        // Ends with `ma`.
        ["stigma", "stigmata"],
        ["stoma", "stomata"],
        ["dogma", "dogmata"],
        ["lemma", "lemmata"],
        ["schema", "schemata"],
        ["anathema", "anathemata"],
        // Other irregular rules.
        ["ox", "oxen"],
        ["axe", "axes"],
        ["die", "dice"],
        ["yes", "yeses"],
        ["foot", "feet"],
        ["eave", "eaves"],
        ["goose", "geese"],
        ["tooth", "teeth"],
        ["quiz", "quizzes"],
        ["human", "humans"],
        ["proof", "proofs"],
        ["carve", "carves"],
        ["valve", "valves"],
        ["looey", "looies"],
        ["thief", "thieves"],
        ["groove", "grooves"],
        ["pickaxe", "pickaxes"],
        ["passerby", "passersby"]
      ].forEach(function (rule) {
        return pluralize.addIrregularRule(rule[0], rule[1]);
      });
      [
        [/s?$/i, "s"],
        [/[^\u0000-\u007F]$/i, "$0"],
        [/([^aeiou]ese)$/i, "$1"],
        [/(ax|test)is$/i, "$1es"],
        [/(alias|[^aou]us|t[lm]as|gas|ris)$/i, "$1es"],
        [/(e[mn]u)s?$/i, "$1s"],
        [/([^l]ias|[aeiou]las|[ejzr]as|[iu]am)$/i, "$1"],
        [/(alumn|syllab|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i, "$1i"],
        [/(alumn|alg|vertebr)(?:a|ae)$/i, "$1ae"],
        [/(seraph|cherub)(?:im)?$/i, "$1im"],
        [/(her|at|gr)o$/i, "$1oes"],
        [/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|automat|quor)(?:a|um)$/i, "$1a"],
        [/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)(?:a|on)$/i, "$1a"],
        [/sis$/i, "ses"],
        [/(?:(kni|wi|li)fe|(ar|l|ea|eo|oa|hoo)f)$/i, "$1$2ves"],
        [/([^aeiouy]|qu)y$/i, "$1ies"],
        [/([^ch][ieo][ln])ey$/i, "$1ies"],
        [/(x|ch|ss|sh|zz)$/i, "$1es"],
        [/(matr|cod|mur|sil|vert|ind|append)(?:ix|ex)$/i, "$1ices"],
        [/\b((?:tit)?m|l)(?:ice|ouse)$/i, "$1ice"],
        [/(pe)(?:rson|ople)$/i, "$1ople"],
        [/(child)(?:ren)?$/i, "$1ren"],
        [/eaux$/i, "$0"],
        [/m[ae]n$/i, "men"],
        ["thou", "you"]
      ].forEach(function (rule) {
        return pluralize.addPluralRule(rule[0], rule[1]);
      });
      [
        [/s$/i, ""],
        [/(ss)$/i, "$1"],
        [/(wi|kni|(?:after|half|high|low|mid|non|night|[^\w]|^)li)ves$/i, "$1fe"],
        [/(ar|(?:wo|[ae])l|[eo][ao])ves$/i, "$1f"],
        [/ies$/i, "y"],
        [/\b([pl]|zomb|(?:neck|cross)?t|coll|faer|food|gen|goon|group|lass|talk|goal|cut)ies$/i, "$1ie"],
        [/\b(mon|smil)ies$/i, "$1ey"],
        [/\b((?:tit)?m|l)ice$/i, "$1ouse"],
        [/(seraph|cherub)im$/i, "$1"],
        [/(x|ch|ss|sh|zz|tto|go|cho|alias|[^aou]us|t[lm]as|gas|(?:her|at|gr)o|[aeiou]ris)(?:es)?$/i, "$1"],
        [/(analy|diagno|parenthe|progno|synop|the|empha|cri|ne)(?:sis|ses)$/i, "$1sis"],
        [/(movie|twelve|abuse|e[mn]u)s$/i, "$1"],
        [/(test)(?:is|es)$/i, "$1is"],
        [/(alumn|syllab|vir|radi|nucle|fung|cact|stimul|termin|bacill|foc|uter|loc|strat)(?:us|i)$/i, "$1us"],
        [/(agend|addend|millenni|dat|extrem|bacteri|desiderat|strat|candelabr|errat|ov|symposi|curricul|quor)a$/i, "$1um"],
        [/(apheli|hyperbat|periheli|asyndet|noumen|phenomen|criteri|organ|prolegomen|hedr|automat)a$/i, "$1on"],
        [/(alumn|alg|vertebr)ae$/i, "$1a"],
        [/(cod|mur|sil|vert|ind)ices$/i, "$1ex"],
        [/(matr|append)ices$/i, "$1ix"],
        [/(pe)(rson|ople)$/i, "$1rson"],
        [/(child)ren$/i, "$1"],
        [/(eau)x?$/i, "$1"],
        [/men$/i, "man"]
      ].forEach(function (rule) {
        return pluralize.addSingularRule(rule[0], rule[1]);
      });
      [
        // Singular words with no plurals.
        "adulthood",
        "advice",
        "agenda",
        "aid",
        "aircraft",
        "alcohol",
        "ammo",
        "analytics",
        "anime",
        "athletics",
        "audio",
        "bison",
        "blood",
        "bream",
        "buffalo",
        "butter",
        "carp",
        "cash",
        "chassis",
        "chess",
        "clothing",
        "cod",
        "commerce",
        "cooperation",
        "corps",
        "debris",
        "diabetes",
        "digestion",
        "elk",
        "energy",
        "equipment",
        "excretion",
        "expertise",
        "firmware",
        "flounder",
        "fun",
        "gallows",
        "garbage",
        "graffiti",
        "hardware",
        "headquarters",
        "health",
        "herpes",
        "highjinks",
        "homework",
        "housework",
        "information",
        "jeans",
        "justice",
        "kudos",
        "labour",
        "literature",
        "machinery",
        "mackerel",
        "mail",
        "media",
        "mews",
        "moose",
        "music",
        "mud",
        "manga",
        "news",
        "only",
        "personnel",
        "pike",
        "plankton",
        "pliers",
        "police",
        "pollution",
        "premises",
        "rain",
        "research",
        "rice",
        "salmon",
        "scissors",
        "series",
        "sewage",
        "shambles",
        "shrimp",
        "software",
        "species",
        "staff",
        "swine",
        "tennis",
        "traffic",
        "transportation",
        "trout",
        "tuna",
        "wealth",
        "welfare",
        "whiting",
        "wildebeest",
        "wildlife",
        "you",
        /pok[eé]mon$/i,
        // Regexes.
        /[^aeiou]ese$/i,
        // "chinese", "japanese"
        /deer$/i,
        // "deer", "reindeer"
        /fish$/i,
        // "fish", "blowfish", "angelfish"
        /measles$/i,
        /o[iu]s$/i,
        // "carnivorous"
        /pox$/i,
        // "chickpox", "smallpox"
        /sheep$/i
      ].forEach(pluralize.addUncountableRule);
      return pluralize;
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/common.js
var require_common = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/common.js"(exports2, module2) {
    "use strict";
    function isNothing2(subject) {
      return typeof subject === "undefined" || subject === null;
    }
    function isObject3(subject) {
      return typeof subject === "object" && subject !== null;
    }
    function toArray2(sequence) {
      if (Array.isArray(sequence)) return sequence;
      else if (isNothing2(sequence)) return [];
      return [sequence];
    }
    function extend3(target, source) {
      var index, length, key, sourceKeys;
      if (source) {
        sourceKeys = Object.keys(source);
        for (index = 0, length = sourceKeys.length; index < length; index += 1) {
          key = sourceKeys[index];
          target[key] = source[key];
        }
      }
      return target;
    }
    function repeat2(string3, count) {
      var result = "", cycle;
      for (cycle = 0; cycle < count; cycle += 1) {
        result += string3;
      }
      return result;
    }
    function isNegativeZero2(number3) {
      return number3 === 0 && Number.NEGATIVE_INFINITY === 1 / number3;
    }
    module2.exports.isNothing = isNothing2;
    module2.exports.isObject = isObject3;
    module2.exports.toArray = toArray2;
    module2.exports.repeat = repeat2;
    module2.exports.isNegativeZero = isNegativeZero2;
    module2.exports.extend = extend3;
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/exception.js
var require_exception = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/exception.js"(exports2, module2) {
    "use strict";
    function formatError2(exception2, compact2) {
      var where = "", message = exception2.reason || "(unknown reason)";
      if (!exception2.mark) return message;
      if (exception2.mark.name) {
        where += 'in "' + exception2.mark.name + '" ';
      }
      where += "(" + (exception2.mark.line + 1) + ":" + (exception2.mark.column + 1) + ")";
      if (!compact2 && exception2.mark.snippet) {
        where += "\n\n" + exception2.mark.snippet;
      }
      return message + " " + where;
    }
    function YAMLException2(reason, mark) {
      Error.call(this);
      this.name = "YAMLException";
      this.reason = reason;
      this.mark = mark;
      this.message = formatError2(this, false);
      if (Error.captureStackTrace) {
        Error.captureStackTrace(this, this.constructor);
      } else {
        this.stack = new Error().stack || "";
      }
    }
    YAMLException2.prototype = Object.create(Error.prototype);
    YAMLException2.prototype.constructor = YAMLException2;
    YAMLException2.prototype.toString = function toString4(compact2) {
      return this.name + ": " + formatError2(this, compact2);
    };
    module2.exports = YAMLException2;
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/snippet.js
var require_snippet = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/snippet.js"(exports2, module2) {
    "use strict";
    var common2 = require_common();
    function getLine2(buffer, lineStart, lineEnd, position, maxLineLength) {
      var head = "";
      var tail = "";
      var maxHalfLength = Math.floor(maxLineLength / 2) - 1;
      if (position - lineStart > maxHalfLength) {
        head = " ... ";
        lineStart = position - maxHalfLength + head.length;
      }
      if (lineEnd - position > maxHalfLength) {
        tail = " ...";
        lineEnd = position + maxHalfLength - tail.length;
      }
      return {
        str: head + buffer.slice(lineStart, lineEnd).replace(/\t/g, "\u2192") + tail,
        pos: position - lineStart + head.length
        // relative position
      };
    }
    function padStart2(string3, max) {
      return common2.repeat(" ", max - string3.length) + string3;
    }
    function makeSnippet2(mark, options) {
      options = Object.create(options || null);
      if (!mark.buffer) return null;
      if (!options.maxLength) options.maxLength = 79;
      if (typeof options.indent !== "number") options.indent = 1;
      if (typeof options.linesBefore !== "number") options.linesBefore = 3;
      if (typeof options.linesAfter !== "number") options.linesAfter = 2;
      var re = /\r?\n|\r|\0/g;
      var lineStarts = [0];
      var lineEnds = [];
      var match;
      var foundLineNo = -1;
      while (match = re.exec(mark.buffer)) {
        lineEnds.push(match.index);
        lineStarts.push(match.index + match[0].length);
        if (mark.position <= match.index && foundLineNo < 0) {
          foundLineNo = lineStarts.length - 2;
        }
      }
      if (foundLineNo < 0) foundLineNo = lineStarts.length - 1;
      var result = "", i, line;
      var lineNoLength = Math.min(mark.line + options.linesAfter, lineEnds.length).toString().length;
      var maxLineLength = options.maxLength - (options.indent + lineNoLength + 3);
      for (i = 1; i <= options.linesBefore; i++) {
        if (foundLineNo - i < 0) break;
        line = getLine2(
          mark.buffer,
          lineStarts[foundLineNo - i],
          lineEnds[foundLineNo - i],
          mark.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo - i]),
          maxLineLength
        );
        result = common2.repeat(" ", options.indent) + padStart2((mark.line - i + 1).toString(), lineNoLength) + " | " + line.str + "\n" + result;
      }
      line = getLine2(mark.buffer, lineStarts[foundLineNo], lineEnds[foundLineNo], mark.position, maxLineLength);
      result += common2.repeat(" ", options.indent) + padStart2((mark.line + 1).toString(), lineNoLength) + " | " + line.str + "\n";
      result += common2.repeat("-", options.indent + lineNoLength + 3 + line.pos) + "^\n";
      for (i = 1; i <= options.linesAfter; i++) {
        if (foundLineNo + i >= lineEnds.length) break;
        line = getLine2(
          mark.buffer,
          lineStarts[foundLineNo + i],
          lineEnds[foundLineNo + i],
          mark.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo + i]),
          maxLineLength
        );
        result += common2.repeat(" ", options.indent) + padStart2((mark.line + i + 1).toString(), lineNoLength) + " | " + line.str + "\n";
      }
      return result.replace(/\n$/, "");
    }
    module2.exports = makeSnippet2;
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type.js
var require_type = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type.js"(exports2, module2) {
    "use strict";
    var YAMLException2 = require_exception();
    var TYPE_CONSTRUCTOR_OPTIONS2 = [
      "kind",
      "multi",
      "resolve",
      "construct",
      "instanceOf",
      "predicate",
      "represent",
      "representName",
      "defaultStyle",
      "styleAliases"
    ];
    var YAML_NODE_KINDS2 = [
      "scalar",
      "sequence",
      "mapping"
    ];
    function compileStyleAliases2(map2) {
      var result = {};
      if (map2 !== null) {
        Object.keys(map2).forEach(function (style) {
          map2[style].forEach(function (alias) {
            result[String(alias)] = style;
          });
        });
      }
      return result;
    }
    function Type3(tag, options) {
      options = options || {};
      Object.keys(options).forEach(function (name) {
        if (TYPE_CONSTRUCTOR_OPTIONS2.indexOf(name) === -1) {
          throw new YAMLException2('Unknown option "' + name + '" is met in definition of "' + tag + '" YAML type.');
        }
      });
      this.options = options;
      this.tag = tag;
      this.kind = options["kind"] || null;
      this.resolve = options["resolve"] || function () {
        return true;
      };
      this.construct = options["construct"] || function (data) {
        return data;
      };
      this.instanceOf = options["instanceOf"] || null;
      this.predicate = options["predicate"] || null;
      this.represent = options["represent"] || null;
      this.representName = options["representName"] || null;
      this.defaultStyle = options["defaultStyle"] || null;
      this.multi = options["multi"] || false;
      this.styleAliases = compileStyleAliases2(options["styleAliases"] || null);
      if (YAML_NODE_KINDS2.indexOf(this.kind) === -1) {
        throw new YAMLException2('Unknown kind "' + this.kind + '" is specified for "' + tag + '" YAML type.');
      }
    }
    module2.exports = Type3;
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema.js
var require_schema = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema.js"(exports2, module2) {
    "use strict";
    var YAMLException2 = require_exception();
    var Type3 = require_type();
    function compileList2(schema2, name) {
      var result = [];
      schema2[name].forEach(function (currentType) {
        var newIndex = result.length;
        result.forEach(function (previousType, previousIndex) {
          if (previousType.tag === currentType.tag && previousType.kind === currentType.kind && previousType.multi === currentType.multi) {
            newIndex = previousIndex;
          }
        });
        result[newIndex] = currentType;
      });
      return result;
    }
    function compileMap2() {
      var result = {
        scalar: {},
        sequence: {},
        mapping: {},
        fallback: {},
        multi: {
          scalar: [],
          sequence: [],
          mapping: [],
          fallback: []
        }
      }, index, length;
      function collectType(type2) {
        if (type2.multi) {
          result.multi[type2.kind].push(type2);
          result.multi["fallback"].push(type2);
        } else {
          result[type2.kind][type2.tag] = result["fallback"][type2.tag] = type2;
        }
      }
      for (index = 0, length = arguments.length; index < length; index += 1) {
        arguments[index].forEach(collectType);
      }
      return result;
    }
    function Schema3(definition) {
      return this.extend(definition);
    }
    Schema3.prototype.extend = function extend3(definition) {
      var implicit = [];
      var explicit = [];
      if (definition instanceof Type3) {
        explicit.push(definition);
      } else if (Array.isArray(definition)) {
        explicit = explicit.concat(definition);
      } else if (definition && (Array.isArray(definition.implicit) || Array.isArray(definition.explicit))) {
        if (definition.implicit) implicit = implicit.concat(definition.implicit);
        if (definition.explicit) explicit = explicit.concat(definition.explicit);
      } else {
        throw new YAMLException2("Schema.extend argument should be a Type, [ Type ], or a schema definition ({ implicit: [...], explicit: [...] })");
      }
      implicit.forEach(function (type2) {
        if (!(type2 instanceof Type3)) {
          throw new YAMLException2("Specified list of YAML types (or a single Type object) contains a non-Type object.");
        }
        if (type2.loadKind && type2.loadKind !== "scalar") {
          throw new YAMLException2("There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.");
        }
        if (type2.multi) {
          throw new YAMLException2("There is a multi type in the implicit list of a schema. Multi tags can only be listed as explicit.");
        }
      });
      explicit.forEach(function (type2) {
        if (!(type2 instanceof Type3)) {
          throw new YAMLException2("Specified list of YAML types (or a single Type object) contains a non-Type object.");
        }
      });
      var result = Object.create(Schema3.prototype);
      result.implicit = (this.implicit || []).concat(implicit);
      result.explicit = (this.explicit || []).concat(explicit);
      result.compiledImplicit = compileList2(result, "implicit");
      result.compiledExplicit = compileList2(result, "explicit");
      result.compiledTypeMap = compileMap2(result.compiledImplicit, result.compiledExplicit);
      return result;
    };
    module2.exports = Schema3;
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/str.js
var require_str = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/str.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    module2.exports = new Type3("tag:yaml.org,2002:str", {
      kind: "scalar",
      construct: function (data) {
        return data !== null ? data : "";
      }
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/seq.js
var require_seq = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/seq.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    module2.exports = new Type3("tag:yaml.org,2002:seq", {
      kind: "sequence",
      construct: function (data) {
        return data !== null ? data : [];
      }
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/map.js
var require_map = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/map.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    module2.exports = new Type3("tag:yaml.org,2002:map", {
      kind: "mapping",
      construct: function (data) {
        return data !== null ? data : {};
      }
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/failsafe.js
var require_failsafe = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/failsafe.js"(exports2, module2) {
    "use strict";
    var Schema3 = require_schema();
    module2.exports = new Schema3({
      explicit: [
        require_str(),
        require_seq(),
        require_map()
      ]
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/null.js
var require_null = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/null.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    function resolveYamlNull2(data) {
      if (data === null) return true;
      var max = data.length;
      return max === 1 && data === "~" || max === 4 && (data === "null" || data === "Null" || data === "NULL");
    }
    function constructYamlNull2() {
      return null;
    }
    function isNull3(object3) {
      return object3 === null;
    }
    module2.exports = new Type3("tag:yaml.org,2002:null", {
      kind: "scalar",
      resolve: resolveYamlNull2,
      construct: constructYamlNull2,
      predicate: isNull3,
      represent: {
        canonical: function () {
          return "~";
        },
        lowercase: function () {
          return "null";
        },
        uppercase: function () {
          return "NULL";
        },
        camelcase: function () {
          return "Null";
        },
        empty: function () {
          return "";
        }
      },
      defaultStyle: "lowercase"
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/bool.js
var require_bool = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/bool.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    function resolveYamlBoolean2(data) {
      if (data === null) return false;
      var max = data.length;
      return max === 4 && (data === "true" || data === "True" || data === "TRUE") || max === 5 && (data === "false" || data === "False" || data === "FALSE");
    }
    function constructYamlBoolean2(data) {
      return data === "true" || data === "True" || data === "TRUE";
    }
    function isBoolean2(object3) {
      return Object.prototype.toString.call(object3) === "[object Boolean]";
    }
    module2.exports = new Type3("tag:yaml.org,2002:bool", {
      kind: "scalar",
      resolve: resolveYamlBoolean2,
      construct: constructYamlBoolean2,
      predicate: isBoolean2,
      represent: {
        lowercase: function (object3) {
          return object3 ? "true" : "false";
        },
        uppercase: function (object3) {
          return object3 ? "TRUE" : "FALSE";
        },
        camelcase: function (object3) {
          return object3 ? "True" : "False";
        }
      },
      defaultStyle: "lowercase"
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/int.js
var require_int = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/int.js"(exports2, module2) {
    "use strict";
    var common2 = require_common();
    var Type3 = require_type();
    function isHexCode2(c) {
      return 48 <= c && c <= 57 || 65 <= c && c <= 70 || 97 <= c && c <= 102;
    }
    function isOctCode2(c) {
      return 48 <= c && c <= 55;
    }
    function isDecCode2(c) {
      return 48 <= c && c <= 57;
    }
    function resolveYamlInteger2(data) {
      if (data === null) return false;
      var max = data.length, index = 0, hasDigits = false, ch;
      if (!max) return false;
      ch = data[index];
      if (ch === "-" || ch === "+") {
        ch = data[++index];
      }
      if (ch === "0") {
        if (index + 1 === max) return true;
        ch = data[++index];
        if (ch === "b") {
          index++;
          for (; index < max; index++) {
            ch = data[index];
            if (ch === "_") continue;
            if (ch !== "0" && ch !== "1") return false;
            hasDigits = true;
          }
          return hasDigits && ch !== "_";
        }
        if (ch === "x") {
          index++;
          for (; index < max; index++) {
            ch = data[index];
            if (ch === "_") continue;
            if (!isHexCode2(data.charCodeAt(index))) return false;
            hasDigits = true;
          }
          return hasDigits && ch !== "_";
        }
        if (ch === "o") {
          index++;
          for (; index < max; index++) {
            ch = data[index];
            if (ch === "_") continue;
            if (!isOctCode2(data.charCodeAt(index))) return false;
            hasDigits = true;
          }
          return hasDigits && ch !== "_";
        }
      }
      if (ch === "_") return false;
      for (; index < max; index++) {
        ch = data[index];
        if (ch === "_") continue;
        if (!isDecCode2(data.charCodeAt(index))) {
          return false;
        }
        hasDigits = true;
      }
      if (!hasDigits || ch === "_") return false;
      return true;
    }
    function constructYamlInteger2(data) {
      var value = data, sign = 1, ch;
      if (value.indexOf("_") !== -1) {
        value = value.replace(/_/g, "");
      }
      ch = value[0];
      if (ch === "-" || ch === "+") {
        if (ch === "-") sign = -1;
        value = value.slice(1);
        ch = value[0];
      }
      if (value === "0") return 0;
      if (ch === "0") {
        if (value[1] === "b") return sign * parseInt(value.slice(2), 2);
        if (value[1] === "x") return sign * parseInt(value.slice(2), 16);
        if (value[1] === "o") return sign * parseInt(value.slice(2), 8);
      }
      return sign * parseInt(value, 10);
    }
    function isInteger2(object3) {
      return Object.prototype.toString.call(object3) === "[object Number]" && (object3 % 1 === 0 && !common2.isNegativeZero(object3));
    }
    module2.exports = new Type3("tag:yaml.org,2002:int", {
      kind: "scalar",
      resolve: resolveYamlInteger2,
      construct: constructYamlInteger2,
      predicate: isInteger2,
      represent: {
        binary: function (obj) {
          return obj >= 0 ? "0b" + obj.toString(2) : "-0b" + obj.toString(2).slice(1);
        },
        octal: function (obj) {
          return obj >= 0 ? "0o" + obj.toString(8) : "-0o" + obj.toString(8).slice(1);
        },
        decimal: function (obj) {
          return obj.toString(10);
        },
        /* eslint-disable max-len */
        hexadecimal: function (obj) {
          return obj >= 0 ? "0x" + obj.toString(16).toUpperCase() : "-0x" + obj.toString(16).toUpperCase().slice(1);
        }
      },
      defaultStyle: "decimal",
      styleAliases: {
        binary: [2, "bin"],
        octal: [8, "oct"],
        decimal: [10, "dec"],
        hexadecimal: [16, "hex"]
      }
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/float.js
var require_float = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/float.js"(exports2, module2) {
    "use strict";
    var common2 = require_common();
    var Type3 = require_type();
    var YAML_FLOAT_PATTERN2 = new RegExp(
      // 2.5e4, 2.5 and integers
      "^(?:[-+]?(?:[0-9][0-9_]*)(?:\\.[0-9_]*)?(?:[eE][-+]?[0-9]+)?|\\.[0-9_]+(?:[eE][-+]?[0-9]+)?|[-+]?\\.(?:inf|Inf|INF)|\\.(?:nan|NaN|NAN))$"
    );
    function resolveYamlFloat2(data) {
      if (data === null) return false;
      if (!YAML_FLOAT_PATTERN2.test(data) || // Quick hack to not allow integers end with `_`
        // Probably should update regexp & check speed
        data[data.length - 1] === "_") {
        return false;
      }
      return true;
    }
    function constructYamlFloat2(data) {
      var value, sign;
      value = data.replace(/_/g, "").toLowerCase();
      sign = value[0] === "-" ? -1 : 1;
      if ("+-".indexOf(value[0]) >= 0) {
        value = value.slice(1);
      }
      if (value === ".inf") {
        return sign === 1 ? Number.POSITIVE_INFINITY : Number.NEGATIVE_INFINITY;
      } else if (value === ".nan") {
        return NaN;
      }
      return sign * parseFloat(value, 10);
    }
    var SCIENTIFIC_WITHOUT_DOT2 = /^[-+]?[0-9]+e/;
    function representYamlFloat2(object3, style) {
      var res;
      if (isNaN(object3)) {
        switch (style) {
          case "lowercase":
            return ".nan";
          case "uppercase":
            return ".NAN";
          case "camelcase":
            return ".NaN";
        }
      } else if (Number.POSITIVE_INFINITY === object3) {
        switch (style) {
          case "lowercase":
            return ".inf";
          case "uppercase":
            return ".INF";
          case "camelcase":
            return ".Inf";
        }
      } else if (Number.NEGATIVE_INFINITY === object3) {
        switch (style) {
          case "lowercase":
            return "-.inf";
          case "uppercase":
            return "-.INF";
          case "camelcase":
            return "-.Inf";
        }
      } else if (common2.isNegativeZero(object3)) {
        return "-0.0";
      }
      res = object3.toString(10);
      return SCIENTIFIC_WITHOUT_DOT2.test(res) ? res.replace("e", ".e") : res;
    }
    function isFloat2(object3) {
      return Object.prototype.toString.call(object3) === "[object Number]" && (object3 % 1 !== 0 || common2.isNegativeZero(object3));
    }
    module2.exports = new Type3("tag:yaml.org,2002:float", {
      kind: "scalar",
      resolve: resolveYamlFloat2,
      construct: constructYamlFloat2,
      predicate: isFloat2,
      represent: representYamlFloat2,
      defaultStyle: "lowercase"
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/json.js
var require_json = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/json.js"(exports2, module2) {
    "use strict";
    module2.exports = require_failsafe().extend({
      implicit: [
        require_null(),
        require_bool(),
        require_int(),
        require_float()
      ]
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/core.js
var require_core = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/core.js"(exports2, module2) {
    "use strict";
    module2.exports = require_json();
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/timestamp.js
var require_timestamp = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/timestamp.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    var YAML_DATE_REGEXP2 = new RegExp(
      "^([0-9][0-9][0-9][0-9])-([0-9][0-9])-([0-9][0-9])$"
    );
    var YAML_TIMESTAMP_REGEXP2 = new RegExp(
      "^([0-9][0-9][0-9][0-9])-([0-9][0-9]?)-([0-9][0-9]?)(?:[Tt]|[ \\t]+)([0-9][0-9]?):([0-9][0-9]):([0-9][0-9])(?:\\.([0-9]*))?(?:[ \\t]*(Z|([-+])([0-9][0-9]?)(?::([0-9][0-9]))?))?$"
    );
    function resolveYamlTimestamp2(data) {
      if (data === null) return false;
      if (YAML_DATE_REGEXP2.exec(data) !== null) return true;
      if (YAML_TIMESTAMP_REGEXP2.exec(data) !== null) return true;
      return false;
    }
    function constructYamlTimestamp2(data) {
      var match, year, month, day, hour, minute, second, fraction = 0, delta = null, tz_hour, tz_minute, date3;
      match = YAML_DATE_REGEXP2.exec(data);
      if (match === null) match = YAML_TIMESTAMP_REGEXP2.exec(data);
      if (match === null) throw new Error("Date resolve error");
      year = +match[1];
      month = +match[2] - 1;
      day = +match[3];
      if (!match[4]) {
        return new Date(Date.UTC(year, month, day));
      }
      hour = +match[4];
      minute = +match[5];
      second = +match[6];
      if (match[7]) {
        fraction = match[7].slice(0, 3);
        while (fraction.length < 3) {
          fraction += "0";
        }
        fraction = +fraction;
      }
      if (match[9]) {
        tz_hour = +match[10];
        tz_minute = +(match[11] || 0);
        delta = (tz_hour * 60 + tz_minute) * 6e4;
        if (match[9] === "-") delta = -delta;
      }
      date3 = new Date(Date.UTC(year, month, day, hour, minute, second, fraction));
      if (delta) date3.setTime(date3.getTime() - delta);
      return date3;
    }
    function representYamlTimestamp2(object3) {
      return object3.toISOString();
    }
    module2.exports = new Type3("tag:yaml.org,2002:timestamp", {
      kind: "scalar",
      resolve: resolveYamlTimestamp2,
      construct: constructYamlTimestamp2,
      instanceOf: Date,
      represent: representYamlTimestamp2
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/merge.js
var require_merge = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/merge.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    function resolveYamlMerge2(data) {
      return data === "<<" || data === null;
    }
    module2.exports = new Type3("tag:yaml.org,2002:merge", {
      kind: "scalar",
      resolve: resolveYamlMerge2
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/binary.js
var require_binary = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/binary.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    var BASE64_MAP2 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=\n\r";
    function resolveYamlBinary2(data) {
      if (data === null) return false;
      var code, idx, bitlen = 0, max = data.length, map2 = BASE64_MAP2;
      for (idx = 0; idx < max; idx++) {
        code = map2.indexOf(data.charAt(idx));
        if (code > 64) continue;
        if (code < 0) return false;
        bitlen += 6;
      }
      return bitlen % 8 === 0;
    }
    function constructYamlBinary2(data) {
      var idx, tailbits, input = data.replace(/[\r\n=]/g, ""), max = input.length, map2 = BASE64_MAP2, bits = 0, result = [];
      for (idx = 0; idx < max; idx++) {
        if (idx % 4 === 0 && idx) {
          result.push(bits >> 16 & 255);
          result.push(bits >> 8 & 255);
          result.push(bits & 255);
        }
        bits = bits << 6 | map2.indexOf(input.charAt(idx));
      }
      tailbits = max % 4 * 6;
      if (tailbits === 0) {
        result.push(bits >> 16 & 255);
        result.push(bits >> 8 & 255);
        result.push(bits & 255);
      } else if (tailbits === 18) {
        result.push(bits >> 10 & 255);
        result.push(bits >> 2 & 255);
      } else if (tailbits === 12) {
        result.push(bits >> 4 & 255);
      }
      return new Uint8Array(result);
    }
    function representYamlBinary2(object3) {
      var result = "", bits = 0, idx, tail, max = object3.length, map2 = BASE64_MAP2;
      for (idx = 0; idx < max; idx++) {
        if (idx % 3 === 0 && idx) {
          result += map2[bits >> 18 & 63];
          result += map2[bits >> 12 & 63];
          result += map2[bits >> 6 & 63];
          result += map2[bits & 63];
        }
        bits = (bits << 8) + object3[idx];
      }
      tail = max % 3;
      if (tail === 0) {
        result += map2[bits >> 18 & 63];
        result += map2[bits >> 12 & 63];
        result += map2[bits >> 6 & 63];
        result += map2[bits & 63];
      } else if (tail === 2) {
        result += map2[bits >> 10 & 63];
        result += map2[bits >> 4 & 63];
        result += map2[bits << 2 & 63];
        result += map2[64];
      } else if (tail === 1) {
        result += map2[bits >> 2 & 63];
        result += map2[bits << 4 & 63];
        result += map2[64];
        result += map2[64];
      }
      return result;
    }
    function isBinary2(obj) {
      return Object.prototype.toString.call(obj) === "[object Uint8Array]";
    }
    module2.exports = new Type3("tag:yaml.org,2002:binary", {
      kind: "scalar",
      resolve: resolveYamlBinary2,
      construct: constructYamlBinary2,
      predicate: isBinary2,
      represent: representYamlBinary2
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/omap.js
var require_omap = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/omap.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    var _hasOwnProperty2 = Object.prototype.hasOwnProperty;
    var _toString2 = Object.prototype.toString;
    function resolveYamlOmap2(data) {
      if (data === null) return true;
      var objectKeys = [], index, length, pair, pairKey, pairHasKey, object3 = data;
      for (index = 0, length = object3.length; index < length; index += 1) {
        pair = object3[index];
        pairHasKey = false;
        if (_toString2.call(pair) !== "[object Object]") return false;
        for (pairKey in pair) {
          if (_hasOwnProperty2.call(pair, pairKey)) {
            if (!pairHasKey) pairHasKey = true;
            else return false;
          }
        }
        if (!pairHasKey) return false;
        if (objectKeys.indexOf(pairKey) === -1) objectKeys.push(pairKey);
        else return false;
      }
      return true;
    }
    function constructYamlOmap2(data) {
      return data !== null ? data : [];
    }
    module2.exports = new Type3("tag:yaml.org,2002:omap", {
      kind: "sequence",
      resolve: resolveYamlOmap2,
      construct: constructYamlOmap2
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/pairs.js
var require_pairs = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/pairs.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    var _toString2 = Object.prototype.toString;
    function resolveYamlPairs2(data) {
      if (data === null) return true;
      var index, length, pair, keys5, result, object3 = data;
      result = new Array(object3.length);
      for (index = 0, length = object3.length; index < length; index += 1) {
        pair = object3[index];
        if (_toString2.call(pair) !== "[object Object]") return false;
        keys5 = Object.keys(pair);
        if (keys5.length !== 1) return false;
        result[index] = [keys5[0], pair[keys5[0]]];
      }
      return true;
    }
    function constructYamlPairs2(data) {
      if (data === null) return [];
      var index, length, pair, keys5, result, object3 = data;
      result = new Array(object3.length);
      for (index = 0, length = object3.length; index < length; index += 1) {
        pair = object3[index];
        keys5 = Object.keys(pair);
        result[index] = [keys5[0], pair[keys5[0]]];
      }
      return result;
    }
    module2.exports = new Type3("tag:yaml.org,2002:pairs", {
      kind: "sequence",
      resolve: resolveYamlPairs2,
      construct: constructYamlPairs2
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/set.js
var require_set = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/type/set.js"(exports2, module2) {
    "use strict";
    var Type3 = require_type();
    var _hasOwnProperty2 = Object.prototype.hasOwnProperty;
    function resolveYamlSet2(data) {
      if (data === null) return true;
      var key, object3 = data;
      for (key in object3) {
        if (_hasOwnProperty2.call(object3, key)) {
          if (object3[key] !== null) return false;
        }
      }
      return true;
    }
    function constructYamlSet2(data) {
      return data !== null ? data : {};
    }
    module2.exports = new Type3("tag:yaml.org,2002:set", {
      kind: "mapping",
      resolve: resolveYamlSet2,
      construct: constructYamlSet2
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/default.js
var require_default = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/schema/default.js"(exports2, module2) {
    "use strict";
    module2.exports = require_core().extend({
      implicit: [
        require_timestamp(),
        require_merge()
      ],
      explicit: [
        require_binary(),
        require_omap(),
        require_pairs(),
        require_set()
      ]
    });
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/loader.js
var require_loader = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/loader.js"(exports2, module2) {
    "use strict";
    var common2 = require_common();
    var YAMLException2 = require_exception();
    var makeSnippet2 = require_snippet();
    var DEFAULT_SCHEMA2 = require_default();
    var _hasOwnProperty2 = Object.prototype.hasOwnProperty;
    var CONTEXT_FLOW_IN2 = 1;
    var CONTEXT_FLOW_OUT2 = 2;
    var CONTEXT_BLOCK_IN2 = 3;
    var CONTEXT_BLOCK_OUT2 = 4;
    var CHOMPING_CLIP2 = 1;
    var CHOMPING_STRIP2 = 2;
    var CHOMPING_KEEP2 = 3;
    var PATTERN_NON_PRINTABLE2 = /[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/;
    var PATTERN_NON_ASCII_LINE_BREAKS2 = /[\x85\u2028\u2029]/;
    var PATTERN_FLOW_INDICATORS2 = /[,\[\]\{\}]/;
    var PATTERN_TAG_HANDLE2 = /^(?:!|!!|![a-z\-]+!)$/i;
    var PATTERN_TAG_URI2 = /^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i;
    function _class2(obj) {
      return Object.prototype.toString.call(obj);
    }
    function is_EOL2(c) {
      return c === 10 || c === 13;
    }
    function is_WHITE_SPACE2(c) {
      return c === 9 || c === 32;
    }
    function is_WS_OR_EOL2(c) {
      return c === 9 || c === 32 || c === 10 || c === 13;
    }
    function is_FLOW_INDICATOR2(c) {
      return c === 44 || c === 91 || c === 93 || c === 123 || c === 125;
    }
    function fromHexCode2(c) {
      var lc;
      if (48 <= c && c <= 57) {
        return c - 48;
      }
      lc = c | 32;
      if (97 <= lc && lc <= 102) {
        return lc - 97 + 10;
      }
      return -1;
    }
    function escapedHexLen2(c) {
      if (c === 120) {
        return 2;
      }
      if (c === 117) {
        return 4;
      }
      if (c === 85) {
        return 8;
      }
      return 0;
    }
    function fromDecimalCode2(c) {
      if (48 <= c && c <= 57) {
        return c - 48;
      }
      return -1;
    }
    function simpleEscapeSequence2(c) {
      return c === 48 ? "\0" : c === 97 ? "\x07" : c === 98 ? "\b" : c === 116 ? "	" : c === 9 ? "	" : c === 110 ? "\n" : c === 118 ? "\v" : c === 102 ? "\f" : c === 114 ? "\r" : c === 101 ? "\x1B" : c === 32 ? " " : c === 34 ? '"' : c === 47 ? "/" : c === 92 ? "\\" : c === 78 ? "\x85" : c === 95 ? "\xA0" : c === 76 ? "\u2028" : c === 80 ? "\u2029" : "";
    }
    function charFromCodepoint2(c) {
      if (c <= 65535) {
        return String.fromCharCode(c);
      }
      return String.fromCharCode(
        (c - 65536 >> 10) + 55296,
        (c - 65536 & 1023) + 56320
      );
    }
    var simpleEscapeCheck2 = new Array(256);
    var simpleEscapeMap2 = new Array(256);
    for (i = 0; i < 256; i++) {
      simpleEscapeCheck2[i] = simpleEscapeSequence2(i) ? 1 : 0;
      simpleEscapeMap2[i] = simpleEscapeSequence2(i);
    }
    var i;
    function State3(input, options) {
      this.input = input;
      this.filename = options["filename"] || null;
      this.schema = options["schema"] || DEFAULT_SCHEMA2;
      this.onWarning = options["onWarning"] || null;
      this.legacy = options["legacy"] || false;
      this.json = options["json"] || false;
      this.listener = options["listener"] || null;
      this.implicitTypes = this.schema.compiledImplicit;
      this.typeMap = this.schema.compiledTypeMap;
      this.length = input.length;
      this.position = 0;
      this.line = 0;
      this.lineStart = 0;
      this.lineIndent = 0;
      this.firstTabInLine = -1;
      this.documents = [];
    }
    function generateError2(state, message) {
      var mark = {
        name: state.filename,
        buffer: state.input.slice(0, -1),
        // omit trailing \0
        position: state.position,
        line: state.line,
        column: state.position - state.lineStart
      };
      mark.snippet = makeSnippet2(mark);
      return new YAMLException2(message, mark);
    }
    function throwError2(state, message) {
      throw generateError2(state, message);
    }
    function throwWarning2(state, message) {
      if (state.onWarning) {
        state.onWarning.call(null, generateError2(state, message));
      }
    }
    var directiveHandlers2 = {
      YAML: function handleYamlDirective2(state, name, args) {
        var match, major, minor;
        if (state.version !== null) {
          throwError2(state, "duplication of %YAML directive");
        }
        if (args.length !== 1) {
          throwError2(state, "YAML directive accepts exactly one argument");
        }
        match = /^([0-9]+)\.([0-9]+)$/.exec(args[0]);
        if (match === null) {
          throwError2(state, "ill-formed argument of the YAML directive");
        }
        major = parseInt(match[1], 10);
        minor = parseInt(match[2], 10);
        if (major !== 1) {
          throwError2(state, "unacceptable YAML version of the document");
        }
        state.version = args[0];
        state.checkLineBreaks = minor < 2;
        if (minor !== 1 && minor !== 2) {
          throwWarning2(state, "unsupported YAML version of the document");
        }
      },
      TAG: function handleTagDirective2(state, name, args) {
        var handle, prefix;
        if (args.length !== 2) {
          throwError2(state, "TAG directive accepts exactly two arguments");
        }
        handle = args[0];
        prefix = args[1];
        if (!PATTERN_TAG_HANDLE2.test(handle)) {
          throwError2(state, "ill-formed tag handle (first argument) of the TAG directive");
        }
        if (_hasOwnProperty2.call(state.tagMap, handle)) {
          throwError2(state, 'there is a previously declared suffix for "' + handle + '" tag handle');
        }
        if (!PATTERN_TAG_URI2.test(prefix)) {
          throwError2(state, "ill-formed tag prefix (second argument) of the TAG directive");
        }
        try {
          prefix = decodeURIComponent(prefix);
        } catch (err) {
          throwError2(state, "tag prefix is malformed: " + prefix);
        }
        state.tagMap[handle] = prefix;
      }
    };
    function captureSegment2(state, start, end, checkJson) {
      var _position, _length, _character, _result;
      if (start < end) {
        _result = state.input.slice(start, end);
        if (checkJson) {
          for (_position = 0, _length = _result.length; _position < _length; _position += 1) {
            _character = _result.charCodeAt(_position);
            if (!(_character === 9 || 32 <= _character && _character <= 1114111)) {
              throwError2(state, "expected valid JSON character");
            }
          }
        } else if (PATTERN_NON_PRINTABLE2.test(_result)) {
          throwError2(state, "the stream contains non-printable characters");
        }
        state.result += _result;
      }
    }
    function mergeMappings2(state, destination, source, overridableKeys) {
      var sourceKeys, key, index, quantity;
      if (!common2.isObject(source)) {
        throwError2(state, "cannot merge mappings; the provided source object is unacceptable");
      }
      sourceKeys = Object.keys(source);
      for (index = 0, quantity = sourceKeys.length; index < quantity; index += 1) {
        key = sourceKeys[index];
        if (!_hasOwnProperty2.call(destination, key)) {
          destination[key] = source[key];
          overridableKeys[key] = true;
        }
      }
    }
    function storeMappingPair2(state, _result, overridableKeys, keyTag, keyNode, valueNode, startLine, startLineStart, startPos) {
      var index, quantity;
      if (Array.isArray(keyNode)) {
        keyNode = Array.prototype.slice.call(keyNode);
        for (index = 0, quantity = keyNode.length; index < quantity; index += 1) {
          if (Array.isArray(keyNode[index])) {
            throwError2(state, "nested arrays are not supported inside keys");
          }
          if (typeof keyNode === "object" && _class2(keyNode[index]) === "[object Object]") {
            keyNode[index] = "[object Object]";
          }
        }
      }
      if (typeof keyNode === "object" && _class2(keyNode) === "[object Object]") {
        keyNode = "[object Object]";
      }
      keyNode = String(keyNode);
      if (_result === null) {
        _result = {};
      }
      if (keyTag === "tag:yaml.org,2002:merge") {
        if (Array.isArray(valueNode)) {
          for (index = 0, quantity = valueNode.length; index < quantity; index += 1) {
            mergeMappings2(state, _result, valueNode[index], overridableKeys);
          }
        } else {
          mergeMappings2(state, _result, valueNode, overridableKeys);
        }
      } else {
        if (!state.json && !_hasOwnProperty2.call(overridableKeys, keyNode) && _hasOwnProperty2.call(_result, keyNode)) {
          state.line = startLine || state.line;
          state.lineStart = startLineStart || state.lineStart;
          state.position = startPos || state.position;
          throwError2(state, "duplicated mapping key");
        }
        if (keyNode === "__proto__") {
          Object.defineProperty(_result, keyNode, {
            configurable: true,
            enumerable: true,
            writable: true,
            value: valueNode
          });
        } else {
          _result[keyNode] = valueNode;
        }
        delete overridableKeys[keyNode];
      }
      return _result;
    }
    function readLineBreak2(state) {
      var ch;
      ch = state.input.charCodeAt(state.position);
      if (ch === 10) {
        state.position++;
      } else if (ch === 13) {
        state.position++;
        if (state.input.charCodeAt(state.position) === 10) {
          state.position++;
        }
      } else {
        throwError2(state, "a line break is expected");
      }
      state.line += 1;
      state.lineStart = state.position;
      state.firstTabInLine = -1;
    }
    function skipSeparationSpace2(state, allowComments, checkIndent) {
      var lineBreaks = 0, ch = state.input.charCodeAt(state.position);
      while (ch !== 0) {
        while (is_WHITE_SPACE2(ch)) {
          if (ch === 9 && state.firstTabInLine === -1) {
            state.firstTabInLine = state.position;
          }
          ch = state.input.charCodeAt(++state.position);
        }
        if (allowComments && ch === 35) {
          do {
            ch = state.input.charCodeAt(++state.position);
          } while (ch !== 10 && ch !== 13 && ch !== 0);
        }
        if (is_EOL2(ch)) {
          readLineBreak2(state);
          ch = state.input.charCodeAt(state.position);
          lineBreaks++;
          state.lineIndent = 0;
          while (ch === 32) {
            state.lineIndent++;
            ch = state.input.charCodeAt(++state.position);
          }
        } else {
          break;
        }
      }
      if (checkIndent !== -1 && lineBreaks !== 0 && state.lineIndent < checkIndent) {
        throwWarning2(state, "deficient indentation");
      }
      return lineBreaks;
    }
    function testDocumentSeparator2(state) {
      var _position = state.position, ch;
      ch = state.input.charCodeAt(_position);
      if ((ch === 45 || ch === 46) && ch === state.input.charCodeAt(_position + 1) && ch === state.input.charCodeAt(_position + 2)) {
        _position += 3;
        ch = state.input.charCodeAt(_position);
        if (ch === 0 || is_WS_OR_EOL2(ch)) {
          return true;
        }
      }
      return false;
    }
    function writeFoldedLines2(state, count) {
      if (count === 1) {
        state.result += " ";
      } else if (count > 1) {
        state.result += common2.repeat("\n", count - 1);
      }
    }
    function readPlainScalar2(state, nodeIndent, withinFlowCollection) {
      var preceding, following, captureStart, captureEnd, hasPendingContent, _line, _lineStart, _lineIndent, _kind = state.kind, _result = state.result, ch;
      ch = state.input.charCodeAt(state.position);
      if (is_WS_OR_EOL2(ch) || is_FLOW_INDICATOR2(ch) || ch === 35 || ch === 38 || ch === 42 || ch === 33 || ch === 124 || ch === 62 || ch === 39 || ch === 34 || ch === 37 || ch === 64 || ch === 96) {
        return false;
      }
      if (ch === 63 || ch === 45) {
        following = state.input.charCodeAt(state.position + 1);
        if (is_WS_OR_EOL2(following) || withinFlowCollection && is_FLOW_INDICATOR2(following)) {
          return false;
        }
      }
      state.kind = "scalar";
      state.result = "";
      captureStart = captureEnd = state.position;
      hasPendingContent = false;
      while (ch !== 0) {
        if (ch === 58) {
          following = state.input.charCodeAt(state.position + 1);
          if (is_WS_OR_EOL2(following) || withinFlowCollection && is_FLOW_INDICATOR2(following)) {
            break;
          }
        } else if (ch === 35) {
          preceding = state.input.charCodeAt(state.position - 1);
          if (is_WS_OR_EOL2(preceding)) {
            break;
          }
        } else if (state.position === state.lineStart && testDocumentSeparator2(state) || withinFlowCollection && is_FLOW_INDICATOR2(ch)) {
          break;
        } else if (is_EOL2(ch)) {
          _line = state.line;
          _lineStart = state.lineStart;
          _lineIndent = state.lineIndent;
          skipSeparationSpace2(state, false, -1);
          if (state.lineIndent >= nodeIndent) {
            hasPendingContent = true;
            ch = state.input.charCodeAt(state.position);
            continue;
          } else {
            state.position = captureEnd;
            state.line = _line;
            state.lineStart = _lineStart;
            state.lineIndent = _lineIndent;
            break;
          }
        }
        if (hasPendingContent) {
          captureSegment2(state, captureStart, captureEnd, false);
          writeFoldedLines2(state, state.line - _line);
          captureStart = captureEnd = state.position;
          hasPendingContent = false;
        }
        if (!is_WHITE_SPACE2(ch)) {
          captureEnd = state.position + 1;
        }
        ch = state.input.charCodeAt(++state.position);
      }
      captureSegment2(state, captureStart, captureEnd, false);
      if (state.result) {
        return true;
      }
      state.kind = _kind;
      state.result = _result;
      return false;
    }
    function readSingleQuotedScalar2(state, nodeIndent) {
      var ch, captureStart, captureEnd;
      ch = state.input.charCodeAt(state.position);
      if (ch !== 39) {
        return false;
      }
      state.kind = "scalar";
      state.result = "";
      state.position++;
      captureStart = captureEnd = state.position;
      while ((ch = state.input.charCodeAt(state.position)) !== 0) {
        if (ch === 39) {
          captureSegment2(state, captureStart, state.position, true);
          ch = state.input.charCodeAt(++state.position);
          if (ch === 39) {
            captureStart = state.position;
            state.position++;
            captureEnd = state.position;
          } else {
            return true;
          }
        } else if (is_EOL2(ch)) {
          captureSegment2(state, captureStart, captureEnd, true);
          writeFoldedLines2(state, skipSeparationSpace2(state, false, nodeIndent));
          captureStart = captureEnd = state.position;
        } else if (state.position === state.lineStart && testDocumentSeparator2(state)) {
          throwError2(state, "unexpected end of the document within a single quoted scalar");
        } else {
          state.position++;
          captureEnd = state.position;
        }
      }
      throwError2(state, "unexpected end of the stream within a single quoted scalar");
    }
    function readDoubleQuotedScalar2(state, nodeIndent) {
      var captureStart, captureEnd, hexLength, hexResult, tmp, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch !== 34) {
        return false;
      }
      state.kind = "scalar";
      state.result = "";
      state.position++;
      captureStart = captureEnd = state.position;
      while ((ch = state.input.charCodeAt(state.position)) !== 0) {
        if (ch === 34) {
          captureSegment2(state, captureStart, state.position, true);
          state.position++;
          return true;
        } else if (ch === 92) {
          captureSegment2(state, captureStart, state.position, true);
          ch = state.input.charCodeAt(++state.position);
          if (is_EOL2(ch)) {
            skipSeparationSpace2(state, false, nodeIndent);
          } else if (ch < 256 && simpleEscapeCheck2[ch]) {
            state.result += simpleEscapeMap2[ch];
            state.position++;
          } else if ((tmp = escapedHexLen2(ch)) > 0) {
            hexLength = tmp;
            hexResult = 0;
            for (; hexLength > 0; hexLength--) {
              ch = state.input.charCodeAt(++state.position);
              if ((tmp = fromHexCode2(ch)) >= 0) {
                hexResult = (hexResult << 4) + tmp;
              } else {
                throwError2(state, "expected hexadecimal character");
              }
            }
            state.result += charFromCodepoint2(hexResult);
            state.position++;
          } else {
            throwError2(state, "unknown escape sequence");
          }
          captureStart = captureEnd = state.position;
        } else if (is_EOL2(ch)) {
          captureSegment2(state, captureStart, captureEnd, true);
          writeFoldedLines2(state, skipSeparationSpace2(state, false, nodeIndent));
          captureStart = captureEnd = state.position;
        } else if (state.position === state.lineStart && testDocumentSeparator2(state)) {
          throwError2(state, "unexpected end of the document within a double quoted scalar");
        } else {
          state.position++;
          captureEnd = state.position;
        }
      }
      throwError2(state, "unexpected end of the stream within a double quoted scalar");
    }
    function readFlowCollection2(state, nodeIndent) {
      var readNext = true, _line, _lineStart, _pos, _tag = state.tag, _result, _anchor = state.anchor, following, terminator, isPair, isExplicitPair, isMapping, overridableKeys = /* @__PURE__ */ Object.create(null), keyNode, keyTag, valueNode, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch === 91) {
        terminator = 93;
        isMapping = false;
        _result = [];
      } else if (ch === 123) {
        terminator = 125;
        isMapping = true;
        _result = {};
      } else {
        return false;
      }
      if (state.anchor !== null) {
        state.anchorMap[state.anchor] = _result;
      }
      ch = state.input.charCodeAt(++state.position);
      while (ch !== 0) {
        skipSeparationSpace2(state, true, nodeIndent);
        ch = state.input.charCodeAt(state.position);
        if (ch === terminator) {
          state.position++;
          state.tag = _tag;
          state.anchor = _anchor;
          state.kind = isMapping ? "mapping" : "sequence";
          state.result = _result;
          return true;
        } else if (!readNext) {
          throwError2(state, "missed comma between flow collection entries");
        } else if (ch === 44) {
          throwError2(state, "expected the node content, but found ','");
        }
        keyTag = keyNode = valueNode = null;
        isPair = isExplicitPair = false;
        if (ch === 63) {
          following = state.input.charCodeAt(state.position + 1);
          if (is_WS_OR_EOL2(following)) {
            isPair = isExplicitPair = true;
            state.position++;
            skipSeparationSpace2(state, true, nodeIndent);
          }
        }
        _line = state.line;
        _lineStart = state.lineStart;
        _pos = state.position;
        composeNode2(state, nodeIndent, CONTEXT_FLOW_IN2, false, true);
        keyTag = state.tag;
        keyNode = state.result;
        skipSeparationSpace2(state, true, nodeIndent);
        ch = state.input.charCodeAt(state.position);
        if ((isExplicitPair || state.line === _line) && ch === 58) {
          isPair = true;
          ch = state.input.charCodeAt(++state.position);
          skipSeparationSpace2(state, true, nodeIndent);
          composeNode2(state, nodeIndent, CONTEXT_FLOW_IN2, false, true);
          valueNode = state.result;
        }
        if (isMapping) {
          storeMappingPair2(state, _result, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos);
        } else if (isPair) {
          _result.push(storeMappingPair2(state, null, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos));
        } else {
          _result.push(keyNode);
        }
        skipSeparationSpace2(state, true, nodeIndent);
        ch = state.input.charCodeAt(state.position);
        if (ch === 44) {
          readNext = true;
          ch = state.input.charCodeAt(++state.position);
        } else {
          readNext = false;
        }
      }
      throwError2(state, "unexpected end of the stream within a flow collection");
    }
    function readBlockScalar2(state, nodeIndent) {
      var captureStart, folding, chomping = CHOMPING_CLIP2, didReadContent = false, detectedIndent = false, textIndent = nodeIndent, emptyLines = 0, atMoreIndented = false, tmp, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch === 124) {
        folding = false;
      } else if (ch === 62) {
        folding = true;
      } else {
        return false;
      }
      state.kind = "scalar";
      state.result = "";
      while (ch !== 0) {
        ch = state.input.charCodeAt(++state.position);
        if (ch === 43 || ch === 45) {
          if (CHOMPING_CLIP2 === chomping) {
            chomping = ch === 43 ? CHOMPING_KEEP2 : CHOMPING_STRIP2;
          } else {
            throwError2(state, "repeat of a chomping mode identifier");
          }
        } else if ((tmp = fromDecimalCode2(ch)) >= 0) {
          if (tmp === 0) {
            throwError2(state, "bad explicit indentation width of a block scalar; it cannot be less than one");
          } else if (!detectedIndent) {
            textIndent = nodeIndent + tmp - 1;
            detectedIndent = true;
          } else {
            throwError2(state, "repeat of an indentation width identifier");
          }
        } else {
          break;
        }
      }
      if (is_WHITE_SPACE2(ch)) {
        do {
          ch = state.input.charCodeAt(++state.position);
        } while (is_WHITE_SPACE2(ch));
        if (ch === 35) {
          do {
            ch = state.input.charCodeAt(++state.position);
          } while (!is_EOL2(ch) && ch !== 0);
        }
      }
      while (ch !== 0) {
        readLineBreak2(state);
        state.lineIndent = 0;
        ch = state.input.charCodeAt(state.position);
        while ((!detectedIndent || state.lineIndent < textIndent) && ch === 32) {
          state.lineIndent++;
          ch = state.input.charCodeAt(++state.position);
        }
        if (!detectedIndent && state.lineIndent > textIndent) {
          textIndent = state.lineIndent;
        }
        if (is_EOL2(ch)) {
          emptyLines++;
          continue;
        }
        if (state.lineIndent < textIndent) {
          if (chomping === CHOMPING_KEEP2) {
            state.result += common2.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
          } else if (chomping === CHOMPING_CLIP2) {
            if (didReadContent) {
              state.result += "\n";
            }
          }
          break;
        }
        if (folding) {
          if (is_WHITE_SPACE2(ch)) {
            atMoreIndented = true;
            state.result += common2.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
          } else if (atMoreIndented) {
            atMoreIndented = false;
            state.result += common2.repeat("\n", emptyLines + 1);
          } else if (emptyLines === 0) {
            if (didReadContent) {
              state.result += " ";
            }
          } else {
            state.result += common2.repeat("\n", emptyLines);
          }
        } else {
          state.result += common2.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
        }
        didReadContent = true;
        detectedIndent = true;
        emptyLines = 0;
        captureStart = state.position;
        while (!is_EOL2(ch) && ch !== 0) {
          ch = state.input.charCodeAt(++state.position);
        }
        captureSegment2(state, captureStart, state.position, false);
      }
      return true;
    }
    function readBlockSequence2(state, nodeIndent) {
      var _line, _tag = state.tag, _anchor = state.anchor, _result = [], following, detected = false, ch;
      if (state.firstTabInLine !== -1) return false;
      if (state.anchor !== null) {
        state.anchorMap[state.anchor] = _result;
      }
      ch = state.input.charCodeAt(state.position);
      while (ch !== 0) {
        if (state.firstTabInLine !== -1) {
          state.position = state.firstTabInLine;
          throwError2(state, "tab characters must not be used in indentation");
        }
        if (ch !== 45) {
          break;
        }
        following = state.input.charCodeAt(state.position + 1);
        if (!is_WS_OR_EOL2(following)) {
          break;
        }
        detected = true;
        state.position++;
        if (skipSeparationSpace2(state, true, -1)) {
          if (state.lineIndent <= nodeIndent) {
            _result.push(null);
            ch = state.input.charCodeAt(state.position);
            continue;
          }
        }
        _line = state.line;
        composeNode2(state, nodeIndent, CONTEXT_BLOCK_IN2, false, true);
        _result.push(state.result);
        skipSeparationSpace2(state, true, -1);
        ch = state.input.charCodeAt(state.position);
        if ((state.line === _line || state.lineIndent > nodeIndent) && ch !== 0) {
          throwError2(state, "bad indentation of a sequence entry");
        } else if (state.lineIndent < nodeIndent) {
          break;
        }
      }
      if (detected) {
        state.tag = _tag;
        state.anchor = _anchor;
        state.kind = "sequence";
        state.result = _result;
        return true;
      }
      return false;
    }
    function readBlockMapping2(state, nodeIndent, flowIndent) {
      var following, allowCompact, _line, _keyLine, _keyLineStart, _keyPos, _tag = state.tag, _anchor = state.anchor, _result = {}, overridableKeys = /* @__PURE__ */ Object.create(null), keyTag = null, keyNode = null, valueNode = null, atExplicitKey = false, detected = false, ch;
      if (state.firstTabInLine !== -1) return false;
      if (state.anchor !== null) {
        state.anchorMap[state.anchor] = _result;
      }
      ch = state.input.charCodeAt(state.position);
      while (ch !== 0) {
        if (!atExplicitKey && state.firstTabInLine !== -1) {
          state.position = state.firstTabInLine;
          throwError2(state, "tab characters must not be used in indentation");
        }
        following = state.input.charCodeAt(state.position + 1);
        _line = state.line;
        if ((ch === 63 || ch === 58) && is_WS_OR_EOL2(following)) {
          if (ch === 63) {
            if (atExplicitKey) {
              storeMappingPair2(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
              keyTag = keyNode = valueNode = null;
            }
            detected = true;
            atExplicitKey = true;
            allowCompact = true;
          } else if (atExplicitKey) {
            atExplicitKey = false;
            allowCompact = true;
          } else {
            throwError2(state, "incomplete explicit mapping pair; a key node is missed; or followed by a non-tabulated empty line");
          }
          state.position += 1;
          ch = following;
        } else {
          _keyLine = state.line;
          _keyLineStart = state.lineStart;
          _keyPos = state.position;
          if (!composeNode2(state, flowIndent, CONTEXT_FLOW_OUT2, false, true)) {
            break;
          }
          if (state.line === _line) {
            ch = state.input.charCodeAt(state.position);
            while (is_WHITE_SPACE2(ch)) {
              ch = state.input.charCodeAt(++state.position);
            }
            if (ch === 58) {
              ch = state.input.charCodeAt(++state.position);
              if (!is_WS_OR_EOL2(ch)) {
                throwError2(state, "a whitespace character is expected after the key-value separator within a block mapping");
              }
              if (atExplicitKey) {
                storeMappingPair2(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
                keyTag = keyNode = valueNode = null;
              }
              detected = true;
              atExplicitKey = false;
              allowCompact = false;
              keyTag = state.tag;
              keyNode = state.result;
            } else if (detected) {
              throwError2(state, "can not read an implicit mapping pair; a colon is missed");
            } else {
              state.tag = _tag;
              state.anchor = _anchor;
              return true;
            }
          } else if (detected) {
            throwError2(state, "can not read a block mapping entry; a multiline key may not be an implicit key");
          } else {
            state.tag = _tag;
            state.anchor = _anchor;
            return true;
          }
        }
        if (state.line === _line || state.lineIndent > nodeIndent) {
          if (atExplicitKey) {
            _keyLine = state.line;
            _keyLineStart = state.lineStart;
            _keyPos = state.position;
          }
          if (composeNode2(state, nodeIndent, CONTEXT_BLOCK_OUT2, true, allowCompact)) {
            if (atExplicitKey) {
              keyNode = state.result;
            } else {
              valueNode = state.result;
            }
          }
          if (!atExplicitKey) {
            storeMappingPair2(state, _result, overridableKeys, keyTag, keyNode, valueNode, _keyLine, _keyLineStart, _keyPos);
            keyTag = keyNode = valueNode = null;
          }
          skipSeparationSpace2(state, true, -1);
          ch = state.input.charCodeAt(state.position);
        }
        if ((state.line === _line || state.lineIndent > nodeIndent) && ch !== 0) {
          throwError2(state, "bad indentation of a mapping entry");
        } else if (state.lineIndent < nodeIndent) {
          break;
        }
      }
      if (atExplicitKey) {
        storeMappingPair2(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
      }
      if (detected) {
        state.tag = _tag;
        state.anchor = _anchor;
        state.kind = "mapping";
        state.result = _result;
      }
      return detected;
    }
    function readTagProperty2(state) {
      var _position, isVerbatim = false, isNamed = false, tagHandle, tagName, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch !== 33) return false;
      if (state.tag !== null) {
        throwError2(state, "duplication of a tag property");
      }
      ch = state.input.charCodeAt(++state.position);
      if (ch === 60) {
        isVerbatim = true;
        ch = state.input.charCodeAt(++state.position);
      } else if (ch === 33) {
        isNamed = true;
        tagHandle = "!!";
        ch = state.input.charCodeAt(++state.position);
      } else {
        tagHandle = "!";
      }
      _position = state.position;
      if (isVerbatim) {
        do {
          ch = state.input.charCodeAt(++state.position);
        } while (ch !== 0 && ch !== 62);
        if (state.position < state.length) {
          tagName = state.input.slice(_position, state.position);
          ch = state.input.charCodeAt(++state.position);
        } else {
          throwError2(state, "unexpected end of the stream within a verbatim tag");
        }
      } else {
        while (ch !== 0 && !is_WS_OR_EOL2(ch)) {
          if (ch === 33) {
            if (!isNamed) {
              tagHandle = state.input.slice(_position - 1, state.position + 1);
              if (!PATTERN_TAG_HANDLE2.test(tagHandle)) {
                throwError2(state, "named tag handle cannot contain such characters");
              }
              isNamed = true;
              _position = state.position + 1;
            } else {
              throwError2(state, "tag suffix cannot contain exclamation marks");
            }
          }
          ch = state.input.charCodeAt(++state.position);
        }
        tagName = state.input.slice(_position, state.position);
        if (PATTERN_FLOW_INDICATORS2.test(tagName)) {
          throwError2(state, "tag suffix cannot contain flow indicator characters");
        }
      }
      if (tagName && !PATTERN_TAG_URI2.test(tagName)) {
        throwError2(state, "tag name cannot contain such characters: " + tagName);
      }
      try {
        tagName = decodeURIComponent(tagName);
      } catch (err) {
        throwError2(state, "tag name is malformed: " + tagName);
      }
      if (isVerbatim) {
        state.tag = tagName;
      } else if (_hasOwnProperty2.call(state.tagMap, tagHandle)) {
        state.tag = state.tagMap[tagHandle] + tagName;
      } else if (tagHandle === "!") {
        state.tag = "!" + tagName;
      } else if (tagHandle === "!!") {
        state.tag = "tag:yaml.org,2002:" + tagName;
      } else {
        throwError2(state, 'undeclared tag handle "' + tagHandle + '"');
      }
      return true;
    }
    function readAnchorProperty2(state) {
      var _position, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch !== 38) return false;
      if (state.anchor !== null) {
        throwError2(state, "duplication of an anchor property");
      }
      ch = state.input.charCodeAt(++state.position);
      _position = state.position;
      while (ch !== 0 && !is_WS_OR_EOL2(ch) && !is_FLOW_INDICATOR2(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      if (state.position === _position) {
        throwError2(state, "name of an anchor node must contain at least one character");
      }
      state.anchor = state.input.slice(_position, state.position);
      return true;
    }
    function readAlias2(state) {
      var _position, alias, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch !== 42) return false;
      ch = state.input.charCodeAt(++state.position);
      _position = state.position;
      while (ch !== 0 && !is_WS_OR_EOL2(ch) && !is_FLOW_INDICATOR2(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      if (state.position === _position) {
        throwError2(state, "name of an alias node must contain at least one character");
      }
      alias = state.input.slice(_position, state.position);
      if (!_hasOwnProperty2.call(state.anchorMap, alias)) {
        throwError2(state, 'unidentified alias "' + alias + '"');
      }
      state.result = state.anchorMap[alias];
      skipSeparationSpace2(state, true, -1);
      return true;
    }
    function composeNode2(state, parentIndent, nodeContext, allowToSeek, allowCompact) {
      var allowBlockStyles, allowBlockScalars, allowBlockCollections, indentStatus = 1, atNewLine = false, hasContent = false, typeIndex, typeQuantity, typeList, type2, flowIndent, blockIndent;
      if (state.listener !== null) {
        state.listener("open", state);
      }
      state.tag = null;
      state.anchor = null;
      state.kind = null;
      state.result = null;
      allowBlockStyles = allowBlockScalars = allowBlockCollections = CONTEXT_BLOCK_OUT2 === nodeContext || CONTEXT_BLOCK_IN2 === nodeContext;
      if (allowToSeek) {
        if (skipSeparationSpace2(state, true, -1)) {
          atNewLine = true;
          if (state.lineIndent > parentIndent) {
            indentStatus = 1;
          } else if (state.lineIndent === parentIndent) {
            indentStatus = 0;
          } else if (state.lineIndent < parentIndent) {
            indentStatus = -1;
          }
        }
      }
      if (indentStatus === 1) {
        while (readTagProperty2(state) || readAnchorProperty2(state)) {
          if (skipSeparationSpace2(state, true, -1)) {
            atNewLine = true;
            allowBlockCollections = allowBlockStyles;
            if (state.lineIndent > parentIndent) {
              indentStatus = 1;
            } else if (state.lineIndent === parentIndent) {
              indentStatus = 0;
            } else if (state.lineIndent < parentIndent) {
              indentStatus = -1;
            }
          } else {
            allowBlockCollections = false;
          }
        }
      }
      if (allowBlockCollections) {
        allowBlockCollections = atNewLine || allowCompact;
      }
      if (indentStatus === 1 || CONTEXT_BLOCK_OUT2 === nodeContext) {
        if (CONTEXT_FLOW_IN2 === nodeContext || CONTEXT_FLOW_OUT2 === nodeContext) {
          flowIndent = parentIndent;
        } else {
          flowIndent = parentIndent + 1;
        }
        blockIndent = state.position - state.lineStart;
        if (indentStatus === 1) {
          if (allowBlockCollections && (readBlockSequence2(state, blockIndent) || readBlockMapping2(state, blockIndent, flowIndent)) || readFlowCollection2(state, flowIndent)) {
            hasContent = true;
          } else {
            if (allowBlockScalars && readBlockScalar2(state, flowIndent) || readSingleQuotedScalar2(state, flowIndent) || readDoubleQuotedScalar2(state, flowIndent)) {
              hasContent = true;
            } else if (readAlias2(state)) {
              hasContent = true;
              if (state.tag !== null || state.anchor !== null) {
                throwError2(state, "alias node should not have any properties");
              }
            } else if (readPlainScalar2(state, flowIndent, CONTEXT_FLOW_IN2 === nodeContext)) {
              hasContent = true;
              if (state.tag === null) {
                state.tag = "?";
              }
            }
            if (state.anchor !== null) {
              state.anchorMap[state.anchor] = state.result;
            }
          }
        } else if (indentStatus === 0) {
          hasContent = allowBlockCollections && readBlockSequence2(state, blockIndent);
        }
      }
      if (state.tag === null) {
        if (state.anchor !== null) {
          state.anchorMap[state.anchor] = state.result;
        }
      } else if (state.tag === "?") {
        if (state.result !== null && state.kind !== "scalar") {
          throwError2(state, 'unacceptable node kind for !<?> tag; it should be "scalar", not "' + state.kind + '"');
        }
        for (typeIndex = 0, typeQuantity = state.implicitTypes.length; typeIndex < typeQuantity; typeIndex += 1) {
          type2 = state.implicitTypes[typeIndex];
          if (type2.resolve(state.result)) {
            state.result = type2.construct(state.result);
            state.tag = type2.tag;
            if (state.anchor !== null) {
              state.anchorMap[state.anchor] = state.result;
            }
            break;
          }
        }
      } else if (state.tag !== "!") {
        if (_hasOwnProperty2.call(state.typeMap[state.kind || "fallback"], state.tag)) {
          type2 = state.typeMap[state.kind || "fallback"][state.tag];
        } else {
          type2 = null;
          typeList = state.typeMap.multi[state.kind || "fallback"];
          for (typeIndex = 0, typeQuantity = typeList.length; typeIndex < typeQuantity; typeIndex += 1) {
            if (state.tag.slice(0, typeList[typeIndex].tag.length) === typeList[typeIndex].tag) {
              type2 = typeList[typeIndex];
              break;
            }
          }
        }
        if (!type2) {
          throwError2(state, "unknown tag !<" + state.tag + ">");
        }
        if (state.result !== null && type2.kind !== state.kind) {
          throwError2(state, "unacceptable node kind for !<" + state.tag + '> tag; it should be "' + type2.kind + '", not "' + state.kind + '"');
        }
        if (!type2.resolve(state.result, state.tag)) {
          throwError2(state, "cannot resolve a node with !<" + state.tag + "> explicit tag");
        } else {
          state.result = type2.construct(state.result, state.tag);
          if (state.anchor !== null) {
            state.anchorMap[state.anchor] = state.result;
          }
        }
      }
      if (state.listener !== null) {
        state.listener("close", state);
      }
      return state.tag !== null || state.anchor !== null || hasContent;
    }
    function readDocument2(state) {
      var documentStart = state.position, _position, directiveName, directiveArgs, hasDirectives = false, ch;
      state.version = null;
      state.checkLineBreaks = state.legacy;
      state.tagMap = /* @__PURE__ */ Object.create(null);
      state.anchorMap = /* @__PURE__ */ Object.create(null);
      while ((ch = state.input.charCodeAt(state.position)) !== 0) {
        skipSeparationSpace2(state, true, -1);
        ch = state.input.charCodeAt(state.position);
        if (state.lineIndent > 0 || ch !== 37) {
          break;
        }
        hasDirectives = true;
        ch = state.input.charCodeAt(++state.position);
        _position = state.position;
        while (ch !== 0 && !is_WS_OR_EOL2(ch)) {
          ch = state.input.charCodeAt(++state.position);
        }
        directiveName = state.input.slice(_position, state.position);
        directiveArgs = [];
        if (directiveName.length < 1) {
          throwError2(state, "directive name must not be less than one character in length");
        }
        while (ch !== 0) {
          while (is_WHITE_SPACE2(ch)) {
            ch = state.input.charCodeAt(++state.position);
          }
          if (ch === 35) {
            do {
              ch = state.input.charCodeAt(++state.position);
            } while (ch !== 0 && !is_EOL2(ch));
            break;
          }
          if (is_EOL2(ch)) break;
          _position = state.position;
          while (ch !== 0 && !is_WS_OR_EOL2(ch)) {
            ch = state.input.charCodeAt(++state.position);
          }
          directiveArgs.push(state.input.slice(_position, state.position));
        }
        if (ch !== 0) readLineBreak2(state);
        if (_hasOwnProperty2.call(directiveHandlers2, directiveName)) {
          directiveHandlers2[directiveName](state, directiveName, directiveArgs);
        } else {
          throwWarning2(state, 'unknown document directive "' + directiveName + '"');
        }
      }
      skipSeparationSpace2(state, true, -1);
      if (state.lineIndent === 0 && state.input.charCodeAt(state.position) === 45 && state.input.charCodeAt(state.position + 1) === 45 && state.input.charCodeAt(state.position + 2) === 45) {
        state.position += 3;
        skipSeparationSpace2(state, true, -1);
      } else if (hasDirectives) {
        throwError2(state, "directives end mark is expected");
      }
      composeNode2(state, state.lineIndent - 1, CONTEXT_BLOCK_OUT2, false, true);
      skipSeparationSpace2(state, true, -1);
      if (state.checkLineBreaks && PATTERN_NON_ASCII_LINE_BREAKS2.test(state.input.slice(documentStart, state.position))) {
        throwWarning2(state, "non-ASCII line breaks are interpreted as content");
      }
      state.documents.push(state.result);
      if (state.position === state.lineStart && testDocumentSeparator2(state)) {
        if (state.input.charCodeAt(state.position) === 46) {
          state.position += 3;
          skipSeparationSpace2(state, true, -1);
        }
        return;
      }
      if (state.position < state.length - 1) {
        throwError2(state, "end of the stream or a document separator is expected");
      } else {
        return;
      }
    }
    function loadDocuments2(input, options) {
      input = String(input);
      options = options || {};
      if (input.length !== 0) {
        if (input.charCodeAt(input.length - 1) !== 10 && input.charCodeAt(input.length - 1) !== 13) {
          input += "\n";
        }
        if (input.charCodeAt(0) === 65279) {
          input = input.slice(1);
        }
      }
      var state = new State3(input, options);
      var nullpos = input.indexOf("\0");
      if (nullpos !== -1) {
        state.position = nullpos;
        throwError2(state, "null byte is not allowed in input");
      }
      state.input += "\0";
      while (state.input.charCodeAt(state.position) === 32) {
        state.lineIndent += 1;
        state.position += 1;
      }
      while (state.position < state.length - 1) {
        readDocument2(state);
      }
      return state.documents;
    }
    function loadAll2(input, iterator, options) {
      if (iterator !== null && typeof iterator === "object" && typeof options === "undefined") {
        options = iterator;
        iterator = null;
      }
      var documents = loadDocuments2(input, options);
      if (typeof iterator !== "function") {
        return documents;
      }
      for (var index = 0, length = documents.length; index < length; index += 1) {
        iterator(documents[index]);
      }
    }
    function load2(input, options) {
      var documents = loadDocuments2(input, options);
      if (documents.length === 0) {
        return void 0;
      } else if (documents.length === 1) {
        return documents[0];
      }
      throw new YAMLException2("expected a single document in the stream, but found more");
    }
    module2.exports.loadAll = loadAll2;
    module2.exports.load = load2;
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/dumper.js
var require_dumper = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/lib/dumper.js"(exports2, module2) {
    "use strict";
    var common2 = require_common();
    var YAMLException2 = require_exception();
    var DEFAULT_SCHEMA2 = require_default();
    var _toString2 = Object.prototype.toString;
    var _hasOwnProperty2 = Object.prototype.hasOwnProperty;
    var CHAR_BOM2 = 65279;
    var CHAR_TAB2 = 9;
    var CHAR_LINE_FEED2 = 10;
    var CHAR_CARRIAGE_RETURN2 = 13;
    var CHAR_SPACE2 = 32;
    var CHAR_EXCLAMATION2 = 33;
    var CHAR_DOUBLE_QUOTE2 = 34;
    var CHAR_SHARP2 = 35;
    var CHAR_PERCENT2 = 37;
    var CHAR_AMPERSAND2 = 38;
    var CHAR_SINGLE_QUOTE2 = 39;
    var CHAR_ASTERISK2 = 42;
    var CHAR_COMMA2 = 44;
    var CHAR_MINUS2 = 45;
    var CHAR_COLON2 = 58;
    var CHAR_EQUALS2 = 61;
    var CHAR_GREATER_THAN2 = 62;
    var CHAR_QUESTION2 = 63;
    var CHAR_COMMERCIAL_AT2 = 64;
    var CHAR_LEFT_SQUARE_BRACKET2 = 91;
    var CHAR_RIGHT_SQUARE_BRACKET2 = 93;
    var CHAR_GRAVE_ACCENT2 = 96;
    var CHAR_LEFT_CURLY_BRACKET2 = 123;
    var CHAR_VERTICAL_LINE2 = 124;
    var CHAR_RIGHT_CURLY_BRACKET2 = 125;
    var ESCAPE_SEQUENCES2 = {};
    ESCAPE_SEQUENCES2[0] = "\\0";
    ESCAPE_SEQUENCES2[7] = "\\a";
    ESCAPE_SEQUENCES2[8] = "\\b";
    ESCAPE_SEQUENCES2[9] = "\\t";
    ESCAPE_SEQUENCES2[10] = "\\n";
    ESCAPE_SEQUENCES2[11] = "\\v";
    ESCAPE_SEQUENCES2[12] = "\\f";
    ESCAPE_SEQUENCES2[13] = "\\r";
    ESCAPE_SEQUENCES2[27] = "\\e";
    ESCAPE_SEQUENCES2[34] = '\\"';
    ESCAPE_SEQUENCES2[92] = "\\\\";
    ESCAPE_SEQUENCES2[133] = "\\N";
    ESCAPE_SEQUENCES2[160] = "\\_";
    ESCAPE_SEQUENCES2[8232] = "\\L";
    ESCAPE_SEQUENCES2[8233] = "\\P";
    var DEPRECATED_BOOLEANS_SYNTAX2 = [
      "y",
      "Y",
      "yes",
      "Yes",
      "YES",
      "on",
      "On",
      "ON",
      "n",
      "N",
      "no",
      "No",
      "NO",
      "off",
      "Off",
      "OFF"
    ];
    var DEPRECATED_BASE60_SYNTAX2 = /^[-+]?[0-9_]+(?::[0-9_]+)+(?:\.[0-9_]*)?$/;
    function compileStyleMap2(schema2, map2) {
      var result, keys5, index, length, tag, style, type2;
      if (map2 === null) return {};
      result = {};
      keys5 = Object.keys(map2);
      for (index = 0, length = keys5.length; index < length; index += 1) {
        tag = keys5[index];
        style = String(map2[tag]);
        if (tag.slice(0, 2) === "!!") {
          tag = "tag:yaml.org,2002:" + tag.slice(2);
        }
        type2 = schema2.compiledTypeMap["fallback"][tag];
        if (type2 && _hasOwnProperty2.call(type2.styleAliases, style)) {
          style = type2.styleAliases[style];
        }
        result[tag] = style;
      }
      return result;
    }
    function encodeHex2(character) {
      var string3, handle, length;
      string3 = character.toString(16).toUpperCase();
      if (character <= 255) {
        handle = "x";
        length = 2;
      } else if (character <= 65535) {
        handle = "u";
        length = 4;
      } else if (character <= 4294967295) {
        handle = "U";
        length = 8;
      } else {
        throw new YAMLException2("code point within a string may not be greater than 0xFFFFFFFF");
      }
      return "\\" + handle + common2.repeat("0", length - string3.length) + string3;
    }
    var QUOTING_TYPE_SINGLE2 = 1;
    var QUOTING_TYPE_DOUBLE2 = 2;
    function State3(options) {
      this.schema = options["schema"] || DEFAULT_SCHEMA2;
      this.indent = Math.max(1, options["indent"] || 2);
      this.noArrayIndent = options["noArrayIndent"] || false;
      this.skipInvalid = options["skipInvalid"] || false;
      this.flowLevel = common2.isNothing(options["flowLevel"]) ? -1 : options["flowLevel"];
      this.styleMap = compileStyleMap2(this.schema, options["styles"] || null);
      this.sortKeys = options["sortKeys"] || false;
      this.lineWidth = options["lineWidth"] || 80;
      this.noRefs = options["noRefs"] || false;
      this.noCompatMode = options["noCompatMode"] || false;
      this.condenseFlow = options["condenseFlow"] || false;
      this.quotingType = options["quotingType"] === '"' ? QUOTING_TYPE_DOUBLE2 : QUOTING_TYPE_SINGLE2;
      this.forceQuotes = options["forceQuotes"] || false;
      this.replacer = typeof options["replacer"] === "function" ? options["replacer"] : null;
      this.implicitTypes = this.schema.compiledImplicit;
      this.explicitTypes = this.schema.compiledExplicit;
      this.tag = null;
      this.result = "";
      this.duplicates = [];
      this.usedDuplicates = null;
    }
    function indentString2(string3, spaces) {
      var ind = common2.repeat(" ", spaces), position = 0, next = -1, result = "", line, length = string3.length;
      while (position < length) {
        next = string3.indexOf("\n", position);
        if (next === -1) {
          line = string3.slice(position);
          position = length;
        } else {
          line = string3.slice(position, next + 1);
          position = next + 1;
        }
        if (line.length && line !== "\n") result += ind;
        result += line;
      }
      return result;
    }
    function generateNextLine2(state, level) {
      return "\n" + common2.repeat(" ", state.indent * level);
    }
    function testImplicitResolving2(state, str2) {
      var index, length, type2;
      for (index = 0, length = state.implicitTypes.length; index < length; index += 1) {
        type2 = state.implicitTypes[index];
        if (type2.resolve(str2)) {
          return true;
        }
      }
      return false;
    }
    function isWhitespace2(c) {
      return c === CHAR_SPACE2 || c === CHAR_TAB2;
    }
    function isPrintable2(c) {
      return 32 <= c && c <= 126 || 161 <= c && c <= 55295 && c !== 8232 && c !== 8233 || 57344 <= c && c <= 65533 && c !== CHAR_BOM2 || 65536 <= c && c <= 1114111;
    }
    function isNsCharOrWhitespace2(c) {
      return isPrintable2(c) && c !== CHAR_BOM2 && c !== CHAR_CARRIAGE_RETURN2 && c !== CHAR_LINE_FEED2;
    }
    function isPlainSafe2(c, prev, inblock) {
      var cIsNsCharOrWhitespace = isNsCharOrWhitespace2(c);
      var cIsNsChar = cIsNsCharOrWhitespace && !isWhitespace2(c);
      return (
        // ns-plain-safe
        (inblock ? (
          // c = flow-in
          cIsNsCharOrWhitespace
        ) : cIsNsCharOrWhitespace && c !== CHAR_COMMA2 && c !== CHAR_LEFT_SQUARE_BRACKET2 && c !== CHAR_RIGHT_SQUARE_BRACKET2 && c !== CHAR_LEFT_CURLY_BRACKET2 && c !== CHAR_RIGHT_CURLY_BRACKET2) && c !== CHAR_SHARP2 && !(prev === CHAR_COLON2 && !cIsNsChar) || isNsCharOrWhitespace2(prev) && !isWhitespace2(prev) && c === CHAR_SHARP2 || prev === CHAR_COLON2 && cIsNsChar
      );
    }
    function isPlainSafeFirst2(c) {
      return isPrintable2(c) && c !== CHAR_BOM2 && !isWhitespace2(c) && c !== CHAR_MINUS2 && c !== CHAR_QUESTION2 && c !== CHAR_COLON2 && c !== CHAR_COMMA2 && c !== CHAR_LEFT_SQUARE_BRACKET2 && c !== CHAR_RIGHT_SQUARE_BRACKET2 && c !== CHAR_LEFT_CURLY_BRACKET2 && c !== CHAR_RIGHT_CURLY_BRACKET2 && c !== CHAR_SHARP2 && c !== CHAR_AMPERSAND2 && c !== CHAR_ASTERISK2 && c !== CHAR_EXCLAMATION2 && c !== CHAR_VERTICAL_LINE2 && c !== CHAR_EQUALS2 && c !== CHAR_GREATER_THAN2 && c !== CHAR_SINGLE_QUOTE2 && c !== CHAR_DOUBLE_QUOTE2 && c !== CHAR_PERCENT2 && c !== CHAR_COMMERCIAL_AT2 && c !== CHAR_GRAVE_ACCENT2;
    }
    function isPlainSafeLast2(c) {
      return !isWhitespace2(c) && c !== CHAR_COLON2;
    }
    function codePointAt2(string3, pos) {
      var first = string3.charCodeAt(pos), second;
      if (first >= 55296 && first <= 56319 && pos + 1 < string3.length) {
        second = string3.charCodeAt(pos + 1);
        if (second >= 56320 && second <= 57343) {
          return (first - 55296) * 1024 + second - 56320 + 65536;
        }
      }
      return first;
    }
    function needIndentIndicator2(string3) {
      var leadingSpaceRe = /^\n* /;
      return leadingSpaceRe.test(string3);
    }
    var STYLE_PLAIN2 = 1;
    var STYLE_SINGLE2 = 2;
    var STYLE_LITERAL2 = 3;
    var STYLE_FOLDED2 = 4;
    var STYLE_DOUBLE2 = 5;
    function chooseScalarStyle2(string3, singleLineOnly, indentPerLevel, lineWidth, testAmbiguousType, quotingType, forceQuotes, inblock) {
      var i;
      var char = 0;
      var prevChar = null;
      var hasLineBreak = false;
      var hasFoldableLine = false;
      var shouldTrackWidth = lineWidth !== -1;
      var previousLineBreak = -1;
      var plain = isPlainSafeFirst2(codePointAt2(string3, 0)) && isPlainSafeLast2(codePointAt2(string3, string3.length - 1));
      if (singleLineOnly || forceQuotes) {
        for (i = 0; i < string3.length; char >= 65536 ? i += 2 : i++) {
          char = codePointAt2(string3, i);
          if (!isPrintable2(char)) {
            return STYLE_DOUBLE2;
          }
          plain = plain && isPlainSafe2(char, prevChar, inblock);
          prevChar = char;
        }
      } else {
        for (i = 0; i < string3.length; char >= 65536 ? i += 2 : i++) {
          char = codePointAt2(string3, i);
          if (char === CHAR_LINE_FEED2) {
            hasLineBreak = true;
            if (shouldTrackWidth) {
              hasFoldableLine = hasFoldableLine || // Foldable line = too long, and not more-indented.
                i - previousLineBreak - 1 > lineWidth && string3[previousLineBreak + 1] !== " ";
              previousLineBreak = i;
            }
          } else if (!isPrintable2(char)) {
            return STYLE_DOUBLE2;
          }
          plain = plain && isPlainSafe2(char, prevChar, inblock);
          prevChar = char;
        }
        hasFoldableLine = hasFoldableLine || shouldTrackWidth && (i - previousLineBreak - 1 > lineWidth && string3[previousLineBreak + 1] !== " ");
      }
      if (!hasLineBreak && !hasFoldableLine) {
        if (plain && !forceQuotes && !testAmbiguousType(string3)) {
          return STYLE_PLAIN2;
        }
        return quotingType === QUOTING_TYPE_DOUBLE2 ? STYLE_DOUBLE2 : STYLE_SINGLE2;
      }
      if (indentPerLevel > 9 && needIndentIndicator2(string3)) {
        return STYLE_DOUBLE2;
      }
      if (!forceQuotes) {
        return hasFoldableLine ? STYLE_FOLDED2 : STYLE_LITERAL2;
      }
      return quotingType === QUOTING_TYPE_DOUBLE2 ? STYLE_DOUBLE2 : STYLE_SINGLE2;
    }
    function writeScalar2(state, string3, level, iskey, inblock) {
      state.dump = function () {
        if (string3.length === 0) {
          return state.quotingType === QUOTING_TYPE_DOUBLE2 ? '""' : "''";
        }
        if (!state.noCompatMode) {
          if (DEPRECATED_BOOLEANS_SYNTAX2.indexOf(string3) !== -1 || DEPRECATED_BASE60_SYNTAX2.test(string3)) {
            return state.quotingType === QUOTING_TYPE_DOUBLE2 ? '"' + string3 + '"' : "'" + string3 + "'";
          }
        }
        var indent = state.indent * Math.max(1, level);
        var lineWidth = state.lineWidth === -1 ? -1 : Math.max(Math.min(state.lineWidth, 40), state.lineWidth - indent);
        var singleLineOnly = iskey || state.flowLevel > -1 && level >= state.flowLevel;
        function testAmbiguity(string4) {
          return testImplicitResolving2(state, string4);
        }
        switch (chooseScalarStyle2(
          string3,
          singleLineOnly,
          state.indent,
          lineWidth,
          testAmbiguity,
          state.quotingType,
          state.forceQuotes && !iskey,
          inblock
        )) {
          case STYLE_PLAIN2:
            return string3;
          case STYLE_SINGLE2:
            return "'" + string3.replace(/'/g, "''") + "'";
          case STYLE_LITERAL2:
            return "|" + blockHeader2(string3, state.indent) + dropEndingNewline2(indentString2(string3, indent));
          case STYLE_FOLDED2:
            return ">" + blockHeader2(string3, state.indent) + dropEndingNewline2(indentString2(foldString2(string3, lineWidth), indent));
          case STYLE_DOUBLE2:
            return '"' + escapeString2(string3, lineWidth) + '"';
          default:
            throw new YAMLException2("impossible error: invalid scalar style");
        }
      }();
    }
    function blockHeader2(string3, indentPerLevel) {
      var indentIndicator = needIndentIndicator2(string3) ? String(indentPerLevel) : "";
      var clip = string3[string3.length - 1] === "\n";
      var keep = clip && (string3[string3.length - 2] === "\n" || string3 === "\n");
      var chomp = keep ? "+" : clip ? "" : "-";
      return indentIndicator + chomp + "\n";
    }
    function dropEndingNewline2(string3) {
      return string3[string3.length - 1] === "\n" ? string3.slice(0, -1) : string3;
    }
    function foldString2(string3, width) {
      var lineRe = /(\n+)([^\n]*)/g;
      var result = function () {
        var nextLF = string3.indexOf("\n");
        nextLF = nextLF !== -1 ? nextLF : string3.length;
        lineRe.lastIndex = nextLF;
        return foldLine2(string3.slice(0, nextLF), width);
      }();
      var prevMoreIndented = string3[0] === "\n" || string3[0] === " ";
      var moreIndented;
      var match;
      while (match = lineRe.exec(string3)) {
        var prefix = match[1], line = match[2];
        moreIndented = line[0] === " ";
        result += prefix + (!prevMoreIndented && !moreIndented && line !== "" ? "\n" : "") + foldLine2(line, width);
        prevMoreIndented = moreIndented;
      }
      return result;
    }
    function foldLine2(line, width) {
      if (line === "" || line[0] === " ") return line;
      var breakRe = / [^ ]/g;
      var match;
      var start = 0, end, curr = 0, next = 0;
      var result = "";
      while (match = breakRe.exec(line)) {
        next = match.index;
        if (next - start > width) {
          end = curr > start ? curr : next;
          result += "\n" + line.slice(start, end);
          start = end + 1;
        }
        curr = next;
      }
      result += "\n";
      if (line.length - start > width && curr > start) {
        result += line.slice(start, curr) + "\n" + line.slice(curr + 1);
      } else {
        result += line.slice(start);
      }
      return result.slice(1);
    }
    function escapeString2(string3) {
      var result = "";
      var char = 0;
      var escapeSeq;
      for (var i = 0; i < string3.length; char >= 65536 ? i += 2 : i++) {
        char = codePointAt2(string3, i);
        escapeSeq = ESCAPE_SEQUENCES2[char];
        if (!escapeSeq && isPrintable2(char)) {
          result += string3[i];
          if (char >= 65536) result += string3[i + 1];
        } else {
          result += escapeSeq || encodeHex2(char);
        }
      }
      return result;
    }
    function writeFlowSequence2(state, level, object3) {
      var _result = "", _tag = state.tag, index, length, value;
      for (index = 0, length = object3.length; index < length; index += 1) {
        value = object3[index];
        if (state.replacer) {
          value = state.replacer.call(object3, String(index), value);
        }
        if (writeNode2(state, level, value, false, false) || typeof value === "undefined" && writeNode2(state, level, null, false, false)) {
          if (_result !== "") _result += "," + (!state.condenseFlow ? " " : "");
          _result += state.dump;
        }
      }
      state.tag = _tag;
      state.dump = "[" + _result + "]";
    }
    function writeBlockSequence2(state, level, object3, compact2) {
      var _result = "", _tag = state.tag, index, length, value;
      for (index = 0, length = object3.length; index < length; index += 1) {
        value = object3[index];
        if (state.replacer) {
          value = state.replacer.call(object3, String(index), value);
        }
        if (writeNode2(state, level + 1, value, true, true, false, true) || typeof value === "undefined" && writeNode2(state, level + 1, null, true, true, false, true)) {
          if (!compact2 || _result !== "") {
            _result += generateNextLine2(state, level);
          }
          if (state.dump && CHAR_LINE_FEED2 === state.dump.charCodeAt(0)) {
            _result += "-";
          } else {
            _result += "- ";
          }
          _result += state.dump;
        }
      }
      state.tag = _tag;
      state.dump = _result || "[]";
    }
    function writeFlowMapping2(state, level, object3) {
      var _result = "", _tag = state.tag, objectKeyList = Object.keys(object3), index, length, objectKey, objectValue, pairBuffer;
      for (index = 0, length = objectKeyList.length; index < length; index += 1) {
        pairBuffer = "";
        if (_result !== "") pairBuffer += ", ";
        if (state.condenseFlow) pairBuffer += '"';
        objectKey = objectKeyList[index];
        objectValue = object3[objectKey];
        if (state.replacer) {
          objectValue = state.replacer.call(object3, objectKey, objectValue);
        }
        if (!writeNode2(state, level, objectKey, false, false)) {
          continue;
        }
        if (state.dump.length > 1024) pairBuffer += "? ";
        pairBuffer += state.dump + (state.condenseFlow ? '"' : "") + ":" + (state.condenseFlow ? "" : " ");
        if (!writeNode2(state, level, objectValue, false, false)) {
          continue;
        }
        pairBuffer += state.dump;
        _result += pairBuffer;
      }
      state.tag = _tag;
      state.dump = "{" + _result + "}";
    }
    function writeBlockMapping2(state, level, object3, compact2) {
      var _result = "", _tag = state.tag, objectKeyList = Object.keys(object3), index, length, objectKey, objectValue, explicitPair, pairBuffer;
      if (state.sortKeys === true) {
        objectKeyList.sort();
      } else if (typeof state.sortKeys === "function") {
        objectKeyList.sort(state.sortKeys);
      } else if (state.sortKeys) {
        throw new YAMLException2("sortKeys must be a boolean or a function");
      }
      for (index = 0, length = objectKeyList.length; index < length; index += 1) {
        pairBuffer = "";
        if (!compact2 || _result !== "") {
          pairBuffer += generateNextLine2(state, level);
        }
        objectKey = objectKeyList[index];
        objectValue = object3[objectKey];
        if (state.replacer) {
          objectValue = state.replacer.call(object3, objectKey, objectValue);
        }
        if (!writeNode2(state, level + 1, objectKey, true, true, true)) {
          continue;
        }
        explicitPair = state.tag !== null && state.tag !== "?" || state.dump && state.dump.length > 1024;
        if (explicitPair) {
          if (state.dump && CHAR_LINE_FEED2 === state.dump.charCodeAt(0)) {
            pairBuffer += "?";
          } else {
            pairBuffer += "? ";
          }
        }
        pairBuffer += state.dump;
        if (explicitPair) {
          pairBuffer += generateNextLine2(state, level);
        }
        if (!writeNode2(state, level + 1, objectValue, true, explicitPair)) {
          continue;
        }
        if (state.dump && CHAR_LINE_FEED2 === state.dump.charCodeAt(0)) {
          pairBuffer += ":";
        } else {
          pairBuffer += ": ";
        }
        pairBuffer += state.dump;
        _result += pairBuffer;
      }
      state.tag = _tag;
      state.dump = _result || "{}";
    }
    function detectType2(state, object3, explicit) {
      var _result, typeList, index, length, type2, style;
      typeList = explicit ? state.explicitTypes : state.implicitTypes;
      for (index = 0, length = typeList.length; index < length; index += 1) {
        type2 = typeList[index];
        if ((type2.instanceOf || type2.predicate) && (!type2.instanceOf || typeof object3 === "object" && object3 instanceof type2.instanceOf) && (!type2.predicate || type2.predicate(object3))) {
          if (explicit) {
            if (type2.multi && type2.representName) {
              state.tag = type2.representName(object3);
            } else {
              state.tag = type2.tag;
            }
          } else {
            state.tag = "?";
          }
          if (type2.represent) {
            style = state.styleMap[type2.tag] || type2.defaultStyle;
            if (_toString2.call(type2.represent) === "[object Function]") {
              _result = type2.represent(object3, style);
            } else if (_hasOwnProperty2.call(type2.represent, style)) {
              _result = type2.represent[style](object3, style);
            } else {
              throw new YAMLException2("!<" + type2.tag + '> tag resolver accepts not "' + style + '" style');
            }
            state.dump = _result;
          }
          return true;
        }
      }
      return false;
    }
    function writeNode2(state, level, object3, block, compact2, iskey, isblockseq) {
      state.tag = null;
      state.dump = object3;
      if (!detectType2(state, object3, false)) {
        detectType2(state, object3, true);
      }
      var type2 = _toString2.call(state.dump);
      var inblock = block;
      var tagStr;
      if (block) {
        block = state.flowLevel < 0 || state.flowLevel > level;
      }
      var objectOrArray = type2 === "[object Object]" || type2 === "[object Array]", duplicateIndex, duplicate;
      if (objectOrArray) {
        duplicateIndex = state.duplicates.indexOf(object3);
        duplicate = duplicateIndex !== -1;
      }
      if (state.tag !== null && state.tag !== "?" || duplicate || state.indent !== 2 && level > 0) {
        compact2 = false;
      }
      if (duplicate && state.usedDuplicates[duplicateIndex]) {
        state.dump = "*ref_" + duplicateIndex;
      } else {
        if (objectOrArray && duplicate && !state.usedDuplicates[duplicateIndex]) {
          state.usedDuplicates[duplicateIndex] = true;
        }
        if (type2 === "[object Object]") {
          if (block && Object.keys(state.dump).length !== 0) {
            writeBlockMapping2(state, level, state.dump, compact2);
            if (duplicate) {
              state.dump = "&ref_" + duplicateIndex + state.dump;
            }
          } else {
            writeFlowMapping2(state, level, state.dump);
            if (duplicate) {
              state.dump = "&ref_" + duplicateIndex + " " + state.dump;
            }
          }
        } else if (type2 === "[object Array]") {
          if (block && state.dump.length !== 0) {
            if (state.noArrayIndent && !isblockseq && level > 0) {
              writeBlockSequence2(state, level - 1, state.dump, compact2);
            } else {
              writeBlockSequence2(state, level, state.dump, compact2);
            }
            if (duplicate) {
              state.dump = "&ref_" + duplicateIndex + state.dump;
            }
          } else {
            writeFlowSequence2(state, level, state.dump);
            if (duplicate) {
              state.dump = "&ref_" + duplicateIndex + " " + state.dump;
            }
          }
        } else if (type2 === "[object String]") {
          if (state.tag !== "?") {
            writeScalar2(state, state.dump, level, iskey, inblock);
          }
        } else if (type2 === "[object Undefined]") {
          return false;
        } else {
          if (state.skipInvalid) return false;
          throw new YAMLException2("unacceptable kind of an object to dump " + type2);
        }
        if (state.tag !== null && state.tag !== "?") {
          tagStr = encodeURI(
            state.tag[0] === "!" ? state.tag.slice(1) : state.tag
          ).replace(/!/g, "%21");
          if (state.tag[0] === "!") {
            tagStr = "!" + tagStr;
          } else if (tagStr.slice(0, 18) === "tag:yaml.org,2002:") {
            tagStr = "!!" + tagStr.slice(18);
          } else {
            tagStr = "!<" + tagStr + ">";
          }
          state.dump = tagStr + " " + state.dump;
        }
      }
      return true;
    }
    function getDuplicateReferences2(object3, state) {
      var objects = [], duplicatesIndexes = [], index, length;
      inspectNode2(object3, objects, duplicatesIndexes);
      for (index = 0, length = duplicatesIndexes.length; index < length; index += 1) {
        state.duplicates.push(objects[duplicatesIndexes[index]]);
      }
      state.usedDuplicates = new Array(length);
    }
    function inspectNode2(object3, objects, duplicatesIndexes) {
      var objectKeyList, index, length;
      if (object3 !== null && typeof object3 === "object") {
        index = objects.indexOf(object3);
        if (index !== -1) {
          if (duplicatesIndexes.indexOf(index) === -1) {
            duplicatesIndexes.push(index);
          }
        } else {
          objects.push(object3);
          if (Array.isArray(object3)) {
            for (index = 0, length = object3.length; index < length; index += 1) {
              inspectNode2(object3[index], objects, duplicatesIndexes);
            }
          } else {
            objectKeyList = Object.keys(object3);
            for (index = 0, length = objectKeyList.length; index < length; index += 1) {
              inspectNode2(object3[objectKeyList[index]], objects, duplicatesIndexes);
            }
          }
        }
      }
    }
    function dump2(input, options) {
      options = options || {};
      var state = new State3(options);
      if (!state.noRefs) getDuplicateReferences2(input, state);
      var value = input;
      if (state.replacer) {
        value = state.replacer.call({ "": value }, "", value);
      }
      if (writeNode2(state, 0, value, true, true)) return state.dump + "\n";
      return "";
    }
    module2.exports.dump = dump2;
  }
});

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/index.js
var require_js_yaml = __commonJS({
  "../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/index.js"(exports2, module2) {
    "use strict";
    var loader2 = require_loader();
    var dumper2 = require_dumper();
    function renamed2(from, to) {
      return function () {
        throw new Error("Function yaml." + from + " is removed in js-yaml 4. Use yaml." + to + " instead, which is now safe by default.");
      };
    }
    module2.exports.Type = require_type();
    module2.exports.Schema = require_schema();
    module2.exports.FAILSAFE_SCHEMA = require_failsafe();
    module2.exports.JSON_SCHEMA = require_json();
    module2.exports.CORE_SCHEMA = require_core();
    module2.exports.DEFAULT_SCHEMA = require_default();
    module2.exports.load = loader2.load;
    module2.exports.loadAll = loader2.loadAll;
    module2.exports.dump = dumper2.dump;
    module2.exports.YAMLException = require_exception();
    module2.exports.types = {
      binary: require_binary(),
      float: require_float(),
      map: require_map(),
      null: require_null(),
      pairs: require_pairs(),
      set: require_set(),
      timestamp: require_timestamp(),
      bool: require_bool(),
      int: require_int(),
      merge: require_merge(),
      omap: require_omap(),
      seq: require_seq(),
      str: require_str()
    };
    module2.exports.safeLoad = renamed2("safeLoad", "load");
    module2.exports.safeLoadAll = renamed2("safeLoadAll", "loadAll");
    module2.exports.safeDump = renamed2("safeDump", "dump");
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/js-yaml/index.js
var require_js_yaml2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/js-yaml/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.stringifyYaml = exports2.parseYaml = void 0;
    var js_yaml_1 = require_js_yaml();
    var DEFAULT_SCHEMA_WITHOUT_TIMESTAMP = js_yaml_1.JSON_SCHEMA.extend({
      implicit: [js_yaml_1.types.merge],
      explicit: [js_yaml_1.types.binary, js_yaml_1.types.omap, js_yaml_1.types.pairs, js_yaml_1.types.set]
    });
    var parseYaml = (str2, opts) => (0, js_yaml_1.load)(str2, Object.assign({ schema: DEFAULT_SCHEMA_WITHOUT_TIMESTAMP }, opts));
    exports2.parseYaml = parseYaml;
    var stringifyYaml = (obj, opts) => (0, js_yaml_1.dump)(obj, opts);
    exports2.stringifyYaml = stringifyYaml;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/env.js
var require_env = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/env.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.env = exports2.isBrowser = void 0;
    exports2.isBrowser = // eslint-disable-next-line @typescript-eslint/ban-ts-comment
      // @ts-ignore
      typeof window !== "undefined" || typeof process === "undefined";
    exports2.env = exports2.isBrowser ? {} : process.env || {};
  }
});

// ../../../node_modules/.pnpm/colorette@1.4.0/node_modules/colorette/index.cjs
var require_colorette = __commonJS({
  "../../../node_modules/.pnpm/colorette@1.4.0/node_modules/colorette/index.cjs"(exports2) {
    "use strict";
    var tty = require("tty");
    var env = process.env;
    var isDisabled = "NO_COLOR" in env;
    var isForced = "FORCE_COLOR" in env;
    var isWindows = process.platform === "win32";
    var isCompatibleTerminal = tty && tty.isatty(1) && env.TERM && env.TERM !== "dumb";
    var isCI = "CI" in env && ("GITHUB_ACTIONS" in env || "GITLAB_CI" in env || "CIRCLECI" in env);
    var enabled = !isDisabled && (isForced || isWindows || isCompatibleTerminal || isCI);
    var raw = (open, close, searchRegex, replaceValue) => (s) => enabled ? open + (~(s += "").indexOf(close, 4) ? s.replace(searchRegex, replaceValue) : s) + close : s;
    var init = (open, close) => {
      return raw(
        `\x1B[${open}m`,
        `\x1B[${close}m`,
        new RegExp(`\\x1b\\[${close}m`, "g"),
        `\x1B[${open}m`
      );
    };
    exports2.options = Object.defineProperty({}, "enabled", {
      get: () => enabled,
      set: (value) => enabled = value
    });
    exports2.reset = init(0, 0);
    exports2.bold = raw("\x1B[1m", "\x1B[22m", /\x1b\[22m/g, "\x1B[22m\x1B[1m");
    exports2.dim = raw("\x1B[2m", "\x1B[22m", /\x1b\[22m/g, "\x1B[22m\x1B[2m");
    exports2.italic = init(3, 23);
    exports2.underline = init(4, 24);
    exports2.inverse = init(7, 27);
    exports2.hidden = init(8, 28);
    exports2.strikethrough = init(9, 29);
    exports2.black = init(30, 39);
    exports2.red = init(31, 39);
    exports2.green = init(32, 39);
    exports2.yellow = init(33, 39);
    exports2.blue = init(34, 39);
    exports2.magenta = init(35, 39);
    exports2.cyan = init(36, 39);
    exports2.white = init(37, 39);
    exports2.gray = init(90, 39);
    exports2.bgBlack = init(40, 49);
    exports2.bgRed = init(41, 49);
    exports2.bgGreen = init(42, 49);
    exports2.bgYellow = init(43, 49);
    exports2.bgBlue = init(44, 49);
    exports2.bgMagenta = init(45, 49);
    exports2.bgCyan = init(46, 49);
    exports2.bgWhite = init(47, 49);
    exports2.blackBright = init(90, 39);
    exports2.redBright = init(91, 39);
    exports2.greenBright = init(92, 39);
    exports2.yellowBright = init(93, 39);
    exports2.blueBright = init(94, 39);
    exports2.magentaBright = init(95, 39);
    exports2.cyanBright = init(96, 39);
    exports2.whiteBright = init(97, 39);
    exports2.bgBlackBright = init(100, 49);
    exports2.bgRedBright = init(101, 49);
    exports2.bgGreenBright = init(102, 49);
    exports2.bgYellowBright = init(103, 49);
    exports2.bgBlueBright = init(104, 49);
    exports2.bgMagentaBright = init(105, 49);
    exports2.bgCyanBright = init(106, 49);
    exports2.bgWhiteBright = init(107, 49);
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/logger.js
var require_logger = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/logger.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.logger = exports2.colorize = exports2.colorOptions = void 0;
    var colorette = require_colorette();
    var colorette_1 = require_colorette();
    Object.defineProperty(exports2, "colorOptions", {
      enumerable: true, get: function () {
        return colorette_1.options;
      }
    });
    var env_1 = require_env();
    var utils_1 = require_utils3();
    exports2.colorize = new Proxy(colorette, {
      get(target, prop) {
        if (env_1.isBrowser) {
          return utils_1.identity;
        }
        return target[prop];
      }
    });
    var Logger = class {
      stderr(str2) {
        return process.stderr.write(str2);
      }
      info(str2) {
        return env_1.isBrowser ? console.log(str2) : this.stderr(str2);
      }
      warn(str2) {
        return env_1.isBrowser ? console.warn(str2) : this.stderr(exports2.colorize.yellow(str2));
      }
      error(str2) {
        return env_1.isBrowser ? console.error(str2) : this.stderr(exports2.colorize.red(str2));
      }
    };
    exports2.logger = new Logger();
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/utils.js
var require_utils3 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/utils.js"(exports2) {
    "use strict";
    var __awaiter = exports2 && exports2.__awaiter || function (thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function (resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.nextTick = exports2.pickDefined = exports2.keysOf = exports2.identity = exports2.isTruthy = exports2.showErrorForDeprecatedField = exports2.showWarningForDeprecatedField = exports2.doesYamlFileExist = exports2.isCustomRuleId = exports2.getMatchingStatusCodeRange = exports2.assignExisting = exports2.isNotString = exports2.isString = exports2.isNotEmptyObject = exports2.slash = exports2.isPathParameter = exports2.yamlAndJsonSyncReader = exports2.readFileAsStringSync = exports2.isSingular = exports2.validateMimeTypeOAS3 = exports2.validateMimeType = exports2.splitCamelCaseIntoWords = exports2.omitObjectProps = exports2.pickObjectProps = exports2.readFileFromUrl = exports2.isEmptyArray = exports2.isEmptyObject = exports2.isPlainObject = exports2.isDefined = exports2.loadYaml = exports2.popStack = exports2.pushStack = exports2.stringifyYaml = exports2.parseYaml = void 0;
    var fs = require("fs");
    var path_1 = require("path");
    var minimatch = require_minimatch();
    var node_fetch_1 = (init_lib(), __toCommonJS(lib_exports));
    var pluralize = require_pluralize();
    var js_yaml_1 = require_js_yaml2();
    var env_1 = require_env();
    var logger_1 = require_logger();
    var js_yaml_2 = require_js_yaml2();
    Object.defineProperty(exports2, "parseYaml", {
      enumerable: true, get: function () {
        return js_yaml_2.parseYaml;
      }
    });
    Object.defineProperty(exports2, "stringifyYaml", {
      enumerable: true, get: function () {
        return js_yaml_2.stringifyYaml;
      }
    });
    function pushStack(head, value) {
      return { prev: head, value };
    }
    exports2.pushStack = pushStack;
    function popStack(head) {
      var _a;
      return (_a = head === null || head === void 0 ? void 0 : head.prev) !== null && _a !== void 0 ? _a : null;
    }
    exports2.popStack = popStack;
    function loadYaml(filename) {
      return __awaiter(this, void 0, void 0, function* () {
        const contents = yield fs.promises.readFile(filename, "utf-8");
        return (0, js_yaml_1.parseYaml)(contents);
      });
    }
    exports2.loadYaml = loadYaml;
    function isDefined(x) {
      return x !== void 0;
    }
    exports2.isDefined = isDefined;
    function isPlainObject5(value) {
      return value !== null && typeof value === "object" && !Array.isArray(value);
    }
    exports2.isPlainObject = isPlainObject5;
    function isEmptyObject(value) {
      return isPlainObject5(value) && Object.keys(value).length === 0;
    }
    exports2.isEmptyObject = isEmptyObject;
    function isEmptyArray(value) {
      return Array.isArray(value) && value.length === 0;
    }
    exports2.isEmptyArray = isEmptyArray;
    function readFileFromUrl(url, config) {
      return __awaiter(this, void 0, void 0, function* () {
        const headers = {};
        for (const header of config.headers) {
          if (match(url, header.matches)) {
            headers[header.name] = header.envVariable !== void 0 ? env_1.env[header.envVariable] || "" : header.value;
          }
        }
        const req = yield (config.customFetch || node_fetch_1.default)(url, {
          headers
        });
        if (!req.ok) {
          throw new Error(`Failed to load ${url}: ${req.status} ${req.statusText}`);
        }
        return { body: yield req.text(), mimeType: req.headers.get("content-type") };
      });
    }
    exports2.readFileFromUrl = readFileFromUrl;
    function match(url, pattern) {
      if (!pattern.match(/^https?:\/\//)) {
        url = url.replace(/^https?:\/\//, "");
      }
      return minimatch(url, pattern);
    }
    function pickObjectProps(object3, keys5) {
      return Object.fromEntries(keys5.filter((key) => key in object3).map((key) => [key, object3[key]]));
    }
    exports2.pickObjectProps = pickObjectProps;
    function omitObjectProps(object3, keys5) {
      return Object.fromEntries(Object.entries(object3).filter(([key]) => !keys5.includes(key)));
    }
    exports2.omitObjectProps = omitObjectProps;
    function splitCamelCaseIntoWords(str2) {
      const camel = str2.split(/(?:[-._])|([A-Z][a-z]+)/).filter(isTruthy).map((item) => item.toLocaleLowerCase());
      const caps = str2.split(/([A-Z]{2,})/).filter((e) => e && e === e.toUpperCase()).map((item) => item.toLocaleLowerCase());
      return /* @__PURE__ */ new Set([...camel, ...caps]);
    }
    exports2.splitCamelCaseIntoWords = splitCamelCaseIntoWords;
    function validateMimeType({ type: type2, value }, { report, location }, allowedValues) {
      const ruleType = type2 === "consumes" ? "request" : "response";
      if (!allowedValues)
        throw new Error(`Parameter "allowedValues" is not provided for "${ruleType}-mime-type" rule`);
      if (!value[type2])
        return;
      for (const mime of value[type2]) {
        if (!allowedValues.includes(mime)) {
          report({
            message: `Mime type "${mime}" is not allowed`,
            location: location.child(value[type2].indexOf(mime)).key()
          });
        }
      }
    }
    exports2.validateMimeType = validateMimeType;
    function validateMimeTypeOAS3({ type: type2, value }, { report, location }, allowedValues) {
      const ruleType = type2 === "consumes" ? "request" : "response";
      if (!allowedValues)
        throw new Error(`Parameter "allowedValues" is not provided for "${ruleType}-mime-type" rule`);
      if (!value.content)
        return;
      for (const mime of Object.keys(value.content)) {
        if (!allowedValues.includes(mime)) {
          report({
            message: `Mime type "${mime}" is not allowed`,
            location: location.child("content").child(mime).key()
          });
        }
      }
    }
    exports2.validateMimeTypeOAS3 = validateMimeTypeOAS3;
    function isSingular(path5) {
      return pluralize.isSingular(path5);
    }
    exports2.isSingular = isSingular;
    function readFileAsStringSync(filePath) {
      return fs.readFileSync(filePath, "utf-8");
    }
    exports2.readFileAsStringSync = readFileAsStringSync;
    function yamlAndJsonSyncReader(filePath) {
      const content = fs.readFileSync(filePath, "utf-8");
      return (0, js_yaml_1.parseYaml)(content);
    }
    exports2.yamlAndJsonSyncReader = yamlAndJsonSyncReader;
    function isPathParameter(pathSegment) {
      return pathSegment.startsWith("{") && pathSegment.endsWith("}");
    }
    exports2.isPathParameter = isPathParameter;
    function slash(path5) {
      const isExtendedLengthPath = /^\\\\\?\\/.test(path5);
      if (isExtendedLengthPath) {
        return path5;
      }
      return path5.replace(/\\/g, "/");
    }
    exports2.slash = slash;
    function isNotEmptyObject(obj) {
      return !!obj && Object.keys(obj).length > 0;
    }
    exports2.isNotEmptyObject = isNotEmptyObject;
    function isString2(value) {
      return typeof value === "string";
    }
    exports2.isString = isString2;
    function isNotString(value) {
      return !isString2(value);
    }
    exports2.isNotString = isNotString;
    function assignExisting(target, obj) {
      for (const k of Object.keys(obj)) {
        if (target.hasOwnProperty(k)) {
          target[k] = obj[k];
        }
      }
    }
    exports2.assignExisting = assignExisting;
    function getMatchingStatusCodeRange(code) {
      return `${code}`.replace(/^(\d)\d\d$/, (_, firstDigit) => `${firstDigit}XX`);
    }
    exports2.getMatchingStatusCodeRange = getMatchingStatusCodeRange;
    function isCustomRuleId(id) {
      return id.includes("/");
    }
    exports2.isCustomRuleId = isCustomRuleId;
    function doesYamlFileExist(filePath) {
      return ((0, path_1.extname)(filePath) === ".yaml" || (0, path_1.extname)(filePath) === ".yml") && fs.hasOwnProperty("existsSync") && fs.existsSync(filePath);
    }
    exports2.doesYamlFileExist = doesYamlFileExist;
    function showWarningForDeprecatedField(deprecatedField, updatedField, updatedObject) {
      logger_1.logger.warn(`The '${logger_1.colorize.red(deprecatedField)}' field is deprecated. ${updatedField ? `Use ${logger_1.colorize.green(getUpdatedFieldName(updatedField, updatedObject))} instead. ` : ""}Read more about this change: https://redocly.com/docs/api-registry/guides/migration-guide-config-file/#changed-properties
`);
    }
    exports2.showWarningForDeprecatedField = showWarningForDeprecatedField;
    function showErrorForDeprecatedField(deprecatedField, updatedField, updatedObject) {
      throw new Error(`Do not use '${deprecatedField}' field. ${updatedField ? `Use '${getUpdatedFieldName(updatedField, updatedObject)}' instead. ` : ""}
`);
    }
    exports2.showErrorForDeprecatedField = showErrorForDeprecatedField;
    function isTruthy(value) {
      return !!value;
    }
    exports2.isTruthy = isTruthy;
    function identity2(value) {
      return value;
    }
    exports2.identity = identity2;
    function keysOf(obj) {
      if (!obj)
        return [];
      return Object.keys(obj);
    }
    exports2.keysOf = keysOf;
    function pickDefined(obj) {
      if (!obj)
        return void 0;
      const res = {};
      for (const key in obj) {
        if (obj[key] !== void 0) {
          res[key] = obj[key];
        }
      }
      return res;
    }
    exports2.pickDefined = pickDefined;
    function nextTick() {
      new Promise((resolve) => {
        setTimeout(resolve);
      });
    }
    exports2.nextTick = nextTick;
    function getUpdatedFieldName(updatedField, updatedObject) {
      return `${typeof updatedObject !== "undefined" ? `${updatedObject}.` : ""}${updatedField}`;
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/index.js
var require_types = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isNamedType = exports2.normalizeTypes = exports2.SpecExtension = exports2.mapOf = exports2.listOf = void 0;
    function listOf(typeName) {
      return {
        name: `${typeName}List`,
        properties: {},
        items: typeName
      };
    }
    exports2.listOf = listOf;
    function mapOf(typeName) {
      return {
        name: `${typeName}Map`,
        properties: {},
        additionalProperties: () => typeName
      };
    }
    exports2.mapOf = mapOf;
    exports2.SpecExtension = {
      name: "SpecExtension",
      properties: {},
      // skip validation of additional properties for unknown extensions
      additionalProperties: { resolvable: true }
    };
    function normalizeTypes(types2, options = {}) {
      const normalizedTypes = {};
      for (const typeName of Object.keys(types2)) {
        normalizedTypes[typeName] = Object.assign(Object.assign({}, types2[typeName]), { name: typeName });
      }
      for (const type2 of Object.values(normalizedTypes)) {
        normalizeType(type2);
      }
      normalizedTypes["SpecExtension"] = exports2.SpecExtension;
      return normalizedTypes;
      function normalizeType(type2) {
        if (type2.additionalProperties) {
          type2.additionalProperties = resolveType(type2.additionalProperties);
        }
        if (type2.items) {
          type2.items = resolveType(type2.items);
        }
        if (type2.properties) {
          const mappedProps = {};
          for (const [propName, prop] of Object.entries(type2.properties)) {
            mappedProps[propName] = resolveType(prop);
            if (options.doNotResolveExamples && prop && prop.isExample) {
              mappedProps[propName] = Object.assign(Object.assign({}, prop), { resolvable: false });
            }
          }
          type2.properties = mappedProps;
        }
      }
      function resolveType(type2) {
        if (typeof type2 === "string") {
          if (!normalizedTypes[type2]) {
            throw new Error(`Unknown type name found: ${type2}`);
          }
          return normalizedTypes[type2];
        } else if (typeof type2 === "function") {
          return (value, key) => {
            return resolveType(type2(value, key));
          };
        } else if (type2 && type2.name) {
          type2 = Object.assign({}, type2);
          normalizeType(type2);
          return type2;
        } else if (type2 && type2.directResolveAs) {
          return Object.assign(Object.assign({}, type2), { directResolveAs: resolveType(type2.directResolveAs) });
        } else {
          return type2;
        }
      }
    }
    exports2.normalizeTypes = normalizeTypes;
    function isNamedType(t) {
      return typeof (t === null || t === void 0 ? void 0 : t.name) === "string";
    }
    exports2.isNamedType = isNamedType;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/ref-utils.js
var require_ref_utils = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/ref-utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isAnchor = exports2.isMappingRef = exports2.isAbsoluteUrl = exports2.refBaseName = exports2.pointerBaseName = exports2.parsePointer = exports2.parseRef = exports2.escapePointer = exports2.unescapePointer = exports2.Location = exports2.isRef = exports2.joinPointer = void 0;
    var utils_1 = require_utils3();
    function joinPointer(base, key) {
      if (base === "")
        base = "#/";
      return base[base.length - 1] === "/" ? base + key : base + "/" + key;
    }
    exports2.joinPointer = joinPointer;
    function isRef(node) {
      return node && typeof node.$ref === "string";
    }
    exports2.isRef = isRef;
    var Location = class _Location {
      constructor(source, pointer) {
        this.source = source;
        this.pointer = pointer;
      }
      child(components) {
        return new _Location(this.source, joinPointer(this.pointer, (Array.isArray(components) ? components : [components]).map(escapePointer).join("/")));
      }
      key() {
        return Object.assign(Object.assign({}, this), { reportOnKey: true });
      }
      get absolutePointer() {
        return this.source.absoluteRef + (this.pointer === "#/" ? "" : this.pointer);
      }
    };
    exports2.Location = Location;
    function unescapePointer(fragment) {
      return decodeURIComponent(fragment.replace(/~1/g, "/").replace(/~0/g, "~"));
    }
    exports2.unescapePointer = unescapePointer;
    function escapePointer(fragment) {
      if (typeof fragment === "number")
        return fragment;
      return fragment.replace(/~/g, "~0").replace(/\//g, "~1");
    }
    exports2.escapePointer = escapePointer;
    function parseRef(ref) {
      const [uri, pointer] = ref.split("#/");
      return {
        uri: uri || null,
        pointer: pointer ? pointer.split("/").map(unescapePointer).filter(utils_1.isTruthy) : []
      };
    }
    exports2.parseRef = parseRef;
    function parsePointer(pointer) {
      return pointer.substr(2).split("/").map(unescapePointer);
    }
    exports2.parsePointer = parsePointer;
    function pointerBaseName(pointer) {
      const parts = pointer.split("/");
      return parts[parts.length - 1];
    }
    exports2.pointerBaseName = pointerBaseName;
    function refBaseName(ref) {
      const parts = ref.split(/[\/\\]/);
      return parts[parts.length - 1].replace(/\.[^.]+$/, "");
    }
    exports2.refBaseName = refBaseName;
    function isAbsoluteUrl(ref) {
      return ref.startsWith("http://") || ref.startsWith("https://");
    }
    exports2.isAbsoluteUrl = isAbsoluteUrl;
    function isMappingRef(mapping) {
      return mapping.startsWith("#") || mapping.startsWith("https://") || mapping.startsWith("http://") || mapping.startsWith("./") || mapping.startsWith("../") || mapping.indexOf("/") > -1;
    }
    exports2.isMappingRef = isMappingRef;
    function isAnchor(ref) {
      return /^#[A-Za-z][A-Za-z0-9\-_:.]*$/.test(ref);
    }
    exports2.isAnchor = isAnchor;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/oas3.js
var require_oas3 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/oas3.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Oas3Types = void 0;
    var _1 = require_types();
    var ref_utils_1 = require_ref_utils();
    var responseCodeRegexp = /^[0-9][0-9Xx]{2}$/;
    var Root = {
      properties: {
        openapi: null,
        info: "Info",
        servers: "ServerList",
        security: "SecurityRequirementList",
        tags: "TagList",
        externalDocs: "ExternalDocs",
        paths: "Paths",
        components: "Components",
        "x-webhooks": "WebhooksMap",
        "x-tagGroups": "TagGroups",
        "x-ignoredHeaderParameters": { type: "array", items: { type: "string" } }
      },
      required: ["openapi", "paths", "info"],
      extensionsPrefix: "x-"
    };
    var Tag = {
      properties: {
        name: { type: "string" },
        description: { type: "string" },
        externalDocs: "ExternalDocs",
        "x-traitTag": { type: "boolean" },
        "x-displayName": { type: "string" }
      },
      required: ["name"],
      extensionsPrefix: "x-"
    };
    var TagGroup = {
      properties: {
        name: { type: "string" },
        tags: { type: "array", items: { type: "string" } }
      },
      extensionsPrefix: "x-"
    };
    var ExternalDocs = {
      properties: {
        description: { type: "string" },
        url: { type: "string" }
      },
      required: ["url"],
      extensionsPrefix: "x-"
    };
    var Server = {
      properties: {
        url: { type: "string" },
        description: { type: "string" },
        variables: "ServerVariablesMap"
      },
      required: ["url"],
      extensionsPrefix: "x-"
    };
    var ServerVariable = {
      properties: {
        enum: {
          type: "array",
          items: { type: "string" }
        },
        default: { type: "string" },
        description: { type: "string" }
      },
      required: ["default"],
      extensionsPrefix: "x-"
    };
    var SecurityRequirement = {
      properties: {},
      additionalProperties: { type: "array", items: { type: "string" } }
    };
    var Info = {
      properties: {
        title: { type: "string" },
        version: { type: "string" },
        description: { type: "string" },
        termsOfService: { type: "string" },
        contact: "Contact",
        license: "License",
        "x-logo": "Logo"
      },
      required: ["title", "version"],
      extensionsPrefix: "x-"
    };
    var Logo = {
      properties: {
        url: { type: "string" },
        altText: { type: "string" },
        backgroundColor: { type: "string" },
        href: { type: "string" }
      }
    };
    var Contact = {
      properties: {
        name: { type: "string" },
        url: { type: "string" },
        email: { type: "string" }
      },
      extensionsPrefix: "x-"
    };
    var License = {
      properties: {
        name: { type: "string" },
        url: { type: "string" }
      },
      required: ["name"],
      extensionsPrefix: "x-"
    };
    var Paths = {
      properties: {},
      additionalProperties: (_value, key) => key.startsWith("/") ? "PathItem" : void 0
    };
    var WebhooksMap = {
      properties: {},
      additionalProperties: () => "PathItem"
    };
    var PathItem = {
      properties: {
        $ref: { type: "string" },
        servers: "ServerList",
        parameters: "ParameterList",
        summary: { type: "string" },
        description: { type: "string" },
        get: "Operation",
        put: "Operation",
        post: "Operation",
        delete: "Operation",
        options: "Operation",
        head: "Operation",
        patch: "Operation",
        trace: "Operation"
      },
      extensionsPrefix: "x-"
    };
    var Parameter = {
      properties: {
        name: { type: "string" },
        in: { enum: ["query", "header", "path", "cookie"] },
        description: { type: "string" },
        required: { type: "boolean" },
        deprecated: { type: "boolean" },
        allowEmptyValue: { type: "boolean" },
        style: {
          enum: ["form", "simple", "label", "matrix", "spaceDelimited", "pipeDelimited", "deepObject"]
        },
        explode: { type: "boolean" },
        allowReserved: { type: "boolean" },
        schema: "Schema",
        example: { isExample: true },
        examples: "ExamplesMap",
        content: "MediaTypesMap"
      },
      required: ["name", "in"],
      requiredOneOf: ["schema", "content"],
      extensionsPrefix: "x-"
    };
    var Operation = {
      properties: {
        tags: {
          type: "array",
          items: { type: "string" }
        },
        summary: { type: "string" },
        description: { type: "string" },
        externalDocs: "ExternalDocs",
        operationId: { type: "string" },
        parameters: "ParameterList",
        security: "SecurityRequirementList",
        servers: "ServerList",
        requestBody: "RequestBody",
        responses: "Responses",
        deprecated: { type: "boolean" },
        callbacks: "CallbacksMap",
        "x-codeSamples": "XCodeSampleList",
        "x-code-samples": "XCodeSampleList",
        "x-hideTryItPanel": { type: "boolean" }
      },
      required: ["responses"],
      extensionsPrefix: "x-"
    };
    var XCodeSample = {
      properties: {
        lang: { type: "string" },
        label: { type: "string" },
        source: { type: "string" }
      }
    };
    var RequestBody = {
      properties: {
        description: { type: "string" },
        required: { type: "boolean" },
        content: "MediaTypesMap"
      },
      required: ["content"],
      extensionsPrefix: "x-"
    };
    var MediaTypesMap = {
      properties: {},
      additionalProperties: "MediaType"
    };
    var MediaType2 = {
      properties: {
        schema: "Schema",
        example: { isExample: true },
        examples: "ExamplesMap",
        encoding: "EncodingMap"
      },
      extensionsPrefix: "x-"
    };
    var Example = {
      properties: {
        value: { isExample: true },
        summary: { type: "string" },
        description: { type: "string" },
        externalValue: { type: "string" }
      },
      extensionsPrefix: "x-"
    };
    var Encoding2 = {
      properties: {
        contentType: { type: "string" },
        headers: "HeadersMap",
        style: {
          enum: ["form", "simple", "label", "matrix", "spaceDelimited", "pipeDelimited", "deepObject"]
        },
        explode: { type: "boolean" },
        allowReserved: { type: "boolean" }
      },
      extensionsPrefix: "x-"
    };
    var EnumDescriptions = {
      properties: {},
      additionalProperties: { type: "string" }
    };
    var Header = {
      properties: {
        description: { type: "string" },
        required: { type: "boolean" },
        deprecated: { type: "boolean" },
        allowEmptyValue: { type: "boolean" },
        style: {
          enum: ["form", "simple", "label", "matrix", "spaceDelimited", "pipeDelimited", "deepObject"]
        },
        explode: { type: "boolean" },
        allowReserved: { type: "boolean" },
        schema: "Schema",
        example: { isExample: true },
        examples: "ExamplesMap",
        content: "MediaTypesMap"
      },
      requiredOneOf: ["schema", "content"],
      extensionsPrefix: "x-"
    };
    var Responses = {
      properties: { default: "Response" },
      additionalProperties: (_v, key) => responseCodeRegexp.test(key) ? "Response" : void 0
    };
    var Response3 = {
      properties: {
        description: { type: "string" },
        headers: "HeadersMap",
        content: "MediaTypesMap",
        links: "LinksMap",
        "x-summary": { type: "string" }
      },
      required: ["description"],
      extensionsPrefix: "x-"
    };
    var Link = {
      properties: {
        operationRef: { type: "string" },
        operationId: { type: "string" },
        parameters: null,
        requestBody: null,
        description: { type: "string" },
        server: "Server"
      },
      extensionsPrefix: "x-"
    };
    var Schema3 = {
      properties: {
        externalDocs: "ExternalDocs",
        discriminator: "Discriminator",
        title: { type: "string" },
        multipleOf: { type: "number", minimum: 0 },
        maximum: { type: "number" },
        minimum: { type: "number" },
        exclusiveMaximum: { type: "boolean" },
        exclusiveMinimum: { type: "boolean" },
        maxLength: { type: "integer", minimum: 0 },
        minLength: { type: "integer", minimum: 0 },
        pattern: { type: "string" },
        maxItems: { type: "integer", minimum: 0 },
        minItems: { type: "integer", minimum: 0 },
        uniqueItems: { type: "boolean" },
        maxProperties: { type: "integer", minimum: 0 },
        minProperties: { type: "integer", minimum: 0 },
        required: { type: "array", items: { type: "string" } },
        enum: { type: "array" },
        type: {
          enum: ["object", "array", "string", "number", "integer", "boolean", "null"]
        },
        allOf: (0, _1.listOf)("Schema"),
        anyOf: (0, _1.listOf)("Schema"),
        oneOf: (0, _1.listOf)("Schema"),
        not: "Schema",
        properties: "SchemaProperties",
        items: (value) => {
          if (Array.isArray(value)) {
            return (0, _1.listOf)("Schema");
          } else {
            return "Schema";
          }
        },
        additionalItems: (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return "Schema";
          }
        },
        additionalProperties: (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return "Schema";
          }
        },
        description: { type: "string" },
        format: { type: "string" },
        default: null,
        nullable: { type: "boolean" },
        readOnly: { type: "boolean" },
        writeOnly: { type: "boolean" },
        xml: "Xml",
        example: { isExample: true },
        deprecated: { type: "boolean" },
        "x-tags": { type: "array", items: { type: "string" } },
        "x-additionalPropertiesName": { type: "string" },
        "x-explicitMappingOnly": { type: "boolean" }
      },
      extensionsPrefix: "x-"
    };
    var Xml = {
      properties: {
        name: { type: "string" },
        namespace: { type: "string" },
        prefix: { type: "string" },
        attribute: { type: "boolean" },
        wrapped: { type: "boolean" }
      },
      extensionsPrefix: "x-"
    };
    var SchemaProperties = {
      properties: {},
      additionalProperties: "Schema"
    };
    var DiscriminatorMapping = {
      properties: {},
      additionalProperties: (value) => {
        if ((0, ref_utils_1.isMappingRef)(value)) {
          return { type: "string", directResolveAs: "Schema" };
        } else {
          return { type: "string" };
        }
      }
    };
    var Discriminator = {
      properties: {
        propertyName: { type: "string" },
        mapping: "DiscriminatorMapping"
      },
      required: ["propertyName"],
      extensionsPrefix: "x-"
    };
    var Components = {
      properties: {
        parameters: "NamedParameters",
        schemas: "NamedSchemas",
        responses: "NamedResponses",
        examples: "NamedExamples",
        requestBodies: "NamedRequestBodies",
        headers: "NamedHeaders",
        securitySchemes: "NamedSecuritySchemes",
        links: "NamedLinks",
        callbacks: "NamedCallbacks"
      },
      extensionsPrefix: "x-"
    };
    var ImplicitFlow = {
      properties: {
        refreshUrl: { type: "string" },
        scopes: { type: "object", additionalProperties: { type: "string" } },
        authorizationUrl: { type: "string" }
      },
      required: ["authorizationUrl", "scopes"],
      extensionsPrefix: "x-"
    };
    var PasswordFlow = {
      properties: {
        refreshUrl: { type: "string" },
        scopes: { type: "object", additionalProperties: { type: "string" } },
        tokenUrl: { type: "string" }
      },
      required: ["tokenUrl", "scopes"],
      extensionsPrefix: "x-"
    };
    var ClientCredentials = {
      properties: {
        refreshUrl: { type: "string" },
        scopes: { type: "object", additionalProperties: { type: "string" } },
        tokenUrl: { type: "string" }
      },
      required: ["tokenUrl", "scopes"],
      extensionsPrefix: "x-"
    };
    var AuthorizationCode = {
      properties: {
        refreshUrl: { type: "string" },
        authorizationUrl: { type: "string" },
        scopes: { type: "object", additionalProperties: { type: "string" } },
        tokenUrl: { type: "string" },
        "x-usePkce": (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return "XUsePkce";
          }
        }
      },
      required: ["authorizationUrl", "tokenUrl", "scopes"],
      extensionsPrefix: "x-"
    };
    var OAuth2Flows = {
      properties: {
        implicit: "ImplicitFlow",
        password: "PasswordFlow",
        clientCredentials: "ClientCredentials",
        authorizationCode: "AuthorizationCode"
      },
      extensionsPrefix: "x-"
    };
    var SecurityScheme2 = {
      properties: {
        type: { enum: ["apiKey", "http", "oauth2", "openIdConnect"] },
        description: { type: "string" },
        name: { type: "string" },
        in: { type: "string", enum: ["query", "header", "cookie"] },
        scheme: { type: "string" },
        bearerFormat: { type: "string" },
        flows: "OAuth2Flows",
        openIdConnectUrl: { type: "string" },
        "x-defaultClientId": { type: "string" }
      },
      required(value) {
        switch (value === null || value === void 0 ? void 0 : value.type) {
          case "apiKey":
            return ["type", "name", "in"];
          case "http":
            return ["type", "scheme"];
          case "oauth2":
            return ["type", "flows"];
          case "openIdConnect":
            return ["type", "openIdConnectUrl"];
          default:
            return ["type"];
        }
      },
      allowed(value) {
        switch (value === null || value === void 0 ? void 0 : value.type) {
          case "apiKey":
            return ["type", "name", "in", "description"];
          case "http":
            return ["type", "scheme", "bearerFormat", "description"];
          case "oauth2":
            return ["type", "flows", "description"];
          case "openIdConnect":
            return ["type", "openIdConnectUrl", "description"];
          default:
            return ["type", "description"];
        }
      },
      extensionsPrefix: "x-"
    };
    var XUsePkce = {
      properties: {
        disableManualConfiguration: { type: "boolean" },
        hideClientSecretInput: { type: "boolean" }
      }
    };
    exports2.Oas3Types = {
      Root,
      Tag,
      TagList: (0, _1.listOf)("Tag"),
      TagGroups: (0, _1.listOf)("TagGroup"),
      TagGroup,
      ExternalDocs,
      Server,
      ServerList: (0, _1.listOf)("Server"),
      ServerVariable,
      ServerVariablesMap: (0, _1.mapOf)("ServerVariable"),
      SecurityRequirement,
      SecurityRequirementList: (0, _1.listOf)("SecurityRequirement"),
      Info,
      Contact,
      License,
      Paths,
      PathItem,
      Parameter,
      ParameterList: (0, _1.listOf)("Parameter"),
      Operation,
      Callback: (0, _1.mapOf)("PathItem"),
      CallbacksMap: (0, _1.mapOf)("Callback"),
      RequestBody,
      MediaTypesMap,
      MediaType: MediaType2,
      Example,
      ExamplesMap: (0, _1.mapOf)("Example"),
      Encoding: Encoding2,
      EncodingMap: (0, _1.mapOf)("Encoding"),
      EnumDescriptions,
      Header,
      HeadersMap: (0, _1.mapOf)("Header"),
      Responses,
      Response: Response3,
      Link,
      Logo,
      Schema: Schema3,
      Xml,
      SchemaProperties,
      DiscriminatorMapping,
      Discriminator,
      Components,
      LinksMap: (0, _1.mapOf)("Link"),
      NamedSchemas: (0, _1.mapOf)("Schema"),
      NamedResponses: (0, _1.mapOf)("Response"),
      NamedParameters: (0, _1.mapOf)("Parameter"),
      NamedExamples: (0, _1.mapOf)("Example"),
      NamedRequestBodies: (0, _1.mapOf)("RequestBody"),
      NamedHeaders: (0, _1.mapOf)("Header"),
      NamedSecuritySchemes: (0, _1.mapOf)("SecurityScheme"),
      NamedLinks: (0, _1.mapOf)("Link"),
      NamedCallbacks: (0, _1.mapOf)("Callback"),
      ImplicitFlow,
      PasswordFlow,
      ClientCredentials,
      AuthorizationCode,
      OAuth2Flows,
      SecurityScheme: SecurityScheme2,
      XCodeSample,
      XCodeSampleList: (0, _1.listOf)("XCodeSample"),
      XUsePkce,
      WebhooksMap
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/oas3_1.js
var require_oas3_1 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/oas3_1.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Oas3_1Types = void 0;
    var _1 = require_types();
    var oas3_1 = require_oas3();
    var Root = {
      properties: {
        openapi: null,
        info: "Info",
        servers: "ServerList",
        security: "SecurityRequirementList",
        tags: "TagList",
        externalDocs: "ExternalDocs",
        paths: "Paths",
        webhooks: "WebhooksMap",
        components: "Components",
        jsonSchemaDialect: { type: "string" }
      },
      required: ["openapi", "info"],
      requiredOneOf: ["paths", "components", "webhooks"],
      extensionsPrefix: "x-"
    };
    var License = {
      properties: {
        name: { type: "string" },
        url: { type: "string" },
        identifier: { type: "string" }
      },
      required: ["name"],
      extensionsPrefix: "x-"
    };
    var Info = {
      properties: {
        title: { type: "string" },
        version: { type: "string" },
        description: { type: "string" },
        termsOfService: { type: "string" },
        summary: { type: "string" },
        contact: "Contact",
        license: "License",
        "x-logo": "Logo"
      },
      required: ["title", "version"],
      extensionsPrefix: "x-"
    };
    var Components = {
      properties: {
        parameters: "NamedParameters",
        schemas: "NamedSchemas",
        responses: "NamedResponses",
        examples: "NamedExamples",
        requestBodies: "NamedRequestBodies",
        headers: "NamedHeaders",
        securitySchemes: "NamedSecuritySchemes",
        links: "NamedLinks",
        callbacks: "NamedCallbacks",
        pathItems: "NamedPathItems"
      },
      extensionsPrefix: "x-"
    };
    var Operation = {
      properties: {
        tags: {
          type: "array",
          items: { type: "string" }
        },
        summary: { type: "string" },
        description: { type: "string" },
        externalDocs: "ExternalDocs",
        operationId: { type: "string" },
        parameters: "ParameterList",
        security: "SecurityRequirementList",
        servers: "ServerList",
        requestBody: "RequestBody",
        responses: "Responses",
        deprecated: { type: "boolean" },
        callbacks: "CallbacksMap",
        "x-codeSamples": "XCodeSampleList",
        "x-code-samples": "XCodeSampleList",
        "x-hideTryItPanel": { type: "boolean" }
      },
      extensionsPrefix: "x-"
    };
    var Schema3 = {
      properties: {
        $id: { type: "string" },
        $anchor: { type: "string" },
        id: { type: "string" },
        $schema: { type: "string" },
        definitions: "NamedSchemas",
        $defs: "NamedSchemas",
        $vocabulary: { type: "string" },
        externalDocs: "ExternalDocs",
        discriminator: "Discriminator",
        title: { type: "string" },
        multipleOf: { type: "number", minimum: 0 },
        maximum: { type: "number" },
        minimum: { type: "number" },
        exclusiveMaximum: { type: "number" },
        exclusiveMinimum: { type: "number" },
        maxLength: { type: "integer", minimum: 0 },
        minLength: { type: "integer", minimum: 0 },
        pattern: { type: "string" },
        maxItems: { type: "integer", minimum: 0 },
        minItems: { type: "integer", minimum: 0 },
        uniqueItems: { type: "boolean" },
        maxProperties: { type: "integer", minimum: 0 },
        minProperties: { type: "integer", minimum: 0 },
        required: { type: "array", items: { type: "string" } },
        enum: { type: "array" },
        type: (value) => {
          if (Array.isArray(value)) {
            return {
              type: "array",
              items: { enum: ["object", "array", "string", "number", "integer", "boolean", "null"] }
            };
          } else {
            return {
              enum: ["object", "array", "string", "number", "integer", "boolean", "null"]
            };
          }
        },
        allOf: (0, _1.listOf)("Schema"),
        anyOf: (0, _1.listOf)("Schema"),
        oneOf: (0, _1.listOf)("Schema"),
        not: "Schema",
        if: "Schema",
        then: "Schema",
        else: "Schema",
        dependentSchemas: (0, _1.listOf)("Schema"),
        prefixItems: (0, _1.listOf)("Schema"),
        contains: "Schema",
        minContains: { type: "integer", minimum: 0 },
        maxContains: { type: "integer", minimum: 0 },
        patternProperties: { type: "object" },
        propertyNames: "Schema",
        unevaluatedItems: (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return "Schema";
          }
        },
        unevaluatedProperties: (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return "Schema";
          }
        },
        summary: { type: "string" },
        properties: "SchemaProperties",
        items: (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return "Schema";
          }
        },
        additionalProperties: (value) => {
          return typeof value === "boolean" ? { type: "boolean" } : "Schema";
        },
        description: { type: "string" },
        format: { type: "string" },
        contentEncoding: { type: "string" },
        contentMediaType: { type: "string" },
        default: null,
        readOnly: { type: "boolean" },
        writeOnly: { type: "boolean" },
        xml: "Xml",
        examples: { type: "array" },
        example: { isExample: true },
        deprecated: { type: "boolean" },
        const: null,
        $comment: { type: "string" },
        "x-tags": { type: "array", items: { type: "string" } }
      },
      extensionsPrefix: "x-"
    };
    var SchemaProperties = {
      properties: {},
      additionalProperties: (value) => {
        if (typeof value === "boolean") {
          return { type: "boolean" };
        } else {
          return "Schema";
        }
      }
    };
    var SecurityScheme2 = {
      properties: {
        type: { enum: ["apiKey", "http", "oauth2", "openIdConnect", "mutualTLS"] },
        description: { type: "string" },
        name: { type: "string" },
        in: { type: "string", enum: ["query", "header", "cookie"] },
        scheme: { type: "string" },
        bearerFormat: { type: "string" },
        flows: "OAuth2Flows",
        openIdConnectUrl: { type: "string" }
      },
      required(value) {
        switch (value === null || value === void 0 ? void 0 : value.type) {
          case "apiKey":
            return ["type", "name", "in"];
          case "http":
            return ["type", "scheme"];
          case "oauth2":
            return ["type", "flows"];
          case "openIdConnect":
            return ["type", "openIdConnectUrl"];
          default:
            return ["type"];
        }
      },
      allowed(value) {
        switch (value === null || value === void 0 ? void 0 : value.type) {
          case "apiKey":
            return ["type", "name", "in", "description"];
          case "http":
            return ["type", "scheme", "bearerFormat", "description"];
          case "oauth2":
            switch (value === null || value === void 0 ? void 0 : value.flows) {
              case "implicit":
                return ["type", "flows", "authorizationUrl", "refreshUrl", "description", "scopes"];
              case "password":
              case "clientCredentials":
                return ["type", "flows", "tokenUrl", "refreshUrl", "description", "scopes"];
              case "authorizationCode":
                return [
                  "type",
                  "flows",
                  "authorizationUrl",
                  "refreshUrl",
                  "tokenUrl",
                  "description",
                  "scopes"
                ];
              default:
                return [
                  "type",
                  "flows",
                  "authorizationUrl",
                  "refreshUrl",
                  "tokenUrl",
                  "description",
                  "scopes"
                ];
            }
          case "openIdConnect":
            return ["type", "openIdConnectUrl", "description"];
          case "mutualTLS":
            return ["type", "description"];
          default:
            return ["type", "description"];
        }
      },
      extensionsPrefix: "x-"
    };
    exports2.Oas3_1Types = Object.assign(Object.assign({}, oas3_1.Oas3Types), {
      Info,
      Root,
      Schema: Schema3,
      SchemaProperties,
      License,
      Components,
      NamedPathItems: (0, _1.mapOf)("PathItem"),
      SecurityScheme: SecurityScheme2,
      Operation
    });
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/oas2.js
var require_oas2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/oas2.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Oas2Types = void 0;
    var _1 = require_types();
    var responseCodeRegexp = /^[0-9][0-9Xx]{2}$/;
    var Root = {
      properties: {
        swagger: { type: "string" },
        info: "Info",
        host: { type: "string" },
        basePath: { type: "string" },
        schemes: { type: "array", items: { type: "string" } },
        consumes: { type: "array", items: { type: "string" } },
        produces: { type: "array", items: { type: "string" } },
        paths: "Paths",
        definitions: "NamedSchemas",
        parameters: "NamedParameters",
        responses: "NamedResponses",
        securityDefinitions: "NamedSecuritySchemes",
        security: "SecurityRequirementList",
        tags: "TagList",
        externalDocs: "ExternalDocs",
        "x-servers": "XServerList",
        "x-tagGroups": "TagGroups",
        "x-ignoredHeaderParameters": { type: "array", items: { type: "string" } }
      },
      required: ["swagger", "paths", "info"],
      extensionsPrefix: "x-"
    };
    var Info = {
      properties: {
        title: { type: "string" },
        description: { type: "string" },
        termsOfService: { type: "string" },
        contact: "Contact",
        license: "License",
        version: { type: "string" },
        "x-logo": "Logo"
      },
      required: ["title", "version"],
      extensionsPrefix: "x-"
    };
    var Logo = {
      properties: {
        url: { type: "string" },
        altText: { type: "string" },
        backgroundColor: { type: "string" },
        href: { type: "string" }
      },
      extensionsPrefix: "x-"
    };
    var Contact = {
      properties: {
        name: { type: "string" },
        url: { type: "string" },
        email: { type: "string" }
      },
      extensionsPrefix: "x-"
    };
    var License = {
      properties: {
        name: { type: "string" },
        url: { type: "string" }
      },
      required: ["name"],
      extensionsPrefix: "x-"
    };
    var Paths = {
      properties: {},
      additionalProperties: (_value, key) => key.startsWith("/") ? "PathItem" : void 0
    };
    var PathItem = {
      properties: {
        $ref: { type: "string" },
        parameters: "ParameterList",
        get: "Operation",
        put: "Operation",
        post: "Operation",
        delete: "Operation",
        options: "Operation",
        head: "Operation",
        patch: "Operation"
      },
      extensionsPrefix: "x-"
    };
    var Operation = {
      properties: {
        tags: { type: "array", items: { type: "string" } },
        summary: { type: "string" },
        description: { type: "string" },
        externalDocs: "ExternalDocs",
        operationId: { type: "string" },
        consumes: { type: "array", items: { type: "string" } },
        produces: { type: "array", items: { type: "string" } },
        parameters: "ParameterList",
        responses: "Responses",
        schemes: { type: "array", items: { type: "string" } },
        deprecated: { type: "boolean" },
        security: "SecurityRequirementList",
        "x-codeSamples": "XCodeSampleList",
        "x-code-samples": "XCodeSampleList",
        "x-hideTryItPanel": { type: "boolean" }
      },
      required: ["responses"],
      extensionsPrefix: "x-"
    };
    var XCodeSample = {
      properties: {
        lang: { type: "string" },
        label: { type: "string" },
        source: { type: "string" }
      }
    };
    var XServer = {
      properties: {
        url: { type: "string" },
        description: { type: "string" }
      },
      required: ["url"]
    };
    var ExternalDocs = {
      properties: {
        description: { type: "string" },
        url: { type: "string" }
      },
      required: ["url"],
      extensionsPrefix: "x-"
    };
    var Parameter = {
      properties: {
        name: { type: "string" },
        in: { type: "string", enum: ["query", "header", "path", "formData", "body"] },
        description: { type: "string" },
        required: { type: "boolean" },
        schema: "Schema",
        type: { type: "string", enum: ["string", "number", "integer", "boolean", "array", "file"] },
        format: { type: "string" },
        allowEmptyValue: { type: "boolean" },
        items: "ParameterItems",
        collectionFormat: { type: "string", enum: ["csv", "ssv", "tsv", "pipes", "multi"] },
        default: null,
        maximum: { type: "integer" },
        exclusiveMaximum: { type: "boolean" },
        minimum: { type: "integer" },
        exclusiveMinimum: { type: "boolean" },
        maxLength: { type: "integer" },
        minLength: { type: "integer" },
        pattern: { type: "string" },
        maxItems: { type: "integer" },
        minItems: { type: "integer" },
        uniqueItems: { type: "boolean" },
        enum: { type: "array" },
        multipleOf: { type: "number" },
        "x-example": "Example",
        "x-examples": "ExamplesMap"
      },
      required(value) {
        if (!value || !value.in) {
          return ["name", "in"];
        }
        if (value.in === "body") {
          return ["name", "in", "schema"];
        } else {
          if (value.type === "array") {
            return ["name", "in", "type", "items"];
          } else {
            return ["name", "in", "type"];
          }
        }
      },
      extensionsPrefix: "x-"
    };
    var ParameterItems = {
      properties: {
        type: { type: "string", enum: ["string", "number", "integer", "boolean", "array"] },
        format: { type: "string" },
        items: "ParameterItems",
        collectionFormat: { type: "string", enum: ["csv", "ssv", "tsv", "pipes", "multi"] },
        default: null,
        maximum: { type: "integer" },
        exclusiveMaximum: { type: "boolean" },
        minimum: { type: "integer" },
        exclusiveMinimum: { type: "boolean" },
        maxLength: { type: "integer" },
        minLength: { type: "integer" },
        pattern: { type: "string" },
        maxItems: { type: "integer" },
        minItems: { type: "integer" },
        uniqueItems: { type: "boolean" },
        enum: { type: "array" },
        multipleOf: { type: "number" }
      },
      required(value) {
        if (value && value.type === "array") {
          return ["type", "items"];
        } else {
          return ["type"];
        }
      },
      extensionsPrefix: "x-"
    };
    var Responses = {
      properties: {
        default: "Response"
      },
      additionalProperties: (_v, key) => responseCodeRegexp.test(key) ? "Response" : void 0
    };
    var Response3 = {
      properties: {
        description: { type: "string" },
        schema: "Schema",
        headers: (0, _1.mapOf)("Header"),
        examples: "Examples",
        "x-summary": { type: "string" }
      },
      required: ["description"],
      extensionsPrefix: "x-"
    };
    var Examples = {
      properties: {},
      additionalProperties: { isExample: true }
    };
    var Header = {
      properties: {
        description: { type: "string" },
        type: { type: "string", enum: ["string", "number", "integer", "boolean", "array"] },
        format: { type: "string" },
        items: "ParameterItems",
        collectionFormat: { type: "string", enum: ["csv", "ssv", "tsv", "pipes", "multi"] },
        default: null,
        maximum: { type: "integer" },
        exclusiveMaximum: { type: "boolean" },
        minimum: { type: "integer" },
        exclusiveMinimum: { type: "boolean" },
        maxLength: { type: "integer" },
        minLength: { type: "integer" },
        pattern: { type: "string" },
        maxItems: { type: "integer" },
        minItems: { type: "integer" },
        uniqueItems: { type: "boolean" },
        enum: { type: "array" },
        multipleOf: { type: "number" }
      },
      required(value) {
        if (value && value.type === "array") {
          return ["type", "items"];
        } else {
          return ["type"];
        }
      },
      extensionsPrefix: "x-"
    };
    var Tag = {
      properties: {
        name: { type: "string" },
        description: { type: "string" },
        externalDocs: "ExternalDocs",
        "x-traitTag": { type: "boolean" },
        "x-displayName": { type: "string" }
      },
      required: ["name"],
      extensionsPrefix: "x-"
    };
    var TagGroup = {
      properties: {
        name: { type: "string" },
        tags: { type: "array", items: { type: "string" } }
      }
    };
    var Schema3 = {
      properties: {
        format: { type: "string" },
        title: { type: "string" },
        description: { type: "string" },
        default: null,
        multipleOf: { type: "number" },
        maximum: { type: "number" },
        minimum: { type: "number" },
        exclusiveMaximum: { type: "boolean" },
        exclusiveMinimum: { type: "boolean" },
        maxLength: { type: "number" },
        minLength: { type: "number" },
        pattern: { type: "string" },
        maxItems: { type: "number" },
        minItems: { type: "number" },
        uniqueItems: { type: "boolean" },
        maxProperties: { type: "number" },
        minProperties: { type: "number" },
        required: { type: "array", items: { type: "string" } },
        enum: { type: "array" },
        type: {
          type: "string",
          enum: ["object", "array", "string", "number", "integer", "boolean", "null"]
        },
        items: (value) => {
          if (Array.isArray(value)) {
            return (0, _1.listOf)("Schema");
          } else {
            return "Schema";
          }
        },
        allOf: (0, _1.listOf)("Schema"),
        properties: "SchemaProperties",
        additionalProperties: (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return "Schema";
          }
        },
        discriminator: { type: "string" },
        readOnly: { type: "boolean" },
        xml: "Xml",
        externalDocs: "ExternalDocs",
        example: { isExample: true },
        "x-tags": { type: "array", items: { type: "string" } },
        "x-nullable": { type: "boolean" },
        "x-extendedDiscriminator": { type: "string" },
        "x-additionalPropertiesName": { type: "string" },
        "x-explicitMappingOnly": { type: "boolean" },
        "x-enumDescriptions": "EnumDescriptions"
      },
      extensionsPrefix: "x-"
    };
    var EnumDescriptions = {
      properties: {},
      additionalProperties: { type: "string" }
    };
    var SchemaProperties = {
      properties: {},
      additionalProperties: "Schema"
    };
    var Xml = {
      properties: {
        name: { type: "string" },
        namespace: { type: "string" },
        prefix: { type: "string" },
        attribute: { type: "boolean" },
        wrapped: { type: "boolean" }
      },
      extensionsPrefix: "x-"
    };
    var SecurityScheme2 = {
      properties: {
        type: { enum: ["basic", "apiKey", "oauth2"] },
        description: { type: "string" },
        name: { type: "string" },
        in: { type: "string", enum: ["query", "header"] },
        flow: { enum: ["implicit", "password", "application", "accessCode"] },
        authorizationUrl: { type: "string" },
        tokenUrl: { type: "string" },
        scopes: { type: "object", additionalProperties: { type: "string" } },
        "x-defaultClientId": { type: "string" }
      },
      required(value) {
        switch (value === null || value === void 0 ? void 0 : value.type) {
          case "apiKey":
            return ["type", "name", "in"];
          case "oauth2":
            switch (value === null || value === void 0 ? void 0 : value.flow) {
              case "implicit":
                return ["type", "flow", "authorizationUrl", "scopes"];
              case "accessCode":
                return ["type", "flow", "authorizationUrl", "tokenUrl", "scopes"];
              case "application":
              case "password":
                return ["type", "flow", "tokenUrl", "scopes"];
              default:
                return ["type", "flow", "scopes"];
            }
          default:
            return ["type"];
        }
      },
      allowed(value) {
        switch (value === null || value === void 0 ? void 0 : value.type) {
          case "basic":
            return ["type", "description"];
          case "apiKey":
            return ["type", "name", "in", "description"];
          case "oauth2":
            switch (value === null || value === void 0 ? void 0 : value.flow) {
              case "implicit":
                return ["type", "flow", "authorizationUrl", "description", "scopes"];
              case "accessCode":
                return ["type", "flow", "authorizationUrl", "tokenUrl", "description", "scopes"];
              case "application":
              case "password":
                return ["type", "flow", "tokenUrl", "description", "scopes"];
              default:
                return ["type", "flow", "tokenUrl", "authorizationUrl", "description", "scopes"];
            }
          default:
            return ["type", "description"];
        }
      },
      extensionsPrefix: "x-"
    };
    var SecurityRequirement = {
      properties: {},
      additionalProperties: { type: "array", items: { type: "string" } }
    };
    var Example = {
      properties: {
        value: { isExample: true },
        summary: { type: "string" },
        description: { type: "string" },
        externalValue: { type: "string" }
      },
      extensionsPrefix: "x-"
    };
    exports2.Oas2Types = {
      Root,
      Tag,
      TagList: (0, _1.listOf)("Tag"),
      TagGroups: (0, _1.listOf)("TagGroup"),
      TagGroup,
      ExternalDocs,
      Example,
      ExamplesMap: (0, _1.mapOf)("Example"),
      EnumDescriptions,
      SecurityRequirement,
      SecurityRequirementList: (0, _1.listOf)("SecurityRequirement"),
      Info,
      Contact,
      License,
      Logo,
      Paths,
      PathItem,
      Parameter,
      ParameterItems,
      ParameterList: (0, _1.listOf)("Parameter"),
      Operation,
      Examples,
      Header,
      Responses,
      Response: Response3,
      Schema: Schema3,
      Xml,
      SchemaProperties,
      NamedSchemas: (0, _1.mapOf)("Schema"),
      NamedResponses: (0, _1.mapOf)("Response"),
      NamedParameters: (0, _1.mapOf)("Parameter"),
      NamedSecuritySchemes: (0, _1.mapOf)("SecurityScheme"),
      SecurityScheme: SecurityScheme2,
      XCodeSample,
      XCodeSampleList: (0, _1.listOf)("XCodeSample"),
      XServerList: (0, _1.listOf)("XServer"),
      XServer
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/asyncapi.js
var require_asyncapi = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/asyncapi.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.AsyncApi2Types = void 0;
    var _1 = require_types();
    var ref_utils_1 = require_ref_utils();
    var Root = {
      properties: {
        asyncapi: null,
        info: "Info",
        id: { type: "string" },
        servers: "ServerMap",
        channels: "ChannelMap",
        components: "Components",
        tags: "TagList",
        externalDocs: "ExternalDocs",
        defaultContentType: { type: "string" }
      },
      required: ["asyncapi", "channels", "info"]
    };
    var Channel = {
      properties: {
        description: { type: "string" },
        subscribe: "Operation",
        publish: "Operation",
        parameters: "ParametersMap",
        bindings: "ChannelBindings",
        servers: { type: "array", items: { type: "string" } }
      }
    };
    var ChannelMap = {
      properties: {},
      additionalProperties: "Channel"
    };
    var ChannelBindings = {
      properties: {},
      allowed() {
        return [
          "http",
          "ws",
          "kafka",
          "anypointmq",
          "amqp",
          "amqp1",
          "mqtt",
          "mqtt5",
          "nats",
          "jms",
          "sns",
          "solace",
          "sqs",
          "stomp",
          "redis",
          "mercure",
          "ibmmq",
          "googlepubsub",
          "pulsar"
        ];
      },
      additionalProperties: { type: "object" }
    };
    var Tag = {
      properties: {
        name: { type: "string" },
        description: { type: "string" },
        externalDocs: "ExternalDocs"
      },
      required: ["name"]
    };
    var ExternalDocs = {
      properties: {
        description: { type: "string" },
        url: { type: "string" }
      },
      required: ["url"]
    };
    var SecurityRequirement = {
      properties: {},
      additionalProperties: { type: "array", items: { type: "string" } }
    };
    var ServerBindings = {
      properties: {},
      allowed() {
        return [
          "http",
          "ws",
          "kafka",
          "anypointmq",
          "amqp",
          "amqp1",
          "mqtt",
          "mqtt5",
          "nats",
          "jms",
          "sns",
          "solace",
          "sqs",
          "stomp",
          "redis",
          "mercure",
          "ibmmq",
          "googlepubsub",
          "pulsar"
        ];
      },
      additionalProperties: { type: "object" }
    };
    var Server = {
      properties: {
        url: { type: "string" },
        protocol: { type: "string" },
        protocolVersion: { type: "string" },
        description: { type: "string" },
        variables: "ServerVariablesMap",
        security: "SecurityRequirementList",
        bindings: "ServerBindings",
        tags: "TagList"
      },
      required: ["url", "protocol"]
    };
    var ServerMap = {
      properties: {},
      additionalProperties: (_value, key) => key.match(/^[A-Za-z0-9_\-]+$/) ? "Server" : void 0
    };
    var ServerVariable = {
      properties: {
        enum: {
          type: "array",
          items: { type: "string" }
        },
        default: { type: "string" },
        description: { type: "string" },
        examples: {
          type: "array",
          items: { type: "string" }
        }
      },
      required: []
    };
    var Info = {
      properties: {
        title: { type: "string" },
        version: { type: "string" },
        description: { type: "string" },
        termsOfService: { type: "string" },
        contact: "Contact",
        license: "License"
      },
      required: ["title", "version"]
    };
    var Contact = {
      properties: {
        name: { type: "string" },
        url: { type: "string" },
        email: { type: "string" }
      }
    };
    var License = {
      properties: {
        name: { type: "string" },
        url: { type: "string" }
      },
      required: ["name"]
    };
    var Parameter = {
      properties: {
        description: { type: "string" },
        schema: "Schema",
        location: { type: "string" }
      }
    };
    var CorrelationId = {
      properties: {
        description: { type: "string" },
        location: { type: "string" }
      },
      required: ["location"]
    };
    var Message = {
      properties: {
        messageId: { type: "string" },
        headers: "Schema",
        payload: "Schema",
        correlationId: "CorrelationId",
        schemaFormat: { type: "string" },
        contentType: { type: "string" },
        name: { type: "string" },
        title: { type: "string" },
        summary: { type: "string" },
        description: { type: "string" },
        tags: "TagList",
        externalDocs: "ExternalDocs",
        bindings: "MessageBindings",
        // examples: 'MessageExampleList', // TODO: add support for message examples
        traits: "MessageTraitList"
      },
      additionalProperties: {}
    };
    var MessageBindings = {
      properties: {},
      allowed() {
        return [
          "http",
          "ws",
          "kafka",
          "anypointmq",
          "amqp",
          "amqp1",
          "mqtt",
          "mqtt5",
          "nats",
          "jms",
          "sns",
          "solace",
          "sqs",
          "stomp",
          "redis",
          "mercure",
          "ibmmq",
          "googlepubsub",
          "pulsar"
        ];
      },
      additionalProperties: { type: "object" }
    };
    var OperationBindings = {
      properties: {},
      allowed() {
        return [
          "http",
          "ws",
          "kafka",
          "anypointmq",
          "amqp",
          "amqp1",
          "mqtt",
          "mqtt5",
          "nats",
          "jms",
          "sns",
          "solace",
          "sqs",
          "stomp",
          "redis",
          "mercure",
          "ibmmq",
          "googlepubsub",
          "pulsar"
        ];
      },
      additionalProperties: { type: "object" }
    };
    var OperationTrait = {
      properties: {
        tags: {
          type: "array",
          items: { type: "string" }
        },
        summary: { type: "string" },
        description: { type: "string" },
        externalDocs: "ExternalDocs",
        operationId: { type: "string" },
        security: "SecurityRequirementList",
        bindings: "OperationBindings"
      },
      required: []
    };
    var MessageTrait = {
      properties: {
        messageId: { type: "string" },
        headers: "Schema",
        correlationId: "CorrelationId",
        schemaFormat: { type: "string" },
        contentType: { type: "string" },
        name: { type: "string" },
        title: { type: "string" },
        summary: { type: "string" },
        description: { type: "string" },
        tags: "TagList",
        externalDocs: "ExternalDocs",
        bindings: "MessageBindings"
        // examples: 'MessageExampleList', // TODO: support examples for message traits
      },
      additionalProperties: {}
    };
    var Operation = {
      properties: {
        tags: {
          type: "array",
          items: { type: "string" }
        },
        summary: { type: "string" },
        description: { type: "string" },
        externalDocs: "ExternalDocs",
        operationId: { type: "string" },
        security: "SecurityRequirementList",
        bindings: "OperationBindings",
        traits: "OperationTraitList",
        message: "Message"
      },
      required: []
    };
    var MessageExample = {
      properties: {
        payload: { isExample: true },
        summary: { type: "string" },
        name: { type: "string" },
        headers: { type: "object" }
      }
    };
    var Schema3 = {
      properties: {
        $id: { type: "string" },
        id: { type: "string" },
        $schema: { type: "string" },
        definitions: "NamedSchemas",
        $defs: "NamedSchemas",
        $vocabulary: { type: "string" },
        externalDocs: "ExternalDocs",
        discriminator: "Discriminator",
        myArbitraryKeyword: { type: "boolean" },
        title: { type: "string" },
        multipleOf: { type: "number", minimum: 0 },
        maximum: { type: "number" },
        minimum: { type: "number" },
        exclusiveMaximum: { type: "number" },
        exclusiveMinimum: { type: "number" },
        maxLength: { type: "integer", minimum: 0 },
        minLength: { type: "integer", minimum: 0 },
        pattern: { type: "string" },
        maxItems: { type: "integer", minimum: 0 },
        minItems: { type: "integer", minimum: 0 },
        uniqueItems: { type: "boolean" },
        maxProperties: { type: "integer", minimum: 0 },
        minProperties: { type: "integer", minimum: 0 },
        required: { type: "array", items: { type: "string" } },
        enum: { type: "array" },
        type: (value) => {
          if (Array.isArray(value)) {
            return {
              type: "array",
              items: { enum: ["object", "array", "string", "number", "integer", "boolean", "null"] }
            };
          } else {
            return {
              enum: ["object", "array", "string", "number", "integer", "boolean", "null"]
            };
          }
        },
        allOf: (0, _1.listOf)("Schema"),
        anyOf: (0, _1.listOf)("Schema"),
        oneOf: (0, _1.listOf)("Schema"),
        not: "Schema",
        if: "Schema",
        then: "Schema",
        else: "Schema",
        dependentSchemas: (0, _1.listOf)("Schema"),
        prefixItems: (0, _1.listOf)("Schema"),
        contains: "Schema",
        minContains: { type: "integer", minimum: 0 },
        maxContains: { type: "integer", minimum: 0 },
        patternProperties: { type: "object" },
        propertyNames: "Schema",
        unevaluatedItems: (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return "Schema";
          }
        },
        unevaluatedProperties: (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return "Schema";
          }
        },
        summary: { type: "string" },
        properties: "SchemaProperties",
        items: (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return "Schema";
          }
        },
        additionalProperties: (value) => {
          return typeof value === "boolean" ? { type: "boolean" } : "Schema";
        },
        description: { type: "string" },
        format: { type: "string" },
        contentEncoding: { type: "string" },
        contentMediaType: { type: "string" },
        default: null,
        readOnly: { type: "boolean" },
        writeOnly: { type: "boolean" },
        // xml: 'Xml',
        examples: { type: "array" },
        example: { isExample: true },
        deprecated: { type: "boolean" },
        const: null,
        $comment: { type: "string" },
        dependencies: { type: "object" }
        // TODO
      }
    };
    var SchemaProperties = {
      properties: {},
      additionalProperties: (value) => {
        if (typeof value === "boolean") {
          return { type: "boolean" };
        }
        return "Schema";
      }
    };
    var DiscriminatorMapping = {
      properties: {},
      additionalProperties: (value) => {
        if ((0, ref_utils_1.isMappingRef)(value)) {
          return { type: "string", directResolveAs: "Schema" };
        } else {
          return { type: "string" };
        }
      }
    };
    var Discriminator = {
      properties: {
        propertyName: { type: "string" },
        mapping: "DiscriminatorMapping"
      },
      required: ["propertyName"]
    };
    var Components = {
      properties: {
        messages: "NamedMessages",
        parameters: "NamedParameters",
        schemas: "NamedSchemas",
        correlationIds: "NamedCorrelationIds",
        messageTraits: "NamedMessageTraits",
        operationTraits: "NamedOperationTraits",
        streamHeaders: "NamedStreamHeaders",
        securitySchemes: "NamedSecuritySchemes",
        servers: "ServerMap",
        serverVariables: "ServerVariablesMap",
        channels: "ChannelMap",
        serverBindings: "ServerBindings",
        channelBindings: "ChannelBindings",
        operationBindings: "OperationBindings",
        messageBindings: "MessageBindings"
      }
    };
    var ImplicitFlow = {
      properties: {
        refreshUrl: { type: "string" },
        scopes: { type: "object", additionalProperties: { type: "string" } },
        authorizationUrl: { type: "string" }
      },
      required: ["authorizationUrl", "scopes"]
    };
    var PasswordFlow = {
      properties: {
        refreshUrl: { type: "string" },
        scopes: { type: "object", additionalProperties: { type: "string" } },
        tokenUrl: { type: "string" }
      },
      required: ["tokenUrl", "scopes"]
    };
    var ClientCredentials = {
      properties: {
        refreshUrl: { type: "string" },
        scopes: { type: "object", additionalProperties: { type: "string" } },
        tokenUrl: { type: "string" }
      },
      required: ["tokenUrl", "scopes"]
    };
    var AuthorizationCode = {
      properties: {
        refreshUrl: { type: "string" },
        authorizationUrl: { type: "string" },
        scopes: { type: "object", additionalProperties: { type: "string" } },
        tokenUrl: { type: "string" }
      },
      required: ["authorizationUrl", "tokenUrl", "scopes"]
    };
    var SecuritySchemeFlows = {
      properties: {
        implicit: "ImplicitFlow",
        password: "PasswordFlow",
        clientCredentials: "ClientCredentials",
        authorizationCode: "AuthorizationCode"
      }
    };
    var SecurityScheme2 = {
      properties: {
        type: {
          enum: [
            "userPassword",
            "apiKey",
            "X509",
            "symmetricEncryption",
            "asymmetricEncryption",
            "httpApiKey",
            "http",
            "oauth2",
            "openIdConnect",
            "plain",
            "scramSha256",
            "scramSha512",
            "gssapi"
          ]
        },
        description: { type: "string" },
        name: { type: "string" },
        in: { type: "string", enum: ["query", "header", "cookie", "user", "password"] },
        scheme: { type: "string" },
        bearerFormat: { type: "string" },
        flows: "SecuritySchemeFlows",
        openIdConnectUrl: { type: "string" }
      },
      required(value) {
        switch (value === null || value === void 0 ? void 0 : value.type) {
          case "apiKey":
            return ["type", "in"];
          case "httpApiKey":
            return ["type", "name", "in"];
          case "http":
            return ["type", "scheme"];
          case "oauth2":
            return ["type", "flows"];
          case "openIdConnect":
            return ["type", "openIdConnectUrl"];
          default:
            return ["type"];
        }
      },
      allowed(value) {
        switch (value === null || value === void 0 ? void 0 : value.type) {
          case "apiKey":
            return ["type", "in", "description"];
          case "httpApiKey":
            return ["type", "name", "in", "description"];
          case "http":
            return ["type", "scheme", "bearerFormat", "description"];
          case "oauth2":
            return ["type", "flows", "description"];
          case "openIdConnect":
            return ["type", "openIdConnectUrl", "description"];
          default:
            return ["type", "description"];
        }
      },
      extensionsPrefix: "x-"
    };
    var HttpChannelBinding = {
      properties: {}
      // empty object
    };
    ChannelBindings.properties.http = HttpChannelBinding;
    var HttpServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.http = HttpServerBinding;
    var HttpMessageBinding = {
      properties: {
        headers: "Schema",
        bindingVersion: { type: "string" }
      }
    };
    MessageBindings.properties.http = HttpMessageBinding;
    var HttpOperationBinding = {
      properties: {
        type: { type: "string" },
        method: {
          type: "string",
          enum: ["GET", "POST", "PUT", "PATCH", "DELETE", "HEAD", "OPTIONS", "CONNECT", "TRACE"]
        },
        headers: "Schema",
        bindingVersion: { type: "string" }
      }
    };
    OperationBindings.properties.http = HttpOperationBinding;
    var WsChannelBinding = {
      properties: {
        method: { type: "string" },
        query: "Schema",
        headers: "Schema",
        bindingVersion: { type: "string" }
      }
    };
    ChannelBindings.properties.ws = WsChannelBinding;
    var WsServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.ws = WsServerBinding;
    var WsMessageBinding = {
      properties: {}
      // empty object
    };
    MessageBindings.properties.ws = WsMessageBinding;
    var WsOperationBinding = {
      properties: {}
      // empty object
    };
    OperationBindings.properties.ws = WsOperationBinding;
    var KafkaTopicConfiguration = {
      properties: {
        "cleanup.policy": { type: "array", items: { enum: ["delete", "compact"] } },
        "retention.ms": { type: "integer" },
        "retention.bytes": { type: "integer" },
        "delete.retention.ms": { type: "integer" },
        "max.message.bytes": { type: "integer" }
      }
    };
    var KafkaChannelBinding = {
      properties: {
        topic: { type: "string" },
        partitions: { type: "integer" },
        replicas: { type: "integer" },
        topicConfiguration: "KafkaTopicConfiguration",
        bindingVersion: { type: "string" }
      }
    };
    ChannelBindings.properties.kafka = KafkaChannelBinding;
    var KafkaServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.kafka = KafkaServerBinding;
    var KafkaMessageBinding = {
      properties: {
        key: "Schema",
        schemaIdLocation: { type: "string" },
        schemaIdPayloadEncoding: { type: "string" },
        schemaLookupStrategy: { type: "string" },
        bindingVersion: { type: "string" }
      }
    };
    MessageBindings.properties.kafka = KafkaMessageBinding;
    var KafkaOperationBinding = {
      properties: {
        groupId: "Schema",
        clientId: "Schema",
        bindingVersion: { type: "string" }
      }
    };
    OperationBindings.properties.kafka = KafkaOperationBinding;
    var AnypointmqChannelBinding = {
      properties: {
        destination: { type: "string" },
        destinationType: { type: "string" },
        bindingVersion: { type: "string" }
      }
    };
    ChannelBindings.properties.anypointmq = AnypointmqChannelBinding;
    var AnypointmqServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.anypointmq = AnypointmqServerBinding;
    var AnypointmqMessageBinding = {
      properties: {
        headers: "Schema",
        bindingVersion: { type: "string" }
      }
    };
    MessageBindings.properties.anypointmq = AnypointmqMessageBinding;
    var AnypointmqOperationBinding = {
      properties: {}
      // empty object
    };
    OperationBindings.properties.anypointmq = AnypointmqOperationBinding;
    var AmqpChannelBinding = {
      properties: {}
      // empty object
    };
    ChannelBindings.properties.amqp = AmqpChannelBinding;
    var AmqpServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.amqp = AmqpServerBinding;
    var AmqpMessageBinding = {
      properties: {
        contentEncoding: { type: "string" },
        messageType: { type: "string" },
        bindingVersion: { type: "string" }
      }
    };
    MessageBindings.properties.amqp = AmqpMessageBinding;
    var AmqpOperationBinding = {
      // TODO: some fields are subscribe only
      properties: {
        expiration: { type: "integer" },
        userId: { type: "string" },
        cc: { type: "array", items: { type: "string" } },
        priority: { type: "integer" },
        deliveryMode: { type: "integer" },
        mandatory: { type: "boolean" },
        bcc: { type: "array", items: { type: "string" } },
        replyTo: { type: "string" },
        timestamp: { type: "boolean" },
        ack: { type: "boolean" },
        bindingVersion: { type: "string" }
      }
    };
    OperationBindings.properties.amqp = AmqpOperationBinding;
    var Amqp1ChannelBinding = {
      properties: {}
      // empty object
    };
    ChannelBindings.properties.amqp1 = Amqp1ChannelBinding;
    var Amqp1ServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.amqp1 = Amqp1ServerBinding;
    var Amqp1MessageBinding = {
      properties: {}
      // empty object
    };
    MessageBindings.properties.amqp1 = Amqp1MessageBinding;
    var Amqp1OperationBinding = {
      properties: {}
      // empty object
    };
    OperationBindings.properties.amqp1 = Amqp1OperationBinding;
    var MqttChannelBinding = {
      properties: {
        qos: { type: "integer" },
        retain: { type: "boolean" },
        bindingVersion: { type: "string" }
      }
    };
    ChannelBindings.properties.mqtt = MqttChannelBinding;
    var MqttServerBindingLastWill = {
      properties: {
        topic: { type: "string" },
        qos: { type: "integer" },
        message: { type: "string" },
        retain: { type: "boolean" }
      }
    };
    var MqttServerBinding = {
      properties: {
        clientId: { type: "string" },
        cleanSession: { type: "boolean" },
        lastWill: "MqttServerBindingLastWill",
        keepAlive: { type: "integer" },
        bindingVersion: { type: "string" }
      }
    };
    ServerBindings.properties.mqtt = MqttServerBinding;
    var MqttMessageBinding = {
      properties: {
        bindingVersion: { type: "string" }
      }
    };
    MessageBindings.properties.mqtt = MqttMessageBinding;
    var MqttOperationBinding = {
      properties: {
        qos: { type: "integer" },
        retain: { type: "boolean" },
        bindingVersion: { type: "string" }
      }
    };
    OperationBindings.properties.mqtt = MqttOperationBinding;
    var Mqtt5ChannelBinding = {
      properties: {}
      // empty object
    };
    ChannelBindings.properties.mqtt5 = Mqtt5ChannelBinding;
    var Mqtt5ServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.mqtt5 = Mqtt5ServerBinding;
    var Mqtt5MessageBinding = {
      properties: {}
      // empty object
    };
    MessageBindings.properties.mqtt5 = Mqtt5MessageBinding;
    var Mqtt5OperationBinding = {
      properties: {}
      // empty object
    };
    OperationBindings.properties.mqtt5 = Mqtt5OperationBinding;
    var NatsChannelBinding = {
      properties: {}
      // empty object
    };
    ChannelBindings.properties.nats = NatsChannelBinding;
    var NatsServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.nats = NatsServerBinding;
    var NatsMessageBinding = {
      properties: {}
      // empty object
    };
    MessageBindings.properties.nats = NatsMessageBinding;
    var NatsOperationBinding = {
      properties: {
        queue: { type: "string" },
        bindingVersion: { type: "string" }
      }
    };
    OperationBindings.properties.nats = NatsOperationBinding;
    var JmsChannelBinding = {
      properties: {
        destination: { type: "string" },
        destinationType: { type: "string" },
        bindingVersion: { type: "string" }
      }
    };
    ChannelBindings.properties.jms = JmsChannelBinding;
    var JmsServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.jms = JmsServerBinding;
    var JmsMessageBinding = {
      properties: {
        headers: "Schema",
        bindingVersion: { type: "string" }
      }
    };
    MessageBindings.properties.jms = JmsMessageBinding;
    var JmsOperationBinding = {
      properties: {
        headers: "Schema",
        bindingVersion: { type: "string" }
      }
    };
    OperationBindings.properties.jms = JmsOperationBinding;
    var SolaceChannelBinding = {
      properties: {}
      // empty object
    };
    ChannelBindings.properties.solace = SolaceChannelBinding;
    var SolaceServerBinding = {
      properties: {
        bindingVersion: { type: "string" },
        msgVpn: { type: "string" }
      }
    };
    ServerBindings.properties.solace = SolaceServerBinding;
    var SolaceMessageBinding = {
      properties: {}
      // empty object
    };
    MessageBindings.properties.solace = SolaceMessageBinding;
    var SolaceDestination = {
      properties: {
        destinationType: { type: "string", enum: ["queue", "topic"] },
        deliveryMode: { type: "string", enum: ["direct", "persistent"] },
        "queue.name": { type: "string" },
        "queue.topicSubscriptions": { type: "array", items: { type: "string" } },
        "queue.accessType": { type: "string", enum: ["exclusive", "nonexclusive"] },
        "queue.maxMsgSpoolSize": { type: "string" },
        "queue.maxTtl": { type: "string" },
        "topic.topicSubscriptions": { type: "array", items: { type: "string" } }
      }
    };
    var SolaceOperationBinding = {
      properties: {
        bindingVersion: { type: "string" },
        destinations: (0, _1.listOf)("SolaceDestination")
      }
    };
    OperationBindings.properties.solace = SolaceOperationBinding;
    var StompChannelBinding = {
      properties: {}
      // empty object
    };
    ChannelBindings.properties.stomp = StompChannelBinding;
    var StompServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.stomp = StompServerBinding;
    var StompMessageBinding = {
      properties: {}
      // empty object
    };
    MessageBindings.properties.stomp = StompMessageBinding;
    var StompOperationBinding = {
      properties: {}
      // empty object
    };
    OperationBindings.properties.stomp = StompOperationBinding;
    var RedisChannelBinding = {
      properties: {}
      // empty object
    };
    ChannelBindings.properties.redis = RedisChannelBinding;
    var RedisServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.redis = RedisServerBinding;
    var RedisMessageBinding = {
      properties: {}
      // empty object
    };
    MessageBindings.properties.redis = RedisMessageBinding;
    var RedisOperationBinding = {
      properties: {}
      // empty object
    };
    OperationBindings.properties.redis = RedisOperationBinding;
    var MercureChannelBinding = {
      properties: {}
      // empty object
    };
    ChannelBindings.properties.mercure = MercureChannelBinding;
    var MercureServerBinding = {
      properties: {}
      // empty object
    };
    ServerBindings.properties.mercure = MercureServerBinding;
    var MercureMessageBinding = {
      properties: {}
      // empty object
    };
    MessageBindings.properties.mercure = MercureMessageBinding;
    var MercureOperationBinding = {
      properties: {}
      // empty object
    };
    OperationBindings.properties.mercure = MercureOperationBinding;
    exports2.AsyncApi2Types = {
      Root,
      Tag,
      TagList: (0, _1.listOf)("Tag"),
      ServerMap,
      ExternalDocs,
      Server,
      ServerVariable,
      ServerVariablesMap: (0, _1.mapOf)("ServerVariable"),
      SecurityRequirement,
      SecurityRequirementList: (0, _1.listOf)("SecurityRequirement"),
      Info,
      Contact,
      License,
      HttpServerBinding,
      HttpChannelBinding,
      HttpMessageBinding,
      HttpOperationBinding,
      WsServerBinding,
      WsChannelBinding,
      WsMessageBinding,
      WsOperationBinding,
      KafkaServerBinding,
      KafkaTopicConfiguration,
      KafkaChannelBinding,
      KafkaMessageBinding,
      KafkaOperationBinding,
      AnypointmqServerBinding,
      AnypointmqChannelBinding,
      AnypointmqMessageBinding,
      AnypointmqOperationBinding,
      AmqpServerBinding,
      AmqpChannelBinding,
      AmqpMessageBinding,
      AmqpOperationBinding,
      Amqp1ServerBinding,
      Amqp1ChannelBinding,
      Amqp1MessageBinding,
      Amqp1OperationBinding,
      MqttServerBindingLastWill,
      MqttServerBinding,
      MqttChannelBinding,
      MqttMessageBinding,
      MqttOperationBinding,
      Mqtt5ServerBinding,
      Mqtt5ChannelBinding,
      Mqtt5MessageBinding,
      Mqtt5OperationBinding,
      NatsServerBinding,
      NatsChannelBinding,
      NatsMessageBinding,
      NatsOperationBinding,
      JmsServerBinding,
      JmsChannelBinding,
      JmsMessageBinding,
      JmsOperationBinding,
      SolaceServerBinding,
      SolaceChannelBinding,
      SolaceMessageBinding,
      SolaceDestination,
      SolaceOperationBinding,
      StompServerBinding,
      StompChannelBinding,
      StompMessageBinding,
      StompOperationBinding,
      RedisServerBinding,
      RedisChannelBinding,
      RedisMessageBinding,
      RedisOperationBinding,
      MercureServerBinding,
      MercureChannelBinding,
      MercureMessageBinding,
      MercureOperationBinding,
      ServerBindings,
      ChannelBindings,
      ChannelMap,
      Channel,
      Parameter,
      ParametersMap: (0, _1.mapOf)("Parameter"),
      Operation,
      Schema: Schema3,
      MessageExample,
      SchemaProperties,
      DiscriminatorMapping,
      Discriminator,
      Components,
      NamedSchemas: (0, _1.mapOf)("Schema"),
      NamedMessages: (0, _1.mapOf)("Message"),
      NamedMessageTraits: (0, _1.mapOf)("MessageTrait"),
      NamedOperationTraits: (0, _1.mapOf)("OperationTrait"),
      NamedParameters: (0, _1.mapOf)("Parameter"),
      NamedSecuritySchemes: (0, _1.mapOf)("SecurityScheme"),
      NamedCorrelationIds: (0, _1.mapOf)("CorrelationId"),
      NamedStreamHeaders: (0, _1.mapOf)("StreamHeader"),
      ImplicitFlow,
      PasswordFlow,
      ClientCredentials,
      AuthorizationCode,
      SecuritySchemeFlows,
      SecurityScheme: SecurityScheme2,
      Message,
      MessageBindings,
      OperationBindings,
      OperationTrait,
      OperationTraitList: (0, _1.listOf)("OperationTrait"),
      MessageTrait,
      MessageTraitList: (0, _1.listOf)("MessageTrait"),
      CorrelationId
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/oas-types.js
var require_oas_types = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/oas-types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getTypes = exports2.getMajorSpecVersion = exports2.detectSpec = exports2.SpecMajorVersion = exports2.SpecVersion = void 0;
    var oas2_1 = require_oas2();
    var oas3_1 = require_oas3();
    var oas3_1_1 = require_oas3_1();
    var asyncapi_1 = require_asyncapi();
    var SpecVersion;
    (function (SpecVersion2) {
      SpecVersion2["OAS2"] = "oas2";
      SpecVersion2["OAS3_0"] = "oas3_0";
      SpecVersion2["OAS3_1"] = "oas3_1";
      SpecVersion2["Async2"] = "async2";
    })(SpecVersion || (exports2.SpecVersion = SpecVersion = {}));
    var SpecMajorVersion;
    (function (SpecMajorVersion2) {
      SpecMajorVersion2["OAS2"] = "oas2";
      SpecMajorVersion2["OAS3"] = "oas3";
      SpecMajorVersion2["Async2"] = "async2";
    })(SpecMajorVersion || (exports2.SpecMajorVersion = SpecMajorVersion = {}));
    var typesMap = {
      [SpecVersion.OAS2]: oas2_1.Oas2Types,
      [SpecVersion.OAS3_0]: oas3_1.Oas3Types,
      [SpecVersion.OAS3_1]: oas3_1_1.Oas3_1Types,
      [SpecVersion.Async2]: asyncapi_1.AsyncApi2Types
    };
    function detectSpec(root2) {
      if (typeof root2 !== "object") {
        throw new Error(`Document must be JSON object, got ${typeof root2}`);
      }
      if (root2.openapi && typeof root2.openapi !== "string") {
        throw new Error(`Invalid OpenAPI version: should be a string but got "${typeof root2.openapi}"`);
      }
      if (root2.openapi && root2.openapi.startsWith("3.0")) {
        return SpecVersion.OAS3_0;
      }
      if (root2.openapi && root2.openapi.startsWith("3.1")) {
        return SpecVersion.OAS3_1;
      }
      if (root2.swagger && root2.swagger === "2.0") {
        return SpecVersion.OAS2;
      }
      if (root2.openapi || root2.swagger) {
        throw new Error(`Unsupported OpenAPI version: ${root2.openapi || root2.swagger}`);
      }
      if (root2.asyncapi && root2.asyncapi.startsWith("2.")) {
        return SpecVersion.Async2;
      }
      if (root2.asyncapi) {
        throw new Error(`Unsupported AsyncAPI version: ${root2.asyncapi}`);
      }
      throw new Error(`Unsupported specification`);
    }
    exports2.detectSpec = detectSpec;
    function getMajorSpecVersion(version) {
      if (version === SpecVersion.OAS2) {
        return SpecMajorVersion.OAS2;
      } else if (version === SpecVersion.Async2) {
        return SpecMajorVersion.Async2;
      } else {
        return SpecMajorVersion.OAS3;
      }
    }
    exports2.getMajorSpecVersion = getMajorSpecVersion;
    function getTypes(spec) {
      return typesMap[spec];
    }
    exports2.getTypes = getTypes;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/utils.js
var require_utils4 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/utils.js"(exports2) {
    "use strict";
    var __rest = exports2 && exports2.__rest || function (s, e) {
      var t = {};
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
      if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
          if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
            t[p[i]] = s[p[i]];
        }
      return t;
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ConfigValidationError = exports2.getUniquePlugins = exports2.getResolveConfig = exports2.transformConfig = exports2.checkForDeprecatedFields = exports2.getMergedConfig = exports2.mergeExtends = exports2.prefixRules = exports2.transformApiDefinitionsToApis = exports2.parsePresetName = void 0;
    var utils_1 = require_utils3();
    var config_1 = require_config();
    var logger_1 = require_logger();
    function parsePresetName(presetName) {
      if (presetName.indexOf("/") > -1) {
        const [pluginId, configName] = presetName.split("/");
        return { pluginId, configName };
      } else {
        return { pluginId: "", configName: presetName };
      }
    }
    exports2.parsePresetName = parsePresetName;
    function transformApiDefinitionsToApis(apiDefinitions) {
      if (!apiDefinitions)
        return void 0;
      const apis = {};
      for (const [apiName, apiPath] of Object.entries(apiDefinitions)) {
        apis[apiName] = { root: apiPath };
      }
      return apis;
    }
    exports2.transformApiDefinitionsToApis = transformApiDefinitionsToApis;
    function extractFlatConfig(_a) {
      var _b;
      var { plugins, extends: _extends, rules, oas2Rules, oas3_0Rules, oas3_1Rules, async2Rules, preprocessors, oas2Preprocessors, oas3_0Preprocessors, oas3_1Preprocessors, async2Preprocessors, decorators, oas2Decorators, oas3_0Decorators, oas3_1Decorators, async2Decorators } = _a, rawConfigRest = __rest(_a, ["plugins", "extends", "rules", "oas2Rules", "oas3_0Rules", "oas3_1Rules", "async2Rules", "preprocessors", "oas2Preprocessors", "oas3_0Preprocessors", "oas3_1Preprocessors", "async2Preprocessors", "decorators", "oas2Decorators", "oas3_0Decorators", "oas3_1Decorators", "async2Decorators"]);
      const styleguideConfig = {
        plugins,
        extends: _extends,
        rules,
        oas2Rules,
        oas3_0Rules,
        oas3_1Rules,
        async2Rules,
        preprocessors,
        oas2Preprocessors,
        oas3_0Preprocessors,
        oas3_1Preprocessors,
        async2Preprocessors,
        decorators,
        oas2Decorators,
        oas3_0Decorators,
        oas3_1Decorators,
        async2Decorators,
        doNotResolveExamples: (_b = rawConfigRest.resolve) === null || _b === void 0 ? void 0 : _b.doNotResolveExamples
      };
      if (rawConfigRest.lint && rawConfigRest.styleguide || Object.values(styleguideConfig).some(utils_1.isDefined) && (rawConfigRest.lint || rawConfigRest.styleguide)) {
        throw new Error(`Do not use 'lint', 'styleguide' and flat syntax together. 
See more about the configuration in the docs: https://redocly.com/docs/cli/configuration/ 
`);
      }
      return {
        styleguideConfig: Object.values(styleguideConfig).some(utils_1.isDefined) ? styleguideConfig : void 0,
        rawConfigRest
      };
    }
    function transformApis(legacyApis) {
      if (!legacyApis)
        return void 0;
      const apis = {};
      for (let _a of Object.entries(legacyApis)) {
        const [apiName, _b] = _a, { lint } = _b, apiContent = __rest(_b, ["lint"]);
        const { styleguideConfig, rawConfigRest } = extractFlatConfig(apiContent);
        apis[apiName] = Object.assign({ styleguide: styleguideConfig || lint }, rawConfigRest);
      }
      return apis;
    }
    function prefixRules(rules, prefix) {
      if (!prefix)
        return rules;
      const res = {};
      for (const name of Object.keys(rules)) {
        res[`${prefix}/${name}`] = rules[name];
      }
      return res;
    }
    exports2.prefixRules = prefixRules;
    function mergeExtends(rulesConfList) {
      const result = {
        rules: {},
        oas2Rules: {},
        oas3_0Rules: {},
        oas3_1Rules: {},
        async2Rules: {},
        preprocessors: {},
        oas2Preprocessors: {},
        oas3_0Preprocessors: {},
        oas3_1Preprocessors: {},
        async2Preprocessors: {},
        decorators: {},
        oas2Decorators: {},
        oas3_0Decorators: {},
        oas3_1Decorators: {},
        async2Decorators: {},
        plugins: [],
        pluginPaths: [],
        extendPaths: []
      };
      for (const rulesConf of rulesConfList) {
        if (rulesConf.extends) {
          throw new Error(`'extends' is not supported in shared configs yet: ${JSON.stringify(rulesConf, null, 2)}.`);
        }
        Object.assign(result.rules, rulesConf.rules);
        Object.assign(result.oas2Rules, rulesConf.oas2Rules);
        (0, utils_1.assignExisting)(result.oas2Rules, rulesConf.rules || {});
        Object.assign(result.oas3_0Rules, rulesConf.oas3_0Rules);
        (0, utils_1.assignExisting)(result.oas3_0Rules, rulesConf.rules || {});
        Object.assign(result.oas3_1Rules, rulesConf.oas3_1Rules);
        (0, utils_1.assignExisting)(result.oas3_1Rules, rulesConf.rules || {});
        Object.assign(result.async2Rules, rulesConf.async2Rules);
        (0, utils_1.assignExisting)(result.async2Rules, rulesConf.rules || {});
        Object.assign(result.preprocessors, rulesConf.preprocessors);
        Object.assign(result.oas2Preprocessors, rulesConf.oas2Preprocessors);
        (0, utils_1.assignExisting)(result.oas2Preprocessors, rulesConf.preprocessors || {});
        Object.assign(result.oas3_0Preprocessors, rulesConf.oas3_0Preprocessors);
        (0, utils_1.assignExisting)(result.oas3_0Preprocessors, rulesConf.preprocessors || {});
        Object.assign(result.oas3_1Preprocessors, rulesConf.oas3_1Preprocessors);
        (0, utils_1.assignExisting)(result.oas3_1Preprocessors, rulesConf.preprocessors || {});
        Object.assign(result.async2Preprocessors, rulesConf.async2Preprocessors);
        (0, utils_1.assignExisting)(result.async2Preprocessors, rulesConf.preprocessors || {});
        Object.assign(result.decorators, rulesConf.decorators);
        Object.assign(result.oas2Decorators, rulesConf.oas2Decorators);
        (0, utils_1.assignExisting)(result.oas2Decorators, rulesConf.decorators || {});
        Object.assign(result.oas3_0Decorators, rulesConf.oas3_0Decorators);
        (0, utils_1.assignExisting)(result.oas3_0Decorators, rulesConf.decorators || {});
        Object.assign(result.oas3_1Decorators, rulesConf.oas3_1Decorators);
        (0, utils_1.assignExisting)(result.oas3_1Decorators, rulesConf.decorators || {});
        Object.assign(result.async2Decorators, rulesConf.async2Decorators);
        (0, utils_1.assignExisting)(result.async2Decorators, rulesConf.decorators || {});
        result.plugins.push(...rulesConf.plugins || []);
        result.pluginPaths.push(...rulesConf.pluginPaths || []);
        result.extendPaths.push(...new Set(rulesConf.extendPaths));
      }
      return result;
    }
    exports2.mergeExtends = mergeExtends;
    function getMergedConfig(config, apiName) {
      var _a, _b, _c, _d, _e, _f, _g, _h;
      const extendPaths = [
        ...Object.values(config.apis).map((api) => {
          var _a2;
          return (_a2 = api === null || api === void 0 ? void 0 : api.styleguide) === null || _a2 === void 0 ? void 0 : _a2.extendPaths;
        }),
        (_b = (_a = config.rawConfig) === null || _a === void 0 ? void 0 : _a.styleguide) === null || _b === void 0 ? void 0 : _b.extendPaths
      ].flat().filter(utils_1.isTruthy);
      const pluginPaths = [
        ...Object.values(config.apis).map((api) => {
          var _a2;
          return (_a2 = api === null || api === void 0 ? void 0 : api.styleguide) === null || _a2 === void 0 ? void 0 : _a2.pluginPaths;
        }),
        (_d = (_c = config.rawConfig) === null || _c === void 0 ? void 0 : _c.styleguide) === null || _d === void 0 ? void 0 : _d.pluginPaths
      ].flat().filter(utils_1.isTruthy);
      return apiName ? new config_1.Config(Object.assign(Object.assign({}, config.rawConfig), {
        styleguide: Object.assign(Object.assign({}, config.apis[apiName] ? config.apis[apiName].styleguide : config.rawConfig.styleguide), {
          extendPaths,
          pluginPaths
        }), theme: Object.assign(Object.assign({}, config.rawConfig.theme), (_e = config.apis[apiName]) === null || _e === void 0 ? void 0 : _e.theme), files: [...config.files, ...(_h = (_g = (_f = config.apis) === null || _f === void 0 ? void 0 : _f[apiName]) === null || _g === void 0 ? void 0 : _g.files) !== null && _h !== void 0 ? _h : []]
      }), config.configFile) : config;
    }
    exports2.getMergedConfig = getMergedConfig;
    function checkForDeprecatedFields(deprecatedField, updatedField, rawConfig, updatedObject) {
      const isDeprecatedFieldInApis = rawConfig.apis && Object.values(rawConfig.apis).some((api) => api[deprecatedField]);
      if (rawConfig[deprecatedField] && updatedField === null) {
        (0, utils_1.showWarningForDeprecatedField)(deprecatedField);
      }
      if (rawConfig[deprecatedField] && updatedField && rawConfig[updatedField]) {
        (0, utils_1.showErrorForDeprecatedField)(deprecatedField, updatedField);
      }
      if (rawConfig[deprecatedField] && updatedObject && rawConfig[updatedObject]) {
        (0, utils_1.showErrorForDeprecatedField)(deprecatedField, updatedField, updatedObject);
      }
      if (rawConfig[deprecatedField] || isDeprecatedFieldInApis) {
        (0, utils_1.showWarningForDeprecatedField)(deprecatedField, updatedField, updatedObject);
      }
    }
    exports2.checkForDeprecatedFields = checkForDeprecatedFields;
    function transformConfig(rawConfig) {
      var _a, _b;
      const migratedFields = [
        ["apiDefinitions", "apis", void 0],
        ["referenceDocs", "openapi", "theme"],
        ["lint", void 0, void 0],
        ["styleguide", void 0, void 0],
        ["features.openapi", "openapi", "theme"]
      ];
      for (const [deprecatedField, updatedField, updatedObject] of migratedFields) {
        checkForDeprecatedFields(deprecatedField, updatedField, rawConfig, updatedObject);
      }
      const { apis, apiDefinitions, referenceDocs, lint } = rawConfig, rest = __rest(rawConfig, ["apis", "apiDefinitions", "referenceDocs", "lint"]);
      const { styleguideConfig, rawConfigRest } = extractFlatConfig(rest);
      const transformedConfig = Object.assign({
        theme: {
          openapi: Object.assign(Object.assign(Object.assign({}, referenceDocs), rawConfig["features.openapi"]), (_a = rawConfig.theme) === null || _a === void 0 ? void 0 : _a.openapi),
          mockServer: Object.assign(Object.assign({}, rawConfig["features.mockServer"]), (_b = rawConfig.theme) === null || _b === void 0 ? void 0 : _b.mockServer)
        }, apis: transformApis(apis) || transformApiDefinitionsToApis(apiDefinitions), styleguide: styleguideConfig || lint
      }, rawConfigRest);
      showDeprecationMessages(transformedConfig);
      return transformedConfig;
    }
    exports2.transformConfig = transformConfig;
    function showDeprecationMessages(config) {
      var _a, _b;
      let allRules = Object.assign({}, (_a = config.styleguide) === null || _a === void 0 ? void 0 : _a.rules);
      for (const api of Object.values(config.apis || {})) {
        allRules = Object.assign(Object.assign({}, allRules), (_b = api === null || api === void 0 ? void 0 : api.styleguide) === null || _b === void 0 ? void 0 : _b.rules);
      }
      for (const ruleKey of Object.keys(allRules)) {
        if (ruleKey.startsWith("assert/")) {
          logger_1.logger.warn(`
The 'assert/' syntax in ${ruleKey} is deprecated. Update your configuration to use 'rule/' instead. Examples and more information: https://redocly.com/docs/cli/rules/configurable-rules/
`);
        }
      }
    }
    function getResolveConfig(resolve) {
      var _a, _b;
      return {
        http: {
          headers: (_b = (_a = resolve === null || resolve === void 0 ? void 0 : resolve.http) === null || _a === void 0 ? void 0 : _a.headers) !== null && _b !== void 0 ? _b : [],
          customFetch: void 0
        }
      };
    }
    exports2.getResolveConfig = getResolveConfig;
    function getUniquePlugins(plugins) {
      const seen = /* @__PURE__ */ new Set();
      const results = [];
      for (const p of plugins) {
        if (!seen.has(p.id)) {
          results.push(p);
          seen.add(p.id);
        } else if (p.id) {
          logger_1.logger.warn(`Duplicate plugin id "${logger_1.colorize.red(p.id)}".
`);
        }
      }
      return results;
    }
    exports2.getUniquePlugins = getUniquePlugins;
    var ConfigValidationError = class extends Error {
    };
    exports2.ConfigValidationError = ConfigValidationError;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/config.js
var require_config = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/config.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Config = exports2.StyleguideConfig = exports2.AVAILABLE_REGIONS = exports2.DOMAINS = exports2.DEFAULT_REGION = exports2.IGNORE_FILE = void 0;
    var fs = require("fs");
    var path5 = require("path");
    var js_yaml_1 = require_js_yaml2();
    var utils_1 = require_utils3();
    var oas_types_1 = require_oas_types();
    var env_1 = require_env();
    var utils_2 = require_utils4();
    var ref_utils_1 = require_ref_utils();
    exports2.IGNORE_FILE = ".redocly.lint-ignore.yaml";
    var IGNORE_BANNER = `# This file instructs Redocly's linter to ignore the rules contained for specific parts of your API.
# See https://redoc.ly/docs/cli/ for more information.
`;
    exports2.DEFAULT_REGION = "us";
    function getDomains() {
      const domains = {
        us: "redocly.com",
        eu: "eu.redocly.com"
      };
      const domain = env_1.env.REDOCLY_DOMAIN;
      if (domain === null || domain === void 0 ? void 0 : domain.endsWith(".redocly.host")) {
        domains[domain.split(".")[0]] = domain;
      }
      if (domain === "redoc.online") {
        domains[domain] = domain;
      }
      return domains;
    }
    function getIgnoreFilePath(configFile) {
      if (configFile) {
        return (0, utils_1.doesYamlFileExist)(configFile) ? path5.join(path5.dirname(configFile), exports2.IGNORE_FILE) : path5.join(configFile, exports2.IGNORE_FILE);
      } else {
        return env_1.isBrowser ? void 0 : path5.join(process.cwd(), exports2.IGNORE_FILE);
      }
    }
    exports2.DOMAINS = getDomains();
    exports2.AVAILABLE_REGIONS = Object.keys(exports2.DOMAINS);
    var StyleguideConfig = class {
      constructor(rawConfig, configFile) {
        this.rawConfig = rawConfig;
        this.configFile = configFile;
        this.ignore = {};
        this._usedRules = /* @__PURE__ */ new Set();
        this._usedVersions = /* @__PURE__ */ new Set();
        this.plugins = rawConfig.plugins || [];
        this.doNotResolveExamples = !!rawConfig.doNotResolveExamples;
        this.recommendedFallback = rawConfig.recommendedFallback || false;
        this.rules = {
          [oas_types_1.SpecVersion.OAS2]: Object.assign(Object.assign({}, rawConfig.rules), rawConfig.oas2Rules),
          [oas_types_1.SpecVersion.OAS3_0]: Object.assign(Object.assign({}, rawConfig.rules), rawConfig.oas3_0Rules),
          [oas_types_1.SpecVersion.OAS3_1]: Object.assign(Object.assign({}, rawConfig.rules), rawConfig.oas3_1Rules),
          [oas_types_1.SpecVersion.Async2]: Object.assign(Object.assign({}, rawConfig.rules), rawConfig.async2Rules)
        };
        this.preprocessors = {
          [oas_types_1.SpecVersion.OAS2]: Object.assign(Object.assign({}, rawConfig.preprocessors), rawConfig.oas2Preprocessors),
          [oas_types_1.SpecVersion.OAS3_0]: Object.assign(Object.assign({}, rawConfig.preprocessors), rawConfig.oas3_0Preprocessors),
          [oas_types_1.SpecVersion.OAS3_1]: Object.assign(Object.assign({}, rawConfig.preprocessors), rawConfig.oas3_1Preprocessors),
          [oas_types_1.SpecVersion.Async2]: Object.assign(Object.assign({}, rawConfig.preprocessors), rawConfig.async2Preprocessors)
        };
        this.decorators = {
          [oas_types_1.SpecVersion.OAS2]: Object.assign(Object.assign({}, rawConfig.decorators), rawConfig.oas2Decorators),
          [oas_types_1.SpecVersion.OAS3_0]: Object.assign(Object.assign({}, rawConfig.decorators), rawConfig.oas3_0Decorators),
          [oas_types_1.SpecVersion.OAS3_1]: Object.assign(Object.assign({}, rawConfig.decorators), rawConfig.oas3_1Decorators),
          [oas_types_1.SpecVersion.Async2]: Object.assign(Object.assign({}, rawConfig.decorators), rawConfig.async2Decorators)
        };
        this.extendPaths = rawConfig.extendPaths || [];
        this.pluginPaths = rawConfig.pluginPaths || [];
        this.resolveIgnore(getIgnoreFilePath(configFile));
      }
      resolveIgnore(ignoreFile) {
        if (!ignoreFile || !(0, utils_1.doesYamlFileExist)(ignoreFile))
          return;
        this.ignore = (0, js_yaml_1.parseYaml)(fs.readFileSync(ignoreFile, "utf-8")) || {};
        for (const fileName of Object.keys(this.ignore)) {
          this.ignore[(0, ref_utils_1.isAbsoluteUrl)(fileName) ? fileName : path5.resolve(path5.dirname(ignoreFile), fileName)] = this.ignore[fileName];
          for (const ruleId of Object.keys(this.ignore[fileName])) {
            this.ignore[fileName][ruleId] = new Set(this.ignore[fileName][ruleId]);
          }
          if (!(0, ref_utils_1.isAbsoluteUrl)(fileName)) {
            delete this.ignore[fileName];
          }
        }
      }
      saveIgnore() {
        const dir = this.configFile ? path5.dirname(this.configFile) : process.cwd();
        const ignoreFile = path5.join(dir, exports2.IGNORE_FILE);
        const mapped = {};
        for (const absFileName of Object.keys(this.ignore)) {
          const mappedDefinitionName = (0, ref_utils_1.isAbsoluteUrl)(absFileName) ? absFileName : (0, utils_1.slash)(path5.relative(dir, absFileName));
          const ignoredRules = mapped[mappedDefinitionName] = this.ignore[absFileName];
          for (const ruleId of Object.keys(ignoredRules)) {
            ignoredRules[ruleId] = Array.from(ignoredRules[ruleId]);
          }
        }
        fs.writeFileSync(ignoreFile, IGNORE_BANNER + (0, js_yaml_1.stringifyYaml)(mapped));
      }
      addIgnore(problem) {
        const ignore = this.ignore;
        const loc = problem.location[0];
        if (loc.pointer === void 0)
          return;
        const fileIgnore = ignore[loc.source.absoluteRef] = ignore[loc.source.absoluteRef] || {};
        const ruleIgnore = fileIgnore[problem.ruleId] = fileIgnore[problem.ruleId] || /* @__PURE__ */ new Set();
        ruleIgnore.add(loc.pointer);
      }
      addProblemToIgnore(problem) {
        const loc = problem.location[0];
        if (loc.pointer === void 0)
          return problem;
        const fileIgnore = this.ignore[loc.source.absoluteRef] || {};
        const ruleIgnore = fileIgnore[problem.ruleId];
        const ignored = ruleIgnore && ruleIgnore.has(loc.pointer);
        return ignored ? Object.assign(Object.assign({}, problem), { ignored }) : problem;
      }
      extendTypes(types2, version) {
        let extendedTypes = types2;
        for (const plugin of this.plugins) {
          if (plugin.typeExtension !== void 0) {
            switch (version) {
              case oas_types_1.SpecVersion.OAS3_0:
              case oas_types_1.SpecVersion.OAS3_1:
                if (!plugin.typeExtension.oas3)
                  continue;
                extendedTypes = plugin.typeExtension.oas3(extendedTypes, version);
                break;
              case oas_types_1.SpecVersion.OAS2:
                if (!plugin.typeExtension.oas2)
                  continue;
                extendedTypes = plugin.typeExtension.oas2(extendedTypes, version);
                break;
              case oas_types_1.SpecVersion.Async2:
                if (!plugin.typeExtension.async2)
                  continue;
                extendedTypes = plugin.typeExtension.async2(extendedTypes, version);
                break;
              default:
                throw new Error("Not implemented");
            }
          }
        }
        return extendedTypes;
      }
      getRuleSettings(ruleId, oasVersion) {
        this._usedRules.add(ruleId);
        this._usedVersions.add(oasVersion);
        const settings = this.rules[oasVersion][ruleId] || "off";
        if (typeof settings === "string") {
          return {
            severity: settings
          };
        } else {
          return Object.assign({ severity: "error" }, settings);
        }
      }
      getPreprocessorSettings(ruleId, oasVersion) {
        this._usedRules.add(ruleId);
        this._usedVersions.add(oasVersion);
        const settings = this.preprocessors[oasVersion][ruleId] || "off";
        if (typeof settings === "string") {
          return {
            severity: settings === "on" ? "error" : settings
          };
        } else {
          return Object.assign({ severity: "error" }, settings);
        }
      }
      getDecoratorSettings(ruleId, oasVersion) {
        this._usedRules.add(ruleId);
        this._usedVersions.add(oasVersion);
        const settings = this.decorators[oasVersion][ruleId] || "off";
        if (typeof settings === "string") {
          return {
            severity: settings === "on" ? "error" : settings
          };
        } else {
          return Object.assign({ severity: "error" }, settings);
        }
      }
      getUnusedRules() {
        const rules = [];
        const decorators = [];
        const preprocessors = [];
        for (const usedVersion of Array.from(this._usedVersions)) {
          rules.push(...Object.keys(this.rules[usedVersion]).filter((name) => !this._usedRules.has(name)));
          decorators.push(...Object.keys(this.decorators[usedVersion]).filter((name) => !this._usedRules.has(name)));
          preprocessors.push(...Object.keys(this.preprocessors[usedVersion]).filter((name) => !this._usedRules.has(name)));
        }
        return {
          rules,
          preprocessors,
          decorators
        };
      }
      getRulesForOasVersion(version) {
        switch (version) {
          case oas_types_1.SpecMajorVersion.OAS3:
            const oas3Rules = [];
            this.plugins.forEach((p) => {
              var _a;
              return ((_a = p.preprocessors) === null || _a === void 0 ? void 0 : _a.oas3) && oas3Rules.push(p.preprocessors.oas3);
            });
            this.plugins.forEach((p) => {
              var _a;
              return ((_a = p.rules) === null || _a === void 0 ? void 0 : _a.oas3) && oas3Rules.push(p.rules.oas3);
            });
            this.plugins.forEach((p) => {
              var _a;
              return ((_a = p.decorators) === null || _a === void 0 ? void 0 : _a.oas3) && oas3Rules.push(p.decorators.oas3);
            });
            return oas3Rules;
          case oas_types_1.SpecMajorVersion.OAS2:
            const oas2Rules = [];
            this.plugins.forEach((p) => {
              var _a;
              return ((_a = p.preprocessors) === null || _a === void 0 ? void 0 : _a.oas2) && oas2Rules.push(p.preprocessors.oas2);
            });
            this.plugins.forEach((p) => {
              var _a;
              return ((_a = p.rules) === null || _a === void 0 ? void 0 : _a.oas2) && oas2Rules.push(p.rules.oas2);
            });
            this.plugins.forEach((p) => {
              var _a;
              return ((_a = p.decorators) === null || _a === void 0 ? void 0 : _a.oas2) && oas2Rules.push(p.decorators.oas2);
            });
            return oas2Rules;
          case oas_types_1.SpecMajorVersion.Async2:
            const asyncApiRules = [];
            this.plugins.forEach((p) => {
              var _a;
              return ((_a = p.preprocessors) === null || _a === void 0 ? void 0 : _a.async2) && asyncApiRules.push(p.preprocessors.async2);
            });
            this.plugins.forEach((p) => {
              var _a;
              return ((_a = p.rules) === null || _a === void 0 ? void 0 : _a.async2) && asyncApiRules.push(p.rules.async2);
            });
            this.plugins.forEach((p) => {
              var _a;
              return ((_a = p.decorators) === null || _a === void 0 ? void 0 : _a.async2) && asyncApiRules.push(p.decorators.async2);
            });
            return asyncApiRules;
        }
      }
      skipRules(rules) {
        for (const ruleId of rules || []) {
          for (const version of Object.values(oas_types_1.SpecVersion)) {
            if (this.rules[version][ruleId]) {
              this.rules[version][ruleId] = "off";
            }
          }
        }
      }
      skipPreprocessors(preprocessors) {
        for (const preprocessorId of preprocessors || []) {
          for (const version of Object.values(oas_types_1.SpecVersion)) {
            if (this.preprocessors[version][preprocessorId]) {
              this.preprocessors[version][preprocessorId] = "off";
            }
          }
        }
      }
      skipDecorators(decorators) {
        for (const decoratorId of decorators || []) {
          for (const version of Object.values(oas_types_1.SpecVersion)) {
            if (this.decorators[version][decoratorId]) {
              this.decorators[version][decoratorId] = "off";
            }
          }
        }
      }
    };
    exports2.StyleguideConfig = StyleguideConfig;
    var Config2 = class {
      constructor(rawConfig, configFile) {
        this.rawConfig = rawConfig;
        this.configFile = configFile;
        this.apis = rawConfig.apis || {};
        this.styleguide = new StyleguideConfig(rawConfig.styleguide || {}, configFile);
        this.theme = rawConfig.theme || {};
        this.resolve = (0, utils_2.getResolveConfig)(rawConfig === null || rawConfig === void 0 ? void 0 : rawConfig.resolve);
        this.region = rawConfig.region;
        this.organization = rawConfig.organization;
        this.files = rawConfig.files || [];
        this.telemetry = rawConfig.telemetry;
      }
    };
    exports2.Config = Config2;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/types.js
var require_types2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.DEFAULT_TEAM_CLAIM_NAME = exports2.ApigeeDevOnboardingIntegrationAuthType = exports2.AuthProviderType = void 0;
    var AuthProviderType;
    (function (AuthProviderType2) {
      AuthProviderType2["OIDC"] = "OIDC";
      AuthProviderType2["SAML2"] = "SAML2";
      AuthProviderType2["BASIC"] = "BASIC";
    })(AuthProviderType || (exports2.AuthProviderType = AuthProviderType = {}));
    var ApigeeDevOnboardingIntegrationAuthType;
    (function (ApigeeDevOnboardingIntegrationAuthType2) {
      ApigeeDevOnboardingIntegrationAuthType2["SERVICE_ACCOUNT"] = "SERVICE_ACCOUNT";
      ApigeeDevOnboardingIntegrationAuthType2["OAUTH2"] = "OAUTH2";
    })(ApigeeDevOnboardingIntegrationAuthType || (exports2.ApigeeDevOnboardingIntegrationAuthType = ApigeeDevOnboardingIntegrationAuthType = {}));
    exports2.DEFAULT_TEAM_CLAIM_NAME = "https://redocly.com/sso/teams";
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/rules.js
var require_rules = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/rules.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.initRules = void 0;
    var utils_1 = require_utils3();
    function initRules(rules, config, type2, oasVersion) {
      return rules.flatMap((ruleset) => Object.keys(ruleset).map((ruleId) => {
        const rule = ruleset[ruleId];
        const ruleSettings = type2 === "rules" ? config.getRuleSettings(ruleId, oasVersion) : type2 === "preprocessors" ? config.getPreprocessorSettings(ruleId, oasVersion) : config.getDecoratorSettings(ruleId, oasVersion);
        if (ruleSettings.severity === "off") {
          return void 0;
        }
        const severity = ruleSettings.severity;
        const visitors = rule(ruleSettings);
        if (Array.isArray(visitors)) {
          return visitors.map((visitor) => ({
            severity,
            ruleId,
            visitor
          }));
        }
        return {
          severity,
          ruleId,
          visitor: visitors
          // note: actually it is only one visitor object
        };
      })).flatMap((visitor) => visitor).filter(utils_1.isDefined);
    }
    exports2.initRules = initRules;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/recommended.js
var require_recommended = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/recommended.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var recommended = {
      rules: {
        "info-contact": "off",
        "info-license": "warn",
        "info-license-url": "warn",
        "tag-description": "warn",
        "tags-alphabetical": "off",
        "parameter-description": "off",
        "no-path-trailing-slash": "error",
        "no-identical-paths": "error",
        "no-ambiguous-paths": "warn",
        "path-declaration-must-exist": "error",
        "path-not-include-query": "error",
        "path-parameters-defined": "error",
        "operation-description": "off",
        "operation-2xx-response": "warn",
        "operation-4xx-response": "warn",
        "operation-operationId": "warn",
        "operation-summary": "error",
        "operation-operationId-unique": "error",
        "operation-operationId-url-safe": "error",
        "operation-parameters-unique": "error",
        "operation-tag-defined": "off",
        "security-defined": "error",
        "operation-singular-tag": "off",
        "no-unresolved-refs": "error",
        "no-enum-type-mismatch": "error",
        "paths-kebab-case": "off",
        spec: "error",
        "spec-strict-refs": "off",
        "no-http-verbs-in-paths": "off",
        "no-invalid-parameter-examples": "off",
        "no-invalid-schema-examples": "off",
        "path-excludes-patterns": "off",
        "path-http-verbs-order": "off",
        "path-params-defined": "off",
        "path-segment-plural": "off",
        "required-string-property-missing-min-length": "off",
        "response-contains-header": "off",
        "scalar-property-missing-example": "off"
      },
      oas2Rules: {
        "boolean-parameter-prefixes": "off",
        "request-mime-type": "off",
        "response-contains-property": "off",
        "response-mime-type": "off"
      },
      oas3_0Rules: {
        "no-invalid-media-type-examples": {
          severity: "warn",
          allowAdditionalProperties: false
        },
        "no-server-example.com": "warn",
        "no-server-trailing-slash": "error",
        "no-empty-servers": "error",
        "no-example-value-and-externalValue": "error",
        "no-unused-components": "warn",
        "no-undefined-server-variable": "error",
        "no-server-variables-empty-enum": "error",
        "spec-components-invalid-map-name": "error",
        "boolean-parameter-prefixes": "off",
        "component-name-unique": "off",
        "operation-4xx-problem-details-rfc7807": "off",
        "request-mime-type": "off",
        "response-contains-property": "off",
        "response-mime-type": "off"
      },
      oas3_1Rules: {
        "no-invalid-media-type-examples": "warn",
        "no-server-example.com": "warn",
        "no-server-trailing-slash": "error",
        "no-empty-servers": "error",
        "no-example-value-and-externalValue": "error",
        "no-unused-components": "warn",
        "no-undefined-server-variable": "error",
        "no-server-variables-empty-enum": "error",
        "spec-components-invalid-map-name": "error",
        "boolean-parameter-prefixes": "off",
        "component-name-unique": "off",
        "operation-4xx-problem-details-rfc7807": "off",
        "request-mime-type": "off",
        "response-contains-property": "off",
        "response-mime-type": "off"
      },
      async2Rules: {
        "channels-kebab-case": "off",
        "no-channel-trailing-slash": "off"
      }
    };
    exports2.default = recommended;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/recommended-strict.js
var require_recommended_strict = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/recommended-strict.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var recommendedStrict = {
      rules: {
        "info-contact": "off",
        "info-license": "error",
        "info-license-url": "error",
        "tag-description": "error",
        "tags-alphabetical": "off",
        "parameter-description": "off",
        "no-path-trailing-slash": "error",
        "no-identical-paths": "error",
        "no-ambiguous-paths": "error",
        "path-declaration-must-exist": "error",
        "path-not-include-query": "error",
        "path-parameters-defined": "error",
        "operation-description": "off",
        "operation-2xx-response": "error",
        "operation-4xx-response": "error",
        "operation-operationId": "error",
        "operation-summary": "error",
        "operation-operationId-unique": "error",
        "operation-operationId-url-safe": "error",
        "operation-parameters-unique": "error",
        "operation-tag-defined": "off",
        "security-defined": "error",
        "operation-singular-tag": "off",
        "no-unresolved-refs": "error",
        "no-enum-type-mismatch": "error",
        "paths-kebab-case": "off",
        spec: "error",
        "spec-strict-refs": "off",
        "no-http-verbs-in-paths": "off",
        "no-invalid-parameter-examples": "off",
        "no-invalid-schema-examples": "off",
        "path-excludes-patterns": "off",
        "path-http-verbs-order": "off",
        "path-params-defined": "off",
        "path-segment-plural": "off",
        "required-string-property-missing-min-length": "off",
        "response-contains-header": "off",
        "scalar-property-missing-example": "off"
      },
      oas2Rules: {
        "boolean-parameter-prefixes": "off",
        "request-mime-type": "off",
        "response-contains-property": "off",
        "response-mime-type": "off"
      },
      oas3_0Rules: {
        "no-invalid-media-type-examples": {
          severity: "error",
          allowAdditionalProperties: false
        },
        "no-server-example.com": "error",
        "no-server-trailing-slash": "error",
        "no-empty-servers": "error",
        "no-example-value-and-externalValue": "error",
        "no-unused-components": "error",
        "no-undefined-server-variable": "error",
        "no-server-variables-empty-enum": "error",
        "spec-components-invalid-map-name": "error",
        "boolean-parameter-prefixes": "off",
        "component-name-unique": "off",
        "operation-4xx-problem-details-rfc7807": "off",
        "request-mime-type": "off",
        "response-contains-property": "off",
        "response-mime-type": "off"
      },
      oas3_1Rules: {
        "no-invalid-media-type-examples": "error",
        "no-server-example.com": "error",
        "no-server-trailing-slash": "error",
        "no-empty-servers": "error",
        "no-example-value-and-externalValue": "error",
        "no-unused-components": "error",
        "no-undefined-server-variable": "error",
        "no-server-variables-empty-enum": "error",
        "spec-components-invalid-map-name": "error",
        "boolean-parameter-prefixes": "off",
        "component-name-unique": "off",
        "operation-4xx-problem-details-rfc7807": "off",
        "request-mime-type": "off",
        "response-contains-property": "off",
        "response-mime-type": "off"
      },
      async2Rules: {
        "channels-kebab-case": "off",
        "no-channel-trailing-slash": "off"
      }
    };
    exports2.default = recommendedStrict;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/all.js
var require_all = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/all.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var all = {
      rules: {
        "info-contact": "error",
        "info-license": "error",
        "info-license-url": "error",
        "tag-description": "error",
        "tags-alphabetical": "error",
        "parameter-description": "error",
        "no-identical-paths": "error",
        "no-ambiguous-paths": "error",
        "no-path-trailing-slash": "error",
        "path-segment-plural": "error",
        "path-declaration-must-exist": "error",
        "path-not-include-query": "error",
        "path-parameters-defined": "error",
        "operation-description": "error",
        "operation-2xx-response": "error",
        "operation-4xx-response": "error",
        "operation-operationId": "error",
        "operation-summary": "error",
        "operation-operationId-unique": "error",
        "operation-operationId-url-safe": "error",
        "operation-parameters-unique": "error",
        "operation-tag-defined": "error",
        "security-defined": "error",
        "operation-singular-tag": "error",
        "no-unresolved-refs": "error",
        "no-enum-type-mismatch": "error",
        "paths-kebab-case": "error",
        "no-http-verbs-in-paths": "error",
        "path-excludes-patterns": {
          severity: "error",
          patterns: []
        },
        spec: "error",
        "no-invalid-schema-examples": "error",
        "no-invalid-parameter-examples": "error",
        "scalar-property-missing-example": "error",
        "spec-strict-refs": "error",
        "path-http-verbs-order": "error",
        "path-params-defined": "error",
        "required-string-property-missing-min-length": "error",
        "response-contains-header": "error"
      },
      oas2Rules: {
        "boolean-parameter-prefixes": "error",
        "request-mime-type": {
          severity: "error",
          allowedValues: ["application/json"]
        },
        "response-mime-type": {
          severity: "error",
          allowedValues: ["application/json"]
        },
        "response-contains-property": "error"
      },
      oas3_0Rules: {
        "no-invalid-media-type-examples": "error",
        "no-server-example.com": "error",
        "no-server-trailing-slash": "error",
        "no-empty-servers": "error",
        "no-example-value-and-externalValue": "error",
        "no-unused-components": "error",
        "no-undefined-server-variable": "error",
        "no-server-variables-empty-enum": "error",
        "operation-4xx-problem-details-rfc7807": "error",
        "boolean-parameter-prefixes": "error",
        "request-mime-type": {
          severity: "error",
          allowedValues: ["application/json"]
        },
        "response-mime-type": {
          severity: "error",
          allowedValues: ["application/json"]
        },
        "component-name-unique": "error",
        "response-contains-property": "error",
        "spec-components-invalid-map-name": "error"
      },
      oas3_1Rules: {
        "no-invalid-media-type-examples": "error",
        "no-server-example.com": "error",
        "no-server-trailing-slash": "error",
        "no-empty-servers": "error",
        "no-example-value-and-externalValue": "error",
        "no-unused-components": "error",
        "no-undefined-server-variable": "error",
        "no-server-variables-empty-enum": "error",
        "operation-4xx-problem-details-rfc7807": "error",
        "boolean-parameter-prefixes": "error",
        "request-mime-type": {
          severity: "error",
          allowedValues: ["application/json"]
        },
        "response-mime-type": {
          severity: "error",
          allowedValues: ["application/json"]
        },
        "component-name-unique": "error",
        "response-contains-property": "error",
        "spec-components-invalid-map-name": "error"
      },
      async2Rules: {
        "channels-kebab-case": "error",
        "no-channel-trailing-slash": "error"
      }
    };
    exports2.default = all;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/minimal.js
var require_minimal = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/minimal.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var minimal = {
      rules: {
        "info-contact": "off",
        "info-license": "off",
        "info-license-url": "off",
        "tag-description": "warn",
        "tags-alphabetical": "off",
        "parameter-description": "off",
        "no-path-trailing-slash": "warn",
        "no-identical-paths": "warn",
        "no-ambiguous-paths": "warn",
        "path-declaration-must-exist": "warn",
        "path-not-include-query": "warn",
        "path-parameters-defined": "warn",
        "operation-description": "off",
        "operation-2xx-response": "warn",
        "operation-4xx-response": "off",
        "operation-operationId": "warn",
        "operation-summary": "warn",
        "operation-operationId-unique": "warn",
        "operation-parameters-unique": "warn",
        "operation-tag-defined": "off",
        "security-defined": "warn",
        "operation-operationId-url-safe": "warn",
        "operation-singular-tag": "off",
        "no-unresolved-refs": "error",
        "no-enum-type-mismatch": "warn",
        "paths-kebab-case": "off",
        spec: "error",
        "spec-strict-refs": "off",
        "no-http-verbs-in-paths": "off",
        "no-invalid-parameter-examples": "off",
        "no-invalid-schema-examples": "off",
        "path-excludes-patterns": "off",
        "path-http-verbs-order": "off",
        "path-params-defined": "off",
        "required-string-property-missing-min-length": "off",
        "response-contains-header": "off",
        "path-segment-plural": "off",
        "scalar-property-missing-example": "off"
      },
      oas2Rules: {
        "boolean-parameter-prefixes": "off",
        "request-mime-type": "off",
        "response-contains-property": "off",
        "response-mime-type": "off"
      },
      oas3_0Rules: {
        "no-invalid-media-type-examples": {
          severity: "warn",
          allowAdditionalProperties: false
        },
        "no-server-example.com": "warn",
        "no-server-trailing-slash": "error",
        "no-empty-servers": "warn",
        "no-example-value-and-externalValue": "warn",
        "no-unused-components": "warn",
        "no-undefined-server-variable": "warn",
        "no-server-variables-empty-enum": "error",
        "spec-components-invalid-map-name": "warn",
        "boolean-parameter-prefixes": "off",
        "component-name-unique": "off",
        "operation-4xx-problem-details-rfc7807": "off",
        "request-mime-type": "off",
        "response-contains-property": "off",
        "response-mime-type": "off"
      },
      oas3_1Rules: {
        "no-invalid-media-type-examples": "warn",
        "no-server-example.com": "warn",
        "no-server-trailing-slash": "error",
        "no-empty-servers": "warn",
        "no-example-value-and-externalValue": "warn",
        "no-unused-components": "warn",
        "no-undefined-server-variable": "warn",
        "no-server-variables-empty-enum": "error",
        "spec-components-invalid-map-name": "warn",
        "boolean-parameter-prefixes": "off",
        "component-name-unique": "off",
        "operation-4xx-problem-details-rfc7807": "off",
        "request-mime-type": "off",
        "response-contains-property": "off",
        "response-mime-type": "off"
      },
      async2Rules: {
        "channels-kebab-case": "off",
        "no-channel-trailing-slash": "off"
      }
    };
    exports2.default = minimal;
  }
});

// ../../../node_modules/.pnpm/js-levenshtein@1.1.6/node_modules/js-levenshtein/index.js
var require_js_levenshtein = __commonJS({
  "../../../node_modules/.pnpm/js-levenshtein@1.1.6/node_modules/js-levenshtein/index.js"(exports2, module2) {
    "use strict";
    module2.exports = /* @__PURE__ */ function () {
      function _min(d0, d1, d2, bx, ay) {
        return d0 < d1 || d2 < d1 ? d0 > d2 ? d2 + 1 : d0 + 1 : bx === ay ? d1 : d1 + 1;
      }
      return function (a, b) {
        if (a === b) {
          return 0;
        }
        if (a.length > b.length) {
          var tmp = a;
          a = b;
          b = tmp;
        }
        var la = a.length;
        var lb = b.length;
        while (la > 0 && a.charCodeAt(la - 1) === b.charCodeAt(lb - 1)) {
          la--;
          lb--;
        }
        var offset = 0;
        while (offset < la && a.charCodeAt(offset) === b.charCodeAt(offset)) {
          offset++;
        }
        la -= offset;
        lb -= offset;
        if (la === 0 || lb < 3) {
          return lb;
        }
        var x = 0;
        var y;
        var d0;
        var d1;
        var d2;
        var d3;
        var dd;
        var dy;
        var ay;
        var bx0;
        var bx1;
        var bx2;
        var bx3;
        var vector = [];
        for (y = 0; y < la; y++) {
          vector.push(y + 1);
          vector.push(a.charCodeAt(offset + y));
        }
        var len = vector.length - 1;
        for (; x < lb - 3;) {
          bx0 = b.charCodeAt(offset + (d0 = x));
          bx1 = b.charCodeAt(offset + (d1 = x + 1));
          bx2 = b.charCodeAt(offset + (d2 = x + 2));
          bx3 = b.charCodeAt(offset + (d3 = x + 3));
          dd = x += 4;
          for (y = 0; y < len; y += 2) {
            dy = vector[y];
            ay = vector[y + 1];
            d0 = _min(dy, d0, d1, bx0, ay);
            d1 = _min(d0, d1, d2, bx1, ay);
            d2 = _min(d1, d2, d3, bx2, ay);
            dd = _min(d2, d3, dd, bx3, ay);
            vector[y] = dd;
            d3 = d2;
            d2 = d1;
            d1 = d0;
            d0 = dy;
          }
        }
        for (; x < lb;) {
          bx0 = b.charCodeAt(offset + (d0 = x));
          dd = ++x;
          for (y = 0; y < len; y += 2) {
            dy = vector[y];
            vector[y] = dd = _min(dy, d0, dd, bx0, vector[y + 1]);
            d0 = dy;
          }
        }
        return dd;
      };
    }();
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/codegen/code.js
var require_code = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/codegen/code.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.regexpCode = exports2.getEsmExportName = exports2.getProperty = exports2.safeStringify = exports2.stringify = exports2.strConcat = exports2.addCodeArg = exports2.str = exports2._ = exports2.nil = exports2._Code = exports2.Name = exports2.IDENTIFIER = exports2._CodeOrName = void 0;
    var _CodeOrName = class {
    };
    exports2._CodeOrName = _CodeOrName;
    exports2.IDENTIFIER = /^[a-z$_][a-z$_0-9]*$/i;
    var Name = class extends _CodeOrName {
      constructor(s) {
        super();
        if (!exports2.IDENTIFIER.test(s))
          throw new Error("CodeGen: name must be a valid identifier");
        this.str = s;
      }
      toString() {
        return this.str;
      }
      emptyStr() {
        return false;
      }
      get names() {
        return { [this.str]: 1 };
      }
    };
    exports2.Name = Name;
    var _Code = class extends _CodeOrName {
      constructor(code) {
        super();
        this._items = typeof code === "string" ? [code] : code;
      }
      toString() {
        return this.str;
      }
      emptyStr() {
        if (this._items.length > 1)
          return false;
        const item = this._items[0];
        return item === "" || item === '""';
      }
      get str() {
        var _a;
        return (_a = this._str) !== null && _a !== void 0 ? _a : this._str = this._items.reduce((s, c) => `${s}${c}`, "");
      }
      get names() {
        var _a;
        return (_a = this._names) !== null && _a !== void 0 ? _a : this._names = this._items.reduce((names, c) => {
          if (c instanceof Name)
            names[c.str] = (names[c.str] || 0) + 1;
          return names;
        }, {});
      }
    };
    exports2._Code = _Code;
    exports2.nil = new _Code("");
    function _(strs, ...args) {
      const code = [strs[0]];
      let i = 0;
      while (i < args.length) {
        addCodeArg(code, args[i]);
        code.push(strs[++i]);
      }
      return new _Code(code);
    }
    exports2._ = _;
    var plus = new _Code("+");
    function str2(strs, ...args) {
      const expr = [safeStringify(strs[0])];
      let i = 0;
      while (i < args.length) {
        expr.push(plus);
        addCodeArg(expr, args[i]);
        expr.push(plus, safeStringify(strs[++i]));
      }
      optimize(expr);
      return new _Code(expr);
    }
    exports2.str = str2;
    function addCodeArg(code, arg) {
      if (arg instanceof _Code)
        code.push(...arg._items);
      else if (arg instanceof Name)
        code.push(arg);
      else
        code.push(interpolate(arg));
    }
    exports2.addCodeArg = addCodeArg;
    function optimize(expr) {
      let i = 1;
      while (i < expr.length - 1) {
        if (expr[i] === plus) {
          const res = mergeExprItems(expr[i - 1], expr[i + 1]);
          if (res !== void 0) {
            expr.splice(i - 1, 3, res);
            continue;
          }
          expr[i++] = "+";
        }
        i++;
      }
    }
    function mergeExprItems(a, b) {
      if (b === '""')
        return a;
      if (a === '""')
        return b;
      if (typeof a == "string") {
        if (b instanceof Name || a[a.length - 1] !== '"')
          return;
        if (typeof b != "string")
          return `${a.slice(0, -1)}${b}"`;
        if (b[0] === '"')
          return a.slice(0, -1) + b.slice(1);
        return;
      }
      if (typeof b == "string" && b[0] === '"' && !(a instanceof Name))
        return `"${a}${b.slice(1)}`;
      return;
    }
    function strConcat(c1, c2) {
      return c2.emptyStr() ? c1 : c1.emptyStr() ? c2 : str2`${c1}${c2}`;
    }
    exports2.strConcat = strConcat;
    function interpolate(x) {
      return typeof x == "number" || typeof x == "boolean" || x === null ? x : safeStringify(Array.isArray(x) ? x.join(",") : x);
    }
    function stringify(x) {
      return new _Code(safeStringify(x));
    }
    exports2.stringify = stringify;
    function safeStringify(x) {
      return JSON.stringify(x).replace(/\u2028/g, "\\u2028").replace(/\u2029/g, "\\u2029");
    }
    exports2.safeStringify = safeStringify;
    function getProperty2(key) {
      return typeof key == "string" && exports2.IDENTIFIER.test(key) ? new _Code(`.${key}`) : _`[${key}]`;
    }
    exports2.getProperty = getProperty2;
    function getEsmExportName(key) {
      if (typeof key == "string" && exports2.IDENTIFIER.test(key)) {
        return new _Code(`${key}`);
      }
      throw new Error(`CodeGen: invalid export name: ${key}, use explicit $id name mapping`);
    }
    exports2.getEsmExportName = getEsmExportName;
    function regexpCode(rx) {
      return new _Code(rx.toString());
    }
    exports2.regexpCode = regexpCode;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/codegen/scope.js
var require_scope = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/codegen/scope.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ValueScope = exports2.ValueScopeName = exports2.Scope = exports2.varKinds = exports2.UsedValueState = void 0;
    var code_1 = require_code();
    var ValueError = class extends Error {
      constructor(name) {
        super(`CodeGen: "code" for ${name} not defined`);
        this.value = name.value;
      }
    };
    var UsedValueState;
    (function (UsedValueState2) {
      UsedValueState2[UsedValueState2["Started"] = 0] = "Started";
      UsedValueState2[UsedValueState2["Completed"] = 1] = "Completed";
    })(UsedValueState = exports2.UsedValueState || (exports2.UsedValueState = {}));
    exports2.varKinds = {
      const: new code_1.Name("const"),
      let: new code_1.Name("let"),
      var: new code_1.Name("var")
    };
    var Scope = class {
      constructor({ prefixes, parent } = {}) {
        this._names = {};
        this._prefixes = prefixes;
        this._parent = parent;
      }
      toName(nameOrPrefix) {
        return nameOrPrefix instanceof code_1.Name ? nameOrPrefix : this.name(nameOrPrefix);
      }
      name(prefix) {
        return new code_1.Name(this._newName(prefix));
      }
      _newName(prefix) {
        const ng = this._names[prefix] || this._nameGroup(prefix);
        return `${prefix}${ng.index++}`;
      }
      _nameGroup(prefix) {
        var _a, _b;
        if (((_b = (_a = this._parent) === null || _a === void 0 ? void 0 : _a._prefixes) === null || _b === void 0 ? void 0 : _b.has(prefix)) || this._prefixes && !this._prefixes.has(prefix)) {
          throw new Error(`CodeGen: prefix "${prefix}" is not allowed in this scope`);
        }
        return this._names[prefix] = { prefix, index: 0 };
      }
    };
    exports2.Scope = Scope;
    var ValueScopeName = class extends code_1.Name {
      constructor(prefix, nameStr) {
        super(nameStr);
        this.prefix = prefix;
      }
      setValue(value, { property: property4, itemIndex }) {
        this.value = value;
        this.scopePath = (0, code_1._)`.${new code_1.Name(property4)}[${itemIndex}]`;
      }
    };
    exports2.ValueScopeName = ValueScopeName;
    var line = (0, code_1._)`\n`;
    var ValueScope = class extends Scope {
      constructor(opts) {
        super(opts);
        this._values = {};
        this._scope = opts.scope;
        this.opts = { ...opts, _n: opts.lines ? line : code_1.nil };
      }
      get() {
        return this._scope;
      }
      name(prefix) {
        return new ValueScopeName(prefix, this._newName(prefix));
      }
      value(nameOrPrefix, value) {
        var _a;
        if (value.ref === void 0)
          throw new Error("CodeGen: ref must be passed in value");
        const name = this.toName(nameOrPrefix);
        const { prefix } = name;
        const valueKey = (_a = value.key) !== null && _a !== void 0 ? _a : value.ref;
        let vs = this._values[prefix];
        if (vs) {
          const _name = vs.get(valueKey);
          if (_name)
            return _name;
        } else {
          vs = this._values[prefix] = /* @__PURE__ */ new Map();
        }
        vs.set(valueKey, name);
        const s = this._scope[prefix] || (this._scope[prefix] = []);
        const itemIndex = s.length;
        s[itemIndex] = value.ref;
        name.setValue(value, { property: prefix, itemIndex });
        return name;
      }
      getValue(prefix, keyOrRef) {
        const vs = this._values[prefix];
        if (!vs)
          return;
        return vs.get(keyOrRef);
      }
      scopeRefs(scopeName, values = this._values) {
        return this._reduceValues(values, (name) => {
          if (name.scopePath === void 0)
            throw new Error(`CodeGen: name "${name}" has no value`);
          return (0, code_1._)`${scopeName}${name.scopePath}`;
        });
      }
      scopeCode(values = this._values, usedValues, getCode) {
        return this._reduceValues(values, (name) => {
          if (name.value === void 0)
            throw new Error(`CodeGen: name "${name}" has no value`);
          return name.value.code;
        }, usedValues, getCode);
      }
      _reduceValues(values, valueCode, usedValues = {}, getCode) {
        let code = code_1.nil;
        for (const prefix in values) {
          const vs = values[prefix];
          if (!vs)
            continue;
          const nameSet = usedValues[prefix] = usedValues[prefix] || /* @__PURE__ */ new Map();
          vs.forEach((name) => {
            if (nameSet.has(name))
              return;
            nameSet.set(name, UsedValueState.Started);
            let c = valueCode(name);
            if (c) {
              const def = this.opts.es5 ? exports2.varKinds.var : exports2.varKinds.const;
              code = (0, code_1._)`${code}${def} ${name} = ${c};${this.opts._n}`;
            } else if (c = getCode === null || getCode === void 0 ? void 0 : getCode(name)) {
              code = (0, code_1._)`${code}${c}${this.opts._n}`;
            } else {
              throw new ValueError(name);
            }
            nameSet.set(name, UsedValueState.Completed);
          });
        }
        return code;
      }
    };
    exports2.ValueScope = ValueScope;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/codegen/index.js
var require_codegen = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/codegen/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.or = exports2.and = exports2.not = exports2.CodeGen = exports2.operators = exports2.varKinds = exports2.ValueScopeName = exports2.ValueScope = exports2.Scope = exports2.Name = exports2.regexpCode = exports2.stringify = exports2.getProperty = exports2.nil = exports2.strConcat = exports2.str = exports2._ = void 0;
    var code_1 = require_code();
    var scope_1 = require_scope();
    var code_2 = require_code();
    Object.defineProperty(exports2, "_", {
      enumerable: true, get: function () {
        return code_2._;
      }
    });
    Object.defineProperty(exports2, "str", {
      enumerable: true, get: function () {
        return code_2.str;
      }
    });
    Object.defineProperty(exports2, "strConcat", {
      enumerable: true, get: function () {
        return code_2.strConcat;
      }
    });
    Object.defineProperty(exports2, "nil", {
      enumerable: true, get: function () {
        return code_2.nil;
      }
    });
    Object.defineProperty(exports2, "getProperty", {
      enumerable: true, get: function () {
        return code_2.getProperty;
      }
    });
    Object.defineProperty(exports2, "stringify", {
      enumerable: true, get: function () {
        return code_2.stringify;
      }
    });
    Object.defineProperty(exports2, "regexpCode", {
      enumerable: true, get: function () {
        return code_2.regexpCode;
      }
    });
    Object.defineProperty(exports2, "Name", {
      enumerable: true, get: function () {
        return code_2.Name;
      }
    });
    var scope_2 = require_scope();
    Object.defineProperty(exports2, "Scope", {
      enumerable: true, get: function () {
        return scope_2.Scope;
      }
    });
    Object.defineProperty(exports2, "ValueScope", {
      enumerable: true, get: function () {
        return scope_2.ValueScope;
      }
    });
    Object.defineProperty(exports2, "ValueScopeName", {
      enumerable: true, get: function () {
        return scope_2.ValueScopeName;
      }
    });
    Object.defineProperty(exports2, "varKinds", {
      enumerable: true, get: function () {
        return scope_2.varKinds;
      }
    });
    exports2.operators = {
      GT: new code_1._Code(">"),
      GTE: new code_1._Code(">="),
      LT: new code_1._Code("<"),
      LTE: new code_1._Code("<="),
      EQ: new code_1._Code("==="),
      NEQ: new code_1._Code("!=="),
      NOT: new code_1._Code("!"),
      OR: new code_1._Code("||"),
      AND: new code_1._Code("&&"),
      ADD: new code_1._Code("+")
    };
    var Node = class {
      optimizeNodes() {
        return this;
      }
      optimizeNames(_names, _constants) {
        return this;
      }
    };
    var Def = class extends Node {
      constructor(varKind, name, rhs) {
        super();
        this.varKind = varKind;
        this.name = name;
        this.rhs = rhs;
      }
      render({ es5, _n }) {
        const varKind = es5 ? scope_1.varKinds.var : this.varKind;
        const rhs = this.rhs === void 0 ? "" : ` = ${this.rhs}`;
        return `${varKind} ${this.name}${rhs};` + _n;
      }
      optimizeNames(names, constants) {
        if (!names[this.name.str])
          return;
        if (this.rhs)
          this.rhs = optimizeExpr(this.rhs, names, constants);
        return this;
      }
      get names() {
        return this.rhs instanceof code_1._CodeOrName ? this.rhs.names : {};
      }
    };
    var Assign = class extends Node {
      constructor(lhs, rhs, sideEffects) {
        super();
        this.lhs = lhs;
        this.rhs = rhs;
        this.sideEffects = sideEffects;
      }
      render({ _n }) {
        return `${this.lhs} = ${this.rhs};` + _n;
      }
      optimizeNames(names, constants) {
        if (this.lhs instanceof code_1.Name && !names[this.lhs.str] && !this.sideEffects)
          return;
        this.rhs = optimizeExpr(this.rhs, names, constants);
        return this;
      }
      get names() {
        const names = this.lhs instanceof code_1.Name ? {} : { ...this.lhs.names };
        return addExprNames(names, this.rhs);
      }
    };
    var AssignOp = class extends Assign {
      constructor(lhs, op, rhs, sideEffects) {
        super(lhs, rhs, sideEffects);
        this.op = op;
      }
      render({ _n }) {
        return `${this.lhs} ${this.op}= ${this.rhs};` + _n;
      }
    };
    var Label = class extends Node {
      constructor(label) {
        super();
        this.label = label;
        this.names = {};
      }
      render({ _n }) {
        return `${this.label}:` + _n;
      }
    };
    var Break = class extends Node {
      constructor(label) {
        super();
        this.label = label;
        this.names = {};
      }
      render({ _n }) {
        const label = this.label ? ` ${this.label}` : "";
        return `break${label};` + _n;
      }
    };
    var Throw = class extends Node {
      constructor(error) {
        super();
        this.error = error;
      }
      render({ _n }) {
        return `throw ${this.error};` + _n;
      }
      get names() {
        return this.error.names;
      }
    };
    var AnyCode = class extends Node {
      constructor(code) {
        super();
        this.code = code;
      }
      render({ _n }) {
        return `${this.code};` + _n;
      }
      optimizeNodes() {
        return `${this.code}` ? this : void 0;
      }
      optimizeNames(names, constants) {
        this.code = optimizeExpr(this.code, names, constants);
        return this;
      }
      get names() {
        return this.code instanceof code_1._CodeOrName ? this.code.names : {};
      }
    };
    var ParentNode = class extends Node {
      constructor(nodes = []) {
        super();
        this.nodes = nodes;
      }
      render(opts) {
        return this.nodes.reduce((code, n) => code + n.render(opts), "");
      }
      optimizeNodes() {
        const { nodes } = this;
        let i = nodes.length;
        while (i--) {
          const n = nodes[i].optimizeNodes();
          if (Array.isArray(n))
            nodes.splice(i, 1, ...n);
          else if (n)
            nodes[i] = n;
          else
            nodes.splice(i, 1);
        }
        return nodes.length > 0 ? this : void 0;
      }
      optimizeNames(names, constants) {
        const { nodes } = this;
        let i = nodes.length;
        while (i--) {
          const n = nodes[i];
          if (n.optimizeNames(names, constants))
            continue;
          subtractNames(names, n.names);
          nodes.splice(i, 1);
        }
        return nodes.length > 0 ? this : void 0;
      }
      get names() {
        return this.nodes.reduce((names, n) => addNames(names, n.names), {});
      }
    };
    var BlockNode = class extends ParentNode {
      render(opts) {
        return "{" + opts._n + super.render(opts) + "}" + opts._n;
      }
    };
    var Root = class extends ParentNode {
    };
    var Else = class extends BlockNode {
    };
    Else.kind = "else";
    var If = class _If extends BlockNode {
      constructor(condition, nodes) {
        super(nodes);
        this.condition = condition;
      }
      render(opts) {
        let code = `if(${this.condition})` + super.render(opts);
        if (this.else)
          code += "else " + this.else.render(opts);
        return code;
      }
      optimizeNodes() {
        super.optimizeNodes();
        const cond = this.condition;
        if (cond === true)
          return this.nodes;
        let e = this.else;
        if (e) {
          const ns = e.optimizeNodes();
          e = this.else = Array.isArray(ns) ? new Else(ns) : ns;
        }
        if (e) {
          if (cond === false)
            return e instanceof _If ? e : e.nodes;
          if (this.nodes.length)
            return this;
          return new _If(not(cond), e instanceof _If ? [e] : e.nodes);
        }
        if (cond === false || !this.nodes.length)
          return void 0;
        return this;
      }
      optimizeNames(names, constants) {
        var _a;
        this.else = (_a = this.else) === null || _a === void 0 ? void 0 : _a.optimizeNames(names, constants);
        if (!(super.optimizeNames(names, constants) || this.else))
          return;
        this.condition = optimizeExpr(this.condition, names, constants);
        return this;
      }
      get names() {
        const names = super.names;
        addExprNames(names, this.condition);
        if (this.else)
          addNames(names, this.else.names);
        return names;
      }
    };
    If.kind = "if";
    var For = class extends BlockNode {
    };
    For.kind = "for";
    var ForLoop = class extends For {
      constructor(iteration) {
        super();
        this.iteration = iteration;
      }
      render(opts) {
        return `for(${this.iteration})` + super.render(opts);
      }
      optimizeNames(names, constants) {
        if (!super.optimizeNames(names, constants))
          return;
        this.iteration = optimizeExpr(this.iteration, names, constants);
        return this;
      }
      get names() {
        return addNames(super.names, this.iteration.names);
      }
    };
    var ForRange = class extends For {
      constructor(varKind, name, from, to) {
        super();
        this.varKind = varKind;
        this.name = name;
        this.from = from;
        this.to = to;
      }
      render(opts) {
        const varKind = opts.es5 ? scope_1.varKinds.var : this.varKind;
        const { name, from, to } = this;
        return `for(${varKind} ${name}=${from}; ${name}<${to}; ${name}++)` + super.render(opts);
      }
      get names() {
        const names = addExprNames(super.names, this.from);
        return addExprNames(names, this.to);
      }
    };
    var ForIter = class extends For {
      constructor(loop, varKind, name, iterable) {
        super();
        this.loop = loop;
        this.varKind = varKind;
        this.name = name;
        this.iterable = iterable;
      }
      render(opts) {
        return `for(${this.varKind} ${this.name} ${this.loop} ${this.iterable})` + super.render(opts);
      }
      optimizeNames(names, constants) {
        if (!super.optimizeNames(names, constants))
          return;
        this.iterable = optimizeExpr(this.iterable, names, constants);
        return this;
      }
      get names() {
        return addNames(super.names, this.iterable.names);
      }
    };
    var Func = class extends BlockNode {
      constructor(name, args, async) {
        super();
        this.name = name;
        this.args = args;
        this.async = async;
      }
      render(opts) {
        const _async = this.async ? "async " : "";
        return `${_async}function ${this.name}(${this.args})` + super.render(opts);
      }
    };
    Func.kind = "func";
    var Return = class extends ParentNode {
      render(opts) {
        return "return " + super.render(opts);
      }
    };
    Return.kind = "return";
    var Try = class extends BlockNode {
      render(opts) {
        let code = "try" + super.render(opts);
        if (this.catch)
          code += this.catch.render(opts);
        if (this.finally)
          code += this.finally.render(opts);
        return code;
      }
      optimizeNodes() {
        var _a, _b;
        super.optimizeNodes();
        (_a = this.catch) === null || _a === void 0 ? void 0 : _a.optimizeNodes();
        (_b = this.finally) === null || _b === void 0 ? void 0 : _b.optimizeNodes();
        return this;
      }
      optimizeNames(names, constants) {
        var _a, _b;
        super.optimizeNames(names, constants);
        (_a = this.catch) === null || _a === void 0 ? void 0 : _a.optimizeNames(names, constants);
        (_b = this.finally) === null || _b === void 0 ? void 0 : _b.optimizeNames(names, constants);
        return this;
      }
      get names() {
        const names = super.names;
        if (this.catch)
          addNames(names, this.catch.names);
        if (this.finally)
          addNames(names, this.finally.names);
        return names;
      }
    };
    var Catch = class extends BlockNode {
      constructor(error) {
        super();
        this.error = error;
      }
      render(opts) {
        return `catch(${this.error})` + super.render(opts);
      }
    };
    Catch.kind = "catch";
    var Finally = class extends BlockNode {
      render(opts) {
        return "finally" + super.render(opts);
      }
    };
    Finally.kind = "finally";
    var CodeGen = class {
      constructor(extScope, opts = {}) {
        this._values = {};
        this._blockStarts = [];
        this._constants = {};
        this.opts = { ...opts, _n: opts.lines ? "\n" : "" };
        this._extScope = extScope;
        this._scope = new scope_1.Scope({ parent: extScope });
        this._nodes = [new Root()];
      }
      toString() {
        return this._root.render(this.opts);
      }
      // returns unique name in the internal scope
      name(prefix) {
        return this._scope.name(prefix);
      }
      // reserves unique name in the external scope
      scopeName(prefix) {
        return this._extScope.name(prefix);
      }
      // reserves unique name in the external scope and assigns value to it
      scopeValue(prefixOrName, value) {
        const name = this._extScope.value(prefixOrName, value);
        const vs = this._values[name.prefix] || (this._values[name.prefix] = /* @__PURE__ */ new Set());
        vs.add(name);
        return name;
      }
      getScopeValue(prefix, keyOrRef) {
        return this._extScope.getValue(prefix, keyOrRef);
      }
      // return code that assigns values in the external scope to the names that are used internally
      // (same names that were returned by gen.scopeName or gen.scopeValue)
      scopeRefs(scopeName) {
        return this._extScope.scopeRefs(scopeName, this._values);
      }
      scopeCode() {
        return this._extScope.scopeCode(this._values);
      }
      _def(varKind, nameOrPrefix, rhs, constant2) {
        const name = this._scope.toName(nameOrPrefix);
        if (rhs !== void 0 && constant2)
          this._constants[name.str] = rhs;
        this._leafNode(new Def(varKind, name, rhs));
        return name;
      }
      // `const` declaration (`var` in es5 mode)
      const(nameOrPrefix, rhs, _constant) {
        return this._def(scope_1.varKinds.const, nameOrPrefix, rhs, _constant);
      }
      // `let` declaration with optional assignment (`var` in es5 mode)
      let(nameOrPrefix, rhs, _constant) {
        return this._def(scope_1.varKinds.let, nameOrPrefix, rhs, _constant);
      }
      // `var` declaration with optional assignment
      var(nameOrPrefix, rhs, _constant) {
        return this._def(scope_1.varKinds.var, nameOrPrefix, rhs, _constant);
      }
      // assignment code
      assign(lhs, rhs, sideEffects) {
        return this._leafNode(new Assign(lhs, rhs, sideEffects));
      }
      // `+=` code
      add(lhs, rhs) {
        return this._leafNode(new AssignOp(lhs, exports2.operators.ADD, rhs));
      }
      // appends passed SafeExpr to code or executes Block
      code(c) {
        if (typeof c == "function")
          c();
        else if (c !== code_1.nil)
          this._leafNode(new AnyCode(c));
        return this;
      }
      // returns code for object literal for the passed argument list of key-value pairs
      object(...keyValues) {
        const code = ["{"];
        for (const [key, value] of keyValues) {
          if (code.length > 1)
            code.push(",");
          code.push(key);
          if (key !== value || this.opts.es5) {
            code.push(":");
            (0, code_1.addCodeArg)(code, value);
          }
        }
        code.push("}");
        return new code_1._Code(code);
      }
      // `if` clause (or statement if `thenBody` and, optionally, `elseBody` are passed)
      if(condition, thenBody, elseBody) {
        this._blockNode(new If(condition));
        if (thenBody && elseBody) {
          this.code(thenBody).else().code(elseBody).endIf();
        } else if (thenBody) {
          this.code(thenBody).endIf();
        } else if (elseBody) {
          throw new Error('CodeGen: "else" body without "then" body');
        }
        return this;
      }
      // `else if` clause - invalid without `if` or after `else` clauses
      elseIf(condition) {
        return this._elseNode(new If(condition));
      }
      // `else` clause - only valid after `if` or `else if` clauses
      else() {
        return this._elseNode(new Else());
      }
      // end `if` statement (needed if gen.if was used only with condition)
      endIf() {
        return this._endBlockNode(If, Else);
      }
      _for(node, forBody) {
        this._blockNode(node);
        if (forBody)
          this.code(forBody).endFor();
        return this;
      }
      // a generic `for` clause (or statement if `forBody` is passed)
      for(iteration, forBody) {
        return this._for(new ForLoop(iteration), forBody);
      }
      // `for` statement for a range of values
      forRange(nameOrPrefix, from, to, forBody, varKind = this.opts.es5 ? scope_1.varKinds.var : scope_1.varKinds.let) {
        const name = this._scope.toName(nameOrPrefix);
        return this._for(new ForRange(varKind, name, from, to), () => forBody(name));
      }
      // `for-of` statement (in es5 mode replace with a normal for loop)
      forOf(nameOrPrefix, iterable, forBody, varKind = scope_1.varKinds.const) {
        const name = this._scope.toName(nameOrPrefix);
        if (this.opts.es5) {
          const arr = iterable instanceof code_1.Name ? iterable : this.var("_arr", iterable);
          return this.forRange("_i", 0, (0, code_1._)`${arr}.length`, (i) => {
            this.var(name, (0, code_1._)`${arr}[${i}]`);
            forBody(name);
          });
        }
        return this._for(new ForIter("of", varKind, name, iterable), () => forBody(name));
      }
      // `for-in` statement.
      // With option `ownProperties` replaced with a `for-of` loop for object keys
      forIn(nameOrPrefix, obj, forBody, varKind = this.opts.es5 ? scope_1.varKinds.var : scope_1.varKinds.const) {
        if (this.opts.ownProperties) {
          return this.forOf(nameOrPrefix, (0, code_1._)`Object.keys(${obj})`, forBody);
        }
        const name = this._scope.toName(nameOrPrefix);
        return this._for(new ForIter("in", varKind, name, obj), () => forBody(name));
      }
      // end `for` loop
      endFor() {
        return this._endBlockNode(For);
      }
      // `label` statement
      label(label) {
        return this._leafNode(new Label(label));
      }
      // `break` statement
      break(label) {
        return this._leafNode(new Break(label));
      }
      // `return` statement
      return(value) {
        const node = new Return();
        this._blockNode(node);
        this.code(value);
        if (node.nodes.length !== 1)
          throw new Error('CodeGen: "return" should have one node');
        return this._endBlockNode(Return);
      }
      // `try` statement
      try(tryBody, catchCode, finallyCode) {
        if (!catchCode && !finallyCode)
          throw new Error('CodeGen: "try" without "catch" and "finally"');
        const node = new Try();
        this._blockNode(node);
        this.code(tryBody);
        if (catchCode) {
          const error = this.name("e");
          this._currNode = node.catch = new Catch(error);
          catchCode(error);
        }
        if (finallyCode) {
          this._currNode = node.finally = new Finally();
          this.code(finallyCode);
        }
        return this._endBlockNode(Catch, Finally);
      }
      // `throw` statement
      throw(error) {
        return this._leafNode(new Throw(error));
      }
      // start self-balancing block
      block(body, nodeCount) {
        this._blockStarts.push(this._nodes.length);
        if (body)
          this.code(body).endBlock(nodeCount);
        return this;
      }
      // end the current self-balancing block
      endBlock(nodeCount) {
        const len = this._blockStarts.pop();
        if (len === void 0)
          throw new Error("CodeGen: not in self-balancing block");
        const toClose = this._nodes.length - len;
        if (toClose < 0 || nodeCount !== void 0 && toClose !== nodeCount) {
          throw new Error(`CodeGen: wrong number of nodes: ${toClose} vs ${nodeCount} expected`);
        }
        this._nodes.length = len;
        return this;
      }
      // `function` heading (or definition if funcBody is passed)
      func(name, args = code_1.nil, async, funcBody) {
        this._blockNode(new Func(name, args, async));
        if (funcBody)
          this.code(funcBody).endFunc();
        return this;
      }
      // end function definition
      endFunc() {
        return this._endBlockNode(Func);
      }
      optimize(n = 1) {
        while (n-- > 0) {
          this._root.optimizeNodes();
          this._root.optimizeNames(this._root.names, this._constants);
        }
      }
      _leafNode(node) {
        this._currNode.nodes.push(node);
        return this;
      }
      _blockNode(node) {
        this._currNode.nodes.push(node);
        this._nodes.push(node);
      }
      _endBlockNode(N1, N2) {
        const n = this._currNode;
        if (n instanceof N1 || N2 && n instanceof N2) {
          this._nodes.pop();
          return this;
        }
        throw new Error(`CodeGen: not in block "${N2 ? `${N1.kind}/${N2.kind}` : N1.kind}"`);
      }
      _elseNode(node) {
        const n = this._currNode;
        if (!(n instanceof If)) {
          throw new Error('CodeGen: "else" without "if"');
        }
        this._currNode = n.else = node;
        return this;
      }
      get _root() {
        return this._nodes[0];
      }
      get _currNode() {
        const ns = this._nodes;
        return ns[ns.length - 1];
      }
      set _currNode(node) {
        const ns = this._nodes;
        ns[ns.length - 1] = node;
      }
    };
    exports2.CodeGen = CodeGen;
    function addNames(names, from) {
      for (const n in from)
        names[n] = (names[n] || 0) + (from[n] || 0);
      return names;
    }
    function addExprNames(names, from) {
      return from instanceof code_1._CodeOrName ? addNames(names, from.names) : names;
    }
    function optimizeExpr(expr, names, constants) {
      if (expr instanceof code_1.Name)
        return replaceName(expr);
      if (!canOptimize(expr))
        return expr;
      return new code_1._Code(expr._items.reduce((items, c) => {
        if (c instanceof code_1.Name)
          c = replaceName(c);
        if (c instanceof code_1._Code)
          items.push(...c._items);
        else
          items.push(c);
        return items;
      }, []));
      function replaceName(n) {
        const c = constants[n.str];
        if (c === void 0 || names[n.str] !== 1)
          return n;
        delete names[n.str];
        return c;
      }
      function canOptimize(e) {
        return e instanceof code_1._Code && e._items.some((c) => c instanceof code_1.Name && names[c.str] === 1 && constants[c.str] !== void 0);
      }
    }
    function subtractNames(names, from) {
      for (const n in from)
        names[n] = (names[n] || 0) - (from[n] || 0);
    }
    function not(x) {
      return typeof x == "boolean" || typeof x == "number" || x === null ? !x : (0, code_1._)`!${par(x)}`;
    }
    exports2.not = not;
    var andCode = mappend(exports2.operators.AND);
    function and(...args) {
      return args.reduce(andCode);
    }
    exports2.and = and;
    var orCode = mappend(exports2.operators.OR);
    function or(...args) {
      return args.reduce(orCode);
    }
    exports2.or = or;
    function mappend(op) {
      return (x, y) => x === code_1.nil ? y : y === code_1.nil ? x : (0, code_1._)`${par(x)} ${op} ${par(y)}`;
    }
    function par(x) {
      return x instanceof code_1.Name ? x : (0, code_1._)`(${x})`;
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/util.js
var require_util = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.checkStrictMode = exports2.getErrorPath = exports2.Type = exports2.useFunc = exports2.setEvaluated = exports2.evaluatedPropsToName = exports2.mergeEvaluated = exports2.eachItem = exports2.unescapeJsonPointer = exports2.escapeJsonPointer = exports2.escapeFragment = exports2.unescapeFragment = exports2.schemaRefOrVal = exports2.schemaHasRulesButRef = exports2.schemaHasRules = exports2.checkUnknownRules = exports2.alwaysValidSchema = exports2.toHash = void 0;
    var codegen_1 = require_codegen();
    var code_1 = require_code();
    function toHash(arr) {
      const hash2 = {};
      for (const item of arr)
        hash2[item] = true;
      return hash2;
    }
    exports2.toHash = toHash;
    function alwaysValidSchema(it, schema2) {
      if (typeof schema2 == "boolean")
        return schema2;
      if (Object.keys(schema2).length === 0)
        return true;
      checkUnknownRules(it, schema2);
      return !schemaHasRules(schema2, it.self.RULES.all);
    }
    exports2.alwaysValidSchema = alwaysValidSchema;
    function checkUnknownRules(it, schema2 = it.schema) {
      const { opts, self: self2 } = it;
      if (!opts.strictSchema)
        return;
      if (typeof schema2 === "boolean")
        return;
      const rules = self2.RULES.keywords;
      for (const key in schema2) {
        if (!rules[key])
          checkStrictMode(it, `unknown keyword: "${key}"`);
      }
    }
    exports2.checkUnknownRules = checkUnknownRules;
    function schemaHasRules(schema2, rules) {
      if (typeof schema2 == "boolean")
        return !schema2;
      for (const key in schema2)
        if (rules[key])
          return true;
      return false;
    }
    exports2.schemaHasRules = schemaHasRules;
    function schemaHasRulesButRef(schema2, RULES) {
      if (typeof schema2 == "boolean")
        return !schema2;
      for (const key in schema2)
        if (key !== "$ref" && RULES.all[key])
          return true;
      return false;
    }
    exports2.schemaHasRulesButRef = schemaHasRulesButRef;
    function schemaRefOrVal({ topSchemaRef, schemaPath }, schema2, keyword, $data) {
      if (!$data) {
        if (typeof schema2 == "number" || typeof schema2 == "boolean")
          return schema2;
        if (typeof schema2 == "string")
          return (0, codegen_1._)`${schema2}`;
      }
      return (0, codegen_1._)`${topSchemaRef}${schemaPath}${(0, codegen_1.getProperty)(keyword)}`;
    }
    exports2.schemaRefOrVal = schemaRefOrVal;
    function unescapeFragment(str2) {
      return unescapeJsonPointer(decodeURIComponent(str2));
    }
    exports2.unescapeFragment = unescapeFragment;
    function escapeFragment(str2) {
      return encodeURIComponent(escapeJsonPointer(str2));
    }
    exports2.escapeFragment = escapeFragment;
    function escapeJsonPointer(str2) {
      if (typeof str2 == "number")
        return `${str2}`;
      return str2.replace(/~/g, "~0").replace(/\//g, "~1");
    }
    exports2.escapeJsonPointer = escapeJsonPointer;
    function unescapeJsonPointer(str2) {
      return str2.replace(/~1/g, "/").replace(/~0/g, "~");
    }
    exports2.unescapeJsonPointer = unescapeJsonPointer;
    function eachItem(xs, f) {
      if (Array.isArray(xs)) {
        for (const x of xs)
          f(x);
      } else {
        f(xs);
      }
    }
    exports2.eachItem = eachItem;
    function makeMergeEvaluated({ mergeNames, mergeToName, mergeValues: mergeValues2, resultToName }) {
      return (gen, from, to, toName) => {
        const res = to === void 0 ? from : to instanceof codegen_1.Name ? (from instanceof codegen_1.Name ? mergeNames(gen, from, to) : mergeToName(gen, from, to), to) : from instanceof codegen_1.Name ? (mergeToName(gen, to, from), from) : mergeValues2(from, to);
        return toName === codegen_1.Name && !(res instanceof codegen_1.Name) ? resultToName(gen, res) : res;
      };
    }
    exports2.mergeEvaluated = {
      props: makeMergeEvaluated({
        mergeNames: (gen, from, to) => gen.if((0, codegen_1._)`${to} !== true && ${from} !== undefined`, () => {
          gen.if((0, codegen_1._)`${from} === true`, () => gen.assign(to, true), () => gen.assign(to, (0, codegen_1._)`${to} || {}`).code((0, codegen_1._)`Object.assign(${to}, ${from})`));
        }),
        mergeToName: (gen, from, to) => gen.if((0, codegen_1._)`${to} !== true`, () => {
          if (from === true) {
            gen.assign(to, true);
          } else {
            gen.assign(to, (0, codegen_1._)`${to} || {}`);
            setEvaluated(gen, to, from);
          }
        }),
        mergeValues: (from, to) => from === true ? true : { ...from, ...to },
        resultToName: evaluatedPropsToName
      }),
      items: makeMergeEvaluated({
        mergeNames: (gen, from, to) => gen.if((0, codegen_1._)`${to} !== true && ${from} !== undefined`, () => gen.assign(to, (0, codegen_1._)`${from} === true ? true : ${to} > ${from} ? ${to} : ${from}`)),
        mergeToName: (gen, from, to) => gen.if((0, codegen_1._)`${to} !== true`, () => gen.assign(to, from === true ? true : (0, codegen_1._)`${to} > ${from} ? ${to} : ${from}`)),
        mergeValues: (from, to) => from === true ? true : Math.max(from, to),
        resultToName: (gen, items) => gen.var("items", items)
      })
    };
    function evaluatedPropsToName(gen, ps) {
      if (ps === true)
        return gen.var("props", true);
      const props = gen.var("props", (0, codegen_1._)`{}`);
      if (ps !== void 0)
        setEvaluated(gen, props, ps);
      return props;
    }
    exports2.evaluatedPropsToName = evaluatedPropsToName;
    function setEvaluated(gen, props, ps) {
      Object.keys(ps).forEach((p) => gen.assign((0, codegen_1._)`${props}${(0, codegen_1.getProperty)(p)}`, true));
    }
    exports2.setEvaluated = setEvaluated;
    var snippets = {};
    function useFunc(gen, f) {
      return gen.scopeValue("func", {
        ref: f,
        code: snippets[f.code] || (snippets[f.code] = new code_1._Code(f.code))
      });
    }
    exports2.useFunc = useFunc;
    var Type3;
    (function (Type4) {
      Type4[Type4["Num"] = 0] = "Num";
      Type4[Type4["Str"] = 1] = "Str";
    })(Type3 = exports2.Type || (exports2.Type = {}));
    function getErrorPath(dataProp, dataPropType, jsPropertySyntax) {
      if (dataProp instanceof codegen_1.Name) {
        const isNumber = dataPropType === Type3.Num;
        return jsPropertySyntax ? isNumber ? (0, codegen_1._)`"[" + ${dataProp} + "]"` : (0, codegen_1._)`"['" + ${dataProp} + "']"` : isNumber ? (0, codegen_1._)`"/" + ${dataProp}` : (0, codegen_1._)`"/" + ${dataProp}.replace(/~/g, "~0").replace(/\\//g, "~1")`;
      }
      return jsPropertySyntax ? (0, codegen_1.getProperty)(dataProp).toString() : "/" + escapeJsonPointer(dataProp);
    }
    exports2.getErrorPath = getErrorPath;
    function checkStrictMode(it, msg, mode = it.opts.strictSchema) {
      if (!mode)
        return;
      msg = `strict mode: ${msg}`;
      if (mode === true)
        throw new Error(msg);
      it.self.logger.warn(msg);
    }
    exports2.checkStrictMode = checkStrictMode;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/names.js
var require_names = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/names.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var names = {
      // validation function arguments
      data: new codegen_1.Name("data"),
      // args passed from referencing schema
      valCxt: new codegen_1.Name("valCxt"),
      instancePath: new codegen_1.Name("instancePath"),
      parentData: new codegen_1.Name("parentData"),
      parentDataProperty: new codegen_1.Name("parentDataProperty"),
      rootData: new codegen_1.Name("rootData"),
      dynamicAnchors: new codegen_1.Name("dynamicAnchors"),
      isAllOfVariant: new codegen_1.Name("isAllOfVariant"),
      // function scoped variables
      vErrors: new codegen_1.Name("vErrors"),
      errors: new codegen_1.Name("errors"),
      this: new codegen_1.Name("this"),
      // "globals"
      self: new codegen_1.Name("self"),
      scope: new codegen_1.Name("scope"),
      // JTD serialize/parse name for JSON string and position
      json: new codegen_1.Name("json"),
      jsonPos: new codegen_1.Name("jsonPos"),
      jsonLen: new codegen_1.Name("jsonLen"),
      jsonPart: new codegen_1.Name("jsonPart")
    };
    exports2.default = names;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/errors.js
var require_errors = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/errors.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.extendErrors = exports2.resetErrorsCount = exports2.reportExtraError = exports2.reportError = exports2.keyword$DataError = exports2.keywordError = void 0;
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var names_1 = require_names();
    exports2.keywordError = {
      message: ({ keyword }) => (0, codegen_1.str)`must pass "${keyword}" keyword validation`
    };
    exports2.keyword$DataError = {
      message: ({ keyword, schemaType }) => schemaType ? (0, codegen_1.str)`"${keyword}" keyword must be ${schemaType} ($data)` : (0, codegen_1.str)`"${keyword}" keyword is invalid ($data)`
    };
    function reportError(cxt, error = exports2.keywordError, errorPaths, overrideAllErrors) {
      const { it } = cxt;
      const { gen, compositeRule, allErrors } = it;
      const errObj = errorObjectCode(cxt, error, errorPaths);
      if (overrideAllErrors !== null && overrideAllErrors !== void 0 ? overrideAllErrors : compositeRule || allErrors) {
        addError(gen, errObj);
      } else {
        returnErrors(it, (0, codegen_1._)`[${errObj}]`);
      }
    }
    exports2.reportError = reportError;
    function reportExtraError(cxt, error = exports2.keywordError, errorPaths) {
      const { it } = cxt;
      const { gen, compositeRule, allErrors } = it;
      const errObj = errorObjectCode(cxt, error, errorPaths);
      addError(gen, errObj);
      if (!(compositeRule || allErrors)) {
        returnErrors(it, names_1.default.vErrors);
      }
    }
    exports2.reportExtraError = reportExtraError;
    function resetErrorsCount(gen, errsCount) {
      gen.assign(names_1.default.errors, errsCount);
      gen.if((0, codegen_1._)`${names_1.default.vErrors} !== null`, () => gen.if(errsCount, () => gen.assign((0, codegen_1._)`${names_1.default.vErrors}.length`, errsCount), () => gen.assign(names_1.default.vErrors, null)));
    }
    exports2.resetErrorsCount = resetErrorsCount;
    function extendErrors({ gen, keyword, schemaValue, data, errsCount, it }) {
      if (errsCount === void 0)
        throw new Error("ajv implementation error");
      const err = gen.name("err");
      gen.forRange("i", errsCount, names_1.default.errors, (i) => {
        gen.const(err, (0, codegen_1._)`${names_1.default.vErrors}[${i}]`);
        gen.if((0, codegen_1._)`${err}.instancePath === undefined`, () => gen.assign((0, codegen_1._)`${err}.instancePath`, (0, codegen_1.strConcat)(names_1.default.instancePath, it.errorPath)));
        gen.assign((0, codegen_1._)`${err}.schemaPath`, (0, codegen_1.str)`${it.errSchemaPath}/${keyword}`);
        if (it.opts.verbose) {
          gen.assign((0, codegen_1._)`${err}.schema`, schemaValue);
          gen.assign((0, codegen_1._)`${err}.data`, data);
        }
      });
    }
    exports2.extendErrors = extendErrors;
    function addError(gen, errObj) {
      const err = gen.const("err", errObj);
      gen.if((0, codegen_1._)`${names_1.default.vErrors} === null`, () => gen.assign(names_1.default.vErrors, (0, codegen_1._)`[${err}]`), (0, codegen_1._)`${names_1.default.vErrors}.push(${err})`);
      gen.code((0, codegen_1._)`${names_1.default.errors}++`);
    }
    function returnErrors(it, errs) {
      const { gen, validateName: validateName2, schemaEnv } = it;
      if (schemaEnv.$async) {
        gen.throw((0, codegen_1._)`new ${it.ValidationError}(${errs})`);
      } else {
        gen.assign((0, codegen_1._)`${validateName2}.errors`, errs);
        gen.return(false);
      }
    }
    var E = {
      keyword: new codegen_1.Name("keyword"),
      schemaPath: new codegen_1.Name("schemaPath"),
      params: new codegen_1.Name("params"),
      propertyName: new codegen_1.Name("propertyName"),
      message: new codegen_1.Name("message"),
      schema: new codegen_1.Name("schema"),
      parentSchema: new codegen_1.Name("parentSchema")
    };
    function errorObjectCode(cxt, error, errorPaths) {
      const { createErrors } = cxt.it;
      if (createErrors === false)
        return (0, codegen_1._)`{}`;
      return errorObject(cxt, error, errorPaths);
    }
    function errorObject(cxt, error, errorPaths = {}) {
      const { gen, it } = cxt;
      const keyValues = [
        errorInstancePath(it, errorPaths),
        errorSchemaPath(cxt, errorPaths)
      ];
      extraErrorProps(cxt, error, keyValues);
      return gen.object(...keyValues);
    }
    function errorInstancePath({ errorPath }, { instancePath }) {
      const instPath = instancePath ? (0, codegen_1.str)`${errorPath}${(0, util_1.getErrorPath)(instancePath, util_1.Type.Str)}` : errorPath;
      return [names_1.default.instancePath, (0, codegen_1.strConcat)(names_1.default.instancePath, instPath)];
    }
    function errorSchemaPath({ keyword, it: { errSchemaPath } }, { schemaPath, parentSchema }) {
      let schPath = parentSchema ? errSchemaPath : (0, codegen_1.str)`${errSchemaPath}/${keyword}`;
      if (schemaPath) {
        schPath = (0, codegen_1.str)`${schPath}${(0, util_1.getErrorPath)(schemaPath, util_1.Type.Str)}`;
      }
      return [E.schemaPath, schPath];
    }
    function extraErrorProps(cxt, { params, message }, keyValues) {
      const { keyword, data, schemaValue, it } = cxt;
      const { opts, propertyName, topSchemaRef, schemaPath } = it;
      keyValues.push([E.keyword, keyword], [E.params, typeof params == "function" ? params(cxt) : params || (0, codegen_1._)`{}`]);
      if (opts.messages) {
        keyValues.push([E.message, typeof message == "function" ? message(cxt) : message]);
      }
      if (opts.verbose) {
        keyValues.push([E.schema, schemaValue], [E.parentSchema, (0, codegen_1._)`${topSchemaRef}${schemaPath}`], [names_1.default.data, data]);
      }
      if (propertyName)
        keyValues.push([E.propertyName, propertyName]);
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/boolSchema.js
var require_boolSchema = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/boolSchema.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.boolOrEmptySchema = exports2.topBoolOrEmptySchema = void 0;
    var errors_1 = require_errors();
    var codegen_1 = require_codegen();
    var names_1 = require_names();
    var boolError = {
      message: "boolean schema is false"
    };
    function topBoolOrEmptySchema(it) {
      const { gen, schema: schema2, validateName: validateName2 } = it;
      if (schema2 === false) {
        falseSchemaError(it, false);
      } else if (typeof schema2 == "object" && schema2.$async === true) {
        gen.return(names_1.default.data);
      } else {
        gen.assign((0, codegen_1._)`${validateName2}.errors`, null);
        gen.return(true);
      }
    }
    exports2.topBoolOrEmptySchema = topBoolOrEmptySchema;
    function boolOrEmptySchema(it, valid) {
      const { gen, schema: schema2 } = it;
      if (schema2 === false) {
        gen.var(valid, false);
        falseSchemaError(it);
      } else {
        gen.var(valid, true);
      }
    }
    exports2.boolOrEmptySchema = boolOrEmptySchema;
    function falseSchemaError(it, overrideAllErrors) {
      const { gen, data } = it;
      const cxt = {
        gen,
        keyword: "false schema",
        data,
        schema: false,
        schemaCode: false,
        schemaValue: false,
        params: {},
        it
      };
      (0, errors_1.reportError)(cxt, boolError, void 0, overrideAllErrors);
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/rules.js
var require_rules2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/rules.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getRules = exports2.isJSONType = void 0;
    var _jsonTypes = ["string", "number", "integer", "boolean", "null", "object", "array"];
    var jsonTypes = new Set(_jsonTypes);
    function isJSONType(x) {
      return typeof x == "string" && jsonTypes.has(x);
    }
    exports2.isJSONType = isJSONType;
    function getRules() {
      const groups = {
        number: { type: "number", rules: [] },
        string: { type: "string", rules: [] },
        array: { type: "array", rules: [] },
        object: { type: "object", rules: [] }
      };
      return {
        types: { ...groups, integer: true, boolean: true, null: true },
        rules: [{ rules: [] }, groups.number, groups.string, groups.array, groups.object],
        post: { rules: [] },
        all: {},
        keywords: {}
      };
    }
    exports2.getRules = getRules;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/applicability.js
var require_applicability = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/applicability.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.shouldUseRule = exports2.shouldUseGroup = exports2.schemaHasRulesForType = void 0;
    function schemaHasRulesForType({ schema: schema2, self: self2 }, type2) {
      const group = self2.RULES.types[type2];
      return group && group !== true && shouldUseGroup(schema2, group);
    }
    exports2.schemaHasRulesForType = schemaHasRulesForType;
    function shouldUseGroup(schema2, group) {
      return group.rules.some((rule) => shouldUseRule(schema2, rule));
    }
    exports2.shouldUseGroup = shouldUseGroup;
    function shouldUseRule(schema2, rule) {
      var _a;
      return schema2[rule.keyword] !== void 0 || ((_a = rule.definition.implements) === null || _a === void 0 ? void 0 : _a.some((kwd) => schema2[kwd] !== void 0));
    }
    exports2.shouldUseRule = shouldUseRule;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/dataType.js
var require_dataType = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/dataType.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.reportTypeError = exports2.checkDataTypes = exports2.checkDataType = exports2.coerceAndCheckDataType = exports2.getJSONTypes = exports2.getSchemaTypes = exports2.DataType = void 0;
    var rules_1 = require_rules2();
    var applicability_1 = require_applicability();
    var errors_1 = require_errors();
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var DataType;
    (function (DataType2) {
      DataType2[DataType2["Correct"] = 0] = "Correct";
      DataType2[DataType2["Wrong"] = 1] = "Wrong";
    })(DataType = exports2.DataType || (exports2.DataType = {}));
    function getSchemaTypes(schema2) {
      const types2 = getJSONTypes(schema2.type);
      const hasNull = types2.includes("null");
      if (hasNull) {
        if (schema2.nullable === false)
          throw new Error("type: null contradicts nullable: false");
      } else {
        if (!types2.length && schema2.nullable !== void 0) {
          throw new Error('"nullable" cannot be used without "type"');
        }
        if (schema2.nullable === true)
          types2.push("null");
      }
      return types2;
    }
    exports2.getSchemaTypes = getSchemaTypes;
    function getJSONTypes(ts) {
      const types2 = Array.isArray(ts) ? ts : ts ? [ts] : [];
      if (types2.every(rules_1.isJSONType))
        return types2;
      throw new Error("type must be JSONType or JSONType[]: " + types2.join(","));
    }
    exports2.getJSONTypes = getJSONTypes;
    function coerceAndCheckDataType(it, types2) {
      const { gen, data, opts } = it;
      const coerceTo = coerceToTypes(types2, opts.coerceTypes);
      const checkTypes = types2.length > 0 && !(coerceTo.length === 0 && types2.length === 1 && (0, applicability_1.schemaHasRulesForType)(it, types2[0]));
      if (checkTypes) {
        const wrongType = checkDataTypes(types2, data, opts.strictNumbers, DataType.Wrong);
        gen.if(wrongType, () => {
          if (coerceTo.length)
            coerceData(it, types2, coerceTo);
          else
            reportTypeError(it);
        });
      }
      return checkTypes;
    }
    exports2.coerceAndCheckDataType = coerceAndCheckDataType;
    var COERCIBLE = /* @__PURE__ */ new Set(["string", "number", "integer", "boolean", "null"]);
    function coerceToTypes(types2, coerceTypes) {
      return coerceTypes ? types2.filter((t) => COERCIBLE.has(t) || coerceTypes === "array" && t === "array") : [];
    }
    function coerceData(it, types2, coerceTo) {
      const { gen, data, opts } = it;
      const dataType = gen.let("dataType", (0, codegen_1._)`typeof ${data}`);
      const coerced = gen.let("coerced", (0, codegen_1._)`undefined`);
      if (opts.coerceTypes === "array") {
        gen.if((0, codegen_1._)`${dataType} == 'object' && Array.isArray(${data}) && ${data}.length == 1`, () => gen.assign(data, (0, codegen_1._)`${data}[0]`).assign(dataType, (0, codegen_1._)`typeof ${data}`).if(checkDataTypes(types2, data, opts.strictNumbers), () => gen.assign(coerced, data)));
      }
      gen.if((0, codegen_1._)`${coerced} !== undefined`);
      for (const t of coerceTo) {
        if (COERCIBLE.has(t) || t === "array" && opts.coerceTypes === "array") {
          coerceSpecificType(t);
        }
      }
      gen.else();
      reportTypeError(it);
      gen.endIf();
      gen.if((0, codegen_1._)`${coerced} !== undefined`, () => {
        gen.assign(data, coerced);
        assignParentData(it, coerced);
      });
      function coerceSpecificType(t) {
        switch (t) {
          case "string":
            gen.elseIf((0, codegen_1._)`${dataType} == "number" || ${dataType} == "boolean"`).assign(coerced, (0, codegen_1._)`"" + ${data}`).elseIf((0, codegen_1._)`${data} === null`).assign(coerced, (0, codegen_1._)`""`);
            return;
          case "number":
            gen.elseIf((0, codegen_1._)`${dataType} == "boolean" || ${data} === null
              || (${dataType} == "string" && ${data} && ${data} == +${data})`).assign(coerced, (0, codegen_1._)`+${data}`);
            return;
          case "integer":
            gen.elseIf((0, codegen_1._)`${dataType} === "boolean" || ${data} === null
              || (${dataType} === "string" && ${data} && ${data} == +${data} && !(${data} % 1))`).assign(coerced, (0, codegen_1._)`+${data}`);
            return;
          case "boolean":
            gen.elseIf((0, codegen_1._)`${data} === "false" || ${data} === 0 || ${data} === null`).assign(coerced, false).elseIf((0, codegen_1._)`${data} === "true" || ${data} === 1`).assign(coerced, true);
            return;
          case "null":
            gen.elseIf((0, codegen_1._)`${data} === "" || ${data} === 0 || ${data} === false`);
            gen.assign(coerced, null);
            return;
          case "array":
            gen.elseIf((0, codegen_1._)`${dataType} === "string" || ${dataType} === "number"
              || ${dataType} === "boolean" || ${data} === null`).assign(coerced, (0, codegen_1._)`[${data}]`);
        }
      }
    }
    function assignParentData({ gen, parentData, parentDataProperty }, expr) {
      gen.if((0, codegen_1._)`${parentData} !== undefined`, () => gen.assign((0, codegen_1._)`${parentData}[${parentDataProperty}]`, expr));
    }
    function checkDataType(dataType, data, strictNums, correct = DataType.Correct) {
      const EQ = correct === DataType.Correct ? codegen_1.operators.EQ : codegen_1.operators.NEQ;
      let cond;
      switch (dataType) {
        case "null":
          return (0, codegen_1._)`${data} ${EQ} null`;
        case "array":
          cond = (0, codegen_1._)`Array.isArray(${data})`;
          break;
        case "object":
          cond = (0, codegen_1._)`${data} && typeof ${data} == "object" && !Array.isArray(${data})`;
          break;
        case "integer":
          cond = numCond((0, codegen_1._)`!(${data} % 1) && !isNaN(${data})`);
          break;
        case "number":
          cond = numCond();
          break;
        default:
          return (0, codegen_1._)`typeof ${data} ${EQ} ${dataType}`;
      }
      return correct === DataType.Correct ? cond : (0, codegen_1.not)(cond);
      function numCond(_cond = codegen_1.nil) {
        return (0, codegen_1.and)((0, codegen_1._)`typeof ${data} == "number"`, _cond, strictNums ? (0, codegen_1._)`isFinite(${data})` : codegen_1.nil);
      }
    }
    exports2.checkDataType = checkDataType;
    function checkDataTypes(dataTypes, data, strictNums, correct) {
      if (dataTypes.length === 1) {
        return checkDataType(dataTypes[0], data, strictNums, correct);
      }
      let cond;
      const types2 = (0, util_1.toHash)(dataTypes);
      if (types2.array && types2.object) {
        const notObj = (0, codegen_1._)`typeof ${data} != "object"`;
        cond = types2.null ? notObj : (0, codegen_1._)`!${data} || ${notObj}`;
        delete types2.null;
        delete types2.array;
        delete types2.object;
      } else {
        cond = codegen_1.nil;
      }
      if (types2.number)
        delete types2.integer;
      for (const t in types2)
        cond = (0, codegen_1.and)(cond, checkDataType(t, data, strictNums, correct));
      return cond;
    }
    exports2.checkDataTypes = checkDataTypes;
    var typeError = {
      message: ({ schema: schema2 }) => `must be ${schema2}`,
      params: ({ schema: schema2, schemaValue }) => typeof schema2 == "string" ? (0, codegen_1._)`{type: ${schema2}}` : (0, codegen_1._)`{type: ${schemaValue}}`
    };
    function reportTypeError(it) {
      const cxt = getTypeErrorContext(it);
      (0, errors_1.reportError)(cxt, typeError);
    }
    exports2.reportTypeError = reportTypeError;
    function getTypeErrorContext(it) {
      const { gen, data, schema: schema2 } = it;
      const schemaCode = (0, util_1.schemaRefOrVal)(it, schema2, "type");
      return {
        gen,
        keyword: "type",
        data,
        schema: schema2.type,
        schemaCode,
        schemaValue: schemaCode,
        parentSchema: schema2,
        params: {},
        it
      };
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/defaults.js
var require_defaults = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/defaults.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.assignDefaults = void 0;
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    function assignDefaults(it, ty) {
      const { properties, items } = it.schema;
      if (ty === "object" && properties) {
        for (const key in properties) {
          assignDefault(it, key, properties[key].default);
        }
      } else if (ty === "array" && Array.isArray(items)) {
        items.forEach((sch, i) => assignDefault(it, i, sch.default));
      }
    }
    exports2.assignDefaults = assignDefaults;
    function assignDefault(it, prop, defaultValue) {
      const { gen, compositeRule, data, opts } = it;
      if (defaultValue === void 0)
        return;
      const childData = (0, codegen_1._)`${data}${(0, codegen_1.getProperty)(prop)}`;
      if (compositeRule) {
        (0, util_1.checkStrictMode)(it, `default is ignored for: ${childData}`);
        return;
      }
      let condition = (0, codegen_1._)`${childData} === undefined`;
      if (opts.useDefaults === "empty") {
        condition = (0, codegen_1._)`${condition} || ${childData} === null || ${childData} === ""`;
      }
      gen.if(condition, (0, codegen_1._)`${childData} = ${(0, codegen_1.stringify)(defaultValue)}`);
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/code.js
var require_code2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/code.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.validateUnion = exports2.validateArray = exports2.usePattern = exports2.callValidateCode = exports2.schemaProperties = exports2.allSchemaProperties = exports2.noPropertyInData = exports2.propertyInData = exports2.isOwnProperty = exports2.hasPropFunc = exports2.reportMissingProp = exports2.checkMissingProp = exports2.checkReportMissingProp = void 0;
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var names_1 = require_names();
    var util_2 = require_util();
    function checkReportMissingProp(cxt, prop) {
      const { gen, data, it } = cxt;
      gen.if(noPropertyInData(gen, data, prop, it.opts.ownProperties), () => {
        cxt.setParams({ missingProperty: (0, codegen_1._)`${prop}` }, true);
        cxt.error();
      });
    }
    exports2.checkReportMissingProp = checkReportMissingProp;
    function checkMissingProp({ gen, data, it: { opts } }, properties, missing) {
      return (0, codegen_1.or)(...properties.map((prop) => (0, codegen_1.and)(noPropertyInData(gen, data, prop, opts.ownProperties), (0, codegen_1._)`${missing} = ${prop}`)));
    }
    exports2.checkMissingProp = checkMissingProp;
    function reportMissingProp(cxt, missing) {
      cxt.setParams({ missingProperty: missing }, true);
      cxt.error();
    }
    exports2.reportMissingProp = reportMissingProp;
    function hasPropFunc(gen) {
      return gen.scopeValue("func", {
        // eslint-disable-next-line @typescript-eslint/unbound-method
        ref: Object.prototype.hasOwnProperty,
        code: (0, codegen_1._)`Object.prototype.hasOwnProperty`
      });
    }
    exports2.hasPropFunc = hasPropFunc;
    function isOwnProperty(gen, data, property4) {
      return (0, codegen_1._)`${hasPropFunc(gen)}.call(${data}, ${property4})`;
    }
    exports2.isOwnProperty = isOwnProperty;
    function propertyInData(gen, data, property4, ownProperties) {
      const cond = (0, codegen_1._)`${data}${(0, codegen_1.getProperty)(property4)} !== undefined`;
      return ownProperties ? (0, codegen_1._)`${cond} && ${isOwnProperty(gen, data, property4)}` : cond;
    }
    exports2.propertyInData = propertyInData;
    function noPropertyInData(gen, data, property4, ownProperties) {
      const cond = (0, codegen_1._)`${data}${(0, codegen_1.getProperty)(property4)} === undefined`;
      return ownProperties ? (0, codegen_1.or)(cond, (0, codegen_1.not)(isOwnProperty(gen, data, property4))) : cond;
    }
    exports2.noPropertyInData = noPropertyInData;
    function allSchemaProperties(schemaMap) {
      return schemaMap ? Object.keys(schemaMap).filter((p) => p !== "__proto__") : [];
    }
    exports2.allSchemaProperties = allSchemaProperties;
    function schemaProperties(it, schemaMap) {
      return allSchemaProperties(schemaMap).filter((p) => !(0, util_1.alwaysValidSchema)(it, schemaMap[p]));
    }
    exports2.schemaProperties = schemaProperties;
    function callValidateCode({ schemaCode, data, it: { gen, topSchemaRef, schemaPath, errorPath }, it }, func, context, passSchema) {
      const dataAndSchema = passSchema ? (0, codegen_1._)`${schemaCode}, ${data}, ${topSchemaRef}${schemaPath}` : data;
      const valCxt = [
        [names_1.default.instancePath, (0, codegen_1.strConcat)(names_1.default.instancePath, errorPath)],
        [names_1.default.parentData, it.parentData],
        [names_1.default.parentDataProperty, it.parentDataProperty],
        [names_1.default.rootData, names_1.default.rootData],
        [names_1.default.isAllOfVariant, it.isAllOfVariant ? 1 : 0]
      ];
      if (it.opts.dynamicRef)
        valCxt.push([names_1.default.dynamicAnchors, names_1.default.dynamicAnchors]);
      const args = (0, codegen_1._)`${dataAndSchema}, ${gen.object(...valCxt)}`;
      return context !== codegen_1.nil ? (0, codegen_1._)`${func}.call(${context}, ${args})` : (0, codegen_1._)`${func}(${args})`;
    }
    exports2.callValidateCode = callValidateCode;
    var newRegExp = (0, codegen_1._)`new RegExp`;
    function usePattern({ gen, it: { opts } }, pattern) {
      const u = opts.unicodeRegExp ? "u" : "";
      const { regExp } = opts.code;
      const rx = regExp(pattern, u);
      return gen.scopeValue("pattern", {
        key: rx.toString(),
        ref: rx,
        code: (0, codegen_1._)`${regExp.code === "new RegExp" ? newRegExp : (0, util_2.useFunc)(gen, regExp)}(${pattern}, ${u})`
      });
    }
    exports2.usePattern = usePattern;
    function validateArray(cxt) {
      const { gen, data, keyword, it } = cxt;
      const valid = gen.name("valid");
      if (it.allErrors) {
        const validArr = gen.let("valid", true);
        validateItems(() => gen.assign(validArr, false));
        return validArr;
      }
      gen.var(valid, true);
      validateItems(() => gen.break());
      return valid;
      function validateItems(notValid) {
        const len = gen.const("len", (0, codegen_1._)`${data}.length`);
        gen.forRange("i", 0, len, (i) => {
          cxt.subschema({
            keyword,
            dataProp: i,
            dataPropType: util_1.Type.Num
          }, valid);
          gen.if((0, codegen_1.not)(valid), notValid);
        });
      }
    }
    exports2.validateArray = validateArray;
    function validateUnion(cxt) {
      const { gen, schema: schema2, keyword, parentSchema, it } = cxt;
      if (!Array.isArray(schema2))
        throw new Error("ajv implementation error");
      if (it.opts.discriminator && parentSchema.discriminator)
        return;
      const alwaysValid = schema2.some((sch) => (0, util_1.alwaysValidSchema)(it, sch));
      if (alwaysValid && !it.opts.unevaluated)
        return;
      const valid = gen.let("valid", false);
      const schValid = gen.name("_valid");
      gen.block(() => schema2.forEach((_sch, i) => {
        const schCxt = cxt.subschema({
          keyword,
          schemaProp: i,
          compositeRule: true
        }, schValid);
        gen.assign(valid, (0, codegen_1._)`${valid} || ${schValid}`);
        const merged = cxt.mergeValidEvaluated(schCxt, schValid);
        if (!merged)
          gen.if((0, codegen_1.not)(valid));
      }));
      cxt.result(valid, () => cxt.reset(), () => cxt.error(true));
    }
    exports2.validateUnion = validateUnion;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/keyword.js
var require_keyword = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/keyword.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.validateKeywordUsage = exports2.validSchemaType = exports2.funcKeywordCode = exports2.macroKeywordCode = void 0;
    var codegen_1 = require_codegen();
    var names_1 = require_names();
    var code_1 = require_code2();
    var errors_1 = require_errors();
    function macroKeywordCode(cxt, def) {
      const { gen, keyword, schema: schema2, parentSchema, it } = cxt;
      const macroSchema = def.macro.call(it.self, schema2, parentSchema, it);
      const schemaRef = useKeyword(gen, keyword, macroSchema);
      if (it.opts.validateSchema !== false)
        it.self.validateSchema(macroSchema, true);
      const valid = gen.name("valid");
      cxt.subschema({
        schema: macroSchema,
        schemaPath: codegen_1.nil,
        errSchemaPath: `${it.errSchemaPath}/${keyword}`,
        topSchemaRef: schemaRef,
        compositeRule: true
      }, valid);
      cxt.pass(valid, () => cxt.error(true));
    }
    exports2.macroKeywordCode = macroKeywordCode;
    function funcKeywordCode(cxt, def) {
      var _a;
      const { gen, keyword, schema: schema2, parentSchema, $data, it } = cxt;
      checkAsyncKeyword(it, def);
      const validate = !$data && def.compile ? def.compile.call(it.self, schema2, parentSchema, it) : def.validate;
      const validateRef = useKeyword(gen, keyword, validate);
      const valid = gen.let("valid");
      cxt.block$data(valid, validateKeyword);
      cxt.ok((_a = def.valid) !== null && _a !== void 0 ? _a : valid);
      function validateKeyword() {
        if (def.errors === false) {
          assignValid();
          if (def.modifying)
            modifyData(cxt);
          reportErrs(() => cxt.error());
        } else {
          const ruleErrs = def.async ? validateAsync() : validateSync();
          if (def.modifying)
            modifyData(cxt);
          reportErrs(() => addErrs(cxt, ruleErrs));
        }
      }
      function validateAsync() {
        const ruleErrs = gen.let("ruleErrs", null);
        gen.try(() => assignValid((0, codegen_1._)`await `), (e) => gen.assign(valid, false).if((0, codegen_1._)`${e} instanceof ${it.ValidationError}`, () => gen.assign(ruleErrs, (0, codegen_1._)`${e}.errors`), () => gen.throw(e)));
        return ruleErrs;
      }
      function validateSync() {
        const validateErrs = (0, codegen_1._)`${validateRef}.errors`;
        gen.assign(validateErrs, null);
        assignValid(codegen_1.nil);
        return validateErrs;
      }
      function assignValid(_await = def.async ? (0, codegen_1._)`await ` : codegen_1.nil) {
        const passCxt = it.opts.passContext ? names_1.default.this : names_1.default.self;
        const passSchema = !("compile" in def && !$data || def.schema === false);
        gen.assign(valid, (0, codegen_1._)`${_await}${(0, code_1.callValidateCode)(cxt, validateRef, passCxt, passSchema)}`, def.modifying);
      }
      function reportErrs(errors) {
        var _a2;
        gen.if((0, codegen_1.not)((_a2 = def.valid) !== null && _a2 !== void 0 ? _a2 : valid), errors);
      }
    }
    exports2.funcKeywordCode = funcKeywordCode;
    function modifyData(cxt) {
      const { gen, data, it } = cxt;
      gen.if(it.parentData, () => gen.assign(data, (0, codegen_1._)`${it.parentData}[${it.parentDataProperty}]`));
    }
    function addErrs(cxt, errs) {
      const { gen } = cxt;
      gen.if((0, codegen_1._)`Array.isArray(${errs})`, () => {
        gen.assign(names_1.default.vErrors, (0, codegen_1._)`${names_1.default.vErrors} === null ? ${errs} : ${names_1.default.vErrors}.concat(${errs})`).assign(names_1.default.errors, (0, codegen_1._)`${names_1.default.vErrors}.length`);
        (0, errors_1.extendErrors)(cxt);
      }, () => cxt.error());
    }
    function checkAsyncKeyword({ schemaEnv }, def) {
      if (def.async && !schemaEnv.$async)
        throw new Error("async keyword in sync schema");
    }
    function useKeyword(gen, keyword, result) {
      if (result === void 0)
        throw new Error(`keyword "${keyword}" failed to compile`);
      return gen.scopeValue("keyword", typeof result == "function" ? { ref: result } : { ref: result, code: (0, codegen_1.stringify)(result) });
    }
    function validSchemaType(schema2, schemaType, allowUndefined = false) {
      return !schemaType.length || schemaType.some((st) => st === "array" ? Array.isArray(schema2) : st === "object" ? schema2 && typeof schema2 == "object" && !Array.isArray(schema2) : typeof schema2 == st || allowUndefined && typeof schema2 == "undefined");
    }
    exports2.validSchemaType = validSchemaType;
    function validateKeywordUsage({ schema: schema2, opts, self: self2, errSchemaPath }, def, keyword) {
      if (Array.isArray(def.keyword) ? !def.keyword.includes(keyword) : def.keyword !== keyword) {
        throw new Error("ajv implementation error");
      }
      const deps = def.dependencies;
      if (deps === null || deps === void 0 ? void 0 : deps.some((kwd) => !Object.prototype.hasOwnProperty.call(schema2, kwd))) {
        throw new Error(`parent schema must have dependencies of ${keyword}: ${deps.join(",")}`);
      }
      if (def.validateSchema) {
        const valid = def.validateSchema(schema2[keyword]);
        if (!valid) {
          const msg = `keyword "${keyword}" value is invalid at path "${errSchemaPath}": ` + self2.errorsText(def.validateSchema.errors);
          if (opts.validateSchema === "log")
            self2.logger.error(msg);
          else
            throw new Error(msg);
        }
      }
    }
    exports2.validateKeywordUsage = validateKeywordUsage;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/subschema.js
var require_subschema = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/subschema.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.extendSubschemaMode = exports2.extendSubschemaData = exports2.getSubschema = void 0;
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    function getSubschema(it, { keyword, schemaProp, schema: schema2, schemaPath, errSchemaPath, topSchemaRef }) {
      if (keyword !== void 0 && schema2 !== void 0) {
        throw new Error('both "keyword" and "schema" passed, only one allowed');
      }
      if (keyword !== void 0) {
        const sch = it.schema[keyword];
        return schemaProp === void 0 ? {
          schema: sch,
          schemaPath: (0, codegen_1._)`${it.schemaPath}${(0, codegen_1.getProperty)(keyword)}`,
          errSchemaPath: `${it.errSchemaPath}/${keyword}`
        } : {
          schema: sch[schemaProp],
          schemaPath: (0, codegen_1._)`${it.schemaPath}${(0, codegen_1.getProperty)(keyword)}${(0, codegen_1.getProperty)(schemaProp)}`,
          errSchemaPath: `${it.errSchemaPath}/${keyword}/${(0, util_1.escapeFragment)(schemaProp)}`
        };
      }
      if (schema2 !== void 0) {
        if (schemaPath === void 0 || errSchemaPath === void 0 || topSchemaRef === void 0) {
          throw new Error('"schemaPath", "errSchemaPath" and "topSchemaRef" are required with "schema"');
        }
        return {
          schema: schema2,
          schemaPath,
          topSchemaRef,
          errSchemaPath
        };
      }
      throw new Error('either "keyword" or "schema" must be passed');
    }
    exports2.getSubschema = getSubschema;
    function extendSubschemaData(subschema, it, { dataProp, dataPropType: dpType, data, dataTypes, propertyName }) {
      if (data !== void 0 && dataProp !== void 0) {
        throw new Error('both "data" and "dataProp" passed, only one allowed');
      }
      const { gen } = it;
      if (dataProp !== void 0) {
        const { errorPath, dataPathArr, opts } = it;
        const nextData = gen.let("data", (0, codegen_1._)`${it.data}${(0, codegen_1.getProperty)(dataProp)}`, true);
        dataContextProps(nextData);
        subschema.errorPath = (0, codegen_1.str)`${errorPath}${(0, util_1.getErrorPath)(dataProp, dpType, opts.jsPropertySyntax)}`;
        subschema.parentDataProperty = (0, codegen_1._)`${dataProp}`;
        subschema.dataPathArr = [...dataPathArr, subschema.parentDataProperty];
      }
      if (data !== void 0) {
        const nextData = data instanceof codegen_1.Name ? data : gen.let("data", data, true);
        dataContextProps(nextData);
        if (propertyName !== void 0)
          subschema.propertyName = propertyName;
      }
      if (dataTypes)
        subschema.dataTypes = dataTypes;
      function dataContextProps(_nextData) {
        subschema.data = _nextData;
        subschema.dataLevel = it.dataLevel + 1;
        subschema.dataTypes = [];
        it.definedProperties = /* @__PURE__ */ new Set();
        subschema.parentData = it.data;
        subschema.dataNames = [...it.dataNames, _nextData];
      }
    }
    exports2.extendSubschemaData = extendSubschemaData;
    function extendSubschemaMode(subschema, { jtdDiscriminator, jtdMetadata, compositeRule, createErrors, allErrors }) {
      if (compositeRule !== void 0)
        subschema.compositeRule = compositeRule;
      if (createErrors !== void 0)
        subschema.createErrors = createErrors;
      if (allErrors !== void 0)
        subschema.allErrors = allErrors;
      subschema.jtdDiscriminator = jtdDiscriminator;
      subschema.jtdMetadata = jtdMetadata;
    }
    exports2.extendSubschemaMode = extendSubschemaMode;
  }
});

// ../../../node_modules/.pnpm/fast-deep-equal@3.1.3/node_modules/fast-deep-equal/index.js
var require_fast_deep_equal = __commonJS({
  "../../../node_modules/.pnpm/fast-deep-equal@3.1.3/node_modules/fast-deep-equal/index.js"(exports2, module2) {
    "use strict";
    module2.exports = function equal(a, b) {
      if (a === b) return true;
      if (a && b && typeof a == "object" && typeof b == "object") {
        if (a.constructor !== b.constructor) return false;
        var length, i, keys5;
        if (Array.isArray(a)) {
          length = a.length;
          if (length != b.length) return false;
          for (i = length; i-- !== 0;)
            if (!equal(a[i], b[i])) return false;
          return true;
        }
        if (a.constructor === RegExp) return a.source === b.source && a.flags === b.flags;
        if (a.valueOf !== Object.prototype.valueOf) return a.valueOf() === b.valueOf();
        if (a.toString !== Object.prototype.toString) return a.toString() === b.toString();
        keys5 = Object.keys(a);
        length = keys5.length;
        if (length !== Object.keys(b).length) return false;
        for (i = length; i-- !== 0;)
          if (!Object.prototype.hasOwnProperty.call(b, keys5[i])) return false;
        for (i = length; i-- !== 0;) {
          var key = keys5[i];
          if (!equal(a[key], b[key])) return false;
        }
        return true;
      }
      return a !== a && b !== b;
    };
  }
});

// ../../../node_modules/.pnpm/json-schema-traverse@1.0.0/node_modules/json-schema-traverse/index.js
var require_json_schema_traverse = __commonJS({
  "../../../node_modules/.pnpm/json-schema-traverse@1.0.0/node_modules/json-schema-traverse/index.js"(exports2, module2) {
    "use strict";
    var traverse = module2.exports = function (schema2, opts, cb) {
      if (typeof opts == "function") {
        cb = opts;
        opts = {};
      }
      cb = opts.cb || cb;
      var pre = typeof cb == "function" ? cb : cb.pre || function () {
      };
      var post = cb.post || function () {
      };
      _traverse(opts, pre, post, schema2, "", schema2);
    };
    traverse.keywords = {
      additionalItems: true,
      items: true,
      contains: true,
      additionalProperties: true,
      propertyNames: true,
      not: true,
      if: true,
      then: true,
      else: true
    };
    traverse.arrayKeywords = {
      items: true,
      allOf: true,
      anyOf: true,
      oneOf: true
    };
    traverse.propsKeywords = {
      $defs: true,
      definitions: true,
      properties: true,
      patternProperties: true,
      dependencies: true
    };
    traverse.skipKeywords = {
      default: true,
      enum: true,
      const: true,
      required: true,
      maximum: true,
      minimum: true,
      exclusiveMaximum: true,
      exclusiveMinimum: true,
      multipleOf: true,
      maxLength: true,
      minLength: true,
      pattern: true,
      format: true,
      maxItems: true,
      minItems: true,
      uniqueItems: true,
      maxProperties: true,
      minProperties: true
    };
    function _traverse(opts, pre, post, schema2, jsonPtr, rootSchema, parentJsonPtr, parentKeyword, parentSchema, keyIndex) {
      if (schema2 && typeof schema2 == "object" && !Array.isArray(schema2)) {
        pre(schema2, jsonPtr, rootSchema, parentJsonPtr, parentKeyword, parentSchema, keyIndex);
        for (var key in schema2) {
          var sch = schema2[key];
          if (Array.isArray(sch)) {
            if (key in traverse.arrayKeywords) {
              for (var i = 0; i < sch.length; i++)
                _traverse(opts, pre, post, sch[i], jsonPtr + "/" + key + "/" + i, rootSchema, jsonPtr, key, schema2, i);
            }
          } else if (key in traverse.propsKeywords) {
            if (sch && typeof sch == "object") {
              for (var prop in sch)
                _traverse(opts, pre, post, sch[prop], jsonPtr + "/" + key + "/" + escapeJsonPtr(prop), rootSchema, jsonPtr, key, schema2, prop);
            }
          } else if (key in traverse.keywords || opts.allKeys && !(key in traverse.skipKeywords)) {
            _traverse(opts, pre, post, sch, jsonPtr + "/" + key, rootSchema, jsonPtr, key, schema2);
          }
        }
        post(schema2, jsonPtr, rootSchema, parentJsonPtr, parentKeyword, parentSchema, keyIndex);
      }
    }
    function escapeJsonPtr(str2) {
      return str2.replace(/~/g, "~0").replace(/\//g, "~1");
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/resolve.js
var require_resolve = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/resolve.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getSchemaRefs = exports2.resolveUrl = exports2.normalizeId = exports2._getFullPath = exports2.getFullPath = exports2.inlineRef = void 0;
    var util_1 = require_util();
    var equal = require_fast_deep_equal();
    var traverse = require_json_schema_traverse();
    var SIMPLE_INLINED = /* @__PURE__ */ new Set([
      "type",
      "format",
      "pattern",
      "maxLength",
      "minLength",
      "maxProperties",
      "minProperties",
      "maxItems",
      "minItems",
      "maximum",
      "minimum",
      "uniqueItems",
      "multipleOf",
      "required",
      "enum",
      "const"
    ]);
    function inlineRef(schema2, limit = true) {
      if (typeof schema2 == "boolean")
        return true;
      if (limit === true)
        return !hasRef(schema2);
      if (!limit)
        return false;
      return countKeys(schema2) <= limit;
    }
    exports2.inlineRef = inlineRef;
    var REF_KEYWORDS = /* @__PURE__ */ new Set([
      "$ref",
      "$recursiveRef",
      "$recursiveAnchor",
      "$dynamicRef",
      "$dynamicAnchor"
    ]);
    function hasRef(schema2) {
      for (const key in schema2) {
        if (REF_KEYWORDS.has(key))
          return true;
        const sch = schema2[key];
        if (Array.isArray(sch) && sch.some(hasRef))
          return true;
        if (typeof sch == "object" && hasRef(sch))
          return true;
      }
      return false;
    }
    function countKeys(schema2) {
      let count = 0;
      for (const key in schema2) {
        if (key === "$ref")
          return Infinity;
        count++;
        if (SIMPLE_INLINED.has(key))
          continue;
        if (typeof schema2[key] == "object") {
          (0, util_1.eachItem)(schema2[key], (sch) => count += countKeys(sch));
        }
        if (count === Infinity)
          return Infinity;
      }
      return count;
    }
    function getFullPath(resolver, id = "", normalize2) {
      if (normalize2 !== false)
        id = normalizeId(id);
      const p = resolver.parse(id);
      return _getFullPath(resolver, p);
    }
    exports2.getFullPath = getFullPath;
    function _getFullPath(resolver, p) {
      const serialized = resolver.serialize(p);
      return serialized.split("#")[0] + "#";
    }
    exports2._getFullPath = _getFullPath;
    var TRAILING_SLASH_HASH = /#\/?$/;
    function normalizeId(id) {
      return id ? id.replace(TRAILING_SLASH_HASH, "") : "";
    }
    exports2.normalizeId = normalizeId;
    function resolveUrl(resolver, baseId, id) {
      id = normalizeId(id);
      return resolver.resolve(baseId, id);
    }
    exports2.resolveUrl = resolveUrl;
    var ANCHOR = /^[a-z_][-a-z0-9._]*$/i;
    function getSchemaRefs(schema2, baseId) {
      if (typeof schema2 == "boolean")
        return {};
      const { schemaId, uriResolver } = this.opts;
      const schId = normalizeId(schema2[schemaId] || baseId);
      const baseIds = { "": schId };
      const pathPrefix = getFullPath(uriResolver, schId, false);
      const localRefs = {};
      const schemaRefs = /* @__PURE__ */ new Set();
      traverse(schema2, { allKeys: true }, (sch, jsonPtr, _, parentJsonPtr) => {
        if (parentJsonPtr === void 0)
          return;
        const fullPath = pathPrefix + jsonPtr;
        let baseId2 = baseIds[parentJsonPtr];
        if (typeof sch[schemaId] == "string")
          baseId2 = addRef.call(this, sch[schemaId]);
        addAnchor.call(this, sch.$anchor);
        addAnchor.call(this, sch.$dynamicAnchor);
        baseIds[jsonPtr] = baseId2;
        function addRef(ref) {
          const _resolve = this.opts.uriResolver.resolve;
          ref = normalizeId(baseId2 ? _resolve(baseId2, ref) : ref);
          if (schemaRefs.has(ref))
            throw ambiguos(ref);
          schemaRefs.add(ref);
          let schOrRef = this.refs[ref];
          if (typeof schOrRef == "string")
            schOrRef = this.refs[schOrRef];
          if (typeof schOrRef == "object") {
            checkAmbiguosRef(sch, schOrRef.schema, ref);
          } else if (ref !== normalizeId(fullPath)) {
            if (ref[0] === "#") {
              checkAmbiguosRef(sch, localRefs[ref], ref);
              localRefs[ref] = sch;
            } else {
              this.refs[ref] = fullPath;
            }
          }
          return ref;
        }
        function addAnchor(anchor) {
          if (typeof anchor == "string") {
            if (!ANCHOR.test(anchor))
              throw new Error(`invalid anchor "${anchor}"`);
            addRef.call(this, `#${anchor}`);
          }
        }
      });
      return localRefs;
      function checkAmbiguosRef(sch1, sch2, ref) {
        if (sch2 !== void 0 && !equal(sch1, sch2))
          throw ambiguos(ref);
      }
      function ambiguos(ref) {
        return new Error(`reference "${ref}" resolves to more than one schema`);
      }
    }
    exports2.getSchemaRefs = getSchemaRefs;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/index.js
var require_validate = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/validate/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getData = exports2.KeywordCxt = exports2.validateFunctionCode = void 0;
    var boolSchema_1 = require_boolSchema();
    var dataType_1 = require_dataType();
    var applicability_1 = require_applicability();
    var dataType_2 = require_dataType();
    var defaults_1 = require_defaults();
    var keyword_1 = require_keyword();
    var subschema_1 = require_subschema();
    var codegen_1 = require_codegen();
    var names_1 = require_names();
    var resolve_1 = require_resolve();
    var util_1 = require_util();
    var errors_1 = require_errors();
    function validateFunctionCode(it) {
      if (isSchemaObj(it)) {
        checkKeywords(it);
        if (schemaCxtHasRules(it)) {
          topSchemaObjCode(it);
          return;
        }
      }
      validateFunction(it, () => (0, boolSchema_1.topBoolOrEmptySchema)(it));
    }
    exports2.validateFunctionCode = validateFunctionCode;
    function validateFunction({ gen, validateName: validateName2, schema: schema2, schemaEnv, opts }, body) {
      if (opts.code.es5) {
        gen.func(validateName2, (0, codegen_1._)`${names_1.default.data}, ${names_1.default.valCxt}`, schemaEnv.$async, () => {
          gen.code((0, codegen_1._)`"use strict"; ${funcSourceUrl(schema2, opts)}`);
          destructureValCxtES5(gen, opts);
          gen.code(body);
        });
      } else {
        gen.func(validateName2, (0, codegen_1._)`${names_1.default.data}, ${destructureValCxt(opts)}`, schemaEnv.$async, () => gen.code(funcSourceUrl(schema2, opts)).code(body));
      }
    }
    function destructureValCxt(opts) {
      return (0, codegen_1._)`{${names_1.default.instancePath}="", ${names_1.default.parentData}, ${names_1.default.parentDataProperty}, ${names_1.default.rootData}=${names_1.default.data}${opts.dynamicRef ? (0, codegen_1._)`, ${names_1.default.dynamicAnchors}={}` : codegen_1.nil}, ${names_1.default.isAllOfVariant} = 0}={}`;
    }
    function destructureValCxtES5(gen, opts) {
      gen.if(names_1.default.valCxt, () => {
        gen.var(names_1.default.instancePath, (0, codegen_1._)`${names_1.default.valCxt}.${names_1.default.instancePath}`);
        gen.var(names_1.default.parentData, (0, codegen_1._)`${names_1.default.valCxt}.${names_1.default.parentData}`);
        gen.var(names_1.default.parentDataProperty, (0, codegen_1._)`${names_1.default.valCxt}.${names_1.default.parentDataProperty}`);
        gen.var(names_1.default.rootData, (0, codegen_1._)`${names_1.default.valCxt}.${names_1.default.rootData}`);
        gen.var(names_1.default.isAllOfVariant, (0, codegen_1._)`${names_1.default.valCxt}.${names_1.default.isAllOfVariant}`);
        if (opts.dynamicRef)
          gen.var(names_1.default.dynamicAnchors, (0, codegen_1._)`${names_1.default.valCxt}.${names_1.default.dynamicAnchors}`);
      }, () => {
        gen.var(names_1.default.instancePath, (0, codegen_1._)`""`);
        gen.var(names_1.default.parentData, (0, codegen_1._)`undefined`);
        gen.var(names_1.default.parentDataProperty, (0, codegen_1._)`undefined`);
        gen.var(names_1.default.rootData, names_1.default.data);
        gen.var(names_1.default.isAllOfVariant, (0, codegen_1._)`0`);
        if (opts.dynamicRef)
          gen.var(names_1.default.dynamicAnchors, (0, codegen_1._)`{}`);
      });
    }
    function topSchemaObjCode(it) {
      const { schema: schema2, opts, gen } = it;
      validateFunction(it, () => {
        if (opts.$comment && schema2.$comment)
          commentKeyword(it);
        checkNoDefault(it);
        gen.let(names_1.default.vErrors, null);
        gen.let(names_1.default.errors, 0);
        if (opts.unevaluated)
          resetEvaluated(it);
        typeAndKeywords(it);
        returnResults(it);
      });
      return;
    }
    function resetEvaluated(it) {
      const { gen, validateName: validateName2 } = it;
      it.evaluated = gen.const("evaluated", (0, codegen_1._)`${validateName2}.evaluated`);
      gen.if((0, codegen_1._)`${it.evaluated}.dynamicProps`, () => gen.assign((0, codegen_1._)`${it.evaluated}.props`, (0, codegen_1._)`undefined`));
      gen.if((0, codegen_1._)`${it.evaluated}.dynamicItems`, () => gen.assign((0, codegen_1._)`${it.evaluated}.items`, (0, codegen_1._)`undefined`));
    }
    function funcSourceUrl(schema2, opts) {
      const schId = typeof schema2 == "object" && schema2[opts.schemaId];
      return schId && (opts.code.source || opts.code.process) ? (0, codegen_1._)`/*# sourceURL=${schId} */` : codegen_1.nil;
    }
    function subschemaCode(it, valid) {
      if (isSchemaObj(it)) {
        checkKeywords(it);
        if (schemaCxtHasRules(it)) {
          subSchemaObjCode(it, valid);
          return;
        }
      }
      (0, boolSchema_1.boolOrEmptySchema)(it, valid);
    }
    function schemaCxtHasRules({ schema: schema2, self: self2 }) {
      if (typeof schema2 == "boolean")
        return !schema2;
      for (const key in schema2)
        if (self2.RULES.all[key])
          return true;
      return false;
    }
    function isSchemaObj(it) {
      return typeof it.schema != "boolean";
    }
    function subSchemaObjCode(it, valid) {
      const { schema: schema2, gen, opts } = it;
      if (opts.$comment && schema2.$comment)
        commentKeyword(it);
      updateContext(it);
      checkAsyncSchema(it);
      const errsCount = gen.const("_errs", names_1.default.errors);
      typeAndKeywords(it, errsCount);
      gen.var(valid, (0, codegen_1._)`${errsCount} === ${names_1.default.errors}`);
    }
    function checkKeywords(it) {
      (0, util_1.checkUnknownRules)(it);
      checkRefsAndKeywords(it);
    }
    function typeAndKeywords(it, errsCount) {
      if (it.opts.jtd)
        return schemaKeywords(it, [], false, errsCount);
      const types2 = (0, dataType_1.getSchemaTypes)(it.schema);
      const checkedTypes = (0, dataType_1.coerceAndCheckDataType)(it, types2);
      schemaKeywords(it, types2, !checkedTypes, errsCount);
    }
    function checkRefsAndKeywords(it) {
      const { schema: schema2, errSchemaPath, opts, self: self2 } = it;
      if (schema2.$ref && opts.ignoreKeywordsWithRef && (0, util_1.schemaHasRulesButRef)(schema2, self2.RULES)) {
        self2.logger.warn(`$ref: keywords ignored in schema at path "${errSchemaPath}"`);
      }
    }
    function checkNoDefault(it) {
      const { schema: schema2, opts } = it;
      if (schema2.default !== void 0 && opts.useDefaults && opts.strictSchema) {
        (0, util_1.checkStrictMode)(it, "default is ignored in the schema root");
      }
    }
    function updateContext(it) {
      const schId = it.schema[it.opts.schemaId];
      if (schId)
        it.baseId = (0, resolve_1.resolveUrl)(it.opts.uriResolver, it.baseId, schId);
    }
    function checkAsyncSchema(it) {
      if (it.schema.$async && !it.schemaEnv.$async)
        throw new Error("async schema in sync schema");
    }
    function commentKeyword({ gen, schemaEnv, schema: schema2, errSchemaPath, opts }) {
      const msg = schema2.$comment;
      if (opts.$comment === true) {
        gen.code((0, codegen_1._)`${names_1.default.self}.logger.log(${msg})`);
      } else if (typeof opts.$comment == "function") {
        const schemaPath = (0, codegen_1.str)`${errSchemaPath}/$comment`;
        const rootName = gen.scopeValue("root", { ref: schemaEnv.root });
        gen.code((0, codegen_1._)`${names_1.default.self}.opts.$comment(${msg}, ${schemaPath}, ${rootName}.schema)`);
      }
    }
    function returnResults(it) {
      const { gen, schemaEnv, validateName: validateName2, ValidationError, opts } = it;
      if (schemaEnv.$async) {
        gen.if((0, codegen_1._)`${names_1.default.errors} === 0`, () => gen.return(names_1.default.data), () => gen.throw((0, codegen_1._)`new ${ValidationError}(${names_1.default.vErrors})`));
      } else {
        gen.assign((0, codegen_1._)`${validateName2}.errors`, names_1.default.vErrors);
        if (opts.unevaluated)
          assignEvaluated(it);
        gen.return((0, codegen_1._)`${names_1.default.errors} === 0`);
      }
    }
    function assignEvaluated({ gen, evaluated, props, items }) {
      if (props instanceof codegen_1.Name)
        gen.assign((0, codegen_1._)`${evaluated}.props`, props);
      if (items instanceof codegen_1.Name)
        gen.assign((0, codegen_1._)`${evaluated}.items`, items);
    }
    function schemaKeywords(it, types2, typeErrors, errsCount) {
      const { gen, schema: schema2, data, allErrors, opts, self: self2 } = it;
      const { RULES } = self2;
      if (schema2.$ref && (opts.ignoreKeywordsWithRef || !(0, util_1.schemaHasRulesButRef)(schema2, RULES))) {
        gen.block(() => keywordCode(it, "$ref", RULES.all.$ref.definition));
        return;
      }
      if (!opts.jtd)
        checkStrictTypes(it, types2);
      gen.block(() => {
        for (const group of RULES.rules)
          groupKeywords(group);
        groupKeywords(RULES.post);
      });
      function groupKeywords(group) {
        if (!(0, applicability_1.shouldUseGroup)(schema2, group))
          return;
        if (group.type) {
          gen.if((0, dataType_2.checkDataType)(group.type, data, opts.strictNumbers));
          iterateKeywords(it, group);
          if (types2.length === 1 && types2[0] === group.type && typeErrors) {
            gen.else();
            (0, dataType_2.reportTypeError)(it);
          }
          gen.endIf();
        } else {
          iterateKeywords(it, group);
        }
        if (!allErrors)
          gen.if((0, codegen_1._)`${names_1.default.errors} === ${errsCount || 0}`);
      }
    }
    function iterateKeywords(it, group) {
      const { gen, schema: schema2, opts: { useDefaults } } = it;
      if (useDefaults)
        (0, defaults_1.assignDefaults)(it, group.type);
      gen.block(() => {
        for (const rule of group.rules) {
          if ((0, applicability_1.shouldUseRule)(schema2, rule) || shouldForceUnevaluatedProperties(schema2, rule)) {
            keywordCode(it, rule.keyword, rule.definition, group.type);
          }
        }
      });
      function shouldForceUnevaluatedProperties(schema3, rule) {
        return !!(rule.keyword === "unevaluatedProperties" && (schema3.properties || schema3.patternProperties) && !it.isAllOfVariant && it.opts.defaultUnevaluatedProperties === false);
      }
    }
    function checkStrictTypes(it, types2) {
      if (it.schemaEnv.meta || !it.opts.strictTypes)
        return;
      checkContextTypes(it, types2);
      if (!it.opts.allowUnionTypes)
        checkMultipleTypes(it, types2);
      checkKeywordTypes(it, it.dataTypes);
    }
    function checkContextTypes(it, types2) {
      if (!types2.length)
        return;
      if (!it.dataTypes.length) {
        it.dataTypes = types2;
        return;
      }
      types2.forEach((t) => {
        if (!includesType(it.dataTypes, t)) {
          strictTypesError(it, `type "${t}" not allowed by context "${it.dataTypes.join(",")}"`);
        }
      });
      it.dataTypes = it.dataTypes.filter((t) => includesType(types2, t));
    }
    function checkMultipleTypes(it, ts) {
      if (ts.length > 1 && !(ts.length === 2 && ts.includes("null"))) {
        strictTypesError(it, "use allowUnionTypes to allow union type keyword");
      }
    }
    function checkKeywordTypes(it, ts) {
      const rules = it.self.RULES.all;
      for (const keyword in rules) {
        const rule = rules[keyword];
        if (typeof rule == "object" && (0, applicability_1.shouldUseRule)(it.schema, rule)) {
          const { type: type2 } = rule.definition;
          if (type2.length && !type2.some((t) => hasApplicableType(ts, t))) {
            strictTypesError(it, `missing type "${type2.join(",")}" for keyword "${keyword}"`);
          }
        }
      }
    }
    function hasApplicableType(schTs, kwdT) {
      return schTs.includes(kwdT) || kwdT === "number" && schTs.includes("integer");
    }
    function includesType(ts, t) {
      return ts.includes(t) || t === "integer" && ts.includes("number");
    }
    function strictTypesError(it, msg) {
      const schemaPath = it.schemaEnv.baseId + it.errSchemaPath;
      msg += ` at "${schemaPath}" (strictTypes)`;
      (0, util_1.checkStrictMode)(it, msg, it.opts.strictTypes);
    }
    var KeywordCxt = class {
      constructor(it, def, keyword) {
        (0, keyword_1.validateKeywordUsage)(it, def, keyword);
        this.gen = it.gen;
        this.allErrors = it.allErrors;
        this.keyword = keyword;
        this.data = it.data;
        this.schema = it.schema[keyword];
        this.$data = def.$data && it.opts.$data && this.schema && this.schema.$data;
        this.schemaValue = (0, util_1.schemaRefOrVal)(it, this.schema, keyword, this.$data);
        this.schemaType = def.schemaType;
        this.parentSchema = it.schema;
        this.params = {};
        this.it = it;
        this.def = def;
        if (this.$data) {
          this.schemaCode = it.gen.const("vSchema", getData(this.$data, it));
        } else {
          this.schemaCode = this.schemaValue;
          if (!(0, keyword_1.validSchemaType)(this.schema, def.schemaType, def.allowUndefined)) {
            throw new Error(`${keyword} value must be ${JSON.stringify(def.schemaType)}`);
          }
        }
        if ("code" in def ? def.trackErrors : def.errors !== false) {
          this.errsCount = it.gen.const("_errs", names_1.default.errors);
        }
      }
      result(condition, successAction, failAction) {
        this.failResult((0, codegen_1.not)(condition), successAction, failAction);
      }
      failResult(condition, successAction, failAction) {
        this.gen.if(condition);
        if (failAction)
          failAction();
        else
          this.error();
        if (successAction) {
          this.gen.else();
          successAction();
          if (this.allErrors)
            this.gen.endIf();
        } else {
          if (this.allErrors)
            this.gen.endIf();
          else
            this.gen.else();
        }
      }
      pass(condition, failAction) {
        this.failResult((0, codegen_1.not)(condition), void 0, failAction);
      }
      fail(condition) {
        if (condition === void 0) {
          this.error();
          if (!this.allErrors)
            this.gen.if(false);
          return;
        }
        this.gen.if(condition);
        this.error();
        if (this.allErrors)
          this.gen.endIf();
        else
          this.gen.else();
      }
      fail$data(condition) {
        if (!this.$data)
          return this.fail(condition);
        const { schemaCode } = this;
        this.fail((0, codegen_1._)`${schemaCode} !== undefined && (${(0, codegen_1.or)(this.invalid$data(), condition)})`);
      }
      error(append, errorParams, errorPaths) {
        if (errorParams) {
          this.setParams(errorParams);
          this._error(append, errorPaths);
          this.setParams({});
          return;
        }
        this._error(append, errorPaths);
      }
      _error(append, errorPaths) {
        ;
        (append ? errors_1.reportExtraError : errors_1.reportError)(this, this.def.error, errorPaths);
      }
      $dataError() {
        (0, errors_1.reportError)(this, this.def.$dataError || errors_1.keyword$DataError);
      }
      reset() {
        if (this.errsCount === void 0)
          throw new Error('add "trackErrors" to keyword definition');
        (0, errors_1.resetErrorsCount)(this.gen, this.errsCount);
      }
      ok(cond) {
        if (!this.allErrors)
          this.gen.if(cond);
      }
      setParams(obj, assign) {
        if (assign)
          Object.assign(this.params, obj);
        else
          this.params = obj;
      }
      block$data(valid, codeBlock, $dataValid = codegen_1.nil) {
        this.gen.block(() => {
          this.check$data(valid, $dataValid);
          codeBlock();
        });
      }
      check$data(valid = codegen_1.nil, $dataValid = codegen_1.nil) {
        if (!this.$data)
          return;
        const { gen, schemaCode, schemaType, def } = this;
        gen.if((0, codegen_1.or)((0, codegen_1._)`${schemaCode} === undefined`, $dataValid));
        if (valid !== codegen_1.nil)
          gen.assign(valid, true);
        if (schemaType.length || def.validateSchema) {
          gen.elseIf(this.invalid$data());
          this.$dataError();
          if (valid !== codegen_1.nil)
            gen.assign(valid, false);
        }
        gen.else();
      }
      invalid$data() {
        const { gen, schemaCode, schemaType, def, it } = this;
        return (0, codegen_1.or)(wrong$DataType(), invalid$DataSchema());
        function wrong$DataType() {
          if (schemaType.length) {
            if (!(schemaCode instanceof codegen_1.Name))
              throw new Error("ajv implementation error");
            const st = Array.isArray(schemaType) ? schemaType : [schemaType];
            return (0, codegen_1._)`${(0, dataType_2.checkDataTypes)(st, schemaCode, it.opts.strictNumbers, dataType_2.DataType.Wrong)}`;
          }
          return codegen_1.nil;
        }
        function invalid$DataSchema() {
          if (def.validateSchema) {
            const validateSchemaRef = gen.scopeValue("validate$data", { ref: def.validateSchema });
            return (0, codegen_1._)`!${validateSchemaRef}(${schemaCode})`;
          }
          return codegen_1.nil;
        }
      }
      subschema(appl, valid, isAllOfVariant) {
        const subschema = (0, subschema_1.getSubschema)(this.it, appl);
        (0, subschema_1.extendSubschemaData)(subschema, this.it, appl);
        (0, subschema_1.extendSubschemaMode)(subschema, appl);
        const nextContext = {
          ...this.it,
          ...subschema,
          items: void 0,
          props: void 0,
          isAllOfVariant
        };
        subschemaCode(nextContext, valid);
        return nextContext;
      }
      mergeEvaluated(schemaCxt, toName) {
        const { it, gen } = this;
        if (!it.opts.unevaluated)
          return;
        if (it.props !== true && schemaCxt.props !== void 0) {
          it.props = util_1.mergeEvaluated.props(gen, schemaCxt.props, it.props, toName);
        }
        if (it.items !== true && schemaCxt.items !== void 0) {
          it.items = util_1.mergeEvaluated.items(gen, schemaCxt.items, it.items, toName);
        }
      }
      mergeValidEvaluated(schemaCxt, valid) {
        const { it, gen } = this;
        if (it.opts.unevaluated && (it.props !== true || it.items !== true)) {
          gen.if(valid, () => this.mergeEvaluated(schemaCxt, codegen_1.Name));
          return true;
        }
      }
    };
    exports2.KeywordCxt = KeywordCxt;
    function keywordCode(it, keyword, def, ruleType) {
      const cxt = new KeywordCxt(it, def, keyword);
      if ("code" in def) {
        def.code(cxt, ruleType);
      } else if (cxt.$data && def.validate) {
        (0, keyword_1.funcKeywordCode)(cxt, def);
      } else if ("macro" in def) {
        (0, keyword_1.macroKeywordCode)(cxt, def);
      } else if (def.compile || def.validate) {
        (0, keyword_1.funcKeywordCode)(cxt, def);
      }
    }
    var JSON_POINTER = /^\/(?:[^~]|~0|~1)*$/;
    var RELATIVE_JSON_POINTER = /^([0-9]+)(#|\/(?:[^~]|~0|~1)*)?$/;
    function getData($data, { dataLevel, dataNames, dataPathArr }) {
      let jsonPointer;
      let data;
      if ($data === "")
        return names_1.default.rootData;
      if ($data[0] === "/") {
        if (!JSON_POINTER.test($data))
          throw new Error(`Invalid JSON-pointer: ${$data}`);
        jsonPointer = $data;
        data = names_1.default.rootData;
      } else {
        const matches = RELATIVE_JSON_POINTER.exec($data);
        if (!matches)
          throw new Error(`Invalid JSON-pointer: ${$data}`);
        const up = +matches[1];
        jsonPointer = matches[2];
        if (jsonPointer === "#") {
          if (up >= dataLevel)
            throw new Error(errorMsg("property/index", up));
          return dataPathArr[dataLevel - up];
        }
        if (up > dataLevel)
          throw new Error(errorMsg("data", up));
        data = dataNames[dataLevel - up];
        if (!jsonPointer)
          return data;
      }
      let expr = data;
      const segments = jsonPointer.split("/");
      for (const segment of segments) {
        if (segment) {
          data = (0, codegen_1._)`${data}${(0, codegen_1.getProperty)((0, util_1.unescapeJsonPointer)(segment))}`;
          expr = (0, codegen_1._)`${expr} && ${data}`;
        }
      }
      return expr;
      function errorMsg(pointerType, up) {
        return `Cannot access ${pointerType} ${up} levels up, current level is ${dataLevel}`;
      }
    }
    exports2.getData = getData;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/runtime/validation_error.js
var require_validation_error = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/runtime/validation_error.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var ValidationError = class extends Error {
      constructor(errors) {
        super("validation failed");
        this.errors = errors;
        this.ajv = this.validation = true;
      }
    };
    exports2.default = ValidationError;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/ref_error.js
var require_ref_error = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/ref_error.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var resolve_1 = require_resolve();
    var MissingRefError = class extends Error {
      constructor(resolver, baseId, ref, msg) {
        super(msg || `can't resolve reference ${ref} from id ${baseId}`);
        this.missingRef = (0, resolve_1.resolveUrl)(resolver, baseId, ref);
        this.missingSchema = (0, resolve_1.normalizeId)((0, resolve_1.getFullPath)(resolver, this.missingRef));
      }
    };
    exports2.default = MissingRefError;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/index.js
var require_compile = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/compile/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.resolveSchema = exports2.getCompilingSchema = exports2.resolveRef = exports2.compileSchema = exports2.SchemaEnv = void 0;
    var codegen_1 = require_codegen();
    var validation_error_1 = require_validation_error();
    var names_1 = require_names();
    var resolve_1 = require_resolve();
    var util_1 = require_util();
    var validate_1 = require_validate();
    var SchemaEnv = class {
      constructor(env) {
        var _a;
        this.refs = {};
        this.dynamicAnchors = {};
        let schema2;
        if (typeof env.schema == "object")
          schema2 = env.schema;
        this.schema = env.schema;
        this.schemaId = env.schemaId;
        this.root = env.root || this;
        this.baseId = (_a = env.baseId) !== null && _a !== void 0 ? _a : (0, resolve_1.normalizeId)(schema2 === null || schema2 === void 0 ? void 0 : schema2[env.schemaId || "$id"]);
        this.schemaPath = env.schemaPath;
        this.localRefs = env.localRefs;
        this.meta = env.meta;
        this.$async = schema2 === null || schema2 === void 0 ? void 0 : schema2.$async;
        this.refs = {};
      }
    };
    exports2.SchemaEnv = SchemaEnv;
    function compileSchema(sch) {
      const _sch = getCompilingSchema.call(this, sch);
      if (_sch)
        return _sch;
      const rootId = (0, resolve_1.getFullPath)(this.opts.uriResolver, sch.root.baseId);
      const { es5, lines } = this.opts.code;
      const { ownProperties } = this.opts;
      const gen = new codegen_1.CodeGen(this.scope, { es5, lines, ownProperties });
      let _ValidationError;
      if (sch.$async) {
        _ValidationError = gen.scopeValue("Error", {
          ref: validation_error_1.default,
          code: (0, codegen_1._)`require("ajv/dist/runtime/validation_error").default`
        });
      }
      const validateName2 = gen.scopeName("validate");
      sch.validateName = validateName2;
      const schemaCxt = {
        gen,
        allErrors: this.opts.allErrors,
        data: names_1.default.data,
        parentData: names_1.default.parentData,
        parentDataProperty: names_1.default.parentDataProperty,
        dataNames: [names_1.default.data],
        dataPathArr: [codegen_1.nil],
        dataLevel: 0,
        dataTypes: [],
        definedProperties: /* @__PURE__ */ new Set(),
        topSchemaRef: gen.scopeValue("schema", this.opts.code.source === true ? { ref: sch.schema, code: (0, codegen_1.stringify)(sch.schema) } : { ref: sch.schema }),
        validateName: validateName2,
        ValidationError: _ValidationError,
        schema: sch.schema,
        schemaEnv: sch,
        rootId,
        baseId: sch.baseId || rootId,
        schemaPath: codegen_1.nil,
        errSchemaPath: sch.schemaPath || (this.opts.jtd ? "" : "#"),
        errorPath: (0, codegen_1._)`""`,
        opts: this.opts,
        self: this
      };
      let sourceCode;
      try {
        this._compilations.add(sch);
        (0, validate_1.validateFunctionCode)(schemaCxt);
        gen.optimize(this.opts.code.optimize);
        const validateCode = gen.toString();
        sourceCode = `const visitedNodesForRef = new WeakMap(); ${gen.scopeRefs(names_1.default.scope)}return ${validateCode}`;
        if (this.opts.code.process)
          sourceCode = this.opts.code.process(sourceCode, sch);
        const makeValidate = new Function(`${names_1.default.self}`, `${names_1.default.scope}`, sourceCode);
        const validate = makeValidate(this, this.scope.get());
        this.scope.value(validateName2, { ref: validate });
        validate.errors = null;
        validate.schema = sch.schema;
        validate.schemaEnv = sch;
        if (sch.$async)
          validate.$async = true;
        if (this.opts.code.source === true) {
          validate.source = { validateName: validateName2, validateCode, scopeValues: gen._values };
        }
        if (this.opts.unevaluated) {
          const { props, items } = schemaCxt;
          validate.evaluated = {
            props: props instanceof codegen_1.Name ? void 0 : props,
            items: items instanceof codegen_1.Name ? void 0 : items,
            dynamicProps: props instanceof codegen_1.Name,
            dynamicItems: items instanceof codegen_1.Name
          };
          if (validate.source)
            validate.source.evaluated = (0, codegen_1.stringify)(validate.evaluated);
        }
        sch.validate = validate;
        return sch;
      } catch (e) {
        delete sch.validate;
        delete sch.validateName;
        if (sourceCode)
          this.logger.error("Error compiling schema, function code:", sourceCode);
        throw e;
      } finally {
        this._compilations.delete(sch);
      }
    }
    exports2.compileSchema = compileSchema;
    function resolveRef(root2, baseId, origRef) {
      var _a;
      const ref = (0, resolve_1.resolveUrl)(this.opts.uriResolver, baseId, origRef);
      const schOrFunc = root2.refs[ref];
      if (schOrFunc)
        return schOrFunc;
      let _sch = resolve.call(this, root2, ref);
      if (_sch === void 0) {
        const schema2 = (_a = root2.localRefs) === null || _a === void 0 ? void 0 : _a[ref];
        const { schemaId } = this.opts;
        if (schema2)
          _sch = new SchemaEnv({ schema: schema2, schemaId, root: root2, baseId });
      }
      if (_sch === void 0 && this.opts.loadSchemaSync) {
        const remoteSchema = this.opts.loadSchemaSync(baseId, origRef, ref);
        if (remoteSchema && !(this.refs[ref] || this.schemas[ref])) {
          this.addSchema(remoteSchema, ref, void 0);
          _sch = resolve.call(this, root2, ref);
        }
      }
      if (_sch === void 0)
        return;
      return root2.refs[ref] = inlineOrCompile.call(this, _sch);
    }
    exports2.resolveRef = resolveRef;
    function inlineOrCompile(sch) {
      if ((0, resolve_1.inlineRef)(sch.schema, this.opts.inlineRefs))
        return sch.schema;
      return sch.validate ? sch : compileSchema.call(this, sch);
    }
    function getCompilingSchema(schEnv) {
      for (const sch of this._compilations) {
        if (sameSchemaEnv(sch, schEnv))
          return sch;
      }
    }
    exports2.getCompilingSchema = getCompilingSchema;
    function sameSchemaEnv(s1, s2) {
      return s1.schema === s2.schema && s1.root === s2.root && s1.baseId === s2.baseId;
    }
    function resolve(root2, ref) {
      let sch;
      while (typeof (sch = this.refs[ref]) == "string")
        ref = sch;
      return sch || this.schemas[ref] || resolveSchema2.call(this, root2, ref);
    }
    function resolveSchema2(root2, ref) {
      const p = this.opts.uriResolver.parse(ref);
      const refPath = (0, resolve_1._getFullPath)(this.opts.uriResolver, p);
      let baseId = (0, resolve_1.getFullPath)(this.opts.uriResolver, root2.baseId, void 0);
      if (Object.keys(root2.schema).length > 0 && refPath === baseId) {
        return getJsonPointer.call(this, p, root2);
      }
      const id = (0, resolve_1.normalizeId)(refPath);
      const schOrRef = this.refs[id] || this.schemas[id];
      if (typeof schOrRef == "string") {
        const sch = resolveSchema2.call(this, root2, schOrRef);
        if (typeof (sch === null || sch === void 0 ? void 0 : sch.schema) !== "object")
          return;
        return getJsonPointer.call(this, p, sch);
      }
      if (typeof (schOrRef === null || schOrRef === void 0 ? void 0 : schOrRef.schema) !== "object")
        return;
      if (!schOrRef.validate)
        compileSchema.call(this, schOrRef);
      if (id === (0, resolve_1.normalizeId)(ref)) {
        const { schema: schema2 } = schOrRef;
        const { schemaId } = this.opts;
        const schId = schema2[schemaId];
        if (schId)
          baseId = (0, resolve_1.resolveUrl)(this.opts.uriResolver, baseId, schId);
        return new SchemaEnv({ schema: schema2, schemaId, root: root2, baseId });
      }
      return getJsonPointer.call(this, p, schOrRef);
    }
    exports2.resolveSchema = resolveSchema2;
    var PREVENT_SCOPE_CHANGE = /* @__PURE__ */ new Set([
      "properties",
      "patternProperties",
      "enum",
      "dependencies",
      "definitions"
    ]);
    function getJsonPointer(parsedRef, { baseId, schema: schema2, root: root2 }) {
      var _a;
      if (((_a = parsedRef.fragment) === null || _a === void 0 ? void 0 : _a[0]) !== "/")
        return;
      for (const part of parsedRef.fragment.slice(1).split("/")) {
        if (typeof schema2 === "boolean")
          return;
        const partSchema = schema2[(0, util_1.unescapeFragment)(part)];
        if (partSchema === void 0)
          return;
        schema2 = partSchema;
        const schId = typeof schema2 === "object" && schema2[this.opts.schemaId];
        if (!PREVENT_SCOPE_CHANGE.has(part) && schId) {
          baseId = (0, resolve_1.resolveUrl)(this.opts.uriResolver, baseId, schId);
        }
      }
      let env;
      if (typeof schema2 != "boolean" && schema2.$ref && !(0, util_1.schemaHasRulesButRef)(schema2, this.RULES)) {
        const $ref = (0, resolve_1.resolveUrl)(this.opts.uriResolver, baseId, schema2.$ref);
        env = resolveSchema2.call(this, root2, $ref);
      }
      const { schemaId } = this.opts;
      env = env || new SchemaEnv({ schema: schema2, schemaId, root: root2, baseId });
      if (env.schema !== env.root.schema)
        return env;
      return void 0;
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/data.json
var require_data = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/data.json"(exports2, module2) {
    module2.exports = {
      $id: "https://raw.githubusercontent.com/ajv-validator/ajv/master/lib/refs/data.json#",
      description: "Meta-schema for $data reference (JSON AnySchema extension proposal)",
      type: "object",
      required: ["$data"],
      properties: {
        $data: {
          type: "string",
          anyOf: [{ format: "relative-json-pointer" }, { format: "json-pointer" }]
        }
      },
      additionalProperties: false
    };
  }
});

// ../../../node_modules/.pnpm/uri-js@4.4.1/node_modules/uri-js/dist/es5/uri.all.js
var require_uri_all = __commonJS({
  "../../../node_modules/.pnpm/uri-js@4.4.1/node_modules/uri-js/dist/es5/uri.all.js"(exports2, module2) {
    "use strict";
    (function (global2, factory) {
      typeof exports2 === "object" && typeof module2 !== "undefined" ? factory(exports2) : typeof define === "function" && define.amd ? define(["exports"], factory) : factory(global2.URI = global2.URI || {});
    })(exports2, function (exports3) {
      "use strict";
      function merge3() {
        for (var _len = arguments.length, sets = Array(_len), _key = 0; _key < _len; _key++) {
          sets[_key] = arguments[_key];
        }
        if (sets.length > 1) {
          sets[0] = sets[0].slice(0, -1);
          var xl = sets.length - 1;
          for (var x = 1; x < xl; ++x) {
            sets[x] = sets[x].slice(1, -1);
          }
          sets[xl] = sets[xl].slice(1);
          return sets.join("");
        } else {
          return sets[0];
        }
      }
      function subexp(str2) {
        return "(?:" + str2 + ")";
      }
      function typeOf(o) {
        return o === void 0 ? "undefined" : o === null ? "null" : Object.prototype.toString.call(o).split(" ").pop().split("]").shift().toLowerCase();
      }
      function toUpperCase(str2) {
        return str2.toUpperCase();
      }
      function toArray2(obj) {
        return obj !== void 0 && obj !== null ? obj instanceof Array ? obj : typeof obj.length !== "number" || obj.split || obj.setInterval || obj.call ? [obj] : Array.prototype.slice.call(obj) : [];
      }
      function assign(target, source) {
        var obj = target;
        if (source) {
          for (var key in source) {
            obj[key] = source[key];
          }
        }
        return obj;
      }
      function buildExps(isIRI2) {
        var ALPHA$$ = "[A-Za-z]", CR$ = "[\\x0D]", DIGIT$$ = "[0-9]", DQUOTE$$ = "[\\x22]", HEXDIG$$2 = merge3(DIGIT$$, "[A-Fa-f]"), LF$$ = "[\\x0A]", SP$$ = "[\\x20]", PCT_ENCODED$2 = subexp(subexp("%[EFef]" + HEXDIG$$2 + "%" + HEXDIG$$2 + HEXDIG$$2 + "%" + HEXDIG$$2 + HEXDIG$$2) + "|" + subexp("%[89A-Fa-f]" + HEXDIG$$2 + "%" + HEXDIG$$2 + HEXDIG$$2) + "|" + subexp("%" + HEXDIG$$2 + HEXDIG$$2)), GEN_DELIMS$$ = "[\\:\\/\\?\\#\\[\\]\\@]", SUB_DELIMS$$ = "[\\!\\$\\&\\'\\(\\)\\*\\+\\,\\;\\=]", RESERVED$$ = merge3(GEN_DELIMS$$, SUB_DELIMS$$), UCSCHAR$$ = isIRI2 ? "[\\xA0-\\u200D\\u2010-\\u2029\\u202F-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFEF]" : "[]", IPRIVATE$$ = isIRI2 ? "[\\uE000-\\uF8FF]" : "[]", UNRESERVED$$2 = merge3(ALPHA$$, DIGIT$$, "[\\-\\.\\_\\~]", UCSCHAR$$), SCHEME$ = subexp(ALPHA$$ + merge3(ALPHA$$, DIGIT$$, "[\\+\\-\\.]") + "*"), USERINFO$ = subexp(subexp(PCT_ENCODED$2 + "|" + merge3(UNRESERVED$$2, SUB_DELIMS$$, "[\\:]")) + "*"), DEC_OCTET$ = subexp(subexp("25[0-5]") + "|" + subexp("2[0-4]" + DIGIT$$) + "|" + subexp("1" + DIGIT$$ + DIGIT$$) + "|" + subexp("[1-9]" + DIGIT$$) + "|" + DIGIT$$), DEC_OCTET_RELAXED$ = subexp(subexp("25[0-5]") + "|" + subexp("2[0-4]" + DIGIT$$) + "|" + subexp("1" + DIGIT$$ + DIGIT$$) + "|" + subexp("0?[1-9]" + DIGIT$$) + "|0?0?" + DIGIT$$), IPV4ADDRESS$ = subexp(DEC_OCTET_RELAXED$ + "\\." + DEC_OCTET_RELAXED$ + "\\." + DEC_OCTET_RELAXED$ + "\\." + DEC_OCTET_RELAXED$), H16$ = subexp(HEXDIG$$2 + "{1,4}"), LS32$ = subexp(subexp(H16$ + "\\:" + H16$) + "|" + IPV4ADDRESS$), IPV6ADDRESS1$ = subexp(subexp(H16$ + "\\:") + "{6}" + LS32$), IPV6ADDRESS2$ = subexp("\\:\\:" + subexp(H16$ + "\\:") + "{5}" + LS32$), IPV6ADDRESS3$ = subexp(subexp(H16$) + "?\\:\\:" + subexp(H16$ + "\\:") + "{4}" + LS32$), IPV6ADDRESS4$ = subexp(subexp(subexp(H16$ + "\\:") + "{0,1}" + H16$) + "?\\:\\:" + subexp(H16$ + "\\:") + "{3}" + LS32$), IPV6ADDRESS5$ = subexp(subexp(subexp(H16$ + "\\:") + "{0,2}" + H16$) + "?\\:\\:" + subexp(H16$ + "\\:") + "{2}" + LS32$), IPV6ADDRESS6$ = subexp(subexp(subexp(H16$ + "\\:") + "{0,3}" + H16$) + "?\\:\\:" + H16$ + "\\:" + LS32$), IPV6ADDRESS7$ = subexp(subexp(subexp(H16$ + "\\:") + "{0,4}" + H16$) + "?\\:\\:" + LS32$), IPV6ADDRESS8$ = subexp(subexp(subexp(H16$ + "\\:") + "{0,5}" + H16$) + "?\\:\\:" + H16$), IPV6ADDRESS9$ = subexp(subexp(subexp(H16$ + "\\:") + "{0,6}" + H16$) + "?\\:\\:"), IPV6ADDRESS$ = subexp([IPV6ADDRESS1$, IPV6ADDRESS2$, IPV6ADDRESS3$, IPV6ADDRESS4$, IPV6ADDRESS5$, IPV6ADDRESS6$, IPV6ADDRESS7$, IPV6ADDRESS8$, IPV6ADDRESS9$].join("|")), ZONEID$ = subexp(subexp(UNRESERVED$$2 + "|" + PCT_ENCODED$2) + "+"), IPV6ADDRZ$ = subexp(IPV6ADDRESS$ + "\\%25" + ZONEID$), IPV6ADDRZ_RELAXED$ = subexp(IPV6ADDRESS$ + subexp("\\%25|\\%(?!" + HEXDIG$$2 + "{2})") + ZONEID$), IPVFUTURE$ = subexp("[vV]" + HEXDIG$$2 + "+\\." + merge3(UNRESERVED$$2, SUB_DELIMS$$, "[\\:]") + "+"), IP_LITERAL$ = subexp("\\[" + subexp(IPV6ADDRZ_RELAXED$ + "|" + IPV6ADDRESS$ + "|" + IPVFUTURE$) + "\\]"), REG_NAME$ = subexp(subexp(PCT_ENCODED$2 + "|" + merge3(UNRESERVED$$2, SUB_DELIMS$$)) + "*"), HOST$ = subexp(IP_LITERAL$ + "|" + IPV4ADDRESS$ + "(?!" + REG_NAME$ + ")|" + REG_NAME$), PORT$ = subexp(DIGIT$$ + "*"), AUTHORITY$ = subexp(subexp(USERINFO$ + "@") + "?" + HOST$ + subexp("\\:" + PORT$) + "?"), PCHAR$ = subexp(PCT_ENCODED$2 + "|" + merge3(UNRESERVED$$2, SUB_DELIMS$$, "[\\:\\@]")), SEGMENT$ = subexp(PCHAR$ + "*"), SEGMENT_NZ$ = subexp(PCHAR$ + "+"), SEGMENT_NZ_NC$ = subexp(subexp(PCT_ENCODED$2 + "|" + merge3(UNRESERVED$$2, SUB_DELIMS$$, "[\\@]")) + "+"), PATH_ABEMPTY$ = subexp(subexp("\\/" + SEGMENT$) + "*"), PATH_ABSOLUTE$ = subexp("\\/" + subexp(SEGMENT_NZ$ + PATH_ABEMPTY$) + "?"), PATH_NOSCHEME$ = subexp(SEGMENT_NZ_NC$ + PATH_ABEMPTY$), PATH_ROOTLESS$ = subexp(SEGMENT_NZ$ + PATH_ABEMPTY$), PATH_EMPTY$ = "(?!" + PCHAR$ + ")", PATH$ = subexp(PATH_ABEMPTY$ + "|" + PATH_ABSOLUTE$ + "|" + PATH_NOSCHEME$ + "|" + PATH_ROOTLESS$ + "|" + PATH_EMPTY$), QUERY$ = subexp(subexp(PCHAR$ + "|" + merge3("[\\/\\?]", IPRIVATE$$)) + "*"), FRAGMENT$ = subexp(subexp(PCHAR$ + "|[\\/\\?]") + "*"), HIER_PART$ = subexp(subexp("\\/\\/" + AUTHORITY$ + PATH_ABEMPTY$) + "|" + PATH_ABSOLUTE$ + "|" + PATH_ROOTLESS$ + "|" + PATH_EMPTY$), URI$ = subexp(SCHEME$ + "\\:" + HIER_PART$ + subexp("\\?" + QUERY$) + "?" + subexp("\\#" + FRAGMENT$) + "?"), RELATIVE_PART$ = subexp(subexp("\\/\\/" + AUTHORITY$ + PATH_ABEMPTY$) + "|" + PATH_ABSOLUTE$ + "|" + PATH_NOSCHEME$ + "|" + PATH_EMPTY$), RELATIVE$ = subexp(RELATIVE_PART$ + subexp("\\?" + QUERY$) + "?" + subexp("\\#" + FRAGMENT$) + "?"), URI_REFERENCE$ = subexp(URI$ + "|" + RELATIVE$), ABSOLUTE_URI$ = subexp(SCHEME$ + "\\:" + HIER_PART$ + subexp("\\?" + QUERY$) + "?"), GENERIC_REF$ = "^(" + SCHEME$ + ")\\:" + subexp(subexp("\\/\\/(" + subexp("(" + USERINFO$ + ")@") + "?(" + HOST$ + ")" + subexp("\\:(" + PORT$ + ")") + "?)") + "?(" + PATH_ABEMPTY$ + "|" + PATH_ABSOLUTE$ + "|" + PATH_ROOTLESS$ + "|" + PATH_EMPTY$ + ")") + subexp("\\?(" + QUERY$ + ")") + "?" + subexp("\\#(" + FRAGMENT$ + ")") + "?$", RELATIVE_REF$ = "^(){0}" + subexp(subexp("\\/\\/(" + subexp("(" + USERINFO$ + ")@") + "?(" + HOST$ + ")" + subexp("\\:(" + PORT$ + ")") + "?)") + "?(" + PATH_ABEMPTY$ + "|" + PATH_ABSOLUTE$ + "|" + PATH_NOSCHEME$ + "|" + PATH_EMPTY$ + ")") + subexp("\\?(" + QUERY$ + ")") + "?" + subexp("\\#(" + FRAGMENT$ + ")") + "?$", ABSOLUTE_REF$ = "^(" + SCHEME$ + ")\\:" + subexp(subexp("\\/\\/(" + subexp("(" + USERINFO$ + ")@") + "?(" + HOST$ + ")" + subexp("\\:(" + PORT$ + ")") + "?)") + "?(" + PATH_ABEMPTY$ + "|" + PATH_ABSOLUTE$ + "|" + PATH_ROOTLESS$ + "|" + PATH_EMPTY$ + ")") + subexp("\\?(" + QUERY$ + ")") + "?$", SAMEDOC_REF$ = "^" + subexp("\\#(" + FRAGMENT$ + ")") + "?$", AUTHORITY_REF$ = "^" + subexp("(" + USERINFO$ + ")@") + "?(" + HOST$ + ")" + subexp("\\:(" + PORT$ + ")") + "?$";
        return {
          NOT_SCHEME: new RegExp(merge3("[^]", ALPHA$$, DIGIT$$, "[\\+\\-\\.]"), "g"),
          NOT_USERINFO: new RegExp(merge3("[^\\%\\:]", UNRESERVED$$2, SUB_DELIMS$$), "g"),
          NOT_HOST: new RegExp(merge3("[^\\%\\[\\]\\:]", UNRESERVED$$2, SUB_DELIMS$$), "g"),
          NOT_PATH: new RegExp(merge3("[^\\%\\/\\:\\@]", UNRESERVED$$2, SUB_DELIMS$$), "g"),
          NOT_PATH_NOSCHEME: new RegExp(merge3("[^\\%\\/\\@]", UNRESERVED$$2, SUB_DELIMS$$), "g"),
          NOT_QUERY: new RegExp(merge3("[^\\%]", UNRESERVED$$2, SUB_DELIMS$$, "[\\:\\@\\/\\?]", IPRIVATE$$), "g"),
          NOT_FRAGMENT: new RegExp(merge3("[^\\%]", UNRESERVED$$2, SUB_DELIMS$$, "[\\:\\@\\/\\?]"), "g"),
          ESCAPE: new RegExp(merge3("[^]", UNRESERVED$$2, SUB_DELIMS$$), "g"),
          UNRESERVED: new RegExp(UNRESERVED$$2, "g"),
          OTHER_CHARS: new RegExp(merge3("[^\\%]", UNRESERVED$$2, RESERVED$$), "g"),
          PCT_ENCODED: new RegExp(PCT_ENCODED$2, "g"),
          IPV4ADDRESS: new RegExp("^(" + IPV4ADDRESS$ + ")$"),
          IPV6ADDRESS: new RegExp("^\\[?(" + IPV6ADDRESS$ + ")" + subexp(subexp("\\%25|\\%(?!" + HEXDIG$$2 + "{2})") + "(" + ZONEID$ + ")") + "?\\]?$")
          //RFC 6874, with relaxed parsing rules
        };
      }
      var URI_PROTOCOL = buildExps(false);
      var IRI_PROTOCOL = buildExps(true);
      var slicedToArray = /* @__PURE__ */ function () {
        function sliceIterator(arr, i) {
          var _arr = [];
          var _n = true;
          var _d = false;
          var _e = void 0;
          try {
            for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
              _arr.push(_s.value);
              if (i && _arr.length === i) break;
            }
          } catch (err) {
            _d = true;
            _e = err;
          } finally {
            try {
              if (!_n && _i["return"]) _i["return"]();
            } finally {
              if (_d) throw _e;
            }
          }
          return _arr;
        }
        return function (arr, i) {
          if (Array.isArray(arr)) {
            return arr;
          } else if (Symbol.iterator in Object(arr)) {
            return sliceIterator(arr, i);
          } else {
            throw new TypeError("Invalid attempt to destructure non-iterable instance");
          }
        };
      }();
      var toConsumableArray = function (arr) {
        if (Array.isArray(arr)) {
          for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];
          return arr2;
        } else {
          return Array.from(arr);
        }
      };
      var maxInt = 2147483647;
      var base = 36;
      var tMin = 1;
      var tMax = 26;
      var skew = 38;
      var damp = 700;
      var initialBias = 72;
      var initialN = 128;
      var delimiter = "-";
      var regexPunycode = /^xn--/;
      var regexNonASCII = /[^\0-\x7E]/;
      var regexSeparators = /[\x2E\u3002\uFF0E\uFF61]/g;
      var errors = {
        "overflow": "Overflow: input needs wider integers to process",
        "not-basic": "Illegal input >= 0x80 (not a basic code point)",
        "invalid-input": "Invalid input"
      };
      var baseMinusTMin = base - tMin;
      var floor = Math.floor;
      var stringFromCharCode = String.fromCharCode;
      function error$1(type2) {
        throw new RangeError(errors[type2]);
      }
      function map2(array, fn) {
        var result = [];
        var length = array.length;
        while (length--) {
          result[length] = fn(array[length]);
        }
        return result;
      }
      function mapDomain(string3, fn) {
        var parts = string3.split("@");
        var result = "";
        if (parts.length > 1) {
          result = parts[0] + "@";
          string3 = parts[1];
        }
        string3 = string3.replace(regexSeparators, ".");
        var labels = string3.split(".");
        var encoded = map2(labels, fn).join(".");
        return result + encoded;
      }
      function ucs2decode(string3) {
        var output = [];
        var counter = 0;
        var length = string3.length;
        while (counter < length) {
          var value = string3.charCodeAt(counter++);
          if (value >= 55296 && value <= 56319 && counter < length) {
            var extra = string3.charCodeAt(counter++);
            if ((extra & 64512) == 56320) {
              output.push(((value & 1023) << 10) + (extra & 1023) + 65536);
            } else {
              output.push(value);
              counter--;
            }
          } else {
            output.push(value);
          }
        }
        return output;
      }
      var ucs2encode = function ucs2encode2(array) {
        return String.fromCodePoint.apply(String, toConsumableArray(array));
      };
      var basicToDigit = function basicToDigit2(codePoint) {
        if (codePoint - 48 < 10) {
          return codePoint - 22;
        }
        if (codePoint - 65 < 26) {
          return codePoint - 65;
        }
        if (codePoint - 97 < 26) {
          return codePoint - 97;
        }
        return base;
      };
      var digitToBasic = function digitToBasic2(digit, flag) {
        return digit + 22 + 75 * (digit < 26) - ((flag != 0) << 5);
      };
      var adapt = function adapt2(delta, numPoints, firstTime) {
        var k = 0;
        delta = firstTime ? floor(delta / damp) : delta >> 1;
        delta += floor(delta / numPoints);
        for (
          ;
          /* no initialization */
          delta > baseMinusTMin * tMax >> 1;
          k += base
        ) {
          delta = floor(delta / baseMinusTMin);
        }
        return floor(k + (baseMinusTMin + 1) * delta / (delta + skew));
      };
      var decode = function decode2(input) {
        var output = [];
        var inputLength = input.length;
        var i = 0;
        var n = initialN;
        var bias = initialBias;
        var basic = input.lastIndexOf(delimiter);
        if (basic < 0) {
          basic = 0;
        }
        for (var j = 0; j < basic; ++j) {
          if (input.charCodeAt(j) >= 128) {
            error$1("not-basic");
          }
          output.push(input.charCodeAt(j));
        }
        for (var index = basic > 0 ? basic + 1 : 0; index < inputLength;) {
          var oldi = i;
          for (
            var w = 1, k = base;
            ;
            /* no condition */
            k += base
          ) {
            if (index >= inputLength) {
              error$1("invalid-input");
            }
            var digit = basicToDigit(input.charCodeAt(index++));
            if (digit >= base || digit > floor((maxInt - i) / w)) {
              error$1("overflow");
            }
            i += digit * w;
            var t = k <= bias ? tMin : k >= bias + tMax ? tMax : k - bias;
            if (digit < t) {
              break;
            }
            var baseMinusT = base - t;
            if (w > floor(maxInt / baseMinusT)) {
              error$1("overflow");
            }
            w *= baseMinusT;
          }
          var out = output.length + 1;
          bias = adapt(i - oldi, out, oldi == 0);
          if (floor(i / out) > maxInt - n) {
            error$1("overflow");
          }
          n += floor(i / out);
          i %= out;
          output.splice(i++, 0, n);
        }
        return String.fromCodePoint.apply(String, output);
      };
      var encode = function encode2(input) {
        var output = [];
        input = ucs2decode(input);
        var inputLength = input.length;
        var n = initialN;
        var delta = 0;
        var bias = initialBias;
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = void 0;
        try {
          for (var _iterator = input[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var _currentValue2 = _step.value;
            if (_currentValue2 < 128) {
              output.push(stringFromCharCode(_currentValue2));
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }
        var basicLength = output.length;
        var handledCPCount = basicLength;
        if (basicLength) {
          output.push(delimiter);
        }
        while (handledCPCount < inputLength) {
          var m = maxInt;
          var _iteratorNormalCompletion2 = true;
          var _didIteratorError2 = false;
          var _iteratorError2 = void 0;
          try {
            for (var _iterator2 = input[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
              var currentValue = _step2.value;
              if (currentValue >= n && currentValue < m) {
                m = currentValue;
              }
            }
          } catch (err) {
            _didIteratorError2 = true;
            _iteratorError2 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion2 && _iterator2.return) {
                _iterator2.return();
              }
            } finally {
              if (_didIteratorError2) {
                throw _iteratorError2;
              }
            }
          }
          var handledCPCountPlusOne = handledCPCount + 1;
          if (m - n > floor((maxInt - delta) / handledCPCountPlusOne)) {
            error$1("overflow");
          }
          delta += (m - n) * handledCPCountPlusOne;
          n = m;
          var _iteratorNormalCompletion3 = true;
          var _didIteratorError3 = false;
          var _iteratorError3 = void 0;
          try {
            for (var _iterator3 = input[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
              var _currentValue = _step3.value;
              if (_currentValue < n && ++delta > maxInt) {
                error$1("overflow");
              }
              if (_currentValue == n) {
                var q = delta;
                for (
                  var k = base;
                  ;
                  /* no condition */
                  k += base
                ) {
                  var t = k <= bias ? tMin : k >= bias + tMax ? tMax : k - bias;
                  if (q < t) {
                    break;
                  }
                  var qMinusT = q - t;
                  var baseMinusT = base - t;
                  output.push(stringFromCharCode(digitToBasic(t + qMinusT % baseMinusT, 0)));
                  q = floor(qMinusT / baseMinusT);
                }
                output.push(stringFromCharCode(digitToBasic(q, 0)));
                bias = adapt(delta, handledCPCountPlusOne, handledCPCount == basicLength);
                delta = 0;
                ++handledCPCount;
              }
            }
          } catch (err) {
            _didIteratorError3 = true;
            _iteratorError3 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion3 && _iterator3.return) {
                _iterator3.return();
              }
            } finally {
              if (_didIteratorError3) {
                throw _iteratorError3;
              }
            }
          }
          ++delta;
          ++n;
        }
        return output.join("");
      };
      var toUnicode = function toUnicode2(input) {
        return mapDomain(input, function (string3) {
          return regexPunycode.test(string3) ? decode(string3.slice(4).toLowerCase()) : string3;
        });
      };
      var toASCII = function toASCII2(input) {
        return mapDomain(input, function (string3) {
          return regexNonASCII.test(string3) ? "xn--" + encode(string3) : string3;
        });
      };
      var punycode = {
        /**
         * A string representing the current Punycode.js version number.
         * @memberOf punycode
         * @type String
         */
        "version": "2.1.0",
        /**
         * An object of methods to convert from JavaScript's internal character
         * representation (UCS-2) to Unicode code points, and back.
         * @see <https://mathiasbynens.be/notes/javascript-encoding>
         * @memberOf punycode
         * @type Object
         */
        "ucs2": {
          "decode": ucs2decode,
          "encode": ucs2encode
        },
        "decode": decode,
        "encode": encode,
        "toASCII": toASCII,
        "toUnicode": toUnicode
      };
      var SCHEMES = {};
      function pctEncChar(chr) {
        var c = chr.charCodeAt(0);
        var e = void 0;
        if (c < 16) e = "%0" + c.toString(16).toUpperCase();
        else if (c < 128) e = "%" + c.toString(16).toUpperCase();
        else if (c < 2048) e = "%" + (c >> 6 | 192).toString(16).toUpperCase() + "%" + (c & 63 | 128).toString(16).toUpperCase();
        else e = "%" + (c >> 12 | 224).toString(16).toUpperCase() + "%" + (c >> 6 & 63 | 128).toString(16).toUpperCase() + "%" + (c & 63 | 128).toString(16).toUpperCase();
        return e;
      }
      function pctDecChars(str2) {
        var newStr = "";
        var i = 0;
        var il = str2.length;
        while (i < il) {
          var c = parseInt(str2.substr(i + 1, 2), 16);
          if (c < 128) {
            newStr += String.fromCharCode(c);
            i += 3;
          } else if (c >= 194 && c < 224) {
            if (il - i >= 6) {
              var c2 = parseInt(str2.substr(i + 4, 2), 16);
              newStr += String.fromCharCode((c & 31) << 6 | c2 & 63);
            } else {
              newStr += str2.substr(i, 6);
            }
            i += 6;
          } else if (c >= 224) {
            if (il - i >= 9) {
              var _c = parseInt(str2.substr(i + 4, 2), 16);
              var c3 = parseInt(str2.substr(i + 7, 2), 16);
              newStr += String.fromCharCode((c & 15) << 12 | (_c & 63) << 6 | c3 & 63);
            } else {
              newStr += str2.substr(i, 9);
            }
            i += 9;
          } else {
            newStr += str2.substr(i, 3);
            i += 3;
          }
        }
        return newStr;
      }
      function _normalizeComponentEncoding(components, protocol) {
        function decodeUnreserved2(str2) {
          var decStr = pctDecChars(str2);
          return !decStr.match(protocol.UNRESERVED) ? str2 : decStr;
        }
        if (components.scheme) components.scheme = String(components.scheme).replace(protocol.PCT_ENCODED, decodeUnreserved2).toLowerCase().replace(protocol.NOT_SCHEME, "");
        if (components.userinfo !== void 0) components.userinfo = String(components.userinfo).replace(protocol.PCT_ENCODED, decodeUnreserved2).replace(protocol.NOT_USERINFO, pctEncChar).replace(protocol.PCT_ENCODED, toUpperCase);
        if (components.host !== void 0) components.host = String(components.host).replace(protocol.PCT_ENCODED, decodeUnreserved2).toLowerCase().replace(protocol.NOT_HOST, pctEncChar).replace(protocol.PCT_ENCODED, toUpperCase);
        if (components.path !== void 0) components.path = String(components.path).replace(protocol.PCT_ENCODED, decodeUnreserved2).replace(components.scheme ? protocol.NOT_PATH : protocol.NOT_PATH_NOSCHEME, pctEncChar).replace(protocol.PCT_ENCODED, toUpperCase);
        if (components.query !== void 0) components.query = String(components.query).replace(protocol.PCT_ENCODED, decodeUnreserved2).replace(protocol.NOT_QUERY, pctEncChar).replace(protocol.PCT_ENCODED, toUpperCase);
        if (components.fragment !== void 0) components.fragment = String(components.fragment).replace(protocol.PCT_ENCODED, decodeUnreserved2).replace(protocol.NOT_FRAGMENT, pctEncChar).replace(protocol.PCT_ENCODED, toUpperCase);
        return components;
      }
      function _stripLeadingZeros(str2) {
        return str2.replace(/^0*(.*)/, "$1") || "0";
      }
      function _normalizeIPv4(host, protocol) {
        var matches = host.match(protocol.IPV4ADDRESS) || [];
        var _matches = slicedToArray(matches, 2), address = _matches[1];
        if (address) {
          return address.split(".").map(_stripLeadingZeros).join(".");
        } else {
          return host;
        }
      }
      function _normalizeIPv6(host, protocol) {
        var matches = host.match(protocol.IPV6ADDRESS) || [];
        var _matches2 = slicedToArray(matches, 3), address = _matches2[1], zone = _matches2[2];
        if (address) {
          var _address$toLowerCase$ = address.toLowerCase().split("::").reverse(), _address$toLowerCase$2 = slicedToArray(_address$toLowerCase$, 2), last = _address$toLowerCase$2[0], first = _address$toLowerCase$2[1];
          var firstFields = first ? first.split(":").map(_stripLeadingZeros) : [];
          var lastFields = last.split(":").map(_stripLeadingZeros);
          var isLastFieldIPv4Address = protocol.IPV4ADDRESS.test(lastFields[lastFields.length - 1]);
          var fieldCount = isLastFieldIPv4Address ? 7 : 8;
          var lastFieldsStart = lastFields.length - fieldCount;
          var fields = Array(fieldCount);
          for (var x = 0; x < fieldCount; ++x) {
            fields[x] = firstFields[x] || lastFields[lastFieldsStart + x] || "";
          }
          if (isLastFieldIPv4Address) {
            fields[fieldCount - 1] = _normalizeIPv4(fields[fieldCount - 1], protocol);
          }
          var allZeroFields = fields.reduce(function (acc, field, index) {
            if (!field || field === "0") {
              var lastLongest = acc[acc.length - 1];
              if (lastLongest && lastLongest.index + lastLongest.length === index) {
                lastLongest.length++;
              } else {
                acc.push({ index, length: 1 });
              }
            }
            return acc;
          }, []);
          var longestZeroFields = allZeroFields.sort(function (a, b) {
            return b.length - a.length;
          })[0];
          var newHost = void 0;
          if (longestZeroFields && longestZeroFields.length > 1) {
            var newFirst = fields.slice(0, longestZeroFields.index);
            var newLast = fields.slice(longestZeroFields.index + longestZeroFields.length);
            newHost = newFirst.join(":") + "::" + newLast.join(":");
          } else {
            newHost = fields.join(":");
          }
          if (zone) {
            newHost += "%" + zone;
          }
          return newHost;
        } else {
          return host;
        }
      }
      var URI_PARSE = /^(?:([^:\/?#]+):)?(?:\/\/((?:([^\/?#@]*)@)?(\[[^\/?#\]]+\]|[^\/?#:]*)(?:\:(\d*))?))?([^?#]*)(?:\?([^#]*))?(?:#((?:.|\n|\r)*))?/i;
      var NO_MATCH_IS_UNDEFINED = "".match(/(){0}/)[1] === void 0;
      function parse2(uriString) {
        var options = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        var components = {};
        var protocol = options.iri !== false ? IRI_PROTOCOL : URI_PROTOCOL;
        if (options.reference === "suffix") uriString = (options.scheme ? options.scheme + ":" : "") + "//" + uriString;
        var matches = uriString.match(URI_PARSE);
        if (matches) {
          if (NO_MATCH_IS_UNDEFINED) {
            components.scheme = matches[1];
            components.userinfo = matches[3];
            components.host = matches[4];
            components.port = parseInt(matches[5], 10);
            components.path = matches[6] || "";
            components.query = matches[7];
            components.fragment = matches[8];
            if (isNaN(components.port)) {
              components.port = matches[5];
            }
          } else {
            components.scheme = matches[1] || void 0;
            components.userinfo = uriString.indexOf("@") !== -1 ? matches[3] : void 0;
            components.host = uriString.indexOf("//") !== -1 ? matches[4] : void 0;
            components.port = parseInt(matches[5], 10);
            components.path = matches[6] || "";
            components.query = uriString.indexOf("?") !== -1 ? matches[7] : void 0;
            components.fragment = uriString.indexOf("#") !== -1 ? matches[8] : void 0;
            if (isNaN(components.port)) {
              components.port = uriString.match(/\/\/(?:.|\n)*\:(?:\/|\?|\#|$)/) ? matches[4] : void 0;
            }
          }
          if (components.host) {
            components.host = _normalizeIPv6(_normalizeIPv4(components.host, protocol), protocol);
          }
          if (components.scheme === void 0 && components.userinfo === void 0 && components.host === void 0 && components.port === void 0 && !components.path && components.query === void 0) {
            components.reference = "same-document";
          } else if (components.scheme === void 0) {
            components.reference = "relative";
          } else if (components.fragment === void 0) {
            components.reference = "absolute";
          } else {
            components.reference = "uri";
          }
          if (options.reference && options.reference !== "suffix" && options.reference !== components.reference) {
            components.error = components.error || "URI is not a " + options.reference + " reference.";
          }
          var schemeHandler = SCHEMES[(options.scheme || components.scheme || "").toLowerCase()];
          if (!options.unicodeSupport && (!schemeHandler || !schemeHandler.unicodeSupport)) {
            if (components.host && (options.domainHost || schemeHandler && schemeHandler.domainHost)) {
              try {
                components.host = punycode.toASCII(components.host.replace(protocol.PCT_ENCODED, pctDecChars).toLowerCase());
              } catch (e) {
                components.error = components.error || "Host's domain name can not be converted to ASCII via punycode: " + e;
              }
            }
            _normalizeComponentEncoding(components, URI_PROTOCOL);
          } else {
            _normalizeComponentEncoding(components, protocol);
          }
          if (schemeHandler && schemeHandler.parse) {
            schemeHandler.parse(components, options);
          }
        } else {
          components.error = components.error || "URI can not be parsed.";
        }
        return components;
      }
      function _recomposeAuthority(components, options) {
        var protocol = options.iri !== false ? IRI_PROTOCOL : URI_PROTOCOL;
        var uriTokens = [];
        if (components.userinfo !== void 0) {
          uriTokens.push(components.userinfo);
          uriTokens.push("@");
        }
        if (components.host !== void 0) {
          uriTokens.push(_normalizeIPv6(_normalizeIPv4(String(components.host), protocol), protocol).replace(protocol.IPV6ADDRESS, function (_, $1, $2) {
            return "[" + $1 + ($2 ? "%25" + $2 : "") + "]";
          }));
        }
        if (typeof components.port === "number" || typeof components.port === "string") {
          uriTokens.push(":");
          uriTokens.push(String(components.port));
        }
        return uriTokens.length ? uriTokens.join("") : void 0;
      }
      var RDS1 = /^\.\.?\//;
      var RDS2 = /^\/\.(\/|$)/;
      var RDS3 = /^\/\.\.(\/|$)/;
      var RDS5 = /^\/?(?:.|\n)*?(?=\/|$)/;
      function removeDotSegments(input) {
        var output = [];
        while (input.length) {
          if (input.match(RDS1)) {
            input = input.replace(RDS1, "");
          } else if (input.match(RDS2)) {
            input = input.replace(RDS2, "/");
          } else if (input.match(RDS3)) {
            input = input.replace(RDS3, "/");
            output.pop();
          } else if (input === "." || input === "..") {
            input = "";
          } else {
            var im = input.match(RDS5);
            if (im) {
              var s = im[0];
              input = input.slice(s.length);
              output.push(s);
            } else {
              throw new Error("Unexpected dot segment condition");
            }
          }
        }
        return output.join("");
      }
      function serialize(components) {
        var options = arguments.length > 1 && arguments[1] !== void 0 ? arguments[1] : {};
        var protocol = options.iri ? IRI_PROTOCOL : URI_PROTOCOL;
        var uriTokens = [];
        var schemeHandler = SCHEMES[(options.scheme || components.scheme || "").toLowerCase()];
        if (schemeHandler && schemeHandler.serialize) schemeHandler.serialize(components, options);
        if (components.host) {
          if (protocol.IPV6ADDRESS.test(components.host)) {
          } else if (options.domainHost || schemeHandler && schemeHandler.domainHost) {
            try {
              components.host = !options.iri ? punycode.toASCII(components.host.replace(protocol.PCT_ENCODED, pctDecChars).toLowerCase()) : punycode.toUnicode(components.host);
            } catch (e) {
              components.error = components.error || "Host's domain name can not be converted to " + (!options.iri ? "ASCII" : "Unicode") + " via punycode: " + e;
            }
          }
        }
        _normalizeComponentEncoding(components, protocol);
        if (options.reference !== "suffix" && components.scheme) {
          uriTokens.push(components.scheme);
          uriTokens.push(":");
        }
        var authority = _recomposeAuthority(components, options);
        if (authority !== void 0) {
          if (options.reference !== "suffix") {
            uriTokens.push("//");
          }
          uriTokens.push(authority);
          if (components.path && components.path.charAt(0) !== "/") {
            uriTokens.push("/");
          }
        }
        if (components.path !== void 0) {
          var s = components.path;
          if (!options.absolutePath && (!schemeHandler || !schemeHandler.absolutePath)) {
            s = removeDotSegments(s);
          }
          if (authority === void 0) {
            s = s.replace(/^\/\//, "/%2F");
          }
          uriTokens.push(s);
        }
        if (components.query !== void 0) {
          uriTokens.push("?");
          uriTokens.push(components.query);
        }
        if (components.fragment !== void 0) {
          uriTokens.push("#");
          uriTokens.push(components.fragment);
        }
        return uriTokens.join("");
      }
      function resolveComponents(base2, relative2) {
        var options = arguments.length > 2 && arguments[2] !== void 0 ? arguments[2] : {};
        var skipNormalization = arguments[3];
        var target = {};
        if (!skipNormalization) {
          base2 = parse2(serialize(base2, options), options);
          relative2 = parse2(serialize(relative2, options), options);
        }
        options = options || {};
        if (!options.tolerant && relative2.scheme) {
          target.scheme = relative2.scheme;
          target.userinfo = relative2.userinfo;
          target.host = relative2.host;
          target.port = relative2.port;
          target.path = removeDotSegments(relative2.path || "");
          target.query = relative2.query;
        } else {
          if (relative2.userinfo !== void 0 || relative2.host !== void 0 || relative2.port !== void 0) {
            target.userinfo = relative2.userinfo;
            target.host = relative2.host;
            target.port = relative2.port;
            target.path = removeDotSegments(relative2.path || "");
            target.query = relative2.query;
          } else {
            if (!relative2.path) {
              target.path = base2.path;
              if (relative2.query !== void 0) {
                target.query = relative2.query;
              } else {
                target.query = base2.query;
              }
            } else {
              if (relative2.path.charAt(0) === "/") {
                target.path = removeDotSegments(relative2.path);
              } else {
                if ((base2.userinfo !== void 0 || base2.host !== void 0 || base2.port !== void 0) && !base2.path) {
                  target.path = "/" + relative2.path;
                } else if (!base2.path) {
                  target.path = relative2.path;
                } else {
                  target.path = base2.path.slice(0, base2.path.lastIndexOf("/") + 1) + relative2.path;
                }
                target.path = removeDotSegments(target.path);
              }
              target.query = relative2.query;
            }
            target.userinfo = base2.userinfo;
            target.host = base2.host;
            target.port = base2.port;
          }
          target.scheme = base2.scheme;
        }
        target.fragment = relative2.fragment;
        return target;
      }
      function resolve(baseURI, relativeURI, options) {
        var schemelessOptions = assign({ scheme: "null" }, options);
        return serialize(resolveComponents(parse2(baseURI, schemelessOptions), parse2(relativeURI, schemelessOptions), schemelessOptions, true), schemelessOptions);
      }
      function normalize2(uri, options) {
        if (typeof uri === "string") {
          uri = serialize(parse2(uri, options), options);
        } else if (typeOf(uri) === "object") {
          uri = parse2(serialize(uri, options), options);
        }
        return uri;
      }
      function equal(uriA, uriB, options) {
        if (typeof uriA === "string") {
          uriA = serialize(parse2(uriA, options), options);
        } else if (typeOf(uriA) === "object") {
          uriA = serialize(uriA, options);
        }
        if (typeof uriB === "string") {
          uriB = serialize(parse2(uriB, options), options);
        } else if (typeOf(uriB) === "object") {
          uriB = serialize(uriB, options);
        }
        return uriA === uriB;
      }
      function escapeComponent(str2, options) {
        return str2 && str2.toString().replace(!options || !options.iri ? URI_PROTOCOL.ESCAPE : IRI_PROTOCOL.ESCAPE, pctEncChar);
      }
      function unescapeComponent(str2, options) {
        return str2 && str2.toString().replace(!options || !options.iri ? URI_PROTOCOL.PCT_ENCODED : IRI_PROTOCOL.PCT_ENCODED, pctDecChars);
      }
      var handler = {
        scheme: "http",
        domainHost: true,
        parse: function parse3(components, options) {
          if (!components.host) {
            components.error = components.error || "HTTP URIs must have a host.";
          }
          return components;
        },
        serialize: function serialize2(components, options) {
          var secure = String(components.scheme).toLowerCase() === "https";
          if (components.port === (secure ? 443 : 80) || components.port === "") {
            components.port = void 0;
          }
          if (!components.path) {
            components.path = "/";
          }
          return components;
        }
      };
      var handler$1 = {
        scheme: "https",
        domainHost: handler.domainHost,
        parse: handler.parse,
        serialize: handler.serialize
      };
      function isSecure(wsComponents) {
        return typeof wsComponents.secure === "boolean" ? wsComponents.secure : String(wsComponents.scheme).toLowerCase() === "wss";
      }
      var handler$2 = {
        scheme: "ws",
        domainHost: true,
        parse: function parse3(components, options) {
          var wsComponents = components;
          wsComponents.secure = isSecure(wsComponents);
          wsComponents.resourceName = (wsComponents.path || "/") + (wsComponents.query ? "?" + wsComponents.query : "");
          wsComponents.path = void 0;
          wsComponents.query = void 0;
          return wsComponents;
        },
        serialize: function serialize2(wsComponents, options) {
          if (wsComponents.port === (isSecure(wsComponents) ? 443 : 80) || wsComponents.port === "") {
            wsComponents.port = void 0;
          }
          if (typeof wsComponents.secure === "boolean") {
            wsComponents.scheme = wsComponents.secure ? "wss" : "ws";
            wsComponents.secure = void 0;
          }
          if (wsComponents.resourceName) {
            var _wsComponents$resourc = wsComponents.resourceName.split("?"), _wsComponents$resourc2 = slicedToArray(_wsComponents$resourc, 2), path5 = _wsComponents$resourc2[0], query = _wsComponents$resourc2[1];
            wsComponents.path = path5 && path5 !== "/" ? path5 : void 0;
            wsComponents.query = query;
            wsComponents.resourceName = void 0;
          }
          wsComponents.fragment = void 0;
          return wsComponents;
        }
      };
      var handler$3 = {
        scheme: "wss",
        domainHost: handler$2.domainHost,
        parse: handler$2.parse,
        serialize: handler$2.serialize
      };
      var O = {};
      var isIRI = true;
      var UNRESERVED$$ = "[A-Za-z0-9\\-\\.\\_\\~" + (isIRI ? "\\xA0-\\u200D\\u2010-\\u2029\\u202F-\\uD7FF\\uF900-\\uFDCF\\uFDF0-\\uFFEF" : "") + "]";
      var HEXDIG$$ = "[0-9A-Fa-f]";
      var PCT_ENCODED$ = subexp(subexp("%[EFef]" + HEXDIG$$ + "%" + HEXDIG$$ + HEXDIG$$ + "%" + HEXDIG$$ + HEXDIG$$) + "|" + subexp("%[89A-Fa-f]" + HEXDIG$$ + "%" + HEXDIG$$ + HEXDIG$$) + "|" + subexp("%" + HEXDIG$$ + HEXDIG$$));
      var ATEXT$$ = "[A-Za-z0-9\\!\\$\\%\\'\\*\\+\\-\\^\\_\\`\\{\\|\\}\\~]";
      var QTEXT$$ = "[\\!\\$\\%\\'\\(\\)\\*\\+\\,\\-\\.0-9\\<\\>A-Z\\x5E-\\x7E]";
      var VCHAR$$ = merge3(QTEXT$$, '[\\"\\\\]');
      var SOME_DELIMS$$ = "[\\!\\$\\'\\(\\)\\*\\+\\,\\;\\:\\@]";
      var UNRESERVED = new RegExp(UNRESERVED$$, "g");
      var PCT_ENCODED = new RegExp(PCT_ENCODED$, "g");
      var NOT_LOCAL_PART = new RegExp(merge3("[^]", ATEXT$$, "[\\.]", '[\\"]', VCHAR$$), "g");
      var NOT_HFNAME = new RegExp(merge3("[^]", UNRESERVED$$, SOME_DELIMS$$), "g");
      var NOT_HFVALUE = NOT_HFNAME;
      function decodeUnreserved(str2) {
        var decStr = pctDecChars(str2);
        return !decStr.match(UNRESERVED) ? str2 : decStr;
      }
      var handler$4 = {
        scheme: "mailto",
        parse: function parse$$1(components, options) {
          var mailtoComponents = components;
          var to = mailtoComponents.to = mailtoComponents.path ? mailtoComponents.path.split(",") : [];
          mailtoComponents.path = void 0;
          if (mailtoComponents.query) {
            var unknownHeaders = false;
            var headers = {};
            var hfields = mailtoComponents.query.split("&");
            for (var x = 0, xl = hfields.length; x < xl; ++x) {
              var hfield = hfields[x].split("=");
              switch (hfield[0]) {
                case "to":
                  var toAddrs = hfield[1].split(",");
                  for (var _x = 0, _xl = toAddrs.length; _x < _xl; ++_x) {
                    to.push(toAddrs[_x]);
                  }
                  break;
                case "subject":
                  mailtoComponents.subject = unescapeComponent(hfield[1], options);
                  break;
                case "body":
                  mailtoComponents.body = unescapeComponent(hfield[1], options);
                  break;
                default:
                  unknownHeaders = true;
                  headers[unescapeComponent(hfield[0], options)] = unescapeComponent(hfield[1], options);
                  break;
              }
            }
            if (unknownHeaders) mailtoComponents.headers = headers;
          }
          mailtoComponents.query = void 0;
          for (var _x2 = 0, _xl2 = to.length; _x2 < _xl2; ++_x2) {
            var addr = to[_x2].split("@");
            addr[0] = unescapeComponent(addr[0]);
            if (!options.unicodeSupport) {
              try {
                addr[1] = punycode.toASCII(unescapeComponent(addr[1], options).toLowerCase());
              } catch (e) {
                mailtoComponents.error = mailtoComponents.error || "Email address's domain name can not be converted to ASCII via punycode: " + e;
              }
            } else {
              addr[1] = unescapeComponent(addr[1], options).toLowerCase();
            }
            to[_x2] = addr.join("@");
          }
          return mailtoComponents;
        },
        serialize: function serialize$$1(mailtoComponents, options) {
          var components = mailtoComponents;
          var to = toArray2(mailtoComponents.to);
          if (to) {
            for (var x = 0, xl = to.length; x < xl; ++x) {
              var toAddr = String(to[x]);
              var atIdx = toAddr.lastIndexOf("@");
              var localPart = toAddr.slice(0, atIdx).replace(PCT_ENCODED, decodeUnreserved).replace(PCT_ENCODED, toUpperCase).replace(NOT_LOCAL_PART, pctEncChar);
              var domain = toAddr.slice(atIdx + 1);
              try {
                domain = !options.iri ? punycode.toASCII(unescapeComponent(domain, options).toLowerCase()) : punycode.toUnicode(domain);
              } catch (e) {
                components.error = components.error || "Email address's domain name can not be converted to " + (!options.iri ? "ASCII" : "Unicode") + " via punycode: " + e;
              }
              to[x] = localPart + "@" + domain;
            }
            components.path = to.join(",");
          }
          var headers = mailtoComponents.headers = mailtoComponents.headers || {};
          if (mailtoComponents.subject) headers["subject"] = mailtoComponents.subject;
          if (mailtoComponents.body) headers["body"] = mailtoComponents.body;
          var fields = [];
          for (var name in headers) {
            if (headers[name] !== O[name]) {
              fields.push(name.replace(PCT_ENCODED, decodeUnreserved).replace(PCT_ENCODED, toUpperCase).replace(NOT_HFNAME, pctEncChar) + "=" + headers[name].replace(PCT_ENCODED, decodeUnreserved).replace(PCT_ENCODED, toUpperCase).replace(NOT_HFVALUE, pctEncChar));
            }
          }
          if (fields.length) {
            components.query = fields.join("&");
          }
          return components;
        }
      };
      var URN_PARSE = /^([^\:]+)\:(.*)/;
      var handler$5 = {
        scheme: "urn",
        parse: function parse$$1(components, options) {
          var matches = components.path && components.path.match(URN_PARSE);
          var urnComponents = components;
          if (matches) {
            var scheme = options.scheme || urnComponents.scheme || "urn";
            var nid = matches[1].toLowerCase();
            var nss = matches[2];
            var urnScheme = scheme + ":" + (options.nid || nid);
            var schemeHandler = SCHEMES[urnScheme];
            urnComponents.nid = nid;
            urnComponents.nss = nss;
            urnComponents.path = void 0;
            if (schemeHandler) {
              urnComponents = schemeHandler.parse(urnComponents, options);
            }
          } else {
            urnComponents.error = urnComponents.error || "URN can not be parsed.";
          }
          return urnComponents;
        },
        serialize: function serialize$$1(urnComponents, options) {
          var scheme = options.scheme || urnComponents.scheme || "urn";
          var nid = urnComponents.nid;
          var urnScheme = scheme + ":" + (options.nid || nid);
          var schemeHandler = SCHEMES[urnScheme];
          if (schemeHandler) {
            urnComponents = schemeHandler.serialize(urnComponents, options);
          }
          var uriComponents = urnComponents;
          var nss = urnComponents.nss;
          uriComponents.path = (nid || options.nid) + ":" + nss;
          return uriComponents;
        }
      };
      var UUID2 = /^[0-9A-Fa-f]{8}(?:\-[0-9A-Fa-f]{4}){3}\-[0-9A-Fa-f]{12}$/;
      var handler$6 = {
        scheme: "urn:uuid",
        parse: function parse3(urnComponents, options) {
          var uuidComponents = urnComponents;
          uuidComponents.uuid = uuidComponents.nss;
          uuidComponents.nss = void 0;
          if (!options.tolerant && (!uuidComponents.uuid || !uuidComponents.uuid.match(UUID2))) {
            uuidComponents.error = uuidComponents.error || "UUID is not valid.";
          }
          return uuidComponents;
        },
        serialize: function serialize2(uuidComponents, options) {
          var urnComponents = uuidComponents;
          urnComponents.nss = (uuidComponents.uuid || "").toLowerCase();
          return urnComponents;
        }
      };
      SCHEMES[handler.scheme] = handler;
      SCHEMES[handler$1.scheme] = handler$1;
      SCHEMES[handler$2.scheme] = handler$2;
      SCHEMES[handler$3.scheme] = handler$3;
      SCHEMES[handler$4.scheme] = handler$4;
      SCHEMES[handler$5.scheme] = handler$5;
      SCHEMES[handler$6.scheme] = handler$6;
      exports3.SCHEMES = SCHEMES;
      exports3.pctEncChar = pctEncChar;
      exports3.pctDecChars = pctDecChars;
      exports3.parse = parse2;
      exports3.removeDotSegments = removeDotSegments;
      exports3.serialize = serialize;
      exports3.resolveComponents = resolveComponents;
      exports3.resolve = resolve;
      exports3.normalize = normalize2;
      exports3.equal = equal;
      exports3.escapeComponent = escapeComponent;
      exports3.unescapeComponent = unescapeComponent;
      Object.defineProperty(exports3, "__esModule", { value: true });
    });
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/runtime/uri.js
var require_uri = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/runtime/uri.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var uri = require_uri_all();
    uri.code = 'require("ajv/dist/runtime/uri").default';
    exports2.default = uri;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/core.js
var require_core2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/core.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CodeGen = exports2.Name = exports2.nil = exports2.stringify = exports2.str = exports2._ = exports2.KeywordCxt = void 0;
    var validate_1 = require_validate();
    Object.defineProperty(exports2, "KeywordCxt", {
      enumerable: true, get: function () {
        return validate_1.KeywordCxt;
      }
    });
    var codegen_1 = require_codegen();
    Object.defineProperty(exports2, "_", {
      enumerable: true, get: function () {
        return codegen_1._;
      }
    });
    Object.defineProperty(exports2, "str", {
      enumerable: true, get: function () {
        return codegen_1.str;
      }
    });
    Object.defineProperty(exports2, "stringify", {
      enumerable: true, get: function () {
        return codegen_1.stringify;
      }
    });
    Object.defineProperty(exports2, "nil", {
      enumerable: true, get: function () {
        return codegen_1.nil;
      }
    });
    Object.defineProperty(exports2, "Name", {
      enumerable: true, get: function () {
        return codegen_1.Name;
      }
    });
    Object.defineProperty(exports2, "CodeGen", {
      enumerable: true, get: function () {
        return codegen_1.CodeGen;
      }
    });
    var validation_error_1 = require_validation_error();
    var ref_error_1 = require_ref_error();
    var rules_1 = require_rules2();
    var compile_1 = require_compile();
    var codegen_2 = require_codegen();
    var resolve_1 = require_resolve();
    var dataType_1 = require_dataType();
    var util_1 = require_util();
    var $dataRefSchema = require_data();
    var uri_1 = require_uri();
    var defaultRegExp = (str2, flags) => new RegExp(str2, flags);
    defaultRegExp.code = "new RegExp";
    var META_IGNORE_OPTIONS = [
      "removeAdditional",
      "useDefaults",
      "coerceTypes",
      "defaultUnevaluatedProperties",
      "defaultAdditionalProperties"
    ];
    var EXT_SCOPE_NAMES = /* @__PURE__ */ new Set([
      "validate",
      "serialize",
      "parse",
      "wrapper",
      "root",
      "schema",
      "keyword",
      "pattern",
      "formats",
      "validate$data",
      "func",
      "obj",
      "Error"
    ]);
    var removedOptions = {
      errorDataPath: "",
      format: "`validateFormats: false` can be used instead.",
      nullable: '"nullable" keyword is supported by default.',
      jsonPointers: "Deprecated jsPropertySyntax can be used instead.",
      extendRefs: "Deprecated ignoreKeywordsWithRef can be used instead.",
      missingRefs: "Pass empty schema with $id that should be ignored to ajv.addSchema.",
      processCode: "Use option `code: {process: (code, schemaEnv: object) => string}`",
      sourceCode: "Use option `code: {source: true}`",
      strictDefaults: "It is default now, see option `strict`.",
      strictKeywords: "It is default now, see option `strict`.",
      uniqueItems: '"uniqueItems" keyword is always validated.',
      unknownFormats: "Disable strict mode or pass `true` to `ajv.addFormat` (or `formats` option).",
      cache: "Map is used as cache, schema object as key.",
      serialize: "Map is used as cache, schema object as key.",
      ajvErrors: "It is default now."
    };
    var deprecatedOptions = {
      ignoreKeywordsWithRef: "",
      jsPropertySyntax: "",
      unicode: '"minLength"/"maxLength" account for unicode characters by default.'
    };
    var MAX_EXPRESSION = 200;
    function requiredOptions(o) {
      var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0;
      const s = o.strict;
      const _optz = (_a = o.code) === null || _a === void 0 ? void 0 : _a.optimize;
      const optimize = _optz === true || _optz === void 0 ? 1 : _optz || 0;
      const regExp = (_c = (_b = o.code) === null || _b === void 0 ? void 0 : _b.regExp) !== null && _c !== void 0 ? _c : defaultRegExp;
      const uriResolver = (_d = o.uriResolver) !== null && _d !== void 0 ? _d : uri_1.default;
      return {
        strictSchema: (_f = (_e = o.strictSchema) !== null && _e !== void 0 ? _e : s) !== null && _f !== void 0 ? _f : true,
        strictNumbers: (_h = (_g = o.strictNumbers) !== null && _g !== void 0 ? _g : s) !== null && _h !== void 0 ? _h : true,
        strictTypes: (_k = (_j = o.strictTypes) !== null && _j !== void 0 ? _j : s) !== null && _k !== void 0 ? _k : "log",
        strictTuples: (_m = (_l = o.strictTuples) !== null && _l !== void 0 ? _l : s) !== null && _m !== void 0 ? _m : "log",
        strictRequired: (_p = (_o = o.strictRequired) !== null && _o !== void 0 ? _o : s) !== null && _p !== void 0 ? _p : false,
        code: o.code ? { ...o.code, optimize, regExp } : { optimize, regExp },
        loopRequired: (_q = o.loopRequired) !== null && _q !== void 0 ? _q : MAX_EXPRESSION,
        loopEnum: (_r = o.loopEnum) !== null && _r !== void 0 ? _r : MAX_EXPRESSION,
        meta: (_s = o.meta) !== null && _s !== void 0 ? _s : true,
        messages: (_t = o.messages) !== null && _t !== void 0 ? _t : true,
        inlineRefs: (_u = o.inlineRefs) !== null && _u !== void 0 ? _u : true,
        schemaId: (_v = o.schemaId) !== null && _v !== void 0 ? _v : "$id",
        addUsedSchema: (_w = o.addUsedSchema) !== null && _w !== void 0 ? _w : true,
        validateSchema: (_x = o.validateSchema) !== null && _x !== void 0 ? _x : true,
        validateFormats: (_y = o.validateFormats) !== null && _y !== void 0 ? _y : true,
        unicodeRegExp: (_z = o.unicodeRegExp) !== null && _z !== void 0 ? _z : true,
        int32range: (_0 = o.int32range) !== null && _0 !== void 0 ? _0 : true,
        uriResolver
      };
    }
    var Ajv = class {
      constructor(opts = {}) {
        this.schemas = {};
        this.refs = {};
        this.formats = {};
        this._compilations = /* @__PURE__ */ new Set();
        this._loading = {};
        this._cache = /* @__PURE__ */ new Map();
        opts = this.opts = { ...opts, ...requiredOptions(opts) };
        const { es5, lines } = this.opts.code;
        this.scope = new codegen_2.ValueScope({ scope: {}, prefixes: EXT_SCOPE_NAMES, es5, lines });
        this.logger = getLogger(opts.logger);
        const formatOpt = opts.validateFormats;
        opts.validateFormats = false;
        this.RULES = (0, rules_1.getRules)();
        checkOptions.call(this, removedOptions, opts, "NOT SUPPORTED");
        checkOptions.call(this, deprecatedOptions, opts, "DEPRECATED", "warn");
        this._metaOpts = getMetaSchemaOptions.call(this);
        if (opts.formats)
          addInitialFormats.call(this);
        this._addVocabularies();
        this._addDefaultMetaSchema();
        if (opts.keywords)
          addInitialKeywords.call(this, opts.keywords);
        if (typeof opts.meta == "object")
          this.addMetaSchema(opts.meta);
        addInitialSchemas.call(this);
        opts.validateFormats = formatOpt;
      }
      _addVocabularies() {
        this.addKeyword("$async");
      }
      _addDefaultMetaSchema() {
        const { $data, meta, schemaId } = this.opts;
        let _dataRefSchema = $dataRefSchema;
        if (schemaId === "id") {
          _dataRefSchema = { ...$dataRefSchema };
          _dataRefSchema.id = _dataRefSchema.$id;
          delete _dataRefSchema.$id;
        }
        if (meta && $data)
          this.addMetaSchema(_dataRefSchema, _dataRefSchema[schemaId], false);
      }
      defaultMeta() {
        const { meta, schemaId } = this.opts;
        return this.opts.defaultMeta = typeof meta == "object" ? meta[schemaId] || meta : void 0;
      }
      validate(schemaKeyRef, data) {
        let v;
        if (typeof schemaKeyRef == "string") {
          v = this.getSchema(schemaKeyRef);
          if (!v)
            throw new Error(`no schema with key or ref "${schemaKeyRef}"`);
        } else {
          v = this.compile(schemaKeyRef);
        }
        const valid = v(data);
        if (!("$async" in v))
          this.errors = v.errors;
        return valid;
      }
      compile(schema2, _meta) {
        const sch = this._addSchema(schema2, _meta);
        return sch.validate || this._compileSchemaEnv(sch);
      }
      compileAsync(schema2, meta) {
        if (typeof this.opts.loadSchema != "function") {
          throw new Error("options.loadSchema should be a function");
        }
        const { loadSchema } = this.opts;
        return runCompileAsync.call(this, schema2, meta);
        async function runCompileAsync(_schema, _meta) {
          await loadMetaSchema.call(this, _schema.$schema);
          const sch = this._addSchema(_schema, _meta);
          return sch.validate || _compileAsync.call(this, sch);
        }
        async function loadMetaSchema($ref) {
          if ($ref && !this.getSchema($ref)) {
            await runCompileAsync.call(this, { $ref }, true);
          }
        }
        async function _compileAsync(sch) {
          try {
            return this._compileSchemaEnv(sch);
          } catch (e) {
            if (!(e instanceof ref_error_1.default))
              throw e;
            checkLoaded.call(this, e);
            await loadMissingSchema.call(this, e.missingSchema);
            return _compileAsync.call(this, sch);
          }
        }
        function checkLoaded({ missingSchema: ref, missingRef }) {
          if (this.refs[ref]) {
            throw new Error(`AnySchema ${ref} is loaded but ${missingRef} cannot be resolved`);
          }
        }
        async function loadMissingSchema(ref) {
          const _schema = await _loadSchema.call(this, ref);
          if (!this.refs[ref])
            await loadMetaSchema.call(this, _schema.$schema);
          if (!this.refs[ref])
            this.addSchema(_schema, ref, meta);
        }
        async function _loadSchema(ref) {
          const p = this._loading[ref];
          if (p)
            return p;
          try {
            return await (this._loading[ref] = loadSchema(ref));
          } finally {
            delete this._loading[ref];
          }
        }
      }
      // Adds schema to the instance
      addSchema(schema2, key, _meta, _validateSchema = this.opts.validateSchema) {
        if (Array.isArray(schema2)) {
          for (const sch of schema2)
            this.addSchema(sch, void 0, _meta, _validateSchema);
          return this;
        }
        let id;
        if (typeof schema2 === "object") {
          const { schemaId } = this.opts;
          id = schema2[schemaId];
          if (id !== void 0 && typeof id != "string") {
            throw new Error(`schema ${schemaId} must be string`);
          }
        }
        key = (0, resolve_1.normalizeId)(key || id);
        this._checkUnique(key);
        this.schemas[key] = this._addSchema(schema2, _meta, key, _validateSchema, true);
        return this;
      }
      // Add schema that will be used to validate other schemas
      // options in META_IGNORE_OPTIONS are alway set to false
      addMetaSchema(schema2, key, _validateSchema = this.opts.validateSchema) {
        this.addSchema(schema2, key, true, _validateSchema);
        return this;
      }
      //  Validate schema against its meta-schema
      validateSchema(schema2, throwOrLogError) {
        if (typeof schema2 == "boolean")
          return true;
        let $schema;
        $schema = schema2.$schema;
        if ($schema !== void 0 && typeof $schema != "string") {
          throw new Error("$schema must be a string");
        }
        $schema = $schema || this.opts.defaultMeta || this.defaultMeta();
        if (!$schema) {
          this.logger.warn("meta-schema not available");
          this.errors = null;
          return true;
        }
        const valid = this.validate($schema, schema2);
        if (!valid && throwOrLogError) {
          const message = "schema is invalid: " + this.errorsText();
          if (this.opts.validateSchema === "log")
            this.logger.error(message);
          else
            throw new Error(message);
        }
        return valid;
      }
      // Get compiled schema by `key` or `ref`.
      // (`key` that was passed to `addSchema` or full schema reference - `schema.$id` or resolved id)
      getSchema(keyRef) {
        let sch;
        while (typeof (sch = getSchEnv.call(this, keyRef)) == "string")
          keyRef = sch;
        if (sch === void 0) {
          const { schemaId } = this.opts;
          const root2 = new compile_1.SchemaEnv({ schema: {}, schemaId });
          sch = compile_1.resolveSchema.call(this, root2, keyRef);
          if (!sch)
            return;
          this.refs[keyRef] = sch;
        }
        return sch.validate || this._compileSchemaEnv(sch);
      }
      // Remove cached schema(s).
      // If no parameter is passed all schemas but meta-schemas are removed.
      // If RegExp is passed all schemas with key/id matching pattern but meta-schemas are removed.
      // Even if schema is referenced by other schemas it still can be removed as other schemas have local references.
      removeSchema(schemaKeyRef) {
        if (schemaKeyRef instanceof RegExp) {
          this._removeAllSchemas(this.schemas, schemaKeyRef);
          this._removeAllSchemas(this.refs, schemaKeyRef);
          return this;
        }
        switch (typeof schemaKeyRef) {
          case "undefined":
            this._removeAllSchemas(this.schemas);
            this._removeAllSchemas(this.refs);
            this._cache.clear();
            return this;
          case "string": {
            const sch = getSchEnv.call(this, schemaKeyRef);
            if (typeof sch == "object")
              this._cache.delete(sch.schema);
            delete this.schemas[schemaKeyRef];
            delete this.refs[schemaKeyRef];
            return this;
          }
          case "object": {
            const cacheKey = schemaKeyRef;
            this._cache.delete(cacheKey);
            let id = schemaKeyRef[this.opts.schemaId];
            if (id) {
              id = (0, resolve_1.normalizeId)(id);
              delete this.schemas[id];
              delete this.refs[id];
            }
            return this;
          }
          default:
            throw new Error("ajv.removeSchema: invalid parameter");
        }
      }
      // add "vocabulary" - a collection of keywords
      addVocabulary(definitions) {
        for (const def of definitions)
          this.addKeyword(def);
        return this;
      }
      addKeyword(kwdOrDef, def) {
        let keyword;
        if (typeof kwdOrDef == "string") {
          keyword = kwdOrDef;
          if (typeof def == "object") {
            this.logger.warn("these parameters are deprecated, see docs for addKeyword");
            def.keyword = keyword;
          }
        } else if (typeof kwdOrDef == "object" && def === void 0) {
          def = kwdOrDef;
          keyword = def.keyword;
          if (Array.isArray(keyword) && !keyword.length) {
            throw new Error("addKeywords: keyword must be string or non-empty array");
          }
        } else {
          throw new Error("invalid addKeywords parameters");
        }
        checkKeyword.call(this, keyword, def);
        if (!def) {
          (0, util_1.eachItem)(keyword, (kwd) => addRule.call(this, kwd));
          return this;
        }
        keywordMetaschema.call(this, def);
        const definition = {
          ...def,
          type: (0, dataType_1.getJSONTypes)(def.type),
          schemaType: (0, dataType_1.getJSONTypes)(def.schemaType)
        };
        (0, util_1.eachItem)(keyword, definition.type.length === 0 ? (k) => addRule.call(this, k, definition) : (k) => definition.type.forEach((t) => addRule.call(this, k, definition, t)));
        return this;
      }
      getKeyword(keyword) {
        const rule = this.RULES.all[keyword];
        return typeof rule == "object" ? rule.definition : !!rule;
      }
      // Remove keyword
      removeKeyword(keyword) {
        const { RULES } = this;
        delete RULES.keywords[keyword];
        delete RULES.all[keyword];
        for (const group of RULES.rules) {
          const i = group.rules.findIndex((rule) => rule.keyword === keyword);
          if (i >= 0)
            group.rules.splice(i, 1);
        }
        return this;
      }
      // Add format
      addFormat(name, format) {
        if (typeof format == "string")
          format = new RegExp(format);
        this.formats[name] = format;
        return this;
      }
      errorsText(errors = this.errors, { separator = ", ", dataVar = "data" } = {}) {
        if (!errors || errors.length === 0)
          return "No errors";
        return errors.map((e) => `${dataVar}${e.instancePath} ${e.message}`).reduce((text, msg) => text + separator + msg);
      }
      $dataMetaSchema(metaSchema, keywordsJsonPointers) {
        const rules = this.RULES.all;
        metaSchema = JSON.parse(JSON.stringify(metaSchema));
        for (const jsonPointer of keywordsJsonPointers) {
          const segments = jsonPointer.split("/").slice(1);
          let keywords = metaSchema;
          for (const seg of segments)
            keywords = keywords[seg];
          for (const key in rules) {
            const rule = rules[key];
            if (typeof rule != "object")
              continue;
            const { $data } = rule.definition;
            const schema2 = keywords[key];
            if ($data && schema2)
              keywords[key] = schemaOrData(schema2);
          }
        }
        return metaSchema;
      }
      _removeAllSchemas(schemas, regex) {
        for (const keyRef in schemas) {
          const sch = schemas[keyRef];
          if (!regex || regex.test(keyRef)) {
            if (typeof sch == "string") {
              delete schemas[keyRef];
            } else if (sch && !sch.meta) {
              this._cache.delete(sch.schema);
              delete schemas[keyRef];
            }
          }
        }
      }
      _addSchema(schema2, meta, baseId, validateSchema = this.opts.validateSchema, addSchema = this.opts.addUsedSchema) {
        let id;
        const { schemaId } = this.opts;
        if (typeof schema2 == "object") {
          id = schema2[schemaId];
        } else {
          if (this.opts.jtd)
            throw new Error("schema must be object");
          else if (typeof schema2 != "boolean")
            throw new Error("schema must be object or boolean");
        }
        let sch = this._cache.get(schema2);
        if (sch !== void 0)
          return sch;
        baseId = (0, resolve_1.normalizeId)(id || baseId);
        const localRefs = resolve_1.getSchemaRefs.call(this, schema2, baseId);
        sch = new compile_1.SchemaEnv({ schema: schema2, schemaId, meta, baseId, localRefs });
        this._cache.set(sch.schema, sch);
        if (addSchema && !baseId.startsWith("#")) {
          if (baseId)
            this._checkUnique(baseId);
          this.refs[baseId] = sch;
        }
        if (validateSchema)
          this.validateSchema(schema2, true);
        return sch;
      }
      _checkUnique(id) {
        if (this.schemas[id] || this.refs[id]) {
          throw new Error(`schema with key or id "${id}" already exists`);
        }
      }
      _compileSchemaEnv(sch) {
        if (sch.meta)
          this._compileMetaSchema(sch);
        else
          compile_1.compileSchema.call(this, sch);
        if (!sch.validate)
          throw new Error("ajv implementation error");
        return sch.validate;
      }
      _compileMetaSchema(sch) {
        const currentOpts = this.opts;
        this.opts = this._metaOpts;
        try {
          compile_1.compileSchema.call(this, sch);
        } finally {
          this.opts = currentOpts;
        }
      }
    };
    exports2.default = Ajv;
    Ajv.ValidationError = validation_error_1.default;
    Ajv.MissingRefError = ref_error_1.default;
    function checkOptions(checkOpts, options, msg, log = "error") {
      for (const key in checkOpts) {
        const opt = key;
        if (opt in options)
          this.logger[log](`${msg}: option ${key}. ${checkOpts[opt]}`);
      }
    }
    function getSchEnv(keyRef) {
      keyRef = (0, resolve_1.normalizeId)(keyRef);
      return this.schemas[keyRef] || this.refs[keyRef];
    }
    function addInitialSchemas() {
      const optsSchemas = this.opts.schemas;
      if (!optsSchemas)
        return;
      if (Array.isArray(optsSchemas))
        this.addSchema(optsSchemas);
      else
        for (const key in optsSchemas)
          this.addSchema(optsSchemas[key], key);
    }
    function addInitialFormats() {
      for (const name in this.opts.formats) {
        const format = this.opts.formats[name];
        if (format)
          this.addFormat(name, format);
      }
    }
    function addInitialKeywords(defs) {
      if (Array.isArray(defs)) {
        this.addVocabulary(defs);
        return;
      }
      this.logger.warn("keywords option as map is deprecated, pass array");
      for (const keyword in defs) {
        const def = defs[keyword];
        if (!def.keyword)
          def.keyword = keyword;
        this.addKeyword(def);
      }
    }
    function getMetaSchemaOptions() {
      const metaOpts = { ...this.opts };
      for (const opt of META_IGNORE_OPTIONS)
        delete metaOpts[opt];
      return metaOpts;
    }
    var noLogs = {
      log() {
      }, warn() {
      }, error() {
      }
    };
    function getLogger(logger) {
      if (logger === false)
        return noLogs;
      if (logger === void 0)
        return console;
      if (logger.log && logger.warn && logger.error)
        return logger;
      throw new Error("logger must implement log, warn and error methods");
    }
    var KEYWORD_NAME = /^[a-z_$][a-z0-9_$:-]*$/i;
    function checkKeyword(keyword, def) {
      const { RULES } = this;
      (0, util_1.eachItem)(keyword, (kwd) => {
        if (RULES.keywords[kwd])
          throw new Error(`Keyword ${kwd} is already defined`);
        if (!KEYWORD_NAME.test(kwd))
          throw new Error(`Keyword ${kwd} has invalid name`);
      });
      if (!def)
        return;
      if (def.$data && !("code" in def || "validate" in def)) {
        throw new Error('$data keyword must have "code" or "validate" function');
      }
    }
    function addRule(keyword, definition, dataType) {
      var _a;
      const post = definition === null || definition === void 0 ? void 0 : definition.post;
      if (dataType && post)
        throw new Error('keyword with "post" flag cannot have "type"');
      const { RULES } = this;
      let ruleGroup = post ? RULES.post : RULES.rules.find(({ type: t }) => t === dataType);
      if (!ruleGroup) {
        ruleGroup = { type: dataType, rules: [] };
        RULES.rules.push(ruleGroup);
      }
      RULES.keywords[keyword] = true;
      if (!definition)
        return;
      const rule = {
        keyword,
        definition: {
          ...definition,
          type: (0, dataType_1.getJSONTypes)(definition.type),
          schemaType: (0, dataType_1.getJSONTypes)(definition.schemaType)
        }
      };
      if (definition.before)
        addBeforeRule.call(this, ruleGroup, rule, definition.before);
      else
        ruleGroup.rules.push(rule);
      RULES.all[keyword] = rule;
      (_a = definition.implements) === null || _a === void 0 ? void 0 : _a.forEach((kwd) => this.addKeyword(kwd));
    }
    function addBeforeRule(ruleGroup, rule, before) {
      const i = ruleGroup.rules.findIndex((_rule) => _rule.keyword === before);
      if (i >= 0) {
        ruleGroup.rules.splice(i, 0, rule);
      } else {
        ruleGroup.rules.push(rule);
        this.logger.warn(`rule ${before} is not defined`);
      }
    }
    function keywordMetaschema(def) {
      let { metaSchema } = def;
      if (metaSchema === void 0)
        return;
      if (def.$data && this.opts.$data)
        metaSchema = schemaOrData(metaSchema);
      def.validateSchema = this.compile(metaSchema, true);
    }
    var $dataRef = {
      $ref: "https://raw.githubusercontent.com/ajv-validator/ajv/master/lib/refs/data.json#"
    };
    function schemaOrData(schema2) {
      return { anyOf: [schema2, $dataRef] };
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/core/id.js
var require_id = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/core/id.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var def = {
      keyword: "id",
      code() {
        throw new Error('NOT SUPPORTED: keyword "id", use "$id" for schema ID');
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/core/ref.js
var require_ref = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/core/ref.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.callRef = exports2.getValidate = void 0;
    var ref_error_1 = require_ref_error();
    var code_1 = require_code2();
    var codegen_1 = require_codegen();
    var names_1 = require_names();
    var compile_1 = require_compile();
    var util_1 = require_util();
    var def = {
      keyword: "$ref",
      schemaType: "string",
      code(cxt) {
        const { gen, schema: $ref, it } = cxt;
        const { baseId, schemaEnv: env, validateName: validateName2, opts, self: self2 } = it;
        const { root: root2 } = env;
        if (($ref === "#" || $ref === "#/") && baseId === root2.baseId)
          return callRootRef();
        const schOrEnv = compile_1.resolveRef.call(self2, root2, baseId, $ref);
        if (schOrEnv === void 0)
          throw new ref_error_1.default(it.opts.uriResolver, baseId, $ref);
        if (schOrEnv instanceof compile_1.SchemaEnv)
          return callValidate(schOrEnv);
        return inlineRefSchema(schOrEnv);
        function callRootRef() {
          if (env === root2)
            return callRef(cxt, validateName2, env, env.$async);
          const rootName = gen.scopeValue("root", { ref: root2 });
          return callRef(cxt, (0, codegen_1._)`${rootName}.validate`, root2, root2.$async);
        }
        function callValidate(sch) {
          const v = getValidate(cxt, sch);
          callRef(cxt, v, sch, sch.$async);
        }
        function inlineRefSchema(sch) {
          const schName = gen.scopeValue("schema", opts.code.source === true ? { ref: sch, code: (0, codegen_1.stringify)(sch) } : { ref: sch });
          const valid = gen.name("valid");
          const schCxt = cxt.subschema(
            {
              schema: sch,
              dataTypes: [],
              schemaPath: codegen_1.nil,
              topSchemaRef: schName,
              errSchemaPath: $ref
            },
            valid,
            it.isAllOfVariant
            // pass isAllOfVariant into inlined $ref
          );
          cxt.mergeEvaluated(schCxt);
          cxt.ok(valid);
        }
      }
    };
    function getValidate(cxt, sch) {
      const { gen } = cxt;
      return sch.validate ? gen.scopeValue("validate", { ref: sch.validate }) : (0, codegen_1._)`${gen.scopeValue("wrapper", { ref: sch })}.validate`;
    }
    exports2.getValidate = getValidate;
    function callRef(cxt, v, sch, $async) {
      const { gen, it } = cxt;
      const { allErrors, schemaEnv: env, opts } = it;
      const passCxt = opts.passContext ? names_1.default.this : codegen_1.nil;
      if ($async)
        callAsyncRef();
      else
        callSyncRef();
      function callAsyncRef() {
        if (!env.$async)
          throw new Error("async schema referenced by sync schema");
        const valid = gen.let("valid");
        gen.try(() => {
          gen.code((0, codegen_1._)`await ${(0, code_1.callValidateCode)(cxt, v, passCxt)}`);
          addEvaluatedFrom(v);
          if (!allErrors)
            gen.assign(valid, true);
        }, (e) => {
          gen.if((0, codegen_1._)`!(${e} instanceof ${it.ValidationError})`, () => gen.throw(e));
          addErrorsFrom(e);
          if (!allErrors)
            gen.assign(valid, false);
        });
        cxt.ok(valid);
      }
      function callSyncRef() {
        const visitedNodes = gen.name("visitedNodes");
        gen.code((0, codegen_1._)`const ${visitedNodes} = (typeof visitedNodesForRef !== 'undefined') && visitedNodesForRef.get(${v}) || new Set()`);
        gen.if((0, codegen_1._)`!${visitedNodes}.has(${cxt.data})`, () => {
          gen.code((0, codegen_1._)`if (typeof visitedNodesForRef !== 'undefined') visitedNodesForRef.set(${v}, ${visitedNodes})`);
          gen.code((0, codegen_1._)`const dataNode = ${cxt.data}`);
          gen.code((0, codegen_1._)`if (typeof dataNode === "object" && dataNode !== null) ${visitedNodes}.add(dataNode)`);
          const res = cxt.result((0, code_1.callValidateCode)(cxt, v, passCxt), () => addEvaluatedFrom(v), () => addErrorsFrom(v));
          gen.code((0, codegen_1._)`${visitedNodes}.delete(dataNode)`);
          return res;
        });
      }
      function addErrorsFrom(source) {
        const errs = (0, codegen_1._)`${source}.errors`;
        gen.assign(names_1.default.vErrors, (0, codegen_1._)`${names_1.default.vErrors} === null ? ${errs} : ${names_1.default.vErrors}.concat(${errs})`);
        gen.assign(names_1.default.errors, (0, codegen_1._)`${names_1.default.vErrors}.length`);
      }
      function addEvaluatedFrom(source) {
        var _a;
        if (!it.opts.unevaluated)
          return;
        const schEvaluated = (_a = sch === null || sch === void 0 ? void 0 : sch.validate) === null || _a === void 0 ? void 0 : _a.evaluated;
        if (it.props !== true) {
          if (schEvaluated && !schEvaluated.dynamicProps) {
            if (schEvaluated.props !== void 0) {
              it.props = util_1.mergeEvaluated.props(gen, schEvaluated.props, it.props);
            }
          } else {
            const props = gen.var("props", (0, codegen_1._)`${source}.evaluated.props`);
            it.props = util_1.mergeEvaluated.props(gen, props, it.props, codegen_1.Name);
          }
        }
        if (it.items !== true) {
          if (schEvaluated && !schEvaluated.dynamicItems) {
            if (schEvaluated.items !== void 0) {
              it.items = util_1.mergeEvaluated.items(gen, schEvaluated.items, it.items);
            }
          } else {
            const items = gen.var("items", (0, codegen_1._)`${source}.evaluated.items`);
            it.items = util_1.mergeEvaluated.items(gen, items, it.items, codegen_1.Name);
          }
        }
      }
    }
    exports2.callRef = callRef;
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/core/index.js
var require_core3 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/core/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var id_1 = require_id();
    var ref_1 = require_ref();
    var core2 = [
      "$schema",
      "$id",
      "$defs",
      "$vocabulary",
      { keyword: "$comment" },
      "definitions",
      id_1.default,
      ref_1.default
    ];
    exports2.default = core2;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/limitNumber.js
var require_limitNumber = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/limitNumber.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var ops = codegen_1.operators;
    var KWDs = {
      maximum: { okStr: "<=", ok: ops.LTE, fail: ops.GT },
      minimum: { okStr: ">=", ok: ops.GTE, fail: ops.LT },
      exclusiveMaximum: { okStr: "<", ok: ops.LT, fail: ops.GTE },
      exclusiveMinimum: { okStr: ">", ok: ops.GT, fail: ops.LTE }
    };
    var error = {
      message: ({ keyword, schemaCode }) => (0, codegen_1.str)`must be ${KWDs[keyword].okStr} ${schemaCode}`,
      params: ({ keyword, schemaCode }) => (0, codegen_1._)`{comparison: ${KWDs[keyword].okStr}, limit: ${schemaCode}}`
    };
    var def = {
      keyword: Object.keys(KWDs),
      type: "number",
      schemaType: "number",
      $data: true,
      error,
      code(cxt) {
        const { keyword, data, schemaCode } = cxt;
        cxt.fail$data((0, codegen_1._)`${data} ${KWDs[keyword].fail} ${schemaCode} || isNaN(${data})`);
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/multipleOf.js
var require_multipleOf = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/multipleOf.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var error = {
      message: ({ schemaCode }) => (0, codegen_1.str)`must be multiple of ${schemaCode}`,
      params: ({ schemaCode }) => (0, codegen_1._)`{multipleOf: ${schemaCode}}`
    };
    var def = {
      keyword: "multipleOf",
      type: "number",
      schemaType: "number",
      $data: true,
      error,
      code(cxt) {
        const { gen, data, schemaCode, it } = cxt;
        const prec = it.opts.multipleOfPrecision;
        const res = gen.let("res");
        const invalid = prec ? (0, codegen_1._)`Math.abs(Math.round(${res}) - ${res}) > 1e-${prec}` : (0, codegen_1._)`${res} !== parseInt(${res})`;
        cxt.fail$data((0, codegen_1._)`(${schemaCode} === 0 || (${res} = ${data}/${schemaCode}, ${invalid}))`);
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/runtime/ucs2length.js
var require_ucs2length = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/runtime/ucs2length.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    function ucs2length(str2) {
      const len = str2.length;
      let length = 0;
      let pos = 0;
      let value;
      while (pos < len) {
        length++;
        value = str2.charCodeAt(pos++);
        if (value >= 55296 && value <= 56319 && pos < len) {
          value = str2.charCodeAt(pos);
          if ((value & 64512) === 56320)
            pos++;
        }
      }
      return length;
    }
    exports2.default = ucs2length;
    ucs2length.code = 'require("ajv/dist/runtime/ucs2length").default';
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/limitLength.js
var require_limitLength = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/limitLength.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var ucs2length_1 = require_ucs2length();
    var error = {
      message({ keyword, schemaCode }) {
        const comp = keyword === "maxLength" ? "more" : "fewer";
        return (0, codegen_1.str)`must NOT have ${comp} than ${schemaCode} characters`;
      },
      params: ({ schemaCode }) => (0, codegen_1._)`{limit: ${schemaCode}}`
    };
    var def = {
      keyword: ["maxLength", "minLength"],
      type: "string",
      schemaType: "number",
      $data: true,
      error,
      code(cxt) {
        const { keyword, data, schemaCode, it } = cxt;
        const op = keyword === "maxLength" ? codegen_1.operators.GT : codegen_1.operators.LT;
        const len = it.opts.unicode === false ? (0, codegen_1._)`${data}.length` : (0, codegen_1._)`${(0, util_1.useFunc)(cxt.gen, ucs2length_1.default)}(${data})`;
        cxt.fail$data((0, codegen_1._)`${len} ${op} ${schemaCode}`);
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/pattern.js
var require_pattern = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/pattern.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var code_1 = require_code2();
    var codegen_1 = require_codegen();
    var error = {
      message: ({ schemaCode }) => (0, codegen_1.str)`must match pattern "${schemaCode}"`,
      params: ({ schemaCode }) => (0, codegen_1._)`{pattern: ${schemaCode}}`
    };
    var def = {
      keyword: "pattern",
      type: "string",
      schemaType: "string",
      $data: true,
      error,
      code(cxt) {
        const { data, $data, schema: schema2, schemaCode, it } = cxt;
        const u = it.opts.unicodeRegExp ? "u" : "";
        const regExp = $data ? (0, codegen_1._)`(new RegExp(${schemaCode}, ${u}))` : (0, code_1.usePattern)(cxt, schema2);
        cxt.fail$data((0, codegen_1._)`!${regExp}.test(${data})`);
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/limitProperties.js
var require_limitProperties = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/limitProperties.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var error = {
      message({ keyword, schemaCode }) {
        const comp = keyword === "maxProperties" ? "more" : "fewer";
        return (0, codegen_1.str)`must NOT have ${comp} than ${schemaCode} properties`;
      },
      params: ({ schemaCode }) => (0, codegen_1._)`{limit: ${schemaCode}}`
    };
    var def = {
      keyword: ["maxProperties", "minProperties"],
      type: "object",
      schemaType: "number",
      $data: true,
      error,
      code(cxt) {
        const { keyword, data, schemaCode } = cxt;
        const op = keyword === "maxProperties" ? codegen_1.operators.GT : codegen_1.operators.LT;
        cxt.fail$data((0, codegen_1._)`Object.keys(${data}).length ${op} ${schemaCode}`);
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/required.js
var require_required = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/required.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var code_1 = require_code2();
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var error = {
      message: ({ params: { missingProperty } }) => (0, codegen_1.str)`must have required property '${missingProperty}'`,
      params: ({ params: { missingProperty } }) => (0, codegen_1._)`{missingProperty: ${missingProperty}}`
    };
    var def = {
      keyword: "required",
      type: "object",
      schemaType: "array",
      $data: true,
      error,
      code(cxt) {
        const { gen, schema: schema2, schemaCode, data, $data, it } = cxt;
        const { opts } = it;
        if (!$data && schema2.length === 0)
          return;
        const useLoop = schema2.length >= opts.loopRequired;
        if (it.allErrors)
          allErrorsMode();
        else
          exitOnErrorMode();
        if (opts.strictRequired) {
          const props = cxt.parentSchema.properties;
          const { definedProperties } = cxt.it;
          for (const requiredKey of schema2) {
            if ((props === null || props === void 0 ? void 0 : props[requiredKey]) === void 0 && !definedProperties.has(requiredKey)) {
              const schemaPath = it.schemaEnv.baseId + it.errSchemaPath;
              const msg = `required property "${requiredKey}" is not defined at "${schemaPath}" (strictRequired)`;
              (0, util_1.checkStrictMode)(it, msg, it.opts.strictRequired);
            }
          }
        }
        function allErrorsMode() {
          if (useLoop || $data) {
            cxt.block$data(codegen_1.nil, loopAllRequired);
          } else {
            for (const prop of schema2) {
              (0, code_1.checkReportMissingProp)(cxt, prop);
            }
          }
        }
        function exitOnErrorMode() {
          const missing = gen.let("missing");
          if (useLoop || $data) {
            const valid = gen.let("valid", true);
            cxt.block$data(valid, () => loopUntilMissing(missing, valid));
            cxt.ok(valid);
          } else {
            gen.if((0, code_1.checkMissingProp)(cxt, schema2, missing));
            (0, code_1.reportMissingProp)(cxt, missing);
            gen.else();
          }
        }
        function loopAllRequired() {
          gen.forOf("prop", schemaCode, (prop) => {
            cxt.setParams({ missingProperty: prop });
            gen.if((0, code_1.noPropertyInData)(gen, data, prop, opts.ownProperties), () => cxt.error());
          });
        }
        function loopUntilMissing(missing, valid) {
          cxt.setParams({ missingProperty: missing });
          gen.forOf(missing, schemaCode, () => {
            gen.assign(valid, (0, code_1.propertyInData)(gen, data, missing, opts.ownProperties));
            gen.if((0, codegen_1.not)(valid), () => {
              cxt.error();
              gen.break();
            });
          }, codegen_1.nil);
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/limitItems.js
var require_limitItems = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/limitItems.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var error = {
      message({ keyword, schemaCode }) {
        const comp = keyword === "maxItems" ? "more" : "fewer";
        return (0, codegen_1.str)`must NOT have ${comp} than ${schemaCode} items`;
      },
      params: ({ schemaCode }) => (0, codegen_1._)`{limit: ${schemaCode}}`
    };
    var def = {
      keyword: ["maxItems", "minItems"],
      type: "array",
      schemaType: "number",
      $data: true,
      error,
      code(cxt) {
        const { keyword, data, schemaCode } = cxt;
        const op = keyword === "maxItems" ? codegen_1.operators.GT : codegen_1.operators.LT;
        cxt.fail$data((0, codegen_1._)`${data}.length ${op} ${schemaCode}`);
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/runtime/equal.js
var require_equal = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/runtime/equal.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var equal = require_fast_deep_equal();
    equal.code = 'require("ajv/dist/runtime/equal").default';
    exports2.default = equal;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/uniqueItems.js
var require_uniqueItems = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/uniqueItems.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var dataType_1 = require_dataType();
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var equal_1 = require_equal();
    var error = {
      message: ({ params: { i, j } }) => (0, codegen_1.str)`must NOT have duplicate items (items ## ${j} and ${i} are identical)`,
      params: ({ params: { i, j } }) => (0, codegen_1._)`{i: ${i}, j: ${j}}`
    };
    var def = {
      keyword: "uniqueItems",
      type: "array",
      schemaType: "boolean",
      $data: true,
      error,
      code(cxt) {
        const { gen, data, $data, schema: schema2, parentSchema, schemaCode, it } = cxt;
        if (!$data && !schema2)
          return;
        const valid = gen.let("valid");
        const itemTypes = parentSchema.items ? (0, dataType_1.getSchemaTypes)(parentSchema.items) : [];
        cxt.block$data(valid, validateUniqueItems, (0, codegen_1._)`${schemaCode} === false`);
        cxt.ok(valid);
        function validateUniqueItems() {
          const i = gen.let("i", (0, codegen_1._)`${data}.length`);
          const j = gen.let("j");
          cxt.setParams({ i, j });
          gen.assign(valid, true);
          gen.if((0, codegen_1._)`${i} > 1`, () => (canOptimize() ? loopN : loopN2)(i, j));
        }
        function canOptimize() {
          return itemTypes.length > 0 && !itemTypes.some((t) => t === "object" || t === "array");
        }
        function loopN(i, j) {
          const item = gen.name("item");
          const wrongType = (0, dataType_1.checkDataTypes)(itemTypes, item, it.opts.strictNumbers, dataType_1.DataType.Wrong);
          const indices = gen.const("indices", (0, codegen_1._)`{}`);
          gen.for((0, codegen_1._)`;${i}--;`, () => {
            gen.let(item, (0, codegen_1._)`${data}[${i}]`);
            gen.if(wrongType, (0, codegen_1._)`continue`);
            if (itemTypes.length > 1)
              gen.if((0, codegen_1._)`typeof ${item} == "string"`, (0, codegen_1._)`${item} += "_"`);
            gen.if((0, codegen_1._)`typeof ${indices}[${item}] == "number"`, () => {
              gen.assign(j, (0, codegen_1._)`${indices}[${item}]`);
              cxt.error();
              gen.assign(valid, false).break();
            }).code((0, codegen_1._)`${indices}[${item}] = ${i}`);
          });
        }
        function loopN2(i, j) {
          const eql = (0, util_1.useFunc)(gen, equal_1.default);
          const outer = gen.name("outer");
          gen.label(outer).for((0, codegen_1._)`;${i}--;`, () => gen.for((0, codegen_1._)`${j} = ${i}; ${j}--;`, () => gen.if((0, codegen_1._)`${eql}(${data}[${i}], ${data}[${j}])`, () => {
            cxt.error();
            gen.assign(valid, false).break(outer);
          })));
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/const.js
var require_const = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/const.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var equal_1 = require_equal();
    var error = {
      message: "must be equal to constant",
      params: ({ schemaCode }) => (0, codegen_1._)`{allowedValue: ${schemaCode}}`
    };
    var def = {
      keyword: "const",
      $data: true,
      error,
      code(cxt) {
        const { gen, data, $data, schemaCode, schema: schema2 } = cxt;
        if ($data || schema2 && typeof schema2 == "object") {
          cxt.fail$data((0, codegen_1._)`!${(0, util_1.useFunc)(gen, equal_1.default)}(${data}, ${schemaCode})`);
        } else {
          cxt.fail((0, codegen_1._)`${schema2} !== ${data}`);
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/enum.js
var require_enum = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/enum.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var equal_1 = require_equal();
    var error = {
      message: "must be equal to one of the allowed values",
      params: ({ schemaCode }) => (0, codegen_1._)`{allowedValues: ${schemaCode}}`
    };
    var def = {
      keyword: "enum",
      schemaType: "array",
      $data: true,
      error,
      code(cxt) {
        const { gen, data, $data, schema: schema2, schemaCode, it } = cxt;
        if (!$data && schema2.length === 0)
          throw new Error("enum must have non-empty array");
        const useLoop = schema2.length >= it.opts.loopEnum;
        let eql;
        const getEql = () => eql !== null && eql !== void 0 ? eql : eql = (0, util_1.useFunc)(gen, equal_1.default);
        let valid;
        if (useLoop || $data) {
          valid = gen.let("valid");
          cxt.block$data(valid, loopEnum);
        } else {
          if (!Array.isArray(schema2))
            throw new Error("ajv implementation error");
          const vSchema = gen.const("vSchema", schemaCode);
          valid = (0, codegen_1.or)(...schema2.map((_x, i) => equalCode(vSchema, i)));
        }
        cxt.pass(valid);
        function loopEnum() {
          gen.assign(valid, false);
          gen.forOf("v", schemaCode, (v) => gen.if((0, codegen_1._)`${getEql()}(${data}, ${v})`, () => gen.assign(valid, true).break()));
        }
        function equalCode(vSchema, i) {
          const sch = schema2[i];
          return typeof sch === "object" && sch !== null ? (0, codegen_1._)`${getEql()}(${data}, ${vSchema}[${i}])` : (0, codegen_1._)`${data} === ${sch}`;
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/index.js
var require_validation = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var limitNumber_1 = require_limitNumber();
    var multipleOf_1 = require_multipleOf();
    var limitLength_1 = require_limitLength();
    var pattern_1 = require_pattern();
    var limitProperties_1 = require_limitProperties();
    var required_1 = require_required();
    var limitItems_1 = require_limitItems();
    var uniqueItems_1 = require_uniqueItems();
    var const_1 = require_const();
    var enum_1 = require_enum();
    var validation = [
      // number
      limitNumber_1.default,
      multipleOf_1.default,
      // string
      limitLength_1.default,
      pattern_1.default,
      // object
      limitProperties_1.default,
      required_1.default,
      // array
      limitItems_1.default,
      uniqueItems_1.default,
      // any
      { keyword: "type", schemaType: ["string", "array"] },
      { keyword: "nullable", schemaType: "boolean" },
      const_1.default,
      enum_1.default
    ];
    exports2.default = validation;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/additionalItems.js
var require_additionalItems = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/additionalItems.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.validateAdditionalItems = void 0;
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var error = {
      message: ({ params: { len } }) => (0, codegen_1.str)`must NOT have more than ${len} items`,
      params: ({ params: { len } }) => (0, codegen_1._)`{limit: ${len}}`
    };
    var def = {
      keyword: "additionalItems",
      type: "array",
      schemaType: ["boolean", "object"],
      before: "uniqueItems",
      error,
      code(cxt) {
        const { parentSchema, it } = cxt;
        const { items } = parentSchema;
        if (!Array.isArray(items)) {
          (0, util_1.checkStrictMode)(it, '"additionalItems" is ignored when "items" is not an array of schemas');
          return;
        }
        validateAdditionalItems(cxt, items);
      }
    };
    function validateAdditionalItems(cxt, items) {
      const { gen, schema: schema2, data, keyword, it } = cxt;
      it.items = true;
      const len = gen.const("len", (0, codegen_1._)`${data}.length`);
      if (schema2 === false) {
        cxt.setParams({ len: items.length });
        cxt.pass((0, codegen_1._)`${len} <= ${items.length}`);
      } else if (typeof schema2 == "object" && !(0, util_1.alwaysValidSchema)(it, schema2)) {
        const valid = gen.var("valid", (0, codegen_1._)`${len} <= ${items.length}`);
        gen.if((0, codegen_1.not)(valid), () => validateItems(valid));
        cxt.ok(valid);
      }
      function validateItems(valid) {
        gen.forRange("i", items.length, len, (i) => {
          cxt.subschema({ keyword, dataProp: i, dataPropType: util_1.Type.Num }, valid);
          if (!it.allErrors)
            gen.if((0, codegen_1.not)(valid), () => gen.break());
        });
      }
    }
    exports2.validateAdditionalItems = validateAdditionalItems;
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/items.js
var require_items = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/items.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.validateTuple = void 0;
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var code_1 = require_code2();
    var def = {
      keyword: "items",
      type: "array",
      schemaType: ["object", "array", "boolean"],
      before: "uniqueItems",
      code(cxt) {
        const { schema: schema2, it } = cxt;
        if (Array.isArray(schema2))
          return validateTuple(cxt, "additionalItems", schema2);
        it.items = true;
        if ((0, util_1.alwaysValidSchema)(it, schema2))
          return;
        cxt.ok((0, code_1.validateArray)(cxt));
      }
    };
    function validateTuple(cxt, extraItems, schArr = cxt.schema) {
      const { gen, parentSchema, data, keyword, it } = cxt;
      checkStrictTuple(parentSchema);
      if (it.opts.unevaluated && schArr.length && it.items !== true) {
        it.items = util_1.mergeEvaluated.items(gen, schArr.length, it.items);
      }
      const valid = gen.name("valid");
      const len = gen.const("len", (0, codegen_1._)`${data}.length`);
      schArr.forEach((sch, i) => {
        if ((0, util_1.alwaysValidSchema)(it, sch))
          return;
        gen.if((0, codegen_1._)`${len} > ${i}`, () => cxt.subschema({
          keyword,
          schemaProp: i,
          dataProp: i
        }, valid));
        cxt.ok(valid);
      });
      function checkStrictTuple(sch) {
        const { opts, errSchemaPath } = it;
        const l = schArr.length;
        const fullTuple = l === sch.minItems && (l === sch.maxItems || sch[extraItems] === false);
        if (opts.strictTuples && !fullTuple) {
          const msg = `"${keyword}" is ${l}-tuple, but minItems or maxItems/${extraItems} are not specified or different at path "${errSchemaPath}"`;
          (0, util_1.checkStrictMode)(it, msg, opts.strictTuples);
        }
      }
    }
    exports2.validateTuple = validateTuple;
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/prefixItems.js
var require_prefixItems = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/prefixItems.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var items_1 = require_items();
    var def = {
      keyword: "prefixItems",
      type: "array",
      schemaType: ["array"],
      before: "uniqueItems",
      code: (cxt) => (0, items_1.validateTuple)(cxt, "items")
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/items2020.js
var require_items2020 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/items2020.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var code_1 = require_code2();
    var additionalItems_1 = require_additionalItems();
    var error = {
      message: ({ params: { len } }) => (0, codegen_1.str)`must NOT have more than ${len} items`,
      params: ({ params: { len } }) => (0, codegen_1._)`{limit: ${len}}`
    };
    var def = {
      keyword: "items",
      type: "array",
      schemaType: ["object", "boolean"],
      before: "uniqueItems",
      error,
      code(cxt) {
        const { schema: schema2, parentSchema, it } = cxt;
        const { prefixItems } = parentSchema;
        it.items = true;
        if ((0, util_1.alwaysValidSchema)(it, schema2))
          return;
        if (prefixItems)
          (0, additionalItems_1.validateAdditionalItems)(cxt, prefixItems);
        else
          cxt.ok((0, code_1.validateArray)(cxt));
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/contains.js
var require_contains = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/contains.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var error = {
      message: ({ params: { min, max } }) => max === void 0 ? (0, codegen_1.str)`must contain at least ${min} valid item(s)` : (0, codegen_1.str)`must contain at least ${min} and no more than ${max} valid item(s)`,
      params: ({ params: { min, max } }) => max === void 0 ? (0, codegen_1._)`{minContains: ${min}}` : (0, codegen_1._)`{minContains: ${min}, maxContains: ${max}}`
    };
    var def = {
      keyword: "contains",
      type: "array",
      schemaType: ["object", "boolean"],
      before: "uniqueItems",
      trackErrors: true,
      error,
      code(cxt) {
        const { gen, schema: schema2, parentSchema, data, it } = cxt;
        let min;
        let max;
        const { minContains, maxContains } = parentSchema;
        if (it.opts.next) {
          min = minContains === void 0 ? 1 : minContains;
          max = maxContains;
        } else {
          min = 1;
        }
        const len = gen.const("len", (0, codegen_1._)`${data}.length`);
        cxt.setParams({ min, max });
        if (max === void 0 && min === 0) {
          (0, util_1.checkStrictMode)(it, `"minContains" == 0 without "maxContains": "contains" keyword ignored`);
          return;
        }
        if (max !== void 0 && min > max) {
          (0, util_1.checkStrictMode)(it, `"minContains" > "maxContains" is always invalid`);
          cxt.fail();
          return;
        }
        if ((0, util_1.alwaysValidSchema)(it, schema2)) {
          let cond = (0, codegen_1._)`${len} >= ${min}`;
          if (max !== void 0)
            cond = (0, codegen_1._)`${cond} && ${len} <= ${max}`;
          cxt.pass(cond);
          return;
        }
        it.items = true;
        const valid = gen.name("valid");
        if (max === void 0 && min === 1) {
          validateItems(valid, () => gen.if(valid, () => gen.break()));
        } else if (min === 0) {
          gen.let(valid, true);
          if (max !== void 0)
            gen.if((0, codegen_1._)`${data}.length > 0`, validateItemsWithCount);
        } else {
          gen.let(valid, false);
          validateItemsWithCount();
        }
        cxt.result(valid, () => cxt.reset());
        function validateItemsWithCount() {
          const schValid = gen.name("_valid");
          const count = gen.let("count", 0);
          validateItems(schValid, () => gen.if(schValid, () => checkLimits(count)));
        }
        function validateItems(_valid, block) {
          gen.forRange("i", 0, len, (i) => {
            cxt.subschema({
              keyword: "contains",
              dataProp: i,
              dataPropType: util_1.Type.Num,
              compositeRule: true
            }, _valid);
            block();
          });
        }
        function checkLimits(count) {
          gen.code((0, codegen_1._)`${count}++`);
          if (max === void 0) {
            gen.if((0, codegen_1._)`${count} >= ${min}`, () => gen.assign(valid, true).break());
          } else {
            gen.if((0, codegen_1._)`${count} > ${max}`, () => gen.assign(valid, false).break());
            if (min === 1)
              gen.assign(valid, true);
            else
              gen.if((0, codegen_1._)`${count} >= ${min}`, () => gen.assign(valid, true));
          }
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/dependencies.js
var require_dependencies = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/dependencies.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.validateSchemaDeps = exports2.validatePropertyDeps = exports2.error = void 0;
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var code_1 = require_code2();
    exports2.error = {
      message: ({ params: { property: property4, depsCount, deps } }) => {
        const property_ies = depsCount === 1 ? "property" : "properties";
        return (0, codegen_1.str)`must have ${property_ies} ${deps} when property ${property4} is present`;
      },
      params: ({ params: { property: property4, depsCount, deps, missingProperty } }) => (0, codegen_1._)`{property: ${property4},
    missingProperty: ${missingProperty},
    depsCount: ${depsCount},
    deps: ${deps}}`
      // TODO change to reference
    };
    var def = {
      keyword: "dependencies",
      type: "object",
      schemaType: "object",
      error: exports2.error,
      code(cxt) {
        const [propDeps, schDeps] = splitDependencies(cxt);
        validatePropertyDeps(cxt, propDeps);
        validateSchemaDeps(cxt, schDeps);
      }
    };
    function splitDependencies({ schema: schema2 }) {
      const propertyDeps = {};
      const schemaDeps = {};
      for (const key in schema2) {
        if (key === "__proto__")
          continue;
        const deps = Array.isArray(schema2[key]) ? propertyDeps : schemaDeps;
        deps[key] = schema2[key];
      }
      return [propertyDeps, schemaDeps];
    }
    function validatePropertyDeps(cxt, propertyDeps = cxt.schema) {
      const { gen, data, it } = cxt;
      if (Object.keys(propertyDeps).length === 0)
        return;
      const missing = gen.let("missing");
      for (const prop in propertyDeps) {
        const deps = propertyDeps[prop];
        if (deps.length === 0)
          continue;
        const hasProperty = (0, code_1.propertyInData)(gen, data, prop, it.opts.ownProperties);
        cxt.setParams({
          property: prop,
          depsCount: deps.length,
          deps: deps.join(", ")
        });
        if (it.allErrors) {
          gen.if(hasProperty, () => {
            for (const depProp of deps) {
              (0, code_1.checkReportMissingProp)(cxt, depProp);
            }
          });
        } else {
          gen.if((0, codegen_1._)`${hasProperty} && (${(0, code_1.checkMissingProp)(cxt, deps, missing)})`);
          (0, code_1.reportMissingProp)(cxt, missing);
          gen.else();
        }
      }
    }
    exports2.validatePropertyDeps = validatePropertyDeps;
    function validateSchemaDeps(cxt, schemaDeps = cxt.schema) {
      const { gen, data, keyword, it } = cxt;
      const valid = gen.name("valid");
      for (const prop in schemaDeps) {
        if ((0, util_1.alwaysValidSchema)(it, schemaDeps[prop]))
          continue;
        gen.if(
          (0, code_1.propertyInData)(gen, data, prop, it.opts.ownProperties),
          () => {
            const schCxt = cxt.subschema({ keyword, schemaProp: prop }, valid);
            cxt.mergeValidEvaluated(schCxt, valid);
          },
          () => gen.var(valid, true)
          // TODO var
        );
        cxt.ok(valid);
      }
    }
    exports2.validateSchemaDeps = validateSchemaDeps;
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/propertyNames.js
var require_propertyNames = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/propertyNames.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var error = {
      message: "property name must be valid",
      params: ({ params }) => (0, codegen_1._)`{propertyName: ${params.propertyName}}`
    };
    var def = {
      keyword: "propertyNames",
      type: "object",
      schemaType: ["object", "boolean"],
      error,
      code(cxt) {
        const { gen, schema: schema2, data, it } = cxt;
        if ((0, util_1.alwaysValidSchema)(it, schema2))
          return;
        const valid = gen.name("valid");
        gen.forIn("key", data, (key) => {
          cxt.setParams({ propertyName: key });
          cxt.subschema({
            keyword: "propertyNames",
            data: key,
            dataTypes: ["string"],
            propertyName: key,
            compositeRule: true
          }, valid);
          gen.if((0, codegen_1.not)(valid), () => {
            cxt.error(true);
            if (!it.allErrors)
              gen.break();
          });
        });
        cxt.ok(valid);
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/additionalProperties.js
var require_additionalProperties = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/additionalProperties.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var code_1 = require_code2();
    var codegen_1 = require_codegen();
    var names_1 = require_names();
    var util_1 = require_util();
    var error = {
      message: "must NOT have additional properties",
      params: ({ params }) => (0, codegen_1._)`{additionalProperty: ${params.additionalProperty}}`
    };
    var def = {
      keyword: "additionalProperties",
      type: ["object"],
      schemaType: ["boolean", "object"],
      allowUndefined: true,
      trackErrors: true,
      error,
      code(cxt) {
        const { gen, parentSchema, data, errsCount, it } = cxt;
        const { schema: schema2 = it.opts.defaultAdditionalProperties } = cxt;
        if (!errsCount)
          throw new Error("ajv implementation error");
        const { allErrors, opts } = it;
        it.props = true;
        if (opts.removeAdditional !== "all" && (0, util_1.alwaysValidSchema)(it, schema2))
          return;
        const props = (0, code_1.allSchemaProperties)(parentSchema.properties);
        const patProps = (0, code_1.allSchemaProperties)(parentSchema.patternProperties);
        checkAdditionalProperties();
        cxt.ok((0, codegen_1._)`${errsCount} === ${names_1.default.errors}`);
        function checkAdditionalProperties() {
          gen.forIn("key", data, (key) => {
            if (!props.length && !patProps.length)
              additionalPropertyCode(key);
            else
              gen.if(isAdditional(key), () => additionalPropertyCode(key));
          });
        }
        function isAdditional(key) {
          let definedProp;
          if (props.length > 8) {
            const propsSchema = (0, util_1.schemaRefOrVal)(it, parentSchema.properties, "properties");
            definedProp = (0, code_1.isOwnProperty)(gen, propsSchema, key);
          } else if (props.length) {
            definedProp = (0, codegen_1.or)(...props.map((p) => (0, codegen_1._)`${key} === ${p}`));
          } else {
            definedProp = codegen_1.nil;
          }
          if (patProps.length) {
            definedProp = (0, codegen_1.or)(definedProp, ...patProps.map((p) => (0, codegen_1._)`${(0, code_1.usePattern)(cxt, p)}.test(${key})`));
          }
          return (0, codegen_1.not)(definedProp);
        }
        function deleteAdditional(key) {
          gen.code((0, codegen_1._)`delete ${data}[${key}]`);
        }
        function additionalPropertyCode(key) {
          if (opts.removeAdditional === "all" || opts.removeAdditional && schema2 === false) {
            deleteAdditional(key);
            return;
          }
          if (schema2 === false) {
            cxt.setParams({ additionalProperty: key });
            cxt.error();
            if (!allErrors)
              gen.break();
            return;
          }
          if (typeof schema2 == "object" && !(0, util_1.alwaysValidSchema)(it, schema2)) {
            const valid = gen.name("valid");
            if (opts.removeAdditional === "failing") {
              applyAdditionalSchema(key, valid, false);
              gen.if((0, codegen_1.not)(valid), () => {
                cxt.reset();
                deleteAdditional(key);
              });
            } else {
              applyAdditionalSchema(key, valid);
              if (!allErrors)
                gen.if((0, codegen_1.not)(valid), () => gen.break());
            }
          }
        }
        function applyAdditionalSchema(key, valid, errors) {
          const subschema = {
            keyword: "additionalProperties",
            dataProp: key,
            dataPropType: util_1.Type.Str
          };
          if (errors === false) {
            Object.assign(subschema, {
              compositeRule: true,
              createErrors: false,
              allErrors: false
            });
          }
          cxt.subschema(subschema, valid);
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/properties.js
var require_properties = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/properties.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var validate_1 = require_validate();
    var code_1 = require_code2();
    var util_1 = require_util();
    var additionalProperties_1 = require_additionalProperties();
    var def = {
      keyword: "properties",
      type: "object",
      schemaType: "object",
      code(cxt) {
        const { gen, schema: schema2, parentSchema, data, it } = cxt;
        if (it.opts.removeAdditional === "all" && parentSchema.additionalProperties === void 0 || it.opts.defaultAdditionalProperties === false) {
          additionalProperties_1.default.code(new validate_1.KeywordCxt(it, additionalProperties_1.default, "additionalProperties"));
        }
        const allProps = (0, code_1.allSchemaProperties)(schema2);
        for (const prop of allProps) {
          it.definedProperties.add(prop);
        }
        if (it.opts.unevaluated && allProps.length && it.props !== true) {
          it.props = util_1.mergeEvaluated.props(gen, (0, util_1.toHash)(allProps), it.props);
        }
        const properties = allProps.filter((p) => !(0, util_1.alwaysValidSchema)(it, schema2[p]));
        if (properties.length === 0)
          return;
        const valid = gen.name("valid");
        for (const prop of properties) {
          if (hasDefault(prop)) {
            applyPropertySchema(prop);
          } else {
            gen.if((0, code_1.propertyInData)(gen, data, prop, it.opts.ownProperties));
            applyPropertySchema(prop);
            if (!it.allErrors)
              gen.else().var(valid, true);
            gen.endIf();
          }
          cxt.it.definedProperties.add(prop);
          cxt.ok(valid);
        }
        function hasDefault(prop) {
          return it.opts.useDefaults && !it.compositeRule && schema2[prop].default !== void 0;
        }
        function applyPropertySchema(prop) {
          cxt.subschema({
            keyword: "properties",
            schemaProp: prop,
            dataProp: prop
          }, valid);
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/patternProperties.js
var require_patternProperties = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/patternProperties.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var code_1 = require_code2();
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var util_2 = require_util();
    var def = {
      keyword: "patternProperties",
      type: "object",
      schemaType: "object",
      code(cxt) {
        const { gen, schema: schema2, data, parentSchema, it } = cxt;
        const { opts } = it;
        const patterns = (0, code_1.allSchemaProperties)(schema2);
        const alwaysValidPatterns = patterns.filter((p) => (0, util_1.alwaysValidSchema)(it, schema2[p]));
        if (patterns.length === 0 || alwaysValidPatterns.length === patterns.length && (!it.opts.unevaluated || it.props === true)) {
          return;
        }
        const checkProperties = opts.strictSchema && !opts.allowMatchingProperties && parentSchema.properties;
        const valid = gen.name("valid");
        if (it.props !== true && !(it.props instanceof codegen_1.Name)) {
          it.props = (0, util_2.evaluatedPropsToName)(gen, it.props);
        }
        const { props } = it;
        validatePatternProperties();
        function validatePatternProperties() {
          for (const pat of patterns) {
            if (checkProperties)
              checkMatchingProperties(pat);
            if (it.allErrors) {
              validateProperties(pat);
            } else {
              gen.var(valid, true);
              validateProperties(pat);
              gen.if(valid);
            }
          }
        }
        function checkMatchingProperties(pat) {
          for (const prop in checkProperties) {
            if (new RegExp(pat).test(prop)) {
              (0, util_1.checkStrictMode)(it, `property ${prop} matches pattern ${pat} (use allowMatchingProperties)`);
            }
          }
        }
        function validateProperties(pat) {
          gen.forIn("key", data, (key) => {
            gen.if((0, codegen_1._)`${(0, code_1.usePattern)(cxt, pat)}.test(${key})`, () => {
              const alwaysValid = alwaysValidPatterns.includes(pat);
              if (!alwaysValid) {
                cxt.subschema({
                  keyword: "patternProperties",
                  schemaProp: pat,
                  dataProp: key,
                  dataPropType: util_2.Type.Str
                }, valid);
              }
              if (it.opts.unevaluated && props !== true) {
                gen.assign((0, codegen_1._)`${props}[${key}]`, true);
              } else if (!alwaysValid && !it.allErrors) {
                gen.if((0, codegen_1.not)(valid), () => gen.break());
              }
            });
          });
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/not.js
var require_not = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/not.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var util_1 = require_util();
    var def = {
      keyword: "not",
      schemaType: ["object", "boolean"],
      trackErrors: true,
      code(cxt) {
        const { gen, schema: schema2, it } = cxt;
        if ((0, util_1.alwaysValidSchema)(it, schema2)) {
          cxt.fail();
          return;
        }
        const valid = gen.name("valid");
        cxt.subschema({
          keyword: "not",
          compositeRule: true,
          createErrors: false,
          allErrors: false
        }, valid);
        cxt.failResult(valid, () => cxt.reset(), () => cxt.error());
      },
      error: { message: "must NOT be valid" }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/anyOf.js
var require_anyOf = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/anyOf.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var code_1 = require_code2();
    var def = {
      keyword: "anyOf",
      schemaType: "array",
      trackErrors: true,
      code: code_1.validateUnion,
      error: { message: "must match a schema in anyOf" }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/oneOf.js
var require_oneOf = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/oneOf.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var error = {
      message: "must match exactly one schema in oneOf",
      params: ({ params }) => (0, codegen_1._)`{passingSchemas: ${params.passing}}`
    };
    var def = {
      keyword: "oneOf",
      schemaType: "array",
      trackErrors: true,
      error,
      code(cxt) {
        const { gen, schema: schema2, parentSchema, it } = cxt;
        if (!Array.isArray(schema2))
          throw new Error("ajv implementation error");
        if (it.opts.discriminator && parentSchema.discriminator)
          return;
        const schArr = schema2;
        const valid = gen.let("valid", false);
        const passing = gen.let("passing", null);
        const schValid = gen.name("_valid");
        cxt.setParams({ passing });
        gen.block(validateOneOf);
        cxt.result(valid, () => cxt.reset(), () => cxt.error(true));
        function validateOneOf() {
          schArr.forEach((sch, i) => {
            let schCxt;
            if ((0, util_1.alwaysValidSchema)(it, sch)) {
              gen.var(schValid, true);
            } else {
              schCxt = cxt.subschema({
                keyword: "oneOf",
                schemaProp: i,
                compositeRule: true
              }, schValid);
            }
            if (i > 0) {
              gen.if((0, codegen_1._)`${schValid} && ${valid}`).assign(valid, false).assign(passing, (0, codegen_1._)`[${passing}, ${i}]`).else();
            }
            gen.if(schValid, () => {
              gen.assign(valid, true);
              gen.assign(passing, i);
              if (schCxt)
                cxt.mergeEvaluated(schCxt, codegen_1.Name);
            });
          });
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/allOf.js
var require_allOf = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/allOf.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var util_1 = require_util();
    var def = {
      keyword: "allOf",
      schemaType: "array",
      code(cxt) {
        const { gen, schema: schema2, it } = cxt;
        if (!Array.isArray(schema2))
          throw new Error("ajv implementation error");
        const valid = gen.name("valid");
        schema2.forEach((sch, i) => {
          if ((0, util_1.alwaysValidSchema)(it, sch))
            return;
          const schCxt = cxt.subschema({ keyword: "allOf", schemaProp: i }, valid, true);
          cxt.ok(valid);
          cxt.mergeEvaluated(schCxt);
        });
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/if.js
var require_if = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/if.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var error = {
      message: ({ params }) => (0, codegen_1.str)`must match "${params.ifClause}" schema`,
      params: ({ params }) => (0, codegen_1._)`{failingKeyword: ${params.ifClause}}`
    };
    var def = {
      keyword: "if",
      schemaType: ["object", "boolean"],
      trackErrors: true,
      error,
      code(cxt) {
        const { gen, parentSchema, it } = cxt;
        if (parentSchema.then === void 0 && parentSchema.else === void 0) {
          (0, util_1.checkStrictMode)(it, '"if" without "then" and "else" is ignored');
        }
        const hasThen = hasSchema(it, "then");
        const hasElse = hasSchema(it, "else");
        if (!hasThen && !hasElse)
          return;
        const valid = gen.let("valid", true);
        const schValid = gen.name("_valid");
        validateIf();
        cxt.reset();
        if (hasThen && hasElse) {
          const ifClause = gen.let("ifClause");
          cxt.setParams({ ifClause });
          gen.if(schValid, validateClause("then", ifClause), validateClause("else", ifClause));
        } else if (hasThen) {
          gen.if(schValid, validateClause("then"));
        } else {
          gen.if((0, codegen_1.not)(schValid), validateClause("else"));
        }
        cxt.pass(valid, () => cxt.error(true));
        function validateIf() {
          const schCxt = cxt.subschema({
            keyword: "if",
            compositeRule: true,
            createErrors: false,
            allErrors: false
          }, schValid);
          cxt.mergeEvaluated(schCxt);
        }
        function validateClause(keyword, ifClause) {
          return () => {
            const schCxt = cxt.subschema({ keyword }, schValid);
            gen.assign(valid, schValid);
            cxt.mergeValidEvaluated(schCxt, valid);
            if (ifClause)
              gen.assign(ifClause, (0, codegen_1._)`${keyword}`);
            else
              cxt.setParams({ ifClause: keyword });
          };
        }
      }
    };
    function hasSchema(it, keyword) {
      const schema2 = it.schema[keyword];
      return schema2 !== void 0 && !(0, util_1.alwaysValidSchema)(it, schema2);
    }
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/thenElse.js
var require_thenElse = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/thenElse.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var util_1 = require_util();
    var def = {
      keyword: ["then", "else"],
      schemaType: ["object", "boolean"],
      code({ keyword, parentSchema, it }) {
        if (parentSchema.if === void 0)
          (0, util_1.checkStrictMode)(it, `"${keyword}" without "if" is ignored`);
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/index.js
var require_applicator = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var additionalItems_1 = require_additionalItems();
    var prefixItems_1 = require_prefixItems();
    var items_1 = require_items();
    var items2020_1 = require_items2020();
    var contains_1 = require_contains();
    var dependencies_1 = require_dependencies();
    var propertyNames_1 = require_propertyNames();
    var additionalProperties_1 = require_additionalProperties();
    var properties_1 = require_properties();
    var patternProperties_1 = require_patternProperties();
    var not_1 = require_not();
    var anyOf_1 = require_anyOf();
    var oneOf_1 = require_oneOf();
    var allOf_1 = require_allOf();
    var if_1 = require_if();
    var thenElse_1 = require_thenElse();
    function getApplicator(draft2020 = false) {
      const applicator = [
        // any
        not_1.default,
        anyOf_1.default,
        oneOf_1.default,
        allOf_1.default,
        if_1.default,
        thenElse_1.default,
        // object
        propertyNames_1.default,
        additionalProperties_1.default,
        dependencies_1.default,
        properties_1.default,
        patternProperties_1.default
      ];
      if (draft2020)
        applicator.push(prefixItems_1.default, items2020_1.default);
      else
        applicator.push(additionalItems_1.default, items_1.default);
      applicator.push(contains_1.default);
      return applicator;
    }
    exports2.default = getApplicator;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/dynamic/dynamicAnchor.js
var require_dynamicAnchor = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/dynamic/dynamicAnchor.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.dynamicAnchor = void 0;
    var codegen_1 = require_codegen();
    var names_1 = require_names();
    var compile_1 = require_compile();
    var ref_1 = require_ref();
    var def = {
      keyword: "$dynamicAnchor",
      schemaType: "string",
      code: (cxt) => dynamicAnchor(cxt, cxt.schema)
    };
    function dynamicAnchor(cxt, anchor) {
      const { gen, it } = cxt;
      it.schemaEnv.root.dynamicAnchors[anchor] = true;
      const v = (0, codegen_1._)`${names_1.default.dynamicAnchors}${(0, codegen_1.getProperty)(anchor)}`;
      const validate = it.errSchemaPath === "#" ? it.validateName : _getValidate(cxt);
      gen.if((0, codegen_1._)`!${v}`, () => gen.assign(v, validate));
    }
    exports2.dynamicAnchor = dynamicAnchor;
    function _getValidate(cxt) {
      const { schemaEnv, schema: schema2, self: self2 } = cxt.it;
      const { root: root2, baseId, localRefs, meta } = schemaEnv.root;
      const { schemaId } = self2.opts;
      const sch = new compile_1.SchemaEnv({ schema: schema2, schemaId, root: root2, baseId, localRefs, meta });
      compile_1.compileSchema.call(self2, sch);
      return (0, ref_1.getValidate)(cxt, sch);
    }
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/dynamic/dynamicRef.js
var require_dynamicRef = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/dynamic/dynamicRef.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.dynamicRef = void 0;
    var codegen_1 = require_codegen();
    var names_1 = require_names();
    var ref_1 = require_ref();
    var def = {
      keyword: "$dynamicRef",
      schemaType: "string",
      code: (cxt) => dynamicRef(cxt, cxt.schema)
    };
    function dynamicRef(cxt, ref) {
      const { gen, keyword, it } = cxt;
      if (ref[0] !== "#")
        throw new Error(`"${keyword}" only supports hash fragment reference`);
      const anchor = ref.slice(1);
      if (it.allErrors) {
        _dynamicRef();
      } else {
        const valid = gen.let("valid", false);
        _dynamicRef(valid);
        cxt.ok(valid);
      }
      function _dynamicRef(valid) {
        if (it.schemaEnv.root.dynamicAnchors[anchor]) {
          const v = gen.let("_v", (0, codegen_1._)`${names_1.default.dynamicAnchors}${(0, codegen_1.getProperty)(anchor)}`);
          gen.if(v, _callRef(v, valid), _callRef(it.validateName, valid));
        } else {
          _callRef(it.validateName, valid)();
        }
      }
      function _callRef(validate, valid) {
        return valid ? () => gen.block(() => {
          (0, ref_1.callRef)(cxt, validate);
          gen.let(valid, true);
        }) : () => (0, ref_1.callRef)(cxt, validate);
      }
    }
    exports2.dynamicRef = dynamicRef;
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/dynamic/recursiveAnchor.js
var require_recursiveAnchor = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/dynamic/recursiveAnchor.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var dynamicAnchor_1 = require_dynamicAnchor();
    var util_1 = require_util();
    var def = {
      keyword: "$recursiveAnchor",
      schemaType: "boolean",
      code(cxt) {
        if (cxt.schema)
          (0, dynamicAnchor_1.dynamicAnchor)(cxt, "");
        else
          (0, util_1.checkStrictMode)(cxt.it, "$recursiveAnchor: false is ignored");
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/dynamic/recursiveRef.js
var require_recursiveRef = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/dynamic/recursiveRef.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var dynamicRef_1 = require_dynamicRef();
    var def = {
      keyword: "$recursiveRef",
      schemaType: "string",
      code: (cxt) => (0, dynamicRef_1.dynamicRef)(cxt, cxt.schema)
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/dynamic/index.js
var require_dynamic = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/dynamic/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var dynamicAnchor_1 = require_dynamicAnchor();
    var dynamicRef_1 = require_dynamicRef();
    var recursiveAnchor_1 = require_recursiveAnchor();
    var recursiveRef_1 = require_recursiveRef();
    var dynamic = [dynamicAnchor_1.default, dynamicRef_1.default, recursiveAnchor_1.default, recursiveRef_1.default];
    exports2.default = dynamic;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/dependentRequired.js
var require_dependentRequired = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/dependentRequired.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var dependencies_1 = require_dependencies();
    var def = {
      keyword: "dependentRequired",
      type: "object",
      schemaType: "object",
      error: dependencies_1.error,
      code: (cxt) => (0, dependencies_1.validatePropertyDeps)(cxt)
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/dependentSchemas.js
var require_dependentSchemas = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/applicator/dependentSchemas.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var dependencies_1 = require_dependencies();
    var def = {
      keyword: "dependentSchemas",
      type: "object",
      schemaType: "object",
      code: (cxt) => (0, dependencies_1.validateSchemaDeps)(cxt)
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/limitContains.js
var require_limitContains = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/validation/limitContains.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var util_1 = require_util();
    var def = {
      keyword: ["maxContains", "minContains"],
      type: "array",
      schemaType: "number",
      code({ keyword, parentSchema, it }) {
        if (parentSchema.contains === void 0) {
          (0, util_1.checkStrictMode)(it, `"${keyword}" without "contains" is ignored`);
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/next.js
var require_next = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/next.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var dependentRequired_1 = require_dependentRequired();
    var dependentSchemas_1 = require_dependentSchemas();
    var limitContains_1 = require_limitContains();
    var next = [dependentRequired_1.default, dependentSchemas_1.default, limitContains_1.default];
    exports2.default = next;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/unevaluated/unevaluatedProperties.js
var require_unevaluatedProperties = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/unevaluated/unevaluatedProperties.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var names_1 = require_names();
    var error = {
      message: "must NOT have unevaluated properties",
      params: ({ params }) => (0, codegen_1._)`{unevaluatedProperty: ${params.unevaluatedProperty}}`
    };
    var def = {
      keyword: "unevaluatedProperties",
      type: "object",
      schemaType: ["boolean", "object"],
      allowUndefined: true,
      trackErrors: true,
      error,
      code(cxt) {
        const { gen, schema: schema2 = cxt.it.opts.defaultUnevaluatedProperties, data, errsCount, it } = cxt;
        const isForced = cxt.schema === void 0 && cxt.it.opts.defaultUnevaluatedProperties === false;
        if (!errsCount)
          throw new Error("ajv implementation error");
        const { allErrors, props } = it;
        if (props instanceof codegen_1.Name) {
          gen.if((0, codegen_1._)`${props} !== true`, () => gen.forIn("key", data, (key) => gen.if(unevaluatedDynamic(props, key), () => unevaluatedPropCode(key))));
        } else if (props !== true) {
          const staticCheck = () => gen.forIn("key", data, (key) => props === void 0 ? unevaluatedPropCode(key) : gen.if(unevaluatedStatic(props, key), () => unevaluatedPropCode(key)));
          if (isForced && it.errorPath.emptyStr()) {
            gen.if((0, codegen_1._)`${names_1.default.isAllOfVariant} === 0`, staticCheck);
          } else {
            staticCheck();
          }
        }
        if (!isForced) {
          it.props = true;
        }
        cxt.ok((0, codegen_1._)`${errsCount} === ${names_1.default.errors}`);
        function unevaluatedPropCode(key) {
          if (schema2 === false) {
            cxt.setParams({ unevaluatedProperty: key });
            cxt.error();
            if (!allErrors)
              gen.break();
            return;
          }
          if (!(0, util_1.alwaysValidSchema)(it, schema2)) {
            const valid = gen.name("valid");
            cxt.subschema({
              keyword: "unevaluatedProperties",
              dataProp: key,
              dataPropType: util_1.Type.Str
            }, valid);
            if (!allErrors)
              gen.if((0, codegen_1.not)(valid), () => gen.break());
          }
        }
        function unevaluatedDynamic(evaluatedProps, key) {
          return (0, codegen_1._)`!${evaluatedProps} || !${evaluatedProps}[${key}]`;
        }
        function unevaluatedStatic(evaluatedProps, key) {
          const ps = [];
          for (const p in evaluatedProps) {
            if (evaluatedProps[p] === true)
              ps.push((0, codegen_1._)`${key} !== ${p}`);
          }
          return (0, codegen_1.and)(...ps);
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/unevaluated/unevaluatedItems.js
var require_unevaluatedItems = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/unevaluated/unevaluatedItems.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var util_1 = require_util();
    var error = {
      message: ({ params: { len } }) => (0, codegen_1.str)`must NOT have more than ${len} items`,
      params: ({ params: { len } }) => (0, codegen_1._)`{limit: ${len}}`
    };
    var def = {
      keyword: "unevaluatedItems",
      type: "array",
      schemaType: ["boolean", "object"],
      error,
      code(cxt) {
        const { gen, schema: schema2, data, it } = cxt;
        const items = it.items || 0;
        if (items === true)
          return;
        const len = gen.const("len", (0, codegen_1._)`${data}.length`);
        if (schema2 === false) {
          cxt.setParams({ len: items });
          cxt.fail((0, codegen_1._)`${len} > ${items}`);
        } else if (typeof schema2 == "object" && !(0, util_1.alwaysValidSchema)(it, schema2)) {
          const valid = gen.var("valid", (0, codegen_1._)`${len} <= ${items}`);
          gen.if((0, codegen_1.not)(valid), () => validateItems(valid, items));
          cxt.ok(valid);
        }
        it.items = true;
        function validateItems(valid, from) {
          gen.forRange("i", from, len, (i) => {
            cxt.subschema({ keyword: "unevaluatedItems", dataProp: i, dataPropType: util_1.Type.Num }, valid);
            if (!it.allErrors)
              gen.if((0, codegen_1.not)(valid), () => gen.break());
          });
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/unevaluated/index.js
var require_unevaluated = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/unevaluated/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var unevaluatedProperties_1 = require_unevaluatedProperties();
    var unevaluatedItems_1 = require_unevaluatedItems();
    var unevaluated = [unevaluatedProperties_1.default, unevaluatedItems_1.default];
    exports2.default = unevaluated;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/format/format.js
var require_format = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/format/format.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var error = {
      message: ({ schemaCode }) => (0, codegen_1.str)`must match format "${schemaCode}"`,
      params: ({ schemaCode }) => (0, codegen_1._)`{format: ${schemaCode}}`
    };
    var def = {
      keyword: "format",
      type: ["number", "string"],
      schemaType: "string",
      $data: true,
      error,
      code(cxt, ruleType) {
        const { gen, data, $data, schema: schema2, schemaCode, it } = cxt;
        const { opts, errSchemaPath, schemaEnv, self: self2 } = it;
        if (!opts.validateFormats)
          return;
        if ($data)
          validate$DataFormat();
        else
          validateFormat();
        function validate$DataFormat() {
          const fmts = gen.scopeValue("formats", {
            ref: self2.formats,
            code: opts.code.formats
          });
          const fDef = gen.const("fDef", (0, codegen_1._)`${fmts}[${schemaCode}]`);
          const fType = gen.let("fType");
          const format = gen.let("format");
          gen.if((0, codegen_1._)`typeof ${fDef} == "object" && !(${fDef} instanceof RegExp)`, () => gen.assign(fType, (0, codegen_1._)`${fDef}.type || "string"`).assign(format, (0, codegen_1._)`${fDef}.validate`), () => gen.assign(fType, (0, codegen_1._)`"string"`).assign(format, fDef));
          cxt.fail$data((0, codegen_1.or)(unknownFmt(), invalidFmt()));
          function unknownFmt() {
            if (opts.strictSchema === false)
              return codegen_1.nil;
            return (0, codegen_1._)`${schemaCode} && !${format}`;
          }
          function invalidFmt() {
            const callFormat = schemaEnv.$async ? (0, codegen_1._)`(${fDef}.async ? await ${format}(${data}) : ${format}(${data}))` : (0, codegen_1._)`${format}(${data})`;
            const validData = (0, codegen_1._)`(typeof ${format} == "function" ? ${callFormat} : ${format}.test(${data}))`;
            return (0, codegen_1._)`${format} && ${format} !== true && ${fType} === ${ruleType} && !${validData}`;
          }
        }
        function validateFormat() {
          const formatDef = self2.formats[schema2];
          if (!formatDef) {
            unknownFormat();
            return;
          }
          if (formatDef === true)
            return;
          const [fmtType, format, fmtRef] = getFormat(formatDef);
          if (fmtType === ruleType)
            cxt.pass(validCondition());
          function unknownFormat() {
            if (opts.strictSchema === false) {
              self2.logger.warn(unknownMsg());
              return;
            }
            throw new Error(unknownMsg());
            function unknownMsg() {
              return `unknown format "${schema2}" ignored in schema at path "${errSchemaPath}"`;
            }
          }
          function getFormat(fmtDef) {
            const code = fmtDef instanceof RegExp ? (0, codegen_1.regexpCode)(fmtDef) : opts.code.formats ? (0, codegen_1._)`${opts.code.formats}${(0, codegen_1.getProperty)(schema2)}` : void 0;
            const fmt = gen.scopeValue("formats", { key: schema2, ref: fmtDef, code });
            if (typeof fmtDef == "object" && !(fmtDef instanceof RegExp)) {
              return [fmtDef.type || "string", fmtDef.validate, (0, codegen_1._)`${fmt}.validate`];
            }
            return ["string", fmtDef, fmt];
          }
          function validCondition() {
            if (typeof formatDef == "object" && !(formatDef instanceof RegExp) && formatDef.async) {
              if (!schemaEnv.$async)
                throw new Error("async format in sync schema");
              return (0, codegen_1._)`await ${fmtRef}(${data})`;
            }
            return typeof format == "function" ? (0, codegen_1._)`${fmtRef}(${data})` : (0, codegen_1._)`${fmtRef}.test(${data})`;
          }
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/format/index.js
var require_format2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/format/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var format_1 = require_format();
    var format = [format_1.default];
    exports2.default = format;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/metadata.js
var require_metadata = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/metadata.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.contentVocabulary = exports2.metadataVocabulary = void 0;
    exports2.metadataVocabulary = [
      "title",
      "description",
      "default",
      "deprecated",
      "readOnly",
      "writeOnly",
      "examples"
    ];
    exports2.contentVocabulary = [
      "contentMediaType",
      "contentEncoding",
      "contentSchema"
    ];
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/draft2020.js
var require_draft2020 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/draft2020.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var core_1 = require_core3();
    var validation_1 = require_validation();
    var applicator_1 = require_applicator();
    var dynamic_1 = require_dynamic();
    var next_1 = require_next();
    var unevaluated_1 = require_unevaluated();
    var format_1 = require_format2();
    var metadata_1 = require_metadata();
    var draft2020Vocabularies = [
      dynamic_1.default,
      core_1.default,
      validation_1.default,
      (0, applicator_1.default)(true),
      format_1.default,
      metadata_1.metadataVocabulary,
      metadata_1.contentVocabulary,
      next_1.default,
      unevaluated_1.default
    ];
    exports2.default = draft2020Vocabularies;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/discriminator/types.js
var require_types3 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/discriminator/types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.DiscrError = void 0;
    var DiscrError;
    (function (DiscrError2) {
      DiscrError2["Tag"] = "tag";
      DiscrError2["Mapping"] = "mapping";
    })(DiscrError = exports2.DiscrError || (exports2.DiscrError = {}));
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/discriminator/index.js
var require_discriminator = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/vocabularies/discriminator/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var codegen_1 = require_codegen();
    var types_1 = require_types3();
    var compile_1 = require_compile();
    var util_1 = require_util();
    var error = {
      message: ({ params: { discrError, tagName } }) => discrError === types_1.DiscrError.Tag ? `tag "${tagName}" must be string` : `value of tag "${tagName}" must be in oneOf or anyOf`,
      params: ({ params: { discrError, tag, tagName } }) => (0, codegen_1._)`{error: ${discrError}, tag: ${tagName}, tagValue: ${tag}}`
    };
    var def = {
      keyword: "discriminator",
      type: "object",
      schemaType: "object",
      error,
      code(cxt) {
        const { gen, data, schema: schema2, parentSchema, it } = cxt;
        const keyword = parentSchema.oneOf ? "oneOf" : parentSchema.anyOf ? "anyOf" : void 0;
        if (!it.opts.discriminator) {
          throw new Error("discriminator: requires discriminator option");
        }
        const tagName = schema2.propertyName;
        if (typeof tagName != "string")
          throw new Error("discriminator: requires propertyName");
        if (!keyword)
          throw new Error("discriminator: requires oneOf or anyOf composite keyword");
        const parentSchemaVariants = parentSchema[keyword];
        const valid = gen.let("valid", false);
        const tag = gen.const("tag", (0, codegen_1._)`${data}${(0, codegen_1.getProperty)(tagName)}`);
        gen.if((0, codegen_1._)`typeof ${tag} == "string"`, () => validateMapping(), () => cxt.error(false, { discrError: types_1.DiscrError.Tag, tag, tagName }));
        cxt.ok(valid);
        function validateMapping() {
          const mapping = getMapping();
          gen.if(false);
          for (const tagValue in mapping) {
            gen.elseIf((0, codegen_1._)`${tag} === ${tagValue}`);
            gen.assign(valid, applyTagSchema(mapping[tagValue]));
          }
          gen.else();
          cxt.error(false, { discrError: types_1.DiscrError.Mapping, tag, tagName });
          gen.endIf();
        }
        function applyTagSchema(schemaProp) {
          const _valid = gen.name("valid");
          const schCxt = cxt.subschema({ keyword, schemaProp }, _valid);
          cxt.mergeEvaluated(schCxt, codegen_1.Name);
          return _valid;
        }
        function getMapping() {
          var _a;
          const discriminatorMapping = {};
          const topRequired = hasRequired(parentSchema);
          let tagRequired = true;
          for (let i = 0; i < parentSchemaVariants.length; i++) {
            let sch = parentSchemaVariants[i];
            const schRef = sch === null || sch === void 0 ? void 0 : sch.$ref;
            if (schRef && schema2.mapping) {
              const { mapping } = schema2;
              const matchedKeys = Object.keys(mapping).filter((key) => mapping[key] === sch.$ref);
              if (matchedKeys.length) {
                for (const key of matchedKeys) {
                  addMapping(key, i);
                }
                continue;
              }
            }
            if (schRef && !(0, util_1.schemaHasRulesButRef)(sch, it.self.RULES)) {
              sch = compile_1.resolveRef.call(it.self, it.schemaEnv.root, it.baseId, schRef);
              if (sch instanceof compile_1.SchemaEnv)
                sch = sch.schema;
            }
            const propSch = (_a = sch === null || sch === void 0 ? void 0 : sch.properties) === null || _a === void 0 ? void 0 : _a[tagName];
            if (typeof propSch != "object") {
              throw new Error(`discriminator: ${keyword} subschemas (or referenced schemas) must have "properties/${tagName}" or match mapping`);
            }
            tagRequired = tagRequired && (topRequired || hasRequired(sch));
            addMappings(propSch, i);
          }
          if (!tagRequired)
            throw new Error(`discriminator: "${tagName}" must be required`);
          return discriminatorMapping;
          function hasRequired({ required }) {
            return Array.isArray(required) && required.includes(tagName);
          }
          function addMappings(sch, i) {
            if (sch.const) {
              addMapping(sch.const, i);
            } else if (sch.enum) {
              for (const tagValue of sch.enum) {
                addMapping(tagValue, i);
              }
            } else {
              throw new Error(`discriminator: "properties/${tagName}" must have "const" or "enum"`);
            }
          }
          function addMapping(tagValue, i) {
            if (typeof tagValue != "string" || tagValue in discriminatorMapping) {
              throw new Error(`discriminator: "${tagName}" values must be unique strings`);
            }
            discriminatorMapping[tagValue] = i;
          }
        }
      }
    };
    exports2.default = def;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/schema.json
var require_schema2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/schema.json"(exports2, module2) {
    module2.exports = {
      $schema: "https://json-schema.org/draft/2020-12/schema",
      $id: "https://json-schema.org/draft/2020-12/schema",
      $vocabulary: {
        "https://json-schema.org/draft/2020-12/vocab/core": true,
        "https://json-schema.org/draft/2020-12/vocab/applicator": true,
        "https://json-schema.org/draft/2020-12/vocab/unevaluated": true,
        "https://json-schema.org/draft/2020-12/vocab/validation": true,
        "https://json-schema.org/draft/2020-12/vocab/meta-data": true,
        "https://json-schema.org/draft/2020-12/vocab/format-annotation": true,
        "https://json-schema.org/draft/2020-12/vocab/content": true
      },
      $dynamicAnchor: "meta",
      title: "Core and Validation specifications meta-schema",
      allOf: [
        { $ref: "meta/core" },
        { $ref: "meta/applicator" },
        { $ref: "meta/unevaluated" },
        { $ref: "meta/validation" },
        { $ref: "meta/meta-data" },
        { $ref: "meta/format-annotation" },
        { $ref: "meta/content" }
      ],
      type: ["object", "boolean"],
      $comment: "This meta-schema also defines keywords that have appeared in previous drafts in order to prevent incompatible extensions as they remain in common use.",
      properties: {
        definitions: {
          $comment: '"definitions" has been replaced by "$defs".',
          type: "object",
          additionalProperties: { $dynamicRef: "#meta" },
          deprecated: true,
          default: {}
        },
        dependencies: {
          $comment: '"dependencies" has been split and replaced by "dependentSchemas" and "dependentRequired" in order to serve their differing semantics.',
          type: "object",
          additionalProperties: {
            anyOf: [{ $dynamicRef: "#meta" }, { $ref: "meta/validation#/$defs/stringArray" }]
          },
          deprecated: true,
          default: {}
        },
        $recursiveAnchor: {
          $comment: '"$recursiveAnchor" has been replaced by "$dynamicAnchor".',
          $ref: "meta/core#/$defs/anchorString",
          deprecated: true
        },
        $recursiveRef: {
          $comment: '"$recursiveRef" has been replaced by "$dynamicRef".',
          $ref: "meta/core#/$defs/uriReferenceString",
          deprecated: true
        }
      }
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/applicator.json
var require_applicator2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/applicator.json"(exports2, module2) {
    module2.exports = {
      $schema: "https://json-schema.org/draft/2020-12/schema",
      $id: "https://json-schema.org/draft/2020-12/meta/applicator",
      $vocabulary: {
        "https://json-schema.org/draft/2020-12/vocab/applicator": true
      },
      $dynamicAnchor: "meta",
      title: "Applicator vocabulary meta-schema",
      type: ["object", "boolean"],
      properties: {
        prefixItems: { $ref: "#/$defs/schemaArray" },
        items: { $dynamicRef: "#meta" },
        contains: { $dynamicRef: "#meta" },
        additionalProperties: { $dynamicRef: "#meta" },
        properties: {
          type: "object",
          additionalProperties: { $dynamicRef: "#meta" },
          default: {}
        },
        patternProperties: {
          type: "object",
          additionalProperties: { $dynamicRef: "#meta" },
          propertyNames: { format: "regex" },
          default: {}
        },
        dependentSchemas: {
          type: "object",
          additionalProperties: { $dynamicRef: "#meta" },
          default: {}
        },
        propertyNames: { $dynamicRef: "#meta" },
        if: { $dynamicRef: "#meta" },
        then: { $dynamicRef: "#meta" },
        else: { $dynamicRef: "#meta" },
        allOf: { $ref: "#/$defs/schemaArray" },
        anyOf: { $ref: "#/$defs/schemaArray" },
        oneOf: { $ref: "#/$defs/schemaArray" },
        not: { $dynamicRef: "#meta" }
      },
      $defs: {
        schemaArray: {
          type: "array",
          minItems: 1,
          items: { $dynamicRef: "#meta" }
        }
      }
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/unevaluated.json
var require_unevaluated2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/unevaluated.json"(exports2, module2) {
    module2.exports = {
      $schema: "https://json-schema.org/draft/2020-12/schema",
      $id: "https://json-schema.org/draft/2020-12/meta/unevaluated",
      $vocabulary: {
        "https://json-schema.org/draft/2020-12/vocab/unevaluated": true
      },
      $dynamicAnchor: "meta",
      title: "Unevaluated applicator vocabulary meta-schema",
      type: ["object", "boolean"],
      properties: {
        unevaluatedItems: { $dynamicRef: "#meta" },
        unevaluatedProperties: { $dynamicRef: "#meta" }
      }
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/content.json
var require_content = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/content.json"(exports2, module2) {
    module2.exports = {
      $schema: "https://json-schema.org/draft/2020-12/schema",
      $id: "https://json-schema.org/draft/2020-12/meta/content",
      $vocabulary: {
        "https://json-schema.org/draft/2020-12/vocab/content": true
      },
      $dynamicAnchor: "meta",
      title: "Content vocabulary meta-schema",
      type: ["object", "boolean"],
      properties: {
        contentEncoding: { type: "string" },
        contentMediaType: { type: "string" },
        contentSchema: { $dynamicRef: "#meta" }
      }
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/core.json
var require_core4 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/core.json"(exports2, module2) {
    module2.exports = {
      $schema: "https://json-schema.org/draft/2020-12/schema",
      $id: "https://json-schema.org/draft/2020-12/meta/core",
      $vocabulary: {
        "https://json-schema.org/draft/2020-12/vocab/core": true
      },
      $dynamicAnchor: "meta",
      title: "Core vocabulary meta-schema",
      type: ["object", "boolean"],
      properties: {
        $id: {
          $ref: "#/$defs/uriReferenceString",
          $comment: "Non-empty fragments not allowed.",
          pattern: "^[^#]*#?$"
        },
        $schema: { $ref: "#/$defs/uriString" },
        $ref: { $ref: "#/$defs/uriReferenceString" },
        $anchor: { $ref: "#/$defs/anchorString" },
        $dynamicRef: { $ref: "#/$defs/uriReferenceString" },
        $dynamicAnchor: { $ref: "#/$defs/anchorString" },
        $vocabulary: {
          type: "object",
          propertyNames: { $ref: "#/$defs/uriString" },
          additionalProperties: {
            type: "boolean"
          }
        },
        $comment: {
          type: "string"
        },
        $defs: {
          type: "object",
          additionalProperties: { $dynamicRef: "#meta" }
        }
      },
      $defs: {
        anchorString: {
          type: "string",
          pattern: "^[A-Za-z_][-A-Za-z0-9._]*$"
        },
        uriString: {
          type: "string",
          format: "uri"
        },
        uriReferenceString: {
          type: "string",
          format: "uri-reference"
        }
      }
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/format-annotation.json
var require_format_annotation = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/format-annotation.json"(exports2, module2) {
    module2.exports = {
      $schema: "https://json-schema.org/draft/2020-12/schema",
      $id: "https://json-schema.org/draft/2020-12/meta/format-annotation",
      $vocabulary: {
        "https://json-schema.org/draft/2020-12/vocab/format-annotation": true
      },
      $dynamicAnchor: "meta",
      title: "Format vocabulary meta-schema for annotation results",
      type: ["object", "boolean"],
      properties: {
        format: { type: "string" }
      }
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/meta-data.json
var require_meta_data = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/meta-data.json"(exports2, module2) {
    module2.exports = {
      $schema: "https://json-schema.org/draft/2020-12/schema",
      $id: "https://json-schema.org/draft/2020-12/meta/meta-data",
      $vocabulary: {
        "https://json-schema.org/draft/2020-12/vocab/meta-data": true
      },
      $dynamicAnchor: "meta",
      title: "Meta-data vocabulary meta-schema",
      type: ["object", "boolean"],
      properties: {
        title: {
          type: "string"
        },
        description: {
          type: "string"
        },
        default: true,
        deprecated: {
          type: "boolean",
          default: false
        },
        readOnly: {
          type: "boolean",
          default: false
        },
        writeOnly: {
          type: "boolean",
          default: false
        },
        examples: {
          type: "array",
          items: true
        }
      }
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/validation.json
var require_validation2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/meta/validation.json"(exports2, module2) {
    module2.exports = {
      $schema: "https://json-schema.org/draft/2020-12/schema",
      $id: "https://json-schema.org/draft/2020-12/meta/validation",
      $vocabulary: {
        "https://json-schema.org/draft/2020-12/vocab/validation": true
      },
      $dynamicAnchor: "meta",
      title: "Validation vocabulary meta-schema",
      type: ["object", "boolean"],
      properties: {
        type: {
          anyOf: [
            { $ref: "#/$defs/simpleTypes" },
            {
              type: "array",
              items: { $ref: "#/$defs/simpleTypes" },
              minItems: 1,
              uniqueItems: true
            }
          ]
        },
        const: true,
        enum: {
          type: "array",
          items: true
        },
        multipleOf: {
          type: "number",
          exclusiveMinimum: 0
        },
        maximum: {
          type: "number"
        },
        exclusiveMaximum: {
          type: "number"
        },
        minimum: {
          type: "number"
        },
        exclusiveMinimum: {
          type: "number"
        },
        maxLength: { $ref: "#/$defs/nonNegativeInteger" },
        minLength: { $ref: "#/$defs/nonNegativeIntegerDefault0" },
        pattern: {
          type: "string",
          format: "regex"
        },
        maxItems: { $ref: "#/$defs/nonNegativeInteger" },
        minItems: { $ref: "#/$defs/nonNegativeIntegerDefault0" },
        uniqueItems: {
          type: "boolean",
          default: false
        },
        maxContains: { $ref: "#/$defs/nonNegativeInteger" },
        minContains: {
          $ref: "#/$defs/nonNegativeInteger",
          default: 1
        },
        maxProperties: { $ref: "#/$defs/nonNegativeInteger" },
        minProperties: { $ref: "#/$defs/nonNegativeIntegerDefault0" },
        required: { $ref: "#/$defs/stringArray" },
        dependentRequired: {
          type: "object",
          additionalProperties: {
            $ref: "#/$defs/stringArray"
          }
        }
      },
      $defs: {
        nonNegativeInteger: {
          type: "integer",
          minimum: 0
        },
        nonNegativeIntegerDefault0: {
          $ref: "#/$defs/nonNegativeInteger",
          default: 0
        },
        simpleTypes: {
          enum: ["array", "boolean", "integer", "null", "number", "object", "string"]
        },
        stringArray: {
          type: "array",
          items: { type: "string" },
          uniqueItems: true,
          default: []
        }
      }
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/index.js
var require_json_schema_2020_12 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/refs/json-schema-2020-12/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var metaSchema = require_schema2();
    var applicator = require_applicator2();
    var unevaluated = require_unevaluated2();
    var content = require_content();
    var core2 = require_core4();
    var format = require_format_annotation();
    var metadata = require_meta_data();
    var validation = require_validation2();
    var META_SUPPORT_DATA = ["/properties"];
    function addMetaSchema2020($data) {
      ;
      [
        metaSchema,
        applicator,
        unevaluated,
        content,
        core2,
        with$data(this, format),
        metadata,
        with$data(this, validation)
      ].forEach((sch) => this.addMetaSchema(sch, void 0, false));
      return this;
      function with$data(ajv, sch) {
        return $data ? ajv.$dataMetaSchema(sch, META_SUPPORT_DATA) : sch;
      }
    }
    exports2.default = addMetaSchema2020;
  }
});

// ../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/2020.js
var require__ = __commonJS({
  "../../../node_modules/.pnpm/@redocly+ajv@8.11.0/node_modules/@redocly/ajv/dist/2020.js"(exports2, module2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CodeGen = exports2.Name = exports2.nil = exports2.stringify = exports2.str = exports2._ = exports2.KeywordCxt = void 0;
    var core_1 = require_core2();
    var draft2020_1 = require_draft2020();
    var discriminator_1 = require_discriminator();
    var json_schema_2020_12_1 = require_json_schema_2020_12();
    var META_SCHEMA_ID = "https://json-schema.org/draft/2020-12/schema";
    var Ajv2020 = class extends core_1.default {
      constructor(opts = {}) {
        super({
          ...opts,
          dynamicRef: true,
          next: true,
          unevaluated: true
        });
      }
      _addVocabularies() {
        super._addVocabularies();
        draft2020_1.default.forEach((v) => this.addVocabulary(v));
        if (this.opts.discriminator)
          this.addKeyword(discriminator_1.default);
      }
      _addDefaultMetaSchema() {
        super._addDefaultMetaSchema();
        const { $data, meta } = this.opts;
        if (!meta)
          return;
        json_schema_2020_12_1.default.call(this, $data);
        this.refs["http://json-schema.org/schema"] = META_SCHEMA_ID;
      }
      defaultMeta() {
        return this.opts.defaultMeta = super.defaultMeta() || (this.getSchema(META_SCHEMA_ID) ? META_SCHEMA_ID : void 0);
      }
    };
    module2.exports = exports2 = Ajv2020;
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.default = Ajv2020;
    var validate_1 = require_validate();
    Object.defineProperty(exports2, "KeywordCxt", {
      enumerable: true, get: function () {
        return validate_1.KeywordCxt;
      }
    });
    var codegen_1 = require_codegen();
    Object.defineProperty(exports2, "_", {
      enumerable: true, get: function () {
        return codegen_1._;
      }
    });
    Object.defineProperty(exports2, "str", {
      enumerable: true, get: function () {
        return codegen_1.str;
      }
    });
    Object.defineProperty(exports2, "stringify", {
      enumerable: true, get: function () {
        return codegen_1.stringify;
      }
    });
    Object.defineProperty(exports2, "nil", {
      enumerable: true, get: function () {
        return codegen_1.nil;
      }
    });
    Object.defineProperty(exports2, "Name", {
      enumerable: true, get: function () {
        return codegen_1.Name;
      }
    });
    Object.defineProperty(exports2, "CodeGen", {
      enumerable: true, get: function () {
        return codegen_1.CodeGen;
      }
    });
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/ajv.js
var require_ajv = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/ajv.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.validateJsonSchema = exports2.releaseAjvInstance = void 0;
    var _2020_1 = require__();
    var ref_utils_1 = require_ref_utils();
    var ajvInstance = null;
    function releaseAjvInstance() {
      ajvInstance = null;
    }
    exports2.releaseAjvInstance = releaseAjvInstance;
    function getAjv(resolve, allowAdditionalProperties) {
      if (!ajvInstance) {
        ajvInstance = new _2020_1.default({
          schemaId: "$id",
          meta: true,
          allErrors: true,
          strictSchema: false,
          inlineRefs: false,
          validateSchema: false,
          discriminator: true,
          allowUnionTypes: true,
          validateFormats: false,
          defaultUnevaluatedProperties: allowAdditionalProperties,
          loadSchemaSync(base, $ref) {
            const resolvedRef = resolve({ $ref }, base.split("#")[0]);
            if (!resolvedRef || !resolvedRef.location)
              return false;
            return Object.assign({ $id: resolvedRef.location.absolutePointer }, resolvedRef.node);
          },
          logger: false
        });
      }
      return ajvInstance;
    }
    function getAjvValidator(schema2, loc, resolve, allowAdditionalProperties) {
      const ajv = getAjv(resolve, allowAdditionalProperties);
      if (!ajv.getSchema(loc.absolutePointer)) {
        ajv.addSchema(Object.assign({ $id: loc.absolutePointer }, schema2), loc.absolutePointer);
      }
      return ajv.getSchema(loc.absolutePointer);
    }
    function validateJsonSchema(data, schema2, schemaLoc, instancePath, resolve, allowAdditionalProperties) {
      const validate = getAjvValidator(schema2, schemaLoc, resolve, allowAdditionalProperties);
      if (!validate)
        return { valid: true, errors: [] };
      const valid = validate(data, {
        instancePath,
        parentData: { fake: {} },
        parentDataProperty: "fake",
        rootData: {},
        dynamicAnchors: {}
      });
      return {
        valid: !!valid,
        errors: (validate.errors || []).map(beatifyErrorMessage)
      };
      function beatifyErrorMessage(error) {
        let message = error.message;
        const suggest = error.keyword === "enum" ? error.params.allowedValues : void 0;
        if (suggest) {
          message += ` ${suggest.map((e) => `"${e}"`).join(", ")}`;
        }
        if (error.keyword === "type") {
          message = `type ${message}`;
        }
        const relativePath = error.instancePath.substring(instancePath.length + 1);
        const propName = relativePath.substring(relativePath.lastIndexOf("/") + 1);
        if (propName) {
          message = `\`${propName}\` property ${message}`;
        }
        if (error.keyword === "additionalProperties" || error.keyword === "unevaluatedProperties") {
          const property4 = error.params.additionalProperty || error.params.unevaluatedProperty;
          message = `${message} \`${property4}\``;
          error.instancePath += "/" + (0, ref_utils_1.escapePointer)(property4);
        }
        return Object.assign(Object.assign({}, error), {
          message,
          suggest
        });
      }
    }
    exports2.validateJsonSchema = validateJsonSchema;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/utils.js
var require_utils5 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.validateResponseCodes = exports2.validateSchemaEnumType = exports2.getAdditionalPropertiesOption = exports2.validateExample = exports2.getSuggest = exports2.validateDefinedAndNonEmpty = exports2.fieldNonEmpty = exports2.missingRequiredField = exports2.matchesJsonSchemaType = exports2.oasTypeOf = void 0;
    var levenshtein = require_js_levenshtein();
    var ref_utils_1 = require_ref_utils();
    var ajv_1 = require_ajv();
    var utils_1 = require_utils3();
    function oasTypeOf(value) {
      if (Array.isArray(value)) {
        return "array";
      } else if (value === null) {
        return "null";
      } else if (Number.isInteger(value)) {
        return "integer";
      } else {
        return typeof value;
      }
    }
    exports2.oasTypeOf = oasTypeOf;
    function matchesJsonSchemaType(value, type2, nullable) {
      if (nullable && value === null) {
        return true;
      }
      switch (type2) {
        case "array":
          return Array.isArray(value);
        case "object":
          return typeof value === "object" && value !== null && !Array.isArray(value);
        case "null":
          return value === null;
        case "integer":
          return Number.isInteger(value);
        default:
          return typeof value === type2;
      }
    }
    exports2.matchesJsonSchemaType = matchesJsonSchemaType;
    function missingRequiredField(type2, field) {
      return `${type2} object should contain \`${field}\` field.`;
    }
    exports2.missingRequiredField = missingRequiredField;
    function fieldNonEmpty(type2, field) {
      return `${type2} object \`${field}\` must be non-empty string.`;
    }
    exports2.fieldNonEmpty = fieldNonEmpty;
    function validateDefinedAndNonEmpty(fieldName, value, ctx) {
      if (typeof value !== "object") {
        return;
      }
      if (value[fieldName] === void 0) {
        ctx.report({
          message: missingRequiredField(ctx.type.name, fieldName),
          location: ctx.location.child([fieldName]).key()
        });
      } else if (!value[fieldName]) {
        ctx.report({
          message: fieldNonEmpty(ctx.type.name, fieldName),
          location: ctx.location.child([fieldName]).key()
        });
      }
    }
    exports2.validateDefinedAndNonEmpty = validateDefinedAndNonEmpty;
    function getSuggest(given, variants) {
      if (given === null)
        return variants;
      if (typeof given !== "string" || !variants.length)
        return [];
      const distances = [];
      for (let i = 0; i < variants.length; i++) {
        const distance = levenshtein(given, variants[i]);
        if (distance < 4) {
          distances.push({ distance, variant: variants[i] });
        }
      }
      distances.sort((a, b) => a.distance - b.distance);
      return distances.map((d) => d.variant);
    }
    exports2.getSuggest = getSuggest;
    function validateExample(example, schema2, dataLoc, { resolve, location, report }, allowAdditionalProperties) {
      try {
        const { valid, errors } = (0, ajv_1.validateJsonSchema)(example, schema2, location.child("schema"), dataLoc.pointer, resolve, allowAdditionalProperties);
        if (!valid) {
          for (const error of errors) {
            report({
              message: `Example value must conform to the schema: ${error.message}.`,
              location: Object.assign(Object.assign({}, new ref_utils_1.Location(dataLoc.source, error.instancePath)), { reportOnKey: error.keyword === "unevaluatedProperties" || error.keyword === "additionalProperties" }),
              from: location,
              suggest: error.suggest
            });
          }
        }
      } catch (e) {
        if (e.message === "discriminator: requires oneOf or anyOf composite keyword") {
          return;
        }
        report({
          message: `Example validation errored: ${e.message}.`,
          location: location.child("schema"),
          from: location
        });
      }
    }
    exports2.validateExample = validateExample;
    function getAdditionalPropertiesOption(opts) {
      if (opts.disallowAdditionalProperties === void 0) {
        return opts.allowAdditionalProperties;
      }
      if (opts.allowAdditionalProperties !== void 0) {
        (0, utils_1.showErrorForDeprecatedField)("disallowAdditionalProperties", "allowAdditionalProperties", void 0);
      }
      (0, utils_1.showWarningForDeprecatedField)("disallowAdditionalProperties", "allowAdditionalProperties");
      return !opts.disallowAdditionalProperties;
    }
    exports2.getAdditionalPropertiesOption = getAdditionalPropertiesOption;
    function validateSchemaEnumType(schemaEnum, propertyValue, propName, refLocation, { report, location }) {
      if (!schemaEnum) {
        return;
      }
      if (!schemaEnum.includes(propertyValue)) {
        report({
          location,
          message: `\`${propName}\` can be one of the following only: ${schemaEnum.map((type2) => `"${type2}"`).join(", ")}.`,
          from: refLocation,
          suggest: getSuggest(propertyValue, schemaEnum)
        });
      }
    }
    exports2.validateSchemaEnumType = validateSchemaEnumType;
    function validateResponseCodes(responseCodes, codeRange, { report }) {
      const responseCodeRegexp = new RegExp(`^${codeRange[0]}[0-9Xx]{2}$`);
      const containsNeededCode = responseCodes.some((code) => codeRange === "2XX" && code === "default" || // It's OK to replace 2xx codes with the default
        responseCodeRegexp.test(code));
      if (!containsNeededCode) {
        report({
          message: `Operation must have at least one \`${codeRange}\` response.`,
          location: { reportOnKey: true }
        });
      }
    }
    exports2.validateResponseCodes = validateResponseCodes;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/spec.js
var require_spec = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/spec.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Spec = void 0;
    var types_1 = require_types();
    var utils_1 = require_utils5();
    var ref_utils_1 = require_ref_utils();
    var utils_2 = require_utils3();
    var Spec = () => {
      return {
        any(node, { report, type: type2, location, rawLocation, key, resolve, ignoreNextVisitorsOnNode }) {
          var _a, _b, _c, _d, _e, _f;
          const nodeType = (0, utils_1.oasTypeOf)(node);
          const refLocation = rawLocation !== location ? rawLocation : void 0;
          if (type2.items) {
            if (nodeType !== "array") {
              report({
                message: `Expected type \`${type2.name}\` (array) but got \`${nodeType}\``,
                from: refLocation
              });
              ignoreNextVisitorsOnNode();
            }
            return;
          } else if (nodeType !== "object") {
            if (type2 !== types_1.SpecExtension) {
              report({
                message: `Expected type \`${type2.name}\` (object) but got \`${nodeType}\``,
                from: refLocation
              });
            }
            ignoreNextVisitorsOnNode();
            return;
          }
          const required = typeof type2.required === "function" ? type2.required(node, key) : type2.required;
          for (const propName of required || []) {
            if (!node.hasOwnProperty(propName)) {
              report({
                message: `The field \`${propName}\` must be present on this level.`,
                from: refLocation,
                location: [{ reportOnKey: true }]
              });
            }
          }
          const allowed = (_a = type2.allowed) === null || _a === void 0 ? void 0 : _a.call(type2, node);
          if (allowed && (0, utils_2.isPlainObject)(node)) {
            for (const propName in node) {
              if (allowed.includes(propName) || type2.extensionsPrefix && propName.startsWith(type2.extensionsPrefix) || !Object.keys(type2.properties).includes(propName)) {
                continue;
              }
              report({
                message: `The field \`${propName}\` is not allowed here.`,
                from: refLocation,
                location: location.child([propName]).key()
              });
            }
          }
          const requiredOneOf = type2.requiredOneOf || null;
          if (requiredOneOf) {
            let hasProperty = false;
            for (const propName of requiredOneOf || []) {
              if (node.hasOwnProperty(propName)) {
                hasProperty = true;
              }
            }
            if (!hasProperty)
              report({
                message: `Must contain at least one of the following fields: ${(_b = type2.requiredOneOf) === null || _b === void 0 ? void 0 : _b.join(", ")}.`,
                from: refLocation,
                location: [{ reportOnKey: true }]
              });
          }
          for (const propName of Object.keys(node)) {
            const propLocation = location.child([propName]);
            let propValue = node[propName];
            let propType = type2.properties[propName];
            if (propType === void 0)
              propType = type2.additionalProperties;
            if (typeof propType === "function")
              propType = propType(propValue, propName);
            if ((0, types_1.isNamedType)(propType)) {
              continue;
            }
            const propSchema = propType;
            const propValueType = (0, utils_1.oasTypeOf)(propValue);
            if (propSchema === void 0) {
              if (propName.startsWith("x-"))
                continue;
              report({
                message: `Property \`${propName}\` is not expected here.`,
                suggest: (0, utils_1.getSuggest)(propName, Object.keys(type2.properties)),
                from: refLocation,
                location: propLocation.key()
              });
              continue;
            }
            if (propSchema === null) {
              continue;
            }
            if (propSchema.resolvable !== false && (0, ref_utils_1.isRef)(propValue)) {
              propValue = resolve(propValue).node;
            }
            if (propSchema.items && ((_c = propSchema.items) === null || _c === void 0 ? void 0 : _c.enum) && Array.isArray(propValue)) {
              for (let i = 0; i < propValue.length; i++) {
                (0, utils_1.validateSchemaEnumType)((_d = propSchema.items) === null || _d === void 0 ? void 0 : _d.enum, propValue[i], propName, refLocation, {
                  report,
                  location: location.child([propName, i])
                });
              }
            }
            if (propSchema.enum) {
              (0, utils_1.validateSchemaEnumType)(propSchema.enum, propValue, propName, refLocation, {
                report,
                location: location.child([propName])
              });
            } else if (propSchema.type && !(0, utils_1.matchesJsonSchemaType)(propValue, propSchema.type, false)) {
              report({
                message: `Expected type \`${propSchema.type}\` but got \`${propValueType}\`.`,
                from: refLocation,
                location: propLocation
              });
              ignoreNextVisitorsOnNode();
            } else if (propValueType === "array" && ((_e = propSchema.items) === null || _e === void 0 ? void 0 : _e.type)) {
              const itemsType = (_f = propSchema.items) === null || _f === void 0 ? void 0 : _f.type;
              for (let i = 0; i < propValue.length; i++) {
                const item = propValue[i];
                if (!(0, utils_1.matchesJsonSchemaType)(item, itemsType, false)) {
                  report({
                    message: `Expected type \`${itemsType}\` but got \`${(0, utils_1.oasTypeOf)(item)}\`.`,
                    from: refLocation,
                    location: propLocation.child([i])
                  });
                }
              }
            }
            if (typeof propSchema.minimum === "number") {
              if (propSchema.minimum > node[propName]) {
                report({
                  message: `The value of the ${propName} field must be greater than or equal to ${propSchema.minimum}`,
                  from: refLocation,
                  location: location.child([propName])
                });
              }
            }
            if (propName === "nullable" && !node.type) {
              report({
                message: "The `type` field must be defined when the `nullable` field is used.",
                location: location.child([propName])
              });
            }
          }
        }
      };
    };
    exports2.Spec = Spec;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-2xx-response.js
var require_operation_2xx_response = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-2xx-response.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Operation2xxResponse = void 0;
    var utils_1 = require_utils5();
    var Operation2xxResponse = ({ validateWebhooks }) => {
      return {
        Paths: {
          Responses(responses, { report }) {
            const codes = Object.keys(responses || {});
            (0, utils_1.validateResponseCodes)(codes, "2XX", { report });
          }
        },
        WebhooksMap: {
          Responses(responses, { report }) {
            if (!validateWebhooks)
              return;
            const codes = Object.keys(responses || {});
            (0, utils_1.validateResponseCodes)(codes, "2XX", { report });
          }
        }
      };
    };
    exports2.Operation2xxResponse = Operation2xxResponse;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-4xx-response.js
var require_operation_4xx_response = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-4xx-response.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Operation4xxResponse = void 0;
    var utils_1 = require_utils5();
    var Operation4xxResponse = ({ validateWebhooks }) => {
      return {
        Paths: {
          Responses(responses, { report }) {
            const codes = Object.keys(responses || {});
            (0, utils_1.validateResponseCodes)(codes, "4XX", { report });
          }
        },
        WebhooksMap: {
          Responses(responses, { report }) {
            if (!validateWebhooks)
              return;
            const codes = Object.keys(responses || {});
            (0, utils_1.validateResponseCodes)(codes, "4XX", { report });
          }
        }
      };
    };
    exports2.Operation4xxResponse = Operation4xxResponse;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/assertions/asserts.js
var require_asserts = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/assertions/asserts.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.buildAssertCustomFunction = exports2.asserts = exports2.runOnValuesSet = exports2.runOnKeysSet = void 0;
    var utils_1 = require_utils3();
    var utils_2 = require_utils6();
    exports2.runOnKeysSet = /* @__PURE__ */ new Set([
      "mutuallyExclusive",
      "mutuallyRequired",
      "enum",
      "pattern",
      "notPattern",
      "minLength",
      "maxLength",
      "casing",
      "sortOrder",
      "disallowed",
      "required",
      "requireAny",
      "ref",
      "const",
      "defined"
      // In case if `property` for assertions is not added
    ]);
    exports2.runOnValuesSet = /* @__PURE__ */ new Set([
      "pattern",
      "notPattern",
      "enum",
      "defined",
      "undefined",
      "nonEmpty",
      "minLength",
      "maxLength",
      "casing",
      "sortOrder",
      "ref",
      "const"
    ]);
    exports2.asserts = {
      pattern: (value, condition, { baseLocation, rawValue }) => {
        if (typeof value === "undefined" || (0, utils_1.isPlainObject)(value))
          return [];
        const values = Array.isArray(value) ? value : [value];
        const regex = (0, utils_2.regexFromString)(condition);
        return values.map((_val) => !(regex === null || regex === void 0 ? void 0 : regex.test(_val)) && {
          message: `"${_val}" should match a regex ${condition}`,
          location: (0, utils_1.isString)(value) ? baseLocation : (0, utils_1.isPlainObject)(rawValue) ? baseLocation.child(_val).key() : baseLocation.key()
        }).filter(utils_1.isTruthy);
      },
      notPattern: (value, condition, { baseLocation, rawValue }) => {
        if (typeof value === "undefined" || (0, utils_1.isPlainObject)(value))
          return [];
        const values = Array.isArray(value) ? value : [value];
        const regex = (0, utils_2.regexFromString)(condition);
        return values.map((_val) => (regex === null || regex === void 0 ? void 0 : regex.test(_val)) && {
          message: `"${_val}" should not match a regex ${condition}`,
          location: (0, utils_1.isString)(value) ? baseLocation : (0, utils_1.isPlainObject)(rawValue) ? baseLocation.child(_val).key() : baseLocation.key()
        }).filter(utils_1.isTruthy);
      },
      enum: (value, condition, { baseLocation }) => {
        if (typeof value === "undefined" || (0, utils_1.isPlainObject)(value))
          return [];
        const values = Array.isArray(value) ? value : [value];
        return values.map((_val) => !condition.includes(_val) && {
          message: `"${_val}" should be one of the predefined values`,
          location: (0, utils_1.isString)(value) ? baseLocation : baseLocation.child(_val).key()
        }).filter(utils_1.isTruthy);
      },
      defined: (value, condition = true, { baseLocation }) => {
        const isDefined = typeof value !== "undefined";
        const isValid2 = condition ? isDefined : !isDefined;
        return isValid2 ? [] : [
          {
            message: condition ? `Should be defined` : "Should be not defined",
            location: baseLocation
          }
        ];
      },
      required: (value, keys5, { baseLocation }) => {
        return keys5.map((requiredKey) => !value.includes(requiredKey) && {
          message: `${requiredKey} is required`,
          location: baseLocation.key()
        }).filter(utils_1.isTruthy);
      },
      disallowed: (value, condition, { baseLocation }) => {
        if (typeof value === "undefined" || (0, utils_1.isPlainObject)(value))
          return [];
        const values = Array.isArray(value) ? value : [value];
        return values.map((_val) => condition.includes(_val) && {
          message: `"${_val}" is disallowed`,
          location: (0, utils_1.isString)(value) ? baseLocation : baseLocation.child(_val).key()
        }).filter(utils_1.isTruthy);
      },
      const: (value, condition, { baseLocation }) => {
        if (typeof value === "undefined")
          return [];
        if (Array.isArray(value)) {
          return value.map((_val) => condition !== _val && {
            message: `"${_val}" should be equal ${condition} `,
            location: (0, utils_1.isString)(value) ? baseLocation : baseLocation.child(_val).key()
          }).filter(utils_1.isTruthy);
        } else {
          return value !== condition ? [
            {
              message: `${value} should be equal ${condition}`,
              location: baseLocation
            }
          ] : [];
        }
      },
      undefined: (value, condition = true, { baseLocation }) => {
        const isUndefined = typeof value === "undefined";
        const isValid2 = condition ? isUndefined : !isUndefined;
        return isValid2 ? [] : [
          {
            message: condition ? `Should not be defined` : "Should be defined",
            location: baseLocation
          }
        ];
      },
      nonEmpty: (value, condition = true, { baseLocation }) => {
        const isEmpty = typeof value === "undefined" || value === null || value === "";
        const isValid2 = condition ? !isEmpty : isEmpty;
        return isValid2 ? [] : [
          {
            message: condition ? `Should not be empty` : "Should be empty",
            location: baseLocation
          }
        ];
      },
      minLength: (value, condition, { baseLocation }) => {
        if (typeof value === "undefined" || value.length >= condition)
          return [];
        return [
          {
            message: `Should have at least ${condition} characters`,
            location: baseLocation
          }
        ];
      },
      maxLength: (value, condition, { baseLocation }) => {
        if (typeof value === "undefined" || value.length <= condition)
          return [];
        return [
          {
            message: `Should have at most ${condition} characters`,
            location: baseLocation
          }
        ];
      },
      casing: (value, condition, { baseLocation }) => {
        if (typeof value === "undefined" || (0, utils_1.isPlainObject)(value))
          return [];
        const values = Array.isArray(value) ? value : [value];
        const casingRegexes = {
          camelCase: /^[a-z][a-zA-Z0-9]+$/g,
          "kebab-case": /^([a-z][a-z0-9]*)(-[a-z0-9]+)*$/g,
          snake_case: /^([a-z][a-z0-9]*)(_[a-z0-9]+)*$/g,
          PascalCase: /^[A-Z][a-zA-Z0-9]+$/g,
          MACRO_CASE: /^([A-Z][A-Z0-9]*)(_[A-Z0-9]+)*$/g,
          "COBOL-CASE": /^([A-Z][A-Z0-9]*)(-[A-Z0-9]+)*$/g,
          flatcase: /^[a-z][a-z0-9]+$/g
        };
        return values.map((_val) => !_val.match(casingRegexes[condition]) && {
          message: `"${_val}" should use ${condition}`,
          location: (0, utils_1.isString)(value) ? baseLocation : baseLocation.child(_val).key()
        }).filter(utils_1.isTruthy);
      },
      sortOrder: (value, condition, { baseLocation }) => {
        const direction = condition.direction || condition;
        const property4 = condition.property;
        if (Array.isArray(value) && value.length > 0 && typeof value[0] === "object" && !property4) {
          return [
            {
              message: `Please define a property to sort objects by`,
              location: baseLocation
            }
          ];
        }
        if (typeof value === "undefined" || (0, utils_2.isOrdered)(value, condition))
          return [];
        return [
          {
            message: `Should be sorted in ${direction === "asc" ? "an ascending" : "a descending"} order${property4 ? ` by property ${property4}` : ""}`,
            location: baseLocation
          }
        ];
      },
      mutuallyExclusive: (value, condition, { baseLocation }) => {
        if ((0, utils_2.getIntersectionLength)(value, condition) < 2)
          return [];
        return [
          {
            message: `${condition.join(", ")} keys should be mutually exclusive`,
            location: baseLocation.key()
          }
        ];
      },
      mutuallyRequired: (value, condition, { baseLocation }) => {
        const isValid2 = (0, utils_2.getIntersectionLength)(value, condition) > 0 ? (0, utils_2.getIntersectionLength)(value, condition) === condition.length : true;
        return isValid2 ? [] : [
          {
            message: `Properties ${condition.join(", ")} are mutually required`,
            location: baseLocation.key()
          }
        ];
      },
      requireAny: (value, condition, { baseLocation }) => {
        return (0, utils_2.getIntersectionLength)(value, condition) >= 1 ? [] : [
          {
            message: `Should have any of ${condition.join(", ")}`,
            location: baseLocation.key()
          }
        ];
      },
      ref: (_value, condition, { baseLocation, rawValue }) => {
        if (typeof rawValue === "undefined")
          return [];
        const hasRef = rawValue.hasOwnProperty("$ref");
        if (typeof condition === "boolean") {
          const isValid3 = condition ? hasRef : !hasRef;
          return isValid3 ? [] : [
            {
              message: condition ? `should use $ref` : "should not use $ref",
              location: hasRef ? baseLocation : baseLocation.key()
            }
          ];
        }
        const regex = (0, utils_2.regexFromString)(condition);
        const isValid2 = hasRef && (regex === null || regex === void 0 ? void 0 : regex.test(rawValue["$ref"]));
        return isValid2 ? [] : [
          {
            message: `$ref value should match ${condition}`,
            location: hasRef ? baseLocation : baseLocation.key()
          }
        ];
      }
    };
    function buildAssertCustomFunction(fn) {
      return (value, options, ctx) => fn.call(null, value, options, ctx);
    }
    exports2.buildAssertCustomFunction = buildAssertCustomFunction;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/assertions/utils.js
var require_utils6 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/assertions/utils.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.regexFromString = exports2.runAssertion = exports2.isOrdered = exports2.getIntersectionLength = exports2.buildSubjectVisitor = exports2.buildVisitorObject = exports2.getAssertsToApply = void 0;
    var asserts_1 = require_asserts();
    var logger_1 = require_logger();
    var ref_utils_1 = require_ref_utils();
    var utils_1 = require_utils3();
    var assertionMessageTemplates = {
      problems: "{{problems}}"
    };
    function getPredicatesFromLocators(locators) {
      const { filterInParentKeys, filterOutParentKeys, matchParentKeys } = locators;
      const keyMatcher = matchParentKeys && regexFromString(matchParentKeys);
      const matchKeysPredicate = keyMatcher && ((key) => keyMatcher.test(key.toString()));
      const filterInPredicate = Array.isArray(filterInParentKeys) && ((key) => filterInParentKeys.includes(key.toString()));
      const filterOutPredicate = Array.isArray(filterOutParentKeys) && ((key) => !filterOutParentKeys.includes(key.toString()));
      return [matchKeysPredicate, filterInPredicate, filterOutPredicate].filter(utils_1.isTruthy);
    }
    function getAssertsToApply(assertion) {
      const assertsToApply = (0, utils_1.keysOf)(asserts_1.asserts).filter((assertName) => assertion.assertions[assertName] !== void 0).map((assertName) => {
        return {
          name: assertName,
          conditions: assertion.assertions[assertName],
          runsOnKeys: asserts_1.runOnKeysSet.has(assertName),
          runsOnValues: asserts_1.runOnValuesSet.has(assertName)
        };
      });
      const shouldRunOnKeys = assertsToApply.find((assert) => assert.runsOnKeys && !assert.runsOnValues);
      const shouldRunOnValues = assertsToApply.find((assert) => assert.runsOnValues && !assert.runsOnKeys);
      if (shouldRunOnValues && !assertion.subject.property) {
        throw new Error(`${shouldRunOnValues.name} can't be used on all keys. Please provide a single property`);
      }
      if (shouldRunOnKeys && assertion.subject.property) {
        throw new Error(`${shouldRunOnKeys.name} can't be used on a single property. Please use 'property'.`);
      }
      return assertsToApply;
    }
    exports2.getAssertsToApply = getAssertsToApply;
    function getAssertionProperties({ subject }) {
      return (Array.isArray(subject.property) ? subject.property : [subject === null || subject === void 0 ? void 0 : subject.property]).filter(Boolean);
    }
    function applyAssertions(assertionDefinition, asserts, ctx) {
      const properties = getAssertionProperties(assertionDefinition);
      const assertResults = [];
      for (const assert of asserts) {
        if (properties.length) {
          for (const property4 of properties) {
            assertResults.push(runAssertion({
              assert,
              ctx,
              assertionProperty: property4
            }));
          }
        } else {
          assertResults.push(runAssertion({
            assert,
            ctx
          }));
        }
      }
      return assertResults.flat();
    }
    function buildVisitorObject(assertion, subjectVisitor) {
      var _a, _b;
      const targetVisitorLocatorPredicates = getPredicatesFromLocators(assertion.subject);
      const targetVisitorSkipFunction = targetVisitorLocatorPredicates.length ? (_, key) => !targetVisitorLocatorPredicates.every((predicate) => predicate(key)) : void 0;
      const targetVisitor = {
        [assertion.subject.type]: Object.assign({ enter: subjectVisitor }, targetVisitorSkipFunction && { skip: targetVisitorSkipFunction })
      };
      if (!Array.isArray(assertion.where)) {
        return targetVisitor;
      }
      let currentVisitorLevel = {};
      const visitor = currentVisitorLevel;
      const context = assertion.where;
      for (let index = 0; index < context.length; index++) {
        const assertionDefinitionNode = context[index];
        if (!(0, utils_1.isString)((_a = assertionDefinitionNode.subject) === null || _a === void 0 ? void 0 : _a.type)) {
          throw new Error(`${assertion.assertionId} -> where -> [${index}]: 'type' (String) is required`);
        }
        const locatorPredicates = getPredicatesFromLocators(assertionDefinitionNode.subject);
        const assertsToApply = getAssertsToApply(assertionDefinitionNode);
        const skipFunction = (node, key, ctx) => !locatorPredicates.every((predicate) => predicate(key)) || !!applyAssertions(assertionDefinitionNode, assertsToApply, Object.assign(Object.assign({}, ctx), { node })).length;
        const nodeVisitor = Object.assign({}, (locatorPredicates.length || assertsToApply.length) && { skip: skipFunction });
        if (assertionDefinitionNode.subject.type === assertion.subject.type && index === context.length - 1) {
          targetVisitor[assertion.subject.type] = Object.assign({ enter: subjectVisitor }, nodeVisitor.skip && { skip: nodeVisitor.skip } || targetVisitorSkipFunction && {
            skip: (node, key, ctx) => {
              var _a2;
              return !!(((_a2 = nodeVisitor.skip) === null || _a2 === void 0 ? void 0 : _a2.call(nodeVisitor, node, key, ctx)) || (targetVisitorSkipFunction === null || targetVisitorSkipFunction === void 0 ? void 0 : targetVisitorSkipFunction(node, key)));
            }
          });
        } else {
          currentVisitorLevel = currentVisitorLevel[(_b = assertionDefinitionNode.subject) === null || _b === void 0 ? void 0 : _b.type] = nodeVisitor;
        }
      }
      currentVisitorLevel[assertion.subject.type] = targetVisitor[assertion.subject.type];
      return visitor;
    }
    exports2.buildVisitorObject = buildVisitorObject;
    function buildSubjectVisitor(assertId, assertion) {
      return (node, ctx) => {
        const properties = getAssertionProperties(assertion);
        const defaultMessage = `${logger_1.colorize.blue(assertId)} failed because the ${logger_1.colorize.blue(assertion.subject.type)} ${logger_1.colorize.blue(properties.join(", "))} didn't meet the assertions: ${assertionMessageTemplates.problems}`.replace(/ +/g, " ");
        const problems = applyAssertions(assertion, getAssertsToApply(assertion), Object.assign(Object.assign({}, ctx), { node }));
        if (problems.length) {
          for (const problemGroup of groupProblemsByPointer(problems)) {
            const message = assertion.message || defaultMessage;
            const problemMessage = getProblemsMessage(problemGroup);
            ctx.report({
              message: message.replace(assertionMessageTemplates.problems, problemMessage),
              location: getProblemsLocation(problemGroup) || ctx.location,
              forceSeverity: assertion.severity || "error",
              suggest: assertion.suggest || [],
              ruleId: assertId
            });
          }
        }
      };
    }
    exports2.buildSubjectVisitor = buildSubjectVisitor;
    function groupProblemsByPointer(problems) {
      const groups = {};
      for (const problem of problems) {
        if (!problem.location)
          continue;
        const pointer = problem.location.pointer;
        groups[pointer] = groups[pointer] || [];
        groups[pointer].push(problem);
      }
      return Object.values(groups);
    }
    function getProblemsLocation(problems) {
      return problems.length ? problems[0].location : void 0;
    }
    function getProblemsMessage(problems) {
      var _a;
      return problems.length === 1 ? (_a = problems[0].message) !== null && _a !== void 0 ? _a : "" : problems.map((problem) => {
        var _a2;
        return `
- ${(_a2 = problem.message) !== null && _a2 !== void 0 ? _a2 : ""}`;
      }).join("");
    }
    function getIntersectionLength(keys5, properties) {
      const props = new Set(properties);
      let count = 0;
      for (const key of keys5) {
        if (props.has(key)) {
          count++;
        }
      }
      return count;
    }
    exports2.getIntersectionLength = getIntersectionLength;
    function isOrdered(value, options) {
      const direction = options.direction || options;
      const property4 = options.property;
      for (let i = 1; i < value.length; i++) {
        let currValue = value[i];
        let prevVal = value[i - 1];
        if (property4) {
          const currPropValue = value[i][property4];
          const prevPropValue = value[i - 1][property4];
          if (!currPropValue || !prevPropValue) {
            return false;
          }
          currValue = currPropValue;
          prevVal = prevPropValue;
        }
        if (typeof currValue === "string" && typeof prevVal === "string") {
          currValue = currValue.toLowerCase();
          prevVal = prevVal.toLowerCase();
        }
        const result = direction === "asc" ? currValue >= prevVal : currValue <= prevVal;
        if (!result) {
          return false;
        }
      }
      return true;
    }
    exports2.isOrdered = isOrdered;
    function runAssertion({ assert, ctx, assertionProperty }) {
      var _a;
      const currentLocation = assert.name === "ref" ? ctx.rawLocation : ctx.location;
      if (assertionProperty) {
        const values = (0, ref_utils_1.isRef)(ctx.node[assertionProperty]) ? (_a = ctx.resolve(ctx.node[assertionProperty])) === null || _a === void 0 ? void 0 : _a.node : ctx.node[assertionProperty];
        const rawValues = ctx.rawNode[assertionProperty];
        const location = currentLocation.child(assertionProperty);
        return asserts_1.asserts[assert.name](values, assert.conditions, Object.assign(Object.assign({}, ctx), { baseLocation: location, rawValue: rawValues }));
      } else {
        const value = Array.isArray(ctx.node) ? ctx.node : Object.keys(ctx.node);
        return asserts_1.asserts[assert.name](value, assert.conditions, Object.assign(Object.assign({}, ctx), { rawValue: ctx.rawNode, baseLocation: currentLocation }));
      }
    }
    exports2.runAssertion = runAssertion;
    function regexFromString(input) {
      const matches = input.match(/^\/(.*)\/(.*)|(.*)/);
      return matches && new RegExp(matches[1] || matches[3], matches[2]);
    }
    exports2.regexFromString = regexFromString;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/assertions/index.js
var require_assertions = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/assertions/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Assertions = void 0;
    var utils_1 = require_utils6();
    var utils_2 = require_utils3();
    var Assertions = (opts) => {
      const visitors = [];
      const assertions = Object.values(opts).filter((opt) => typeof opt === "object" && opt !== null);
      for (const [_, assertion] of assertions.entries()) {
        if (!(0, utils_2.isString)(assertion.subject.type)) {
          throw new Error(`${assertion.assertionId}: 'type' (String) is required`);
        }
        const subjectVisitor = (0, utils_1.buildSubjectVisitor)(assertion.assertionId, assertion);
        const visitorObject = (0, utils_1.buildVisitorObject)(assertion, subjectVisitor);
        visitors.push(visitorObject);
      }
      return visitors;
    };
    exports2.Assertions = Assertions;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-operationId-unique.js
var require_operation_operationId_unique = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-operationId-unique.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OperationIdUnique = void 0;
    var OperationIdUnique = () => {
      const seenOperations = /* @__PURE__ */ new Set();
      return {
        Operation(operation, { report, location }) {
          if (!operation.operationId)
            return;
          if (seenOperations.has(operation.operationId)) {
            report({
              message: "Every operation must have a unique `operationId`.",
              location: location.child([operation.operationId])
            });
          }
          seenOperations.add(operation.operationId);
        }
      };
    };
    exports2.OperationIdUnique = OperationIdUnique;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-parameters-unique.js
var require_operation_parameters_unique = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-parameters-unique.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OperationParametersUnique = void 0;
    var OperationParametersUnique = () => {
      let seenPathParams;
      let seenOperationParams;
      return {
        PathItem: {
          enter() {
            seenPathParams = /* @__PURE__ */ new Set();
          },
          Parameter(parameter, { report, key, parentLocations }) {
            const paramId = `${parameter.in}___${parameter.name}`;
            if (seenPathParams.has(paramId)) {
              report({
                message: `Paths must have unique \`name\` + \`in\` parameters.
Repeats of \`in:${parameter.in}\` + \`name:${parameter.name}\`.`,
                location: parentLocations.PathItem.child(["parameters", key])
              });
            }
            seenPathParams.add(`${parameter.in}___${parameter.name}`);
          },
          Operation: {
            enter() {
              seenOperationParams = /* @__PURE__ */ new Set();
            },
            Parameter(parameter, { report, key, parentLocations }) {
              const paramId = `${parameter.in}___${parameter.name}`;
              if (seenOperationParams.has(paramId)) {
                report({
                  message: `Operations must have unique \`name\` + \`in\` parameters. Repeats of \`in:${parameter.in}\` + \`name:${parameter.name}\`.`,
                  location: parentLocations.Operation.child(["parameters", key])
                });
              }
              seenOperationParams.add(paramId);
            }
          }
        }
      };
    };
    exports2.OperationParametersUnique = OperationParametersUnique;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-params-defined.js
var require_path_params_defined = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-params-defined.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PathParamsDefined = void 0;
    var pathRegex = /\{([a-zA-Z0-9_.-]+)\}+/g;
    var PathParamsDefined = () => {
      let pathTemplateParams;
      let definedPathParams;
      let currentPath;
      let definedOperationParams;
      return {
        PathItem: {
          enter(_, { key }) {
            definedPathParams = /* @__PURE__ */ new Set();
            currentPath = key;
            pathTemplateParams = new Set(Array.from(key.toString().matchAll(pathRegex)).map((m) => m[1]));
          },
          Parameter(parameter, { report, location }) {
            if (parameter.in === "path" && parameter.name) {
              definedPathParams.add(parameter.name);
              if (!pathTemplateParams.has(parameter.name)) {
                report({
                  message: `Path parameter \`${parameter.name}\` is not used in the path \`${currentPath}\`.`,
                  location: location.child(["name"])
                });
              }
            }
          },
          Operation: {
            enter() {
              definedOperationParams = /* @__PURE__ */ new Set();
            },
            leave(_op, { report, location }) {
              for (const templateParam of Array.from(pathTemplateParams.keys())) {
                if (!definedOperationParams.has(templateParam) && !definedPathParams.has(templateParam)) {
                  report({
                    message: `The operation does not define the path parameter \`{${templateParam}}\` expected by path \`${currentPath}\`.`,
                    location: location.child(["parameters"]).key()
                    // report on operation
                  });
                }
              }
            },
            Parameter(parameter, { report, location }) {
              if (parameter.in === "path" && parameter.name) {
                definedOperationParams.add(parameter.name);
                if (!pathTemplateParams.has(parameter.name)) {
                  report({
                    message: `Path parameter \`${parameter.name}\` is not used in the path \`${currentPath}\`.`,
                    location: location.child(["name"])
                  });
                }
              }
            }
          }
        }
      };
    };
    exports2.PathParamsDefined = PathParamsDefined;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-tag-defined.js
var require_operation_tag_defined = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-tag-defined.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OperationTagDefined = void 0;
    var OperationTagDefined = () => {
      let definedTags;
      return {
        Root(root2) {
          var _a;
          definedTags = new Set(((_a = root2.tags) !== null && _a !== void 0 ? _a : []).map((t) => t.name));
        },
        Operation(operation, { report, location }) {
          if (operation.tags) {
            for (let i = 0; i < operation.tags.length; i++) {
              if (!definedTags.has(operation.tags[i])) {
                report({
                  message: `Operation tags should be defined in global tags.`,
                  location: location.child(["tags", i])
                });
              }
            }
          }
        }
      };
    };
    exports2.OperationTagDefined = OperationTagDefined;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-example-value-and-externalValue.js
var require_no_example_value_and_externalValue = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-example-value-and-externalValue.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoExampleValueAndExternalValue = void 0;
    var NoExampleValueAndExternalValue = () => {
      return {
        Example(example, { report, location }) {
          if (example.value && example.externalValue) {
            report({
              message: "Example object can have either `value` or `externalValue` fields.",
              location: location.child(["value"]).key()
            });
          }
        }
      };
    };
    exports2.NoExampleValueAndExternalValue = NoExampleValueAndExternalValue;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-enum-type-mismatch.js
var require_no_enum_type_mismatch = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-enum-type-mismatch.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoEnumTypeMismatch = void 0;
    var utils_1 = require_utils5();
    var NoEnumTypeMismatch = () => {
      return {
        Schema(schema2, { report, location }) {
          if (schema2.enum && !Array.isArray(schema2.enum))
            return;
          if (schema2.enum && schema2.type && !Array.isArray(schema2.type)) {
            const typeMismatchedValues = schema2.enum.filter((item) => !(0, utils_1.matchesJsonSchemaType)(item, schema2.type, schema2.nullable));
            for (const mismatchedValue of typeMismatchedValues) {
              report({
                message: `All values of \`enum\` field must be of the same type as the \`type\` field: expected "${schema2.type}" but received "${(0, utils_1.oasTypeOf)(mismatchedValue)}".`,
                location: location.child(["enum", schema2.enum.indexOf(mismatchedValue)])
              });
            }
          }
          if (schema2.enum && schema2.type && Array.isArray(schema2.type)) {
            const mismatchedResults = {};
            for (const enumValue of schema2.enum) {
              mismatchedResults[enumValue] = [];
              for (const type2 of schema2.type) {
                const valid = (0, utils_1.matchesJsonSchemaType)(enumValue, type2, schema2.nullable);
                if (!valid)
                  mismatchedResults[enumValue].push(type2);
              }
              if (mismatchedResults[enumValue].length !== schema2.type.length)
                delete mismatchedResults[enumValue];
            }
            for (const mismatchedKey of Object.keys(mismatchedResults)) {
              report({
                message: `Enum value \`${mismatchedKey}\` must be of allowed types: \`${schema2.type}\`.`,
                location: location.child(["enum", schema2.enum.indexOf(mismatchedKey)])
              });
            }
          }
        }
      };
    };
    exports2.NoEnumTypeMismatch = NoEnumTypeMismatch;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-path-trailing-slash.js
var require_no_path_trailing_slash = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-path-trailing-slash.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoPathTrailingSlash = void 0;
    var NoPathTrailingSlash = () => {
      return {
        PathItem(_path, { report, key, rawLocation }) {
          if (key.endsWith("/") && key !== "/") {
            report({
              message: `\`${key}\` should not have a trailing slash.`,
              location: rawLocation.key()
            });
          }
        }
      };
    };
    exports2.NoPathTrailingSlash = NoPathTrailingSlash;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-declaration-must-exist.js
var require_path_declaration_must_exist = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-declaration-must-exist.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PathDeclarationMustExist = void 0;
    var PathDeclarationMustExist = () => {
      return {
        PathItem(_path, { report, key }) {
          if (key.indexOf("{}") !== -1) {
            report({
              message: "Path parameter declarations must be non-empty. `{}` is invalid.",
              location: { reportOnKey: true }
            });
          }
        }
      };
    };
    exports2.PathDeclarationMustExist = PathDeclarationMustExist;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-operationId-url-safe.js
var require_operation_operationId_url_safe = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-operationId-url-safe.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OperationIdUrlSafe = void 0;
    var validUrlSymbols = /^[A-Za-z0-9-._~:/?#\[\]@!\$&'()*+,;=]*$/;
    var OperationIdUrlSafe = () => {
      return {
        Operation(operation, { report, location }) {
          if (operation.operationId && !validUrlSymbols.test(operation.operationId)) {
            report({
              message: "Operation `operationId` should not have URL invalid characters.",
              location: location.child(["operationId"])
            });
          }
        }
      };
    };
    exports2.OperationIdUrlSafe = OperationIdUrlSafe;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/tags-alphabetical.js
var require_tags_alphabetical = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/tags-alphabetical.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.TagsAlphabetical = void 0;
    var TagsAlphabetical = ({ ignoreCase = false }) => {
      return {
        Root(root2, { report, location }) {
          if (!root2.tags)
            return;
          for (let i = 0; i < root2.tags.length - 1; i++) {
            if (getTagName(root2.tags[i], ignoreCase) > getTagName(root2.tags[i + 1], ignoreCase)) {
              report({
                message: "The `tags` array should be in alphabetical order.",
                location: location.child(["tags", i])
              });
            }
          }
        }
      };
    };
    exports2.TagsAlphabetical = TagsAlphabetical;
    function getTagName(tag, ignoreCase) {
      return ignoreCase ? tag.name.toLowerCase() : tag.name;
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-server-example.com.js
var require_no_server_example_com = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-server-example.com.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoServerExample = void 0;
    var NoServerExample = () => {
      return {
        Server(server, { report, location }) {
          const pattern = /^(.*[\/.])?(example\.com|localhost)([\/:?].*|$)/;
          if (server.url && pattern.test(server.url)) {
            report({
              message: "Server `url` should not point to example.com or localhost.",
              location: location.child(["url"])
            });
          }
        }
      };
    };
    exports2.NoServerExample = NoServerExample;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-server-trailing-slash.js
var require_no_server_trailing_slash = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-server-trailing-slash.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoServerTrailingSlash = void 0;
    var NoServerTrailingSlash = () => {
      return {
        Server(server, { report, location }) {
          if (!server.url)
            return;
          if (server.url.endsWith("/") && server.url !== "/") {
            report({
              message: "Server `url` should not have a trailing slash.",
              location: location.child(["url"])
            });
          }
        }
      };
    };
    exports2.NoServerTrailingSlash = NoServerTrailingSlash;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/tag-description.js
var require_tag_description = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/tag-description.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.TagDescription = void 0;
    var utils_1 = require_utils5();
    var TagDescription = () => {
      return {
        Tag(tag, ctx) {
          (0, utils_1.validateDefinedAndNonEmpty)("description", tag, ctx);
        }
      };
    };
    exports2.TagDescription = TagDescription;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/info-contact.js
var require_info_contact = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/info-contact.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.InfoContact = void 0;
    var utils_1 = require_utils5();
    var InfoContact = () => {
      return {
        Info(info, { report, location }) {
          if (!info.contact) {
            report({
              message: (0, utils_1.missingRequiredField)("Info", "contact"),
              location: location.child("contact").key()
            });
          }
        }
      };
    };
    exports2.InfoContact = InfoContact;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/info-license.js
var require_info_license = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/info-license.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.InfoLicense = void 0;
    var utils_1 = require_utils5();
    var InfoLicense = () => {
      return {
        Info(info, { report }) {
          if (!info.license) {
            report({
              message: (0, utils_1.missingRequiredField)("Info", "license"),
              location: { reportOnKey: true }
            });
          }
        }
      };
    };
    exports2.InfoLicense = InfoLicense;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/info-license-url.js
var require_info_license_url = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/info-license-url.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.InfoLicenseUrl = void 0;
    var utils_1 = require_utils5();
    var InfoLicenseUrl = () => {
      return {
        License(license, ctx) {
          (0, utils_1.validateDefinedAndNonEmpty)("url", license, ctx);
        }
      };
    };
    exports2.InfoLicenseUrl = InfoLicenseUrl;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-description.js
var require_operation_description = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-description.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OperationDescription = void 0;
    var utils_1 = require_utils5();
    var OperationDescription = () => {
      return {
        Operation(operation, ctx) {
          (0, utils_1.validateDefinedAndNonEmpty)("description", operation, ctx);
        }
      };
    };
    exports2.OperationDescription = OperationDescription;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-unused-components.js
var require_no_unused_components = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-unused-components.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoUnusedComponents = void 0;
    var NoUnusedComponents = () => {
      const components = /* @__PURE__ */ new Map();
      function registerComponent(location, name) {
        var _a;
        components.set(location.absolutePointer, {
          used: ((_a = components.get(location.absolutePointer)) === null || _a === void 0 ? void 0 : _a.used) || false,
          location,
          name
        });
      }
      return {
        ref(ref, { type: type2, resolve, key, location }) {
          if (["Schema", "Header", "Parameter", "Response", "Example", "RequestBody"].includes(type2.name)) {
            const resolvedRef = resolve(ref);
            if (!resolvedRef.location)
              return;
            components.set(resolvedRef.location.absolutePointer, {
              used: true,
              name: key.toString(),
              location
            });
          }
        },
        Root: {
          leave(_, { report }) {
            components.forEach((usageInfo) => {
              if (!usageInfo.used) {
                report({
                  message: `Component: "${usageInfo.name}" is never used.`,
                  location: usageInfo.location.key()
                });
              }
            });
          }
        },
        NamedSchemas: {
          Schema(schema2, { location, key }) {
            if (!schema2.allOf) {
              registerComponent(location, key.toString());
            }
          }
        },
        NamedParameters: {
          Parameter(_parameter, { location, key }) {
            registerComponent(location, key.toString());
          }
        },
        NamedResponses: {
          Response(_response, { location, key }) {
            registerComponent(location, key.toString());
          }
        },
        NamedExamples: {
          Example(_example, { location, key }) {
            registerComponent(location, key.toString());
          }
        },
        NamedRequestBodies: {
          RequestBody(_requestBody, { location, key }) {
            registerComponent(location, key.toString());
          }
        },
        NamedHeaders: {
          Header(_header, { location, key }) {
            registerComponent(location, key.toString());
          }
        }
      };
    };
    exports2.NoUnusedComponents = NoUnusedComponents;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-not-include-query.js
var require_path_not_include_query = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-not-include-query.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PathNotIncludeQuery = void 0;
    var PathNotIncludeQuery = () => {
      return {
        Paths: {
          PathItem(_operation, { report, key }) {
            if (key.toString().includes("?")) {
              report({
                message: `Don't put query string items in the path, they belong in parameters with \`in: query\`.`,
                location: { reportOnKey: true }
              });
            }
          }
        }
      };
    };
    exports2.PathNotIncludeQuery = PathNotIncludeQuery;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/parameter-description.js
var require_parameter_description = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/parameter-description.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ParameterDescription = void 0;
    var ParameterDescription = () => {
      return {
        Parameter(parameter, { report, location }) {
          if (parameter.description === void 0) {
            report({
              message: "Parameter object description must be present.",
              location: { reportOnKey: true }
            });
          } else if (!parameter.description) {
            report({
              message: "Parameter object description must be non-empty string.",
              location: location.child(["description"])
            });
          }
        }
      };
    };
    exports2.ParameterDescription = ParameterDescription;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-singular-tag.js
var require_operation_singular_tag = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-singular-tag.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OperationSingularTag = void 0;
    var OperationSingularTag = () => {
      return {
        Operation(operation, { report, location }) {
          if (operation.tags && operation.tags.length > 1) {
            report({
              message: "Operation `tags` object should have only one tag.",
              location: location.child(["tags"]).key()
            });
          }
        }
      };
    };
    exports2.OperationSingularTag = OperationSingularTag;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/security-defined.js
var require_security_defined = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/security-defined.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SecurityDefined = void 0;
    var SecurityDefined = () => {
      const referencedSchemes = /* @__PURE__ */ new Map();
      const operationsWithoutSecurity = [];
      let eachOperationHasSecurity = true;
      return {
        Root: {
          leave(root2, { report }) {
            for (const [name, scheme] of referencedSchemes.entries()) {
              if (scheme.defined)
                continue;
              for (const reportedFromLocation of scheme.from) {
                report({
                  message: `There is no \`${name}\` security scheme defined.`,
                  location: reportedFromLocation.key()
                });
              }
            }
            if (root2.security || eachOperationHasSecurity) {
              return;
            } else {
              for (const operationLocation of operationsWithoutSecurity) {
                report({
                  message: `Every operation should have security defined on it or on the root level.`,
                  location: operationLocation.key()
                });
              }
            }
          }
        },
        SecurityScheme(_securityScheme, { key }) {
          referencedSchemes.set(key.toString(), { defined: true, from: [] });
        },
        SecurityRequirement(requirements, { location }) {
          for (const requirement of Object.keys(requirements)) {
            const authScheme = referencedSchemes.get(requirement);
            const requirementLocation = location.child([requirement]);
            if (!authScheme) {
              referencedSchemes.set(requirement, { from: [requirementLocation] });
            } else {
              authScheme.from.push(requirementLocation);
            }
          }
        },
        Operation(operation, { location }) {
          if (!(operation === null || operation === void 0 ? void 0 : operation.security)) {
            eachOperationHasSecurity = false;
            operationsWithoutSecurity.push(location);
          }
        }
      };
    };
    exports2.SecurityDefined = SecurityDefined;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/resolve.js
var require_resolve2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/resolve.js"(exports2) {
    "use strict";
    var __awaiter = exports2 && exports2.__awaiter || function (thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function (resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.resolveDocument = exports2.BaseResolver = exports2.makeDocumentFromString = exports2.makeRefId = exports2.YamlParseError = exports2.ResolveError = exports2.Source = void 0;
    var fs = require("fs");
    var path5 = require("path");
    var ref_utils_1 = require_ref_utils();
    var types_1 = require_types();
    var utils_1 = require_utils3();
    var Source4 = class {
      constructor(absoluteRef, body, mimeType) {
        this.absoluteRef = absoluteRef;
        this.body = body;
        this.mimeType = mimeType;
      }
      // pass safeLoad as argument to separate it from browser bundle
      getAst(safeLoad2) {
        var _a;
        if (this._ast === void 0) {
          this._ast = (_a = safeLoad2(this.body, { filename: this.absoluteRef })) !== null && _a !== void 0 ? _a : void 0;
          if (this._ast && this._ast.kind === 0 && // KIND.scalar = 0
            this._ast.value === "" && this._ast.startPosition !== 1) {
            this._ast.startPosition = 1;
            this._ast.endPosition = 1;
          }
        }
        return this._ast;
      }
      getLines() {
        if (this._lines === void 0) {
          this._lines = this.body.split(/\r\n|[\n\r]/g);
        }
        return this._lines;
      }
    };
    exports2.Source = Source4;
    var ResolveError = class _ResolveError extends Error {
      constructor(originalError) {
        super(originalError.message);
        this.originalError = originalError;
        Object.setPrototypeOf(this, _ResolveError.prototype);
      }
    };
    exports2.ResolveError = ResolveError;
    var jsYamlErrorLineColRegexp = /\((\d+):(\d+)\)$/;
    var YamlParseError = class _YamlParseError extends Error {
      constructor(originalError, source) {
        super(originalError.message.split("\n")[0]);
        this.originalError = originalError;
        this.source = source;
        Object.setPrototypeOf(this, _YamlParseError.prototype);
        const [, line, col] = this.message.match(jsYamlErrorLineColRegexp) || [];
        this.line = parseInt(line, 10);
        this.col = parseInt(col, 10);
      }
    };
    exports2.YamlParseError = YamlParseError;
    function makeRefId(absoluteRef, pointer) {
      return absoluteRef + "::" + pointer;
    }
    exports2.makeRefId = makeRefId;
    function makeDocumentFromString(sourceString, absoluteRef) {
      const source = new Source4(absoluteRef, sourceString);
      try {
        return {
          source,
          parsed: (0, utils_1.parseYaml)(sourceString, { filename: absoluteRef })
        };
      } catch (e) {
        throw new YamlParseError(e, source);
      }
    }
    exports2.makeDocumentFromString = makeDocumentFromString;
    var BaseResolver = class {
      constructor(config = { http: { headers: [] } }) {
        this.config = config;
        this.cache = /* @__PURE__ */ new Map();
      }
      getFiles() {
        return new Set(Array.from(this.cache.keys()));
      }
      resolveExternalRef(base, ref) {
        if ((0, ref_utils_1.isAbsoluteUrl)(ref)) {
          return ref;
        }
        if (base && (0, ref_utils_1.isAbsoluteUrl)(base)) {
          return new URL(ref, base).href;
        }
        return path5.resolve(base ? path5.dirname(base) : process.cwd(), ref);
      }
      loadExternalRef(absoluteRef) {
        return __awaiter(this, void 0, void 0, function* () {
          try {
            if ((0, ref_utils_1.isAbsoluteUrl)(absoluteRef)) {
              const { body, mimeType } = yield (0, utils_1.readFileFromUrl)(absoluteRef, this.config.http);
              return new Source4(absoluteRef, body, mimeType);
            } else {
              if (fs.lstatSync(absoluteRef).isDirectory()) {
                throw new Error(`Expected a file but received a folder at ${absoluteRef}`);
              }
              const content = yield fs.promises.readFile(absoluteRef, "utf-8");
              return new Source4(absoluteRef, content.replace(/\r\n/g, "\n"));
            }
          } catch (error) {
            error.message = error.message.replace(", lstat", "");
            throw new ResolveError(error);
          }
        });
      }
      parseDocument(source, isRoot = false) {
        var _a;
        const ext = source.absoluteRef.substr(source.absoluteRef.lastIndexOf("."));
        if (![".json", ".json", ".yml", ".yaml"].includes(ext) && !((_a = source.mimeType) === null || _a === void 0 ? void 0 : _a.match(/(json|yaml|openapi)/)) && !isRoot) {
          return { source, parsed: source.body };
        }
        try {
          return {
            source,
            parsed: (0, utils_1.parseYaml)(source.body, { filename: source.absoluteRef })
          };
        } catch (e) {
          throw new YamlParseError(e, source);
        }
      }
      resolveDocument(base, ref, isRoot = false) {
        return __awaiter(this, void 0, void 0, function* () {
          const absoluteRef = this.resolveExternalRef(base, ref);
          const cachedDocument = this.cache.get(absoluteRef);
          if (cachedDocument) {
            return cachedDocument;
          }
          const doc = this.loadExternalRef(absoluteRef).then((source) => {
            return this.parseDocument(source, isRoot);
          });
          this.cache.set(absoluteRef, doc);
          return doc;
        });
      }
    };
    exports2.BaseResolver = BaseResolver;
    function pushRef(head, node) {
      return {
        prev: head,
        node
      };
    }
    function hasRef(head, node) {
      while (head) {
        if (head.node === node) {
          return true;
        }
        head = head.prev;
      }
      return false;
    }
    var unknownType2 = { name: "unknown", properties: {} };
    var resolvableScalarType = { name: "scalar", properties: {} };
    function resolveDocument(opts) {
      return __awaiter(this, void 0, void 0, function* () {
        const { rootDocument, externalRefResolver, rootType } = opts;
        const resolvedRefMap = /* @__PURE__ */ new Map();
        const seedNodes = /* @__PURE__ */ new Set();
        const resolvePromises = [];
        resolveRefsInParallel(rootDocument.parsed, rootDocument, "#/", rootType);
        let resolved;
        do {
          resolved = yield Promise.all(resolvePromises);
        } while (resolvePromises.length !== resolved.length);
        return resolvedRefMap;
        function resolveRefsInParallel(rootNode, rootNodeDocument, rootNodePointer, type2) {
          const rootNodeDocAbsoluteRef = rootNodeDocument.source.absoluteRef;
          const anchorRefsMap = /* @__PURE__ */ new Map();
          walk(rootNode, type2, rootNodeDocAbsoluteRef + rootNodePointer);
          function walk(node, type3, nodeAbsoluteRef) {
            if (typeof node !== "object" || node === null) {
              return;
            }
            const nodeId = `${type3.name}::${nodeAbsoluteRef}`;
            if (seedNodes.has(nodeId)) {
              return;
            }
            seedNodes.add(nodeId);
            const [_, anchor] = Object.entries(node).find(([key]) => key === "$anchor") || [];
            if (anchor) {
              anchorRefsMap.set(`#${anchor}`, node);
            }
            if (Array.isArray(node)) {
              const itemsType = type3.items;
              if (itemsType === void 0 && type3 !== unknownType2 && type3 !== types_1.SpecExtension) {
                return;
              }
              for (let i = 0; i < node.length; i++) {
                walk(node[i], itemsType || unknownType2, (0, ref_utils_1.joinPointer)(nodeAbsoluteRef, i));
              }
              return;
            }
            for (const propName of Object.keys(node)) {
              let propValue = node[propName];
              let propType = type3.properties[propName];
              if (propType === void 0)
                propType = type3.additionalProperties;
              if (typeof propType === "function")
                propType = propType(propValue, propName);
              if (propType === void 0)
                propType = unknownType2;
              if (type3.extensionsPrefix && propName.startsWith(type3.extensionsPrefix) && propType === unknownType2) {
                propType = types_1.SpecExtension;
              }
              if (!(0, types_1.isNamedType)(propType) && (propType === null || propType === void 0 ? void 0 : propType.directResolveAs)) {
                propType = propType.directResolveAs;
                propValue = { $ref: propValue };
              }
              if (propType && propType.name === void 0 && propType.resolvable !== false) {
                propType = resolvableScalarType;
              }
              if (!(0, types_1.isNamedType)(propType) || typeof propValue !== "object") {
                continue;
              }
              walk(propValue, propType, (0, ref_utils_1.joinPointer)(nodeAbsoluteRef, (0, ref_utils_1.escapePointer)(propName)));
            }
            if ((0, ref_utils_1.isRef)(node)) {
              const promise = followRef(rootNodeDocument, node, {
                prev: null,
                node
              }).then((resolvedRef) => {
                if (resolvedRef.resolved) {
                  resolveRefsInParallel(resolvedRef.node, resolvedRef.document, resolvedRef.nodePointer, type3);
                }
              });
              resolvePromises.push(promise);
            }
          }
          function followRef(document, ref, refStack) {
            return __awaiter(this, void 0, void 0, function* () {
              if (hasRef(refStack.prev, ref)) {
                throw new Error("Self-referencing circular pointer");
              }
              if ((0, ref_utils_1.isAnchor)(ref.$ref)) {
                yield (0, utils_1.nextTick)();
                const resolvedRef2 = {
                  resolved: true,
                  isRemote: false,
                  node: anchorRefsMap.get(ref.$ref),
                  document,
                  nodePointer: ref.$ref
                };
                const refId2 = makeRefId(document.source.absoluteRef, ref.$ref);
                resolvedRefMap.set(refId2, resolvedRef2);
                return resolvedRef2;
              }
              const { uri, pointer } = (0, ref_utils_1.parseRef)(ref.$ref);
              const isRemote = uri !== null;
              let targetDoc;
              try {
                targetDoc = isRemote ? yield externalRefResolver.resolveDocument(document.source.absoluteRef, uri) : document;
              } catch (error) {
                const resolvedRef2 = {
                  resolved: false,
                  isRemote,
                  document: void 0,
                  error
                };
                const refId2 = makeRefId(document.source.absoluteRef, ref.$ref);
                resolvedRefMap.set(refId2, resolvedRef2);
                return resolvedRef2;
              }
              let resolvedRef = {
                resolved: true,
                document: targetDoc,
                isRemote,
                node: document.parsed,
                nodePointer: "#/"
              };
              let target = targetDoc.parsed;
              const segments = pointer;
              for (const segment of segments) {
                if (typeof target !== "object") {
                  target = void 0;
                  break;
                } else if (target[segment] !== void 0) {
                  target = target[segment];
                  resolvedRef.nodePointer = (0, ref_utils_1.joinPointer)(resolvedRef.nodePointer, (0, ref_utils_1.escapePointer)(segment));
                } else if ((0, ref_utils_1.isRef)(target)) {
                  resolvedRef = yield followRef(targetDoc, target, pushRef(refStack, target));
                  targetDoc = resolvedRef.document || targetDoc;
                  if (typeof resolvedRef.node !== "object") {
                    target = void 0;
                    break;
                  }
                  target = resolvedRef.node[segment];
                  resolvedRef.nodePointer = (0, ref_utils_1.joinPointer)(resolvedRef.nodePointer, (0, ref_utils_1.escapePointer)(segment));
                } else {
                  target = void 0;
                  break;
                }
              }
              resolvedRef.node = target;
              resolvedRef.document = targetDoc;
              const refId = makeRefId(document.source.absoluteRef, ref.$ref);
              if (resolvedRef.document && (0, ref_utils_1.isRef)(target)) {
                resolvedRef = yield followRef(resolvedRef.document, target, pushRef(refStack, target));
              }
              resolvedRefMap.set(refId, resolvedRef);
              return Object.assign({}, resolvedRef);
            });
          }
        }
      });
    }
    exports2.resolveDocument = resolveDocument;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/no-unresolved-refs.js
var require_no_unresolved_refs = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/no-unresolved-refs.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.reportUnresolvedRef = exports2.NoUnresolvedRefs = void 0;
    var resolve_1 = require_resolve2();
    var NoUnresolvedRefs = () => {
      return {
        ref: {
          leave(_, { report, location }, resolved) {
            if (resolved.node !== void 0)
              return;
            reportUnresolvedRef(resolved, report, location);
          }
        },
        DiscriminatorMapping(mapping, { report, resolve, location }) {
          for (const mappingName of Object.keys(mapping)) {
            const resolved = resolve({ $ref: mapping[mappingName] });
            if (resolved.node !== void 0)
              return;
            reportUnresolvedRef(resolved, report, location.child(mappingName));
          }
        }
      };
    };
    exports2.NoUnresolvedRefs = NoUnresolvedRefs;
    function reportUnresolvedRef(resolved, report, location) {
      var _a;
      const error = resolved.error;
      if (error instanceof resolve_1.YamlParseError) {
        report({
          message: "Failed to parse: " + error.message,
          location: {
            source: error.source,
            pointer: void 0,
            start: {
              col: error.col,
              line: error.line
            }
          }
        });
      }
      const message = (_a = resolved.error) === null || _a === void 0 ? void 0 : _a.message;
      report({
        location,
        message: `Can't resolve $ref${message ? ": " + message : ""}`
      });
    }
    exports2.reportUnresolvedRef = reportUnresolvedRef;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/boolean-parameter-prefixes.js
var require_boolean_parameter_prefixes = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/boolean-parameter-prefixes.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.BooleanParameterPrefixes = void 0;
    var BooleanParameterPrefixes = (options) => {
      const prefixes = options.prefixes || ["is", "has"];
      const regexp = new RegExp(`^(${prefixes.join("|")})[A-Z-_]`);
      const wrappedPrefixes = prefixes.map((p) => `\`${p}\``);
      const prefixesString = wrappedPrefixes.length === 1 ? wrappedPrefixes[0] : wrappedPrefixes.slice(0, -1).join(", ") + " or " + wrappedPrefixes[prefixes.length - 1];
      return {
        Parameter: {
          Schema(schema2, { report, parentLocations }, parents) {
            if (schema2.type === "boolean" && !regexp.test(parents.Parameter.name)) {
              report({
                message: `Boolean parameter \`${parents.Parameter.name}\` should have ${prefixesString} prefix.`,
                location: parentLocations.Parameter.child(["name"])
              });
            }
          }
        }
      };
    };
    exports2.BooleanParameterPrefixes = BooleanParameterPrefixes;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/paths-kebab-case.js
var require_paths_kebab_case = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/paths-kebab-case.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PathsKebabCase = void 0;
    var PathsKebabCase = () => {
      return {
        PathItem(_path, { report, key }) {
          const segments = key.substr(1).split("/").filter((s) => s !== "");
          if (!segments.every((segment) => /^{.+}$/.test(segment) || /^[a-z0-9-.]+$/.test(segment))) {
            report({
              message: `\`${key}\` does not use kebab-case.`,
              location: { reportOnKey: true }
            });
          }
        }
      };
    };
    exports2.PathsKebabCase = PathsKebabCase;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-http-verbs-order.js
var require_path_http_verbs_order = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-http-verbs-order.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PathHttpVerbsOrder = void 0;
    var defaultOrder = ["get", "head", "post", "put", "patch", "delete", "options", "trace"];
    var PathHttpVerbsOrder = (opts) => {
      const order = opts && opts.order || defaultOrder;
      if (!Array.isArray(order)) {
        throw new Error("path-http-verbs-order `order` option must be an array");
      }
      return {
        PathItem(path5, { report, location }) {
          const httpVerbs = Object.keys(path5).filter((k) => order.includes(k));
          for (let i = 0; i < httpVerbs.length - 1; i++) {
            const aIdx = order.indexOf(httpVerbs[i]);
            const bIdx = order.indexOf(httpVerbs[i + 1]);
            if (bIdx < aIdx) {
              report({
                message: "Operation http verbs must be ordered.",
                location: Object.assign({ reportOnKey: true }, location.child(httpVerbs[i + 1]))
              });
            }
          }
        }
      };
    };
    exports2.PathHttpVerbsOrder = PathHttpVerbsOrder;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-empty-servers.js
var require_no_empty_servers = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-empty-servers.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoEmptyServers = void 0;
    var NoEmptyServers = () => {
      return {
        Root(root2, { report, location }) {
          if (!root2.hasOwnProperty("servers")) {
            report({
              message: "Servers must be present.",
              location: location.child(["openapi"]).key()
            });
            return;
          }
          if (!Array.isArray(root2.servers) || root2.servers.length === 0) {
            report({
              message: "Servers must be a non-empty array.",
              location: location.child(["servers"]).key()
            });
          }
        }
      };
    };
    exports2.NoEmptyServers = NoEmptyServers;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-invalid-media-type-examples.js
var require_no_invalid_media_type_examples = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-invalid-media-type-examples.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ValidContentExamples = void 0;
    var ref_utils_1 = require_ref_utils();
    var utils_1 = require_utils5();
    var ValidContentExamples = (opts) => {
      var _a;
      const allowAdditionalProperties = (_a = (0, utils_1.getAdditionalPropertiesOption)(opts)) !== null && _a !== void 0 ? _a : false;
      return {
        MediaType: {
          leave(mediaType, ctx) {
            const { location, resolve } = ctx;
            if (!mediaType.schema)
              return;
            if (mediaType.example) {
              resolveAndValidateExample(mediaType.example, location.child("example"));
            } else if (mediaType.examples) {
              for (const exampleName of Object.keys(mediaType.examples)) {
                resolveAndValidateExample(mediaType.examples[exampleName], location.child(["examples", exampleName, "value"]), true);
              }
            }
            function resolveAndValidateExample(example, location2, isMultiple) {
              if ((0, ref_utils_1.isRef)(example)) {
                const resolved = resolve(example);
                if (!resolved.location)
                  return;
                location2 = isMultiple ? resolved.location.child("value") : resolved.location;
                example = resolved.node;
              }
              (0, utils_1.validateExample)(isMultiple ? example.value : example, mediaType.schema, location2, ctx, allowAdditionalProperties);
            }
          }
        }
      };
    };
    exports2.ValidContentExamples = ValidContentExamples;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-identical-paths.js
var require_no_identical_paths = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-identical-paths.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoIdenticalPaths = void 0;
    var NoIdenticalPaths = () => {
      return {
        Paths(pathMap, { report, location }) {
          const Paths = /* @__PURE__ */ new Map();
          for (const pathName of Object.keys(pathMap)) {
            const id = pathName.replace(/{.+?}/g, "{VARIABLE}");
            const existingSamePath = Paths.get(id);
            if (existingSamePath) {
              report({
                message: `The path already exists which differs only by path parameter name(s): \`${existingSamePath}\` and \`${pathName}\`.`,
                location: location.child([pathName]).key()
              });
            } else {
              Paths.set(id, pathName);
            }
          }
        }
      };
    };
    exports2.NoIdenticalPaths = NoIdenticalPaths;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-undefined-server-variable.js
var require_no_undefined_server_variable = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-undefined-server-variable.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoUndefinedServerVariable = void 0;
    var NoUndefinedServerVariable = () => {
      return {
        Server(server, { report, location }) {
          var _a;
          if (!server.url)
            return;
          const urlVariables = ((_a = server.url.match(/{[^}]+}/g)) === null || _a === void 0 ? void 0 : _a.map((e) => e.slice(1, e.length - 1))) || [];
          const definedVariables = (server === null || server === void 0 ? void 0 : server.variables) && Object.keys(server.variables) || [];
          for (const serverVar of urlVariables) {
            if (!definedVariables.includes(serverVar)) {
              report({
                message: `The \`${serverVar}\` variable is not defined in the \`variables\` objects.`,
                location: location.child(["url"])
              });
            }
          }
          for (const definedServerVar of definedVariables) {
            if (!urlVariables.includes(definedServerVar)) {
              report({
                message: `The \`${definedServerVar}\` variable is not used in the server's \`url\` field.`,
                location: location.child(["variables", definedServerVar]).key(),
                from: location.child("url")
              });
            }
          }
        }
      };
    };
    exports2.NoUndefinedServerVariable = NoUndefinedServerVariable;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-operationId.js
var require_operation_operationId = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-operationId.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OperationOperationId = void 0;
    var utils_1 = require_utils5();
    var OperationOperationId = () => {
      return {
        Root: {
          PathItem: {
            Operation(operation, ctx) {
              (0, utils_1.validateDefinedAndNonEmpty)("operationId", operation, ctx);
            }
          }
        }
      };
    };
    exports2.OperationOperationId = OperationOperationId;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-summary.js
var require_operation_summary = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/operation-summary.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OperationSummary = void 0;
    var utils_1 = require_utils5();
    var OperationSummary = () => {
      return {
        Operation(operation, ctx) {
          (0, utils_1.validateDefinedAndNonEmpty)("summary", operation, ctx);
        }
      };
    };
    exports2.OperationSummary = OperationSummary;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-ambiguous-paths.js
var require_no_ambiguous_paths = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-ambiguous-paths.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoAmbiguousPaths = void 0;
    var NoAmbiguousPaths = () => {
      return {
        Paths(pathMap, { report, location }) {
          const seenPaths = [];
          for (const currentPath of Object.keys(pathMap)) {
            const ambiguousPath = seenPaths.find((seenPath) => arePathsAmbiguous(seenPath, currentPath));
            if (ambiguousPath) {
              report({
                message: `Paths should resolve unambiguously. Found two ambiguous paths: \`${ambiguousPath}\` and \`${currentPath}\`.`,
                location: location.child([currentPath]).key()
              });
            }
            seenPaths.push(currentPath);
          }
        }
      };
    };
    exports2.NoAmbiguousPaths = NoAmbiguousPaths;
    function arePathsAmbiguous(a, b) {
      const partsA = a.split("/");
      const partsB = b.split("/");
      if (partsA.length !== partsB.length)
        return false;
      let aVars = 0;
      let bVars = 0;
      let ambiguous = true;
      for (let i = 0; i < partsA.length; i++) {
        const aIsVar = partsA[i].match(/^{.+?}$/);
        const bIsVar = partsB[i].match(/^{.+?}$/);
        if (aIsVar || bIsVar) {
          if (aIsVar)
            aVars++;
          if (bIsVar)
            bVars++;
          continue;
        } else if (partsA[i] !== partsB[i]) {
          ambiguous = false;
        }
      }
      return ambiguous && aVars === bVars;
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-server-variables-empty-enum.js
var require_no_server_variables_empty_enum = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/no-server-variables-empty-enum.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoServerVariablesEmptyEnum = void 0;
    var enumError;
    (function (enumError2) {
      enumError2["empty"] = "empty";
      enumError2["invalidDefaultValue"] = "invalidDefaultValue";
    })(enumError || (enumError = {}));
    var NoServerVariablesEmptyEnum = () => {
      return {
        Root(root2, { report, location }) {
          if (!root2.servers || root2.servers.length === 0)
            return;
          const invalidVariables = [];
          if (Array.isArray(root2.servers)) {
            for (const server of root2.servers) {
              const enumErrors = checkEnumVariables(server);
              if (!enumErrors)
                continue;
              invalidVariables.push(...enumErrors);
            }
          } else {
            const enumErrors = checkEnumVariables(root2.servers);
            if (!enumErrors)
              return;
            invalidVariables.push(...enumErrors);
          }
          for (const invalidVariable of invalidVariables) {
            if (invalidVariable === enumError.empty) {
              report({
                message: "Server variable with `enum` must be a non-empty array.",
                location: location.child(["servers"]).key()
              });
            }
            if (invalidVariable === enumError.invalidDefaultValue) {
              report({
                message: "Server variable define `enum` and `default`. `enum` must include default value",
                location: location.child(["servers"]).key()
              });
            }
          }
        }
      };
    };
    exports2.NoServerVariablesEmptyEnum = NoServerVariablesEmptyEnum;
    function checkEnumVariables(server) {
      var _a;
      if (server.variables && Object.keys(server.variables).length === 0)
        return;
      const errors = [];
      for (const variable in server.variables) {
        const serverVariable = server.variables[variable];
        if (!serverVariable.enum)
          continue;
        if (Array.isArray(serverVariable.enum) && ((_a = serverVariable.enum) === null || _a === void 0 ? void 0 : _a.length) === 0)
          errors.push(enumError.empty);
        if (!serverVariable.default)
          continue;
        const defaultValue = server.variables[variable].default;
        if (serverVariable.enum && !serverVariable.enum.includes(defaultValue))
          errors.push(enumError.invalidDefaultValue);
      }
      if (errors.length)
        return errors;
      return;
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-http-verbs-in-paths.js
var require_no_http_verbs_in_paths = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-http-verbs-in-paths.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoHttpVerbsInPaths = void 0;
    var utils_1 = require_utils3();
    var httpMethods = ["get", "head", "post", "put", "patch", "delete", "options", "trace"];
    var NoHttpVerbsInPaths = ({ splitIntoWords }) => {
      return {
        PathItem(_path, { key, report, location }) {
          const pathKey = key.toString();
          if (!pathKey.startsWith("/"))
            return;
          const pathSegments = pathKey.split("/");
          for (const pathSegment of pathSegments) {
            if (!pathSegment || (0, utils_1.isPathParameter)(pathSegment))
              continue;
            const isHttpMethodIncluded = (method) => {
              return splitIntoWords ? (0, utils_1.splitCamelCaseIntoWords)(pathSegment).has(method) : pathSegment.toLocaleLowerCase().includes(method);
            };
            for (const method of httpMethods) {
              if (isHttpMethodIncluded(method)) {
                report({
                  message: `path \`${pathKey}\` should not contain http verb ${method}`,
                  location: location.key()
                });
              }
            }
          }
        }
      };
    };
    exports2.NoHttpVerbsInPaths = NoHttpVerbsInPaths;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/request-mime-type.js
var require_request_mime_type = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/request-mime-type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RequestMimeType = void 0;
    var utils_1 = require_utils3();
    var RequestMimeType = ({ allowedValues }) => {
      return {
        Paths: {
          RequestBody: {
            leave(requestBody, ctx) {
              (0, utils_1.validateMimeTypeOAS3)({ type: "consumes", value: requestBody }, ctx, allowedValues);
            }
          },
          Callback: {
            RequestBody() {
            },
            Response: {
              leave(response, ctx) {
                (0, utils_1.validateMimeTypeOAS3)({ type: "consumes", value: response }, ctx, allowedValues);
              }
            }
          }
        },
        WebhooksMap: {
          Response: {
            leave(response, ctx) {
              (0, utils_1.validateMimeTypeOAS3)({ type: "consumes", value: response }, ctx, allowedValues);
            }
          }
        }
      };
    };
    exports2.RequestMimeType = RequestMimeType;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/response-mime-type.js
var require_response_mime_type = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/response-mime-type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ResponseMimeType = void 0;
    var utils_1 = require_utils3();
    var ResponseMimeType = ({ allowedValues }) => {
      return {
        Paths: {
          Response: {
            leave(response, ctx) {
              (0, utils_1.validateMimeTypeOAS3)({ type: "produces", value: response }, ctx, allowedValues);
            }
          },
          Callback: {
            Response() {
            },
            RequestBody: {
              leave(requestBody, ctx) {
                (0, utils_1.validateMimeTypeOAS3)({ type: "produces", value: requestBody }, ctx, allowedValues);
              }
            }
          }
        },
        WebhooksMap: {
          RequestBody: {
            leave(requestBody, ctx) {
              (0, utils_1.validateMimeTypeOAS3)({ type: "produces", value: requestBody }, ctx, allowedValues);
            }
          }
        }
      };
    };
    exports2.ResponseMimeType = ResponseMimeType;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-segment-plural.js
var require_path_segment_plural = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-segment-plural.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PathSegmentPlural = void 0;
    var utils_1 = require_utils3();
    var PathSegmentPlural = (opts) => {
      const { ignoreLastPathSegment, exceptions } = opts;
      return {
        PathItem: {
          leave(_path, { report, key, location }) {
            const pathKey = key.toString();
            if (pathKey.startsWith("/")) {
              const pathSegments = pathKey.split("/");
              pathSegments.shift();
              if (ignoreLastPathSegment && pathSegments.length > 1) {
                pathSegments.pop();
              }
              for (const pathSegment of pathSegments) {
                if (exceptions && exceptions.includes(pathSegment))
                  continue;
                if (!(0, utils_1.isPathParameter)(pathSegment) && (0, utils_1.isSingular)(pathSegment)) {
                  report({
                    message: `path segment \`${pathSegment}\` should be plural.`,
                    location: location.key()
                  });
                }
              }
            }
          }
        }
      };
    };
    exports2.PathSegmentPlural = PathSegmentPlural;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-excludes-patterns.js
var require_path_excludes_patterns = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/path-excludes-patterns.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.PathExcludesPatterns = void 0;
    var PathExcludesPatterns = ({ patterns }) => {
      return {
        PathItem(_path, { report, key, location }) {
          if (!patterns)
            throw new Error(`Parameter "patterns" is not provided for "path-excludes-patterns" rule`);
          const pathKey = key.toString();
          if (pathKey.startsWith("/")) {
            const matches = patterns.filter((pattern) => pathKey.match(pattern));
            for (const match of matches) {
              report({
                message: `path \`${pathKey}\` should not match regex pattern: \`${match}\``,
                location: location.key()
              });
            }
          }
        }
      };
    };
    exports2.PathExcludesPatterns = PathExcludesPatterns;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-invalid-schema-examples.js
var require_no_invalid_schema_examples = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-invalid-schema-examples.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoInvalidSchemaExamples = void 0;
    var utils_1 = require_utils5();
    var NoInvalidSchemaExamples = (opts) => {
      var _a;
      const allowAdditionalProperties = (_a = (0, utils_1.getAdditionalPropertiesOption)(opts)) !== null && _a !== void 0 ? _a : false;
      return {
        Schema: {
          leave(schema2, ctx) {
            if (schema2.examples) {
              for (const example of schema2.examples) {
                (0, utils_1.validateExample)(example, schema2, ctx.location.child(["examples", schema2.examples.indexOf(example)]), ctx, allowAdditionalProperties);
              }
            }
            if (schema2.example) {
              (0, utils_1.validateExample)(schema2.example, schema2, ctx.location.child("example"), ctx, true);
            }
          }
        }
      };
    };
    exports2.NoInvalidSchemaExamples = NoInvalidSchemaExamples;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-invalid-parameter-examples.js
var require_no_invalid_parameter_examples = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/no-invalid-parameter-examples.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoInvalidParameterExamples = void 0;
    var utils_1 = require_utils5();
    var NoInvalidParameterExamples = (opts) => {
      var _a;
      const allowAdditionalProperties = (_a = (0, utils_1.getAdditionalPropertiesOption)(opts)) !== null && _a !== void 0 ? _a : false;
      return {
        Parameter: {
          leave(parameter, ctx) {
            if (parameter.example) {
              (0, utils_1.validateExample)(parameter.example, parameter.schema, ctx.location.child("example"), ctx, allowAdditionalProperties);
            }
            if (parameter.examples) {
              for (const [key, example] of Object.entries(parameter.examples)) {
                if ("value" in example) {
                  (0, utils_1.validateExample)(example.value, parameter.schema, ctx.location.child(["examples", key]), ctx, true);
                }
              }
            }
          }
        }
      };
    };
    exports2.NoInvalidParameterExamples = NoInvalidParameterExamples;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/response-contains-header.js
var require_response_contains_header = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/response-contains-header.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ResponseContainsHeader = void 0;
    var utils_1 = require_utils3();
    var ResponseContainsHeader = (options) => {
      const names = options.names || {};
      return {
        Operation: {
          Response: {
            enter: (response, { report, location, key }) => {
              const expectedHeaders = names[key] || names[(0, utils_1.getMatchingStatusCodeRange)(key)] || names[(0, utils_1.getMatchingStatusCodeRange)(key).toLowerCase()] || [];
              for (const expectedHeader of expectedHeaders) {
                if (!(response === null || response === void 0 ? void 0 : response.headers) || !Object.keys(response === null || response === void 0 ? void 0 : response.headers).some((header) => header.toLowerCase() === expectedHeader.toLowerCase())) {
                  report({
                    message: `Response object must contain a "${expectedHeader}" header.`,
                    location: location.child("headers").key()
                  });
                }
              }
            }
          }
        }
      };
    };
    exports2.ResponseContainsHeader = ResponseContainsHeader;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/response-contains-property.js
var require_response_contains_property = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/response-contains-property.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ResponseContainsProperty = void 0;
    var utils_1 = require_utils3();
    var ResponseContainsProperty = (options) => {
      const names = options.names || {};
      let key;
      return {
        Operation: {
          Response: {
            skip: (_response, key2) => {
              return `${key2}` === "204";
            },
            enter: (_response, ctx) => {
              key = ctx.key;
            },
            MediaType: {
              Schema(schema2, { report, location }) {
                var _a;
                if (schema2.type !== "object")
                  return;
                const expectedProperties = names[key] || names[(0, utils_1.getMatchingStatusCodeRange)(key)] || names[(0, utils_1.getMatchingStatusCodeRange)(key).toLowerCase()] || [];
                for (const expectedProperty of expectedProperties) {
                  if (!((_a = schema2.properties) === null || _a === void 0 ? void 0 : _a[expectedProperty])) {
                    report({
                      message: `Response object must contain a top-level "${expectedProperty}" property.`,
                      location: location.child("properties").key()
                    });
                  }
                }
              }
            }
          }
        }
      };
    };
    exports2.ResponseContainsProperty = ResponseContainsProperty;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/scalar-property-missing-example.js
var require_scalar_property_missing_example = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/scalar-property-missing-example.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ScalarPropertyMissingExample = void 0;
    var oas_types_1 = require_oas_types();
    var SCALAR_TYPES = ["string", "integer", "number", "boolean", "null"];
    var ScalarPropertyMissingExample = () => {
      return {
        SchemaProperties(properties, { report, location, oasVersion, resolve }) {
          for (const propName of Object.keys(properties)) {
            const propSchema = resolve(properties[propName]).node;
            if (!propSchema || !isScalarSchema(propSchema)) {
              continue;
            }
            if (propSchema.example === void 0 && propSchema.examples === void 0) {
              report({
                message: `Scalar property should have "example"${oasVersion === oas_types_1.SpecVersion.OAS3_1 ? ' or "examples"' : ""} defined.`,
                location: location.child(propName).key()
              });
            }
          }
        }
      };
    };
    exports2.ScalarPropertyMissingExample = ScalarPropertyMissingExample;
    function isScalarSchema(schema2) {
      if (!schema2.type) {
        return false;
      }
      if (schema2.allOf || schema2.anyOf || schema2.oneOf) {
        return false;
      }
      if (schema2.format === "binary") {
        return false;
      }
      if (Array.isArray(schema2.type)) {
        return schema2.type.every((t) => SCALAR_TYPES.includes(t));
      }
      return SCALAR_TYPES.includes(schema2.type);
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/spec-components-invalid-map-name.js
var require_spec_components_invalid_map_name = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/spec-components-invalid-map-name.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SpecComponentsInvalidMapName = void 0;
    var SpecComponentsInvalidMapName = () => {
      const KEYS_REGEX = "^[a-zA-Z0-9\\.\\-_]+$";
      function validateKey(key, report, location, component) {
        if (!new RegExp(KEYS_REGEX).test(key)) {
          report({
            message: `The map key in ${component} "${key}" does not match the regular expression "${KEYS_REGEX}"`,
            location: location.key()
          });
        }
      }
      return {
        NamedSchemas: {
          Schema(_node, { key, report, location }) {
            validateKey(key, report, location, "schemas");
          }
        },
        NamedParameters: {
          Parameter(_node, { key, report, location }) {
            validateKey(key, report, location, "parameters");
          }
        },
        NamedResponses: {
          Response(_node, { key, report, location }) {
            validateKey(key, report, location, "responses");
          }
        },
        NamedExamples: {
          Example(_node, { key, report, location }) {
            validateKey(key, report, location, "examples");
          }
        },
        NamedRequestBodies: {
          RequestBody(_node, { key, report, location }) {
            validateKey(key, report, location, "requestBodies");
          }
        },
        NamedHeaders: {
          Header(_node, { key, report, location }) {
            validateKey(key, report, location, "headers");
          }
        },
        NamedSecuritySchemes: {
          SecurityScheme(_node, { key, report, location }) {
            validateKey(key, report, location, "securitySchemes");
          }
        },
        NamedLinks: {
          Link(_node, { key, report, location }) {
            validateKey(key, report, location, "links");
          }
        },
        NamedCallbacks: {
          Callback(_node, { key, report, location }) {
            validateKey(key, report, location, "callbacks");
          }
        }
      };
    };
    exports2.SpecComponentsInvalidMapName = SpecComponentsInvalidMapName;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/operation-4xx-problem-details-rfc7807.js
var require_operation_4xx_problem_details_rfc7807 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/operation-4xx-problem-details-rfc7807.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Operation4xxProblemDetailsRfc7807 = void 0;
    var utils_1 = require_utils5();
    var Operation4xxProblemDetailsRfc7807 = () => {
      return {
        Response: {
          skip(_, key) {
            return !/4[Xx0-9]{2}/.test(`${key}`);
          },
          enter(response, { report, location }) {
            if (!response.content || !response.content["application/problem+json"])
              report({
                message: "Response `4xx` must have content-type `application/problem+json`.",
                location: location.key()
              });
          },
          MediaType: {
            skip(_, key) {
              return key !== "application/problem+json";
            },
            enter(media, ctx) {
              (0, utils_1.validateDefinedAndNonEmpty)("schema", media, ctx);
            },
            SchemaProperties(schema2, ctx) {
              (0, utils_1.validateDefinedAndNonEmpty)("type", schema2, ctx);
              (0, utils_1.validateDefinedAndNonEmpty)("title", schema2, ctx);
            }
          }
        }
      };
    };
    exports2.Operation4xxProblemDetailsRfc7807 = Operation4xxProblemDetailsRfc7807;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/required-string-property-missing-min-length.js
var require_required_string_property_missing_min_length = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/required-string-property-missing-min-length.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RequiredStringPropertyMissingMinLength = void 0;
    var RequiredStringPropertyMissingMinLength = () => {
      let skipSchemaProperties;
      let requiredPropertiesSet;
      return {
        Schema: {
          enter(schema2) {
            if (!(schema2 === null || schema2 === void 0 ? void 0 : schema2.required)) {
              skipSchemaProperties = true;
              return;
            }
            requiredPropertiesSet = new Set(schema2.required);
            skipSchemaProperties = false;
          },
          SchemaProperties: {
            skip() {
              return skipSchemaProperties;
            },
            Schema: {
              enter(schema2, { key, location, report }) {
                if (requiredPropertiesSet.has(key) && schema2.type === "string") {
                  if (!(schema2 === null || schema2 === void 0 ? void 0 : schema2.minLength)) {
                    report({
                      message: "Property minLength is required.",
                      location: location.key()
                    });
                  }
                }
              }
            }
          }
        }
      };
    };
    exports2.RequiredStringPropertyMissingMinLength = RequiredStringPropertyMissingMinLength;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/spec-strict-refs.js
var require_spec_strict_refs = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/common/spec-strict-refs.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.SpecStrictRefs = void 0;
    var ref_utils_1 = require_ref_utils();
    var SpecStrictRefs = () => {
      const nodesToSkip = [
        "Schema",
        "Response",
        "Parameter",
        "RequestBody",
        "Example",
        "Header",
        "SecurityScheme",
        "Link",
        "Callback",
        "PathItem"
      ];
      return {
        any(_node, { report, rawNode, rawLocation, type: type2 }) {
          const shouldCheck = !nodesToSkip.includes(type2.name);
          if (shouldCheck && (0, ref_utils_1.isRef)(rawNode)) {
            report({
              message: "Field $ref is not expected here.",
              location: rawLocation.child("$ref").key()
            });
          }
        }
      };
    };
    exports2.SpecStrictRefs = SpecStrictRefs;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/component-name-unique.js
var require_component_name_unique = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/component-name-unique.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ComponentNameUnique = void 0;
    var TYPE_NAME_SCHEMA = "Schema";
    var TYPE_NAME_PARAMETER = "Parameter";
    var TYPE_NAME_RESPONSE = "Response";
    var TYPE_NAME_REQUEST_BODY = "RequestBody";
    var TYPE_NAME_TO_OPTION_COMPONENT_NAME = {
      [TYPE_NAME_SCHEMA]: "schemas",
      [TYPE_NAME_PARAMETER]: "parameters",
      [TYPE_NAME_RESPONSE]: "responses",
      [TYPE_NAME_REQUEST_BODY]: "requestBodies"
    };
    var ComponentNameUnique = (options) => {
      const components = /* @__PURE__ */ new Map();
      const typeNames = [];
      if (options.schemas !== "off") {
        typeNames.push(TYPE_NAME_SCHEMA);
      }
      if (options.parameters !== "off") {
        typeNames.push(TYPE_NAME_PARAMETER);
      }
      if (options.responses !== "off") {
        typeNames.push(TYPE_NAME_RESPONSE);
      }
      if (options.requestBodies !== "off") {
        typeNames.push(TYPE_NAME_REQUEST_BODY);
      }
      const rule = {
        ref: {
          leave(ref, { type: type2, resolve }) {
            const typeName = type2.name;
            if (typeNames.includes(typeName)) {
              const resolvedRef = resolve(ref);
              if (!resolvedRef.location)
                return;
              addComponentFromAbsoluteLocation(typeName, resolvedRef.location.absolutePointer.toString());
            }
          }
        },
        Root: {
          leave(root2, ctx) {
            components.forEach((value, key, _) => {
              if (value.size > 1) {
                const component = getComponentFromKey(key);
                const optionComponentName = getOptionComponentNameForTypeName(component.typeName);
                const definitions = Array.from(value).map((v) => `- ${v}`).join("\n");
                const problem = {
                  message: `Component '${optionComponentName}/${component.componentName}' is not unique. It is defined at:
${definitions}`
                };
                const componentSeverity = optionComponentName ? options[optionComponentName] : null;
                if (componentSeverity) {
                  problem.forceSeverity = componentSeverity;
                }
                ctx.report(problem);
              }
            });
          }
        }
      };
      if (options.schemas != "off") {
        rule.NamedSchemas = {
          Schema(_, { location }) {
            addComponentFromAbsoluteLocation(TYPE_NAME_SCHEMA, location.absolutePointer.toString());
          }
        };
      }
      if (options.responses != "off") {
        rule.NamedResponses = {
          Response(_, { location }) {
            addComponentFromAbsoluteLocation(TYPE_NAME_RESPONSE, location.absolutePointer.toString());
          }
        };
      }
      if (options.parameters != "off") {
        rule.NamedParameters = {
          Parameter(_, { location }) {
            addComponentFromAbsoluteLocation(TYPE_NAME_PARAMETER, location.absolutePointer.toString());
          }
        };
      }
      if (options.requestBodies != "off") {
        rule.NamedRequestBodies = {
          RequestBody(_, { location }) {
            addComponentFromAbsoluteLocation(TYPE_NAME_REQUEST_BODY, location.absolutePointer.toString());
          }
        };
      }
      return rule;
      function getComponentNameFromAbsoluteLocation(absoluteLocation) {
        const componentName = absoluteLocation.split("/").slice(-1)[0];
        if (componentName.endsWith(".yml") || componentName.endsWith(".yaml") || componentName.endsWith(".json")) {
          return componentName.slice(0, componentName.lastIndexOf("."));
        }
        return componentName;
      }
      function addFoundComponent(typeName, componentName, absoluteLocation) {
        var _a;
        const key = getKeyForComponent(typeName, componentName);
        const locations = (_a = components.get(key)) !== null && _a !== void 0 ? _a : /* @__PURE__ */ new Set();
        locations.add(absoluteLocation);
        components.set(key, locations);
      }
      function addComponentFromAbsoluteLocation(typeName, absoluteLocation) {
        const componentName = getComponentNameFromAbsoluteLocation(absoluteLocation);
        addFoundComponent(typeName, componentName, absoluteLocation);
      }
    };
    exports2.ComponentNameUnique = ComponentNameUnique;
    function getOptionComponentNameForTypeName(typeName) {
      var _a;
      return (_a = TYPE_NAME_TO_OPTION_COMPONENT_NAME[typeName]) !== null && _a !== void 0 ? _a : null;
    }
    function getKeyForComponent(typeName, componentName) {
      return `${typeName}/${componentName}`;
    }
    function getComponentFromKey(key) {
      const [typeName, componentName] = key.split("/");
      return { typeName, componentName };
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/index.js
var require_oas32 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas3/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.preprocessors = exports2.rules = void 0;
    var spec_1 = require_spec();
    var operation_2xx_response_1 = require_operation_2xx_response();
    var operation_4xx_response_1 = require_operation_4xx_response();
    var assertions_1 = require_assertions();
    var operation_operationId_unique_1 = require_operation_operationId_unique();
    var operation_parameters_unique_1 = require_operation_parameters_unique();
    var path_params_defined_1 = require_path_params_defined();
    var operation_tag_defined_1 = require_operation_tag_defined();
    var no_example_value_and_externalValue_1 = require_no_example_value_and_externalValue();
    var no_enum_type_mismatch_1 = require_no_enum_type_mismatch();
    var no_path_trailing_slash_1 = require_no_path_trailing_slash();
    var path_declaration_must_exist_1 = require_path_declaration_must_exist();
    var operation_operationId_url_safe_1 = require_operation_operationId_url_safe();
    var tags_alphabetical_1 = require_tags_alphabetical();
    var no_server_example_com_1 = require_no_server_example_com();
    var no_server_trailing_slash_1 = require_no_server_trailing_slash();
    var tag_description_1 = require_tag_description();
    var info_contact_1 = require_info_contact();
    var info_license_1 = require_info_license();
    var info_license_url_1 = require_info_license_url();
    var operation_description_1 = require_operation_description();
    var no_unused_components_1 = require_no_unused_components();
    var path_not_include_query_1 = require_path_not_include_query();
    var parameter_description_1 = require_parameter_description();
    var operation_singular_tag_1 = require_operation_singular_tag();
    var security_defined_1 = require_security_defined();
    var no_unresolved_refs_1 = require_no_unresolved_refs();
    var boolean_parameter_prefixes_1 = require_boolean_parameter_prefixes();
    var paths_kebab_case_1 = require_paths_kebab_case();
    var path_http_verbs_order_1 = require_path_http_verbs_order();
    var no_empty_servers_1 = require_no_empty_servers();
    var no_invalid_media_type_examples_1 = require_no_invalid_media_type_examples();
    var no_identical_paths_1 = require_no_identical_paths();
    var no_undefined_server_variable_1 = require_no_undefined_server_variable();
    var operation_operationId_1 = require_operation_operationId();
    var operation_summary_1 = require_operation_summary();
    var no_ambiguous_paths_1 = require_no_ambiguous_paths();
    var no_server_variables_empty_enum_1 = require_no_server_variables_empty_enum();
    var no_http_verbs_in_paths_1 = require_no_http_verbs_in_paths();
    var request_mime_type_1 = require_request_mime_type();
    var response_mime_type_1 = require_response_mime_type();
    var path_segment_plural_1 = require_path_segment_plural();
    var path_excludes_patterns_1 = require_path_excludes_patterns();
    var no_invalid_schema_examples_1 = require_no_invalid_schema_examples();
    var no_invalid_parameter_examples_1 = require_no_invalid_parameter_examples();
    var response_contains_header_1 = require_response_contains_header();
    var response_contains_property_1 = require_response_contains_property();
    var scalar_property_missing_example_1 = require_scalar_property_missing_example();
    var spec_components_invalid_map_name_1 = require_spec_components_invalid_map_name();
    var operation_4xx_problem_details_rfc7807_1 = require_operation_4xx_problem_details_rfc7807();
    var required_string_property_missing_min_length_1 = require_required_string_property_missing_min_length();
    var spec_strict_refs_1 = require_spec_strict_refs();
    var component_name_unique_1 = require_component_name_unique();
    exports2.rules = {
      spec: spec_1.Spec,
      "info-contact": info_contact_1.InfoContact,
      "info-license": info_license_1.InfoLicense,
      "info-license-url": info_license_url_1.InfoLicenseUrl,
      "operation-2xx-response": operation_2xx_response_1.Operation2xxResponse,
      "operation-4xx-response": operation_4xx_response_1.Operation4xxResponse,
      "operation-4xx-problem-details-rfc7807": operation_4xx_problem_details_rfc7807_1.Operation4xxProblemDetailsRfc7807,
      assertions: assertions_1.Assertions,
      "operation-operationId-unique": operation_operationId_unique_1.OperationIdUnique,
      "operation-parameters-unique": operation_parameters_unique_1.OperationParametersUnique,
      "operation-tag-defined": operation_tag_defined_1.OperationTagDefined,
      "no-example-value-and-externalValue": no_example_value_and_externalValue_1.NoExampleValueAndExternalValue,
      "no-enum-type-mismatch": no_enum_type_mismatch_1.NoEnumTypeMismatch,
      "no-path-trailing-slash": no_path_trailing_slash_1.NoPathTrailingSlash,
      "no-empty-servers": no_empty_servers_1.NoEmptyServers,
      "path-declaration-must-exist": path_declaration_must_exist_1.PathDeclarationMustExist,
      "operation-operationId-url-safe": operation_operationId_url_safe_1.OperationIdUrlSafe,
      "operation-operationId": operation_operationId_1.OperationOperationId,
      "operation-summary": operation_summary_1.OperationSummary,
      "tags-alphabetical": tags_alphabetical_1.TagsAlphabetical,
      "no-server-example.com": no_server_example_com_1.NoServerExample,
      "no-server-trailing-slash": no_server_trailing_slash_1.NoServerTrailingSlash,
      "tag-description": tag_description_1.TagDescription,
      "operation-description": operation_description_1.OperationDescription,
      "no-unused-components": no_unused_components_1.NoUnusedComponents,
      "path-not-include-query": path_not_include_query_1.PathNotIncludeQuery,
      "path-parameters-defined": path_params_defined_1.PathParamsDefined,
      "path-params-defined": path_params_defined_1.PathParamsDefined,
      "parameter-description": parameter_description_1.ParameterDescription,
      "operation-singular-tag": operation_singular_tag_1.OperationSingularTag,
      "security-defined": security_defined_1.SecurityDefined,
      "no-unresolved-refs": no_unresolved_refs_1.NoUnresolvedRefs,
      "paths-kebab-case": paths_kebab_case_1.PathsKebabCase,
      "boolean-parameter-prefixes": boolean_parameter_prefixes_1.BooleanParameterPrefixes,
      "path-http-verbs-order": path_http_verbs_order_1.PathHttpVerbsOrder,
      "no-invalid-media-type-examples": no_invalid_media_type_examples_1.ValidContentExamples,
      "no-identical-paths": no_identical_paths_1.NoIdenticalPaths,
      "no-ambiguous-paths": no_ambiguous_paths_1.NoAmbiguousPaths,
      "no-undefined-server-variable": no_undefined_server_variable_1.NoUndefinedServerVariable,
      "no-server-variables-empty-enum": no_server_variables_empty_enum_1.NoServerVariablesEmptyEnum,
      "no-http-verbs-in-paths": no_http_verbs_in_paths_1.NoHttpVerbsInPaths,
      "path-excludes-patterns": path_excludes_patterns_1.PathExcludesPatterns,
      "request-mime-type": request_mime_type_1.RequestMimeType,
      "response-mime-type": response_mime_type_1.ResponseMimeType,
      "path-segment-plural": path_segment_plural_1.PathSegmentPlural,
      "no-invalid-schema-examples": no_invalid_schema_examples_1.NoInvalidSchemaExamples,
      "no-invalid-parameter-examples": no_invalid_parameter_examples_1.NoInvalidParameterExamples,
      "response-contains-header": response_contains_header_1.ResponseContainsHeader,
      "response-contains-property": response_contains_property_1.ResponseContainsProperty,
      "scalar-property-missing-example": scalar_property_missing_example_1.ScalarPropertyMissingExample,
      "spec-components-invalid-map-name": spec_components_invalid_map_name_1.SpecComponentsInvalidMapName,
      "required-string-property-missing-min-length": required_string_property_missing_min_length_1.RequiredStringPropertyMissingMinLength,
      "spec-strict-refs": spec_strict_refs_1.SpecStrictRefs,
      "component-name-unique": component_name_unique_1.ComponentNameUnique
    };
    exports2.preprocessors = {};
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas2/boolean-parameter-prefixes.js
var require_boolean_parameter_prefixes2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas2/boolean-parameter-prefixes.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.BooleanParameterPrefixes = void 0;
    var BooleanParameterPrefixes = (options) => {
      const prefixes = options.prefixes || ["is", "has"];
      const regexp = new RegExp(`^(${prefixes.join("|")})[A-Z-_]`);
      const wrappedPrefixes = prefixes.map((p) => `\`${p}\``);
      const prefixesString = wrappedPrefixes.length === 1 ? wrappedPrefixes[0] : wrappedPrefixes.slice(0, -1).join(", ") + " or " + wrappedPrefixes[prefixes.length - 1];
      return {
        Parameter(param, { report, location }) {
          if (param.type === "boolean" && !regexp.test(param.name)) {
            report({
              message: `Boolean parameter \`${param.name}\` should have ${prefixesString} prefix.`,
              location: location.child("name")
            });
          }
        }
      };
    };
    exports2.BooleanParameterPrefixes = BooleanParameterPrefixes;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas2/request-mime-type.js
var require_request_mime_type2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas2/request-mime-type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RequestMimeType = void 0;
    var utils_1 = require_utils3();
    var RequestMimeType = ({ allowedValues }) => {
      return {
        Root(root2, ctx) {
          (0, utils_1.validateMimeType)({ type: "consumes", value: root2 }, ctx, allowedValues);
        },
        Operation: {
          leave(operation, ctx) {
            (0, utils_1.validateMimeType)({ type: "consumes", value: operation }, ctx, allowedValues);
          }
        }
      };
    };
    exports2.RequestMimeType = RequestMimeType;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas2/response-mime-type.js
var require_response_mime_type2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas2/response-mime-type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ResponseMimeType = void 0;
    var utils_1 = require_utils3();
    var ResponseMimeType = ({ allowedValues }) => {
      return {
        Root(root2, ctx) {
          (0, utils_1.validateMimeType)({ type: "produces", value: root2 }, ctx, allowedValues);
        },
        Operation: {
          leave(operation, ctx) {
            (0, utils_1.validateMimeType)({ type: "produces", value: operation }, ctx, allowedValues);
          }
        }
      };
    };
    exports2.ResponseMimeType = ResponseMimeType;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas2/response-contains-property.js
var require_response_contains_property2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas2/response-contains-property.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ResponseContainsProperty = void 0;
    var utils_1 = require_utils3();
    var ResponseContainsProperty = (options) => {
      const names = options.names || {};
      let key;
      return {
        Operation: {
          Response: {
            skip: (_response, key2) => {
              return `${key2}` === "204";
            },
            enter: (_response, ctx) => {
              key = ctx.key;
            },
            Schema(schema2, { report, location }) {
              var _a;
              if (schema2.type !== "object")
                return;
              const expectedProperties = names[key] || names[(0, utils_1.getMatchingStatusCodeRange)(key)] || names[(0, utils_1.getMatchingStatusCodeRange)(key).toLowerCase()] || [];
              for (const expectedProperty of expectedProperties) {
                if (!((_a = schema2.properties) === null || _a === void 0 ? void 0 : _a[expectedProperty])) {
                  report({
                    message: `Response object must contain a top-level "${expectedProperty}" property.`,
                    location: location.child("properties").key()
                  });
                }
              }
            }
          }
        }
      };
    };
    exports2.ResponseContainsProperty = ResponseContainsProperty;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas2/index.js
var require_oas22 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/oas2/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.preprocessors = exports2.rules = void 0;
    var spec_1 = require_spec();
    var no_invalid_schema_examples_1 = require_no_invalid_schema_examples();
    var no_invalid_parameter_examples_1 = require_no_invalid_parameter_examples();
    var info_contact_1 = require_info_contact();
    var info_license_1 = require_info_license();
    var info_license_url_1 = require_info_license_url();
    var boolean_parameter_prefixes_1 = require_boolean_parameter_prefixes2();
    var tag_description_1 = require_tag_description();
    var tags_alphabetical_1 = require_tags_alphabetical();
    var paths_kebab_case_1 = require_paths_kebab_case();
    var no_enum_type_mismatch_1 = require_no_enum_type_mismatch();
    var no_path_trailing_slash_1 = require_no_path_trailing_slash();
    var operation_2xx_response_1 = require_operation_2xx_response();
    var operation_4xx_response_1 = require_operation_4xx_response();
    var assertions_1 = require_assertions();
    var operation_operationId_unique_1 = require_operation_operationId_unique();
    var operation_parameters_unique_1 = require_operation_parameters_unique();
    var path_params_defined_1 = require_path_params_defined();
    var operation_tag_defined_1 = require_operation_tag_defined();
    var path_declaration_must_exist_1 = require_path_declaration_must_exist();
    var operation_operationId_url_safe_1 = require_operation_operationId_url_safe();
    var operation_description_1 = require_operation_description();
    var path_not_include_query_1 = require_path_not_include_query();
    var parameter_description_1 = require_parameter_description();
    var operation_singular_tag_1 = require_operation_singular_tag();
    var security_defined_1 = require_security_defined();
    var no_unresolved_refs_1 = require_no_unresolved_refs();
    var path_http_verbs_order_1 = require_path_http_verbs_order();
    var no_identical_paths_1 = require_no_identical_paths();
    var operation_operationId_1 = require_operation_operationId();
    var operation_summary_1 = require_operation_summary();
    var no_ambiguous_paths_1 = require_no_ambiguous_paths();
    var no_http_verbs_in_paths_1 = require_no_http_verbs_in_paths();
    var path_excludes_patterns_1 = require_path_excludes_patterns();
    var request_mime_type_1 = require_request_mime_type2();
    var response_mime_type_1 = require_response_mime_type2();
    var path_segment_plural_1 = require_path_segment_plural();
    var response_contains_header_1 = require_response_contains_header();
    var response_contains_property_1 = require_response_contains_property2();
    var scalar_property_missing_example_1 = require_scalar_property_missing_example();
    var required_string_property_missing_min_length_1 = require_required_string_property_missing_min_length();
    var spec_strict_refs_1 = require_spec_strict_refs();
    exports2.rules = {
      spec: spec_1.Spec,
      "no-invalid-schema-examples": no_invalid_schema_examples_1.NoInvalidSchemaExamples,
      "no-invalid-parameter-examples": no_invalid_parameter_examples_1.NoInvalidParameterExamples,
      "info-contact": info_contact_1.InfoContact,
      "info-license": info_license_1.InfoLicense,
      "info-license-url": info_license_url_1.InfoLicenseUrl,
      "tag-description": tag_description_1.TagDescription,
      "tags-alphabetical": tags_alphabetical_1.TagsAlphabetical,
      "paths-kebab-case": paths_kebab_case_1.PathsKebabCase,
      "no-enum-type-mismatch": no_enum_type_mismatch_1.NoEnumTypeMismatch,
      "boolean-parameter-prefixes": boolean_parameter_prefixes_1.BooleanParameterPrefixes,
      "no-path-trailing-slash": no_path_trailing_slash_1.NoPathTrailingSlash,
      "operation-2xx-response": operation_2xx_response_1.Operation2xxResponse,
      "operation-4xx-response": operation_4xx_response_1.Operation4xxResponse,
      assertions: assertions_1.Assertions,
      "operation-operationId-unique": operation_operationId_unique_1.OperationIdUnique,
      "operation-parameters-unique": operation_parameters_unique_1.OperationParametersUnique,
      "path-parameters-defined": path_params_defined_1.PathParamsDefined,
      "operation-tag-defined": operation_tag_defined_1.OperationTagDefined,
      "path-declaration-must-exist": path_declaration_must_exist_1.PathDeclarationMustExist,
      "operation-operationId-url-safe": operation_operationId_url_safe_1.OperationIdUrlSafe,
      "operation-operationId": operation_operationId_1.OperationOperationId,
      "operation-summary": operation_summary_1.OperationSummary,
      "operation-description": operation_description_1.OperationDescription,
      "path-not-include-query": path_not_include_query_1.PathNotIncludeQuery,
      "path-params-defined": path_params_defined_1.PathParamsDefined,
      "parameter-description": parameter_description_1.ParameterDescription,
      "operation-singular-tag": operation_singular_tag_1.OperationSingularTag,
      "security-defined": security_defined_1.SecurityDefined,
      "no-unresolved-refs": no_unresolved_refs_1.NoUnresolvedRefs,
      "no-identical-paths": no_identical_paths_1.NoIdenticalPaths,
      "no-ambiguous-paths": no_ambiguous_paths_1.NoAmbiguousPaths,
      "path-http-verbs-order": path_http_verbs_order_1.PathHttpVerbsOrder,
      "no-http-verbs-in-paths": no_http_verbs_in_paths_1.NoHttpVerbsInPaths,
      "path-excludes-patterns": path_excludes_patterns_1.PathExcludesPatterns,
      "request-mime-type": request_mime_type_1.RequestMimeType,
      "response-mime-type": response_mime_type_1.ResponseMimeType,
      "path-segment-plural": path_segment_plural_1.PathSegmentPlural,
      "response-contains-header": response_contains_header_1.ResponseContainsHeader,
      "response-contains-property": response_contains_property_1.ResponseContainsProperty,
      "scalar-property-missing-example": scalar_property_missing_example_1.ScalarPropertyMissingExample,
      "required-string-property-missing-min-length": required_string_property_missing_min_length_1.RequiredStringPropertyMissingMinLength,
      "spec-strict-refs": spec_strict_refs_1.SpecStrictRefs
    };
    exports2.preprocessors = {};
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/async2/channels-kebab-case.js
var require_channels_kebab_case = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/async2/channels-kebab-case.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ChannelsKebabCase = void 0;
    var ChannelsKebabCase = () => {
      return {
        Channel(_channel, { report, key }) {
          const segments = key.split(/[/.:]/).filter((s) => s !== "");
          if (!segments.every((segment) => /^{.+}$/.test(segment) || /^[a-z0-9-.]+$/.test(segment))) {
            report({
              message: `\`${key}\` does not use kebab-case.`,
              location: { reportOnKey: true }
            });
          }
        }
      };
    };
    exports2.ChannelsKebabCase = ChannelsKebabCase;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/async2/no-channel-trailing-slash.js
var require_no_channel_trailing_slash = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/async2/no-channel-trailing-slash.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.NoChannelTrailingSlash = void 0;
    var NoChannelTrailingSlash = () => {
      return {
        Channel(_channel, { report, key, location }) {
          if (key.endsWith("/") && key !== "/") {
            report({
              message: `\`${key}\` should not have a trailing slash.`,
              location: location.key()
            });
          }
        }
      };
    };
    exports2.NoChannelTrailingSlash = NoChannelTrailingSlash;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/async2/index.js
var require_async2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/async2/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.preprocessors = exports2.rules = void 0;
    var assertions_1 = require_assertions();
    var spec_1 = require_spec();
    var info_contact_1 = require_info_contact();
    var operation_operationId_1 = require_operation_operationId();
    var tag_description_1 = require_tag_description();
    var tags_alphabetical_1 = require_tags_alphabetical();
    var channels_kebab_case_1 = require_channels_kebab_case();
    var no_channel_trailing_slash_1 = require_no_channel_trailing_slash();
    exports2.rules = {
      spec: spec_1.Spec,
      assertions: assertions_1.Assertions,
      "info-contact": info_contact_1.InfoContact,
      "operation-operationId": operation_operationId_1.OperationOperationId,
      "channels-kebab-case": channels_kebab_case_1.ChannelsKebabCase,
      "no-channel-trailing-slash": no_channel_trailing_slash_1.NoChannelTrailingSlash,
      "tag-description": tag_description_1.TagDescription,
      "tags-alphabetical": tags_alphabetical_1.TagsAlphabetical
    };
    exports2.preprocessors = {};
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/package.json
var require_package = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/package.json"(exports2, module2) {
    module2.exports = {
      name: "@redocly/openapi-core",
      version: "1.4.1",
      description: "",
      main: "lib/index.js",
      engines: {
        node: ">=14.19.0",
        npm: ">=7.0.0"
      },
      engineStrict: true,
      license: "MIT",
      repository: {
        type: "git",
        url: "https://github.com/Redocly/redocly-cli.git"
      },
      browser: {
        fs: false,
        path: "path-browserify",
        os: false,
        "node-fetch": false,
        colorette: false
      },
      homepage: "https://github.com/Redocly/redocly-cli",
      keywords: [
        "linter",
        "OpenAPI",
        "Swagger",
        "OpenAPI linter",
        "Swagger linter",
        "AsyncAPI linter",
        "oas"
      ],
      contributors: [
        "Roman Hotsiy <roman@redoc.ly> (https://redoc.ly/)"
      ],
      dependencies: {
        "@redocly/ajv": "^8.11.0",
        "@types/node": "^14.11.8",
        colorette: "^1.2.0",
        "js-levenshtein": "^1.1.6",
        "js-yaml": "^4.1.0",
        "lodash.isequal": "^4.5.0",
        minimatch: "^5.0.1",
        "node-fetch": "^2.6.1",
        pluralize: "^8.0.0",
        "yaml-ast-parser": "0.0.43"
      },
      devDependencies: {
        "@types/js-levenshtein": "^1.1.0",
        "@types/js-yaml": "^4.0.3",
        "@types/lodash.isequal": "^4.5.5",
        "@types/minimatch": "^3.0.5",
        "@types/node-fetch": "^2.5.7",
        "@types/pluralize": "^0.0.29",
        typescript: "^5.2.2"
      }
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/redocly/registry-api.js
var require_registry_api = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/redocly/registry-api.js"(exports2) {
    "use strict";
    var __awaiter = exports2 && exports2.__awaiter || function (thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function (resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RegistryApi = void 0;
    var node_fetch_1 = (init_lib(), __toCommonJS(lib_exports));
    var config_1 = require_config();
    var utils_1 = require_utils3();
    var version = require_package().version;
    var RegistryApi = class {
      constructor(accessTokens, region) {
        this.accessTokens = accessTokens;
        this.region = region;
      }
      get accessToken() {
        return (0, utils_1.isNotEmptyObject)(this.accessTokens) && this.accessTokens[this.region];
      }
      getBaseUrl(region = config_1.DEFAULT_REGION) {
        return `https://api.${config_1.DOMAINS[region]}/registry`;
      }
      setAccessTokens(accessTokens) {
        this.accessTokens = accessTokens;
        return this;
      }
      request(path5 = "", options = {}, region) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
          const currentCommand = typeof process !== "undefined" ? ((_a = process.env) === null || _a === void 0 ? void 0 : _a.REDOCLY_CLI_COMMAND) || "" : "";
          const redoclyEnv = typeof process !== "undefined" ? ((_b = process.env) === null || _b === void 0 ? void 0 : _b.REDOCLY_ENVIRONMENT) || "" : "";
          const headers = Object.assign({}, options.headers || {}, {
            "x-redocly-cli-version": version,
            "user-agent": `redocly-cli / ${version} ${currentCommand} ${redoclyEnv}`
          });
          if (!headers.hasOwnProperty("authorization")) {
            throw new Error("Unauthorized");
          }
          const response = yield (0, node_fetch_1.default)(`${this.getBaseUrl(region)}${path5}`, Object.assign({}, options, { headers }));
          if (response.status === 401) {
            throw new Error("Unauthorized");
          }
          if (response.status === 404) {
            const body = yield response.json();
            throw new Error(body.code);
          }
          return response;
        });
      }
      authStatus(accessToken, region, verbose = false) {
        return __awaiter(this, void 0, void 0, function* () {
          try {
            const response = yield this.request("", { headers: { authorization: accessToken } }, region);
            return yield response.json();
          } catch (error) {
            if (verbose) {
              console.log(error);
            }
            throw error;
          }
        });
      }
      prepareFileUpload({ organizationId, name, version: version2, filesHash, filename, isUpsert }) {
        return __awaiter(this, void 0, void 0, function* () {
          const response = yield this.request(`/${organizationId}/${name}/${version2}/prepare-file-upload`, {
            method: "POST",
            headers: {
              "content-type": "application/json",
              authorization: this.accessToken
            },
            body: JSON.stringify({
              filesHash,
              filename,
              isUpsert
            })
          }, this.region);
          if (response.ok) {
            return response.json();
          }
          throw new Error("Could not prepare file upload");
        });
      }
      pushApi({ organizationId, name, version: version2, rootFilePath, filePaths, branch, isUpsert, isPublic, batchId, batchSize }) {
        return __awaiter(this, void 0, void 0, function* () {
          const response = yield this.request(`/${organizationId}/${name}/${version2}`, {
            method: "PUT",
            headers: {
              "content-type": "application/json",
              authorization: this.accessToken
            },
            body: JSON.stringify({
              rootFilePath,
              filePaths,
              branch,
              isUpsert,
              isPublic,
              batchId,
              batchSize
            })
          }, this.region);
          if (response.ok) {
            return;
          }
          throw new Error("Could not push api");
        });
      }
    };
    exports2.RegistryApi = RegistryApi;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/redocly/index.js
var require_redocly = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/redocly/index.js"(exports2) {
    "use strict";
    var __awaiter = exports2 && exports2.__awaiter || function (thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function (resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isRedoclyRegistryURL = exports2.RedoclyClient = void 0;
    var fs_1 = require("fs");
    var path_1 = require("path");
    var os_1 = require("os");
    var registry_api_1 = require_registry_api();
    var config_1 = require_config();
    var env_1 = require_env();
    var utils_1 = require_utils3();
    var logger_1 = require_logger();
    var TOKEN_FILENAME = ".redocly-config.json";
    var RedoclyClient = class {
      constructor(region) {
        this.accessTokens = {};
        this.region = this.loadRegion(region);
        this.loadTokens();
        this.domain = region ? config_1.DOMAINS[region] : env_1.env.REDOCLY_DOMAIN || config_1.DOMAINS[config_1.DEFAULT_REGION];
        env_1.env.REDOCLY_DOMAIN = this.domain;
        this.registryApi = new registry_api_1.RegistryApi(this.accessTokens, this.region);
      }
      loadRegion(region) {
        if (region && !config_1.DOMAINS[region]) {
          throw new Error(`Invalid argument: region in config file.
Given: ${logger_1.colorize.green(region)}, choices: "us", "eu".`);
        }
        if (env_1.env.REDOCLY_DOMAIN) {
          return config_1.AVAILABLE_REGIONS.find((region2) => config_1.DOMAINS[region2] === env_1.env.REDOCLY_DOMAIN) || config_1.DEFAULT_REGION;
        }
        return region || config_1.DEFAULT_REGION;
      }
      getRegion() {
        return this.region;
      }
      hasTokens() {
        return (0, utils_1.isNotEmptyObject)(this.accessTokens);
      }
      // <backward compatibility: old versions of portal>
      hasToken() {
        return !!this.accessTokens[this.region];
      }
      getAuthorizationHeader() {
        return __awaiter(this, void 0, void 0, function* () {
          return this.accessTokens[this.region];
        });
      }
      // </backward compatibility: portal>
      setAccessTokens(accessTokens) {
        this.accessTokens = accessTokens;
      }
      loadTokens() {
        const credentialsPath = (0, path_1.resolve)((0, os_1.homedir)(), TOKEN_FILENAME);
        const credentials = this.readCredentialsFile(credentialsPath);
        if ((0, utils_1.isNotEmptyObject)(credentials)) {
          this.setAccessTokens(Object.assign(Object.assign({}, credentials), credentials.token && !credentials[this.region] && {
            [this.region]: credentials.token
          }));
        }
        if (env_1.env.REDOCLY_AUTHORIZATION) {
          this.setAccessTokens(Object.assign(Object.assign({}, this.accessTokens), { [this.region]: env_1.env.REDOCLY_AUTHORIZATION }));
        }
      }
      getAllTokens() {
        return Object.entries(this.accessTokens).filter(([region]) => config_1.AVAILABLE_REGIONS.includes(region)).map(([region, token]) => ({ region, token }));
      }
      getValidTokens() {
        return __awaiter(this, void 0, void 0, function* () {
          const allTokens = this.getAllTokens();
          const verifiedTokens = yield Promise.allSettled(allTokens.map(({ token, region }) => this.verifyToken(token, region)));
          return allTokens.filter((_, index) => verifiedTokens[index].status === "fulfilled").map(({ token, region }) => ({ token, region, valid: true }));
        });
      }
      getTokens() {
        return __awaiter(this, void 0, void 0, function* () {
          return this.hasTokens() ? yield this.getValidTokens() : [];
        });
      }
      isAuthorizedWithRedoclyByRegion() {
        return __awaiter(this, void 0, void 0, function* () {
          if (!this.hasTokens()) {
            return false;
          }
          const accessToken = this.accessTokens[this.region];
          if (!accessToken) {
            return false;
          }
          try {
            yield this.verifyToken(accessToken, this.region);
            return true;
          } catch (err) {
            return false;
          }
        });
      }
      isAuthorizedWithRedocly() {
        return __awaiter(this, void 0, void 0, function* () {
          return this.hasTokens() && (0, utils_1.isNotEmptyObject)(yield this.getValidTokens());
        });
      }
      readCredentialsFile(credentialsPath) {
        return (0, fs_1.existsSync)(credentialsPath) ? JSON.parse((0, fs_1.readFileSync)(credentialsPath, "utf-8")) : {};
      }
      verifyToken(accessToken, region, verbose = false) {
        return __awaiter(this, void 0, void 0, function* () {
          return this.registryApi.authStatus(accessToken, region, verbose);
        });
      }
      login(accessToken, verbose = false) {
        return __awaiter(this, void 0, void 0, function* () {
          const credentialsPath = (0, path_1.resolve)((0, os_1.homedir)(), TOKEN_FILENAME);
          try {
            yield this.verifyToken(accessToken, this.region, verbose);
          } catch (err) {
            throw new Error("Authorization failed. Please check if you entered a valid API key.");
          }
          const credentials = Object.assign(Object.assign({}, this.readCredentialsFile(credentialsPath)), { [this.region]: accessToken, token: accessToken });
          this.accessTokens = credentials;
          this.registryApi.setAccessTokens(credentials);
          (0, fs_1.writeFileSync)(credentialsPath, JSON.stringify(credentials, null, 2));
        });
      }
      logout() {
        const credentialsPath = (0, path_1.resolve)((0, os_1.homedir)(), TOKEN_FILENAME);
        if ((0, fs_1.existsSync)(credentialsPath)) {
          (0, fs_1.unlinkSync)(credentialsPath);
        }
      }
    };
    exports2.RedoclyClient = RedoclyClient;
    function isRedoclyRegistryURL(link) {
      const domain = env_1.env.REDOCLY_DOMAIN || config_1.DOMAINS[config_1.DEFAULT_REGION];
      const legacyDomain = domain === "redocly.com" ? "redoc.ly" : domain;
      if (!link.startsWith(`https://api.${domain}/registry/`) && !link.startsWith(`https://api.${legacyDomain}/registry/`)) {
        return false;
      }
      return true;
    }
    exports2.isRedoclyRegistryURL = isRedoclyRegistryURL;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/registry-dependencies.js
var require_registry_dependencies = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/registry-dependencies.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RegistryDependencies = void 0;
    var redocly_1 = require_redocly();
    var RegistryDependencies = () => {
      const registryDependencies = /* @__PURE__ */ new Set();
      return {
        Root: {
          leave(_, ctx) {
            const data = ctx.getVisitorData();
            data.links = Array.from(registryDependencies);
          }
        },
        ref(node) {
          if (node.$ref) {
            const link = node.$ref.split("#/")[0];
            if ((0, redocly_1.isRedoclyRegistryURL)(link)) {
              registryDependencies.add(link);
            }
          }
        }
      };
    };
    exports2.RegistryDependencies = RegistryDependencies;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/operation-description-override.js
var require_operation_description_override = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/operation-description-override.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.OperationDescriptionOverride = void 0;
    var utils_1 = require_utils3();
    var OperationDescriptionOverride = ({ operationIds }) => {
      return {
        Operation: {
          leave(operation, { report, location }) {
            if (!operation.operationId)
              return;
            if (!operationIds)
              throw new Error(`Parameter "operationIds" is not provided for "operation-description-override" rule`);
            const operationId = operation.operationId;
            if (operationIds[operationId]) {
              try {
                operation.description = (0, utils_1.readFileAsStringSync)(operationIds[operationId]);
              } catch (e) {
                report({
                  message: `Failed to read markdown override file for operation "${operationId}".
${e.message}`,
                  location: location.child("operationId").key()
                });
              }
            }
          }
        }
      };
    };
    exports2.OperationDescriptionOverride = OperationDescriptionOverride;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/tag-description-override.js
var require_tag_description_override = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/tag-description-override.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.TagDescriptionOverride = void 0;
    var utils_1 = require_utils3();
    var TagDescriptionOverride = ({ tagNames }) => {
      return {
        Tag: {
          leave(tag, { report }) {
            if (!tagNames)
              throw new Error(`Parameter "tagNames" is not provided for "tag-description-override" rule`);
            if (tagNames[tag.name]) {
              try {
                tag.description = (0, utils_1.readFileAsStringSync)(tagNames[tag.name]);
              } catch (e) {
                report({
                  message: `Failed to read markdown override file for tag "${tag.name}".
${e.message}`
                });
              }
            }
          }
        }
      };
    };
    exports2.TagDescriptionOverride = TagDescriptionOverride;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/info-description-override.js
var require_info_description_override = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/info-description-override.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.InfoDescriptionOverride = void 0;
    var utils_1 = require_utils3();
    var InfoDescriptionOverride = ({ filePath }) => {
      return {
        Info: {
          leave(info, { report, location }) {
            if (!filePath)
              throw new Error(`Parameter "filePath" is not provided for "info-description-override" rule`);
            try {
              info.description = (0, utils_1.readFileAsStringSync)(filePath);
            } catch (e) {
              report({
                message: `Failed to read markdown override file for "info.description".
${e.message}`,
                location: location.child("description")
              });
            }
          }
        }
      };
    };
    exports2.InfoDescriptionOverride = InfoDescriptionOverride;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/info-override.js
var require_info_override = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/info-override.js"(exports2) {
    "use strict";
    var __rest = exports2 && exports2.__rest || function (s, e) {
      var t = {};
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
      if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
          if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
            t[p[i]] = s[p[i]];
        }
      return t;
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.InfoOverride = void 0;
    var InfoOverride = (newInfo) => {
      return {
        Info: {
          leave(info) {
            if (typeof newInfo !== "object" || Array.isArray(newInfo) || newInfo === null) {
              throw new Error(`"info-override" decorator should be called with an object`);
            }
            const { severity: _ } = newInfo, rest = __rest(newInfo, ["severity"]);
            Object.assign(info, rest);
          }
        }
      };
    };
    exports2.InfoOverride = InfoOverride;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/remove-x-internal.js
var require_remove_x_internal = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/remove-x-internal.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RemoveXInternal = void 0;
    var utils_1 = require_utils3();
    var ref_utils_1 = require_ref_utils();
    var DEFAULT_INTERNAL_PROPERTY_NAME = "x-internal";
    var RemoveXInternal = ({ internalFlagProperty }) => {
      const hiddenTag = internalFlagProperty || DEFAULT_INTERNAL_PROPERTY_NAME;
      function removeInternal(node, ctx) {
        var _a, _b, _c, _d;
        const { parent, key } = ctx;
        let didDelete = false;
        if (Array.isArray(node)) {
          for (let i = 0; i < node.length; i++) {
            if ((0, ref_utils_1.isRef)(node[i])) {
              const resolved = ctx.resolve(node[i]);
              if ((_a = resolved.node) === null || _a === void 0 ? void 0 : _a[hiddenTag]) {
                node.splice(i, 1);
                didDelete = true;
                i--;
              }
            }
            if ((_b = node[i]) === null || _b === void 0 ? void 0 : _b[hiddenTag]) {
              node.splice(i, 1);
              didDelete = true;
              i--;
            }
          }
        } else if ((0, utils_1.isPlainObject)(node)) {
          for (const key2 of Object.keys(node)) {
            node = node;
            if ((0, ref_utils_1.isRef)(node[key2])) {
              const resolved = ctx.resolve(node[key2]);
              if ((_c = resolved.node) === null || _c === void 0 ? void 0 : _c[hiddenTag]) {
                delete node[key2];
                didDelete = true;
              }
            }
            if ((_d = node[key2]) === null || _d === void 0 ? void 0 : _d[hiddenTag]) {
              delete node[key2];
              didDelete = true;
            }
          }
        }
        if (didDelete && ((0, utils_1.isEmptyObject)(node) || (0, utils_1.isEmptyArray)(node))) {
          delete parent[key];
        }
      }
      return {
        any: {
          enter: (node, ctx) => {
            removeInternal(node, ctx);
          }
        }
      };
    };
    exports2.RemoveXInternal = RemoveXInternal;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/filters/filter-helper.js
var require_filter_helper = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/filters/filter-helper.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.checkIfMatchByStrategy = exports2.filter = void 0;
    var ref_utils_1 = require_ref_utils();
    var utils_1 = require_utils3();
    function filter(node, ctx, criteria) {
      const { parent, key } = ctx;
      let didDelete = false;
      if (Array.isArray(node)) {
        for (let i = 0; i < node.length; i++) {
          if ((0, ref_utils_1.isRef)(node[i])) {
            const resolved = ctx.resolve(node[i]);
            if (criteria(resolved.node)) {
              node.splice(i, 1);
              didDelete = true;
              i--;
            }
          }
          if (criteria(node[i])) {
            node.splice(i, 1);
            didDelete = true;
            i--;
          }
        }
      } else if ((0, utils_1.isPlainObject)(node)) {
        for (const key2 of Object.keys(node)) {
          node = node;
          if ((0, ref_utils_1.isRef)(node[key2])) {
            const resolved = ctx.resolve(node[key2]);
            if (criteria(resolved.node)) {
              delete node[key2];
              didDelete = true;
            }
          }
          if (criteria(node[key2])) {
            delete node[key2];
            didDelete = true;
          }
        }
      }
      if (didDelete && ((0, utils_1.isEmptyObject)(node) || (0, utils_1.isEmptyArray)(node))) {
        delete parent[key];
      }
    }
    exports2.filter = filter;
    function checkIfMatchByStrategy(nodeValue, decoratorValue, strategy) {
      if (nodeValue === void 0 || decoratorValue === void 0) {
        return false;
      }
      if (!Array.isArray(decoratorValue) && !Array.isArray(nodeValue)) {
        return nodeValue === decoratorValue;
      }
      decoratorValue = toArrayIfNeeded(decoratorValue);
      nodeValue = toArrayIfNeeded(nodeValue);
      if (strategy === "any") {
        return decoratorValue.some((item) => nodeValue.includes(item));
      }
      if (strategy === "all") {
        return decoratorValue.every((item) => nodeValue.includes(item));
      }
      return false;
    }
    exports2.checkIfMatchByStrategy = checkIfMatchByStrategy;
    function toArrayIfNeeded(value) {
      return Array.isArray(value) ? value : [value];
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/filters/filter-in.js
var require_filter_in = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/filters/filter-in.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.FilterIn = void 0;
    var filter_helper_1 = require_filter_helper();
    var DEFAULT_STRATEGY = "any";
    var FilterIn = ({ property: property4, value, matchStrategy }) => {
      const strategy = matchStrategy || DEFAULT_STRATEGY;
      const filterInCriteria = (item) => (item === null || item === void 0 ? void 0 : item[property4]) && !(0, filter_helper_1.checkIfMatchByStrategy)(item === null || item === void 0 ? void 0 : item[property4], value, strategy);
      return {
        any: {
          enter: (node, ctx) => {
            (0, filter_helper_1.filter)(node, ctx, filterInCriteria);
          }
        }
      };
    };
    exports2.FilterIn = FilterIn;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/filters/filter-out.js
var require_filter_out = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/filters/filter-out.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.FilterOut = void 0;
    var filter_helper_1 = require_filter_helper();
    var DEFAULT_STRATEGY = "any";
    var FilterOut = ({ property: property4, value, matchStrategy }) => {
      const strategy = matchStrategy || DEFAULT_STRATEGY;
      const filterOutCriteria = (item) => (0, filter_helper_1.checkIfMatchByStrategy)(item === null || item === void 0 ? void 0 : item[property4], value, strategy);
      return {
        any: {
          enter: (node, ctx) => {
            (0, filter_helper_1.filter)(node, ctx, filterOutCriteria);
          }
        }
      };
    };
    exports2.FilterOut = FilterOut;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/media-type-examples-override.js
var require_media_type_examples_override = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/common/media-type-examples-override.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.MediaTypeExamplesOverride = void 0;
    var utils_1 = require_utils3();
    var ref_utils_1 = require_ref_utils();
    var MediaTypeExamplesOverride = ({ operationIds }) => {
      return {
        Operation: {
          enter(operation, ctx) {
            const operationId = operation.operationId;
            if (!operationId) {
              return;
            }
            const properties = operationIds[operationId];
            if (!properties) {
              return;
            }
            if (properties.responses && operation.responses) {
              for (const responseCode of Object.keys(properties.responses)) {
                const resolvedResponse = checkAndResolveRef(operation.responses[responseCode], ctx.resolve);
                if (!resolvedResponse) {
                  continue;
                }
                resolvedResponse.content = resolvedResponse.content ? resolvedResponse.content : {};
                Object.keys(properties.responses[responseCode]).forEach((mimeType) => {
                  resolvedResponse.content[mimeType] = Object.assign(Object.assign({}, resolvedResponse.content[mimeType]), { examples: (0, utils_1.yamlAndJsonSyncReader)(properties.responses[responseCode][mimeType]) });
                });
                operation.responses[responseCode] = resolvedResponse;
              }
            }
            if (properties.request && operation.requestBody) {
              const resolvedRequest = checkAndResolveRef(operation.requestBody, ctx.resolve);
              if (!resolvedRequest) {
                return;
              }
              resolvedRequest.content = resolvedRequest.content ? resolvedRequest.content : {};
              Object.keys(properties.request).forEach((mimeType) => {
                resolvedRequest.content[mimeType] = Object.assign(Object.assign({}, resolvedRequest.content[mimeType]), { examples: (0, utils_1.yamlAndJsonSyncReader)(properties.request[mimeType]) });
              });
              operation.requestBody = resolvedRequest;
            }
          }
        }
      };
    };
    exports2.MediaTypeExamplesOverride = MediaTypeExamplesOverride;
    function checkAndResolveRef(node, resolver) {
      if (!(0, ref_utils_1.isRef)(node)) {
        return node;
      }
      const resolved = resolver(node);
      return resolved.error ? void 0 : JSON.parse(JSON.stringify(resolved.node));
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/oas3/index.js
var require_oas33 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/oas3/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.decorators = void 0;
    var registry_dependencies_1 = require_registry_dependencies();
    var operation_description_override_1 = require_operation_description_override();
    var tag_description_override_1 = require_tag_description_override();
    var info_description_override_1 = require_info_description_override();
    var info_override_1 = require_info_override();
    var remove_x_internal_1 = require_remove_x_internal();
    var filter_in_1 = require_filter_in();
    var filter_out_1 = require_filter_out();
    var media_type_examples_override_1 = require_media_type_examples_override();
    exports2.decorators = {
      "registry-dependencies": registry_dependencies_1.RegistryDependencies,
      "operation-description-override": operation_description_override_1.OperationDescriptionOverride,
      "tag-description-override": tag_description_override_1.TagDescriptionOverride,
      "info-description-override": info_description_override_1.InfoDescriptionOverride,
      "info-override": info_override_1.InfoOverride,
      "remove-x-internal": remove_x_internal_1.RemoveXInternal,
      "filter-in": filter_in_1.FilterIn,
      "filter-out": filter_out_1.FilterOut,
      "media-type-examples-override": media_type_examples_override_1.MediaTypeExamplesOverride
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/oas2/index.js
var require_oas23 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/oas2/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.decorators = void 0;
    var registry_dependencies_1 = require_registry_dependencies();
    var operation_description_override_1 = require_operation_description_override();
    var tag_description_override_1 = require_tag_description_override();
    var info_description_override_1 = require_info_description_override();
    var info_override_1 = require_info_override();
    var remove_x_internal_1 = require_remove_x_internal();
    var filter_in_1 = require_filter_in();
    var filter_out_1 = require_filter_out();
    exports2.decorators = {
      "registry-dependencies": registry_dependencies_1.RegistryDependencies,
      "operation-description-override": operation_description_override_1.OperationDescriptionOverride,
      "tag-description-override": tag_description_override_1.TagDescriptionOverride,
      "info-description-override": info_description_override_1.InfoDescriptionOverride,
      "info-override": info_override_1.InfoOverride,
      "remove-x-internal": remove_x_internal_1.RemoveXInternal,
      "filter-in": filter_in_1.FilterIn,
      "filter-out": filter_out_1.FilterOut
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/builtIn.js
var require_builtIn = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/builtIn.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.defaultPlugin = exports2.builtInConfigs = void 0;
    var recommended_1 = require_recommended();
    var recommended_strict_1 = require_recommended_strict();
    var all_1 = require_all();
    var minimal_1 = require_minimal();
    var oas3_1 = require_oas32();
    var oas2_1 = require_oas22();
    var async2_1 = require_async2();
    var oas3_2 = require_oas32();
    var oas2_2 = require_oas22();
    var oas3_3 = require_oas33();
    var oas2_3 = require_oas23();
    exports2.builtInConfigs = {
      recommended: recommended_1.default,
      "recommended-strict": recommended_strict_1.default,
      minimal: minimal_1.default,
      all: all_1.default,
      "redocly-registry": {
        decorators: { "registry-dependencies": "on" }
      }
    };
    exports2.defaultPlugin = {
      id: "",
      rules: {
        oas3: oas3_1.rules,
        oas2: oas2_1.rules,
        async2: async2_1.rules
      },
      preprocessors: {
        oas3: oas3_2.preprocessors,
        oas2: oas2_2.preprocessors,
        async2: {}
      },
      decorators: {
        oas3: oas3_3.decorators,
        oas2: oas2_3.decorators,
        async2: {}
      },
      configs: exports2.builtInConfigs
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/config-resolvers.js
var require_config_resolvers = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/config-resolvers.js"(exports2) {
    "use strict";
    var __awaiter = exports2 && exports2.__awaiter || function (thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function (resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    var __rest = exports2 && exports2.__rest || function (s, e) {
      var t = {};
      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
      if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
          if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
            t[p[i]] = s[p[i]];
        }
      return t;
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.resolvePreset = exports2.resolveStyleguideConfig = exports2.resolveApis = exports2.resolvePlugins = exports2.resolveConfig = void 0;
    var path5 = require("path");
    var ref_utils_1 = require_ref_utils();
    var utils_1 = require_utils3();
    var resolve_1 = require_resolve2();
    var builtIn_1 = require_builtIn();
    var utils_2 = require_utils4();
    var env_1 = require_env();
    var utils_3 = require_utils3();
    var config_1 = require_config();
    var logger_1 = require_logger();
    var asserts_1 = require_asserts();
    function resolveConfig(rawConfig, configPath) {
      var _a, _b;
      return __awaiter(this, void 0, void 0, function* () {
        if ((_b = (_a = rawConfig.styleguide) === null || _a === void 0 ? void 0 : _a.extends) === null || _b === void 0 ? void 0 : _b.some(utils_3.isNotString)) {
          throw new Error(`Error configuration format not detected in extends value must contain strings`);
        }
        const resolver = new resolve_1.BaseResolver((0, utils_2.getResolveConfig)(rawConfig.resolve));
        const apis = yield resolveApis({
          rawConfig,
          configPath,
          resolver
        });
        const styleguide = yield resolveStyleguideConfig({
          styleguideConfig: rawConfig.styleguide,
          configPath,
          resolver
        });
        return new config_1.Config(Object.assign(Object.assign({}, rawConfig), {
          apis,
          styleguide
        }), configPath);
      });
    }
    exports2.resolveConfig = resolveConfig;
    function resolvePlugins(plugins, configPath = "") {
      if (!plugins)
        return [];
      const requireFunc = (plugin) => {
        if (env_1.isBrowser && (0, utils_3.isString)(plugin)) {
          logger_1.logger.error(`Cannot load ${plugin}. Plugins aren't supported in browser yet.`);
          return void 0;
        }
        if ((0, utils_3.isString)(plugin)) {
          try {
            const absoltePluginPath = path5.resolve(path5.dirname(configPath), plugin);
            return typeof __webpack_require__ === "function" ? (
              // eslint-disable-next-line @typescript-eslint/ban-ts-comment
              // @ts-ignore
              __non_webpack_require__(absoltePluginPath)
            ) : require(absoltePluginPath);
          } catch (e) {
            if (e instanceof SyntaxError) {
              throw e;
            }
            throw new Error(`Failed to load plugin "${plugin}". Please provide a valid path`);
          }
        }
        return plugin;
      };
      const seenPluginIds = /* @__PURE__ */ new Map();
      return plugins.map((p) => {
        if ((0, utils_3.isString)(p) && (0, ref_utils_1.isAbsoluteUrl)(p)) {
          throw new Error(logger_1.colorize.red(`We don't support remote plugins yet.`));
        }
        const pluginModule = requireFunc(p);
        if (!pluginModule) {
          return;
        }
        const id = pluginModule.id;
        if (typeof id !== "string") {
          throw new Error(logger_1.colorize.red(`Plugin must define \`id\` property in ${logger_1.colorize.blue(p.toString())}.`));
        }
        if (seenPluginIds.has(id)) {
          const pluginPath = seenPluginIds.get(id);
          throw new Error(logger_1.colorize.red(`Plugin "id" must be unique. Plugin ${logger_1.colorize.blue(p.toString())} uses id "${logger_1.colorize.blue(id)}" already seen in ${logger_1.colorize.blue(pluginPath)}`));
        }
        seenPluginIds.set(id, p.toString());
        const plugin = Object.assign(Object.assign({ id }, pluginModule.configs ? { configs: pluginModule.configs } : {}), pluginModule.typeExtension ? { typeExtension: pluginModule.typeExtension } : {});
        if (pluginModule.rules) {
          if (!pluginModule.rules.oas3 && !pluginModule.rules.oas2 && !pluginModule.rules.async2) {
            throw new Error(`Plugin rules must have \`oas3\`, \`oas2\` or \`async2\` rules "${p}.`);
          }
          plugin.rules = {};
          if (pluginModule.rules.oas3) {
            plugin.rules.oas3 = (0, utils_2.prefixRules)(pluginModule.rules.oas3, id);
          }
          if (pluginModule.rules.oas2) {
            plugin.rules.oas2 = (0, utils_2.prefixRules)(pluginModule.rules.oas2, id);
          }
          if (pluginModule.rules.async2) {
            plugin.rules.async2 = (0, utils_2.prefixRules)(pluginModule.rules.async2, id);
          }
        }
        if (pluginModule.preprocessors) {
          if (!pluginModule.preprocessors.oas3 && !pluginModule.preprocessors.oas2 && !pluginModule.preprocessors.async2) {
            throw new Error(`Plugin \`preprocessors\` must have \`oas3\`, \`oas2\` or \`async2\` preprocessors "${p}.`);
          }
          plugin.preprocessors = {};
          if (pluginModule.preprocessors.oas3) {
            plugin.preprocessors.oas3 = (0, utils_2.prefixRules)(pluginModule.preprocessors.oas3, id);
          }
          if (pluginModule.preprocessors.oas2) {
            plugin.preprocessors.oas2 = (0, utils_2.prefixRules)(pluginModule.preprocessors.oas2, id);
          }
          if (pluginModule.preprocessors.async2) {
            plugin.preprocessors.async2 = (0, utils_2.prefixRules)(pluginModule.preprocessors.async2, id);
          }
        }
        if (pluginModule.decorators) {
          if (!pluginModule.decorators.oas3 && !pluginModule.decorators.oas2 && !pluginModule.decorators.async2) {
            throw new Error(`Plugin \`decorators\` must have \`oas3\`, \`oas2\` or \`async2\` decorators "${p}.`);
          }
          plugin.decorators = {};
          if (pluginModule.decorators.oas3) {
            plugin.decorators.oas3 = (0, utils_2.prefixRules)(pluginModule.decorators.oas3, id);
          }
          if (pluginModule.decorators.oas2) {
            plugin.decorators.oas2 = (0, utils_2.prefixRules)(pluginModule.decorators.oas2, id);
          }
          if (pluginModule.decorators.async2) {
            plugin.decorators.async2 = (0, utils_2.prefixRules)(pluginModule.decorators.async2, id);
          }
        }
        if (pluginModule.assertions) {
          plugin.assertions = pluginModule.assertions;
        }
        return plugin;
      }).filter(utils_3.isDefined);
    }
    exports2.resolvePlugins = resolvePlugins;
    function resolveApis({ rawConfig, configPath = "", resolver }) {
      var _a, _b;
      return __awaiter(this, void 0, void 0, function* () {
        const { apis = {}, styleguide: styleguideConfig = {} } = rawConfig;
        const resolvedApis = {};
        for (const [apiName, apiContent] of Object.entries(apis || {})) {
          if ((_b = (_a = apiContent.styleguide) === null || _a === void 0 ? void 0 : _a.extends) === null || _b === void 0 ? void 0 : _b.some(utils_3.isNotString)) {
            throw new Error(`Error configuration format not detected in extends value must contain strings`);
          }
          const rawStyleguideConfig = getMergedRawStyleguideConfig(styleguideConfig, apiContent.styleguide);
          const resolvedApiConfig = yield resolveStyleguideConfig({
            styleguideConfig: rawStyleguideConfig,
            configPath,
            resolver
          });
          resolvedApis[apiName] = Object.assign(Object.assign({}, apiContent), { styleguide: resolvedApiConfig });
        }
        return resolvedApis;
      });
    }
    exports2.resolveApis = resolveApis;
    function resolveAndMergeNestedStyleguideConfig({ styleguideConfig, configPath = "", resolver = new resolve_1.BaseResolver() }, parentConfigPaths = [], extendPaths = []) {
      var _a, _b, _c;
      return __awaiter(this, void 0, void 0, function* () {
        if (parentConfigPaths.includes(configPath)) {
          throw new Error(`Circular dependency in config file: "${configPath}"`);
        }
        const plugins = (0, utils_2.getUniquePlugins)(resolvePlugins([...(styleguideConfig === null || styleguideConfig === void 0 ? void 0 : styleguideConfig.plugins) || [], builtIn_1.defaultPlugin], configPath));
        const pluginPaths = (_a = styleguideConfig === null || styleguideConfig === void 0 ? void 0 : styleguideConfig.plugins) === null || _a === void 0 ? void 0 : _a.filter(utils_3.isString).map((p) => path5.resolve(path5.dirname(configPath), p));
        const resolvedConfigPath = (0, ref_utils_1.isAbsoluteUrl)(configPath) ? configPath : configPath && path5.resolve(configPath);
        const extendConfigs = yield Promise.all(((_b = styleguideConfig === null || styleguideConfig === void 0 ? void 0 : styleguideConfig.extends) === null || _b === void 0 ? void 0 : _b.map((presetItem) => __awaiter(this, void 0, void 0, function* () {
          if (!(0, ref_utils_1.isAbsoluteUrl)(presetItem) && !path5.extname(presetItem)) {
            return resolvePreset(presetItem, plugins);
          }
          const pathItem = (0, ref_utils_1.isAbsoluteUrl)(presetItem) ? presetItem : (0, ref_utils_1.isAbsoluteUrl)(configPath) ? new URL(presetItem, configPath).href : path5.resolve(path5.dirname(configPath), presetItem);
          const extendedStyleguideConfig = yield loadExtendStyleguideConfig(pathItem, resolver);
          return yield resolveAndMergeNestedStyleguideConfig({
            styleguideConfig: extendedStyleguideConfig,
            configPath: pathItem,
            resolver
          }, [...parentConfigPaths, resolvedConfigPath], extendPaths);
        }))) || []);
        const _d = (0, utils_2.mergeExtends)([
          ...extendConfigs,
          Object.assign(Object.assign({}, styleguideConfig), { plugins, extends: void 0, extendPaths: [...parentConfigPaths, resolvedConfigPath], pluginPaths })
        ]), { plugins: mergedPlugins = [] } = _d, styleguide = __rest(_d, ["plugins"]);
        return Object.assign(Object.assign({}, styleguide), { extendPaths: (_c = styleguide.extendPaths) === null || _c === void 0 ? void 0 : _c.filter((path6) => path6 && !(0, ref_utils_1.isAbsoluteUrl)(path6)), plugins: (0, utils_2.getUniquePlugins)(mergedPlugins), recommendedFallback: styleguideConfig === null || styleguideConfig === void 0 ? void 0 : styleguideConfig.recommendedFallback, doNotResolveExamples: styleguideConfig === null || styleguideConfig === void 0 ? void 0 : styleguideConfig.doNotResolveExamples });
      });
    }
    function resolveStyleguideConfig(opts, parentConfigPaths = [], extendPaths = []) {
      return __awaiter(this, void 0, void 0, function* () {
        const resolvedStyleguideConfig = yield resolveAndMergeNestedStyleguideConfig(opts, parentConfigPaths, extendPaths);
        return Object.assign(Object.assign({}, resolvedStyleguideConfig), { rules: resolvedStyleguideConfig.rules && groupStyleguideAssertionRules(resolvedStyleguideConfig) });
      });
    }
    exports2.resolveStyleguideConfig = resolveStyleguideConfig;
    function resolvePreset(presetName, plugins) {
      var _a;
      const { pluginId, configName } = (0, utils_2.parsePresetName)(presetName);
      const plugin = plugins.find((p) => p.id === pluginId);
      if (!plugin) {
        throw new Error(`Invalid config ${logger_1.colorize.red(presetName)}: plugin ${pluginId} is not included.`);
      }
      const preset = (_a = plugin.configs) === null || _a === void 0 ? void 0 : _a[configName];
      if (!preset) {
        throw new Error(pluginId ? `Invalid config ${logger_1.colorize.red(presetName)}: plugin ${pluginId} doesn't export config with name ${configName}.` : `Invalid config ${logger_1.colorize.red(presetName)}: there is no such built-in config.`);
      }
      return preset;
    }
    exports2.resolvePreset = resolvePreset;
    function loadExtendStyleguideConfig(filePath, resolver) {
      return __awaiter(this, void 0, void 0, function* () {
        try {
          const fileSource = yield resolver.loadExternalRef(filePath);
          const rawConfig = (0, utils_2.transformConfig)((0, utils_3.parseYaml)(fileSource.body));
          if (!rawConfig.styleguide) {
            throw new Error(`Styleguide configuration format not detected: "${filePath}"`);
          }
          return rawConfig.styleguide;
        } catch (error) {
          throw new Error(`Failed to load "${filePath}": ${error.message}`);
        }
      });
    }
    function getMergedRawStyleguideConfig(rootStyleguideConfig, apiStyleguideConfig) {
      const resultLint = Object.assign(Object.assign(Object.assign({}, rootStyleguideConfig), (0, utils_1.pickDefined)(apiStyleguideConfig)), { rules: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.rules), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.rules), oas2Rules: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.oas2Rules), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.oas2Rules), oas3_0Rules: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.oas3_0Rules), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.oas3_0Rules), oas3_1Rules: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.oas3_1Rules), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.oas3_1Rules), preprocessors: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.preprocessors), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.preprocessors), oas2Preprocessors: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.oas2Preprocessors), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.oas2Preprocessors), oas3_0Preprocessors: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.oas3_0Preprocessors), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.oas3_0Preprocessors), oas3_1Preprocessors: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.oas3_1Preprocessors), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.oas3_1Preprocessors), decorators: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.decorators), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.decorators), oas2Decorators: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.oas2Decorators), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.oas2Decorators), oas3_0Decorators: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.oas3_0Decorators), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.oas3_0Decorators), oas3_1Decorators: Object.assign(Object.assign({}, rootStyleguideConfig === null || rootStyleguideConfig === void 0 ? void 0 : rootStyleguideConfig.oas3_1Decorators), apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.oas3_1Decorators), recommendedFallback: (apiStyleguideConfig === null || apiStyleguideConfig === void 0 ? void 0 : apiStyleguideConfig.extends) ? false : rootStyleguideConfig.recommendedFallback });
      return resultLint;
    }
    function groupStyleguideAssertionRules({ rules, plugins }) {
      if (!rules) {
        return rules;
      }
      const transformedRules = {};
      const assertions = [];
      for (const [ruleKey, rule] of Object.entries(rules)) {
        if ((ruleKey.startsWith("rule/") || ruleKey.startsWith("assert/")) && typeof rule === "object" && rule !== null) {
          const assertion = rule;
          if (plugins) {
            registerCustomAssertions(plugins, assertion);
            for (const context of assertion.where || []) {
              registerCustomAssertions(plugins, context);
            }
          }
          assertions.push(Object.assign(Object.assign({}, assertion), { assertionId: ruleKey }));
        } else {
          transformedRules[ruleKey] = rule;
        }
      }
      if (assertions.length > 0) {
        transformedRules.assertions = assertions;
      }
      return transformedRules;
    }
    function registerCustomAssertions(plugins, assertion) {
      for (const field of (0, utils_3.keysOf)(assertion.assertions)) {
        const [pluginId, fn] = field.split("/");
        if (!pluginId || !fn)
          continue;
        const plugin = plugins.find((plugin2) => plugin2.id === pluginId);
        if (!plugin) {
          throw Error(logger_1.colorize.red(`Plugin ${logger_1.colorize.blue(pluginId)} isn't found.`));
        }
        if (!plugin.assertions || !plugin.assertions[fn]) {
          throw Error(`Plugin ${logger_1.colorize.red(pluginId)} doesn't export assertions function with name ${logger_1.colorize.red(fn)}.`);
        }
        asserts_1.asserts[field] = (0, asserts_1.buildAssertCustomFunction)(plugin.assertions[fn]);
      }
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/load.js
var require_load = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/load.js"(exports2) {
    "use strict";
    var __awaiter = exports2 && exports2.__awaiter || function (thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function (resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.createConfig = exports2.getConfig = exports2.findConfig = exports2.CONFIG_FILE_NAMES = exports2.loadConfig = void 0;
    var fs = require("fs");
    var path5 = require("path");
    var redocly_1 = require_redocly();
    var utils_1 = require_utils3();
    var js_yaml_1 = require_js_yaml2();
    var config_1 = require_config();
    var utils_2 = require_utils4();
    var config_resolvers_1 = require_config_resolvers();
    function addConfigMetadata({ rawConfig, customExtends, configPath, tokens, files, region }) {
      var _a;
      return __awaiter(this, void 0, void 0, function* () {
        if (customExtends !== void 0) {
          rawConfig.styleguide = rawConfig.styleguide || {};
          rawConfig.styleguide.extends = customExtends;
        } else if ((0, utils_1.isEmptyObject)(rawConfig)) {
          rawConfig.styleguide = { extends: ["recommended"], recommendedFallback: true };
        }
        if (tokens === null || tokens === void 0 ? void 0 : tokens.length) {
          if (!rawConfig.resolve)
            rawConfig.resolve = {};
          if (!rawConfig.resolve.http)
            rawConfig.resolve.http = {};
          rawConfig.resolve.http.headers = [...(_a = rawConfig.resolve.http.headers) !== null && _a !== void 0 ? _a : []];
          for (const item of tokens) {
            const domain = config_1.DOMAINS[item.region];
            rawConfig.resolve.http.headers.push(
              {
                matches: `https://api.${domain}/registry/**`,
                name: "Authorization",
                envVariable: void 0,
                value: item.token
              },
              ...item.region === "us" ? [
                {
                  matches: `https://api.redoc.ly/registry/**`,
                  name: "Authorization",
                  envVariable: void 0,
                  value: item.token
                }
              ] : []
            );
          }
        }
        return (0, config_resolvers_1.resolveConfig)(Object.assign(Object.assign({}, rawConfig), { files: files !== null && files !== void 0 ? files : rawConfig.files, region: region !== null && region !== void 0 ? region : rawConfig.region }), configPath);
      });
    }
    function loadConfig(options = {}) {
      return __awaiter(this, void 0, void 0, function* () {
        const { configPath = findConfig(), customExtends, processRawConfig, files, region } = options;
        const rawConfig = yield getConfig(configPath, processRawConfig);
        const redoclyClient = new redocly_1.RedoclyClient();
        const tokens = yield redoclyClient.getTokens();
        return addConfigMetadata({
          rawConfig,
          customExtends,
          configPath,
          tokens,
          files,
          region
        });
      });
    }
    exports2.loadConfig = loadConfig;
    exports2.CONFIG_FILE_NAMES = ["redocly.yaml", "redocly.yml", ".redocly.yaml", ".redocly.yml"];
    function findConfig(dir) {
      if (!fs.hasOwnProperty("existsSync"))
        return;
      const existingConfigFiles = exports2.CONFIG_FILE_NAMES.map((name) => dir ? path5.resolve(dir, name) : name).filter(fs.existsSync);
      if (existingConfigFiles.length > 1) {
        throw new Error(`
      Multiple configuration files are not allowed.
      Found the following files: ${existingConfigFiles.join(", ")}.
      Please use 'redocly.yaml' instead.
    `);
      }
      return existingConfigFiles[0];
    }
    exports2.findConfig = findConfig;
    function getConfig(configPath = findConfig(), processRawConfig) {
      return __awaiter(this, void 0, void 0, function* () {
        if (!configPath || !(0, utils_1.doesYamlFileExist)(configPath))
          return {};
        try {
          const rawConfig = (yield (0, utils_1.loadYaml)(configPath)) || {};
          if (typeof processRawConfig === "function") {
            yield processRawConfig(rawConfig);
          }
          return (0, utils_2.transformConfig)(rawConfig);
        } catch (e) {
          if (e instanceof utils_2.ConfigValidationError) {
            throw e;
          }
          throw new Error(`Error parsing config file at '${configPath}': ${e.message}`);
        }
      });
    }
    exports2.getConfig = getConfig;
    function createConfig(config, options) {
      return __awaiter(this, void 0, void 0, function* () {
        return addConfigMetadata(Object.assign({ rawConfig: (0, utils_2.transformConfig)(typeof config === "string" ? (0, js_yaml_1.parseYaml)(config) : config) }, options));
      });
    }
    exports2.createConfig = createConfig;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/index.js
var require_config2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/config/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function (o, m, k, k2) {
      if (k2 === void 0) k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m, k);
      if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
        desc = {
          enumerable: true, get: function () {
            return m[k];
          }
        };
      }
      Object.defineProperty(o, k2, desc);
    } : function (o, m, k, k2) {
      if (k2 === void 0) k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function (m, exports3) {
      for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p)) __createBinding(exports3, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    __exportStar(require_config(), exports2);
    __exportStar(require_types2(), exports2);
    __exportStar(require_rules(), exports2);
    __exportStar(require_builtIn(), exports2);
    __exportStar(require_load(), exports2);
    __exportStar(require_utils4(), exports2);
    __exportStar(require_config_resolvers(), exports2);
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/portal-config-schema.js
var require_portal_config_schema = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/portal-config-schema.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.rootRedoclyConfigSchema = exports2.environmentSchema = exports2.redoclyConfigSchema = exports2.apiConfigSchema = exports2.ssoConfigSchema = void 0;
    var config_1 = require_config2();
    var oidcIssuerMetadataSchema = {
      type: "object",
      properties: {
        end_session_endpoint: { type: "string" },
        token_endpoint: { type: "string" },
        authorization_endpoint: { type: "string" },
        jwks_uri: { type: "string" }
      },
      required: ["token_endpoint", "authorization_endpoint"],
      additionalProperties: true
    };
    var oidcProviderConfigSchema = {
      type: "object",
      properties: {
        type: { type: "string", const: config_1.AuthProviderType.OIDC },
        title: { type: "string" },
        configurationUrl: { type: "string", minLength: 1 },
        configuration: oidcIssuerMetadataSchema,
        clientId: { type: "string", minLength: 1 },
        clientSecret: { type: "string", minLength: 1 },
        teamsClaimName: { type: "string" },
        teamsClaimMap: { type: "object", additionalProperties: { type: "string" } },
        defaultTeams: { type: "array", items: { type: "string" } },
        scopes: { type: "array", items: { type: "string" } },
        tokenExpirationTime: { type: "number" },
        authorizationRequestCustomParams: { type: "object", additionalProperties: { type: "string" } },
        tokenRequestCustomParams: { type: "object", additionalProperties: { type: "string" } },
        audience: { type: "array", items: { type: "string" } }
      },
      required: ["type", "clientId", "clientSecret"],
      oneOf: [{ required: ["configurationUrl"] }, { required: ["configuration"] }],
      additionalProperties: false
    };
    var saml2ProviderConfigSchema = {
      type: "object",
      properties: {
        type: { type: "string", const: config_1.AuthProviderType.SAML2 },
        title: { type: "string" },
        issuerId: { type: "string" },
        entityId: { type: "string" },
        ssoUrl: { type: "string" },
        x509PublicCert: { type: "string" },
        teamsAttributeName: { type: "string", default: config_1.DEFAULT_TEAM_CLAIM_NAME },
        teamsAttributeMap: { type: "object", additionalProperties: { type: "string" } },
        defaultTeams: { type: "array", items: { type: "string" } }
      },
      additionalProperties: false,
      required: ["type", "issuerId", "ssoUrl", "x509PublicCert"]
    };
    var basicAuthProviderConfigSchema = {
      type: "object",
      properties: {
        type: { type: "string", const: config_1.AuthProviderType.BASIC },
        title: { type: "string" },
        credentials: {
          type: "array",
          items: {
            type: "object",
            properties: {
              username: { type: "string" },
              password: { type: "string" },
              passwordHash: { type: "string" },
              teams: { type: "array", items: { type: "string" } }
            },
            required: ["username"],
            additionalProperties: false
          }
        }
      },
      required: ["type", "credentials"],
      additionalProperties: false
    };
    var authProviderConfigSchema = {
      oneOf: [oidcProviderConfigSchema, saml2ProviderConfigSchema, basicAuthProviderConfigSchema],
      discriminator: { propertyName: "type" }
    };
    exports2.ssoConfigSchema = {
      type: "object",
      additionalProperties: authProviderConfigSchema
    };
    var redirectConfigSchema = {
      type: "object",
      properties: {
        to: { type: "string" },
        type: { type: "number", default: 301 }
      },
      required: ["to"],
      additionalProperties: false
    };
    exports2.apiConfigSchema = {
      type: "object",
      properties: {
        root: { type: "string" },
        rbac: { type: "object", additionalProperties: true },
        theme: {
          type: "object",
          properties: {
            openapi: { type: "object", additionalProperties: true }
          },
          additionalProperties: false
        },
        title: { type: "string" },
        metadata: { type: "object", additionalProperties: true }
      },
      additionalProperties: true,
      required: ["root"]
    };
    var metadataConfigSchema = {
      type: "object",
      additionalProperties: true
    };
    var seoConfigSchema = {
      type: "object",
      properties: {
        title: { type: "string" },
        description: { type: "string" },
        siteUrl: { type: "string" },
        image: { type: "string" },
        keywords: { type: "array", items: { type: "string" } },
        lang: { type: "string" },
        jsonLd: { type: "object" },
        meta: {
          type: "array",
          items: {
            type: "object",
            properties: {
              name: { type: "string" },
              content: { type: "string" }
            },
            required: ["name", "content"],
            additionalProperties: false
          }
        }
      },
      additionalProperties: false
    };
    var rbacScopeItemsSchema = { type: "object", additionalProperties: { type: "string" } };
    var rbacConfigSchema = {
      type: "object",
      properties: {
        defaults: rbacScopeItemsSchema
      },
      additionalProperties: rbacScopeItemsSchema
    };
    var graviteeAdapterConfigSchema = {
      type: "object",
      properties: {
        type: { type: "string", const: "GRAVITEE" },
        apiBaseUrl: { type: "string" },
        env: { type: "string" },
        allowApiProductsOutsideCatalog: { type: "boolean", default: false },
        stage: { type: "string", default: "non-production" },
        auth: { type: "object", properties: { static: { type: "string" } } }
      },
      additionalProperties: false,
      required: ["type", "apiBaseUrl"]
    };
    var apigeeAdapterAuthOauth2Schema = {
      type: "object",
      properties: {
        type: { type: "string", const: config_1.ApigeeDevOnboardingIntegrationAuthType.OAUTH2 },
        tokenEndpoint: { type: "string" },
        clientId: { type: "string" },
        clientSecret: { type: "string" }
      },
      additionalProperties: false,
      required: ["type", "tokenEndpoint", "clientId", "clientSecret"]
    };
    var apigeeAdapterAuthServiceAccountSchema = {
      type: "object",
      properties: {
        type: { type: "string", const: config_1.ApigeeDevOnboardingIntegrationAuthType.SERVICE_ACCOUNT },
        serviceAccountEmail: { type: "string" },
        serviceAccountPrivateKey: { type: "string" }
      },
      additionalProperties: false,
      required: ["type", "serviceAccountEmail", "serviceAccountPrivateKey"]
    };
    var apigeeXAdapterConfigSchema = {
      type: "object",
      properties: {
        type: { type: "string", const: "APIGEE_X" },
        apiUrl: { type: "string" },
        stage: { type: "string", default: "non-production" },
        organizationName: { type: "string" },
        ignoreApiProducts: { type: "array", items: { type: "string" } },
        allowApiProductsOutsideCatalog: { type: "boolean", default: false },
        auth: {
          type: "object",
          oneOf: [apigeeAdapterAuthOauth2Schema, apigeeAdapterAuthServiceAccountSchema],
          discriminator: { propertyName: "type" }
        }
      },
      additionalProperties: false,
      required: ["type", "organizationName", "auth"]
    };
    var apigeeEdgeAdapterConfigSchema = Object.assign(Object.assign({}, apigeeXAdapterConfigSchema), { properties: Object.assign(Object.assign({}, apigeeXAdapterConfigSchema.properties), { type: { type: "string", const: "APIGEE_EDGE" } }) });
    var devOnboardingAdapterConfigSchema = {
      type: "object",
      oneOf: [apigeeXAdapterConfigSchema, apigeeEdgeAdapterConfigSchema, graviteeAdapterConfigSchema],
      discriminator: { propertyName: "type" }
    };
    var devOnboardingConfigSchema = {
      type: "object",
      required: ["adapters"],
      additionalProperties: false,
      properties: {
        adapters: {
          type: "array",
          items: devOnboardingAdapterConfigSchema
        }
      }
    };
    var responseHeaderSchema = {
      type: "object",
      properties: {
        name: { type: "string" },
        value: { type: "string" }
      },
      additionalProperties: false,
      required: ["name", "value"]
    };
    exports2.redoclyConfigSchema = {
      type: "object",
      properties: {
        licenseKey: { type: "string" },
        theme: { type: "object", default: {} },
        redirects: { type: "object", additionalProperties: redirectConfigSchema, default: {} },
        seo: seoConfigSchema,
        rbac: rbacConfigSchema,
        responseHeaders: {
          type: "object",
          additionalProperties: {
            type: "array",
            items: responseHeaderSchema
          }
        },
        mockServer: {
          type: "object",
          properties: {
            off: { type: "boolean", default: false },
            position: { type: "string", enum: ["first", "last", "replace", "off"], default: "first" },
            strictExamples: { type: "boolean", default: false },
            errorIfForcedExampleNotFound: { type: "boolean", default: false },
            description: { type: "string" }
          }
        },
        apis: {
          type: "object",
          additionalProperties: exports2.apiConfigSchema
        },
        sso: exports2.ssoConfigSchema,
        developerOnboarding: devOnboardingConfigSchema,
        i18n: {
          type: "object",
          properties: {
            defaultLocale: {
              type: "string"
            },
            locales: {
              type: "array",
              items: {
                type: "object",
                properties: {
                  code: {
                    type: "string"
                  },
                  name: {
                    type: "string"
                  }
                },
                required: ["code"]
              }
            }
          },
          additionalProperties: false,
          required: ["defaultLocale", "locales"]
        },
        metadata: metadataConfigSchema
      },
      default: {},
      additionalProperties: true
    };
    exports2.environmentSchema = {
      oneOf: [
        Object.assign(Object.assign({}, exports2.redoclyConfigSchema), { additionalProperties: false }),
        {
          type: "object",
          properties: {
            $ref: { type: "string" }
          },
          required: ["$ref"],
          additionalProperties: false
        }
      ]
    };
    exports2.rootRedoclyConfigSchema = Object.assign(Object.assign({}, exports2.redoclyConfigSchema), {
      properties: Object.assign(Object.assign({}, exports2.redoclyConfigSchema.properties), {
        env: {
          type: "object",
          additionalProperties: exports2.environmentSchema
        }
      }), default: {}, required: ["redirects"]
    });
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/theme-config.js
var require_theme_config = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/theme-config.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ScorecardStatus = exports2.productThemeOverrideSchema = exports2.themeConfigSchema = void 0;
    var logoConfigSchema = {
      type: "object",
      properties: {
        image: { type: "string" },
        srcSet: { type: "string" },
        altText: { type: "string" },
        link: { type: "string" },
        favicon: { type: "string" }
      },
      additionalProperties: false
    };
    var hideConfigSchema = {
      type: "object",
      properties: {
        hide: { type: "boolean" }
      },
      additionalProperties: false
    };
    var scriptConfigSchema = {
      type: "object",
      properties: {
        src: { type: "string" },
        async: { type: "boolean" },
        crossorigin: { type: "string" },
        defer: { type: "boolean" },
        fetchpriority: { type: "string" },
        integrity: { type: "string" },
        module: { type: "boolean" },
        nomodule: { type: "boolean" },
        nonce: { type: "string" },
        referrerpolicy: { type: "string" },
        type: { type: "string" }
      },
      required: ["src"],
      additionalProperties: true
    };
    var linksConfigSchema = {
      type: "object",
      properties: {
        href: { type: "string" },
        as: { type: "string" },
        crossorigin: { type: "string" },
        fetchpriority: { type: "string" },
        hreflang: { type: "string" },
        imagesizes: { type: "string" },
        imagesrcset: { type: "string" },
        integrity: { type: "string" },
        media: { type: "string" },
        prefetch: { type: "string" },
        referrerpolicy: { type: "string" },
        rel: { type: "string" },
        sizes: { type: "string" },
        title: { type: "string" },
        type: { type: "string" }
      },
      required: ["href"],
      additionalProperties: true
    };
    var markdownConfigSchema = {
      type: "object",
      properties: {
        frontMatterKeysToResolve: {
          type: "array",
          items: { type: "string" },
          default: ["image", "links"]
        },
        lastUpdatedBlock: {
          type: "object",
          properties: Object.assign({
            format: {
              type: "string",
              enum: ["timeago", "iso", "long", "short"],
              default: "timeago"
            }, locale: { type: "string", default: "en-US" }
          }, hideConfigSchema.properties),
          additionalProperties: false,
          default: {}
        },
        toc: {
          type: "object",
          properties: Object.assign({ header: { type: "string", default: "On this page" }, depth: { type: "integer", default: 3, minimum: 1 } }, hideConfigSchema.properties),
          additionalProperties: false,
          default: {}
        },
        editPage: {
          type: "object",
          properties: Object.assign({ baseUrl: { type: "string" } }, hideConfigSchema.properties),
          additionalProperties: false,
          default: {}
        }
      },
      additionalProperties: false,
      default: {}
    };
    var amplitudeAnalyticsConfigSchema = {
      type: "object",
      properties: {
        includeInDevelopment: { type: "boolean" },
        apiKey: { type: "string" },
        head: { type: "boolean" },
        respectDNT: { type: "boolean" },
        exclude: { type: "array", items: { type: "string" } },
        outboundClickEventName: { type: "string" },
        pageViewEventName: { type: "string" },
        amplitudeConfig: { type: "object", additionalProperties: true }
      },
      additionalProperties: false,
      required: ["apiKey"]
    };
    var fullstoryAnalyticsConfigSchema = {
      type: "object",
      properties: {
        includeInDevelopment: { type: "boolean" },
        orgId: { type: "string" }
      },
      additionalProperties: false,
      required: ["orgId"]
    };
    var heapAnalyticsConfigSchema = {
      type: "object",
      properties: {
        includeInDevelopment: { type: "boolean" },
        appId: { type: "string" }
      },
      additionalProperties: false,
      required: ["appId"]
    };
    var rudderstackAnalyticsConfigSchema = {
      type: "object",
      properties: {
        includeInDevelopment: { type: "boolean" },
        writeKey: { type: "string", minLength: 10 },
        trackPage: { type: "boolean" },
        dataPlaneUrl: { type: "string" },
        controlPlaneUrl: { type: "string" },
        sdkUrl: { type: "string" },
        loadOptions: { type: "object", additionalProperties: true }
      },
      additionalProperties: false,
      required: ["writeKey"]
    };
    var segmentAnalyticsConfigSchema = {
      type: "object",
      properties: {
        includeInDevelopment: { type: "boolean" },
        writeKey: { type: "string", minLength: 10 },
        trackPage: { type: "boolean" },
        includeTitleInPageCall: { type: "boolean" },
        host: { type: "string" }
      },
      additionalProperties: false,
      required: ["writeKey"]
    };
    var gtmAnalyticsConfigSchema = {
      type: "object",
      properties: {
        includeInDevelopment: { type: "boolean" },
        trackingId: { type: "string" },
        gtmAuth: { type: "string" },
        gtmPreview: { type: "string" },
        defaultDataLayer: {},
        dataLayerName: { type: "string" },
        enableWebVitalsTracking: { type: "boolean" },
        selfHostedOrigin: { type: "string" },
        pageViewEventName: { type: "string" }
      },
      additionalProperties: false,
      required: ["trackingId"]
    };
    var googleAnalyticsConfigSchema = {
      type: "object",
      properties: {
        includeInDevelopment: { type: "boolean" },
        trackingId: { type: "string" },
        conversionId: { type: "string" },
        floodlightId: { type: "string" },
        head: { type: "boolean" },
        respectDNT: { type: "boolean" },
        exclude: { type: "array", items: { type: "string" } },
        optimizeId: { type: "string" },
        anonymizeIp: { type: "boolean" },
        cookieExpires: { type: "number" }
      },
      additionalProperties: false,
      required: ["trackingId"]
    };
    var adobeAnalyticsConfigSchema = {
      type: "object",
      properties: {
        includeInDevelopment: { type: "boolean" },
        scriptUrl: { type: "string" },
        pageViewEventName: { type: "string" }
      },
      additionalProperties: false,
      required: ["scriptUrl"]
    };
    var navItemSchema = {
      type: "object",
      properties: {
        page: { type: "string" },
        directory: { type: "string" },
        group: { type: "string" },
        label: { type: "string" },
        separator: { type: "string" },
        separatorLine: { type: "boolean" },
        linePosition: {
          type: "string",
          enum: ["top", "bottom"],
          default: "top"
        },
        version: { type: "string" },
        menuStyle: { type: "string", enum: ["drilldown"] },
        expanded: { type: "string", const: "always" },
        selectFirstItemOnExpand: { type: "boolean" },
        flatten: { type: "boolean" },
        linkedSidebars: {
          type: "array",
          items: { type: "string" }
        }
      }
    };
    var navItemsSchema = {
      type: "array",
      items: Object.assign(Object.assign({}, navItemSchema), { properties: Object.assign(Object.assign({}, navItemSchema.properties), { items: { type: "array", items: navItemSchema } }) })
    };
    var productConfigSchema = {
      type: "object",
      properties: {
        name: { type: "string" },
        icon: { type: "string" },
        folder: { type: "string" }
      },
      additionalProperties: false,
      required: ["name", "icon", "folder"]
    };
    var suggestedPageSchema = {
      type: "object",
      properties: {
        page: { type: "string" },
        label: { type: "string" },
        labelTranslationKey: { type: "string" }
      },
      required: ["page"]
    };
    var catalogFilterSchema = {
      type: "object",
      additionalProperties: false,
      required: ["title", "property"],
      properties: {
        type: { type: "string", enum: ["select", "checkboxes", "date-range"] },
        title: { type: "string" },
        titleTranslationKey: { type: "string" },
        property: { type: "string" },
        parentFilter: { type: "string" },
        missingCategoryName: { type: "string" },
        missingCategoryNameTranslationKey: { type: "string" },
        options: { type: "array", items: { type: "string" } }
      }
    };
    var scorecardConfigSchema = {
      type: "object",
      additionalProperties: true,
      required: ["levels"],
      properties: {
        failBuildIfBelowMinimum: { type: "boolean", default: false },
        teamMetadataProperty: {
          type: "object",
          properties: {
            property: { type: "string" },
            label: { type: "string" },
            default: { type: "string" }
          }
        },
        levels: {
          type: "array",
          items: {
            type: "object",
            required: ["name"],
            properties: {
              name: { type: "string" },
              extends: { type: "array", items: { type: "string" } },
              rules: {
                type: "object",
                additionalProperties: {
                  type: ["object", "string"]
                }
              }
            },
            additionalProperties: false
          }
        },
        targets: {
          type: "array",
          items: {
            type: "object",
            required: ["where"],
            properties: {
              minimumLevel: { type: "string" },
              where: {
                type: "object",
                required: ["metadata"],
                properties: {
                  metadata: { type: "object", additionalProperties: { type: "string" } }
                },
                additionalProperties: false
              }
            },
            additionalProperties: false
          }
        }
      }
    };
    var catalogSchema = {
      type: "object",
      additionalProperties: true,
      required: ["slug", "items"],
      properties: {
        slug: { type: "string" },
        filters: { type: "array", items: catalogFilterSchema },
        groupByFirstFilter: { type: "boolean" },
        filterValuesCasing: {
          type: "string",
          enum: ["sentence", "original", "lowercase", "uppercase"]
        },
        items: navItemsSchema,
        requiredPermission: { type: "string" },
        separateVersions: { type: "boolean" },
        title: { type: "string" },
        titleTranslationKey: { type: "string" },
        description: { type: "string" },
        descriptionTranslationKey: { type: "string" }
      }
    };
    var catalogsConfigSchema = {
      type: "object",
      patternProperties: {
        ".*": catalogSchema
      }
    };
    exports2.themeConfigSchema = {
      type: "object",
      properties: {
        imports: {
          type: "array",
          items: { type: "string" },
          default: []
        },
        logo: logoConfigSchema,
        navbar: {
          type: "object",
          properties: Object.assign({ items: navItemsSchema }, hideConfigSchema.properties),
          additionalProperties: false
        },
        products: {
          type: "object",
          additionalProperties: productConfigSchema
        },
        footer: {
          type: "object",
          properties: Object.assign({ items: navItemsSchema, copyrightText: { type: "string" }, logo: hideConfigSchema }, hideConfigSchema.properties),
          additionalProperties: false
        },
        sidebar: {
          type: "object",
          properties: Object.assign({
            separatorLine: { type: "boolean" }, linePosition: {
              type: "string",
              enum: ["top", "bottom"],
              default: "bottom"
            }
          }, hideConfigSchema.properties),
          additionalProperties: false
        },
        seo: {
          type: "object",
          properties: {
            title: { type: "string" }
          }
        },
        scripts: {
          type: "object",
          properties: {
            head: { type: "array", items: scriptConfigSchema },
            body: { type: "array", items: scriptConfigSchema }
          },
          additionalProperties: false
        },
        links: { type: "array", items: linksConfigSchema },
        feedback: {
          type: "object",
          properties: {
            hide: {
              type: "boolean",
              default: false
            },
            type: {
              type: "string",
              enum: ["rating", "sentiment", "comment", "reasons"],
              default: "sentiment"
            },
            settings: Object.assign({
              type: "object", properties: {
                label: { type: "string" },
                submitText: { type: "string" },
                max: { type: "number" },
                buttonText: { type: "string" },
                multi: { type: "boolean" },
                items: { type: "array", items: { type: "string" }, minItems: 1 },
                reasons: {
                  type: "object",
                  properties: {
                    enable: { type: "boolean", default: true },
                    multi: { type: "boolean" },
                    label: { type: "string" },
                    items: { type: "array", items: { type: "string" } }
                  },
                  additionalProperties: false
                },
                comment: {
                  type: "object",
                  properties: {
                    enable: { type: "boolean", default: true },
                    label: { type: "string" },
                    likeLabel: { type: "string" },
                    dislikeLabel: { type: "string" }
                  },
                  additionalProperties: false
                }
              }, additionalProperties: false
            }, hideConfigSchema.properties)
          },
          additionalProperties: false,
          default: {}
        },
        search: {
          type: "object",
          properties: Object.assign({
            placement: {
              type: "string",
              default: "navbar"
            }, shortcuts: {
              type: "array",
              items: { type: "string" },
              default: ["/"]
            }, suggestedPages: {
              type: "array",
              items: suggestedPageSchema
            }
          }, hideConfigSchema.properties),
          additionalProperties: false,
          default: {}
        },
        colorMode: {
          type: "object",
          properties: Object.assign({
            ignoreDetection: { type: "boolean" }, modes: {
              type: "array",
              items: { type: "string" },
              default: ["light", "dark"]
            }
          }, hideConfigSchema.properties),
          additionalProperties: false,
          default: {}
        },
        navigation: {
          type: "object",
          properties: {
            nextButton: {
              type: "object",
              properties: Object.assign({ text: { type: "string", default: "Next to {label}" } }, hideConfigSchema.properties),
              additionalProperties: false,
              default: {}
            },
            previousButton: {
              type: "object",
              properties: Object.assign({ text: { type: "string", default: "Back to {label}" } }, hideConfigSchema.properties),
              additionalProperties: false,
              default: {}
            }
          },
          additionalProperties: false,
          default: {}
        },
        codeSnippet: {
          type: "object",
          properties: {
            controlsStyle: { type: "string", default: "icon" },
            copy: {
              type: "object",
              properties: Object.assign({}, hideConfigSchema.properties),
              additionalProperties: false,
              default: { hide: false }
            },
            report: {
              type: "object",
              properties: Object.assign({}, hideConfigSchema.properties),
              additionalProperties: false,
              default: { hide: true }
            },
            expand: {
              type: "object",
              properties: Object.assign({}, hideConfigSchema.properties),
              additionalProperties: false,
              default: { hide: false }
            },
            collapse: {
              type: "object",
              properties: Object.assign({}, hideConfigSchema.properties),
              additionalProperties: false,
              default: { hide: false }
            }
          },
          additionalProperties: false,
          default: {}
        },
        markdown: markdownConfigSchema,
        openapi: { type: "object", additionalProperties: true },
        graphql: { type: "object", additionalProperties: true },
        analytics: {
          type: "object",
          properties: {
            adobe: adobeAnalyticsConfigSchema,
            amplitude: amplitudeAnalyticsConfigSchema,
            fullstory: fullstoryAnalyticsConfigSchema,
            heap: heapAnalyticsConfigSchema,
            rudderstack: rudderstackAnalyticsConfigSchema,
            segment: segmentAnalyticsConfigSchema,
            gtm: gtmAnalyticsConfigSchema,
            ga: googleAnalyticsConfigSchema
          }
        },
        userProfile: {
          type: "object",
          properties: Object.assign({
            loginLabel: { type: "string", default: "Login" }, logoutLabel: { type: "string", default: "Logout" }, menu: {
              type: "array",
              items: {
                type: "object",
                properties: {
                  label: { type: "string" },
                  external: { type: "boolean" },
                  link: { type: "string" },
                  separatorLine: { type: "boolean" }
                },
                additionalProperties: true
              },
              default: []
            }
          }, hideConfigSchema.properties),
          additionalProperties: false,
          default: {}
        },
        versionPicker: {
          type: "object",
          properties: {
            hide: { type: "boolean" },
            showForUnversioned: {
              type: "boolean"
            }
          }
        },
        breadcrumbs: {
          type: "object",
          properties: {
            hide: { type: "boolean" },
            prefixItems: {
              type: "array",
              items: {
                type: "object",
                properties: {
                  label: { type: "string" },
                  labelTranslationKey: { type: "string" },
                  page: { type: "string" }
                },
                additionalProperties: false,
                default: {}
              }
            }
          },
          additionalProperties: false,
          default: {}
        },
        catalog: catalogsConfigSchema,
        scorecard: scorecardConfigSchema
      },
      additionalProperties: true,
      default: {}
    };
    exports2.productThemeOverrideSchema = {
      type: "object",
      properties: {
        logo: exports2.themeConfigSchema.properties.logo,
        navbar: exports2.themeConfigSchema.properties.navbar,
        footer: exports2.themeConfigSchema.properties.footer,
        sidebar: exports2.themeConfigSchema.properties.sidebar,
        search: exports2.themeConfigSchema.properties.search,
        codeSnippet: exports2.themeConfigSchema.properties.codeSnippet,
        breadcrumbs: exports2.themeConfigSchema.properties.breadcrumbs
      },
      additionalProperties: true,
      default: {}
    };
    var ScorecardStatus;
    (function (ScorecardStatus2) {
      ScorecardStatus2["BelowMinimum"] = "Below minimum";
      ScorecardStatus2["Highest"] = "Highest";
      ScorecardStatus2["Minimum"] = "Minimum";
    })(ScorecardStatus || (exports2.ScorecardStatus = ScorecardStatus = {}));
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/redocly-yaml.js
var require_redocly_yaml = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/types/redocly-yaml.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ConfigTypes = void 0;
    var portal_config_schema_1 = require_portal_config_schema();
    var theme_config_1 = require_theme_config();
    var _1 = require_types();
    var oas3_1_1 = require_oas3_1();
    var utils_1 = require_utils3();
    var builtInCommonRules = [
      "spec",
      "info-contact",
      "operation-operationId",
      "tag-description",
      "tags-alphabetical"
    ];
    var builtInCommonOASRules = [
      "info-license-url",
      "info-license",
      "no-ambiguous-paths",
      "no-enum-type-mismatch",
      "no-http-verbs-in-paths",
      "no-identical-paths",
      "no-invalid-parameter-examples",
      "no-invalid-schema-examples",
      "no-path-trailing-slash",
      "operation-2xx-response",
      "operation-4xx-response",
      "operation-description",
      "operation-operationId-unique",
      "operation-operationId-url-safe",
      "operation-parameters-unique",
      "operation-singular-tag",
      "operation-summary",
      "operation-tag-defined",
      "parameter-description",
      "path-declaration-must-exist",
      "path-excludes-patterns",
      "path-http-verbs-order",
      "path-not-include-query",
      "path-params-defined",
      "path-parameters-defined",
      "path-segment-plural",
      "paths-kebab-case",
      "required-string-property-missing-min-length",
      "response-contains-header",
      "scalar-property-missing-example",
      "security-defined",
      "spec-strict-refs",
      "no-unresolved-refs"
    ];
    var builtInOAS2Rules = [
      "boolean-parameter-prefixes",
      "request-mime-type",
      "response-contains-property",
      "response-mime-type"
    ];
    var builtInOAS3Rules = [
      "boolean-parameter-prefixes",
      "component-name-unique",
      "no-empty-servers",
      "no-example-value-and-externalValue",
      "no-invalid-media-type-examples",
      "no-server-example.com",
      "no-server-trailing-slash",
      "no-server-variables-empty-enum",
      "no-undefined-server-variable",
      "no-unused-components",
      "operation-4xx-problem-details-rfc7807",
      "request-mime-type",
      "response-contains-property",
      "response-mime-type",
      "spec-components-invalid-map-name"
    ];
    var builtInAsync2Rules = ["channels-kebab-case", "no-channel-trailing-slash"];
    var builtInRules = [
      ...builtInCommonRules,
      ...builtInCommonOASRules,
      ...builtInOAS2Rules,
      ...builtInOAS3Rules,
      ...builtInAsync2Rules
    ];
    var nodeTypesList = [
      "any",
      "Root",
      "Tag",
      "TagList",
      "ExternalDocs",
      "Server",
      "ServerList",
      "ServerVariable",
      "ServerVariablesMap",
      "SecurityRequirement",
      "SecurityRequirementList",
      "Info",
      "Contact",
      "License",
      "Paths",
      "PathItem",
      "Parameter",
      "ParameterList",
      "Operation",
      "Callback",
      "CallbacksMap",
      "RequestBody",
      "MediaTypesMap",
      "MediaType",
      "Example",
      "ExamplesMap",
      "Encoding",
      "EncodingMap",
      "Header",
      "HeadersMap",
      "Responses",
      "Response",
      "Link",
      "LinksMap",
      "Schema",
      "Xml",
      "SchemaProperties",
      "DiscriminatorMapping",
      "Discriminator",
      "Components",
      "NamedSchemas",
      "NamedResponses",
      "NamedParameters",
      "NamedExamples",
      "NamedRequestBodies",
      "NamedHeaders",
      "NamedSecuritySchemes",
      "NamedLinks",
      "NamedCallbacks",
      "ImplicitFlow",
      "PasswordFlow",
      "ClientCredentials",
      "AuthorizationCode",
      "OAuth2Flows",
      "SecurityScheme",
      "XCodeSample",
      "XCodeSampleList",
      "WebhooksMap",
      "SpecExtension",
      "Message"
    ];
    var ConfigStyleguide = {
      properties: {
        extends: {
          type: "array",
          items: {
            type: "string"
          }
        },
        rules: "Rules",
        oas2Rules: "Rules",
        oas3_0Rules: "Rules",
        oas3_1Rules: "Rules",
        async2Rules: "Rules",
        preprocessors: { type: "object" },
        oas2Preprocessors: { type: "object" },
        oas3_0Preprocessors: { type: "object" },
        oas3_1Preprocessors: { type: "object" },
        async2Preprocessors: { type: "object" },
        decorators: { type: "object" },
        oas2Decorators: { type: "object" },
        oas3_0Decorators: { type: "object" },
        oas3_1Decorators: { type: "object" },
        async2Decorators: { type: "object" }
      }
    };
    var RootConfigStyleguide = {
      properties: Object.assign({
        plugins: {
          type: "array",
          items: { type: "string" }
        }
      }, ConfigStyleguide.properties)
    };
    var ConfigRoot = {
      properties: Object.assign(Object.assign(Object.assign({}, portal_config_schema_1.rootRedoclyConfigSchema.properties), RootConfigStyleguide.properties), {
        apis: "ConfigApis", theme: "ConfigRootTheme", "features.openapi": "ConfigReferenceDocs", "features.mockServer": "ConfigMockServer", organization: { type: "string" }, region: { enum: ["us", "eu"] }, telemetry: { enum: ["on", "off"] }, resolve: {
          properties: {
            http: "ConfigHTTP",
            doNotResolveExamples: { type: "boolean" }
          }
        }, files: {
          type: "array",
          items: {
            type: "string"
          }
        }
      })
    };
    var ConfigApis = {
      properties: {},
      additionalProperties: "ConfigApisProperties"
    };
    var ConfigApisProperties = {
      properties: Object.assign(Object.assign(Object.assign(Object.assign({}, portal_config_schema_1.apiConfigSchema.properties), {
        root: { type: "string" }, labels: {
          type: "array",
          items: {
            type: "string"
          }
        }, lint: "ConfigStyleguide", styleguide: "ConfigStyleguide"
      }), ConfigStyleguide.properties), {
        "features.openapi": "ConfigReferenceDocs", "features.mockServer": "ConfigMockServer", theme: "ConfigRootTheme", files: {
          type: "array",
          items: {
            type: "string"
          }
        }
      }),
      required: ["root"]
    };
    var ConfigHTTP = {
      properties: {
        headers: {
          type: "array",
          items: {
            type: "string"
          }
        }
      }
    };
    var ConfigRootTheme = {
      properties: Object.assign(Object.assign({}, theme_config_1.themeConfigSchema.properties), { openapi: "ConfigReferenceDocs", mockServer: "ConfigMockServer" })
    };
    var Rules = {
      properties: {},
      additionalProperties: (value, key) => {
        if (key.startsWith("rule/")) {
          return "Assert";
        } else if (key.startsWith("assert/")) {
          return "Assert";
        } else if (builtInRules.includes(key) || (0, utils_1.isCustomRuleId)(key)) {
          if (typeof value === "string") {
            return { enum: ["error", "warn", "off"] };
          } else {
            return "ObjectRule";
          }
        } else if (key === "metadata-schema" || key === "custom-fields-schema") {
          return "Schema";
        }
        return;
      }
    };
    var ObjectRule = {
      properties: {
        severity: { enum: ["error", "warn", "off"] }
      },
      additionalProperties: {},
      required: ["severity"]
    };
    var AssertionDefinitionSubject = {
      properties: {
        type: { enum: nodeTypesList },
        property: (value) => {
          if (Array.isArray(value)) {
            return { type: "array", items: { type: "string" } };
          } else if (value === null) {
            return null;
          } else {
            return { type: "string" };
          }
        },
        filterInParentKeys: { type: "array", items: { type: "string" } },
        filterOutParentKeys: { type: "array", items: { type: "string" } },
        matchParentKeys: { type: "string" }
      },
      required: ["type"]
    };
    var AssertionDefinitionAssertions = {
      properties: {
        enum: { type: "array", items: { type: "string" } },
        pattern: { type: "string" },
        notPattern: { type: "string" },
        casing: {
          enum: [
            "camelCase",
            "kebab-case",
            "snake_case",
            "PascalCase",
            "MACRO_CASE",
            "COBOL-CASE",
            "flatcase"
          ]
        },
        mutuallyExclusive: { type: "array", items: { type: "string" } },
        mutuallyRequired: { type: "array", items: { type: "string" } },
        required: { type: "array", items: { type: "string" } },
        requireAny: { type: "array", items: { type: "string" } },
        disallowed: { type: "array", items: { type: "string" } },
        defined: { type: "boolean" },
        // undefined: { type: 'boolean' }, // TODO: Remove `undefined` assertion from codebase overall
        nonEmpty: { type: "boolean" },
        minLength: { type: "integer" },
        maxLength: { type: "integer" },
        ref: (value) => typeof value === "string" ? { type: "string" } : { type: "boolean" },
        const: (value) => {
          if (typeof value === "string") {
            return { type: "string" };
          }
          if (typeof value === "number") {
            return { type: "number" };
          }
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return;
          }
        }
      },
      additionalProperties: (_value, key) => {
        if (/^\w+\/\w+$/.test(key))
          return { type: "object" };
        return;
      }
    };
    var AssertDefinition = {
      properties: {
        subject: "AssertionDefinitionSubject",
        assertions: "AssertionDefinitionAssertions"
      },
      required: ["subject", "assertions"]
    };
    var Assert = {
      properties: {
        subject: "AssertionDefinitionSubject",
        assertions: "AssertionDefinitionAssertions",
        where: (0, _1.listOf)("AssertDefinition"),
        message: { type: "string" },
        suggest: { type: "array", items: { type: "string" } },
        severity: { enum: ["error", "warn", "off"] }
      },
      required: ["subject", "assertions"]
    };
    var ConfigLanguage = {
      properties: {
        label: { type: "string" },
        lang: {
          enum: [
            "curl",
            "C#",
            "Go",
            "Java",
            "Java8+Apache",
            "JavaScript",
            "Node.js",
            "PHP",
            "Python",
            "R",
            "Ruby"
          ]
        }
      },
      required: ["lang"]
    };
    var ConfigLabels = {
      properties: {
        enum: { type: "string" },
        enumSingleValue: { type: "string" },
        enumArray: { type: "string" },
        default: { type: "string" },
        deprecated: { type: "string" },
        example: { type: "string" },
        examples: { type: "string" },
        nullable: { type: "string" },
        recursive: { type: "string" },
        arrayOf: { type: "string" },
        webhook: { type: "string" },
        authorizations: { type: "string" },
        tryItAuthBasicUsername: { type: "string" },
        tryItAuthBasicPassword: { type: "string" }
      }
    };
    var ConfigSidebarLinks = {
      properties: {
        beforeInfo: (0, _1.listOf)("CommonConfigSidebarLinks"),
        end: (0, _1.listOf)("CommonConfigSidebarLinks")
      }
    };
    var CommonConfigSidebarLinks = {
      properties: {
        label: { type: "string" },
        link: { type: "string" },
        target: { type: "string" }
      },
      required: ["label", "link"]
    };
    var CommonThemeColors = {
      properties: {
        main: { type: "string" },
        light: { type: "string" },
        dark: { type: "string" },
        contrastText: { type: "string" }
      }
    };
    var CommonColorProps = {
      properties: {
        backgroundColor: { type: "string" },
        borderColor: { type: "string" },
        color: { type: "string" },
        tabTextColor: { type: "string" }
      }
    };
    var BorderThemeColors = {
      properties: (0, utils_1.pickObjectProps)(CommonThemeColors.properties, ["light", "dark"])
    };
    var HttpColors = {
      properties: {
        basic: { type: "string" },
        delete: { type: "string" },
        get: { type: "string" },
        head: { type: "string" },
        link: { type: "string" },
        options: { type: "string" },
        patch: { type: "string" },
        post: { type: "string" },
        put: { type: "string" }
      }
    };
    var ResponseColors = {
      properties: {
        error: "CommonColorProps",
        info: "CommonColorProps",
        redirect: "CommonColorProps",
        success: "CommonColorProps"
      }
    };
    var SecondaryColors = {
      properties: (0, utils_1.omitObjectProps)(CommonThemeColors.properties, ["dark"])
    };
    var TextThemeColors = {
      properties: {
        primary: { type: "string" },
        secondary: { type: "string" },
        light: { type: "string" }
      }
    };
    var ThemeColors = {
      properties: {
        accent: "CommonThemeColors",
        border: "BorderThemeColors",
        error: "CommonThemeColors",
        http: "HttpColors",
        primary: "CommonThemeColors",
        responses: "ResponseColors",
        secondary: "SecondaryColors",
        success: "CommonThemeColors",
        text: "TextThemeColors",
        tonalOffset: { type: "number" },
        warning: "CommonThemeColors"
      }
    };
    var SizeProps = {
      properties: {
        fontSize: { type: "string" },
        padding: { type: "string" },
        minWidth: { type: "string" }
      }
    };
    var Sizes = {
      properties: {
        small: "SizeProps",
        medium: "SizeProps",
        large: "SizeProps",
        xlarge: "SizeProps"
      }
    };
    var FontConfig = {
      properties: {
        fontFamily: { type: "string" },
        fontSize: { type: "string" },
        fontWeight: { type: "string" },
        lineHeight: { type: "string" }
      }
    };
    var ButtonsConfig = {
      properties: Object.assign(Object.assign({}, (0, utils_1.omitObjectProps)(FontConfig.properties, ["fontSize", "lineHeight"])), { borderRadius: { type: "string" }, hoverStyle: { type: "string" }, boxShadow: { type: "string" }, hoverBoxShadow: { type: "string" }, sizes: "Sizes" })
    };
    var BadgeFontConfig = {
      properties: (0, utils_1.pickObjectProps)(FontConfig.properties, ["fontSize", "lineHeight"])
    };
    var BadgeSizes = {
      properties: {
        medium: "BadgeFontConfig",
        small: "BadgeFontConfig"
      }
    };
    var HttpBadgesConfig = {
      properties: Object.assign(Object.assign({}, (0, utils_1.omitObjectProps)(FontConfig.properties, ["fontSize", "lineHeight"])), { borderRadius: { type: "string" }, color: { type: "string" }, sizes: "BadgeSizes" })
    };
    var LabelControls = {
      properties: {
        top: { type: "string" },
        width: { type: "string" },
        height: { type: "string" }
      }
    };
    var Panels = {
      properties: {
        borderRadius: { type: "string" },
        backgroundColor: { type: "string" }
      }
    };
    var TryItButton = {
      properties: {
        fullWidth: { type: "boolean" }
      }
    };
    var ConfigThemeComponents = {
      properties: {
        buttons: "ButtonsConfig",
        httpBadges: "HttpBadgesConfig",
        layoutControls: "LabelControls",
        panels: "Panels",
        tryItButton: "TryItButton",
        tryItSendButton: "TryItButton"
      }
    };
    var Breakpoints = {
      properties: {
        small: { type: "string" },
        medium: { type: "string" },
        large: { type: "string" }
      }
    };
    var StackedConfig = {
      properties: {
        maxWidth: "Breakpoints"
      }
    };
    var ThreePanelConfig = {
      properties: {
        maxWidth: "Breakpoints",
        middlePanelMaxWidth: "Breakpoints"
      }
    };
    var Layout = {
      properties: {
        showDarkRightPanel: { type: "boolean" },
        stacked: "StackedConfig",
        "three-panel": "ThreePanelConfig"
      }
    };
    var SchemaColorsConfig = {
      properties: {
        backgroundColor: { type: "string" },
        border: { type: "string" }
      }
    };
    var ConfigThemeSchema = {
      properties: {
        breakFieldNames: { type: "boolean" },
        caretColor: { type: "string" },
        caretSize: { type: "string" },
        constraints: "SchemaColorsConfig",
        defaultDetailsWidth: { type: "string" },
        examples: "SchemaColorsConfig",
        labelsTextSize: { type: "string" },
        linesColor: { type: "string" },
        nestedBackground: { type: "string" },
        nestingSpacing: { type: "string" },
        requireLabelColor: { type: "string" },
        typeNameColor: { type: "string" },
        typeTitleColor: { type: "string" }
      }
    };
    var GroupItemsConfig = {
      properties: {
        subItemsColor: { type: "string" },
        textTransform: { type: "string" },
        fontWeight: { type: "string" }
      }
    };
    var Level1Items = {
      properties: (0, utils_1.pickObjectProps)(GroupItemsConfig.properties, ["textTransform"])
    };
    var SpacingConfig = {
      properties: {
        unit: { type: "number" },
        paddingHorizontal: { type: "string" },
        paddingVertical: { type: "string" },
        offsetTop: { type: "string" },
        offsetLeft: { type: "string" },
        offsetNesting: { type: "string" }
      }
    };
    var Sidebar = {
      properties: Object.assign(Object.assign({}, (0, utils_1.omitObjectProps)(FontConfig.properties, ["fontWeight", "lineHeight"])), { activeBgColor: { type: "string" }, activeTextColor: { type: "string" }, backgroundColor: { type: "string" }, borderRadius: { type: "string" }, breakPath: { type: "boolean" }, caretColor: { type: "string" }, caretSize: { type: "string" }, groupItems: "GroupItemsConfig", level1items: "Level1Items", rightLineColor: { type: "string" }, separatorLabelColor: { type: "string" }, showAtBreakpoint: { type: "string" }, spacing: "SpacingConfig", textColor: { type: "string" }, width: { type: "string" } })
    };
    var Heading = {
      properties: Object.assign(Object.assign({}, FontConfig.properties), { color: { type: "string" }, transform: { type: "string" } })
    };
    var CodeConfig = {
      properties: Object.assign(Object.assign({}, FontConfig.properties), {
        backgroundColor: { type: "string" }, color: { type: "string" }, wordBreak: {
          enum: [
            "break-all",
            "break-word",
            "keep-all",
            "normal",
            "revert",
            "unset",
            "inherit",
            "initial"
          ]
        }, wrap: { type: "boolean" }
      })
    };
    var HeadingsConfig = {
      properties: (0, utils_1.omitObjectProps)(FontConfig.properties, ["fontSize"])
    };
    var LinksConfig = {
      properties: {
        color: { type: "string" },
        hover: { type: "string" },
        textDecoration: { type: "string" },
        hoverTextDecoration: { type: "string" },
        visited: { type: "string" }
      }
    };
    var Typography = {
      properties: Object.assign(Object.assign({ code: "CodeConfig", fieldName: "FontConfig" }, (0, utils_1.pickObjectProps)(FontConfig.properties, ["fontSize", "fontFamily"])), { fontWeightBold: { type: "string" }, fontWeightLight: { type: "string" }, fontWeightRegular: { type: "string" }, heading1: "Heading", heading2: "Heading", heading3: "Heading", headings: "HeadingsConfig", lineHeight: { type: "string" }, links: "LinksConfig", optimizeSpeed: { type: "boolean" }, rightPanelHeading: "Heading", smoothing: { enum: ["auto", "none", "antialiased", "subpixel-antialiased", "grayscale"] } })
    };
    var TokenProps = {
      properties: Object.assign({ color: { type: "string" } }, (0, utils_1.omitObjectProps)(FontConfig.properties, ["fontWeight"]))
    };
    var CodeBlock = {
      properties: {
        backgroundColor: { type: "string" },
        borderRadius: { type: "string" },
        tokens: "TokenProps"
      }
    };
    var ConfigThemeLogo = {
      properties: {
        gutter: { type: "string" },
        maxHeight: { type: "string" },
        maxWidth: { type: "string" }
      }
    };
    var Fab = {
      properties: {
        backgroundColor: { type: "string" },
        color: { type: "string" }
      }
    };
    var ButtonOverrides = {
      properties: {
        custom: { type: "string" }
      }
    };
    var Overrides = {
      properties: {
        DownloadButton: "ButtonOverrides",
        NextSectionButton: "ButtonOverrides"
      }
    };
    var RightPanel = {
      properties: {
        backgroundColor: { type: "string" },
        panelBackgroundColor: { type: "string" },
        panelControlsBackgroundColor: { type: "string" },
        showAtBreakpoint: { type: "string" },
        textColor: { type: "string" },
        width: { type: "string" }
      }
    };
    var Shape = {
      properties: { borderRadius: { type: "string" } }
    };
    var ThemeSpacing = {
      properties: {
        sectionHorizontal: { type: "number" },
        sectionVertical: { type: "number" },
        unit: { type: "number" }
      }
    };
    var ConfigTheme = {
      properties: {
        breakpoints: "Breakpoints",
        codeBlock: "CodeBlock",
        colors: "ThemeColors",
        components: "ConfigThemeComponents",
        layout: "Layout",
        logo: "ConfigThemeLogo",
        fab: "Fab",
        overrides: "Overrides",
        rightPanel: "RightPanel",
        schema: "ConfigThemeSchema",
        shape: "Shape",
        sidebar: "Sidebar",
        spacing: "ThemeSpacing",
        typography: "Typography",
        links: { properties: { color: { type: "string" } } },
        codeSample: { properties: { backgroundColor: { type: "string" } } }
        // deprecated
      }
    };
    var GenerateCodeSamples = {
      properties: {
        skipOptionalParameters: { type: "boolean" },
        languages: (0, _1.listOf)("ConfigLanguage")
      },
      required: ["languages"]
    };
    var ConfigReferenceDocs = {
      properties: {
        theme: "ConfigTheme",
        corsProxyUrl: { type: "string" },
        ctrlFHijack: { type: "boolean" },
        defaultSampleLanguage: { type: "string" },
        disableDeepLinks: { type: "boolean" },
        disableSearch: { type: "boolean" },
        disableSidebar: { type: "boolean" },
        downloadDefinitionUrl: { type: "string" },
        expandDefaultServerVariables: { type: "boolean" },
        enumSkipQuotes: { type: "boolean" },
        expandDefaultRequest: { type: "boolean" },
        expandDefaultResponse: { type: "boolean" },
        expandResponses: { type: "string" },
        expandSingleSchemaField: { type: "boolean" },
        generateCodeSamples: "GenerateCodeSamples",
        generatedPayloadSamplesMaxDepth: { type: "number" },
        hideDownloadButton: { type: "boolean" },
        hideHostname: { type: "boolean" },
        hideInfoSection: { type: "boolean" },
        hideLoading: { type: "boolean" },
        hideLogo: { type: "boolean" },
        hideRequestPayloadSample: { type: "boolean" },
        hideRightPanel: { type: "boolean" },
        hideSchemaPattern: { type: "boolean" },
        hideSchemaTitles: { type: "boolean" },
        hideSingleRequestSampleTab: { type: "boolean" },
        hideSecuritySection: { type: "boolean" },
        hideTryItPanel: { type: "boolean" },
        hideFab: { type: "boolean" },
        hideOneOfDescription: { type: "boolean" },
        htmlTemplate: { type: "string" },
        jsonSampleExpandLevel: (value) => {
          if (typeof value === "number") {
            return { type: "number", minimum: 1 };
          } else {
            return { type: "string" };
          }
        },
        labels: "ConfigLabels",
        layout: { enum: ["stacked", "three-panel"] },
        maxDisplayedEnumValues: { type: "number" },
        menuToggle: { type: "boolean" },
        nativeScrollbars: { type: "boolean" },
        noAutoAuth: { type: "boolean" },
        oAuth2RedirectURI: { type: "string" },
        onDeepLinkClick: { type: "object" },
        onlyRequiredInSamples: { type: "boolean" },
        pagination: { enum: ["none", "section", "item"] },
        pathInMiddlePanel: { type: "boolean" },
        payloadSampleIdx: { type: "number", minimum: 0 },
        requestInterceptor: { type: "object" },
        requiredPropsFirst: { type: "boolean" },
        routingBasePath: { type: "string" },
        routingStrategy: { type: "string" },
        samplesTabsMaxCount: { type: "number" },
        schemaExpansionLevel: (value) => {
          if (typeof value === "number") {
            return { type: "number", minimum: 0 };
          } else {
            return { type: "string" };
          }
        },
        schemaDefinitionsTagName: { type: "string" },
        minCharacterLengthToInitSearch: { type: "number", minimum: 1 },
        maxResponseHeadersToShowInTryIt: { type: "number", minimum: 0 },
        scrollYOffset: (value) => {
          if (typeof value === "number") {
            return { type: "number" };
          } else {
            return { type: "string" };
          }
        },
        searchAutoExpand: { type: "boolean" },
        searchFieldLevelBoost: { type: "number", minimum: 0 },
        searchMaxDepth: { type: "number", minimum: 1 },
        searchMode: { enum: ["default", "path-only"] },
        searchOperationTitleBoost: { type: "number" },
        searchTagTitleBoost: { type: "number" },
        sendXUserAgentInTryIt: { type: "boolean" },
        showChangeLayoutButton: { type: "boolean" },
        showConsole: { type: "boolean" },
        showExtensions: (value) => {
          if (typeof value === "boolean") {
            return { type: "boolean" };
          } else {
            return {
              type: "array",
              items: {
                type: "string"
              }
            };
          }
        },
        showNextButton: { type: "boolean" },
        showRightPanelToggle: { type: "boolean" },
        showSecuritySchemeType: { type: "boolean" },
        showWebhookVerb: { type: "boolean" },
        showObjectSchemaExamples: { type: "boolean" },
        disableTryItRequestUrlEncoding: { type: "boolean" },
        sidebarLinks: "ConfigSidebarLinks",
        sideNavStyle: { enum: ["summary-only", "path-first", "id-only"] },
        simpleOneOfTypeLabel: { type: "boolean" },
        sortEnumValuesAlphabetically: { type: "boolean" },
        sortOperationsAlphabetically: { type: "boolean" },
        sortPropsAlphabetically: { type: "boolean" },
        sortTagsAlphabetically: { type: "boolean" },
        suppressWarnings: { type: "boolean" },
        unstable_externalDescription: { type: "boolean" },
        unstable_ignoreMimeParameters: { type: "boolean" },
        untrustedDefinition: { type: "boolean" },
        mockServer: {
          properties: {
            url: { type: "string" },
            position: { enum: ["first", "last", "replace", "off"] },
            description: { type: "string" }
          }
        },
        showAccessMode: { type: "boolean" },
        preserveOriginalExtensionsName: { type: "boolean" },
        markdownHeadingsAnchorLevel: { type: "number" }
      },
      additionalProperties: { type: "string" }
    };
    var ConfigMockServer = {
      properties: {
        strictExamples: { type: "boolean" },
        errorIfForcedExampleNotFound: { type: "boolean" }
      }
    };
    exports2.ConfigTypes = Object.assign(Object.assign({}, oas3_1_1.Oas3_1Types), {
      Assert,
      ConfigRoot,
      ConfigApis,
      ConfigApisProperties,
      RootConfigStyleguide,
      ConfigStyleguide,
      ConfigReferenceDocs,
      ConfigMockServer,
      ConfigHTTP,
      ConfigLanguage,
      ConfigLabels,
      ConfigSidebarLinks,
      CommonConfigSidebarLinks,
      ConfigTheme,
      ConfigRootTheme,
      AssertDefinition,
      ThemeColors,
      CommonThemeColors,
      BorderThemeColors,
      HttpColors,
      ResponseColors,
      SecondaryColors,
      TextThemeColors,
      Sizes,
      ButtonsConfig,
      CommonColorProps,
      BadgeFontConfig,
      BadgeSizes,
      HttpBadgesConfig,
      LabelControls,
      Panels,
      TryItButton,
      Breakpoints,
      StackedConfig,
      ThreePanelConfig,
      SchemaColorsConfig,
      SizeProps,
      Level1Items,
      SpacingConfig,
      FontConfig,
      CodeConfig,
      HeadingsConfig,
      LinksConfig,
      TokenProps,
      CodeBlock,
      ConfigThemeLogo,
      Fab,
      ButtonOverrides,
      Overrides,
      ObjectRule,
      RightPanel,
      Rules,
      Shape,
      ThemeSpacing,
      GenerateCodeSamples,
      GroupItemsConfig,
      ConfigThemeComponents,
      Layout,
      ConfigThemeSchema,
      Sidebar,
      Heading,
      Typography,
      AssertionDefinitionAssertions,
      AssertionDefinitionSubject
    });
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/other/stats.js
var require_stats = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/rules/other/stats.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.Stats = void 0;
    var Stats = (statsAccumulator) => {
      return {
        ExternalDocs: {
          leave() {
            statsAccumulator.externalDocs.total++;
          }
        },
        ref: {
          enter(ref) {
            statsAccumulator.refs.items.add(ref["$ref"]);
          }
        },
        Tag: {
          leave(tag) {
            statsAccumulator.tags.items.add(tag.name);
          }
        },
        Link: {
          leave(link) {
            statsAccumulator.links.items.add(link.operationId);
          }
        },
        Root: {
          leave() {
            statsAccumulator.parameters.total = statsAccumulator.parameters.items.size;
            statsAccumulator.refs.total = statsAccumulator.refs.items.size;
            statsAccumulator.links.total = statsAccumulator.links.items.size;
            statsAccumulator.tags.total = statsAccumulator.tags.items.size;
          }
        },
        WebhooksMap: {
          Operation: {
            leave(operation) {
              operation.tags.forEach((tag) => {
                statsAccumulator.tags.items.add(tag);
              });
            }
          }
        },
        Paths: {
          PathItem: {
            leave() {
              statsAccumulator.pathItems.total++;
            },
            Operation: {
              leave(operation) {
                statsAccumulator.operations.total++;
                operation.tags && operation.tags.forEach((tag) => {
                  statsAccumulator.tags.items.add(tag);
                });
              }
            },
            Parameter: {
              leave(parameter) {
                statsAccumulator.parameters.items.add(parameter.name);
              }
            }
          }
        },
        NamedSchemas: {
          Schema: {
            leave() {
              statsAccumulator.schemas.total++;
            }
          }
        }
      };
    };
    exports2.Stats = Stats;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/visitors.js
var require_visitors = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/visitors.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.normalizeVisitors = void 0;
    var types_1 = require_types();
    var legacyTypesMap = {
      Root: "DefinitionRoot",
      ServerVariablesMap: "ServerVariableMap",
      Paths: ["PathMap", "PathsMap"],
      CallbacksMap: "CallbackMap",
      MediaTypesMap: "MediaTypeMap",
      ExamplesMap: "ExampleMap",
      EncodingMap: "EncodingsMap",
      HeadersMap: "HeaderMap",
      LinksMap: "LinkMap",
      OAuth2Flows: "SecuritySchemeFlows",
      Responses: "ResponsesMap"
    };
    function normalizeVisitors(visitorsConfig, types2) {
      const normalizedVisitors = {};
      normalizedVisitors.any = {
        enter: [],
        leave: []
      };
      for (const typeName of Object.keys(types2)) {
        normalizedVisitors[typeName] = {
          enter: [],
          leave: []
        };
      }
      normalizedVisitors.ref = {
        enter: [],
        leave: []
      };
      for (const { ruleId, severity, visitor } of visitorsConfig) {
        normalizeVisitorLevel({ ruleId, severity }, visitor, null);
      }
      for (const v of Object.keys(normalizedVisitors)) {
        normalizedVisitors[v].enter.sort((a, b) => b.depth - a.depth);
        normalizedVisitors[v].leave.sort((a, b) => a.depth - b.depth);
      }
      return normalizedVisitors;
      function addWeakNodes(ruleConf, from, to, parentContext, stack = []) {
        if (stack.includes(from))
          return;
        stack = [...stack, from];
        const possibleChildren = /* @__PURE__ */ new Set();
        for (const type2 of Object.values(from.properties)) {
          if (type2 === to) {
            addWeakFromStack(ruleConf, stack);
            continue;
          }
          if (typeof type2 === "object" && type2 !== null && type2.name) {
            possibleChildren.add(type2);
          }
        }
        if (from.additionalProperties && typeof from.additionalProperties !== "function") {
          if (from.additionalProperties === to) {
            addWeakFromStack(ruleConf, stack);
          } else if (from.additionalProperties.name !== void 0) {
            possibleChildren.add(from.additionalProperties);
          }
        }
        if (from.items) {
          if (from.items === to) {
            addWeakFromStack(ruleConf, stack);
          } else if (from.items.name !== void 0) {
            possibleChildren.add(from.items);
          }
        }
        if (from.extensionsPrefix) {
          possibleChildren.add(types_1.SpecExtension);
        }
        for (const fromType of Array.from(possibleChildren.values())) {
          addWeakNodes(ruleConf, fromType, to, parentContext, stack);
        }
        function addWeakFromStack(ruleConf2, stack2) {
          for (const interType of stack2.slice(1)) {
            normalizedVisitors[interType.name] = normalizedVisitors[interType.name] || {
              enter: [],
              leave: []
            };
            normalizedVisitors[interType.name].enter.push(Object.assign(Object.assign({}, ruleConf2), {
              visit: () => void 0, depth: 0, context: {
                isSkippedLevel: true,
                seen: /* @__PURE__ */ new Set(),
                parent: parentContext
              }
            }));
          }
        }
      }
      function findLegacyVisitorNode(visitor, typeName) {
        if (Array.isArray(typeName)) {
          const name = typeName.find((name2) => visitor[name2]) || void 0;
          return name && visitor[name];
        }
        return visitor[typeName];
      }
      function normalizeVisitorLevel(ruleConf, visitor, parentContext, depth = 0) {
        const visitorKeys = Object.keys(types2);
        if (depth === 0) {
          visitorKeys.push("any");
          visitorKeys.push("ref");
        } else {
          if (visitor.any) {
            throw new Error("any() is allowed only on top level");
          }
          if (visitor.ref) {
            throw new Error("ref() is allowed only on top level");
          }
        }
        for (const typeName of visitorKeys) {
          const typeVisitor = visitor[typeName] || findLegacyVisitorNode(visitor, legacyTypesMap[typeName]);
          const normalizedTypeVisitor = normalizedVisitors[typeName];
          if (!typeVisitor)
            continue;
          let visitorEnter;
          let visitorLeave;
          let visitorSkip;
          const isObjectVisitor = typeof typeVisitor === "object";
          if (typeName === "ref" && isObjectVisitor && typeVisitor.skip) {
            throw new Error("ref() visitor does not support skip");
          }
          if (typeof typeVisitor === "function") {
            visitorEnter = typeVisitor;
          } else if (isObjectVisitor) {
            visitorEnter = typeVisitor.enter;
            visitorLeave = typeVisitor.leave;
            visitorSkip = typeVisitor.skip;
          }
          const context = {
            activatedOn: null,
            type: types2[typeName],
            parent: parentContext,
            isSkippedLevel: false
          };
          if (typeof typeVisitor === "object") {
            normalizeVisitorLevel(ruleConf, typeVisitor, context, depth + 1);
          }
          if (parentContext) {
            addWeakNodes(ruleConf, parentContext.type, types2[typeName], parentContext);
          }
          if (visitorEnter || isObjectVisitor) {
            if (visitorEnter && typeof visitorEnter !== "function") {
              throw new Error("DEV: should be function");
            }
            normalizedTypeVisitor.enter.push(Object.assign(Object.assign({}, ruleConf), {
              visit: visitorEnter || (() => void 0),
              skip: visitorSkip,
              depth,
              context
            }));
          }
          if (visitorLeave) {
            if (typeof visitorLeave !== "function") {
              throw new Error("DEV: should be function");
            }
            normalizedTypeVisitor.leave.push(Object.assign(Object.assign({}, ruleConf), {
              visit: visitorLeave,
              depth,
              context
            }));
          }
        }
      }
    }
    exports2.normalizeVisitors = normalizeVisitors;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/walk.js
var require_walk = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/walk.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.walkDocument = void 0;
    var ref_utils_1 = require_ref_utils();
    var utils_1 = require_utils3();
    var resolve_1 = require_resolve2();
    var types_1 = require_types();
    function collectParents(ctx) {
      var _a;
      const parents = {};
      while (ctx.parent) {
        parents[ctx.parent.type.name] = (_a = ctx.parent.activatedOn) === null || _a === void 0 ? void 0 : _a.value.node;
        ctx = ctx.parent;
      }
      return parents;
    }
    function collectParentsLocations(ctx) {
      var _a, _b;
      const locations = {};
      while (ctx.parent) {
        if ((_a = ctx.parent.activatedOn) === null || _a === void 0 ? void 0 : _a.value.location) {
          locations[ctx.parent.type.name] = (_b = ctx.parent.activatedOn) === null || _b === void 0 ? void 0 : _b.value.location;
        }
        ctx = ctx.parent;
      }
      return locations;
    }
    function walkDocument(opts) {
      const { document, rootType, normalizedVisitors, resolvedRefMap, ctx } = opts;
      const seenNodesPerType = {};
      const ignoredNodes = /* @__PURE__ */ new Set();
      walkNode(document.parsed, rootType, new ref_utils_1.Location(document.source, "#/"), void 0, "");
      function walkNode(node, type2, location, parent, key) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l;
        const resolve = (ref, from = currentLocation.source.absoluteRef) => {
          if (!(0, ref_utils_1.isRef)(ref))
            return { location, node: ref };
          const refId = (0, resolve_1.makeRefId)(from, ref.$ref);
          const resolvedRef = resolvedRefMap.get(refId);
          if (!resolvedRef) {
            return {
              location: void 0,
              node: void 0
            };
          }
          const { resolved, node: node2, document: document2, nodePointer, error: error2 } = resolvedRef;
          const newLocation = resolved ? new ref_utils_1.Location(document2.source, nodePointer) : error2 instanceof resolve_1.YamlParseError ? new ref_utils_1.Location(error2.source, "") : void 0;
          return { location: newLocation, node: node2, error: error2 };
        };
        const rawLocation = location;
        let currentLocation = location;
        const { node: resolvedNode, location: resolvedLocation, error } = resolve(node);
        const enteredContexts = /* @__PURE__ */ new Set();
        if ((0, ref_utils_1.isRef)(node)) {
          const refEnterVisitors = normalizedVisitors.ref.enter;
          for (const { visit: visitor, ruleId, severity, context } of refEnterVisitors) {
            enteredContexts.add(context);
            const report = reportFn.bind(void 0, ruleId, severity);
            visitor(node, {
              report,
              resolve,
              rawNode: node,
              rawLocation,
              location,
              type: type2,
              parent,
              key,
              parentLocations: {},
              oasVersion: ctx.oasVersion,
              getVisitorData: getVisitorDataFn.bind(void 0, ruleId)
            }, { node: resolvedNode, location: resolvedLocation, error });
            if ((resolvedLocation === null || resolvedLocation === void 0 ? void 0 : resolvedLocation.source.absoluteRef) && ctx.refTypes) {
              ctx.refTypes.set(resolvedLocation === null || resolvedLocation === void 0 ? void 0 : resolvedLocation.source.absoluteRef, type2);
            }
          }
        }
        if (resolvedNode !== void 0 && resolvedLocation && type2.name !== "scalar") {
          currentLocation = resolvedLocation;
          const isNodeSeen = (_b = (_a = seenNodesPerType[type2.name]) === null || _a === void 0 ? void 0 : _a.has) === null || _b === void 0 ? void 0 : _b.call(_a, resolvedNode);
          let visitedBySome = false;
          const anyEnterVisitors = normalizedVisitors.any.enter;
          const currentEnterVisitors = anyEnterVisitors.concat(((_c = normalizedVisitors[type2.name]) === null || _c === void 0 ? void 0 : _c.enter) || []);
          const activatedContexts = [];
          for (const { context, visit, skip, ruleId, severity } of currentEnterVisitors) {
            if (ignoredNodes.has(currentLocation.pointer))
              break;
            if (context.isSkippedLevel) {
              if (context.parent.activatedOn && !context.parent.activatedOn.value.nextLevelTypeActivated && !context.seen.has(node)) {
                context.seen.add(node);
                visitedBySome = true;
                activatedContexts.push(context);
              }
            } else {
              if (context.parent && // if nested
                context.parent.activatedOn && ((_d = context.activatedOn) === null || _d === void 0 ? void 0 : _d.value.withParentNode) !== context.parent.activatedOn.value.node && // do not enter if visited by parent children (it works thanks because deeper visitors are sorted before)
                ((_e = context.parent.activatedOn.value.nextLevelTypeActivated) === null || _e === void 0 ? void 0 : _e.value) !== type2 || !context.parent && !isNodeSeen) {
                activatedContexts.push(context);
                const activatedOn = {
                  node: resolvedNode,
                  location: resolvedLocation,
                  nextLevelTypeActivated: null,
                  withParentNode: (_g = (_f = context.parent) === null || _f === void 0 ? void 0 : _f.activatedOn) === null || _g === void 0 ? void 0 : _g.value.node,
                  skipped: (_k = ((_j = (_h = context.parent) === null || _h === void 0 ? void 0 : _h.activatedOn) === null || _j === void 0 ? void 0 : _j.value.skipped) || (skip === null || skip === void 0 ? void 0 : skip(resolvedNode, key, {
                    location,
                    rawLocation,
                    resolve,
                    rawNode: node
                  }))) !== null && _k !== void 0 ? _k : false
                };
                context.activatedOn = (0, utils_1.pushStack)(context.activatedOn, activatedOn);
                let ctx2 = context.parent;
                while (ctx2) {
                  ctx2.activatedOn.value.nextLevelTypeActivated = (0, utils_1.pushStack)(ctx2.activatedOn.value.nextLevelTypeActivated, type2);
                  ctx2 = ctx2.parent;
                }
                if (!activatedOn.skipped) {
                  visitedBySome = true;
                  enteredContexts.add(context);
                  visitWithContext(visit, resolvedNode, node, context, ruleId, severity);
                }
              }
            }
          }
          if (visitedBySome || !isNodeSeen) {
            seenNodesPerType[type2.name] = seenNodesPerType[type2.name] || /* @__PURE__ */ new Set();
            seenNodesPerType[type2.name].add(resolvedNode);
            if (Array.isArray(resolvedNode)) {
              const itemsType = type2.items;
              if (itemsType !== void 0) {
                for (let i = 0; i < resolvedNode.length; i++) {
                  walkNode(resolvedNode[i], itemsType, resolvedLocation.child([i]), resolvedNode, i);
                }
              }
            } else if (typeof resolvedNode === "object" && resolvedNode !== null) {
              const props = Object.keys(type2.properties);
              if (type2.additionalProperties) {
                props.push(...Object.keys(resolvedNode).filter((k) => !props.includes(k)));
              } else if (type2.extensionsPrefix) {
                props.push(...Object.keys(resolvedNode).filter((k) => k.startsWith(type2.extensionsPrefix)));
              }
              if ((0, ref_utils_1.isRef)(node)) {
                props.push(...Object.keys(node).filter((k) => k !== "$ref" && !props.includes(k)));
              }
              for (const propName of props) {
                let value = resolvedNode[propName];
                let loc = resolvedLocation;
                if (value === void 0) {
                  value = node[propName];
                  loc = location;
                }
                let propType = type2.properties[propName];
                if (propType === void 0)
                  propType = type2.additionalProperties;
                if (typeof propType === "function")
                  propType = propType(value, propName);
                if (propType === void 0 && type2.extensionsPrefix && propName.startsWith(type2.extensionsPrefix)) {
                  propType = types_1.SpecExtension;
                }
                if (!(0, types_1.isNamedType)(propType) && (propType === null || propType === void 0 ? void 0 : propType.directResolveAs)) {
                  propType = propType.directResolveAs;
                  value = { $ref: value };
                }
                if (propType && propType.name === void 0 && propType.resolvable !== false) {
                  propType = { name: "scalar", properties: {} };
                }
                if (!(0, types_1.isNamedType)(propType) || propType.name === "scalar" && !(0, ref_utils_1.isRef)(value)) {
                  continue;
                }
                walkNode(value, propType, loc.child([propName]), resolvedNode, propName);
              }
            }
          }
          const anyLeaveVisitors = normalizedVisitors.any.leave;
          const currentLeaveVisitors = (((_l = normalizedVisitors[type2.name]) === null || _l === void 0 ? void 0 : _l.leave) || []).concat(anyLeaveVisitors);
          for (const context of activatedContexts.reverse()) {
            if (context.isSkippedLevel) {
              context.seen.delete(resolvedNode);
            } else {
              context.activatedOn = (0, utils_1.popStack)(context.activatedOn);
              if (context.parent) {
                let ctx2 = context.parent;
                while (ctx2) {
                  ctx2.activatedOn.value.nextLevelTypeActivated = (0, utils_1.popStack)(ctx2.activatedOn.value.nextLevelTypeActivated);
                  ctx2 = ctx2.parent;
                }
              }
            }
          }
          for (const { context, visit, ruleId, severity } of currentLeaveVisitors) {
            if (!context.isSkippedLevel && enteredContexts.has(context)) {
              visitWithContext(visit, resolvedNode, node, context, ruleId, severity);
            }
          }
        }
        currentLocation = location;
        if ((0, ref_utils_1.isRef)(node)) {
          const refLeaveVisitors = normalizedVisitors.ref.leave;
          for (const { visit: visitor, ruleId, severity, context } of refLeaveVisitors) {
            if (enteredContexts.has(context)) {
              const report = reportFn.bind(void 0, ruleId, severity);
              visitor(node, {
                report,
                resolve,
                rawNode: node,
                rawLocation,
                location,
                type: type2,
                parent,
                key,
                parentLocations: {},
                oasVersion: ctx.oasVersion,
                getVisitorData: getVisitorDataFn.bind(void 0, ruleId)
              }, { node: resolvedNode, location: resolvedLocation, error });
            }
          }
        }
        function visitWithContext(visit, resolvedNode2, node2, context, ruleId, severity) {
          const report = reportFn.bind(void 0, ruleId, severity);
          visit(resolvedNode2, {
            report,
            resolve,
            rawNode: node2,
            location: currentLocation,
            rawLocation,
            type: type2,
            parent,
            key,
            parentLocations: collectParentsLocations(context),
            oasVersion: ctx.oasVersion,
            ignoreNextVisitorsOnNode: () => {
              ignoredNodes.add(currentLocation.pointer);
            },
            getVisitorData: getVisitorDataFn.bind(void 0, ruleId)
          }, collectParents(context), context);
        }
        function reportFn(ruleId, severity, opts2) {
          const normalizedLocation = opts2.location ? Array.isArray(opts2.location) ? opts2.location : [opts2.location] : [Object.assign(Object.assign({}, currentLocation), { reportOnKey: false })];
          const location2 = normalizedLocation.map((l) => Object.assign(Object.assign(Object.assign({}, currentLocation), { reportOnKey: false }), l));
          const ruleSeverity = opts2.forceSeverity || severity;
          if (ruleSeverity !== "off") {
            ctx.problems.push(Object.assign(Object.assign({ ruleId: opts2.ruleId || ruleId, severity: ruleSeverity }, opts2), { suggest: opts2.suggest || [], location: location2 }));
          }
        }
        function getVisitorDataFn(ruleId) {
          ctx.visitorsData[ruleId] = ctx.visitorsData[ruleId] || {};
          return ctx.visitorsData[ruleId];
        }
      }
    }
    exports2.walkDocument = walkDocument;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/yamlAST.js
var require_yamlAST = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/yamlAST.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var Kind;
    (function (Kind2) {
      Kind2[Kind2["SCALAR"] = 0] = "SCALAR";
      Kind2[Kind2["MAPPING"] = 1] = "MAPPING";
      Kind2[Kind2["MAP"] = 2] = "MAP";
      Kind2[Kind2["SEQ"] = 3] = "SEQ";
      Kind2[Kind2["ANCHOR_REF"] = 4] = "ANCHOR_REF";
      Kind2[Kind2["INCLUDE_REF"] = 5] = "INCLUDE_REF";
    })(Kind = exports2.Kind || (exports2.Kind = {}));
    function newMapping(key, value) {
      var end = value ? value.endPosition : key.endPosition + 1;
      var node = {
        key,
        value,
        startPosition: key.startPosition,
        endPosition: end,
        kind: Kind.MAPPING,
        parent: null,
        errors: []
      };
      return node;
    }
    exports2.newMapping = newMapping;
    function newAnchorRef(key, start, end, value) {
      return {
        errors: [],
        referencesAnchor: key,
        value,
        startPosition: start,
        endPosition: end,
        kind: Kind.ANCHOR_REF,
        parent: null
      };
    }
    exports2.newAnchorRef = newAnchorRef;
    function newScalar(v) {
      if (v === void 0) {
        v = "";
      }
      var result = {
        errors: [],
        startPosition: -1,
        endPosition: -1,
        value: "" + v,
        kind: Kind.SCALAR,
        parent: null,
        doubleQuoted: false,
        rawValue: "" + v
      };
      if (typeof v !== "string") {
        result.valueObject = v;
      }
      return result;
    }
    exports2.newScalar = newScalar;
    function newItems() {
      return {
        errors: [],
        startPosition: -1,
        endPosition: -1,
        items: [],
        kind: Kind.SEQ,
        parent: null
      };
    }
    exports2.newItems = newItems;
    function newSeq() {
      return newItems();
    }
    exports2.newSeq = newSeq;
    function newMap(mappings) {
      return {
        errors: [],
        startPosition: -1,
        endPosition: -1,
        mappings: mappings ? mappings : [],
        kind: Kind.MAP,
        parent: null
      };
    }
    exports2.newMap = newMap;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/common.js
var require_common2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/common.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    function isNothing2(subject) {
      return typeof subject === "undefined" || null === subject;
    }
    exports2.isNothing = isNothing2;
    function isObject3(subject) {
      return typeof subject === "object" && null !== subject;
    }
    exports2.isObject = isObject3;
    function toArray2(sequence) {
      if (Array.isArray(sequence)) {
        return sequence;
      } else if (isNothing2(sequence)) {
        return [];
      }
      return [sequence];
    }
    exports2.toArray = toArray2;
    function extend3(target, source) {
      var index, length, key, sourceKeys;
      if (source) {
        sourceKeys = Object.keys(source);
        for (index = 0, length = sourceKeys.length; index < length; index += 1) {
          key = sourceKeys[index];
          target[key] = source[key];
        }
      }
      return target;
    }
    exports2.extend = extend3;
    function repeat2(string3, count) {
      var result = "", cycle;
      for (cycle = 0; cycle < count; cycle += 1) {
        result += string3;
      }
      return result;
    }
    exports2.repeat = repeat2;
    function isNegativeZero2(number3) {
      return 0 === number3 && Number.NEGATIVE_INFINITY === 1 / number3;
    }
    exports2.isNegativeZero = isNegativeZero2;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/exception.js
var require_exception2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/exception.js"(exports2, module2) {
    "use strict";
    var YAMLException2 = function () {
      function YAMLException3(reason, mark, isWarning) {
        if (mark === void 0) {
          mark = null;
        }
        if (isWarning === void 0) {
          isWarning = false;
        }
        this.name = "YAMLException";
        this.reason = reason;
        this.mark = mark;
        this.message = this.toString(false);
        this.isWarning = isWarning;
      }
      YAMLException3.isInstance = function (instance) {
        if (instance != null && instance.getClassIdentifier && typeof instance.getClassIdentifier == "function") {
          for (var _i = 0, _a = instance.getClassIdentifier(); _i < _a.length; _i++) {
            var currentIdentifier = _a[_i];
            if (currentIdentifier == YAMLException3.CLASS_IDENTIFIER)
              return true;
          }
        }
        return false;
      };
      YAMLException3.prototype.getClassIdentifier = function () {
        var superIdentifiers = [];
        return superIdentifiers.concat(YAMLException3.CLASS_IDENTIFIER);
      };
      YAMLException3.prototype.toString = function (compact2) {
        if (compact2 === void 0) {
          compact2 = false;
        }
        var result;
        result = "JS-YAML: " + (this.reason || "(unknown reason)");
        if (!compact2 && this.mark) {
          result += " " + this.mark.toString();
        }
        return result;
      };
      YAMLException3.CLASS_IDENTIFIER = "yaml-ast-parser.YAMLException";
      return YAMLException3;
    }();
    module2.exports = YAMLException2;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/mark.js
var require_mark = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/mark.js"(exports2, module2) {
    "use strict";
    var common2 = require_common2();
    var Mark = function () {
      function Mark2(name, buffer, position, line, column) {
        this.name = name;
        this.buffer = buffer;
        this.position = position;
        this.line = line;
        this.column = column;
      }
      Mark2.prototype.getSnippet = function (indent, maxLength) {
        if (indent === void 0) {
          indent = 0;
        }
        if (maxLength === void 0) {
          maxLength = 75;
        }
        var head, start, tail, end, snippet2;
        if (!this.buffer) {
          return null;
        }
        indent = indent || 4;
        maxLength = maxLength || 75;
        head = "";
        start = this.position;
        while (start > 0 && -1 === "\0\r\n\x85\u2028\u2029".indexOf(this.buffer.charAt(start - 1))) {
          start -= 1;
          if (this.position - start > maxLength / 2 - 1) {
            head = " ... ";
            start += 5;
            break;
          }
        }
        tail = "";
        end = this.position;
        while (end < this.buffer.length && -1 === "\0\r\n\x85\u2028\u2029".indexOf(this.buffer.charAt(end))) {
          end += 1;
          if (end - this.position > maxLength / 2 - 1) {
            tail = " ... ";
            end -= 5;
            break;
          }
        }
        snippet2 = this.buffer.slice(start, end);
        return common2.repeat(" ", indent) + head + snippet2 + tail + "\n" + common2.repeat(" ", indent + this.position - start + head.length) + "^";
      };
      Mark2.prototype.toString = function (compact2) {
        if (compact2 === void 0) {
          compact2 = true;
        }
        var snippet2, where = "";
        if (this.name) {
          where += 'in "' + this.name + '" ';
        }
        where += "at line " + (this.line + 1) + ", column " + (this.column + 1);
        if (!compact2) {
          snippet2 = this.getSnippet();
          if (snippet2) {
            where += ":\n" + snippet2;
          }
        }
        return where;
      };
      return Mark2;
    }();
    module2.exports = Mark;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type.js
var require_type2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var YAMLException2 = require_exception2();
    var TYPE_CONSTRUCTOR_OPTIONS2 = [
      "kind",
      "resolve",
      "construct",
      "instanceOf",
      "predicate",
      "represent",
      "defaultStyle",
      "styleAliases"
    ];
    var YAML_NODE_KINDS2 = [
      "scalar",
      "sequence",
      "mapping"
    ];
    function compileStyleAliases2(map2) {
      var result = {};
      if (null !== map2) {
        Object.keys(map2).forEach(function (style) {
          map2[style].forEach(function (alias) {
            result[String(alias)] = style;
          });
        });
      }
      return result;
    }
    var Type3 = /* @__PURE__ */ function () {
      function Type4(tag, options) {
        options = options || {};
        Object.keys(options).forEach(function (name) {
          if (-1 === TYPE_CONSTRUCTOR_OPTIONS2.indexOf(name)) {
            throw new YAMLException2('Unknown option "' + name + '" is met in definition of "' + tag + '" YAML type.');
          }
        });
        this.tag = tag;
        this.kind = options["kind"] || null;
        this.resolve = options["resolve"] || function () {
          return true;
        };
        this.construct = options["construct"] || function (data) {
          return data;
        };
        this.instanceOf = options["instanceOf"] || null;
        this.predicate = options["predicate"] || null;
        this.represent = options["represent"] || null;
        this.defaultStyle = options["defaultStyle"] || null;
        this.styleAliases = compileStyleAliases2(options["styleAliases"] || null);
        if (-1 === YAML_NODE_KINDS2.indexOf(this.kind)) {
          throw new YAMLException2('Unknown kind "' + this.kind + '" is specified for "' + tag + '" YAML type.');
        }
      }
      return Type4;
    }();
    exports2.Type = Type3;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema.js
var require_schema3 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var common2 = require_common2();
    var YAMLException2 = require_exception2();
    var type_1 = require_type2();
    function compileList2(schema2, name, result) {
      var exclude = [];
      schema2.include.forEach(function (includedSchema) {
        result = compileList2(includedSchema, name, result);
      });
      schema2[name].forEach(function (currentType) {
        result.forEach(function (previousType, previousIndex) {
          if (previousType.tag === currentType.tag) {
            exclude.push(previousIndex);
          }
        });
        result.push(currentType);
      });
      return result.filter(function (type2, index) {
        return -1 === exclude.indexOf(index);
      });
    }
    function compileMap2() {
      var result = {}, index, length;
      function collectType(type2) {
        result[type2.tag] = type2;
      }
      for (index = 0, length = arguments.length; index < length; index += 1) {
        arguments[index].forEach(collectType);
      }
      return result;
    }
    var Schema3 = function () {
      function Schema4(definition) {
        this.include = definition.include || [];
        this.implicit = definition.implicit || [];
        this.explicit = definition.explicit || [];
        this.implicit.forEach(function (type2) {
          if (type2.loadKind && "scalar" !== type2.loadKind) {
            throw new YAMLException2("There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.");
          }
        });
        this.compiledImplicit = compileList2(this, "implicit", []);
        this.compiledExplicit = compileList2(this, "explicit", []);
        this.compiledTypeMap = compileMap2(this.compiledImplicit, this.compiledExplicit);
      }
      Schema4.DEFAULT = null;
      Schema4.create = function createSchema() {
        var schemas, types2;
        switch (arguments.length) {
          case 1:
            schemas = Schema4.DEFAULT;
            types2 = arguments[0];
            break;
          case 2:
            schemas = arguments[0];
            types2 = arguments[1];
            break;
          default:
            throw new YAMLException2("Wrong number of arguments for Schema.create function");
        }
        schemas = common2.toArray(schemas);
        types2 = common2.toArray(types2);
        if (!schemas.every(function (schema2) {
          return schema2 instanceof Schema4;
        })) {
          throw new YAMLException2("Specified list of super schemas (or a single Schema object) contains a non-Schema object.");
        }
        if (!types2.every(function (type2) {
          return type2 instanceof type_1.Type;
        })) {
          throw new YAMLException2("Specified list of YAML types (or a single Type object) contains a non-Type object.");
        }
        return new Schema4({
          include: schemas,
          explicit: types2
        });
      };
      return Schema4;
    }();
    exports2.Schema = Schema3;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/str.js
var require_str2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/str.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    module2.exports = new type_1.Type("tag:yaml.org,2002:str", {
      kind: "scalar",
      construct: function (data) {
        return null !== data ? data : "";
      }
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/seq.js
var require_seq2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/seq.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    module2.exports = new type_1.Type("tag:yaml.org,2002:seq", {
      kind: "sequence",
      construct: function (data) {
        return null !== data ? data : [];
      }
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/map.js
var require_map2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/map.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    module2.exports = new type_1.Type("tag:yaml.org,2002:map", {
      kind: "mapping",
      construct: function (data) {
        return null !== data ? data : {};
      }
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema/failsafe.js
var require_failsafe2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema/failsafe.js"(exports2, module2) {
    "use strict";
    var schema_1 = require_schema3();
    module2.exports = new schema_1.Schema({
      explicit: [
        require_str2(),
        require_seq2(),
        require_map2()
      ]
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/null.js
var require_null2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/null.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    function resolveYamlNull2(data) {
      if (null === data) {
        return true;
      }
      var max = data.length;
      return max === 1 && data === "~" || max === 4 && (data === "null" || data === "Null" || data === "NULL");
    }
    function constructYamlNull2() {
      return null;
    }
    function isNull3(object3) {
      return null === object3;
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:null", {
      kind: "scalar",
      resolve: resolveYamlNull2,
      construct: constructYamlNull2,
      predicate: isNull3,
      represent: {
        canonical: function () {
          return "~";
        },
        lowercase: function () {
          return "null";
        },
        uppercase: function () {
          return "NULL";
        },
        camelcase: function () {
          return "Null";
        }
      },
      defaultStyle: "lowercase"
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/bool.js
var require_bool2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/bool.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    function resolveYamlBoolean2(data) {
      if (null === data) {
        return false;
      }
      var max = data.length;
      return max === 4 && (data === "true" || data === "True" || data === "TRUE") || max === 5 && (data === "false" || data === "False" || data === "FALSE");
    }
    function constructYamlBoolean2(data) {
      return data === "true" || data === "True" || data === "TRUE";
    }
    function isBoolean2(object3) {
      return "[object Boolean]" === Object.prototype.toString.call(object3);
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:bool", {
      kind: "scalar",
      resolve: resolveYamlBoolean2,
      construct: constructYamlBoolean2,
      predicate: isBoolean2,
      represent: {
        lowercase: function (object3) {
          return object3 ? "true" : "false";
        },
        uppercase: function (object3) {
          return object3 ? "TRUE" : "FALSE";
        },
        camelcase: function (object3) {
          return object3 ? "True" : "False";
        }
      },
      defaultStyle: "lowercase"
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/int.js
var require_int2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/int.js"(exports2, module2) {
    "use strict";
    var common2 = require_common2();
    var type_1 = require_type2();
    function isHexCode2(c) {
      return 48 <= c && c <= 57 || 65 <= c && c <= 70 || 97 <= c && c <= 102;
    }
    function isOctCode2(c) {
      return 48 <= c && c <= 55;
    }
    function isDecCode2(c) {
      return 48 <= c && c <= 57;
    }
    function resolveYamlInteger2(data) {
      if (null === data) {
        return false;
      }
      var max = data.length, index = 0, hasDigits = false, ch;
      if (!max) {
        return false;
      }
      ch = data[index];
      if (ch === "-" || ch === "+") {
        ch = data[++index];
      }
      if (ch === "0") {
        if (index + 1 === max) {
          return true;
        }
        ch = data[++index];
        if (ch === "b") {
          index++;
          for (; index < max; index++) {
            ch = data[index];
            if (ch === "_") {
              continue;
            }
            if (ch !== "0" && ch !== "1") {
              return false;
            }
            hasDigits = true;
          }
          return hasDigits;
        }
        if (ch === "x") {
          index++;
          for (; index < max; index++) {
            ch = data[index];
            if (ch === "_") {
              continue;
            }
            if (!isHexCode2(data.charCodeAt(index))) {
              return false;
            }
            hasDigits = true;
          }
          return hasDigits;
        }
        for (; index < max; index++) {
          ch = data[index];
          if (ch === "_") {
            continue;
          }
          if (!isOctCode2(data.charCodeAt(index))) {
            return false;
          }
          hasDigits = true;
        }
        return hasDigits;
      }
      for (; index < max; index++) {
        ch = data[index];
        if (ch === "_") {
          continue;
        }
        if (ch === ":") {
          break;
        }
        if (!isDecCode2(data.charCodeAt(index))) {
          return false;
        }
        hasDigits = true;
      }
      if (!hasDigits) {
        return false;
      }
      if (ch !== ":") {
        return true;
      }
      return /^(:[0-5]?[0-9])+$/.test(data.slice(index));
    }
    function constructYamlInteger2(data) {
      var value = data, sign = 1, ch, base, digits = [];
      if (value.indexOf("_") !== -1) {
        value = value.replace(/_/g, "");
      }
      ch = value[0];
      if (ch === "-" || ch === "+") {
        if (ch === "-") {
          sign = -1;
        }
        value = value.slice(1);
        ch = value[0];
      }
      if ("0" === value) {
        return 0;
      }
      if (ch === "0") {
        if (value[1] === "b") {
          return sign * parseInt(value.slice(2), 2);
        }
        if (value[1] === "x") {
          return sign * parseInt(value, 16);
        }
        return sign * parseInt(value, 8);
      }
      if (value.indexOf(":") !== -1) {
        value.split(":").forEach(function (v) {
          digits.unshift(parseInt(v, 10));
        });
        value = 0;
        base = 1;
        digits.forEach(function (d) {
          value += d * base;
          base *= 60;
        });
        return sign * value;
      }
      return sign * parseInt(value, 10);
    }
    function isInteger2(object3) {
      return "[object Number]" === Object.prototype.toString.call(object3) && (0 === object3 % 1 && !common2.isNegativeZero(object3));
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:int", {
      kind: "scalar",
      resolve: resolveYamlInteger2,
      construct: constructYamlInteger2,
      predicate: isInteger2,
      represent: {
        binary: function (object3) {
          return "0b" + object3.toString(2);
        },
        octal: function (object3) {
          return "0" + object3.toString(8);
        },
        decimal: function (object3) {
          return object3.toString(10);
        },
        hexadecimal: function (object3) {
          return "0x" + object3.toString(16).toUpperCase();
        }
      },
      defaultStyle: "decimal",
      styleAliases: {
        binary: [2, "bin"],
        octal: [8, "oct"],
        decimal: [10, "dec"],
        hexadecimal: [16, "hex"]
      }
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/float.js
var require_float2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/float.js"(exports2, module2) {
    "use strict";
    var common2 = require_common2();
    var type_1 = require_type2();
    var YAML_FLOAT_PATTERN2 = new RegExp("^(?:[-+]?(?:[0-9][0-9_]*)\\.[0-9_]*(?:[eE][-+][0-9]+)?|\\.[0-9_]+(?:[eE][-+][0-9]+)?|[-+]?[0-9][0-9_]*(?::[0-5]?[0-9])+\\.[0-9_]*|[-+]?\\.(?:inf|Inf|INF)|\\.(?:nan|NaN|NAN))$");
    function resolveYamlFloat2(data) {
      if (null === data) {
        return false;
      }
      var value, sign, base, digits;
      if (!YAML_FLOAT_PATTERN2.test(data)) {
        return false;
      }
      return true;
    }
    function constructYamlFloat2(data) {
      var value, sign, base, digits;
      value = data.replace(/_/g, "").toLowerCase();
      sign = "-" === value[0] ? -1 : 1;
      digits = [];
      if (0 <= "+-".indexOf(value[0])) {
        value = value.slice(1);
      }
      if (".inf" === value) {
        return 1 === sign ? Number.POSITIVE_INFINITY : Number.NEGATIVE_INFINITY;
      } else if (".nan" === value) {
        return NaN;
      } else if (0 <= value.indexOf(":")) {
        value.split(":").forEach(function (v) {
          digits.unshift(parseFloat(v, 10));
        });
        value = 0;
        base = 1;
        digits.forEach(function (d) {
          value += d * base;
          base *= 60;
        });
        return sign * value;
      }
      return sign * parseFloat(value, 10);
    }
    function representYamlFloat2(object3, style) {
      if (isNaN(object3)) {
        switch (style) {
          case "lowercase":
            return ".nan";
          case "uppercase":
            return ".NAN";
          case "camelcase":
            return ".NaN";
        }
      } else if (Number.POSITIVE_INFINITY === object3) {
        switch (style) {
          case "lowercase":
            return ".inf";
          case "uppercase":
            return ".INF";
          case "camelcase":
            return ".Inf";
        }
      } else if (Number.NEGATIVE_INFINITY === object3) {
        switch (style) {
          case "lowercase":
            return "-.inf";
          case "uppercase":
            return "-.INF";
          case "camelcase":
            return "-.Inf";
        }
      } else if (common2.isNegativeZero(object3)) {
        return "-0.0";
      }
      return object3.toString(10);
    }
    function isFloat2(object3) {
      return "[object Number]" === Object.prototype.toString.call(object3) && (0 !== object3 % 1 || common2.isNegativeZero(object3));
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:float", {
      kind: "scalar",
      resolve: resolveYamlFloat2,
      construct: constructYamlFloat2,
      predicate: isFloat2,
      represent: representYamlFloat2,
      defaultStyle: "lowercase"
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema/json.js
var require_json2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema/json.js"(exports2, module2) {
    "use strict";
    var schema_1 = require_schema3();
    module2.exports = new schema_1.Schema({
      include: [
        require_failsafe2()
      ],
      implicit: [
        require_null2(),
        require_bool2(),
        require_int2(),
        require_float2()
      ]
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema/core.js
var require_core5 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema/core.js"(exports2, module2) {
    "use strict";
    var schema_1 = require_schema3();
    module2.exports = new schema_1.Schema({
      include: [
        require_json2()
      ]
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/timestamp.js
var require_timestamp2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/timestamp.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    var YAML_TIMESTAMP_REGEXP2 = new RegExp("^([0-9][0-9][0-9][0-9])-([0-9][0-9]?)-([0-9][0-9]?)(?:(?:[Tt]|[ \\t]+)([0-9][0-9]?):([0-9][0-9]):([0-9][0-9])(?:\\.([0-9]*))?(?:[ \\t]*(Z|([-+])([0-9][0-9]?)(?::([0-9][0-9]))?))?)?$");
    function resolveYamlTimestamp2(data) {
      if (null === data) {
        return false;
      }
      var match, year, month, day, hour, minute, second, fraction = 0, delta = null, tz_hour, tz_minute, date3;
      match = YAML_TIMESTAMP_REGEXP2.exec(data);
      if (null === match) {
        return false;
      }
      return true;
    }
    function constructYamlTimestamp2(data) {
      var match, year, month, day, hour, minute, second, fraction = 0, delta = null, tz_hour, tz_minute, date3;
      match = YAML_TIMESTAMP_REGEXP2.exec(data);
      if (null === match) {
        throw new Error("Date resolve error");
      }
      year = +match[1];
      month = +match[2] - 1;
      day = +match[3];
      if (!match[4]) {
        return new Date(Date.UTC(year, month, day));
      }
      hour = +match[4];
      minute = +match[5];
      second = +match[6];
      if (match[7]) {
        fraction = match[7].slice(0, 3);
        while (fraction.length < 3) {
          fraction = fraction + "0";
        }
        fraction = +fraction;
      }
      if (match[9]) {
        tz_hour = +match[10];
        tz_minute = +(match[11] || 0);
        delta = (tz_hour * 60 + tz_minute) * 6e4;
        if ("-" === match[9]) {
          delta = -delta;
        }
      }
      date3 = new Date(Date.UTC(year, month, day, hour, minute, second, fraction));
      if (delta) {
        date3.setTime(date3.getTime() - delta);
      }
      return date3;
    }
    function representYamlTimestamp2(object3) {
      return object3.toISOString();
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:timestamp", {
      kind: "scalar",
      resolve: resolveYamlTimestamp2,
      construct: constructYamlTimestamp2,
      instanceOf: Date,
      represent: representYamlTimestamp2
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/merge.js
var require_merge2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/merge.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    function resolveYamlMerge2(data) {
      return "<<" === data || null === data;
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:merge", {
      kind: "scalar",
      resolve: resolveYamlMerge2
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/binary.js
var require_binary2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/binary.js"(exports2, module2) {
    "use strict";
    var NodeBuffer = require("buffer").Buffer;
    var type_1 = require_type2();
    var BASE64_MAP2 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=\n\r";
    function resolveYamlBinary2(data) {
      if (null === data) {
        return false;
      }
      var code, idx, bitlen = 0, len = 0, max = data.length, map2 = BASE64_MAP2;
      for (idx = 0; idx < max; idx++) {
        code = map2.indexOf(data.charAt(idx));
        if (code > 64) {
          continue;
        }
        if (code < 0) {
          return false;
        }
        bitlen += 6;
      }
      return bitlen % 8 === 0;
    }
    function constructYamlBinary2(data) {
      var code, idx, tailbits, input = data.replace(/[\r\n=]/g, ""), max = input.length, map2 = BASE64_MAP2, bits = 0, result = [];
      for (idx = 0; idx < max; idx++) {
        if (idx % 4 === 0 && idx) {
          result.push(bits >> 16 & 255);
          result.push(bits >> 8 & 255);
          result.push(bits & 255);
        }
        bits = bits << 6 | map2.indexOf(input.charAt(idx));
      }
      tailbits = max % 4 * 6;
      if (tailbits === 0) {
        result.push(bits >> 16 & 255);
        result.push(bits >> 8 & 255);
        result.push(bits & 255);
      } else if (tailbits === 18) {
        result.push(bits >> 10 & 255);
        result.push(bits >> 2 & 255);
      } else if (tailbits === 12) {
        result.push(bits >> 4 & 255);
      }
      if (NodeBuffer) {
        return new NodeBuffer(result);
      }
      return result;
    }
    function representYamlBinary2(object3) {
      var result = "", bits = 0, idx, tail, max = object3.length, map2 = BASE64_MAP2;
      for (idx = 0; idx < max; idx++) {
        if (idx % 3 === 0 && idx) {
          result += map2[bits >> 18 & 63];
          result += map2[bits >> 12 & 63];
          result += map2[bits >> 6 & 63];
          result += map2[bits & 63];
        }
        bits = (bits << 8) + object3[idx];
      }
      tail = max % 3;
      if (tail === 0) {
        result += map2[bits >> 18 & 63];
        result += map2[bits >> 12 & 63];
        result += map2[bits >> 6 & 63];
        result += map2[bits & 63];
      } else if (tail === 2) {
        result += map2[bits >> 10 & 63];
        result += map2[bits >> 4 & 63];
        result += map2[bits << 2 & 63];
        result += map2[64];
      } else if (tail === 1) {
        result += map2[bits >> 2 & 63];
        result += map2[bits << 4 & 63];
        result += map2[64];
        result += map2[64];
      }
      return result;
    }
    function isBinary2(object3) {
      return NodeBuffer && NodeBuffer.isBuffer(object3);
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:binary", {
      kind: "scalar",
      resolve: resolveYamlBinary2,
      construct: constructYamlBinary2,
      predicate: isBinary2,
      represent: representYamlBinary2
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/omap.js
var require_omap2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/omap.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    var _hasOwnProperty2 = Object.prototype.hasOwnProperty;
    var _toString2 = Object.prototype.toString;
    function resolveYamlOmap2(data) {
      if (null === data) {
        return true;
      }
      var objectKeys = [], index, length, pair, pairKey, pairHasKey, object3 = data;
      for (index = 0, length = object3.length; index < length; index += 1) {
        pair = object3[index];
        pairHasKey = false;
        if ("[object Object]" !== _toString2.call(pair)) {
          return false;
        }
        for (pairKey in pair) {
          if (_hasOwnProperty2.call(pair, pairKey)) {
            if (!pairHasKey) {
              pairHasKey = true;
            } else {
              return false;
            }
          }
        }
        if (!pairHasKey) {
          return false;
        }
        if (-1 === objectKeys.indexOf(pairKey)) {
          objectKeys.push(pairKey);
        } else {
          return false;
        }
      }
      return true;
    }
    function constructYamlOmap2(data) {
      return null !== data ? data : [];
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:omap", {
      kind: "sequence",
      resolve: resolveYamlOmap2,
      construct: constructYamlOmap2
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/pairs.js
var require_pairs2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/pairs.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    var ast = require_yamlAST();
    var _toString2 = Object.prototype.toString;
    function resolveYamlPairs2(data) {
      if (null === data) {
        return true;
      }
      if (data.kind != ast.Kind.SEQ) {
        return false;
      }
      var index, length, pair, keys5, result, object3 = data.items;
      for (index = 0, length = object3.length; index < length; index += 1) {
        pair = object3[index];
        if ("[object Object]" !== _toString2.call(pair)) {
          return false;
        }
        if (!Array.isArray(pair.mappings)) {
          return false;
        }
        if (1 !== pair.mappings.length) {
          return false;
        }
      }
      return true;
    }
    function constructYamlPairs2(data) {
      if (null === data || !Array.isArray(data.items)) {
        return [];
      }
      var index, length, keys5, result, object3 = data.items;
      result = ast.newItems();
      result.parent = data.parent;
      result.startPosition = data.startPosition;
      result.endPosition = data.endPosition;
      for (index = 0, length = object3.length; index < length; index += 1) {
        var pair = object3[index];
        var mapping = pair.mappings[0];
        var pairSeq = ast.newItems();
        pairSeq.parent = result;
        pairSeq.startPosition = mapping.key.startPosition;
        pairSeq.endPosition = mapping.value.startPosition;
        mapping.key.parent = pairSeq;
        mapping.value.parent = pairSeq;
        pairSeq.items = [mapping.key, mapping.value];
        result.items.push(pairSeq);
      }
      return result;
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:pairs", {
      kind: "sequence",
      resolve: resolveYamlPairs2,
      construct: constructYamlPairs2
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/set.js
var require_set2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/set.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    var ast = require_yamlAST();
    function resolveYamlSet2(data) {
      if (null === data) {
        return true;
      }
      if (data.kind != ast.Kind.MAP) {
        return false;
      }
      return true;
    }
    function constructYamlSet2(data) {
      return null !== data ? data : {};
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:set", {
      kind: "mapping",
      resolve: resolveYamlSet2,
      construct: constructYamlSet2
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema/default_safe.js
var require_default_safe = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema/default_safe.js"(exports2, module2) {
    "use strict";
    var schema_1 = require_schema3();
    var schema2 = new schema_1.Schema({
      include: [
        require_core5()
      ],
      implicit: [
        require_timestamp2(),
        require_merge2()
      ],
      explicit: [
        require_binary2(),
        require_omap2(),
        require_pairs2(),
        require_set2()
      ]
    });
    module2.exports = schema2;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/js/undefined.js
var require_undefined = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/js/undefined.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    function resolveJavascriptUndefined() {
      return true;
    }
    function constructJavascriptUndefined() {
      return void 0;
    }
    function representJavascriptUndefined() {
      return "";
    }
    function isUndefined(object3) {
      return "undefined" === typeof object3;
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:js/undefined", {
      kind: "scalar",
      resolve: resolveJavascriptUndefined,
      construct: constructJavascriptUndefined,
      predicate: isUndefined,
      represent: representJavascriptUndefined
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/js/regexp.js
var require_regexp = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/type/js/regexp.js"(exports2, module2) {
    "use strict";
    var type_1 = require_type2();
    function resolveJavascriptRegExp(data) {
      if (null === data) {
        return false;
      }
      if (0 === data.length) {
        return false;
      }
      var regexp = data, tail = /\/([gim]*)$/.exec(data), modifiers = "";
      if ("/" === regexp[0]) {
        if (tail) {
          modifiers = tail[1];
        }
        if (modifiers.length > 3) {
          return false;
        }
        if (regexp[regexp.length - modifiers.length - 1] !== "/") {
          return false;
        }
        regexp = regexp.slice(1, regexp.length - modifiers.length - 1);
      }
      try {
        var dummy = new RegExp(regexp, modifiers);
        return true;
      } catch (error) {
        return false;
      }
    }
    function constructJavascriptRegExp(data) {
      var regexp = data, tail = /\/([gim]*)$/.exec(data), modifiers = "";
      if ("/" === regexp[0]) {
        if (tail) {
          modifiers = tail[1];
        }
        regexp = regexp.slice(1, regexp.length - modifiers.length - 1);
      }
      return new RegExp(regexp, modifiers);
    }
    function representJavascriptRegExp(object3) {
      var result = "/" + object3.source + "/";
      if (object3.global) {
        result += "g";
      }
      if (object3.multiline) {
        result += "m";
      }
      if (object3.ignoreCase) {
        result += "i";
      }
      return result;
    }
    function isRegExp(object3) {
      return "[object RegExp]" === Object.prototype.toString.call(object3);
    }
    module2.exports = new type_1.Type("tag:yaml.org,2002:js/regexp", {
      kind: "scalar",
      resolve: resolveJavascriptRegExp,
      construct: constructJavascriptRegExp,
      predicate: isRegExp,
      represent: representJavascriptRegExp
    });
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema/default_full.js
var require_default_full = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/schema/default_full.js"(exports2, module2) {
    "use strict";
    var schema_1 = require_schema3();
    var schema2 = new schema_1.Schema({
      include: [
        require_default_safe()
      ],
      explicit: [
        require_undefined(),
        require_regexp()
      ]
    });
    schema_1.Schema.DEFAULT = schema2;
    module2.exports = schema2;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/loader.js
var require_loader2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/loader.js"(exports2, module2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var ast = require_yamlAST();
    var common2 = require_common2();
    var YAMLException2 = require_exception2();
    var Mark = require_mark();
    var DEFAULT_SAFE_SCHEMA = require_default_safe();
    var DEFAULT_FULL_SCHEMA = require_default_full();
    var _hasOwnProperty2 = Object.prototype.hasOwnProperty;
    var CONTEXT_FLOW_IN2 = 1;
    var CONTEXT_FLOW_OUT2 = 2;
    var CONTEXT_BLOCK_IN2 = 3;
    var CONTEXT_BLOCK_OUT2 = 4;
    var CHOMPING_CLIP2 = 1;
    var CHOMPING_STRIP2 = 2;
    var CHOMPING_KEEP2 = 3;
    var PATTERN_NON_PRINTABLE2 = /[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/;
    var PATTERN_NON_ASCII_LINE_BREAKS2 = /[\x85\u2028\u2029]/;
    var PATTERN_FLOW_INDICATORS2 = /[,\[\]\{\}]/;
    var PATTERN_TAG_HANDLE2 = /^(?:!|!!|![a-z\-]+!)$/i;
    var PATTERN_TAG_URI2 = /^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i;
    function is_EOL2(c) {
      return c === 10 || c === 13;
    }
    function is_WHITE_SPACE2(c) {
      return c === 9 || c === 32;
    }
    function is_WS_OR_EOL2(c) {
      return c === 9 || c === 32 || c === 10 || c === 13;
    }
    function is_FLOW_INDICATOR2(c) {
      return 44 === c || 91 === c || 93 === c || 123 === c || 125 === c;
    }
    function fromHexCode2(c) {
      var lc;
      if (48 <= c && c <= 57) {
        return c - 48;
      }
      lc = c | 32;
      if (97 <= lc && lc <= 102) {
        return lc - 97 + 10;
      }
      return -1;
    }
    function escapedHexLen2(c) {
      if (c === 120) {
        return 2;
      }
      if (c === 117) {
        return 4;
      }
      if (c === 85) {
        return 8;
      }
      return 0;
    }
    function fromDecimalCode2(c) {
      if (48 <= c && c <= 57) {
        return c - 48;
      }
      return -1;
    }
    function simpleEscapeSequence2(c) {
      return c === 48 ? "\0" : c === 97 ? "\x07" : c === 98 ? "\b" : c === 116 ? "	" : c === 9 ? "	" : c === 110 ? "\n" : c === 118 ? "\v" : c === 102 ? "\f" : c === 114 ? "\r" : c === 101 ? "\x1B" : c === 32 ? " " : c === 34 ? '"' : c === 47 ? "/" : c === 92 ? "\\" : c === 78 ? "\x85" : c === 95 ? "\xA0" : c === 76 ? "\u2028" : c === 80 ? "\u2029" : "";
    }
    function charFromCodepoint2(c) {
      if (c <= 65535) {
        return String.fromCharCode(c);
      }
      return String.fromCharCode((c - 65536 >> 10) + 55296, (c - 65536 & 1023) + 56320);
    }
    var simpleEscapeCheck2 = new Array(256);
    var simpleEscapeMap2 = new Array(256);
    var customEscapeCheck = new Array(256);
    var customEscapeMap = new Array(256);
    for (i = 0; i < 256; i++) {
      customEscapeMap[i] = simpleEscapeMap2[i] = simpleEscapeSequence2(i);
      simpleEscapeCheck2[i] = simpleEscapeMap2[i] ? 1 : 0;
      customEscapeCheck[i] = 1;
      if (!simpleEscapeCheck2[i]) {
        customEscapeMap[i] = "\\" + String.fromCharCode(i);
      }
    }
    var i;
    var State3 = /* @__PURE__ */ function () {
      function State4(input, options) {
        this.errorMap = {};
        this.errors = [];
        this.lines = [];
        this.input = input;
        this.filename = options["filename"] || null;
        this.schema = options["schema"] || DEFAULT_FULL_SCHEMA;
        this.onWarning = options["onWarning"] || null;
        this.legacy = options["legacy"] || false;
        this.allowAnyEscape = options["allowAnyEscape"] || false;
        this.ignoreDuplicateKeys = options["ignoreDuplicateKeys"] || false;
        this.implicitTypes = this.schema.compiledImplicit;
        this.typeMap = this.schema.compiledTypeMap;
        this.length = input.length;
        this.position = 0;
        this.line = 0;
        this.lineStart = 0;
        this.lineIndent = 0;
        this.documents = [];
      }
      return State4;
    }();
    function generateError2(state, message, isWarning) {
      if (isWarning === void 0) {
        isWarning = false;
      }
      return new YAMLException2(message, new Mark(state.filename, state.input, state.position, state.line, state.position - state.lineStart), isWarning);
    }
    function throwErrorFromPosition(state, position, message, isWarning, toLineEnd) {
      if (isWarning === void 0) {
        isWarning = false;
      }
      if (toLineEnd === void 0) {
        toLineEnd = false;
      }
      var line = positionToLine(state, position);
      if (!line) {
        return;
      }
      var hash2 = message + position;
      if (state.errorMap[hash2]) {
        return;
      }
      var mark = new Mark(state.filename, state.input, position, line.line, position - line.start);
      if (toLineEnd) {
        mark.toLineEnd = true;
      }
      var error = new YAMLException2(message, mark, isWarning);
      state.errors.push(error);
    }
    function throwError2(state, message) {
      var error = generateError2(state, message);
      var hash2 = error.message + error.mark.position;
      if (state.errorMap[hash2]) {
        return;
      }
      state.errors.push(error);
      state.errorMap[hash2] = 1;
      var or = state.position;
      while (true) {
        if (state.position >= state.input.length - 1) {
          return;
        }
        var c = state.input.charAt(state.position);
        if (c == "\n") {
          state.position--;
          if (state.position == or) {
            state.position += 1;
          }
          return;
        }
        if (c == "\r") {
          state.position--;
          if (state.position == or) {
            state.position += 1;
          }
          return;
        }
        state.position++;
      }
    }
    function throwWarning2(state, message) {
      var error = generateError2(state, message);
      if (state.onWarning) {
        state.onWarning.call(null, error);
      } else {
      }
    }
    var directiveHandlers2 = {
      YAML: function handleYamlDirective2(state, name, args) {
        var match, major, minor;
        if (null !== state.version) {
          throwError2(state, "duplication of %YAML directive");
        }
        if (1 !== args.length) {
          throwError2(state, "YAML directive accepts exactly one argument");
        }
        match = /^([0-9]+)\.([0-9]+)$/.exec(args[0]);
        if (null === match) {
          throwError2(state, "ill-formed argument of the YAML directive");
        }
        major = parseInt(match[1], 10);
        minor = parseInt(match[2], 10);
        if (1 !== major) {
          throwError2(state, "found incompatible YAML document (version 1.2 is required)");
        }
        state.version = args[0];
        state.checkLineBreaks = minor < 2;
        if (2 !== minor) {
          throwError2(state, "found incompatible YAML document (version 1.2 is required)");
        }
      },
      TAG: function handleTagDirective2(state, name, args) {
        var handle, prefix;
        if (2 !== args.length) {
          throwError2(state, "TAG directive accepts exactly two arguments");
        }
        handle = args[0];
        prefix = args[1];
        if (!PATTERN_TAG_HANDLE2.test(handle)) {
          throwError2(state, "ill-formed tag handle (first argument) of the TAG directive");
        }
        if (_hasOwnProperty2.call(state.tagMap, handle)) {
          throwError2(state, 'there is a previously declared suffix for "' + handle + '" tag handle');
        }
        if (!PATTERN_TAG_URI2.test(prefix)) {
          throwError2(state, "ill-formed tag prefix (second argument) of the TAG directive");
        }
        state.tagMap[handle] = prefix;
      }
    };
    function captureSegment2(state, start, end, checkJson) {
      var _position, _length, _character, _result;
      var scalar = state.result;
      if (scalar.startPosition == -1) {
        scalar.startPosition = start;
      }
      if (start <= end) {
        _result = state.input.slice(start, end);
        if (checkJson) {
          for (_position = 0, _length = _result.length; _position < _length; _position += 1) {
            _character = _result.charCodeAt(_position);
            if (!(9 === _character || 32 <= _character && _character <= 1114111)) {
              throwError2(state, "expected valid JSON character");
            }
          }
        } else if (PATTERN_NON_PRINTABLE2.test(_result)) {
          throwError2(state, "the stream contains non-printable characters");
        }
        scalar.value += _result;
        scalar.endPosition = end;
      }
    }
    function storeMappingPair2(state, _result, keyTag, keyNode, valueNode) {
      var index, quantity;
      if (keyNode == null) {
        return;
      }
      if (null === _result) {
        _result = {
          startPosition: keyNode.startPosition,
          endPosition: valueNode.endPosition,
          parent: null,
          errors: [],
          mappings: [],
          kind: ast.Kind.MAP
        };
      }
      var mapping = ast.newMapping(keyNode, valueNode);
      mapping.parent = _result;
      keyNode.parent = mapping;
      if (valueNode != null) {
        valueNode.parent = mapping;
      }
      !state.ignoreDuplicateKeys && _result.mappings.forEach(function (sibling) {
        if (sibling.key && sibling.key.value === (mapping.key && mapping.key.value)) {
          throwErrorFromPosition(state, mapping.key.startPosition, "duplicate key");
          throwErrorFromPosition(state, sibling.key.startPosition, "duplicate key");
        }
      });
      _result.mappings.push(mapping);
      _result.endPosition = valueNode ? valueNode.endPosition : keyNode.endPosition + 1;
      return _result;
    }
    function readLineBreak2(state) {
      var ch;
      ch = state.input.charCodeAt(state.position);
      if (10 === ch) {
        state.position++;
      } else if (13 === ch) {
        state.position++;
        if (10 === state.input.charCodeAt(state.position)) {
          state.position++;
        }
      } else {
        throwError2(state, "a line break is expected");
      }
      state.line += 1;
      state.lineStart = state.position;
      state.lines.push({
        start: state.lineStart,
        line: state.line
      });
    }
    function positionToLine(state, position) {
      var line;
      for (var i2 = 0; i2 < state.lines.length; i2++) {
        if (state.lines[i2].start > position) {
          break;
        }
        line = state.lines[i2];
      }
      if (!line) {
        return {
          start: 0,
          line: 0
        };
      }
      return line;
    }
    function skipSeparationSpace2(state, allowComments, checkIndent) {
      var lineBreaks = 0, ch = state.input.charCodeAt(state.position);
      while (0 !== ch) {
        while (is_WHITE_SPACE2(ch)) {
          if (ch === 9) {
            state.errors.push(generateError2(state, "Using tabs can lead to unpredictable results", true));
          }
          ch = state.input.charCodeAt(++state.position);
        }
        if (allowComments && 35 === ch) {
          do {
            ch = state.input.charCodeAt(++state.position);
          } while (ch !== 10 && ch !== 13 && 0 !== ch);
        }
        if (is_EOL2(ch)) {
          readLineBreak2(state);
          ch = state.input.charCodeAt(state.position);
          lineBreaks++;
          state.lineIndent = 0;
          while (32 === ch) {
            state.lineIndent++;
            ch = state.input.charCodeAt(++state.position);
          }
        } else {
          break;
        }
      }
      if (-1 !== checkIndent && 0 !== lineBreaks && state.lineIndent < checkIndent) {
        throwWarning2(state, "deficient indentation");
      }
      return lineBreaks;
    }
    function testDocumentSeparator2(state) {
      var _position = state.position, ch;
      ch = state.input.charCodeAt(_position);
      if ((45 === ch || 46 === ch) && state.input.charCodeAt(_position + 1) === ch && state.input.charCodeAt(_position + 2) === ch) {
        _position += 3;
        ch = state.input.charCodeAt(_position);
        if (ch === 0 || is_WS_OR_EOL2(ch)) {
          return true;
        }
      }
      return false;
    }
    function writeFoldedLines2(state, scalar, count) {
      if (1 === count) {
        scalar.value += " ";
      } else if (count > 1) {
        scalar.value += common2.repeat("\n", count - 1);
      }
    }
    function readPlainScalar2(state, nodeIndent, withinFlowCollection) {
      var preceding, following, captureStart, captureEnd, hasPendingContent, _line, _lineStart, _lineIndent, _kind = state.kind, _result = state.result, ch;
      var state_result = ast.newScalar();
      state_result.plainScalar = true;
      state.result = state_result;
      ch = state.input.charCodeAt(state.position);
      if (is_WS_OR_EOL2(ch) || is_FLOW_INDICATOR2(ch) || 35 === ch || 38 === ch || 42 === ch || 33 === ch || 124 === ch || 62 === ch || 39 === ch || 34 === ch || 37 === ch || 64 === ch || 96 === ch) {
        return false;
      }
      if (63 === ch || 45 === ch) {
        following = state.input.charCodeAt(state.position + 1);
        if (is_WS_OR_EOL2(following) || withinFlowCollection && is_FLOW_INDICATOR2(following)) {
          return false;
        }
      }
      state.kind = "scalar";
      captureStart = captureEnd = state.position;
      hasPendingContent = false;
      while (0 !== ch) {
        if (58 === ch) {
          following = state.input.charCodeAt(state.position + 1);
          if (is_WS_OR_EOL2(following) || withinFlowCollection && is_FLOW_INDICATOR2(following)) {
            break;
          }
        } else if (35 === ch) {
          preceding = state.input.charCodeAt(state.position - 1);
          if (is_WS_OR_EOL2(preceding)) {
            break;
          }
        } else if (state.position === state.lineStart && testDocumentSeparator2(state) || withinFlowCollection && is_FLOW_INDICATOR2(ch)) {
          break;
        } else if (is_EOL2(ch)) {
          _line = state.line;
          _lineStart = state.lineStart;
          _lineIndent = state.lineIndent;
          skipSeparationSpace2(state, false, -1);
          if (state.lineIndent >= nodeIndent) {
            hasPendingContent = true;
            ch = state.input.charCodeAt(state.position);
            continue;
          } else {
            state.position = captureEnd;
            state.line = _line;
            state.lineStart = _lineStart;
            state.lineIndent = _lineIndent;
            break;
          }
        }
        if (hasPendingContent) {
          captureSegment2(state, captureStart, captureEnd, false);
          writeFoldedLines2(state, state_result, state.line - _line);
          captureStart = captureEnd = state.position;
          hasPendingContent = false;
        }
        if (!is_WHITE_SPACE2(ch)) {
          captureEnd = state.position + 1;
        }
        ch = state.input.charCodeAt(++state.position);
        if (state.position >= state.input.length) {
          return false;
        }
      }
      captureSegment2(state, captureStart, captureEnd, false);
      if (state.result.startPosition != -1) {
        state_result.rawValue = state.input.substring(state_result.startPosition, state_result.endPosition);
        return true;
      }
      state.kind = _kind;
      state.result = _result;
      return false;
    }
    function readSingleQuotedScalar2(state, nodeIndent) {
      var ch, captureStart, captureEnd;
      ch = state.input.charCodeAt(state.position);
      if (39 !== ch) {
        return false;
      }
      var scalar = ast.newScalar();
      scalar.singleQuoted = true;
      state.kind = "scalar";
      state.result = scalar;
      scalar.startPosition = state.position;
      state.position++;
      captureStart = captureEnd = state.position;
      while (0 !== (ch = state.input.charCodeAt(state.position))) {
        if (39 === ch) {
          captureSegment2(state, captureStart, state.position, true);
          ch = state.input.charCodeAt(++state.position);
          scalar.endPosition = state.position;
          if (39 === ch) {
            captureStart = captureEnd = state.position;
            state.position++;
          } else {
            return true;
          }
        } else if (is_EOL2(ch)) {
          captureSegment2(state, captureStart, captureEnd, true);
          writeFoldedLines2(state, scalar, skipSeparationSpace2(state, false, nodeIndent));
          captureStart = captureEnd = state.position;
        } else if (state.position === state.lineStart && testDocumentSeparator2(state)) {
          throwError2(state, "unexpected end of the document within a single quoted scalar");
        } else {
          state.position++;
          captureEnd = state.position;
          scalar.endPosition = state.position;
        }
      }
      throwError2(state, "unexpected end of the stream within a single quoted scalar");
    }
    function readDoubleQuotedScalar2(state, nodeIndent) {
      var captureStart, captureEnd, hexLength, hexResult, tmp, tmpEsc, ch;
      ch = state.input.charCodeAt(state.position);
      if (34 !== ch) {
        return false;
      }
      state.kind = "scalar";
      var scalar = ast.newScalar();
      scalar.doubleQuoted = true;
      state.result = scalar;
      scalar.startPosition = state.position;
      state.position++;
      captureStart = captureEnd = state.position;
      while (0 !== (ch = state.input.charCodeAt(state.position))) {
        if (34 === ch) {
          captureSegment2(state, captureStart, state.position, true);
          state.position++;
          scalar.endPosition = state.position;
          scalar.rawValue = state.input.substring(scalar.startPosition, scalar.endPosition);
          return true;
        } else if (92 === ch) {
          captureSegment2(state, captureStart, state.position, true);
          ch = state.input.charCodeAt(++state.position);
          if (is_EOL2(ch)) {
            skipSeparationSpace2(state, false, nodeIndent);
          } else if (ch < 256 && (state.allowAnyEscape ? customEscapeCheck[ch] : simpleEscapeCheck2[ch])) {
            scalar.value += state.allowAnyEscape ? customEscapeMap[ch] : simpleEscapeMap2[ch];
            state.position++;
          } else if ((tmp = escapedHexLen2(ch)) > 0) {
            hexLength = tmp;
            hexResult = 0;
            for (; hexLength > 0; hexLength--) {
              ch = state.input.charCodeAt(++state.position);
              if ((tmp = fromHexCode2(ch)) >= 0) {
                hexResult = (hexResult << 4) + tmp;
              } else {
                throwError2(state, "expected hexadecimal character");
              }
            }
            scalar.value += charFromCodepoint2(hexResult);
            state.position++;
          } else {
            throwError2(state, "unknown escape sequence");
          }
          captureStart = captureEnd = state.position;
        } else if (is_EOL2(ch)) {
          captureSegment2(state, captureStart, captureEnd, true);
          writeFoldedLines2(state, scalar, skipSeparationSpace2(state, false, nodeIndent));
          captureStart = captureEnd = state.position;
        } else if (state.position === state.lineStart && testDocumentSeparator2(state)) {
          throwError2(state, "unexpected end of the document within a double quoted scalar");
        } else {
          state.position++;
          captureEnd = state.position;
        }
      }
      throwError2(state, "unexpected end of the stream within a double quoted scalar");
    }
    function readFlowCollection2(state, nodeIndent) {
      var readNext = true, _line, _tag = state.tag, _result, _anchor = state.anchor, following, terminator, isPair, isExplicitPair, isMapping, keyNode, keyTag, valueNode, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch === 91) {
        terminator = 93;
        isMapping = false;
        _result = ast.newItems();
        _result.startPosition = state.position;
      } else if (ch === 123) {
        terminator = 125;
        isMapping = true;
        _result = ast.newMap();
        _result.startPosition = state.position;
      } else {
        return false;
      }
      if (null !== state.anchor) {
        _result.anchorId = state.anchor;
        state.anchorMap[state.anchor] = _result;
      }
      ch = state.input.charCodeAt(++state.position);
      while (0 !== ch) {
        skipSeparationSpace2(state, true, nodeIndent);
        ch = state.input.charCodeAt(state.position);
        if (ch === terminator) {
          state.position++;
          state.tag = _tag;
          state.anchor = _anchor;
          state.kind = isMapping ? "mapping" : "sequence";
          state.result = _result;
          _result.endPosition = state.position;
          return true;
        } else if (!readNext) {
          var p = state.position;
          throwError2(state, "missed comma between flow collection entries");
          state.position = p + 1;
        }
        keyTag = keyNode = valueNode = null;
        isPair = isExplicitPair = false;
        if (63 === ch) {
          following = state.input.charCodeAt(state.position + 1);
          if (is_WS_OR_EOL2(following)) {
            isPair = isExplicitPair = true;
            state.position++;
            skipSeparationSpace2(state, true, nodeIndent);
          }
        }
        _line = state.line;
        composeNode2(state, nodeIndent, CONTEXT_FLOW_IN2, false, true);
        keyTag = state.tag;
        keyNode = state.result;
        skipSeparationSpace2(state, true, nodeIndent);
        ch = state.input.charCodeAt(state.position);
        if ((isExplicitPair || state.line === _line) && 58 === ch) {
          isPair = true;
          ch = state.input.charCodeAt(++state.position);
          skipSeparationSpace2(state, true, nodeIndent);
          composeNode2(state, nodeIndent, CONTEXT_FLOW_IN2, false, true);
          valueNode = state.result;
        }
        if (isMapping) {
          storeMappingPair2(state, _result, keyTag, keyNode, valueNode);
        } else if (isPair) {
          var mp = storeMappingPair2(state, null, keyTag, keyNode, valueNode);
          mp.parent = _result;
          _result.items.push(mp);
        } else {
          if (keyNode) {
            keyNode.parent = _result;
          }
          _result.items.push(keyNode);
        }
        _result.endPosition = state.position + 1;
        skipSeparationSpace2(state, true, nodeIndent);
        ch = state.input.charCodeAt(state.position);
        if (44 === ch) {
          readNext = true;
          ch = state.input.charCodeAt(++state.position);
        } else {
          readNext = false;
        }
      }
      throwError2(state, "unexpected end of the stream within a flow collection");
    }
    function readBlockScalar2(state, nodeIndent) {
      var captureStart, folding, chomping = CHOMPING_CLIP2, detectedIndent = false, textIndent = nodeIndent, emptyLines = 0, atMoreIndented = false, tmp, ch;
      ch = state.input.charCodeAt(state.position);
      if (ch === 124) {
        folding = false;
      } else if (ch === 62) {
        folding = true;
      } else {
        return false;
      }
      var sc = ast.newScalar();
      state.kind = "scalar";
      state.result = sc;
      sc.startPosition = state.position;
      while (0 !== ch) {
        ch = state.input.charCodeAt(++state.position);
        if (43 === ch || 45 === ch) {
          if (CHOMPING_CLIP2 === chomping) {
            chomping = 43 === ch ? CHOMPING_KEEP2 : CHOMPING_STRIP2;
          } else {
            throwError2(state, "repeat of a chomping mode identifier");
          }
        } else if ((tmp = fromDecimalCode2(ch)) >= 0) {
          if (tmp === 0) {
            throwError2(state, "bad explicit indentation width of a block scalar; it cannot be less than one");
          } else if (!detectedIndent) {
            textIndent = nodeIndent + tmp - 1;
            detectedIndent = true;
          } else {
            throwError2(state, "repeat of an indentation width identifier");
          }
        } else {
          break;
        }
      }
      if (is_WHITE_SPACE2(ch)) {
        do {
          ch = state.input.charCodeAt(++state.position);
        } while (is_WHITE_SPACE2(ch));
        if (35 === ch) {
          do {
            ch = state.input.charCodeAt(++state.position);
          } while (!is_EOL2(ch) && 0 !== ch);
        }
      }
      while (0 !== ch) {
        readLineBreak2(state);
        state.lineIndent = 0;
        ch = state.input.charCodeAt(state.position);
        while ((!detectedIndent || state.lineIndent < textIndent) && 32 === ch) {
          state.lineIndent++;
          ch = state.input.charCodeAt(++state.position);
        }
        if (!detectedIndent && state.lineIndent > textIndent) {
          textIndent = state.lineIndent;
        }
        if (is_EOL2(ch)) {
          emptyLines++;
          continue;
        }
        if (state.lineIndent < textIndent) {
          if (chomping === CHOMPING_KEEP2) {
            sc.value += common2.repeat("\n", emptyLines);
          } else if (chomping === CHOMPING_CLIP2) {
            if (detectedIndent) {
              sc.value += "\n";
            }
          }
          break;
        }
        if (folding) {
          if (is_WHITE_SPACE2(ch)) {
            atMoreIndented = true;
            sc.value += common2.repeat("\n", emptyLines + 1);
          } else if (atMoreIndented) {
            atMoreIndented = false;
            sc.value += common2.repeat("\n", emptyLines + 1);
          } else if (0 === emptyLines) {
            if (detectedIndent) {
              sc.value += " ";
            }
          } else {
            sc.value += common2.repeat("\n", emptyLines);
          }
        } else if (detectedIndent) {
          sc.value += common2.repeat("\n", emptyLines + 1);
        } else {
        }
        detectedIndent = true;
        emptyLines = 0;
        captureStart = state.position;
        while (!is_EOL2(ch) && 0 !== ch) {
          ch = state.input.charCodeAt(++state.position);
        }
        captureSegment2(state, captureStart, state.position, false);
      }
      sc.endPosition = state.position;
      var i2 = state.position - 1;
      var needMinus = false;
      while (true) {
        var c = state.input[i2];
        if (c == "\r" || c == "\n") {
          if (needMinus) {
            i2--;
          }
          break;
        }
        if (c != " " && c != "	") {
          break;
        }
        i2--;
      }
      sc.endPosition = i2;
      sc.rawValue = state.input.substring(sc.startPosition, sc.endPosition);
      return true;
    }
    function readBlockSequence2(state, nodeIndent) {
      var _line, _tag = state.tag, _anchor = state.anchor, _result = ast.newItems(), following, detected = false, ch;
      if (null !== state.anchor) {
        _result.anchorId = state.anchor;
        state.anchorMap[state.anchor] = _result;
      }
      _result.startPosition = state.position;
      ch = state.input.charCodeAt(state.position);
      while (0 !== ch) {
        if (45 !== ch) {
          break;
        }
        following = state.input.charCodeAt(state.position + 1);
        if (!is_WS_OR_EOL2(following)) {
          break;
        }
        detected = true;
        state.position++;
        if (skipSeparationSpace2(state, true, -1)) {
          if (state.lineIndent <= nodeIndent) {
            _result.items.push(null);
            ch = state.input.charCodeAt(state.position);
            continue;
          }
        }
        _line = state.line;
        composeNode2(state, nodeIndent, CONTEXT_BLOCK_IN2, false, true);
        if (state.result) {
          state.result.parent = _result;
          _result.items.push(state.result);
        }
        skipSeparationSpace2(state, true, -1);
        ch = state.input.charCodeAt(state.position);
        if ((state.line === _line || state.lineIndent > nodeIndent) && 0 !== ch) {
          throwError2(state, "bad indentation of a sequence entry");
        } else if (state.lineIndent < nodeIndent) {
          break;
        }
      }
      _result.endPosition = state.position;
      if (detected) {
        state.tag = _tag;
        state.anchor = _anchor;
        state.kind = "sequence";
        state.result = _result;
        _result.endPosition = state.position;
        return true;
      }
      return false;
    }
    function readBlockMapping2(state, nodeIndent, flowIndent) {
      var following, allowCompact, _line, _tag = state.tag, _anchor = state.anchor, _result = ast.newMap(), keyTag = null, keyNode = null, valueNode = null, atExplicitKey = false, detected = false, ch;
      _result.startPosition = state.position;
      if (null !== state.anchor) {
        _result.anchorId = state.anchor;
        state.anchorMap[state.anchor] = _result;
      }
      ch = state.input.charCodeAt(state.position);
      while (0 !== ch) {
        following = state.input.charCodeAt(state.position + 1);
        _line = state.line;
        if ((63 === ch || 58 === ch) && is_WS_OR_EOL2(following)) {
          if (63 === ch) {
            if (atExplicitKey) {
              storeMappingPair2(state, _result, keyTag, keyNode, null);
              keyTag = keyNode = valueNode = null;
            }
            detected = true;
            atExplicitKey = true;
            allowCompact = true;
          } else if (atExplicitKey) {
            atExplicitKey = false;
            allowCompact = true;
          } else {
            throwError2(state, "incomplete explicit mapping pair; a key node is missed");
          }
          state.position += 1;
          ch = following;
        } else if (composeNode2(state, flowIndent, CONTEXT_FLOW_OUT2, false, true)) {
          if (state.line === _line) {
            ch = state.input.charCodeAt(state.position);
            while (is_WHITE_SPACE2(ch)) {
              ch = state.input.charCodeAt(++state.position);
            }
            if (58 === ch) {
              ch = state.input.charCodeAt(++state.position);
              if (!is_WS_OR_EOL2(ch)) {
                throwError2(state, "a whitespace character is expected after the key-value separator within a block mapping");
              }
              if (atExplicitKey) {
                storeMappingPair2(state, _result, keyTag, keyNode, null);
                keyTag = keyNode = valueNode = null;
              }
              detected = true;
              atExplicitKey = false;
              allowCompact = false;
              keyTag = state.tag;
              keyNode = state.result;
            } else if (state.position == state.lineStart && testDocumentSeparator2(state)) {
              break;
            } else if (detected) {
              throwError2(state, "can not read an implicit mapping pair; a colon is missed");
            } else {
              state.tag = _tag;
              state.anchor = _anchor;
              return true;
            }
          } else if (detected) {
            throwError2(state, "can not read a block mapping entry; a multiline key may not be an implicit key");
            while (state.position > 0) {
              ch = state.input.charCodeAt(--state.position);
              if (is_EOL2(ch)) {
                state.position++;
                break;
              }
            }
          } else {
            state.tag = _tag;
            state.anchor = _anchor;
            return true;
          }
        } else {
          break;
        }
        if (state.line === _line || state.lineIndent > nodeIndent) {
          if (composeNode2(state, nodeIndent, CONTEXT_BLOCK_OUT2, true, allowCompact)) {
            if (atExplicitKey) {
              keyNode = state.result;
            } else {
              valueNode = state.result;
            }
          }
          if (!atExplicitKey) {
            storeMappingPair2(state, _result, keyTag, keyNode, valueNode);
            keyTag = keyNode = valueNode = null;
          }
          skipSeparationSpace2(state, true, -1);
          ch = state.input.charCodeAt(state.position);
        }
        if (state.lineIndent > nodeIndent && 0 !== ch) {
          throwError2(state, "bad indentation of a mapping entry");
        } else if (state.lineIndent < nodeIndent) {
          break;
        }
      }
      if (atExplicitKey) {
        storeMappingPair2(state, _result, keyTag, keyNode, null);
      }
      if (detected) {
        state.tag = _tag;
        state.anchor = _anchor;
        state.kind = "mapping";
        state.result = _result;
      }
      return detected;
    }
    function readTagProperty2(state) {
      var _position, isVerbatim = false, isNamed = false, tagHandle, tagName, ch;
      ch = state.input.charCodeAt(state.position);
      if (33 !== ch) {
        return false;
      }
      if (null !== state.tag) {
        throwError2(state, "duplication of a tag property");
      }
      ch = state.input.charCodeAt(++state.position);
      if (60 === ch) {
        isVerbatim = true;
        ch = state.input.charCodeAt(++state.position);
      } else if (33 === ch) {
        isNamed = true;
        tagHandle = "!!";
        ch = state.input.charCodeAt(++state.position);
      } else {
        tagHandle = "!";
      }
      _position = state.position;
      if (isVerbatim) {
        do {
          ch = state.input.charCodeAt(++state.position);
        } while (0 !== ch && 62 !== ch);
        if (state.position < state.length) {
          tagName = state.input.slice(_position, state.position);
          ch = state.input.charCodeAt(++state.position);
        } else {
          throwError2(state, "unexpected end of the stream within a verbatim tag");
        }
      } else {
        while (0 !== ch && !is_WS_OR_EOL2(ch)) {
          if (33 === ch) {
            if (!isNamed) {
              tagHandle = state.input.slice(_position - 1, state.position + 1);
              if (!PATTERN_TAG_HANDLE2.test(tagHandle)) {
                throwError2(state, "named tag handle cannot contain such characters");
              }
              isNamed = true;
              _position = state.position + 1;
            } else {
              throwError2(state, "tag suffix cannot contain exclamation marks");
            }
          }
          ch = state.input.charCodeAt(++state.position);
        }
        tagName = state.input.slice(_position, state.position);
        if (PATTERN_FLOW_INDICATORS2.test(tagName)) {
          throwError2(state, "tag suffix cannot contain flow indicator characters");
        }
      }
      if (tagName && !PATTERN_TAG_URI2.test(tagName)) {
        throwError2(state, "tag name cannot contain such characters: " + tagName);
      }
      if (isVerbatim) {
        state.tag = tagName;
      } else if (_hasOwnProperty2.call(state.tagMap, tagHandle)) {
        state.tag = state.tagMap[tagHandle] + tagName;
      } else if ("!" === tagHandle) {
        state.tag = "!" + tagName;
      } else if ("!!" === tagHandle) {
        state.tag = "tag:yaml.org,2002:" + tagName;
      } else {
        throwError2(state, 'undeclared tag handle "' + tagHandle + '"');
      }
      return true;
    }
    function readAnchorProperty2(state) {
      var _position, ch;
      ch = state.input.charCodeAt(state.position);
      if (38 !== ch) {
        return false;
      }
      if (null !== state.anchor) {
        throwError2(state, "duplication of an anchor property");
      }
      ch = state.input.charCodeAt(++state.position);
      _position = state.position;
      while (0 !== ch && !is_WS_OR_EOL2(ch) && !is_FLOW_INDICATOR2(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      if (state.position === _position) {
        throwError2(state, "name of an anchor node must contain at least one character");
      }
      state.anchor = state.input.slice(_position, state.position);
      return true;
    }
    function readAlias2(state) {
      var _position, alias, len = state.length, input = state.input, ch;
      ch = state.input.charCodeAt(state.position);
      if (42 !== ch) {
        return false;
      }
      ch = state.input.charCodeAt(++state.position);
      _position = state.position;
      while (0 !== ch && !is_WS_OR_EOL2(ch) && !is_FLOW_INDICATOR2(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      if (state.position <= _position) {
        throwError2(state, "name of an alias node must contain at least one character");
        state.position = _position + 1;
      }
      alias = state.input.slice(_position, state.position);
      if (!state.anchorMap.hasOwnProperty(alias)) {
        throwError2(state, 'unidentified alias "' + alias + '"');
        if (state.position <= _position) {
          state.position = _position + 1;
        }
      }
      state.result = ast.newAnchorRef(alias, _position, state.position, state.anchorMap[alias]);
      skipSeparationSpace2(state, true, -1);
      return true;
    }
    function composeNode2(state, parentIndent, nodeContext, allowToSeek, allowCompact) {
      var allowBlockStyles, allowBlockScalars, allowBlockCollections, indentStatus = 1, atNewLine = false, hasContent = false, typeIndex, typeQuantity, type2, flowIndent, blockIndent, _result;
      state.tag = null;
      state.anchor = null;
      state.kind = null;
      state.result = null;
      allowBlockStyles = allowBlockScalars = allowBlockCollections = CONTEXT_BLOCK_OUT2 === nodeContext || CONTEXT_BLOCK_IN2 === nodeContext;
      if (allowToSeek) {
        if (skipSeparationSpace2(state, true, -1)) {
          atNewLine = true;
          if (state.lineIndent > parentIndent) {
            indentStatus = 1;
          } else if (state.lineIndent === parentIndent) {
            indentStatus = 0;
          } else if (state.lineIndent < parentIndent) {
            indentStatus = -1;
          }
        }
      }
      var tagStart = state.position;
      var tagColumn = state.position - state.lineStart;
      if (1 === indentStatus) {
        while (readTagProperty2(state) || readAnchorProperty2(state)) {
          if (skipSeparationSpace2(state, true, -1)) {
            atNewLine = true;
            allowBlockCollections = allowBlockStyles;
            if (state.lineIndent > parentIndent) {
              indentStatus = 1;
            } else if (state.lineIndent === parentIndent) {
              indentStatus = 0;
            } else if (state.lineIndent < parentIndent) {
              indentStatus = -1;
            }
          } else {
            allowBlockCollections = false;
          }
        }
      }
      if (allowBlockCollections) {
        allowBlockCollections = atNewLine || allowCompact;
      }
      if (1 === indentStatus || CONTEXT_BLOCK_OUT2 === nodeContext) {
        if (CONTEXT_FLOW_IN2 === nodeContext || CONTEXT_FLOW_OUT2 === nodeContext) {
          flowIndent = parentIndent;
        } else {
          flowIndent = parentIndent + 1;
        }
        blockIndent = state.position - state.lineStart;
        if (1 === indentStatus) {
          if (allowBlockCollections && (readBlockSequence2(state, blockIndent) || readBlockMapping2(state, blockIndent, flowIndent)) || readFlowCollection2(state, flowIndent)) {
            hasContent = true;
          } else {
            if (allowBlockScalars && readBlockScalar2(state, flowIndent) || readSingleQuotedScalar2(state, flowIndent) || readDoubleQuotedScalar2(state, flowIndent)) {
              hasContent = true;
            } else if (readAlias2(state)) {
              hasContent = true;
              if (null !== state.tag || null !== state.anchor) {
                throwError2(state, "alias node should not have any properties");
              }
            } else if (readPlainScalar2(state, flowIndent, CONTEXT_FLOW_IN2 === nodeContext)) {
              hasContent = true;
              if (null === state.tag) {
                state.tag = "?";
              }
            }
            if (null !== state.anchor) {
              state.anchorMap[state.anchor] = state.result;
              state.result.anchorId = state.anchor;
            }
          }
        } else if (0 === indentStatus) {
          hasContent = allowBlockCollections && readBlockSequence2(state, blockIndent);
        }
      }
      if (null !== state.tag && "!" !== state.tag) {
        if (state.tag == "!include") {
          if (!state.result) {
            state.result = ast.newScalar();
            state.result.startPosition = state.position;
            state.result.endPosition = state.position;
            throwError2(state, "!include without value");
          }
          state.result.kind = ast.Kind.INCLUDE_REF;
        } else if ("?" === state.tag) {
          for (typeIndex = 0, typeQuantity = state.implicitTypes.length; typeIndex < typeQuantity; typeIndex += 1) {
            type2 = state.implicitTypes[typeIndex];
            var vl = state.result["value"];
            if (type2.resolve(vl)) {
              state.result.valueObject = type2.construct(state.result["value"]);
              state.tag = type2.tag;
              if (null !== state.anchor) {
                state.result.anchorId = state.anchor;
                state.anchorMap[state.anchor] = state.result;
              }
              break;
            }
          }
        } else if (_hasOwnProperty2.call(state.typeMap, state.tag)) {
          type2 = state.typeMap[state.tag];
          if (null !== state.result && type2.kind !== state.kind) {
            throwError2(state, "unacceptable node kind for !<" + state.tag + '> tag; it should be "' + type2.kind + '", not "' + state.kind + '"');
          }
          if (!type2.resolve(state.result)) {
            throwError2(state, "cannot resolve a node with !<" + state.tag + "> explicit tag");
          } else {
            state.result = type2.construct(state.result);
            if (null !== state.anchor) {
              state.result.anchorId = state.anchor;
              state.anchorMap[state.anchor] = state.result;
            }
          }
        } else {
          throwErrorFromPosition(state, tagStart, "unknown tag <" + state.tag + ">", false, true);
        }
      }
      return null !== state.tag || null !== state.anchor || hasContent;
    }
    function readDocument2(state) {
      var documentStart = state.position, _position, directiveName, directiveArgs, hasDirectives = false, ch;
      state.version = null;
      state.checkLineBreaks = state.legacy;
      state.tagMap = {};
      state.anchorMap = {};
      while (0 !== (ch = state.input.charCodeAt(state.position))) {
        skipSeparationSpace2(state, true, -1);
        ch = state.input.charCodeAt(state.position);
        if (state.lineIndent > 0 || 37 !== ch) {
          break;
        }
        hasDirectives = true;
        ch = state.input.charCodeAt(++state.position);
        _position = state.position;
        while (0 !== ch && !is_WS_OR_EOL2(ch)) {
          ch = state.input.charCodeAt(++state.position);
        }
        directiveName = state.input.slice(_position, state.position);
        directiveArgs = [];
        if (directiveName.length < 1) {
          throwError2(state, "directive name must not be less than one character in length");
        }
        while (0 !== ch) {
          while (is_WHITE_SPACE2(ch)) {
            ch = state.input.charCodeAt(++state.position);
          }
          if (35 === ch) {
            do {
              ch = state.input.charCodeAt(++state.position);
            } while (0 !== ch && !is_EOL2(ch));
            break;
          }
          if (is_EOL2(ch)) {
            break;
          }
          _position = state.position;
          while (0 !== ch && !is_WS_OR_EOL2(ch)) {
            ch = state.input.charCodeAt(++state.position);
          }
          directiveArgs.push(state.input.slice(_position, state.position));
        }
        if (0 !== ch) {
          readLineBreak2(state);
        }
        if (_hasOwnProperty2.call(directiveHandlers2, directiveName)) {
          directiveHandlers2[directiveName](state, directiveName, directiveArgs);
        } else {
          throwWarning2(state, 'unknown document directive "' + directiveName + '"');
          state.position++;
        }
      }
      skipSeparationSpace2(state, true, -1);
      if (0 === state.lineIndent && 45 === state.input.charCodeAt(state.position) && 45 === state.input.charCodeAt(state.position + 1) && 45 === state.input.charCodeAt(state.position + 2)) {
        state.position += 3;
        skipSeparationSpace2(state, true, -1);
      } else if (hasDirectives) {
        throwError2(state, "directives end mark is expected");
      }
      composeNode2(state, state.lineIndent - 1, CONTEXT_BLOCK_OUT2, false, true);
      skipSeparationSpace2(state, true, -1);
      if (state.checkLineBreaks && PATTERN_NON_ASCII_LINE_BREAKS2.test(state.input.slice(documentStart, state.position))) {
        throwWarning2(state, "non-ASCII line breaks are interpreted as content");
      }
      state.documents.push(state.result);
      if (state.position === state.lineStart && testDocumentSeparator2(state)) {
        if (46 === state.input.charCodeAt(state.position)) {
          state.position += 3;
          skipSeparationSpace2(state, true, -1);
        }
        return;
      }
      if (state.position < state.length - 1) {
        throwError2(state, "end of the stream or a document separator is expected");
      } else {
        return;
      }
    }
    function loadDocuments2(input, options) {
      input = String(input);
      options = options || {};
      var inputLength = input.length;
      if (inputLength !== 0) {
        if (10 !== input.charCodeAt(inputLength - 1) && 13 !== input.charCodeAt(inputLength - 1)) {
          input += "\n";
        }
        if (input.charCodeAt(0) === 65279) {
          input = input.slice(1);
        }
      }
      var state = new State3(input, options);
      state.input += "\0";
      while (32 === state.input.charCodeAt(state.position)) {
        state.lineIndent += 1;
        state.position += 1;
      }
      while (state.position < state.length - 1) {
        var q = state.position;
        readDocument2(state);
        if (state.position <= q) {
          for (; state.position < state.length - 1; state.position++) {
            var c = state.input.charAt(state.position);
            if (c == "\n") {
              break;
            }
          }
        }
      }
      var documents = state.documents;
      var docsCount = documents.length;
      if (docsCount > 0) {
        documents[docsCount - 1].endPosition = inputLength;
      }
      for (var _i = 0, documents_1 = documents; _i < documents_1.length; _i++) {
        var x = documents_1[_i];
        x.errors = state.errors;
        if (x.startPosition > x.endPosition) {
          x.startPosition = x.endPosition;
        }
      }
      return documents;
    }
    function loadAll2(input, iterator, options) {
      if (options === void 0) {
        options = {};
      }
      var documents = loadDocuments2(input, options), index, length;
      for (index = 0, length = documents.length; index < length; index += 1) {
        iterator(documents[index]);
      }
    }
    exports2.loadAll = loadAll2;
    function load2(input, options) {
      if (options === void 0) {
        options = {};
      }
      var documents = loadDocuments2(input, options), index, length;
      if (0 === documents.length) {
        return void 0;
      } else if (1 === documents.length) {
        return documents[0];
      }
      var e = new YAMLException2("expected a single document in the stream, but found more");
      e.mark = new Mark("", "", 0, 0, 0);
      e.mark.position = documents[0].endPosition;
      documents[0].errors.push(e);
      return documents[0];
    }
    exports2.load = load2;
    function safeLoadAll2(input, output, options) {
      if (options === void 0) {
        options = {};
      }
      loadAll2(input, output, common2.extend({ schema: DEFAULT_SAFE_SCHEMA }, options));
    }
    exports2.safeLoadAll = safeLoadAll2;
    function safeLoad2(input, options) {
      if (options === void 0) {
        options = {};
      }
      return load2(input, common2.extend({ schema: DEFAULT_SAFE_SCHEMA }, options));
    }
    exports2.safeLoad = safeLoad2;
    module2.exports.loadAll = loadAll2;
    module2.exports.load = load2;
    module2.exports.safeLoadAll = safeLoadAll2;
    module2.exports.safeLoad = safeLoad2;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/dumper.js
var require_dumper2 = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/dumper.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var common2 = require_common2();
    var YAMLException2 = require_exception2();
    var DEFAULT_FULL_SCHEMA = require_default_full();
    var DEFAULT_SAFE_SCHEMA = require_default_safe();
    var _toString2 = Object.prototype.toString;
    var _hasOwnProperty2 = Object.prototype.hasOwnProperty;
    var CHAR_TAB2 = 9;
    var CHAR_LINE_FEED2 = 10;
    var CHAR_CARRIAGE_RETURN2 = 13;
    var CHAR_SPACE2 = 32;
    var CHAR_EXCLAMATION2 = 33;
    var CHAR_DOUBLE_QUOTE2 = 34;
    var CHAR_SHARP2 = 35;
    var CHAR_PERCENT2 = 37;
    var CHAR_AMPERSAND2 = 38;
    var CHAR_SINGLE_QUOTE2 = 39;
    var CHAR_ASTERISK2 = 42;
    var CHAR_COMMA2 = 44;
    var CHAR_MINUS2 = 45;
    var CHAR_COLON2 = 58;
    var CHAR_GREATER_THAN2 = 62;
    var CHAR_QUESTION2 = 63;
    var CHAR_COMMERCIAL_AT2 = 64;
    var CHAR_LEFT_SQUARE_BRACKET2 = 91;
    var CHAR_RIGHT_SQUARE_BRACKET2 = 93;
    var CHAR_GRAVE_ACCENT2 = 96;
    var CHAR_LEFT_CURLY_BRACKET2 = 123;
    var CHAR_VERTICAL_LINE2 = 124;
    var CHAR_RIGHT_CURLY_BRACKET2 = 125;
    var ESCAPE_SEQUENCES2 = {};
    ESCAPE_SEQUENCES2[0] = "\\0";
    ESCAPE_SEQUENCES2[7] = "\\a";
    ESCAPE_SEQUENCES2[8] = "\\b";
    ESCAPE_SEQUENCES2[9] = "\\t";
    ESCAPE_SEQUENCES2[10] = "\\n";
    ESCAPE_SEQUENCES2[11] = "\\v";
    ESCAPE_SEQUENCES2[12] = "\\f";
    ESCAPE_SEQUENCES2[13] = "\\r";
    ESCAPE_SEQUENCES2[27] = "\\e";
    ESCAPE_SEQUENCES2[34] = '\\"';
    ESCAPE_SEQUENCES2[92] = "\\\\";
    ESCAPE_SEQUENCES2[133] = "\\N";
    ESCAPE_SEQUENCES2[160] = "\\_";
    ESCAPE_SEQUENCES2[8232] = "\\L";
    ESCAPE_SEQUENCES2[8233] = "\\P";
    var DEPRECATED_BOOLEANS_SYNTAX2 = [
      "y",
      "Y",
      "yes",
      "Yes",
      "YES",
      "on",
      "On",
      "ON",
      "n",
      "N",
      "no",
      "No",
      "NO",
      "off",
      "Off",
      "OFF"
    ];
    function compileStyleMap2(schema2, map2) {
      var result, keys5, index, length, tag, style, type2;
      if (null === map2) {
        return {};
      }
      result = {};
      keys5 = Object.keys(map2);
      for (index = 0, length = keys5.length; index < length; index += 1) {
        tag = keys5[index];
        style = String(map2[tag]);
        if ("!!" === tag.slice(0, 2)) {
          tag = "tag:yaml.org,2002:" + tag.slice(2);
        }
        type2 = schema2.compiledTypeMap[tag];
        if (type2 && _hasOwnProperty2.call(type2.styleAliases, style)) {
          style = type2.styleAliases[style];
        }
        result[tag] = style;
      }
      return result;
    }
    function encodeHex2(character) {
      var string3, handle, length;
      string3 = character.toString(16).toUpperCase();
      if (character <= 255) {
        handle = "x";
        length = 2;
      } else if (character <= 65535) {
        handle = "u";
        length = 4;
      } else if (character <= 4294967295) {
        handle = "U";
        length = 8;
      } else {
        throw new YAMLException2("code point within a string may not be greater than 0xFFFFFFFF");
      }
      return "\\" + handle + common2.repeat("0", length - string3.length) + string3;
    }
    function State3(options) {
      this.schema = options["schema"] || DEFAULT_FULL_SCHEMA;
      this.indent = Math.max(1, options["indent"] || 2);
      this.skipInvalid = options["skipInvalid"] || false;
      this.flowLevel = common2.isNothing(options["flowLevel"]) ? -1 : options["flowLevel"];
      this.styleMap = compileStyleMap2(this.schema, options["styles"] || null);
      this.implicitTypes = this.schema.compiledImplicit;
      this.explicitTypes = this.schema.compiledExplicit;
      this.tag = null;
      this.result = "";
      this.duplicates = [];
      this.usedDuplicates = null;
    }
    function indentString2(string3, spaces) {
      var ind = common2.repeat(" ", spaces), position = 0, next = -1, result = "", line, length = string3.length;
      while (position < length) {
        next = string3.indexOf("\n", position);
        if (next === -1) {
          line = string3.slice(position);
          position = length;
        } else {
          line = string3.slice(position, next + 1);
          position = next + 1;
        }
        if (line.length && line !== "\n") {
          result += ind;
        }
        result += line;
      }
      return result;
    }
    function generateNextLine2(state, level) {
      return "\n" + common2.repeat(" ", state.indent * level);
    }
    function testImplicitResolving2(state, str2) {
      var index, length, type2;
      for (index = 0, length = state.implicitTypes.length; index < length; index += 1) {
        type2 = state.implicitTypes[index];
        if (type2.resolve(str2)) {
          return true;
        }
      }
      return false;
    }
    function StringBuilder(source) {
      this.source = source;
      this.result = "";
      this.checkpoint = 0;
    }
    StringBuilder.prototype.takeUpTo = function (position) {
      var er;
      if (position < this.checkpoint) {
        er = new Error("position should be > checkpoint");
        er.position = position;
        er.checkpoint = this.checkpoint;
        throw er;
      }
      this.result += this.source.slice(this.checkpoint, position);
      this.checkpoint = position;
      return this;
    };
    StringBuilder.prototype.escapeChar = function () {
      var character, esc;
      character = this.source.charCodeAt(this.checkpoint);
      esc = ESCAPE_SEQUENCES2[character] || encodeHex2(character);
      this.result += esc;
      this.checkpoint += 1;
      return this;
    };
    StringBuilder.prototype.finish = function () {
      if (this.source.length > this.checkpoint) {
        this.takeUpTo(this.source.length);
      }
    };
    function writeScalar2(state, object3, level) {
      var simple, first, spaceWrap, folded, literal, single, double, sawLineFeed, linePosition, longestLine, indent, max, character, position, escapeSeq, hexEsc, previous, lineLength, modifier, trailingLineBreaks, result;
      if (0 === object3.length) {
        state.dump = "''";
        return;
      }
      if (object3.indexOf("!include") == 0) {
        state.dump = "" + object3;
        return;
      }
      if (object3.indexOf("!$$$novalue") == 0) {
        state.dump = "";
        return;
      }
      if (-1 !== DEPRECATED_BOOLEANS_SYNTAX2.indexOf(object3)) {
        state.dump = "'" + object3 + "'";
        return;
      }
      simple = true;
      first = object3.length ? object3.charCodeAt(0) : 0;
      spaceWrap = CHAR_SPACE2 === first || CHAR_SPACE2 === object3.charCodeAt(object3.length - 1);
      if (CHAR_MINUS2 === first || CHAR_QUESTION2 === first || CHAR_COMMERCIAL_AT2 === first || CHAR_GRAVE_ACCENT2 === first) {
        simple = false;
      }
      if (spaceWrap) {
        simple = false;
        folded = false;
        literal = false;
      } else {
        folded = true;
        literal = true;
      }
      single = true;
      double = new StringBuilder(object3);
      sawLineFeed = false;
      linePosition = 0;
      longestLine = 0;
      indent = state.indent * level;
      max = 80;
      if (indent < 40) {
        max -= indent;
      } else {
        max = 40;
      }
      for (position = 0; position < object3.length; position++) {
        character = object3.charCodeAt(position);
        if (simple) {
          if (!simpleChar(character)) {
            simple = false;
          } else {
            continue;
          }
        }
        if (single && character === CHAR_SINGLE_QUOTE2) {
          single = false;
        }
        escapeSeq = ESCAPE_SEQUENCES2[character];
        hexEsc = needsHexEscape(character);
        if (!escapeSeq && !hexEsc) {
          continue;
        }
        if (character !== CHAR_LINE_FEED2 && character !== CHAR_DOUBLE_QUOTE2 && character !== CHAR_SINGLE_QUOTE2) {
          folded = false;
          literal = false;
        } else if (character === CHAR_LINE_FEED2) {
          sawLineFeed = true;
          single = false;
          if (position > 0) {
            previous = object3.charCodeAt(position - 1);
            if (previous === CHAR_SPACE2) {
              literal = false;
              folded = false;
            }
          }
          if (folded) {
            lineLength = position - linePosition;
            linePosition = position;
            if (lineLength > longestLine) {
              longestLine = lineLength;
            }
          }
        }
        if (character !== CHAR_DOUBLE_QUOTE2) {
          single = false;
        }
        double.takeUpTo(position);
        double.escapeChar();
      }
      if (simple && testImplicitResolving2(state, object3)) {
        simple = false;
      }
      modifier = "";
      if (folded || literal) {
        trailingLineBreaks = 0;
        if (object3.charCodeAt(object3.length - 1) === CHAR_LINE_FEED2) {
          trailingLineBreaks += 1;
          if (object3.charCodeAt(object3.length - 2) === CHAR_LINE_FEED2) {
            trailingLineBreaks += 1;
          }
        }
        if (trailingLineBreaks === 0) {
          modifier = "-";
        } else if (trailingLineBreaks === 2) {
          modifier = "+";
        }
      }
      if (literal && longestLine < max) {
        folded = false;
      }
      if (!sawLineFeed) {
        literal = false;
      }
      if (simple) {
        state.dump = object3;
      } else if (single) {
        state.dump = "'" + object3 + "'";
      } else if (folded) {
        result = fold(object3, max);
        state.dump = ">" + modifier + "\n" + indentString2(result, indent);
      } else if (literal) {
        if (!modifier) {
          object3 = object3.replace(/\n$/, "");
        }
        state.dump = "|" + modifier + "\n" + indentString2(object3, indent);
      } else if (double) {
        double.finish();
        state.dump = '"' + double.result + '"';
      } else {
        throw new Error("Failed to dump scalar value");
      }
      return;
    }
    function fold(object3, max) {
      var result = "", position = 0, length = object3.length, trailing = /\n+$/.exec(object3), newLine;
      if (trailing) {
        length = trailing.index + 1;
      }
      while (position < length) {
        newLine = object3.indexOf("\n", position);
        if (newLine > length || newLine === -1) {
          if (result) {
            result += "\n\n";
          }
          result += foldLine2(object3.slice(position, length), max);
          position = length;
        } else {
          if (result) {
            result += "\n\n";
          }
          result += foldLine2(object3.slice(position, newLine), max);
          position = newLine + 1;
        }
      }
      if (trailing && trailing[0] !== "\n") {
        result += trailing[0];
      }
      return result;
    }
    function foldLine2(line, max) {
      if (line === "") {
        return line;
      }
      var foldRe = /[^\s] [^\s]/g, result = "", prevMatch = 0, foldStart = 0, match = foldRe.exec(line), index, foldEnd, folded;
      while (match) {
        index = match.index;
        if (index - foldStart > max) {
          if (prevMatch !== foldStart) {
            foldEnd = prevMatch;
          } else {
            foldEnd = index;
          }
          if (result) {
            result += "\n";
          }
          folded = line.slice(foldStart, foldEnd);
          result += folded;
          foldStart = foldEnd + 1;
        }
        prevMatch = index + 1;
        match = foldRe.exec(line);
      }
      if (result) {
        result += "\n";
      }
      if (foldStart !== prevMatch && line.length - foldStart > max) {
        result += line.slice(foldStart, prevMatch) + "\n" + line.slice(prevMatch + 1);
      } else {
        result += line.slice(foldStart);
      }
      return result;
    }
    function simpleChar(character) {
      return CHAR_TAB2 !== character && CHAR_LINE_FEED2 !== character && CHAR_CARRIAGE_RETURN2 !== character && CHAR_COMMA2 !== character && CHAR_LEFT_SQUARE_BRACKET2 !== character && CHAR_RIGHT_SQUARE_BRACKET2 !== character && CHAR_LEFT_CURLY_BRACKET2 !== character && CHAR_RIGHT_CURLY_BRACKET2 !== character && CHAR_SHARP2 !== character && CHAR_AMPERSAND2 !== character && CHAR_ASTERISK2 !== character && CHAR_EXCLAMATION2 !== character && CHAR_VERTICAL_LINE2 !== character && CHAR_GREATER_THAN2 !== character && CHAR_SINGLE_QUOTE2 !== character && CHAR_DOUBLE_QUOTE2 !== character && CHAR_PERCENT2 !== character && CHAR_COLON2 !== character && !ESCAPE_SEQUENCES2[character] && !needsHexEscape(character);
    }
    function needsHexEscape(character) {
      return !(32 <= character && character <= 126 || 133 === character || 160 <= character && character <= 55295 || 57344 <= character && character <= 65533 || 65536 <= character && character <= 1114111);
    }
    function writeFlowSequence2(state, level, object3) {
      var _result = "", _tag = state.tag, index, length;
      for (index = 0, length = object3.length; index < length; index += 1) {
        if (writeNode2(state, level, object3[index], false, false)) {
          if (0 !== index) {
            _result += ", ";
          }
          _result += state.dump;
        }
      }
      state.tag = _tag;
      state.dump = "[" + _result + "]";
    }
    function writeBlockSequence2(state, level, object3, compact2) {
      var _result = "", _tag = state.tag, index, length;
      for (index = 0, length = object3.length; index < length; index += 1) {
        if (writeNode2(state, level + 1, object3[index], true, true)) {
          if (!compact2 || 0 !== index) {
            _result += generateNextLine2(state, level);
          }
          _result += "- " + state.dump;
        }
      }
      state.tag = _tag;
      state.dump = _result || "[]";
    }
    function writeFlowMapping2(state, level, object3) {
      var _result = "", _tag = state.tag, objectKeyList = Object.keys(object3), index, length, objectKey, objectValue, pairBuffer;
      for (index = 0, length = objectKeyList.length; index < length; index += 1) {
        pairBuffer = "";
        if (0 !== index) {
          pairBuffer += ", ";
        }
        objectKey = objectKeyList[index];
        objectValue = object3[objectKey];
        if (!writeNode2(state, level, objectKey, false, false)) {
          continue;
        }
        if (state.dump.length > 1024) {
          pairBuffer += "? ";
        }
        pairBuffer += state.dump + ": ";
        if (!writeNode2(state, level, objectValue, false, false)) {
          continue;
        }
        pairBuffer += state.dump;
        _result += pairBuffer;
      }
      state.tag = _tag;
      state.dump = "{" + _result + "}";
    }
    function writeBlockMapping2(state, level, object3, compact2) {
      var _result = "", _tag = state.tag, objectKeyList = Object.keys(object3), index, length, objectKey, objectValue, explicitPair, pairBuffer;
      for (index = 0, length = objectKeyList.length; index < length; index += 1) {
        pairBuffer = "";
        if (!compact2 || 0 !== index) {
          pairBuffer += generateNextLine2(state, level);
        }
        objectKey = objectKeyList[index];
        objectValue = object3[objectKey];
        if (!writeNode2(state, level + 1, objectKey, true, true)) {
          continue;
        }
        explicitPair = null !== state.tag && "?" !== state.tag || state.dump && state.dump.length > 1024;
        if (explicitPair) {
          if (state.dump && CHAR_LINE_FEED2 === state.dump.charCodeAt(0)) {
            pairBuffer += "?";
          } else {
            pairBuffer += "? ";
          }
        }
        pairBuffer += state.dump;
        if (explicitPair) {
          pairBuffer += generateNextLine2(state, level);
        }
        if (!writeNode2(state, level + 1, objectValue, true, explicitPair)) {
          continue;
        }
        if (state.dump && CHAR_LINE_FEED2 === state.dump.charCodeAt(0)) {
          pairBuffer += ":";
        } else {
          pairBuffer += ": ";
        }
        pairBuffer += state.dump;
        _result += pairBuffer;
      }
      state.tag = _tag;
      state.dump = _result || "{}";
    }
    function detectType2(state, object3, explicit) {
      var _result, typeList, index, length, type2, style;
      typeList = explicit ? state.explicitTypes : state.implicitTypes;
      for (index = 0, length = typeList.length; index < length; index += 1) {
        type2 = typeList[index];
        if ((type2.instanceOf || type2.predicate) && (!type2.instanceOf || "object" === typeof object3 && object3 instanceof type2.instanceOf) && (!type2.predicate || type2.predicate(object3))) {
          state.tag = explicit ? type2.tag : "?";
          if (type2.represent) {
            style = state.styleMap[type2.tag] || type2.defaultStyle;
            if ("[object Function]" === _toString2.call(type2.represent)) {
              _result = type2.represent(object3, style);
            } else if (_hasOwnProperty2.call(type2.represent, style)) {
              _result = type2.represent[style](object3, style);
            } else {
              throw new YAMLException2("!<" + type2.tag + '> tag resolver accepts not "' + style + '" style');
            }
            state.dump = _result;
          }
          return true;
        }
      }
      return false;
    }
    function writeNode2(state, level, object3, block, compact2) {
      state.tag = null;
      state.dump = object3;
      if (!detectType2(state, object3, false)) {
        detectType2(state, object3, true);
      }
      var type2 = _toString2.call(state.dump);
      if (block) {
        block = 0 > state.flowLevel || state.flowLevel > level;
      }
      if (null !== state.tag && "?" !== state.tag || 2 !== state.indent && level > 0) {
        compact2 = false;
      }
      var objectOrArray = "[object Object]" === type2 || "[object Array]" === type2, duplicateIndex, duplicate;
      if (objectOrArray) {
        duplicateIndex = state.duplicates.indexOf(object3);
        duplicate = duplicateIndex !== -1;
      }
      if (duplicate && state.usedDuplicates[duplicateIndex]) {
        state.dump = "*ref_" + duplicateIndex;
      } else {
        if (objectOrArray && duplicate && !state.usedDuplicates[duplicateIndex]) {
          state.usedDuplicates[duplicateIndex] = true;
        }
        if ("[object Object]" === type2) {
          if (block && 0 !== Object.keys(state.dump).length) {
            writeBlockMapping2(state, level, state.dump, compact2);
            if (duplicate) {
              state.dump = "&ref_" + duplicateIndex + (0 === level ? "\n" : "") + state.dump;
            }
          } else {
            writeFlowMapping2(state, level, state.dump);
            if (duplicate) {
              state.dump = "&ref_" + duplicateIndex + " " + state.dump;
            }
          }
        } else if ("[object Array]" === type2) {
          if (block && 0 !== state.dump.length) {
            writeBlockSequence2(state, level, state.dump, compact2);
            if (duplicate) {
              state.dump = "&ref_" + duplicateIndex + (0 === level ? "\n" : "") + state.dump;
            }
          } else {
            writeFlowSequence2(state, level, state.dump);
            if (duplicate) {
              state.dump = "&ref_" + duplicateIndex + " " + state.dump;
            }
          }
        } else if ("[object String]" === type2) {
          if ("?" !== state.tag) {
            writeScalar2(state, state.dump, level);
          }
        } else {
          if (state.skipInvalid) {
            return false;
          }
          throw new YAMLException2("unacceptable kind of an object to dump " + type2);
        }
        if (null !== state.tag && "?" !== state.tag) {
          state.dump = "!<" + state.tag + "> " + state.dump;
        }
      }
      return true;
    }
    function getDuplicateReferences2(object3, state) {
      var objects = [], duplicatesIndexes = [], index, length;
      inspectNode2(object3, objects, duplicatesIndexes);
      for (index = 0, length = duplicatesIndexes.length; index < length; index += 1) {
        state.duplicates.push(objects[duplicatesIndexes[index]]);
      }
      state.usedDuplicates = new Array(length);
    }
    function inspectNode2(object3, objects, duplicatesIndexes) {
      var type2 = _toString2.call(object3), objectKeyList, index, length;
      if (null !== object3 && "object" === typeof object3) {
        index = objects.indexOf(object3);
        if (-1 !== index) {
          if (-1 === duplicatesIndexes.indexOf(index)) {
            duplicatesIndexes.push(index);
          }
        } else {
          objects.push(object3);
          if (Array.isArray(object3)) {
            for (index = 0, length = object3.length; index < length; index += 1) {
              inspectNode2(object3[index], objects, duplicatesIndexes);
            }
          } else {
            objectKeyList = Object.keys(object3);
            for (index = 0, length = objectKeyList.length; index < length; index += 1) {
              inspectNode2(object3[objectKeyList[index]], objects, duplicatesIndexes);
            }
          }
        }
      }
    }
    function dump2(input, options) {
      options = options || {};
      var state = new State3(options);
      getDuplicateReferences2(input, state);
      if (writeNode2(state, 0, input, true, true)) {
        return state.dump + "\n";
      }
      return "";
    }
    exports2.dump = dump2;
    function safeDump2(input, options) {
      return dump2(input, common2.extend({ schema: DEFAULT_SAFE_SCHEMA }, options));
    }
    exports2.safeDump = safeDump2;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/scalarInference.js
var require_scalarInference = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/scalarInference.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    function parseYamlBoolean(input) {
      if (["true", "True", "TRUE"].lastIndexOf(input) >= 0) {
        return true;
      } else if (["false", "False", "FALSE"].lastIndexOf(input) >= 0) {
        return false;
      }
      throw 'Invalid boolean "' + input + '"';
    }
    exports2.parseYamlBoolean = parseYamlBoolean;
    function safeParseYamlInteger(input) {
      if (input.lastIndexOf("0o", 0) === 0) {
        return parseInt(input.substring(2), 8);
      }
      return parseInt(input);
    }
    function parseYamlInteger(input) {
      var result = safeParseYamlInteger(input);
      if (isNaN(result)) {
        throw 'Invalid integer "' + input + '"';
      }
      return result;
    }
    exports2.parseYamlInteger = parseYamlInteger;
    function parseYamlFloat(input) {
      if ([".nan", ".NaN", ".NAN"].lastIndexOf(input) >= 0) {
        return NaN;
      }
      var infinity = /^([-+])?(?:\.inf|\.Inf|\.INF)$/;
      var match = infinity.exec(input);
      if (match) {
        return match[1] === "-" ? -Infinity : Infinity;
      }
      var result = parseFloat(input);
      if (!isNaN(result)) {
        return result;
      }
      throw 'Invalid float "' + input + '"';
    }
    exports2.parseYamlFloat = parseYamlFloat;
    var ScalarType;
    (function (ScalarType2) {
      ScalarType2[ScalarType2["null"] = 0] = "null";
      ScalarType2[ScalarType2["bool"] = 1] = "bool";
      ScalarType2[ScalarType2["int"] = 2] = "int";
      ScalarType2[ScalarType2["float"] = 3] = "float";
      ScalarType2[ScalarType2["string"] = 4] = "string";
    })(ScalarType = exports2.ScalarType || (exports2.ScalarType = {}));
    function determineScalarType(node) {
      if (node === void 0) {
        return ScalarType.null;
      }
      if (node.doubleQuoted || !node.plainScalar || node["singleQuoted"]) {
        return ScalarType.string;
      }
      var value = node.value;
      if (["null", "Null", "NULL", "~", ""].indexOf(value) >= 0) {
        return ScalarType.null;
      }
      if (value === null || value === void 0) {
        return ScalarType.null;
      }
      if (["true", "True", "TRUE", "false", "False", "FALSE"].indexOf(value) >= 0) {
        return ScalarType.bool;
      }
      var base10 = /^[-+]?[0-9]+$/;
      var base8 = /^0o[0-7]+$/;
      var base16 = /^0x[0-9a-fA-F]+$/;
      if (base10.test(value) || base8.test(value) || base16.test(value)) {
        return ScalarType.int;
      }
      var float2 = /^[-+]?(\.[0-9]+|[0-9]+(\.[0-9]*)?)([eE][-+]?[0-9]+)?$/;
      var infinity = /^[-+]?(\.inf|\.Inf|\.INF)$/;
      if (float2.test(value) || infinity.test(value) || [".nan", ".NaN", ".NAN"].indexOf(value) >= 0) {
        return ScalarType.float;
      }
      return ScalarType.string;
    }
    exports2.determineScalarType = determineScalarType;
  }
});

// ../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/index.js
var require_src = __commonJS({
  "../../../node_modules/.pnpm/yaml-ast-parser@0.0.43/node_modules/yaml-ast-parser/dist/src/index.js"(exports2) {
    "use strict";
    function __export2(m) {
      for (var p in m) if (!exports2.hasOwnProperty(p)) exports2[p] = m[p];
    }
    Object.defineProperty(exports2, "__esModule", { value: true });
    var loader_1 = require_loader2();
    exports2.load = loader_1.load;
    exports2.loadAll = loader_1.loadAll;
    exports2.safeLoad = loader_1.safeLoad;
    exports2.safeLoadAll = loader_1.safeLoadAll;
    var dumper_1 = require_dumper2();
    exports2.dump = dumper_1.dump;
    exports2.safeDump = dumper_1.safeDump;
    exports2.YAMLException = require_exception2();
    __export2(require_yamlAST());
    __export2(require_scalarInference());
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/format/codeframes.js
var require_codeframes = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/format/codeframes.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.getAstNodeByPointer = exports2.getLineColLocation = exports2.getCodeframe = void 0;
    var yamlAst = require_src();
    var ref_utils_1 = require_ref_utils();
    var logger_1 = require_logger();
    var MAX_LINE_LENGTH = 150;
    var MAX_CODEFRAME_LINES = 3;
    function parsePointer(pointer) {
      return pointer.substr(2).split("/").map(ref_utils_1.unescapePointer);
    }
    function getCodeframe(location, color) {
      logger_1.colorOptions.enabled = color;
      const { start, end = { line: start.line, col: start.col + 1 }, source } = location;
      const lines = source.getLines();
      const startLineNum = start.line;
      const endLineNum = Math.max(Math.min(end.line, lines.length), start.line);
      let skipLines = Math.max(endLineNum - startLineNum - MAX_CODEFRAME_LINES + 1, 0);
      if (skipLines < 2)
        skipLines = 0;
      const prefixedLines = [];
      let currentPad = 0;
      for (let i = startLineNum; i <= endLineNum; i++) {
        if (skipLines > 0 && i >= endLineNum - skipLines)
          break;
        const line = lines[i - 1] || "";
        if (line !== "")
          currentPad = padSize(line);
        const startIdx = i === startLineNum ? start.col - 1 : currentPad;
        const endIdx = i === endLineNum ? end.col - 1 : line.length;
        prefixedLines.push([`${i}`, markLine(line, startIdx, endIdx, logger_1.colorize.red)]);
        if (!color)
          prefixedLines.push(["", underlineLine(line, startIdx, endIdx)]);
      }
      if (skipLines > 0) {
        prefixedLines.push([
          `\u2026`,
          `${whitespace(currentPad)}${logger_1.colorize.gray(`< ${skipLines} more lines >`)}`
        ]);
        prefixedLines.push([
          `${endLineNum}`,
          markLine(lines[endLineNum - 1], -1, end.col - 1, logger_1.colorize.red)
        ]);
        if (!color)
          prefixedLines.push(["", underlineLine(lines[endLineNum - 1], -1, end.col - 1)]);
      }
      return printPrefixedLines([
        [`${startLineNum - 2}`, markLine(lines[startLineNum - 1 - 2])],
        [`${startLineNum - 1}`, markLine(lines[startLineNum - 1 - 1])],
        ...prefixedLines,
        [`${endLineNum + 1}`, markLine(lines[endLineNum - 1 + 1])],
        [`${endLineNum + 2}`, markLine(lines[endLineNum - 1 + 2])]
      ]);
      function markLine(line, startIdx = -1, endIdx = Infinity, variant = logger_1.colorize.gray) {
        if (!color)
          return line;
        if (!line)
          return line;
        if (startIdx === -1) {
          startIdx = padSize(line);
        }
        endIdx = Math.min(endIdx, line.length);
        return line.substr(0, startIdx) + variant(line.substring(startIdx, endIdx)) + line.substr(endIdx);
      }
    }
    exports2.getCodeframe = getCodeframe;
    function printPrefixedLines(lines) {
      const existingLines = lines.filter(([_, line]) => line !== void 0);
      const padLen = Math.max(...existingLines.map(([prefix]) => prefix.length));
      const dedentLen = Math.min(...existingLines.map(([_, line]) => line === "" ? Infinity : padSize(line)));
      return existingLines.map(([prefix, line]) => logger_1.colorize.gray(leftPad(padLen, prefix) + " |") + (line ? " " + limitLineLength(line.substring(dedentLen)) : "")).join("\n");
    }
    function limitLineLength(line, maxLen = MAX_LINE_LENGTH) {
      const overflowLen = line.length - maxLen;
      if (overflowLen > 0) {
        const charsMoreText = logger_1.colorize.gray(`...<${overflowLen} chars>`);
        return line.substring(0, maxLen - charsMoreText.length) + charsMoreText;
      } else {
        return line;
      }
    }
    function underlineLine(line, startIdx = -1, endIdx = Infinity) {
      if (startIdx === -1) {
        startIdx = padSize(line);
      }
      endIdx = Math.min(endIdx, line.length);
      return whitespace(startIdx) + "^".repeat(Math.max(endIdx - startIdx, 1));
    }
    function whitespace(len) {
      return " ".repeat(len);
    }
    function leftPad(len, str2) {
      return whitespace(len - str2.length) + str2;
    }
    function padSize(line) {
      for (let i = 0; i < line.length; i++) {
        if (line[i] !== " ")
          return i;
      }
      return line.length;
    }
    function getLineColLocation(location) {
      var _a, _b;
      if (location.pointer === void 0)
        return location;
      const { source, pointer, reportOnKey } = location;
      const ast = source.getAst(yamlAst.safeLoad);
      const astNode = getAstNodeByPointer(ast, pointer, !!reportOnKey);
      return Object.assign(Object.assign(Object.assign({}, location), { pointer: void 0 }), positionsToLoc(source.body, (_a = astNode === null || astNode === void 0 ? void 0 : astNode.startPosition) !== null && _a !== void 0 ? _a : 1, (_b = astNode === null || astNode === void 0 ? void 0 : astNode.endPosition) !== null && _b !== void 0 ? _b : 1));
    }
    exports2.getLineColLocation = getLineColLocation;
    function positionsToLoc(source, startPos, endPos) {
      let currentLine = 1;
      let currentCol = 1;
      let start = { line: 1, col: 1 };
      for (let i = 0; i < endPos - 1; i++) {
        if (i === startPos - 1) {
          start = { line: currentLine, col: currentCol + 1 };
        }
        if (source[i] === "\n") {
          currentLine++;
          currentCol = 1;
          if (i === startPos - 1) {
            start = { line: currentLine, col: currentCol };
          }
          if (source[i + 1] === "\r")
            i++;
          continue;
        }
        currentCol++;
      }
      const end = startPos === endPos ? Object.assign({}, start) : { line: currentLine, col: currentCol + 1 };
      return { start, end };
    }
    function getAstNodeByPointer(root2, pointer, reportOnKey) {
      const pointerSegments = parsePointer(pointer);
      if (root2 === void 0) {
        return void 0;
      }
      let currentNode = root2;
      for (const key of pointerSegments) {
        if (currentNode.kind === yamlAst.Kind.MAP) {
          const mapping = currentNode.mappings.find((m) => m.key.value === key);
          if (!mapping)
            break;
          currentNode = mapping;
          if (!(mapping === null || mapping === void 0 ? void 0 : mapping.value))
            break;
          currentNode = mapping.value;
        } else if (currentNode.kind === yamlAst.Kind.SEQ) {
          const elem = currentNode.items[parseInt(key, 10)];
          if (!elem)
            break;
          currentNode = elem;
        }
      }
      if (!reportOnKey) {
        return currentNode;
      } else {
        const parent = currentNode.parent;
        if (!parent)
          return currentNode;
        if (parent.kind === yamlAst.Kind.SEQ) {
          return currentNode;
        } else if (parent.kind === yamlAst.Kind.MAPPING) {
          return parent.key;
        } else {
          return currentNode;
        }
      }
    }
    exports2.getAstNodeByPointer = getAstNodeByPointer;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/output.js
var require_output = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/output.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.output = void 0;
    var env_1 = require_env();
    exports2.output = {
      write(str2) {
        return env_1.isBrowser ? void 0 : process.stdout.write(str2);
      }
    };
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/format/format.js
var require_format3 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/format/format.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.formatProblems = exports2.getTotals = void 0;
    var path5 = require("path");
    var logger_1 = require_logger();
    var output_1 = require_output();
    var coreVersion = require_package().version;
    var codeframes_1 = require_codeframes();
    var env_1 = require_env();
    var ref_utils_1 = require_ref_utils();
    var ERROR_MESSAGE = {
      INVALID_SEVERITY_LEVEL: "Invalid severity level; accepted values: error or warn"
    };
    var BG_COLORS = {
      warn: (str2) => logger_1.colorize.bgYellow(logger_1.colorize.black(str2)),
      error: logger_1.colorize.bgRed
    };
    var COLORS = {
      warn: logger_1.colorize.yellow,
      error: logger_1.colorize.red
    };
    var SEVERITY_NAMES = {
      warn: "Warning",
      error: "Error"
    };
    var CODECLIMATE_SEVERITY_MAPPING = {
      error: "critical",
      warn: "minor"
    };
    var MAX_SUGGEST = 5;
    function severityToNumber(severity) {
      return severity === "error" ? 1 : 2;
    }
    function getTotals(problems) {
      let errors = 0;
      let warnings = 0;
      let ignored = 0;
      for (const m of problems) {
        if (m.ignored) {
          ignored++;
          continue;
        }
        if (m.severity === "error")
          errors++;
        if (m.severity === "warn")
          warnings++;
      }
      return {
        errors,
        warnings,
        ignored
      };
    }
    exports2.getTotals = getTotals;
    function formatProblems(problems, opts) {
      const { maxProblems = 100, cwd = process.cwd(), format = "codeframe", color = logger_1.colorOptions.enabled, totals = getTotals(problems), version = coreVersion } = opts;
      logger_1.colorOptions.enabled = color;
      const totalProblems = problems.length;
      problems = problems.filter((m) => !m.ignored);
      const ignoredProblems = totalProblems - problems.length;
      problems = problems.sort((a, b) => severityToNumber(a.severity) - severityToNumber(b.severity)).slice(0, maxProblems);
      if (!totalProblems && format !== "json")
        return;
      switch (format) {
        case "json":
          outputJSON();
          break;
        case "codeframe":
          for (let i = 0; i < problems.length; i++) {
            const problem = problems[i];
            logger_1.logger.info(`${formatCodeframe(problem, i)}
`);
          }
          break;
        case "stylish": {
          const groupedByFile = groupByFiles(problems);
          for (const [file, { ruleIdPad, locationPad: positionPad, fileProblems }] of Object.entries(groupedByFile)) {
            logger_1.logger.info(`${logger_1.colorize.blue((0, ref_utils_1.isAbsoluteUrl)(file) ? file : path5.relative(cwd, file))}:
`);
            for (let i = 0; i < fileProblems.length; i++) {
              const problem = fileProblems[i];
              logger_1.logger.info(`${formatStylish(problem, positionPad, ruleIdPad)}
`);
            }
            logger_1.logger.info("\n");
          }
          break;
        }
        case "checkstyle": {
          const groupedByFile = groupByFiles(problems);
          output_1.output.write('<?xml version="1.0" encoding="UTF-8"?>\n');
          output_1.output.write('<checkstyle version="4.3">\n');
          for (const [file, { fileProblems }] of Object.entries(groupedByFile)) {
            output_1.output.write(`<file name="${xmlEscape((0, ref_utils_1.isAbsoluteUrl)(file) ? file : path5.relative(cwd, file))}">
`);
            fileProblems.forEach(formatCheckstyle);
            output_1.output.write(`</file>
`);
          }
          output_1.output.write(`</checkstyle>
`);
          break;
        }
        case "codeclimate":
          outputForCodeClimate();
          break;
        case "summary":
          formatSummary(problems);
          break;
      }
      if (totalProblems - ignoredProblems > maxProblems) {
        logger_1.logger.info(`< ... ${totalProblems - maxProblems} more problems hidden > ${logger_1.colorize.gray("increase with `--max-problems N`")}
`);
      }
      function outputForCodeClimate() {
        const issues = problems.map((p) => {
          const location = p.location[0];
          const lineCol = (0, codeframes_1.getLineColLocation)(location);
          return {
            description: p.message,
            location: {
              path: (0, ref_utils_1.isAbsoluteUrl)(location.source.absoluteRef) ? location.source.absoluteRef : path5.relative(cwd, location.source.absoluteRef),
              lines: {
                begin: lineCol.start.line
              }
            },
            severity: CODECLIMATE_SEVERITY_MAPPING[p.severity],
            fingerprint: `${p.ruleId}${p.location.length > 0 ? "-" + p.location[0].pointer : ""}`
          };
        });
        output_1.output.write(JSON.stringify(issues, null, 2));
      }
      function outputJSON() {
        const resultObject = {
          totals,
          version,
          problems: problems.map((p) => {
            var _a, _b, _c;
            const problem = Object.assign(Object.assign({}, p), {
              location: p.location.map((location) => Object.assign(Object.assign({}, location), {
                source: {
                  ref: (0, ref_utils_1.isAbsoluteUrl)(location.source.absoluteRef) ? location.source.absoluteRef : path5.relative(cwd, location.source.absoluteRef)
                }
              })), from: p.from ? Object.assign(Object.assign({}, p.from), {
                source: {
                  ref: (0, ref_utils_1.isAbsoluteUrl)((_a = p.from) === null || _a === void 0 ? void 0 : _a.source.absoluteRef) ? (_b = p.from) === null || _b === void 0 ? void 0 : _b.source.absoluteRef : path5.relative(cwd, ((_c = p.from) === null || _c === void 0 ? void 0 : _c.source.absoluteRef) || cwd)
                }
              }) : void 0
            });
            if (env_1.env.FORMAT_JSON_WITH_CODEFRAMES) {
              const location = p.location[0];
              const loc = (0, codeframes_1.getLineColLocation)(location);
              problem.codeframe = (0, codeframes_1.getCodeframe)(loc, color);
            }
            return problem;
          })
        };
        output_1.output.write(JSON.stringify(resultObject, null, 2));
      }
      function getBgColor(problem) {
        const { severity } = problem;
        if (!BG_COLORS[severity]) {
          throw new Error(ERROR_MESSAGE.INVALID_SEVERITY_LEVEL);
        }
        return BG_COLORS[severity];
      }
      function formatCodeframe(problem, idx) {
        const bgColor = getBgColor(problem);
        const location = problem.location[0];
        const relativePath = (0, ref_utils_1.isAbsoluteUrl)(location.source.absoluteRef) ? location.source.absoluteRef : path5.relative(cwd, location.source.absoluteRef);
        const loc = (0, codeframes_1.getLineColLocation)(location);
        const atPointer = location.pointer ? logger_1.colorize.gray(`at ${location.pointer}`) : "";
        const fileWithLoc = `${relativePath}:${loc.start.line}:${loc.start.col}`;
        return `[${idx + 1}] ${bgColor(fileWithLoc)} ${atPointer}

${problem.message}

` + formatDidYouMean(problem) + (0, codeframes_1.getCodeframe)(loc, color) + "\n\n" + formatFrom(cwd, problem.from) + `${SEVERITY_NAMES[problem.severity]} was generated by the ${logger_1.colorize.blue(problem.ruleId)} rule.

`;
      }
      function formatStylish(problem, locationPad, ruleIdPad) {
        const color2 = COLORS[problem.severity];
        if (!SEVERITY_NAMES[problem.severity]) {
          return "Error not found severity. Please check your config file. Allowed values: `warn,error,off`";
        }
        const severityName = color2(SEVERITY_NAMES[problem.severity].toLowerCase().padEnd(7));
        const { start } = problem.location[0];
        return `  ${`${start.line}:${start.col}`.padEnd(locationPad)}  ${severityName}  ${problem.ruleId.padEnd(ruleIdPad)}  ${problem.message}`;
      }
      function formatCheckstyle(problem) {
        const { line, col } = problem.location[0].start;
        const severity = problem.severity == "warn" ? "warning" : "error";
        const message = xmlEscape(problem.message);
        const source = xmlEscape(problem.ruleId);
        output_1.output.write(`<error line="${line}" column="${col}" severity="${severity}" message="${message}" source="${source}" />
`);
      }
    }
    exports2.formatProblems = formatProblems;
    function formatSummary(problems) {
      const counts = {};
      for (const problem of problems) {
        counts[problem.ruleId] = counts[problem.ruleId] || { count: 0, severity: problem.severity };
        counts[problem.ruleId].count++;
      }
      const sorted = Object.entries(counts).sort(([, a], [, b]) => {
        const severityDiff = severityToNumber(a.severity) - severityToNumber(b.severity);
        return severityDiff || b.count - a.count;
      });
      for (const [ruleId, info] of sorted) {
        const color = COLORS[info.severity];
        const severityName = color(SEVERITY_NAMES[info.severity].toLowerCase().padEnd(7));
        logger_1.logger.info(`${severityName} ${ruleId}: ${info.count}
`);
      }
      logger_1.logger.info("\n");
    }
    function formatFrom(cwd, location) {
      if (!location)
        return "";
      const relativePath = path5.relative(cwd, location.source.absoluteRef);
      const loc = (0, codeframes_1.getLineColLocation)(location);
      const fileWithLoc = `${relativePath}:${loc.start.line}:${loc.start.col}`;
      const atPointer = location.pointer ? logger_1.colorize.gray(`at ${location.pointer}`) : "";
      return `referenced from ${logger_1.colorize.blue(fileWithLoc)} ${atPointer} 

`;
    }
    function formatDidYouMean(problem) {
      if (problem.suggest.length === 0)
        return "";
      if (problem.suggest.length === 1) {
        return `Did you mean: ${problem.suggest[0]} ?

`;
      } else {
        return `Did you mean:
  - ${problem.suggest.slice(0, MAX_SUGGEST).join("\n  - ")}

`;
      }
    }
    var groupByFiles = (problems) => {
      const fileGroups = {};
      for (const problem of problems) {
        const absoluteRef = problem.location[0].source.absoluteRef;
        fileGroups[absoluteRef] = fileGroups[absoluteRef] || {
          fileProblems: [],
          ruleIdPad: 0,
          locationPad: 0
        };
        const mappedProblem = Object.assign(Object.assign({}, problem), { location: problem.location.map(codeframes_1.getLineColLocation) });
        fileGroups[absoluteRef].fileProblems.push(mappedProblem);
        fileGroups[absoluteRef].ruleIdPad = Math.max(problem.ruleId.length, fileGroups[absoluteRef].ruleIdPad);
        fileGroups[absoluteRef].locationPad = Math.max(Math.max(...mappedProblem.location.map((loc) => `${loc.start.line}:${loc.start.col}`.length)), fileGroups[absoluteRef].locationPad);
      }
      return fileGroups;
    };
    function xmlEscape(s) {
      return s.replace(/[<>&"'\x00-\x1F\x7F\u0080-\uFFFF]/gu, (char) => {
        switch (char) {
          case "<":
            return "&lt;";
          case ">":
            return "&gt;";
          case "&":
            return "&amp;";
          case '"':
            return "&quot;";
          case "'":
            return "&apos;";
          default:
            return `&#${char.charCodeAt(0)};`;
        }
      });
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/lint.js
var require_lint = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/lint.js"(exports2) {
    "use strict";
    var __awaiter = exports2 && exports2.__awaiter || function (thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function (resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.lintConfig = exports2.lintDocument = exports2.lintFromString = exports2.lint = void 0;
    var resolve_1 = require_resolve2();
    var visitors_1 = require_visitors();
    var walk_1 = require_walk();
    var config_1 = require_config2();
    var types_1 = require_types();
    var ajv_1 = require_ajv();
    var oas_types_1 = require_oas_types();
    var redocly_yaml_1 = require_redocly_yaml();
    var spec_1 = require_spec();
    function lint(opts) {
      return __awaiter(this, void 0, void 0, function* () {
        const { ref, externalRefResolver = new resolve_1.BaseResolver(opts.config.resolve) } = opts;
        const document = yield externalRefResolver.resolveDocument(null, ref, true);
        return lintDocument(Object.assign(Object.assign({ document }, opts), { externalRefResolver, config: opts.config.styleguide }));
      });
    }
    exports2.lint = lint;
    function lintFromString(opts) {
      return __awaiter(this, void 0, void 0, function* () {
        const { source, absoluteRef, externalRefResolver = new resolve_1.BaseResolver(opts.config.resolve) } = opts;
        const document = (0, resolve_1.makeDocumentFromString)(source, absoluteRef || "/");
        return lintDocument(Object.assign(Object.assign({ document }, opts), { externalRefResolver, config: opts.config.styleguide }));
      });
    }
    exports2.lintFromString = lintFromString;
    function lintDocument(opts) {
      return __awaiter(this, void 0, void 0, function* () {
        (0, ajv_1.releaseAjvInstance)();
        const { document, customTypes, externalRefResolver, config } = opts;
        const specVersion = (0, oas_types_1.detectSpec)(document.parsed);
        const specMajorVersion = (0, oas_types_1.getMajorSpecVersion)(specVersion);
        const rules = config.getRulesForOasVersion(specMajorVersion);
        const types2 = (0, types_1.normalizeTypes)(config.extendTypes(customTypes !== null && customTypes !== void 0 ? customTypes : (0, oas_types_1.getTypes)(specVersion), specVersion), config);
        const ctx = {
          problems: [],
          oasVersion: specVersion,
          visitorsData: {}
        };
        const preprocessors = (0, config_1.initRules)(rules, config, "preprocessors", specVersion);
        const regularRules = (0, config_1.initRules)(rules, config, "rules", specVersion);
        let resolvedRefMap = yield (0, resolve_1.resolveDocument)({
          rootDocument: document,
          rootType: types2.Root,
          externalRefResolver
        });
        if (preprocessors.length > 0) {
          (0, walk_1.walkDocument)({
            document,
            rootType: types2.Root,
            normalizedVisitors: (0, visitors_1.normalizeVisitors)(preprocessors, types2),
            resolvedRefMap,
            ctx
          });
          resolvedRefMap = yield (0, resolve_1.resolveDocument)({
            rootDocument: document,
            rootType: types2.Root,
            externalRefResolver
          });
        }
        const normalizedVisitors = (0, visitors_1.normalizeVisitors)(regularRules, types2);
        (0, walk_1.walkDocument)({
          document,
          rootType: types2.Root,
          normalizedVisitors,
          resolvedRefMap,
          ctx
        });
        return ctx.problems.map((problem) => config.addProblemToIgnore(problem));
      });
    }
    exports2.lintDocument = lintDocument;
    function lintConfig(opts) {
      return __awaiter(this, void 0, void 0, function* () {
        const { document, severity } = opts;
        const ctx = {
          problems: [],
          oasVersion: oas_types_1.SpecVersion.OAS3_0,
          visitorsData: {}
        };
        const plugins = (0, config_1.resolvePlugins)([config_1.defaultPlugin]);
        const config = new config_1.StyleguideConfig({
          plugins,
          rules: { spec: "error" }
        });
        const types2 = (0, types_1.normalizeTypes)(redocly_yaml_1.ConfigTypes, config);
        const rules = [
          {
            severity: severity || "error",
            ruleId: "configuration spec",
            visitor: (0, spec_1.Spec)({ severity: "error" })
          }
        ];
        const normalizedVisitors = (0, visitors_1.normalizeVisitors)(rules, types2);
        (0, walk_1.walkDocument)({
          document,
          rootType: types2.ConfigRoot,
          normalizedVisitors,
          resolvedRefMap: /* @__PURE__ */ new Map(),
          ctx
        });
        return ctx.problems;
      });
    }
    exports2.lintConfig = lintConfig;
  }
});

// ../../../node_modules/.pnpm/lodash.isequal@4.5.0/node_modules/lodash.isequal/index.js
var require_lodash = __commonJS({
  "../../../node_modules/.pnpm/lodash.isequal@4.5.0/node_modules/lodash.isequal/index.js"(exports2, module2) {
    "use strict";
    var LARGE_ARRAY_SIZE3 = 200;
    var HASH_UNDEFINED4 = "__lodash_hash_undefined__";
    var COMPARE_PARTIAL_FLAG7 = 1;
    var COMPARE_UNORDERED_FLAG5 = 2;
    var MAX_SAFE_INTEGER3 = 9007199254740991;
    var argsTag4 = "[object Arguments]";
    var arrayTag3 = "[object Array]";
    var asyncTag2 = "[object AsyncFunction]";
    var boolTag3 = "[object Boolean]";
    var dateTag3 = "[object Date]";
    var errorTag3 = "[object Error]";
    var funcTag3 = "[object Function]";
    var genTag2 = "[object GeneratorFunction]";
    var mapTag5 = "[object Map]";
    var numberTag3 = "[object Number]";
    var nullTag2 = "[object Null]";
    var objectTag5 = "[object Object]";
    var promiseTag2 = "[object Promise]";
    var proxyTag2 = "[object Proxy]";
    var regexpTag3 = "[object RegExp]";
    var setTag5 = "[object Set]";
    var stringTag4 = "[object String]";
    var symbolTag3 = "[object Symbol]";
    var undefinedTag2 = "[object Undefined]";
    var weakMapTag3 = "[object WeakMap]";
    var arrayBufferTag3 = "[object ArrayBuffer]";
    var dataViewTag4 = "[object DataView]";
    var float32Tag2 = "[object Float32Array]";
    var float64Tag2 = "[object Float64Array]";
    var int8Tag2 = "[object Int8Array]";
    var int16Tag2 = "[object Int16Array]";
    var int32Tag2 = "[object Int32Array]";
    var uint8Tag2 = "[object Uint8Array]";
    var uint8ClampedTag2 = "[object Uint8ClampedArray]";
    var uint16Tag2 = "[object Uint16Array]";
    var uint32Tag2 = "[object Uint32Array]";
    var reRegExpChar2 = /[\\^$.*+?()[\]{}|]/g;
    var reIsHostCtor2 = /^\[object .+?Constructor\]$/;
    var reIsUint2 = /^(?:0|[1-9]\d*)$/;
    var typedArrayTags2 = {};
    typedArrayTags2[float32Tag2] = typedArrayTags2[float64Tag2] = typedArrayTags2[int8Tag2] = typedArrayTags2[int16Tag2] = typedArrayTags2[int32Tag2] = typedArrayTags2[uint8Tag2] = typedArrayTags2[uint8ClampedTag2] = typedArrayTags2[uint16Tag2] = typedArrayTags2[uint32Tag2] = true;
    typedArrayTags2[argsTag4] = typedArrayTags2[arrayTag3] = typedArrayTags2[arrayBufferTag3] = typedArrayTags2[boolTag3] = typedArrayTags2[dataViewTag4] = typedArrayTags2[dateTag3] = typedArrayTags2[errorTag3] = typedArrayTags2[funcTag3] = typedArrayTags2[mapTag5] = typedArrayTags2[numberTag3] = typedArrayTags2[objectTag5] = typedArrayTags2[regexpTag3] = typedArrayTags2[setTag5] = typedArrayTags2[stringTag4] = typedArrayTags2[weakMapTag3] = false;
    var freeGlobal2 = typeof global == "object" && global && global.Object === Object && global;
    var freeSelf2 = typeof self == "object" && self && self.Object === Object && self;
    var root2 = freeGlobal2 || freeSelf2 || Function("return this")();
    var freeExports4 = typeof exports2 == "object" && exports2 && !exports2.nodeType && exports2;
    var freeModule4 = freeExports4 && typeof module2 == "object" && module2 && !module2.nodeType && module2;
    var moduleExports4 = freeModule4 && freeModule4.exports === freeExports4;
    var freeProcess2 = moduleExports4 && freeGlobal2.process;
    var nodeUtil2 = function () {
      try {
        return freeProcess2 && freeProcess2.binding && freeProcess2.binding("util");
      } catch (e) {
      }
    }();
    var nodeIsTypedArray2 = nodeUtil2 && nodeUtil2.isTypedArray;
    function arrayFilter2(array, predicate) {
      var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result = [];
      while (++index < length) {
        var value = array[index];
        if (predicate(value, index, array)) {
          result[resIndex++] = value;
        }
      }
      return result;
    }
    function arrayPush2(array, values) {
      var index = -1, length = values.length, offset = array.length;
      while (++index < length) {
        array[offset + index] = values[index];
      }
      return array;
    }
    function arraySome2(array, predicate) {
      var index = -1, length = array == null ? 0 : array.length;
      while (++index < length) {
        if (predicate(array[index], index, array)) {
          return true;
        }
      }
      return false;
    }
    function baseTimes2(n, iteratee) {
      var index = -1, result = Array(n);
      while (++index < n) {
        result[index] = iteratee(index);
      }
      return result;
    }
    function baseUnary2(func) {
      return function (value) {
        return func(value);
      };
    }
    function cacheHas2(cache, key) {
      return cache.has(key);
    }
    function getValue2(object3, key) {
      return object3 == null ? void 0 : object3[key];
    }
    function mapToArray2(map2) {
      var index = -1, result = Array(map2.size);
      map2.forEach(function (value, key) {
        result[++index] = [key, value];
      });
      return result;
    }
    function overArg2(func, transform3) {
      return function (arg) {
        return func(transform3(arg));
      };
    }
    function setToArray2(set4) {
      var index = -1, result = Array(set4.size);
      set4.forEach(function (value) {
        result[++index] = value;
      });
      return result;
    }
    var arrayProto2 = Array.prototype;
    var funcProto4 = Function.prototype;
    var objectProto16 = Object.prototype;
    var coreJsData2 = root2["__core-js_shared__"];
    var funcToString4 = funcProto4.toString;
    var hasOwnProperty13 = objectProto16.hasOwnProperty;
    var maskSrcKey2 = function () {
      var uid = /[^.]+$/.exec(coreJsData2 && coreJsData2.keys && coreJsData2.keys.IE_PROTO || "");
      return uid ? "Symbol(src)_1." + uid : "";
    }();
    var nativeObjectToString3 = objectProto16.toString;
    var reIsNative2 = RegExp(
      "^" + funcToString4.call(hasOwnProperty13).replace(reRegExpChar2, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
    );
    var Buffer4 = moduleExports4 ? root2.Buffer : void 0;
    var Symbol3 = root2.Symbol;
    var Uint8Array3 = root2.Uint8Array;
    var propertyIsEnumerable3 = objectProto16.propertyIsEnumerable;
    var splice2 = arrayProto2.splice;
    var symToStringTag3 = Symbol3 ? Symbol3.toStringTag : void 0;
    var nativeGetSymbols3 = Object.getOwnPropertySymbols;
    var nativeIsBuffer2 = Buffer4 ? Buffer4.isBuffer : void 0;
    var nativeKeys2 = overArg2(Object.keys, Object);
    var DataView2 = getNative2(root2, "DataView");
    var Map3 = getNative2(root2, "Map");
    var Promise3 = getNative2(root2, "Promise");
    var Set3 = getNative2(root2, "Set");
    var WeakMap3 = getNative2(root2, "WeakMap");
    var nativeCreate2 = getNative2(Object, "create");
    var dataViewCtorString2 = toSource2(DataView2);
    var mapCtorString2 = toSource2(Map3);
    var promiseCtorString2 = toSource2(Promise3);
    var setCtorString2 = toSource2(Set3);
    var weakMapCtorString2 = toSource2(WeakMap3);
    var symbolProto3 = Symbol3 ? Symbol3.prototype : void 0;
    var symbolValueOf2 = symbolProto3 ? symbolProto3.valueOf : void 0;
    function Hash2(entries4) {
      var index = -1, length = entries4 == null ? 0 : entries4.length;
      this.clear();
      while (++index < length) {
        var entry = entries4[index];
        this.set(entry[0], entry[1]);
      }
    }
    function hashClear2() {
      this.__data__ = nativeCreate2 ? nativeCreate2(null) : {};
      this.size = 0;
    }
    function hashDelete2(key) {
      var result = this.has(key) && delete this.__data__[key];
      this.size -= result ? 1 : 0;
      return result;
    }
    function hashGet2(key) {
      var data = this.__data__;
      if (nativeCreate2) {
        var result = data[key];
        return result === HASH_UNDEFINED4 ? void 0 : result;
      }
      return hasOwnProperty13.call(data, key) ? data[key] : void 0;
    }
    function hashHas2(key) {
      var data = this.__data__;
      return nativeCreate2 ? data[key] !== void 0 : hasOwnProperty13.call(data, key);
    }
    function hashSet2(key, value) {
      var data = this.__data__;
      this.size += this.has(key) ? 0 : 1;
      data[key] = nativeCreate2 && value === void 0 ? HASH_UNDEFINED4 : value;
      return this;
    }
    Hash2.prototype.clear = hashClear2;
    Hash2.prototype["delete"] = hashDelete2;
    Hash2.prototype.get = hashGet2;
    Hash2.prototype.has = hashHas2;
    Hash2.prototype.set = hashSet2;
    function ListCache2(entries4) {
      var index = -1, length = entries4 == null ? 0 : entries4.length;
      this.clear();
      while (++index < length) {
        var entry = entries4[index];
        this.set(entry[0], entry[1]);
      }
    }
    function listCacheClear2() {
      this.__data__ = [];
      this.size = 0;
    }
    function listCacheDelete2(key) {
      var data = this.__data__, index = assocIndexOf2(data, key);
      if (index < 0) {
        return false;
      }
      var lastIndex = data.length - 1;
      if (index == lastIndex) {
        data.pop();
      } else {
        splice2.call(data, index, 1);
      }
      --this.size;
      return true;
    }
    function listCacheGet2(key) {
      var data = this.__data__, index = assocIndexOf2(data, key);
      return index < 0 ? void 0 : data[index][1];
    }
    function listCacheHas2(key) {
      return assocIndexOf2(this.__data__, key) > -1;
    }
    function listCacheSet2(key, value) {
      var data = this.__data__, index = assocIndexOf2(data, key);
      if (index < 0) {
        ++this.size;
        data.push([key, value]);
      } else {
        data[index][1] = value;
      }
      return this;
    }
    ListCache2.prototype.clear = listCacheClear2;
    ListCache2.prototype["delete"] = listCacheDelete2;
    ListCache2.prototype.get = listCacheGet2;
    ListCache2.prototype.has = listCacheHas2;
    ListCache2.prototype.set = listCacheSet2;
    function MapCache2(entries4) {
      var index = -1, length = entries4 == null ? 0 : entries4.length;
      this.clear();
      while (++index < length) {
        var entry = entries4[index];
        this.set(entry[0], entry[1]);
      }
    }
    function mapCacheClear2() {
      this.size = 0;
      this.__data__ = {
        "hash": new Hash2(),
        "map": new (Map3 || ListCache2)(),
        "string": new Hash2()
      };
    }
    function mapCacheDelete2(key) {
      var result = getMapData2(this, key)["delete"](key);
      this.size -= result ? 1 : 0;
      return result;
    }
    function mapCacheGet2(key) {
      return getMapData2(this, key).get(key);
    }
    function mapCacheHas2(key) {
      return getMapData2(this, key).has(key);
    }
    function mapCacheSet2(key, value) {
      var data = getMapData2(this, key), size2 = data.size;
      data.set(key, value);
      this.size += data.size == size2 ? 0 : 1;
      return this;
    }
    MapCache2.prototype.clear = mapCacheClear2;
    MapCache2.prototype["delete"] = mapCacheDelete2;
    MapCache2.prototype.get = mapCacheGet2;
    MapCache2.prototype.has = mapCacheHas2;
    MapCache2.prototype.set = mapCacheSet2;
    function SetCache2(values) {
      var index = -1, length = values == null ? 0 : values.length;
      this.__data__ = new MapCache2();
      while (++index < length) {
        this.add(values[index]);
      }
    }
    function setCacheAdd2(value) {
      this.__data__.set(value, HASH_UNDEFINED4);
      return this;
    }
    function setCacheHas2(value) {
      return this.__data__.has(value);
    }
    SetCache2.prototype.add = SetCache2.prototype.push = setCacheAdd2;
    SetCache2.prototype.has = setCacheHas2;
    function Stack2(entries4) {
      var data = this.__data__ = new ListCache2(entries4);
      this.size = data.size;
    }
    function stackClear2() {
      this.__data__ = new ListCache2();
      this.size = 0;
    }
    function stackDelete2(key) {
      var data = this.__data__, result = data["delete"](key);
      this.size = data.size;
      return result;
    }
    function stackGet2(key) {
      return this.__data__.get(key);
    }
    function stackHas2(key) {
      return this.__data__.has(key);
    }
    function stackSet2(key, value) {
      var data = this.__data__;
      if (data instanceof ListCache2) {
        var pairs2 = data.__data__;
        if (!Map3 || pairs2.length < LARGE_ARRAY_SIZE3 - 1) {
          pairs2.push([key, value]);
          this.size = ++data.size;
          return this;
        }
        data = this.__data__ = new MapCache2(pairs2);
      }
      data.set(key, value);
      this.size = data.size;
      return this;
    }
    Stack2.prototype.clear = stackClear2;
    Stack2.prototype["delete"] = stackDelete2;
    Stack2.prototype.get = stackGet2;
    Stack2.prototype.has = stackHas2;
    Stack2.prototype.set = stackSet2;
    function arrayLikeKeys2(value, inherited) {
      var isArr = isArray2(value), isArg = !isArr && isArguments2(value), isBuff = !isArr && !isArg && isBuffer2(value), isType = !isArr && !isArg && !isBuff && isTypedArray2(value), skipIndexes = isArr || isArg || isBuff || isType, result = skipIndexes ? baseTimes2(value.length, String) : [], length = result.length;
      for (var key in value) {
        if ((inherited || hasOwnProperty13.call(value, key)) && !(skipIndexes && // Safari 9 has enumerable `arguments.length` in strict mode.
          (key == "length" || // Node.js 0.10 has enumerable non-index properties on buffers.
            isBuff && (key == "offset" || key == "parent") || // PhantomJS 2 has enumerable non-index properties on typed arrays.
            isType && (key == "buffer" || key == "byteLength" || key == "byteOffset") || // Skip index properties.
            isIndex2(key, length)))) {
          result.push(key);
        }
      }
      return result;
    }
    function assocIndexOf2(array, key) {
      var length = array.length;
      while (length--) {
        if (eq2(array[length][0], key)) {
          return length;
        }
      }
      return -1;
    }
    function baseGetAllKeys2(object3, keysFunc, symbolsFunc) {
      var result = keysFunc(object3);
      return isArray2(object3) ? result : arrayPush2(result, symbolsFunc(object3));
    }
    function baseGetTag2(value) {
      if (value == null) {
        return value === void 0 ? undefinedTag2 : nullTag2;
      }
      return symToStringTag3 && symToStringTag3 in Object(value) ? getRawTag2(value) : objectToString2(value);
    }
    function baseIsArguments2(value) {
      return isObjectLike3(value) && baseGetTag2(value) == argsTag4;
    }
    function baseIsEqual2(value, other, bitmask, customizer, stack) {
      if (value === other) {
        return true;
      }
      if (value == null || other == null || !isObjectLike3(value) && !isObjectLike3(other)) {
        return value !== value && other !== other;
      }
      return baseIsEqualDeep2(value, other, bitmask, customizer, baseIsEqual2, stack);
    }
    function baseIsEqualDeep2(object3, other, bitmask, customizer, equalFunc, stack) {
      var objIsArr = isArray2(object3), othIsArr = isArray2(other), objTag = objIsArr ? arrayTag3 : getTag2(object3), othTag = othIsArr ? arrayTag3 : getTag2(other);
      objTag = objTag == argsTag4 ? objectTag5 : objTag;
      othTag = othTag == argsTag4 ? objectTag5 : othTag;
      var objIsObj = objTag == objectTag5, othIsObj = othTag == objectTag5, isSameTag = objTag == othTag;
      if (isSameTag && isBuffer2(object3)) {
        if (!isBuffer2(other)) {
          return false;
        }
        objIsArr = true;
        objIsObj = false;
      }
      if (isSameTag && !objIsObj) {
        stack || (stack = new Stack2());
        return objIsArr || isTypedArray2(object3) ? equalArrays2(object3, other, bitmask, customizer, equalFunc, stack) : equalByTag2(object3, other, objTag, bitmask, customizer, equalFunc, stack);
      }
      if (!(bitmask & COMPARE_PARTIAL_FLAG7)) {
        var objIsWrapped = objIsObj && hasOwnProperty13.call(object3, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty13.call(other, "__wrapped__");
        if (objIsWrapped || othIsWrapped) {
          var objUnwrapped = objIsWrapped ? object3.value() : object3, othUnwrapped = othIsWrapped ? other.value() : other;
          stack || (stack = new Stack2());
          return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
        }
      }
      if (!isSameTag) {
        return false;
      }
      stack || (stack = new Stack2());
      return equalObjects2(object3, other, bitmask, customizer, equalFunc, stack);
    }
    function baseIsNative2(value) {
      if (!isObject3(value) || isMasked2(value)) {
        return false;
      }
      var pattern = isFunction2(value) ? reIsNative2 : reIsHostCtor2;
      return pattern.test(toSource2(value));
    }
    function baseIsTypedArray2(value) {
      return isObjectLike3(value) && isLength2(value.length) && !!typedArrayTags2[baseGetTag2(value)];
    }
    function baseKeys2(object3) {
      if (!isPrototype2(object3)) {
        return nativeKeys2(object3);
      }
      var result = [];
      for (var key in Object(object3)) {
        if (hasOwnProperty13.call(object3, key) && key != "constructor") {
          result.push(key);
        }
      }
      return result;
    }
    function equalArrays2(array, other, bitmask, customizer, equalFunc, stack) {
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG7, arrLength = array.length, othLength = other.length;
      if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
        return false;
      }
      var stacked = stack.get(array);
      if (stacked && stack.get(other)) {
        return stacked == other;
      }
      var index = -1, result = true, seen = bitmask & COMPARE_UNORDERED_FLAG5 ? new SetCache2() : void 0;
      stack.set(array, other);
      stack.set(other, array);
      while (++index < arrLength) {
        var arrValue = array[index], othValue = other[index];
        if (customizer) {
          var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
        }
        if (compared !== void 0) {
          if (compared) {
            continue;
          }
          result = false;
          break;
        }
        if (seen) {
          if (!arraySome2(other, function (othValue2, othIndex) {
            if (!cacheHas2(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
              return seen.push(othIndex);
            }
          })) {
            result = false;
            break;
          }
        } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
          result = false;
          break;
        }
      }
      stack["delete"](array);
      stack["delete"](other);
      return result;
    }
    function equalByTag2(object3, other, tag, bitmask, customizer, equalFunc, stack) {
      switch (tag) {
        case dataViewTag4:
          if (object3.byteLength != other.byteLength || object3.byteOffset != other.byteOffset) {
            return false;
          }
          object3 = object3.buffer;
          other = other.buffer;
        case arrayBufferTag3:
          if (object3.byteLength != other.byteLength || !equalFunc(new Uint8Array3(object3), new Uint8Array3(other))) {
            return false;
          }
          return true;
        case boolTag3:
        case dateTag3:
        case numberTag3:
          return eq2(+object3, +other);
        case errorTag3:
          return object3.name == other.name && object3.message == other.message;
        case regexpTag3:
        case stringTag4:
          return object3 == other + "";
        case mapTag5:
          var convert3 = mapToArray2;
        case setTag5:
          var isPartial = bitmask & COMPARE_PARTIAL_FLAG7;
          convert3 || (convert3 = setToArray2);
          if (object3.size != other.size && !isPartial) {
            return false;
          }
          var stacked = stack.get(object3);
          if (stacked) {
            return stacked == other;
          }
          bitmask |= COMPARE_UNORDERED_FLAG5;
          stack.set(object3, other);
          var result = equalArrays2(convert3(object3), convert3(other), bitmask, customizer, equalFunc, stack);
          stack["delete"](object3);
          return result;
        case symbolTag3:
          if (symbolValueOf2) {
            return symbolValueOf2.call(object3) == symbolValueOf2.call(other);
          }
      }
      return false;
    }
    function equalObjects2(object3, other, bitmask, customizer, equalFunc, stack) {
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG7, objProps = getAllKeys2(object3), objLength = objProps.length, othProps = getAllKeys2(other), othLength = othProps.length;
      if (objLength != othLength && !isPartial) {
        return false;
      }
      var index = objLength;
      while (index--) {
        var key = objProps[index];
        if (!(isPartial ? key in other : hasOwnProperty13.call(other, key))) {
          return false;
        }
      }
      var stacked = stack.get(object3);
      if (stacked && stack.get(other)) {
        return stacked == other;
      }
      var result = true;
      stack.set(object3, other);
      stack.set(other, object3);
      var skipCtor = isPartial;
      while (++index < objLength) {
        key = objProps[index];
        var objValue = object3[key], othValue = other[key];
        if (customizer) {
          var compared = isPartial ? customizer(othValue, objValue, key, other, object3, stack) : customizer(objValue, othValue, key, object3, other, stack);
        }
        if (!(compared === void 0 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
          result = false;
          break;
        }
        skipCtor || (skipCtor = key == "constructor");
      }
      if (result && !skipCtor) {
        var objCtor = object3.constructor, othCtor = other.constructor;
        if (objCtor != othCtor && ("constructor" in object3 && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
          result = false;
        }
      }
      stack["delete"](object3);
      stack["delete"](other);
      return result;
    }
    function getAllKeys2(object3) {
      return baseGetAllKeys2(object3, keys5, getSymbols2);
    }
    function getMapData2(map2, key) {
      var data = map2.__data__;
      return isKeyable2(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
    }
    function getNative2(object3, key) {
      var value = getValue2(object3, key);
      return baseIsNative2(value) ? value : void 0;
    }
    function getRawTag2(value) {
      var isOwn = hasOwnProperty13.call(value, symToStringTag3), tag = value[symToStringTag3];
      try {
        value[symToStringTag3] = void 0;
        var unmasked = true;
      } catch (e) {
      }
      var result = nativeObjectToString3.call(value);
      if (unmasked) {
        if (isOwn) {
          value[symToStringTag3] = tag;
        } else {
          delete value[symToStringTag3];
        }
      }
      return result;
    }
    var getSymbols2 = !nativeGetSymbols3 ? stubArray2 : function (object3) {
      if (object3 == null) {
        return [];
      }
      object3 = Object(object3);
      return arrayFilter2(nativeGetSymbols3(object3), function (symbol) {
        return propertyIsEnumerable3.call(object3, symbol);
      });
    };
    var getTag2 = baseGetTag2;
    if (DataView2 && getTag2(new DataView2(new ArrayBuffer(1))) != dataViewTag4 || Map3 && getTag2(new Map3()) != mapTag5 || Promise3 && getTag2(Promise3.resolve()) != promiseTag2 || Set3 && getTag2(new Set3()) != setTag5 || WeakMap3 && getTag2(new WeakMap3()) != weakMapTag3) {
      getTag2 = function (value) {
        var result = baseGetTag2(value), Ctor = result == objectTag5 ? value.constructor : void 0, ctorString = Ctor ? toSource2(Ctor) : "";
        if (ctorString) {
          switch (ctorString) {
            case dataViewCtorString2:
              return dataViewTag4;
            case mapCtorString2:
              return mapTag5;
            case promiseCtorString2:
              return promiseTag2;
            case setCtorString2:
              return setTag5;
            case weakMapCtorString2:
              return weakMapTag3;
          }
        }
        return result;
      };
    }
    function isIndex2(value, length) {
      length = length == null ? MAX_SAFE_INTEGER3 : length;
      return !!length && (typeof value == "number" || reIsUint2.test(value)) && (value > -1 && value % 1 == 0 && value < length);
    }
    function isKeyable2(value) {
      var type2 = typeof value;
      return type2 == "string" || type2 == "number" || type2 == "symbol" || type2 == "boolean" ? value !== "__proto__" : value === null;
    }
    function isMasked2(func) {
      return !!maskSrcKey2 && maskSrcKey2 in func;
    }
    function isPrototype2(value) {
      var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto16;
      return value === proto;
    }
    function objectToString2(value) {
      return nativeObjectToString3.call(value);
    }
    function toSource2(func) {
      if (func != null) {
        try {
          return funcToString4.call(func);
        } catch (e) {
        }
        try {
          return func + "";
        } catch (e) {
        }
      }
      return "";
    }
    function eq2(value, other) {
      return value === other || value !== value && other !== other;
    }
    var isArguments2 = baseIsArguments2(/* @__PURE__ */ function () {
      return arguments;
    }()) ? baseIsArguments2 : function (value) {
      return isObjectLike3(value) && hasOwnProperty13.call(value, "callee") && !propertyIsEnumerable3.call(value, "callee");
    };
    var isArray2 = Array.isArray;
    function isArrayLike2(value) {
      return value != null && isLength2(value.length) && !isFunction2(value);
    }
    var isBuffer2 = nativeIsBuffer2 || stubFalse2;
    function isEqual2(value, other) {
      return baseIsEqual2(value, other);
    }
    function isFunction2(value) {
      if (!isObject3(value)) {
        return false;
      }
      var tag = baseGetTag2(value);
      return tag == funcTag3 || tag == genTag2 || tag == asyncTag2 || tag == proxyTag2;
    }
    function isLength2(value) {
      return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER3;
    }
    function isObject3(value) {
      var type2 = typeof value;
      return value != null && (type2 == "object" || type2 == "function");
    }
    function isObjectLike3(value) {
      return value != null && typeof value == "object";
    }
    var isTypedArray2 = nodeIsTypedArray2 ? baseUnary2(nodeIsTypedArray2) : baseIsTypedArray2;
    function keys5(object3) {
      return isArrayLike2(object3) ? arrayLikeKeys2(object3) : baseKeys2(object3);
    }
    function stubArray2() {
      return [];
    }
    function stubFalse2() {
      return false;
    }
    module2.exports = isEqual2;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/oas2/remove-unused-components.js
var require_remove_unused_components = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/oas2/remove-unused-components.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RemoveUnusedComponents = void 0;
    var utils_1 = require_utils3();
    var RemoveUnusedComponents = () => {
      const components = /* @__PURE__ */ new Map();
      function registerComponent(location, componentType, name) {
        var _a;
        components.set(location.absolutePointer, {
          used: ((_a = components.get(location.absolutePointer)) === null || _a === void 0 ? void 0 : _a.used) || false,
          componentType,
          name
        });
      }
      return {
        ref: {
          leave(ref, { type: type2, resolve, key }) {
            if (["Schema", "Parameter", "Response", "SecurityScheme"].includes(type2.name)) {
              const resolvedRef = resolve(ref);
              if (!resolvedRef.location)
                return;
              const [fileLocation, localPointer] = resolvedRef.location.absolutePointer.split("#", 2);
              const componentLevelLocalPointer = localPointer.split("/").slice(0, 3).join("/");
              const pointer = `${fileLocation}#${componentLevelLocalPointer}`;
              components.set(pointer, {
                used: true,
                name: key.toString()
              });
            }
          }
        },
        Root: {
          leave(root2, ctx) {
            const data = ctx.getVisitorData();
            data.removedCount = 0;
            const rootComponents = /* @__PURE__ */ new Set();
            components.forEach((usageInfo) => {
              const { used, name, componentType } = usageInfo;
              if (!used && componentType) {
                rootComponents.add(componentType);
                delete root2[componentType][name];
                data.removedCount++;
              }
            });
            for (const component of rootComponents) {
              if ((0, utils_1.isEmptyObject)(root2[component])) {
                delete root2[component];
              }
            }
          }
        },
        NamedSchemas: {
          Schema(schema2, { location, key }) {
            if (!schema2.allOf) {
              registerComponent(location, "definitions", key.toString());
            }
          }
        },
        NamedParameters: {
          Parameter(_parameter, { location, key }) {
            registerComponent(location, "parameters", key.toString());
          }
        },
        NamedResponses: {
          Response(_response, { location, key }) {
            registerComponent(location, "responses", key.toString());
          }
        },
        NamedSecuritySchemes: {
          SecurityScheme(_securityScheme, { location, key }) {
            registerComponent(location, "securityDefinitions", key.toString());
          }
        }
      };
    };
    exports2.RemoveUnusedComponents = RemoveUnusedComponents;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/oas3/remove-unused-components.js
var require_remove_unused_components2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/decorators/oas3/remove-unused-components.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.RemoveUnusedComponents = void 0;
    var utils_1 = require_utils3();
    var RemoveUnusedComponents = () => {
      const components = /* @__PURE__ */ new Map();
      function registerComponent(location, componentType, name) {
        var _a;
        components.set(location.absolutePointer, {
          used: ((_a = components.get(location.absolutePointer)) === null || _a === void 0 ? void 0 : _a.used) || false,
          componentType,
          name
        });
      }
      return {
        ref: {
          leave(ref, { type: type2, resolve, key }) {
            if (["Schema", "Header", "Parameter", "Response", "Example", "RequestBody"].includes(type2.name)) {
              const resolvedRef = resolve(ref);
              if (!resolvedRef.location)
                return;
              const [fileLocation, localPointer] = resolvedRef.location.absolutePointer.split("#", 2);
              const componentLevelLocalPointer = localPointer.split("/").slice(0, 4).join("/");
              const pointer = `${fileLocation}#${componentLevelLocalPointer}`;
              components.set(pointer, {
                used: true,
                name: key.toString()
              });
            }
          }
        },
        Root: {
          leave(root2, ctx) {
            const data = ctx.getVisitorData();
            data.removedCount = 0;
            components.forEach((usageInfo) => {
              const { used, componentType, name } = usageInfo;
              if (!used && componentType && root2.components) {
                const componentChild = root2.components[componentType];
                delete componentChild[name];
                data.removedCount++;
                if ((0, utils_1.isEmptyObject)(componentChild)) {
                  delete root2.components[componentType];
                }
              }
            });
            if ((0, utils_1.isEmptyObject)(root2.components)) {
              delete root2.components;
            }
          }
        },
        NamedSchemas: {
          Schema(schema2, { location, key }) {
            if (!schema2.allOf) {
              registerComponent(location, "schemas", key.toString());
            }
          }
        },
        NamedParameters: {
          Parameter(_parameter, { location, key }) {
            registerComponent(location, "parameters", key.toString());
          }
        },
        NamedResponses: {
          Response(_response, { location, key }) {
            registerComponent(location, "responses", key.toString());
          }
        },
        NamedExamples: {
          Example(_example, { location, key }) {
            registerComponent(location, "examples", key.toString());
          }
        },
        NamedRequestBodies: {
          RequestBody(_requestBody, { location, key }) {
            registerComponent(location, "requestBodies", key.toString());
          }
        },
        NamedHeaders: {
          Header(_header, { location, key }) {
            registerComponent(location, "headers", key.toString());
          }
        }
      };
    };
    exports2.RemoveUnusedComponents = RemoveUnusedComponents;
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/bundle.js
var require_bundle = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/bundle.js"(exports2) {
    "use strict";
    var __awaiter = exports2 && exports2.__awaiter || function (thisArg, _arguments, P, generator) {
      function adopt(value) {
        return value instanceof P ? value : new P(function (resolve) {
          resolve(value);
        });
      }
      return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
          try {
            step(generator.next(value));
          } catch (e) {
            reject(e);
          }
        }
        function rejected(value) {
          try {
            step(generator["throw"](value));
          } catch (e) {
            reject(e);
          }
        }
        function step(result) {
          result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.mapTypeToComponent = exports2.bundleDocument = exports2.bundleFromString = exports2.bundle = exports2.OasVersion = void 0;
    var isEqual2 = require_lodash();
    var resolve_1 = require_resolve2();
    var visitors_1 = require_visitors();
    var types_1 = require_types();
    var walk_1 = require_walk();
    var oas_types_1 = require_oas_types();
    var ref_utils_1 = require_ref_utils();
    var rules_1 = require_rules();
    var no_unresolved_refs_1 = require_no_unresolved_refs();
    var utils_1 = require_utils3();
    var redocly_1 = require_redocly();
    var remove_unused_components_1 = require_remove_unused_components();
    var remove_unused_components_2 = require_remove_unused_components2();
    var OasVersion;
    (function (OasVersion2) {
      OasVersion2["Version2"] = "oas2";
      OasVersion2["Version3_0"] = "oas3_0";
      OasVersion2["Version3_1"] = "oas3_1";
    })(OasVersion || (exports2.OasVersion = OasVersion = {}));
    function bundle2(opts) {
      return __awaiter(this, void 0, void 0, function* () {
        const { ref, doc, externalRefResolver = new resolve_1.BaseResolver(opts.config.resolve), base = null } = opts;
        if (!(ref || doc)) {
          throw new Error("Document or reference is required.\n");
        }
        const document = doc === void 0 ? yield externalRefResolver.resolveDocument(base, ref, true) : doc;
        if (document instanceof Error) {
          throw document;
        }
        return bundleDocument(Object.assign(Object.assign({ document }, opts), { config: opts.config.styleguide, externalRefResolver }));
      });
    }
    exports2.bundle = bundle2;
    function bundleFromString(opts) {
      return __awaiter(this, void 0, void 0, function* () {
        const { source, absoluteRef, externalRefResolver = new resolve_1.BaseResolver(opts.config.resolve) } = opts;
        const document = (0, resolve_1.makeDocumentFromString)(source, absoluteRef || "/");
        return bundleDocument(Object.assign(Object.assign({ document }, opts), { externalRefResolver, config: opts.config.styleguide }));
      });
    }
    exports2.bundleFromString = bundleFromString;
    function bundleDocument(opts) {
      return __awaiter(this, void 0, void 0, function* () {
        const { document, config, customTypes, externalRefResolver, dereference = false, skipRedoclyRegistryRefs = false, removeUnusedComponents = false, keepUrlRefs = false } = opts;
        const specVersion = (0, oas_types_1.detectSpec)(document.parsed);
        const specMajorVersion = (0, oas_types_1.getMajorSpecVersion)(specVersion);
        const rules = config.getRulesForOasVersion(specMajorVersion);
        const types2 = (0, types_1.normalizeTypes)(config.extendTypes(customTypes !== null && customTypes !== void 0 ? customTypes : (0, oas_types_1.getTypes)(specVersion), specVersion), config);
        const preprocessors = (0, rules_1.initRules)(rules, config, "preprocessors", specVersion);
        const decorators = (0, rules_1.initRules)(rules, config, "decorators", specVersion);
        const ctx = {
          problems: [],
          oasVersion: specVersion,
          refTypes: /* @__PURE__ */ new Map(),
          visitorsData: {}
        };
        if (removeUnusedComponents) {
          decorators.push({
            severity: "error",
            ruleId: "remove-unused-components",
            visitor: specMajorVersion === oas_types_1.SpecMajorVersion.OAS2 ? (0, remove_unused_components_1.RemoveUnusedComponents)({}) : (0, remove_unused_components_2.RemoveUnusedComponents)({})
          });
        }
        let resolvedRefMap = yield (0, resolve_1.resolveDocument)({
          rootDocument: document,
          rootType: types2.Root,
          externalRefResolver
        });
        if (preprocessors.length > 0) {
          (0, walk_1.walkDocument)({
            document,
            rootType: types2.Root,
            normalizedVisitors: (0, visitors_1.normalizeVisitors)(preprocessors, types2),
            resolvedRefMap,
            ctx
          });
          resolvedRefMap = yield (0, resolve_1.resolveDocument)({
            rootDocument: document,
            rootType: types2.Root,
            externalRefResolver
          });
        }
        const bundleVisitor = (0, visitors_1.normalizeVisitors)([
          {
            severity: "error",
            ruleId: "bundler",
            visitor: makeBundleVisitor(specMajorVersion, dereference, skipRedoclyRegistryRefs, document, resolvedRefMap, keepUrlRefs)
          },
          ...decorators
        ], types2);
        (0, walk_1.walkDocument)({
          document,
          rootType: types2.Root,
          normalizedVisitors: bundleVisitor,
          resolvedRefMap,
          ctx
        });
        return {
          bundle: document,
          problems: ctx.problems.map((problem) => config.addProblemToIgnore(problem)),
          fileDependencies: externalRefResolver.getFiles(),
          rootType: types2.Root,
          refTypes: ctx.refTypes,
          visitorsData: ctx.visitorsData
        };
      });
    }
    exports2.bundleDocument = bundleDocument;
    function mapTypeToComponent(typeName, version) {
      switch (version) {
        case oas_types_1.SpecMajorVersion.OAS3:
          switch (typeName) {
            case "Schema":
              return "schemas";
            case "Parameter":
              return "parameters";
            case "Response":
              return "responses";
            case "Example":
              return "examples";
            case "RequestBody":
              return "requestBodies";
            case "Header":
              return "headers";
            case "SecuritySchema":
              return "securitySchemes";
            case "Link":
              return "links";
            case "Callback":
              return "callbacks";
            default:
              return null;
          }
        case oas_types_1.SpecMajorVersion.OAS2:
          switch (typeName) {
            case "Schema":
              return "definitions";
            case "Parameter":
              return "parameters";
            case "Response":
              return "responses";
            default:
              return null;
          }
        case oas_types_1.SpecMajorVersion.Async2:
          switch (typeName) {
            case "Schema":
              return "schemas";
            case "Parameter":
              return "parameters";
            default:
              return null;
          }
      }
    }
    exports2.mapTypeToComponent = mapTypeToComponent;
    function makeBundleVisitor(version, dereference, skipRedoclyRegistryRefs, rootDocument, resolvedRefMap, keepUrlRefs) {
      let components;
      let rootLocation;
      const visitor = {
        ref: {
          leave(node, ctx, resolved) {
            if (!resolved.location || resolved.node === void 0) {
              (0, no_unresolved_refs_1.reportUnresolvedRef)(resolved, ctx.report, ctx.location);
              return;
            }
            if (resolved.location.source === rootDocument.source && resolved.location.source === ctx.location.source && ctx.type.name !== "scalar" && !dereference) {
              return;
            }
            if (skipRedoclyRegistryRefs && (0, redocly_1.isRedoclyRegistryURL)(node.$ref)) {
              return;
            }
            if (keepUrlRefs && (0, ref_utils_1.isAbsoluteUrl)(node.$ref)) {
              return;
            }
            const componentType = mapTypeToComponent(ctx.type.name, version);
            if (!componentType) {
              replaceRef(node, resolved, ctx);
            } else {
              if (dereference) {
                saveComponent(componentType, resolved, ctx);
                replaceRef(node, resolved, ctx);
              } else {
                node.$ref = saveComponent(componentType, resolved, ctx);
                resolveBundledComponent(node, resolved, ctx);
              }
            }
          }
        },
        Root: {
          enter(root2, ctx) {
            rootLocation = ctx.location;
            if (version === oas_types_1.SpecMajorVersion.OAS3) {
              components = root2.components = root2.components || {};
            } else if (version === oas_types_1.SpecMajorVersion.OAS2) {
              components = root2;
            }
          }
        }
      };
      if (version === oas_types_1.SpecMajorVersion.OAS3) {
        visitor.DiscriminatorMapping = {
          leave(mapping, ctx) {
            for (const name of Object.keys(mapping)) {
              const $ref = mapping[name];
              const resolved = ctx.resolve({ $ref });
              if (!resolved.location || resolved.node === void 0) {
                (0, no_unresolved_refs_1.reportUnresolvedRef)(resolved, ctx.report, ctx.location.child(name));
                return;
              }
              const componentType = mapTypeToComponent("Schema", version);
              if (dereference) {
                saveComponent(componentType, resolved, ctx);
              } else {
                mapping[name] = saveComponent(componentType, resolved, ctx);
              }
            }
          }
        };
      }
      function resolveBundledComponent(node, resolved, ctx) {
        const newRefId = (0, resolve_1.makeRefId)(ctx.location.source.absoluteRef, node.$ref);
        resolvedRefMap.set(newRefId, {
          document: rootDocument,
          isRemote: false,
          node: resolved.node,
          nodePointer: node.$ref,
          resolved: true
        });
      }
      function replaceRef(ref, resolved, ctx) {
        if (!(0, utils_1.isPlainObject)(resolved.node)) {
          ctx.parent[ctx.key] = resolved.node;
        } else {
          delete ref.$ref;
          const obj = Object.assign({}, resolved.node, ref);
          Object.assign(ref, obj);
        }
      }
      function saveComponent(componentType, target, ctx) {
        components[componentType] = components[componentType] || {};
        const name = getComponentName(target, componentType, ctx);
        components[componentType][name] = target.node;
        if (version === oas_types_1.SpecMajorVersion.OAS3) {
          return `#/components/${componentType}/${name}`;
        } else {
          return `#/${componentType}/${name}`;
        }
      }
      function isEqualOrEqualRef(node, target, ctx) {
        var _a;
        if ((0, ref_utils_1.isRef)(node) && ((_a = ctx.resolve(node, rootLocation.absolutePointer).location) === null || _a === void 0 ? void 0 : _a.absolutePointer) === target.location.absolutePointer) {
          return true;
        }
        return isEqual2(node, target.node);
      }
      function getComponentName(target, componentType, ctx) {
        const [fileRef, pointer] = [target.location.source.absoluteRef, target.location.pointer];
        const componentsGroup = components[componentType];
        let name = "";
        const refParts = pointer.slice(2).split("/").filter(utils_1.isTruthy);
        while (refParts.length > 0) {
          name = refParts.pop() + (name ? `-${name}` : "");
          if (!componentsGroup || !componentsGroup[name] || isEqualOrEqualRef(componentsGroup[name], target, ctx)) {
            return name;
          }
        }
        name = (0, ref_utils_1.refBaseName)(fileRef) + (name ? `_${name}` : "");
        if (!componentsGroup[name] || isEqualOrEqualRef(componentsGroup[name], target, ctx)) {
          return name;
        }
        const prevName = name;
        let serialId = 2;
        while (componentsGroup[name] && !isEqualOrEqualRef(componentsGroup[name], target, ctx)) {
          name = `${prevName}-${serialId}`;
          serialId++;
        }
        if (!componentsGroup[name]) {
          ctx.report({
            message: `Two schemas are referenced with the same name but different content. Renamed ${prevName} to ${name}.`,
            location: ctx.location,
            forceSeverity: "warn"
          });
        }
        return name;
      }
      return visitor;
    }
  }
});

// ../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/index.js
var require_lib2 = __commonJS({
  "../../../node_modules/.pnpm/@redocly+openapi-core@1.4.1/node_modules/@redocly/openapi-core/lib/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.lintConfig = exports2.lintFromString = exports2.lintDocument = exports2.validate = exports2.lint = exports2.getTotals = exports2.formatProblems = exports2.getLineColLocation = exports2.getAstNodeByPointer = exports2.walkDocument = exports2.normalizeVisitors = exports2.getTypes = exports2.detectSpec = exports2.SpecVersion = exports2.getMajorSpecVersion = exports2.SpecMajorVersion = exports2.isAbsoluteUrl = exports2.isRef = exports2.unescapePointer = exports2.stringifyYaml = exports2.parseYaml = exports2.makeDocumentFromString = exports2.YamlParseError = exports2.ResolveError = exports2.resolveDocument = exports2.BaseResolver = exports2.Source = exports2.isRedoclyRegistryURL = exports2.RedoclyClient = exports2.createConfig = exports2.CONFIG_FILE_NAMES = exports2.findConfig = exports2.getConfig = exports2.loadConfig = exports2.transformConfig = exports2.getMergedConfig = exports2.IGNORE_FILE = exports2.StyleguideConfig = exports2.Config = exports2.Stats = exports2.normalizeTypes = exports2.ConfigTypes = exports2.AsyncApi2Types = exports2.Oas2Types = exports2.Oas3Types = exports2.Oas3_1Types = exports2.isTruthy = exports2.doesYamlFileExist = exports2.slash = exports2.readFileFromUrl = void 0;
    exports2.bundleFromString = exports2.mapTypeToComponent = exports2.bundleDocument = exports2.bundle = void 0;
    var utils_1 = require_utils3();
    Object.defineProperty(exports2, "readFileFromUrl", {
      enumerable: true, get: function () {
        return utils_1.readFileFromUrl;
      }
    });
    Object.defineProperty(exports2, "slash", {
      enumerable: true, get: function () {
        return utils_1.slash;
      }
    });
    Object.defineProperty(exports2, "doesYamlFileExist", {
      enumerable: true, get: function () {
        return utils_1.doesYamlFileExist;
      }
    });
    Object.defineProperty(exports2, "isTruthy", {
      enumerable: true, get: function () {
        return utils_1.isTruthy;
      }
    });
    var oas3_1_1 = require_oas3_1();
    Object.defineProperty(exports2, "Oas3_1Types", {
      enumerable: true, get: function () {
        return oas3_1_1.Oas3_1Types;
      }
    });
    var oas3_1 = require_oas3();
    Object.defineProperty(exports2, "Oas3Types", {
      enumerable: true, get: function () {
        return oas3_1.Oas3Types;
      }
    });
    var oas2_1 = require_oas2();
    Object.defineProperty(exports2, "Oas2Types", {
      enumerable: true, get: function () {
        return oas2_1.Oas2Types;
      }
    });
    var asyncapi_1 = require_asyncapi();
    Object.defineProperty(exports2, "AsyncApi2Types", {
      enumerable: true, get: function () {
        return asyncapi_1.AsyncApi2Types;
      }
    });
    var redocly_yaml_1 = require_redocly_yaml();
    Object.defineProperty(exports2, "ConfigTypes", {
      enumerable: true, get: function () {
        return redocly_yaml_1.ConfigTypes;
      }
    });
    var types_1 = require_types();
    Object.defineProperty(exports2, "normalizeTypes", {
      enumerable: true, get: function () {
        return types_1.normalizeTypes;
      }
    });
    var stats_1 = require_stats();
    Object.defineProperty(exports2, "Stats", {
      enumerable: true, get: function () {
        return stats_1.Stats;
      }
    });
    var config_1 = require_config2();
    Object.defineProperty(exports2, "Config", {
      enumerable: true, get: function () {
        return config_1.Config;
      }
    });
    Object.defineProperty(exports2, "StyleguideConfig", {
      enumerable: true, get: function () {
        return config_1.StyleguideConfig;
      }
    });
    Object.defineProperty(exports2, "IGNORE_FILE", {
      enumerable: true, get: function () {
        return config_1.IGNORE_FILE;
      }
    });
    Object.defineProperty(exports2, "getMergedConfig", {
      enumerable: true, get: function () {
        return config_1.getMergedConfig;
      }
    });
    Object.defineProperty(exports2, "transformConfig", {
      enumerable: true, get: function () {
        return config_1.transformConfig;
      }
    });
    Object.defineProperty(exports2, "loadConfig", {
      enumerable: true, get: function () {
        return config_1.loadConfig;
      }
    });
    Object.defineProperty(exports2, "getConfig", {
      enumerable: true, get: function () {
        return config_1.getConfig;
      }
    });
    Object.defineProperty(exports2, "findConfig", {
      enumerable: true, get: function () {
        return config_1.findConfig;
      }
    });
    Object.defineProperty(exports2, "CONFIG_FILE_NAMES", {
      enumerable: true, get: function () {
        return config_1.CONFIG_FILE_NAMES;
      }
    });
    Object.defineProperty(exports2, "createConfig", {
      enumerable: true, get: function () {
        return config_1.createConfig;
      }
    });
    var redocly_1 = require_redocly();
    Object.defineProperty(exports2, "RedoclyClient", {
      enumerable: true, get: function () {
        return redocly_1.RedoclyClient;
      }
    });
    Object.defineProperty(exports2, "isRedoclyRegistryURL", {
      enumerable: true, get: function () {
        return redocly_1.isRedoclyRegistryURL;
      }
    });
    var resolve_1 = require_resolve2();
    Object.defineProperty(exports2, "Source", {
      enumerable: true, get: function () {
        return resolve_1.Source;
      }
    });
    Object.defineProperty(exports2, "BaseResolver", {
      enumerable: true, get: function () {
        return resolve_1.BaseResolver;
      }
    });
    Object.defineProperty(exports2, "resolveDocument", {
      enumerable: true, get: function () {
        return resolve_1.resolveDocument;
      }
    });
    Object.defineProperty(exports2, "ResolveError", {
      enumerable: true, get: function () {
        return resolve_1.ResolveError;
      }
    });
    Object.defineProperty(exports2, "YamlParseError", {
      enumerable: true, get: function () {
        return resolve_1.YamlParseError;
      }
    });
    Object.defineProperty(exports2, "makeDocumentFromString", {
      enumerable: true, get: function () {
        return resolve_1.makeDocumentFromString;
      }
    });
    var js_yaml_1 = require_js_yaml2();
    Object.defineProperty(exports2, "parseYaml", {
      enumerable: true, get: function () {
        return js_yaml_1.parseYaml;
      }
    });
    Object.defineProperty(exports2, "stringifyYaml", {
      enumerable: true, get: function () {
        return js_yaml_1.stringifyYaml;
      }
    });
    var ref_utils_1 = require_ref_utils();
    Object.defineProperty(exports2, "unescapePointer", {
      enumerable: true, get: function () {
        return ref_utils_1.unescapePointer;
      }
    });
    Object.defineProperty(exports2, "isRef", {
      enumerable: true, get: function () {
        return ref_utils_1.isRef;
      }
    });
    Object.defineProperty(exports2, "isAbsoluteUrl", {
      enumerable: true, get: function () {
        return ref_utils_1.isAbsoluteUrl;
      }
    });
    var oas_types_1 = require_oas_types();
    Object.defineProperty(exports2, "SpecMajorVersion", {
      enumerable: true, get: function () {
        return oas_types_1.SpecMajorVersion;
      }
    });
    Object.defineProperty(exports2, "getMajorSpecVersion", {
      enumerable: true, get: function () {
        return oas_types_1.getMajorSpecVersion;
      }
    });
    Object.defineProperty(exports2, "SpecVersion", {
      enumerable: true, get: function () {
        return oas_types_1.SpecVersion;
      }
    });
    Object.defineProperty(exports2, "detectSpec", {
      enumerable: true, get: function () {
        return oas_types_1.detectSpec;
      }
    });
    Object.defineProperty(exports2, "getTypes", {
      enumerable: true, get: function () {
        return oas_types_1.getTypes;
      }
    });
    var visitors_1 = require_visitors();
    Object.defineProperty(exports2, "normalizeVisitors", {
      enumerable: true, get: function () {
        return visitors_1.normalizeVisitors;
      }
    });
    var walk_1 = require_walk();
    Object.defineProperty(exports2, "walkDocument", {
      enumerable: true, get: function () {
        return walk_1.walkDocument;
      }
    });
    var codeframes_1 = require_codeframes();
    Object.defineProperty(exports2, "getAstNodeByPointer", {
      enumerable: true, get: function () {
        return codeframes_1.getAstNodeByPointer;
      }
    });
    Object.defineProperty(exports2, "getLineColLocation", {
      enumerable: true, get: function () {
        return codeframes_1.getLineColLocation;
      }
    });
    var format_1 = require_format3();
    Object.defineProperty(exports2, "formatProblems", {
      enumerable: true, get: function () {
        return format_1.formatProblems;
      }
    });
    Object.defineProperty(exports2, "getTotals", {
      enumerable: true, get: function () {
        return format_1.getTotals;
      }
    });
    var lint_1 = require_lint();
    Object.defineProperty(exports2, "lint", {
      enumerable: true, get: function () {
        return lint_1.lint;
      }
    });
    Object.defineProperty(exports2, "validate", {
      enumerable: true, get: function () {
        return lint_1.lint;
      }
    });
    Object.defineProperty(exports2, "lintDocument", {
      enumerable: true, get: function () {
        return lint_1.lintDocument;
      }
    });
    Object.defineProperty(exports2, "lintFromString", {
      enumerable: true, get: function () {
        return lint_1.lintFromString;
      }
    });
    Object.defineProperty(exports2, "lintConfig", {
      enumerable: true, get: function () {
        return lint_1.lintConfig;
      }
    });
    var bundle_1 = require_bundle();
    Object.defineProperty(exports2, "bundle", {
      enumerable: true, get: function () {
        return bundle_1.bundle;
      }
    });
    Object.defineProperty(exports2, "bundleDocument", {
      enumerable: true, get: function () {
        return bundle_1.bundleDocument;
      }
    });
    Object.defineProperty(exports2, "mapTypeToComponent", {
      enumerable: true, get: function () {
        return bundle_1.mapTypeToComponent;
      }
    });
    Object.defineProperty(exports2, "bundleFromString", {
      enumerable: true, get: function () {
        return bundle_1.bundleFromString;
      }
    });
  }
});

// ../../../node_modules/.pnpm/object-hash@3.0.0/node_modules/object-hash/index.js
var require_object_hash = __commonJS({
  "../../../node_modules/.pnpm/object-hash@3.0.0/node_modules/object-hash/index.js"(exports2, module2) {
    "use strict";
    var crypto2 = require("crypto");
    exports2 = module2.exports = objectHash;
    function objectHash(object3, options) {
      options = applyDefaults(object3, options);
      return hash2(object3, options);
    }
    exports2.sha1 = function (object3) {
      return objectHash(object3);
    };
    exports2.keys = function (object3) {
      return objectHash(object3, { excludeValues: true, algorithm: "sha1", encoding: "hex" });
    };
    exports2.MD5 = function (object3) {
      return objectHash(object3, { algorithm: "md5", encoding: "hex" });
    };
    exports2.keysMD5 = function (object3) {
      return objectHash(object3, { algorithm: "md5", encoding: "hex", excludeValues: true });
    };
    var hashes = crypto2.getHashes ? crypto2.getHashes().slice() : ["sha1", "md5"];
    hashes.push("passthrough");
    var encodings = ["buffer", "hex", "binary", "base64"];
    function applyDefaults(object3, sourceOptions) {
      sourceOptions = sourceOptions || {};
      var options = {};
      options.algorithm = sourceOptions.algorithm || "sha1";
      options.encoding = sourceOptions.encoding || "hex";
      options.excludeValues = sourceOptions.excludeValues ? true : false;
      options.algorithm = options.algorithm.toLowerCase();
      options.encoding = options.encoding.toLowerCase();
      options.ignoreUnknown = sourceOptions.ignoreUnknown !== true ? false : true;
      options.respectType = sourceOptions.respectType === false ? false : true;
      options.respectFunctionNames = sourceOptions.respectFunctionNames === false ? false : true;
      options.respectFunctionProperties = sourceOptions.respectFunctionProperties === false ? false : true;
      options.unorderedArrays = sourceOptions.unorderedArrays !== true ? false : true;
      options.unorderedSets = sourceOptions.unorderedSets === false ? false : true;
      options.unorderedObjects = sourceOptions.unorderedObjects === false ? false : true;
      options.replacer = sourceOptions.replacer || void 0;
      options.excludeKeys = sourceOptions.excludeKeys || void 0;
      if (typeof object3 === "undefined") {
        throw new Error("Object argument required.");
      }
      for (var i = 0; i < hashes.length; ++i) {
        if (hashes[i].toLowerCase() === options.algorithm.toLowerCase()) {
          options.algorithm = hashes[i];
        }
      }
      if (hashes.indexOf(options.algorithm) === -1) {
        throw new Error('Algorithm "' + options.algorithm + '"  not supported. supported values: ' + hashes.join(", "));
      }
      if (encodings.indexOf(options.encoding) === -1 && options.algorithm !== "passthrough") {
        throw new Error('Encoding "' + options.encoding + '"  not supported. supported values: ' + encodings.join(", "));
      }
      return options;
    }
    function isNativeFunction(f) {
      if (typeof f !== "function") {
        return false;
      }
      var exp = /^function\s+\w*\s*\(\s*\)\s*{\s+\[native code\]\s+}$/i;
      return exp.exec(Function.prototype.toString.call(f)) != null;
    }
    function hash2(object3, options) {
      var hashingStream;
      if (options.algorithm !== "passthrough") {
        hashingStream = crypto2.createHash(options.algorithm);
      } else {
        hashingStream = new PassThrough2();
      }
      if (typeof hashingStream.write === "undefined") {
        hashingStream.write = hashingStream.update;
        hashingStream.end = hashingStream.update;
      }
      var hasher = typeHasher(options, hashingStream);
      hasher.dispatch(object3);
      if (!hashingStream.update) {
        hashingStream.end("");
      }
      if (hashingStream.digest) {
        return hashingStream.digest(options.encoding === "buffer" ? void 0 : options.encoding);
      }
      var buf = hashingStream.read();
      if (options.encoding === "buffer") {
        return buf;
      }
      return buf.toString(options.encoding);
    }
    exports2.writeToStream = function (object3, options, stream) {
      if (typeof stream === "undefined") {
        stream = options;
        options = {};
      }
      options = applyDefaults(object3, options);
      return typeHasher(options, stream).dispatch(object3);
    };
    function typeHasher(options, writeTo, context) {
      context = context || [];
      var write = function (str2) {
        if (writeTo.update) {
          return writeTo.update(str2, "utf8");
        } else {
          return writeTo.write(str2, "utf8");
        }
      };
      return {
        dispatch: function (value) {
          if (options.replacer) {
            value = options.replacer(value);
          }
          var type2 = typeof value;
          if (value === null) {
            type2 = "null";
          }
          return this["_" + type2](value);
        },
        _object: function (object3) {
          var pattern = /\[object (.*)\]/i;
          var objString = Object.prototype.toString.call(object3);
          var objType = pattern.exec(objString);
          if (!objType) {
            objType = "unknown:[" + objString + "]";
          } else {
            objType = objType[1];
          }
          objType = objType.toLowerCase();
          var objectNumber = null;
          if ((objectNumber = context.indexOf(object3)) >= 0) {
            return this.dispatch("[CIRCULAR:" + objectNumber + "]");
          } else {
            context.push(object3);
          }
          if (typeof Buffer !== "undefined" && Buffer.isBuffer && Buffer.isBuffer(object3)) {
            write("buffer:");
            return write(object3);
          }
          if (objType !== "object" && objType !== "function" && objType !== "asyncfunction") {
            if (this["_" + objType]) {
              this["_" + objType](object3);
            } else if (options.ignoreUnknown) {
              return write("[" + objType + "]");
            } else {
              throw new Error('Unknown object type "' + objType + '"');
            }
          } else {
            var keys5 = Object.keys(object3);
            if (options.unorderedObjects) {
              keys5 = keys5.sort();
            }
            if (options.respectType !== false && !isNativeFunction(object3)) {
              keys5.splice(0, 0, "prototype", "__proto__", "constructor");
            }
            if (options.excludeKeys) {
              keys5 = keys5.filter(function (key) {
                return !options.excludeKeys(key);
              });
            }
            write("object:" + keys5.length + ":");
            var self2 = this;
            return keys5.forEach(function (key) {
              self2.dispatch(key);
              write(":");
              if (!options.excludeValues) {
                self2.dispatch(object3[key]);
              }
              write(",");
            });
          }
        },
        _array: function (arr, unordered) {
          unordered = typeof unordered !== "undefined" ? unordered : options.unorderedArrays !== false;
          var self2 = this;
          write("array:" + arr.length + ":");
          if (!unordered || arr.length <= 1) {
            return arr.forEach(function (entry) {
              return self2.dispatch(entry);
            });
          }
          var contextAdditions = [];
          var entries4 = arr.map(function (entry) {
            var strm = new PassThrough2();
            var localContext = context.slice();
            var hasher = typeHasher(options, strm, localContext);
            hasher.dispatch(entry);
            contextAdditions = contextAdditions.concat(localContext.slice(context.length));
            return strm.read().toString();
          });
          context = context.concat(contextAdditions);
          entries4.sort();
          return this._array(entries4, false);
        },
        _date: function (date3) {
          return write("date:" + date3.toJSON());
        },
        _symbol: function (sym) {
          return write("symbol:" + sym.toString());
        },
        _error: function (err) {
          return write("error:" + err.toString());
        },
        _boolean: function (bool2) {
          return write("bool:" + bool2.toString());
        },
        _string: function (string3) {
          write("string:" + string3.length + ":");
          write(string3.toString());
        },
        _function: function (fn) {
          write("fn:");
          if (isNativeFunction(fn)) {
            this.dispatch("[native]");
          } else {
            this.dispatch(fn.toString());
          }
          if (options.respectFunctionNames !== false) {
            this.dispatch("function-name:" + String(fn.name));
          }
          if (options.respectFunctionProperties) {
            this._object(fn);
          }
        },
        _number: function (number3) {
          return write("number:" + number3.toString());
        },
        _xml: function (xml) {
          return write("xml:" + xml.toString());
        },
        _null: function () {
          return write("Null");
        },
        _undefined: function () {
          return write("Undefined");
        },
        _regexp: function (regex) {
          return write("regex:" + regex.toString());
        },
        _uint8array: function (arr) {
          write("uint8array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _uint8clampedarray: function (arr) {
          write("uint8clampedarray:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _int8array: function (arr) {
          write("int8array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _uint16array: function (arr) {
          write("uint16array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _int16array: function (arr) {
          write("int16array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _uint32array: function (arr) {
          write("uint32array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _int32array: function (arr) {
          write("int32array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _float32array: function (arr) {
          write("float32array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _float64array: function (arr) {
          write("float64array:");
          return this.dispatch(Array.prototype.slice.call(arr));
        },
        _arraybuffer: function (arr) {
          write("arraybuffer:");
          return this.dispatch(new Uint8Array(arr));
        },
        _url: function (url) {
          return write("url:" + url.toString(), "utf8");
        },
        _map: function (map2) {
          write("map:");
          var arr = Array.from(map2);
          return this._array(arr, options.unorderedSets !== false);
        },
        _set: function (set4) {
          write("set:");
          var arr = Array.from(set4);
          return this._array(arr, options.unorderedSets !== false);
        },
        _file: function (file) {
          write("file:");
          return this.dispatch([file.name, file.size, file.type, file.lastModfied]);
        },
        _blob: function () {
          if (options.ignoreUnknown) {
            return write("[blob]");
          }
          throw Error('Hashing Blob objects is currently not supported\n(see https://github.com/puleos/object-hash/issues/26)\nUse "options.replacer" or "options.ignoreUnknown"\n');
        },
        _domwindow: function () {
          return write("domwindow");
        },
        _bigint: function (number3) {
          return write("bigint:" + number3.toString());
        },
        /* Node.js standard native objects */
        _process: function () {
          return write("process");
        },
        _timer: function () {
          return write("timer");
        },
        _pipe: function () {
          return write("pipe");
        },
        _tcp: function () {
          return write("tcp");
        },
        _udp: function () {
          return write("udp");
        },
        _tty: function () {
          return write("tty");
        },
        _statwatcher: function () {
          return write("statwatcher");
        },
        _securecontext: function () {
          return write("securecontext");
        },
        _connection: function () {
          return write("connection");
        },
        _zlib: function () {
          return write("zlib");
        },
        _context: function () {
          return write("context");
        },
        _nodescript: function () {
          return write("nodescript");
        },
        _httpparser: function () {
          return write("httpparser");
        },
        _dataview: function () {
          return write("dataview");
        },
        _signal: function () {
          return write("signal");
        },
        _fsevent: function () {
          return write("fsevent");
        },
        _tlswrap: function () {
          return write("tlswrap");
        }
      };
    }
    function PassThrough2() {
      return {
        buf: "",
        write: function (b) {
          this.buf += b;
        },
        end: function (b) {
          this.buf += b;
        },
        read: function () {
          return this.buf;
        }
      };
    }
  }
});

// src/index.ts
var src_exports = {};
__export(src_exports, {
  generateDynamicIR: () => generateDynamicIR
});
module.exports = __toCommonJS(src_exports);

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_freeGlobal.js
var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
var freeGlobal_default = freeGlobal;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_root.js
var freeSelf = typeof self == "object" && self && self.Object === Object && self;
var root = freeGlobal_default || freeSelf || Function("return this")();
var root_default = root;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Symbol.js
var Symbol2 = root_default.Symbol;
var Symbol_default = Symbol2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getRawTag.js
var objectProto = Object.prototype;
var hasOwnProperty = objectProto.hasOwnProperty;
var nativeObjectToString = objectProto.toString;
var symToStringTag = Symbol_default ? Symbol_default.toStringTag : void 0;
function getRawTag(value) {
  var isOwn = hasOwnProperty.call(value, symToStringTag), tag = value[symToStringTag];
  try {
    value[symToStringTag] = void 0;
    var unmasked = true;
  } catch (e) {
  }
  var result = nativeObjectToString.call(value);
  if (unmasked) {
    if (isOwn) {
      value[symToStringTag] = tag;
    } else {
      delete value[symToStringTag];
    }
  }
  return result;
}
var getRawTag_default = getRawTag;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_objectToString.js
var objectProto2 = Object.prototype;
var nativeObjectToString2 = objectProto2.toString;
function objectToString(value) {
  return nativeObjectToString2.call(value);
}
var objectToString_default = objectToString;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseGetTag.js
var nullTag = "[object Null]";
var undefinedTag = "[object Undefined]";
var symToStringTag2 = Symbol_default ? Symbol_default.toStringTag : void 0;
function baseGetTag(value) {
  if (value == null) {
    return value === void 0 ? undefinedTag : nullTag;
  }
  return symToStringTag2 && symToStringTag2 in Object(value) ? getRawTag_default(value) : objectToString_default(value);
}
var baseGetTag_default = baseGetTag;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isObjectLike.js
function isObjectLike(value) {
  return value != null && typeof value == "object";
}
var isObjectLike_default = isObjectLike;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isSymbol.js
var symbolTag = "[object Symbol]";
function isSymbol(value) {
  return typeof value == "symbol" || isObjectLike_default(value) && baseGetTag_default(value) == symbolTag;
}
var isSymbol_default = isSymbol;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayMap.js
function arrayMap(array, iteratee) {
  var index = -1, length = array == null ? 0 : array.length, result = Array(length);
  while (++index < length) {
    result[index] = iteratee(array[index], index, array);
  }
  return result;
}
var arrayMap_default = arrayMap;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArray.js
var isArray = Array.isArray;
var isArray_default = isArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseToString.js
var INFINITY = 1 / 0;
var symbolProto = Symbol_default ? Symbol_default.prototype : void 0;
var symbolToString = symbolProto ? symbolProto.toString : void 0;
function baseToString(value) {
  if (typeof value == "string") {
    return value;
  }
  if (isArray_default(value)) {
    return arrayMap_default(value, baseToString) + "";
  }
  if (isSymbol_default(value)) {
    return symbolToString ? symbolToString.call(value) : "";
  }
  var result = value + "";
  return result == "0" && 1 / value == -INFINITY ? "-0" : result;
}
var baseToString_default = baseToString;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isObject.js
function isObject(value) {
  var type2 = typeof value;
  return value != null && (type2 == "object" || type2 == "function");
}
var isObject_default = isObject;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/identity.js
function identity(value) {
  return value;
}
var identity_default = identity;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isFunction.js
var asyncTag = "[object AsyncFunction]";
var funcTag = "[object Function]";
var genTag = "[object GeneratorFunction]";
var proxyTag = "[object Proxy]";
function isFunction(value) {
  if (!isObject_default(value)) {
    return false;
  }
  var tag = baseGetTag_default(value);
  return tag == funcTag || tag == genTag || tag == asyncTag || tag == proxyTag;
}
var isFunction_default = isFunction;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_coreJsData.js
var coreJsData = root_default["__core-js_shared__"];
var coreJsData_default = coreJsData;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isMasked.js
var maskSrcKey = function () {
  var uid = /[^.]+$/.exec(coreJsData_default && coreJsData_default.keys && coreJsData_default.keys.IE_PROTO || "");
  return uid ? "Symbol(src)_1." + uid : "";
}();
function isMasked(func) {
  return !!maskSrcKey && maskSrcKey in func;
}
var isMasked_default = isMasked;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_toSource.js
var funcProto = Function.prototype;
var funcToString = funcProto.toString;
function toSource(func) {
  if (func != null) {
    try {
      return funcToString.call(func);
    } catch (e) {
    }
    try {
      return func + "";
    } catch (e) {
    }
  }
  return "";
}
var toSource_default = toSource;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsNative.js
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
var reIsHostCtor = /^\[object .+?Constructor\]$/;
var funcProto2 = Function.prototype;
var objectProto3 = Object.prototype;
var funcToString2 = funcProto2.toString;
var hasOwnProperty2 = objectProto3.hasOwnProperty;
var reIsNative = RegExp(
  "^" + funcToString2.call(hasOwnProperty2).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
);
function baseIsNative(value) {
  if (!isObject_default(value) || isMasked_default(value)) {
    return false;
  }
  var pattern = isFunction_default(value) ? reIsNative : reIsHostCtor;
  return pattern.test(toSource_default(value));
}
var baseIsNative_default = baseIsNative;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getValue.js
function getValue(object3, key) {
  return object3 == null ? void 0 : object3[key];
}
var getValue_default = getValue;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getNative.js
function getNative(object3, key) {
  var value = getValue_default(object3, key);
  return baseIsNative_default(value) ? value : void 0;
}
var getNative_default = getNative;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_WeakMap.js
var WeakMap2 = getNative_default(root_default, "WeakMap");
var WeakMap_default = WeakMap2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseCreate.js
var objectCreate = Object.create;
var baseCreate = /* @__PURE__ */ function () {
  function object3() {
  }
  return function (proto) {
    if (!isObject_default(proto)) {
      return {};
    }
    if (objectCreate) {
      return objectCreate(proto);
    }
    object3.prototype = proto;
    var result = new object3();
    object3.prototype = void 0;
    return result;
  };
}();
var baseCreate_default = baseCreate;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_apply.js
function apply(func, thisArg, args) {
  switch (args.length) {
    case 0:
      return func.call(thisArg);
    case 1:
      return func.call(thisArg, args[0]);
    case 2:
      return func.call(thisArg, args[0], args[1]);
    case 3:
      return func.call(thisArg, args[0], args[1], args[2]);
  }
  return func.apply(thisArg, args);
}
var apply_default = apply;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_copyArray.js
function copyArray(source, array) {
  var index = -1, length = source.length;
  array || (array = Array(length));
  while (++index < length) {
    array[index] = source[index];
  }
  return array;
}
var copyArray_default = copyArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_shortOut.js
var HOT_COUNT = 800;
var HOT_SPAN = 16;
var nativeNow = Date.now;
function shortOut(func) {
  var count = 0, lastCalled = 0;
  return function () {
    var stamp = nativeNow(), remaining = HOT_SPAN - (stamp - lastCalled);
    lastCalled = stamp;
    if (remaining > 0) {
      if (++count >= HOT_COUNT) {
        return arguments[0];
      }
    } else {
      count = 0;
    }
    return func.apply(void 0, arguments);
  };
}
var shortOut_default = shortOut;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/constant.js
function constant(value) {
  return function () {
    return value;
  };
}
var constant_default = constant;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_defineProperty.js
var defineProperty = function () {
  try {
    var func = getNative_default(Object, "defineProperty");
    func({}, "", {});
    return func;
  } catch (e) {
  }
}();
var defineProperty_default = defineProperty;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseSetToString.js
var baseSetToString = !defineProperty_default ? identity_default : function (func, string3) {
  return defineProperty_default(func, "toString", {
    "configurable": true,
    "enumerable": false,
    "value": constant_default(string3),
    "writable": true
  });
};
var baseSetToString_default = baseSetToString;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_setToString.js
var setToString = shortOut_default(baseSetToString_default);
var setToString_default = setToString;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseFindIndex.js
function baseFindIndex(array, predicate, fromIndex, fromRight) {
  var length = array.length, index = fromIndex + (fromRight ? 1 : -1);
  while (fromRight ? index-- : ++index < length) {
    if (predicate(array[index], index, array)) {
      return index;
    }
  }
  return -1;
}
var baseFindIndex_default = baseFindIndex;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsNaN.js
function baseIsNaN(value) {
  return value !== value;
}
var baseIsNaN_default = baseIsNaN;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_strictIndexOf.js
function strictIndexOf(array, value, fromIndex) {
  var index = fromIndex - 1, length = array.length;
  while (++index < length) {
    if (array[index] === value) {
      return index;
    }
  }
  return -1;
}
var strictIndexOf_default = strictIndexOf;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIndexOf.js
function baseIndexOf(array, value, fromIndex) {
  return value === value ? strictIndexOf_default(array, value, fromIndex) : baseFindIndex_default(array, baseIsNaN_default, fromIndex);
}
var baseIndexOf_default = baseIndexOf;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayIncludes.js
function arrayIncludes(array, value) {
  var length = array == null ? 0 : array.length;
  return !!length && baseIndexOf_default(array, value, 0) > -1;
}
var arrayIncludes_default = arrayIncludes;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isIndex.js
var MAX_SAFE_INTEGER = 9007199254740991;
var reIsUint = /^(?:0|[1-9]\d*)$/;
function isIndex(value, length) {
  var type2 = typeof value;
  length = length == null ? MAX_SAFE_INTEGER : length;
  return !!length && (type2 == "number" || type2 != "symbol" && reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
}
var isIndex_default = isIndex;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseAssignValue.js
function baseAssignValue(object3, key, value) {
  if (key == "__proto__" && defineProperty_default) {
    defineProperty_default(object3, key, {
      "configurable": true,
      "enumerable": true,
      "value": value,
      "writable": true
    });
  } else {
    object3[key] = value;
  }
}
var baseAssignValue_default = baseAssignValue;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/eq.js
function eq(value, other) {
  return value === other || value !== value && other !== other;
}
var eq_default = eq;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_assignValue.js
var objectProto4 = Object.prototype;
var hasOwnProperty3 = objectProto4.hasOwnProperty;
function assignValue(object3, key, value) {
  var objValue = object3[key];
  if (!(hasOwnProperty3.call(object3, key) && eq_default(objValue, value)) || value === void 0 && !(key in object3)) {
    baseAssignValue_default(object3, key, value);
  }
}
var assignValue_default = assignValue;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_copyObject.js
function copyObject(source, props, object3, customizer) {
  var isNew = !object3;
  object3 || (object3 = {});
  var index = -1, length = props.length;
  while (++index < length) {
    var key = props[index];
    var newValue = customizer ? customizer(object3[key], source[key], key, object3, source) : void 0;
    if (newValue === void 0) {
      newValue = source[key];
    }
    if (isNew) {
      baseAssignValue_default(object3, key, newValue);
    } else {
      assignValue_default(object3, key, newValue);
    }
  }
  return object3;
}
var copyObject_default = copyObject;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_overRest.js
var nativeMax = Math.max;
function overRest(func, start, transform3) {
  start = nativeMax(start === void 0 ? func.length - 1 : start, 0);
  return function () {
    var args = arguments, index = -1, length = nativeMax(args.length - start, 0), array = Array(length);
    while (++index < length) {
      array[index] = args[start + index];
    }
    index = -1;
    var otherArgs = Array(start + 1);
    while (++index < start) {
      otherArgs[index] = args[index];
    }
    otherArgs[start] = transform3(array);
    return apply_default(func, this, otherArgs);
  };
}
var overRest_default = overRest;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseRest.js
function baseRest(func, start) {
  return setToString_default(overRest_default(func, start, identity_default), func + "");
}
var baseRest_default = baseRest;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isLength.js
var MAX_SAFE_INTEGER2 = 9007199254740991;
function isLength(value) {
  return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER2;
}
var isLength_default = isLength;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArrayLike.js
function isArrayLike(value) {
  return value != null && isLength_default(value.length) && !isFunction_default(value);
}
var isArrayLike_default = isArrayLike;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isIterateeCall.js
function isIterateeCall(value, index, object3) {
  if (!isObject_default(object3)) {
    return false;
  }
  var type2 = typeof index;
  if (type2 == "number" ? isArrayLike_default(object3) && isIndex_default(index, object3.length) : type2 == "string" && index in object3) {
    return eq_default(object3[index], value);
  }
  return false;
}
var isIterateeCall_default = isIterateeCall;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createAssigner.js
function createAssigner(assigner) {
  return baseRest_default(function (object3, sources) {
    var index = -1, length = sources.length, customizer = length > 1 ? sources[length - 1] : void 0, guard = length > 2 ? sources[2] : void 0;
    customizer = assigner.length > 3 && typeof customizer == "function" ? (length--, customizer) : void 0;
    if (guard && isIterateeCall_default(sources[0], sources[1], guard)) {
      customizer = length < 3 ? void 0 : customizer;
      length = 1;
    }
    object3 = Object(object3);
    while (++index < length) {
      var source = sources[index];
      if (source) {
        assigner(object3, source, index, customizer);
      }
    }
    return object3;
  });
}
var createAssigner_default = createAssigner;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isPrototype.js
var objectProto5 = Object.prototype;
function isPrototype(value) {
  var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto5;
  return value === proto;
}
var isPrototype_default = isPrototype;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseTimes.js
function baseTimes(n, iteratee) {
  var index = -1, result = Array(n);
  while (++index < n) {
    result[index] = iteratee(index);
  }
  return result;
}
var baseTimes_default = baseTimes;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsArguments.js
var argsTag = "[object Arguments]";
function baseIsArguments(value) {
  return isObjectLike_default(value) && baseGetTag_default(value) == argsTag;
}
var baseIsArguments_default = baseIsArguments;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArguments.js
var objectProto6 = Object.prototype;
var hasOwnProperty4 = objectProto6.hasOwnProperty;
var propertyIsEnumerable = objectProto6.propertyIsEnumerable;
var isArguments = baseIsArguments_default(/* @__PURE__ */ function () {
  return arguments;
}()) ? baseIsArguments_default : function (value) {
  return isObjectLike_default(value) && hasOwnProperty4.call(value, "callee") && !propertyIsEnumerable.call(value, "callee");
};
var isArguments_default = isArguments;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/stubFalse.js
function stubFalse() {
  return false;
}
var stubFalse_default = stubFalse;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isBuffer.js
var freeExports = typeof exports == "object" && exports && !exports.nodeType && exports;
var freeModule = freeExports && typeof module == "object" && module && !module.nodeType && module;
var moduleExports = freeModule && freeModule.exports === freeExports;
var Buffer2 = moduleExports ? root_default.Buffer : void 0;
var nativeIsBuffer = Buffer2 ? Buffer2.isBuffer : void 0;
var isBuffer = nativeIsBuffer || stubFalse_default;
var isBuffer_default = isBuffer;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsTypedArray.js
var argsTag2 = "[object Arguments]";
var arrayTag = "[object Array]";
var boolTag = "[object Boolean]";
var dateTag = "[object Date]";
var errorTag = "[object Error]";
var funcTag2 = "[object Function]";
var mapTag = "[object Map]";
var numberTag = "[object Number]";
var objectTag = "[object Object]";
var regexpTag = "[object RegExp]";
var setTag = "[object Set]";
var stringTag = "[object String]";
var weakMapTag = "[object WeakMap]";
var arrayBufferTag = "[object ArrayBuffer]";
var dataViewTag = "[object DataView]";
var float32Tag = "[object Float32Array]";
var float64Tag = "[object Float64Array]";
var int8Tag = "[object Int8Array]";
var int16Tag = "[object Int16Array]";
var int32Tag = "[object Int32Array]";
var uint8Tag = "[object Uint8Array]";
var uint8ClampedTag = "[object Uint8ClampedArray]";
var uint16Tag = "[object Uint16Array]";
var uint32Tag = "[object Uint32Array]";
var typedArrayTags = {};
typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
typedArrayTags[argsTag2] = typedArrayTags[arrayTag] = typedArrayTags[arrayBufferTag] = typedArrayTags[boolTag] = typedArrayTags[dataViewTag] = typedArrayTags[dateTag] = typedArrayTags[errorTag] = typedArrayTags[funcTag2] = typedArrayTags[mapTag] = typedArrayTags[numberTag] = typedArrayTags[objectTag] = typedArrayTags[regexpTag] = typedArrayTags[setTag] = typedArrayTags[stringTag] = typedArrayTags[weakMapTag] = false;
function baseIsTypedArray(value) {
  return isObjectLike_default(value) && isLength_default(value.length) && !!typedArrayTags[baseGetTag_default(value)];
}
var baseIsTypedArray_default = baseIsTypedArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseUnary.js
function baseUnary(func) {
  return function (value) {
    return func(value);
  };
}
var baseUnary_default = baseUnary;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_nodeUtil.js
var freeExports2 = typeof exports == "object" && exports && !exports.nodeType && exports;
var freeModule2 = freeExports2 && typeof module == "object" && module && !module.nodeType && module;
var moduleExports2 = freeModule2 && freeModule2.exports === freeExports2;
var freeProcess = moduleExports2 && freeGlobal_default.process;
var nodeUtil = function () {
  try {
    var types2 = freeModule2 && freeModule2.require && freeModule2.require("util").types;
    if (types2) {
      return types2;
    }
    return freeProcess && freeProcess.binding && freeProcess.binding("util");
  } catch (e) {
  }
}();
var nodeUtil_default = nodeUtil;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isTypedArray.js
var nodeIsTypedArray = nodeUtil_default && nodeUtil_default.isTypedArray;
var isTypedArray = nodeIsTypedArray ? baseUnary_default(nodeIsTypedArray) : baseIsTypedArray_default;
var isTypedArray_default = isTypedArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayLikeKeys.js
var objectProto7 = Object.prototype;
var hasOwnProperty5 = objectProto7.hasOwnProperty;
function arrayLikeKeys(value, inherited) {
  var isArr = isArray_default(value), isArg = !isArr && isArguments_default(value), isBuff = !isArr && !isArg && isBuffer_default(value), isType = !isArr && !isArg && !isBuff && isTypedArray_default(value), skipIndexes = isArr || isArg || isBuff || isType, result = skipIndexes ? baseTimes_default(value.length, String) : [], length = result.length;
  for (var key in value) {
    if ((inherited || hasOwnProperty5.call(value, key)) && !(skipIndexes && // Safari 9 has enumerable `arguments.length` in strict mode.
      (key == "length" || // Node.js 0.10 has enumerable non-index properties on buffers.
        isBuff && (key == "offset" || key == "parent") || // PhantomJS 2 has enumerable non-index properties on typed arrays.
        isType && (key == "buffer" || key == "byteLength" || key == "byteOffset") || // Skip index properties.
        isIndex_default(key, length)))) {
      result.push(key);
    }
  }
  return result;
}
var arrayLikeKeys_default = arrayLikeKeys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_overArg.js
function overArg(func, transform3) {
  return function (arg) {
    return func(transform3(arg));
  };
}
var overArg_default = overArg;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_nativeKeys.js
var nativeKeys = overArg_default(Object.keys, Object);
var nativeKeys_default = nativeKeys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseKeys.js
var objectProto8 = Object.prototype;
var hasOwnProperty6 = objectProto8.hasOwnProperty;
function baseKeys(object3) {
  if (!isPrototype_default(object3)) {
    return nativeKeys_default(object3);
  }
  var result = [];
  for (var key in Object(object3)) {
    if (hasOwnProperty6.call(object3, key) && key != "constructor") {
      result.push(key);
    }
  }
  return result;
}
var baseKeys_default = baseKeys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/keys.js
function keys(object3) {
  return isArrayLike_default(object3) ? arrayLikeKeys_default(object3) : baseKeys_default(object3);
}
var keys_default = keys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_nativeKeysIn.js
function nativeKeysIn(object3) {
  var result = [];
  if (object3 != null) {
    for (var key in Object(object3)) {
      result.push(key);
    }
  }
  return result;
}
var nativeKeysIn_default = nativeKeysIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseKeysIn.js
var objectProto9 = Object.prototype;
var hasOwnProperty7 = objectProto9.hasOwnProperty;
function baseKeysIn(object3) {
  if (!isObject_default(object3)) {
    return nativeKeysIn_default(object3);
  }
  var isProto = isPrototype_default(object3), result = [];
  for (var key in object3) {
    if (!(key == "constructor" && (isProto || !hasOwnProperty7.call(object3, key)))) {
      result.push(key);
    }
  }
  return result;
}
var baseKeysIn_default = baseKeysIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/keysIn.js
function keysIn(object3) {
  return isArrayLike_default(object3) ? arrayLikeKeys_default(object3, true) : baseKeysIn_default(object3);
}
var keysIn_default = keysIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isKey.js
var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/;
var reIsPlainProp = /^\w*$/;
function isKey(value, object3) {
  if (isArray_default(value)) {
    return false;
  }
  var type2 = typeof value;
  if (type2 == "number" || type2 == "symbol" || type2 == "boolean" || value == null || isSymbol_default(value)) {
    return true;
  }
  return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object3 != null && value in Object(object3);
}
var isKey_default = isKey;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_nativeCreate.js
var nativeCreate = getNative_default(Object, "create");
var nativeCreate_default = nativeCreate;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hashClear.js
function hashClear() {
  this.__data__ = nativeCreate_default ? nativeCreate_default(null) : {};
  this.size = 0;
}
var hashClear_default = hashClear;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hashDelete.js
function hashDelete(key) {
  var result = this.has(key) && delete this.__data__[key];
  this.size -= result ? 1 : 0;
  return result;
}
var hashDelete_default = hashDelete;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hashGet.js
var HASH_UNDEFINED = "__lodash_hash_undefined__";
var objectProto10 = Object.prototype;
var hasOwnProperty8 = objectProto10.hasOwnProperty;
function hashGet(key) {
  var data = this.__data__;
  if (nativeCreate_default) {
    var result = data[key];
    return result === HASH_UNDEFINED ? void 0 : result;
  }
  return hasOwnProperty8.call(data, key) ? data[key] : void 0;
}
var hashGet_default = hashGet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hashHas.js
var objectProto11 = Object.prototype;
var hasOwnProperty9 = objectProto11.hasOwnProperty;
function hashHas(key) {
  var data = this.__data__;
  return nativeCreate_default ? data[key] !== void 0 : hasOwnProperty9.call(data, key);
}
var hashHas_default = hashHas;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hashSet.js
var HASH_UNDEFINED2 = "__lodash_hash_undefined__";
function hashSet(key, value) {
  var data = this.__data__;
  this.size += this.has(key) ? 0 : 1;
  data[key] = nativeCreate_default && value === void 0 ? HASH_UNDEFINED2 : value;
  return this;
}
var hashSet_default = hashSet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Hash.js
function Hash(entries4) {
  var index = -1, length = entries4 == null ? 0 : entries4.length;
  this.clear();
  while (++index < length) {
    var entry = entries4[index];
    this.set(entry[0], entry[1]);
  }
}
Hash.prototype.clear = hashClear_default;
Hash.prototype["delete"] = hashDelete_default;
Hash.prototype.get = hashGet_default;
Hash.prototype.has = hashHas_default;
Hash.prototype.set = hashSet_default;
var Hash_default = Hash;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_listCacheClear.js
function listCacheClear() {
  this.__data__ = [];
  this.size = 0;
}
var listCacheClear_default = listCacheClear;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_assocIndexOf.js
function assocIndexOf(array, key) {
  var length = array.length;
  while (length--) {
    if (eq_default(array[length][0], key)) {
      return length;
    }
  }
  return -1;
}
var assocIndexOf_default = assocIndexOf;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_listCacheDelete.js
var arrayProto = Array.prototype;
var splice = arrayProto.splice;
function listCacheDelete(key) {
  var data = this.__data__, index = assocIndexOf_default(data, key);
  if (index < 0) {
    return false;
  }
  var lastIndex = data.length - 1;
  if (index == lastIndex) {
    data.pop();
  } else {
    splice.call(data, index, 1);
  }
  --this.size;
  return true;
}
var listCacheDelete_default = listCacheDelete;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_listCacheGet.js
function listCacheGet(key) {
  var data = this.__data__, index = assocIndexOf_default(data, key);
  return index < 0 ? void 0 : data[index][1];
}
var listCacheGet_default = listCacheGet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_listCacheHas.js
function listCacheHas(key) {
  return assocIndexOf_default(this.__data__, key) > -1;
}
var listCacheHas_default = listCacheHas;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_listCacheSet.js
function listCacheSet(key, value) {
  var data = this.__data__, index = assocIndexOf_default(data, key);
  if (index < 0) {
    ++this.size;
    data.push([key, value]);
  } else {
    data[index][1] = value;
  }
  return this;
}
var listCacheSet_default = listCacheSet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_ListCache.js
function ListCache(entries4) {
  var index = -1, length = entries4 == null ? 0 : entries4.length;
  this.clear();
  while (++index < length) {
    var entry = entries4[index];
    this.set(entry[0], entry[1]);
  }
}
ListCache.prototype.clear = listCacheClear_default;
ListCache.prototype["delete"] = listCacheDelete_default;
ListCache.prototype.get = listCacheGet_default;
ListCache.prototype.has = listCacheHas_default;
ListCache.prototype.set = listCacheSet_default;
var ListCache_default = ListCache;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Map.js
var Map2 = getNative_default(root_default, "Map");
var Map_default = Map2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_mapCacheClear.js
function mapCacheClear() {
  this.size = 0;
  this.__data__ = {
    "hash": new Hash_default(),
    "map": new (Map_default || ListCache_default)(),
    "string": new Hash_default()
  };
}
var mapCacheClear_default = mapCacheClear;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isKeyable.js
function isKeyable(value) {
  var type2 = typeof value;
  return type2 == "string" || type2 == "number" || type2 == "symbol" || type2 == "boolean" ? value !== "__proto__" : value === null;
}
var isKeyable_default = isKeyable;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getMapData.js
function getMapData(map2, key) {
  var data = map2.__data__;
  return isKeyable_default(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
}
var getMapData_default = getMapData;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_mapCacheDelete.js
function mapCacheDelete(key) {
  var result = getMapData_default(this, key)["delete"](key);
  this.size -= result ? 1 : 0;
  return result;
}
var mapCacheDelete_default = mapCacheDelete;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_mapCacheGet.js
function mapCacheGet(key) {
  return getMapData_default(this, key).get(key);
}
var mapCacheGet_default = mapCacheGet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_mapCacheHas.js
function mapCacheHas(key) {
  return getMapData_default(this, key).has(key);
}
var mapCacheHas_default = mapCacheHas;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_mapCacheSet.js
function mapCacheSet(key, value) {
  var data = getMapData_default(this, key), size2 = data.size;
  data.set(key, value);
  this.size += data.size == size2 ? 0 : 1;
  return this;
}
var mapCacheSet_default = mapCacheSet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_MapCache.js
function MapCache(entries4) {
  var index = -1, length = entries4 == null ? 0 : entries4.length;
  this.clear();
  while (++index < length) {
    var entry = entries4[index];
    this.set(entry[0], entry[1]);
  }
}
MapCache.prototype.clear = mapCacheClear_default;
MapCache.prototype["delete"] = mapCacheDelete_default;
MapCache.prototype.get = mapCacheGet_default;
MapCache.prototype.has = mapCacheHas_default;
MapCache.prototype.set = mapCacheSet_default;
var MapCache_default = MapCache;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/memoize.js
var FUNC_ERROR_TEXT = "Expected a function";
function memoize(func, resolver) {
  if (typeof func != "function" || resolver != null && typeof resolver != "function") {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  var memoized = function () {
    var args = arguments, key = resolver ? resolver.apply(this, args) : args[0], cache = memoized.cache;
    if (cache.has(key)) {
      return cache.get(key);
    }
    var result = func.apply(this, args);
    memoized.cache = cache.set(key, result) || cache;
    return result;
  };
  memoized.cache = new (memoize.Cache || MapCache_default)();
  return memoized;
}
memoize.Cache = MapCache_default;
var memoize_default = memoize;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_memoizeCapped.js
var MAX_MEMOIZE_SIZE = 500;
function memoizeCapped(func) {
  var result = memoize_default(func, function (key) {
    if (cache.size === MAX_MEMOIZE_SIZE) {
      cache.clear();
    }
    return key;
  });
  var cache = result.cache;
  return result;
}
var memoizeCapped_default = memoizeCapped;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stringToPath.js
var rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
var reEscapeChar = /\\(\\)?/g;
var stringToPath = memoizeCapped_default(function (string3) {
  var result = [];
  if (string3.charCodeAt(0) === 46) {
    result.push("");
  }
  string3.replace(rePropName, function (match, number3, quote, subString) {
    result.push(quote ? subString.replace(reEscapeChar, "$1") : number3 || match);
  });
  return result;
});
var stringToPath_default = stringToPath;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/toString.js
function toString2(value) {
  return value == null ? "" : baseToString_default(value);
}
var toString_default = toString2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_castPath.js
function castPath(value, object3) {
  if (isArray_default(value)) {
    return value;
  }
  return isKey_default(value, object3) ? [value] : stringToPath_default(toString_default(value));
}
var castPath_default = castPath;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_toKey.js
var INFINITY2 = 1 / 0;
function toKey(value) {
  if (typeof value == "string" || isSymbol_default(value)) {
    return value;
  }
  var result = value + "";
  return result == "0" && 1 / value == -INFINITY2 ? "-0" : result;
}
var toKey_default = toKey;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseGet.js
function baseGet(object3, path5) {
  path5 = castPath_default(path5, object3);
  var index = 0, length = path5.length;
  while (object3 != null && index < length) {
    object3 = object3[toKey_default(path5[index++])];
  }
  return index && index == length ? object3 : void 0;
}
var baseGet_default = baseGet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/get.js
function get(object3, path5, defaultValue) {
  var result = object3 == null ? void 0 : baseGet_default(object3, path5);
  return result === void 0 ? defaultValue : result;
}
var get_default = get;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayPush.js
function arrayPush(array, values) {
  var index = -1, length = values.length, offset = array.length;
  while (++index < length) {
    array[offset + index] = values[index];
  }
  return array;
}
var arrayPush_default = arrayPush;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isFlattenable.js
var spreadableSymbol = Symbol_default ? Symbol_default.isConcatSpreadable : void 0;
function isFlattenable(value) {
  return isArray_default(value) || isArguments_default(value) || !!(spreadableSymbol && value && value[spreadableSymbol]);
}
var isFlattenable_default = isFlattenable;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseFlatten.js
function baseFlatten(array, depth, predicate, isStrict, result) {
  var index = -1, length = array.length;
  predicate || (predicate = isFlattenable_default);
  result || (result = []);
  while (++index < length) {
    var value = array[index];
    if (depth > 0 && predicate(value)) {
      if (depth > 1) {
        baseFlatten(value, depth - 1, predicate, isStrict, result);
      } else {
        arrayPush_default(result, value);
      }
    } else if (!isStrict) {
      result[result.length] = value;
    }
  }
  return result;
}
var baseFlatten_default = baseFlatten;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getPrototype.js
var getPrototype = overArg_default(Object.getPrototypeOf, Object);
var getPrototype_default = getPrototype;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isPlainObject.js
var objectTag2 = "[object Object]";
var funcProto3 = Function.prototype;
var objectProto12 = Object.prototype;
var funcToString3 = funcProto3.toString;
var hasOwnProperty10 = objectProto12.hasOwnProperty;
var objectCtorString = funcToString3.call(Object);
function isPlainObject(value) {
  if (!isObjectLike_default(value) || baseGetTag_default(value) != objectTag2) {
    return false;
  }
  var proto = getPrototype_default(value);
  if (proto === null) {
    return true;
  }
  var Ctor = hasOwnProperty10.call(proto, "constructor") && proto.constructor;
  return typeof Ctor == "function" && Ctor instanceof Ctor && funcToString3.call(Ctor) == objectCtorString;
}
var isPlainObject_default = isPlainObject;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseSlice.js
function baseSlice(array, start, end) {
  var index = -1, length = array.length;
  if (start < 0) {
    start = -start > length ? 0 : length + start;
  }
  end = end > length ? length : end;
  if (end < 0) {
    end += length;
  }
  length = start > end ? 0 : end - start >>> 0;
  start >>>= 0;
  var result = Array(length);
  while (++index < length) {
    result[index] = array[index + start];
  }
  return result;
}
var baseSlice_default = baseSlice;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_castSlice.js
function castSlice(array, start, end) {
  var length = array.length;
  end = end === void 0 ? length : end;
  return !start && end >= length ? array : baseSlice_default(array, start, end);
}
var castSlice_default = castSlice;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hasUnicode.js
var rsAstralRange = "\\ud800-\\udfff";
var rsComboMarksRange = "\\u0300-\\u036f";
var reComboHalfMarksRange = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange = "\\u20d0-\\u20ff";
var rsComboRange = rsComboMarksRange + reComboHalfMarksRange + rsComboSymbolsRange;
var rsVarRange = "\\ufe0e\\ufe0f";
var rsZWJ = "\\u200d";
var reHasUnicode = RegExp("[" + rsZWJ + rsAstralRange + rsComboRange + rsVarRange + "]");
function hasUnicode(string3) {
  return reHasUnicode.test(string3);
}
var hasUnicode_default = hasUnicode;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_asciiToArray.js
function asciiToArray(string3) {
  return string3.split("");
}
var asciiToArray_default = asciiToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_unicodeToArray.js
var rsAstralRange2 = "\\ud800-\\udfff";
var rsComboMarksRange2 = "\\u0300-\\u036f";
var reComboHalfMarksRange2 = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange2 = "\\u20d0-\\u20ff";
var rsComboRange2 = rsComboMarksRange2 + reComboHalfMarksRange2 + rsComboSymbolsRange2;
var rsVarRange2 = "\\ufe0e\\ufe0f";
var rsAstral = "[" + rsAstralRange2 + "]";
var rsCombo = "[" + rsComboRange2 + "]";
var rsFitz = "\\ud83c[\\udffb-\\udfff]";
var rsModifier = "(?:" + rsCombo + "|" + rsFitz + ")";
var rsNonAstral = "[^" + rsAstralRange2 + "]";
var rsRegional = "(?:\\ud83c[\\udde6-\\uddff]){2}";
var rsSurrPair = "[\\ud800-\\udbff][\\udc00-\\udfff]";
var rsZWJ2 = "\\u200d";
var reOptMod = rsModifier + "?";
var rsOptVar = "[" + rsVarRange2 + "]?";
var rsOptJoin = "(?:" + rsZWJ2 + "(?:" + [rsNonAstral, rsRegional, rsSurrPair].join("|") + ")" + rsOptVar + reOptMod + ")*";
var rsSeq = rsOptVar + reOptMod + rsOptJoin;
var rsSymbol = "(?:" + [rsNonAstral + rsCombo + "?", rsCombo, rsRegional, rsSurrPair, rsAstral].join("|") + ")";
var reUnicode = RegExp(rsFitz + "(?=" + rsFitz + ")|" + rsSymbol + rsSeq, "g");
function unicodeToArray(string3) {
  return string3.match(reUnicode) || [];
}
var unicodeToArray_default = unicodeToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stringToArray.js
function stringToArray(string3) {
  return hasUnicode_default(string3) ? unicodeToArray_default(string3) : asciiToArray_default(string3);
}
var stringToArray_default = stringToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createCaseFirst.js
function createCaseFirst(methodName) {
  return function (string3) {
    string3 = toString_default(string3);
    var strSymbols = hasUnicode_default(string3) ? stringToArray_default(string3) : void 0;
    var chr = strSymbols ? strSymbols[0] : string3.charAt(0);
    var trailing = strSymbols ? castSlice_default(strSymbols, 1).join("") : string3.slice(1);
    return chr[methodName]() + trailing;
  };
}
var createCaseFirst_default = createCaseFirst;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/upperFirst.js
var upperFirst = createCaseFirst_default("toUpperCase");
var upperFirst_default = upperFirst;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/capitalize.js
function capitalize(string3) {
  return upperFirst_default(toString_default(string3).toLowerCase());
}
var capitalize_default = capitalize;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayReduce.js
function arrayReduce(array, iteratee, accumulator, initAccum) {
  var index = -1, length = array == null ? 0 : array.length;
  if (initAccum && length) {
    accumulator = array[++index];
  }
  while (++index < length) {
    accumulator = iteratee(accumulator, array[index], index, array);
  }
  return accumulator;
}
var arrayReduce_default = arrayReduce;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_basePropertyOf.js
function basePropertyOf(object3) {
  return function (key) {
    return object3 == null ? void 0 : object3[key];
  };
}
var basePropertyOf_default = basePropertyOf;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_deburrLetter.js
var deburredLetters = {
  // Latin-1 Supplement block.
  "\xC0": "A",
  "\xC1": "A",
  "\xC2": "A",
  "\xC3": "A",
  "\xC4": "A",
  "\xC5": "A",
  "\xE0": "a",
  "\xE1": "a",
  "\xE2": "a",
  "\xE3": "a",
  "\xE4": "a",
  "\xE5": "a",
  "\xC7": "C",
  "\xE7": "c",
  "\xD0": "D",
  "\xF0": "d",
  "\xC8": "E",
  "\xC9": "E",
  "\xCA": "E",
  "\xCB": "E",
  "\xE8": "e",
  "\xE9": "e",
  "\xEA": "e",
  "\xEB": "e",
  "\xCC": "I",
  "\xCD": "I",
  "\xCE": "I",
  "\xCF": "I",
  "\xEC": "i",
  "\xED": "i",
  "\xEE": "i",
  "\xEF": "i",
  "\xD1": "N",
  "\xF1": "n",
  "\xD2": "O",
  "\xD3": "O",
  "\xD4": "O",
  "\xD5": "O",
  "\xD6": "O",
  "\xD8": "O",
  "\xF2": "o",
  "\xF3": "o",
  "\xF4": "o",
  "\xF5": "o",
  "\xF6": "o",
  "\xF8": "o",
  "\xD9": "U",
  "\xDA": "U",
  "\xDB": "U",
  "\xDC": "U",
  "\xF9": "u",
  "\xFA": "u",
  "\xFB": "u",
  "\xFC": "u",
  "\xDD": "Y",
  "\xFD": "y",
  "\xFF": "y",
  "\xC6": "Ae",
  "\xE6": "ae",
  "\xDE": "Th",
  "\xFE": "th",
  "\xDF": "ss",
  // Latin Extended-A block.
  "\u0100": "A",
  "\u0102": "A",
  "\u0104": "A",
  "\u0101": "a",
  "\u0103": "a",
  "\u0105": "a",
  "\u0106": "C",
  "\u0108": "C",
  "\u010A": "C",
  "\u010C": "C",
  "\u0107": "c",
  "\u0109": "c",
  "\u010B": "c",
  "\u010D": "c",
  "\u010E": "D",
  "\u0110": "D",
  "\u010F": "d",
  "\u0111": "d",
  "\u0112": "E",
  "\u0114": "E",
  "\u0116": "E",
  "\u0118": "E",
  "\u011A": "E",
  "\u0113": "e",
  "\u0115": "e",
  "\u0117": "e",
  "\u0119": "e",
  "\u011B": "e",
  "\u011C": "G",
  "\u011E": "G",
  "\u0120": "G",
  "\u0122": "G",
  "\u011D": "g",
  "\u011F": "g",
  "\u0121": "g",
  "\u0123": "g",
  "\u0124": "H",
  "\u0126": "H",
  "\u0125": "h",
  "\u0127": "h",
  "\u0128": "I",
  "\u012A": "I",
  "\u012C": "I",
  "\u012E": "I",
  "\u0130": "I",
  "\u0129": "i",
  "\u012B": "i",
  "\u012D": "i",
  "\u012F": "i",
  "\u0131": "i",
  "\u0134": "J",
  "\u0135": "j",
  "\u0136": "K",
  "\u0137": "k",
  "\u0138": "k",
  "\u0139": "L",
  "\u013B": "L",
  "\u013D": "L",
  "\u013F": "L",
  "\u0141": "L",
  "\u013A": "l",
  "\u013C": "l",
  "\u013E": "l",
  "\u0140": "l",
  "\u0142": "l",
  "\u0143": "N",
  "\u0145": "N",
  "\u0147": "N",
  "\u014A": "N",
  "\u0144": "n",
  "\u0146": "n",
  "\u0148": "n",
  "\u014B": "n",
  "\u014C": "O",
  "\u014E": "O",
  "\u0150": "O",
  "\u014D": "o",
  "\u014F": "o",
  "\u0151": "o",
  "\u0154": "R",
  "\u0156": "R",
  "\u0158": "R",
  "\u0155": "r",
  "\u0157": "r",
  "\u0159": "r",
  "\u015A": "S",
  "\u015C": "S",
  "\u015E": "S",
  "\u0160": "S",
  "\u015B": "s",
  "\u015D": "s",
  "\u015F": "s",
  "\u0161": "s",
  "\u0162": "T",
  "\u0164": "T",
  "\u0166": "T",
  "\u0163": "t",
  "\u0165": "t",
  "\u0167": "t",
  "\u0168": "U",
  "\u016A": "U",
  "\u016C": "U",
  "\u016E": "U",
  "\u0170": "U",
  "\u0172": "U",
  "\u0169": "u",
  "\u016B": "u",
  "\u016D": "u",
  "\u016F": "u",
  "\u0171": "u",
  "\u0173": "u",
  "\u0174": "W",
  "\u0175": "w",
  "\u0176": "Y",
  "\u0177": "y",
  "\u0178": "Y",
  "\u0179": "Z",
  "\u017B": "Z",
  "\u017D": "Z",
  "\u017A": "z",
  "\u017C": "z",
  "\u017E": "z",
  "\u0132": "IJ",
  "\u0133": "ij",
  "\u0152": "Oe",
  "\u0153": "oe",
  "\u0149": "'n",
  "\u017F": "s"
};
var deburrLetter = basePropertyOf_default(deburredLetters);
var deburrLetter_default = deburrLetter;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/deburr.js
var reLatin = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g;
var rsComboMarksRange3 = "\\u0300-\\u036f";
var reComboHalfMarksRange3 = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange3 = "\\u20d0-\\u20ff";
var rsComboRange3 = rsComboMarksRange3 + reComboHalfMarksRange3 + rsComboSymbolsRange3;
var rsCombo2 = "[" + rsComboRange3 + "]";
var reComboMark = RegExp(rsCombo2, "g");
function deburr(string3) {
  string3 = toString_default(string3);
  return string3 && string3.replace(reLatin, deburrLetter_default).replace(reComboMark, "");
}
var deburr_default = deburr;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_asciiWords.js
var reAsciiWord = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g;
function asciiWords(string3) {
  return string3.match(reAsciiWord) || [];
}
var asciiWords_default = asciiWords;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hasUnicodeWord.js
var reHasUnicodeWord = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/;
function hasUnicodeWord(string3) {
  return reHasUnicodeWord.test(string3);
}
var hasUnicodeWord_default = hasUnicodeWord;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_unicodeWords.js
var rsAstralRange3 = "\\ud800-\\udfff";
var rsComboMarksRange4 = "\\u0300-\\u036f";
var reComboHalfMarksRange4 = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange4 = "\\u20d0-\\u20ff";
var rsComboRange4 = rsComboMarksRange4 + reComboHalfMarksRange4 + rsComboSymbolsRange4;
var rsDingbatRange = "\\u2700-\\u27bf";
var rsLowerRange = "a-z\\xdf-\\xf6\\xf8-\\xff";
var rsMathOpRange = "\\xac\\xb1\\xd7\\xf7";
var rsNonCharRange = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf";
var rsPunctuationRange = "\\u2000-\\u206f";
var rsSpaceRange = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000";
var rsUpperRange = "A-Z\\xc0-\\xd6\\xd8-\\xde";
var rsVarRange3 = "\\ufe0e\\ufe0f";
var rsBreakRange = rsMathOpRange + rsNonCharRange + rsPunctuationRange + rsSpaceRange;
var rsApos = "['\u2019]";
var rsBreak = "[" + rsBreakRange + "]";
var rsCombo3 = "[" + rsComboRange4 + "]";
var rsDigits = "\\d+";
var rsDingbat = "[" + rsDingbatRange + "]";
var rsLower = "[" + rsLowerRange + "]";
var rsMisc = "[^" + rsAstralRange3 + rsBreakRange + rsDigits + rsDingbatRange + rsLowerRange + rsUpperRange + "]";
var rsFitz2 = "\\ud83c[\\udffb-\\udfff]";
var rsModifier2 = "(?:" + rsCombo3 + "|" + rsFitz2 + ")";
var rsNonAstral2 = "[^" + rsAstralRange3 + "]";
var rsRegional2 = "(?:\\ud83c[\\udde6-\\uddff]){2}";
var rsSurrPair2 = "[\\ud800-\\udbff][\\udc00-\\udfff]";
var rsUpper = "[" + rsUpperRange + "]";
var rsZWJ3 = "\\u200d";
var rsMiscLower = "(?:" + rsLower + "|" + rsMisc + ")";
var rsMiscUpper = "(?:" + rsUpper + "|" + rsMisc + ")";
var rsOptContrLower = "(?:" + rsApos + "(?:d|ll|m|re|s|t|ve))?";
var rsOptContrUpper = "(?:" + rsApos + "(?:D|LL|M|RE|S|T|VE))?";
var reOptMod2 = rsModifier2 + "?";
var rsOptVar2 = "[" + rsVarRange3 + "]?";
var rsOptJoin2 = "(?:" + rsZWJ3 + "(?:" + [rsNonAstral2, rsRegional2, rsSurrPair2].join("|") + ")" + rsOptVar2 + reOptMod2 + ")*";
var rsOrdLower = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])";
var rsOrdUpper = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])";
var rsSeq2 = rsOptVar2 + reOptMod2 + rsOptJoin2;
var rsEmoji = "(?:" + [rsDingbat, rsRegional2, rsSurrPair2].join("|") + ")" + rsSeq2;
var reUnicodeWord = RegExp([
  rsUpper + "?" + rsLower + "+" + rsOptContrLower + "(?=" + [rsBreak, rsUpper, "$"].join("|") + ")",
  rsMiscUpper + "+" + rsOptContrUpper + "(?=" + [rsBreak, rsUpper + rsMiscLower, "$"].join("|") + ")",
  rsUpper + "?" + rsMiscLower + "+" + rsOptContrLower,
  rsUpper + "+" + rsOptContrUpper,
  rsOrdUpper,
  rsOrdLower,
  rsDigits,
  rsEmoji
].join("|"), "g");
function unicodeWords(string3) {
  return string3.match(reUnicodeWord) || [];
}
var unicodeWords_default = unicodeWords;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/words.js
function words(string3, pattern, guard) {
  string3 = toString_default(string3);
  pattern = guard ? void 0 : pattern;
  if (pattern === void 0) {
    return hasUnicodeWord_default(string3) ? unicodeWords_default(string3) : asciiWords_default(string3);
  }
  return string3.match(pattern) || [];
}
var words_default = words;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createCompounder.js
var rsApos2 = "['\u2019]";
var reApos = RegExp(rsApos2, "g");
function createCompounder(callback) {
  return function (string3) {
    return arrayReduce_default(words_default(deburr_default(string3).replace(reApos, "")), callback, "");
  };
}
var createCompounder_default = createCompounder;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/camelCase.js
var camelCase = createCompounder_default(function (result, word, index) {
  word = word.toLowerCase();
  return result + (index ? capitalize_default(word) : word);
});
var camelCase_default = camelCase;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stackClear.js
function stackClear() {
  this.__data__ = new ListCache_default();
  this.size = 0;
}
var stackClear_default = stackClear;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stackDelete.js
function stackDelete(key) {
  var data = this.__data__, result = data["delete"](key);
  this.size = data.size;
  return result;
}
var stackDelete_default = stackDelete;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stackGet.js
function stackGet(key) {
  return this.__data__.get(key);
}
var stackGet_default = stackGet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stackHas.js
function stackHas(key) {
  return this.__data__.has(key);
}
var stackHas_default = stackHas;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stackSet.js
var LARGE_ARRAY_SIZE = 200;
function stackSet(key, value) {
  var data = this.__data__;
  if (data instanceof ListCache_default) {
    var pairs2 = data.__data__;
    if (!Map_default || pairs2.length < LARGE_ARRAY_SIZE - 1) {
      pairs2.push([key, value]);
      this.size = ++data.size;
      return this;
    }
    data = this.__data__ = new MapCache_default(pairs2);
  }
  data.set(key, value);
  this.size = data.size;
  return this;
}
var stackSet_default = stackSet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Stack.js
function Stack(entries4) {
  var data = this.__data__ = new ListCache_default(entries4);
  this.size = data.size;
}
Stack.prototype.clear = stackClear_default;
Stack.prototype["delete"] = stackDelete_default;
Stack.prototype.get = stackGet_default;
Stack.prototype.has = stackHas_default;
Stack.prototype.set = stackSet_default;
var Stack_default = Stack;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_cloneBuffer.js
var freeExports3 = typeof exports == "object" && exports && !exports.nodeType && exports;
var freeModule3 = freeExports3 && typeof module == "object" && module && !module.nodeType && module;
var moduleExports3 = freeModule3 && freeModule3.exports === freeExports3;
var Buffer3 = moduleExports3 ? root_default.Buffer : void 0;
var allocUnsafe = Buffer3 ? Buffer3.allocUnsafe : void 0;
function cloneBuffer(buffer, isDeep) {
  if (isDeep) {
    return buffer.slice();
  }
  var length = buffer.length, result = allocUnsafe ? allocUnsafe(length) : new buffer.constructor(length);
  buffer.copy(result);
  return result;
}
var cloneBuffer_default = cloneBuffer;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayFilter.js
function arrayFilter(array, predicate) {
  var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result = [];
  while (++index < length) {
    var value = array[index];
    if (predicate(value, index, array)) {
      result[resIndex++] = value;
    }
  }
  return result;
}
var arrayFilter_default = arrayFilter;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/stubArray.js
function stubArray() {
  return [];
}
var stubArray_default = stubArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getSymbols.js
var objectProto13 = Object.prototype;
var propertyIsEnumerable2 = objectProto13.propertyIsEnumerable;
var nativeGetSymbols = Object.getOwnPropertySymbols;
var getSymbols = !nativeGetSymbols ? stubArray_default : function (object3) {
  if (object3 == null) {
    return [];
  }
  object3 = Object(object3);
  return arrayFilter_default(nativeGetSymbols(object3), function (symbol) {
    return propertyIsEnumerable2.call(object3, symbol);
  });
};
var getSymbols_default = getSymbols;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getSymbolsIn.js
var nativeGetSymbols2 = Object.getOwnPropertySymbols;
var getSymbolsIn = !nativeGetSymbols2 ? stubArray_default : function (object3) {
  var result = [];
  while (object3) {
    arrayPush_default(result, getSymbols_default(object3));
    object3 = getPrototype_default(object3);
  }
  return result;
};
var getSymbolsIn_default = getSymbolsIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseGetAllKeys.js
function baseGetAllKeys(object3, keysFunc, symbolsFunc) {
  var result = keysFunc(object3);
  return isArray_default(object3) ? result : arrayPush_default(result, symbolsFunc(object3));
}
var baseGetAllKeys_default = baseGetAllKeys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getAllKeys.js
function getAllKeys(object3) {
  return baseGetAllKeys_default(object3, keys_default, getSymbols_default);
}
var getAllKeys_default = getAllKeys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getAllKeysIn.js
function getAllKeysIn(object3) {
  return baseGetAllKeys_default(object3, keysIn_default, getSymbolsIn_default);
}
var getAllKeysIn_default = getAllKeysIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_DataView.js
var DataView = getNative_default(root_default, "DataView");
var DataView_default = DataView;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Promise.js
var Promise2 = getNative_default(root_default, "Promise");
var Promise_default = Promise2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Set.js
var Set2 = getNative_default(root_default, "Set");
var Set_default = Set2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getTag.js
var mapTag2 = "[object Map]";
var objectTag3 = "[object Object]";
var promiseTag = "[object Promise]";
var setTag2 = "[object Set]";
var weakMapTag2 = "[object WeakMap]";
var dataViewTag2 = "[object DataView]";
var dataViewCtorString = toSource_default(DataView_default);
var mapCtorString = toSource_default(Map_default);
var promiseCtorString = toSource_default(Promise_default);
var setCtorString = toSource_default(Set_default);
var weakMapCtorString = toSource_default(WeakMap_default);
var getTag = baseGetTag_default;
if (DataView_default && getTag(new DataView_default(new ArrayBuffer(1))) != dataViewTag2 || Map_default && getTag(new Map_default()) != mapTag2 || Promise_default && getTag(Promise_default.resolve()) != promiseTag || Set_default && getTag(new Set_default()) != setTag2 || WeakMap_default && getTag(new WeakMap_default()) != weakMapTag2) {
  getTag = function (value) {
    var result = baseGetTag_default(value), Ctor = result == objectTag3 ? value.constructor : void 0, ctorString = Ctor ? toSource_default(Ctor) : "";
    if (ctorString) {
      switch (ctorString) {
        case dataViewCtorString:
          return dataViewTag2;
        case mapCtorString:
          return mapTag2;
        case promiseCtorString:
          return promiseTag;
        case setCtorString:
          return setTag2;
        case weakMapCtorString:
          return weakMapTag2;
      }
    }
    return result;
  };
}
var getTag_default = getTag;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_Uint8Array.js
var Uint8Array2 = root_default.Uint8Array;
var Uint8Array_default = Uint8Array2;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_cloneArrayBuffer.js
function cloneArrayBuffer(arrayBuffer) {
  var result = new arrayBuffer.constructor(arrayBuffer.byteLength);
  new Uint8Array_default(result).set(new Uint8Array_default(arrayBuffer));
  return result;
}
var cloneArrayBuffer_default = cloneArrayBuffer;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_cloneTypedArray.js
function cloneTypedArray(typedArray, isDeep) {
  var buffer = isDeep ? cloneArrayBuffer_default(typedArray.buffer) : typedArray.buffer;
  return new typedArray.constructor(buffer, typedArray.byteOffset, typedArray.length);
}
var cloneTypedArray_default = cloneTypedArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_initCloneObject.js
function initCloneObject(object3) {
  return typeof object3.constructor == "function" && !isPrototype_default(object3) ? baseCreate_default(getPrototype_default(object3)) : {};
}
var initCloneObject_default = initCloneObject;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/compact.js
function compact(array) {
  var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result = [];
  while (++index < length) {
    var value = array[index];
    if (value) {
      result[resIndex++] = value;
    }
  }
  return result;
}
var compact_default = compact;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_setCacheAdd.js
var HASH_UNDEFINED3 = "__lodash_hash_undefined__";
function setCacheAdd(value) {
  this.__data__.set(value, HASH_UNDEFINED3);
  return this;
}
var setCacheAdd_default = setCacheAdd;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_setCacheHas.js
function setCacheHas(value) {
  return this.__data__.has(value);
}
var setCacheHas_default = setCacheHas;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_SetCache.js
function SetCache(values) {
  var index = -1, length = values == null ? 0 : values.length;
  this.__data__ = new MapCache_default();
  while (++index < length) {
    this.add(values[index]);
  }
}
SetCache.prototype.add = SetCache.prototype.push = setCacheAdd_default;
SetCache.prototype.has = setCacheHas_default;
var SetCache_default = SetCache;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arraySome.js
function arraySome(array, predicate) {
  var index = -1, length = array == null ? 0 : array.length;
  while (++index < length) {
    if (predicate(array[index], index, array)) {
      return true;
    }
  }
  return false;
}
var arraySome_default = arraySome;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_cacheHas.js
function cacheHas(cache, key) {
  return cache.has(key);
}
var cacheHas_default = cacheHas;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_equalArrays.js
var COMPARE_PARTIAL_FLAG = 1;
var COMPARE_UNORDERED_FLAG = 2;
function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG, arrLength = array.length, othLength = other.length;
  if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
    return false;
  }
  var arrStacked = stack.get(array);
  var othStacked = stack.get(other);
  if (arrStacked && othStacked) {
    return arrStacked == other && othStacked == array;
  }
  var index = -1, result = true, seen = bitmask & COMPARE_UNORDERED_FLAG ? new SetCache_default() : void 0;
  stack.set(array, other);
  stack.set(other, array);
  while (++index < arrLength) {
    var arrValue = array[index], othValue = other[index];
    if (customizer) {
      var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
    }
    if (compared !== void 0) {
      if (compared) {
        continue;
      }
      result = false;
      break;
    }
    if (seen) {
      if (!arraySome_default(other, function (othValue2, othIndex) {
        if (!cacheHas_default(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
          return seen.push(othIndex);
        }
      })) {
        result = false;
        break;
      }
    } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
      result = false;
      break;
    }
  }
  stack["delete"](array);
  stack["delete"](other);
  return result;
}
var equalArrays_default = equalArrays;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_mapToArray.js
function mapToArray(map2) {
  var index = -1, result = Array(map2.size);
  map2.forEach(function (value, key) {
    result[++index] = [key, value];
  });
  return result;
}
var mapToArray_default = mapToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_setToArray.js
function setToArray(set4) {
  var index = -1, result = Array(set4.size);
  set4.forEach(function (value) {
    result[++index] = value;
  });
  return result;
}
var setToArray_default = setToArray;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_equalByTag.js
var COMPARE_PARTIAL_FLAG2 = 1;
var COMPARE_UNORDERED_FLAG2 = 2;
var boolTag2 = "[object Boolean]";
var dateTag2 = "[object Date]";
var errorTag2 = "[object Error]";
var mapTag3 = "[object Map]";
var numberTag2 = "[object Number]";
var regexpTag2 = "[object RegExp]";
var setTag3 = "[object Set]";
var stringTag2 = "[object String]";
var symbolTag2 = "[object Symbol]";
var arrayBufferTag2 = "[object ArrayBuffer]";
var dataViewTag3 = "[object DataView]";
var symbolProto2 = Symbol_default ? Symbol_default.prototype : void 0;
var symbolValueOf = symbolProto2 ? symbolProto2.valueOf : void 0;
function equalByTag(object3, other, tag, bitmask, customizer, equalFunc, stack) {
  switch (tag) {
    case dataViewTag3:
      if (object3.byteLength != other.byteLength || object3.byteOffset != other.byteOffset) {
        return false;
      }
      object3 = object3.buffer;
      other = other.buffer;
    case arrayBufferTag2:
      if (object3.byteLength != other.byteLength || !equalFunc(new Uint8Array_default(object3), new Uint8Array_default(other))) {
        return false;
      }
      return true;
    case boolTag2:
    case dateTag2:
    case numberTag2:
      return eq_default(+object3, +other);
    case errorTag2:
      return object3.name == other.name && object3.message == other.message;
    case regexpTag2:
    case stringTag2:
      return object3 == other + "";
    case mapTag3:
      var convert3 = mapToArray_default;
    case setTag3:
      var isPartial = bitmask & COMPARE_PARTIAL_FLAG2;
      convert3 || (convert3 = setToArray_default);
      if (object3.size != other.size && !isPartial) {
        return false;
      }
      var stacked = stack.get(object3);
      if (stacked) {
        return stacked == other;
      }
      bitmask |= COMPARE_UNORDERED_FLAG2;
      stack.set(object3, other);
      var result = equalArrays_default(convert3(object3), convert3(other), bitmask, customizer, equalFunc, stack);
      stack["delete"](object3);
      return result;
    case symbolTag2:
      if (symbolValueOf) {
        return symbolValueOf.call(object3) == symbolValueOf.call(other);
      }
  }
  return false;
}
var equalByTag_default = equalByTag;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_equalObjects.js
var COMPARE_PARTIAL_FLAG3 = 1;
var objectProto14 = Object.prototype;
var hasOwnProperty11 = objectProto14.hasOwnProperty;
function equalObjects(object3, other, bitmask, customizer, equalFunc, stack) {
  var isPartial = bitmask & COMPARE_PARTIAL_FLAG3, objProps = getAllKeys_default(object3), objLength = objProps.length, othProps = getAllKeys_default(other), othLength = othProps.length;
  if (objLength != othLength && !isPartial) {
    return false;
  }
  var index = objLength;
  while (index--) {
    var key = objProps[index];
    if (!(isPartial ? key in other : hasOwnProperty11.call(other, key))) {
      return false;
    }
  }
  var objStacked = stack.get(object3);
  var othStacked = stack.get(other);
  if (objStacked && othStacked) {
    return objStacked == other && othStacked == object3;
  }
  var result = true;
  stack.set(object3, other);
  stack.set(other, object3);
  var skipCtor = isPartial;
  while (++index < objLength) {
    key = objProps[index];
    var objValue = object3[key], othValue = other[key];
    if (customizer) {
      var compared = isPartial ? customizer(othValue, objValue, key, other, object3, stack) : customizer(objValue, othValue, key, object3, other, stack);
    }
    if (!(compared === void 0 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
      result = false;
      break;
    }
    skipCtor || (skipCtor = key == "constructor");
  }
  if (result && !skipCtor) {
    var objCtor = object3.constructor, othCtor = other.constructor;
    if (objCtor != othCtor && ("constructor" in object3 && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
      result = false;
    }
  }
  stack["delete"](object3);
  stack["delete"](other);
  return result;
}
var equalObjects_default = equalObjects;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsEqualDeep.js
var COMPARE_PARTIAL_FLAG4 = 1;
var argsTag3 = "[object Arguments]";
var arrayTag2 = "[object Array]";
var objectTag4 = "[object Object]";
var objectProto15 = Object.prototype;
var hasOwnProperty12 = objectProto15.hasOwnProperty;
function baseIsEqualDeep(object3, other, bitmask, customizer, equalFunc, stack) {
  var objIsArr = isArray_default(object3), othIsArr = isArray_default(other), objTag = objIsArr ? arrayTag2 : getTag_default(object3), othTag = othIsArr ? arrayTag2 : getTag_default(other);
  objTag = objTag == argsTag3 ? objectTag4 : objTag;
  othTag = othTag == argsTag3 ? objectTag4 : othTag;
  var objIsObj = objTag == objectTag4, othIsObj = othTag == objectTag4, isSameTag = objTag == othTag;
  if (isSameTag && isBuffer_default(object3)) {
    if (!isBuffer_default(other)) {
      return false;
    }
    objIsArr = true;
    objIsObj = false;
  }
  if (isSameTag && !objIsObj) {
    stack || (stack = new Stack_default());
    return objIsArr || isTypedArray_default(object3) ? equalArrays_default(object3, other, bitmask, customizer, equalFunc, stack) : equalByTag_default(object3, other, objTag, bitmask, customizer, equalFunc, stack);
  }
  if (!(bitmask & COMPARE_PARTIAL_FLAG4)) {
    var objIsWrapped = objIsObj && hasOwnProperty12.call(object3, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty12.call(other, "__wrapped__");
    if (objIsWrapped || othIsWrapped) {
      var objUnwrapped = objIsWrapped ? object3.value() : object3, othUnwrapped = othIsWrapped ? other.value() : other;
      stack || (stack = new Stack_default());
      return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
    }
  }
  if (!isSameTag) {
    return false;
  }
  stack || (stack = new Stack_default());
  return equalObjects_default(object3, other, bitmask, customizer, equalFunc, stack);
}
var baseIsEqualDeep_default = baseIsEqualDeep;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsEqual.js
function baseIsEqual(value, other, bitmask, customizer, stack) {
  if (value === other) {
    return true;
  }
  if (value == null || other == null || !isObjectLike_default(value) && !isObjectLike_default(other)) {
    return value !== value && other !== other;
  }
  return baseIsEqualDeep_default(value, other, bitmask, customizer, baseIsEqual, stack);
}
var baseIsEqual_default = baseIsEqual;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIsMatch.js
var COMPARE_PARTIAL_FLAG5 = 1;
var COMPARE_UNORDERED_FLAG3 = 2;
function baseIsMatch(object3, source, matchData, customizer) {
  var index = matchData.length, length = index, noCustomizer = !customizer;
  if (object3 == null) {
    return !length;
  }
  object3 = Object(object3);
  while (index--) {
    var data = matchData[index];
    if (noCustomizer && data[2] ? data[1] !== object3[data[0]] : !(data[0] in object3)) {
      return false;
    }
  }
  while (++index < length) {
    data = matchData[index];
    var key = data[0], objValue = object3[key], srcValue = data[1];
    if (noCustomizer && data[2]) {
      if (objValue === void 0 && !(key in object3)) {
        return false;
      }
    } else {
      var stack = new Stack_default();
      if (customizer) {
        var result = customizer(objValue, srcValue, key, object3, source, stack);
      }
      if (!(result === void 0 ? baseIsEqual_default(srcValue, objValue, COMPARE_PARTIAL_FLAG5 | COMPARE_UNORDERED_FLAG3, customizer, stack) : result)) {
        return false;
      }
    }
  }
  return true;
}
var baseIsMatch_default = baseIsMatch;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_isStrictComparable.js
function isStrictComparable(value) {
  return value === value && !isObject_default(value);
}
var isStrictComparable_default = isStrictComparable;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_getMatchData.js
function getMatchData(object3) {
  var result = keys_default(object3), length = result.length;
  while (length--) {
    var key = result[length], value = object3[key];
    result[length] = [key, value, isStrictComparable_default(value)];
  }
  return result;
}
var getMatchData_default = getMatchData;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_matchesStrictComparable.js
function matchesStrictComparable(key, srcValue) {
  return function (object3) {
    if (object3 == null) {
      return false;
    }
    return object3[key] === srcValue && (srcValue !== void 0 || key in Object(object3));
  };
}
var matchesStrictComparable_default = matchesStrictComparable;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseMatches.js
function baseMatches(source) {
  var matchData = getMatchData_default(source);
  if (matchData.length == 1 && matchData[0][2]) {
    return matchesStrictComparable_default(matchData[0][0], matchData[0][1]);
  }
  return function (object3) {
    return object3 === source || baseIsMatch_default(object3, source, matchData);
  };
}
var baseMatches_default = baseMatches;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseHasIn.js
function baseHasIn(object3, key) {
  return object3 != null && key in Object(object3);
}
var baseHasIn_default = baseHasIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_hasPath.js
function hasPath(object3, path5, hasFunc) {
  path5 = castPath_default(path5, object3);
  var index = -1, length = path5.length, result = false;
  while (++index < length) {
    var key = toKey_default(path5[index]);
    if (!(result = object3 != null && hasFunc(object3, key))) {
      break;
    }
    object3 = object3[key];
  }
  if (result || ++index != length) {
    return result;
  }
  length = object3 == null ? 0 : object3.length;
  return !!length && isLength_default(length) && isIndex_default(key, length) && (isArray_default(object3) || isArguments_default(object3));
}
var hasPath_default = hasPath;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/hasIn.js
function hasIn(object3, path5) {
  return object3 != null && hasPath_default(object3, path5, baseHasIn_default);
}
var hasIn_default = hasIn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseMatchesProperty.js
var COMPARE_PARTIAL_FLAG6 = 1;
var COMPARE_UNORDERED_FLAG4 = 2;
function baseMatchesProperty(path5, srcValue) {
  if (isKey_default(path5) && isStrictComparable_default(srcValue)) {
    return matchesStrictComparable_default(toKey_default(path5), srcValue);
  }
  return function (object3) {
    var objValue = get_default(object3, path5);
    return objValue === void 0 && objValue === srcValue ? hasIn_default(object3, path5) : baseIsEqual_default(srcValue, objValue, COMPARE_PARTIAL_FLAG6 | COMPARE_UNORDERED_FLAG4);
  };
}
var baseMatchesProperty_default = baseMatchesProperty;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseProperty.js
function baseProperty(key) {
  return function (object3) {
    return object3 == null ? void 0 : object3[key];
  };
}
var baseProperty_default = baseProperty;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_basePropertyDeep.js
function basePropertyDeep(path5) {
  return function (object3) {
    return baseGet_default(object3, path5);
  };
}
var basePropertyDeep_default = basePropertyDeep;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/property.js
function property(path5) {
  return isKey_default(path5) ? baseProperty_default(toKey_default(path5)) : basePropertyDeep_default(path5);
}
var property_default = property;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseIteratee.js
function baseIteratee(value) {
  if (typeof value == "function") {
    return value;
  }
  if (value == null) {
    return identity_default;
  }
  if (typeof value == "object") {
    return isArray_default(value) ? baseMatchesProperty_default(value[0], value[1]) : baseMatches_default(value);
  }
  return property_default(value);
}
var baseIteratee_default = baseIteratee;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayAggregator.js
function arrayAggregator(array, setter, iteratee, accumulator) {
  var index = -1, length = array == null ? 0 : array.length;
  while (++index < length) {
    var value = array[index];
    setter(accumulator, value, iteratee(value), array);
  }
  return accumulator;
}
var arrayAggregator_default = arrayAggregator;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createBaseFor.js
function createBaseFor(fromRight) {
  return function (object3, iteratee, keysFunc) {
    var index = -1, iterable = Object(object3), props = keysFunc(object3), length = props.length;
    while (length--) {
      var key = props[fromRight ? length : ++index];
      if (iteratee(iterable[key], key, iterable) === false) {
        break;
      }
    }
    return object3;
  };
}
var createBaseFor_default = createBaseFor;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseFor.js
var baseFor = createBaseFor_default();
var baseFor_default = baseFor;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseForOwn.js
function baseForOwn(object3, iteratee) {
  return object3 && baseFor_default(object3, iteratee, keys_default);
}
var baseForOwn_default = baseForOwn;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createBaseEach.js
function createBaseEach(eachFunc, fromRight) {
  return function (collection, iteratee) {
    if (collection == null) {
      return collection;
    }
    if (!isArrayLike_default(collection)) {
      return eachFunc(collection, iteratee);
    }
    var length = collection.length, index = fromRight ? length : -1, iterable = Object(collection);
    while (fromRight ? index-- : ++index < length) {
      if (iteratee(iterable[index], index, iterable) === false) {
        break;
      }
    }
    return collection;
  };
}
var createBaseEach_default = createBaseEach;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseEach.js
var baseEach = createBaseEach_default(baseForOwn_default);
var baseEach_default = baseEach;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseAggregator.js
function baseAggregator(collection, setter, iteratee, accumulator) {
  baseEach_default(collection, function (value, key, collection2) {
    setter(accumulator, value, iteratee(value), collection2);
  });
  return accumulator;
}
var baseAggregator_default = baseAggregator;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_createAggregator.js
function createAggregator(setter, initializer) {
  return function (collection, iteratee) {
    var func = isArray_default(collection) ? arrayAggregator_default : baseAggregator_default, accumulator = initializer ? initializer() : {};
    return func(collection, setter, baseIteratee_default(iteratee, 2), accumulator);
  };
}
var createAggregator_default = createAggregator;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_assignMergeValue.js
function assignMergeValue(object3, key, value) {
  if (value !== void 0 && !eq_default(object3[key], value) || value === void 0 && !(key in object3)) {
    baseAssignValue_default(object3, key, value);
  }
}
var assignMergeValue_default = assignMergeValue;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isArrayLikeObject.js
function isArrayLikeObject(value) {
  return isObjectLike_default(value) && isArrayLike_default(value);
}
var isArrayLikeObject_default = isArrayLikeObject;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_safeGet.js
function safeGet(object3, key) {
  if (key === "constructor" && typeof object3[key] === "function") {
    return;
  }
  if (key == "__proto__") {
    return;
  }
  return object3[key];
}
var safeGet_default = safeGet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/toPlainObject.js
function toPlainObject(value) {
  return copyObject_default(value, keysIn_default(value));
}
var toPlainObject_default = toPlainObject;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseMergeDeep.js
function baseMergeDeep(object3, source, key, srcIndex, mergeFunc, customizer, stack) {
  var objValue = safeGet_default(object3, key), srcValue = safeGet_default(source, key), stacked = stack.get(srcValue);
  if (stacked) {
    assignMergeValue_default(object3, key, stacked);
    return;
  }
  var newValue = customizer ? customizer(objValue, srcValue, key + "", object3, source, stack) : void 0;
  var isCommon = newValue === void 0;
  if (isCommon) {
    var isArr = isArray_default(srcValue), isBuff = !isArr && isBuffer_default(srcValue), isTyped = !isArr && !isBuff && isTypedArray_default(srcValue);
    newValue = srcValue;
    if (isArr || isBuff || isTyped) {
      if (isArray_default(objValue)) {
        newValue = objValue;
      } else if (isArrayLikeObject_default(objValue)) {
        newValue = copyArray_default(objValue);
      } else if (isBuff) {
        isCommon = false;
        newValue = cloneBuffer_default(srcValue, true);
      } else if (isTyped) {
        isCommon = false;
        newValue = cloneTypedArray_default(srcValue, true);
      } else {
        newValue = [];
      }
    } else if (isPlainObject_default(srcValue) || isArguments_default(srcValue)) {
      newValue = objValue;
      if (isArguments_default(objValue)) {
        newValue = toPlainObject_default(objValue);
      } else if (!isObject_default(objValue) || isFunction_default(objValue)) {
        newValue = initCloneObject_default(srcValue);
      }
    } else {
      isCommon = false;
    }
  }
  if (isCommon) {
    stack.set(srcValue, newValue);
    mergeFunc(newValue, srcValue, srcIndex, customizer, stack);
    stack["delete"](srcValue);
  }
  assignMergeValue_default(object3, key, newValue);
}
var baseMergeDeep_default = baseMergeDeep;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseMerge.js
function baseMerge(object3, source, srcIndex, customizer, stack) {
  if (object3 === source) {
    return;
  }
  baseFor_default(source, function (srcValue, key) {
    stack || (stack = new Stack_default());
    if (isObject_default(srcValue)) {
      baseMergeDeep_default(object3, source, key, srcIndex, baseMerge, customizer, stack);
    } else {
      var newValue = customizer ? customizer(safeGet_default(object3, key), srcValue, key + "", object3, source, stack) : void 0;
      if (newValue === void 0) {
        newValue = srcValue;
      }
      assignMergeValue_default(object3, key, newValue);
    }
  }, keysIn_default);
}
var baseMerge_default = baseMerge;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/mergeWith.js
var mergeWith = createAssigner_default(function (object3, source, srcIndex, customizer) {
  baseMerge_default(object3, source, srcIndex, customizer);
});
var mergeWith_default = mergeWith;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_arrayIncludesWith.js
function arrayIncludesWith(array, value, comparator) {
  var index = -1, length = array == null ? 0 : array.length;
  while (++index < length) {
    if (comparator(value, array[index])) {
      return true;
    }
  }
  return false;
}
var arrayIncludesWith_default = arrayIncludesWith;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseDifference.js
var LARGE_ARRAY_SIZE2 = 200;
function baseDifference(array, values, iteratee, comparator) {
  var index = -1, includes = arrayIncludes_default, isCommon = true, length = array.length, result = [], valuesLength = values.length;
  if (!length) {
    return result;
  }
  if (iteratee) {
    values = arrayMap_default(values, baseUnary_default(iteratee));
  }
  if (comparator) {
    includes = arrayIncludesWith_default;
    isCommon = false;
  } else if (values.length >= LARGE_ARRAY_SIZE2) {
    includes = cacheHas_default;
    isCommon = false;
    values = new SetCache_default(values);
  }
  outer:
  while (++index < length) {
    var value = array[index], computed = iteratee == null ? value : iteratee(value);
    value = comparator || value !== 0 ? value : 0;
    if (isCommon && computed === computed) {
      var valuesIndex = valuesLength;
      while (valuesIndex--) {
        if (values[valuesIndex] === computed) {
          continue outer;
        }
      }
      result.push(value);
    } else if (!includes(values, computed, comparator)) {
      result.push(value);
    }
  }
  return result;
}
var baseDifference_default = baseDifference;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/difference.js
var difference = baseRest_default(function (array, values) {
  return isArrayLikeObject_default(array) ? baseDifference_default(array, baseFlatten_default(values, 1, isArrayLikeObject_default, true)) : [];
});
var difference_default = difference;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isString.js
var stringTag3 = "[object String]";
function isString(value) {
  return typeof value == "string" || !isArray_default(value) && isObjectLike_default(value) && baseGetTag_default(value) == stringTag3;
}
var isString_default = isString;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isEqual.js
function isEqual(value, other) {
  return baseIsEqual_default(value, other);
}
var isEqual_default = isEqual;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/isNull.js
function isNull(value) {
  return value === null;
}
var isNull_default = isNull;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/keyBy.js
var keyBy = createAggregator_default(function (result, value, key) {
  baseAssignValue_default(result, key, value);
});
var keyBy_default = keyBy;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/mapKeys.js
function mapKeys(object3, iteratee) {
  var result = {};
  iteratee = baseIteratee_default(iteratee, 3);
  baseForOwn_default(object3, function (value, key, object4) {
    baseAssignValue_default(result, iteratee(value, key, object4), value);
  });
  return result;
}
var mapKeys_default = mapKeys;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/mapValues.js
function mapValues(object3, iteratee) {
  var result = {};
  iteratee = baseIteratee_default(iteratee, 3);
  baseForOwn_default(object3, function (value, key, object4) {
    baseAssignValue_default(result, key, iteratee(value, key, object4));
  });
  return result;
}
var mapValues_default = mapValues;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/negate.js
var FUNC_ERROR_TEXT2 = "Expected a function";
function negate(predicate) {
  if (typeof predicate != "function") {
    throw new TypeError(FUNC_ERROR_TEXT2);
  }
  return function () {
    var args = arguments;
    switch (args.length) {
      case 0:
        return !predicate.call(this);
      case 1:
        return !predicate.call(this, args[0]);
      case 2:
        return !predicate.call(this, args[0], args[1]);
      case 3:
        return !predicate.call(this, args[0], args[1], args[2]);
    }
    return !predicate.apply(this, args);
  };
}
var negate_default = negate;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_baseSet.js
function baseSet(object3, path5, value, customizer) {
  if (!isObject_default(object3)) {
    return object3;
  }
  path5 = castPath_default(path5, object3);
  var index = -1, length = path5.length, lastIndex = length - 1, nested = object3;
  while (nested != null && ++index < length) {
    var key = toKey_default(path5[index]), newValue = value;
    if (key === "__proto__" || key === "constructor" || key === "prototype") {
      return object3;
    }
    if (index != lastIndex) {
      var objValue = nested[key];
      newValue = customizer ? customizer(objValue, key, nested) : void 0;
      if (newValue === void 0) {
        newValue = isObject_default(objValue) ? objValue : isIndex_default(path5[index + 1]) ? [] : {};
      }
    }
    assignValue_default(nested, key, newValue);
    nested = nested[key];
  }
  return object3;
}
var baseSet_default = baseSet;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_basePickBy.js
function basePickBy(object3, paths, predicate) {
  var index = -1, length = paths.length, result = {};
  while (++index < length) {
    var path5 = paths[index], value = baseGet_default(object3, path5);
    if (predicate(value, path5)) {
      baseSet_default(result, castPath_default(path5, object3), value);
    }
  }
  return result;
}
var basePickBy_default = basePickBy;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/pickBy.js
function pickBy(object3, predicate) {
  if (object3 == null) {
    return {};
  }
  var props = arrayMap_default(getAllKeysIn_default(object3), function (prop) {
    return [prop];
  });
  predicate = baseIteratee_default(predicate);
  return basePickBy_default(object3, props, function (value, path5) {
    return predicate(value, path5[0]);
  });
}
var pickBy_default = pickBy;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/omitBy.js
function omitBy(object3, predicate) {
  return pickBy_default(object3, negate_default(baseIteratee_default(predicate)));
}
var omitBy_default = omitBy;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_asciiSize.js
var asciiSize = baseProperty_default("length");
var asciiSize_default = asciiSize;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_unicodeSize.js
var rsAstralRange4 = "\\ud800-\\udfff";
var rsComboMarksRange5 = "\\u0300-\\u036f";
var reComboHalfMarksRange5 = "\\ufe20-\\ufe2f";
var rsComboSymbolsRange5 = "\\u20d0-\\u20ff";
var rsComboRange5 = rsComboMarksRange5 + reComboHalfMarksRange5 + rsComboSymbolsRange5;
var rsVarRange4 = "\\ufe0e\\ufe0f";
var rsAstral2 = "[" + rsAstralRange4 + "]";
var rsCombo4 = "[" + rsComboRange5 + "]";
var rsFitz3 = "\\ud83c[\\udffb-\\udfff]";
var rsModifier3 = "(?:" + rsCombo4 + "|" + rsFitz3 + ")";
var rsNonAstral3 = "[^" + rsAstralRange4 + "]";
var rsRegional3 = "(?:\\ud83c[\\udde6-\\uddff]){2}";
var rsSurrPair3 = "[\\ud800-\\udbff][\\udc00-\\udfff]";
var rsZWJ4 = "\\u200d";
var reOptMod3 = rsModifier3 + "?";
var rsOptVar3 = "[" + rsVarRange4 + "]?";
var rsOptJoin3 = "(?:" + rsZWJ4 + "(?:" + [rsNonAstral3, rsRegional3, rsSurrPair3].join("|") + ")" + rsOptVar3 + reOptMod3 + ")*";
var rsSeq3 = rsOptVar3 + reOptMod3 + rsOptJoin3;
var rsSymbol2 = "(?:" + [rsNonAstral3 + rsCombo4 + "?", rsCombo4, rsRegional3, rsSurrPair3, rsAstral2].join("|") + ")";
var reUnicode2 = RegExp(rsFitz3 + "(?=" + rsFitz3 + ")|" + rsSymbol2 + rsSeq3, "g");
function unicodeSize(string3) {
  var result = reUnicode2.lastIndex = 0;
  while (reUnicode2.test(string3)) {
    ++result;
  }
  return result;
}
var unicodeSize_default = unicodeSize;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/_stringSize.js
function stringSize(string3) {
  return hasUnicode_default(string3) ? unicodeSize_default(string3) : asciiSize_default(string3);
}
var stringSize_default = stringSize;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/size.js
var mapTag4 = "[object Map]";
var setTag4 = "[object Set]";
function size(collection) {
  if (collection == null) {
    return 0;
  }
  if (isArrayLike_default(collection)) {
    return isString_default(collection) ? stringSize_default(collection) : collection.length;
  }
  var tag = getTag_default(collection);
  if (tag == mapTag4 || tag == setTag4) {
    return collection.size;
  }
  return baseKeys_default(collection).length;
}
var size_default = size;

// ../../../node_modules/.pnpm/lodash-es@4.17.21/node_modules/lodash-es/snakeCase.js
var snakeCase = createCompounder_default(function (result, word, index) {
  return result + (index ? "_" : "") + word.toLowerCase();
});
var snakeCase_default = snakeCase;

// ../../commons/core-utils/lib/assertNever.js
function assertNever(x) {
  throw new Error("Unexpected value: " + JSON.stringify(x));
}

// ../../commons/core-utils/lib/examples.js
var examples_exports = {};
__export(examples_exports, {
  BASE64: () => BASE64,
  BIG_INTEGER: () => BIG_INTEGER,
  BOOLEAN: () => BOOLEAN,
  DATE: () => DATE,
  DATE_TIME: () => DATE_TIME,
  DOUBLE: () => DOUBLE,
  FLOAT: () => FLOAT,
  INT: () => INT,
  INT64: () => INT64,
  SAMPLE_STRINGS: () => SAMPLE_STRINGS,
  STRING: () => STRING,
  UINT: () => UINT,
  UINT64: () => UINT64,
  UUID: () => UUID
});
var STRING = "string";
var BASE64 = "SGVsbG8gd29ybGQh";
var BOOLEAN = true;
var DATE = "2023-01-15";
var DATE_TIME = "2024-01-15T09:30:00Z";
var DOUBLE = 1.1;
var FLOAT = 1.1;
var INT = 1;
var INT64 = 1e6;
var UINT = 1;
var UINT64 = 1e6;
var UUID = "d5e9c84f-c2b2-4bf4-b4b0-7ffd7a9ffc32";
var BIG_INTEGER = "123456789123456789";
var SAMPLE_STRINGS = [
  "x",
  "xy",
  "foo",
  "buzz",
  "alpha",
  "banana",
  "apricot",
  "mandarin",
  "nectarine",
  "strawberry",
  "pomegranate",
  "blackcurrant"
];

// ../../commons/core-utils/lib/getDuplicates.js
function getDuplicates(items) {
  const seen = /* @__PURE__ */ new Set();
  const duplicatesSet = /* @__PURE__ */ new Set();
  const duplicates = [];
  for (const item of items) {
    if (seen.has(item) && !duplicatesSet.has(item)) {
      duplicatesSet.add(item);
      duplicates.push(item);
    }
    seen.add(item);
  }
  return duplicates;
}

// ../../commons/core-utils/lib/isNonNullish.js
function isNonNullish(x) {
  return x != null;
}

// ../../commons/core-utils/lib/mediaType.js
var import_whatwg_mimetype = __toESM(require_mime_type(), 1);
var MediaType = class _MediaType {
  type;
  subtype;
  essence;
  parameters;
  mimeType;
  input;
  constructor(type2, subtype, essence, parameters, mimeType, input) {
    this.type = type2;
    this.subtype = subtype;
    this.essence = essence;
    this.parameters = parameters;
    this.mimeType = mimeType;
    this.input = input;
  }
  static APPLICATION_JSON = "application/json";
  static APPLICATION_OCTET_STREAM = "application/octet-stream";
  static MULTIPART_FORM_DATA = "multipart/form-data";
  static parse(input) {
    if (input == null) {
      return null;
    }
    const parsed = import_whatwg_mimetype.default.parse(input);
    if (parsed == null) {
      return null;
    }
    return new _MediaType(parsed.type, parsed.subtype, parsed.essence, parsed.parameters, parsed, input);
  }
  toString() {
    return this.input;
  }
  /** Types */
  isText() {
    return this.type === "text";
  }
  isImage() {
    return this.type === "image";
  }
  isAudio() {
    return this.type === "audio";
  }
  isVideo() {
    return this.type === "video";
  }
  isFont() {
    return this.type === "font";
  }
  isMultipart() {
    return this.type === "multipart";
  }
  isApplication() {
    return this.type === "application";
  }
  isMessage() {
    return this.type === "message";
  }
  isModel() {
    return this.type === "model";
  }
  /** Text */
  isCSS() {
    return this.isText() && this.subtype === "css";
  }
  isCSV() {
    return this.isText() && this.subtype === "csv";
  }
  isMarkdown() {
    return this.isText() && this.subtype === "markdown";
  }
  isPlainText() {
    return this.isText() && this.subtype === "plain";
  }
  /** Multipart */
  isMultiPartFormData() {
    return this.isMultipart() && this.subtype === "form-data";
  }
  /** Application */
  isJSON() {
    return this.isApplication() && this.subtype === "json";
  }
  isURLEncoded() {
    return this.isApplication() && this.subtype === "x-www-form-urlencoded";
  }
  isOctetStream() {
    return this.isApplication() && this.subtype === "octet-stream";
  }
  isPDF() {
    return this.isApplication() && this.subtype === "pdf";
  }
  isZip() {
    return this.isApplication() && this.subtype === "zip";
  }
  isGzip() {
    return this.isApplication() && this.subtype === "gzip";
  }
  isTar() {
    return this.isApplication() && this.subtype === "tar";
  }
  isBrotli() {
    return this.isApplication() && this.subtype === "br";
  }
  isDeflate() {
    return this.isApplication() && this.subtype === "deflate";
  }
  isProtobuf() {
    return this.isApplication() && this.subtype === "protobuf";
  }
  /** Images */
  isAvif() {
    return this.isImage() && this.subtype === "avif";
  }
  isWebP() {
    return this.isImage() && this.subtype === "webp";
  }
  isSVG() {
    return this.isImage() && this.subtype === "svg+xml";
  }
  isPNG() {
    return this.isImage() && this.subtype === "png";
  }
  isJPEG() {
    return this.isImage() && this.subtype === "jpeg";
  }
  isGIF() {
    return this.isImage() && this.subtype === "gif";
  }
  /** Audio */
  isMPEG() {
    return this.isAudio() && this.subtype === "mpeg";
  }
  isWAV() {
    return this.isAudio() && this.subtype === "wav";
  }
  /** Mixed */
  isHTML() {
    return this.mimeType.isHTML();
  }
  isXML() {
    return this.mimeType.isXML();
  }
  isJavaScript() {
    return this.mimeType.isJavaScript();
  }
};

// ../../commons/core-utils/lib/noop.js
function noop() {
}

// ../../commons/core-utils/lib/objects/keys.js
function keys2(object3) {
  return Object.keys(object3);
}

// ../../commons/core-utils/lib/ObjectPropertiesVisitor.js
async function visitObject(object3, visitor) {
  for (const key of keys2(visitor)) {
    await visitor[key](object3[key]);
  }
}

// ../../commons/core-utils/lib/objects/entries.js
function entries(object3) {
  return Object.entries(object3);
}

// ../../commons/core-utils/lib/objects/isPlainObject.js
function isPlainObject2(value) {
  if (!isObjectLike2(value) || toString.call(value) !== "[object Object]") {
    return false;
  }
  if (Object.getPrototypeOf(value) == null) {
    return true;
  }
  let proto = value;
  while (Object.getPrototypeOf(proto) != null) {
    proto = Object.getPrototypeOf(proto);
  }
  return Object.getPrototypeOf(value) === proto;
}
function isObjectLike2(value) {
  return typeof value === "object" && value != null;
}

// ../../commons/core-utils/lib/mergeWithOverrides.js
async function mergeWithOverrides({ data, overrides }) {
  const merged = mergeWith_default(data, mergeWith_default, overrides, (obj, src) => Array.isArray(obj) && Array.isArray(src) ? src.every((element) => typeof element === "object") && obj.every((element) => typeof element === "object") ? (
    // nested arrays of objects are merged
    void 0
  ) : (
    // nested arrays of primitives are replaced
    [...src]
  ) : void 0);
  const filtered = omitDeepBy(merged, isNull_default);
  return filtered;
}
var omitDeepBy = (object3, cb) => {
  function omitByDeepByOnOwnProps(object4) {
    if (Array.isArray(object4)) {
      return object4.map((element) => omitDeepBy(element, cb));
    }
    if (isPlainObject_default(object4)) {
      const temp = {};
      for (const [key, value] of Object.entries(object4)) {
        temp[key] = omitDeepBy(value, cb);
      }
      return omitBy_default(temp, cb);
    }
    return object4;
  }
  return omitByDeepByOnOwnProps(object3);
};

// ../../cli/configuration/lib/constants.js
var ROOT_API_FILENAME = "api.yml";
var FERN_PACKAGE_MARKER_FILENAME_NO_EXTENSION = "__package__";
var FERN_PACKAGE_MARKER_FILENAME = `${FERN_PACKAGE_MARKER_FILENAME_NO_EXTENSION}.yml`;
var DEFAULT_GROUP_NAME = "local";

// ../../cli/configuration/lib/generators-yml/index.js
var generators_yml_exports = {};
__export(generators_yml_exports, {
  API_ORIGIN_LOCATION_KEY: () => API_ORIGIN_LOCATION_KEY,
  API_SETTINGS_KEY: () => API_SETTINGS_KEY,
  ASYNC_API_LOCATION_KEY: () => ASYNC_API_LOCATION_KEY,
  DEFAULT_GROUP_GENERATORS_CONFIG_KEY: () => DEFAULT_GROUP_GENERATORS_CONFIG_KEY,
  DEFAULT_GROUP_NAME: () => DEFAULT_GROUP_NAME,
  GenerationLanguage: () => GenerationLanguage,
  GithubCommitAndReleaseMode: () => GithubCommitAndReleaseMode,
  GithubLicenseType: () => GithubLicenseType,
  MessageNamingSettingsSchema: () => MessageNamingSettingsSchema,
  OPENAPI_LOCATION_KEY: () => OPENAPI_LOCATION_KEY,
  OPENAPI_OVERRIDES_LOCATION_KEY: () => OPENAPI_OVERRIDES_LOCATION_KEY,
  UnionSettingsSchema: () => UnionSettingsSchema,
  fernDefinition: () => fernDefinition_exports,
  generators: () => generators_exports,
  getPackageName: () => getPackageName,
  group: () => group_exports,
  isApiConfigurationV2Schema: () => isApiConfigurationV2Schema,
  isAsyncAPISchema: () => isAsyncAPISchema,
  isConjureSchema: () => isConjureSchema,
  isNamespacedApiConfiguration: () => isNamespacedApiConfiguration,
  isOpenAPISchema: () => isOpenAPISchema,
  isRawProtobufAPIDefinitionSchema: () => isRawProtobufAPIDefinitionSchema,
  license: () => license_exports,
  reviewers: () => reviewers_exports,
  serialization: () => serialization_exports
});

// ../../cli/configuration/lib/generators-yml/utils/isApiConfigurationV2Schema.js
function isApiConfigurationV2Schema(api) {
  return api?.specs != null;
}

// ../../cli/configuration/lib/generators-yml/utils/isAsyncAPISpecSchema.js
function isAsyncAPISchema(spec) {
  return spec?.asyncapi != null;
}

// ../../cli/configuration/lib/generators-yml/utils/isOpenAPISpecSchema.js
function isOpenAPISchema(spec) {
  return spec?.openapi != null;
}

// ../../cli/configuration/lib/generators-yml/utils/isConjureSchema.js
function isConjureSchema(specs) {
  return specs?.conjure != null;
}

// ../../cli/configuration/lib/generators-yml/utils/isNamespacedApiConfiguration.js
function isNamespacedApiConfiguration(api) {
  return api?.namespaces != null;
}

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/generators/index.js
var generators_exports = {};
__export(generators_exports, {
  MessageNamingSettingsSchema: () => MessageNamingSettingsSchema,
  UnionSettingsSchema: () => UnionSettingsSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/generators/types/UnionSettingsSchema.js
var UnionSettingsSchema = {
  V1: "v1"
};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/generators/types/MessageNamingSettingsSchema.js
var MessageNamingSettingsSchema = {
  V1: "v1",
  V2: "v2"
};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/group/index.js
var group_exports = {};
__export(group_exports, {
  GithubCommitAndReleaseMode: () => GithubCommitAndReleaseMode
});

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/group/types/GithubCommitAndReleaseMode.js
var GithubCommitAndReleaseMode = {
  Commit: "commit",
  Release: "release"
};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/license/index.js
var license_exports = {};
__export(license_exports, {
  GithubLicenseType: () => GithubLicenseType
});

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/license/types/GithubLicenseType.js
var GithubLicenseType = {
  Mit: "MIT",
  Apache: "Apache-2.0"
};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/reviewers/index.js
var reviewers_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/index.js
var fernDefinition_exports = {};
__export(fernDefinition_exports, {
  AvailabilityStatusSchema: () => AvailabilityStatusSchema,
  auth: () => auth_exports,
  availability: () => availability_exports,
  commons: () => commons_exports,
  encoding: () => encoding_exports,
  environments: () => environments_exports,
  file: () => file_exports,
  service: () => service_exports,
  types: () => types_exports,
  validation: () => validation_exports
});

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/auth/index.js
var auth_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/availability/index.js
var availability_exports = {};
__export(availability_exports, {
  AvailabilityStatusSchema: () => AvailabilityStatusSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/availability/types/AvailabilityStatusSchema.js
var AvailabilityStatusSchema = {
  InDevelopment: "in-development",
  PreRelease: "pre-release",
  Deprecated: "deprecated",
  GenerallyAvailable: "generally-available"
};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/commons/index.js
var commons_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/encoding/index.js
var encoding_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/environments/index.js
var environments_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/file/index.js
var file_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/service/index.js
var service_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/types/index.js
var types_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/api/resources/fernDefinition/resources/validation/index.js
var validation_exports = {};

// ../../cli/configuration/lib/generators-yml/schemas/serialization/index.js
var serialization_exports = {};
__export(serialization_exports, {
  ApiConfigurationSchema: () => ApiConfigurationSchema,
  ApiConfigurationSchemaInternal: () => ApiConfigurationSchemaInternal,
  ApiConfigurationV2Schema: () => ApiConfigurationV2Schema,
  ApiConfigurationV2SpecsSchema: () => ApiConfigurationV2SpecsSchema,
  ApiDefinitionList: () => ApiDefinitionList,
  ApiDefinitionPathSchema: () => ApiDefinitionPathSchema,
  ApiDefinitionSchema: () => ApiDefinitionSchema,
  ApiDefinitionSettingsSchema: () => ApiDefinitionSettingsSchema,
  ApiDefinitionWithOverridesSchema: () => ApiDefinitionWithOverridesSchema,
  AsyncApiOrOpenApiSpecSchema: () => AsyncApiOrOpenApiSpecSchema,
  AsyncApiSchema: () => AsyncApiSchema,
  AsyncApiSettingsSchema: () => AsyncApiSettingsSchema,
  ConjureSchema: () => ConjureSchema,
  GeneratorApiSettingsSchema: () => GeneratorApiSettingsSchema,
  GeneratorGroupSchema: () => GeneratorGroupSchema,
  GeneratorInvocationSchema: () => GeneratorInvocationSchema,
  GeneratorOutputSchema: () => GeneratorOutputSchema,
  GeneratorPublishMetadataSchema: () => GeneratorPublishMetadataSchema,
  GeneratorSnippetsSchema: () => GeneratorSnippetsSchema,
  GeneratorsConfigurationSchema: () => GeneratorsConfigurationSchema,
  GeneratorsOpenApiObjectSchema: () => GeneratorsOpenApiObjectSchema,
  GeneratorsOpenApiSchema: () => GeneratorsOpenApiSchema,
  GithubCommitAndReleaseMode: () => GithubCommitAndReleaseMode2,
  GithubCommitAndReleaseSchema: () => GithubCommitAndReleaseSchema,
  GithubConfigurationSchema: () => GithubConfigurationSchema,
  GithubLicenseCustomSchema: () => GithubLicenseCustomSchema,
  GithubLicenseSchema: () => GithubLicenseSchema,
  GithubLicenseType: () => GithubLicenseType2,
  GithubPullRequestSchema: () => GithubPullRequestSchema,
  GithubPushSchema: () => GithubPushSchema,
  LocalFileSystemOutputLocationSchema: () => LocalFileSystemOutputLocationSchema,
  MavenOutputLocationSchema: () => MavenOutputLocationSchema,
  MavenOutputSignatureSchema: () => MavenOutputSignatureSchema,
  MessageNamingSettingsSchema: () => MessageNamingSettingsSchema2,
  NamespacedApiConfigurationSchema: () => NamespacedApiConfigurationSchema,
  NpmOutputLocationSchema: () => NpmOutputLocationSchema,
  NugetOutputLocationSchema: () => NugetOutputLocationSchema,
  OpenApiSettingsSchema: () => OpenApiSettingsSchema,
  OpenApiSpecSchema: () => OpenApiSpecSchema,
  OutputMetadataAuthor: () => OutputMetadataAuthor,
  OutputMetadataSchema: () => OutputMetadataSchema,
  PostmanOutputLocationSchema: () => PostmanOutputLocationSchema,
  ProtobufApiDefinitionSchema: () => ProtobufApiDefinitionSchema,
  ProtobufDefinitionSchema: () => ProtobufDefinitionSchema,
  PypiOutputLocationSchema: () => PypiOutputLocationSchema,
  PypiOutputMetadataSchema: () => PypiOutputMetadataSchema,
  ReadmeEndpointObjectSchema: () => ReadmeEndpointObjectSchema,
  ReadmeEndpointSchema: () => ReadmeEndpointSchema,
  ReadmeSchema: () => ReadmeSchema,
  ReviewerSchema: () => ReviewerSchema,
  ReviewersSchema: () => ReviewersSchema,
  RubyGemsOutputLocationSchema: () => RubyGemsOutputLocationSchema,
  UnionSettingsSchema: () => UnionSettingsSchema2,
  WhitelabelConfigurationSchema: () => WhitelabelConfigurationSchema,
  WhitelabelGithubConfigurationSchema: () => WhitelabelGithubConfigurationSchema,
  fernDefinition: () => fernDefinition_exports2,
  generators: () => generators_exports2,
  group: () => group_exports2,
  license: () => license_exports2,
  reviewers: () => reviewers_exports2
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/index.js
var generators_exports2 = {};
__export(generators_exports2, {
  ApiConfigurationSchema: () => ApiConfigurationSchema,
  ApiConfigurationSchemaInternal: () => ApiConfigurationSchemaInternal,
  ApiConfigurationV2Schema: () => ApiConfigurationV2Schema,
  ApiConfigurationV2SpecsSchema: () => ApiConfigurationV2SpecsSchema,
  ApiDefinitionList: () => ApiDefinitionList,
  ApiDefinitionPathSchema: () => ApiDefinitionPathSchema,
  ApiDefinitionSchema: () => ApiDefinitionSchema,
  ApiDefinitionSettingsSchema: () => ApiDefinitionSettingsSchema,
  ApiDefinitionWithOverridesSchema: () => ApiDefinitionWithOverridesSchema,
  AsyncApiOrOpenApiSpecSchema: () => AsyncApiOrOpenApiSpecSchema,
  AsyncApiSchema: () => AsyncApiSchema,
  AsyncApiSettingsSchema: () => AsyncApiSettingsSchema,
  ConjureSchema: () => ConjureSchema,
  GeneratorsConfigurationSchema: () => GeneratorsConfigurationSchema,
  GeneratorsOpenApiObjectSchema: () => GeneratorsOpenApiObjectSchema,
  GeneratorsOpenApiSchema: () => GeneratorsOpenApiSchema,
  MessageNamingSettingsSchema: () => MessageNamingSettingsSchema2,
  NamespacedApiConfigurationSchema: () => NamespacedApiConfigurationSchema,
  OpenApiSettingsSchema: () => OpenApiSettingsSchema,
  OpenApiSpecSchema: () => OpenApiSpecSchema,
  OutputMetadataAuthor: () => OutputMetadataAuthor,
  OutputMetadataSchema: () => OutputMetadataSchema,
  ProtobufApiDefinitionSchema: () => ProtobufApiDefinitionSchema,
  ProtobufDefinitionSchema: () => ProtobufDefinitionSchema,
  ReadmeEndpointObjectSchema: () => ReadmeEndpointObjectSchema,
  ReadmeEndpointSchema: () => ReadmeEndpointSchema,
  ReadmeSchema: () => ReadmeSchema,
  UnionSettingsSchema: () => UnionSettingsSchema2,
  WhitelabelConfigurationSchema: () => WhitelabelConfigurationSchema,
  WhitelabelGithubConfigurationSchema: () => WhitelabelGithubConfigurationSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/index.js
var schemas_exports = {};
__export(schemas_exports, {
  JsonError: () => JsonError,
  ParseError: () => ParseError,
  any: () => any,
  boolean: () => boolean,
  booleanLiteral: () => booleanLiteral,
  date: () => date,
  discriminant: () => discriminant,
  enum_: () => enum_,
  getObjectLikeUtils: () => getObjectLikeUtils,
  getObjectUtils: () => getObjectUtils,
  getSchemaUtils: () => getSchemaUtils,
  isProperty: () => isProperty,
  lazy: () => lazy,
  lazyObject: () => lazyObject,
  list: () => list,
  number: () => number,
  object: () => object,
  objectWithoutOptionalProperties: () => objectWithoutOptionalProperties,
  optional: () => optional,
  property: () => property2,
  record: () => record,
  set: () => set,
  string: () => string,
  stringLiteral: () => stringLiteral,
  transform: () => transform,
  undiscriminatedUnion: () => undiscriminatedUnion,
  union: () => union,
  unknown: () => unknown,
  withParsedProperties: () => withParsedProperties
});

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/Schema.js
var SchemaType = {
  DATE: "date",
  ENUM: "enum",
  LIST: "list",
  STRING_LITERAL: "stringLiteral",
  BOOLEAN_LITERAL: "booleanLiteral",
  OBJECT: "object",
  ANY: "any",
  BOOLEAN: "boolean",
  NUMBER: "number",
  STRING: "string",
  UNKNOWN: "unknown",
  RECORD: "record",
  SET: "set",
  UNION: "union",
  UNDISCRIMINATED_UNION: "undiscriminatedUnion",
  OPTIONAL: "optional"
};

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/getErrorMessageForIncorrectType.js
function getErrorMessageForIncorrectType(value, expectedType) {
  return `Expected ${expectedType}. Received ${getTypeAsString(value)}.`;
}
function getTypeAsString(value) {
  if (Array.isArray(value)) {
    return "list";
  }
  if (value === null) {
    return "null";
  }
  switch (typeof value) {
    case "string":
      return `"${value}"`;
    case "number":
    case "boolean":
    case "undefined":
      return `${value}`;
  }
  return typeof value;
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/maybeSkipValidation.js
function maybeSkipValidation(schema2) {
  return {
    ...schema2,
    json: transformAndMaybeSkipValidation(schema2.json),
    parse: transformAndMaybeSkipValidation(schema2.parse)
  };
}
function transformAndMaybeSkipValidation(transform3) {
  return (value, opts) => {
    const transformed = transform3(value, opts);
    const { skipValidation = false } = opts ?? {};
    if (!transformed.ok && skipValidation) {
      console.warn([
        "Failed to validate.",
        ...transformed.errors.map((error) => "  - " + (error.path.length > 0 ? `${error.path.join(".")}: ${error.message}` : error.message))
      ].join("\n"));
      return {
        ok: true,
        value
      };
    } else {
      return transformed;
    }
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/schema-utils/stringifyValidationErrors.js
function stringifyValidationError(error) {
  if (error.path.length === 0) {
    return error.message;
  }
  return `${error.path.join(" -> ")}: ${error.message}`;
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/schema-utils/JsonError.js
var JsonError = class _JsonError extends Error {
  errors;
  constructor(errors) {
    super(errors.map(stringifyValidationError).join("; "));
    this.errors = errors;
    Object.setPrototypeOf(this, _JsonError.prototype);
  }
};

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/schema-utils/ParseError.js
var ParseError = class _ParseError extends Error {
  errors;
  constructor(errors) {
    super(errors.map(stringifyValidationError).join("; "));
    this.errors = errors;
    Object.setPrototypeOf(this, _ParseError.prototype);
  }
};

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/schema-utils/getSchemaUtils.js
function getSchemaUtils(schema2) {
  return {
    optional: () => optional(schema2),
    transform: (transformer) => transform(schema2, transformer),
    parseOrThrow: (raw, opts) => {
      const parsed = schema2.parse(raw, opts);
      if (parsed.ok) {
        return parsed.value;
      }
      throw new ParseError(parsed.errors);
    },
    jsonOrThrow: (parsed, opts) => {
      const raw = schema2.json(parsed, opts);
      if (raw.ok) {
        return raw.value;
      }
      throw new JsonError(raw.errors);
    }
  };
}
function optional(schema2) {
  const baseSchema = {
    parse: (raw, opts) => {
      if (raw == null) {
        return {
          ok: true,
          value: void 0
        };
      }
      return schema2.parse(raw, opts);
    },
    json: (parsed, opts) => {
      if (opts?.omitUndefined && parsed === void 0) {
        return {
          ok: true,
          value: void 0
        };
      }
      if (parsed == null) {
        return {
          ok: true,
          value: null
        };
      }
      return schema2.json(parsed, opts);
    },
    getType: () => SchemaType.OPTIONAL
  };
  return {
    ...baseSchema,
    ...getSchemaUtils(baseSchema)
  };
}
function transform(schema2, transformer) {
  const baseSchema = {
    parse: (raw, opts) => {
      const parsed = schema2.parse(raw, opts);
      if (!parsed.ok) {
        return parsed;
      }
      return {
        ok: true,
        value: transformer.transform(parsed.value)
      };
    },
    json: (transformed, opts) => {
      const parsed = transformer.untransform(transformed);
      return schema2.json(parsed, opts);
    },
    getType: () => schema2.getType()
  };
  return {
    ...baseSchema,
    ...getSchemaUtils(baseSchema)
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/date/date.js
var ISO_8601_REGEX = /^([+-]?\d{4}(?!\d{2}\b))((-?)((0[1-9]|1[0-2])(\3([12]\d|0[1-9]|3[01]))?|W([0-4]\d|5[0-2])(-?[1-7])?|(00[1-9]|0[1-9]\d|[12]\d{2}|3([0-5]\d|6[1-6])))([T\s]((([01]\d|2[0-3])((:?)[0-5]\d)?|24:?00)([.,]\d+(?!:))?)?(\17[0-5]\d([.,]\d+)?)?([zZ]|([+-])([01]\d|2[0-3]):?([0-5]\d)?)?)?)?$/;
function date() {
  const baseSchema = {
    parse: (raw, { breadcrumbsPrefix = [] } = {}) => {
      if (typeof raw !== "string") {
        return {
          ok: false,
          errors: [
            {
              path: breadcrumbsPrefix,
              message: getErrorMessageForIncorrectType(raw, "string")
            }
          ]
        };
      }
      if (!ISO_8601_REGEX.test(raw)) {
        return {
          ok: false,
          errors: [
            {
              path: breadcrumbsPrefix,
              message: getErrorMessageForIncorrectType(raw, "ISO 8601 date string")
            }
          ]
        };
      }
      return {
        ok: true,
        value: new Date(raw)
      };
    },
    json: (date3, { breadcrumbsPrefix = [] } = {}) => {
      if (date3 instanceof Date) {
        return {
          ok: true,
          value: date3.toISOString()
        };
      } else {
        return {
          ok: false,
          errors: [
            {
              path: breadcrumbsPrefix,
              message: getErrorMessageForIncorrectType(date3, "Date object")
            }
          ]
        };
      }
    },
    getType: () => SchemaType.DATE
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema)
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/createIdentitySchemaCreator.js
function createIdentitySchemaCreator(schemaType, validate) {
  return () => {
    const baseSchema = {
      parse: validate,
      json: validate,
      getType: () => schemaType
    };
    return {
      ...maybeSkipValidation(baseSchema),
      ...getSchemaUtils(baseSchema)
    };
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/enum/enum.js
function enum_(values) {
  const validValues = new Set(values);
  const schemaCreator = createIdentitySchemaCreator(SchemaType.ENUM, (value, { allowUnrecognizedEnumValues, breadcrumbsPrefix = [] } = {}) => {
    if (typeof value !== "string") {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType(value, "string")
          }
        ]
      };
    }
    if (!validValues.has(value) && !allowUnrecognizedEnumValues) {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType(value, "enum")
          }
        ]
      };
    }
    return {
      ok: true,
      value
    };
  });
  return schemaCreator();
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/lazy/lazy.js
function lazy(getter) {
  const baseSchema = constructLazyBaseSchema(getter);
  return {
    ...baseSchema,
    ...getSchemaUtils(baseSchema)
  };
}
function constructLazyBaseSchema(getter) {
  return {
    parse: (raw, opts) => getMemoizedSchema(getter).parse(raw, opts),
    json: (parsed, opts) => getMemoizedSchema(getter).json(parsed, opts),
    getType: () => getMemoizedSchema(getter).getType()
  };
}
function getMemoizedSchema(getter) {
  const castedGetter = getter;
  if (castedGetter.__zurg_memoized == null) {
    castedGetter.__zurg_memoized = getter();
  }
  return castedGetter.__zurg_memoized;
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/entries.js
function entries2(object3) {
  return Object.entries(object3);
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/filterObject.js
function filterObject(obj, keysToInclude) {
  const keysToIncludeSet = new Set(keysToInclude);
  return Object.entries(obj).reduce((acc, [key, value]) => {
    if (keysToIncludeSet.has(key)) {
      acc[key] = value;
    }
    return acc;
  }, {});
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/isPlainObject.js
function isPlainObject3(value) {
  if (typeof value !== "object" || value === null) {
    return false;
  }
  if (Object.getPrototypeOf(value) === null) {
    return true;
  }
  let proto = value;
  while (Object.getPrototypeOf(proto) !== null) {
    proto = Object.getPrototypeOf(proto);
  }
  return Object.getPrototypeOf(value) === proto;
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/keys.js
function keys3(object3) {
  return Object.keys(object3);
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/utils/partition.js
function partition(items, predicate) {
  const trueItems = [], falseItems = [];
  for (const item of items) {
    if (predicate(item)) {
      trueItems.push(item);
    } else {
      falseItems.push(item);
    }
  }
  return [trueItems, falseItems];
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/object-like/getObjectLikeUtils.js
function getObjectLikeUtils(schema2) {
  return {
    withParsedProperties: (properties) => withParsedProperties(schema2, properties)
  };
}
function withParsedProperties(objectLike, properties) {
  const objectSchema = {
    parse: (raw, opts) => {
      const parsedObject = objectLike.parse(raw, opts);
      if (!parsedObject.ok) {
        return parsedObject;
      }
      const additionalProperties = Object.entries(properties).reduce((processed, [key, value]) => {
        return {
          ...processed,
          [key]: typeof value === "function" ? value(parsedObject.value) : value
        };
      }, {});
      return {
        ok: true,
        value: {
          ...parsedObject.value,
          ...additionalProperties
        }
      };
    },
    json: (parsed, opts) => {
      if (!isPlainObject3(parsed)) {
        return {
          ok: false,
          errors: [
            {
              path: opts?.breadcrumbsPrefix ?? [],
              message: getErrorMessageForIncorrectType(parsed, "object")
            }
          ]
        };
      }
      const addedPropertyKeys = new Set(Object.keys(properties));
      const parsedWithoutAddedProperties = filterObject(parsed, Object.keys(parsed).filter((key) => !addedPropertyKeys.has(key)));
      return objectLike.json(parsedWithoutAddedProperties, opts);
    },
    getType: () => objectLike.getType()
  };
  return {
    ...objectSchema,
    ...getSchemaUtils(objectSchema),
    ...getObjectLikeUtils(objectSchema)
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/object/property.js
function property2(rawKey, valueSchema) {
  return {
    rawKey,
    valueSchema,
    isProperty: true
  };
}
function isProperty(maybeProperty) {
  return maybeProperty.isProperty;
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/object/object.js
function object(schemas) {
  const baseSchema = {
    _getRawProperties: () => Object.entries(schemas).map(([parsedKey, propertySchema]) => isProperty(propertySchema) ? propertySchema.rawKey : parsedKey),
    _getParsedProperties: () => keys3(schemas),
    parse: (raw, opts) => {
      const rawKeyToProperty = {};
      const requiredKeys = [];
      for (const [parsedKey, schemaOrObjectProperty] of entries2(schemas)) {
        const rawKey = isProperty(schemaOrObjectProperty) ? schemaOrObjectProperty.rawKey : parsedKey;
        const valueSchema = isProperty(schemaOrObjectProperty) ? schemaOrObjectProperty.valueSchema : schemaOrObjectProperty;
        const property4 = {
          rawKey,
          parsedKey,
          valueSchema
        };
        rawKeyToProperty[rawKey] = property4;
        if (isSchemaRequired(valueSchema)) {
          requiredKeys.push(rawKey);
        }
      }
      return validateAndTransformObject({
        value: raw,
        requiredKeys,
        getProperty: (rawKey) => {
          const property4 = rawKeyToProperty[rawKey];
          if (property4 == null) {
            return void 0;
          }
          return {
            transformedKey: property4.parsedKey,
            transform: (propertyValue) => property4.valueSchema.parse(propertyValue, {
              ...opts,
              breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], rawKey]
            })
          };
        },
        unrecognizedObjectKeys: opts?.unrecognizedObjectKeys,
        skipValidation: opts?.skipValidation,
        breadcrumbsPrefix: opts?.breadcrumbsPrefix,
        omitUndefined: opts?.omitUndefined
      });
    },
    json: (parsed, opts) => {
      const requiredKeys = [];
      for (const [parsedKey, schemaOrObjectProperty] of entries2(schemas)) {
        const valueSchema = isProperty(schemaOrObjectProperty) ? schemaOrObjectProperty.valueSchema : schemaOrObjectProperty;
        if (isSchemaRequired(valueSchema)) {
          requiredKeys.push(parsedKey);
        }
      }
      return validateAndTransformObject({
        value: parsed,
        requiredKeys,
        getProperty: (parsedKey) => {
          const property4 = schemas[parsedKey];
          if (property4 == null) {
            return void 0;
          }
          if (isProperty(property4)) {
            return {
              transformedKey: property4.rawKey,
              transform: (propertyValue) => property4.valueSchema.json(propertyValue, {
                ...opts,
                breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], parsedKey]
              })
            };
          } else {
            return {
              transformedKey: parsedKey,
              transform: (propertyValue) => property4.json(propertyValue, {
                ...opts,
                breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], parsedKey]
              })
            };
          }
        },
        unrecognizedObjectKeys: opts?.unrecognizedObjectKeys,
        skipValidation: opts?.skipValidation,
        breadcrumbsPrefix: opts?.breadcrumbsPrefix,
        omitUndefined: opts?.omitUndefined
      });
    },
    getType: () => SchemaType.OBJECT
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema),
    ...getObjectLikeUtils(baseSchema),
    ...getObjectUtils(baseSchema)
  };
}
function validateAndTransformObject({ value, requiredKeys, getProperty: getProperty2, unrecognizedObjectKeys = "fail", skipValidation = false, breadcrumbsPrefix = [] }) {
  if (!isPlainObject3(value)) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType(value, "object")
        }
      ]
    };
  }
  const missingRequiredKeys = new Set(requiredKeys);
  const errors = [];
  const transformed = {};
  for (const [preTransformedKey, preTransformedItemValue] of Object.entries(value)) {
    const property4 = getProperty2(preTransformedKey);
    if (property4 != null) {
      missingRequiredKeys.delete(preTransformedKey);
      const value2 = property4.transform(preTransformedItemValue);
      if (value2.ok) {
        transformed[property4.transformedKey] = value2.value;
      } else {
        transformed[preTransformedKey] = preTransformedItemValue;
        errors.push(...value2.errors);
      }
    } else {
      switch (unrecognizedObjectKeys) {
        case "fail":
          errors.push({
            path: [...breadcrumbsPrefix, preTransformedKey],
            message: `Unexpected key "${preTransformedKey}"`
          });
          break;
        case "strip":
          break;
        case "passthrough":
          transformed[preTransformedKey] = preTransformedItemValue;
          break;
      }
    }
  }
  errors.push(...requiredKeys.filter((key) => missingRequiredKeys.has(key)).map((key) => ({
    path: breadcrumbsPrefix,
    message: `Missing required key "${key}"`
  })));
  if (errors.length === 0 || skipValidation) {
    return {
      ok: true,
      value: transformed
    };
  } else {
    return {
      ok: false,
      errors
    };
  }
}
function getObjectUtils(schema2) {
  return {
    extend: (extension) => {
      const baseSchema = {
        _getParsedProperties: () => [...schema2._getParsedProperties(), ...extension._getParsedProperties()],
        _getRawProperties: () => [...schema2._getRawProperties(), ...extension._getRawProperties()],
        parse: (raw, opts) => {
          return validateAndTransformExtendedObject({
            extensionKeys: extension._getRawProperties(),
            value: raw,
            transformBase: (rawBase) => schema2.parse(rawBase, opts),
            transformExtension: (rawExtension) => extension.parse(rawExtension, opts)
          });
        },
        json: (parsed, opts) => {
          return validateAndTransformExtendedObject({
            extensionKeys: extension._getParsedProperties(),
            value: parsed,
            transformBase: (parsedBase) => schema2.json(parsedBase, opts),
            transformExtension: (parsedExtension) => extension.json(parsedExtension, opts)
          });
        },
        getType: () => SchemaType.OBJECT
      };
      return {
        ...baseSchema,
        ...getSchemaUtils(baseSchema),
        ...getObjectLikeUtils(baseSchema),
        ...getObjectUtils(baseSchema)
      };
    }
  };
}
function validateAndTransformExtendedObject({ extensionKeys, value, transformBase, transformExtension }) {
  const extensionPropertiesSet = new Set(extensionKeys);
  const [extensionProperties, baseProperties] = partition(keys3(value), (key) => extensionPropertiesSet.has(key));
  const transformedBase = transformBase(filterObject(value, baseProperties));
  const transformedExtension = transformExtension(filterObject(value, extensionProperties));
  if (transformedBase.ok && transformedExtension.ok) {
    return {
      ok: true,
      value: {
        ...transformedBase.value,
        ...transformedExtension.value
      }
    };
  } else {
    return {
      ok: false,
      errors: [
        ...transformedBase.ok ? [] : transformedBase.errors,
        ...transformedExtension.ok ? [] : transformedExtension.errors
      ]
    };
  }
}
function isSchemaRequired(schema2) {
  return !isSchemaOptional(schema2);
}
function isSchemaOptional(schema2) {
  switch (schema2.getType()) {
    case SchemaType.ANY:
    case SchemaType.UNKNOWN:
    case SchemaType.OPTIONAL:
      return true;
    default:
      return false;
  }
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/object/objectWithoutOptionalProperties.js
function objectWithoutOptionalProperties(schemas) {
  return object(schemas);
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/lazy/lazyObject.js
function lazyObject(getter) {
  const baseSchema = {
    ...constructLazyBaseSchema(getter),
    _getRawProperties: () => getMemoizedSchema(getter)._getRawProperties(),
    _getParsedProperties: () => getMemoizedSchema(getter)._getParsedProperties()
  };
  return {
    ...baseSchema,
    ...getSchemaUtils(baseSchema),
    ...getObjectLikeUtils(baseSchema),
    ...getObjectUtils(baseSchema)
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/list/list.js
function list(schema2) {
  const baseSchema = {
    parse: (raw, opts) => validateAndTransformArray(raw, (item, index) => schema2.parse(item, {
      ...opts,
      breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `[${index}]`]
    })),
    json: (parsed, opts) => validateAndTransformArray(parsed, (item, index) => schema2.json(item, {
      ...opts,
      breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `[${index}]`]
    })),
    getType: () => SchemaType.LIST
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema)
  };
}
function validateAndTransformArray(value, transformItem) {
  if (!Array.isArray(value)) {
    return {
      ok: false,
      errors: [
        {
          message: getErrorMessageForIncorrectType(value, "list"),
          path: []
        }
      ]
    };
  }
  const maybeValidItems = value.map((item, index) => transformItem(item, index));
  return maybeValidItems.reduce((acc, item) => {
    if (acc.ok && item.ok) {
      return {
        ok: true,
        value: [...acc.value, item.value]
      };
    }
    const errors = [];
    if (!acc.ok) {
      errors.push(...acc.errors);
    }
    if (!item.ok) {
      errors.push(...item.errors);
    }
    return {
      ok: false,
      errors
    };
  }, { ok: true, value: [] });
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/literals/stringLiteral.js
function stringLiteral(literal) {
  const schemaCreator = createIdentitySchemaCreator(SchemaType.STRING_LITERAL, (value, { breadcrumbsPrefix = [] } = {}) => {
    if (value === literal) {
      return {
        ok: true,
        value: literal
      };
    } else {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType(value, `"${literal}"`)
          }
        ]
      };
    }
  });
  return schemaCreator();
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/literals/booleanLiteral.js
function booleanLiteral(literal) {
  const schemaCreator = createIdentitySchemaCreator(SchemaType.BOOLEAN_LITERAL, (value, { breadcrumbsPrefix = [] } = {}) => {
    if (value === literal) {
      return {
        ok: true,
        value: literal
      };
    } else {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType(value, `${literal.toString()}`)
          }
        ]
      };
    }
  });
  return schemaCreator();
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/primitives/any.js
var any = createIdentitySchemaCreator(SchemaType.ANY, (value) => ({ ok: true, value }));

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/primitives/boolean.js
var boolean = createIdentitySchemaCreator(SchemaType.BOOLEAN, (value, { breadcrumbsPrefix = [] } = {}) => {
  if (typeof value === "boolean") {
    return {
      ok: true,
      value
    };
  } else {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType(value, "boolean")
        }
      ]
    };
  }
});

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/primitives/number.js
var number = createIdentitySchemaCreator(SchemaType.NUMBER, (value, { breadcrumbsPrefix = [] } = {}) => {
  if (typeof value === "number") {
    return {
      ok: true,
      value
    };
  } else {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType(value, "number")
        }
      ]
    };
  }
});

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/primitives/string.js
var string = createIdentitySchemaCreator(SchemaType.STRING, (value, { breadcrumbsPrefix = [] } = {}) => {
  if (typeof value === "string") {
    return {
      ok: true,
      value
    };
  } else {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType(value, "string")
        }
      ]
    };
  }
});

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/primitives/unknown.js
var unknown = createIdentitySchemaCreator(SchemaType.UNKNOWN, (value) => ({ ok: true, value }));

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/record/record.js
function record(keySchema, valueSchema) {
  const baseSchema = {
    parse: (raw, opts) => {
      return validateAndTransformRecord({
        value: raw,
        isKeyNumeric: keySchema.getType() === SchemaType.NUMBER,
        transformKey: (key) => keySchema.parse(key, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key} (key)`]
        }),
        transformValue: (value, key) => valueSchema.parse(value, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key}`]
        }),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    json: (parsed, opts) => {
      return validateAndTransformRecord({
        value: parsed,
        isKeyNumeric: keySchema.getType() === SchemaType.NUMBER,
        transformKey: (key) => keySchema.json(key, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key} (key)`]
        }),
        transformValue: (value, key) => valueSchema.json(value, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key}`]
        }),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    getType: () => SchemaType.RECORD
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema)
  };
}
function validateAndTransformRecord({ value, isKeyNumeric, transformKey, transformValue, breadcrumbsPrefix = [] }) {
  if (!isPlainObject3(value)) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType(value, "object")
        }
      ]
    };
  }
  return entries2(value).reduce((accPromise, [stringKey, value2]) => {
    if (value2 == null) {
      return accPromise;
    }
    const acc = accPromise;
    let key = stringKey;
    if (isKeyNumeric) {
      const numberKey = stringKey.length > 0 ? Number(stringKey) : NaN;
      if (!isNaN(numberKey)) {
        key = numberKey;
      }
    }
    const transformedKey = transformKey(key);
    const transformedValue = transformValue(value2, key);
    if (acc.ok && transformedKey.ok && transformedValue.ok) {
      return {
        ok: true,
        value: {
          ...acc.value,
          [transformedKey.value]: transformedValue.value
        }
      };
    }
    const errors = [];
    if (!acc.ok) {
      errors.push(...acc.errors);
    }
    if (!transformedKey.ok) {
      errors.push(...transformedKey.errors);
    }
    if (!transformedValue.ok) {
      errors.push(...transformedValue.errors);
    }
    return {
      ok: false,
      errors
    };
  }, { ok: true, value: {} });
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/set/set.js
function set(schema2) {
  const listSchema = list(schema2);
  const baseSchema = {
    parse: (raw, opts) => {
      const parsedList = listSchema.parse(raw, opts);
      if (parsedList.ok) {
        return {
          ok: true,
          value: new Set(parsedList.value)
        };
      } else {
        return parsedList;
      }
    },
    json: (parsed, opts) => {
      if (!(parsed instanceof Set)) {
        return {
          ok: false,
          errors: [
            {
              path: opts?.breadcrumbsPrefix ?? [],
              message: getErrorMessageForIncorrectType(parsed, "Set")
            }
          ]
        };
      }
      const jsonList = listSchema.json([...parsed], opts);
      return jsonList;
    },
    getType: () => SchemaType.SET
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema)
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/undiscriminated-union/undiscriminatedUnion.js
function undiscriminatedUnion(schemas) {
  const baseSchema = {
    parse: (raw, opts) => {
      return validateAndTransformUndiscriminatedUnion((schema2, opts2) => schema2.parse(raw, opts2), schemas, opts);
    },
    json: (parsed, opts) => {
      return validateAndTransformUndiscriminatedUnion((schema2, opts2) => schema2.json(parsed, opts2), schemas, opts);
    },
    getType: () => SchemaType.UNDISCRIMINATED_UNION
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema)
  };
}
function validateAndTransformUndiscriminatedUnion(transform3, schemas, opts) {
  const errors = [];
  for (const [index, schema2] of schemas.entries()) {
    const transformed = transform3(schema2, { ...opts, skipValidation: false });
    if (transformed.ok) {
      return transformed;
    } else {
      for (const error of transformed.errors) {
        errors.push({
          path: error.path,
          message: `[Variant ${index}] ${error.message}`
        });
      }
    }
  }
  return {
    ok: false,
    errors
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/union/discriminant.js
function discriminant(parsedDiscriminant, rawDiscriminant) {
  return {
    parsedDiscriminant,
    rawDiscriminant
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/core/schemas/builders/union/union.js
function union(discriminant3, union3) {
  const rawDiscriminant = typeof discriminant3 === "string" ? discriminant3 : discriminant3.rawDiscriminant;
  const parsedDiscriminant = typeof discriminant3 === "string" ? discriminant3 : discriminant3.parsedDiscriminant;
  const discriminantValueSchema = enum_(keys3(union3));
  const baseSchema = {
    parse: (raw, opts) => {
      return transformAndValidateUnion({
        value: raw,
        discriminant: rawDiscriminant,
        transformedDiscriminant: parsedDiscriminant,
        transformDiscriminantValue: (discriminantValue) => discriminantValueSchema.parse(discriminantValue, {
          allowUnrecognizedEnumValues: opts?.allowUnrecognizedUnionMembers,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], rawDiscriminant]
        }),
        getAdditionalPropertiesSchema: (discriminantValue) => union3[discriminantValue],
        allowUnrecognizedUnionMembers: opts?.allowUnrecognizedUnionMembers,
        transformAdditionalProperties: (additionalProperties, additionalPropertiesSchema) => additionalPropertiesSchema.parse(additionalProperties, opts),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    json: (parsed, opts) => {
      return transformAndValidateUnion({
        value: parsed,
        discriminant: parsedDiscriminant,
        transformedDiscriminant: rawDiscriminant,
        transformDiscriminantValue: (discriminantValue) => discriminantValueSchema.json(discriminantValue, {
          allowUnrecognizedEnumValues: opts?.allowUnrecognizedUnionMembers,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], parsedDiscriminant]
        }),
        getAdditionalPropertiesSchema: (discriminantValue) => union3[discriminantValue],
        allowUnrecognizedUnionMembers: opts?.allowUnrecognizedUnionMembers,
        transformAdditionalProperties: (additionalProperties, additionalPropertiesSchema) => additionalPropertiesSchema.json(additionalProperties, opts),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    getType: () => SchemaType.UNION
  };
  return {
    ...maybeSkipValidation(baseSchema),
    ...getSchemaUtils(baseSchema),
    ...getObjectLikeUtils(baseSchema)
  };
}
function transformAndValidateUnion({ value, discriminant: discriminant3, transformedDiscriminant, transformDiscriminantValue, getAdditionalPropertiesSchema, allowUnrecognizedUnionMembers = false, transformAdditionalProperties, breadcrumbsPrefix = [] }) {
  if (!isPlainObject3(value)) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType(value, "object")
        }
      ]
    };
  }
  const { [discriminant3]: discriminantValue, ...additionalProperties } = value;
  if (discriminantValue == null) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: `Missing discriminant ("${discriminant3}")`
        }
      ]
    };
  }
  const transformedDiscriminantValue = transformDiscriminantValue(discriminantValue);
  if (!transformedDiscriminantValue.ok) {
    return {
      ok: false,
      errors: transformedDiscriminantValue.errors
    };
  }
  const additionalPropertiesSchema = getAdditionalPropertiesSchema(transformedDiscriminantValue.value);
  if (additionalPropertiesSchema == null) {
    if (allowUnrecognizedUnionMembers) {
      return {
        ok: true,
        value: {
          [transformedDiscriminant]: transformedDiscriminantValue.value,
          ...additionalProperties
        }
      };
    } else {
      return {
        ok: false,
        errors: [
          {
            path: [...breadcrumbsPrefix, discriminant3],
            message: "Unexpected discriminant value"
          }
        ]
      };
    }
  }
  const transformedAdditionalProperties = transformAdditionalProperties(additionalProperties, additionalPropertiesSchema);
  if (!transformedAdditionalProperties.ok) {
    return transformedAdditionalProperties;
  }
  return {
    ok: true,
    value: {
      [transformedDiscriminant]: discriminantValue,
      ...transformedAdditionalProperties.value
    }
  };
}

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthAccessTokenRequestPropertiesSchema.js
var OAuthAccessTokenRequestPropertiesSchema = schemas_exports.object({
  "client-id": schemas_exports.string().optional(),
  "client-secret": schemas_exports.string().optional(),
  scopes: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthAccessTokenResponsePropertiesSchema.js
var OAuthAccessTokenResponsePropertiesSchema = schemas_exports.object({
  "access-token": schemas_exports.string().optional(),
  "expires-in": schemas_exports.string().optional(),
  "refresh-token": schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthGetTokenEndpointSchema.js
var OAuthGetTokenEndpointSchema = schemas_exports.object({
  endpoint: schemas_exports.string(),
  "request-properties": OAuthAccessTokenRequestPropertiesSchema.optional(),
  "response-properties": OAuthAccessTokenResponsePropertiesSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthRefreshTokenRequestPropertiesSchema.js
var OAuthRefreshTokenRequestPropertiesSchema = schemas_exports.object({
  "refresh-token": schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthRefreshTokenResponsePropertiesSchema.js
var OAuthRefreshTokenResponsePropertiesSchema = schemas_exports.object({
  "access-token": schemas_exports.string().optional(),
  "expires-in": schemas_exports.string().optional(),
  "refresh-token": schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthRefreshTokenEndpointSchema.js
var OAuthRefreshTokenEndpointSchema = schemas_exports.object({
  endpoint: schemas_exports.string(),
  "request-properties": OAuthRefreshTokenRequestPropertiesSchema.optional(),
  "response-properties": OAuthRefreshTokenResponsePropertiesSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/commons/types/WithDocsSchema.js
var WithDocsSchema = schemas_exports.object({
  docs: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/OAuthSchemeSchema.js
var OAuthSchemeSchema = schemas_exports.object({
  scheme: schemas_exports.stringLiteral("oauth"),
  type: schemas_exports.stringLiteral("client-credentials"),
  scopes: schemas_exports.list(schemas_exports.string()).optional(),
  "client-id-env": schemas_exports.string().optional(),
  "client-secret-env": schemas_exports.string().optional(),
  "token-prefix": schemas_exports.string().optional(),
  "token-header": schemas_exports.string().optional(),
  "get-token": OAuthGetTokenEndpointSchema,
  "refresh-token": OAuthRefreshTokenEndpointSchema.optional()
}).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/WithEnvironmentVariable.js
var WithEnvironmentVariable = schemas_exports.object({
  env: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/commons/types/WithName.js
var WithName = schemas_exports.object({
  name: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/HeaderAuthSchemeSchema.js
var HeaderAuthSchemeSchema = schemas_exports.object({
  header: schemas_exports.string(),
  type: schemas_exports.string().optional(),
  prefix: schemas_exports.string().optional()
}).extend(WithEnvironmentVariable).extend(WithName).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/AuthVariable.js
var AuthVariable = schemas_exports.object({}).extend(WithEnvironmentVariable).extend(WithName);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/BasicAuthSchemeSchema.js
var BasicAuthSchemeSchema = schemas_exports.object({
  scheme: schemas_exports.stringLiteral("basic"),
  username: AuthVariable.optional(),
  password: AuthVariable.optional()
}).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/BearerAuthSchemeSchema.js
var BearerAuthSchemeSchema = schemas_exports.object({
  scheme: schemas_exports.stringLiteral("bearer"),
  token: AuthVariable.optional()
}).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/AuthSchemeDeclarationSchema.js
var AuthSchemeDeclarationSchema = schemas_exports.undiscriminatedUnion([
  OAuthSchemeSchema,
  HeaderAuthSchemeSchema,
  BasicAuthSchemeSchema,
  BearerAuthSchemeSchema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiDefinitionPathSchema.js
var ApiDefinitionPathSchema = schemas_exports.string();

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/UnionSettingsSchema.js
var UnionSettingsSchema2 = schemas_exports.enum_(["v1"]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/MessageNamingSettingsSchema.js
var MessageNamingSettingsSchema2 = schemas_exports.enum_(["v1", "v2"]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiDefinitionSettingsSchema.js
var ApiDefinitionSettingsSchema = schemas_exports.object({
  "use-title": schemas_exports.boolean().optional(),
  unions: UnionSettingsSchema2.optional(),
  "message-naming": MessageNamingSettingsSchema2.optional(),
  "only-include-referenced-schemas": schemas_exports.boolean().optional(),
  "inline-path-parameters": schemas_exports.boolean().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiDefinitionWithOverridesSchema.js
var ApiDefinitionWithOverridesSchema = schemas_exports.object({
  path: ApiDefinitionPathSchema,
  origin: schemas_exports.string().optional(),
  overrides: schemas_exports.string().optional(),
  audiences: schemas_exports.list(schemas_exports.string()).optional(),
  settings: ApiDefinitionSettingsSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ProtobufDefinitionSchema.js
var ProtobufDefinitionSchema = schemas_exports.object({
  root: schemas_exports.string(),
  target: schemas_exports.string(),
  overrides: schemas_exports.string().optional(),
  "local-generation": schemas_exports.boolean().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ProtobufApiDefinitionSchema.js
var ProtobufApiDefinitionSchema = schemas_exports.object({
  proto: ProtobufDefinitionSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiDefinitionSchema.js
var ApiDefinitionSchema = schemas_exports.undiscriminatedUnion([
  ApiDefinitionPathSchema,
  ApiDefinitionWithOverridesSchema,
  ProtobufApiDefinitionSchema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiDefinitionList.js
var ApiDefinitionList = schemas_exports.list(ApiDefinitionSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiConfigurationSchemaInternal.js
var ApiConfigurationSchemaInternal = schemas_exports.undiscriminatedUnion([
  ApiDefinitionPathSchema,
  ApiDefinitionWithOverridesSchema,
  ApiDefinitionList,
  ProtobufApiDefinitionSchema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/NamespacedApiConfigurationSchema.js
var NamespacedApiConfigurationSchema = schemas_exports.object({
  namespaces: schemas_exports.record(schemas_exports.string(), ApiConfigurationSchemaInternal)
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/AuthSchemeReferenceSchema.js
var AuthSchemeReferenceSchema = schemas_exports.object({
  scheme: schemas_exports.string()
}).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/AnyAuthItem.js
var AnyAuthItem = schemas_exports.undiscriminatedUnion([schemas_exports.string(), AuthSchemeReferenceSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/AnyAuthSchemesSchema.js
var AnyAuthSchemesSchema = schemas_exports.object({
  any: schemas_exports.list(AnyAuthItem)
}).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/types/ApiAuthSchema.js
var ApiAuthSchema = schemas_exports.undiscriminatedUnion([
  schemas_exports.string(),
  AuthSchemeReferenceSchema,
  AnyAuthSchemesSchema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/OpenApiSettingsSchema.js
var OpenApiSettingsSchema = schemas_exports.object({
  "title-as-schema-name": schemas_exports.boolean().optional(),
  "optional-additional-properties": schemas_exports.boolean().optional(),
  "coerce-enums-to-literals": schemas_exports.boolean().optional(),
  "object-query-parameters": schemas_exports.boolean().optional(),
  "respect-readonly-schemas": schemas_exports.boolean().optional(),
  "only-include-referenced-schemas": schemas_exports.boolean().optional(),
  "inline-path-parameters": schemas_exports.boolean().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/OpenApiSpecSchema.js
var OpenApiSpecSchema = schemas_exports.object({
  openapi: schemas_exports.string(),
  origin: schemas_exports.string().optional(),
  overrides: schemas_exports.string().optional(),
  namespace: schemas_exports.string().optional(),
  settings: OpenApiSettingsSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/AsyncApiSettingsSchema.js
var AsyncApiSettingsSchema = schemas_exports.object({
  "title-as-schema-name": schemas_exports.boolean().optional(),
  "optional-additional-properties": schemas_exports.boolean().optional(),
  "coerce-enums-to-literals": schemas_exports.boolean().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/AsyncApiSchema.js
var AsyncApiSchema = schemas_exports.object({
  asyncapi: schemas_exports.string(),
  origin: schemas_exports.string().optional(),
  overrides: schemas_exports.string().optional(),
  namespace: schemas_exports.string().optional(),
  settings: AsyncApiSettingsSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/AsyncApiOrOpenApiSpecSchema.js
var AsyncApiOrOpenApiSpecSchema = schemas_exports.undiscriminatedUnion([OpenApiSpecSchema, AsyncApiSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ConjureSchema.js
var ConjureSchema = schemas_exports.object({
  conjure: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiConfigurationV2SpecsSchema.js
var ApiConfigurationV2SpecsSchema = schemas_exports.undiscriminatedUnion([schemas_exports.list(AsyncApiOrOpenApiSpecSchema), ConjureSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/encoding/types/ProtobufTypeSchema.js
var ProtobufTypeSchema = schemas_exports.object({
  type: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/encoding/types/EncodingSchema.js
var EncodingSchema = schemas_exports.object({
  proto: ProtobufTypeSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/validation/types/StringValidationSchema.js
var StringValidationSchema = schemas_exports.object({
  minLength: schemas_exports.number().optional(),
  maxLength: schemas_exports.number().optional(),
  pattern: schemas_exports.string().optional(),
  format: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/validation/types/NumberValidationSchema.js
var NumberValidationSchema = schemas_exports.object({
  min: schemas_exports.number().optional(),
  max: schemas_exports.number().optional(),
  exclusiveMin: schemas_exports.boolean().optional(),
  exclusiveMax: schemas_exports.boolean().optional(),
  multipleOf: schemas_exports.number().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/validation/types/ValidationSchema.js
var ValidationSchema = schemas_exports.undiscriminatedUnion([StringValidationSchema, NumberValidationSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/availability/types/AvailabilityStatusSchema.js
var AvailabilityStatusSchema2 = schemas_exports.enum_(["in-development", "pre-release", "deprecated", "generally-available"]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/availability/types/AvailabilitySchema.js
var AvailabilitySchema = schemas_exports.object({
  status: AvailabilityStatusSchema2,
  message: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/availability/types/AvailabilityUnionSchema.js
var AvailabilityUnionSchema = schemas_exports.undiscriminatedUnion([AvailabilityStatusSchema2, AvailabilitySchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/commons/types/WithAvailability.js
var WithAvailability = schemas_exports.object({
  availability: AvailabilityUnionSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/types/types/BaseTypeReferenceSchema.js
var BaseTypeReferenceSchema = schemas_exports.object({
  default: schemas_exports.unknown().optional(),
  encoding: EncodingSchema.optional(),
  validation: ValidationSchema.optional()
}).extend(WithDocsSchema).extend(WithAvailability);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/commons/types/WithAudiences.js
var WithAudiences = schemas_exports.object({
  audiences: schemas_exports.list(schemas_exports.string()).optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/types/types/TypeReferenceDeclarationWithName.js
var TypeReferenceDeclarationWithName = schemas_exports.object({
  type: schemas_exports.string()
}).extend(BaseTypeReferenceSchema).extend(WithName).extend(WithAudiences);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/service/types/TypeReferenceDeclarationWithEnvOverrideSchema.js
var TypeReferenceDeclarationWithEnvOverrideSchema = schemas_exports.object({
  env: schemas_exports.string().optional()
}).extend(TypeReferenceDeclarationWithName);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/service/types/TypeReferenceDeclarationWithEnvOverride.js
var TypeReferenceDeclarationWithEnvOverride = schemas_exports.undiscriminatedUnion([
  schemas_exports.string(),
  TypeReferenceDeclarationWithEnvOverrideSchema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/service/types/HttpHeaderSchema.js
var HttpHeaderSchema = TypeReferenceDeclarationWithEnvOverride;

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/file/types/WithHeadersSchema.js
var WithHeadersSchema = schemas_exports.object({
  headers: schemas_exports.record(schemas_exports.string(), HttpHeaderSchema).optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/environments/types/SingleBaseUrlEnvironmentSchema.js
var SingleBaseUrlEnvironmentSchema = schemas_exports.object({
  url: schemas_exports.string()
}).extend(WithAudiences).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/environments/types/MultipleBaseUrlsEnvironmentSchema.js
var MultipleBaseUrlsEnvironmentSchema = schemas_exports.object({
  urls: schemas_exports.record(schemas_exports.string(), schemas_exports.string())
}).extend(WithAudiences).extend(WithDocsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/environments/types/EnvironmentSchema.js
var EnvironmentSchema = schemas_exports.undiscriminatedUnion([
  schemas_exports.string(),
  SingleBaseUrlEnvironmentSchema,
  MultipleBaseUrlsEnvironmentSchema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/environments/types/WithEnvironmentsSchema.js
var WithEnvironmentsSchema = schemas_exports.object({
  "default-url": schemas_exports.string().optional(),
  "default-environment": schemas_exports.string().optional(),
  environments: schemas_exports.record(schemas_exports.string(), EnvironmentSchema).optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiConfigurationV2Schema.js
var ApiConfigurationV2Schema = schemas_exports.object({
  auth: ApiAuthSchema.optional(),
  specs: ApiConfigurationV2SpecsSchema
}).extend(WithHeadersSchema).extend(WithEnvironmentsSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ApiConfigurationSchema.js
var ApiConfigurationSchema = schemas_exports.undiscriminatedUnion([
  ApiConfigurationSchemaInternal,
  NamespacedApiConfigurationSchema,
  ApiConfigurationV2Schema
]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/WhitelabelGithubConfigurationSchema.js
var WhitelabelGithubConfigurationSchema = schemas_exports.object({
  username: schemas_exports.string(),
  email: schemas_exports.string(),
  token: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/WhitelabelConfigurationSchema.js
var WhitelabelConfigurationSchema = schemas_exports.object({
  github: WhitelabelGithubConfigurationSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/OutputMetadataAuthor.js
var OutputMetadataAuthor = schemas_exports.object({
  name: schemas_exports.string(),
  email: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/OutputMetadataSchema.js
var OutputMetadataSchema = schemas_exports.object({
  description: schemas_exports.string().optional(),
  authors: schemas_exports.list(OutputMetadataAuthor).optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ReadmeEndpointObjectSchema.js
var ReadmeEndpointObjectSchema = schemas_exports.object({
  method: schemas_exports.string(),
  path: schemas_exports.string(),
  stream: schemas_exports.boolean().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ReadmeEndpointSchema.js
var ReadmeEndpointSchema = schemas_exports.undiscriminatedUnion([schemas_exports.string(), ReadmeEndpointObjectSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/ReadmeSchema.js
var ReadmeSchema = schemas_exports.object({
  bannerLink: schemas_exports.string().optional(),
  introduction: schemas_exports.string().optional(),
  apiReferenceLink: schemas_exports.string().optional(),
  defaultEndpoint: ReadmeEndpointSchema.optional(),
  features: schemas_exports.record(schemas_exports.string(), schemas_exports.list(ReadmeEndpointSchema)).optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/NpmOutputLocationSchema.js
var NpmOutputLocationSchema = schemas_exports.object({
  url: schemas_exports.string().optional(),
  "package-name": schemas_exports.string(),
  token: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/MavenOutputSignatureSchema.js
var MavenOutputSignatureSchema = schemas_exports.object({
  keyId: schemas_exports.string(),
  password: schemas_exports.string(),
  secretKey: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/MavenOutputLocationSchema.js
var MavenOutputLocationSchema = schemas_exports.object({
  url: schemas_exports.string().optional(),
  coordinate: schemas_exports.string(),
  username: schemas_exports.string().optional(),
  password: schemas_exports.string().optional(),
  signature: MavenOutputSignatureSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/PypiOutputMetadataSchema.js
var PypiOutputMetadataSchema = schemas_exports.object({
  keywords: schemas_exports.list(schemas_exports.string()).optional(),
  "documentation-link": schemas_exports.string().optional(),
  "homepage-link": schemas_exports.string().optional()
}).extend(OutputMetadataSchema);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/PypiOutputLocationSchema.js
var PypiOutputLocationSchema = schemas_exports.object({
  url: schemas_exports.string().optional(),
  "package-name": schemas_exports.string(),
  token: schemas_exports.string().optional(),
  username: schemas_exports.string().optional(),
  password: schemas_exports.string().optional(),
  metadata: PypiOutputMetadataSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/PostmanOutputLocationSchema.js
var PostmanOutputLocationSchema = schemas_exports.object({
  "api-key": schemas_exports.string(),
  "workspace-id": schemas_exports.string(),
  "collection-id": schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/LocalFileSystemOutputLocationSchema.js
var LocalFileSystemOutputLocationSchema = schemas_exports.object({
  path: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/NugetOutputLocationSchema.js
var NugetOutputLocationSchema = schemas_exports.object({
  url: schemas_exports.string().optional(),
  "package-name": schemas_exports.string(),
  "api-key": schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/RubyGemsOutputLocationSchema.js
var RubyGemsOutputLocationSchema = schemas_exports.object({
  url: schemas_exports.string().optional(),
  "package-name": schemas_exports.string(),
  "api-key": schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GeneratorOutputSchema.js
var GeneratorOutputSchema = schemas_exports.union("location", {
  npm: NpmOutputLocationSchema,
  maven: MavenOutputLocationSchema,
  pypi: PypiOutputLocationSchema,
  postman: PostmanOutputLocationSchema,
  "local-file-system": LocalFileSystemOutputLocationSchema,
  nuget: NugetOutputLocationSchema,
  rubygems: RubyGemsOutputLocationSchema
}).transform({
  transform: (value) => value,
  untransform: (value) => value
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/license/types/GithubLicenseType.js
var GithubLicenseType2 = schemas_exports.enum_(["MIT", "Apache-2.0"]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/license/types/GithubLicenseCustomSchema.js
var GithubLicenseCustomSchema = schemas_exports.object({
  custom: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/license/types/GithubLicenseSchema.js
var GithubLicenseSchema = schemas_exports.undiscriminatedUnion([GithubLicenseType2, GithubLicenseCustomSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GithubCommitAndReleaseMode.js
var GithubCommitAndReleaseMode2 = schemas_exports.enum_(["commit", "release"]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GithubCommitAndReleaseSchema.js
var GithubCommitAndReleaseSchema = schemas_exports.object({
  repository: schemas_exports.string(),
  license: GithubLicenseSchema.optional(),
  mode: GithubCommitAndReleaseMode2.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/reviewers/types/ReviewerSchema.js
var ReviewerSchema = schemas_exports.object({
  name: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/reviewers/types/ReviewersSchema.js
var ReviewersSchema = schemas_exports.object({
  teams: schemas_exports.list(ReviewerSchema).optional(),
  users: schemas_exports.list(ReviewerSchema).optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GithubPullRequestSchema.js
var GithubPullRequestSchema = schemas_exports.object({
  repository: schemas_exports.string(),
  branch: schemas_exports.string().optional(),
  license: GithubLicenseSchema.optional(),
  mode: schemas_exports.stringLiteral("pull-request"),
  reviewers: ReviewersSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GithubPushSchema.js
var GithubPushSchema = schemas_exports.object({
  repository: schemas_exports.string(),
  license: GithubLicenseSchema.optional(),
  mode: schemas_exports.stringLiteral("push"),
  branch: schemas_exports.string().optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GithubConfigurationSchema.js
var GithubConfigurationSchema = schemas_exports.undiscriminatedUnion([GithubCommitAndReleaseSchema, GithubPullRequestSchema, GithubPushSchema]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GeneratorPublishMetadataSchema.js
var GeneratorPublishMetadataSchema = schemas_exports.object({
  "package-description": schemas_exports.string().optional(),
  email: schemas_exports.string().optional(),
  "reference-url": schemas_exports.string().optional(),
  author: schemas_exports.string().optional(),
  license: GithubLicenseSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GeneratorSnippetsSchema.js
var GeneratorSnippetsSchema = schemas_exports.object({
  path: schemas_exports.string()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GeneratorApiSettingsSchema.js
var GeneratorApiSettingsSchema = schemas_exports.object({
  settings: ApiDefinitionSettingsSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GeneratorInvocationSchema.js
var GeneratorInvocationSchema = schemas_exports.object({
  name: schemas_exports.string(),
  version: schemas_exports.string(),
  output: GeneratorOutputSchema.optional(),
  github: GithubConfigurationSchema.optional(),
  config: schemas_exports.unknown(),
  metadata: GeneratorPublishMetadataSchema.optional(),
  keywords: schemas_exports.list(schemas_exports.string()).optional(),
  snippets: GeneratorSnippetsSchema.optional(),
  "ir-version": schemas_exports.string().optional(),
  "smart-casing": schemas_exports.boolean().optional(),
  api: GeneratorApiSettingsSchema.optional(),
  "disable-examples": schemas_exports.boolean().optional(),
  "publish-metadata": GeneratorPublishMetadataSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/types/GeneratorGroupSchema.js
var GeneratorGroupSchema = schemas_exports.object({
  audiences: schemas_exports.list(schemas_exports.string()).optional(),
  generators: schemas_exports.list(GeneratorInvocationSchema),
  metadata: OutputMetadataSchema.optional(),
  reviewers: ReviewersSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/GeneratorsOpenApiObjectSchema.js
var GeneratorsOpenApiObjectSchema = schemas_exports.object({
  path: schemas_exports.string(),
  origin: schemas_exports.string().optional(),
  overrides: schemas_exports.string().optional(),
  "disable-examples": schemas_exports.boolean().optional(),
  settings: ApiDefinitionSettingsSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/GeneratorsOpenApiSchema.js
var GeneratorsOpenApiSchema = schemas_exports.undiscriminatedUnion([GeneratorsOpenApiObjectSchema, schemas_exports.string()]);

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/generators/types/GeneratorsConfigurationSchema.js
var GeneratorsConfigurationSchema = schemas_exports.object({
  "auth-schemes": schemas_exports.record(schemas_exports.string(), AuthSchemeDeclarationSchema).optional(),
  api: ApiConfigurationSchema.optional(),
  whitelabel: WhitelabelConfigurationSchema.optional(),
  metadata: OutputMetadataSchema.optional(),
  readme: ReadmeSchema.optional(),
  "default-group": schemas_exports.string().optional(),
  groups: schemas_exports.record(schemas_exports.string(), GeneratorGroupSchema).optional(),
  reviewers: ReviewersSchema.optional(),
  openapi: GeneratorsOpenApiSchema.optional(),
  "openapi-overrides": schemas_exports.string().optional(),
  "spec-origin": schemas_exports.string().optional(),
  "async-api": schemas_exports.string().optional(),
  "api-settings": ApiDefinitionSettingsSchema.optional()
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/group/index.js
var group_exports2 = {};
__export(group_exports2, {
  GeneratorApiSettingsSchema: () => GeneratorApiSettingsSchema,
  GeneratorGroupSchema: () => GeneratorGroupSchema,
  GeneratorInvocationSchema: () => GeneratorInvocationSchema,
  GeneratorOutputSchema: () => GeneratorOutputSchema,
  GeneratorPublishMetadataSchema: () => GeneratorPublishMetadataSchema,
  GeneratorSnippetsSchema: () => GeneratorSnippetsSchema,
  GithubCommitAndReleaseMode: () => GithubCommitAndReleaseMode2,
  GithubCommitAndReleaseSchema: () => GithubCommitAndReleaseSchema,
  GithubConfigurationSchema: () => GithubConfigurationSchema,
  GithubPullRequestSchema: () => GithubPullRequestSchema,
  GithubPushSchema: () => GithubPushSchema,
  LocalFileSystemOutputLocationSchema: () => LocalFileSystemOutputLocationSchema,
  MavenOutputLocationSchema: () => MavenOutputLocationSchema,
  MavenOutputSignatureSchema: () => MavenOutputSignatureSchema,
  NpmOutputLocationSchema: () => NpmOutputLocationSchema,
  NugetOutputLocationSchema: () => NugetOutputLocationSchema,
  PostmanOutputLocationSchema: () => PostmanOutputLocationSchema,
  PypiOutputLocationSchema: () => PypiOutputLocationSchema,
  PypiOutputMetadataSchema: () => PypiOutputMetadataSchema,
  RubyGemsOutputLocationSchema: () => RubyGemsOutputLocationSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/license/index.js
var license_exports2 = {};
__export(license_exports2, {
  GithubLicenseCustomSchema: () => GithubLicenseCustomSchema,
  GithubLicenseSchema: () => GithubLicenseSchema,
  GithubLicenseType: () => GithubLicenseType2
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/reviewers/index.js
var reviewers_exports2 = {};
__export(reviewers_exports2, {
  ReviewerSchema: () => ReviewerSchema,
  ReviewersSchema: () => ReviewersSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/index.js
var fernDefinition_exports2 = {};
__export(fernDefinition_exports2, {
  AnyAuthItem: () => AnyAuthItem,
  AnyAuthSchemesSchema: () => AnyAuthSchemesSchema,
  ApiAuthSchema: () => ApiAuthSchema,
  AuthSchemeDeclarationSchema: () => AuthSchemeDeclarationSchema,
  AuthSchemeReferenceSchema: () => AuthSchemeReferenceSchema,
  AuthVariable: () => AuthVariable,
  AvailabilitySchema: () => AvailabilitySchema,
  AvailabilityStatusSchema: () => AvailabilityStatusSchema2,
  AvailabilityUnionSchema: () => AvailabilityUnionSchema,
  BaseTypeReferenceSchema: () => BaseTypeReferenceSchema,
  BasicAuthSchemeSchema: () => BasicAuthSchemeSchema,
  BearerAuthSchemeSchema: () => BearerAuthSchemeSchema,
  EncodingSchema: () => EncodingSchema,
  EnvironmentSchema: () => EnvironmentSchema,
  HeaderAuthSchemeSchema: () => HeaderAuthSchemeSchema,
  HttpHeaderSchema: () => HttpHeaderSchema,
  MultipleBaseUrlsEnvironmentSchema: () => MultipleBaseUrlsEnvironmentSchema,
  NumberValidationSchema: () => NumberValidationSchema,
  OAuthAccessTokenRequestPropertiesSchema: () => OAuthAccessTokenRequestPropertiesSchema,
  OAuthAccessTokenResponsePropertiesSchema: () => OAuthAccessTokenResponsePropertiesSchema,
  OAuthGetTokenEndpointSchema: () => OAuthGetTokenEndpointSchema,
  OAuthRefreshTokenEndpointSchema: () => OAuthRefreshTokenEndpointSchema,
  OAuthRefreshTokenRequestPropertiesSchema: () => OAuthRefreshTokenRequestPropertiesSchema,
  OAuthRefreshTokenResponsePropertiesSchema: () => OAuthRefreshTokenResponsePropertiesSchema,
  OAuthSchemeSchema: () => OAuthSchemeSchema,
  ProtobufTypeSchema: () => ProtobufTypeSchema,
  SingleBaseUrlEnvironmentSchema: () => SingleBaseUrlEnvironmentSchema,
  StringValidationSchema: () => StringValidationSchema,
  TypeReferenceDeclarationWithEnvOverride: () => TypeReferenceDeclarationWithEnvOverride,
  TypeReferenceDeclarationWithEnvOverrideSchema: () => TypeReferenceDeclarationWithEnvOverrideSchema,
  TypeReferenceDeclarationWithName: () => TypeReferenceDeclarationWithName,
  ValidationSchema: () => ValidationSchema,
  WithAudiences: () => WithAudiences,
  WithAvailability: () => WithAvailability,
  WithDocsSchema: () => WithDocsSchema,
  WithEnvironmentVariable: () => WithEnvironmentVariable,
  WithEnvironmentsSchema: () => WithEnvironmentsSchema,
  WithHeadersSchema: () => WithHeadersSchema,
  WithName: () => WithName,
  auth: () => auth_exports2,
  availability: () => availability_exports2,
  commons: () => commons_exports2,
  encoding: () => encoding_exports2,
  environments: () => environments_exports2,
  file: () => file_exports2,
  service: () => service_exports2,
  types: () => types_exports2,
  validation: () => validation_exports2
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/auth/index.js
var auth_exports2 = {};
__export(auth_exports2, {
  AnyAuthItem: () => AnyAuthItem,
  AnyAuthSchemesSchema: () => AnyAuthSchemesSchema,
  ApiAuthSchema: () => ApiAuthSchema,
  AuthSchemeDeclarationSchema: () => AuthSchemeDeclarationSchema,
  AuthSchemeReferenceSchema: () => AuthSchemeReferenceSchema,
  AuthVariable: () => AuthVariable,
  BasicAuthSchemeSchema: () => BasicAuthSchemeSchema,
  BearerAuthSchemeSchema: () => BearerAuthSchemeSchema,
  HeaderAuthSchemeSchema: () => HeaderAuthSchemeSchema,
  OAuthAccessTokenRequestPropertiesSchema: () => OAuthAccessTokenRequestPropertiesSchema,
  OAuthAccessTokenResponsePropertiesSchema: () => OAuthAccessTokenResponsePropertiesSchema,
  OAuthGetTokenEndpointSchema: () => OAuthGetTokenEndpointSchema,
  OAuthRefreshTokenEndpointSchema: () => OAuthRefreshTokenEndpointSchema,
  OAuthRefreshTokenRequestPropertiesSchema: () => OAuthRefreshTokenRequestPropertiesSchema,
  OAuthRefreshTokenResponsePropertiesSchema: () => OAuthRefreshTokenResponsePropertiesSchema,
  OAuthSchemeSchema: () => OAuthSchemeSchema,
  WithEnvironmentVariable: () => WithEnvironmentVariable
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/availability/index.js
var availability_exports2 = {};
__export(availability_exports2, {
  AvailabilitySchema: () => AvailabilitySchema,
  AvailabilityStatusSchema: () => AvailabilityStatusSchema2,
  AvailabilityUnionSchema: () => AvailabilityUnionSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/commons/index.js
var commons_exports2 = {};
__export(commons_exports2, {
  WithAudiences: () => WithAudiences,
  WithAvailability: () => WithAvailability,
  WithDocsSchema: () => WithDocsSchema,
  WithName: () => WithName
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/encoding/index.js
var encoding_exports2 = {};
__export(encoding_exports2, {
  EncodingSchema: () => EncodingSchema,
  ProtobufTypeSchema: () => ProtobufTypeSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/environments/index.js
var environments_exports2 = {};
__export(environments_exports2, {
  EnvironmentSchema: () => EnvironmentSchema,
  MultipleBaseUrlsEnvironmentSchema: () => MultipleBaseUrlsEnvironmentSchema,
  SingleBaseUrlEnvironmentSchema: () => SingleBaseUrlEnvironmentSchema,
  WithEnvironmentsSchema: () => WithEnvironmentsSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/file/index.js
var file_exports2 = {};
__export(file_exports2, {
  WithHeadersSchema: () => WithHeadersSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/service/index.js
var service_exports2 = {};
__export(service_exports2, {
  HttpHeaderSchema: () => HttpHeaderSchema,
  TypeReferenceDeclarationWithEnvOverride: () => TypeReferenceDeclarationWithEnvOverride,
  TypeReferenceDeclarationWithEnvOverrideSchema: () => TypeReferenceDeclarationWithEnvOverrideSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/types/index.js
var types_exports2 = {};
__export(types_exports2, {
  BaseTypeReferenceSchema: () => BaseTypeReferenceSchema,
  TypeReferenceDeclarationWithName: () => TypeReferenceDeclarationWithName
});

// ../../cli/configuration/lib/generators-yml/schemas/serialization/resources/fernDefinition/resources/validation/index.js
var validation_exports2 = {};
__export(validation_exports2, {
  NumberValidationSchema: () => NumberValidationSchema,
  StringValidationSchema: () => StringValidationSchema,
  ValidationSchema: () => ValidationSchema
});

// ../../cli/configuration/lib/generators-yml/schemas/index.js
var API_ORIGIN_LOCATION_KEY = "spec-origin";
var ASYNC_API_LOCATION_KEY = "async-api";
var DEFAULT_GROUP_GENERATORS_CONFIG_KEY = "default-group";
var OPENAPI_LOCATION_KEY = "openapi";
var OPENAPI_OVERRIDES_LOCATION_KEY = "openapi-overrides";
var API_SETTINGS_KEY = "api-settings";

// ../../cli/configuration/lib/generators-yml/GeneratorsConfiguration.js
var GenerationLanguage = {
  TYPESCRIPT: "typescript",
  JAVA: "java",
  PYTHON: "python",
  GO: "go",
  RUBY: "ruby",
  CSHARP: "csharp",
  SWIFT: "swift",
  PHP: "php"
};
function getPackageName({ generatorInvocation }) {
  return generatorInvocation.outputMode._visit({
    downloadFiles: () => void 0,
    github: (val) => val.publishInfo?._visit({
      maven: (val2) => val2.coordinate,
      npm: (val2) => val2.packageName,
      pypi: (val2) => val2.packageName,
      postman: () => void 0,
      rubygems: (val2) => val2.packageName,
      nuget: (val2) => val2.packageName,
      _other: () => void 0
    }),
    githubV2: (val) => val.publishInfo?._visit({
      maven: (val2) => val2.coordinate,
      npm: (val2) => val2.packageName,
      pypi: (val2) => val2.packageName,
      postman: () => void 0,
      rubygems: (val2) => val2.packageName,
      nuget: (val2) => val2.packageName,
      _other: () => void 0
    }),
    publish: () => void 0,
    publishV2: () => void 0,
    _other: () => void 0
  });
}

// ../../cli/configuration/lib/generators-yml/isRawProtobufAPIDefinitionSchema.js
function isRawProtobufAPIDefinitionSchema(rawApiConfiguration) {
  return typeof rawApiConfiguration !== "string" && "proto" in rawApiConfiguration;
}

// ../../cli/generation/ir-generator/lib/casings/reserved.js
var RESERVED_KEYWORDS = {
  [generators_yml_exports.GenerationLanguage.PHP]: new Set([
    "abstract",
    "and",
    "as",
    "break",
    "callable",
    "case",
    "catch",
    "class",
    "clone",
    "const",
    "continue",
    "declare",
    "default",
    "do",
    "echo",
    "else",
    "elseif",
    "enddeclare",
    "endfor",
    "endforeach",
    "endif",
    "endswitch",
    "endwhile",
    "extends",
    "final",
    "finally",
    "fn",
    "for",
    "foreach",
    "function",
    "global",
    "goto",
    "list",
    "if",
    "implements",
    "include",
    "include_once",
    "instanceof",
    "insteadof",
    "interface",
    "match",
    "namespace",
    "new",
    "or",
    "parent",
    "Parent",
    "print",
    "private",
    "protected",
    "public",
    "readonly",
    "require",
    "require_once",
    "return",
    "static",
    "switch",
    "throw",
    "trait",
    "try",
    "use",
    "var",
    "while",
    "xor",
    "yield"
  ].flatMap((str2) => [str2, upperFirst_default(str2)])),
  [generators_yml_exports.GenerationLanguage.TYPESCRIPT]: /* @__PURE__ */ new Set([
    "any",
    "as",
    "boolean",
    "break",
    "case",
    "catch",
    "class",
    "const",
    "constructor",
    "continue",
    "debugger",
    "declare",
    "default",
    "delete",
    "do",
    "else",
    "enum",
    "export",
    "extends",
    "false",
    "finally",
    "for",
    "from",
    "function",
    "get",
    "if",
    "implements",
    "import",
    "in",
    "instanceof",
    "interface",
    "let",
    "module",
    "new",
    "null",
    "number",
    "of",
    "package",
    "private",
    "protected",
    "public",
    "require",
    "return",
    "set",
    "static",
    "string",
    "super",
    "switch",
    "symbol",
    "this",
    "throw",
    "true",
    "try",
    "type",
    "typeof",
    "var",
    "void",
    "while",
    "with",
    "yield",
    "Date",
    "Error",
    "File",
    "Object",
    "Record"
  ]),
  [generators_yml_exports.GenerationLanguage.JAVA]: /* @__PURE__ */ new Set([
    "abstract",
    "assert",
    "boolean",
    "break",
    "byte",
    "case",
    "catch",
    "char",
    "class",
    "const",
    "continue",
    "default",
    "do",
    "double",
    "else",
    "enum",
    "extends",
    "final",
    "finally",
    "float",
    "for",
    "goto",
    "if",
    "implements",
    "import",
    "instanceof",
    "int",
    "interface",
    "long",
    "native",
    "new",
    "null",
    "package",
    "private",
    "protected",
    "public",
    "return",
    "short",
    "static",
    "strictfp",
    "super",
    "switch",
    "synchronized",
    "this",
    "throw",
    "throws",
    "transient",
    "try",
    "void",
    "volatile",
    "while"
  ]),
  [generators_yml_exports.GenerationLanguage.PYTHON]: /* @__PURE__ */ new Set([
    "False",
    "None",
    "True",
    "and",
    "as",
    "assert",
    "async",
    "await",
    "break",
    "class",
    "continue",
    "def",
    "del",
    "elif",
    "else",
    "except",
    "finally",
    "for",
    "from",
    "global",
    "if",
    "import",
    "in",
    "is",
    "lambda",
    "nonlocal",
    "not",
    "or",
    "pass",
    "raise",
    "return",
    "try",
    "while",
    "with",
    "yield",
    "float",
    "int",
    "complex",
    "bool",
    "uuid",
    "list",
    "set",
    "map",
    "long",
    // the following aren't actually reserved, but we treat them as unavailable
    "self",
    "all"
  ]),
  [generators_yml_exports.GenerationLanguage.GO]: /* @__PURE__ */ new Set([
    // Keywords - these are not allowed. https://go.dev/ref/spec#Keywords
    "break",
    "case",
    "chan",
    "const",
    "continue",
    "default",
    "defer",
    "else",
    "fallthrough",
    "for",
    "func",
    "go",
    "goto",
    "if",
    "import",
    "interface",
    "map",
    "package",
    "range",
    "return",
    "select",
    "struct",
    "switch",
    "type",
    "var",
    // Technically allowed as identifiers, but should be avoided.
    "any",
    "bool",
    "byte",
    "complex64",
    "complex128",
    "error",
    "float32",
    "float64",
    "int",
    "int8",
    "int16",
    "int32",
    "int64",
    "make",
    "new",
    "rune",
    "string",
    "uint",
    "uint8",
    "uint16",
    "uint32",
    "uint64",
    "uintptr"
  ]),
  [generators_yml_exports.GenerationLanguage.RUBY]: /* @__PURE__ */ new Set([
    // https://docs.ruby-lang.org/en/2.2.0/keywords_rdoc.html
    "__ENCODING__",
    "__LINE__",
    "__FILE__",
    "alias",
    "and",
    "begin",
    "break",
    "case",
    "class",
    "def",
    "defined",
    "do",
    "else",
    "elsif",
    "end",
    "ensure",
    "false",
    "for",
    "if",
    "in",
    "module",
    "next",
    "nil",
    "not",
    "or",
    "redo",
    "rescue",
    "retry",
    "return",
    "self",
    "super",
    "then",
    "true",
    "undef",
    "unless",
    "until",
    "when",
    "while",
    "yield",
    "Object",
    "JSON",
    "Date",
    "DateTime"
  ]),
  [generators_yml_exports.GenerationLanguage.CSHARP]: /* @__PURE__ */ new Set([
    "abstract",
    "as",
    "base",
    "bool",
    "break",
    "byte",
    "case",
    "catch",
    "char",
    "checked",
    "class",
    "const",
    "continue",
    "decimal",
    "default",
    "delegate",
    "do",
    "double",
    "else",
    "enum",
    "event",
    "explicit",
    "extern",
    "false",
    "finally",
    "fixed",
    "float",
    "for",
    "foreach",
    "goto",
    "if",
    "implicit",
    "in",
    "int",
    "interface",
    "internal",
    "is",
    "lock",
    "long",
    "namespace",
    "new",
    "null",
    "object",
    "operator",
    "out",
    "override",
    "params",
    "private",
    "protected",
    "public",
    "readonly",
    "ref",
    "return",
    "sbyte",
    "sealed",
    "short",
    "sizeof",
    "stackalloc",
    "static",
    "string",
    "struct",
    "switch",
    "this",
    "throw",
    "true",
    "try",
    "typeof",
    "uint",
    "ulong",
    "unchecked",
    "unsafe",
    "ushort",
    "using",
    "virtual",
    "void",
    "volatile",
    "while",
    "add",
    "and",
    "alias",
    "ascending",
    "args",
    "async",
    "await",
    "by",
    "descending",
    "dynamic",
    "equals",
    "file",
    "from",
    "get",
    "global",
    "group",
    "init",
    "into",
    "join",
    "let",
    "managed",
    "nameof",
    "nint",
    "not",
    "notnull",
    "nuint",
    "on",
    "or",
    "orderby",
    "partial",
    "record",
    "remove",
    "required",
    "scoped",
    "select",
    "set",
    "unmanaged",
    "value",
    "var",
    "when",
    "where",
    "with",
    "yield"
  ]),
  // TODO(mikemilla): add reserved keywords for Swift
  [generators_yml_exports.GenerationLanguage.SWIFT]: /* @__PURE__ */ new Set([])
};

// ../../cli/generation/ir-generator/lib/casings/CasingsGenerator.js
var CAPITALIZE_INITIALISM = ["go", "ruby"];
function constructCasingsGenerator({ generationLanguage, keywords, smartCasing }) {
  const casingsGenerator = {
    generateName: (name, opts) => {
      const generateSafeAndUnsafeString = (unsafeString) => ({
        unsafeName: unsafeString,
        safeName: sanitizeName({
          name: unsafeString,
          keywords: getKeywords({ generationLanguage, keywords })
        })
      });
      let camelCaseName = camelCase_default(name);
      let pascalCaseName = upperFirst_default(camelCaseName);
      let snakeCaseName = snakeCase_default(name);
      const camelCaseWords = words_default(camelCaseName);
      if (smartCasing) {
        if (!hasAdjacentCommonInitialisms(camelCaseWords) && (generationLanguage == null || CAPITALIZE_INITIALISM.includes(generationLanguage))) {
          camelCaseName = camelCaseWords.map((word, index) => {
            if (index > 0) {
              const pluralInitialism = maybeGetPluralInitialism(word);
              if (pluralInitialism != null) {
                return pluralInitialism;
              }
              if (isCommonInitialism(word)) {
                return word.toUpperCase();
              }
            }
            return word;
          }).join("");
          pascalCaseName = camelCaseWords.map((word, index) => {
            const pluralInitialism = maybeGetPluralInitialism(word);
            if (pluralInitialism != null) {
              return pluralInitialism;
            }
            if (isCommonInitialism(word)) {
              return word.toUpperCase();
            }
            if (index === 0) {
              return upperFirst_default(word);
            }
            return word;
          }).join("");
        }
        snakeCaseName = name.split(" ").map((part) => part.split(/(\d+)/).map(snakeCase_default).join("")).join("_");
      }
      return {
        originalName: name,
        camelCase: generateSafeAndUnsafeString(opts?.casingOverrides?.camel ?? camelCaseName),
        snakeCase: generateSafeAndUnsafeString(opts?.casingOverrides?.snake ?? snakeCaseName),
        screamingSnakeCase: generateSafeAndUnsafeString(opts?.casingOverrides?.["screaming-snake"] ?? snakeCaseName.toUpperCase()),
        pascalCase: generateSafeAndUnsafeString(opts?.casingOverrides?.pascal ?? pascalCaseName)
      };
    },
    generateNameAndWireValue: ({ name, wireValue, opts }) => ({
      name: casingsGenerator.generateName(name, opts),
      wireValue
    })
  };
  return casingsGenerator;
}
function sanitizeName({ name, keywords }) {
  if (keywords == null) {
    return name;
  }
  if (keywords.has(name)) {
    return name + "_";
  } else if (startsWithNumber(name)) {
    return "_" + name;
  } else {
    return name;
  }
}
function getKeywords({ generationLanguage, keywords }) {
  if (keywords != null) {
    return new Set(keywords);
  }
  if (generationLanguage != null) {
    return RESERVED_KEYWORDS[generationLanguage];
  }
  return void 0;
}
var STARTS_WITH_NUMBER = /^[0-9]/;
function startsWithNumber(str2) {
  return STARTS_WITH_NUMBER.test(str2);
}
function hasAdjacentCommonInitialisms(wordList) {
  return wordList.some((word, index) => {
    if (index === 0) {
      return false;
    }
    const previousWord = wordList[index - 1];
    if (previousWord == null) {
      return false;
    }
    const previousWordIsInitialism = maybeGetPluralInitialism(previousWord) != null || isCommonInitialism(previousWord);
    const currentWordIsInitialism = maybeGetPluralInitialism(word) != null || isCommonInitialism(word);
    return previousWordIsInitialism && currentWordIsInitialism;
  });
}
function maybeGetPluralInitialism(name) {
  return PLURAL_COMMON_ITIALISMS.get(name.toUpperCase());
}
function isCommonInitialism(name) {
  return COMMON_ITIALISMS.has(name.toUpperCase());
}
var COMMON_ITIALISMS = /* @__PURE__ */ new Set([
  "ACL",
  "API",
  "ASCII",
  "CPU",
  "CSS",
  "DNS",
  "EOF",
  "GUID",
  "HTML",
  "HTTP",
  "HTTPS",
  "ID",
  "IP",
  "JSON",
  "LHS",
  "QPS",
  "RAM",
  "RHS",
  "RPC",
  "SAML",
  "SCIM",
  "SLA",
  "SMTP",
  "SQL",
  "SSH",
  "SSO",
  "TCP",
  "TLS",
  "TTL",
  "UDP",
  "UI",
  "UID",
  "UUID",
  "URI",
  "URL",
  "UTF8",
  "VM",
  "XML",
  "XMPP",
  "XSRF",
  "XSS"
]);
var PLURAL_COMMON_ITIALISMS = /* @__PURE__ */ new Map([
  ["ACLS", "ACLs"],
  ["APIS", "APIs"],
  ["CPUS", "CPUs"],
  ["GUIDS", "GUIDs"],
  ["IDS", "IDs"],
  ["UIDS", "UIDs"],
  ["UUIDS", "UUIDs"],
  ["URIS", "URIs"],
  ["URLS", "URLs"]
]);

// ../../cli/generation/ir-generator/lib/converters/services/constructHttpPath.js
function constructHttpPath(rawPath) {
  const rawPathGenerator = createStringGenerator(rawPath);
  const { value: head, done } = readUntil(rawPathGenerator, "{");
  if (done) {
    return { head, parts: [] };
  } else {
    return {
      head,
      parts: [...getAllParts(rawPathGenerator)]
    };
  }
}
function* getAllParts(rawPathGenerator) {
  let done;
  do {
    const { value: pathParameter } = readUntil(rawPathGenerator, "}");
    const untilNextOpeningBrace = readUntil(rawPathGenerator, "{");
    done = untilNextOpeningBrace.done;
    yield {
      pathParameter,
      tail: untilNextOpeningBrace.value
    };
  } while (!done);
}
function* createStringGenerator(str2) {
  for (const char of str2) {
    yield char;
  }
}
function readUntil(generator, delimiter) {
  let value = "";
  let nextResult = generator.next();
  while (nextResult.done !== true && nextResult.value !== delimiter) {
    value += nextResult.value;
    nextResult = generator.next();
  }
  return {
    value,
    done: nextResult.done ?? false
  };
}

// ../../cli/generation/ir-generator/lib/IdGenerator.js
var IdGenerator = {
  generateTypeId: (typeName) => {
    const joinedFernFilePath = stringifyFernFilepath(typeName.fernFilepath);
    return `type_${joinedFernFilePath}:${typeName.name.originalName}`;
  },
  generateErrorId: (errorName) => {
    const joinedFernFilePath = stringifyFernFilepath(errorName.fernFilepath);
    return `error_${joinedFernFilePath}:${errorName.name.originalName}`;
  },
  generateServiceId: (serviceName) => {
    const joinedFernFilePath = stringifyFernFilepath(serviceName.fernFilepath);
    return `service_${joinedFernFilePath}`;
  },
  generateServiceIdFromFernFilepath: (fernFilepath) => {
    const joinedFernFilePath = stringifyFernFilepath(fernFilepath);
    return `service_${joinedFernFilePath}`;
  },
  generateSubpackageId: (fernFilepath) => {
    const joinedFernFilePath = stringifyFernFilepath(fernFilepath);
    return `subpackage_${joinedFernFilePath}`;
  },
  generateEndpointId: (declaredServiceName, httpEndpoint) => {
    const joinedFernFilePath = stringifyFernFilepath(declaredServiceName.fernFilepath);
    const endpointId = httpEndpoint.name.originalName;
    return `endpoint_${joinedFernFilePath}.${endpointId}`;
  },
  generateEndpointIdFromResolvedEndpoint: (resolvedEndpoint) => {
    const joinedFernFilePath = stringifyFernFilepath(resolvedEndpoint.file.fernFilepath);
    const endpointId = resolvedEndpoint.endpointId;
    return `endpoint_${joinedFernFilePath}.${endpointId}`;
  },
  generateWebhookGroupId: (fernFilepath) => {
    const joinedFernFilePath = stringifyFernFilepath(fernFilepath);
    return `webhooks_${joinedFernFilePath}`;
  },
  generateWebhookId: (fernFilepath, webhookId) => {
    const joinedFernFilePath = stringifyFernFilepath(fernFilepath);
    return `webhooks_${joinedFernFilePath}.${webhookId}`;
  },
  generateWebSocketChannelId: (fernFilepath) => {
    const joinedFernFilePath = stringifyFernFilepath(fernFilepath);
    return `channel_${joinedFernFilePath}`;
  }
};
function stringifyFernFilepath(fernFilepath) {
  return fernFilepath.allParts.map((part) => part.originalName).join("/");
}

// ../../commons/path-utils/lib/isBrowser.js
function isBrowser() {
  return typeof window !== "undefined";
}

// ../../commons/path-utils/lib/getPathModule.js
function getPathModule() {
  if (isBrowser()) {
    return {
      isAbsolute: (value) => {
        return value.startsWith("/");
      }
    };
  } else {
    return require("path");
  }
}

// ../../commons/path-utils/lib/convertToOsPath.js
function convertToOsPath(path5) {
  if (isBrowser()) {
    return path5.replace(/\\/g, "/");
  }
  if (process.platform === "win32") {
    return path5.replace(/\//g, "\\");
  } else {
    return path5.replace(/\\/g, "/");
  }
}

// ../../commons/path-utils/lib/AbsoluteFilePath.js
var path = getPathModule();
var AbsoluteFilePath = {
  of: (value) => {
    if (!path.isAbsolute(value)) {
      throw new Error("Filepath is not absolute: " + value);
    }
    return convertToOsPath(value);
  }
};

// ../../commons/path-utils/lib/RelativeFilePath.js
var path2 = getPathModule();
var RelativeFilePath = {
  of: (value) => {
    if (path2.isAbsolute(value)) {
      throw new Error("Filepath is not relative: " + value);
    }
    return convertToOsPath(value);
  }
};

// ../../commons/path-utils/lib/basename.js
function basename(path5, options) {
  const basename3 = path5.split("/").pop() ?? path5;
  if (options?.stripExtension) {
    return basename3.split(".")[0] ?? basename3;
  }
  return basename3;
}

// ../../commons/path-utils/lib/dirname.js
function dirname(filepath) {
  const trimmed = filepath.replace(/\/+$/, "");
  const lastSlashIndex = trimmed.lastIndexOf("/");
  if (lastSlashIndex === -1) {
    return ".";
  }
  if (lastSlashIndex === 0) {
    return "/";
  }
  return filepath.slice(0, lastSlashIndex);
}

// ../../commons/path-utils/lib/join.js
function join(...parts) {
  const stack = [];
  for (const part of parts.flatMap((segment) => segment.split("/")).filter(Boolean)) {
    if (part === "." || part === "") {
      continue;
    }
    if (part === "..") {
      if (stack.length > 0 && stack[stack.length - 1] !== "..") {
        stack.pop();
      } else {
        stack.push(part);
      }
    } else {
      stack.push(part);
    }
  }
  return (parts[0]?.startsWith("/") ? "/" : "") + stack.join("/");
}

// ../../commons/path-utils/lib/sep.js
var sep = "/";

// ../../commons/path-utils/lib/relative.js
function relative(from, to) {
  const fromParts = from.split(sep).filter(Boolean);
  const toParts = to.split(sep).filter(Boolean);
  let i = 0;
  while (i < fromParts.length && i < toParts.length && fromParts[i] === toParts[i]) {
    i++;
  }
  const upLevels = fromParts.length - i;
  const result = [
    ...Array(upLevels).fill(".."),
    ...toParts.slice(i)
    // Add the remaining path parts from `to`
  ];
  return result.join(sep) || ".";
}

// ../../cli/generation/ir-generator/lib/utils/convertToFernFilepath.js
function convertToFernFilepath({ relativeFilepath, casingsGenerator }) {
  const pathToPackage = dirname(relativeFilepath);
  const filename = basename(relativeFilepath, { stripExtension: true });
  const packagePath = pathToPackage === "." ? [] : pathToPackage.split(sep).map((part) => casingsGenerator.generateName(part));
  const file = filename !== FERN_PACKAGE_MARKER_FILENAME_NO_EXTENSION ? casingsGenerator.generateName(filename) : void 0;
  const allParts = [];
  allParts.push(...packagePath);
  if (file != null) {
    allParts.push(file);
  }
  return {
    allParts,
    packagePath,
    file
  };
}

// ../../cli/generation/ir-generator/lib/utils/getResolvedPathOfImportedFile.js
function getResolvedPathOfImportedFile({ referencedIn, importPath }) {
  return join(dirname(referencedIn), importPath);
}

// ../../cli/generation/ir-generator/lib/utils/parseReferenceToTypeName.js
function parseReferenceToTypeName({ reference, referencedIn, imports }) {
  const [firstPart, secondPart, ...rest] = reference.split(".");
  if (firstPart == null || rest.length > 0) {
    return void 0;
  }
  if (secondPart == null) {
    return {
      typeName: firstPart,
      relativeFilepath: referencedIn
    };
  }
  const importAlias = firstPart;
  const importPath = imports[importAlias];
  if (importPath == null) {
    return void 0;
  }
  return {
    relativeFilepath: getResolvedPathOfImportedFile({ referencedIn, importPath }),
    typeName: secondPart
  };
}

// ../../cli/generation/ir-generator/lib/utils/parseErrorName.js
function parseErrorName({ errorName, file }) {
  const reference = parseReferenceToTypeName({
    reference: errorName,
    referencedIn: file.relativeFilepath,
    imports: file.imports
  });
  if (reference == null) {
    throw new Error("Failed to locate error " + errorName);
  }
  const nameWithoutId = {
    name: file.casingsGenerator.generateName(reference.typeName),
    fernFilepath: convertToFernFilepath({
      relativeFilepath: reference.relativeFilepath,
      casingsGenerator: file.casingsGenerator
    })
  };
  return {
    ...nameWithoutId,
    errorId: IdGenerator.generateErrorId(nameWithoutId)
  };
}

// ../../cli/generation/ir-generator/lib/converters/services/convertResponseErrors.js
function convertResponseErrors({ errors, file }) {
  return errors == null ? [] : Object.values(errors).map((errorReference) => {
    const referenceToError = typeof errorReference === "string" ? errorReference : errorReference.error;
    const errorName = parseErrorName({
      errorName: referenceToError,
      file
    });
    return {
      docs: typeof errorReference !== "string" ? errorReference.docs : void 0,
      error: errorName
    };
  });
}

// ../../ir-sdk/lib/sdk/api/resources/auth/types/AuthSchemesRequirement.js
var AuthSchemesRequirement = {
  All: "ALL",
  Any: "ANY",
  _visit: (value, visitor) => {
    switch (value) {
      case AuthSchemesRequirement.All:
        return visitor.all();
      case AuthSchemesRequirement.Any:
        return visitor.any();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/auth/types/AuthScheme.js
var AuthScheme = {
  bearer: (value) => {
    return {
      ...value,
      type: "bearer",
      _visit: function (visitor) {
        return AuthScheme._visit(this, visitor);
      }
    };
  },
  basic: (value) => {
    return {
      ...value,
      type: "basic",
      _visit: function (visitor) {
        return AuthScheme._visit(this, visitor);
      }
    };
  },
  header: (value) => {
    return {
      ...value,
      type: "header",
      _visit: function (visitor) {
        return AuthScheme._visit(this, visitor);
      }
    };
  },
  oauth: (value) => {
    return {
      ...value,
      type: "oauth",
      _visit: function (visitor) {
        return AuthScheme._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "bearer":
        return visitor.bearer(value);
      case "basic":
        return visitor.basic(value);
      case "header":
        return visitor.header(value);
      case "oauth":
        return visitor.oauth(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/auth/types/OAuthConfiguration.js
var OAuthConfiguration = {
  clientCredentials: (value) => {
    return {
      ...value,
      type: "clientCredentials",
      _visit: function (visitor) {
        return OAuthConfiguration._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "clientCredentials":
        return visitor.clientCredentials(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/commons/types/AvailabilityStatus.js
var AvailabilityStatus = {
  InDevelopment: "IN_DEVELOPMENT",
  PreRelease: "PRE_RELEASE",
  GeneralAvailability: "GENERAL_AVAILABILITY",
  Deprecated: "DEPRECATED",
  _visit: (value, visitor) => {
    switch (value) {
      case AvailabilityStatus.InDevelopment:
        return visitor.inDevelopment();
      case AvailabilityStatus.PreRelease:
        return visitor.preRelease();
      case AvailabilityStatus.GeneralAvailability:
        return visitor.generalAvailability();
      case AvailabilityStatus.Deprecated:
        return visitor.deprecated();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/index.js
var dynamic_exports = {};
__export(dynamic_exports, {
  Auth: () => Auth,
  AuthValues: () => AuthValues,
  ErrorSeverity: () => ErrorSeverity,
  FileUploadRequestBodyProperty: () => FileUploadRequestBodyProperty,
  InlinedRequestBody: () => InlinedRequestBody,
  LiteralType: () => LiteralType,
  NamedType: () => NamedType,
  ReferencedRequestBodyType: () => ReferencedRequestBodyType,
  Request: () => Request,
  Response: () => Response,
  SingleDiscriminatedUnionType: () => SingleDiscriminatedUnionType,
  TypeReference: () => TypeReference,
  auth: () => auth_exports3,
  declaration: () => declaration_exports,
  endpoints: () => endpoints_exports,
  ir: () => ir_exports,
  snippets: () => snippets_exports,
  types: () => types_exports3
});

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/auth/index.js
var auth_exports3 = {};
__export(auth_exports3, {
  Auth: () => Auth,
  AuthValues: () => AuthValues
});

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/auth/types/Auth.js
var Auth = {
  basic: (value) => {
    return {
      ...value,
      type: "basic",
      _visit: function (visitor) {
        return dynamic_exports.Auth._visit(this, visitor);
      }
    };
  },
  bearer: (value) => {
    return {
      ...value,
      type: "bearer",
      _visit: function (visitor) {
        return dynamic_exports.Auth._visit(this, visitor);
      }
    };
  },
  header: (value) => {
    return {
      ...value,
      type: "header",
      _visit: function (visitor) {
        return dynamic_exports.Auth._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "basic":
        return visitor.basic(value);
      case "bearer":
        return visitor.bearer(value);
      case "header":
        return visitor.header(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/auth/types/AuthValues.js
var AuthValues = {
  basic: (value) => {
    return {
      ...value,
      type: "basic",
      _visit: function (visitor) {
        return dynamic_exports.AuthValues._visit(this, visitor);
      }
    };
  },
  bearer: (value) => {
    return {
      ...value,
      type: "bearer",
      _visit: function (visitor) {
        return dynamic_exports.AuthValues._visit(this, visitor);
      }
    };
  },
  header: (value) => {
    return {
      ...value,
      type: "header",
      _visit: function (visitor) {
        return dynamic_exports.AuthValues._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "basic":
        return visitor.basic(value);
      case "bearer":
        return visitor.bearer(value);
      case "header":
        return visitor.header(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/declaration/index.js
var declaration_exports = {};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/endpoints/index.js
var endpoints_exports = {};
__export(endpoints_exports, {
  FileUploadRequestBodyProperty: () => FileUploadRequestBodyProperty,
  InlinedRequestBody: () => InlinedRequestBody,
  ReferencedRequestBodyType: () => ReferencedRequestBodyType,
  Request: () => Request,
  Response: () => Response
});

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/endpoints/types/Request.js
var Request = {
  body: (value) => {
    return {
      ...value,
      type: "body",
      _visit: function (visitor) {
        return dynamic_exports.Request._visit(this, visitor);
      }
    };
  },
  inlined: (value) => {
    return {
      ...value,
      type: "inlined",
      _visit: function (visitor) {
        return dynamic_exports.Request._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "body":
        return visitor.body(value);
      case "inlined":
        return visitor.inlined(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/endpoints/types/Response.js
var Response = {
  json: () => {
    return {
      type: "json",
      _visit: function (visitor) {
        return dynamic_exports.Response._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "json":
        return visitor.json();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/endpoints/types/InlinedRequestBody.js
var InlinedRequestBody = {
  properties: (value) => {
    return {
      value,
      type: "properties",
      _visit: function (visitor) {
        return dynamic_exports.InlinedRequestBody._visit(this, visitor);
      }
    };
  },
  referenced: (value) => {
    return {
      ...value,
      type: "referenced",
      _visit: function (visitor) {
        return dynamic_exports.InlinedRequestBody._visit(this, visitor);
      }
    };
  },
  fileUpload: (value) => {
    return {
      ...value,
      type: "fileUpload",
      _visit: function (visitor) {
        return dynamic_exports.InlinedRequestBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "properties":
        return visitor.properties(value.value);
      case "referenced":
        return visitor.referenced(value);
      case "fileUpload":
        return visitor.fileUpload(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/endpoints/types/ReferencedRequestBodyType.js
var ReferencedRequestBodyType = {
  bytes: () => {
    return {
      type: "bytes",
      _visit: function (visitor) {
        return dynamic_exports.ReferencedRequestBodyType._visit(this, visitor);
      }
    };
  },
  typeReference: (value) => {
    return {
      value,
      type: "typeReference",
      _visit: function (visitor) {
        return dynamic_exports.ReferencedRequestBodyType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "bytes":
        return visitor.bytes();
      case "typeReference":
        return visitor.typeReference(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/endpoints/types/FileUploadRequestBodyProperty.js
var FileUploadRequestBodyProperty = {
  file: (value) => {
    return {
      ...value,
      type: "file",
      _visit: function (visitor) {
        return dynamic_exports.FileUploadRequestBodyProperty._visit(this, visitor);
      }
    };
  },
  fileArray: (value) => {
    return {
      ...value,
      type: "fileArray",
      _visit: function (visitor) {
        return dynamic_exports.FileUploadRequestBodyProperty._visit(this, visitor);
      }
    };
  },
  bodyProperty: (value) => {
    return {
      ...value,
      type: "bodyProperty",
      _visit: function (visitor) {
        return dynamic_exports.FileUploadRequestBodyProperty._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "file":
        return visitor.file(value);
      case "fileArray":
        return visitor.fileArray(value);
      case "bodyProperty":
        return visitor.bodyProperty(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/ir/index.js
var ir_exports = {};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/snippets/index.js
var snippets_exports = {};
__export(snippets_exports, {
  ErrorSeverity: () => ErrorSeverity
});

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/snippets/types/ErrorSeverity.js
var ErrorSeverity = {
  Critical: "CRITICAL",
  Warning: "WARNING",
  _visit: (value, visitor) => {
    switch (value) {
      case ErrorSeverity.Critical:
        return visitor.critical();
      case ErrorSeverity.Warning:
        return visitor.warning();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/types/index.js
var types_exports3 = {};
__export(types_exports3, {
  LiteralType: () => LiteralType,
  NamedType: () => NamedType,
  SingleDiscriminatedUnionType: () => SingleDiscriminatedUnionType,
  TypeReference: () => TypeReference
});

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/types/types/NamedType.js
var NamedType = {
  alias: (value) => {
    return {
      ...value,
      type: "alias",
      _visit: function (visitor) {
        return dynamic_exports.NamedType._visit(this, visitor);
      }
    };
  },
  enum: (value) => {
    return {
      ...value,
      type: "enum",
      _visit: function (visitor) {
        return dynamic_exports.NamedType._visit(this, visitor);
      }
    };
  },
  object: (value) => {
    return {
      ...value,
      type: "object",
      _visit: function (visitor) {
        return dynamic_exports.NamedType._visit(this, visitor);
      }
    };
  },
  discriminatedUnion: (value) => {
    return {
      ...value,
      type: "discriminatedUnion",
      _visit: function (visitor) {
        return dynamic_exports.NamedType._visit(this, visitor);
      }
    };
  },
  undiscriminatedUnion: (value) => {
    return {
      ...value,
      type: "undiscriminatedUnion",
      _visit: function (visitor) {
        return dynamic_exports.NamedType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "alias":
        return visitor.alias(value);
      case "enum":
        return visitor.enum(value);
      case "object":
        return visitor.object(value);
      case "discriminatedUnion":
        return visitor.discriminatedUnion(value);
      case "undiscriminatedUnion":
        return visitor.undiscriminatedUnion(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/types/types/TypeReference.js
var TypeReference = {
  list: (value) => {
    return {
      value,
      type: "list",
      _visit: function (visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  literal: (value) => {
    return {
      value,
      type: "literal",
      _visit: function (visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  map: (value) => {
    return {
      ...value,
      type: "map",
      _visit: function (visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  named: (value) => {
    return {
      value,
      type: "named",
      _visit: function (visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  optional: (value) => {
    return {
      value,
      type: "optional",
      _visit: function (visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  primitive: (value) => {
    return {
      value,
      type: "primitive",
      _visit: function (visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  set: (value) => {
    return {
      value,
      type: "set",
      _visit: function (visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  unknown: () => {
    return {
      type: "unknown",
      _visit: function (visitor) {
        return dynamic_exports.TypeReference._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "list":
        return visitor.list(value.value);
      case "literal":
        return visitor.literal(value.value);
      case "map":
        return visitor.map(value);
      case "named":
        return visitor.named(value.value);
      case "optional":
        return visitor.optional(value.value);
      case "primitive":
        return visitor.primitive(value.value);
      case "set":
        return visitor.set(value.value);
      case "unknown":
        return visitor.unknown();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/types/types/SingleDiscriminatedUnionType.js
var SingleDiscriminatedUnionType = {
  samePropertiesAsObject: (value) => {
    return {
      ...value,
      type: "samePropertiesAsObject",
      _visit: function (visitor) {
        return dynamic_exports.SingleDiscriminatedUnionType._visit(this, visitor);
      }
    };
  },
  singleProperty: (value) => {
    return {
      ...value,
      type: "singleProperty",
      _visit: function (visitor) {
        return dynamic_exports.SingleDiscriminatedUnionType._visit(this, visitor);
      }
    };
  },
  noProperties: (value) => {
    return {
      ...value,
      type: "noProperties",
      _visit: function (visitor) {
        return dynamic_exports.SingleDiscriminatedUnionType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "samePropertiesAsObject":
        return visitor.samePropertiesAsObject(value);
      case "singleProperty":
        return visitor.singleProperty(value);
      case "noProperties":
        return visitor.noProperties(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/dynamic/resources/types/types/LiteralType.js
var LiteralType = {
  boolean: (value) => {
    return {
      value,
      type: "boolean",
      _visit: function (visitor) {
        return dynamic_exports.LiteralType._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      value,
      type: "string",
      _visit: function (visitor) {
        return dynamic_exports.LiteralType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "boolean":
        return visitor.boolean(value.value);
      case "string":
        return visitor.string(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/environment/types/Environments.js
var Environments = {
  singleBaseUrl: (value) => {
    return {
      ...value,
      type: "singleBaseUrl",
      _visit: function (visitor) {
        return Environments._visit(this, visitor);
      }
    };
  },
  multipleBaseUrls: (value) => {
    return {
      ...value,
      type: "multipleBaseUrls",
      _visit: function (visitor) {
        return Environments._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "singleBaseUrl":
        return visitor.singleBaseUrl(value);
      case "multipleBaseUrls":
        return visitor.multipleBaseUrls(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/Transport.js
var Transport = {
  http: () => {
    return {
      type: "http",
      _visit: function (visitor) {
        return Transport._visit(this, visitor);
      }
    };
  },
  grpc: (value) => {
    return {
      ...value,
      type: "grpc",
      _visit: function (visitor) {
        return Transport._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "http":
        return visitor.http();
      case "grpc":
        return visitor.grpc(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/HttpMethod.js
var HttpMethod = {
  Get: "GET",
  Post: "POST",
  Put: "PUT",
  Patch: "PATCH",
  Delete: "DELETE",
  _visit: (value, visitor) => {
    switch (value) {
      case HttpMethod.Get:
        return visitor.get();
      case HttpMethod.Post:
        return visitor.post();
      case HttpMethod.Put:
        return visitor.put();
      case HttpMethod.Patch:
        return visitor.patch();
      case HttpMethod.Delete:
        return visitor.delete();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/PathParameterLocation.js
var PathParameterLocation = {
  Root: "ROOT",
  Service: "SERVICE",
  Endpoint: "ENDPOINT",
  _visit: (value, visitor) => {
    switch (value) {
      case PathParameterLocation.Root:
        return visitor.root();
      case PathParameterLocation.Service:
        return visitor.service();
      case PathParameterLocation.Endpoint:
        return visitor.endpoint();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/HttpRequestBody.js
var HttpRequestBody = {
  inlinedRequestBody: (value) => {
    return {
      ...value,
      type: "inlinedRequestBody",
      _visit: function (visitor) {
        return HttpRequestBody._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function (visitor) {
        return HttpRequestBody._visit(this, visitor);
      }
    };
  },
  fileUpload: (value) => {
    return {
      ...value,
      type: "fileUpload",
      _visit: function (visitor) {
        return HttpRequestBody._visit(this, visitor);
      }
    };
  },
  bytes: (value) => {
    return {
      ...value,
      type: "bytes",
      _visit: function (visitor) {
        return HttpRequestBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "inlinedRequestBody":
        return visitor.inlinedRequestBody(value);
      case "reference":
        return visitor.reference(value);
      case "fileUpload":
        return visitor.fileUpload(value);
      case "bytes":
        return visitor.bytes(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/FileUploadRequestProperty.js
var FileUploadRequestProperty = {
  file: (value) => {
    return {
      value,
      type: "file",
      _visit: function (visitor) {
        return FileUploadRequestProperty._visit(this, visitor);
      }
    };
  },
  bodyProperty: (value) => {
    return {
      ...value,
      type: "bodyProperty",
      _visit: function (visitor) {
        return FileUploadRequestProperty._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "file":
        return visitor.file(value.value);
      case "bodyProperty":
        return visitor.bodyProperty(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/FileProperty.js
var FileProperty = {
  file: (value) => {
    return {
      ...value,
      type: "file",
      _visit: function (visitor) {
        return FileProperty._visit(this, visitor);
      }
    };
  },
  fileArray: (value) => {
    return {
      ...value,
      type: "fileArray",
      _visit: function (visitor) {
        return FileProperty._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "file":
        return visitor.file(value);
      case "fileArray":
        return visitor.fileArray(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/SdkRequestBodyType.js
var SdkRequestBodyType = {
  typeReference: (value) => {
    return {
      ...value,
      type: "typeReference",
      _visit: function (visitor) {
        return SdkRequestBodyType._visit(this, visitor);
      }
    };
  },
  bytes: (value) => {
    return {
      ...value,
      type: "bytes",
      _visit: function (visitor) {
        return SdkRequestBodyType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "typeReference":
        return visitor.typeReference(value);
      case "bytes":
        return visitor.bytes(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/SdkRequestShape.js
var SdkRequestShape = {
  justRequestBody: (value) => {
    return {
      value,
      type: "justRequestBody",
      _visit: function (visitor) {
        return SdkRequestShape._visit(this, visitor);
      }
    };
  },
  wrapper: (value) => {
    return {
      ...value,
      type: "wrapper",
      _visit: function (visitor) {
        return SdkRequestShape._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "justRequestBody":
        return visitor.justRequestBody(value.value);
      case "wrapper":
        return visitor.wrapper(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/NonStreamHttpResponseBody.js
var NonStreamHttpResponseBody = {
  json: (value) => {
    return {
      value,
      type: "json",
      _visit: function (visitor) {
        return NonStreamHttpResponseBody._visit(this, visitor);
      }
    };
  },
  fileDownload: (value) => {
    return {
      ...value,
      type: "fileDownload",
      _visit: function (visitor) {
        return NonStreamHttpResponseBody._visit(this, visitor);
      }
    };
  },
  text: (value) => {
    return {
      ...value,
      type: "text",
      _visit: function (visitor) {
        return NonStreamHttpResponseBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "json":
        return visitor.json(value.value);
      case "fileDownload":
        return visitor.fileDownload(value);
      case "text":
        return visitor.text(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/HttpResponseBody.js
var HttpResponseBody = {
  json: (value) => {
    return {
      value,
      type: "json",
      _visit: function (visitor) {
        return HttpResponseBody._visit(this, visitor);
      }
    };
  },
  fileDownload: (value) => {
    return {
      ...value,
      type: "fileDownload",
      _visit: function (visitor) {
        return HttpResponseBody._visit(this, visitor);
      }
    };
  },
  text: (value) => {
    return {
      ...value,
      type: "text",
      _visit: function (visitor) {
        return HttpResponseBody._visit(this, visitor);
      }
    };
  },
  streaming: (value) => {
    return {
      value,
      type: "streaming",
      _visit: function (visitor) {
        return HttpResponseBody._visit(this, visitor);
      }
    };
  },
  streamParameter: (value) => {
    return {
      ...value,
      type: "streamParameter",
      _visit: function (visitor) {
        return HttpResponseBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "json":
        return visitor.json(value.value);
      case "fileDownload":
        return visitor.fileDownload(value);
      case "text":
        return visitor.text(value);
      case "streaming":
        return visitor.streaming(value.value);
      case "streamParameter":
        return visitor.streamParameter(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/JsonResponse.js
var JsonResponse = {
  response: (value) => {
    return {
      ...value,
      type: "response",
      _visit: function (visitor) {
        return JsonResponse._visit(this, visitor);
      }
    };
  },
  nestedPropertyAsResponse: (value) => {
    return {
      ...value,
      type: "nestedPropertyAsResponse",
      _visit: function (visitor) {
        return JsonResponse._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "response":
        return visitor.response(value);
      case "nestedPropertyAsResponse":
        return visitor.nestedPropertyAsResponse(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/StreamingResponse.js
var StreamingResponse = {
  json: (value) => {
    return {
      ...value,
      type: "json",
      _visit: function (visitor) {
        return StreamingResponse._visit(this, visitor);
      }
    };
  },
  text: (value) => {
    return {
      ...value,
      type: "text",
      _visit: function (visitor) {
        return StreamingResponse._visit(this, visitor);
      }
    };
  },
  sse: (value) => {
    return {
      ...value,
      type: "sse",
      _visit: function (visitor) {
        return StreamingResponse._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "json":
        return visitor.json(value);
      case "text":
        return visitor.text(value);
      case "sse":
        return visitor.sse(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/Pagination.js
var Pagination = {
  cursor: (value) => {
    return {
      ...value,
      type: "cursor",
      _visit: function (visitor) {
        return Pagination._visit(this, visitor);
      }
    };
  },
  offset: (value) => {
    return {
      ...value,
      type: "offset",
      _visit: function (visitor) {
        return Pagination._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "cursor":
        return visitor.cursor(value);
      case "offset":
        return visitor.offset(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/RequestPropertyValue.js
var RequestPropertyValue = {
  query: (value) => {
    return {
      ...value,
      type: "query",
      _visit: function (visitor) {
        return RequestPropertyValue._visit(this, visitor);
      }
    };
  },
  body: (value) => {
    return {
      ...value,
      type: "body",
      _visit: function (visitor) {
        return RequestPropertyValue._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "query":
        return visitor.query(value);
      case "body":
        return visitor.body(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/ExampleCodeSample.js
var ExampleCodeSample = {
  language: (value) => {
    return {
      ...value,
      type: "language",
      _visit: function (visitor) {
        return ExampleCodeSample._visit(this, visitor);
      }
    };
  },
  sdk: (value) => {
    return {
      ...value,
      type: "sdk",
      _visit: function (visitor) {
        return ExampleCodeSample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "language":
        return visitor.language(value);
      case "sdk":
        return visitor.sdk(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/ExampleQueryParameterShape.js
var ExampleQueryParameterShape = {
  single: () => {
    return {
      type: "single",
      _visit: function (visitor) {
        return ExampleQueryParameterShape._visit(this, visitor);
      }
    };
  },
  exploded: () => {
    return {
      type: "exploded",
      _visit: function (visitor) {
        return ExampleQueryParameterShape._visit(this, visitor);
      }
    };
  },
  commaSeparated: () => {
    return {
      type: "commaSeparated",
      _visit: function (visitor) {
        return ExampleQueryParameterShape._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "single":
        return visitor.single();
      case "exploded":
        return visitor.exploded();
      case "commaSeparated":
        return visitor.commaSeparated();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/ExampleRequestBody.js
var ExampleRequestBody = {
  inlinedRequestBody: (value) => {
    return {
      ...value,
      type: "inlinedRequestBody",
      _visit: function (visitor) {
        return ExampleRequestBody._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function (visitor) {
        return ExampleRequestBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "inlinedRequestBody":
        return visitor.inlinedRequestBody(value);
      case "reference":
        return visitor.reference(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/ExampleResponse.js
var ExampleResponse = {
  ok: (value) => {
    return {
      value,
      type: "ok",
      _visit: function (visitor) {
        return ExampleResponse._visit(this, visitor);
      }
    };
  },
  error: (value) => {
    return {
      ...value,
      type: "error",
      _visit: function (visitor) {
        return ExampleResponse._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "ok":
        return visitor.ok(value.value);
      case "error":
        return visitor.error(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/http/types/ExampleEndpointSuccessResponse.js
var ExampleEndpointSuccessResponse = {
  body: (value) => {
    return {
      value,
      type: "body",
      _visit: function (visitor) {
        return ExampleEndpointSuccessResponse._visit(this, visitor);
      }
    };
  },
  stream: (value) => {
    return {
      value,
      type: "stream",
      _visit: function (visitor) {
        return ExampleEndpointSuccessResponse._visit(this, visitor);
      }
    };
  },
  sse: (value) => {
    return {
      value,
      type: "sse",
      _visit: function (visitor) {
        return ExampleEndpointSuccessResponse._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "body":
        return visitor.body(value.value);
      case "stream":
        return visitor.stream(value.value);
      case "sse":
        return visitor.sse(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/ir/types/ApiVersionScheme.js
var ApiVersionScheme = {
  header: (value) => {
    return {
      ...value,
      type: "header",
      _visit: function (visitor) {
        return ApiVersionScheme._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "header":
        return visitor.header(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/ir/types/ErrorDiscriminationStrategy.js
var ErrorDiscriminationStrategy = {
  statusCode: () => {
    return {
      type: "statusCode",
      _visit: function (visitor) {
        return ErrorDiscriminationStrategy._visit(this, visitor);
      }
    };
  },
  property: (value) => {
    return {
      ...value,
      type: "property",
      _visit: function (visitor) {
        return ErrorDiscriminationStrategy._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "statusCode":
        return visitor.statusCode();
      case "property":
        return visitor.property(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/proto/types/ProtobufType.js
var ProtobufType = {
  wellKnown: (value) => {
    return {
      value,
      type: "wellKnown",
      _visit: function (visitor) {
        return ProtobufType._visit(this, visitor);
      }
    };
  },
  userDefined: (value) => {
    return {
      ...value,
      type: "userDefined",
      _visit: function (visitor) {
        return ProtobufType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "wellKnown":
        return visitor.wellKnown(value.value);
      case "userDefined":
        return visitor.userDefined(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/proto/types/WellKnownProtobufType.js
var WellKnownProtobufType = {
  any: () => {
    return {
      type: "any",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  api: () => {
    return {
      type: "api",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  boolValue: () => {
    return {
      type: "boolValue",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  bytesValue: () => {
    return {
      type: "bytesValue",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  doubleValue: () => {
    return {
      type: "doubleValue",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  duration: () => {
    return {
      type: "duration",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  empty: () => {
    return {
      type: "empty",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  enum: () => {
    return {
      type: "enum",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  enumValue: () => {
    return {
      type: "enumValue",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  field: () => {
    return {
      type: "field",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  fieldCardinality: () => {
    return {
      type: "fieldCardinality",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  fieldKind: () => {
    return {
      type: "fieldKind",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  fieldMask: () => {
    return {
      type: "fieldMask",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  floatValue: () => {
    return {
      type: "floatValue",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  int32Value: () => {
    return {
      type: "int32Value",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  int64Value: () => {
    return {
      type: "int64Value",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  listValue: () => {
    return {
      type: "listValue",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  method: () => {
    return {
      type: "method",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  mixin: () => {
    return {
      type: "mixin",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  nullValue: () => {
    return {
      type: "nullValue",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  option: () => {
    return {
      type: "option",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  sourceContext: () => {
    return {
      type: "sourceContext",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  stringValue: () => {
    return {
      type: "stringValue",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  struct: () => {
    return {
      type: "struct",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  syntax: () => {
    return {
      type: "syntax",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  timestamp: () => {
    return {
      type: "timestamp",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  type: () => {
    return {
      type: "type",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  uint32Value: () => {
    return {
      type: "uint32Value",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  uint64Value: () => {
    return {
      type: "uint64Value",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  value: () => {
    return {
      type: "value",
      _visit: function (visitor) {
        return WellKnownProtobufType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "any":
        return visitor.any();
      case "api":
        return visitor.api();
      case "boolValue":
        return visitor.boolValue();
      case "bytesValue":
        return visitor.bytesValue();
      case "doubleValue":
        return visitor.doubleValue();
      case "duration":
        return visitor.duration();
      case "empty":
        return visitor.empty();
      case "enum":
        return visitor.enum();
      case "enumValue":
        return visitor.enumValue();
      case "field":
        return visitor.field();
      case "fieldCardinality":
        return visitor.fieldCardinality();
      case "fieldKind":
        return visitor.fieldKind();
      case "fieldMask":
        return visitor.fieldMask();
      case "floatValue":
        return visitor.floatValue();
      case "int32Value":
        return visitor.int32Value();
      case "int64Value":
        return visitor.int64Value();
      case "listValue":
        return visitor.listValue();
      case "method":
        return visitor.method();
      case "mixin":
        return visitor.mixin();
      case "nullValue":
        return visitor.nullValue();
      case "option":
        return visitor.option();
      case "sourceContext":
        return visitor.sourceContext();
      case "stringValue":
        return visitor.stringValue();
      case "struct":
        return visitor.struct();
      case "syntax":
        return visitor.syntax();
      case "timestamp":
        return visitor.timestamp();
      case "type":
        return visitor.type();
      case "uint32Value":
        return visitor.uint32Value();
      case "uint64Value":
        return visitor.uint64Value();
      case "value":
        return visitor.value();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/Source.js
var Source = {
  proto: (value) => {
    return {
      value,
      type: "proto",
      _visit: function (visitor) {
        return Source._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "proto":
        return visitor.proto(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/Type.js
var Type = {
  alias: (value) => {
    return {
      ...value,
      type: "alias",
      _visit: function (visitor) {
        return Type._visit(this, visitor);
      }
    };
  },
  enum: (value) => {
    return {
      ...value,
      type: "enum",
      _visit: function (visitor) {
        return Type._visit(this, visitor);
      }
    };
  },
  object: (value) => {
    return {
      ...value,
      type: "object",
      _visit: function (visitor) {
        return Type._visit(this, visitor);
      }
    };
  },
  union: (value) => {
    return {
      ...value,
      type: "union",
      _visit: function (visitor) {
        return Type._visit(this, visitor);
      }
    };
  },
  undiscriminatedUnion: (value) => {
    return {
      ...value,
      type: "undiscriminatedUnion",
      _visit: function (visitor) {
        return Type._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "alias":
        return visitor.alias(value);
      case "enum":
        return visitor.enum(value);
      case "object":
        return visitor.object(value);
      case "union":
        return visitor.union(value);
      case "undiscriminatedUnion":
        return visitor.undiscriminatedUnion(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ResolvedTypeReference.js
var ResolvedTypeReference = {
  container: (value) => {
    return {
      container: value,
      type: "container",
      _visit: function (visitor) {
        return ResolvedTypeReference._visit(this, visitor);
      }
    };
  },
  named: (value) => {
    return {
      ...value,
      type: "named",
      _visit: function (visitor) {
        return ResolvedTypeReference._visit(this, visitor);
      }
    };
  },
  primitive: (value) => {
    return {
      primitive: value,
      type: "primitive",
      _visit: function (visitor) {
        return ResolvedTypeReference._visit(this, visitor);
      }
    };
  },
  unknown: () => {
    return {
      type: "unknown",
      _visit: function (visitor) {
        return ResolvedTypeReference._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "container":
        return visitor.container(value.container);
      case "named":
        return visitor.named(value);
      case "primitive":
        return visitor.primitive(value.primitive);
      case "unknown":
        return visitor.unknown();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ShapeType.js
var ShapeType = {
  Enum: "ENUM",
  Object: "OBJECT",
  Union: "UNION",
  UndiscriminatedUnion: "UNDISCRIMINATED_UNION",
  _visit: (value, visitor) => {
    switch (value) {
      case ShapeType.Enum:
        return visitor.enum();
      case ShapeType.Object:
        return visitor.object();
      case ShapeType.Union:
        return visitor.union();
      case ShapeType.UndiscriminatedUnion:
        return visitor.undiscriminatedUnion();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/SingleUnionTypeProperties.js
var SingleUnionTypeProperties = {
  samePropertiesAsObject: (value) => {
    return {
      ...value,
      propertiesType: "samePropertiesAsObject",
      _visit: function (visitor) {
        return SingleUnionTypeProperties._visit(this, visitor);
      }
    };
  },
  singleProperty: (value) => {
    return {
      ...value,
      propertiesType: "singleProperty",
      _visit: function (visitor) {
        return SingleUnionTypeProperties._visit(this, visitor);
      }
    };
  },
  noProperties: () => {
    return {
      propertiesType: "noProperties",
      _visit: function (visitor) {
        return SingleUnionTypeProperties._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.propertiesType) {
      case "samePropertiesAsObject":
        return visitor.samePropertiesAsObject(value);
      case "singleProperty":
        return visitor.singleProperty(value);
      case "noProperties":
        return visitor.noProperties();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/TypeReference.js
var TypeReference2 = {
  container: (value) => {
    return {
      container: value,
      type: "container",
      _visit: function (visitor) {
        return TypeReference2._visit(this, visitor);
      }
    };
  },
  named: (value) => {
    return {
      ...value,
      type: "named",
      _visit: function (visitor) {
        return TypeReference2._visit(this, visitor);
      }
    };
  },
  primitive: (value) => {
    return {
      primitive: value,
      type: "primitive",
      _visit: function (visitor) {
        return TypeReference2._visit(this, visitor);
      }
    };
  },
  unknown: () => {
    return {
      type: "unknown",
      _visit: function (visitor) {
        return TypeReference2._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "container":
        return visitor.container(value.container);
      case "named":
        return visitor.named(value);
      case "primitive":
        return visitor.primitive(value.primitive);
      case "unknown":
        return visitor.unknown();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ContainerType.js
var ContainerType = {
  list: (value) => {
    return {
      list: value,
      type: "list",
      _visit: function (visitor) {
        return ContainerType._visit(this, visitor);
      }
    };
  },
  map: (value) => {
    return {
      ...value,
      type: "map",
      _visit: function (visitor) {
        return ContainerType._visit(this, visitor);
      }
    };
  },
  optional: (value) => {
    return {
      optional: value,
      type: "optional",
      _visit: function (visitor) {
        return ContainerType._visit(this, visitor);
      }
    };
  },
  set: (value) => {
    return {
      set: value,
      type: "set",
      _visit: function (visitor) {
        return ContainerType._visit(this, visitor);
      }
    };
  },
  literal: (value) => {
    return {
      literal: value,
      type: "literal",
      _visit: function (visitor) {
        return ContainerType._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "list":
        return visitor.list(value.list);
      case "map":
        return visitor.map(value);
      case "optional":
        return visitor.optional(value.optional);
      case "set":
        return visitor.set(value.set);
      case "literal":
        return visitor.literal(value.literal);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/PrimitiveTypeV1.js
var PrimitiveTypeV1 = {
  Integer: "INTEGER",
  Long: "LONG",
  Uint: "UINT",
  Uint64: "UINT_64",
  Float: "FLOAT",
  Double: "DOUBLE",
  Boolean: "BOOLEAN",
  String: "STRING",
  Date: "DATE",
  DateTime: "DATE_TIME",
  Uuid: "UUID",
  Base64: "BASE_64",
  BigInteger: "BIG_INTEGER",
  _visit: (value, visitor) => {
    switch (value) {
      case PrimitiveTypeV1.Integer:
        return visitor.integer();
      case PrimitiveTypeV1.Long:
        return visitor.long();
      case PrimitiveTypeV1.Uint:
        return visitor.uint();
      case PrimitiveTypeV1.Uint64:
        return visitor.uint64();
      case PrimitiveTypeV1.Float:
        return visitor.float();
      case PrimitiveTypeV1.Double:
        return visitor.double();
      case PrimitiveTypeV1.Boolean:
        return visitor.boolean();
      case PrimitiveTypeV1.String:
        return visitor.string();
      case PrimitiveTypeV1.Date:
        return visitor.date();
      case PrimitiveTypeV1.DateTime:
        return visitor.dateTime();
      case PrimitiveTypeV1.Uuid:
        return visitor.uuid();
      case PrimitiveTypeV1.Base64:
        return visitor.base64();
      case PrimitiveTypeV1.BigInteger:
        return visitor.bigInteger();
      default:
        return visitor._other();
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/PrimitiveTypeV2.js
var PrimitiveTypeV2 = {
  integer: (value) => {
    return {
      ...value,
      type: "integer",
      _visit: function (visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  long: (value) => {
    return {
      ...value,
      type: "long",
      _visit: function (visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  uint: (value) => {
    return {
      ...value,
      type: "uint",
      _visit: function (visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  uint64: (value) => {
    return {
      ...value,
      type: "uint64",
      _visit: function (visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  float: (value) => {
    return {
      ...value,
      type: "float",
      _visit: function (visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  double: (value) => {
    return {
      ...value,
      type: "double",
      _visit: function (visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  boolean: (value) => {
    return {
      ...value,
      type: "boolean",
      _visit: function (visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      ...value,
      type: "string",
      _visit: function (visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  date: (value) => {
    return {
      ...value,
      type: "date",
      _visit: function (visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  dateTime: (value) => {
    return {
      ...value,
      type: "dateTime",
      _visit: function (visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  uuid: (value) => {
    return {
      ...value,
      type: "uuid",
      _visit: function (visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  base64: (value) => {
    return {
      ...value,
      type: "base64",
      _visit: function (visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  bigInteger: (value) => {
    return {
      ...value,
      type: "bigInteger",
      _visit: function (visitor) {
        return PrimitiveTypeV2._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "integer":
        return visitor.integer(value);
      case "long":
        return visitor.long(value);
      case "uint":
        return visitor.uint(value);
      case "uint64":
        return visitor.uint64(value);
      case "float":
        return visitor.float(value);
      case "double":
        return visitor.double(value);
      case "boolean":
        return visitor.boolean(value);
      case "string":
        return visitor.string(value);
      case "date":
        return visitor.date(value);
      case "dateTime":
        return visitor.dateTime(value);
      case "uuid":
        return visitor.uuid(value);
      case "base64":
        return visitor.base64(value);
      case "bigInteger":
        return visitor.bigInteger(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/Literal.js
var Literal = {
  string: (value) => {
    return {
      string: value,
      type: "string",
      _visit: function (visitor) {
        return Literal._visit(this, visitor);
      }
    };
  },
  boolean: (value) => {
    return {
      boolean: value,
      type: "boolean",
      _visit: function (visitor) {
        return Literal._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "string":
        return visitor.string(value.string);
      case "boolean":
        return visitor.boolean(value.boolean);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ExampleTypeShape.js
var ExampleTypeShape = {
  alias: (value) => {
    return {
      ...value,
      type: "alias",
      _visit: function (visitor) {
        return ExampleTypeShape._visit(this, visitor);
      }
    };
  },
  enum: (value) => {
    return {
      ...value,
      type: "enum",
      _visit: function (visitor) {
        return ExampleTypeShape._visit(this, visitor);
      }
    };
  },
  object: (value) => {
    return {
      ...value,
      type: "object",
      _visit: function (visitor) {
        return ExampleTypeShape._visit(this, visitor);
      }
    };
  },
  union: (value) => {
    return {
      ...value,
      type: "union",
      _visit: function (visitor) {
        return ExampleTypeShape._visit(this, visitor);
      }
    };
  },
  undiscriminatedUnion: (value) => {
    return {
      ...value,
      type: "undiscriminatedUnion",
      _visit: function (visitor) {
        return ExampleTypeShape._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "alias":
        return visitor.alias(value);
      case "enum":
        return visitor.enum(value);
      case "object":
        return visitor.object(value);
      case "union":
        return visitor.union(value);
      case "undiscriminatedUnion":
        return visitor.undiscriminatedUnion(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ExampleSingleUnionTypeProperties.js
var ExampleSingleUnionTypeProperties = {
  samePropertiesAsObject: (value) => {
    return {
      ...value,
      type: "samePropertiesAsObject",
      _visit: function (visitor) {
        return ExampleSingleUnionTypeProperties._visit(this, visitor);
      }
    };
  },
  singleProperty: (value) => {
    return {
      ...value,
      type: "singleProperty",
      _visit: function (visitor) {
        return ExampleSingleUnionTypeProperties._visit(this, visitor);
      }
    };
  },
  noProperties: () => {
    return {
      type: "noProperties",
      _visit: function (visitor) {
        return ExampleSingleUnionTypeProperties._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "samePropertiesAsObject":
        return visitor.samePropertiesAsObject(value);
      case "singleProperty":
        return visitor.singleProperty(value);
      case "noProperties":
        return visitor.noProperties();
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ExampleTypeReferenceShape.js
var ExampleTypeReferenceShape = {
  primitive: (value) => {
    return {
      primitive: value,
      type: "primitive",
      _visit: function (visitor) {
        return ExampleTypeReferenceShape._visit(this, visitor);
      }
    };
  },
  container: (value) => {
    return {
      container: value,
      type: "container",
      _visit: function (visitor) {
        return ExampleTypeReferenceShape._visit(this, visitor);
      }
    };
  },
  unknown: (value) => {
    return {
      unknown: value,
      type: "unknown",
      _visit: function (visitor) {
        return ExampleTypeReferenceShape._visit(this, visitor);
      }
    };
  },
  named: (value) => {
    return {
      ...value,
      type: "named",
      _visit: function (visitor) {
        return ExampleTypeReferenceShape._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "primitive":
        return visitor.primitive(value.primitive);
      case "container":
        return visitor.container(value.container);
      case "unknown":
        return visitor.unknown(value.unknown);
      case "named":
        return visitor.named(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ExampleContainer.js
var ExampleContainer = {
  list: (value) => {
    return {
      ...value,
      type: "list",
      _visit: function (visitor) {
        return ExampleContainer._visit(this, visitor);
      }
    };
  },
  set: (value) => {
    return {
      ...value,
      type: "set",
      _visit: function (visitor) {
        return ExampleContainer._visit(this, visitor);
      }
    };
  },
  optional: (value) => {
    return {
      ...value,
      type: "optional",
      _visit: function (visitor) {
        return ExampleContainer._visit(this, visitor);
      }
    };
  },
  map: (value) => {
    return {
      ...value,
      type: "map",
      _visit: function (visitor) {
        return ExampleContainer._visit(this, visitor);
      }
    };
  },
  literal: (value) => {
    return {
      ...value,
      type: "literal",
      _visit: function (visitor) {
        return ExampleContainer._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "list":
        return visitor.list(value);
      case "set":
        return visitor.set(value);
      case "optional":
        return visitor.optional(value);
      case "map":
        return visitor.map(value);
      case "literal":
        return visitor.literal(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/types/types/ExamplePrimitive.js
var ExamplePrimitive = {
  integer: (value) => {
    return {
      integer: value,
      type: "integer",
      _visit: function (visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  long: (value) => {
    return {
      long: value,
      type: "long",
      _visit: function (visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  uint: (value) => {
    return {
      uint: value,
      type: "uint",
      _visit: function (visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  uint64: (value) => {
    return {
      uint64: value,
      type: "uint64",
      _visit: function (visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  float: (value) => {
    return {
      float: value,
      type: "float",
      _visit: function (visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  double: (value) => {
    return {
      double: value,
      type: "double",
      _visit: function (visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  boolean: (value) => {
    return {
      boolean: value,
      type: "boolean",
      _visit: function (visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      string: value,
      type: "string",
      _visit: function (visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  date: (value) => {
    return {
      date: value,
      type: "date",
      _visit: function (visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  datetime: (value) => {
    return {
      ...value,
      type: "datetime",
      _visit: function (visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  uuid: (value) => {
    return {
      uuid: value,
      type: "uuid",
      _visit: function (visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  base64: (value) => {
    return {
      base64: value,
      type: "base64",
      _visit: function (visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  bigInteger: (value) => {
    return {
      bigInteger: value,
      type: "bigInteger",
      _visit: function (visitor) {
        return ExamplePrimitive._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "integer":
        return visitor.integer(value.integer);
      case "long":
        return visitor.long(value.long);
      case "uint":
        return visitor.uint(value.uint);
      case "uint64":
        return visitor.uint64(value.uint64);
      case "float":
        return visitor.float(value.float);
      case "double":
        return visitor.double(value.double);
      case "boolean":
        return visitor.boolean(value.boolean);
      case "string":
        return visitor.string(value.string);
      case "date":
        return visitor.date(value.date);
      case "datetime":
        return visitor.datetime(value);
      case "uuid":
        return visitor.uuid(value.uuid);
      case "base64":
        return visitor.base64(value.base64);
      case "bigInteger":
        return visitor.bigInteger(value.bigInteger);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/webhooks/types/WebhookPayload.js
var WebhookPayload = {
  inlinedPayload: (value) => {
    return {
      ...value,
      type: "inlinedPayload",
      _visit: function (visitor) {
        return WebhookPayload._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function (visitor) {
        return WebhookPayload._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "inlinedPayload":
        return visitor.inlinedPayload(value);
      case "reference":
        return visitor.reference(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/websocket/types/WebSocketMessageBody.js
var WebSocketMessageBody = {
  inlinedBody: (value) => {
    return {
      ...value,
      type: "inlinedBody",
      _visit: function (visitor) {
        return WebSocketMessageBody._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function (visitor) {
        return WebSocketMessageBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "inlinedBody":
        return visitor.inlinedBody(value);
      case "reference":
        return visitor.reference(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../ir-sdk/lib/sdk/api/resources/websocket/types/ExampleWebSocketMessageBody.js
var ExampleWebSocketMessageBody = {
  inlinedBody: (value) => {
    return {
      ...value,
      type: "inlinedBody",
      _visit: function (visitor) {
        return ExampleWebSocketMessageBody._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function (visitor) {
        return ExampleWebSocketMessageBody._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "inlinedBody":
        return visitor.inlinedBody(value);
      case "reference":
        return visitor.reference(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/fern-definition/schema/lib/constants.js
var EXAMPLE_REFERENCE_PREFIX = "$";

// ../../cli/fern-definition/schema/lib/schemas/index.js
var schemas_exports3 = {};
__export(schemas_exports3, {
  AvailabilityStatusSchema: () => AvailabilityStatusSchema3,
  FernDefinitionError: () => FernDefinitionError,
  FernDefinitionTimeoutError: () => FernDefinitionTimeoutError,
  HttpMethodSchema: () => HttpMethodSchema,
  StreamFormat: () => StreamFormat,
  SupportedSdkLanguageSchema: () => SupportedSdkLanguageSchema,
  WebSocketOrigin: () => WebSocketOrigin,
  WebhookMethodSchema: () => WebhookMethodSchema,
  auth: () => auth_exports5,
  availability: () => availability_exports3,
  commons: () => commons_exports4,
  encoding: () => encoding_exports3,
  environments: () => environments_exports3,
  errors: () => errors_exports2,
  examples: () => examples_exports2,
  file: () => file_exports3,
  pagination: () => pagination_exports,
  serialization: () => serialization_exports2,
  service: () => service_exports3,
  source: () => source_exports,
  types: () => types_exports5,
  validation: () => validation_exports3,
  variables: () => variables_exports2,
  versioning: () => versioning_exports,
  webhooks: () => webhooks_exports2,
  websocket: () => websocket_exports2
});

// ../../cli/fern-definition/schema/lib/schemas/api/resources/auth/index.js
var auth_exports5 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/availability/index.js
var availability_exports3 = {};
__export(availability_exports3, {
  AvailabilityStatusSchema: () => AvailabilityStatusSchema3
});

// ../../cli/fern-definition/schema/lib/schemas/api/resources/availability/types/AvailabilityStatusSchema.js
var AvailabilityStatusSchema3 = {
  InDevelopment: "in-development",
  PreRelease: "pre-release",
  Deprecated: "deprecated",
  GenerallyAvailable: "generally-available"
};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/commons/index.js
var commons_exports4 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/encoding/index.js
var encoding_exports3 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/environments/index.js
var environments_exports3 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/errors/index.js
var errors_exports2 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/examples/index.js
var examples_exports2 = {};
__export(examples_exports2, {
  SupportedSdkLanguageSchema: () => SupportedSdkLanguageSchema
});

// ../../cli/fern-definition/schema/lib/schemas/api/resources/examples/types/SupportedSdkLanguageSchema.js
var SupportedSdkLanguageSchema = {
  Curl: "curl",
  Python: "python",
  Javascript: "javascript",
  Typescript: "typescript",
  Go: "go",
  Ruby: "ruby",
  Csharp: "csharp",
  Java: "java",
  Js: "js",
  Node: "node",
  Ts: "ts",
  Nodets: "nodets",
  Golang: "golang",
  Dotnet: "dotnet",
  Jvm: "jvm",
  Csharp2: "c#"
};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/file/index.js
var file_exports3 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/pagination/index.js
var pagination_exports = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/service/index.js
var service_exports3 = {};
__export(service_exports3, {
  HttpMethodSchema: () => HttpMethodSchema,
  StreamFormat: () => StreamFormat
});

// ../../cli/fern-definition/schema/lib/schemas/api/resources/service/types/HttpMethodSchema.js
var HttpMethodSchema = {
  Get: "GET",
  Post: "POST",
  Put: "PUT",
  Patch: "PATCH",
  Delete: "DELETE"
};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/service/types/StreamFormat.js
var StreamFormat = {
  Sse: "sse",
  Json: "json"
};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/source/index.js
var source_exports = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/types/index.js
var types_exports5 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/validation/index.js
var validation_exports3 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/variables/index.js
var variables_exports2 = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/versioning/index.js
var versioning_exports = {};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/webhooks/index.js
var webhooks_exports2 = {};
__export(webhooks_exports2, {
  WebhookMethodSchema: () => WebhookMethodSchema
});

// ../../cli/fern-definition/schema/lib/schemas/api/resources/webhooks/types/WebhookMethodSchema.js
var WebhookMethodSchema = {
  Post: "POST",
  Get: "GET"
};

// ../../cli/fern-definition/schema/lib/schemas/api/resources/websocket/index.js
var websocket_exports2 = {};
__export(websocket_exports2, {
  WebSocketOrigin: () => WebSocketOrigin
});

// ../../cli/fern-definition/schema/lib/schemas/api/resources/websocket/types/WebSocketOrigin.js
var WebSocketOrigin = {
  Client: "client",
  Server: "server"
};

// ../../cli/fern-definition/schema/lib/schemas/serialization/index.js
var serialization_exports2 = {};
__export(serialization_exports2, {
  AliasSchema: () => AliasSchema,
  AnyAuthItem: () => AnyAuthItem2,
  AnyAuthSchemesSchema: () => AnyAuthSchemesSchema2,
  ApiAuthSchema: () => ApiAuthSchema2,
  AuthSchemeDeclarationSchema: () => AuthSchemeDeclarationSchema2,
  AuthSchemeReferenceSchema: () => AuthSchemeReferenceSchema2,
  AuthVariable: () => AuthVariable2,
  AvailabilitySchema: () => AvailabilitySchema2,
  AvailabilityStatusSchema: () => AvailabilityStatusSchema4,
  AvailabilityUnionSchema: () => AvailabilityUnionSchema2,
  BaseTypeDeclarationSchema: () => BaseTypeDeclarationSchema,
  BaseTypeReferenceSchema: () => BaseTypeReferenceSchema2,
  BasicAuthSchemeSchema: () => BasicAuthSchemeSchema2,
  BearerAuthSchemeSchema: () => BearerAuthSchemeSchema2,
  CasingOverridesSchema: () => CasingOverridesSchema,
  CursorPaginationSchema: () => CursorPaginationSchema,
  DeclarationSchema: () => DeclarationSchema,
  DeclarationWithNameSchema: () => DeclarationWithNameSchema,
  DeclarationWithoutDocsSchema: () => DeclarationWithoutDocsSchema,
  DefinitionFileSchema: () => DefinitionFileSchema,
  DiscriminatedUnionSchema: () => DiscriminatedUnionSchema,
  EncodingSchema: () => EncodingSchema2,
  EnumSchema: () => EnumSchema,
  EnumValue: () => EnumValue,
  EnumValueSchema: () => EnumValueSchema,
  EnvironmentSchema: () => EnvironmentSchema2,
  ErrorDeclarationSchema: () => ErrorDeclarationSchema,
  ErrorDiscriminationSchema: () => ErrorDiscriminationSchema,
  ExampleBodyResponseSchema: () => ExampleBodyResponseSchema,
  ExampleCodeSampleSchema: () => ExampleCodeSampleSchema,
  ExampleCodeSampleSchemaLanguage: () => ExampleCodeSampleSchemaLanguage,
  ExampleCodeSampleSchemaSdk: () => ExampleCodeSampleSchemaSdk,
  ExampleEndpointCallArraySchema: () => ExampleEndpointCallArraySchema,
  ExampleEndpointCallSchema: () => ExampleEndpointCallSchema,
  ExampleResponseSchema: () => ExampleResponseSchema,
  ExampleSseEventSchema: () => ExampleSseEventSchema,
  ExampleSseResponseSchema: () => ExampleSseResponseSchema,
  ExampleStreamResponseSchema: () => ExampleStreamResponseSchema,
  ExampleTypeReferenceSchema: () => ExampleTypeReferenceSchema,
  ExampleTypeSchema: () => ExampleTypeSchema,
  ExampleTypeValueSchema: () => ExampleTypeValueSchema,
  ExampleWebSocketMessage: () => ExampleWebSocketMessage,
  ExampleWebSocketSession: () => ExampleWebSocketSession,
  ExampleWebhookCallSchema: () => ExampleWebhookCallSchema,
  Export: () => Export,
  ExportDetailed: () => ExportDetailed,
  GrpcTransport: () => GrpcTransport,
  HeaderAuthSchemeSchema: () => HeaderAuthSchemeSchema2,
  HttpEndpointSchema: () => HttpEndpointSchema,
  HttpHeaderSchema: () => HttpHeaderSchema2,
  HttpInlineRequestBodyPropertySchema: () => HttpInlineRequestBodyPropertySchema,
  HttpInlineRequestBodySchema: () => HttpInlineRequestBodySchema,
  HttpMethodSchema: () => HttpMethodSchema2,
  HttpPathParameterSchema: () => HttpPathParameterSchema,
  HttpQueryParameterSchema: () => HttpQueryParameterSchema,
  HttpReferencedRequestBodySchema: () => HttpReferencedRequestBodySchema,
  HttpRequest: () => HttpRequest,
  HttpRequestBodySchema: () => HttpRequestBodySchema,
  HttpRequestSchema: () => HttpRequestSchema,
  HttpResponseSchema: () => HttpResponseSchema,
  HttpResponseSchemaDetailed: () => HttpResponseSchemaDetailed,
  HttpResponseStreamSchema: () => HttpResponseStreamSchema,
  HttpResponseStreamSchemaDetailed: () => HttpResponseStreamSchemaDetailed,
  HttpServiceSchema: () => HttpServiceSchema,
  MultipleBaseUrlsEnvironmentSchema: () => MultipleBaseUrlsEnvironmentSchema2,
  Navigation: () => Navigation,
  NumberValidationSchema: () => NumberValidationSchema2,
  OAuthAccessTokenRequestPropertiesSchema: () => OAuthAccessTokenRequestPropertiesSchema2,
  OAuthAccessTokenResponsePropertiesSchema: () => OAuthAccessTokenResponsePropertiesSchema2,
  OAuthGetTokenEndpointSchema: () => OAuthGetTokenEndpointSchema2,
  OAuthRefreshTokenEndpointSchema: () => OAuthRefreshTokenEndpointSchema2,
  OAuthRefreshTokenRequestPropertiesSchema: () => OAuthRefreshTokenRequestPropertiesSchema2,
  OAuthRefreshTokenResponsePropertiesSchema: () => OAuthRefreshTokenResponsePropertiesSchema2,
  OAuthSchemeSchema: () => OAuthSchemeSchema2,
  ObjectExtendsSchema: () => ObjectExtendsSchema,
  ObjectPropertySchema: () => ObjectPropertySchema,
  ObjectSchema: () => ObjectSchema,
  OffsetPaginationSchema: () => OffsetPaginationSchema,
  OpenApiSourceSchema: () => OpenApiSourceSchema,
  PackageMarkerFileSchema: () => PackageMarkerFileSchema,
  Pagination: () => Pagination2,
  PaginationSchema: () => PaginationSchema,
  PropertyBasedErrorDiscrimination: () => PropertyBasedErrorDiscrimination,
  ProtobufSourceSchema: () => ProtobufSourceSchema,
  ProtobufTypeSchema: () => ProtobufTypeSchema2,
  QueryParameterTypeReferenceDetailed: () => QueryParameterTypeReferenceDetailed,
  ResponseError: () => ResponseError,
  ResponseErrorWithDocsSchema: () => ResponseErrorWithDocsSchema,
  ResponseErrorsSchema: () => ResponseErrorsSchema,
  RootApiFileSchema: () => RootApiFileSchema,
  ServiceTransport: () => ServiceTransport,
  SingleBaseUrlEnvironmentSchema: () => SingleBaseUrlEnvironmentSchema2,
  SingleUndiscriminatedUnionTypeDetailedSchema: () => SingleUndiscriminatedUnionTypeDetailedSchema,
  SingleUndiscriminatedUnionTypeSchema: () => SingleUndiscriminatedUnionTypeSchema,
  SingleUnionTypeDetailedSchema: () => SingleUnionTypeDetailedSchema,
  SingleUnionTypeKey: () => SingleUnionTypeKey,
  SingleUnionTypeKeySchema: () => SingleUnionTypeKeySchema,
  SingleUnionTypeSchema: () => SingleUnionTypeSchema,
  SourceSchema: () => SourceSchema,
  StatusCodeBasedErrorDiscrimination: () => StatusCodeBasedErrorDiscrimination,
  StreamFormat: () => StreamFormat2,
  StringValidationSchema: () => StringValidationSchema2,
  SupportedSdkLanguageSchema: () => SupportedSdkLanguageSchema2,
  TypeDeclarationSchema: () => TypeDeclarationSchema,
  TypeReferenceDeclarationWithContentTypeSchema: () => TypeReferenceDeclarationWithContentTypeSchema,
  TypeReferenceDeclarationWithEnvOverride: () => TypeReferenceDeclarationWithEnvOverride2,
  TypeReferenceDeclarationWithEnvOverrideSchema: () => TypeReferenceDeclarationWithEnvOverrideSchema2,
  TypeReferenceDeclarationWithName: () => TypeReferenceDeclarationWithName2,
  TypeReferenceDeclarationWithNameSchema: () => TypeReferenceDeclarationWithNameSchema,
  TypeReferenceDetailedSchema: () => TypeReferenceDetailedSchema,
  TypeReferenceSchema: () => TypeReferenceSchema,
  UndiscriminatedUnionSchema: () => UndiscriminatedUnionSchema,
  UnionDiscriminant: () => UnionDiscriminant,
  UnionDiscriminantSchema: () => UnionDiscriminantSchema,
  ValidationSchema: () => ValidationSchema2,
  VariableDeclarationDetailed: () => VariableDeclarationDetailed,
  VariableDeclarationSchema: () => VariableDeclarationSchema,
  VariableReferenceSchema: () => VariableReferenceSchema,
  VersionDeclarationHeaderObjectSchema: () => VersionDeclarationHeaderObjectSchema,
  VersionDeclarationHeaderSchema: () => VersionDeclarationHeaderSchema,
  VersionDeclarationSchema: () => VersionDeclarationSchema,
  VersionValue: () => VersionValue,
  VersionValueDetailed: () => VersionValueDetailed,
  WebSocketChannelInlinedMessageSchema: () => WebSocketChannelInlinedMessageSchema,
  WebSocketChannelMessageBodySchema: () => WebSocketChannelMessageBodySchema,
  WebSocketChannelMessageSchema: () => WebSocketChannelMessageSchema,
  WebSocketChannelReferencedMessageSchema: () => WebSocketChannelReferencedMessageSchema,
  WebSocketChannelSchema: () => WebSocketChannelSchema,
  WebSocketOrigin: () => WebSocketOrigin2,
  WebhookInlinedPayloadSchema: () => WebhookInlinedPayloadSchema,
  WebhookMethodSchema: () => WebhookMethodSchema2,
  WebhookPayloadSchema: () => WebhookPayloadSchema,
  WebhookReferencedPayloadSchema: () => WebhookReferencedPayloadSchema,
  WebhookSchema: () => WebhookSchema,
  WithAudiences: () => WithAudiences2,
  WithAuthSchema: () => WithAuthSchema,
  WithAvailability: () => WithAvailability2,
  WithDisplayName: () => WithDisplayName,
  WithDocsSchema: () => WithDocsSchema2,
  WithEnvironmentVariable: () => WithEnvironmentVariable2,
  WithEnvironmentsSchema: () => WithEnvironmentsSchema2,
  WithHeadersSchema: () => WithHeadersSchema2,
  WithName: () => WithName2,
  auth: () => auth_exports6,
  availability: () => availability_exports4,
  commons: () => commons_exports5,
  encoding: () => encoding_exports4,
  environments: () => environments_exports4,
  errors: () => errors_exports3,
  examples: () => examples_exports3,
  file: () => file_exports4,
  pagination: () => pagination_exports2,
  service: () => service_exports4,
  source: () => source_exports2,
  types: () => types_exports6,
  validation: () => validation_exports4,
  variables: () => variables_exports3,
  versioning: () => versioning_exports2,
  webhooks: () => webhooks_exports3,
  websocket: () => websocket_exports3
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/index.js
var auth_exports6 = {};
__export(auth_exports6, {
  AnyAuthItem: () => AnyAuthItem2,
  AnyAuthSchemesSchema: () => AnyAuthSchemesSchema2,
  ApiAuthSchema: () => ApiAuthSchema2,
  AuthSchemeDeclarationSchema: () => AuthSchemeDeclarationSchema2,
  AuthSchemeReferenceSchema: () => AuthSchemeReferenceSchema2,
  AuthVariable: () => AuthVariable2,
  BasicAuthSchemeSchema: () => BasicAuthSchemeSchema2,
  BearerAuthSchemeSchema: () => BearerAuthSchemeSchema2,
  HeaderAuthSchemeSchema: () => HeaderAuthSchemeSchema2,
  OAuthAccessTokenRequestPropertiesSchema: () => OAuthAccessTokenRequestPropertiesSchema2,
  OAuthAccessTokenResponsePropertiesSchema: () => OAuthAccessTokenResponsePropertiesSchema2,
  OAuthGetTokenEndpointSchema: () => OAuthGetTokenEndpointSchema2,
  OAuthRefreshTokenEndpointSchema: () => OAuthRefreshTokenEndpointSchema2,
  OAuthRefreshTokenRequestPropertiesSchema: () => OAuthRefreshTokenRequestPropertiesSchema2,
  OAuthRefreshTokenResponsePropertiesSchema: () => OAuthRefreshTokenResponsePropertiesSchema2,
  OAuthSchemeSchema: () => OAuthSchemeSchema2,
  WithAuthSchema: () => WithAuthSchema,
  WithEnvironmentVariable: () => WithEnvironmentVariable2
});

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/index.js
var schemas_exports2 = {};
__export(schemas_exports2, {
  JsonError: () => JsonError2,
  ParseError: () => ParseError2,
  any: () => any2,
  boolean: () => boolean2,
  booleanLiteral: () => booleanLiteral2,
  date: () => date2,
  discriminant: () => discriminant2,
  enum_: () => enum_2,
  getObjectLikeUtils: () => getObjectLikeUtils2,
  getObjectUtils: () => getObjectUtils2,
  getSchemaUtils: () => getSchemaUtils2,
  isProperty: () => isProperty2,
  lazy: () => lazy2,
  lazyObject: () => lazyObject2,
  list: () => list2,
  number: () => number2,
  object: () => object2,
  objectWithoutOptionalProperties: () => objectWithoutOptionalProperties2,
  optional: () => optional2,
  property: () => property3,
  record: () => record2,
  set: () => set2,
  string: () => string2,
  stringLiteral: () => stringLiteral2,
  transform: () => transform2,
  undiscriminatedUnion: () => undiscriminatedUnion2,
  union: () => union2,
  unknown: () => unknown2,
  withParsedProperties: () => withParsedProperties2
});

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/Schema.js
var SchemaType2 = {
  DATE: "date",
  ENUM: "enum",
  LIST: "list",
  STRING_LITERAL: "stringLiteral",
  BOOLEAN_LITERAL: "booleanLiteral",
  OBJECT: "object",
  ANY: "any",
  BOOLEAN: "boolean",
  NUMBER: "number",
  STRING: "string",
  UNKNOWN: "unknown",
  RECORD: "record",
  SET: "set",
  UNION: "union",
  UNDISCRIMINATED_UNION: "undiscriminatedUnion",
  OPTIONAL: "optional"
};

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/getErrorMessageForIncorrectType.js
function getErrorMessageForIncorrectType2(value, expectedType) {
  return `Expected ${expectedType}. Received ${getTypeAsString2(value)}.`;
}
function getTypeAsString2(value) {
  if (Array.isArray(value)) {
    return "list";
  }
  if (value === null) {
    return "null";
  }
  switch (typeof value) {
    case "string":
      return `"${value}"`;
    case "number":
    case "boolean":
    case "undefined":
      return `${value}`;
  }
  return typeof value;
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/maybeSkipValidation.js
function maybeSkipValidation2(schema2) {
  return {
    ...schema2,
    json: transformAndMaybeSkipValidation2(schema2.json),
    parse: transformAndMaybeSkipValidation2(schema2.parse)
  };
}
function transformAndMaybeSkipValidation2(transform3) {
  return (value, opts) => {
    const transformed = transform3(value, opts);
    const { skipValidation = false } = opts ?? {};
    if (!transformed.ok && skipValidation) {
      console.warn([
        "Failed to validate.",
        ...transformed.errors.map((error) => "  - " + (error.path.length > 0 ? `${error.path.join(".")}: ${error.message}` : error.message))
      ].join("\n"));
      return {
        ok: true,
        value
      };
    } else {
      return transformed;
    }
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/schema-utils/stringifyValidationErrors.js
function stringifyValidationError2(error) {
  if (error.path.length === 0) {
    return error.message;
  }
  return `${error.path.join(" -> ")}: ${error.message}`;
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/schema-utils/JsonError.js
var JsonError2 = class _JsonError extends Error {
  errors;
  constructor(errors) {
    super(errors.map(stringifyValidationError2).join("; "));
    this.errors = errors;
    Object.setPrototypeOf(this, _JsonError.prototype);
  }
};

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/schema-utils/ParseError.js
var ParseError2 = class _ParseError extends Error {
  errors;
  constructor(errors) {
    super(errors.map(stringifyValidationError2).join("; "));
    this.errors = errors;
    Object.setPrototypeOf(this, _ParseError.prototype);
  }
};

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/schema-utils/getSchemaUtils.js
function getSchemaUtils2(schema2) {
  return {
    optional: () => optional2(schema2),
    transform: (transformer) => transform2(schema2, transformer),
    parseOrThrow: (raw, opts) => {
      const parsed = schema2.parse(raw, opts);
      if (parsed.ok) {
        return parsed.value;
      }
      throw new ParseError2(parsed.errors);
    },
    jsonOrThrow: (parsed, opts) => {
      const raw = schema2.json(parsed, opts);
      if (raw.ok) {
        return raw.value;
      }
      throw new JsonError2(raw.errors);
    }
  };
}
function optional2(schema2) {
  const baseSchema = {
    parse: (raw, opts) => {
      if (raw == null) {
        return {
          ok: true,
          value: void 0
        };
      }
      return schema2.parse(raw, opts);
    },
    json: (parsed, opts) => {
      if (opts?.omitUndefined && parsed === void 0) {
        return {
          ok: true,
          value: void 0
        };
      }
      if (parsed == null) {
        return {
          ok: true,
          value: null
        };
      }
      return schema2.json(parsed, opts);
    },
    getType: () => SchemaType2.OPTIONAL
  };
  return {
    ...baseSchema,
    ...getSchemaUtils2(baseSchema)
  };
}
function transform2(schema2, transformer) {
  const baseSchema = {
    parse: (raw, opts) => {
      const parsed = schema2.parse(raw, opts);
      if (!parsed.ok) {
        return parsed;
      }
      return {
        ok: true,
        value: transformer.transform(parsed.value)
      };
    },
    json: (transformed, opts) => {
      const parsed = transformer.untransform(transformed);
      return schema2.json(parsed, opts);
    },
    getType: () => schema2.getType()
  };
  return {
    ...baseSchema,
    ...getSchemaUtils2(baseSchema)
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/date/date.js
var ISO_8601_REGEX2 = /^([+-]?\d{4}(?!\d{2}\b))((-?)((0[1-9]|1[0-2])(\3([12]\d|0[1-9]|3[01]))?|W([0-4]\d|5[0-2])(-?[1-7])?|(00[1-9]|0[1-9]\d|[12]\d{2}|3([0-5]\d|6[1-6])))([T\s]((([01]\d|2[0-3])((:?)[0-5]\d)?|24:?00)([.,]\d+(?!:))?)?(\17[0-5]\d([.,]\d+)?)?([zZ]|([+-])([01]\d|2[0-3]):?([0-5]\d)?)?)?)?$/;
function date2() {
  const baseSchema = {
    parse: (raw, { breadcrumbsPrefix = [] } = {}) => {
      if (typeof raw !== "string") {
        return {
          ok: false,
          errors: [
            {
              path: breadcrumbsPrefix,
              message: getErrorMessageForIncorrectType2(raw, "string")
            }
          ]
        };
      }
      if (!ISO_8601_REGEX2.test(raw)) {
        return {
          ok: false,
          errors: [
            {
              path: breadcrumbsPrefix,
              message: getErrorMessageForIncorrectType2(raw, "ISO 8601 date string")
            }
          ]
        };
      }
      return {
        ok: true,
        value: new Date(raw)
      };
    },
    json: (date3, { breadcrumbsPrefix = [] } = {}) => {
      if (date3 instanceof Date) {
        return {
          ok: true,
          value: date3.toISOString()
        };
      } else {
        return {
          ok: false,
          errors: [
            {
              path: breadcrumbsPrefix,
              message: getErrorMessageForIncorrectType2(date3, "Date object")
            }
          ]
        };
      }
    },
    getType: () => SchemaType2.DATE
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema)
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/createIdentitySchemaCreator.js
function createIdentitySchemaCreator2(schemaType, validate) {
  return () => {
    const baseSchema = {
      parse: validate,
      json: validate,
      getType: () => schemaType
    };
    return {
      ...maybeSkipValidation2(baseSchema),
      ...getSchemaUtils2(baseSchema)
    };
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/enum/enum.js
function enum_2(values) {
  const validValues = new Set(values);
  const schemaCreator = createIdentitySchemaCreator2(SchemaType2.ENUM, (value, { allowUnrecognizedEnumValues, breadcrumbsPrefix = [] } = {}) => {
    if (typeof value !== "string") {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType2(value, "string")
          }
        ]
      };
    }
    if (!validValues.has(value) && !allowUnrecognizedEnumValues) {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType2(value, "enum")
          }
        ]
      };
    }
    return {
      ok: true,
      value
    };
  });
  return schemaCreator();
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/lazy/lazy.js
function lazy2(getter) {
  const baseSchema = constructLazyBaseSchema2(getter);
  return {
    ...baseSchema,
    ...getSchemaUtils2(baseSchema)
  };
}
function constructLazyBaseSchema2(getter) {
  return {
    parse: (raw, opts) => getMemoizedSchema2(getter).parse(raw, opts),
    json: (parsed, opts) => getMemoizedSchema2(getter).json(parsed, opts),
    getType: () => getMemoizedSchema2(getter).getType()
  };
}
function getMemoizedSchema2(getter) {
  const castedGetter = getter;
  if (castedGetter.__zurg_memoized == null) {
    castedGetter.__zurg_memoized = getter();
  }
  return castedGetter.__zurg_memoized;
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/entries.js
function entries3(object3) {
  return Object.entries(object3);
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/filterObject.js
function filterObject2(obj, keysToInclude) {
  const keysToIncludeSet = new Set(keysToInclude);
  return Object.entries(obj).reduce((acc, [key, value]) => {
    if (keysToIncludeSet.has(key)) {
      acc[key] = value;
    }
    return acc;
  }, {});
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/isPlainObject.js
function isPlainObject4(value) {
  if (typeof value !== "object" || value === null) {
    return false;
  }
  if (Object.getPrototypeOf(value) === null) {
    return true;
  }
  let proto = value;
  while (Object.getPrototypeOf(proto) !== null) {
    proto = Object.getPrototypeOf(proto);
  }
  return Object.getPrototypeOf(value) === proto;
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/keys.js
function keys4(object3) {
  return Object.keys(object3);
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/utils/partition.js
function partition2(items, predicate) {
  const trueItems = [], falseItems = [];
  for (const item of items) {
    if (predicate(item)) {
      trueItems.push(item);
    } else {
      falseItems.push(item);
    }
  }
  return [trueItems, falseItems];
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/object-like/getObjectLikeUtils.js
function getObjectLikeUtils2(schema2) {
  return {
    withParsedProperties: (properties) => withParsedProperties2(schema2, properties)
  };
}
function withParsedProperties2(objectLike, properties) {
  const objectSchema = {
    parse: (raw, opts) => {
      const parsedObject = objectLike.parse(raw, opts);
      if (!parsedObject.ok) {
        return parsedObject;
      }
      const additionalProperties = Object.entries(properties).reduce((processed, [key, value]) => {
        return {
          ...processed,
          [key]: typeof value === "function" ? value(parsedObject.value) : value
        };
      }, {});
      return {
        ok: true,
        value: {
          ...parsedObject.value,
          ...additionalProperties
        }
      };
    },
    json: (parsed, opts) => {
      if (!isPlainObject4(parsed)) {
        return {
          ok: false,
          errors: [
            {
              path: opts?.breadcrumbsPrefix ?? [],
              message: getErrorMessageForIncorrectType2(parsed, "object")
            }
          ]
        };
      }
      const addedPropertyKeys = new Set(Object.keys(properties));
      const parsedWithoutAddedProperties = filterObject2(parsed, Object.keys(parsed).filter((key) => !addedPropertyKeys.has(key)));
      return objectLike.json(parsedWithoutAddedProperties, opts);
    },
    getType: () => objectLike.getType()
  };
  return {
    ...objectSchema,
    ...getSchemaUtils2(objectSchema),
    ...getObjectLikeUtils2(objectSchema)
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/object/property.js
function property3(rawKey, valueSchema) {
  return {
    rawKey,
    valueSchema,
    isProperty: true
  };
}
function isProperty2(maybeProperty) {
  return maybeProperty.isProperty;
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/object/object.js
function object2(schemas) {
  const baseSchema = {
    _getRawProperties: () => Object.entries(schemas).map(([parsedKey, propertySchema]) => isProperty2(propertySchema) ? propertySchema.rawKey : parsedKey),
    _getParsedProperties: () => keys4(schemas),
    parse: (raw, opts) => {
      const rawKeyToProperty = {};
      const requiredKeys = [];
      for (const [parsedKey, schemaOrObjectProperty] of entries3(schemas)) {
        const rawKey = isProperty2(schemaOrObjectProperty) ? schemaOrObjectProperty.rawKey : parsedKey;
        const valueSchema = isProperty2(schemaOrObjectProperty) ? schemaOrObjectProperty.valueSchema : schemaOrObjectProperty;
        const property4 = {
          rawKey,
          parsedKey,
          valueSchema
        };
        rawKeyToProperty[rawKey] = property4;
        if (isSchemaRequired2(valueSchema)) {
          requiredKeys.push(rawKey);
        }
      }
      return validateAndTransformObject2({
        value: raw,
        requiredKeys,
        getProperty: (rawKey) => {
          const property4 = rawKeyToProperty[rawKey];
          if (property4 == null) {
            return void 0;
          }
          return {
            transformedKey: property4.parsedKey,
            transform: (propertyValue) => property4.valueSchema.parse(propertyValue, {
              ...opts,
              breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], rawKey]
            })
          };
        },
        unrecognizedObjectKeys: opts?.unrecognizedObjectKeys,
        skipValidation: opts?.skipValidation,
        breadcrumbsPrefix: opts?.breadcrumbsPrefix,
        omitUndefined: opts?.omitUndefined
      });
    },
    json: (parsed, opts) => {
      const requiredKeys = [];
      for (const [parsedKey, schemaOrObjectProperty] of entries3(schemas)) {
        const valueSchema = isProperty2(schemaOrObjectProperty) ? schemaOrObjectProperty.valueSchema : schemaOrObjectProperty;
        if (isSchemaRequired2(valueSchema)) {
          requiredKeys.push(parsedKey);
        }
      }
      return validateAndTransformObject2({
        value: parsed,
        requiredKeys,
        getProperty: (parsedKey) => {
          const property4 = schemas[parsedKey];
          if (property4 == null) {
            return void 0;
          }
          if (isProperty2(property4)) {
            return {
              transformedKey: property4.rawKey,
              transform: (propertyValue) => property4.valueSchema.json(propertyValue, {
                ...opts,
                breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], parsedKey]
              })
            };
          } else {
            return {
              transformedKey: parsedKey,
              transform: (propertyValue) => property4.json(propertyValue, {
                ...opts,
                breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], parsedKey]
              })
            };
          }
        },
        unrecognizedObjectKeys: opts?.unrecognizedObjectKeys,
        skipValidation: opts?.skipValidation,
        breadcrumbsPrefix: opts?.breadcrumbsPrefix,
        omitUndefined: opts?.omitUndefined
      });
    },
    getType: () => SchemaType2.OBJECT
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema),
    ...getObjectLikeUtils2(baseSchema),
    ...getObjectUtils2(baseSchema)
  };
}
function validateAndTransformObject2({ value, requiredKeys, getProperty: getProperty2, unrecognizedObjectKeys = "fail", skipValidation = false, breadcrumbsPrefix = [] }) {
  if (!isPlainObject4(value)) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType2(value, "object")
        }
      ]
    };
  }
  const missingRequiredKeys = new Set(requiredKeys);
  const errors = [];
  const transformed = {};
  for (const [preTransformedKey, preTransformedItemValue] of Object.entries(value)) {
    const property4 = getProperty2(preTransformedKey);
    if (property4 != null) {
      missingRequiredKeys.delete(preTransformedKey);
      const value2 = property4.transform(preTransformedItemValue);
      if (value2.ok) {
        transformed[property4.transformedKey] = value2.value;
      } else {
        transformed[preTransformedKey] = preTransformedItemValue;
        errors.push(...value2.errors);
      }
    } else {
      switch (unrecognizedObjectKeys) {
        case "fail":
          errors.push({
            path: [...breadcrumbsPrefix, preTransformedKey],
            message: `Unexpected key "${preTransformedKey}"`
          });
          break;
        case "strip":
          break;
        case "passthrough":
          transformed[preTransformedKey] = preTransformedItemValue;
          break;
      }
    }
  }
  errors.push(...requiredKeys.filter((key) => missingRequiredKeys.has(key)).map((key) => ({
    path: breadcrumbsPrefix,
    message: `Missing required key "${key}"`
  })));
  if (errors.length === 0 || skipValidation) {
    return {
      ok: true,
      value: transformed
    };
  } else {
    return {
      ok: false,
      errors
    };
  }
}
function getObjectUtils2(schema2) {
  return {
    extend: (extension) => {
      const baseSchema = {
        _getParsedProperties: () => [...schema2._getParsedProperties(), ...extension._getParsedProperties()],
        _getRawProperties: () => [...schema2._getRawProperties(), ...extension._getRawProperties()],
        parse: (raw, opts) => {
          return validateAndTransformExtendedObject2({
            extensionKeys: extension._getRawProperties(),
            value: raw,
            transformBase: (rawBase) => schema2.parse(rawBase, opts),
            transformExtension: (rawExtension) => extension.parse(rawExtension, opts)
          });
        },
        json: (parsed, opts) => {
          return validateAndTransformExtendedObject2({
            extensionKeys: extension._getParsedProperties(),
            value: parsed,
            transformBase: (parsedBase) => schema2.json(parsedBase, opts),
            transformExtension: (parsedExtension) => extension.json(parsedExtension, opts)
          });
        },
        getType: () => SchemaType2.OBJECT
      };
      return {
        ...baseSchema,
        ...getSchemaUtils2(baseSchema),
        ...getObjectLikeUtils2(baseSchema),
        ...getObjectUtils2(baseSchema)
      };
    }
  };
}
function validateAndTransformExtendedObject2({ extensionKeys, value, transformBase, transformExtension }) {
  const extensionPropertiesSet = new Set(extensionKeys);
  const [extensionProperties, baseProperties] = partition2(keys4(value), (key) => extensionPropertiesSet.has(key));
  const transformedBase = transformBase(filterObject2(value, baseProperties));
  const transformedExtension = transformExtension(filterObject2(value, extensionProperties));
  if (transformedBase.ok && transformedExtension.ok) {
    return {
      ok: true,
      value: {
        ...transformedBase.value,
        ...transformedExtension.value
      }
    };
  } else {
    return {
      ok: false,
      errors: [
        ...transformedBase.ok ? [] : transformedBase.errors,
        ...transformedExtension.ok ? [] : transformedExtension.errors
      ]
    };
  }
}
function isSchemaRequired2(schema2) {
  return !isSchemaOptional2(schema2);
}
function isSchemaOptional2(schema2) {
  switch (schema2.getType()) {
    case SchemaType2.ANY:
    case SchemaType2.UNKNOWN:
    case SchemaType2.OPTIONAL:
      return true;
    default:
      return false;
  }
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/object/objectWithoutOptionalProperties.js
function objectWithoutOptionalProperties2(schemas) {
  return object2(schemas);
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/lazy/lazyObject.js
function lazyObject2(getter) {
  const baseSchema = {
    ...constructLazyBaseSchema2(getter),
    _getRawProperties: () => getMemoizedSchema2(getter)._getRawProperties(),
    _getParsedProperties: () => getMemoizedSchema2(getter)._getParsedProperties()
  };
  return {
    ...baseSchema,
    ...getSchemaUtils2(baseSchema),
    ...getObjectLikeUtils2(baseSchema),
    ...getObjectUtils2(baseSchema)
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/list/list.js
function list2(schema2) {
  const baseSchema = {
    parse: (raw, opts) => validateAndTransformArray2(raw, (item, index) => schema2.parse(item, {
      ...opts,
      breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `[${index}]`]
    })),
    json: (parsed, opts) => validateAndTransformArray2(parsed, (item, index) => schema2.json(item, {
      ...opts,
      breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `[${index}]`]
    })),
    getType: () => SchemaType2.LIST
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema)
  };
}
function validateAndTransformArray2(value, transformItem) {
  if (!Array.isArray(value)) {
    return {
      ok: false,
      errors: [
        {
          message: getErrorMessageForIncorrectType2(value, "list"),
          path: []
        }
      ]
    };
  }
  const maybeValidItems = value.map((item, index) => transformItem(item, index));
  return maybeValidItems.reduce((acc, item) => {
    if (acc.ok && item.ok) {
      return {
        ok: true,
        value: [...acc.value, item.value]
      };
    }
    const errors = [];
    if (!acc.ok) {
      errors.push(...acc.errors);
    }
    if (!item.ok) {
      errors.push(...item.errors);
    }
    return {
      ok: false,
      errors
    };
  }, { ok: true, value: [] });
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/literals/stringLiteral.js
function stringLiteral2(literal) {
  const schemaCreator = createIdentitySchemaCreator2(SchemaType2.STRING_LITERAL, (value, { breadcrumbsPrefix = [] } = {}) => {
    if (value === literal) {
      return {
        ok: true,
        value: literal
      };
    } else {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType2(value, `"${literal}"`)
          }
        ]
      };
    }
  });
  return schemaCreator();
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/literals/booleanLiteral.js
function booleanLiteral2(literal) {
  const schemaCreator = createIdentitySchemaCreator2(SchemaType2.BOOLEAN_LITERAL, (value, { breadcrumbsPrefix = [] } = {}) => {
    if (value === literal) {
      return {
        ok: true,
        value: literal
      };
    } else {
      return {
        ok: false,
        errors: [
          {
            path: breadcrumbsPrefix,
            message: getErrorMessageForIncorrectType2(value, `${literal.toString()}`)
          }
        ]
      };
    }
  });
  return schemaCreator();
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/primitives/any.js
var any2 = createIdentitySchemaCreator2(SchemaType2.ANY, (value) => ({ ok: true, value }));

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/primitives/boolean.js
var boolean2 = createIdentitySchemaCreator2(SchemaType2.BOOLEAN, (value, { breadcrumbsPrefix = [] } = {}) => {
  if (typeof value === "boolean") {
    return {
      ok: true,
      value
    };
  } else {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType2(value, "boolean")
        }
      ]
    };
  }
});

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/primitives/number.js
var number2 = createIdentitySchemaCreator2(SchemaType2.NUMBER, (value, { breadcrumbsPrefix = [] } = {}) => {
  if (typeof value === "number") {
    return {
      ok: true,
      value
    };
  } else {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType2(value, "number")
        }
      ]
    };
  }
});

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/primitives/string.js
var string2 = createIdentitySchemaCreator2(SchemaType2.STRING, (value, { breadcrumbsPrefix = [] } = {}) => {
  if (typeof value === "string") {
    return {
      ok: true,
      value
    };
  } else {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType2(value, "string")
        }
      ]
    };
  }
});

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/primitives/unknown.js
var unknown2 = createIdentitySchemaCreator2(SchemaType2.UNKNOWN, (value) => ({ ok: true, value }));

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/record/record.js
function record2(keySchema, valueSchema) {
  const baseSchema = {
    parse: (raw, opts) => {
      return validateAndTransformRecord2({
        value: raw,
        isKeyNumeric: keySchema.getType() === SchemaType2.NUMBER,
        transformKey: (key) => keySchema.parse(key, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key} (key)`]
        }),
        transformValue: (value, key) => valueSchema.parse(value, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key}`]
        }),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    json: (parsed, opts) => {
      return validateAndTransformRecord2({
        value: parsed,
        isKeyNumeric: keySchema.getType() === SchemaType2.NUMBER,
        transformKey: (key) => keySchema.json(key, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key} (key)`]
        }),
        transformValue: (value, key) => valueSchema.json(value, {
          ...opts,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], `${key}`]
        }),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    getType: () => SchemaType2.RECORD
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema)
  };
}
function validateAndTransformRecord2({ value, isKeyNumeric, transformKey, transformValue, breadcrumbsPrefix = [] }) {
  if (!isPlainObject4(value)) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType2(value, "object")
        }
      ]
    };
  }
  return entries3(value).reduce((accPromise, [stringKey, value2]) => {
    if (value2 == null) {
      return accPromise;
    }
    const acc = accPromise;
    let key = stringKey;
    if (isKeyNumeric) {
      const numberKey = stringKey.length > 0 ? Number(stringKey) : NaN;
      if (!isNaN(numberKey)) {
        key = numberKey;
      }
    }
    const transformedKey = transformKey(key);
    const transformedValue = transformValue(value2, key);
    if (acc.ok && transformedKey.ok && transformedValue.ok) {
      return {
        ok: true,
        value: {
          ...acc.value,
          [transformedKey.value]: transformedValue.value
        }
      };
    }
    const errors = [];
    if (!acc.ok) {
      errors.push(...acc.errors);
    }
    if (!transformedKey.ok) {
      errors.push(...transformedKey.errors);
    }
    if (!transformedValue.ok) {
      errors.push(...transformedValue.errors);
    }
    return {
      ok: false,
      errors
    };
  }, { ok: true, value: {} });
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/set/set.js
function set2(schema2) {
  const listSchema = list2(schema2);
  const baseSchema = {
    parse: (raw, opts) => {
      const parsedList = listSchema.parse(raw, opts);
      if (parsedList.ok) {
        return {
          ok: true,
          value: new Set(parsedList.value)
        };
      } else {
        return parsedList;
      }
    },
    json: (parsed, opts) => {
      if (!(parsed instanceof Set)) {
        return {
          ok: false,
          errors: [
            {
              path: opts?.breadcrumbsPrefix ?? [],
              message: getErrorMessageForIncorrectType2(parsed, "Set")
            }
          ]
        };
      }
      const jsonList = listSchema.json([...parsed], opts);
      return jsonList;
    },
    getType: () => SchemaType2.SET
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema)
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/undiscriminated-union/undiscriminatedUnion.js
function undiscriminatedUnion2(schemas) {
  const baseSchema = {
    parse: (raw, opts) => {
      return validateAndTransformUndiscriminatedUnion2((schema2, opts2) => schema2.parse(raw, opts2), schemas, opts);
    },
    json: (parsed, opts) => {
      return validateAndTransformUndiscriminatedUnion2((schema2, opts2) => schema2.json(parsed, opts2), schemas, opts);
    },
    getType: () => SchemaType2.UNDISCRIMINATED_UNION
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema)
  };
}
function validateAndTransformUndiscriminatedUnion2(transform3, schemas, opts) {
  const errors = [];
  for (const [index, schema2] of schemas.entries()) {
    const transformed = transform3(schema2, { ...opts, skipValidation: false });
    if (transformed.ok) {
      return transformed;
    } else {
      for (const error of transformed.errors) {
        errors.push({
          path: error.path,
          message: `[Variant ${index}] ${error.message}`
        });
      }
    }
  }
  return {
    ok: false,
    errors
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/union/discriminant.js
function discriminant2(parsedDiscriminant, rawDiscriminant) {
  return {
    parsedDiscriminant,
    rawDiscriminant
  };
}

// ../../cli/fern-definition/schema/lib/schemas/core/schemas/builders/union/union.js
function union2(discriminant3, union3) {
  const rawDiscriminant = typeof discriminant3 === "string" ? discriminant3 : discriminant3.rawDiscriminant;
  const parsedDiscriminant = typeof discriminant3 === "string" ? discriminant3 : discriminant3.parsedDiscriminant;
  const discriminantValueSchema = enum_2(keys4(union3));
  const baseSchema = {
    parse: (raw, opts) => {
      return transformAndValidateUnion2({
        value: raw,
        discriminant: rawDiscriminant,
        transformedDiscriminant: parsedDiscriminant,
        transformDiscriminantValue: (discriminantValue) => discriminantValueSchema.parse(discriminantValue, {
          allowUnrecognizedEnumValues: opts?.allowUnrecognizedUnionMembers,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], rawDiscriminant]
        }),
        getAdditionalPropertiesSchema: (discriminantValue) => union3[discriminantValue],
        allowUnrecognizedUnionMembers: opts?.allowUnrecognizedUnionMembers,
        transformAdditionalProperties: (additionalProperties, additionalPropertiesSchema) => additionalPropertiesSchema.parse(additionalProperties, opts),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    json: (parsed, opts) => {
      return transformAndValidateUnion2({
        value: parsed,
        discriminant: parsedDiscriminant,
        transformedDiscriminant: rawDiscriminant,
        transformDiscriminantValue: (discriminantValue) => discriminantValueSchema.json(discriminantValue, {
          allowUnrecognizedEnumValues: opts?.allowUnrecognizedUnionMembers,
          breadcrumbsPrefix: [...opts?.breadcrumbsPrefix ?? [], parsedDiscriminant]
        }),
        getAdditionalPropertiesSchema: (discriminantValue) => union3[discriminantValue],
        allowUnrecognizedUnionMembers: opts?.allowUnrecognizedUnionMembers,
        transformAdditionalProperties: (additionalProperties, additionalPropertiesSchema) => additionalPropertiesSchema.json(additionalProperties, opts),
        breadcrumbsPrefix: opts?.breadcrumbsPrefix
      });
    },
    getType: () => SchemaType2.UNION
  };
  return {
    ...maybeSkipValidation2(baseSchema),
    ...getSchemaUtils2(baseSchema),
    ...getObjectLikeUtils2(baseSchema)
  };
}
function transformAndValidateUnion2({ value, discriminant: discriminant3, transformedDiscriminant, transformDiscriminantValue, getAdditionalPropertiesSchema, allowUnrecognizedUnionMembers = false, transformAdditionalProperties, breadcrumbsPrefix = [] }) {
  if (!isPlainObject4(value)) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: getErrorMessageForIncorrectType2(value, "object")
        }
      ]
    };
  }
  const { [discriminant3]: discriminantValue, ...additionalProperties } = value;
  if (discriminantValue == null) {
    return {
      ok: false,
      errors: [
        {
          path: breadcrumbsPrefix,
          message: `Missing discriminant ("${discriminant3}")`
        }
      ]
    };
  }
  const transformedDiscriminantValue = transformDiscriminantValue(discriminantValue);
  if (!transformedDiscriminantValue.ok) {
    return {
      ok: false,
      errors: transformedDiscriminantValue.errors
    };
  }
  const additionalPropertiesSchema = getAdditionalPropertiesSchema(transformedDiscriminantValue.value);
  if (additionalPropertiesSchema == null) {
    if (allowUnrecognizedUnionMembers) {
      return {
        ok: true,
        value: {
          [transformedDiscriminant]: transformedDiscriminantValue.value,
          ...additionalProperties
        }
      };
    } else {
      return {
        ok: false,
        errors: [
          {
            path: [...breadcrumbsPrefix, discriminant3],
            message: "Unexpected discriminant value"
          }
        ]
      };
    }
  }
  const transformedAdditionalProperties = transformAdditionalProperties(additionalProperties, additionalPropertiesSchema);
  if (!transformedAdditionalProperties.ok) {
    return transformedAdditionalProperties;
  }
  return {
    ok: true,
    value: {
      [transformedDiscriminant]: discriminantValue,
      ...transformedAdditionalProperties.value
    }
  };
}

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/WithDocsSchema.js
var WithDocsSchema2 = schemas_exports2.object({
  docs: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/AuthSchemeReferenceSchema.js
var AuthSchemeReferenceSchema2 = schemas_exports2.object({
  scheme: schemas_exports2.string()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/AnyAuthItem.js
var AnyAuthItem2 = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), AuthSchemeReferenceSchema2]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/AnyAuthSchemesSchema.js
var AnyAuthSchemesSchema2 = schemas_exports2.object({
  any: schemas_exports2.list(AnyAuthItem2)
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/ApiAuthSchema.js
var ApiAuthSchema2 = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  AuthSchemeReferenceSchema2,
  AnyAuthSchemesSchema2
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthAccessTokenRequestPropertiesSchema.js
var OAuthAccessTokenRequestPropertiesSchema2 = schemas_exports2.object({
  "client-id": schemas_exports2.string().optional(),
  "client-secret": schemas_exports2.string().optional(),
  scopes: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthAccessTokenResponsePropertiesSchema.js
var OAuthAccessTokenResponsePropertiesSchema2 = schemas_exports2.object({
  "access-token": schemas_exports2.string().optional(),
  "expires-in": schemas_exports2.string().optional(),
  "refresh-token": schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthGetTokenEndpointSchema.js
var OAuthGetTokenEndpointSchema2 = schemas_exports2.object({
  endpoint: schemas_exports2.string(),
  "request-properties": OAuthAccessTokenRequestPropertiesSchema2.optional(),
  "response-properties": OAuthAccessTokenResponsePropertiesSchema2.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthRefreshTokenRequestPropertiesSchema.js
var OAuthRefreshTokenRequestPropertiesSchema2 = schemas_exports2.object({
  "refresh-token": schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthRefreshTokenResponsePropertiesSchema.js
var OAuthRefreshTokenResponsePropertiesSchema2 = schemas_exports2.object({
  "access-token": schemas_exports2.string().optional(),
  "expires-in": schemas_exports2.string().optional(),
  "refresh-token": schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthRefreshTokenEndpointSchema.js
var OAuthRefreshTokenEndpointSchema2 = schemas_exports2.object({
  endpoint: schemas_exports2.string(),
  "request-properties": OAuthRefreshTokenRequestPropertiesSchema2.optional(),
  "response-properties": OAuthRefreshTokenResponsePropertiesSchema2.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/OAuthSchemeSchema.js
var OAuthSchemeSchema2 = schemas_exports2.object({
  scheme: schemas_exports2.stringLiteral("oauth"),
  type: schemas_exports2.stringLiteral("client-credentials"),
  scopes: schemas_exports2.list(schemas_exports2.string()).optional(),
  "client-id-env": schemas_exports2.string().optional(),
  "client-secret-env": schemas_exports2.string().optional(),
  "token-prefix": schemas_exports2.string().optional(),
  "token-header": schemas_exports2.string().optional(),
  "get-token": OAuthGetTokenEndpointSchema2,
  "refresh-token": OAuthRefreshTokenEndpointSchema2.optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/WithEnvironmentVariable.js
var WithEnvironmentVariable2 = schemas_exports2.object({
  env: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/WithName.js
var WithName2 = schemas_exports2.object({
  name: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/HeaderAuthSchemeSchema.js
var HeaderAuthSchemeSchema2 = schemas_exports2.object({
  header: schemas_exports2.string(),
  type: schemas_exports2.string().optional(),
  prefix: schemas_exports2.string().optional()
}).extend(WithEnvironmentVariable2).extend(WithName2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/AuthVariable.js
var AuthVariable2 = schemas_exports2.object({}).extend(WithEnvironmentVariable2).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/BasicAuthSchemeSchema.js
var BasicAuthSchemeSchema2 = schemas_exports2.object({
  scheme: schemas_exports2.stringLiteral("basic"),
  username: AuthVariable2.optional(),
  password: AuthVariable2.optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/BearerAuthSchemeSchema.js
var BearerAuthSchemeSchema2 = schemas_exports2.object({
  scheme: schemas_exports2.stringLiteral("bearer"),
  token: AuthVariable2.optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/AuthSchemeDeclarationSchema.js
var AuthSchemeDeclarationSchema2 = schemas_exports2.undiscriminatedUnion([
  OAuthSchemeSchema2,
  HeaderAuthSchemeSchema2,
  BasicAuthSchemeSchema2,
  BearerAuthSchemeSchema2
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/auth/types/WithAuthSchema.js
var WithAuthSchema = schemas_exports2.object({
  auth: ApiAuthSchema2.optional(),
  "auth-schemes": schemas_exports2.record(schemas_exports2.string(), AuthSchemeDeclarationSchema2).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/availability/index.js
var availability_exports4 = {};
__export(availability_exports4, {
  AvailabilitySchema: () => AvailabilitySchema2,
  AvailabilityStatusSchema: () => AvailabilityStatusSchema4,
  AvailabilityUnionSchema: () => AvailabilityUnionSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/availability/types/AvailabilityStatusSchema.js
var AvailabilityStatusSchema4 = schemas_exports2.enum_(["in-development", "pre-release", "deprecated", "generally-available"]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/availability/types/AvailabilitySchema.js
var AvailabilitySchema2 = schemas_exports2.object({
  status: AvailabilityStatusSchema4,
  message: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/availability/types/AvailabilityUnionSchema.js
var AvailabilityUnionSchema2 = schemas_exports2.undiscriminatedUnion([AvailabilityStatusSchema4, AvailabilitySchema2]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/index.js
var commons_exports5 = {};
__export(commons_exports5, {
  DeclarationSchema: () => DeclarationSchema,
  DeclarationWithNameSchema: () => DeclarationWithNameSchema,
  DeclarationWithoutDocsSchema: () => DeclarationWithoutDocsSchema,
  WithAudiences: () => WithAudiences2,
  WithAvailability: () => WithAvailability2,
  WithDisplayName: () => WithDisplayName,
  WithDocsSchema: () => WithDocsSchema2,
  WithName: () => WithName2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/WithAvailability.js
var WithAvailability2 = schemas_exports2.object({
  availability: AvailabilityUnionSchema2.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/WithDisplayName.js
var WithDisplayName = schemas_exports2.object({
  "display-name": schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/WithAudiences.js
var WithAudiences2 = schemas_exports2.object({
  audiences: schemas_exports2.list(schemas_exports2.string()).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/DeclarationSchema.js
var DeclarationSchema = schemas_exports2.object({}).extend(WithDocsSchema2).extend(WithAvailability2).extend(WithAudiences2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/DeclarationWithoutDocsSchema.js
var DeclarationWithoutDocsSchema = schemas_exports2.object({}).extend(WithAvailability2).extend(WithAudiences2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/commons/types/DeclarationWithNameSchema.js
var DeclarationWithNameSchema = schemas_exports2.object({}).extend(DeclarationSchema).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/encoding/index.js
var encoding_exports4 = {};
__export(encoding_exports4, {
  EncodingSchema: () => EncodingSchema2,
  ProtobufTypeSchema: () => ProtobufTypeSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/encoding/types/ProtobufTypeSchema.js
var ProtobufTypeSchema2 = schemas_exports2.object({
  type: schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/encoding/types/EncodingSchema.js
var EncodingSchema2 = schemas_exports2.object({
  proto: ProtobufTypeSchema2.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/environments/index.js
var environments_exports4 = {};
__export(environments_exports4, {
  EnvironmentSchema: () => EnvironmentSchema2,
  MultipleBaseUrlsEnvironmentSchema: () => MultipleBaseUrlsEnvironmentSchema2,
  SingleBaseUrlEnvironmentSchema: () => SingleBaseUrlEnvironmentSchema2,
  WithEnvironmentsSchema: () => WithEnvironmentsSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/environments/types/SingleBaseUrlEnvironmentSchema.js
var SingleBaseUrlEnvironmentSchema2 = schemas_exports2.object({
  url: schemas_exports2.string()
}).extend(WithAudiences2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/environments/types/MultipleBaseUrlsEnvironmentSchema.js
var MultipleBaseUrlsEnvironmentSchema2 = schemas_exports2.object({
  urls: schemas_exports2.record(schemas_exports2.string(), schemas_exports2.string())
}).extend(WithAudiences2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/environments/types/EnvironmentSchema.js
var EnvironmentSchema2 = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  SingleBaseUrlEnvironmentSchema2,
  MultipleBaseUrlsEnvironmentSchema2
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/environments/types/WithEnvironmentsSchema.js
var WithEnvironmentsSchema2 = schemas_exports2.object({
  "default-url": schemas_exports2.string().optional(),
  "default-environment": schemas_exports2.string().optional(),
  environments: schemas_exports2.record(schemas_exports2.string(), EnvironmentSchema2).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/errors/index.js
var errors_exports3 = {};
__export(errors_exports3, {
  ErrorDeclarationSchema: () => ErrorDeclarationSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleTypeValueSchema.js
var ExampleTypeValueSchema = schemas_exports2.unknown();

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleTypeSchema.js
var ExampleTypeSchema = schemas_exports2.object({
  value: ExampleTypeValueSchema
}).extend(WithName2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/errors/types/ErrorDeclarationSchema.js
var ErrorDeclarationSchema = schemas_exports2.object({
  "status-code": schemas_exports2.number(),
  type: schemas_exports2.string().optional(),
  examples: schemas_exports2.list(ExampleTypeSchema).optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/index.js
var examples_exports3 = {};
__export(examples_exports3, {
  ExampleBodyResponseSchema: () => ExampleBodyResponseSchema,
  ExampleCodeSampleSchema: () => ExampleCodeSampleSchema,
  ExampleCodeSampleSchemaLanguage: () => ExampleCodeSampleSchemaLanguage,
  ExampleCodeSampleSchemaSdk: () => ExampleCodeSampleSchemaSdk,
  ExampleEndpointCallArraySchema: () => ExampleEndpointCallArraySchema,
  ExampleEndpointCallSchema: () => ExampleEndpointCallSchema,
  ExampleResponseSchema: () => ExampleResponseSchema,
  ExampleSseEventSchema: () => ExampleSseEventSchema,
  ExampleSseResponseSchema: () => ExampleSseResponseSchema,
  ExampleStreamResponseSchema: () => ExampleStreamResponseSchema,
  ExampleTypeReferenceSchema: () => ExampleTypeReferenceSchema,
  ExampleTypeSchema: () => ExampleTypeSchema,
  ExampleTypeValueSchema: () => ExampleTypeValueSchema,
  ExampleWebSocketMessage: () => ExampleWebSocketMessage,
  ExampleWebSocketSession: () => ExampleWebSocketSession,
  ExampleWebhookCallSchema: () => ExampleWebhookCallSchema,
  SupportedSdkLanguageSchema: () => SupportedSdkLanguageSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleTypeReferenceSchema.js
var ExampleTypeReferenceSchema = schemas_exports2.unknown();

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleWebSocketMessage.js
var ExampleWebSocketMessage = schemas_exports2.object({
  type: schemas_exports2.string(),
  body: schemas_exports2.unknown()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleWebSocketSession.js
var ExampleWebSocketSession = schemas_exports2.object({
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), ExampleTypeReferenceSchema).optional(),
  "query-parameters": schemas_exports2.record(schemas_exports2.string(), ExampleTypeReferenceSchema).optional(),
  headers: schemas_exports2.record(schemas_exports2.string(), ExampleTypeReferenceSchema).optional(),
  messages: schemas_exports2.list(ExampleWebSocketMessage)
}).extend(WithName2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleBodyResponseSchema.js
var ExampleBodyResponseSchema = schemas_exports2.object({
  error: schemas_exports2.string().optional(),
  body: ExampleTypeReferenceSchema.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleStreamResponseSchema.js
var ExampleStreamResponseSchema = schemas_exports2.object({
  stream: schemas_exports2.list(ExampleTypeReferenceSchema)
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleSseEventSchema.js
var ExampleSseEventSchema = schemas_exports2.object({
  event: schemas_exports2.string(),
  data: ExampleTypeReferenceSchema.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleSseResponseSchema.js
var ExampleSseResponseSchema = schemas_exports2.object({
  stream: schemas_exports2.list(ExampleSseEventSchema)
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleResponseSchema.js
var ExampleResponseSchema = schemas_exports2.undiscriminatedUnion([
  ExampleBodyResponseSchema,
  ExampleStreamResponseSchema,
  ExampleSseResponseSchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/SupportedSdkLanguageSchema.js
var SupportedSdkLanguageSchema2 = schemas_exports2.enum_([
  "curl",
  "python",
  "javascript",
  "typescript",
  "go",
  "ruby",
  "csharp",
  "java",
  "js",
  "node",
  "ts",
  "nodets",
  "golang",
  "dotnet",
  "jvm",
  "c#"
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleCodeSampleSchemaSdk.js
var ExampleCodeSampleSchemaSdk = schemas_exports2.object({
  sdk: SupportedSdkLanguageSchema2,
  code: schemas_exports2.string()
}).extend(WithDocsSchema2).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleCodeSampleSchemaLanguage.js
var ExampleCodeSampleSchemaLanguage = schemas_exports2.object({
  language: schemas_exports2.string(),
  code: schemas_exports2.string(),
  install: schemas_exports2.string().optional()
}).extend(WithDocsSchema2).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleCodeSampleSchema.js
var ExampleCodeSampleSchema = schemas_exports2.undiscriminatedUnion([ExampleCodeSampleSchemaSdk, ExampleCodeSampleSchemaLanguage]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleEndpointCallSchema.js
var ExampleEndpointCallSchema = schemas_exports2.object({
  id: schemas_exports2.string().optional(),
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), ExampleTypeReferenceSchema).optional(),
  "query-parameters": schemas_exports2.record(schemas_exports2.string(), ExampleTypeReferenceSchema).optional(),
  headers: schemas_exports2.record(schemas_exports2.string(), ExampleTypeReferenceSchema).optional(),
  request: ExampleTypeReferenceSchema.optional(),
  response: ExampleResponseSchema.optional(),
  "code-samples": schemas_exports2.list(ExampleCodeSampleSchema).optional()
}).extend(WithName2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleEndpointCallArraySchema.js
var ExampleEndpointCallArraySchema = schemas_exports2.list(ExampleEndpointCallSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/examples/types/ExampleWebhookCallSchema.js
var ExampleWebhookCallSchema = schemas_exports2.object({
  id: schemas_exports2.string().optional(),
  payload: ExampleTypeReferenceSchema
}).extend(WithName2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/index.js
var file_exports4 = {};
__export(file_exports4, {
  DefinitionFileSchema: () => DefinitionFileSchema,
  ErrorDiscriminationSchema: () => ErrorDiscriminationSchema,
  Export: () => Export,
  ExportDetailed: () => ExportDetailed,
  Navigation: () => Navigation,
  PackageMarkerFileSchema: () => PackageMarkerFileSchema,
  PropertyBasedErrorDiscrimination: () => PropertyBasedErrorDiscrimination,
  RootApiFileSchema: () => RootApiFileSchema,
  StatusCodeBasedErrorDiscrimination: () => StatusCodeBasedErrorDiscrimination,
  WithHeadersSchema: () => WithHeadersSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/ObjectExtendsSchema.js
var ObjectExtendsSchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  schemas_exports2.list(schemas_exports2.string())
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/validation/types/StringValidationSchema.js
var StringValidationSchema2 = schemas_exports2.object({
  minLength: schemas_exports2.number().optional(),
  maxLength: schemas_exports2.number().optional(),
  pattern: schemas_exports2.string().optional(),
  format: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/validation/types/NumberValidationSchema.js
var NumberValidationSchema2 = schemas_exports2.object({
  min: schemas_exports2.number().optional(),
  max: schemas_exports2.number().optional(),
  exclusiveMin: schemas_exports2.boolean().optional(),
  exclusiveMax: schemas_exports2.boolean().optional(),
  multipleOf: schemas_exports2.number().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/validation/types/ValidationSchema.js
var ValidationSchema2 = schemas_exports2.undiscriminatedUnion([StringValidationSchema2, NumberValidationSchema2]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/BaseTypeReferenceSchema.js
var BaseTypeReferenceSchema2 = schemas_exports2.object({
  default: schemas_exports2.unknown().optional(),
  encoding: EncodingSchema2.optional(),
  validation: ValidationSchema2.optional()
}).extend(WithDocsSchema2).extend(WithAvailability2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/TypeReferenceDeclarationWithName.js
var TypeReferenceDeclarationWithName2 = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(BaseTypeReferenceSchema2).extend(WithName2).extend(WithAudiences2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/TypeReferenceDeclarationWithNameSchema.js
var TypeReferenceDeclarationWithNameSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), TypeReferenceDeclarationWithName2]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/ObjectPropertySchema.js
var ObjectPropertySchema = TypeReferenceDeclarationWithNameSchema;

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/source/types/OpenApiSourceSchema.js
var OpenApiSourceSchema = schemas_exports2.object({
  openapi: schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/source/types/ProtobufSourceSchema.js
var ProtobufSourceSchema = schemas_exports2.object({
  proto: schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/source/types/SourceSchema.js
var SourceSchema = schemas_exports2.undiscriminatedUnion([OpenApiSourceSchema, ProtobufSourceSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/BaseTypeDeclarationSchema.js
var BaseTypeDeclarationSchema = schemas_exports2.object({
  examples: schemas_exports2.list(ExampleTypeSchema).optional(),
  encoding: EncodingSchema2.optional(),
  source: SourceSchema.optional(),
  inline: schemas_exports2.boolean().optional()
}).extend(WithDocsSchema2).extend(WithAvailability2).extend(WithAudiences2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/ObjectSchema.js
var ObjectSchema = schemas_exports2.object({
  extends: ObjectExtendsSchema.optional(),
  properties: schemas_exports2.record(schemas_exports2.string(), ObjectPropertySchema).optional(),
  "extra-properties": schemas_exports2.boolean().optional()
}).extend(BaseTypeDeclarationSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/CasingOverridesSchema.js
var CasingOverridesSchema = schemas_exports2.object({
  camel: schemas_exports2.string().optional(),
  snake: schemas_exports2.string().optional(),
  pascal: schemas_exports2.string().optional(),
  "screaming-snake": schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/EnumValueSchema.js
var EnumValueSchema = schemas_exports2.object({
  value: schemas_exports2.string(),
  casing: CasingOverridesSchema.optional()
}).extend(WithDocsSchema2).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/EnumValue.js
var EnumValue = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), EnumValueSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/EnumSchema.js
var EnumSchema = schemas_exports2.object({
  default: schemas_exports2.string().optional(),
  enum: schemas_exports2.list(EnumValue)
}).extend(BaseTypeDeclarationSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/UnionDiscriminantSchema.js
var UnionDiscriminantSchema = schemas_exports2.object({
  value: schemas_exports2.string()
}).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/UnionDiscriminant.js
var UnionDiscriminant = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), UnionDiscriminantSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/TypeReferenceDetailedSchema.js
var TypeReferenceDetailedSchema = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(BaseTypeReferenceSchema2).extend(WithName2).extend(WithAudiences2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/TypeReferenceSchema.js
var TypeReferenceSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), TypeReferenceDetailedSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/SingleUnionTypeKeySchema.js
var SingleUnionTypeKeySchema = schemas_exports2.object({
  value: schemas_exports2.string()
}).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/SingleUnionTypeKey.js
var SingleUnionTypeKey = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), SingleUnionTypeKeySchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/SingleUnionTypeDetailedSchema.js
var SingleUnionTypeDetailedSchema = schemas_exports2.object({
  type: schemas_exports2.string().optional(),
  key: SingleUnionTypeKey.optional()
}).extend(WithDocsSchema2).extend(WithName2).extend(WithAvailability2).extend(WithDisplayName);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/SingleUnionTypeSchema.js
var SingleUnionTypeSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), SingleUnionTypeDetailedSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/DiscriminatedUnionSchema.js
var DiscriminatedUnionSchema = schemas_exports2.object({
  discriminant: UnionDiscriminant.optional(),
  extends: ObjectExtendsSchema.optional(),
  "base-properties": schemas_exports2.record(schemas_exports2.string(), TypeReferenceSchema).optional(),
  union: schemas_exports2.record(schemas_exports2.string(), SingleUnionTypeSchema)
}).extend(BaseTypeDeclarationSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/SingleUndiscriminatedUnionTypeDetailedSchema.js
var SingleUndiscriminatedUnionTypeDetailedSchema = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(WithDocsSchema2).extend(WithDisplayName);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/SingleUndiscriminatedUnionTypeSchema.js
var SingleUndiscriminatedUnionTypeSchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  SingleUndiscriminatedUnionTypeDetailedSchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/UndiscriminatedUnionSchema.js
var UndiscriminatedUnionSchema = schemas_exports2.object({
  discriminated: schemas_exports2.booleanLiteral(false),
  union: schemas_exports2.list(SingleUndiscriminatedUnionTypeSchema)
}).extend(BaseTypeDeclarationSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/AliasSchema.js
var AliasSchema = schemas_exports2.object({
  type: schemas_exports2.string(),
  validation: ValidationSchema2.optional()
}).extend(BaseTypeDeclarationSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/types/TypeDeclarationSchema.js
var TypeDeclarationSchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  ObjectSchema,
  EnumSchema,
  DiscriminatedUnionSchema,
  UndiscriminatedUnionSchema,
  AliasSchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/GrpcTransport.js
var GrpcTransport = schemas_exports2.object({
  "service-name": schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/ServiceTransport.js
var ServiceTransport = schemas_exports2.object({
  grpc: GrpcTransport.optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpMethodSchema.js
var HttpMethodSchema2 = schemas_exports2.enum_(["GET", "POST", "PUT", "PATCH", "DELETE"]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/variables/types/VariableReferenceSchema.js
var VariableReferenceSchema = schemas_exports2.object({
  variable: schemas_exports2.string()
}).extend(WithAvailability2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpPathParameterSchema.js
var HttpPathParameterSchema = schemas_exports2.undiscriminatedUnion([TypeReferenceSchema, VariableReferenceSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/QueryParameterTypeReferenceDetailed.js
var QueryParameterTypeReferenceDetailed = schemas_exports2.object({
  "allow-multiple": schemas_exports2.boolean().optional()
}).extend(TypeReferenceDeclarationWithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpQueryParameterSchema.js
var HttpQueryParameterSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), QueryParameterTypeReferenceDetailed]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/TypeReferenceDeclarationWithEnvOverrideSchema.js
var TypeReferenceDeclarationWithEnvOverrideSchema2 = schemas_exports2.object({
  env: schemas_exports2.string().optional()
}).extend(TypeReferenceDeclarationWithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/TypeReferenceDeclarationWithEnvOverride.js
var TypeReferenceDeclarationWithEnvOverride2 = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  TypeReferenceDeclarationWithEnvOverrideSchema2
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpHeaderSchema.js
var HttpHeaderSchema2 = TypeReferenceDeclarationWithEnvOverride2;

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpReferencedRequestBodySchema.js
var HttpReferencedRequestBodySchema = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/TypeReferenceDeclarationWithContentTypeSchema.js
var TypeReferenceDeclarationWithContentTypeSchema = schemas_exports2.object({
  "content-type": schemas_exports2.string().optional()
}).extend(TypeReferenceDeclarationWithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpInlineRequestBodyPropertySchema.js
var HttpInlineRequestBodyPropertySchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  TypeReferenceDeclarationWithContentTypeSchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpInlineRequestBodySchema.js
var HttpInlineRequestBodySchema = schemas_exports2.object({
  extends: ObjectExtendsSchema.optional(),
  "extra-properties": schemas_exports2.boolean().optional(),
  properties: schemas_exports2.record(schemas_exports2.string(), HttpInlineRequestBodyPropertySchema).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpRequestBodySchema.js
var HttpRequestBodySchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  HttpReferencedRequestBodySchema,
  HttpInlineRequestBodySchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpRequestSchema.js
var HttpRequestSchema = schemas_exports2.object({
  "content-type": schemas_exports2.string().optional(),
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), HttpPathParameterSchema).optional(),
  "query-parameters": schemas_exports2.record(schemas_exports2.string(), HttpQueryParameterSchema).optional(),
  headers: schemas_exports2.record(schemas_exports2.string(), HttpHeaderSchema2).optional(),
  body: HttpRequestBodySchema.optional()
}).extend(WithName2).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpRequest.js
var HttpRequest = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), HttpRequestSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpResponseSchemaDetailed.js
var HttpResponseSchemaDetailed = schemas_exports2.object({
  type: schemas_exports2.string(),
  property: schemas_exports2.string().optional(),
  "status-code": schemas_exports2.number().optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpResponseSchema.js
var HttpResponseSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), HttpResponseSchemaDetailed]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/StreamFormat.js
var StreamFormat2 = schemas_exports2.enum_(["sse", "json"]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpResponseStreamSchemaDetailed.js
var HttpResponseStreamSchemaDetailed = schemas_exports2.object({
  type: schemas_exports2.string(),
  format: StreamFormat2.optional(),
  terminator: schemas_exports2.string().optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpResponseStreamSchema.js
var HttpResponseStreamSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), HttpResponseStreamSchemaDetailed]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/ResponseErrorWithDocsSchema.js
var ResponseErrorWithDocsSchema = schemas_exports2.object({
  error: schemas_exports2.string()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/ResponseError.js
var ResponseError = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), ResponseErrorWithDocsSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/ResponseErrorsSchema.js
var ResponseErrorsSchema = schemas_exports2.list(ResponseError);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/pagination/types/CursorPaginationSchema.js
var CursorPaginationSchema = schemas_exports2.object({
  cursor: schemas_exports2.string(),
  next_cursor: schemas_exports2.string(),
  results: schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/pagination/types/OffsetPaginationSchema.js
var OffsetPaginationSchema = schemas_exports2.object({
  offset: schemas_exports2.string(),
  results: schemas_exports2.string(),
  step: schemas_exports2.string().optional(),
  "has-next-page": schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/pagination/types/PaginationSchema.js
var PaginationSchema = schemas_exports2.undiscriminatedUnion([CursorPaginationSchema, OffsetPaginationSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/Pagination.js
var Pagination2 = schemas_exports2.undiscriminatedUnion([PaginationSchema, schemas_exports2.boolean()]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpEndpointSchema.js
var HttpEndpointSchema = schemas_exports2.object({
  method: HttpMethodSchema2.optional(),
  "base-path": schemas_exports2.string().optional(),
  path: schemas_exports2.string(),
  url: schemas_exports2.string().optional(),
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), HttpPathParameterSchema).optional(),
  auth: schemas_exports2.boolean().optional(),
  idempotent: schemas_exports2.boolean().optional(),
  "stream-condition": schemas_exports2.string().optional(),
  request: HttpRequest.optional(),
  response: HttpResponseSchema.optional(),
  "response-stream": HttpResponseStreamSchema.optional(),
  errors: ResponseErrorsSchema.optional(),
  examples: schemas_exports2.list(ExampleEndpointCallSchema).optional(),
  pagination: Pagination2.optional(),
  transport: ServiceTransport.optional(),
  source: SourceSchema.optional()
}).extend(WithDisplayName).extend(DeclarationSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/types/HttpServiceSchema.js
var HttpServiceSchema = schemas_exports2.object({
  auth: schemas_exports2.boolean(),
  url: schemas_exports2.string().optional(),
  "base-path": schemas_exports2.string(),
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), schemas_exports2.string()).optional(),
  idempotent: schemas_exports2.boolean().optional(),
  headers: schemas_exports2.record(schemas_exports2.string(), TypeReferenceSchema).optional(),
  transport: ServiceTransport.optional(),
  source: SourceSchema.optional(),
  endpoints: schemas_exports2.record(schemas_exports2.string(), HttpEndpointSchema)
}).extend(DeclarationWithoutDocsSchema).extend(WithDisplayName);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/webhooks/types/WebhookMethodSchema.js
var WebhookMethodSchema2 = schemas_exports2.enum_(["POST", "GET"]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/webhooks/types/WebhookReferencedPayloadSchema.js
var WebhookReferencedPayloadSchema = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/webhooks/types/WebhookInlinedPayloadSchema.js
var WebhookInlinedPayloadSchema = schemas_exports2.object({
  name: schemas_exports2.string(),
  extends: ObjectExtendsSchema.optional(),
  properties: schemas_exports2.record(schemas_exports2.string(), ObjectPropertySchema).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/webhooks/types/WebhookPayloadSchema.js
var WebhookPayloadSchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  WebhookReferencedPayloadSchema,
  WebhookInlinedPayloadSchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/webhooks/types/WebhookSchema.js
var WebhookSchema = schemas_exports2.object({
  method: WebhookMethodSchema2,
  headers: schemas_exports2.record(schemas_exports2.string(), HttpHeaderSchema2).optional(),
  payload: WebhookPayloadSchema,
  examples: schemas_exports2.list(ExampleWebhookCallSchema).optional()
}).extend(WithAvailability2).extend(WithAudiences2).extend(WithDocsSchema2).extend(WithDisplayName);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/types/WebSocketOrigin.js
var WebSocketOrigin2 = schemas_exports2.enum_(["client", "server"]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/types/WebSocketChannelReferencedMessageSchema.js
var WebSocketChannelReferencedMessageSchema = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/types/WebSocketChannelInlinedMessageSchema.js
var WebSocketChannelInlinedMessageSchema = schemas_exports2.object({
  name: schemas_exports2.string(),
  extends: ObjectExtendsSchema.optional(),
  properties: schemas_exports2.record(schemas_exports2.string(), ObjectPropertySchema).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/types/WebSocketChannelMessageBodySchema.js
var WebSocketChannelMessageBodySchema = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  WebSocketChannelReferencedMessageSchema,
  WebSocketChannelInlinedMessageSchema
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/types/WebSocketChannelMessageSchema.js
var WebSocketChannelMessageSchema = schemas_exports2.object({
  origin: WebSocketOrigin2,
  body: WebSocketChannelMessageBodySchema
}).extend(DeclarationSchema).extend(WithDisplayName);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/types/WebSocketChannelSchema.js
var WebSocketChannelSchema = schemas_exports2.object({
  auth: schemas_exports2.boolean(),
  path: schemas_exports2.string(),
  headers: schemas_exports2.record(schemas_exports2.string(), HttpHeaderSchema2).optional(),
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), HttpPathParameterSchema).optional(),
  "query-parameters": schemas_exports2.record(schemas_exports2.string(), HttpQueryParameterSchema).optional(),
  messages: schemas_exports2.record(schemas_exports2.string(), WebSocketChannelMessageSchema).optional(),
  examples: schemas_exports2.list(ExampleWebSocketSession).optional()
}).extend(DeclarationSchema).extend(WithDisplayName);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/DefinitionFileSchema.js
var DefinitionFileSchema = schemas_exports2.object({
  imports: schemas_exports2.record(schemas_exports2.string(), schemas_exports2.string()).optional(),
  types: schemas_exports2.record(schemas_exports2.string(), TypeDeclarationSchema).optional(),
  service: HttpServiceSchema.optional(),
  errors: schemas_exports2.record(schemas_exports2.string(), ErrorDeclarationSchema).optional(),
  webhooks: schemas_exports2.record(schemas_exports2.string(), WebhookSchema).optional(),
  channel: WebSocketChannelSchema.optional()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/Navigation.js
var Navigation = schemas_exports2.undiscriminatedUnion([
  schemas_exports2.string(),
  schemas_exports2.list(schemas_exports2.string())
]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/ExportDetailed.js
var ExportDetailed = schemas_exports2.object({
  dependency: schemas_exports2.string(),
  url: schemas_exports2.string().optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/Export.js
var Export = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), ExportDetailed]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/PackageMarkerFileSchema.js
var PackageMarkerFileSchema = schemas_exports2.object({
  navigation: Navigation.optional(),
  export: Export.optional()
}).extend(DefinitionFileSchema);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/WithHeadersSchema.js
var WithHeadersSchema2 = schemas_exports2.object({
  headers: schemas_exports2.record(schemas_exports2.string(), HttpHeaderSchema2).optional()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/PropertyBasedErrorDiscrimination.js
var PropertyBasedErrorDiscrimination = schemas_exports2.object({
  strategy: schemas_exports2.stringLiteral("property"),
  "property-name": schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/StatusCodeBasedErrorDiscrimination.js
var StatusCodeBasedErrorDiscrimination = schemas_exports2.object({
  strategy: schemas_exports2.stringLiteral("status-code")
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/ErrorDiscriminationSchema.js
var ErrorDiscriminationSchema = schemas_exports2.undiscriminatedUnion([PropertyBasedErrorDiscrimination, StatusCodeBasedErrorDiscrimination]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/variables/types/VariableDeclarationDetailed.js
var VariableDeclarationDetailed = schemas_exports2.object({
  type: schemas_exports2.string()
}).extend(WithDocsSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/variables/types/VariableDeclarationSchema.js
var VariableDeclarationSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), VariableDeclarationDetailed]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/versioning/types/VersionValueDetailed.js
var VersionValueDetailed = schemas_exports2.object({
  value: schemas_exports2.string()
}).extend(WithDocsSchema2).extend(WithName2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/versioning/types/VersionValue.js
var VersionValue = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), VersionValueDetailed]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/versioning/types/VersionDeclarationHeaderObjectSchema.js
var VersionDeclarationHeaderObjectSchema = schemas_exports2.object({
  name: schemas_exports2.string().optional(),
  env: schemas_exports2.string().optional(),
  value: schemas_exports2.string()
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/versioning/types/VersionDeclarationHeaderSchema.js
var VersionDeclarationHeaderSchema = schemas_exports2.undiscriminatedUnion([schemas_exports2.string(), VersionDeclarationHeaderObjectSchema]);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/versioning/types/VersionDeclarationSchema.js
var VersionDeclarationSchema = schemas_exports2.object({
  default: schemas_exports2.string().optional(),
  values: schemas_exports2.list(VersionValue),
  header: VersionDeclarationHeaderSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/file/types/RootApiFileSchema.js
var RootApiFileSchema = schemas_exports2.object({
  name: schemas_exports2.string(),
  imports: schemas_exports2.record(schemas_exports2.string(), schemas_exports2.string()).optional(),
  "error-discrimination": ErrorDiscriminationSchema.optional(),
  audiences: schemas_exports2.list(schemas_exports2.string()).optional(),
  errors: schemas_exports2.list(schemas_exports2.string()).optional(),
  "base-path": schemas_exports2.string().optional(),
  "path-parameters": schemas_exports2.record(schemas_exports2.string(), HttpPathParameterSchema).optional(),
  "idempotency-headers": schemas_exports2.record(schemas_exports2.string(), HttpHeaderSchema2).optional(),
  variables: schemas_exports2.record(schemas_exports2.string(), VariableDeclarationSchema).optional(),
  pagination: PaginationSchema.optional(),
  version: VersionDeclarationSchema.optional()
}).extend(WithDocsSchema2).extend(WithDisplayName).extend(WithEnvironmentsSchema2).extend(WithAuthSchema).extend(WithHeadersSchema2);

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/pagination/index.js
var pagination_exports2 = {};
__export(pagination_exports2, {
  CursorPaginationSchema: () => CursorPaginationSchema,
  OffsetPaginationSchema: () => OffsetPaginationSchema,
  PaginationSchema: () => PaginationSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/service/index.js
var service_exports4 = {};
__export(service_exports4, {
  GrpcTransport: () => GrpcTransport,
  HttpEndpointSchema: () => HttpEndpointSchema,
  HttpHeaderSchema: () => HttpHeaderSchema2,
  HttpInlineRequestBodyPropertySchema: () => HttpInlineRequestBodyPropertySchema,
  HttpInlineRequestBodySchema: () => HttpInlineRequestBodySchema,
  HttpMethodSchema: () => HttpMethodSchema2,
  HttpPathParameterSchema: () => HttpPathParameterSchema,
  HttpQueryParameterSchema: () => HttpQueryParameterSchema,
  HttpReferencedRequestBodySchema: () => HttpReferencedRequestBodySchema,
  HttpRequest: () => HttpRequest,
  HttpRequestBodySchema: () => HttpRequestBodySchema,
  HttpRequestSchema: () => HttpRequestSchema,
  HttpResponseSchema: () => HttpResponseSchema,
  HttpResponseSchemaDetailed: () => HttpResponseSchemaDetailed,
  HttpResponseStreamSchema: () => HttpResponseStreamSchema,
  HttpResponseStreamSchemaDetailed: () => HttpResponseStreamSchemaDetailed,
  HttpServiceSchema: () => HttpServiceSchema,
  Pagination: () => Pagination2,
  QueryParameterTypeReferenceDetailed: () => QueryParameterTypeReferenceDetailed,
  ResponseError: () => ResponseError,
  ResponseErrorWithDocsSchema: () => ResponseErrorWithDocsSchema,
  ResponseErrorsSchema: () => ResponseErrorsSchema,
  ServiceTransport: () => ServiceTransport,
  StreamFormat: () => StreamFormat2,
  TypeReferenceDeclarationWithContentTypeSchema: () => TypeReferenceDeclarationWithContentTypeSchema,
  TypeReferenceDeclarationWithEnvOverride: () => TypeReferenceDeclarationWithEnvOverride2,
  TypeReferenceDeclarationWithEnvOverrideSchema: () => TypeReferenceDeclarationWithEnvOverrideSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/source/index.js
var source_exports2 = {};
__export(source_exports2, {
  OpenApiSourceSchema: () => OpenApiSourceSchema,
  ProtobufSourceSchema: () => ProtobufSourceSchema,
  SourceSchema: () => SourceSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/types/index.js
var types_exports6 = {};
__export(types_exports6, {
  AliasSchema: () => AliasSchema,
  BaseTypeDeclarationSchema: () => BaseTypeDeclarationSchema,
  BaseTypeReferenceSchema: () => BaseTypeReferenceSchema2,
  CasingOverridesSchema: () => CasingOverridesSchema,
  DiscriminatedUnionSchema: () => DiscriminatedUnionSchema,
  EnumSchema: () => EnumSchema,
  EnumValue: () => EnumValue,
  EnumValueSchema: () => EnumValueSchema,
  ObjectExtendsSchema: () => ObjectExtendsSchema,
  ObjectPropertySchema: () => ObjectPropertySchema,
  ObjectSchema: () => ObjectSchema,
  SingleUndiscriminatedUnionTypeDetailedSchema: () => SingleUndiscriminatedUnionTypeDetailedSchema,
  SingleUndiscriminatedUnionTypeSchema: () => SingleUndiscriminatedUnionTypeSchema,
  SingleUnionTypeDetailedSchema: () => SingleUnionTypeDetailedSchema,
  SingleUnionTypeKey: () => SingleUnionTypeKey,
  SingleUnionTypeKeySchema: () => SingleUnionTypeKeySchema,
  SingleUnionTypeSchema: () => SingleUnionTypeSchema,
  TypeDeclarationSchema: () => TypeDeclarationSchema,
  TypeReferenceDeclarationWithName: () => TypeReferenceDeclarationWithName2,
  TypeReferenceDeclarationWithNameSchema: () => TypeReferenceDeclarationWithNameSchema,
  TypeReferenceDetailedSchema: () => TypeReferenceDetailedSchema,
  TypeReferenceSchema: () => TypeReferenceSchema,
  UndiscriminatedUnionSchema: () => UndiscriminatedUnionSchema,
  UnionDiscriminant: () => UnionDiscriminant,
  UnionDiscriminantSchema: () => UnionDiscriminantSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/validation/index.js
var validation_exports4 = {};
__export(validation_exports4, {
  NumberValidationSchema: () => NumberValidationSchema2,
  StringValidationSchema: () => StringValidationSchema2,
  ValidationSchema: () => ValidationSchema2
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/variables/index.js
var variables_exports3 = {};
__export(variables_exports3, {
  VariableDeclarationDetailed: () => VariableDeclarationDetailed,
  VariableDeclarationSchema: () => VariableDeclarationSchema,
  VariableReferenceSchema: () => VariableReferenceSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/versioning/index.js
var versioning_exports2 = {};
__export(versioning_exports2, {
  VersionDeclarationHeaderObjectSchema: () => VersionDeclarationHeaderObjectSchema,
  VersionDeclarationHeaderSchema: () => VersionDeclarationHeaderSchema,
  VersionDeclarationSchema: () => VersionDeclarationSchema,
  VersionValue: () => VersionValue,
  VersionValueDetailed: () => VersionValueDetailed
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/webhooks/index.js
var webhooks_exports3 = {};
__export(webhooks_exports3, {
  WebhookInlinedPayloadSchema: () => WebhookInlinedPayloadSchema,
  WebhookMethodSchema: () => WebhookMethodSchema2,
  WebhookPayloadSchema: () => WebhookPayloadSchema,
  WebhookReferencedPayloadSchema: () => WebhookReferencedPayloadSchema,
  WebhookSchema: () => WebhookSchema
});

// ../../cli/fern-definition/schema/lib/schemas/serialization/resources/websocket/index.js
var websocket_exports3 = {};
__export(websocket_exports3, {
  WebSocketChannelInlinedMessageSchema: () => WebSocketChannelInlinedMessageSchema,
  WebSocketChannelMessageBodySchema: () => WebSocketChannelMessageBodySchema,
  WebSocketChannelMessageSchema: () => WebSocketChannelMessageSchema,
  WebSocketChannelReferencedMessageSchema: () => WebSocketChannelReferencedMessageSchema,
  WebSocketChannelSchema: () => WebSocketChannelSchema,
  WebSocketOrigin: () => WebSocketOrigin2
});

// ../../cli/fern-definition/schema/lib/schemas/errors/FernDefinitionError.js
var FernDefinitionError = class _FernDefinitionError extends Error {
  statusCode;
  body;
  constructor({ message, statusCode, body }) {
    super(buildMessage({ message, statusCode, body }));
    Object.setPrototypeOf(this, _FernDefinitionError.prototype);
    if (statusCode != null) {
      this.statusCode = statusCode;
    }
    if (body !== void 0) {
      this.body = body;
    }
  }
};
function buildMessage({ message, statusCode, body }) {
  let lines = [];
  if (message != null) {
    lines.push(message);
  }
  if (statusCode != null) {
    lines.push(`Status code: ${statusCode.toString()}`);
  }
  if (body != null) {
    lines.push(`Body: ${JSON.stringify(body, void 0, 2)}`);
  }
  return lines.join("\n");
}

// ../../cli/fern-definition/schema/lib/schemas/errors/FernDefinitionTimeoutError.js
var FernDefinitionTimeoutError = class _FernDefinitionTimeoutError extends Error {
  constructor() {
    super("Timeout");
    Object.setPrototypeOf(this, _FernDefinitionTimeoutError.prototype);
  }
};

// ../../cli/fern-definition/schema/lib/utils/RawContainerType.js
var RawContainerType = {
  optional: "optional",
  set: "set",
  list: "list",
  map: "map",
  literal: "literal"
};
var RawContainerTypes = new Set(Object.values(RawContainerType));

// ../../cli/fern-definition/schema/lib/utils/generics/parseGeneric.js
function parseGeneric(name) {
  const genericMatch = name.match(/([\w.]+)<([\w,\s]+)>/);
  if (genericMatch?.[0] != null && genericMatch[1] != null && genericMatch[2] != null && !RawContainerTypes.has(genericMatch[1].trim())) {
    return {
      name: genericMatch[1].trim(),
      arguments: genericMatch[2].split(",").map((arg) => arg.trim())
    };
  }
  return void 0;
}

// ../../cli/fern-definition/schema/lib/utils/generics/isGeneric.js
function isGeneric(name) {
  return parseGeneric(name) != null;
}

// ../../cli/fern-definition/schema/lib/utils/isInlineRequestBody.js
function isInlineRequestBody(requestBody) {
  if (typeof requestBody === "string") {
    return false;
  }
  return (
    // eslint-disable-next-line @typescript-eslint/no-unnecessary-condition
    requestBody?.extends != null || // eslint-disable-next-line @typescript-eslint/no-unnecessary-condition
    requestBody?.properties != null
  );
}

// ../../cli/fern-definition/schema/lib/utils/isRawProtobufSourceSchema.js
function isRawProtobufSourceSchema(rawSourceSchema) {
  if (!rawSourceSchema) {
    return false;
  }
  return rawSourceSchema.proto != null;
}

// ../../cli/fern-definition/schema/lib/utils/isRawTextType.js
var TEXT_TYPE = "text";
function isRawTextType(typeReference) {
  return typeReference === TEXT_TYPE;
}

// ../../cli/fern-definition/schema/lib/utils/RawPrimitiveType.js
var RawPrimitiveType = {
  integer: "integer",
  long: "long",
  uint: "uint",
  uint64: "uint64",
  float: "float",
  double: "double",
  boolean: "boolean",
  string: "string",
  datetime: "datetime",
  base64: "base64",
  uuid: "uuid",
  date: "date",
  bigint: "bigint",
  unknown: "unknown"
};

// ../../cli/fern-definition/schema/lib/utils/visitRawTypeReference.js
var FernContainerRegex = {
  MAP: /^map<\s*([^,]*)\s*,\s*(.*)\s*>$/,
  LIST: /^list<\s*(.*)\s*>$/,
  SET: /^set<\s*(.*)\s*>$/,
  OPTIONAL: /^optional<\s*(.*)\s*>$/,
  LITERAL: /^literal<\s*(?:"(.*)"|(true|false))\s*>$/
};
function visitRawTypeReference({ type: type2, _default: _default2, validation, visitor }) {
  switch (type2) {
    case RawPrimitiveType.integer: {
      const maybeNumberValidation2 = validation != null ? validation : void 0;
      return visitor.primitive({
        v1: PrimitiveTypeV1.Integer,
        v2: PrimitiveTypeV2.integer({
          default: _default2 != null ? _default2 : void 0,
          validation: maybeNumberValidation2 != null ? {
            min: maybeNumberValidation2.min,
            max: maybeNumberValidation2.max,
            exclusiveMin: maybeNumberValidation2.exclusiveMin,
            exclusiveMax: maybeNumberValidation2.exclusiveMax,
            multipleOf: maybeNumberValidation2.multipleOf
          } : void 0
        })
      });
    }
    case RawPrimitiveType.double: {
      const maybeNumberValidation2 = validation != null ? validation : void 0;
      return visitor.primitive({
        v1: PrimitiveTypeV1.Double,
        v2: PrimitiveTypeV2.double({
          default: _default2 != null ? _default2 : void 0,
          validation: maybeNumberValidation2 != null ? {
            min: maybeNumberValidation2.min,
            max: maybeNumberValidation2.max,
            exclusiveMin: maybeNumberValidation2.exclusiveMin,
            exclusiveMax: maybeNumberValidation2.exclusiveMax,
            multipleOf: maybeNumberValidation2.multipleOf
          } : void 0
        })
      });
    }
    case RawPrimitiveType.string: {
      const maybeStringValidation3 = validation != null ? validation : void 0;
      return visitor.primitive({
        v1: PrimitiveTypeV1.String,
        v2: PrimitiveTypeV2.string({
          default: _default2 != null ? _default2 : void 0,
          validation: maybeStringValidation3 != null ? {
            format: maybeStringValidation3.format,
            pattern: maybeStringValidation3.pattern,
            minLength: maybeStringValidation3.minLength,
            maxLength: maybeStringValidation3.maxLength
          } : void 0
        })
      });
    }
    case RawPrimitiveType.float:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Float,
        v2: void 0
      });
    case RawPrimitiveType.long:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Long,
        v2: void 0
      });
    case RawPrimitiveType.boolean:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Boolean,
        v2: void 0
      });
    case RawPrimitiveType.datetime:
      return visitor.primitive({
        v1: PrimitiveTypeV1.DateTime,
        v2: void 0
      });
    case RawPrimitiveType.date:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Date,
        v2: void 0
      });
    case RawPrimitiveType.uuid:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Uuid,
        v2: void 0
      });
    case RawPrimitiveType.base64:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Base64,
        v2: void 0
      });
    case RawPrimitiveType.bigint:
      return visitor.primitive({
        v1: PrimitiveTypeV1.BigInteger,
        v2: void 0
      });
    case RawPrimitiveType.uint:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Uint,
        v2: void 0
      });
    case RawPrimitiveType.uint64:
      return visitor.primitive({
        v1: PrimitiveTypeV1.Uint64,
        v2: void 0
      });
    case RawPrimitiveType.unknown:
      return visitor.unknown();
  }
  const mapMatch = type2.match(FernContainerRegex.MAP);
  if (mapMatch?.[1] != null && mapMatch[2] != null) {
    return visitor.map({
      keyType: mapMatch[1],
      valueType: mapMatch[2]
    });
  }
  const listMatch = type2.match(FernContainerRegex.LIST);
  if (listMatch?.[1] != null) {
    return visitor.list(listMatch[1]);
  }
  const setMatch = type2.match(FernContainerRegex.SET);
  if (setMatch?.[1] != null) {
    return visitor.set(setMatch[1]);
  }
  const optionalMatch = type2.match(FernContainerRegex.OPTIONAL);
  if (optionalMatch?.[1] != null) {
    return visitor.optional(optionalMatch[1]);
  }
  const literalMatch = type2.match(FernContainerRegex.LITERAL);
  if (literalMatch?.[1] != null) {
    return visitor.literal(Literal.string(literalMatch[1]));
  }
  if (literalMatch?.[2] != null) {
    const group = literalMatch[2];
    switch (group) {
      case "false":
        return visitor.literal(Literal.boolean(false));
      case "true":
        return visitor.literal(Literal.boolean(true));
      default:
        throw new Error(`Unsupported literal value: ${group}`);
    }
  }
  return visitor.named(type2);
}

// ../../cli/fern-definition/schema/lib/utils/parseRawBytesType.js
var BYTES_TYPE = "bytes";
function parseRawBytesType(typeReference) {
  if (typeReference === BYTES_TYPE) {
    return { isOptional: false };
  }
  const optionalMatch = typeReference.match(FernContainerRegex.OPTIONAL);
  if (optionalMatch?.[1] === BYTES_TYPE) {
    return { isOptional: true };
  }
  return void 0;
}

// ../../cli/fern-definition/schema/lib/utils/parseBytesRequest.js
function parseBytesRequest(request) {
  const reference = typeof request === "string" ? request : typeof request.body === "string" ? request.body : void 0;
  if (reference == null) {
    return void 0;
  }
  return parseRawBytesType(reference);
}

// ../../cli/fern-definition/schema/lib/utils/parseRawFileType.js
var FILE_TYPE = "file";
function isFileArray(typeReference) {
  const listMatch = typeReference.match(FernContainerRegex.LIST);
  if (listMatch?.[1] === FILE_TYPE) {
    return true;
  }
  return false;
}
function parseRawFileType(typeReference) {
  if (typeReference === FILE_TYPE) {
    return { isOptional: false, isArray: false };
  }
  const optionalMatch = typeReference.match(FernContainerRegex.OPTIONAL);
  if (optionalMatch?.[1] !== void 0) {
    if (optionalMatch[1] === FILE_TYPE) {
      return { isOptional: true, isArray: false };
    } else if (isFileArray(optionalMatch[1])) {
      return { isOptional: true, isArray: true };
    }
  }
  if (isFileArray(typeReference)) {
    return { isOptional: false, isArray: true };
  }
  return void 0;
}

// ../../cli/fern-definition/schema/lib/utils/parseFileUploadRequest.js
function isFileUploadRequest(request) {
  if (typeof request === "string") {
    return false;
  }
  if (MediaType.parse(request["content-type"])?.isMultiPartFormData() ?? false) {
    return true;
  }
  if (request.body != null && isInlineRequestBody(request.body)) {
    if (Object.values(request.body.properties ?? []).some((property4) => {
      const propertyType = typeof property4 === "string" ? property4 : property4.type;
      return propertyType === "file";
    })) {
      return true;
    }
  }
  return false;
}
function parseFileUploadRequest(request) {
  if (!isFileUploadRequest(request) || request.body == null) {
    return void 0;
  }
  if (request.name == null) {
    return void 0;
  }
  if (request.body != null && isInlineRequestBody(request.body)) {
    return createRawFileUploadRequest(request.name, request.body);
  }
  return void 0;
}
function createRawFileUploadRequest(requestName, requestBody) {
  const properties = Object.entries(requestBody.properties ?? []).reduce((acc, [key, propertyType]) => {
    const docs = typeof propertyType !== "string" ? propertyType.docs : void 0;
    const contentType = typeof propertyType !== "string" ? propertyType["content-type"] : void 0;
    const maybeParsedFileType = parseRawFileType(typeof propertyType === "string" ? propertyType : propertyType.type);
    if (maybeParsedFileType != null) {
      acc.push({
        isFile: true,
        key,
        docs,
        isOptional: maybeParsedFileType.isOptional,
        isArray: maybeParsedFileType.isArray,
        contentType
      });
    } else {
      acc.push({ isFile: false, key, propertyType, docs, contentType });
    }
    return acc;
  }, []);
  if (requestBody["extra-properties"]) {
  }
  return {
    name: requestName,
    // TODO: handle requestBody.extends
    extends: requestBody.extends,
    properties
  };
}

// ../../cli/fern-definition/schema/lib/utils/parseRawTextType.js
var TEXT_TYPE2 = "text";
function parseRawTextType(typeReference) {
  if (typeReference === TEXT_TYPE2) {
    return { isOptional: false };
  }
  const optionalMatch = typeReference.match(FernContainerRegex.OPTIONAL);
  if (optionalMatch?.[1] === TEXT_TYPE2) {
    return { isOptional: true };
  }
  return void 0;
}

// ../../cli/fern-definition/schema/lib/utils/recursivelyVisitRawTypeReference.js
function recursivelyVisitRawTypeReference({ type: type2, _default: _default2, validation, visitor }) {
  return visitRawTypeReference({
    type: type2,
    _default: _default2,
    validation,
    visitor: {
      primitive: visitor.primitive,
      map: ({ keyType, valueType }) => visitor.map({
        keyType: recursivelyVisitRawTypeReference({
          type: keyType,
          _default: void 0,
          validation: void 0,
          visitor
        }),
        valueType: recursivelyVisitRawTypeReference({
          type: valueType,
          _default: void 0,
          validation: void 0,
          visitor
        })
      }),
      list: (valueType) => visitor.list(recursivelyVisitRawTypeReference({
        type: valueType,
        _default: void 0,
        validation: void 0,
        visitor
      })),
      set: (valueType) => visitor.set(recursivelyVisitRawTypeReference({
        type: valueType,
        _default: void 0,
        validation: void 0,
        visitor
      })),
      optional: (valueType) => visitor.optional(recursivelyVisitRawTypeReference({ type: valueType, _default: _default2, validation, visitor })),
      literal: visitor.literal,
      named: visitor.named,
      unknown: visitor.unknown
    }
  });
}

// ../../cli/fern-definition/schema/lib/utils/visitExampleCodeSampleSchema.js
function visitExampleCodeSampleSchema(codeSample, visitor) {
  if (isExampleCodeSampleSchemaSdk(codeSample)) {
    return visitor.sdk(codeSample);
  }
  if (isExampleCodeSampleSchemaLanguage(codeSample)) {
    return visitor.language(codeSample);
  }
  assertNever(codeSample);
}
function isExampleCodeSampleSchemaSdk(codeSample) {
  return codeSample.sdk != null;
}
function isExampleCodeSampleSchemaLanguage(codeSample) {
  return codeSample.language != null;
}

// ../../cli/fern-definition/schema/lib/utils/isSimpleStreamResponseSchema.js
function isSimpleStreamResponseSchema(endpoint) {
  return endpoint["response-stream"] != null && (typeof endpoint["response-stream"] === "string" || endpoint["response-stream"].format == null || endpoint["response-stream"].format === "json");
}

// ../../cli/fern-definition/schema/lib/utils/isSseStreamResponseSchema.js
function isSseStsreamResponseSchema(endpoint) {
  return endpoint["response-stream"] != null && typeof endpoint["response-stream"] !== "string" && endpoint["response-stream"].format === "sse";
}

// ../../cli/fern-definition/schema/lib/utils/visitExampleResponseSchema.js
function visitExampleResponseSchema(endpoint, example, visitor) {
  if (isExampleStreamResponseSchema(endpoint, example)) {
    return visitor.stream(example);
  } else if (isExampleSseResponseSchema(endpoint, example)) {
    return visitor.events(example);
  } else {
    return visitor.body(example);
  }
}
function isExampleStreamResponseSchema(endpoint, example) {
  return example.stream !== void 0 && isSimpleStreamResponseSchema(endpoint);
}
function isExampleSseResponseSchema(endpoint, example) {
  return example.stream !== void 0 && isSseStsreamResponseSchema(endpoint);
}

// ../../cli/fern-definition/schema/lib/utils/visitRawApiAuth.js
function visitRawApiAuth(apiAuth, visitor) {
  if (isSingleAuthScheme(apiAuth)) {
    return visitor.single(apiAuth);
  }
  if (isAnyAuthSchemes(apiAuth)) {
    return visitor.any(apiAuth);
  }
  assertNever(apiAuth);
}
function isSingleAuthScheme(apiAuth) {
  return typeof apiAuth === "string" || apiAuth.scheme != null;
}
function isAnyAuthSchemes(apiAuth) {
  const [firstKey, ...rest] = Object.keys(apiAuth);
  return firstKey === "any" && rest.length === 0;
}

// ../../cli/fern-definition/schema/lib/utils/visitRawAuthSchemeDeclaration.js
function visitRawAuthSchemeDeclaration(authScheme, visitor) {
  if (isHeaderAuthScheme(authScheme)) {
    return visitor.header(authScheme);
  }
  switch (authScheme.scheme) {
    case "basic":
      return visitor.basic(authScheme);
    case "bearer":
      return visitor.bearer(authScheme);
    case "oauth":
      return visitor.oauth(authScheme);
    default:
      assertNever(authScheme);
  }
}
function isHeaderAuthScheme(authScheme) {
  return authScheme.header != null;
}

// ../../cli/fern-definition/schema/lib/utils/visitRawEnvironmentDeclaration.js
function visitRawEnvironmentDeclaration(environment, visitor) {
  if (isRawSingleBaseUrlEnvironment(environment)) {
    return visitor.singleBaseUrl(environment);
  }
  if (isRawMultipleBaseUrlsEnvironment(environment)) {
    return visitor.multipleBaseUrls(environment);
  }
  assertNever(environment);
}
function isRawSingleBaseUrlEnvironment(environment) {
  return typeof environment === "string" || "url" in environment;
}
function isRawMultipleBaseUrlsEnvironment(environment) {
  return typeof environment !== "string" && "urls" in environment;
}

// ../../cli/fern-definition/schema/lib/utils/visitRawPathParameter.js
function isVariablePathParameter(rawPathParameter) {
  if (typeof rawPathParameter === "string") {
    return rawPathParameter.startsWith("$");
  }
  return "variable" in rawPathParameter;
}

// ../../cli/fern-definition/schema/lib/utils/visitRawTypeDeclaration.js
function visitRawTypeDeclaration(declaration, visitor) {
  if (isRawAliasDefinition(declaration)) {
    return visitor.alias(declaration);
  }
  if (isRawDiscriminatedUnionDefinition(declaration)) {
    return visitor.discriminatedUnion(declaration);
  }
  if (isRawObjectDefinition(declaration)) {
    return visitor.object(declaration);
  }
  if (isRawUndiscriminatedUnionDefinition(declaration)) {
    return visitor.undiscriminatedUnion(declaration);
  }
  if (isRawEnumDefinition(declaration)) {
    return visitor.enum(declaration);
  }
  assertNever(declaration);
}
function isRawAliasDefinition(rawTypeDeclaration) {
  return typeof rawTypeDeclaration === "string" || rawTypeDeclaration.type != null;
}
function isRawObjectDefinition(rawTypeDeclaration) {
  return rawTypeDeclaration.extends != null || rawTypeDeclaration.properties != null;
}
function isRawDiscriminatedUnionDefinition(rawTypeDeclaration) {
  return (
    // eslint-disable-next-line @typescript-eslint/no-unnecessary-condition
    rawTypeDeclaration.union != null && // eslint-disable-next-line @typescript-eslint/no-explicit-any
    rawTypeDeclaration.discriminated == null
  );
}
function isRawUndiscriminatedUnionDefinition(rawTypeDeclaration) {
  const undiscriminatedUnionSchema = rawTypeDeclaration;
  return undiscriminatedUnionSchema.union != null && undiscriminatedUnionSchema.discriminated != null;
}
function isRawEnumDefinition(rawTypeDeclaration) {
  return rawTypeDeclaration.enum != null;
}

// ../../cli/fern-definition/schema/lib/utils/HttpEndpointReferenceParser.js
var HttpEndpointReferenceParser = class {
  //eslint-disable-next-line
  REFERENCE_REGEX = /^(GET|POST|PUT|DELETE|PATCH)\s(\/[a-zA-Z0-9\/]*)$/;
  validate(reference) {
    const validFormat = this.REFERENCE_REGEX.test(reference);
    if (!validFormat) {
      return { type: "invalid" };
    }
    return { type: "valid" };
  }
  tryParse(reference) {
    const validationResponse = this.validate(reference);
    if (validationResponse.type === "invalid") {
      return void 0;
    }
    const match = reference.match(this.REFERENCE_REGEX);
    if (match == null || match[1] == null || match[2] == null) {
      return void 0;
    }
    return {
      method: match[1],
      path: match[2]
    };
  }
};

// ../../cli/generation/ir-generator/lib/utils/parseTypeName.js
function parseTypeName({ typeName, file }) {
  const reference = parseReferenceToTypeName({
    reference: typeName,
    referencedIn: file.relativeFilepath,
    imports: file.imports
  });
  if (reference == null) {
    throw new Error("Failed to locate type: " + typeName);
  }
  const nameWithoutId = {
    name: file.casingsGenerator.generateName(reference.typeName),
    fernFilepath: convertToFernFilepath({
      relativeFilepath: reference.relativeFilepath,
      casingsGenerator: file.casingsGenerator
    })
  };
  return {
    ...nameWithoutId,
    typeId: IdGenerator.generateTypeId(nameWithoutId)
  };
}

// ../../cli/generation/ir-generator/lib/formatDocs.js
var isBrowser2 = typeof window !== "undefined" && typeof window.document !== "undefined";
async function formatDocs(docs) {
  if (docs == null || isBrowser2) {
    return void 0;
  }
  const prettier = await import("prettier");
  const formattedDocs = prettier.format(docs, {
    parser: "markdown"
  });
  if (formattedDocs.endsWith("\n") || formattedDocs.endsWith("\r")) {
    return formattedDocs.substring(0, formattedDocs.length - 1);
  }
  return formattedDocs;
}

// ../../cli/generation/ir-generator/lib/converters/convertDeclaration.js
var DEFAULT_DECLARATION = {
  docs: void 0,
  availability: void 0
};
async function convertDeclaration(declaration) {
  if (typeof declaration === "string") {
    return DEFAULT_DECLARATION;
  }
  return {
    docs: await formatDocs(declaration.docs),
    availability: convertAvailability(declaration.availability)
  };
}
function convertAvailability(availability) {
  if (availability == null) {
    return void 0;
  }
  return {
    status: convertAvailabilityStatus(typeof availability === "string" ? availability : availability.status),
    message: typeof availability !== "string" ? availability.message : void 0
  };
}
function getAudiences(schema2) {
  if (typeof schema2 === "string") {
    return [];
  }
  return schema2.audiences ?? [];
}
function convertAvailabilityStatus(status) {
  switch (status) {
    case "in-development":
      return AvailabilityStatus.InDevelopment;
    case "pre-release":
      return AvailabilityStatus.PreRelease;
    case "deprecated":
      return AvailabilityStatus.Deprecated;
    case "generally-available":
      return AvailabilityStatus.GeneralAvailability;
    default:
      assertNever(status);
  }
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertObjectTypeDeclaration.js
async function convertObjectTypeDeclaration({ object: object3, file }) {
  return Type.object({
    extends: getExtensionsAsList(object3.extends).map((extended) => parseTypeName({ typeName: extended, file })),
    properties: await getObjectPropertiesFromRawObjectSchema(object3, file),
    extraProperties: object3["extra-properties"] ?? false,
    extendedProperties: void 0
  });
}
async function getObjectPropertiesFromRawObjectSchema(object3, file) {
  if (object3.properties == null) {
    return [];
  }
  return await Promise.all(Object.entries(object3.properties).map(async ([propertyKey, propertyDefinition]) => ({
    ...await convertDeclaration(propertyDefinition),
    name: file.casingsGenerator.generateNameAndWireValue({
      wireValue: propertyKey,
      name: getPropertyName({ propertyKey, property: propertyDefinition }).name
    }),
    valueType: file.parseTypeReference(propertyDefinition)
  })));
}
function getExtensionsAsList(extensions) {
  if (extensions == null) {
    return [];
  }
  if (typeof extensions === "string") {
    return [extensions];
  }
  return extensions;
}
function getPropertyName({ propertyKey, property: property4 }) {
  if (typeof property4 !== "string" && property4.name != null) {
    return {
      name: property4.name,
      wasExplicitlySet: true
    };
  }
  return {
    name: propertyKey,
    wasExplicitlySet: false
  };
}

// ../../cli/generation/ir-generator/lib/converters/services/convertHttpRequestBody.js
function convertHttpRequestBody({ request, file }) {
  const bytesRequest = request != null ? parseBytesRequest(request) : void 0;
  if (bytesRequest != null) {
    return HttpRequestBody.bytes({
      isOptional: bytesRequest.isOptional,
      contentType: typeof request === "string" ? void 0 : request?.["content-type"],
      docs: typeof request === "string" ? void 0 : request?.docs
    });
  }
  if (typeof request === "string") {
    return HttpRequestBody.reference(convertReferenceHttpRequestBody({
      requestBody: request,
      file
    }));
  }
  if (request?.body == null) {
    return void 0;
  }
  const fileUploadRequest = parseFileUploadRequest(request);
  if (fileUploadRequest != null) {
    return HttpRequestBody.fileUpload({
      name: file.casingsGenerator.generateName(fileUploadRequest.name),
      properties: fileUploadRequest.properties.map((property4) => {
        if (property4.isFile) {
          if (property4.isArray) {
            return FileUploadRequestProperty.file(FileProperty.fileArray({
              key: file.casingsGenerator.generateNameAndWireValue({
                wireValue: property4.key,
                name: property4.key
              }),
              isOptional: property4.isOptional,
              contentType: property4.contentType
            }));
          } else {
            return FileUploadRequestProperty.file(FileProperty.file({
              key: file.casingsGenerator.generateNameAndWireValue({
                wireValue: property4.key,
                name: property4.key
              }),
              isOptional: property4.isOptional,
              contentType: property4.contentType
            }));
          }
        } else {
          return FileUploadRequestProperty.bodyProperty({
            ...convertInlinedRequestProperty({
              propertyKey: property4.key,
              propertyDefinition: property4.propertyType,
              docs: property4.docs,
              availability: convertAvailability(property4.availability),
              file
            }),
            contentType: property4.contentType
          });
        }
      }),
      docs: request.docs
    });
  }
  if (isInlineRequestBody(request.body)) {
    if (request.name == null) {
      throw new Error("Name is missing for inlined request");
    }
    return HttpRequestBody.inlinedRequestBody({
      name: file.casingsGenerator.generateName(request.name),
      extends: getExtensionsAsList(request.body.extends).map((extended) => parseTypeName({ typeName: extended, file })),
      contentType: request["content-type"],
      docs: request.docs,
      properties: request.body.properties != null ? Object.entries(request.body.properties).map(([propertyKey, propertyDefinition]) => convertInlinedRequestProperty({
        propertyKey,
        propertyDefinition,
        docs: typeof propertyDefinition !== "string" ? propertyDefinition.docs : void 0,
        availability: typeof propertyDefinition !== "string" ? convertAvailability(propertyDefinition.availability) : void 0,
        file
      })) : [],
      extraProperties: request.body["extra-properties"] ?? false,
      extendedProperties: void 0
    });
  }
  return HttpRequestBody.reference(convertReferenceHttpRequestBody({
    requestBody: request.body,
    file,
    contentType: request["content-type"]
  }));
}
function convertReferenceHttpRequestBody({ requestBody, file, contentType }) {
  return {
    docs: typeof requestBody !== "string" ? requestBody.docs : void 0,
    requestBodyType: file.parseTypeReference(requestBody),
    contentType
  };
}
function convertInlinedRequestProperty({ propertyKey, propertyDefinition, docs, availability, file }) {
  return {
    docs,
    availability,
    name: file.casingsGenerator.generateNameAndWireValue({
      wireValue: propertyKey,
      name: getPropertyName({ propertyKey, property: propertyDefinition }).name
    }),
    valueType: file.parseTypeReference(propertyDefinition)
  };
}

// ../../cli/generation/ir-generator/lib/converters/services/getObjectPropertyFromResolvedType.js
async function getObjectPropertyFromResolvedType({ typeResolver, file, resolvedType, property: property4 }) {
  switch (resolvedType._type) {
    case "container":
      if (resolvedType.container._type === "optional") {
        return await getObjectPropertyFromResolvedType({
          typeResolver,
          file,
          resolvedType: resolvedType.container.itemType,
          property: property4
        });
      }
      break;
    case "named":
      if (isRawObjectDefinition(resolvedType.declaration)) {
        return await getObjectPropertyFromObjectSchema({
          typeResolver,
          file: resolvedType.file,
          objectSchema: resolvedType.declaration,
          property: property4
        });
      }
      break;
    case "primitive":
    case "unknown":
      break;
    default:
      assertNever(resolvedType);
  }
  throw new Error("Internal error; response must be an object in order to return a property as a response");
}
async function getObjectPropertyFromObjectSchema({ typeResolver, file, objectSchema, property: property4 }) {
  const properties = await getAllPropertiesForRawObjectSchema(objectSchema, file, typeResolver);
  const objectProperty = properties[property4];
  if (objectProperty == null) {
    throw new Error(`Object does not have a property named ${property4}.`);
  }
  return objectProperty;
}
async function getAllPropertiesForRawObjectSchema(objectSchema, file, typeResolver) {
  let extendedTypes = [];
  if (typeof objectSchema.extends === "string") {
    extendedTypes = [objectSchema.extends];
  } else if (Array.isArray(objectSchema.extends)) {
    extendedTypes = objectSchema.extends;
  }
  const properties = {};
  for (const extendedType of extendedTypes) {
    const extendedProperties = await getAllPropertiesForExtendedType(extendedType, file, typeResolver);
    Object.entries(extendedProperties).map(([propertyKey, objectProperty]) => {
      properties[propertyKey] = objectProperty;
    });
  }
  const objectProperties = await getObjectPropertiesFromRawObjectSchema(objectSchema, file);
  objectProperties.forEach((objectProperty) => {
    properties[objectProperty.name.name.originalName] = objectProperty;
  });
  return properties;
}
async function getAllPropertiesForExtendedType(extendedType, file, typeResolver) {
  const resolvedType = typeResolver.resolveNamedTypeOrThrow({
    referenceToNamedType: extendedType,
    file
  });
  if (resolvedType._type === "named" && isRawObjectDefinition(resolvedType.declaration)) {
    return await getAllPropertiesForRawObjectSchema(resolvedType.declaration, file, typeResolver);
  }
  throw new Error(`Extended type ${extendedType} must be another named type`);
}

// ../../cli/generation/ir-generator/lib/converters/services/convertProperty.js
async function getNestedObjectPropertyFromResolvedType({ typeResolver, file, resolvedType, propertyComponents }) {
  if (propertyComponents.length === 0) {
    return void 0;
  }
  if (propertyComponents.length === 1) {
    return await getObjectPropertyFromResolvedType({
      typeResolver,
      file,
      resolvedType,
      property: propertyComponents[0] ?? ""
    });
  }
  const objectSchema = maybeObjectSchema(resolvedType);
  if (objectSchema == null) {
    return void 0;
  }
  return getNestedObjectPropertyFromObjectSchema({
    typeResolver,
    file,
    objectSchema,
    propertyComponents
  });
}
async function getNestedObjectPropertyFromObjectSchema({ typeResolver, file, objectSchema, propertyComponents }) {
  if (propertyComponents.length === 0) {
    return void 0;
  }
  if (propertyComponents.length === 1) {
    return await getObjectPropertyFromObjectSchema({
      typeResolver,
      file,
      objectSchema,
      property: propertyComponents[0] ?? ""
    });
  }
  const propertyType = await getPropertyTypeFromObjectSchema({
    typeResolver,
    file,
    objectSchema,
    property: propertyComponents[0] ?? ""
  });
  const resolvedTypeProperty = typeResolver.resolveTypeOrThrow({
    type: propertyType,
    file
  });
  return getNestedObjectPropertyFromResolvedType({
    typeResolver,
    file: maybeFileFromResolvedType(resolvedTypeProperty) ?? file,
    resolvedType: resolvedTypeProperty,
    propertyComponents: propertyComponents.slice(1)
  });
}
async function getPropertyTypeFromObjectSchema({ typeResolver, file, objectSchema, property: property4 }) {
  const properties = await getAllPropertiesForRawObjectSchema2({
    typeResolver,
    file,
    objectSchema
  });
  const propertyType = properties[property4];
  if (propertyType == null) {
    throw new Error(`Response does not have a property named ${property4}.`);
  }
  return propertyType;
}
async function getAllPropertiesForRawObjectSchema2({ typeResolver, file, objectSchema }) {
  let extendedTypes = [];
  if (typeof objectSchema.extends === "string") {
    extendedTypes = [objectSchema.extends];
  } else if (Array.isArray(objectSchema.extends)) {
    extendedTypes = objectSchema.extends;
  }
  const properties = {};
  for (const extendedType of extendedTypes) {
    const extendedProperties = await getAllPropertiesForExtendedType2({
      typeResolver,
      file,
      extendedType
    });
    Object.entries(extendedProperties).map(([propertyKey, propertyType]) => {
      properties[propertyKey] = propertyType;
    });
  }
  if (objectSchema.properties != null) {
    Object.entries(objectSchema.properties).map(([propertyKey, propertyType]) => {
      properties[propertyKey] = typeof propertyType === "string" ? propertyType : propertyType.type;
    });
  }
  return properties;
}
async function getAllPropertiesForExtendedType2({ typeResolver, file, extendedType }) {
  const resolvedType = typeResolver.resolveNamedTypeOrThrow({
    referenceToNamedType: extendedType,
    file
  });
  if (resolvedType._type === "named" && isRawObjectDefinition(resolvedType.declaration)) {
    return await getAllPropertiesForRawObjectSchema2({
      typeResolver,
      file: maybeFileFromResolvedType(resolvedType) ?? file,
      objectSchema: resolvedType.declaration
    });
  }
  throw new Error(`Extended type ${extendedType} must be another named type.`);
}
function maybeFileFromResolvedType(resolvedType) {
  if (resolvedType == null) {
    return void 0;
  }
  if (resolvedType._type === "named") {
    return resolvedType.file;
  }
  if (resolvedType._type === "container" && resolvedType.container._type === "optional") {
    return maybeFileFromResolvedType(resolvedType.container.itemType);
  }
  return void 0;
}
function maybeObjectSchema(resolvedType) {
  if (resolvedType == null) {
    return void 0;
  }
  if (resolvedType._type === "named" && isRawObjectDefinition(resolvedType.declaration)) {
    return resolvedType.declaration;
  }
  if (resolvedType._type === "container" && resolvedType.container._type === "optional") {
    return maybeObjectSchema(resolvedType.container.itemType);
  }
  return void 0;
}
function getRequestPropertyComponents(value) {
  const trimmed = value.substring("$request.".length);
  return trimmed?.split(".") ?? [];
}
function getResponsePropertyComponents(value) {
  const trimmed = value.substring("$response.".length);
  return trimmed?.split(".") ?? [];
}

// ../../cli/generation/ir-generator/lib/converters/services/convertHttpSdkRequest.js
var DEFAULT_REQUEST_PARAMETER_NAME = "request";
var DEFAULT_BODY_PROPERTY_KEY_IN_WRAPPER = "body";
async function convertHttpSdkRequest({ request, endpointKey, endpoint, service, file, typeResolver, propertyResolver }) {
  const shape = convertHttpSdkRequestShape({ request, service, file, typeResolver });
  if (shape == null) {
    return void 0;
  }
  return {
    shape,
    requestParameterName: file.casingsGenerator.generateName(DEFAULT_REQUEST_PARAMETER_NAME),
    streamParameter: endpoint["stream-condition"] != null ? await propertyResolver.resolveRequestPropertyOrThrow({
      file,
      endpoint: endpointKey,
      propertyComponents: getRequestPropertyComponents(endpoint["stream-condition"])
    }) : void 0
  };
}
function convertHttpSdkRequestShape({ service, request, file, typeResolver }) {
  const constructWrapper = () => {
    if (typeof request === "string" || request?.name == null) {
      throw new Error("Name is missing for request wrapper");
    }
    return SdkRequestShape.wrapper({
      wrapperName: file.casingsGenerator.generateName(request.name),
      bodyKey: file.casingsGenerator.generateName(DEFAULT_BODY_PROPERTY_KEY_IN_WRAPPER),
      includePathParameters: shouldIncludePathParametersInWrapper(request),
      onlyPathParameters: doesRequestHaveOnlyPathParameters({ request, file, typeResolver })
    });
  };
  if (!areAllHeadersLiteral({ headers: service.headers ?? {}, file, typeResolver })) {
    return constructWrapper();
  }
  if (request == null) {
    return void 0;
  }
  if (typeof request === "string") {
    return SdkRequestShape.justRequestBody(getSdkJustRequestBodyType({ requestBody: request, file }));
  }
  const { body } = request;
  if (doesRequestHaveNonBodyProperties({ request, file, typeResolver }) || body != null && isInlineRequestBody(body)) {
    return constructWrapper();
  }
  if (body == null) {
    return void 0;
  }
  return SdkRequestShape.justRequestBody(getSdkJustRequestBodyType({ requestBody: body, file }));
}
function getSdkJustRequestBodyType({ requestBody, file, contentType }) {
  const rawBytes = typeof requestBody === "string" ? parseRawBytesType(requestBody) : parseRawBytesType(requestBody.type);
  if (rawBytes != null) {
    return SdkRequestBodyType.bytes({
      isOptional: rawBytes.isOptional,
      contentType,
      docs: void 0
    });
  }
  return SdkRequestBodyType.typeReference(convertReferenceHttpRequestBody({
    requestBody,
    file,
    contentType
  }));
}
function doesRequestHaveNonBodyProperties({ request, file, typeResolver }) {
  const { headers = {}, "path-parameters": pathParameters = {}, "query-parameters": queryParameters = {} } = request;
  return !areAllHeadersLiteral({ headers, file, typeResolver }) || size_default(pathParameters) > 0 || size_default(queryParameters) > 0;
}
function doesRequestHaveOnlyPathParameters({ request, file, typeResolver }) {
  const { headers = {}, "path-parameters": pathParameters = {}, "query-parameters": queryParameters = {} } = request;
  return size_default(pathParameters) > 0 && areAllHeadersLiteral({ headers, file, typeResolver }) && size_default(queryParameters) === 0 && request.body == null;
}
function shouldIncludePathParametersInWrapper(request) {
  return typeof request !== "string" && request?.["path-parameters"] != null;
}
function areAllHeadersLiteral({ headers, file, typeResolver }) {
  return Object.values(headers).filter((header) => {
    const headerType = typeof header === "string" ? header : header.type;
    const resolvedType = typeResolver.resolveTypeOrThrow({
      type: headerType,
      file
    });
    const isLiteral = resolvedType._type === "container" && resolvedType.container._type === "literal";
    return !isLiteral;
  }).length === 0;
}

// ../../../node_modules/.pnpm/url-join@5.0.0/node_modules/url-join/lib/url-join.js
function normalize(strArray) {
  var resultArray = [];
  if (strArray.length === 0) {
    return "";
  }
  if (typeof strArray[0] !== "string") {
    throw new TypeError("Url must be a string. Received " + strArray[0]);
  }
  if (strArray[0].match(/^[^/:]+:\/*$/) && strArray.length > 1) {
    var first = strArray.shift();
    strArray[0] = first + strArray[0];
  }
  if (strArray[0].match(/^file:\/\/\//)) {
    strArray[0] = strArray[0].replace(/^([^/:]+):\/*/, "$1:///");
  } else {
    strArray[0] = strArray[0].replace(/^([^/:]+):\/*/, "$1://");
  }
  for (var i = 0; i < strArray.length; i++) {
    var component = strArray[i];
    if (typeof component !== "string") {
      throw new TypeError("Url must be a string. Received " + component);
    }
    if (component === "") {
      continue;
    }
    if (i > 0) {
      component = component.replace(/^[\/]+/, "");
    }
    if (i < strArray.length - 1) {
      component = component.replace(/[\/]+$/, "");
    } else {
      component = component.replace(/[\/]+$/, "/");
    }
    resultArray.push(component);
  }
  var str2 = resultArray.join("/");
  str2 = str2.replace(/\/(\?|&|#[^!])/g, "$1");
  var parts = str2.split("?");
  str2 = parts.shift() + (parts.length > 0 ? "?" : "") + parts.join("&");
  return str2;
}
function urlJoin() {
  var input;
  if (typeof arguments[0] === "object") {
    input = arguments[0];
  } else {
    input = [].slice.call(arguments);
  }
  return normalize(input);
}

// ../../cli/generation/ir-generator/lib/converters/services/convertCodeSamples.js
function convertCodeSample({ codeSample, file }) {
  return visitExampleCodeSampleSchema(codeSample, {
    language: (languageScheme) => ExampleCodeSample.language({
      name: languageScheme.name != null ? file.casingsGenerator.generateName(languageScheme.name) : void 0,
      docs: languageScheme.docs,
      language: languageScheme.language,
      code: languageScheme.code,
      install: languageScheme.install
    }),
    sdk: (sdkScheme) => ExampleCodeSample.sdk({
      name: sdkScheme.name != null ? file.casingsGenerator.generateName(sdkScheme.name) : void 0,
      docs: sdkScheme.docs,
      sdk: removeSdkAlias(sdkScheme.sdk),
      code: sdkScheme.code
    })
  });
}
function removeSdkAlias(sdk) {
  switch (sdk) {
    case "js":
      return "javascript";
    case "node":
      return "javascript";
    case "ts":
      return "typescript";
    case "nodets":
      return "typescript";
    case "golang":
      return "go";
    case "dotnet":
      return "csharp";
    case "c#":
      return "csharp";
    case "jvm":
      return "java";
    default:
      return sdk;
  }
}

// ../../cli/generation/ir-generator/lib/converters/services/convertExampleEndpointCall.js
var import_crypto = __toESM(require("crypto"), 1);

// ../../cli/generation/ir-generator/lib/examples/getViolationsForMisshapenExample.js
function getViolationsForMisshapenExample(example, expectedTypeIncludingArticle) {
  return [
    {
      message: `Expected example to be ${expectedTypeIncludingArticle}. Example is: ${JSON.stringify(example)}`
    }
  ];
}

// ../../cli/generation/ir-generator/lib/examples/validateAliasExample.js
function validateAliasExample({ rawAlias, example, file, typeResolver, exampleResolver, workspace, breadcrumbs, depth }) {
  return validateTypeReferenceExample({
    rawTypeReference: typeof rawAlias === "string" ? rawAlias : rawAlias.type,
    example,
    file,
    typeResolver,
    exampleResolver,
    workspace,
    breadcrumbs,
    depth: depth + 1
  });
}

// ../../cli/generation/ir-generator/lib/examples/validateEnumExample.js
function validateEnumExample({ rawEnum, example, breadcrumbs }) {
  const wireValues = rawEnum.enum.map((enumValue) => typeof enumValue === "string" ? enumValue : enumValue.value);
  const validEnumValuesLines = wireValues.map((wireValue) => `  - ${wireValue}`).join("\n");
  if (typeof example !== "string") {
    return getViolationsForMisshapenExample(example, "a string");
  }
  if (wireValues.includes(example)) {
    return [];
  }
  return [
    {
      message: `"${example}" is not a valid example for this enum. Enum values are:
` + validEnumValuesLines
    }
  ];
}

// ../../cli/workspace/commons/lib/AbstractAPIWorkspace.js
var AbstractAPIWorkspace = class {
  generatorsConfiguration;
  workspaceName;
  cliVersion;
  absoluteFilePath;
  changelog;
  type = "api";
  constructor({ generatorsConfiguration, workspaceName, cliVersion, absoluteFilePath, changelog }) {
    this.generatorsConfiguration = generatorsConfiguration;
    this.workspaceName = workspaceName;
    this.cliVersion = cliVersion;
    this.absoluteFilePath = absoluteFilePath;
    this.changelog = changelog;
  }
};

// ../../cli/workspace/commons/lib/FernWorkspace.js
var FernWorkspace = class extends AbstractAPIWorkspace {
  definition;
  sources;
  constructor({ definition, sources, ...superArgs }) {
    super(superArgs);
    this.definition = definition;
    this.sources = sources ?? [];
  }
  async getDefinition() {
    return this.definition;
  }
  async toFernWorkspace() {
    return this;
  }
  getSources() {
    return this.sources;
  }
  getAbsoluteFilePaths() {
    return [this.absoluteFilePath];
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/commons/types/Source.js
var Source2 = {
  openapi: (value) => {
    return {
      ...value,
      type: "openapi",
      _visit: function (visitor) {
        return Source2._visit(this, visitor);
      }
    };
  },
  protobuf: (value) => {
    return {
      ...value,
      type: "protobuf",
      _visit: function (visitor) {
        return Source2._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "openapi":
        return visitor.openapi(value);
      case "protobuf":
        return visitor.protobuf(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/commons/types/Encoding.js
var Encoding = {
  protobuf: (value) => {
    return {
      ...value,
      type: "protobuf",
      _visit: function (visitor) {
        return Encoding._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "protobuf":
        return visitor.protobuf(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/commons/types/SecurityScheme.js
var SecurityScheme = {
  basic: (value) => {
    return {
      ...value,
      type: "basic",
      _visit: function (visitor) {
        return SecurityScheme._visit(this, visitor);
      }
    };
  },
  bearer: (value) => {
    return {
      ...value,
      type: "bearer",
      _visit: function (visitor) {
        return SecurityScheme._visit(this, visitor);
      }
    };
  },
  header: (value) => {
    return {
      ...value,
      type: "header",
      _visit: function (visitor) {
        return SecurityScheme._visit(this, visitor);
      }
    };
  },
  query: (value) => {
    return {
      ...value,
      type: "query",
      _visit: function (visitor) {
        return SecurityScheme._visit(this, visitor);
      }
    };
  },
  oauth: (value) => {
    return {
      ...value,
      type: "oauth",
      _visit: function (visitor) {
        return SecurityScheme._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "basic":
        return visitor.basic(value);
      case "bearer":
        return visitor.bearer(value);
      case "header":
        return visitor.header(value);
      case "query":
        return visitor.query(value);
      case "oauth":
        return visitor.oauth(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/example/types/FullExample.js
var FullExample = {
  primitive: (value) => {
    return {
      value,
      type: "primitive",
      _visit: function (visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  object: (value) => {
    return {
      ...value,
      type: "object",
      _visit: function (visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  array: (value) => {
    return {
      value,
      type: "array",
      _visit: function (visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  map: (value) => {
    return {
      value,
      type: "map",
      _visit: function (visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  enum: (value) => {
    return {
      value,
      type: "enum",
      _visit: function (visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  literal: (value) => {
    return {
      value,
      type: "literal",
      _visit: function (visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  oneOf: (value) => {
    return {
      value,
      type: "oneOf",
      _visit: function (visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  unknown: (value) => {
    return {
      value,
      type: "unknown",
      _visit: function (visitor) {
        return FullExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "primitive":
        return visitor.primitive(value.value);
      case "object":
        return visitor.object(value);
      case "array":
        return visitor.array(value.value);
      case "map":
        return visitor.map(value.value);
      case "enum":
        return visitor.enum(value.value);
      case "literal":
        return visitor.literal(value.value);
      case "oneOf":
        return visitor.oneOf(value.value);
      case "unknown":
        return visitor.unknown(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/example/types/PrimitiveExample.js
var PrimitiveExample = {
  int: (value) => {
    return {
      value,
      type: "int",
      _visit: function (visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  int64: (value) => {
    return {
      value,
      type: "int64",
      _visit: function (visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  uint: (value) => {
    return {
      value,
      type: "uint",
      _visit: function (visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  uint64: (value) => {
    return {
      value,
      type: "uint64",
      _visit: function (visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  float: (value) => {
    return {
      value,
      type: "float",
      _visit: function (visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  double: (value) => {
    return {
      value,
      type: "double",
      _visit: function (visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      value,
      type: "string",
      _visit: function (visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  datetime: (value) => {
    return {
      value,
      type: "datetime",
      _visit: function (visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  date: (value) => {
    return {
      value,
      type: "date",
      _visit: function (visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  base64: (value) => {
    return {
      value,
      type: "base64",
      _visit: function (visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  boolean: (value) => {
    return {
      value,
      type: "boolean",
      _visit: function (visitor) {
        return PrimitiveExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "int":
        return visitor.int(value.value);
      case "int64":
        return visitor.int64(value.value);
      case "uint":
        return visitor.uint(value.value);
      case "uint64":
        return visitor.uint64(value.value);
      case "float":
        return visitor.float(value.value);
      case "double":
        return visitor.double(value.value);
      case "string":
        return visitor.string(value.value);
      case "datetime":
        return visitor.datetime(value.value);
      case "date":
        return visitor.date(value.value);
      case "base64":
        return visitor.base64(value.value);
      case "boolean":
        return visitor.boolean(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/example/types/FullOneOfExample.js
var FullOneOfExample = {
  discriminated: (value) => {
    return {
      value,
      type: "discriminated",
      _visit: function (visitor) {
        return FullOneOfExample._visit(this, visitor);
      }
    };
  },
  undisciminated: (value) => {
    return {
      value,
      type: "undisciminated",
      _visit: function (visitor) {
        return FullOneOfExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "discriminated":
        return visitor.discriminated(value.value);
      case "undisciminated":
        return visitor.undisciminated(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/Availability.js
var Availability = {
  GenerallyAvailable: "GenerallyAvailable",
  Beta: "Beta",
  Deprecated: "Deprecated",
  _visit: (value, visitor) => {
    switch (value) {
      case Availability.GenerallyAvailable:
        return visitor.generallyAvailable();
      case Availability.Beta:
        return visitor.beta();
      case Availability.Deprecated:
        return visitor.deprecated();
      default:
        return visitor._other();
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/Pagination.js
var Pagination3 = {
  cursor: (value) => {
    return {
      ...value,
      type: "cursor",
      _visit: function (visitor) {
        return Pagination3._visit(this, visitor);
      }
    };
  },
  offset: (value) => {
    return {
      ...value,
      type: "offset",
      _visit: function (visitor) {
        return Pagination3._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "cursor":
        return visitor.cursor(value);
      case "offset":
        return visitor.offset(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/CustomCodeSample.js
var CustomCodeSample = {
  language: (value) => {
    return {
      ...value,
      type: "language",
      _visit: function (visitor) {
        return CustomCodeSample._visit(this, visitor);
      }
    };
  },
  sdk: (value) => {
    return {
      ...value,
      type: "sdk",
      _visit: function (visitor) {
        return CustomCodeSample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "language":
        return visitor.language(value);
      case "sdk":
        return visitor.sdk(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/SupportedSdkLanguage.js
var SupportedSdkLanguage = {
  Curl: "curl",
  Python: "python",
  Javascript: "javascript",
  Typescript: "typescript",
  Go: "go",
  Ruby: "ruby",
  Csharp: "csharp",
  Java: "java",
  Js: "js",
  Node: "node",
  Ts: "ts",
  Nodets: "nodets",
  Golang: "golang",
  Dotnet: "dotnet",
  Jvm: "jvm",
  _visit: (value, visitor) => {
    switch (value) {
      case SupportedSdkLanguage.Curl:
        return visitor.curl();
      case SupportedSdkLanguage.Python:
        return visitor.python();
      case SupportedSdkLanguage.Javascript:
        return visitor.javascript();
      case SupportedSdkLanguage.Typescript:
        return visitor.typescript();
      case SupportedSdkLanguage.Go:
        return visitor.go();
      case SupportedSdkLanguage.Ruby:
        return visitor.ruby();
      case SupportedSdkLanguage.Csharp:
        return visitor.csharp();
      case SupportedSdkLanguage.Java:
        return visitor.java();
      case SupportedSdkLanguage.Js:
        return visitor.js();
      case SupportedSdkLanguage.Node:
        return visitor.node();
      case SupportedSdkLanguage.Ts:
        return visitor.ts();
      case SupportedSdkLanguage.Nodets:
        return visitor.nodets();
      case SupportedSdkLanguage.Golang:
        return visitor.golang();
      case SupportedSdkLanguage.Dotnet:
        return visitor.dotnet();
      case SupportedSdkLanguage.Jvm:
        return visitor.jvm();
      default:
        return visitor._other();
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/EndpointExample.js
var EndpointExample = {
  unknown: (value) => {
    return {
      value,
      type: "unknown",
      _visit: function (visitor) {
        return EndpointExample._visit(this, visitor);
      }
    };
  },
  full: (value) => {
    return {
      ...value,
      type: "full",
      _visit: function (visitor) {
        return EndpointExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "unknown":
        return visitor.unknown(value.value);
      case "full":
        return visitor.full(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/EndpointResponseExample.js
var EndpointResponseExample = {
  withStreaming: (value) => {
    return {
      value,
      type: "withStreaming",
      _visit: function (visitor) {
        return EndpointResponseExample._visit(this, visitor);
      }
    };
  },
  withoutStreaming: (value) => {
    return {
      value,
      type: "withoutStreaming",
      _visit: function (visitor) {
        return EndpointResponseExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "withStreaming":
        return visitor.withStreaming(value.value);
      case "withoutStreaming":
        return visitor.withoutStreaming(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/HttpMethod.js
var HttpMethod2 = {
  Get: "GET",
  Post: "POST",
  Put: "PUT",
  Patch: "PATCH",
  Delete: "DELETE",
  Head: "HEAD",
  Options: "OPTIONS",
  Trace: "TRACE",
  _visit: (value, visitor) => {
    switch (value) {
      case HttpMethod2.Get:
        return visitor.get();
      case HttpMethod2.Post:
        return visitor.post();
      case HttpMethod2.Put:
        return visitor.put();
      case HttpMethod2.Patch:
        return visitor.patch();
      case HttpMethod2.Delete:
        return visitor.delete();
      case HttpMethod2.Head:
        return visitor.head();
      case HttpMethod2.Options:
        return visitor.options();
      case HttpMethod2.Trace:
        return visitor.trace();
      default:
        return visitor._other();
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/MultipartSchema.js
var MultipartSchema = {
  file: (value) => {
    return {
      ...value,
      type: "file",
      _visit: function (visitor) {
        return MultipartSchema._visit(this, visitor);
      }
    };
  },
  json: (value) => {
    return {
      value,
      type: "json",
      _visit: function (visitor) {
        return MultipartSchema._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "file":
        return visitor.file(value);
      case "json":
        return visitor.json(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/Schema.js
var Schema = {
  primitive: (value) => {
    return {
      ...value,
      type: "primitive",
      _visit: function (visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  object: (value) => {
    return {
      ...value,
      type: "object",
      _visit: function (visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  array: (value) => {
    return {
      ...value,
      type: "array",
      _visit: function (visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  map: (value) => {
    return {
      ...value,
      type: "map",
      _visit: function (visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  optional: (value) => {
    return {
      ...value,
      type: "optional",
      _visit: function (visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  enum: (value) => {
    return {
      ...value,
      type: "enum",
      _visit: function (visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function (visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  literal: (value) => {
    return {
      ...value,
      type: "literal",
      _visit: function (visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  oneOf: (value) => {
    return {
      value,
      type: "oneOf",
      _visit: function (visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  nullable: (value) => {
    return {
      ...value,
      type: "nullable",
      _visit: function (visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  unknown: (value) => {
    return {
      ...value,
      type: "unknown",
      _visit: function (visitor) {
        return Schema._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "primitive":
        return visitor.primitive(value);
      case "object":
        return visitor.object(value);
      case "array":
        return visitor.array(value);
      case "map":
        return visitor.map(value);
      case "optional":
        return visitor.optional(value);
      case "enum":
        return visitor.enum(value);
      case "reference":
        return visitor.reference(value);
      case "literal":
        return visitor.literal(value);
      case "oneOf":
        return visitor.oneOf(value.value);
      case "nullable":
        return visitor.nullable(value);
      case "unknown":
        return visitor.unknown(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/PrimitiveSchemaValue.js
var PrimitiveSchemaValue = {
  int: (value) => {
    return {
      ...value,
      type: "int",
      _visit: function (visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  int64: (value) => {
    return {
      ...value,
      type: "int64",
      _visit: function (visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  uint: () => {
    return {
      type: "uint",
      _visit: function (visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  uint64: () => {
    return {
      type: "uint64",
      _visit: function (visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  float: () => {
    return {
      type: "float",
      _visit: function (visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  double: (value) => {
    return {
      ...value,
      type: "double",
      _visit: function (visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      ...value,
      type: "string",
      _visit: function (visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  datetime: () => {
    return {
      type: "datetime",
      _visit: function (visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  date: () => {
    return {
      type: "date",
      _visit: function (visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  base64: () => {
    return {
      type: "base64",
      _visit: function (visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  boolean: (value) => {
    return {
      ...value,
      type: "boolean",
      _visit: function (visitor) {
        return PrimitiveSchemaValue._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "int":
        return visitor.int(value);
      case "int64":
        return visitor.int64(value);
      case "uint":
        return visitor.uint();
      case "uint64":
        return visitor.uint64();
      case "float":
        return visitor.float();
      case "double":
        return visitor.double(value);
      case "string":
        return visitor.string(value);
      case "datetime":
        return visitor.datetime();
      case "date":
        return visitor.date();
      case "base64":
        return visitor.base64();
      case "boolean":
        return visitor.boolean(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/LiteralSchemaValue.js
var LiteralSchemaValue = {
  boolean: (value) => {
    return {
      value,
      type: "boolean",
      _visit: function (visitor) {
        return LiteralSchemaValue._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      value,
      type: "string",
      _visit: function (visitor) {
        return LiteralSchemaValue._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "boolean":
        return visitor.boolean(value.value);
      case "string":
        return visitor.string(value.value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/finalIr/types/OneOfSchema.js
var OneOfSchema = {
  discriminated: (value) => {
    return {
      ...value,
      type: "discriminated",
      _visit: function (visitor) {
        return OneOfSchema._visit(this, visitor);
      }
    };
  },
  undisciminated: (value) => {
    return {
      ...value,
      type: "undisciminated",
      _visit: function (visitor) {
        return OneOfSchema._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "discriminated":
        return visitor.discriminated(value);
      case "undisciminated":
        return visitor.undisciminated(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/parseIr/types/RequestWithExample.js
var RequestWithExample = {
  octetStream: (value) => {
    return {
      ...value,
      type: "octetStream",
      _visit: function (visitor) {
        return RequestWithExample._visit(this, visitor);
      }
    };
  },
  multipart: (value) => {
    return {
      ...value,
      type: "multipart",
      _visit: function (visitor) {
        return RequestWithExample._visit(this, visitor);
      }
    };
  },
  json: (value) => {
    return {
      ...value,
      type: "json",
      _visit: function (visitor) {
        return RequestWithExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "octetStream":
        return visitor.octetStream(value);
      case "multipart":
        return visitor.multipart(value);
      case "json":
        return visitor.json(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/parseIr/types/ResponseWithExample.js
var ResponseWithExample = {
  file: (value) => {
    return {
      ...value,
      type: "file",
      _visit: function (visitor) {
        return ResponseWithExample._visit(this, visitor);
      }
    };
  },
  json: (value) => {
    return {
      ...value,
      type: "json",
      _visit: function (visitor) {
        return ResponseWithExample._visit(this, visitor);
      }
    };
  },
  text: (value) => {
    return {
      ...value,
      type: "text",
      _visit: function (visitor) {
        return ResponseWithExample._visit(this, visitor);
      }
    };
  },
  streamingSse: (value) => {
    return {
      ...value,
      type: "streamingSse",
      _visit: function (visitor) {
        return ResponseWithExample._visit(this, visitor);
      }
    };
  },
  streamingText: (value) => {
    return {
      ...value,
      type: "streamingText",
      _visit: function (visitor) {
        return ResponseWithExample._visit(this, visitor);
      }
    };
  },
  streamingJson: (value) => {
    return {
      ...value,
      type: "streamingJson",
      _visit: function (visitor) {
        return ResponseWithExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "file":
        return visitor.file(value);
      case "json":
        return visitor.json(value);
      case "text":
        return visitor.text(value);
      case "streamingSse":
        return visitor.streamingSse(value);
      case "streamingText":
        return visitor.streamingText(value);
      case "streamingJson":
        return visitor.streamingJson(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/parseIr/types/SchemaWithExample.js
var SchemaWithExample = {
  primitive: (value) => {
    return {
      ...value,
      type: "primitive",
      _visit: function (visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  object: (value) => {
    return {
      ...value,
      type: "object",
      _visit: function (visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  array: (value) => {
    return {
      ...value,
      type: "array",
      _visit: function (visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  map: (value) => {
    return {
      ...value,
      type: "map",
      _visit: function (visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  optional: (value) => {
    return {
      ...value,
      type: "optional",
      _visit: function (visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  enum: (value) => {
    return {
      ...value,
      type: "enum",
      _visit: function (visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  reference: (value) => {
    return {
      ...value,
      type: "reference",
      _visit: function (visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  literal: (value) => {
    return {
      ...value,
      type: "literal",
      _visit: function (visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  oneOf: (value) => {
    return {
      value,
      type: "oneOf",
      _visit: function (visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  nullable: (value) => {
    return {
      ...value,
      type: "nullable",
      _visit: function (visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  unknown: (value) => {
    return {
      ...value,
      type: "unknown",
      _visit: function (visitor) {
        return SchemaWithExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "primitive":
        return visitor.primitive(value);
      case "object":
        return visitor.object(value);
      case "array":
        return visitor.array(value);
      case "map":
        return visitor.map(value);
      case "optional":
        return visitor.optional(value);
      case "enum":
        return visitor.enum(value);
      case "reference":
        return visitor.reference(value);
      case "literal":
        return visitor.literal(value);
      case "oneOf":
        return visitor.oneOf(value.value);
      case "nullable":
        return visitor.nullable(value);
      case "unknown":
        return visitor.unknown(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/parseIr/types/OneOfSchemaWithExample.js
var OneOfSchemaWithExample = {
  discriminated: (value) => {
    return {
      ...value,
      type: "discriminated",
      _visit: function (visitor) {
        return OneOfSchemaWithExample._visit(this, visitor);
      }
    };
  },
  undisciminated: (value) => {
    return {
      ...value,
      type: "undisciminated",
      _visit: function (visitor) {
        return OneOfSchemaWithExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "discriminated":
        return visitor.discriminated(value);
      case "undisciminated":
        return visitor.undisciminated(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/sdk/api/resources/parseIr/types/PrimitiveSchemaValueWithExample.js
var PrimitiveSchemaValueWithExample = {
  int: (value) => {
    return {
      ...value,
      type: "int",
      _visit: function (visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  int64: (value) => {
    return {
      ...value,
      type: "int64",
      _visit: function (visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  uint: (value) => {
    return {
      ...value,
      type: "uint",
      _visit: function (visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  uint64: (value) => {
    return {
      ...value,
      type: "uint64",
      _visit: function (visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  float: (value) => {
    return {
      ...value,
      type: "float",
      _visit: function (visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  double: (value) => {
    return {
      ...value,
      type: "double",
      _visit: function (visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  string: (value) => {
    return {
      ...value,
      type: "string",
      _visit: function (visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  datetime: (value) => {
    return {
      ...value,
      type: "datetime",
      _visit: function (visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  date: (value) => {
    return {
      ...value,
      type: "date",
      _visit: function (visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  base64: (value) => {
    return {
      ...value,
      type: "base64",
      _visit: function (visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  boolean: (value) => {
    return {
      ...value,
      type: "boolean",
      _visit: function (visitor) {
        return PrimitiveSchemaValueWithExample._visit(this, visitor);
      }
    };
  },
  _visit: (value, visitor) => {
    switch (value.type) {
      case "int":
        return visitor.int(value);
      case "int64":
        return visitor.int64(value);
      case "uint":
        return visitor.uint(value);
      case "uint64":
        return visitor.uint64(value);
      case "float":
        return visitor.float(value);
      case "double":
        return visitor.double(value);
      case "string":
        return visitor.string(value);
      case "datetime":
        return visitor.datetime(value);
      case "date":
        return visitor.date(value);
      case "base64":
        return visitor.base64(value);
      case "boolean":
        return visitor.boolean(value);
      default:
        return visitor._other(value);
    }
  }
};

// ../../cli/api-importers/openapi/openapi-ir/lib/utils/constants.js
var NUMERIC_REGEX = /^(\d+)/;
var VALID_ENUM_NAME_REGEX = /^[a-zA-Z][a-zA-Z0-9_]*$/;
var HARDCODED_ENUM_NAMES = {
  "<": "LESS_THAN",
  ">": "GREATER_THAN",
  ">=": "GREATER_THAN_OR_EQUAL_TO",
  "<=": "LESS_THAN_OR_EQUAL_TO",
  "!=": "NOT_EQUALS",
  "=": "EQUAL_TO",
  "==": "EQUAL_TO",
  "*": "ALL",
  "": "EMPTY",
  '""': "EMPTY_STRING",
  "-": "HYPHEN",
  "|": "PIPE",
  ".": "DOT",
  "/": "SLASH"
};

// ../../cli/api-importers/openapi/openapi-ir/lib/utils/convertNumberToSnakeCase.js
function convertNumberToSnakeCase(number3) {
  const singleDigits = ["zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine"];
  const teenNumbers = [
    "ten",
    "eleven",
    "twelve",
    "thirteen",
    "fourteen",
    "fifteen",
    "sixteen",
    "seventeen",
    "eighteen",
    "nineteen"
  ];
  const tensNumbers = ["", "", "twenty", "thirty", "forty", "fifty", "sixty", "seventy", "eighty", "ninety"];
  if (number3 < 0 || number3 > 9999) {
    return void 0;
  }
  if (number3 < 10) {
    return singleDigits[number3];
  }
  if (number3 < 20) {
    return teenNumbers[number3 - 10];
  }
  if (number3 < 100) {
    const tens = Math.floor(number3 / 10);
    const remainder2 = number3 % 10;
    if (remainder2 === 0) {
      return tensNumbers[tens];
    } else {
      return `${tensNumbers[tens]}_${singleDigits[remainder2]}`;
    }
  }
  if (number3 < 1e3) {
    const hundreds = Math.floor(number3 / 100);
    const remainder2 = number3 % 100;
    if (remainder2 === 0) {
      return `${singleDigits[hundreds]}_hundred`;
    } else {
      return `${singleDigits[hundreds]}_hundred_${convertNumberToSnakeCase(remainder2)}`;
    }
  }
  const thousands = Math.floor(number3 / 1e3);
  const remainder = number3 % 1e3;
  if (remainder === 0) {
    return `${singleDigits[thousands]}_thousand`;
  } else {
    return `${singleDigits[thousands]}_thousand_${convertNumberToSnakeCase(remainder)}`;
  }
}

// ../../cli/api-importers/openapi/openapi-ir/lib/utils/replaceStartingNumber.js
function replaceStartingNumber(input) {
  const matches = input.match(NUMERIC_REGEX);
  if (matches && matches[0] != null) {
    const numericPart = matches[0];
    const nonNumericPart = input.substring(numericPart.length);
    const parsedNumber = parseFloat(numericPart);
    if (!isNaN(parsedNumber) && isFinite(parsedNumber)) {
      const snakeCasedNumber = convertNumberToSnakeCase(parsedNumber);
      return nonNumericPart.length > 0 ? `${snakeCasedNumber}_${nonNumericPart}` : snakeCasedNumber;
    }
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir/lib/utils/generateEnumNameFromValue.js
function generateEnumNameFromValue(value) {
  const maybeParsedNumber = replaceStartingNumber(value);
  const maybeHardcodedEnumName = HARDCODED_ENUM_NAMES[value];
  if (maybeParsedNumber != null) {
    return upperFirst_default(camelCase_default(maybeParsedNumber));
  } else if (maybeHardcodedEnumName != null) {
    return maybeHardcodedEnumName;
  } else {
    if (value.toLowerCase() === "n/a") {
      return "NOT_APPLICABLE";
    }
    return upperFirst_default(camelCase_default(value));
  }
}

// ../../cli/api-importers/openapi/openapi-ir/lib/utils/isSchemaEqual.js
function isSchemaEqual(a, b) {
  if (a.type === "primitive" && b.type === "primitive") {
    return isPrimitiveSchemaValueEqual(a.schema, b.schema);
  } else if (a.type === "enum" && b.type === "enum") {
    return areEnumValuesEqual(a.values, b.values);
  } else if (a.type === "array" && b.type === "array") {
    return isSchemaEqual(a.value, b.value);
  } else if (a.type === "unknown" && b.type === "unknown") {
    return true;
  } else if (a.type === "reference" && b.type === "reference") {
    return a.schema === b.schema;
  } else if (a.type === "optional" && b.type === "optional") {
    return isSchemaEqual(a.value, b.value);
  } else if (a.type === "oneOf" && b.type === "oneOf") {
    return isOneOfEqual(a.value, b.value);
  } else if (a.type === "object" && b.type === "object") {
    return isObjectEqual(a, b);
  } else if (a.type === "map" && b.type === "map") {
    return isPrimitiveSchemaValueEqual(a.key.schema, b.key.schema) && isSchemaEqual(a.value, b.value);
  } else if (a.type === "literal" && b.type === "literal") {
    return a.value === b.value;
  }
  return false;
}
function isPrimitiveSchemaValueEqual(a, b) {
  return a.type === b.type;
}
function areEnumValuesEqual(a, b) {
  const aSet = new Set(...a.map((enumValue) => enumValue.value));
  const bSet = new Set(...b.map((enumValue) => enumValue.value));
  return isEqual_default(aSet, bSet);
}
function isOneOfEqual(a, b) {
  if (a.type === "discriminated" && b.type === "discriminated") {
    return a.discriminantProperty === b.discriminantProperty && Object.keys(a.schemas).length === Object.keys(b.schemas).length && Object.entries(a.schemas).every(([discrminant, aSchema]) => {
      const bSchema = b.schemas[discrminant];
      if (bSchema == null) {
        return false;
      }
      return isSchemaEqual(aSchema, bSchema);
    });
  }
  if (a.type === "undisciminated" && b.type === "undisciminated") {
    return a.schemas.length === b.schemas.length && a.schemas.every((aSchema, index) => {
      const bSchema = b.schemas[index];
      if (bSchema == null) {
        return false;
      }
      return isSchemaEqual(aSchema, bSchema);
    });
  }
  return false;
}
function isObjectEqual(a, b) {
  if (Object.keys(a.properties).length !== Object.keys(b.properties).length) {
    return false;
  }
  const aPropertyMap = Object.fromEntries(a.properties.map((property4) => {
    return [property4.key, property4.schema];
  }));
  return Object.entries(b.properties).every(([bPropertyName, bPropertySchema]) => {
    const aProperty = aPropertyMap[bPropertyName];
    if (aProperty == null) {
      return false;
    }
    return isSchemaEqual(aProperty, bPropertySchema.schema);
  });
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/convertToEncodingSchema.js
function convertToEncodingSchema(encoding) {
  switch (encoding.type) {
    case "protobuf":
      return {
        proto: {
          type: encoding.typeName
        }
      };
    default:
      assertNever(encoding.type);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/getGroupNameForSchema.js
function getGroupNameForSchema(schema2) {
  switch (schema2.type) {
    case "object":
    case "enum":
    case "array":
    case "map":
    case "reference":
    case "literal":
    case "optional":
    case "nullable":
    case "primitive":
      return schema2.groupName ?? void 0;
    case "oneOf":
      return schema2.value.groupName ?? void 0;
    case "unknown":
      return void 0;
    default:
      assertNever(schema2);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/getTypeFromTypeReference.js
function getTypeFromTypeReference(typeReference) {
  if (typeof typeReference === "string") {
    return typeReference;
  }
  return typeReference.type;
}
function getDocsFromTypeReference(typeReference) {
  if (typeof typeReference === "string") {
    return void 0;
  }
  return typeReference.docs;
}
function getDefaultFromTypeReference(typeReference) {
  if (typeof typeReference === "string") {
    return void 0;
  }
  return typeReference.default;
}
function getValidationFromTypeReference(typeReference) {
  if (typeof typeReference === "string") {
    return void 0;
  }
  return typeReference.validation;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/convertSdkGroupName.js
function cleanSdkGroupName(groupName) {
  const maybeNamespace = groupName.find((group) => typeof group === "object" && group.type === "namespace");
  const noNamespace = groupName.filter((group) => typeof group === "string" || group.type !== "namespace");
  return maybeNamespace ? [maybeNamespace, ...noNamespace] : noNamespace;
}
function convertSdkGroupNameToFileWithoutExtension(groupName) {
  const cleanedGroupName = groupName ? cleanSdkGroupName(groupName) : void 0;
  if (cleanedGroupName == null || cleanedGroupName.length === 0) {
    return FERN_PACKAGE_MARKER_FILENAME_NO_EXTENSION;
  }
  const fileNames = [];
  for (const [index, group] of cleanedGroupName.entries()) {
    if (typeof group === "string") {
      fileNames.push(camelCase_default(group));
    } else if (typeof group === "object") {
      switch (group.type) {
        case "namespace": {
          if (index < cleanedGroupName.length - 1) {
            fileNames.push(camelCase_default(group.name));
          } else {
            fileNames.push(...[group.name, FERN_PACKAGE_MARKER_FILENAME_NO_EXTENSION]);
          }
          break;
        }
        default:
          assertNever(group.type);
      }
    } else {
      assertNever(group);
    }
  }
  return fileNames.join("/");
}
function convertSdkGroupNameToFile(groupName) {
  return RelativeFilePath.of(`${convertSdkGroupNameToFileWithoutExtension(groupName)}.yml`);
}
function convertEndpointSdkNameToFileWithoutExtension({ sdkName, namespaceOverride }) {
  let groupName;
  if (sdkName == null || sdkName.groupName.length === 0 && namespaceOverride == null) {
    return FERN_PACKAGE_MARKER_FILENAME_NO_EXTENSION;
  } else if (namespaceOverride != null) {
    groupName = [
      { type: "namespace", name: namespaceOverride },
      ...sdkName.groupName.filter((group) => typeof group === "string" || group.type !== "namespace")
    ];
  } else {
    groupName = sdkName.groupName;
  }
  return convertSdkGroupNameToFileWithoutExtension(groupName);
}
function convertEndpointSdkNameToFile({ sdkName, namespaceOverride }) {
  return RelativeFilePath.of(`${convertEndpointSdkNameToFileWithoutExtension({ sdkName, namespaceOverride })}.yml`);
}
function resolveLocationWithNamespace({ location, namespaceOverride }) {
  if (namespaceOverride != null) {
    return join(RelativeFilePath.of(namespaceOverride), location);
  }
  return location;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/convertAvailability.js
function convertAvailability2(availability) {
  switch (availability) {
    case Availability.Deprecated:
      return "deprecated";
    case Availability.Beta:
      return "pre-release";
    case Availability.GenerallyAvailable:
      return "generally-available";
    default:
      return void 0;
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildTypeReference.js
var MIN_INT_32 = -2147483648;
var MAX_INT_32 = 2147483647;
var MIN_DOUBLE_64 = -17976931348623157e292;
var MAX_DOUBLE_64 = 17976931348623157e292;
function buildTypeReference({
  schema: schema2,
  /* The file the type reference will be written to */
  fileContainingReference,
  /* The file any type declarations will be written to. Defaults to fileContainingReference if not present */
  declarationFile = fileContainingReference,
  context,
  namespace,
  declarationDepth
}) {
  if (context.shouldMarkSchemaAsReferenced()) {
    context.markSchemaAsReferenced(schema2, namespace);
  }
  switch (schema2.type) {
    case "primitive": {
      return buildPrimitiveTypeReference(schema2);
    }
    case "array":
      return buildArrayTypeReference({
        schema: schema2,
        fileContainingReference,
        context,
        declarationFile,
        namespace,
        declarationDepth
      });
    case "map":
      return buildMapTypeReference({
        schema: schema2,
        fileContainingReference,
        context,
        declarationFile,
        namespace,
        declarationDepth
      });
    case "reference":
      return buildReferenceTypeReference({
        schema: schema2,
        fileContainingReference,
        context,
        namespace
      });
    case "unknown":
      return buildUnknownTypeReference();
    case "optional":
    case "nullable":
      return buildOptionalTypeReference({
        schema: schema2,
        fileContainingReference,
        context,
        declarationFile,
        namespace,
        declarationDepth
      });
    case "enum":
      return buildEnumTypeReference({
        schema: schema2,
        fileContainingReference,
        context,
        declarationFile,
        declarationDepth
      });
    case "literal":
      schema2.value;
      return buildLiteralTypeReference(schema2);
    case "object":
      return buildObjectTypeReference({
        schema: schema2,
        fileContainingReference,
        context,
        declarationFile,
        namespace,
        declarationDepth
      });
    case "oneOf":
      return buildOneOfTypeReference({
        schema: schema2.value,
        fileContainingReference,
        context,
        declarationFile,
        namespace,
        declarationDepth
      });
    default:
      assertNever(schema2);
  }
}
function buildPrimitiveTypeReference(primitiveSchema) {
  switch (primitiveSchema.schema.type) {
    case "string":
      return buildStringTypeReference({
        description: primitiveSchema.description,
        schema: primitiveSchema.schema
      });
    case "int":
      return buildIntegerTypeReference({
        description: primitiveSchema.description,
        schema: primitiveSchema.schema
      });
    case "float":
      return buildFloatTypeReference({
        description: primitiveSchema.description,
        schema: primitiveSchema.schema
      });
    case "double":
      return buildDoubleTypeReference({
        description: primitiveSchema.description,
        schema: primitiveSchema.schema
      });
    case "boolean":
      return buildBooleanTypeReference({
        description: primitiveSchema.description,
        schema: primitiveSchema.schema
      });
    case "int64":
      return buildLongTypeReference({
        description: primitiveSchema.description,
        schema: primitiveSchema.schema
      });
  }
  const typeReference = primitiveSchema.schema._visit({
    int: () => "integer",
    int64: () => "long",
    uint: () => "uint",
    uint64: () => "uint64",
    float: () => "double",
    double: () => "double",
    string: () => "string",
    datetime: () => "datetime",
    date: () => "date",
    base64: () => "base64",
    boolean: () => "boolean",
    _other: () => "unknown"
  });
  if (primitiveSchema.description == null && primitiveSchema.title == null) {
    return typeReference;
  }
  return {
    type: typeReference,
    ...primitiveSchema.description != null ? { docs: primitiveSchema.description } : {},
    ...primitiveSchema.availability != null ? { availability: convertAvailability2(primitiveSchema.availability) } : {}
  };
}
function buildBooleanTypeReference({ description, schema: schema2 }) {
  const type2 = "boolean";
  if (description == null && schema2.default == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (description != null) {
    result.docs = description;
  }
  if (schema2.default != null) {
    result.default = schema2.default;
  }
  return result;
}
function buildLongTypeReference({ description, schema: schema2 }) {
  const type2 = "long";
  if (description == null && schema2.default == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (description != null) {
    result.docs = description;
  }
  if (schema2.default != null) {
    result.default = schema2.default;
  }
  return result;
}
function buildStringTypeReference({ description, schema: schema2 }) {
  const type2 = "string";
  const validation = maybeStringValidation(schema2);
  if (description == null && schema2.default == null && validation == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (description != null) {
    result.docs = description;
  }
  if (schema2.default != null) {
    result.default = schema2.default;
  }
  if (validation != null) {
    result.validation = validation;
  }
  return result;
}
function buildIntegerTypeReference({ description, schema: schema2 }) {
  const type2 = "integer";
  const validation = maybeNumberValidation(schema2, type2);
  if (description == null && schema2.default == null && validation == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (description != null) {
    result.docs = description;
  }
  if (schema2.default != null) {
    result.default = schema2.default;
  }
  if (validation != null) {
    result.validation = validation;
  }
  return result;
}
function buildFloatTypeReference({ description, schema: schema2 }) {
  const type2 = "float";
  if (description == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (description != null) {
    result.docs = description;
  }
  return result;
}
function buildDoubleTypeReference({ description, schema: schema2 }) {
  const type2 = "double";
  const validation = maybeNumberValidation(schema2, type2);
  if (description == null && schema2.default == null && validation == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (description != null) {
    result.docs = description;
  }
  if (schema2.default != null) {
    result.default = schema2.default;
  }
  if (validation != null) {
    result.validation = validation;
  }
  return result;
}
function maybeStringValidation(schema2) {
  if (schema2 == null) {
    return void 0;
  }
  const { format, pattern, minLength, maxLength } = schema2;
  const validFormat = maybeValidFormat(format);
  if (validFormat == null && pattern == null && minLength == null && maxLength == null) {
    return void 0;
  }
  return {
    format: validFormat,
    pattern,
    minLength,
    maxLength
  };
}
function maybeValidFormat(format) {
  switch (format) {
    case "date":
    case "date-time":
    case "password":
    case "byte":
    case "bytes":
    case "binary":
    case "email":
    case "uuid":
    case "uri":
    case "hostname":
    case "ipv4":
    case "ipv6":
      return format;
    default:
      return void 0;
  }
}
function maybeNumberValidation(schema2, type2) {
  if (schema2 == null) {
    return void 0;
  }
  let { minimum, maximum, multipleOf } = schema2;
  const { exclusiveMinimum, exclusiveMaximum } = schema2;
  minimum = makeUndefinedIfOutsideRange(minimum, type2);
  maximum = makeUndefinedIfOutsideRange(maximum, type2);
  multipleOf = makeUndefinedIfOutsideRange(multipleOf, type2);
  if (minimum == null && maximum == null && exclusiveMinimum == null && exclusiveMaximum == null && multipleOf == null) {
    return void 0;
  }
  return {
    min: minimum,
    max: maximum,
    exclusiveMin: exclusiveMinimum,
    exclusiveMax: exclusiveMaximum,
    multipleOf
  };
}
function makeUndefinedIfOutsideRange(num, type2) {
  if (num === void 0) {
    return void 0;
  }
  const [min, max] = type2 === "integer" ? [MIN_INT_32, MAX_INT_32] : [MIN_DOUBLE_64, MAX_DOUBLE_64];
  return num < min || num > max ? void 0 : num;
}
function buildReferenceTypeReference({ schema: schema2, fileContainingReference, context, namespace }) {
  const resolvedSchema = context.getSchema(schema2.schema, namespace);
  if (resolvedSchema == null) {
    return "unknown";
  }
  const schemaName = getSchemaName(resolvedSchema) ?? schema2.schema;
  const groupName = getGroupNameForSchema(resolvedSchema);
  const displayName = getDisplayName(resolvedSchema);
  const typeWithPrefix = getPrefixedType({
    context,
    fileContainingReference,
    declarationFile: convertSdkGroupNameToFile(groupName),
    type: schemaName
  });
  const type2 = resolvedSchema.type === "nullable" ? `optional<${typeWithPrefix}>` : typeWithPrefix;
  if (schema2.description == null && displayName == null) {
    return type2;
  }
  return {
    type: resolvedSchema.type === "nullable" ? `optional<${typeWithPrefix}>` : typeWithPrefix,
    ...schema2.description != null ? { docs: schema2.description } : {},
    ...schema2.availability != null ? { availability: convertAvailability2(schema2.availability) } : {}
  };
}
function buildArrayTypeReference({ schema: schema2, fileContainingReference, declarationFile, context, namespace, declarationDepth }) {
  const item = buildTypeReference({
    schema: schema2.value,
    fileContainingReference,
    declarationFile,
    context,
    namespace,
    declarationDepth
  });
  const type2 = `list<${getTypeFromTypeReference(item)}>`;
  if (schema2.description == null && schema2.title == null) {
    return type2;
  }
  return {
    ...schema2.description != null ? { docs: schema2.description } : {},
    ...schema2.availability != null ? { availability: convertAvailability2(schema2.availability) } : {},
    type: type2
  };
}
function buildMapTypeReference({ schema: schema2, fileContainingReference, declarationFile, context, namespace, declarationDepth }) {
  const keyTypeReference = buildPrimitiveTypeReference(schema2.key);
  const valueTypeReference = buildTypeReference({
    schema: schema2.value,
    fileContainingReference,
    declarationFile,
    context,
    namespace,
    declarationDepth
  });
  const encoding = schema2.encoding != null ? convertToEncodingSchema(schema2.encoding) : void 0;
  const type2 = `map<${getTypeFromTypeReference(keyTypeReference)}, ${getTypeFromTypeReference(valueTypeReference)}>`;
  if (schema2.description == null && encoding == null && schema2.title == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (schema2.description != null) {
    result.docs = schema2.description;
  }
  if (schema2.encoding != null) {
    result.encoding = encoding;
  }
  if (schema2.availability != null) {
    result.availability = convertAvailability2(schema2.availability);
  }
  return result;
}
function buildOptionalTypeReference({ schema: schema2, fileContainingReference, declarationFile, context, namespace, declarationDepth }) {
  const itemTypeReference = buildTypeReference({
    schema: schema2.value,
    fileContainingReference,
    declarationFile,
    context,
    namespace,
    declarationDepth
  });
  const itemType = getTypeFromTypeReference(itemTypeReference);
  const itemDocs = getDocsFromTypeReference(itemTypeReference);
  const itemDefault = getDefaultFromTypeReference(itemTypeReference);
  const itemValidation = getValidationFromTypeReference(itemTypeReference);
  const type2 = itemType.startsWith("optional<") ? itemType : `optional<${itemType}>`;
  if (schema2.availability == null && schema2.description == null && itemDocs == null && itemDefault == null && itemValidation == null && schema2.title == null) {
    return type2;
  }
  const result = {
    type: type2
  };
  if (schema2.description != null || itemDocs != null) {
    result.docs = schema2.description ?? itemDocs;
  }
  if (itemDefault != null) {
    result.default = itemDefault;
  }
  if (itemValidation != null) {
    result.validation = itemValidation;
  }
  if (schema2.availability != null) {
    result.availability = convertAvailability2(schema2.availability);
  }
  return result;
}
function buildUnknownTypeReference() {
  return "unknown";
}
function buildLiteralTypeReference(schema2) {
  let value;
  switch (schema2.value.type) {
    case "boolean": {
      value = `literal<${schema2.value.value}>`;
      break;
    }
    case "string": {
      value = `literal<"${schema2.value.value}">`;
      break;
    }
    default:
      assertNever(schema2.value);
  }
  if (schema2.description == null && schema2.title == null) {
    return value;
  }
  return {
    type: value,
    ...schema2.description != null ? { docs: schema2.description } : {},
    ...schema2.availability != null ? { availability: convertAvailability2(schema2.availability) } : {}
  };
}
function buildEnumTypeReference({ schema: schema2, fileContainingReference, declarationFile, context, declarationDepth }) {
  const enumTypeDeclaration = buildEnumTypeDeclaration(schema2, declarationDepth);
  const name = schema2.nameOverride ?? schema2.generatedName;
  context.builder.addType(declarationFile, {
    name,
    schema: enumTypeDeclaration.schema
  });
  const prefixedType = getPrefixedType({ type: name, fileContainingReference, declarationFile, context });
  if (schema2.description == null && schema2.default == null && schema2.title == null) {
    return prefixedType;
  }
  const result = {
    type: prefixedType
  };
  if (schema2.description != null) {
    result.docs = schema2.description;
  }
  if (schema2.default != null) {
    result.default = schema2.default.value;
  }
  if (schema2.availability != null) {
    result.availability = convertAvailability2(schema2.availability);
  }
  return result;
}
function buildObjectTypeReference({ schema: schema2, fileContainingReference, declarationFile, context, namespace, declarationDepth }) {
  const objectTypeDeclaration = buildObjectTypeDeclaration({
    schema: schema2,
    declarationFile,
    context,
    namespace,
    declarationDepth
  });
  const name = schema2.nameOverride ?? schema2.generatedName;
  context.builder.addType(declarationFile, {
    name,
    schema: objectTypeDeclaration.schema
  });
  const prefixedType = getPrefixedType({ type: name, fileContainingReference, declarationFile, context });
  if (schema2.description == null && schema2.title == null) {
    return prefixedType;
  }
  return {
    type: prefixedType,
    ...schema2.description != null ? { docs: schema2.description } : {},
    ...schema2.availability != null ? { availability: convertAvailability2(schema2.availability) } : {}
  };
}
function buildOneOfTypeReference({ schema: schema2, fileContainingReference, declarationFile, context, namespace, declarationDepth }) {
  const unionTypeDeclaration = buildOneOfTypeDeclaration({
    schema: schema2,
    declarationFile,
    context,
    namespace,
    declarationDepth
  });
  const name = schema2.nameOverride ?? schema2.generatedName;
  context.builder.addType(declarationFile, {
    name,
    schema: unionTypeDeclaration.schema
  });
  const prefixedType = getPrefixedType({ type: name, fileContainingReference, declarationFile, context });
  if (schema2.description == null && schema2.title == null) {
    return prefixedType;
  }
  return {
    ...schema2.title != null ? { "display-name": schema2.title } : {},
    type: prefixedType,
    ...schema2.description != null ? { docs: schema2.description } : {},
    ...schema2.availability != null ? { availability: convertAvailability2(schema2.availability) } : {}
  };
}
function getPrefixedType({ type: type2, fileContainingReference, declarationFile, context }) {
  if (declarationFile === fileContainingReference) {
    return type2;
  }
  const prefix = context.builder.addImport({
    file: fileContainingReference,
    fileToImport: declarationFile
  });
  return prefix != null ? `${prefix}.${type2}` : type2;
}
function getSchemaName(schema2) {
  return Schema._visit(schema2, {
    primitive: (s) => s.nameOverride ?? s.generatedName,
    object: (s) => s.nameOverride ?? s.generatedName,
    array: (s) => s.nameOverride ?? s.generatedName,
    map: (s) => s.nameOverride ?? s.generatedName,
    enum: (s) => s.nameOverride ?? s.generatedName,
    reference: (s) => s.nameOverride ?? s.generatedName,
    literal: (s) => s.nameOverride ?? s.generatedName,
    oneOf: (s) => s.nameOverride ?? s.generatedName,
    optional: (s) => s.nameOverride ?? s.generatedName,
    nullable: (s) => s.nameOverride ?? s.generatedName,
    unknown: (s) => s.nameOverride ?? s.generatedName,
    _other: () => void 0
  });
}
function getDisplayName(schema2) {
  return Schema._visit(schema2, {
    primitive: (s) => s.title,
    object: (s) => s.title,
    array: (s) => s.title,
    map: (s) => s.title,
    enum: (s) => s.title,
    reference: (s) => s.title,
    literal: (s) => s.title,
    oneOf: (s) => s.title,
    optional: (s) => s.title,
    nullable: (s) => s.title,
    unknown: (s) => void 0,
    _other: () => void 0
  });
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/convertToSourceSchema.js
function convertToSourceSchema(source) {
  switch (source.type) {
    case "openapi":
      return {
        openapi: source.file
      };
    case "protobuf":
      return {
        proto: source.file
      };
    default:
      assertNever(source);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/State.js
var State;
(function (State3) {
  State3[State3["Channel"] = 0] = "Channel";
  State3[State3["Endpoint"] = 1] = "Endpoint";
  State3[State3["Request"] = 2] = "Request";
  State3[State3["Webhook"] = 3] = "Webhook";
})(State || (State = {}));

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildTypeDeclaration.js
function buildTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth }) {
  switch (schema2.type) {
    case "primitive":
      return buildPrimitiveTypeDeclaration(schema2);
    case "array":
      return buildArrayTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth });
    case "map":
      return buildMapTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth });
    case "reference":
      return buildReferenceTypeDeclaration({ schema: schema2, context, declarationFile, namespace });
    case "unknown":
      return buildUnknownTypeDeclaration(schema2.nameOverride, schema2.generatedName);
    case "optional":
    case "nullable":
      return buildOptionalTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth });
    case "enum":
      return buildEnumTypeDeclaration(schema2, declarationDepth);
    case "literal":
      return buildLiteralTypeDeclaration(schema2, schema2.nameOverride, schema2.generatedName);
    case "object":
      return buildObjectTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth });
    case "oneOf":
      return buildOneOfTypeDeclaration({
        schema: schema2.value,
        context,
        declarationFile,
        namespace,
        declarationDepth
      });
    default:
      assertNever(schema2);
  }
}
function buildObjectTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth }) {
  const shouldSkipReadonly = context.isInState(State.Request) && context.respectReadonlySchemas && (context.getEndpointMethod() === "POST" || context.getEndpointMethod() === "PUT" || context.getEndpointMethod() === "PATCH");
  let readOnlyPropertyPresent = false;
  const properties = {};
  const schemasToInline = /* @__PURE__ */ new Set();
  for (const property4 of schema2.properties) {
    if (property4.readonly) {
      readOnlyPropertyPresent = true;
    }
    if (shouldSkipReadonly && property4.readonly) {
      continue;
    }
    if (Object.keys(property4.conflict).length > 0) {
      const parentHasIdentiticalProperty = Object.entries(property4.conflict).every(([_, conflict]) => {
        return !conflict.differentSchema;
      });
      if (parentHasIdentiticalProperty) {
        continue;
      } else {
        Object.entries(property4.conflict).forEach(([schemaId]) => {
          const parentSchemasToInine = getAllParentSchemasToInline({
            property: property4.key,
            schemaId,
            context,
            namespace
          });
          parentSchemasToInine.forEach((schemaToInline) => {
            schemasToInline.add(schemaToInline);
          });
        });
      }
    }
    const typeReference = buildTypeReference({
      schema: property4.schema,
      context,
      fileContainingReference: declarationFile,
      namespace,
      declarationDepth: declarationDepth + 1
    });
    const audiences = property4.audiences;
    const name2 = property4.nameOverride;
    const availability = convertAvailability2(property4.availability);
    properties[property4.key] = convertPropertyTypeReferenceToTypeDefinition({
      typeReference,
      audiences,
      name: name2,
      availability
    });
  }
  const propertiesToSetToUnknown = /* @__PURE__ */ new Set();
  for (const allOfPropertyConflict of schema2.allOfPropertyConflicts) {
    allOfPropertyConflict.allOfSchemaIds.forEach((schemaId) => schemasToInline.add(schemaId));
    if (allOfPropertyConflict.conflictingTypeSignatures) {
      propertiesToSetToUnknown.add(allOfPropertyConflict.propertyKey);
    }
  }
  const extendedSchemas = [];
  for (const allOf of schema2.allOf) {
    const resolvedSchemaId = getSchemaIdOfResolvedType({ schema: allOf.schema, context, namespace });
    if (resolvedSchemaId == null) {
      continue;
    }
    if (schemasToInline.has(allOf.schema) || schemasToInline.has(resolvedSchemaId)) {
      continue;
    }
    const allOfTypeReference = buildTypeReference({
      schema: Schema.reference(allOf),
      context,
      fileContainingReference: declarationFile,
      namespace,
      declarationDepth: declarationDepth + 1
    });
    extendedSchemas.push(getTypeFromTypeReference(allOfTypeReference));
  }
  for (const inlineSchemaId of schemasToInline) {
    const inlinedSchemaPropertyInfo = getProperties(context, inlineSchemaId, namespace);
    for (const propertyToInline of inlinedSchemaPropertyInfo.properties) {
      if (properties[propertyToInline.key] == null) {
        if (propertiesToSetToUnknown.has(propertyToInline.key)) {
          properties[propertyToInline.key] = "unknown";
        }
        properties[propertyToInline.key] = buildTypeReference({
          schema: propertyToInline.schema,
          context,
          fileContainingReference: declarationFile,
          namespace,
          declarationDepth: declarationDepth + 1
        });
      }
    }
    for (const extendedSchema of inlinedSchemaPropertyInfo.allOf) {
      if (schemasToInline.has(extendedSchema.schema)) {
        continue;
      }
      const extendedSchemaTypeReference = buildTypeReference({
        schema: Schema.reference(extendedSchema),
        context,
        fileContainingReference: declarationFile,
        namespace,
        declarationDepth: declarationDepth + 1
      });
      extendedSchemas.push(getTypeFromTypeReference(extendedSchemaTypeReference));
    }
  }
  const objectTypeDeclaration = {
    docs: schema2.description ?? void 0,
    properties: Object.fromEntries(Object.entries(properties).map(([propertyKey, propertyDefinition]) => {
      if (startsWithNumber2(propertyKey)) {
        return [
          propertyKey,
          typeof propertyDefinition === "string" ? {
            type: propertyDefinition,
            name: `_${propertyKey}`
          } : {
            ...propertyDefinition,
            name: `_${propertyKey}`
          }
        ];
      }
      return [propertyKey, propertyDefinition];
    }))
  };
  if (extendedSchemas.length > 0) {
    objectTypeDeclaration.extends = extendedSchemas;
  }
  if (schema2.additionalProperties) {
    objectTypeDeclaration["extra-properties"] = true;
  }
  if (schema2.availability != null) {
    objectTypeDeclaration.availability = convertAvailability2(schema2.availability);
  }
  if (schema2.source != null) {
    objectTypeDeclaration.source = convertToSourceSchema(schema2.source);
  }
  objectTypeDeclaration.inline = getInline(declarationDepth);
  const name = schema2.nameOverride ?? schema2.generatedName;
  return {
    name: readOnlyPropertyPresent && context.respectReadonlySchemas && !shouldSkipReadonly ? `${name}Read` : name,
    schema: objectTypeDeclaration
  };
}
function getAllParentSchemasToInline({ property: property4, schemaId, context, namespace }) {
  const schema2 = context.getSchema(schemaId, namespace);
  if (schema2 == null) {
    return [];
  }
  if (schema2.type === "reference") {
    return getAllParentSchemasToInline({ property: property4, schemaId: schema2.schema, context, namespace });
  }
  if (schema2.type === "object") {
    const { properties, allOf } = getProperties(context, schemaId, namespace);
    const hasProperty = properties.some((p) => {
      return p.key === property4;
    });
    const parentSchemasToInline = [
      ...allOf.flatMap((parent) => {
        return getAllParentSchemasToInline({ property: property4, context, schemaId: parent.schema, namespace });
      })
    ];
    if (hasProperty || parentSchemasToInline.length > 0) {
      return [schemaId, ...parentSchemasToInline];
    }
  }
  return [];
}
function getProperties(context, schemaId, namespace) {
  const schema2 = context.getSchema(schemaId, namespace);
  if (schema2 == null) {
    return { properties: [], allOf: [] };
  }
  if (schema2.type === "object") {
    return { properties: schema2.properties, allOf: schema2.allOf };
  } else if (schema2.type === "reference") {
    return getProperties(context, schema2.schema, namespace);
  }
  throw new Error(`Cannot getAllProperties for a non-object schema. schemaId=${schemaId}, type=${schema2.type}`);
}
function buildArrayTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth }) {
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: buildArrayTypeReference({
      schema: schema2,
      fileContainingReference: declarationFile,
      declarationFile,
      context,
      namespace,
      declarationDepth
    })
  };
}
function buildMapTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth }) {
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: buildMapTypeReference({
      schema: schema2,
      fileContainingReference: declarationFile,
      declarationFile,
      context,
      namespace,
      declarationDepth
    })
  };
}
function buildPrimitiveTypeDeclaration(schema2) {
  const typeReference = buildPrimitiveTypeReference(schema2);
  if (typeof typeReference === "string") {
    return {
      name: schema2.nameOverride ?? schema2.generatedName,
      schema: typeReference
    };
  }
  const { default: _, ...rest } = typeReference;
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: {
      ...rest
    }
  };
}
function isCasingEmpty(casing) {
  return casing.camel == null && casing.pascal == null && casing.screamingSnake == null && casing.snake == null;
}
function buildEnumTypeDeclaration(schema2, declarationDepth) {
  const enumSchema = {
    enum: schema2.values.map((enumValue) => {
      const name = enumValue.nameOverride ?? enumValue.generatedName;
      const value = enumValue.value;
      if (name === value && enumValue.description == null && (enumValue.casing == null || isCasingEmpty(enumValue.casing))) {
        return name;
      }
      const enumValueDeclaration = {
        value: enumValue.value
      };
      if (name !== value) {
        enumValueDeclaration.name = name;
      }
      if (enumValue.description != null) {
        enumValueDeclaration.docs = enumValue.description;
      }
      if (enumValue.casing != null && !isCasingEmpty(enumValue.casing)) {
        const casing = {};
        let setCasing = false;
        if (enumValue.casing.camel != null) {
          casing.camel = enumValue.casing.camel;
          setCasing = true;
        }
        if (enumValue.casing.screamingSnake != null) {
          casing["screaming-snake"] = enumValue.casing.screamingSnake;
          setCasing = true;
        }
        if (enumValue.casing.snake != null) {
          casing.snake = enumValue.casing.snake;
          setCasing = true;
        }
        if (enumValue.casing.pascal != null) {
          casing.pascal = enumValue.casing.pascal;
          setCasing = true;
        }
        if (setCasing) {
          enumValueDeclaration.casing = casing;
        }
      }
      return enumValueDeclaration;
    })
  };
  if (schema2.description != null) {
    enumSchema.docs = schema2.description;
  }
  if (schema2.default != null) {
    enumSchema.default = schema2.default.value;
  }
  const uniqueEnumName = /* @__PURE__ */ new Set();
  const uniqueEnumSchema = {
    ...enumSchema,
    enum: [],
    source: schema2.source != null ? convertToSourceSchema(schema2.source) : void 0
  };
  for (const enumValue of enumSchema.enum) {
    const name = typeof enumValue === "string" ? enumValue : enumValue.name ?? enumValue.value;
    if (!uniqueEnumName.has(name.toLowerCase())) {
      uniqueEnumSchema.enum.push(enumValue);
      uniqueEnumName.add(name.toLowerCase());
    }
  }
  enumSchema.inline = getInline(declarationDepth);
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: uniqueEnumSchema
  };
}
function buildReferenceTypeDeclaration({ schema: schema2, context, declarationFile, namespace }) {
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: buildReferenceTypeReference({
      schema: schema2,
      context,
      fileContainingReference: declarationFile,
      namespace
    })
  };
}
function buildOptionalTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth }) {
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: buildOptionalTypeReference({
      schema: schema2,
      context,
      fileContainingReference: declarationFile,
      declarationFile,
      namespace,
      declarationDepth
    })
  };
}
function buildUnknownTypeDeclaration(nameOverride, generatedName) {
  return {
    name: nameOverride ?? generatedName,
    schema: buildUnknownTypeReference()
  };
}
function buildLiteralTypeDeclaration(schema2, nameOverride, generatedName) {
  return {
    name: nameOverride ?? generatedName,
    schema: buildLiteralTypeReference(schema2)
  };
}
function buildOneOfTypeDeclaration({ schema: schema2, context, declarationFile, namespace, declarationDepth }) {
  const encoding = schema2.encoding != null ? convertToEncodingSchema(schema2.encoding) : void 0;
  if (schema2.type === "discriminated") {
    const baseProperties = {};
    for (const property4 of schema2.commonProperties) {
      baseProperties[property4.key] = buildTypeReference({
        schema: property4.schema,
        fileContainingReference: declarationFile,
        context,
        namespace,
        declarationDepth: declarationDepth + 1
      });
    }
    const union4 = {};
    for (const [discriminantValue, subSchema] of Object.entries(schema2.schemas)) {
      union4[discriminantValue] = buildTypeReference({
        schema: subSchema,
        context,
        fileContainingReference: declarationFile,
        namespace,
        declarationDepth: declarationDepth + 1
      });
    }
    return {
      name: schema2.nameOverride ?? schema2.generatedName,
      schema: {
        discriminant: schema2.discriminantProperty,
        "base-properties": baseProperties,
        docs: schema2.description ?? void 0,
        availability: schema2.availability != null ? convertAvailability2(schema2.availability) : void 0,
        union: union4,
        encoding,
        source: schema2.source != null ? convertToSourceSchema(schema2.source) : void 0
      }
    };
  }
  const union3 = [];
  for (const subSchema of schema2.schemas) {
    union3.push(buildTypeReference({
      schema: subSchema,
      fileContainingReference: declarationFile,
      context,
      namespace,
      declarationDepth: declarationDepth + 1
    }));
  }
  return {
    name: schema2.nameOverride ?? schema2.generatedName,
    schema: {
      discriminated: false,
      docs: schema2.description ?? void 0,
      union: union3,
      encoding,
      source: schema2.source != null ? convertToSourceSchema(schema2.source) : void 0,
      inline: getInline(declarationDepth)
    }
  };
}
var STARTS_WITH_NUMBER2 = /^[0-9]/;
function startsWithNumber2(str2) {
  return STARTS_WITH_NUMBER2.test(str2);
}
function getSchemaIdOfResolvedType({ schema: schema2, context, namespace }) {
  const resolvedSchema = context.getSchema(schema2, namespace);
  if (resolvedSchema == null) {
    return void 0;
  }
  if (resolvedSchema.type === "reference") {
    return getSchemaIdOfResolvedType({ context, schema: resolvedSchema.schema, namespace });
  }
  return schema2;
}
function convertPropertyTypeReferenceToTypeDefinition({ typeReference, audiences, name, availability }) {
  if (audiences.length === 0 && name == null && availability == null) {
    return typeReference;
  } else {
    return {
      ...typeof typeReference === "string" ? { type: typeReference } : { ...typeReference },
      ...audiences.length > 0 ? { audiences } : {},
      ...name != null ? { name } : {},
      ...availability != null ? { availability } : {}
    };
  }
}
function getInline(declarationDepth) {
  return declarationDepth > 0 ? true : void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/getHeaderName.js
function getHeaderName(headerWireKey) {
  const headerWithoutXPrefix = headerWireKey.replace(/^x-|^X-/, "");
  return camelCase_default(headerWithoutXPrefix);
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildAuthSchemes.js
var BASIC_AUTH_SCHEME = "BasicAuthScheme";
var BEARER_AUTH_SCHEME = "BearerAuthScheme";
function buildAuthSchemes(context) {
  if (context.authOverrides != null) {
    for (const [name, declaration] of Object.entries(context.authOverrides["auth-schemes"] ?? {})) {
      context.builder.addAuthScheme({
        name,
        schema: declaration
      });
    }
    if (context.authOverrides.auth != null) {
      context.builder.setAuth(context.authOverrides.auth);
    }
    return;
  }
  let setAuth = false;
  for (const [id, securityScheme] of Object.entries(context.ir.securitySchemes)) {
    if (securityScheme.type === "basic") {
      const basicAuthScheme = {
        scheme: "basic"
      };
      if (securityScheme.usernameVariableName != null) {
        if (basicAuthScheme.username === void 0) {
          basicAuthScheme.username = {
            name: securityScheme.usernameVariableName
          };
        } else {
          basicAuthScheme.username.name = securityScheme.usernameVariableName;
        }
      }
      if (securityScheme.usernameEnvVar != null) {
        if (basicAuthScheme.username === void 0) {
          basicAuthScheme.username = {
            env: securityScheme.usernameEnvVar
          };
        } else {
          basicAuthScheme.username.env = securityScheme.usernameEnvVar;
        }
      }
      if (securityScheme.passwordVariableName != null) {
        if (basicAuthScheme.password === void 0) {
          basicAuthScheme.password = {
            name: securityScheme.passwordVariableName
          };
        } else {
          basicAuthScheme.password.name = securityScheme.passwordVariableName;
        }
      }
      if (securityScheme.passwordEnvVar != null) {
        if (basicAuthScheme.password === void 0) {
          basicAuthScheme.password = {
            env: securityScheme.passwordEnvVar
          };
        } else {
          basicAuthScheme.password.env = securityScheme.passwordEnvVar;
        }
      }
      context.builder.addAuthScheme({
        name: BASIC_AUTH_SCHEME,
        schema: basicAuthScheme
      });
      if (!setAuth) {
        context.builder.setAuth(BASIC_AUTH_SCHEME);
        setAuth = true;
      }
    } else if (securityScheme.type === "bearer") {
      const bearerAuthScheme = {
        scheme: "bearer"
      };
      if (securityScheme.tokenVariableName != null) {
        if (bearerAuthScheme.token === void 0) {
          bearerAuthScheme.token = {
            name: securityScheme.tokenVariableName
          };
        } else {
          bearerAuthScheme.token.name = securityScheme.tokenVariableName;
        }
      }
      if (securityScheme.tokenEnvVar != null) {
        if (bearerAuthScheme.token === void 0) {
          bearerAuthScheme.token = {
            env: securityScheme.tokenEnvVar
          };
        } else {
          bearerAuthScheme.token.env = securityScheme.tokenEnvVar;
        }
      }
      context.builder.addAuthScheme({
        name: BEARER_AUTH_SCHEME,
        schema: bearerAuthScheme
      });
      if (!setAuth) {
        context.builder.setAuth(BEARER_AUTH_SCHEME);
        setAuth = true;
      }
    } else if (securityScheme.type === "header") {
      if (!setAuth) {
        const schema2 = {
          header: securityScheme.headerName,
          name: securityScheme.headerVariableName ?? "apiKey",
          type: "string"
        };
        if (securityScheme.headerEnvVar != null) {
          schema2.env = securityScheme.headerEnvVar;
        }
        if (securityScheme.prefix != null) {
          schema2.prefix = securityScheme.prefix;
        }
        context.builder.addAuthScheme({
          name: id,
          schema: schema2
        });
        context.builder.setAuth(id);
        setAuth = true;
      } else {
        context.builder.addGlobalHeader({
          name: securityScheme.headerName,
          schema: {
            type: "string",
            name: securityScheme.headerVariableName ?? getHeaderName(securityScheme.headerName),
            env: securityScheme.headerEnvVar
          }
        });
      }
    } else if (securityScheme.type === "oauth") {
      const bearerAuthScheme = {
        scheme: "bearer"
      };
      context.builder.addAuthScheme({
        name: BEARER_AUTH_SCHEME,
        schema: bearerAuthScheme
      });
      if (!setAuth) {
        context.builder.setAuth(BEARER_AUTH_SCHEME);
        setAuth = true;
      }
      if (securityScheme.scopesEnum != null && securityScheme.scopesEnum.values.length > 0) {
        context.builder.addType(RelativeFilePath.of("__package__.yml"), {
          name: "OauthScope",
          schema: buildEnumTypeDeclaration(securityScheme.scopesEnum, 0).schema
        });
      }
    }
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildHeader.js
function buildHeader({ header, context, fileContainingReference, namespace }) {
  const typeReference = buildTypeReference({
    schema: header.schema,
    context,
    fileContainingReference,
    namespace,
    declarationDepth: 0
  });
  const headerType = getTypeFromTypeReference(typeReference);
  const headerWithoutXPrefix = header.name.replace(/^x-|^X-/, "");
  const headerVariableName = header.parameterNameOverride != null ? header.parameterNameOverride : camelCase_default(headerWithoutXPrefix);
  if (header.description == null && header.name === headerVariableName && header.env == null && header.availability == null) {
    return headerType;
  }
  const headerSchema = {
    type: headerType
  };
  if (headerVariableName !== header.name) {
    headerSchema.name = headerVariableName;
  }
  if (header.description != null) {
    headerSchema.docs = header.description;
  }
  if (header.env != null) {
    headerSchema.env = header.env;
  }
  if (header.availability != null) {
    headerSchema.availability = convertAvailability2(header.availability);
  }
  return headerSchema;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildPathParameter.js
function buildPathParameter({ pathParameter, context, fileContainingReference, namespace }) {
  const typeReference = buildTypeReference({
    schema: pathParameter.schema,
    context,
    fileContainingReference,
    namespace,
    declarationDepth: 0
  });
  if (pathParameter.variableReference == null && pathParameter.description == null && pathParameter.availability == null) {
    return getTypeFromTypeReference(typeReference);
  }
  const pathParameterSchema = pathParameter.variableReference != null ? {
    variable: `$${pathParameter.variableReference}`
  } : {
    type: getTypeFromTypeReference(typeReference)
  };
  if (pathParameter.description != null) {
    pathParameterSchema.docs = pathParameter.description;
  }
  if (pathParameter.availability != null) {
    pathParameterSchema.availability = convertAvailability2(pathParameter.availability);
  }
  return pathParameterSchema;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildQueryParameter.js
function buildQueryParameter({ queryParameter, context, fileContainingReference, namespace }) {
  const typeReference = getQueryParameterTypeReference({
    schema: queryParameter.schema,
    context,
    fileContainingReference,
    namespace
  });
  if (typeReference == null) {
    return void 0;
  }
  let queryParameterType = getTypeFromTypeReference(typeReference.value);
  if (queryParameterType === "unknown") {
    queryParameterType = "string";
  } else if (queryParameterType === "optional<unknown>") {
    queryParameterType = "optional<string>";
  }
  if (queryParameter.description == null && !typeReference.allowMultiple && queryParameter.parameterNameOverride == null && queryParameter.availability == null) {
    return queryParameterType;
  }
  const queryParameterSchema = {
    type: queryParameterType
  };
  if (typeReference.allowMultiple) {
    queryParameterSchema["allow-multiple"] = true;
  }
  if (queryParameter.description != null) {
    queryParameterSchema.docs = queryParameter.description;
  }
  if (queryParameter.parameterNameOverride != null) {
    queryParameterSchema.name = queryParameter.parameterNameOverride;
  }
  if (queryParameter.availability != null) {
    queryParameterSchema.availability = convertAvailability2(queryParameter.availability);
  }
  if (isRawTypeReferenceDetailedSchema(typeReference.value)) {
    if (typeReference.value.validation !== void 0) {
      queryParameterSchema.validation = typeReference.value.validation;
    }
  }
  return queryParameterSchema;
}
function getQueryParameterTypeReference({ schema: schema2, context, fileContainingReference, namespace }) {
  if (schema2.type === "reference") {
    const resolvedSchema = context.getSchema(schema2.schema, namespace);
    if (resolvedSchema == null) {
      return void 0;
    } else if (resolvedSchema.type === "array") {
      return {
        value: buildTypeReference({
          schema: Schema.optional({
            nameOverride: schema2.nameOverride,
            generatedName: schema2.generatedName,
            title: schema2.title,
            value: resolvedSchema.value,
            description: schema2.description ?? resolvedSchema.description,
            availability: schema2.availability,
            groupName: void 0
          }),
          context,
          declarationFile: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
          fileContainingReference,
          namespace,
          declarationDepth: 0
        }),
        allowMultiple: true
      };
    } else if (resolvedSchema.type === "oneOf" && resolvedSchema.value.type === "undisciminated") {
      const potentialEnumValues = [];
      for (const [_, schema3] of Object.entries(resolvedSchema.value.schemas)) {
        if (schema3.type === "literal" && schema3.value.type === "string") {
          if (VALID_ENUM_NAME_REGEX.test(schema3.value.value)) {
            potentialEnumValues.push(schema3.value.value);
          } else {
            potentialEnumValues.push({
              value: schema3.value.value,
              name: generateEnumNameFromValue(schema3.value.value)
            });
          }
        }
      }
      if (potentialEnumValues.length > 0) {
        context.builder.addType(fileContainingReference, {
          name: schema2.generatedName,
          schema: { enum: potentialEnumValues }
        });
        return {
          value: schema2.generatedName,
          allowMultiple: false
        };
      }
      if (resolvedSchema.value.schemas.length === 2) {
        const [firstSchema, secondSchema] = resolvedSchema.value.schemas;
        if (firstSchema != null && secondSchema != null && hasSamePrimitiveValueType({ array: firstSchema, primitive: secondSchema })) {
          return {
            value: buildTypeReference({
              schema: Schema.optional({
                nameOverride: schema2.nameOverride,
                generatedName: schema2.generatedName,
                title: schema2.title,
                value: secondSchema,
                description: schema2.description,
                availability: schema2.availability,
                groupName: void 0
              }),
              context,
              fileContainingReference,
              namespace,
              declarationDepth: 0
            }),
            allowMultiple: true
          };
        }
        if (firstSchema != null && secondSchema != null && hasSamePrimitiveValueType({ array: firstSchema, primitive: secondSchema })) {
          return {
            value: buildTypeReference({
              schema: Schema.optional({
                nameOverride: schema2.nameOverride,
                generatedName: schema2.generatedName,
                title: schema2.title,
                value: firstSchema,
                description: schema2.description,
                availability: schema2.availability,
                groupName: void 0
              }),
              context,
              fileContainingReference,
              namespace,
              declarationDepth: 0
            }),
            allowMultiple: true
          };
        }
      }
      for (const [_, schema3] of Object.entries(resolvedSchema.value.schemas)) {
        return getQueryParameterTypeReference({
          schema: schema3,
          context,
          fileContainingReference,
          namespace
        });
      }
    } else if (context.objectQueryParameters) {
      return {
        value: buildTypeReference({
          schema: schema2,
          context,
          fileContainingReference,
          declarationFile: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
          namespace,
          declarationDepth: 0
        }),
        allowMultiple: false
      };
    }
  }
  if (schema2.type === "optional" || schema2.type === "nullable") {
    if (schema2.value.type === "reference") {
      const resolvedSchema = context.getSchema(schema2.value.schema, namespace);
      if (resolvedSchema == null) {
        return void 0;
      } else if (resolvedSchema.type === "array") {
        return {
          value: buildTypeReference({
            schema: Schema.optional({
              nameOverride: schema2.nameOverride,
              generatedName: schema2.generatedName,
              title: schema2.title,
              value: resolvedSchema.value,
              description: schema2.description ?? resolvedSchema.description,
              availability: schema2.availability,
              groupName: void 0
            }),
            context,
            fileContainingReference,
            declarationFile: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
            namespace,
            declarationDepth: 0
          }),
          allowMultiple: true
        };
      } else if (context.objectQueryParameters) {
        return {
          value: buildTypeReference({
            schema: schema2,
            context,
            fileContainingReference,
            declarationFile: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
            namespace,
            declarationDepth: 0
          }),
          allowMultiple: false
        };
      }
    }
    if (schema2.value.type === "array") {
      return {
        value: buildTypeReference({
          schema: Schema.optional({
            nameOverride: schema2.nameOverride,
            generatedName: schema2.generatedName,
            title: schema2.title,
            value: schema2.value.value,
            description: schema2.description,
            availability: schema2.availability,
            groupName: void 0
          }),
          context,
          fileContainingReference,
          namespace,
          declarationDepth: 0
        }),
        allowMultiple: true
      };
    } else if (schema2.value.type === "oneOf" && schema2.value.value.type === "undisciminated") {
      const potentialEnumValues = [];
      for (const [_, oneOfSchema] of Object.entries(schema2.value.value.schemas)) {
        if (oneOfSchema.type === "literal" && oneOfSchema.value.type === "string") {
          if (VALID_ENUM_NAME_REGEX.test(oneOfSchema.value.value)) {
            potentialEnumValues.push(oneOfSchema.value.value);
          } else {
            potentialEnumValues.push({
              value: oneOfSchema.value.value,
              name: generateEnumNameFromValue(oneOfSchema.value.value)
            });
          }
        }
      }
      if (potentialEnumValues.length > 0) {
        context.builder.addType(fileContainingReference, {
          name: schema2.generatedName,
          schema: { enum: potentialEnumValues }
        });
        return {
          value: `optional<${schema2.value.value.generatedName}>`,
          allowMultiple: false
        };
      }
      if (schema2.value.value.schemas.length === 2) {
        const [firstSchema, secondSchema] = schema2.value.value.schemas;
        if (firstSchema != null && secondSchema != null && hasSamePrimitiveValueType({ array: firstSchema, primitive: secondSchema })) {
          return {
            value: buildTypeReference({
              schema: Schema.optional({
                nameOverride: schema2.nameOverride,
                generatedName: schema2.generatedName,
                title: schema2.title,
                value: secondSchema,
                description: schema2.description,
                availability: schema2.availability,
                groupName: void 0
              }),
              context,
              fileContainingReference,
              namespace,
              declarationDepth: 0
            }),
            allowMultiple: true
          };
        }
        if (firstSchema != null && secondSchema != null && hasSamePrimitiveValueType({ array: secondSchema, primitive: firstSchema })) {
          return {
            value: buildTypeReference({
              schema: Schema.optional({
                nameOverride: schema2.nameOverride,
                generatedName: schema2.generatedName,
                title: schema2.title,
                value: firstSchema,
                description: schema2.description,
                availability: schema2.availability,
                groupName: void 0
              }),
              context,
              fileContainingReference,
              namespace,
              declarationDepth: 0
            }),
            allowMultiple: true
          };
        }
      }
      for (const [_, oneOfSchema] of Object.entries(schema2.value.value.schemas)) {
        return getQueryParameterTypeReference({
          schema: Schema.optional({
            nameOverride: schema2.nameOverride,
            generatedName: schema2.generatedName,
            title: schema2.title,
            value: oneOfSchema,
            description: void 0,
            availability: schema2.availability,
            groupName: void 0
          }),
          context,
          fileContainingReference,
          namespace
        });
      }
    } else if (schema2.value.type === "object") {
      if (context.objectQueryParameters) {
        return {
          value: buildTypeReference({
            schema: schema2,
            context,
            fileContainingReference,
            declarationFile: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
            namespace,
            declarationDepth: 0
          }),
          allowMultiple: false
        };
      }
      return void 0;
    }
    return {
      value: buildTypeReference({
        schema: schema2,
        context,
        fileContainingReference,
        namespace,
        declarationDepth: 0
      }),
      allowMultiple: false
    };
  }
  if (schema2.type === "array") {
    return {
      value: buildTypeReference({
        schema: Schema.optional({
          nameOverride: schema2.nameOverride,
          generatedName: schema2.generatedName,
          title: schema2.title,
          value: schema2.value,
          description: schema2.description,
          availability: schema2.availability,
          groupName: void 0
        }),
        context,
        fileContainingReference,
        namespace,
        declarationDepth: 0
      }),
      allowMultiple: true
    };
  } else {
    return {
      value: buildTypeReference({
        schema: schema2,
        context,
        fileContainingReference,
        namespace,
        declarationDepth: 0
      }),
      allowMultiple: false
    };
  }
}
function hasSamePrimitiveValueType({ array, primitive }) {
  return array?.type === "array" && array.value.type === "primitive" && primitive?.type === "primitive" && array.value.schema.type === primitive.schema.type;
}
function isRawTypeReferenceDetailedSchema(rawTypeReference) {
  return rawTypeReference.type != null;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildWebsocketSessionExample.js
function buildWebsocketSessionExample({ websocketExample, context }) {
  const example = {
    messages: []
  };
  if (websocketExample.name != null) {
    example.name = websocketExample.name;
  }
  if (websocketExample.description != null) {
    example.docs = websocketExample.description;
  }
  if (websocketExample.queryParameters != null && websocketExample.queryParameters.length > 0) {
    example["query-parameters"] = convertQueryParameterExample(websocketExample.queryParameters);
  }
  if (websocketExample.headers != null && websocketExample.headers.length > 0) {
    example.headers = convertHeaderExamples({ context, namedFullExamples: websocketExample.headers });
  }
  for (const message of websocketExample.messages) {
    const convertedMessage = convertFullExample(message.payload);
    if (convertedMessage != null) {
      example.messages.push({
        type: message.messageType,
        body: convertedMessage
      });
    }
  }
  return example;
}
function convertQueryParameterExample(namedFullExamples) {
  const result = {};
  namedFullExamples.forEach((namedFullExample) => {
    const convertedExample = convertFullExample(namedFullExample.value);
    if (Array.isArray(convertedExample)) {
      result[namedFullExample.name] = convertedExample[0];
    } else if (convertedExample != null) {
      result[namedFullExample.name] = convertedExample;
    }
  });
  return result;
}
function convertHeaderExamples({ context, namedFullExamples }) {
  const globalHeaderNames = context.builder.getGlobalHeaderNames();
  const result = {};
  namedFullExamples.forEach((namedFullExample) => {
    const convertedExample = convertFullExample(namedFullExample.value);
    if (globalHeaderNames.has(namedFullExample.name)) {
      return;
    } else if (convertedExample != null) {
      result[namedFullExample.name] = convertedExample;
    }
  });
  return result;
}
function convertFullExample(fullExample) {
  switch (fullExample.type) {
    case "primitive":
      return convertPrimitive(fullExample.value);
    case "object":
      return convertObject(fullExample.properties);
    case "array":
      return convertArrayExample(fullExample.value);
    case "map":
      return convertMapExample(fullExample.value);
    case "oneOf":
      return convertOneOfExample(fullExample.value);
    case "enum":
      return fullExample.value;
    case "literal":
      return convertLiteralExample(fullExample.value);
    case "unknown":
      return convertFullExample(fullExample.value);
    default:
      assertNever(fullExample);
  }
}
function convertPrimitive(primitiveExample) {
  switch (primitiveExample.type) {
    case "int":
      return primitiveExample.value;
    case "int64":
      return primitiveExample.value;
    case "uint":
      return primitiveExample.value;
    case "uint64":
      return primitiveExample.value;
    case "float":
      return primitiveExample.value;
    case "double":
      return primitiveExample.value;
    case "string": {
      if (primitiveExample.value.startsWith("$")) {
        return `${primitiveExample.value.slice(1)}`;
      }
      return primitiveExample.value;
    }
    case "datetime":
      try {
        return new Date(primitiveExample.value).toISOString().replace(/\.\d{3}Z$/, "Z");
      } catch (e) {
        return "2024-01-15T09:30:00Z";
      }
    case "date":
      return primitiveExample.value;
    case "base64":
    case "boolean":
      return primitiveExample.value;
    default:
      assertNever(primitiveExample);
  }
}
function convertObject(object3) {
  return Object.fromEntries(Object.entries(object3).map(([propertyKey, fullExample]) => {
    return [propertyKey, convertFullExample(fullExample)];
  }));
}
function convertArrayExample(fullExamples) {
  return fullExamples.map((fullExample) => {
    return convertFullExample(fullExample);
  });
}
function convertMapExample(pairs2) {
  return Object.fromEntries(pairs2.map((pair) => {
    return [convertPrimitive(pair.key), convertFullExample(pair.value)];
  }));
}
function convertOneOfExample(oneOf) {
  if (oneOf.type === "discriminated") {
    return convertObject(oneOf.value);
  }
  return convertFullExample(oneOf.value);
}
function convertLiteralExample(literal) {
  switch (literal.type) {
    case "string":
      return literal.value;
    case "boolean":
      return literal.value;
    default:
      assertNever(literal);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/getNamespaceFromGroup.js
function getNamespaceFromGroup(groupName) {
  return groupName.find((group) => typeof group !== "string" && group.type === "namespace")?.name;
}
function getEndpointNamespace(sdkName, namespaceOverride) {
  return namespaceOverride != null ? namespaceOverride : sdkName?.groupName != null ? getNamespaceFromGroup(sdkName.groupName) : void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildChannel.js
function buildChannel({ channel, context, declarationFile }) {
  const convertedChannel = {
    path: channel.path,
    auth: false
  };
  if (channel.summary != null) {
    convertedChannel["display-name"] = channel.summary;
  }
  const maybeChannelNamespace = getNamespaceFromGroup(channel.groupName);
  const pathParameters = {};
  if (channel.handshake.pathParameters.length > 0) {
    for (const pathParameter of channel.handshake.pathParameters) {
      pathParameters[pathParameter.name] = buildPathParameter({
        pathParameter,
        context,
        fileContainingReference: declarationFile,
        namespace: maybeChannelNamespace
      });
    }
  }
  if (Object.keys(pathParameters).length > 0) {
    convertedChannel["path-parameters"] = pathParameters;
  }
  const queryParameters = {};
  if (channel.handshake.queryParameters.length > 0) {
    for (const queryParameter of channel.handshake.queryParameters) {
      const convertedQueryParameter = buildQueryParameter({
        queryParameter,
        context,
        fileContainingReference: declarationFile,
        namespace: maybeChannelNamespace
      });
      if (convertedQueryParameter == null) {
        continue;
      }
      queryParameters[queryParameter.name] = convertedQueryParameter;
    }
  }
  if (Object.keys(queryParameters).length > 0) {
    convertedChannel["query-parameters"] = queryParameters;
  }
  const headers = {};
  if (channel.handshake.headers.length > 0) {
    for (const header of channel.handshake.headers) {
      const headerSchema = buildHeader({
        header,
        context,
        fileContainingReference: declarationFile,
        namespace: maybeChannelNamespace
      });
      headers[header.name] = headerSchema;
    }
  }
  if (Object.keys(headers).length > 0) {
    convertedChannel.headers = headers;
  }
  context.builder.addChannel(declarationFile, {
    channel: convertedChannel
  });
  if (channel.subscribe != null) {
    context.builder.addChannelMessage(declarationFile, {
      messageId: "subscribe",
      message: {
        origin: "server",
        body: buildTypeReference({
          schema: channel.subscribe,
          context,
          fileContainingReference: declarationFile,
          namespace: maybeChannelNamespace,
          declarationDepth: 0
        })
      }
    });
  }
  if (channel.publish != null) {
    context.builder.addChannelMessage(declarationFile, {
      messageId: "publish",
      message: {
        origin: "client",
        body: buildTypeReference({
          schema: channel.publish,
          context,
          fileContainingReference: declarationFile,
          namespace: maybeChannelNamespace,
          declarationDepth: 0
        })
      }
    });
  }
  for (const example of channel.examples) {
    const websocketExample = buildWebsocketSessionExample({ context, websocketExample: example });
    context.builder.addChannelExample(declarationFile, {
      example: websocketExample
    });
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildEnvironments.js
var PRODUCTION_ENVNIRONMENT_NAME = "Production";
var DEFAULT_ENVIRONMENT_NAME = "Default";
function extractUrlsFromEnvironmentSchema(record3) {
  return Object.entries(record3).reduce((acc, [name, schemaOrUrl]) => {
    if (isRawMultipleBaseUrlsEnvironment(schemaOrUrl)) {
      Object.entries(schemaOrUrl.urls).forEach(([urlsName, urlsValue]) => {
        acc[urlsName] = urlsValue;
      });
    } else {
      acc[name] = typeof schemaOrUrl === "string" ? schemaOrUrl : schemaOrUrl.url;
    }
    return acc;
  }, {});
}
function buildEnvironments(context) {
  if (context.environmentOverrides != null) {
    for (const [environment, environmentDeclaration] of Object.entries(context.environmentOverrides.environments ?? {})) {
      context.builder.addEnvironment({
        name: environment,
        schema: environmentDeclaration
      });
    }
    if (context.environmentOverrides["default-environment"] != null) {
      context.builder.setDefaultEnvironment(context.environmentOverrides["default-environment"]);
    }
    if (context.environmentOverrides["default-url"] != null) {
      context.builder.setDefaultUrl(context.environmentOverrides["default-url"]);
    }
    return;
  }
  const topLevelServersWithName = {};
  const topLevelSkippedServers = [];
  for (const server of context.ir.servers) {
    const environmentSchema = server.audiences ? {
      url: server.url,
      audiences: server.audiences
    } : server.url;
    if (server.name == null) {
      topLevelSkippedServers.push(environmentSchema);
      continue;
    }
    topLevelServersWithName[server.name] = environmentSchema;
  }
  const endpointLevelServersWithName = {};
  const endpointLevelSkippedServers = [];
  for (const endpoint of context.ir.endpoints) {
    for (const server of endpoint.server) {
      if (server.url == null) {
        continue;
      }
      const environmentSchema = server.audiences ? {
        url: server.url,
        audiences: server.audiences
      } : server.url;
      if (server.name == null) {
        endpointLevelSkippedServers.push(environmentSchema);
        continue;
      }
      endpointLevelServersWithName[server.name] = environmentSchema;
    }
  }
  const numTopLevelServers = Object.keys(topLevelServersWithName).length;
  const numEndpointLevelServers = Object.keys(endpointLevelServersWithName).length;
  if (numTopLevelServers === 0 && numEndpointLevelServers === 0) {
    const singleURL = context.ir.servers[0]?.url;
    const singleURLAudiences = context.ir.servers[0]?.audiences;
    if (singleURL != null) {
      context.builder.addEnvironment({
        name: DEFAULT_ENVIRONMENT_NAME,
        schema: singleURLAudiences ? {
          url: singleURL,
          audiences: singleURLAudiences
        } : singleURL
      });
      context.builder.setDefaultEnvironment(DEFAULT_ENVIRONMENT_NAME);
    }
  } else if (numTopLevelServers > 0 && numEndpointLevelServers === 0) {
    let count = 0;
    if (topLevelSkippedServers.length > 0) {
      context.logger.error(`Skipping servers ${topLevelSkippedServers.map((server) => typeof server === "string" ? server : server.url).join(", ")} because x-fern-server-name was not provided.`);
    }
    for (const [name, schema2] of Object.entries(topLevelServersWithName)) {
      if (count === 0) {
        context.builder.setDefaultEnvironment(name);
      }
      context.builder.addEnvironment({
        name,
        schema: schema2
      });
      count += 1;
    }
  } else if (numEndpointLevelServers > 0) {
    if (topLevelSkippedServers.length > 0 || endpointLevelSkippedServers.length > 0) {
      context.logger.error(`Skipping servers ${[...topLevelSkippedServers, ...endpointLevelSkippedServers].map((server) => typeof server === "string" ? server : server.url).join(", ")} because x-fern-server-name was not provided.`);
    }
    const toplevelServerEntries = Object.entries(topLevelServersWithName)[0];
    if (toplevelServerEntries != null) {
      const [name, _] = toplevelServerEntries;
      context.setDefaultServerName(name);
    }
    context.builder.addEnvironment({
      name: PRODUCTION_ENVNIRONMENT_NAME,
      schema: {
        urls: {
          ...extractUrlsFromEnvironmentSchema(topLevelServersWithName),
          ...extractUrlsFromEnvironmentSchema(endpointLevelServersWithName)
        }
      }
    });
    context.builder.setDefaultEnvironment(PRODUCTION_ENVNIRONMENT_NAME);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/wrapTypeReferenceAsOptional.js
function wrapTypeReferenceAsOptional(typeReference) {
  const type2 = getTypeFromTypeReference(typeReference);
  if (type2.startsWith("optional")) {
    return typeReference;
  } else if (typeof typeReference === "string") {
    return `optional<${typeReference}>`;
  } else {
    return { ...typeReference, type: `optional<${typeReference.type}>` };
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildGlobalHeaders.js
var HeaderWithCount = class {
  schema;
  count = 0;
  constructor(schema2) {
    this.schema = schema2;
  }
  increment() {
    this.count += 1;
  }
};
var GLOBAL_HEADER_PERCENTAGE_THRESHOLD = 0.75;
var HEADERS_TO_IGNORE = new Set(...["authorization"]);
function buildGlobalHeaders(context) {
  if (context.globalHeaderOverrides != null) {
    for (const [name, declaration] of Object.entries(context.globalHeaderOverrides.headers ?? {})) {
      context.builder.addGlobalHeader({
        name,
        schema: declaration
      });
    }
    return;
  }
  const predefinedGlobalHeaders = Object.fromEntries((context.ir.globalHeaders ?? []).map((header) => [header.header, header]));
  for (const [headerName, header] of Object.entries(predefinedGlobalHeaders)) {
    let schema2 = "optional<string>";
    if (header.name == null && header.env == null && typeof header.schema === "string") {
      schema2 = header.schema;
    } else if (header != null) {
      const groupName = header.schema ? getGroupNameForSchema(header.schema) : void 0;
      const namespace = groupName != null ? getNamespaceFromGroup(groupName) : void 0;
      const defaultFile = RelativeFilePath.of("api.yml");
      schema2 = {
        name: header.name,
        env: header.env,
        type: header.schema != null ? getTypeFromTypeReference(buildTypeReference({
          schema: header.schema,
          context,
          fileContainingReference: namespace ? join(RelativeFilePath.of(camelCase_default(namespace)), defaultFile) : defaultFile,
          namespace,
          declarationDepth: 0
        })) ?? "optional<string>" : "optional<string>"
      };
    }
    context.builder.addGlobalHeader({
      name: headerName,
      schema: schema2
    });
  }
  if (context.detectGlobalHeaders) {
    const globalHeaders = {};
    for (const endpoint of context.ir.endpoints) {
      for (const header of endpoint.headers) {
        if (HEADERS_TO_IGNORE.has(header.name.toLowerCase())) {
          continue;
        }
        let headerWithCount = globalHeaders[header.name];
        if (headerWithCount == null) {
          const predefinedHeader = predefinedGlobalHeaders[header.name];
          const convertedHeader = buildHeader({
            header: {
              ...header,
              schema: predefinedHeader?.schema ?? header.schema,
              name: predefinedHeader?.name ?? header.name
            },
            fileContainingReference: RelativeFilePath.of(ROOT_API_FILENAME),
            context,
            // TODO: how are we namespacing global headers
            namespace: void 0
          });
          headerWithCount = new HeaderWithCount(convertedHeader);
          globalHeaders[header.name] = headerWithCount;
        }
        headerWithCount.increment();
      }
    }
    const globalHeaderThreshold = context.ir.endpoints.length * GLOBAL_HEADER_PERCENTAGE_THRESHOLD;
    for (const [headerName, header] of Object.entries(globalHeaders)) {
      const predefinedHeader = predefinedGlobalHeaders[headerName];
      const isRequired = header.count === context.ir.endpoints.length;
      const isOptional2 = header.count >= globalHeaderThreshold;
      if (predefinedHeader != null) {
        continue;
      } else if (isRequired) {
        context.builder.addGlobalHeader({
          name: headerName,
          schema: header.schema
        });
      } else if (isOptional2) {
        context.builder.addGlobalHeader({
          name: headerName,
          schema: wrapTypeReferenceAsOptional(header.schema)
        });
      }
    }
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildIdempotencyHeaders.js
function buildIdempotencyHeaders(context) {
  for (const header of context.ir.idempotencyHeaders ?? []) {
    const groupName = header.schema ? getGroupNameForSchema(header.schema) : void 0;
    const namespace = groupName != null ? getNamespaceFromGroup(groupName) : void 0;
    const convertedHeader = buildHeader({
      header: {
        ...header,
        schema: header.schema ?? Schema.primitive({
          description: void 0,
          availability: void 0,
          generatedName: "",
          title: void 0,
          groupName: void 0,
          nameOverride: void 0,
          schema: PrimitiveSchemaValue.string({
            default: void 0,
            pattern: void 0,
            format: void 0,
            minLength: void 0,
            maxLength: void 0
          })
        }),
        name: header.name ?? header.header,
        parameterNameOverride: void 0,
        description: void 0,
        availability: void 0,
        source: void 0
      },
      fileContainingReference: RelativeFilePath.of(ROOT_API_FILENAME),
      context,
      namespace
    });
    context.builder.addIdempotencyHeader({
      name: header.header,
      schema: wrapTypeReferenceAsOptional(convertedHeader)
    });
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/convertFullExample.js
function convertFullExample2(fullExample) {
  switch (fullExample.type) {
    case "primitive":
      return convertPrimitive2(fullExample.value);
    case "object":
      return convertObject2(fullExample.properties);
    case "array":
      return convertArrayExample2(fullExample.value);
    case "map":
      return convertMapExample2(fullExample.value);
    case "oneOf":
      return convertOneOfExample2(fullExample.value);
    case "enum":
      return fullExample.value;
    case "literal":
      return convertLiteralExample2(fullExample.value);
    case "unknown":
      return convertFullExample2(fullExample.value);
    default:
      assertNever(fullExample);
  }
}
function convertEndpointResponseExample(endpointResponseExample) {
  switch (endpointResponseExample.type) {
    case "withStreaming":
      return {
        stream: convertArrayExample2(endpointResponseExample.value)
      };
    case "withoutStreaming":
      return {
        body: convertFullExample2(endpointResponseExample.value)
      };
    default:
      assertNever(endpointResponseExample);
  }
}
function convertPrimitive2(primitiveExample) {
  switch (primitiveExample.type) {
    case "int":
      return primitiveExample.value;
    case "int64":
      return primitiveExample.value;
    case "uint":
      return primitiveExample.value;
    case "uint64":
      return primitiveExample.value;
    case "float":
      return primitiveExample.value;
    case "double":
      return primitiveExample.value;
    case "string": {
      if (primitiveExample.value.startsWith("$")) {
        return `${primitiveExample.value.slice(1)}`;
      }
      return primitiveExample.value;
    }
    case "datetime":
      try {
        if (!primitiveExample.value.endsWith("Z") && !primitiveExample.value.includes("+")) {
          primitiveExample.value += "Z";
        }
        return new Date(primitiveExample.value).toISOString().replace(/\.\d{3}Z$/, "Z");
      } catch (e) {
        return "2024-01-15T09:30:00Z";
      }
    case "date":
      return primitiveExample.value;
    case "base64":
    case "boolean":
      return primitiveExample.value;
    default:
      assertNever(primitiveExample);
  }
}
function convertObject2(object3) {
  return Object.fromEntries(Object.entries(object3).map(([propertyKey, fullExample]) => {
    return [propertyKey, convertFullExample2(fullExample)];
  }));
}
function convertArrayExample2(fullExamples) {
  return fullExamples.map((fullExample) => {
    return convertFullExample2(fullExample);
  });
}
function convertMapExample2(pairs2) {
  return Object.fromEntries(pairs2.map((pair) => {
    return [convertPrimitive2(pair.key), convertFullExample2(pair.value)];
  }));
}
function convertOneOfExample2(oneOf) {
  if (oneOf.type === "discriminated") {
    return convertObject2(oneOf.value);
  }
  return convertFullExample2(oneOf.value);
}
function convertLiteralExample2(literal) {
  switch (literal.type) {
    case "string":
      return literal.value;
    case "boolean":
      return literal.value;
    default:
      assertNever(literal);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildEndpointExample.js
function buildEndpointExample({ endpointExample, context }) {
  const example = {};
  if (endpointExample.type !== "full") {
    return endpointExample.value;
  }
  if (endpointExample.name != null) {
    example.name = endpointExample.name;
  }
  if (endpointExample.description != null) {
    example.docs = endpointExample.description;
  }
  if (endpointExample.pathParameters != null && endpointExample.pathParameters.length > 0) {
    example["path-parameters"] = convertPathParameterExample(endpointExample.pathParameters);
  }
  if (endpointExample.queryParameters != null && endpointExample.queryParameters.length > 0) {
    example["query-parameters"] = convertQueryParameterExample2(endpointExample.queryParameters);
  }
  if (endpointExample.headers != null && endpointExample.headers.length > 0) {
    example.headers = convertHeaderExamples2({ context, namedFullExamples: endpointExample.headers });
  }
  if (endpointExample.request != null) {
    example.request = convertFullExample2(endpointExample.request);
  }
  if (endpointExample.response != null) {
    example.response = convertEndpointResponseExample(endpointExample.response);
  }
  if (endpointExample.codeSamples != null && endpointExample.codeSamples.length > 0) {
    example["code-samples"] = endpointExample.codeSamples.map((codeSample) => {
      if (codeSample.type === "language") {
        return {
          name: codeSample.name ?? void 0,
          docs: codeSample.description ?? void 0,
          language: codeSample.language,
          code: codeSample.code,
          install: codeSample.install ?? void 0
        };
      } else {
        return {
          name: codeSample.name ?? void 0,
          docs: codeSample.description ?? void 0,
          sdk: codeSample.sdk,
          code: codeSample.code
        };
      }
    }).filter(isNonNullish);
  }
  return example;
}
function convertPathParameterExample(pathParameterExamples) {
  const result = {};
  pathParameterExamples.forEach((pathParameterExample) => {
    const convertedExample = convertFullExample2(pathParameterExample.value);
    if (convertedExample != null) {
      result[pathParameterExample.parameterNameOverride ?? pathParameterExample.name] = convertedExample;
    }
  });
  return result;
}
function convertQueryParameterExample2(namedFullExamples) {
  const result = {};
  namedFullExamples.forEach((namedFullExample) => {
    const convertedExample = convertFullExample2(namedFullExample.value);
    if (Array.isArray(convertedExample)) {
      result[namedFullExample.name] = convertedExample[0];
    } else if (convertedExample != null) {
      result[namedFullExample.name] = convertedExample;
    }
  });
  return result;
}
function convertHeaderExamples2({ context, namedFullExamples }) {
  const globalHeaderNames = context.builder.getGlobalHeaderNames();
  const result = {};
  namedFullExamples.forEach((namedFullExample) => {
    const convertedExample = convertFullExample2(namedFullExample.value);
    if (globalHeaderNames.has(namedFullExample.name)) {
      return;
    } else if (convertedExample != null) {
      result[namedFullExample.name] = convertedExample;
    }
  });
  return result;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/convertToHttpMethod.js
function convertToHttpMethod(httpMethod) {
  return HttpMethod2._visit(httpMethod, {
    get: () => schemas_exports3.HttpMethodSchema.Get,
    post: () => schemas_exports3.HttpMethodSchema.Post,
    put: () => schemas_exports3.HttpMethodSchema.Put,
    patch: () => schemas_exports3.HttpMethodSchema.Patch,
    delete: () => schemas_exports3.HttpMethodSchema.Delete,
    head: () => {
      throw new Error("HEAD is unsupported");
    },
    options: () => {
      throw new Error("HEAD is unsupported");
    },
    trace: () => {
      throw new Error("HEAD is unsupported");
    },
    _other: () => {
      throw new Error("Unkown http method is unsupported");
    }
  });
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildEndpoint.js
function buildEndpoint({ endpoint, declarationFile, context }) {
  const { nonRequestReferencedSchemas } = context.ir;
  let schemaIdsToExclude = [];
  const names = /* @__PURE__ */ new Set();
  let path5 = endpoint.path;
  const maybeEndpointNamespace = getEndpointNamespace(endpoint.sdkName, endpoint.namespace);
  const pathParameters = {};
  for (const pathParameter of endpoint.pathParameters) {
    if (pathParameter.parameterNameOverride) {
      path5 = path5.replace(pathParameter.name, pathParameter.parameterNameOverride);
    }
    pathParameters[pathParameter.parameterNameOverride ?? pathParameter.name] = buildPathParameter({
      pathParameter,
      context,
      fileContainingReference: declarationFile,
      namespace: maybeEndpointNamespace
    });
    names.add(pathParameter.name);
  }
  const queryParameters = {};
  for (const queryParameter of endpoint.queryParameters) {
    const convertedQueryParameter = buildQueryParameter({
      queryParameter,
      context,
      fileContainingReference: declarationFile,
      namespace: maybeEndpointNamespace
    });
    if (convertedQueryParameter == null) {
      continue;
    }
    queryParameters[queryParameter.name] = convertedQueryParameter;
    names.add(queryParameter.name);
  }
  let pagination = void 0;
  if (endpoint.pagination != null) {
    if (endpoint.pagination.type === "cursor") {
      pagination = {
        cursor: endpoint.pagination.cursor,
        next_cursor: endpoint.pagination.nextCursor,
        results: endpoint.pagination.results
      };
    } else {
      pagination = {
        offset: endpoint.pagination.offset,
        step: endpoint.pagination.step,
        results: endpoint.pagination.results,
        "has-next-page": endpoint.pagination.hasNextPage
      };
    }
  }
  const convertedEndpoint = {
    path: path5,
    method: convertToHttpMethod(endpoint.method),
    auth: endpoint.authed,
    docs: endpoint.description ?? void 0,
    pagination,
    source: endpoint.source != null ? convertToSourceSchema(endpoint.source) : void 0
  };
  if (!endpointRequestSupportsInlinedPathParameters({ context, request: endpoint.request }) && Object.keys(pathParameters).length > 0) {
    convertedEndpoint["path-parameters"] = pathParameters;
  }
  if (endpoint.summary != null) {
    convertedEndpoint["display-name"] = endpoint.summary;
  }
  const headers = {};
  const globalHeaderNames = context.builder.getGlobalHeaderNames();
  const endpointSpecificHeaders = endpoint.headers.filter((header) => {
    return !globalHeaderNames.has(header.name);
  });
  for (const header of endpointSpecificHeaders) {
    const headerSchema = buildHeader({
      header,
      context,
      fileContainingReference: declarationFile,
      namespace: maybeEndpointNamespace
    });
    headers[header.name] = headerSchema;
    names.add(typeof headerSchema === "string" ? header.name : headerSchema.name ?? header.name);
  }
  if (endpoint.request != null) {
    context.setInState(State.Request);
    const convertedRequest = getRequest({
      endpoint,
      context,
      declarationFile,
      request: endpoint.request,
      generatedRequestName: endpoint.generatedRequestName,
      requestNameOverride: endpoint.requestNameOverride ?? void 0,
      pathParameters: context.inlinePathParameters && Object.keys(pathParameters).length > 0 ? pathParameters : void 0,
      queryParameters: Object.keys(queryParameters).length > 0 ? queryParameters : void 0,
      nonRequestReferencedSchemas: Array.from(nonRequestReferencedSchemas),
      headers: Object.keys(headers).length > 0 ? headers : void 0,
      usedNames: names,
      namespace: maybeEndpointNamespace
    });
    convertedEndpoint.request = convertedRequest.value;
    schemaIdsToExclude = [...schemaIdsToExclude, ...convertedRequest.schemaIdsToExclude ?? []];
    context.unsetInState(State.Request);
  } else {
    const hasPathParams = context.inlinePathParameters && Object.keys(pathParameters).length > 0;
    const hasQueryParams = Object.keys(queryParameters).length > 0;
    const hasHeaders = Object.keys(headers).length > 0;
    const convertedRequest = {};
    if (hasPathParams || hasQueryParams || hasHeaders) {
      convertedRequest.name = endpoint.requestNameOverride ?? endpoint.generatedRequestName;
    }
    if (hasPathParams) {
      convertedRequest["path-parameters"] = pathParameters;
    }
    if (hasQueryParams) {
      convertedRequest["query-parameters"] = queryParameters;
    }
    if (hasHeaders) {
      convertedRequest.headers = headers;
    }
    if (Object.keys(convertedRequest).length > 0) {
      convertedEndpoint.request = convertedRequest;
    }
  }
  if (endpoint.response != null) {
    endpoint.response._visit({
      json: (jsonResponse) => {
        const responseTypeReference = buildTypeReference({
          schema: jsonResponse.schema,
          context,
          fileContainingReference: declarationFile,
          namespace: maybeEndpointNamespace,
          declarationDepth: 0
        });
        convertedEndpoint.response = {
          docs: jsonResponse.description ?? void 0,
          type: getTypeFromTypeReference(responseTypeReference)
        };
        if (jsonResponse.responseProperty != null) {
          convertedEndpoint.response.property = jsonResponse.responseProperty;
        }
      },
      streamingJson: (jsonResponse) => {
        const responseTypeReference = buildTypeReference({
          schema: jsonResponse.schema,
          context,
          fileContainingReference: declarationFile,
          namespace: maybeEndpointNamespace,
          declarationDepth: 0
        });
        convertedEndpoint["response-stream"] = {
          docs: jsonResponse.description ?? void 0,
          type: getTypeFromTypeReference(responseTypeReference),
          format: "json"
        };
      },
      streamingSse: (jsonResponse) => {
        const responseTypeReference = buildTypeReference({
          schema: jsonResponse.schema,
          context,
          fileContainingReference: declarationFile,
          namespace: maybeEndpointNamespace,
          declarationDepth: 0
        });
        convertedEndpoint["response-stream"] = {
          docs: jsonResponse.description ?? void 0,
          type: getTypeFromTypeReference(responseTypeReference),
          format: "sse"
        };
      },
      file: (fileResponse) => {
        convertedEndpoint.response = {
          docs: fileResponse.description ?? void 0,
          type: "file"
        };
      },
      streamingText: (textResponse) => {
        convertedEndpoint["response-stream"] = {
          docs: textResponse.description ?? void 0,
          type: "text"
        };
      },
      text: (textResponse) => {
        convertedEndpoint.response = {
          docs: textResponse.description ?? void 0,
          type: "text"
        };
      },
      _other: () => {
        throw new Error("Unrecognized Response type: " + endpoint.response?.type);
      }
    });
  }
  if (context.builder.getEnvironmentType() === "multi") {
    const defaultServer = context.getDefaultServerName();
    const serverOverride = endpoint.server[0];
    if (serverOverride == null) {
      if (defaultServer != null) {
        convertedEndpoint.url = defaultServer;
      }
    } else {
      convertedEndpoint.url = serverOverride.name ?? void 0;
    }
  }
  if (endpoint.idempotent) {
    convertedEndpoint.idempotent = true;
  }
  if (endpoint.availability != null) {
    convertedEndpoint.availability = convertAvailability2(endpoint.availability);
  }
  Object.entries(endpoint.errors).forEach(([statusCode, httpError]) => {
    let errorName = httpError.generatedName;
    const fileContainingReference = RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME);
    if (context.builder.enableUniqueErrorsPerEndpoint) {
      errorName = `${endpoint.generatedRequestName}${httpError.generatedName}`;
      if (httpError.schema != null) {
        if (httpError.schema.type !== "reference" && httpError.schema.type !== "oneOf") {
          httpError.schema.generatedName = `${endpoint.generatedRequestName}${httpError.schema.generatedName}`;
        } else if (httpError.schema.type === "oneOf") {
          httpError.schema.value.generatedName = `${endpoint.generatedRequestName}${httpError.schema.value.generatedName}`;
        }
      }
    }
    const errorDeclaration = {
      "status-code": parseInt(statusCode)
    };
    const errorDeclarationFile = resolveLocationWithNamespace({
      location: ERROR_DECLARATIONS_FILENAME,
      namespaceOverride: maybeEndpointNamespace
    });
    if (httpError.schema != null) {
      const typeReference = buildTypeReference({
        schema: httpError.schema,
        context,
        fileContainingReference: errorDeclarationFile,
        declarationFile: errorDeclarationFile,
        namespace: maybeEndpointNamespace,
        declarationDepth: 0
      });
      errorDeclaration.type = getTypeFromTypeReference(typeReference);
      errorDeclaration.docs = httpError.description;
    }
    context.builder.addError(errorDeclarationFile, {
      name: errorName,
      schema: context.isErrorUnknownSchema(parseInt(statusCode)) ? { ...errorDeclaration, type: "unknown" } : errorDeclaration
    });
    if (convertedEndpoint.errors == null) {
      convertedEndpoint.errors = [];
    }
    const prefix = context.builder.addImport({
      file: declarationFile,
      fileToImport: errorDeclarationFile
    });
    convertedEndpoint.errors.push(prefix != null ? `${prefix}.${errorName}` : errorName);
    const errorTypeReference = errorDeclaration.type;
    if (errorTypeReference != null) {
      httpError.examples?.forEach((example) => {
        const convertedExample = {
          value: convertFullExample2(example.example),
          name: example.name,
          docs: example.description
        };
        context.builder.addErrorExample(errorDeclarationFile, {
          name: errorName,
          example: convertedExample
        });
      });
    }
  });
  if (endpoint.examples.length > 0) {
    convertedEndpoint.examples = convertEndpointExamples({
      endpointExamples: endpoint.examples,
      context
    });
  }
  if (context.ir.hasEndpointsMarkedInternal && (endpoint.internal == null || !endpoint.internal)) {
    convertedEndpoint.audiences = [EXTERNAL_AUDIENCE, ...endpoint.audiences];
  } else if (endpoint.audiences.length > 0) {
    convertedEndpoint.audiences = endpoint.audiences;
  }
  return {
    value: convertedEndpoint,
    schemaIdsToExclude
  };
}
function convertEndpointExamples({ endpointExamples, context }) {
  return endpointExamples.map((endpointExample) => {
    try {
      return buildEndpointExample({ endpointExample, context });
    } catch (e) {
      console.error(`Error building endpoint example: ${e}`);
      throw e;
    }
  });
}
function getRequest({ endpoint, declarationFile, context, request, requestNameOverride, generatedRequestName, pathParameters, queryParameters, nonRequestReferencedSchemas, headers, usedNames, namespace }) {
  if (request.type === "json") {
    const maybeSchemaId = request.schema.type === "reference" ? request.schema.schema : void 0;
    const resolvedSchema = request.schema.type === "reference" ? context.getSchema(request.schema.schema, namespace) : request.schema;
    if (resolvedSchema?.type !== "object" || maybeSchemaId != null && nonRequestReferencedSchemas.includes(maybeSchemaId)) {
      const requestTypeReference = buildTypeReference({
        schema: request.schema,
        fileContainingReference: declarationFile,
        context,
        namespace,
        declarationDepth: 0
      });
      const convertedRequest = {
        schemaIdsToExclude: [],
        value: {
          body: requestTypeReference
        }
      };
      const hasPathParams = Object.keys(pathParameters ?? {}).length > 0;
      const hasQueryParams = Object.keys(queryParameters ?? {}).length > 0;
      const hasHeaders = Object.keys(headers ?? {}).length > 0;
      if (hasPathParams) {
        convertedRequest.value["path-parameters"] = pathParameters;
      }
      if (hasQueryParams) {
        convertedRequest.value["query-parameters"] = queryParameters;
      }
      if (hasHeaders) {
        convertedRequest.value.headers = headers;
      }
      if (hasPathParams || hasQueryParams || hasHeaders) {
        convertedRequest.value.name = requestNameOverride ?? generatedRequestName;
      }
      if (request.contentType != null) {
        convertedRequest.value["content-type"] = request.contentType;
      }
      if (request.description != null) {
        convertedRequest.value.docs = request.description;
      }
      return convertedRequest;
    }
    const properties = Object.fromEntries(resolvedSchema.properties.filter((property4) => {
      if (property4.readonly == null) {
        return true;
      }
      const writeEndpoint = endpoint.method === "POST" || endpoint.method === "PUT";
      if (writeEndpoint && property4.readonly) {
        return false;
      }
      return true;
    }).map((property4) => {
      const propertyTypeReference = buildTypeReference({
        schema: property4.schema,
        fileContainingReference: declarationFile,
        context,
        namespace,
        declarationDepth: 1
        // 1 level deep for request body properties
      });
      const name = property4.nameOverride ?? property4.key;
      const availability = convertAvailability2(property4.availability);
      if (!usedNames.has(name) && property4.audiences.length <= 0) {
        usedNames.add(name);
        if (property4.nameOverride != null) {
          return [
            property4.key,
            {
              type: getTypeFromTypeReference(propertyTypeReference),
              docs: getDocsFromTypeReference(propertyTypeReference),
              name: property4.nameOverride,
              availability
            }
          ];
        }
        return [
          property4.key,
          availability ? {
            ...typeof propertyTypeReference === "string" ? { type: propertyTypeReference } : propertyTypeReference,
            availability
          } : propertyTypeReference
        ];
      }
      const typeReference = {
        type: getTypeFromTypeReference(propertyTypeReference),
        docs: getDocsFromTypeReference(propertyTypeReference)
      };
      if (usedNames.has(name)) {
        typeReference.name = property4.generatedName;
      }
      if (property4.audiences.length > 0) {
        typeReference.audiences = property4.audiences;
      }
      if (availability != null) {
        typeReference.availability = availability;
      }
      usedNames.add(name);
      return [property4.key, typeReference];
    }));
    const extendedSchemas = resolvedSchema.allOf.map((referencedSchema) => {
      const allOfTypeReference = buildTypeReference({
        schema: Schema.reference(referencedSchema),
        fileContainingReference: declarationFile,
        context,
        namespace,
        declarationDepth: 0
      });
      return getTypeFromTypeReference(allOfTypeReference);
    });
    const requestBodySchema = {
      properties
    };
    if (extendedSchemas.length > 0) {
      requestBodySchema.extends = extendedSchemas;
    }
    if (request.additionalProperties) {
      requestBodySchema["extra-properties"] = true;
    }
    const convertedRequestValue = {
      name: requestNameOverride ?? resolvedSchema.nameOverride ?? resolvedSchema.generatedName,
      "path-parameters": pathParameters,
      "query-parameters": queryParameters,
      headers,
      body: requestBodySchema
    };
    if (request.contentType != null) {
      convertedRequestValue["content-type"] = request.contentType;
    }
    if (request.description != null) {
      convertedRequestValue.docs = request.description;
    }
    return {
      schemaIdsToExclude: maybeSchemaId != null ? [maybeSchemaId] : [],
      value: convertedRequestValue
    };
  } else if (request.type === "octetStream") {
    return {
      schemaIdsToExclude: [],
      value: {
        body: "bytes",
        "content-type": MediaType.APPLICATION_OCTET_STREAM,
        ...request.description ? { docs: request.description } : {}
      }
    };
  } else if (request.type === "multipart") {
    const properties = Object.fromEntries(request.properties.map((property4) => {
      if (property4.schema.type === "file") {
        let fileType = property4.schema.isArray ? "list<file>" : "file";
        fileType = property4.schema.isOptional ? `optional<${fileType}>` : fileType;
        if (property4.description != null || property4.contentType != null) {
          const propertyTypeReference = {
            type: fileType
          };
          if (property4.description != null) {
            propertyTypeReference.docs = property4.description;
          }
          if (property4.contentType != null) {
            const contentType = property4.contentType.split(",")[0];
            propertyTypeReference["content-type"] = contentType;
          }
          return [property4.key, propertyTypeReference];
        }
        return [property4.key, fileType];
      } else {
        let propertyTypeReference = buildTypeReference({
          schema: property4.schema.value,
          fileContainingReference: declarationFile,
          context,
          namespace,
          declarationDepth: 1
          // 1 level deep for request body properties
        });
        if (property4.contentType != null) {
          if (typeof propertyTypeReference === "string") {
            propertyTypeReference = {
              type: propertyTypeReference,
              "content-type": property4.contentType
            };
          } else {
            propertyTypeReference["content-type"] = property4.contentType;
          }
        }
        return [property4.key, propertyTypeReference];
      }
    }));
    return {
      schemaIdsToExclude: request.name == null ? [] : [request.name],
      value: {
        name: requestNameOverride ?? request.name ?? generatedRequestName,
        "path-parameters": pathParameters,
        "query-parameters": queryParameters,
        headers,
        body: {
          properties
        },
        "content-type": MediaType.MULTIPART_FORM_DATA,
        ...request.description ? { docs: request.description } : {}
      }
    };
  } else {
    assertNever(request);
  }
}
function endpointRequestSupportsInlinedPathParameters({ context, request }) {
  if (!context.inlinePathParameters) {
    return false;
  }
  if (request == null) {
    return true;
  }
  switch (request.type) {
    case "octetStream":
      return false;
    case "multipart":
      return true;
    case "json":
      return true;
    default:
      assertNever(request);
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/getEndpointLocation.js
function resolveEndpointLocationWithNamespaceOverride({ location, namespaceOverride }) {
  if (namespaceOverride != null) {
    return {
      ...location,
      file: join(RelativeFilePath.of(namespaceOverride), location.file)
    };
  }
  return location;
}
function getUnresolvedEndpointLocation(endpoint) {
  const namespace = endpoint.namespace;
  const tag = endpoint.tags.filter((tag2) => tag2 !== namespace)[0];
  const operationId = endpoint.operationId;
  if (operationId == null) {
    if (tag != null) {
      return {
        file: RelativeFilePath.of(`${camelCase_default(tag)}.yml`),
        endpointId: endpoint.summary != null ? camelCase_default(endpoint.summary) : camelCase_default(`${endpoint.method}_${endpoint.path.split("/").join("_")}`)
      };
    }
    if (endpoint.summary != null) {
      return {
        file: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
        endpointId: camelCase_default(endpoint.summary)
      };
    }
    return {
      file: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
      endpointId: camelCase_default(`${endpoint.method}_${endpoint.path.split("/").join("_")}`)
    };
  }
  if (tag == null) {
    return {
      file: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
      endpointId: operationId
    };
  }
  const tagTokens = tokenizeString(tag);
  const operationIdTokens = tokenizeString(operationId);
  if (isEqual_default(tagTokens, operationIdTokens)) {
    return {
      file: RelativeFilePath.of("__package__.yml"),
      endpointId: tag
    };
  }
  const fastapiEndpointLocation = maybeGetFastApiEndpointLocation({
    operationId,
    tag,
    path: endpoint.path,
    method: endpoint.method
  });
  if (fastapiEndpointLocation != null) {
    return fastapiEndpointLocation;
  }
  const fileParts = [];
  for (let i = 0; i < tagTokens.length; ++i) {
    const tagElement = tagTokens[i];
    if (tagElement != null && tagElement === operationIdTokens[i]) {
      fileParts.push(tagElement);
    } else {
      const camelCasedTag = camelCase_default(tag);
      return {
        file: RelativeFilePath.of(`${camelCasedTag}.yml`),
        endpointId: operationId,
        tag
      };
    }
  }
  if (fileParts.length >= operationIdTokens.length) {
    throw new Error(`Cannot get file for endpoint ${JSON.stringify(endpoint)}`);
  }
  return {
    file: RelativeFilePath.of(camelCase_default(fileParts.join("_")) + ".yml"),
    endpointId: camelCase_default(operationIdTokens.slice(fileParts.length).join("_")),
    tag
  };
}
function getEndpointLocation(endpoint) {
  const tag = endpoint.tags[0];
  if (endpoint.sdkName != null) {
    const filenameWithoutExtension = convertEndpointSdkNameToFileWithoutExtension({
      sdkName: endpoint.sdkName,
      namespaceOverride: endpoint.namespace
    });
    const filename = `${filenameWithoutExtension}.yml`;
    const isTagApplicable = filenameWithoutExtension.toLowerCase() === tag?.toLowerCase().replaceAll(" ", "");
    return {
      file: RelativeFilePath.of(filename),
      endpointId: endpoint.sdkName.methodName,
      // only if the tag lines up with `x-fern-sdk-group-name` do we use it
      tag: isTagApplicable ? tag : void 0
    };
  }
  return resolveEndpointLocationWithNamespaceOverride({
    namespaceOverride: endpoint.namespace,
    location: getUnresolvedEndpointLocation(endpoint)
  });
}
function tokenizeString(input) {
  let tokens;
  if (/^[a-z]+(?:[A-Z][a-z]+)*$/.test(input)) {
    tokens = input.split(/(?=[A-Z])/);
  } else {
    tokens = input.split(/[^a-zA-Z0-9]+/);
  }
  tokens = tokens.map((token) => token.toLowerCase());
  tokens = compact_default(tokens);
  return tokens;
}
var NON_ALPHANUMERIC_EXCEPT_BRACES_REGEX = new RegExp("[^a-zA-Z0-9{}]+");
var BRACE_REGEX = new RegExp("[{}]", "g");
function maybeGetFastApiEndpointLocation({ operationId, tag, path: path5, method }) {
  const pathSegment = path5.split(NON_ALPHANUMERIC_EXCEPT_BRACES_REGEX).join("_").replaceAll(BRACE_REGEX, "_");
  const operationIdSuffix = `${pathSegment}_${method.toLowerCase()}`;
  if (operationId.endsWith(operationIdSuffix)) {
    return {
      file: RelativeFilePath.of(camelCase_default(tag) + ".yml"),
      endpointId: camelCase_default(operationId.slice(0, -1 * operationIdSuffix.length)),
      tag
    };
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildServices.js
function buildServices(context) {
  const sdkGroups = /* @__PURE__ */ new Set();
  const { endpoints, tags } = context.ir;
  let schemaIdsToExclude = [];
  for (const endpoint of endpoints) {
    const { endpointId, file, tag } = getEndpointLocation(endpoint);
    const sdkGroup = file.split(".")[0];
    if (sdkGroup != null) {
      sdkGroups.add(sdkGroup);
    }
    let group = void 0;
    if (endpoint.sdkName != null) {
      const groupInfo = context.ir.groups;
      for (const groupName of endpoint.sdkName.groupName) {
        const trueGroupName = typeof groupName === "string" ? groupName : groupName.name;
        const value = groupInfo[trueGroupName];
        if (value == null) {
          break;
        } else if (value.summary != null || value.description != null) {
          group = groupInfo[trueGroupName];
          break;
        }
      }
    }
    const irTag = tag == null ? void 0 : tags.tagsById[tag];
    context.setInState(State.Endpoint);
    context.setEndpointMethod(endpoint.method);
    const convertedEndpoint = buildEndpoint({
      context,
      endpoint,
      declarationFile: file
    });
    context.unsetEndpointMethod();
    context.unsetInState(State.Endpoint);
    schemaIdsToExclude = [...schemaIdsToExclude, ...convertedEndpoint.schemaIdsToExclude];
    context.builder.addEndpoint(file, {
      name: endpointId,
      schema: convertedEndpoint.value,
      source: endpoint.source != null ? convertToSourceSchema(endpoint.source) : void 0
    });
    if (irTag?.id != null || irTag?.description != null) {
      context.builder.setServiceInfo(file, {
        "display-name": group?.summary ?? irTag?.id,
        docs: group?.description ?? irTag?.description ?? void 0
      });
    }
  }
  return { schemaIdsToExclude, sdkGroups };
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildVariables.js
function buildVariables(context) {
  for (const [variable, variableSchema] of Object.entries(context.ir.variables)) {
    const namespace = variableSchema.groupName != null ? getNamespaceFromGroup(variableSchema.groupName) : void 0;
    const typeReference = buildTypeReference({
      schema: Schema.primitive(variableSchema),
      context,
      fileContainingReference: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
      namespace,
      declarationDepth: 0
    });
    context.builder.addVariable({
      name: variable,
      schema: {
        type: getTypeFromTypeReference(typeReference),
        docs: variableSchema.description ?? void 0
      }
    });
  }
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildWebhooks.js
function buildWebhooks(context) {
  for (const webhook of context.ir.webhooks) {
    const webhookLocation = getWebhookLocation({ webhook, context });
    if (webhookLocation == null) {
      continue;
    }
    const maybeWebhookNamespace = getEndpointNamespace(webhook.sdkName, webhook.namespace);
    const headers = {};
    for (const header of webhook.headers) {
      headers[header.name] = buildHeader({
        header,
        context,
        fileContainingReference: webhookLocation.file,
        namespace: maybeWebhookNamespace
      });
    }
    const webhookDefinition = {
      method: webhook.method,
      "display-name": webhook.summary ?? void 0,
      headers,
      payload: buildTypeReference({
        schema: webhook.payload,
        context,
        fileContainingReference: webhookLocation.file,
        namespace: maybeWebhookNamespace,
        declarationDepth: 0
      }),
      examples: webhook.examples != null ? webhook.examples.map((exampleWebhookCall) => {
        return {
          docs: exampleWebhookCall.description,
          name: exampleWebhookCall.name,
          payload: convertFullExample2(exampleWebhookCall.payload)
        };
      }) : void 0
    };
    context.builder.addWebhook(webhookLocation.file, {
      name: webhookLocation.endpointId,
      schema: webhookDefinition
    });
    if (webhook.description != null) {
      webhookDefinition.docs = webhook.description;
    }
  }
}
function resolveWebhookLocationWithNamespaceOverride({ location, namespaceOverride }) {
  if (location == null) {
    return void 0;
  }
  if (namespaceOverride != null) {
    return {
      ...location,
      file: join(RelativeFilePath.of(namespaceOverride), location.file)
    };
  }
  return location;
}
function getUnresolvedWebhookLocation({ webhook, context }) {
  const tag = webhook.tags[0];
  const operationId = webhook.operationId;
  if (tag == null) {
    return {
      file: RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME),
      endpointId: operationId
    };
  }
  const tagTokens = tokenizeString(tag);
  const operationIdTokens = tokenizeString(operationId);
  if (isEqual_default(tagTokens, operationIdTokens)) {
    return {
      file: RelativeFilePath.of("__package__.yml"),
      endpointId: tag
    };
  }
  const fileParts = [];
  for (let i = 0; i < tagTokens.length; ++i) {
    const tagElement = tagTokens[i];
    if (tagElement != null && tagElement === operationIdTokens[i]) {
      fileParts.push(tagElement);
    } else {
      const camelCasedTag = camelCase_default(tag);
      return {
        file: RelativeFilePath.of(`${camelCasedTag}.yml`),
        endpointId: operationId,
        tag
      };
    }
  }
  if (fileParts.length >= operationIdTokens.length) {
    context.logger.warn(`Skipping webhook ${webhook.operationId} because couldn't compute file location`);
    return void 0;
  }
  return {
    file: RelativeFilePath.of(camelCase_default(fileParts.join("_")) + ".yml"),
    endpointId: camelCase_default(operationIdTokens.slice(fileParts.length).join("_")),
    tag
  };
}
function getWebhookLocation({ webhook, context }) {
  if (webhook.sdkName != null) {
    return {
      file: convertEndpointSdkNameToFile({ sdkName: webhook.sdkName, namespaceOverride: webhook.namespace }),
      endpointId: webhook.sdkName.methodName
    };
  }
  return resolveWebhookLocationWithNamespaceOverride({
    namespaceOverride: webhook.namespace,
    location: getUnresolvedWebhookLocation({ webhook, context })
  });
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/utils/getDeclarationFileForSchema.js
var PACKAGE_MARKER_RELATIVE_FILEPATH = RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME);
function getDeclarationFileForSchema(schema2) {
  switch (schema2.type) {
    case "object":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "enum":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "oneOf":
      return getDeclarationFileFromGroupName(schema2.value.groupName);
    case "array":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "map":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "reference":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "literal":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "optional":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "nullable":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "primitive":
      return getDeclarationFileFromGroupName(schema2.groupName);
    case "unknown":
      return PACKAGE_MARKER_RELATIVE_FILEPATH;
    default:
      assertNever(schema2);
  }
}
function getDeclarationFileFromGroupName(groupName) {
  return convertSdkGroupNameToFile(groupName);
}

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/buildFernDefinition.js
var EXTERNAL_AUDIENCE = "external";
var ERROR_DECLARATIONS_FILENAME = RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME);
function addSchemas({ schemas, schemaIdsToExclude, namespace, context }) {
  for (const [id, schema2] of Object.entries(schemas)) {
    if (schemaIdsToExclude.includes(id)) {
      continue;
    }
    const declarationFile = getDeclarationFileForSchema(schema2);
    const typeDeclaration = buildTypeDeclaration({
      schema: schema2,
      context,
      declarationFile,
      namespace,
      declarationDepth: 0
    });
    if (isRawAliasDefinition(typeDeclaration.schema)) {
      const aliasType = getTypeFromTypeReference(typeDeclaration.schema);
      if (aliasType === (typeDeclaration.name ?? id) || aliasType === `optional<${typeDeclaration.name ?? id}>`) {
        continue;
      }
    }
    context.builder.addType(declarationFile, {
      name: typeDeclaration.name ?? id,
      schema: typeDeclaration.schema
    });
  }
}
function buildFernDefinition(context) {
  if (context.ir.apiVersion != null) {
    context.builder.setApiVersion(context.ir.apiVersion);
  }
  buildEnvironments(context);
  buildGlobalHeaders(context);
  buildIdempotencyHeaders(context);
  buildAuthSchemes(context);
  buildVariables(context);
  if (context.ir.basePath != null) {
    context.builder.setBasePath(context.ir.basePath);
  }
  if (context.ir.hasEndpointsMarkedInternal) {
    context.builder.addAudience(EXTERNAL_AUDIENCE);
  }
  const convertedServices = buildServices(context);
  const sdkGroups = convertedServices.sdkGroups;
  context.setInState(State.Webhook);
  buildWebhooks(context);
  context.unsetInState(State.Webhook);
  context.setInState(State.Channel);
  for (const channel of context.ir.channel) {
    const declarationFile = convertSdkGroupNameToFile(channel.groupName);
    buildChannel({ channel, context, declarationFile });
  }
  context.unsetInState(State.Channel);
  const schemaIdsToExclude = getSchemaIdsToExclude({
    context,
    schemaIdsToExcludeFromServices: convertedServices.schemaIdsToExclude
  });
  addSchemas({ schemas: context.ir.groupedSchemas.rootSchemas, schemaIdsToExclude, namespace: void 0, context });
  for (const [namespace, schemas] of Object.entries(context.ir.groupedSchemas.namespacedSchemas)) {
    addSchemas({ schemas, schemaIdsToExclude, namespace, context });
  }
  if (context.ir.tags.orderedTagIds != null && context.ir.tags.orderedTagIds.length > 0) {
    const containsValidTagIds = context.ir.tags.orderedTagIds.every((tagId) => {
      return sdkGroups.has(tagId);
    });
    if (containsValidTagIds) {
      context.builder.addNavigation({
        navigation: context.ir.tags.orderedTagIds
      });
    }
  }
  return context.builder.build();
}
function getSchemaIdsToExclude({ context, schemaIdsToExcludeFromServices }) {
  const referencedSchemaIds = context.getReferencedSchemaIds();
  if (referencedSchemaIds == null) {
    return schemaIdsToExcludeFromServices;
  }
  const allSchemaIds = /* @__PURE__ */ new Set([
    ...Object.keys(context.ir.groupedSchemas.rootSchemas),
    ...Object.values(context.ir.groupedSchemas.namespacedSchemas).flatMap((schemas) => Object.keys(schemas))
  ]);
  const schemaIdsToExcludeSet = new Set(schemaIdsToExcludeFromServices);
  for (const schemaId of allSchemaIds) {
    if (!referencedSchemaIds.includes(schemaId)) {
      schemaIdsToExcludeSet.add(schemaId);
    }
  }
  return Array.from(schemaIdsToExcludeSet);
}

// ../../cli/api-importers/commons/lib/FernDefinitionBuilder.js
var import_path = __toESM(require("path"), 1);

// ../../cli/api-importers/commons/lib/utils/FernDefinitionDirectory.js
var FernDefinitionDirectory = class _FernDefinitionDirectory {
  files = {};
  directories = {};
  getAllFiles() {
    const files = {};
    const walk = (root2, currentPath) => {
      for (const [relativeFilePath, definition] of Object.entries(root2.files)) {
        const fullRelativeFilePath = currentPath != null ? RelativeFilePath.of(`${currentPath}${sep}${relativeFilePath}`) : RelativeFilePath.of(relativeFilePath);
        files[fullRelativeFilePath] = definition;
      }
      const sortedDirectories = Object.keys(root2.directories).sort();
      for (const directory of sortedDirectories) {
        const nextPath = currentPath != null ? `${currentPath}${sep}${directory}` : directory;
        const nextDirectory = root2.directories[directory];
        walk(nextDirectory, nextPath);
      }
    };
    walk(this);
    return files;
  }
  getOrCreateFile(relativeFilePath) {
    return this.getOrCreateFileRecursive(relativeFilePath.split(sep));
  }
  getOrCreateFileRecursive(pathParts) {
    if (pathParts.length === 1) {
      return this.files[RelativeFilePath.of(pathParts[0])] ??= {};
    }
    const [directory, ...remainingPath] = pathParts;
    if (directory == null) {
      throw new Error(`Internal error; cannot add file with path: ${pathParts}`);
    }
    if (!this.directories[directory]) {
      this.directories[directory] = new _FernDefinitionDirectory();
    }
    return this.directories[directory].getOrCreateFileRecursive(remainingPath);
  }
};

// ../../cli/api-importers/commons/lib/FernDefinitionBuilder.js
var FernDefinitionBuilderImpl = class {
  enableUniqueErrorsPerEndpoint;
  root;
  rootApiFile;
  packageMarkerFile = {};
  basePath = void 0;
  constructor(enableUniqueErrorsPerEndpoint) {
    this.enableUniqueErrorsPerEndpoint = enableUniqueErrorsPerEndpoint;
    this.root = new FernDefinitionDirectory();
    this.rootApiFile = {
      name: "api",
      "error-discrimination": {
        strategy: "status-code"
      }
    };
  }
  setDisplayName({ displayName }) {
    this.rootApiFile["display-name"] = displayName;
  }
  addNavigation({ navigation }) {
    this.packageMarkerFile.navigation = navigation;
  }
  setServiceInfo(file, { auth, "base-path": basePath, "display-name": displayName, docs }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.service == null) {
      fernFile.service = {
        auth: false,
        "base-path": "",
        endpoints: {}
      };
    }
    if (auth != null) {
      fernFile.service.auth = auth;
    }
    if (basePath != null) {
      fernFile.service["base-path"] = basePath;
    }
    if (displayName != null) {
      fernFile.service["display-name"] = displayName;
    }
    if (docs != null) {
      fernFile.docs = docs;
    }
  }
  addAudience(name) {
    if (this.rootApiFile.audiences == null) {
      this.rootApiFile.audiences = [];
    }
    this.rootApiFile.audiences.push(name);
  }
  setAuth(auth) {
    this.rootApiFile.auth = auth;
  }
  addAuthScheme({ name, schema: schema2 }) {
    if (this.rootApiFile["auth-schemes"] == null) {
      this.rootApiFile["auth-schemes"] = {};
    }
    if (this.rootApiFile["auth-schemes"][name] == null) {
      this.rootApiFile["auth-schemes"][name] = schema2;
    }
  }
  setDefaultEnvironment(name) {
    this.rootApiFile["default-environment"] = name;
  }
  setDefaultUrl(name) {
    this.rootApiFile["default-url"] = name;
  }
  setBasePath(basePath) {
    this.basePath = basePath;
  }
  setApiVersion(apiVersionScheme) {
    this.rootApiFile.version = apiVersionScheme;
  }
  getEnvironmentType() {
    const environmentEntry = Object.entries(this.rootApiFile.environments ?? {})[0];
    if (environmentEntry == null) {
      return void 0;
    }
    return visitRawEnvironmentDeclaration(environmentEntry[1], {
      singleBaseUrl: () => "single",
      multipleBaseUrls: () => "multi"
    });
  }
  addEnvironment({ name, schema: schema2 }) {
    if (this.rootApiFile.environments == null) {
      this.rootApiFile.environments = {};
    }
    this.rootApiFile.environments[name] = schema2;
  }
  getGlobalHeaderNames() {
    const headerNames = Object.keys(this.rootApiFile.headers ?? {});
    const maybeVersionHeader = this.getVersionHeader();
    if (maybeVersionHeader != null) {
      headerNames.push(maybeVersionHeader);
    }
    return new Set(headerNames);
  }
  addGlobalHeader({ name, schema: schema2 }) {
    const maybeVersionHeader = this.getVersionHeader();
    if (maybeVersionHeader != null && maybeVersionHeader === name) {
      return;
    }
    if (this.rootApiFile.headers == null) {
      this.rootApiFile.headers = {};
    }
    this.rootApiFile.headers[name] = schema2;
  }
  addIdempotencyHeader({ name, schema: schema2 }) {
    if (this.rootApiFile["idempotency-headers"] == null) {
      this.rootApiFile["idempotency-headers"] = {};
    }
    this.rootApiFile["idempotency-headers"][name] = schema2;
  }
  addVariable({ name, schema: schema2 }) {
    if (this.rootApiFile.variables == null) {
      this.rootApiFile.variables = {};
    }
    this.rootApiFile.variables[name] = schema2;
  }
  addImport({ file, fileToImport, alias }) {
    if (file === fileToImport) {
      return void 0;
    }
    const importPrefix = alias ?? camelCase_default((dirname(fileToImport) + "/" + (0, import_path.basename)(fileToImport, (0, import_path.extname)(fileToImport))).replaceAll("__package__", "root"));
    if (file === RelativeFilePath.of(ROOT_API_FILENAME)) {
      if (this.rootApiFile.imports == null) {
        this.rootApiFile.imports = {};
      }
      this.rootApiFile.imports[importPrefix] = relative(dirname(AbsoluteFilePath.of(`/${file}`)), AbsoluteFilePath.of(`/${fileToImport}`));
      return importPrefix;
    }
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.imports == null) {
      fernFile.imports = {};
    }
    fernFile.imports[importPrefix] = relative(dirname(AbsoluteFilePath.of(`/${file}`)), AbsoluteFilePath.of(`/${fileToImport}`));
    return importPrefix;
  }
  addType(file, { name, schema: schema2 }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.types == null) {
      fernFile.types = {};
    }
    fernFile.types[name] = schema2;
  }
  addTypeExample(file, name, convertedExample) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.types == null) {
      fernFile.types = {};
    }
    const type2 = fernFile.types[name];
    if (type2 != null) {
      if (typeof type2 === "string") {
        fernFile.types[name] = {
          type: type2,
          examples: [convertedExample]
        };
      } else {
        if (type2.examples == null) {
          type2.examples = [];
        }
        type2.examples.push(convertedExample);
      }
    }
  }
  addError(file, { name, schema: schema2 }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.errors == null) {
      fernFile.errors = {};
    }
    if (fernFile.errors[name] == null) {
      fernFile.errors[name] = schema2;
    } else if (fernFile.errors[name]?.type !== schema2.type) {
      fernFile.errors[name] = {
        "status-code": schema2["status-code"],
        type: "unknown"
      };
    }
  }
  addErrorExample(file, { name, example }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.errors == null) {
      return;
    }
    const errorDeclaration = fernFile.errors[name];
    if (errorDeclaration == null) {
      return;
    }
    if (errorDeclaration.examples == null) {
      errorDeclaration.examples = [];
    }
    const alreadyAdded = errorDeclaration.examples.some((existingExample) => {
      return isEqual_default(existingExample, example);
    }) ?? false;
    if (!alreadyAdded) {
      errorDeclaration.examples?.push(example);
    }
  }
  addEndpoint(file, { name, schema: schema2, source }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.service == null) {
      fernFile.service = {
        auth: false,
        "base-path": "",
        endpoints: {}
      };
    }
    if (source != null) {
      fernFile.service.source = source;
    }
    fernFile.service.endpoints[name] = schema2;
  }
  addWebhook(file, { name, schema: schema2 }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.webhooks == null) {
      fernFile.webhooks = {};
    }
    fernFile.webhooks[name] = schema2;
  }
  addChannel(file, { channel }) {
    const fernFile = this.getOrCreateFile(file);
    fernFile.channel = channel;
    const basePath = this.basePath;
    if (basePath != null) {
      fernFile.channel.path = import_path.default.join(basePath, channel.path);
    }
  }
  addChannelExample(file, { example }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.channel == null) {
      fernFile.channel = {
        path: "",
        auth: false
      };
    }
    if (fernFile.channel.messages == null) {
      fernFile.channel.messages = {};
    }
    if (fernFile.channel.examples == null) {
      fernFile.channel.examples = [];
    }
    fernFile.channel.examples.push(example);
  }
  addChannelMessage(file, { messageId, message }) {
    const fernFile = this.getOrCreateFile(file);
    if (fernFile.channel == null) {
      fernFile.channel = {
        path: "",
        auth: false
      };
    }
    if (fernFile.channel.messages == null) {
      fernFile.channel.messages = {};
    }
    fernFile.channel.messages[messageId] = message;
  }
  build() {
    const definitionFiles = this.root.getAllFiles();
    const basePath = this.basePath;
    if (basePath != null) {
      if (this.packageMarkerFile.service != null) {
        this.packageMarkerFile.service = {
          ...this.packageMarkerFile.service,
          endpoints: Object.fromEntries(Object.entries(this.packageMarkerFile.service.endpoints).map(([id, endpoint]) => {
            return [
              id,
              {
                ...endpoint,
                path: import_path.default.join(basePath, endpoint.path)
              }
            ];
          }))
        };
      }
      for (const file of Object.values(definitionFiles)) {
        if (file.service != null) {
          file.service = {
            ...file.service,
            endpoints: Object.fromEntries(Object.entries(file.service.endpoints).map(([id, endpoint]) => {
              return [
                id,
                {
                  ...endpoint,
                  path: import_path.default.join(basePath, endpoint.path)
                }
              ];
            }))
          };
        }
      }
    }
    const definition = {
      rootApiFile: this.rootApiFile,
      packageMarkerFile: this.packageMarkerFile,
      definitionFiles
    };
    return definition;
  }
  getOrCreateFile(file) {
    if (file === FERN_PACKAGE_MARKER_FILENAME) {
      return this.packageMarkerFile;
    } else {
      return this.root.getOrCreateFile(file);
    }
  }
  getVersionHeader() {
    if (this.rootApiFile.version == null) {
      return void 0;
    }
    return typeof this.rootApiFile.version.header === "string" ? this.rootApiFile.version.header : this.rootApiFile.version.header.value;
  }
};

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/OpenApiIrConverterContext.js
var OpenApiIrConverterContext = class {
  logger;
  taskContext;
  ir;
  builder;
  environmentOverrides;
  authOverrides;
  globalHeaderOverrides;
  detectGlobalHeaders;
  objectQueryParameters;
  respectReadonlySchemas;
  onlyIncludeReferencedSchemas;
  inlinePathParameters;
  enableUniqueErrorsPerEndpoint;
  defaultServerName = void 0;
  unknownSchema = /* @__PURE__ */ new Set();
  /**
   * The set of referenced schema ids to include in the generated definition.
   * If this value is undefined, _all_ schemaIds should be treated as referenced,
   * and therefore included in the generated definition.
   */
  referencedSchemaIds;
  /**
   * The current endpoint method being processed. This is used to determine
   * whether certain properties should be included in the generated definition
   * (e.g. readonly properties are excluded for POST/PUT endpoints).
   */
  endpointMethod;
  /**
   * Tracks the state in which a schema is being processed (e.g. endpoint, channel, webhook,
   * request). It's possible that a schema is being processed in multiple states (e.g. an
   * endpoint and a request).
   */
  state = /* @__PURE__ */ new Set();
  constructor({ taskContext, ir, enableUniqueErrorsPerEndpoint, detectGlobalHeaders, environmentOverrides, globalHeaderOverrides, authOverrides, objectQueryParameters, respectReadonlySchemas, onlyIncludeReferencedSchemas, inlinePathParameters }) {
    this.logger = taskContext.logger;
    this.taskContext = taskContext;
    this.ir = ir;
    this.enableUniqueErrorsPerEndpoint = enableUniqueErrorsPerEndpoint;
    this.builder = new FernDefinitionBuilderImpl(enableUniqueErrorsPerEndpoint);
    if (ir.title != null) {
      this.builder.setDisplayName({ displayName: ir.title });
    }
    this.detectGlobalHeaders = detectGlobalHeaders;
    this.environmentOverrides = environmentOverrides;
    this.authOverrides = authOverrides;
    this.globalHeaderOverrides = globalHeaderOverrides;
    this.objectQueryParameters = objectQueryParameters;
    this.respectReadonlySchemas = respectReadonlySchemas;
    this.onlyIncludeReferencedSchemas = onlyIncludeReferencedSchemas;
    this.inlinePathParameters = inlinePathParameters;
    this.referencedSchemaIds = onlyIncludeReferencedSchemas ? /* @__PURE__ */ new Set() : void 0;
    const schemaByStatusCode = {};
    if (!this.enableUniqueErrorsPerEndpoint) {
      for (const endpoint of ir.endpoints) {
        for (const [statusCodeString, error] of Object.entries(endpoint.errors)) {
          const statusCode = parseInt(statusCodeString);
          const existingSchema = schemaByStatusCode[statusCode];
          if (existingSchema == null && error.schema != null) {
            schemaByStatusCode[statusCode] = error.schema;
          } else if (existingSchema != null && error.schema != null && isSchemaEqual(existingSchema, error.schema)) {
          } else {
            this.unknownSchema.add(statusCode);
          }
        }
      }
    }
  }
  getReferencedSchemaIds() {
    if (this.referencedSchemaIds == null) {
      return void 0;
    }
    return Array.from(this.referencedSchemaIds);
  }
  getSchema(id, namespace) {
    if (namespace == null) {
      return this.ir.groupedSchemas.rootSchemas[id];
    }
    return this.ir.groupedSchemas.namespacedSchemas[namespace]?.[id];
  }
  /**
   * Returns the default server URL. This URL should only be set for multi-url cases.
   */
  getDefaultServerName() {
    return this.defaultServerName;
  }
  /**
   * Sets the default server URL. This URL should only be set for multi-url cases.
   */
  setDefaultServerName(name) {
    this.defaultServerName = name;
  }
  /**
   * Is error an unknown schema
   */
  isErrorUnknownSchema(statusCode) {
    return this.unknownSchema.has(statusCode);
  }
  /**
   * Returns the current endpoint method being processed
   */
  getEndpointMethod() {
    return this.endpointMethod;
  }
  /**
   * Sets the current endpoint method being processed
   */
  setEndpointMethod(method) {
    this.endpointMethod = method;
  }
  /**
   * Unsets the current endpoint method being processed
   */
  unsetEndpointMethod() {
    this.endpointMethod = void 0;
  }
  /**
   * Returns whether we're currently processing the given state.
   */
  isInState(state) {
    return this.state.has(state);
  }
  /**
   * Sets that we're currently processing the given state.
   */
  setInState(state) {
    this.state.add(state);
  }
  /**
   * Unsets that we're currently processing the given state.
   */
  unsetInState(state) {
    this.state.delete(state);
  }
  shouldMarkSchemaAsReferenced() {
    return this.onlyIncludeReferencedSchemas && this.isInAnyState(State.Channel, State.Endpoint, State.Webhook);
  }
  /**
   * Marks a schema as referenced.
   */
  markSchemaAsReferenced(schema2, namespace) {
    switch (schema2.type) {
      case "primitive":
        return;
      case "object":
        this.markObjectSchemaAsReferenced(schema2, namespace);
        return;
      case "array":
        this.markSchemaAsReferenced(schema2.value, namespace);
        return;
      case "map":
        this.markSchemaAsReferenced(schema2.value, namespace);
        return;
      case "optional":
        this.markSchemaAsReferenced(schema2.value, namespace);
        return;
      case "reference":
        this.markSchemaIdAsReferenced(schema2.schema, namespace);
        return;
      case "oneOf":
        this.markOneofSchemaAsReferenced(schema2.value, namespace);
        return;
      case "nullable":
        this.markSchemaAsReferenced(schema2.value, namespace);
        return;
      case "enum":
        return;
      case "literal":
        return;
      case "unknown":
        return;
      default:
        assertNever(schema2);
    }
  }
  markObjectSchemaAsReferenced(schema2, namespace) {
    for (const allOf of schema2.allOf) {
      this.markSchemaIdAsReferenced(allOf.schema, namespace);
    }
    for (const property4 of schema2.properties) {
      this.markSchemaAsReferenced(property4.schema, namespace);
    }
  }
  markOneofSchemaAsReferenced(schema2, namespace) {
    switch (schema2.type) {
      case "discriminated":
        for (const oneOf of Object.values(schema2.schemas)) {
          this.markSchemaAsReferenced(oneOf, namespace);
        }
        return;
      case "undisciminated":
        for (const oneOf of schema2.schemas) {
          this.markSchemaAsReferenced(oneOf, namespace);
        }
        return;
      default:
        assertNever(schema2);
    }
  }
  markSchemaIdAsReferenced(id, namespace) {
    if (this.referencedSchemaIds != null && !this.referencedSchemaIds.has(id)) {
      this.referencedSchemaIds.add(id);
      const schema2 = this.getSchema(id, namespace);
      if (schema2 != null) {
        this.markSchemaAsReferenced(schema2, namespace);
      }
    }
  }
  isInAnyState(...states) {
    return states.some((state) => this.isInState(state));
  }
};

// ../../cli/api-importers/openapi/openapi-ir-to-fern/lib/convert.js
function convert(opts) {
  const context = new OpenApiIrConverterContext(opts);
  return buildFernDefinition(context);
}

// ../../../node_modules/.pnpm/js-yaml@4.1.0/node_modules/js-yaml/dist/js-yaml.mjs
function isNothing(subject) {
  return typeof subject === "undefined" || subject === null;
}
function isObject2(subject) {
  return typeof subject === "object" && subject !== null;
}
function toArray(sequence) {
  if (Array.isArray(sequence)) return sequence;
  else if (isNothing(sequence)) return [];
  return [sequence];
}
function extend(target, source) {
  var index, length, key, sourceKeys;
  if (source) {
    sourceKeys = Object.keys(source);
    for (index = 0, length = sourceKeys.length; index < length; index += 1) {
      key = sourceKeys[index];
      target[key] = source[key];
    }
  }
  return target;
}
function repeat(string3, count) {
  var result = "", cycle;
  for (cycle = 0; cycle < count; cycle += 1) {
    result += string3;
  }
  return result;
}
function isNegativeZero(number3) {
  return number3 === 0 && Number.NEGATIVE_INFINITY === 1 / number3;
}
var isNothing_1 = isNothing;
var isObject_1 = isObject2;
var toArray_1 = toArray;
var repeat_1 = repeat;
var isNegativeZero_1 = isNegativeZero;
var extend_1 = extend;
var common = {
  isNothing: isNothing_1,
  isObject: isObject_1,
  toArray: toArray_1,
  repeat: repeat_1,
  isNegativeZero: isNegativeZero_1,
  extend: extend_1
};
function formatError(exception2, compact2) {
  var where = "", message = exception2.reason || "(unknown reason)";
  if (!exception2.mark) return message;
  if (exception2.mark.name) {
    where += 'in "' + exception2.mark.name + '" ';
  }
  where += "(" + (exception2.mark.line + 1) + ":" + (exception2.mark.column + 1) + ")";
  if (!compact2 && exception2.mark.snippet) {
    where += "\n\n" + exception2.mark.snippet;
  }
  return message + " " + where;
}
function YAMLException$1(reason, mark) {
  Error.call(this);
  this.name = "YAMLException";
  this.reason = reason;
  this.mark = mark;
  this.message = formatError(this, false);
  if (Error.captureStackTrace) {
    Error.captureStackTrace(this, this.constructor);
  } else {
    this.stack = new Error().stack || "";
  }
}
YAMLException$1.prototype = Object.create(Error.prototype);
YAMLException$1.prototype.constructor = YAMLException$1;
YAMLException$1.prototype.toString = function toString3(compact2) {
  return this.name + ": " + formatError(this, compact2);
};
var exception = YAMLException$1;
function getLine(buffer, lineStart, lineEnd, position, maxLineLength) {
  var head = "";
  var tail = "";
  var maxHalfLength = Math.floor(maxLineLength / 2) - 1;
  if (position - lineStart > maxHalfLength) {
    head = " ... ";
    lineStart = position - maxHalfLength + head.length;
  }
  if (lineEnd - position > maxHalfLength) {
    tail = " ...";
    lineEnd = position + maxHalfLength - tail.length;
  }
  return {
    str: head + buffer.slice(lineStart, lineEnd).replace(/\t/g, "\u2192") + tail,
    pos: position - lineStart + head.length
    // relative position
  };
}
function padStart(string3, max) {
  return common.repeat(" ", max - string3.length) + string3;
}
function makeSnippet(mark, options) {
  options = Object.create(options || null);
  if (!mark.buffer) return null;
  if (!options.maxLength) options.maxLength = 79;
  if (typeof options.indent !== "number") options.indent = 1;
  if (typeof options.linesBefore !== "number") options.linesBefore = 3;
  if (typeof options.linesAfter !== "number") options.linesAfter = 2;
  var re = /\r?\n|\r|\0/g;
  var lineStarts = [0];
  var lineEnds = [];
  var match;
  var foundLineNo = -1;
  while (match = re.exec(mark.buffer)) {
    lineEnds.push(match.index);
    lineStarts.push(match.index + match[0].length);
    if (mark.position <= match.index && foundLineNo < 0) {
      foundLineNo = lineStarts.length - 2;
    }
  }
  if (foundLineNo < 0) foundLineNo = lineStarts.length - 1;
  var result = "", i, line;
  var lineNoLength = Math.min(mark.line + options.linesAfter, lineEnds.length).toString().length;
  var maxLineLength = options.maxLength - (options.indent + lineNoLength + 3);
  for (i = 1; i <= options.linesBefore; i++) {
    if (foundLineNo - i < 0) break;
    line = getLine(
      mark.buffer,
      lineStarts[foundLineNo - i],
      lineEnds[foundLineNo - i],
      mark.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo - i]),
      maxLineLength
    );
    result = common.repeat(" ", options.indent) + padStart((mark.line - i + 1).toString(), lineNoLength) + " | " + line.str + "\n" + result;
  }
  line = getLine(mark.buffer, lineStarts[foundLineNo], lineEnds[foundLineNo], mark.position, maxLineLength);
  result += common.repeat(" ", options.indent) + padStart((mark.line + 1).toString(), lineNoLength) + " | " + line.str + "\n";
  result += common.repeat("-", options.indent + lineNoLength + 3 + line.pos) + "^\n";
  for (i = 1; i <= options.linesAfter; i++) {
    if (foundLineNo + i >= lineEnds.length) break;
    line = getLine(
      mark.buffer,
      lineStarts[foundLineNo + i],
      lineEnds[foundLineNo + i],
      mark.position - (lineStarts[foundLineNo] - lineStarts[foundLineNo + i]),
      maxLineLength
    );
    result += common.repeat(" ", options.indent) + padStart((mark.line + i + 1).toString(), lineNoLength) + " | " + line.str + "\n";
  }
  return result.replace(/\n$/, "");
}
var snippet = makeSnippet;
var TYPE_CONSTRUCTOR_OPTIONS = [
  "kind",
  "multi",
  "resolve",
  "construct",
  "instanceOf",
  "predicate",
  "represent",
  "representName",
  "defaultStyle",
  "styleAliases"
];
var YAML_NODE_KINDS = [
  "scalar",
  "sequence",
  "mapping"
];
function compileStyleAliases(map2) {
  var result = {};
  if (map2 !== null) {
    Object.keys(map2).forEach(function (style) {
      map2[style].forEach(function (alias) {
        result[String(alias)] = style;
      });
    });
  }
  return result;
}
function Type$1(tag, options) {
  options = options || {};
  Object.keys(options).forEach(function (name) {
    if (TYPE_CONSTRUCTOR_OPTIONS.indexOf(name) === -1) {
      throw new exception('Unknown option "' + name + '" is met in definition of "' + tag + '" YAML type.');
    }
  });
  this.options = options;
  this.tag = tag;
  this.kind = options["kind"] || null;
  this.resolve = options["resolve"] || function () {
    return true;
  };
  this.construct = options["construct"] || function (data) {
    return data;
  };
  this.instanceOf = options["instanceOf"] || null;
  this.predicate = options["predicate"] || null;
  this.represent = options["represent"] || null;
  this.representName = options["representName"] || null;
  this.defaultStyle = options["defaultStyle"] || null;
  this.multi = options["multi"] || false;
  this.styleAliases = compileStyleAliases(options["styleAliases"] || null);
  if (YAML_NODE_KINDS.indexOf(this.kind) === -1) {
    throw new exception('Unknown kind "' + this.kind + '" is specified for "' + tag + '" YAML type.');
  }
}
var type = Type$1;
function compileList(schema2, name) {
  var result = [];
  schema2[name].forEach(function (currentType) {
    var newIndex = result.length;
    result.forEach(function (previousType, previousIndex) {
      if (previousType.tag === currentType.tag && previousType.kind === currentType.kind && previousType.multi === currentType.multi) {
        newIndex = previousIndex;
      }
    });
    result[newIndex] = currentType;
  });
  return result;
}
function compileMap() {
  var result = {
    scalar: {},
    sequence: {},
    mapping: {},
    fallback: {},
    multi: {
      scalar: [],
      sequence: [],
      mapping: [],
      fallback: []
    }
  }, index, length;
  function collectType(type2) {
    if (type2.multi) {
      result.multi[type2.kind].push(type2);
      result.multi["fallback"].push(type2);
    } else {
      result[type2.kind][type2.tag] = result["fallback"][type2.tag] = type2;
    }
  }
  for (index = 0, length = arguments.length; index < length; index += 1) {
    arguments[index].forEach(collectType);
  }
  return result;
}
function Schema$1(definition) {
  return this.extend(definition);
}
Schema$1.prototype.extend = function extend2(definition) {
  var implicit = [];
  var explicit = [];
  if (definition instanceof type) {
    explicit.push(definition);
  } else if (Array.isArray(definition)) {
    explicit = explicit.concat(definition);
  } else if (definition && (Array.isArray(definition.implicit) || Array.isArray(definition.explicit))) {
    if (definition.implicit) implicit = implicit.concat(definition.implicit);
    if (definition.explicit) explicit = explicit.concat(definition.explicit);
  } else {
    throw new exception("Schema.extend argument should be a Type, [ Type ], or a schema definition ({ implicit: [...], explicit: [...] })");
  }
  implicit.forEach(function (type$1) {
    if (!(type$1 instanceof type)) {
      throw new exception("Specified list of YAML types (or a single Type object) contains a non-Type object.");
    }
    if (type$1.loadKind && type$1.loadKind !== "scalar") {
      throw new exception("There is a non-scalar type in the implicit list of a schema. Implicit resolving of such types is not supported.");
    }
    if (type$1.multi) {
      throw new exception("There is a multi type in the implicit list of a schema. Multi tags can only be listed as explicit.");
    }
  });
  explicit.forEach(function (type$1) {
    if (!(type$1 instanceof type)) {
      throw new exception("Specified list of YAML types (or a single Type object) contains a non-Type object.");
    }
  });
  var result = Object.create(Schema$1.prototype);
  result.implicit = (this.implicit || []).concat(implicit);
  result.explicit = (this.explicit || []).concat(explicit);
  result.compiledImplicit = compileList(result, "implicit");
  result.compiledExplicit = compileList(result, "explicit");
  result.compiledTypeMap = compileMap(result.compiledImplicit, result.compiledExplicit);
  return result;
};
var schema = Schema$1;
var str = new type("tag:yaml.org,2002:str", {
  kind: "scalar",
  construct: function (data) {
    return data !== null ? data : "";
  }
});
var seq = new type("tag:yaml.org,2002:seq", {
  kind: "sequence",
  construct: function (data) {
    return data !== null ? data : [];
  }
});
var map = new type("tag:yaml.org,2002:map", {
  kind: "mapping",
  construct: function (data) {
    return data !== null ? data : {};
  }
});
var failsafe = new schema({
  explicit: [
    str,
    seq,
    map
  ]
});
function resolveYamlNull(data) {
  if (data === null) return true;
  var max = data.length;
  return max === 1 && data === "~" || max === 4 && (data === "null" || data === "Null" || data === "NULL");
}
function constructYamlNull() {
  return null;
}
function isNull2(object3) {
  return object3 === null;
}
var _null = new type("tag:yaml.org,2002:null", {
  kind: "scalar",
  resolve: resolveYamlNull,
  construct: constructYamlNull,
  predicate: isNull2,
  represent: {
    canonical: function () {
      return "~";
    },
    lowercase: function () {
      return "null";
    },
    uppercase: function () {
      return "NULL";
    },
    camelcase: function () {
      return "Null";
    },
    empty: function () {
      return "";
    }
  },
  defaultStyle: "lowercase"
});
function resolveYamlBoolean(data) {
  if (data === null) return false;
  var max = data.length;
  return max === 4 && (data === "true" || data === "True" || data === "TRUE") || max === 5 && (data === "false" || data === "False" || data === "FALSE");
}
function constructYamlBoolean(data) {
  return data === "true" || data === "True" || data === "TRUE";
}
function isBoolean(object3) {
  return Object.prototype.toString.call(object3) === "[object Boolean]";
}
var bool = new type("tag:yaml.org,2002:bool", {
  kind: "scalar",
  resolve: resolveYamlBoolean,
  construct: constructYamlBoolean,
  predicate: isBoolean,
  represent: {
    lowercase: function (object3) {
      return object3 ? "true" : "false";
    },
    uppercase: function (object3) {
      return object3 ? "TRUE" : "FALSE";
    },
    camelcase: function (object3) {
      return object3 ? "True" : "False";
    }
  },
  defaultStyle: "lowercase"
});
function isHexCode(c) {
  return 48 <= c && c <= 57 || 65 <= c && c <= 70 || 97 <= c && c <= 102;
}
function isOctCode(c) {
  return 48 <= c && c <= 55;
}
function isDecCode(c) {
  return 48 <= c && c <= 57;
}
function resolveYamlInteger(data) {
  if (data === null) return false;
  var max = data.length, index = 0, hasDigits = false, ch;
  if (!max) return false;
  ch = data[index];
  if (ch === "-" || ch === "+") {
    ch = data[++index];
  }
  if (ch === "0") {
    if (index + 1 === max) return true;
    ch = data[++index];
    if (ch === "b") {
      index++;
      for (; index < max; index++) {
        ch = data[index];
        if (ch === "_") continue;
        if (ch !== "0" && ch !== "1") return false;
        hasDigits = true;
      }
      return hasDigits && ch !== "_";
    }
    if (ch === "x") {
      index++;
      for (; index < max; index++) {
        ch = data[index];
        if (ch === "_") continue;
        if (!isHexCode(data.charCodeAt(index))) return false;
        hasDigits = true;
      }
      return hasDigits && ch !== "_";
    }
    if (ch === "o") {
      index++;
      for (; index < max; index++) {
        ch = data[index];
        if (ch === "_") continue;
        if (!isOctCode(data.charCodeAt(index))) return false;
        hasDigits = true;
      }
      return hasDigits && ch !== "_";
    }
  }
  if (ch === "_") return false;
  for (; index < max; index++) {
    ch = data[index];
    if (ch === "_") continue;
    if (!isDecCode(data.charCodeAt(index))) {
      return false;
    }
    hasDigits = true;
  }
  if (!hasDigits || ch === "_") return false;
  return true;
}
function constructYamlInteger(data) {
  var value = data, sign = 1, ch;
  if (value.indexOf("_") !== -1) {
    value = value.replace(/_/g, "");
  }
  ch = value[0];
  if (ch === "-" || ch === "+") {
    if (ch === "-") sign = -1;
    value = value.slice(1);
    ch = value[0];
  }
  if (value === "0") return 0;
  if (ch === "0") {
    if (value[1] === "b") return sign * parseInt(value.slice(2), 2);
    if (value[1] === "x") return sign * parseInt(value.slice(2), 16);
    if (value[1] === "o") return sign * parseInt(value.slice(2), 8);
  }
  return sign * parseInt(value, 10);
}
function isInteger(object3) {
  return Object.prototype.toString.call(object3) === "[object Number]" && (object3 % 1 === 0 && !common.isNegativeZero(object3));
}
var int = new type("tag:yaml.org,2002:int", {
  kind: "scalar",
  resolve: resolveYamlInteger,
  construct: constructYamlInteger,
  predicate: isInteger,
  represent: {
    binary: function (obj) {
      return obj >= 0 ? "0b" + obj.toString(2) : "-0b" + obj.toString(2).slice(1);
    },
    octal: function (obj) {
      return obj >= 0 ? "0o" + obj.toString(8) : "-0o" + obj.toString(8).slice(1);
    },
    decimal: function (obj) {
      return obj.toString(10);
    },
    /* eslint-disable max-len */
    hexadecimal: function (obj) {
      return obj >= 0 ? "0x" + obj.toString(16).toUpperCase() : "-0x" + obj.toString(16).toUpperCase().slice(1);
    }
  },
  defaultStyle: "decimal",
  styleAliases: {
    binary: [2, "bin"],
    octal: [8, "oct"],
    decimal: [10, "dec"],
    hexadecimal: [16, "hex"]
  }
});
var YAML_FLOAT_PATTERN = new RegExp(
  // 2.5e4, 2.5 and integers
  "^(?:[-+]?(?:[0-9][0-9_]*)(?:\\.[0-9_]*)?(?:[eE][-+]?[0-9]+)?|\\.[0-9_]+(?:[eE][-+]?[0-9]+)?|[-+]?\\.(?:inf|Inf|INF)|\\.(?:nan|NaN|NAN))$"
);
function resolveYamlFloat(data) {
  if (data === null) return false;
  if (!YAML_FLOAT_PATTERN.test(data) || // Quick hack to not allow integers end with `_`
    // Probably should update regexp & check speed
    data[data.length - 1] === "_") {
    return false;
  }
  return true;
}
function constructYamlFloat(data) {
  var value, sign;
  value = data.replace(/_/g, "").toLowerCase();
  sign = value[0] === "-" ? -1 : 1;
  if ("+-".indexOf(value[0]) >= 0) {
    value = value.slice(1);
  }
  if (value === ".inf") {
    return sign === 1 ? Number.POSITIVE_INFINITY : Number.NEGATIVE_INFINITY;
  } else if (value === ".nan") {
    return NaN;
  }
  return sign * parseFloat(value, 10);
}
var SCIENTIFIC_WITHOUT_DOT = /^[-+]?[0-9]+e/;
function representYamlFloat(object3, style) {
  var res;
  if (isNaN(object3)) {
    switch (style) {
      case "lowercase":
        return ".nan";
      case "uppercase":
        return ".NAN";
      case "camelcase":
        return ".NaN";
    }
  } else if (Number.POSITIVE_INFINITY === object3) {
    switch (style) {
      case "lowercase":
        return ".inf";
      case "uppercase":
        return ".INF";
      case "camelcase":
        return ".Inf";
    }
  } else if (Number.NEGATIVE_INFINITY === object3) {
    switch (style) {
      case "lowercase":
        return "-.inf";
      case "uppercase":
        return "-.INF";
      case "camelcase":
        return "-.Inf";
    }
  } else if (common.isNegativeZero(object3)) {
    return "-0.0";
  }
  res = object3.toString(10);
  return SCIENTIFIC_WITHOUT_DOT.test(res) ? res.replace("e", ".e") : res;
}
function isFloat(object3) {
  return Object.prototype.toString.call(object3) === "[object Number]" && (object3 % 1 !== 0 || common.isNegativeZero(object3));
}
var float = new type("tag:yaml.org,2002:float", {
  kind: "scalar",
  resolve: resolveYamlFloat,
  construct: constructYamlFloat,
  predicate: isFloat,
  represent: representYamlFloat,
  defaultStyle: "lowercase"
});
var json = failsafe.extend({
  implicit: [
    _null,
    bool,
    int,
    float
  ]
});
var core = json;
var YAML_DATE_REGEXP = new RegExp(
  "^([0-9][0-9][0-9][0-9])-([0-9][0-9])-([0-9][0-9])$"
);
var YAML_TIMESTAMP_REGEXP = new RegExp(
  "^([0-9][0-9][0-9][0-9])-([0-9][0-9]?)-([0-9][0-9]?)(?:[Tt]|[ \\t]+)([0-9][0-9]?):([0-9][0-9]):([0-9][0-9])(?:\\.([0-9]*))?(?:[ \\t]*(Z|([-+])([0-9][0-9]?)(?::([0-9][0-9]))?))?$"
);
function resolveYamlTimestamp(data) {
  if (data === null) return false;
  if (YAML_DATE_REGEXP.exec(data) !== null) return true;
  if (YAML_TIMESTAMP_REGEXP.exec(data) !== null) return true;
  return false;
}
function constructYamlTimestamp(data) {
  var match, year, month, day, hour, minute, second, fraction = 0, delta = null, tz_hour, tz_minute, date3;
  match = YAML_DATE_REGEXP.exec(data);
  if (match === null) match = YAML_TIMESTAMP_REGEXP.exec(data);
  if (match === null) throw new Error("Date resolve error");
  year = +match[1];
  month = +match[2] - 1;
  day = +match[3];
  if (!match[4]) {
    return new Date(Date.UTC(year, month, day));
  }
  hour = +match[4];
  minute = +match[5];
  second = +match[6];
  if (match[7]) {
    fraction = match[7].slice(0, 3);
    while (fraction.length < 3) {
      fraction += "0";
    }
    fraction = +fraction;
  }
  if (match[9]) {
    tz_hour = +match[10];
    tz_minute = +(match[11] || 0);
    delta = (tz_hour * 60 + tz_minute) * 6e4;
    if (match[9] === "-") delta = -delta;
  }
  date3 = new Date(Date.UTC(year, month, day, hour, minute, second, fraction));
  if (delta) date3.setTime(date3.getTime() - delta);
  return date3;
}
function representYamlTimestamp(object3) {
  return object3.toISOString();
}
var timestamp = new type("tag:yaml.org,2002:timestamp", {
  kind: "scalar",
  resolve: resolveYamlTimestamp,
  construct: constructYamlTimestamp,
  instanceOf: Date,
  represent: representYamlTimestamp
});
function resolveYamlMerge(data) {
  return data === "<<" || data === null;
}
var merge = new type("tag:yaml.org,2002:merge", {
  kind: "scalar",
  resolve: resolveYamlMerge
});
var BASE64_MAP = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=\n\r";
function resolveYamlBinary(data) {
  if (data === null) return false;
  var code, idx, bitlen = 0, max = data.length, map2 = BASE64_MAP;
  for (idx = 0; idx < max; idx++) {
    code = map2.indexOf(data.charAt(idx));
    if (code > 64) continue;
    if (code < 0) return false;
    bitlen += 6;
  }
  return bitlen % 8 === 0;
}
function constructYamlBinary(data) {
  var idx, tailbits, input = data.replace(/[\r\n=]/g, ""), max = input.length, map2 = BASE64_MAP, bits = 0, result = [];
  for (idx = 0; idx < max; idx++) {
    if (idx % 4 === 0 && idx) {
      result.push(bits >> 16 & 255);
      result.push(bits >> 8 & 255);
      result.push(bits & 255);
    }
    bits = bits << 6 | map2.indexOf(input.charAt(idx));
  }
  tailbits = max % 4 * 6;
  if (tailbits === 0) {
    result.push(bits >> 16 & 255);
    result.push(bits >> 8 & 255);
    result.push(bits & 255);
  } else if (tailbits === 18) {
    result.push(bits >> 10 & 255);
    result.push(bits >> 2 & 255);
  } else if (tailbits === 12) {
    result.push(bits >> 4 & 255);
  }
  return new Uint8Array(result);
}
function representYamlBinary(object3) {
  var result = "", bits = 0, idx, tail, max = object3.length, map2 = BASE64_MAP;
  for (idx = 0; idx < max; idx++) {
    if (idx % 3 === 0 && idx) {
      result += map2[bits >> 18 & 63];
      result += map2[bits >> 12 & 63];
      result += map2[bits >> 6 & 63];
      result += map2[bits & 63];
    }
    bits = (bits << 8) + object3[idx];
  }
  tail = max % 3;
  if (tail === 0) {
    result += map2[bits >> 18 & 63];
    result += map2[bits >> 12 & 63];
    result += map2[bits >> 6 & 63];
    result += map2[bits & 63];
  } else if (tail === 2) {
    result += map2[bits >> 10 & 63];
    result += map2[bits >> 4 & 63];
    result += map2[bits << 2 & 63];
    result += map2[64];
  } else if (tail === 1) {
    result += map2[bits >> 2 & 63];
    result += map2[bits << 4 & 63];
    result += map2[64];
    result += map2[64];
  }
  return result;
}
function isBinary(obj) {
  return Object.prototype.toString.call(obj) === "[object Uint8Array]";
}
var binary = new type("tag:yaml.org,2002:binary", {
  kind: "scalar",
  resolve: resolveYamlBinary,
  construct: constructYamlBinary,
  predicate: isBinary,
  represent: representYamlBinary
});
var _hasOwnProperty$3 = Object.prototype.hasOwnProperty;
var _toString$2 = Object.prototype.toString;
function resolveYamlOmap(data) {
  if (data === null) return true;
  var objectKeys = [], index, length, pair, pairKey, pairHasKey, object3 = data;
  for (index = 0, length = object3.length; index < length; index += 1) {
    pair = object3[index];
    pairHasKey = false;
    if (_toString$2.call(pair) !== "[object Object]") return false;
    for (pairKey in pair) {
      if (_hasOwnProperty$3.call(pair, pairKey)) {
        if (!pairHasKey) pairHasKey = true;
        else return false;
      }
    }
    if (!pairHasKey) return false;
    if (objectKeys.indexOf(pairKey) === -1) objectKeys.push(pairKey);
    else return false;
  }
  return true;
}
function constructYamlOmap(data) {
  return data !== null ? data : [];
}
var omap = new type("tag:yaml.org,2002:omap", {
  kind: "sequence",
  resolve: resolveYamlOmap,
  construct: constructYamlOmap
});
var _toString$1 = Object.prototype.toString;
function resolveYamlPairs(data) {
  if (data === null) return true;
  var index, length, pair, keys5, result, object3 = data;
  result = new Array(object3.length);
  for (index = 0, length = object3.length; index < length; index += 1) {
    pair = object3[index];
    if (_toString$1.call(pair) !== "[object Object]") return false;
    keys5 = Object.keys(pair);
    if (keys5.length !== 1) return false;
    result[index] = [keys5[0], pair[keys5[0]]];
  }
  return true;
}
function constructYamlPairs(data) {
  if (data === null) return [];
  var index, length, pair, keys5, result, object3 = data;
  result = new Array(object3.length);
  for (index = 0, length = object3.length; index < length; index += 1) {
    pair = object3[index];
    keys5 = Object.keys(pair);
    result[index] = [keys5[0], pair[keys5[0]]];
  }
  return result;
}
var pairs = new type("tag:yaml.org,2002:pairs", {
  kind: "sequence",
  resolve: resolveYamlPairs,
  construct: constructYamlPairs
});
var _hasOwnProperty$2 = Object.prototype.hasOwnProperty;
function resolveYamlSet(data) {
  if (data === null) return true;
  var key, object3 = data;
  for (key in object3) {
    if (_hasOwnProperty$2.call(object3, key)) {
      if (object3[key] !== null) return false;
    }
  }
  return true;
}
function constructYamlSet(data) {
  return data !== null ? data : {};
}
var set3 = new type("tag:yaml.org,2002:set", {
  kind: "mapping",
  resolve: resolveYamlSet,
  construct: constructYamlSet
});
var _default = core.extend({
  implicit: [
    timestamp,
    merge
  ],
  explicit: [
    binary,
    omap,
    pairs,
    set3
  ]
});
var _hasOwnProperty$1 = Object.prototype.hasOwnProperty;
var CONTEXT_FLOW_IN = 1;
var CONTEXT_FLOW_OUT = 2;
var CONTEXT_BLOCK_IN = 3;
var CONTEXT_BLOCK_OUT = 4;
var CHOMPING_CLIP = 1;
var CHOMPING_STRIP = 2;
var CHOMPING_KEEP = 3;
var PATTERN_NON_PRINTABLE = /[\x00-\x08\x0B\x0C\x0E-\x1F\x7F-\x84\x86-\x9F\uFFFE\uFFFF]|[\uD800-\uDBFF](?![\uDC00-\uDFFF])|(?:[^\uD800-\uDBFF]|^)[\uDC00-\uDFFF]/;
var PATTERN_NON_ASCII_LINE_BREAKS = /[\x85\u2028\u2029]/;
var PATTERN_FLOW_INDICATORS = /[,\[\]\{\}]/;
var PATTERN_TAG_HANDLE = /^(?:!|!!|![a-z\-]+!)$/i;
var PATTERN_TAG_URI = /^(?:!|[^,\[\]\{\}])(?:%[0-9a-f]{2}|[0-9a-z\-#;\/\?:@&=\+\$,_\.!~\*'\(\)\[\]])*$/i;
function _class(obj) {
  return Object.prototype.toString.call(obj);
}
function is_EOL(c) {
  return c === 10 || c === 13;
}
function is_WHITE_SPACE(c) {
  return c === 9 || c === 32;
}
function is_WS_OR_EOL(c) {
  return c === 9 || c === 32 || c === 10 || c === 13;
}
function is_FLOW_INDICATOR(c) {
  return c === 44 || c === 91 || c === 93 || c === 123 || c === 125;
}
function fromHexCode(c) {
  var lc;
  if (48 <= c && c <= 57) {
    return c - 48;
  }
  lc = c | 32;
  if (97 <= lc && lc <= 102) {
    return lc - 97 + 10;
  }
  return -1;
}
function escapedHexLen(c) {
  if (c === 120) {
    return 2;
  }
  if (c === 117) {
    return 4;
  }
  if (c === 85) {
    return 8;
  }
  return 0;
}
function fromDecimalCode(c) {
  if (48 <= c && c <= 57) {
    return c - 48;
  }
  return -1;
}
function simpleEscapeSequence(c) {
  return c === 48 ? "\0" : c === 97 ? "\x07" : c === 98 ? "\b" : c === 116 ? "	" : c === 9 ? "	" : c === 110 ? "\n" : c === 118 ? "\v" : c === 102 ? "\f" : c === 114 ? "\r" : c === 101 ? "\x1B" : c === 32 ? " " : c === 34 ? '"' : c === 47 ? "/" : c === 92 ? "\\" : c === 78 ? "\x85" : c === 95 ? "\xA0" : c === 76 ? "\u2028" : c === 80 ? "\u2029" : "";
}
function charFromCodepoint(c) {
  if (c <= 65535) {
    return String.fromCharCode(c);
  }
  return String.fromCharCode(
    (c - 65536 >> 10) + 55296,
    (c - 65536 & 1023) + 56320
  );
}
var simpleEscapeCheck = new Array(256);
var simpleEscapeMap = new Array(256);
for (i = 0; i < 256; i++) {
  simpleEscapeCheck[i] = simpleEscapeSequence(i) ? 1 : 0;
  simpleEscapeMap[i] = simpleEscapeSequence(i);
}
var i;
function State$1(input, options) {
  this.input = input;
  this.filename = options["filename"] || null;
  this.schema = options["schema"] || _default;
  this.onWarning = options["onWarning"] || null;
  this.legacy = options["legacy"] || false;
  this.json = options["json"] || false;
  this.listener = options["listener"] || null;
  this.implicitTypes = this.schema.compiledImplicit;
  this.typeMap = this.schema.compiledTypeMap;
  this.length = input.length;
  this.position = 0;
  this.line = 0;
  this.lineStart = 0;
  this.lineIndent = 0;
  this.firstTabInLine = -1;
  this.documents = [];
}
function generateError(state, message) {
  var mark = {
    name: state.filename,
    buffer: state.input.slice(0, -1),
    // omit trailing \0
    position: state.position,
    line: state.line,
    column: state.position - state.lineStart
  };
  mark.snippet = snippet(mark);
  return new exception(message, mark);
}
function throwError(state, message) {
  throw generateError(state, message);
}
function throwWarning(state, message) {
  if (state.onWarning) {
    state.onWarning.call(null, generateError(state, message));
  }
}
var directiveHandlers = {
  YAML: function handleYamlDirective(state, name, args) {
    var match, major, minor;
    if (state.version !== null) {
      throwError(state, "duplication of %YAML directive");
    }
    if (args.length !== 1) {
      throwError(state, "YAML directive accepts exactly one argument");
    }
    match = /^([0-9]+)\.([0-9]+)$/.exec(args[0]);
    if (match === null) {
      throwError(state, "ill-formed argument of the YAML directive");
    }
    major = parseInt(match[1], 10);
    minor = parseInt(match[2], 10);
    if (major !== 1) {
      throwError(state, "unacceptable YAML version of the document");
    }
    state.version = args[0];
    state.checkLineBreaks = minor < 2;
    if (minor !== 1 && minor !== 2) {
      throwWarning(state, "unsupported YAML version of the document");
    }
  },
  TAG: function handleTagDirective(state, name, args) {
    var handle, prefix;
    if (args.length !== 2) {
      throwError(state, "TAG directive accepts exactly two arguments");
    }
    handle = args[0];
    prefix = args[1];
    if (!PATTERN_TAG_HANDLE.test(handle)) {
      throwError(state, "ill-formed tag handle (first argument) of the TAG directive");
    }
    if (_hasOwnProperty$1.call(state.tagMap, handle)) {
      throwError(state, 'there is a previously declared suffix for "' + handle + '" tag handle');
    }
    if (!PATTERN_TAG_URI.test(prefix)) {
      throwError(state, "ill-formed tag prefix (second argument) of the TAG directive");
    }
    try {
      prefix = decodeURIComponent(prefix);
    } catch (err) {
      throwError(state, "tag prefix is malformed: " + prefix);
    }
    state.tagMap[handle] = prefix;
  }
};
function captureSegment(state, start, end, checkJson) {
  var _position, _length, _character, _result;
  if (start < end) {
    _result = state.input.slice(start, end);
    if (checkJson) {
      for (_position = 0, _length = _result.length; _position < _length; _position += 1) {
        _character = _result.charCodeAt(_position);
        if (!(_character === 9 || 32 <= _character && _character <= 1114111)) {
          throwError(state, "expected valid JSON character");
        }
      }
    } else if (PATTERN_NON_PRINTABLE.test(_result)) {
      throwError(state, "the stream contains non-printable characters");
    }
    state.result += _result;
  }
}
function mergeMappings(state, destination, source, overridableKeys) {
  var sourceKeys, key, index, quantity;
  if (!common.isObject(source)) {
    throwError(state, "cannot merge mappings; the provided source object is unacceptable");
  }
  sourceKeys = Object.keys(source);
  for (index = 0, quantity = sourceKeys.length; index < quantity; index += 1) {
    key = sourceKeys[index];
    if (!_hasOwnProperty$1.call(destination, key)) {
      destination[key] = source[key];
      overridableKeys[key] = true;
    }
  }
}
function storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, startLine, startLineStart, startPos) {
  var index, quantity;
  if (Array.isArray(keyNode)) {
    keyNode = Array.prototype.slice.call(keyNode);
    for (index = 0, quantity = keyNode.length; index < quantity; index += 1) {
      if (Array.isArray(keyNode[index])) {
        throwError(state, "nested arrays are not supported inside keys");
      }
      if (typeof keyNode === "object" && _class(keyNode[index]) === "[object Object]") {
        keyNode[index] = "[object Object]";
      }
    }
  }
  if (typeof keyNode === "object" && _class(keyNode) === "[object Object]") {
    keyNode = "[object Object]";
  }
  keyNode = String(keyNode);
  if (_result === null) {
    _result = {};
  }
  if (keyTag === "tag:yaml.org,2002:merge") {
    if (Array.isArray(valueNode)) {
      for (index = 0, quantity = valueNode.length; index < quantity; index += 1) {
        mergeMappings(state, _result, valueNode[index], overridableKeys);
      }
    } else {
      mergeMappings(state, _result, valueNode, overridableKeys);
    }
  } else {
    if (!state.json && !_hasOwnProperty$1.call(overridableKeys, keyNode) && _hasOwnProperty$1.call(_result, keyNode)) {
      state.line = startLine || state.line;
      state.lineStart = startLineStart || state.lineStart;
      state.position = startPos || state.position;
      throwError(state, "duplicated mapping key");
    }
    if (keyNode === "__proto__") {
      Object.defineProperty(_result, keyNode, {
        configurable: true,
        enumerable: true,
        writable: true,
        value: valueNode
      });
    } else {
      _result[keyNode] = valueNode;
    }
    delete overridableKeys[keyNode];
  }
  return _result;
}
function readLineBreak(state) {
  var ch;
  ch = state.input.charCodeAt(state.position);
  if (ch === 10) {
    state.position++;
  } else if (ch === 13) {
    state.position++;
    if (state.input.charCodeAt(state.position) === 10) {
      state.position++;
    }
  } else {
    throwError(state, "a line break is expected");
  }
  state.line += 1;
  state.lineStart = state.position;
  state.firstTabInLine = -1;
}
function skipSeparationSpace(state, allowComments, checkIndent) {
  var lineBreaks = 0, ch = state.input.charCodeAt(state.position);
  while (ch !== 0) {
    while (is_WHITE_SPACE(ch)) {
      if (ch === 9 && state.firstTabInLine === -1) {
        state.firstTabInLine = state.position;
      }
      ch = state.input.charCodeAt(++state.position);
    }
    if (allowComments && ch === 35) {
      do {
        ch = state.input.charCodeAt(++state.position);
      } while (ch !== 10 && ch !== 13 && ch !== 0);
    }
    if (is_EOL(ch)) {
      readLineBreak(state);
      ch = state.input.charCodeAt(state.position);
      lineBreaks++;
      state.lineIndent = 0;
      while (ch === 32) {
        state.lineIndent++;
        ch = state.input.charCodeAt(++state.position);
      }
    } else {
      break;
    }
  }
  if (checkIndent !== -1 && lineBreaks !== 0 && state.lineIndent < checkIndent) {
    throwWarning(state, "deficient indentation");
  }
  return lineBreaks;
}
function testDocumentSeparator(state) {
  var _position = state.position, ch;
  ch = state.input.charCodeAt(_position);
  if ((ch === 45 || ch === 46) && ch === state.input.charCodeAt(_position + 1) && ch === state.input.charCodeAt(_position + 2)) {
    _position += 3;
    ch = state.input.charCodeAt(_position);
    if (ch === 0 || is_WS_OR_EOL(ch)) {
      return true;
    }
  }
  return false;
}
function writeFoldedLines(state, count) {
  if (count === 1) {
    state.result += " ";
  } else if (count > 1) {
    state.result += common.repeat("\n", count - 1);
  }
}
function readPlainScalar(state, nodeIndent, withinFlowCollection) {
  var preceding, following, captureStart, captureEnd, hasPendingContent, _line, _lineStart, _lineIndent, _kind = state.kind, _result = state.result, ch;
  ch = state.input.charCodeAt(state.position);
  if (is_WS_OR_EOL(ch) || is_FLOW_INDICATOR(ch) || ch === 35 || ch === 38 || ch === 42 || ch === 33 || ch === 124 || ch === 62 || ch === 39 || ch === 34 || ch === 37 || ch === 64 || ch === 96) {
    return false;
  }
  if (ch === 63 || ch === 45) {
    following = state.input.charCodeAt(state.position + 1);
    if (is_WS_OR_EOL(following) || withinFlowCollection && is_FLOW_INDICATOR(following)) {
      return false;
    }
  }
  state.kind = "scalar";
  state.result = "";
  captureStart = captureEnd = state.position;
  hasPendingContent = false;
  while (ch !== 0) {
    if (ch === 58) {
      following = state.input.charCodeAt(state.position + 1);
      if (is_WS_OR_EOL(following) || withinFlowCollection && is_FLOW_INDICATOR(following)) {
        break;
      }
    } else if (ch === 35) {
      preceding = state.input.charCodeAt(state.position - 1);
      if (is_WS_OR_EOL(preceding)) {
        break;
      }
    } else if (state.position === state.lineStart && testDocumentSeparator(state) || withinFlowCollection && is_FLOW_INDICATOR(ch)) {
      break;
    } else if (is_EOL(ch)) {
      _line = state.line;
      _lineStart = state.lineStart;
      _lineIndent = state.lineIndent;
      skipSeparationSpace(state, false, -1);
      if (state.lineIndent >= nodeIndent) {
        hasPendingContent = true;
        ch = state.input.charCodeAt(state.position);
        continue;
      } else {
        state.position = captureEnd;
        state.line = _line;
        state.lineStart = _lineStart;
        state.lineIndent = _lineIndent;
        break;
      }
    }
    if (hasPendingContent) {
      captureSegment(state, captureStart, captureEnd, false);
      writeFoldedLines(state, state.line - _line);
      captureStart = captureEnd = state.position;
      hasPendingContent = false;
    }
    if (!is_WHITE_SPACE(ch)) {
      captureEnd = state.position + 1;
    }
    ch = state.input.charCodeAt(++state.position);
  }
  captureSegment(state, captureStart, captureEnd, false);
  if (state.result) {
    return true;
  }
  state.kind = _kind;
  state.result = _result;
  return false;
}
function readSingleQuotedScalar(state, nodeIndent) {
  var ch, captureStart, captureEnd;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 39) {
    return false;
  }
  state.kind = "scalar";
  state.result = "";
  state.position++;
  captureStart = captureEnd = state.position;
  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    if (ch === 39) {
      captureSegment(state, captureStart, state.position, true);
      ch = state.input.charCodeAt(++state.position);
      if (ch === 39) {
        captureStart = state.position;
        state.position++;
        captureEnd = state.position;
      } else {
        return true;
      }
    } else if (is_EOL(ch)) {
      captureSegment(state, captureStart, captureEnd, true);
      writeFoldedLines(state, skipSeparationSpace(state, false, nodeIndent));
      captureStart = captureEnd = state.position;
    } else if (state.position === state.lineStart && testDocumentSeparator(state)) {
      throwError(state, "unexpected end of the document within a single quoted scalar");
    } else {
      state.position++;
      captureEnd = state.position;
    }
  }
  throwError(state, "unexpected end of the stream within a single quoted scalar");
}
function readDoubleQuotedScalar(state, nodeIndent) {
  var captureStart, captureEnd, hexLength, hexResult, tmp, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 34) {
    return false;
  }
  state.kind = "scalar";
  state.result = "";
  state.position++;
  captureStart = captureEnd = state.position;
  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    if (ch === 34) {
      captureSegment(state, captureStart, state.position, true);
      state.position++;
      return true;
    } else if (ch === 92) {
      captureSegment(state, captureStart, state.position, true);
      ch = state.input.charCodeAt(++state.position);
      if (is_EOL(ch)) {
        skipSeparationSpace(state, false, nodeIndent);
      } else if (ch < 256 && simpleEscapeCheck[ch]) {
        state.result += simpleEscapeMap[ch];
        state.position++;
      } else if ((tmp = escapedHexLen(ch)) > 0) {
        hexLength = tmp;
        hexResult = 0;
        for (; hexLength > 0; hexLength--) {
          ch = state.input.charCodeAt(++state.position);
          if ((tmp = fromHexCode(ch)) >= 0) {
            hexResult = (hexResult << 4) + tmp;
          } else {
            throwError(state, "expected hexadecimal character");
          }
        }
        state.result += charFromCodepoint(hexResult);
        state.position++;
      } else {
        throwError(state, "unknown escape sequence");
      }
      captureStart = captureEnd = state.position;
    } else if (is_EOL(ch)) {
      captureSegment(state, captureStart, captureEnd, true);
      writeFoldedLines(state, skipSeparationSpace(state, false, nodeIndent));
      captureStart = captureEnd = state.position;
    } else if (state.position === state.lineStart && testDocumentSeparator(state)) {
      throwError(state, "unexpected end of the document within a double quoted scalar");
    } else {
      state.position++;
      captureEnd = state.position;
    }
  }
  throwError(state, "unexpected end of the stream within a double quoted scalar");
}
function readFlowCollection(state, nodeIndent) {
  var readNext = true, _line, _lineStart, _pos, _tag = state.tag, _result, _anchor = state.anchor, following, terminator, isPair, isExplicitPair, isMapping, overridableKeys = /* @__PURE__ */ Object.create(null), keyNode, keyTag, valueNode, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch === 91) {
    terminator = 93;
    isMapping = false;
    _result = [];
  } else if (ch === 123) {
    terminator = 125;
    isMapping = true;
    _result = {};
  } else {
    return false;
  }
  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }
  ch = state.input.charCodeAt(++state.position);
  while (ch !== 0) {
    skipSeparationSpace(state, true, nodeIndent);
    ch = state.input.charCodeAt(state.position);
    if (ch === terminator) {
      state.position++;
      state.tag = _tag;
      state.anchor = _anchor;
      state.kind = isMapping ? "mapping" : "sequence";
      state.result = _result;
      return true;
    } else if (!readNext) {
      throwError(state, "missed comma between flow collection entries");
    } else if (ch === 44) {
      throwError(state, "expected the node content, but found ','");
    }
    keyTag = keyNode = valueNode = null;
    isPair = isExplicitPair = false;
    if (ch === 63) {
      following = state.input.charCodeAt(state.position + 1);
      if (is_WS_OR_EOL(following)) {
        isPair = isExplicitPair = true;
        state.position++;
        skipSeparationSpace(state, true, nodeIndent);
      }
    }
    _line = state.line;
    _lineStart = state.lineStart;
    _pos = state.position;
    composeNode(state, nodeIndent, CONTEXT_FLOW_IN, false, true);
    keyTag = state.tag;
    keyNode = state.result;
    skipSeparationSpace(state, true, nodeIndent);
    ch = state.input.charCodeAt(state.position);
    if ((isExplicitPair || state.line === _line) && ch === 58) {
      isPair = true;
      ch = state.input.charCodeAt(++state.position);
      skipSeparationSpace(state, true, nodeIndent);
      composeNode(state, nodeIndent, CONTEXT_FLOW_IN, false, true);
      valueNode = state.result;
    }
    if (isMapping) {
      storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos);
    } else if (isPair) {
      _result.push(storeMappingPair(state, null, overridableKeys, keyTag, keyNode, valueNode, _line, _lineStart, _pos));
    } else {
      _result.push(keyNode);
    }
    skipSeparationSpace(state, true, nodeIndent);
    ch = state.input.charCodeAt(state.position);
    if (ch === 44) {
      readNext = true;
      ch = state.input.charCodeAt(++state.position);
    } else {
      readNext = false;
    }
  }
  throwError(state, "unexpected end of the stream within a flow collection");
}
function readBlockScalar(state, nodeIndent) {
  var captureStart, folding, chomping = CHOMPING_CLIP, didReadContent = false, detectedIndent = false, textIndent = nodeIndent, emptyLines = 0, atMoreIndented = false, tmp, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch === 124) {
    folding = false;
  } else if (ch === 62) {
    folding = true;
  } else {
    return false;
  }
  state.kind = "scalar";
  state.result = "";
  while (ch !== 0) {
    ch = state.input.charCodeAt(++state.position);
    if (ch === 43 || ch === 45) {
      if (CHOMPING_CLIP === chomping) {
        chomping = ch === 43 ? CHOMPING_KEEP : CHOMPING_STRIP;
      } else {
        throwError(state, "repeat of a chomping mode identifier");
      }
    } else if ((tmp = fromDecimalCode(ch)) >= 0) {
      if (tmp === 0) {
        throwError(state, "bad explicit indentation width of a block scalar; it cannot be less than one");
      } else if (!detectedIndent) {
        textIndent = nodeIndent + tmp - 1;
        detectedIndent = true;
      } else {
        throwError(state, "repeat of an indentation width identifier");
      }
    } else {
      break;
    }
  }
  if (is_WHITE_SPACE(ch)) {
    do {
      ch = state.input.charCodeAt(++state.position);
    } while (is_WHITE_SPACE(ch));
    if (ch === 35) {
      do {
        ch = state.input.charCodeAt(++state.position);
      } while (!is_EOL(ch) && ch !== 0);
    }
  }
  while (ch !== 0) {
    readLineBreak(state);
    state.lineIndent = 0;
    ch = state.input.charCodeAt(state.position);
    while ((!detectedIndent || state.lineIndent < textIndent) && ch === 32) {
      state.lineIndent++;
      ch = state.input.charCodeAt(++state.position);
    }
    if (!detectedIndent && state.lineIndent > textIndent) {
      textIndent = state.lineIndent;
    }
    if (is_EOL(ch)) {
      emptyLines++;
      continue;
    }
    if (state.lineIndent < textIndent) {
      if (chomping === CHOMPING_KEEP) {
        state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
      } else if (chomping === CHOMPING_CLIP) {
        if (didReadContent) {
          state.result += "\n";
        }
      }
      break;
    }
    if (folding) {
      if (is_WHITE_SPACE(ch)) {
        atMoreIndented = true;
        state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
      } else if (atMoreIndented) {
        atMoreIndented = false;
        state.result += common.repeat("\n", emptyLines + 1);
      } else if (emptyLines === 0) {
        if (didReadContent) {
          state.result += " ";
        }
      } else {
        state.result += common.repeat("\n", emptyLines);
      }
    } else {
      state.result += common.repeat("\n", didReadContent ? 1 + emptyLines : emptyLines);
    }
    didReadContent = true;
    detectedIndent = true;
    emptyLines = 0;
    captureStart = state.position;
    while (!is_EOL(ch) && ch !== 0) {
      ch = state.input.charCodeAt(++state.position);
    }
    captureSegment(state, captureStart, state.position, false);
  }
  return true;
}
function readBlockSequence(state, nodeIndent) {
  var _line, _tag = state.tag, _anchor = state.anchor, _result = [], following, detected = false, ch;
  if (state.firstTabInLine !== -1) return false;
  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }
  ch = state.input.charCodeAt(state.position);
  while (ch !== 0) {
    if (state.firstTabInLine !== -1) {
      state.position = state.firstTabInLine;
      throwError(state, "tab characters must not be used in indentation");
    }
    if (ch !== 45) {
      break;
    }
    following = state.input.charCodeAt(state.position + 1);
    if (!is_WS_OR_EOL(following)) {
      break;
    }
    detected = true;
    state.position++;
    if (skipSeparationSpace(state, true, -1)) {
      if (state.lineIndent <= nodeIndent) {
        _result.push(null);
        ch = state.input.charCodeAt(state.position);
        continue;
      }
    }
    _line = state.line;
    composeNode(state, nodeIndent, CONTEXT_BLOCK_IN, false, true);
    _result.push(state.result);
    skipSeparationSpace(state, true, -1);
    ch = state.input.charCodeAt(state.position);
    if ((state.line === _line || state.lineIndent > nodeIndent) && ch !== 0) {
      throwError(state, "bad indentation of a sequence entry");
    } else if (state.lineIndent < nodeIndent) {
      break;
    }
  }
  if (detected) {
    state.tag = _tag;
    state.anchor = _anchor;
    state.kind = "sequence";
    state.result = _result;
    return true;
  }
  return false;
}
function readBlockMapping(state, nodeIndent, flowIndent) {
  var following, allowCompact, _line, _keyLine, _keyLineStart, _keyPos, _tag = state.tag, _anchor = state.anchor, _result = {}, overridableKeys = /* @__PURE__ */ Object.create(null), keyTag = null, keyNode = null, valueNode = null, atExplicitKey = false, detected = false, ch;
  if (state.firstTabInLine !== -1) return false;
  if (state.anchor !== null) {
    state.anchorMap[state.anchor] = _result;
  }
  ch = state.input.charCodeAt(state.position);
  while (ch !== 0) {
    if (!atExplicitKey && state.firstTabInLine !== -1) {
      state.position = state.firstTabInLine;
      throwError(state, "tab characters must not be used in indentation");
    }
    following = state.input.charCodeAt(state.position + 1);
    _line = state.line;
    if ((ch === 63 || ch === 58) && is_WS_OR_EOL(following)) {
      if (ch === 63) {
        if (atExplicitKey) {
          storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
          keyTag = keyNode = valueNode = null;
        }
        detected = true;
        atExplicitKey = true;
        allowCompact = true;
      } else if (atExplicitKey) {
        atExplicitKey = false;
        allowCompact = true;
      } else {
        throwError(state, "incomplete explicit mapping pair; a key node is missed; or followed by a non-tabulated empty line");
      }
      state.position += 1;
      ch = following;
    } else {
      _keyLine = state.line;
      _keyLineStart = state.lineStart;
      _keyPos = state.position;
      if (!composeNode(state, flowIndent, CONTEXT_FLOW_OUT, false, true)) {
        break;
      }
      if (state.line === _line) {
        ch = state.input.charCodeAt(state.position);
        while (is_WHITE_SPACE(ch)) {
          ch = state.input.charCodeAt(++state.position);
        }
        if (ch === 58) {
          ch = state.input.charCodeAt(++state.position);
          if (!is_WS_OR_EOL(ch)) {
            throwError(state, "a whitespace character is expected after the key-value separator within a block mapping");
          }
          if (atExplicitKey) {
            storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
            keyTag = keyNode = valueNode = null;
          }
          detected = true;
          atExplicitKey = false;
          allowCompact = false;
          keyTag = state.tag;
          keyNode = state.result;
        } else if (detected) {
          throwError(state, "can not read an implicit mapping pair; a colon is missed");
        } else {
          state.tag = _tag;
          state.anchor = _anchor;
          return true;
        }
      } else if (detected) {
        throwError(state, "can not read a block mapping entry; a multiline key may not be an implicit key");
      } else {
        state.tag = _tag;
        state.anchor = _anchor;
        return true;
      }
    }
    if (state.line === _line || state.lineIndent > nodeIndent) {
      if (atExplicitKey) {
        _keyLine = state.line;
        _keyLineStart = state.lineStart;
        _keyPos = state.position;
      }
      if (composeNode(state, nodeIndent, CONTEXT_BLOCK_OUT, true, allowCompact)) {
        if (atExplicitKey) {
          keyNode = state.result;
        } else {
          valueNode = state.result;
        }
      }
      if (!atExplicitKey) {
        storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, valueNode, _keyLine, _keyLineStart, _keyPos);
        keyTag = keyNode = valueNode = null;
      }
      skipSeparationSpace(state, true, -1);
      ch = state.input.charCodeAt(state.position);
    }
    if ((state.line === _line || state.lineIndent > nodeIndent) && ch !== 0) {
      throwError(state, "bad indentation of a mapping entry");
    } else if (state.lineIndent < nodeIndent) {
      break;
    }
  }
  if (atExplicitKey) {
    storeMappingPair(state, _result, overridableKeys, keyTag, keyNode, null, _keyLine, _keyLineStart, _keyPos);
  }
  if (detected) {
    state.tag = _tag;
    state.anchor = _anchor;
    state.kind = "mapping";
    state.result = _result;
  }
  return detected;
}
function readTagProperty(state) {
  var _position, isVerbatim = false, isNamed = false, tagHandle, tagName, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 33) return false;
  if (state.tag !== null) {
    throwError(state, "duplication of a tag property");
  }
  ch = state.input.charCodeAt(++state.position);
  if (ch === 60) {
    isVerbatim = true;
    ch = state.input.charCodeAt(++state.position);
  } else if (ch === 33) {
    isNamed = true;
    tagHandle = "!!";
    ch = state.input.charCodeAt(++state.position);
  } else {
    tagHandle = "!";
  }
  _position = state.position;
  if (isVerbatim) {
    do {
      ch = state.input.charCodeAt(++state.position);
    } while (ch !== 0 && ch !== 62);
    if (state.position < state.length) {
      tagName = state.input.slice(_position, state.position);
      ch = state.input.charCodeAt(++state.position);
    } else {
      throwError(state, "unexpected end of the stream within a verbatim tag");
    }
  } else {
    while (ch !== 0 && !is_WS_OR_EOL(ch)) {
      if (ch === 33) {
        if (!isNamed) {
          tagHandle = state.input.slice(_position - 1, state.position + 1);
          if (!PATTERN_TAG_HANDLE.test(tagHandle)) {
            throwError(state, "named tag handle cannot contain such characters");
          }
          isNamed = true;
          _position = state.position + 1;
        } else {
          throwError(state, "tag suffix cannot contain exclamation marks");
        }
      }
      ch = state.input.charCodeAt(++state.position);
    }
    tagName = state.input.slice(_position, state.position);
    if (PATTERN_FLOW_INDICATORS.test(tagName)) {
      throwError(state, "tag suffix cannot contain flow indicator characters");
    }
  }
  if (tagName && !PATTERN_TAG_URI.test(tagName)) {
    throwError(state, "tag name cannot contain such characters: " + tagName);
  }
  try {
    tagName = decodeURIComponent(tagName);
  } catch (err) {
    throwError(state, "tag name is malformed: " + tagName);
  }
  if (isVerbatim) {
    state.tag = tagName;
  } else if (_hasOwnProperty$1.call(state.tagMap, tagHandle)) {
    state.tag = state.tagMap[tagHandle] + tagName;
  } else if (tagHandle === "!") {
    state.tag = "!" + tagName;
  } else if (tagHandle === "!!") {
    state.tag = "tag:yaml.org,2002:" + tagName;
  } else {
    throwError(state, 'undeclared tag handle "' + tagHandle + '"');
  }
  return true;
}
function readAnchorProperty(state) {
  var _position, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 38) return false;
  if (state.anchor !== null) {
    throwError(state, "duplication of an anchor property");
  }
  ch = state.input.charCodeAt(++state.position);
  _position = state.position;
  while (ch !== 0 && !is_WS_OR_EOL(ch) && !is_FLOW_INDICATOR(ch)) {
    ch = state.input.charCodeAt(++state.position);
  }
  if (state.position === _position) {
    throwError(state, "name of an anchor node must contain at least one character");
  }
  state.anchor = state.input.slice(_position, state.position);
  return true;
}
function readAlias(state) {
  var _position, alias, ch;
  ch = state.input.charCodeAt(state.position);
  if (ch !== 42) return false;
  ch = state.input.charCodeAt(++state.position);
  _position = state.position;
  while (ch !== 0 && !is_WS_OR_EOL(ch) && !is_FLOW_INDICATOR(ch)) {
    ch = state.input.charCodeAt(++state.position);
  }
  if (state.position === _position) {
    throwError(state, "name of an alias node must contain at least one character");
  }
  alias = state.input.slice(_position, state.position);
  if (!_hasOwnProperty$1.call(state.anchorMap, alias)) {
    throwError(state, 'unidentified alias "' + alias + '"');
  }
  state.result = state.anchorMap[alias];
  skipSeparationSpace(state, true, -1);
  return true;
}
function composeNode(state, parentIndent, nodeContext, allowToSeek, allowCompact) {
  var allowBlockStyles, allowBlockScalars, allowBlockCollections, indentStatus = 1, atNewLine = false, hasContent = false, typeIndex, typeQuantity, typeList, type2, flowIndent, blockIndent;
  if (state.listener !== null) {
    state.listener("open", state);
  }
  state.tag = null;
  state.anchor = null;
  state.kind = null;
  state.result = null;
  allowBlockStyles = allowBlockScalars = allowBlockCollections = CONTEXT_BLOCK_OUT === nodeContext || CONTEXT_BLOCK_IN === nodeContext;
  if (allowToSeek) {
    if (skipSeparationSpace(state, true, -1)) {
      atNewLine = true;
      if (state.lineIndent > parentIndent) {
        indentStatus = 1;
      } else if (state.lineIndent === parentIndent) {
        indentStatus = 0;
      } else if (state.lineIndent < parentIndent) {
        indentStatus = -1;
      }
    }
  }
  if (indentStatus === 1) {
    while (readTagProperty(state) || readAnchorProperty(state)) {
      if (skipSeparationSpace(state, true, -1)) {
        atNewLine = true;
        allowBlockCollections = allowBlockStyles;
        if (state.lineIndent > parentIndent) {
          indentStatus = 1;
        } else if (state.lineIndent === parentIndent) {
          indentStatus = 0;
        } else if (state.lineIndent < parentIndent) {
          indentStatus = -1;
        }
      } else {
        allowBlockCollections = false;
      }
    }
  }
  if (allowBlockCollections) {
    allowBlockCollections = atNewLine || allowCompact;
  }
  if (indentStatus === 1 || CONTEXT_BLOCK_OUT === nodeContext) {
    if (CONTEXT_FLOW_IN === nodeContext || CONTEXT_FLOW_OUT === nodeContext) {
      flowIndent = parentIndent;
    } else {
      flowIndent = parentIndent + 1;
    }
    blockIndent = state.position - state.lineStart;
    if (indentStatus === 1) {
      if (allowBlockCollections && (readBlockSequence(state, blockIndent) || readBlockMapping(state, blockIndent, flowIndent)) || readFlowCollection(state, flowIndent)) {
        hasContent = true;
      } else {
        if (allowBlockScalars && readBlockScalar(state, flowIndent) || readSingleQuotedScalar(state, flowIndent) || readDoubleQuotedScalar(state, flowIndent)) {
          hasContent = true;
        } else if (readAlias(state)) {
          hasContent = true;
          if (state.tag !== null || state.anchor !== null) {
            throwError(state, "alias node should not have any properties");
          }
        } else if (readPlainScalar(state, flowIndent, CONTEXT_FLOW_IN === nodeContext)) {
          hasContent = true;
          if (state.tag === null) {
            state.tag = "?";
          }
        }
        if (state.anchor !== null) {
          state.anchorMap[state.anchor] = state.result;
        }
      }
    } else if (indentStatus === 0) {
      hasContent = allowBlockCollections && readBlockSequence(state, blockIndent);
    }
  }
  if (state.tag === null) {
    if (state.anchor !== null) {
      state.anchorMap[state.anchor] = state.result;
    }
  } else if (state.tag === "?") {
    if (state.result !== null && state.kind !== "scalar") {
      throwError(state, 'unacceptable node kind for !<?> tag; it should be "scalar", not "' + state.kind + '"');
    }
    for (typeIndex = 0, typeQuantity = state.implicitTypes.length; typeIndex < typeQuantity; typeIndex += 1) {
      type2 = state.implicitTypes[typeIndex];
      if (type2.resolve(state.result)) {
        state.result = type2.construct(state.result);
        state.tag = type2.tag;
        if (state.anchor !== null) {
          state.anchorMap[state.anchor] = state.result;
        }
        break;
      }
    }
  } else if (state.tag !== "!") {
    if (_hasOwnProperty$1.call(state.typeMap[state.kind || "fallback"], state.tag)) {
      type2 = state.typeMap[state.kind || "fallback"][state.tag];
    } else {
      type2 = null;
      typeList = state.typeMap.multi[state.kind || "fallback"];
      for (typeIndex = 0, typeQuantity = typeList.length; typeIndex < typeQuantity; typeIndex += 1) {
        if (state.tag.slice(0, typeList[typeIndex].tag.length) === typeList[typeIndex].tag) {
          type2 = typeList[typeIndex];
          break;
        }
      }
    }
    if (!type2) {
      throwError(state, "unknown tag !<" + state.tag + ">");
    }
    if (state.result !== null && type2.kind !== state.kind) {
      throwError(state, "unacceptable node kind for !<" + state.tag + '> tag; it should be "' + type2.kind + '", not "' + state.kind + '"');
    }
    if (!type2.resolve(state.result, state.tag)) {
      throwError(state, "cannot resolve a node with !<" + state.tag + "> explicit tag");
    } else {
      state.result = type2.construct(state.result, state.tag);
      if (state.anchor !== null) {
        state.anchorMap[state.anchor] = state.result;
      }
    }
  }
  if (state.listener !== null) {
    state.listener("close", state);
  }
  return state.tag !== null || state.anchor !== null || hasContent;
}
function readDocument(state) {
  var documentStart = state.position, _position, directiveName, directiveArgs, hasDirectives = false, ch;
  state.version = null;
  state.checkLineBreaks = state.legacy;
  state.tagMap = /* @__PURE__ */ Object.create(null);
  state.anchorMap = /* @__PURE__ */ Object.create(null);
  while ((ch = state.input.charCodeAt(state.position)) !== 0) {
    skipSeparationSpace(state, true, -1);
    ch = state.input.charCodeAt(state.position);
    if (state.lineIndent > 0 || ch !== 37) {
      break;
    }
    hasDirectives = true;
    ch = state.input.charCodeAt(++state.position);
    _position = state.position;
    while (ch !== 0 && !is_WS_OR_EOL(ch)) {
      ch = state.input.charCodeAt(++state.position);
    }
    directiveName = state.input.slice(_position, state.position);
    directiveArgs = [];
    if (directiveName.length < 1) {
      throwError(state, "directive name must not be less than one character in length");
    }
    while (ch !== 0) {
      while (is_WHITE_SPACE(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      if (ch === 35) {
        do {
          ch = state.input.charCodeAt(++state.position);
        } while (ch !== 0 && !is_EOL(ch));
        break;
      }
      if (is_EOL(ch)) break;
      _position = state.position;
      while (ch !== 0 && !is_WS_OR_EOL(ch)) {
        ch = state.input.charCodeAt(++state.position);
      }
      directiveArgs.push(state.input.slice(_position, state.position));
    }
    if (ch !== 0) readLineBreak(state);
    if (_hasOwnProperty$1.call(directiveHandlers, directiveName)) {
      directiveHandlers[directiveName](state, directiveName, directiveArgs);
    } else {
      throwWarning(state, 'unknown document directive "' + directiveName + '"');
    }
  }
  skipSeparationSpace(state, true, -1);
  if (state.lineIndent === 0 && state.input.charCodeAt(state.position) === 45 && state.input.charCodeAt(state.position + 1) === 45 && state.input.charCodeAt(state.position + 2) === 45) {
    state.position += 3;
    skipSeparationSpace(state, true, -1);
  } else if (hasDirectives) {
    throwError(state, "directives end mark is expected");
  }
  composeNode(state, state.lineIndent - 1, CONTEXT_BLOCK_OUT, false, true);
  skipSeparationSpace(state, true, -1);
  if (state.checkLineBreaks && PATTERN_NON_ASCII_LINE_BREAKS.test(state.input.slice(documentStart, state.position))) {
    throwWarning(state, "non-ASCII line breaks are interpreted as content");
  }
  state.documents.push(state.result);
  if (state.position === state.lineStart && testDocumentSeparator(state)) {
    if (state.input.charCodeAt(state.position) === 46) {
      state.position += 3;
      skipSeparationSpace(state, true, -1);
    }
    return;
  }
  if (state.position < state.length - 1) {
    throwError(state, "end of the stream or a document separator is expected");
  } else {
    return;
  }
}
function loadDocuments(input, options) {
  input = String(input);
  options = options || {};
  if (input.length !== 0) {
    if (input.charCodeAt(input.length - 1) !== 10 && input.charCodeAt(input.length - 1) !== 13) {
      input += "\n";
    }
    if (input.charCodeAt(0) === 65279) {
      input = input.slice(1);
    }
  }
  var state = new State$1(input, options);
  var nullpos = input.indexOf("\0");
  if (nullpos !== -1) {
    state.position = nullpos;
    throwError(state, "null byte is not allowed in input");
  }
  state.input += "\0";
  while (state.input.charCodeAt(state.position) === 32) {
    state.lineIndent += 1;
    state.position += 1;
  }
  while (state.position < state.length - 1) {
    readDocument(state);
  }
  return state.documents;
}
function loadAll$1(input, iterator, options) {
  if (iterator !== null && typeof iterator === "object" && typeof options === "undefined") {
    options = iterator;
    iterator = null;
  }
  var documents = loadDocuments(input, options);
  if (typeof iterator !== "function") {
    return documents;
  }
  for (var index = 0, length = documents.length; index < length; index += 1) {
    iterator(documents[index]);
  }
}
function load$1(input, options) {
  var documents = loadDocuments(input, options);
  if (documents.length === 0) {
    return void 0;
  } else if (documents.length === 1) {
    return documents[0];
  }
  throw new exception("expected a single document in the stream, but found more");
}
var loadAll_1 = loadAll$1;
var load_1 = load$1;
var loader = {
  loadAll: loadAll_1,
  load: load_1
};
var _toString = Object.prototype.toString;
var _hasOwnProperty = Object.prototype.hasOwnProperty;
var CHAR_BOM = 65279;
var CHAR_TAB = 9;
var CHAR_LINE_FEED = 10;
var CHAR_CARRIAGE_RETURN = 13;
var CHAR_SPACE = 32;
var CHAR_EXCLAMATION = 33;
var CHAR_DOUBLE_QUOTE = 34;
var CHAR_SHARP = 35;
var CHAR_PERCENT = 37;
var CHAR_AMPERSAND = 38;
var CHAR_SINGLE_QUOTE = 39;
var CHAR_ASTERISK = 42;
var CHAR_COMMA = 44;
var CHAR_MINUS = 45;
var CHAR_COLON = 58;
var CHAR_EQUALS = 61;
var CHAR_GREATER_THAN = 62;
var CHAR_QUESTION = 63;
var CHAR_COMMERCIAL_AT = 64;
var CHAR_LEFT_SQUARE_BRACKET = 91;
var CHAR_RIGHT_SQUARE_BRACKET = 93;
var CHAR_GRAVE_ACCENT = 96;
var CHAR_LEFT_CURLY_BRACKET = 123;
var CHAR_VERTICAL_LINE = 124;
var CHAR_RIGHT_CURLY_BRACKET = 125;
var ESCAPE_SEQUENCES = {};
ESCAPE_SEQUENCES[0] = "\\0";
ESCAPE_SEQUENCES[7] = "\\a";
ESCAPE_SEQUENCES[8] = "\\b";
ESCAPE_SEQUENCES[9] = "\\t";
ESCAPE_SEQUENCES[10] = "\\n";
ESCAPE_SEQUENCES[11] = "\\v";
ESCAPE_SEQUENCES[12] = "\\f";
ESCAPE_SEQUENCES[13] = "\\r";
ESCAPE_SEQUENCES[27] = "\\e";
ESCAPE_SEQUENCES[34] = '\\"';
ESCAPE_SEQUENCES[92] = "\\\\";
ESCAPE_SEQUENCES[133] = "\\N";
ESCAPE_SEQUENCES[160] = "\\_";
ESCAPE_SEQUENCES[8232] = "\\L";
ESCAPE_SEQUENCES[8233] = "\\P";
var DEPRECATED_BOOLEANS_SYNTAX = [
  "y",
  "Y",
  "yes",
  "Yes",
  "YES",
  "on",
  "On",
  "ON",
  "n",
  "N",
  "no",
  "No",
  "NO",
  "off",
  "Off",
  "OFF"
];
var DEPRECATED_BASE60_SYNTAX = /^[-+]?[0-9_]+(?::[0-9_]+)+(?:\.[0-9_]*)?$/;
function compileStyleMap(schema2, map2) {
  var result, keys5, index, length, tag, style, type2;
  if (map2 === null) return {};
  result = {};
  keys5 = Object.keys(map2);
  for (index = 0, length = keys5.length; index < length; index += 1) {
    tag = keys5[index];
    style = String(map2[tag]);
    if (tag.slice(0, 2) === "!!") {
      tag = "tag:yaml.org,2002:" + tag.slice(2);
    }
    type2 = schema2.compiledTypeMap["fallback"][tag];
    if (type2 && _hasOwnProperty.call(type2.styleAliases, style)) {
      style = type2.styleAliases[style];
    }
    result[tag] = style;
  }
  return result;
}
function encodeHex(character) {
  var string3, handle, length;
  string3 = character.toString(16).toUpperCase();
  if (character <= 255) {
    handle = "x";
    length = 2;
  } else if (character <= 65535) {
    handle = "u";
    length = 4;
  } else if (character <= 4294967295) {
    handle = "U";
    length = 8;
  } else {
    throw new exception("code point within a string may not be greater than 0xFFFFFFFF");
  }
  return "\\" + handle + common.repeat("0", length - string3.length) + string3;
}
var QUOTING_TYPE_SINGLE = 1;
var QUOTING_TYPE_DOUBLE = 2;
function State2(options) {
  this.schema = options["schema"] || _default;
  this.indent = Math.max(1, options["indent"] || 2);
  this.noArrayIndent = options["noArrayIndent"] || false;
  this.skipInvalid = options["skipInvalid"] || false;
  this.flowLevel = common.isNothing(options["flowLevel"]) ? -1 : options["flowLevel"];
  this.styleMap = compileStyleMap(this.schema, options["styles"] || null);
  this.sortKeys = options["sortKeys"] || false;
  this.lineWidth = options["lineWidth"] || 80;
  this.noRefs = options["noRefs"] || false;
  this.noCompatMode = options["noCompatMode"] || false;
  this.condenseFlow = options["condenseFlow"] || false;
  this.quotingType = options["quotingType"] === '"' ? QUOTING_TYPE_DOUBLE : QUOTING_TYPE_SINGLE;
  this.forceQuotes = options["forceQuotes"] || false;
  this.replacer = typeof options["replacer"] === "function" ? options["replacer"] : null;
  this.implicitTypes = this.schema.compiledImplicit;
  this.explicitTypes = this.schema.compiledExplicit;
  this.tag = null;
  this.result = "";
  this.duplicates = [];
  this.usedDuplicates = null;
}
function indentString(string3, spaces) {
  var ind = common.repeat(" ", spaces), position = 0, next = -1, result = "", line, length = string3.length;
  while (position < length) {
    next = string3.indexOf("\n", position);
    if (next === -1) {
      line = string3.slice(position);
      position = length;
    } else {
      line = string3.slice(position, next + 1);
      position = next + 1;
    }
    if (line.length && line !== "\n") result += ind;
    result += line;
  }
  return result;
}
function generateNextLine(state, level) {
  return "\n" + common.repeat(" ", state.indent * level);
}
function testImplicitResolving(state, str2) {
  var index, length, type2;
  for (index = 0, length = state.implicitTypes.length; index < length; index += 1) {
    type2 = state.implicitTypes[index];
    if (type2.resolve(str2)) {
      return true;
    }
  }
  return false;
}
function isWhitespace(c) {
  return c === CHAR_SPACE || c === CHAR_TAB;
}
function isPrintable(c) {
  return 32 <= c && c <= 126 || 161 <= c && c <= 55295 && c !== 8232 && c !== 8233 || 57344 <= c && c <= 65533 && c !== CHAR_BOM || 65536 <= c && c <= 1114111;
}
function isNsCharOrWhitespace(c) {
  return isPrintable(c) && c !== CHAR_BOM && c !== CHAR_CARRIAGE_RETURN && c !== CHAR_LINE_FEED;
}
function isPlainSafe(c, prev, inblock) {
  var cIsNsCharOrWhitespace = isNsCharOrWhitespace(c);
  var cIsNsChar = cIsNsCharOrWhitespace && !isWhitespace(c);
  return (
    // ns-plain-safe
    (inblock ? (
      // c = flow-in
      cIsNsCharOrWhitespace
    ) : cIsNsCharOrWhitespace && c !== CHAR_COMMA && c !== CHAR_LEFT_SQUARE_BRACKET && c !== CHAR_RIGHT_SQUARE_BRACKET && c !== CHAR_LEFT_CURLY_BRACKET && c !== CHAR_RIGHT_CURLY_BRACKET) && c !== CHAR_SHARP && !(prev === CHAR_COLON && !cIsNsChar) || isNsCharOrWhitespace(prev) && !isWhitespace(prev) && c === CHAR_SHARP || prev === CHAR_COLON && cIsNsChar
  );
}
function isPlainSafeFirst(c) {
  return isPrintable(c) && c !== CHAR_BOM && !isWhitespace(c) && c !== CHAR_MINUS && c !== CHAR_QUESTION && c !== CHAR_COLON && c !== CHAR_COMMA && c !== CHAR_LEFT_SQUARE_BRACKET && c !== CHAR_RIGHT_SQUARE_BRACKET && c !== CHAR_LEFT_CURLY_BRACKET && c !== CHAR_RIGHT_CURLY_BRACKET && c !== CHAR_SHARP && c !== CHAR_AMPERSAND && c !== CHAR_ASTERISK && c !== CHAR_EXCLAMATION && c !== CHAR_VERTICAL_LINE && c !== CHAR_EQUALS && c !== CHAR_GREATER_THAN && c !== CHAR_SINGLE_QUOTE && c !== CHAR_DOUBLE_QUOTE && c !== CHAR_PERCENT && c !== CHAR_COMMERCIAL_AT && c !== CHAR_GRAVE_ACCENT;
}
function isPlainSafeLast(c) {
  return !isWhitespace(c) && c !== CHAR_COLON;
}
function codePointAt(string3, pos) {
  var first = string3.charCodeAt(pos), second;
  if (first >= 55296 && first <= 56319 && pos + 1 < string3.length) {
    second = string3.charCodeAt(pos + 1);
    if (second >= 56320 && second <= 57343) {
      return (first - 55296) * 1024 + second - 56320 + 65536;
    }
  }
  return first;
}
function needIndentIndicator(string3) {
  var leadingSpaceRe = /^\n* /;
  return leadingSpaceRe.test(string3);
}
var STYLE_PLAIN = 1;
var STYLE_SINGLE = 2;
var STYLE_LITERAL = 3;
var STYLE_FOLDED = 4;
var STYLE_DOUBLE = 5;
function chooseScalarStyle(string3, singleLineOnly, indentPerLevel, lineWidth, testAmbiguousType, quotingType, forceQuotes, inblock) {
  var i;
  var char = 0;
  var prevChar = null;
  var hasLineBreak = false;
  var hasFoldableLine = false;
  var shouldTrackWidth = lineWidth !== -1;
  var previousLineBreak = -1;
  var plain = isPlainSafeFirst(codePointAt(string3, 0)) && isPlainSafeLast(codePointAt(string3, string3.length - 1));
  if (singleLineOnly || forceQuotes) {
    for (i = 0; i < string3.length; char >= 65536 ? i += 2 : i++) {
      char = codePointAt(string3, i);
      if (!isPrintable(char)) {
        return STYLE_DOUBLE;
      }
      plain = plain && isPlainSafe(char, prevChar, inblock);
      prevChar = char;
    }
  } else {
    for (i = 0; i < string3.length; char >= 65536 ? i += 2 : i++) {
      char = codePointAt(string3, i);
      if (char === CHAR_LINE_FEED) {
        hasLineBreak = true;
        if (shouldTrackWidth) {
          hasFoldableLine = hasFoldableLine || // Foldable line = too long, and not more-indented.
            i - previousLineBreak - 1 > lineWidth && string3[previousLineBreak + 1] !== " ";
          previousLineBreak = i;
        }
      } else if (!isPrintable(char)) {
        return STYLE_DOUBLE;
      }
      plain = plain && isPlainSafe(char, prevChar, inblock);
      prevChar = char;
    }
    hasFoldableLine = hasFoldableLine || shouldTrackWidth && (i - previousLineBreak - 1 > lineWidth && string3[previousLineBreak + 1] !== " ");
  }
  if (!hasLineBreak && !hasFoldableLine) {
    if (plain && !forceQuotes && !testAmbiguousType(string3)) {
      return STYLE_PLAIN;
    }
    return quotingType === QUOTING_TYPE_DOUBLE ? STYLE_DOUBLE : STYLE_SINGLE;
  }
  if (indentPerLevel > 9 && needIndentIndicator(string3)) {
    return STYLE_DOUBLE;
  }
  if (!forceQuotes) {
    return hasFoldableLine ? STYLE_FOLDED : STYLE_LITERAL;
  }
  return quotingType === QUOTING_TYPE_DOUBLE ? STYLE_DOUBLE : STYLE_SINGLE;
}
function writeScalar(state, string3, level, iskey, inblock) {
  state.dump = function () {
    if (string3.length === 0) {
      return state.quotingType === QUOTING_TYPE_DOUBLE ? '""' : "''";
    }
    if (!state.noCompatMode) {
      if (DEPRECATED_BOOLEANS_SYNTAX.indexOf(string3) !== -1 || DEPRECATED_BASE60_SYNTAX.test(string3)) {
        return state.quotingType === QUOTING_TYPE_DOUBLE ? '"' + string3 + '"' : "'" + string3 + "'";
      }
    }
    var indent = state.indent * Math.max(1, level);
    var lineWidth = state.lineWidth === -1 ? -1 : Math.max(Math.min(state.lineWidth, 40), state.lineWidth - indent);
    var singleLineOnly = iskey || state.flowLevel > -1 && level >= state.flowLevel;
    function testAmbiguity(string4) {
      return testImplicitResolving(state, string4);
    }
    switch (chooseScalarStyle(
      string3,
      singleLineOnly,
      state.indent,
      lineWidth,
      testAmbiguity,
      state.quotingType,
      state.forceQuotes && !iskey,
      inblock
    )) {
      case STYLE_PLAIN:
        return string3;
      case STYLE_SINGLE:
        return "'" + string3.replace(/'/g, "''") + "'";
      case STYLE_LITERAL:
        return "|" + blockHeader(string3, state.indent) + dropEndingNewline(indentString(string3, indent));
      case STYLE_FOLDED:
        return ">" + blockHeader(string3, state.indent) + dropEndingNewline(indentString(foldString(string3, lineWidth), indent));
      case STYLE_DOUBLE:
        return '"' + escapeString(string3) + '"';
      default:
        throw new exception("impossible error: invalid scalar style");
    }
  }();
}
function blockHeader(string3, indentPerLevel) {
  var indentIndicator = needIndentIndicator(string3) ? String(indentPerLevel) : "";
  var clip = string3[string3.length - 1] === "\n";
  var keep = clip && (string3[string3.length - 2] === "\n" || string3 === "\n");
  var chomp = keep ? "+" : clip ? "" : "-";
  return indentIndicator + chomp + "\n";
}
function dropEndingNewline(string3) {
  return string3[string3.length - 1] === "\n" ? string3.slice(0, -1) : string3;
}
function foldString(string3, width) {
  var lineRe = /(\n+)([^\n]*)/g;
  var result = function () {
    var nextLF = string3.indexOf("\n");
    nextLF = nextLF !== -1 ? nextLF : string3.length;
    lineRe.lastIndex = nextLF;
    return foldLine(string3.slice(0, nextLF), width);
  }();
  var prevMoreIndented = string3[0] === "\n" || string3[0] === " ";
  var moreIndented;
  var match;
  while (match = lineRe.exec(string3)) {
    var prefix = match[1], line = match[2];
    moreIndented = line[0] === " ";
    result += prefix + (!prevMoreIndented && !moreIndented && line !== "" ? "\n" : "") + foldLine(line, width);
    prevMoreIndented = moreIndented;
  }
  return result;
}
function foldLine(line, width) {
  if (line === "" || line[0] === " ") return line;
  var breakRe = / [^ ]/g;
  var match;
  var start = 0, end, curr = 0, next = 0;
  var result = "";
  while (match = breakRe.exec(line)) {
    next = match.index;
    if (next - start > width) {
      end = curr > start ? curr : next;
      result += "\n" + line.slice(start, end);
      start = end + 1;
    }
    curr = next;
  }
  result += "\n";
  if (line.length - start > width && curr > start) {
    result += line.slice(start, curr) + "\n" + line.slice(curr + 1);
  } else {
    result += line.slice(start);
  }
  return result.slice(1);
}
function escapeString(string3) {
  var result = "";
  var char = 0;
  var escapeSeq;
  for (var i = 0; i < string3.length; char >= 65536 ? i += 2 : i++) {
    char = codePointAt(string3, i);
    escapeSeq = ESCAPE_SEQUENCES[char];
    if (!escapeSeq && isPrintable(char)) {
      result += string3[i];
      if (char >= 65536) result += string3[i + 1];
    } else {
      result += escapeSeq || encodeHex(char);
    }
  }
  return result;
}
function writeFlowSequence(state, level, object3) {
  var _result = "", _tag = state.tag, index, length, value;
  for (index = 0, length = object3.length; index < length; index += 1) {
    value = object3[index];
    if (state.replacer) {
      value = state.replacer.call(object3, String(index), value);
    }
    if (writeNode(state, level, value, false, false) || typeof value === "undefined" && writeNode(state, level, null, false, false)) {
      if (_result !== "") _result += "," + (!state.condenseFlow ? " " : "");
      _result += state.dump;
    }
  }
  state.tag = _tag;
  state.dump = "[" + _result + "]";
}
function writeBlockSequence(state, level, object3, compact2) {
  var _result = "", _tag = state.tag, index, length, value;
  for (index = 0, length = object3.length; index < length; index += 1) {
    value = object3[index];
    if (state.replacer) {
      value = state.replacer.call(object3, String(index), value);
    }
    if (writeNode(state, level + 1, value, true, true, false, true) || typeof value === "undefined" && writeNode(state, level + 1, null, true, true, false, true)) {
      if (!compact2 || _result !== "") {
        _result += generateNextLine(state, level);
      }
      if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
        _result += "-";
      } else {
        _result += "- ";
      }
      _result += state.dump;
    }
  }
  state.tag = _tag;
  state.dump = _result || "[]";
}
function writeFlowMapping(state, level, object3) {
  var _result = "", _tag = state.tag, objectKeyList = Object.keys(object3), index, length, objectKey, objectValue, pairBuffer;
  for (index = 0, length = objectKeyList.length; index < length; index += 1) {
    pairBuffer = "";
    if (_result !== "") pairBuffer += ", ";
    if (state.condenseFlow) pairBuffer += '"';
    objectKey = objectKeyList[index];
    objectValue = object3[objectKey];
    if (state.replacer) {
      objectValue = state.replacer.call(object3, objectKey, objectValue);
    }
    if (!writeNode(state, level, objectKey, false, false)) {
      continue;
    }
    if (state.dump.length > 1024) pairBuffer += "? ";
    pairBuffer += state.dump + (state.condenseFlow ? '"' : "") + ":" + (state.condenseFlow ? "" : " ");
    if (!writeNode(state, level, objectValue, false, false)) {
      continue;
    }
    pairBuffer += state.dump;
    _result += pairBuffer;
  }
  state.tag = _tag;
  state.dump = "{" + _result + "}";
}
function writeBlockMapping(state, level, object3, compact2) {
  var _result = "", _tag = state.tag, objectKeyList = Object.keys(object3), index, length, objectKey, objectValue, explicitPair, pairBuffer;
  if (state.sortKeys === true) {
    objectKeyList.sort();
  } else if (typeof state.sortKeys === "function") {
    objectKeyList.sort(state.sortKeys);
  } else if (state.sortKeys) {
    throw new exception("sortKeys must be a boolean or a function");
  }
  for (index = 0, length = objectKeyList.length; index < length; index += 1) {
    pairBuffer = "";
    if (!compact2 || _result !== "") {
      pairBuffer += generateNextLine(state, level);
    }
    objectKey = objectKeyList[index];
    objectValue = object3[objectKey];
    if (state.replacer) {
      objectValue = state.replacer.call(object3, objectKey, objectValue);
    }
    if (!writeNode(state, level + 1, objectKey, true, true, true)) {
      continue;
    }
    explicitPair = state.tag !== null && state.tag !== "?" || state.dump && state.dump.length > 1024;
    if (explicitPair) {
      if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
        pairBuffer += "?";
      } else {
        pairBuffer += "? ";
      }
    }
    pairBuffer += state.dump;
    if (explicitPair) {
      pairBuffer += generateNextLine(state, level);
    }
    if (!writeNode(state, level + 1, objectValue, true, explicitPair)) {
      continue;
    }
    if (state.dump && CHAR_LINE_FEED === state.dump.charCodeAt(0)) {
      pairBuffer += ":";
    } else {
      pairBuffer += ": ";
    }
    pairBuffer += state.dump;
    _result += pairBuffer;
  }
  state.tag = _tag;
  state.dump = _result || "{}";
}
function detectType(state, object3, explicit) {
  var _result, typeList, index, length, type2, style;
  typeList = explicit ? state.explicitTypes : state.implicitTypes;
  for (index = 0, length = typeList.length; index < length; index += 1) {
    type2 = typeList[index];
    if ((type2.instanceOf || type2.predicate) && (!type2.instanceOf || typeof object3 === "object" && object3 instanceof type2.instanceOf) && (!type2.predicate || type2.predicate(object3))) {
      if (explicit) {
        if (type2.multi && type2.representName) {
          state.tag = type2.representName(object3);
        } else {
          state.tag = type2.tag;
        }
      } else {
        state.tag = "?";
      }
      if (type2.represent) {
        style = state.styleMap[type2.tag] || type2.defaultStyle;
        if (_toString.call(type2.represent) === "[object Function]") {
          _result = type2.represent(object3, style);
        } else if (_hasOwnProperty.call(type2.represent, style)) {
          _result = type2.represent[style](object3, style);
        } else {
          throw new exception("!<" + type2.tag + '> tag resolver accepts not "' + style + '" style');
        }
        state.dump = _result;
      }
      return true;
    }
  }
  return false;
}
function writeNode(state, level, object3, block, compact2, iskey, isblockseq) {
  state.tag = null;
  state.dump = object3;
  if (!detectType(state, object3, false)) {
    detectType(state, object3, true);
  }
  var type2 = _toString.call(state.dump);
  var inblock = block;
  var tagStr;
  if (block) {
    block = state.flowLevel < 0 || state.flowLevel > level;
  }
  var objectOrArray = type2 === "[object Object]" || type2 === "[object Array]", duplicateIndex, duplicate;
  if (objectOrArray) {
    duplicateIndex = state.duplicates.indexOf(object3);
    duplicate = duplicateIndex !== -1;
  }
  if (state.tag !== null && state.tag !== "?" || duplicate || state.indent !== 2 && level > 0) {
    compact2 = false;
  }
  if (duplicate && state.usedDuplicates[duplicateIndex]) {
    state.dump = "*ref_" + duplicateIndex;
  } else {
    if (objectOrArray && duplicate && !state.usedDuplicates[duplicateIndex]) {
      state.usedDuplicates[duplicateIndex] = true;
    }
    if (type2 === "[object Object]") {
      if (block && Object.keys(state.dump).length !== 0) {
        writeBlockMapping(state, level, state.dump, compact2);
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + state.dump;
        }
      } else {
        writeFlowMapping(state, level, state.dump);
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + " " + state.dump;
        }
      }
    } else if (type2 === "[object Array]") {
      if (block && state.dump.length !== 0) {
        if (state.noArrayIndent && !isblockseq && level > 0) {
          writeBlockSequence(state, level - 1, state.dump, compact2);
        } else {
          writeBlockSequence(state, level, state.dump, compact2);
        }
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + state.dump;
        }
      } else {
        writeFlowSequence(state, level, state.dump);
        if (duplicate) {
          state.dump = "&ref_" + duplicateIndex + " " + state.dump;
        }
      }
    } else if (type2 === "[object String]") {
      if (state.tag !== "?") {
        writeScalar(state, state.dump, level, iskey, inblock);
      }
    } else if (type2 === "[object Undefined]") {
      return false;
    } else {
      if (state.skipInvalid) return false;
      throw new exception("unacceptable kind of an object to dump " + type2);
    }
    if (state.tag !== null && state.tag !== "?") {
      tagStr = encodeURI(
        state.tag[0] === "!" ? state.tag.slice(1) : state.tag
      ).replace(/!/g, "%21");
      if (state.tag[0] === "!") {
        tagStr = "!" + tagStr;
      } else if (tagStr.slice(0, 18) === "tag:yaml.org,2002:") {
        tagStr = "!!" + tagStr.slice(18);
      } else {
        tagStr = "!<" + tagStr + ">";
      }
      state.dump = tagStr + " " + state.dump;
    }
  }
  return true;
}
function getDuplicateReferences(object3, state) {
  var objects = [], duplicatesIndexes = [], index, length;
  inspectNode(object3, objects, duplicatesIndexes);
  for (index = 0, length = duplicatesIndexes.length; index < length; index += 1) {
    state.duplicates.push(objects[duplicatesIndexes[index]]);
  }
  state.usedDuplicates = new Array(length);
}
function inspectNode(object3, objects, duplicatesIndexes) {
  var objectKeyList, index, length;
  if (object3 !== null && typeof object3 === "object") {
    index = objects.indexOf(object3);
    if (index !== -1) {
      if (duplicatesIndexes.indexOf(index) === -1) {
        duplicatesIndexes.push(index);
      }
    } else {
      objects.push(object3);
      if (Array.isArray(object3)) {
        for (index = 0, length = object3.length; index < length; index += 1) {
          inspectNode(object3[index], objects, duplicatesIndexes);
        }
      } else {
        objectKeyList = Object.keys(object3);
        for (index = 0, length = objectKeyList.length; index < length; index += 1) {
          inspectNode(object3[objectKeyList[index]], objects, duplicatesIndexes);
        }
      }
    }
  }
}
function dump$1(input, options) {
  options = options || {};
  var state = new State2(options);
  if (!state.noRefs) getDuplicateReferences(input, state);
  var value = input;
  if (state.replacer) {
    value = state.replacer.call({ "": value }, "", value);
  }
  if (writeNode(state, 0, value, true, true)) return state.dump + "\n";
  return "";
}
var dump_1 = dump$1;
var dumper = {
  dump: dump_1
};
function renamed(from, to) {
  return function () {
    throw new Error("Function yaml." + from + " is removed in js-yaml 4. Use yaml." + to + " instead, which is now safe by default.");
  };
}
var Type2 = type;
var Schema2 = schema;
var FAILSAFE_SCHEMA = failsafe;
var JSON_SCHEMA = json;
var CORE_SCHEMA = core;
var DEFAULT_SCHEMA = _default;
var load = loader.load;
var loadAll = loader.loadAll;
var dump = dumper.dump;
var YAMLException = exception;
var types = {
  binary,
  float,
  map,
  null: _null,
  pairs,
  set: set3,
  timestamp,
  bool,
  int,
  merge,
  omap,
  seq,
  str
};
var safeLoad = renamed("safeLoad", "load");
var safeLoadAll = renamed("safeLoadAll", "loadAll");
var safeDump = renamed("safeDump", "dump");
var jsYaml = {
  Type: Type2,
  Schema: Schema2,
  FAILSAFE_SCHEMA,
  JSON_SCHEMA,
  CORE_SCHEMA,
  DEFAULT_SCHEMA,
  load,
  loadAll,
  dump,
  YAMLException,
  types,
  safeLoad,
  safeLoadAll,
  safeDump
};
var js_yaml_default = jsYaml;

// ../../cli/workspace/commons/lib/openapi/BaseOpenAPIWorkspace.js
var BaseOpenAPIWorkspace = class extends AbstractAPIWorkspace {
  inlinePathParameters;
  objectQueryParameters;
  onlyIncludeReferencedSchemas;
  respectReadonlySchemas;
  constructor(args) {
    super(args);
    this.inlinePathParameters = args.inlinePathParameters;
    this.objectQueryParameters = args.objectQueryParameters;
    this.onlyIncludeReferencedSchemas = args.onlyIncludeReferencedSchemas;
    this.respectReadonlySchemas = args.respectReadonlySchemas;
  }
  async getDefinition({ context, absoluteFilePath, relativePathToDependency }, settings) {
    const openApiIr = await this.getOpenAPIIr({ context, relativePathToDependency }, settings);
    const definition = convert({
      authOverrides: this.generatorsConfiguration?.api?.auth != null ? { ...this.generatorsConfiguration?.api } : void 0,
      environmentOverrides: this.generatorsConfiguration?.api?.environments != null ? { ...this.generatorsConfiguration?.api } : void 0,
      globalHeaderOverrides: this.generatorsConfiguration?.api?.headers != null ? { ...this.generatorsConfiguration?.api } : void 0,
      taskContext: context,
      ir: openApiIr,
      enableUniqueErrorsPerEndpoint: settings?.enableUniqueErrorsPerEndpoint ?? false,
      detectGlobalHeaders: settings?.detectGlobalHeaders ?? true,
      objectQueryParameters: this.objectQueryParameters,
      respectReadonlySchemas: this.respectReadonlySchemas,
      onlyIncludeReferencedSchemas: this.onlyIncludeReferencedSchemas,
      inlinePathParameters: this.inlinePathParameters
    });
    return {
      absoluteFilePath: absoluteFilePath ?? this.absoluteFilePath,
      rootApiFile: {
        defaultUrl: definition.rootApiFile["default-url"],
        contents: definition.rootApiFile,
        rawContents: js_yaml_default.dump(definition.rootApiFile)
      },
      namedDefinitionFiles: {
        ...mapValues_default(definition.definitionFiles, (definitionFile) => ({
          absoluteFilepath: absoluteFilePath ?? this.absoluteFilePath,
          rawContents: js_yaml_default.dump(definitionFile),
          contents: definitionFile
        })),
        [RelativeFilePath.of(FERN_PACKAGE_MARKER_FILENAME)]: {
          absoluteFilepath: absoluteFilePath ?? this.absoluteFilePath,
          rawContents: js_yaml_default.dump(definition.packageMarkerFile),
          contents: definition.packageMarkerFile
        }
      },
      packageMarkers: {},
      importedDefinitions: {}
    };
  }
  async toFernWorkspace({ context }, settings) {
    const definition = await this.getDefinition({ context }, settings);
    return new FernWorkspace({
      absoluteFilePath: this.absoluteFilePath,
      workspaceName: this.workspaceName,
      generatorsConfiguration: this.generatorsConfiguration,
      dependenciesConfiguration: {
        dependencies: {}
      },
      definition,
      cliVersion: this.cliVersion
    });
  }
};

// ../../cli/workspace/commons/lib/openapi/getOptionsOverridesFromSettings.js
function getOptionsOverridesFromSettings(settings) {
  if (settings == null) {
    return void 0;
  }
  const result = {};
  if (settings.enableDiscriminatedUnionV2) {
    result.discriminatedUnionV2 = true;
  }
  if (settings.optionalAdditionalProperties) {
    result.optionalAdditionalProperties = true;
  }
  if (settings.cooerceEnumsToLiterals) {
    result.cooerceEnumsToLiterals = true;
  }
  if (settings.preserveSchemaIds) {
    result.preserveSchemaIds = true;
  }
  return result;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/asyncapi/options.js
var DEFAULT_PARSE_ASYNCAPI_SETTINGS = {
  naming: "v1"
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/getExtension.js
function getExtension(object3, extension) {
  const extensions = Array.isArray(extension) ? extension : [extension];
  for (const extension2 of extensions) {
    const extensionValue = object3[extension2];
    if (extensionValue != null) {
      return extensionValue;
    }
  }
  return void 0;
}
function getExtensionAndValidate(object3, extension, schema2, logger, breadcrumbs = []) {
  try {
    const extensionValue = getExtension(object3, extension);
    if (extensionValue != null) {
      return schema2.parse(extensionValue);
    }
  } catch (e) {
    const breadcrumb = compact_default(breadcrumbs).join(" -> ");
    logger.error(`${breadcrumb.length > 0 ? `${breadcrumb}: ` : ""}Failed to parse ${extension}`);
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/id.js
var TypedExtensionId = {
  of(key) {
    return key;
  }
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/fernExtensions.js
var XFernStreaming = {
  properties: {
    "stream-condition": { type: "string" },
    response: "Schema",
    "response-stream": "Schema"
  },
  required: ["stream-condition", "response", "response-stream"],
  extensionsPrefix: "x-"
};
var FERN_TYPE_EXTENSIONS = {
  id: "",
  typeExtension: {
    oas3: (types2) => {
      return {
        ...types2,
        XFernStreaming,
        Operation: {
          ...types2.Operation,
          properties: {
            ...types2.Operation?.properties,
            "x-fern-streaming": "XFernStreaming"
          }
        }
      };
    }
  }
};
var FernOpenAPIExtension = {
  SDK_METHOD_NAME: TypedExtensionId.of("x-fern-sdk-method-name"),
  SDK_GROUP_NAME: TypedExtensionId.of("x-fern-sdk-group-name"),
  REQUEST_NAME_V1: "x-request-name",
  REQUEST_NAME_V2: "x-fern-request-name",
  TYPE_NAME: "x-fern-type-name",
  BOOLEAN_LITERAL: "x-fern-boolean-literal",
  SERVER_NAME_V1: "x-name",
  SERVER_NAME_V2: "x-fern-server-name",
  /**
   * Prepends the configured base path to all of the endpoint paths.
   *
   * x-fern-base-path: /v1
   * servers:
   *   - url: https://api.example.com
   * paths:
   *   /path/to/my/endpoint:
   */
  BASE_PATH: "x-fern-base-path",
  /**
   * Should align with the OpenAPI spec's `x-fern-sdk-group-name` extension.
   * This is a place where you can specify any display names related to the
   * configured SDK group names. These display names and descriptions will
   * come through in the docs.
   *
   * x-fern-groups:
   *  group1:
   *    display-name: Group 1
   *    description: This is group 1
   *    groups:
   *      group2 # add child groups
   */
  GROUPS: TypedExtensionId.of("x-fern-groups"),
  /**
   * Filepath that contains any OpenAPI overrides
   * that you wan't Fern to add on top of your existing spec.
   *
   * x-fern-overrides-filepath: relative/path/to/file
   */
  OPENAPI_OVERIDES_FILEPATH: "x-fern-overrides-filepath",
  /**
   * Used to override the type with fern's type syntax
   * Bar:
   *  properties:
   *    createdDate:
   *      type: string
   *      x-fern-type: datetime
   *      x-fern-type:
   *        properties:
   *         a: string
   *         b: integer
   *      x-fern-type: optional<map<string, integer>>
   */
  TYPE_DEFINITION: "x-fern-type",
  /**
   * Used to specify if an endpoint should be generated
   * as a streaming endpoint.
   *
   * Example usage:
   *   paths:
   *     /path/to/my/endpoint:
   *       x-fern-streaming: true
   *
   * Used to specify if an endpoint should be generated
   * as a streaming endpoint with sever-sent0events.
   *
   * Example usage:
   *   paths:
   *     /path/to/my/endpoint:
   *       x-fern-streaming:
   *          format: sse
   *
   * Alternatively, you can annotate the endpoint so that
   * it generates both a traditional unary endpoint,
   * as well as its streaming equivalent. The stream
   * condition property is included to specify a boolean
   * propetry that tells the server whether or not the
   * response should be streamed or not.
   *
   * Example usage:
   *   paths:
   *     /path/to/my/endpoint:
   *       x-fern-streaming:
   *         format: sse # or json
   *         stream-condition: $request.stream
   *         stream-description: A description
   *         response:
   *           $ref: ./path/to/response/type.yaml
   *         response-stream:
   *           $ref: ./path/to/response-stream/type.yaml
   */
  STREAMING: "x-fern-streaming",
  /**
   * Used to specify if an endpoint should be generated
   * as a paginated endpoint. Both cursor and offset pagination
   * examples are shown below.
   *
   * Example usage:
   *   paths:
   *     /path/to/my/endpoint:
   *       x-fern-pagination:
   *         cursor: $request.cursor
   *         next_cursor: $response.next
   *         results: $response.results
   *
   * Alternatively, if the configuration shown above is
   * specified at the document-level, paths can inherit the
   * configuration by setting the extension to true.
   *
   * Example usage:
   *   x-fern-pagination:
   *     offset: $request.page_number
   *     results: $response.results
   *
   *   paths:
   *     /path/to/my/endpoint:
   *       x-fern-pagination: true
   */
  PAGINATION: "x-fern-pagination",
  /**
   * Used to specify if an endpoint is actually
   * representing a webhook
   * Example usage:
   *   paths:
   *     /path/to/my/endpoint:
   *       x-fern-webhook: true
   */
  WEBHOOK: "x-fern-webhook",
  /**
   * Used to detect if an endpoint has an async version of it
   * Example usage:
   *   paths:
   *    /path/to/my/endpoint:
   *      x-fern-async-config:
   *        discriminant:
   *          type: header
   *          name: X-Header-Name
   *          value: async
   *        response-status-code: 202
   **/
  ASYNC_CONFIG: "x-fern-async-config",
  /**
   * Used to create veriables in the fern definition
   * Example usage:
   * x-fern-sdk-variables:
   *   appName:
   *     type: string
   * paths:
   *   /path/to/my/endpoint/{id}:
   *     parameters:
   *       - name: id
   *         in: path
   *         type: string
   *         x-fern-sdk-variable: appName
   */
  SDK_VARIABLES: "x-fern-sdk-variables",
  SDK_VARIABLE: "x-fern-sdk-variable",
  /**
   * Used to customize the name of the parameter used for a header.
   * Example usage:
   * paths:
   *   /path/to/my/endpoint/{id}:
   *     parameters:
   *       - in: header
   *         name: X-Fern-Version
   *         type: string
   *         x-fern-parameter-name: version
   */
  PARAMETER_NAME: "x-fern-parameter-name",
  /**
   * securitySchemes:
   *   Basic:
   *     scheme: http
   *     type: basic
   *     x-fern-username-variable-name: clientId
   *     x-fern-password-variable-name: clientSecret
   */
  BASIC_AUTH_USERNAME_VARIABLE_NAME: "x-fern-username-variable-name",
  BASIC_AUTH_PASSWORD_VARIABLE_NAME: "x-fern-password-variable-name",
  /**
   * securitySchemes:
   *   Bearer:
   *     scheme: http
   *     type: bearer
   *     x-fern-token-variable-name: apiKey
   */
  BEARER_TOKEN_VARIABLE_NAME: "x-fern-token-variable-name",
  /**
   * securitySchemes:
   *   Bearer:
   *     type: apiKey
   *     in: header
   *     name: X-API-KEY-ID
   *     x-fern-header-variable-name: apiKeyId
   */
  HEADER_VARIABLE_NAME: "x-fern-header-variable-name",
  /**
   * The x-fern-enum allows you to specify docs for the enum value.
   * If your enum is not codegen friendly (not alphanumeric), then you can specify a codegen name as well.
   *
   * MyEnum:
   *   enum:
   *     - VARIANT_ONE
   *     - VARIANT_TWO
   *   x-fern-enum:
   *     VARIANT_ONE:
   *       description: These are docs about the enum
   *       name: ONE
   */
  FERN_ENUM: "x-fern-enum",
  /**
   * Used to mark operations with audiences
   *
   * paths:
   *   /path/to/my/endpoint/{id}:
   *     x-fern-audiences:
   *       - external
   */
  AUDIENCES: "x-fern-audiences",
  /**
   * Used to tell fern to ignore endpoints.
   *
   * paths:
   *   /path/to/my/endpoint/{id}:
   *     get:
   *       x-fern-ignore: true
   */
  IGNORE: "x-fern-ignore",
  /**
   * paths:
   *  /path/to/my:
   *    get:
   *      x-fern-availability: ga # or beta, generally-available, deprecated,
   */
  AVAILABILITY: "x-fern-availability",
  /**
   * Used to signal that the SDK should return a specific property on the response.
   *
   * paths:
   *  /path/to/my:
   *    get:
   *      x-fern-sdk-return-value: data
   */
  RESPONSE_PROPERTY: "x-fern-sdk-return-value",
  /**
   * Used to resolve multiple schemas into a single schema. All the references
   * are replaced with a single schema.
   *
   * x-fern-resolutions:
   *  - name: User
   *    resolutions:
   *      - `#/components/schemas/Group/properties/user`
   *      - `#/components/schemas/User`
   */
  RESOLUTIONS: "x-fern-resolutions",
  /**
   * paths:
   *  /path/to/my:
   *    get:
   *     x-fern-examples:
   *      - name: Example 1
   *        docs: This is an example
   *        request: {}
   *        response:
   *          body: {}
   *        code-samples:
   *          - language: typescript
   *            install: npm install my-client
   *            code: |
   *              import { MyClient } from "my-client";
   *              const client = new MyClient();
   *              const response = await client.myEndpoint();
   *              console.log(response);
   *            name: Console Log My Endpoint
   *            description: This is a code sample that logs the response
   */
  EXAMPLES: "x-fern-examples",
  /**
   * securitySchemes:
   *   Bearer:
   *     scheme: http
   *     type: bearer
   *     x-fern-bearer:
   *       name: apiKey
   *       env: MY_AUTH_TOKEN
   */
  FERN_BEARER_TOKEN: "x-fern-bearer",
  /**
   * securitySchemes:
   *   Bearer:
   *     type: apiKey
   *     in: header
   *     name: X-API-KEY-ID
   *     x-fern-header:
   *       name: header
   *       env: MY_AUTH_TOKEN
   */
  FERN_HEADER_AUTH: "x-fern-header",
  /**
   * securitySchemes:
   *   Basic:
   *     scheme: http
   *     type: basic
   *     x-fern-basic:
   *       username:
   *          name: username
   *          env: MY_USERNAME
   *       password:
   *          name: password
   *          env: MY_PASSWORD
   */
  FERN_BASIC_AUTH: "x-fern-basic",
  /**
   * Allows users to specify which headers are global, and an optional alias for them
   * `header` is the name of the header used throughout your spec, while `name` is the
   * alias you'd like it to appear as within your generated SDK to the consumer.
   *
   * x-fern-global-headers:
   *  - header: our_api_key
   *    name: api_key
   *    optional: true
   *  - header: telemetry_id
   *    env: MY_ENVVAR
   *  - header: X-API-Version
   *    name: version
   *    type: literal<"2.10"> # The type of the header to use
   */
  FERN_GLOBAL_HEADERS: "x-fern-global-headers",
  /**
   * Allows users to specify which headers are idempotent.
   *
   * x-fern-idempotency-headers:
   *  - header: our_api_key
   *    name: api_key
   *    optional: true
   *  - header: telemetry_id
   *    env: MY_ENVVAR
   *  - header: X-API-Version
   *    name: version
   *    type: literal<"2.10"> # The type of the header to use
   */
  FERN_IDEMPOTENCY_HEADERS: "x-fern-idempotency-headers",
  /**
   * Mark a particular endpoint as idempotent.
   *
   * paths:
   *  send:
   *    post:
   *      x-fern-idempotent: true
   */
  IDEMPOTENT: "x-fern-idempotent",
  /**
   * Allows a user to configure the property name for the schema.
   */
  FERN_PROPERTY_NAME: "x-fern-property-name",
  /**
   * Allows a user to configure that a union wiht a discriminant should
   * be undiscriminated.
   *
   * Shape:
   *   x-fern-undiscriminated: true
   *   oneOf:
   *    - $ref: components/schemas/Triangle
   *    - $ref: components/schemas/Square
   */
  IS_UNDISCRIMINATED: "x-fern-undiscriminated",
  /**
   * Allows users to specify the version scheme supported by the API.
   *
   * x-fern-version:
   *   header: X-API-Version
   *   default: "2.0"
   *   values:
   *     - "1.0"
   *     - "2.0"
   *     - "Latest"
   */
  FERN_VERSION: "x-fern-version",
  /**
   * Allows users to specify the encoding of the type. For example, suppose you need to configure
   * Protobuf-encoding details like the following:
   *
   * User:
   *  properties:
   *    username:
   *      type: string
   *  x-fern-encoding:
   *    proto:
   *      type: user.v1.User
   */
  ENCODING: "x-fern-encoding",
  /**
   * Allows users to configure gRPC services. This must be specified on individual service
   * declarations.
   *
   * x-fern-transport:
   *   grpc:
   *     service-name: UserService
   */
  TRANSPORT: "x-fern-transport"
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/isReferenceObject.js
function isReferenceObject(parameter) {
  return parameter.$ref != null;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertAvailability.js
function convertAvailability3(propertySchema) {
  switch (getExtension(propertySchema, FernOpenAPIExtension.AVAILABILITY)) {
    case "deprecated":
      return Availability.Deprecated;
    case "beta":
      return Availability.Beta;
    case "generally-available":
      return Availability.GenerallyAvailable;
    default:
      break;
  }
  if (!isReferenceObject(propertySchema) && propertySchema.deprecated) {
    return Availability.Deprecated;
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/extensions.js
var OpenAPIExtension = {
  BEARER_FORMAT: "x-bearer-format",
  /* This is an extension that several OpenAPI generators use that we support */
  ENUM_VAR_NAMES: "x-enum-varnames",
  /* This extension is a boolean that several generators use */
  INTERNAL: "x-internal",
  /* This extension is used for specifying examples */
  EXAMPLES: "x-examples",
  /* This extension is used for specifying tags on schemas*/
  TAGS: "x-tags",
  /* https://redocly.com/docs/api-reference-docs/specification-extensions/x-code-samples/ */
  REDOCLY_CODE_SAMPLES_KEBAB: "x-code-samples",
  REDOCLY_CODE_SAMPLES_CAMEL: "x-codeSamples"
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getExamples.js
function getExamples(schema2) {
  const examples = getExtension(schema2, "examples");
  if (examples != null && Array.isArray(examples)) {
    return examples;
  }
  return [];
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernEncoding.js
function getFernEncoding({ schema: schema2, logger }) {
  return getExtension(schema2, FernOpenAPIExtension.ENCODING) ?? void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernEnum.js
function getFernEnum(schema2) {
  return getExtension(schema2, FernOpenAPIExtension.FERN_ENUM);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernTypeExtension.js
function getFernTypeExtension({ nameOverride, generatedName, title, schema: schema2, description, availability }) {
  const groupName = getExtension(schema2, FernOpenAPIExtension.SDK_GROUP_NAME);
  const fernType = getExtension(schema2, FernOpenAPIExtension.TYPE_DEFINITION);
  if (fernType == null) {
    return;
  }
  return getSchemaFromFernType({
    fernType,
    nameOverride,
    generatedName,
    title,
    description,
    availability,
    groupName: typeof groupName === "string" ? [groupName] : groupName
  });
}
function getSchemaFromFernType({ fernType, nameOverride, generatedName, title, description, availability, groupName }) {
  return recursivelyVisitRawTypeReference({
    type: fernType,
    _default: void 0,
    validation: void 0,
    visitor: {
      primitive: (primitive) => {
        switch (primitive.v1) {
          case "BASE_64":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.base64({
                example: void 0
              })
            });
          case "BOOLEAN":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.boolean({
                default: void 0,
                example: void 0
              })
            });
          case "DATE":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.date({
                example: void 0
              })
            });
          case "DATE_TIME":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.datetime({
                example: void 0
              })
            });
          case "FLOAT":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.float({
                example: void 0
              })
            });
          case "DOUBLE":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.double({
                default: void 0,
                minimum: void 0,
                maximum: void 0,
                exclusiveMinimum: void 0,
                exclusiveMaximum: void 0,
                multipleOf: void 0,
                example: void 0
              })
            });
          case "UINT":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.uint({
                default: void 0,
                example: void 0
              })
            });
          case "INTEGER":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.int({
                default: void 0,
                minimum: void 0,
                maximum: void 0,
                exclusiveMinimum: void 0,
                exclusiveMaximum: void 0,
                multipleOf: void 0,
                example: void 0
              })
            });
          case "UINT_64":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.uint64({
                default: void 0,
                example: void 0
              })
            });
          case "LONG":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.int64({
                default: void 0,
                example: void 0
              })
            });
          case "STRING":
          case "UUID":
          case "BIG_INTEGER":
            return SchemaWithExample.primitive({
              nameOverride,
              generatedName,
              title,
              description,
              availability,
              groupName,
              schema: PrimitiveSchemaValueWithExample.string({
                default: void 0,
                pattern: void 0,
                maxLength: void 0,
                minLength: void 0,
                example: void 0,
                format: void 0
              })
            });
          default:
            assertNever(primitive.v1);
        }
      },
      unknown: () => {
        return SchemaWithExample.unknown({
          nameOverride,
          generatedName,
          title,
          example: void 0,
          description,
          availability,
          groupName
        });
      },
      map: ({ keyType, valueType }) => keyType?.type === "primitive" && valueType != null ? SchemaWithExample.map({
        nameOverride,
        generatedName,
        title,
        key: keyType,
        value: valueType,
        description,
        availability,
        groupName,
        encoding: void 0,
        example: void 0
      }) : void 0,
      list: (itemType) => itemType != null ? SchemaWithExample.array({
        nameOverride,
        generatedName,
        title,
        value: itemType,
        description,
        availability,
        groupName,
        example: void 0
      }) : void 0,
      optional: (itemType) => itemType != null ? SchemaWithExample.optional({
        nameOverride,
        generatedName,
        title,
        value: itemType,
        description,
        availability,
        groupName
      }) : void 0,
      set: (itemType) => itemType != null ? SchemaWithExample.array({
        nameOverride,
        generatedName,
        title,
        value: itemType,
        description,
        availability,
        groupName,
        example: void 0
      }) : void 0,
      literal: (literal) => SchemaWithExample.literal({
        nameOverride,
        generatedName,
        title,
        value: literal._visit({
          string: (value) => LiteralSchemaValue.string(value),
          boolean: (value) => LiteralSchemaValue.boolean(value),
          _other: () => {
            throw new Error("Unexpected literal type");
          }
        }),
        description,
        availability,
        groupName
      }),
      named: () => {
        return void 0;
      }
    }
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/utils/getValue.js
function getValueIfBoolean(value) {
  if (value != null && typeof value === "boolean") {
    return value;
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertAdditionalProperties.js
function convertAdditionalProperties({ nameOverride, generatedName, title, breadcrumbs, additionalProperties, description, availability, wrapAsNullable, context, groupName, example, encoding, source, namespace }) {
  if (typeof additionalProperties === "boolean" || isAdditionalPropertiesAny(additionalProperties)) {
    return wrapMap({
      nameOverride,
      generatedName,
      title,
      wrapAsNullable,
      description,
      availability,
      keySchema: {
        nameOverride: void 0,
        generatedName: `${generatedName}Key`,
        title: void 0,
        description: void 0,
        availability: void 0,
        schema: PrimitiveSchemaValueWithExample.string({
          default: void 0,
          pattern: void 0,
          format: void 0,
          minLength: void 0,
          maxLength: void 0,
          example: void 0
        }),
        groupName: void 0
      },
      valueSchema: SchemaWithExample.unknown({
        nameOverride: void 0,
        generatedName: `${generatedName}Value`,
        title: void 0,
        description: void 0,
        availability: void 0,
        example: void 0,
        groupName: void 0
      }),
      groupName,
      example,
      encoding
    });
  }
  return wrapMap({
    nameOverride,
    generatedName,
    title,
    wrapAsNullable,
    description,
    availability,
    keySchema: {
      nameOverride: void 0,
      generatedName: `${generatedName}Key`,
      title: void 0,
      description: void 0,
      availability: void 0,
      schema: PrimitiveSchemaValueWithExample.string({
        default: void 0,
        pattern: void 0,
        format: void 0,
        minLength: void 0,
        maxLength: void 0,
        example: void 0
      }),
      groupName: void 0
    },
    valueSchema: convertSchema(additionalProperties, context.options.optionalAdditionalProperties ? wrapAsNullable : false, context, [...breadcrumbs, "Value"], source, namespace),
    groupName,
    example,
    encoding
  });
}
function wrapMap({ nameOverride, generatedName, title, keySchema, valueSchema, wrapAsNullable, description, availability, groupName, example, encoding }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.map({
        nameOverride,
        generatedName,
        title,
        description,
        availability: keySchema.availability,
        key: keySchema,
        value: valueSchema,
        groupName,
        encoding,
        example
      }),
      description,
      availability,
      groupName
    });
  }
  return SchemaWithExample.map({
    nameOverride,
    generatedName,
    title,
    description,
    availability,
    key: keySchema,
    value: valueSchema,
    groupName,
    encoding,
    example
  });
}
function isAdditionalPropertiesAny(additionalProperties) {
  if (additionalProperties == null) {
    return false;
  }
  if (typeof additionalProperties === "boolean") {
    return additionalProperties;
  }
  return !isReferenceObject(additionalProperties) && Object.keys(additionalProperties).length === 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertArray.js
function convertArray({ nameOverride, generatedName, title, breadcrumbs, item, description, availability, wrapAsNullable, context, groupName, example, source, namespace }) {
  const itemSchema = item == null ? SchemaWithExample.unknown({
    nameOverride,
    generatedName,
    title,
    description: void 0,
    availability: void 0,
    example: void 0,
    groupName
  }) : convertSchema(item, false, context, [...breadcrumbs, "Item"], source, namespace);
  return wrapArray({
    nameOverride,
    generatedName,
    title,
    groupName,
    itemSchema,
    wrapAsNullable,
    description,
    availability,
    example
  });
}
function wrapArray({ nameOverride, generatedName, title, itemSchema, wrapAsNullable, description, availability, groupName, example }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.array({
        nameOverride,
        generatedName,
        title,
        value: itemSchema,
        description,
        availability,
        groupName,
        example
      }),
      description,
      availability,
      groupName
    });
  }
  return SchemaWithExample.array({
    nameOverride,
    generatedName,
    title,
    value: itemSchema,
    description,
    availability,
    groupName,
    example
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertDiscriminatedOneOf.js
function convertDiscriminatedOneOf({ nameOverride, generatedName, title, breadcrumbs, properties, description, availability, required, wrapAsNullable, discriminator, context, groupName, encoding, source, namespace }) {
  const discriminant3 = discriminator.propertyName;
  const unionSubTypes = Object.fromEntries(Object.entries(discriminator.mapping ?? {}).map(([discriminantValue, schema2]) => {
    const subtypeReference = convertReferenceObject({
      $ref: schema2
    }, false, context, [schema2], encoding, source, namespace);
    context.markReferencedByDiscriminatedUnion({
      $ref: schema2
    }, discriminant3, 1);
    return [discriminantValue, subtypeReference];
  }));
  const convertedProperties = Object.entries(properties).filter(([propertyName]) => {
    return propertyName !== discriminant3;
  }).map(([propertyName, propertySchema]) => {
    const isRequired = required != null && required.includes(propertyName);
    const schema2 = convertSchema(propertySchema, !isRequired, context, [...breadcrumbs, propertyName], source, namespace);
    return {
      key: propertyName,
      schema: schema2
    };
  });
  return wrapDiscriminantedOneOf({
    nameOverride,
    generatedName,
    title,
    wrapAsNullable,
    properties: convertedProperties,
    description,
    availability,
    discriminant: discriminant3,
    subtypes: unionSubTypes,
    groupName,
    source
  });
}
function convertDiscriminatedOneOfWithVariants({ nameOverride, generatedName, title, breadcrumbs, properties, description, availability, required, wrapAsNullable, discriminant: discriminant3, variants, context, groupName, encoding, source, namespace }) {
  const unionSubTypes = Object.fromEntries(Object.entries(variants).map(([discriminantValue, schema2]) => {
    if (isReferenceObject(schema2)) {
      const subtypeReference = convertReferenceObject(schema2, false, context, [schema2.$ref], encoding, source, namespace);
      context.markReferencedByDiscriminatedUnion(schema2, discriminant3, 1);
      return [discriminantValue, subtypeReference];
    } else {
      const variantSchema = convertSchemaObject(schema2, false, context, [...breadcrumbs, discriminantValue], encoding, source, namespace, /* @__PURE__ */ new Set([discriminant3]));
      return [discriminantValue, variantSchema];
    }
  }));
  const convertedProperties = Object.entries(properties).filter(([propertyName]) => {
    return propertyName !== discriminant3;
  }).map(([propertyName, propertySchema]) => {
    const isRequired = required != null && required.includes(propertyName);
    const schema2 = convertSchema(propertySchema, !isRequired, context, [...breadcrumbs, propertyName], source, namespace);
    return {
      key: propertyName,
      schema: schema2
    };
  });
  return wrapDiscriminantedOneOf({
    nameOverride,
    generatedName,
    title,
    wrapAsNullable,
    properties: convertedProperties,
    description,
    availability,
    discriminant: discriminant3,
    subtypes: unionSubTypes,
    groupName,
    source
  });
}
function wrapDiscriminantedOneOf({ nameOverride, generatedName, title, wrapAsNullable, properties, description, availability, discriminant: discriminant3, subtypes, groupName, source }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.oneOf(OneOfSchemaWithExample.discriminated({
        description,
        availability,
        discriminantProperty: discriminant3,
        nameOverride,
        generatedName,
        title,
        schemas: subtypes,
        commonProperties: properties,
        groupName,
        encoding: void 0,
        source
      })),
      groupName,
      description,
      availability
    });
  }
  return SchemaWithExample.oneOf(OneOfSchemaWithExample.discriminated({
    description,
    availability,
    discriminantProperty: discriminant3,
    nameOverride,
    generatedName,
    title,
    schemas: subtypes,
    commonProperties: properties,
    groupName,
    encoding: void 0,
    source
  }));
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertEncoding.js
function convertEncoding(encodingSchema) {
  if (encodingSchema.proto != null) {
    return Encoding.protobuf({
      typeName: encodingSchema.proto.type
    });
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertEnum.js
function convertEnum({ nameOverride, generatedName, title, fernEnum, enumVarNames, enumValues, _default: _default2, description, availability, wrapAsNullable, groupName, context, source }) {
  const strippedEnumVarNames = stripCommonPrefix(enumVarNames ?? []);
  const uniqueValues = new Set(enumValues);
  const values = Array.from(uniqueValues).map((value, index) => {
    const fernEnumValue = fernEnum?.[value];
    const enumVarName = strippedEnumVarNames[index];
    const valueIsValidName = VALID_ENUM_NAME_REGEX.test(value);
    let nameOverride2 = fernEnumValue?.name ?? enumVarName;
    const generatedName2 = valueIsValidName ? value : generateEnumNameFromValue(value);
    if (nameOverride2 != null && !VALID_ENUM_NAME_REGEX.test(nameOverride2)) {
      context?.logger.warn(`Enum name override ${nameOverride2} is not a valid name. Falling back on ${generatedName2}.`);
      nameOverride2 = void 0;
    }
    return {
      nameOverride: nameOverride2,
      generatedName: generatedName2,
      value,
      description: fernEnumValue?.description,
      availability,
      casing: {
        snake: fernEnumValue?.casing?.snake ?? void 0,
        pascal: fernEnumValue?.casing?.pascal ?? void 0,
        screamingSnake: fernEnumValue?.casing?.screamingSnake ?? void 0,
        camel: fernEnumValue?.casing?.camel ?? void 0
      }
    };
  });
  const _defaultEnumValue = _default2 != null ? values.find((value) => value.value === _default2) : void 0;
  return wrapEnum({
    wrapAsNullable,
    nameOverride,
    generatedName,
    title,
    values,
    _default: _defaultEnumValue,
    description,
    availability,
    groupName,
    source
  });
}
function wrapEnum({ wrapAsNullable, nameOverride, generatedName, title, values, _default: _default2, description, availability, groupName, source }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.enum({
        nameOverride,
        generatedName,
        title,
        values,
        description,
        default: _default2,
        availability,
        example: void 0,
        groupName,
        source
      }),
      description,
      availability,
      groupName
    });
  }
  return SchemaWithExample.enum({
    nameOverride,
    generatedName,
    title,
    values,
    description,
    availability,
    default: _default2,
    example: void 0,
    groupName,
    source
  });
}
function stripCommonPrefix(names) {
  if (names.length <= 1 || names[0] == null) {
    return names;
  }
  const nameZero = names[0];
  let i = 0;
  while (nameZero[i] != null && names.every((name) => name[i] === nameZero[i])) {
    i++;
  }
  return names.map((name) => name.substring(i));
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertInteger.js
function convertInteger({ nameOverride, generatedName, title, format, _default: _default2, minimum, maximum, exclusiveMinimum, exclusiveMaximum, multipleOf, description, availability, wrapAsNullable, example, groupName }) {
  if (format === "int64") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.int64({
        default: _default2,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "uint32") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.uint({
        default: _default2,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "uint64") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.uint64({
        default: _default2,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  }
  return wrapPrimitive({
    nameOverride,
    generatedName,
    title,
    primitive: PrimitiveSchemaValueWithExample.int({
      default: _default2,
      minimum,
      maximum,
      exclusiveMinimum,
      exclusiveMaximum,
      multipleOf,
      example
    }),
    wrapAsNullable,
    description,
    availability,
    groupName
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertLiteral.js
function createLiteralSchemaValue(value) {
  if (typeof value === "string") {
    return LiteralSchemaValue.string(value);
  } else if (typeof value === "boolean") {
    return LiteralSchemaValue.boolean(value);
  } else {
    return LiteralSchemaValue.string(`${value}`);
  }
}
function convertLiteral({ nameOverride, generatedName, title, wrapAsNullable, value, description, availability, groupName }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.literal({
        nameOverride,
        generatedName,
        title,
        value: createLiteralSchemaValue(value),
        description,
        availability,
        groupName
      }),
      description,
      availability,
      groupName
    });
  }
  return SchemaWithExample.literal({
    nameOverride,
    generatedName,
    title,
    value: createLiteralSchemaValue(value),
    description,
    availability,
    groupName
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertNumber.js
function convertNumber({ nameOverride, generatedName, title, format, _default: _default2, minimum, maximum, exclusiveMinimum, exclusiveMaximum, multipleOf, description, availability, wrapAsNullable, example, groupName }) {
  if (format == null || format === "double") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.double({
        default: _default2,
        minimum,
        maximum,
        exclusiveMinimum,
        exclusiveMaximum,
        multipleOf,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "float") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.float({
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "int32") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.int({
        default: _default2,
        minimum,
        maximum,
        exclusiveMinimum,
        exclusiveMaximum,
        multipleOf,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "int64") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.int64({
        default: _default2,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "uint32") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.uint({
        default: _default2,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "uint64") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.uint64({
        default: _default2,
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  } else if (format === "time-delta") {
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.float({
        example
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  }
  return wrapPrimitive({
    nameOverride,
    generatedName,
    title,
    primitive: PrimitiveSchemaValueWithExample.float({
      example
    }),
    wrapAsNullable,
    description,
    availability,
    groupName
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/getBreadcrumbsFromReference.js
var STARTS_WITH_COMPONENTS_SCHEMAS = {
  // if the first three breadcrumbs are "#", "components", "schemas"
  // then the fourth breadcrumb will be a user-defined value that we want to extract
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "#" && refUnderProcessing[1] === "components" && refUnderProcessing[2] === "schemas",
  applyStrategy: (refUnderProcessing) => {
    const newBreadcrumbs = [refUnderProcessing[3] ?? ""];
    return {
      refUnderProcessing: refUnderProcessing.slice(4),
      newBreadcrumbs
    };
  }
};
var STARTS_WITH_COMPONENTS_RESPONSES = {
  // if the first three breadcrumbs are "#", "components", "responses"
  // then the fourth breadcrumb will be a user-defined value that we want to extract
  isApplicable: (breadcrumbs) => breadcrumbs[0] === "#" && breadcrumbs[1] === "components" && breadcrumbs[2] === "responses",
  applyStrategy: (refUnderProcessing) => {
    const newBreadcrumbs = [refUnderProcessing[3] ?? ""];
    refUnderProcessing = refUnderProcessing.slice(4);
    return {
      refUnderProcessing: refUnderProcessing.slice(4),
      newBreadcrumbs
    };
  }
};
var STARTS_WITH_COMPONENTS_PARAMETERS = {
  // if the first three breadcrumbs are "#", "components", "parameters"
  // then the fourth breadcrumb will be a user-defined value that we want to extract
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "#" && refUnderProcessing[1] === "components" && refUnderProcessing[2] === "parameters",
  applyStrategy: (refUnderProcessing) => {
    const newBreadcrumbs = [refUnderProcessing[3] ?? ""];
    refUnderProcessing = refUnderProcessing.slice(4);
    if (refUnderProcessing[0] === "schema") {
      refUnderProcessing = refUnderProcessing.slice(1);
    }
    return {
      refUnderProcessing,
      newBreadcrumbs
    };
  }
};
var EXTRACT_PROPERTY = {
  // if the first breadcrumb is "properties"
  // then the second breadcrumb will be a user-defined value that we want to extract
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "properties",
  applyStrategy: (refUnderProcessing) => {
    const newBreadcrumbs = [refUnderProcessing[1] ?? ""];
    return {
      refUnderProcessing: refUnderProcessing.slice(2),
      newBreadcrumbs
    };
  }
};
var REMOVE_ITEMS_KEYWORD = {
  // if the first breadcrumb is "items"
  // then we want to remove it from the breadcrumbs array
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "items",
  applyStrategy: (refUnderProcessing) => {
    return {
      refUnderProcessing: refUnderProcessing.slice(1),
      newBreadcrumbs: []
    };
  }
};
var REMOVE_ALL_OF_KEYWORD = {
  // if the first breadcrumb is "allOf"
  // then we want to remove it from the breadcrumbs array
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "allOf",
  applyStrategy: (refUnderProcessing) => {
    return {
      refUnderProcessing: refUnderProcessing.slice(1),
      newBreadcrumbs: []
    };
  }
};
var REMOVE_ANY_OF_KEYWORD = {
  // if the first breadcrumb is "anyOf"
  // then we want to remove it from the breadcrumbs array
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "anyOf",
  applyStrategy: (refUnderProcessing) => {
    return {
      refUnderProcessing: refUnderProcessing.slice(1),
      newBreadcrumbs: []
    };
  }
};
var REMOVE_ONE_OF_KEYWORD = {
  // if the first breadcrumb is "oneOf"
  // then we want to remove it from the breadcrumbs array
  isApplicable: (refUnderProcessing) => refUnderProcessing[0] === "oneOf",
  applyStrategy: (refUnderProcessing) => {
    return {
      refUnderProcessing: refUnderProcessing.slice(1),
      newBreadcrumbs: []
    };
  }
};
function getBreadcrumbsFromReference(reference) {
  let refUnderProcessing = reference.split("/").map((breadcrumb) => breadcrumb.replace(/~1/g, "/"));
  let breadcrumbs = [];
  const strategies = [
    // prefix strategies
    STARTS_WITH_COMPONENTS_SCHEMAS,
    STARTS_WITH_COMPONENTS_RESPONSES,
    STARTS_WITH_COMPONENTS_PARAMETERS,
    // index-aware strategies that must happen after prefix strategies
    EXTRACT_PROPERTY,
    REMOVE_ITEMS_KEYWORD,
    REMOVE_ALL_OF_KEYWORD,
    REMOVE_ANY_OF_KEYWORD,
    REMOVE_ONE_OF_KEYWORD
  ];
  let previousRefUnderProcessing;
  do {
    previousRefUnderProcessing = refUnderProcessing;
    for (const strategy of strategies) {
      if (strategy.isApplicable(refUnderProcessing)) {
        const { refUnderProcessing: newRefUnderProcessing, newBreadcrumbs } = strategy.applyStrategy(refUnderProcessing);
        refUnderProcessing = newRefUnderProcessing;
        breadcrumbs = [...breadcrumbs, ...newBreadcrumbs];
      }
    }
  } while (refUnderProcessing.join("") !== previousRefUnderProcessing.join(""));
  return breadcrumbs;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/getSchemaName.js
function getGeneratedTypeName(breadcrumbs, useOriginalSchemaIds) {
  const processedTokens = breadcrumbs.map((token) => {
    if (/^[^a-zA-Z0-9]+$/.test(token)) {
      return token;
    } else {
      return upperFirst_default(camelCase_default(token));
    }
  });
  const name = processedTokens.join("");
  if (/^\d/.test(name)) {
    return replaceStartingNumber(name) ?? name;
  }
  return name;
}
function getGeneratedPropertyName(breadcrumbs) {
  const underscoreDelimited = breadcrumbs.join("_");
  return camelCase_default(underscoreDelimited);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/convertSchemaWithExampleToSchema.js
function convertSchemaWithExampleToSchema(schema2) {
  switch (schema2.type) {
    case "object":
      return Schema.object({
        allOf: schema2.allOf,
        properties: schema2.properties.map((objectProperty) => convertToObjectProperty(objectProperty)),
        allOfPropertyConflicts: schema2.allOfPropertyConflicts,
        description: schema2.description,
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        groupName: schema2.groupName,
        additionalProperties: schema2.additionalProperties,
        availability: schema2.availability,
        source: schema2.source
      });
    case "array":
      return Schema.array({
        description: schema2.description,
        availability: schema2.availability,
        value: convertSchemaWithExampleToSchema(schema2.value),
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        groupName: schema2.groupName
      });
    case "enum":
      return Schema.enum({
        description: schema2.description,
        availability: schema2.availability,
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        values: schema2.values,
        default: schema2.default,
        groupName: schema2.groupName,
        source: schema2.source
      });
    case "literal":
      return Schema.literal({
        description: schema2.description,
        availability: schema2.availability,
        value: schema2.value,
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        groupName: schema2.groupName
      });
    case "nullable":
      return Schema.nullable({
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        description: schema2.description,
        availability: schema2.availability,
        value: convertSchemaWithExampleToSchema(schema2.value),
        groupName: schema2.groupName
      });
    case "optional":
      return Schema.optional({
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        description: schema2.description,
        availability: schema2.availability,
        value: convertSchemaWithExampleToSchema(schema2.value),
        groupName: schema2.groupName
      });
    case "primitive":
      return Schema.primitive({
        description: schema2.description,
        availability: schema2.availability,
        schema: convertToPrimitiveSchemaValue(schema2.schema),
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        groupName: schema2.groupName
      });
    case "map":
      return Schema.map({
        description: schema2.description,
        availability: schema2.availability,
        key: Schema.primitive({
          description: schema2.key.description,
          availability: schema2.key.availability,
          schema: convertToPrimitiveSchemaValue(schema2.key.schema),
          generatedName: schema2.key.generatedName,
          title: schema2.key.title,
          nameOverride: schema2.key.nameOverride,
          groupName: schema2.groupName
        }),
        value: convertSchemaWithExampleToSchema(schema2.value),
        generatedName: schema2.generatedName,
        title: schema2.title,
        nameOverride: schema2.nameOverride,
        groupName: schema2.groupName,
        encoding: schema2.encoding
      });
    case "reference":
      return Schema.reference({
        description: schema2.description,
        availability: schema2.availability,
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        schema: schema2.schema,
        groupName: schema2.groupName,
        source: schema2.source
      });
    case "oneOf":
      return Schema.oneOf(convertToOneOf(schema2.value));
    case "unknown":
      return Schema.unknown({ nameOverride: schema2.nameOverride, generatedName: schema2.generatedName });
    default:
      assertNever(schema2);
  }
}
function convertToOneOf(oneOfSchema) {
  switch (oneOfSchema.type) {
    case "discriminated":
      return OneOfSchema.discriminated({
        commonProperties: oneOfSchema.commonProperties.map((commonProperty) => {
          return {
            key: commonProperty.key,
            schema: convertSchemaWithExampleToSchema(commonProperty.schema)
          };
        }),
        description: oneOfSchema.description,
        availability: oneOfSchema.availability,
        discriminantProperty: oneOfSchema.discriminantProperty,
        generatedName: oneOfSchema.generatedName,
        title: oneOfSchema.title,
        nameOverride: oneOfSchema.nameOverride,
        schemas: Object.fromEntries(Object.entries(oneOfSchema.schemas).map(([discriminantValue, schemaWithExample]) => {
          return [discriminantValue, convertSchemaWithExampleToSchema(schemaWithExample)];
        })),
        groupName: oneOfSchema.groupName,
        encoding: oneOfSchema.encoding,
        source: oneOfSchema.source
      });
    case "undisciminated":
      return OneOfSchema.undisciminated({
        description: oneOfSchema.description,
        availability: oneOfSchema.availability,
        generatedName: oneOfSchema.generatedName,
        title: oneOfSchema.title,
        nameOverride: oneOfSchema.nameOverride,
        schemas: oneOfSchema.schemas.map((oneOfSchema2) => convertSchemaWithExampleToSchema(oneOfSchema2)),
        groupName: oneOfSchema.groupName,
        encoding: oneOfSchema.encoding,
        source: oneOfSchema.source
      });
    default:
      assertNever(oneOfSchema);
  }
}
function convertToPrimitiveSchemaValue(primitiveSchema) {
  switch (primitiveSchema.type) {
    case "string":
      return PrimitiveSchemaValue.string(primitiveSchema);
    case "base64":
      return PrimitiveSchemaValue.base64();
    case "boolean":
      return PrimitiveSchemaValue.boolean(primitiveSchema);
    case "date":
      return PrimitiveSchemaValue.date();
    case "datetime":
      return PrimitiveSchemaValue.datetime();
    case "double":
      return PrimitiveSchemaValue.double(primitiveSchema);
    case "float":
      return PrimitiveSchemaValue.float();
    case "int":
      return PrimitiveSchemaValue.int(primitiveSchema);
    case "int64":
      return PrimitiveSchemaValue.int64(primitiveSchema);
    case "uint":
      return PrimitiveSchemaValue.uint();
    case "uint64":
      return PrimitiveSchemaValue.uint64();
    default:
      assertNever(primitiveSchema);
  }
}
function convertToObjectProperty(objectProperty) {
  return {
    conflict: objectProperty.conflict,
    generatedName: objectProperty.generatedName,
    key: objectProperty.key,
    schema: convertSchemaWithExampleToSchema(objectProperty.schema),
    audiences: objectProperty.audiences,
    nameOverride: objectProperty.nameOverride,
    availability: objectProperty.availability,
    readonly: objectProperty.readonly
  };
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/isSchemaWithExampleEqual.js
function isSchemaWithExampleEqual(a, b) {
  return isSchemaEqual(convertSchemaWithExampleToSchema(a), convertSchemaWithExampleToSchema(b));
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertObject.js
function convertObject3({ nameOverride, generatedName, title, breadcrumbs, properties, description, required, wrapAsNullable, allOf, context, propertiesToExclude, groupName, fullExamples, additionalProperties, availability, encoding, source, namespace }) {
  const allRequired = [...required ?? []];
  const propertiesToConvert = { ...properties };
  const inlinedParentProperties = [];
  const parents = [];
  for (const allOfElement of allOf) {
    if (isReferenceObject(allOfElement)) {
      const resolvedReference = context.resolveSchemaReference(allOfElement);
      if (resolvedReference.discriminator != null && resolvedReference.discriminator.mapping != null) {
        continue;
      }
      if (resolvedReference.oneOf != null) {
        for (const oneOfSchema of resolvedReference.oneOf) {
          const resolvedOneOfSchema = isReferenceObject(oneOfSchema) ? context.resolveSchemaReference(oneOfSchema) : oneOfSchema;
          const convertedOneOfSchema = convertSchema(resolvedOneOfSchema, false, context.DUMMY, breadcrumbs, source, namespace);
          if (convertedOneOfSchema.type === "object") {
            inlinedParentProperties.push(...convertedOneOfSchema.properties.map((property4) => {
              if (property4.schema.type !== "optional" && property4.schema.type !== "nullable") {
                return {
                  ...property4,
                  schema: SchemaWithExample.optional({
                    nameOverride: void 0,
                    generatedName: "",
                    title: void 0,
                    value: property4.schema,
                    description: void 0,
                    availability: property4.availability,
                    groupName: void 0
                  })
                };
              }
              return property4;
            }));
          }
        }
        continue;
      }
      const schemaId = getSchemaIdFromReference(allOfElement);
      if (schemaId == null) {
        continue;
      }
      parents.push({
        schemaId,
        convertedSchema: convertToReferencedSchema(allOfElement, [schemaId], source, context.options.preserveSchemaIds),
        properties: getAllProperties({ schema: allOfElement, context, breadcrumbs, source, namespace })
      });
      context.markSchemaAsReferencedByNonRequest(schemaId);
    } else {
      const allOfSchema = convertSchema(allOfElement, false, context, breadcrumbs, source, namespace);
      if (allOfSchema.type === "object") {
        inlinedParentProperties.push(...allOfSchema.properties);
      }
    }
  }
  const allPropertiesMap = {};
  for (const parent of parents) {
    for (const [propertyKey, propertySchema] of Object.entries(parent.properties)) {
      const propertyInfo = allPropertiesMap[propertyKey];
      if (propertyInfo != null) {
        propertyInfo.schemaIds.push(parent.schemaId);
        const schemaExists = propertyInfo.schemas.some((schema2) => {
          return isSchemaWithExampleEqual(schema2, propertySchema);
        });
        if (!schemaExists) {
          propertyInfo.schemas.push(propertySchema);
        }
      } else {
        allPropertiesMap[propertyKey] = { schemaIds: [parent.schemaId], schemas: [propertySchema] };
      }
    }
  }
  const allOfPropertyConflicts = [];
  for (const [allOfPropertyKey, allOfPropertyInfo] of Object.entries(allPropertiesMap)) {
    if (allOfPropertyInfo.schemaIds.length > 1) {
      allOfPropertyConflicts.push({
        propertyKey: allOfPropertyKey,
        allOfSchemaIds: allOfPropertyInfo.schemaIds,
        conflictingTypeSignatures: allOfPropertyInfo.schemas.length > 1
      });
    }
  }
  const convertedProperties = Object.entries(propertiesToConvert).map(([propertyName, propertySchema]) => {
    const isRequired = allRequired.includes(propertyName);
    const audiences = getExtension(propertySchema, FernOpenAPIExtension.AUDIENCES) ?? [];
    const availability2 = convertAvailability3(propertySchema);
    const readonly = isReferenceObject(propertySchema) ? false : propertySchema.readOnly;
    const propertyNameOverride = getExtension(propertySchema, FernOpenAPIExtension.FERN_PROPERTY_NAME);
    const propertyBreadcrumbs = [...breadcrumbs, propertyName];
    const generatedName2 = getGeneratedPropertyName(propertyBreadcrumbs);
    const schema2 = isRequired ? convertSchema(propertySchema, false, context, propertyBreadcrumbs, source, namespace) : SchemaWithExample.optional({
      nameOverride,
      generatedName: generatedName2,
      title,
      description: void 0,
      availability: availability2,
      value: convertSchema(propertySchema, false, context, propertyBreadcrumbs, source, namespace),
      groupName
    });
    const conflicts = {};
    for (const parent of parents) {
      const parentPropertySchema = parent.properties[propertyName];
      if (parentPropertySchema != null && !isSchemaWithExampleEqual(schema2, parentPropertySchema)) {
        conflicts[parent.schemaId] = { differentSchema: true };
      } else if (parentPropertySchema != null) {
        conflicts[parent.schemaId] = { differentSchema: false };
      }
    }
    return {
      key: propertyName,
      schema: schema2,
      nameOverride: propertyNameOverride,
      audiences,
      conflict: conflicts,
      generatedName: getGeneratedPropertyName([...breadcrumbs, propertyName]),
      availability: availability2,
      readonly
    };
  });
  convertedProperties.push(...inlinedParentProperties.map((property4) => {
    const conflicts = property4.conflict;
    for (const parent of parents) {
      const parentPropertySchema = parent.properties[property4.key];
      if (parentPropertySchema != null && !isSchemaWithExampleEqual(property4.schema, parentPropertySchema)) {
        conflicts[parent.schemaId] = { differentSchema: true };
      } else if (parentPropertySchema != null) {
        conflicts[parent.schemaId] = { differentSchema: false };
      }
    }
    return {
      ...property4,
      conflict: conflicts
    };
  }));
  return wrapObject({
    nameOverride,
    generatedName,
    title,
    wrapAsNullable,
    properties: convertedProperties.filter((objectProperty) => {
      return !propertiesToExclude.has(objectProperty.key);
    }),
    description,
    allOf: parents.map((parent) => parent.convertedSchema),
    allOfPropertyConflicts,
    groupName,
    fullExamples,
    additionalProperties,
    availability,
    source
  });
}
function wrapObject({ nameOverride, generatedName, title, wrapAsNullable, properties, description, allOf, allOfPropertyConflicts, groupName, fullExamples, additionalProperties, availability, source }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.object({
        description,
        properties,
        nameOverride,
        generatedName,
        title,
        allOf,
        allOfPropertyConflicts,
        groupName,
        fullExamples,
        additionalProperties: isAdditionalPropertiesAny(additionalProperties),
        availability: void 0,
        source
      }),
      description,
      availability,
      groupName
    });
  }
  return SchemaWithExample.object({
    description,
    properties,
    nameOverride,
    generatedName,
    title,
    allOf,
    allOfPropertyConflicts,
    groupName,
    fullExamples,
    additionalProperties: isAdditionalPropertiesAny(additionalProperties),
    availability,
    source
  });
}
function getAllProperties({ schema: schema2, context, breadcrumbs, source, namespace }) {
  let properties = {};
  const [resolvedSchema, resolvedBreadCrumbs] = isReferenceObject(schema2) ? [context.resolveSchemaReference(schema2), getBreadcrumbsFromReference(schema2.$ref)] : [schema2, breadcrumbs];
  for (const allOfElement of resolvedSchema.allOf ?? []) {
    properties = {
      ...properties,
      ...getAllProperties({ schema: allOfElement, context, breadcrumbs: resolvedBreadCrumbs, source, namespace })
    };
  }
  for (const [propertyName, propertySchema] of Object.entries(resolvedSchema.properties ?? {})) {
    const convertedPropertySchema = convertSchema(propertySchema, false, context, [...resolvedBreadCrumbs, propertyName], source, namespace);
    properties[propertyName] = convertedPropertySchema;
  }
  return properties;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertUndiscriminatedOneOf.js
function convertUndiscriminatedOneOf({ nameOverride, generatedName, title, breadcrumbs, description, availability, wrapAsNullable, context, subtypes, groupName, encoding, source, subtypePrefixOverrides, namespace }) {
  const derivedSubtypePrefixes = getUniqueSubTypeNames({ schemas: subtypes });
  const convertedSubtypes = subtypes.flatMap((schema2, index) => {
    if (!isReferenceObject(schema2) && schema2.enum != null && context.options.cooerceEnumsToLiterals) {
      return schema2.enum.map((enumValue) => {
        return SchemaWithExample.literal({
          nameOverride: void 0,
          generatedName: getGeneratedTypeName([generatedName, enumValue], context.options.preserveSchemaIds),
          title: void 0,
          value: LiteralSchemaValue.string(enumValue),
          groupName: void 0,
          description: void 0,
          availability: enumValue.availability
        });
      });
    }
    let subtypePrefix = derivedSubtypePrefixes[index];
    if (subtypePrefixOverrides != null) {
      const override = subtypePrefixOverrides[index];
      if (override != null && "name" in override) {
        subtypePrefix = override.name;
      }
    }
    return [
      convertSchema(schema2, false, context, [...breadcrumbs, subtypePrefix ?? `${index}`], source, namespace)
    ];
  });
  const uniqueSubtypes = [];
  for (let i = 0; i < convertedSubtypes.length; ++i) {
    const a = convertedSubtypes[i];
    let isDuplicate = false;
    for (let j = i + 1; j < convertedSubtypes.length; ++j) {
      const b = convertedSubtypes[j];
      if (a != null && b != null && isSchemaEqual(a, b)) {
        isDuplicate = true;
        break;
      }
    }
    if (a != null && !isDuplicate) {
      uniqueSubtypes.push(a);
    }
  }
  const everySubTypeIsLiteral = Object.entries(uniqueSubtypes).every(([_, schema2]) => {
    return schema2.type === "literal";
  });
  if (everySubTypeIsLiteral) {
    const enumDescriptions = {};
    const enumValues = [];
    Object.entries(uniqueSubtypes).forEach(([_, schema2]) => {
      if (schema2.type === "literal" && schema2.value.type === "string") {
        enumValues.push(schema2.value.value);
        if (schema2.description != null) {
          enumDescriptions[schema2.value.value] = {
            description: schema2.description
          };
        }
      }
    });
    return convertEnum({
      nameOverride,
      generatedName,
      title,
      wrapAsNullable,
      description,
      availability,
      fernEnum: enumDescriptions,
      enumVarNames: void 0,
      enumValues,
      _default: void 0,
      groupName,
      context,
      source
    });
  }
  if (uniqueSubtypes.length === 1 && uniqueSubtypes[0] != null) {
    return uniqueSubtypes[0];
  }
  return wrapUndiscriminantedOneOf({
    nameOverride,
    generatedName,
    title,
    wrapAsNullable,
    description,
    availability,
    subtypes: uniqueSubtypes,
    groupName,
    encoding,
    source
  });
}
function convertUndiscriminatedOneOfWithDiscriminant({ nameOverride, generatedName, title, description, availability, wrapAsNullable, context, groupName, discriminator, encoding, source, namespace }) {
  const convertedSubtypes = Object.entries(discriminator.mapping ?? {}).map(([discriminantValue, schema2], index) => {
    const subtypeReferenceSchema = {
      $ref: schema2
    };
    const subtypeReference = convertReferenceObject(subtypeReferenceSchema, false, context, [schema2], encoding, source, namespace);
    context.markSchemaWithDiscriminantValue(subtypeReferenceSchema, discriminator.propertyName, discriminantValue);
    if (subtypeReference.type === "object") {
      subtypeReference.properties = {
        [discriminator.propertyName]: SchemaWithExample.literal({
          nameOverride: void 0,
          generatedName: getGeneratedTypeName([generatedName, discriminantValue], context.options.preserveSchemaIds),
          title: void 0,
          value: LiteralSchemaValue.string(discriminantValue),
          groupName: void 0,
          description: void 0,
          availability: void 0
        }),
        ...subtypeReference.properties.filter((objectProperty) => {
          return objectProperty.key !== discriminator.propertyName;
        })
      };
    }
    return subtypeReference;
  });
  const uniqueSubtypes = [];
  for (let i = 0; i < convertedSubtypes.length; ++i) {
    const a = convertedSubtypes[i];
    let isDuplicate = false;
    for (let j = i + 1; j < convertedSubtypes.length; ++j) {
      const b = convertedSubtypes[j];
      if (a != null && b != null && isSchemaEqual(a, b)) {
        isDuplicate = true;
        break;
      }
    }
    if (a != null && !isDuplicate) {
      uniqueSubtypes.push(a);
    }
  }
  const everySubTypeIsLiteral = Object.entries(uniqueSubtypes).every(([_, schema2]) => {
    return schema2.type === "literal";
  });
  if (everySubTypeIsLiteral) {
    const enumDescriptions = {};
    const enumValues = [];
    Object.entries(uniqueSubtypes).forEach(([_, schema2]) => {
      if (schema2.type === "literal" && schema2.value.type === "string") {
        enumValues.push(schema2.value.value);
        if (schema2.description != null) {
          enumDescriptions[schema2.value.value] = {
            description: schema2.description
          };
        }
      }
    });
    return convertEnum({
      nameOverride,
      generatedName,
      title,
      wrapAsNullable,
      description,
      availability,
      fernEnum: enumDescriptions,
      enumVarNames: void 0,
      enumValues,
      _default: void 0,
      groupName,
      context,
      source
    });
  }
  if (uniqueSubtypes.length === 1 && uniqueSubtypes[0] != null) {
    return uniqueSubtypes[0];
  }
  return wrapUndiscriminantedOneOf({
    nameOverride,
    generatedName,
    title,
    wrapAsNullable,
    description,
    availability,
    subtypes: uniqueSubtypes,
    groupName,
    encoding,
    source
  });
}
function getUniqueSubTypeNames({ schemas }) {
  let uniquePropertySets = {};
  let index = 0;
  for (const schema2 of schemas) {
    if (isReferenceObject(schema2)) {
    } else if (schema2.properties != null && Object.entries(schema2.properties).length > 0) {
      const schemaProperties = Object.keys(schema2.properties);
      const updatedPropertySets = {};
      let uniqueSchemaProperties = schemaProperties;
      for (const [key, uniquePropertySet] of Object.entries(uniquePropertySets)) {
        const updatedSet = difference_default(uniquePropertySet, schemaProperties);
        uniqueSchemaProperties = difference_default(uniqueSchemaProperties, uniquePropertySet);
        updatedPropertySets[key] = updatedSet;
      }
      updatedPropertySets[index] = uniqueSchemaProperties;
      uniquePropertySets = updatedPropertySets;
    }
    index++;
  }
  const prefixes = [];
  let i = 0;
  for (const schema2 of schemas) {
    const propertySet = uniquePropertySets[i];
    if (propertySet != null && propertySet.length > 0) {
      const sortedProperties = propertySet.sort();
      if (sortedProperties[0] != null) {
        prefixes.push(sortedProperties[0]);
        ++i;
        continue;
      }
    }
    if (isReferenceObject(schema2)) {
      prefixes.push(convertNumberToSnakeCase(i) ?? `${i}`);
    } else if (schema2.type === "array" || schema2.type === "boolean" || schema2.type === "integer" || schema2.type === "number" || schema2.type === "string") {
      prefixes.push("");
    } else {
      prefixes.push(convertNumberToSnakeCase(i) ?? `${i}`);
    }
    ++i;
  }
  return prefixes;
}
function wrapUndiscriminantedOneOf({ nameOverride, generatedName, title, wrapAsNullable, description, availability, subtypes, groupName, encoding, source }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.oneOf(OneOfSchemaWithExample.undisciminated({
        description,
        availability,
        nameOverride,
        generatedName,
        title,
        schemas: subtypes,
        groupName,
        encoding,
        source
      })),
      description,
      availability,
      groupName
    });
  }
  return SchemaWithExample.oneOf(OneOfSchemaWithExample.undisciminated({
    description,
    availability,
    nameOverride,
    generatedName,
    title,
    schemas: subtypes,
    groupName,
    encoding,
    source
  }));
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/defaults/getDefault.js
function getDefaultAsString(schema2) {
  if (schema2.default != null && typeof schema2.default === "string") {
    return schema2.default;
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/examples/getExample.js
function getExampleAsNumber({ schema: schema2, logger, fallback }) {
  if (schema2.example != null && typeof schema2.example === "number") {
    return schema2.example;
  }
  const examples = getExamples(schema2);
  for (const example of examples ?? []) {
    if (typeof example === "number") {
      return example;
    }
  }
  if (fallback && typeof fallback === "number") {
    return fallback;
  }
  return void 0;
}
function getExampleAsBoolean({ schema: schema2, logger, fallback }) {
  if (schema2.example != null && typeof schema2.example === "boolean") {
    return schema2.example;
  }
  const examples = getExamples(schema2);
  for (const example of examples ?? []) {
    if (typeof example === "boolean") {
      return example;
    }
  }
  if (fallback && typeof fallback === "boolean") {
    return fallback;
  }
  return void 0;
}
function getExamplesString({ schema: schema2, logger, fallback }) {
  if (schema2.example != null && typeof schema2.example === "string") {
    return schema2.example;
  }
  const examples = getExamples(schema2);
  for (const example of examples ?? []) {
    if (typeof example === "string") {
      return example;
    }
  }
  if (fallback && typeof fallback === "string") {
    return fallback;
  }
  return void 0;
}
function getExampleAsArray({ schema: schema2, logger, fallback }) {
  if (schema2.example != null && Array.isArray(schema2.example)) {
    return schema2.example;
  }
  const examples = getExamples(schema2);
  for (const example of examples ?? []) {
    if (Array.isArray(example)) {
      return example;
    }
  }
  if (fallback && Array.isArray(fallback)) {
    return fallback;
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/convertSchemas.js
var SCHEMA_REFERENCE_PREFIX = "#/components/schemas/";
function convertSchema(schema2, wrapAsNullable, context, breadcrumbs, source, namespace, referencedAsRequest = false, propertiesToExclude = /* @__PURE__ */ new Set(), fallback) {
  const encoding = getEncoding({ schema: schema2, logger: context.logger });
  if (isReferenceObject(schema2)) {
    const schemaId = getSchemaIdFromReference(schema2);
    if (schemaId != null) {
      if (!referencedAsRequest) {
        context.markSchemaAsReferencedByNonRequest(schemaId);
      } else {
        context.markSchemaAsReferencedByRequest(schemaId);
      }
      return convertReferenceObject(schema2, wrapAsNullable, context, breadcrumbs, encoding, source, namespace);
    }
    return convertSchemaObject(context.resolveSchemaReference(schema2), wrapAsNullable, context, getBreadcrumbsFromReference(schema2.$ref), encoding, source, namespace, propertiesToExclude, referencedAsRequest, fallback);
  }
  return convertSchemaObject(schema2, wrapAsNullable, context, breadcrumbs, encoding, source, namespace, propertiesToExclude, referencedAsRequest, fallback);
}
function convertReferenceObject(schema2, wrapAsNullable, context, breadcrumbs, encoding, source, namespace) {
  const referenceSchema = schema2.$ref.includes("properties") ? convertSchemaObject(context.resolveSchemaReference(schema2), wrapAsNullable, context, breadcrumbs, encoding, source, namespace, /* @__PURE__ */ new Set()) : SchemaWithExample.reference(convertToReferencedSchema(schema2, breadcrumbs, source, context.options.preserveSchemaIds));
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      title: void 0,
      nameOverride: void 0,
      generatedName: getGeneratedTypeName(breadcrumbs, context.options.preserveSchemaIds),
      value: referenceSchema,
      description: void 0,
      availability: void 0,
      groupName: void 0
    });
  } else {
    return referenceSchema;
  }
}
function getTitleAsName(title) {
  if (title == null) {
    return void 0;
  }
  if (title.includes(" ")) {
    return void 0;
  }
  if (!/^[a-zA-Z]+$/.test(title)) {
    return void 0;
  }
  return title;
}
function convertSchemaObject(schema2, wrapAsNullable, context, breadcrumbs, encoding, source, namespace, propertiesToExclude = /* @__PURE__ */ new Set(), referencedAsRequest = false, fallback) {
  const nameOverride = getExtension(schema2, FernOpenAPIExtension.TYPE_NAME) ?? (context.options.useTitlesAsName ? getTitleAsName(schema2.title) : void 0);
  const mixedGroupName = getExtension(schema2, FernOpenAPIExtension.SDK_GROUP_NAME) ?? getExtension(schema2, OpenAPIExtension.TAGS)?.[0];
  let groupName = (typeof mixedGroupName === "string" ? [mixedGroupName] : mixedGroupName) ?? [];
  groupName = context.resolveGroupName(groupName);
  const generatedName = getGeneratedTypeName(breadcrumbs, context.options.preserveSchemaIds);
  const title = schema2.title;
  const description = schema2.description;
  const availability = convertAvailability3(schema2);
  const fullExamples = [];
  if (schema2.example != null) {
    fullExamples.push({ name: void 0, value: schema2.example, description: void 0 });
  }
  const xExamples = getExtension(schema2, OpenAPIExtension.EXAMPLES);
  if (xExamples != null && Object.keys(xExamples).length > 0) {
    fullExamples.push(...Object.entries(xExamples).map(([name, value]) => {
      return { name: value?.summary ?? name, value: value.value, description: value.description };
    }));
  }
  const examples = getExamples(schema2);
  if (examples != null && Object.keys(examples).length > 0) {
    fullExamples.push(...examples.map((value) => {
      return { name: void 0, value, description: void 0 };
    }));
  }
  const fernSchema = getFernTypeExtension({ schema: schema2, description, title, nameOverride, generatedName, availability });
  if (fernSchema != null) {
    return fernSchema;
  }
  if (!wrapAsNullable && schema2.nullable === true) {
    return convertSchemaObject(schema2, true, context, breadcrumbs, encoding, source, namespace, propertiesToExclude, referencedAsRequest, fallback);
  }
  if (schema2.enum != null && (schema2.type === "string" || schema2.type == null)) {
    if (!isListOfStrings(schema2.enum)) {
      return wrapPrimitive({
        nameOverride,
        generatedName,
        title,
        primitive: PrimitiveSchemaValueWithExample.string({
          default: getDefaultAsString(schema2),
          minLength: schema2.minLength,
          maxLength: schema2.maxLength,
          pattern: schema2.pattern,
          format: schema2.format,
          example: getExamplesString({ schema: schema2, logger: context.logger, fallback })
        }),
        groupName,
        wrapAsNullable,
        description,
        availability
      });
    }
    const fernEnum = getFernEnum(schema2);
    if (schema2.enum.length === 1 && schema2.enum[0] != null && fernEnum == null) {
      return convertLiteral({
        nameOverride,
        generatedName,
        title,
        wrapAsNullable,
        value: schema2.enum[0],
        description,
        availability,
        groupName
      });
    }
    return convertEnum({
      nameOverride,
      generatedName,
      title,
      fernEnum,
      enumVarNames: getExtension(schema2, [OpenAPIExtension.ENUM_VAR_NAMES]),
      enumValues: schema2.enum,
      _default: schema2.default,
      description,
      availability,
      wrapAsNullable,
      groupName,
      context,
      source
    });
  }
  if (isListOfStrings(schema2.type) && schema2.type[1] != null && schema2.type[0] != null) {
    const firstElement = schema2.type[0];
    const secondElement = schema2.type[1];
    if (firstElement === "null") {
      return SchemaWithExample.nullable({
        nameOverride,
        generatedName,
        title,
        value: convertSchemaObject({
          ...schema2,
          type: secondElement
        }, wrapAsNullable, context, breadcrumbs, encoding, source, namespace, propertiesToExclude, referencedAsRequest, fallback),
        groupName,
        description: schema2.description,
        availability
      });
    } else if (secondElement === "null") {
      return SchemaWithExample.nullable({
        nameOverride,
        generatedName,
        title,
        value: convertSchemaObject({
          ...schema2,
          type: firstElement
        }, wrapAsNullable, context, breadcrumbs, encoding, source, namespace, propertiesToExclude, referencedAsRequest, fallback),
        groupName,
        description: schema2.description,
        availability
      });
    }
  }
  if (isListOfStrings(schema2.type) && schema2.type.length > 1) {
    const wrapVariantAsNullable = schema2.type.includes("null");
    const subtypes = schema2.type.filter((val) => val !== "null").map((type2) => {
      return {
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        type: type2,
        nullable: wrapVariantAsNullable
      };
    });
    return convertUndiscriminatedOneOf({
      nameOverride,
      generatedName,
      title,
      breadcrumbs,
      description,
      availability,
      wrapAsNullable,
      context,
      subtypes,
      groupName,
      encoding,
      source,
      namespace
    });
  }
  if (schema2 === "boolean" || schema2.type === "boolean") {
    const literalValue = getExtension(schema2, FernOpenAPIExtension.BOOLEAN_LITERAL);
    if (literalValue != null) {
      return wrapLiteral({
        nameOverride,
        generatedName,
        title,
        literal: LiteralSchemaValue.boolean(literalValue),
        wrapAsNullable,
        description,
        availability,
        groupName
      });
    }
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.boolean({
        default: schema2.default,
        example: getExampleAsBoolean({ schema: schema2, logger: context.logger, fallback })
      }),
      wrapAsNullable,
      description,
      availability,
      groupName
    });
  }
  if (schema2 === "number" || schema2.type === "number") {
    return convertNumber({
      nameOverride,
      generatedName,
      title,
      format: schema2.format,
      _default: schema2.default,
      minimum: schema2.minimum,
      maximum: schema2.maximum,
      exclusiveMinimum: getValueIfBoolean(schema2.exclusiveMinimum),
      exclusiveMaximum: getValueIfBoolean(schema2.exclusiveMaximum),
      multipleOf: schema2.multipleOf,
      description,
      availability,
      wrapAsNullable,
      example: getExampleAsNumber({ schema: schema2, logger: context.logger, fallback }),
      groupName
    });
  }
  if (schema2 === "integer" || schema2.type === "integer") {
    return convertInteger({
      nameOverride,
      generatedName,
      title,
      format: schema2.format,
      _default: schema2.default,
      minimum: schema2.minimum,
      maximum: schema2.maximum,
      exclusiveMinimum: getValueIfBoolean(schema2.exclusiveMinimum),
      exclusiveMaximum: getValueIfBoolean(schema2.exclusiveMaximum),
      multipleOf: schema2.multipleOf,
      description,
      availability,
      wrapAsNullable,
      example: getExampleAsNumber({ schema: schema2, logger: context.logger, fallback }),
      groupName
    });
  }
  if (schema2 === "float") {
    return convertNumber({
      nameOverride,
      generatedName,
      title,
      format: "float",
      _default: schema2.default,
      minimum: schema2.minimum,
      maximum: schema2.maximum,
      exclusiveMinimum: getValueIfBoolean(schema2.exclusiveMinimum),
      exclusiveMaximum: getValueIfBoolean(schema2.exclusiveMaximum),
      multipleOf: schema2.multipleOf,
      description,
      availability,
      wrapAsNullable,
      example: getExampleAsNumber({ schema: schema2, logger: context.logger, fallback }),
      groupName
    });
  }
  if (schema2 === "string" || schema2.type === "string") {
    if (schema2.format === "date-time") {
      return wrapPrimitive({
        nameOverride,
        generatedName,
        title,
        primitive: PrimitiveSchemaValueWithExample.datetime({
          example: getExamplesString({ schema: schema2, logger: context.logger, fallback })
        }),
        wrapAsNullable,
        description,
        availability,
        groupName
      });
    } else if (schema2.format === "json-string") {
      return SchemaWithExample.unknown({
        nameOverride,
        generatedName,
        title,
        description,
        availability,
        groupName,
        example: void 0
      });
    }
    const maybeConstValue = getProperty(schema2, "const");
    if (maybeConstValue != null) {
      return wrapLiteral({
        nameOverride,
        generatedName,
        title,
        literal: LiteralSchemaValue.string(maybeConstValue),
        wrapAsNullable,
        description,
        availability,
        groupName
      });
    }
    return wrapPrimitive({
      nameOverride,
      generatedName,
      title,
      primitive: PrimitiveSchemaValueWithExample.string({
        default: getDefaultAsString(schema2),
        pattern: schema2.pattern,
        format: schema2.format,
        minLength: schema2.minLength,
        maxLength: schema2.maxLength,
        example: getExamplesString({ schema: schema2, logger: context.logger, fallback })
      }),
      groupName,
      wrapAsNullable,
      description,
      availability
    });
  }
  if (schema2.type === "array") {
    return convertArray({
      nameOverride,
      generatedName,
      title,
      breadcrumbs,
      item: schema2.items,
      description,
      availability,
      wrapAsNullable,
      context,
      groupName,
      example: getExampleAsArray({ schema: schema2, logger: context.logger, fallback }),
      source,
      namespace
    });
  }
  if (schema2.additionalProperties != null && schema2.additionalProperties !== false && hasNoProperties(schema2)) {
    return convertAdditionalProperties({
      nameOverride,
      generatedName,
      title,
      breadcrumbs,
      additionalProperties: schema2.additionalProperties,
      description,
      availability,
      wrapAsNullable,
      context,
      groupName,
      encoding,
      example: schema2.example,
      source,
      namespace
    });
  }
  if (schema2.type === "object" && schema2.discriminator != null && schema2.discriminator.mapping != null) {
    if (!context.options.discriminatedUnionV2) {
      return convertDiscriminatedOneOf({
        nameOverride,
        generatedName,
        title,
        breadcrumbs,
        description,
        availability,
        discriminator: schema2.discriminator,
        properties: schema2.properties ?? {},
        required: schema2.required,
        wrapAsNullable,
        context,
        groupName,
        encoding,
        source,
        namespace
      });
    } else {
      return convertUndiscriminatedOneOfWithDiscriminant({
        nameOverride,
        generatedName,
        title,
        description,
        availability,
        wrapAsNullable,
        context,
        groupName,
        discriminator: schema2.discriminator,
        encoding,
        source,
        namespace
      });
    }
  }
  if (Array.isArray(schema2.type)) {
    if (schema2.oneOf == null) {
      schema2.oneOf = schema2.type;
    } else {
      schema2.oneOf.push(...schema2.type);
    }
  }
  if (schema2.oneOf != null && schema2.oneOf.length > 0) {
    const isUndiscriminated = getExtension(schema2, FernOpenAPIExtension.IS_UNDISCRIMINATED);
    if (schema2.discriminator != null && schema2.discriminator.mapping != null && Object.keys(schema2.discriminator.mapping).length > 0) {
      if (context.options.discriminatedUnionV2 || isUndiscriminated) {
        return convertUndiscriminatedOneOfWithDiscriminant({
          nameOverride,
          generatedName,
          title,
          description,
          availability,
          wrapAsNullable,
          context,
          groupName,
          discriminator: schema2.discriminator,
          encoding,
          source,
          namespace
        });
      } else {
        return convertDiscriminatedOneOf({
          nameOverride,
          generatedName,
          title,
          breadcrumbs,
          description,
          availability,
          discriminator: schema2.discriminator,
          properties: schema2.properties ?? {},
          required: schema2.required,
          wrapAsNullable,
          context,
          groupName,
          encoding,
          source,
          namespace
        });
      }
    } else if (schema2.oneOf.length === 1 && schema2.oneOf[0] != null) {
      const convertedSchema = convertSchema(schema2.oneOf[0], wrapAsNullable, context, breadcrumbs, source, namespace, referencedAsRequest);
      return maybeInjectDescriptionOrGroupName(convertedSchema, description, groupName);
    } else if (schema2.oneOf.length > 1) {
      if (schema2.oneOf.length === 2 && schema2.oneOf[0] != null && schema2.oneOf[1] != null) {
        const firstSchema = schema2.oneOf[0];
        const secondSchema = schema2.oneOf[1];
        if (!isReferenceObject(firstSchema) && firstSchema.type === "null") {
          return convertSchema(secondSchema, true, context, breadcrumbs, source, namespace);
        } else if (!isReferenceObject(secondSchema) && secondSchema.type === "null") {
          return convertSchema(firstSchema, true, context, breadcrumbs, source, namespace);
        }
      }
      const maybeAllEnumValues = getMaybeAllEnumValues({ schemas: schema2.oneOf });
      if (maybeAllEnumValues != null) {
        return convertEnum({
          nameOverride,
          generatedName,
          title,
          fernEnum: void 0,
          enumVarNames: void 0,
          enumValues: maybeAllEnumValues,
          _default: schema2.default,
          description,
          availability,
          wrapAsNullable,
          groupName,
          context,
          source
        });
      }
      const maybeDiscriminant = getDiscriminant({ schemas: schema2.oneOf, context });
      if (maybeDiscriminant != null && !context.options.discriminatedUnionV2 && !isUndiscriminated) {
        return convertDiscriminatedOneOfWithVariants({
          nameOverride,
          generatedName,
          title,
          breadcrumbs,
          properties: schema2.properties ?? {},
          required: schema2.required,
          description,
          availability,
          wrapAsNullable,
          discriminant: maybeDiscriminant.discriminant,
          variants: maybeDiscriminant.schemas,
          context,
          groupName,
          encoding,
          source,
          namespace
        });
      }
      const hasNullValue = schema2.oneOf.filter((schema3) => {
        return !isReferenceObject(schema3) && schema3.type === "null";
      }).length > 0;
      return convertUndiscriminatedOneOf({
        nameOverride,
        generatedName,
        title,
        breadcrumbs,
        description,
        availability,
        wrapAsNullable: wrapAsNullable || hasNullValue,
        context,
        subtypes: schema2.oneOf.filter((schema3) => {
          return isReferenceObject(schema3) || schema3.type !== "null";
        }),
        encoding,
        groupName,
        source,
        namespace
      });
    }
  }
  if (schema2.anyOf != null && schema2.anyOf.length > 0) {
    if (schema2.anyOf.length === 1 && schema2.anyOf[0] != null) {
      const convertedSchema = convertSchema(schema2.anyOf[0], wrapAsNullable, context, breadcrumbs, source, namespace, referencedAsRequest);
      return maybeInjectDescriptionOrGroupName(convertedSchema, description, groupName);
    }
    if (schema2.anyOf.length === 2) {
      const [firstSchema, secondSchema] = schema2.anyOf;
      if (firstSchema != null && secondSchema != null) {
        if (!isReferenceObject(firstSchema) && firstSchema.type === "null") {
          const convertedSchema = convertSchema(secondSchema, true, context, breadcrumbs, source, namespace);
          return maybeInjectDescriptionOrGroupName(convertedSchema, description, groupName);
        } else if (!isReferenceObject(secondSchema) && secondSchema.type === "null") {
          const convertedSchema = convertSchema(firstSchema, true, context, breadcrumbs, source, namespace);
          return maybeInjectDescriptionOrGroupName(convertedSchema, description, groupName);
        }
      }
    }
    const maybeDiscriminant = getDiscriminant({
      schemas: schema2.anyOf,
      context
    });
    if (maybeDiscriminant != null && !context.options.discriminatedUnionV2) {
      return convertDiscriminatedOneOfWithVariants({
        nameOverride,
        generatedName,
        title,
        breadcrumbs,
        properties: schema2.properties ?? {},
        required: schema2.required,
        description,
        availability,
        wrapAsNullable,
        discriminant: maybeDiscriminant.discriminant,
        variants: maybeDiscriminant.schemas,
        context,
        groupName,
        encoding,
        source,
        namespace
      });
    }
    const hasNullValue = schema2.anyOf.filter((schema3) => {
      return !isReferenceObject(schema3) && schema3.type === "null";
    }).length > 0;
    return convertUndiscriminatedOneOf({
      nameOverride,
      generatedName,
      title,
      breadcrumbs,
      description,
      availability,
      wrapAsNullable: wrapAsNullable || hasNullValue,
      context,
      subtypes: schema2.anyOf.filter((schema3) => {
        return isReferenceObject(schema3) || schema3.type !== "null";
      }),
      encoding,
      groupName,
      source,
      namespace
    });
  }
  if (schema2.allOf != null || schema2.properties != null) {
    const filteredAllOfs = [];
    for (const allOf of schema2.allOf ?? []) {
      if (isReferenceObject(allOf) || Object.keys(allOf).length > 0) {
        filteredAllOfs.push(allOf);
      }
    }
    if ((schema2.properties == null || schema2.properties.length === 0) && filteredAllOfs.length === 1 && filteredAllOfs[0] != null) {
      const convertedSchema = convertSchema(filteredAllOfs[0], wrapAsNullable, context, breadcrumbs, source, namespace, referencedAsRequest);
      return maybeInjectDescriptionOrGroupName(convertedSchema, description, groupName);
    }
    const filteredAllOfObjects = filteredAllOfs.filter((allOf) => {
      const valid = isValidAllOfObject(allOf);
      if (!valid) {
        context.logger.warn(`Skipping non-object allOf element: ${JSON.stringify(allOf)}`);
      }
      return valid;
    });
    if ((schema2.properties == null || schema2.properties.length === 0) && filteredAllOfObjects.length === 1 && filteredAllOfObjects[0] != null) {
      const convertedSchema = convertSchema(filteredAllOfObjects[0], wrapAsNullable, context, breadcrumbs, source, namespace, referencedAsRequest);
      return maybeInjectDescriptionOrGroupName(convertedSchema, description, groupName);
    }
    return convertObject3({
      nameOverride,
      generatedName,
      title,
      breadcrumbs,
      properties: schema2.properties ?? {},
      description,
      required: schema2.required,
      wrapAsNullable,
      allOf: filteredAllOfObjects,
      context,
      propertiesToExclude,
      groupName,
      fullExamples,
      additionalProperties: schema2.additionalProperties,
      availability,
      encoding,
      source,
      namespace
    });
  }
  if (schema2.type === "object" && hasNoOneOf(schema2) && hasNoAllOf(schema2) && hasNoProperties(schema2)) {
    return wrapMap({
      nameOverride,
      generatedName,
      title,
      description,
      availability,
      wrapAsNullable,
      keySchema: {
        nameOverride: void 0,
        generatedName: `${generatedName}Key`,
        title: void 0,
        description: void 0,
        availability: void 0,
        schema: PrimitiveSchemaValueWithExample.string({
          default: getDefaultAsString(schema2),
          pattern: schema2.pattern,
          format: schema2.format,
          minLength: schema2.minLength,
          maxLength: schema2.maxLength,
          example: getExamplesString({ schema: schema2, logger: context.logger, fallback })
        }),
        groupName
      },
      valueSchema: SchemaWithExample.unknown({
        nameOverride: void 0,
        generatedName: `${generatedName}Value`,
        title: void 0,
        description: void 0,
        availability: void 0,
        example: void 0,
        groupName
      }),
      groupName,
      encoding,
      example: schema2.example
    });
  }
  if (schema2.type == null) {
    const inferredValue = schema2.example ?? schema2.default;
    return SchemaWithExample.unknown({
      nameOverride,
      generatedName,
      title,
      description,
      availability,
      groupName,
      example: inferredValue
    });
  }
  throw new Error(`Failed to convert schema breadcrumbs=${JSON.stringify(breadcrumbs)} value=${JSON.stringify(schema2)}`);
}
function getSchemaIdFromReference(ref) {
  if (!ref.$ref.startsWith(SCHEMA_REFERENCE_PREFIX)) {
    return void 0;
  }
  return ref.$ref.replace(SCHEMA_REFERENCE_PREFIX, "");
}
function convertToReferencedSchema(schema2, breadcrumbs, source, preserveSchemaIds) {
  const nameOverride = getExtension(schema2, FernOpenAPIExtension.TYPE_NAME);
  const generatedName = getGeneratedTypeName(breadcrumbs, preserveSchemaIds);
  const description = schema2.description;
  const availability = convertAvailability3(schema2);
  const schemaId = getSchemaIdFromReference(schema2);
  if (schemaId == null) {
    throw new Error(`Invalid schema reference ${JSON.stringify(schema2)}`);
  }
  return Schema.reference({
    // TODO(dsinghvi): references may contain files
    generatedName,
    nameOverride,
    title: void 0,
    schema: schemaId,
    description: description ?? void 0,
    availability,
    groupName: void 0,
    source
  });
}
function hasNoOneOf(schema2) {
  return schema2.oneOf == null || schema2.oneOf.length === 0;
}
function hasNoAllOf(schema2) {
  return schema2.allOf == null || schema2.allOf.length === 0;
}
function hasNoProperties(schema2) {
  return schema2.properties == null || Object.keys(schema2.properties).length === 0;
}
function isListOfStrings(x) {
  return Array.isArray(x) && x.every((item) => typeof item === "string");
}
function maybeInjectDescriptionOrGroupName(schema2, description, groupName) {
  if (schema2.type === "reference") {
    return SchemaWithExample.reference({
      ...schema2,
      description,
      availability: schema2.availability,
      groupName
    });
  } else if (schema2.type === "optional") {
    return SchemaWithExample.optional({
      nameOverride: schema2.nameOverride,
      generatedName: schema2.generatedName,
      title: schema2.title,
      value: schema2.value,
      description,
      availability: schema2.availability,
      groupName
    });
  } else if (schema2.type === "nullable") {
    return SchemaWithExample.nullable({
      nameOverride: schema2.nameOverride,
      generatedName: schema2.generatedName,
      title: schema2.title,
      value: schema2.value,
      description,
      availability: schema2.availability,
      groupName
    });
  }
  return schema2;
}
function isValidAllOfObject(allOf) {
  if (isReferenceObject(allOf) || allOf.type === "object" || allOf.properties != null) {
    return true;
  }
  if (allOf.allOf != null) {
    return allOf.allOf.every((elem) => isValidAllOfObject(elem));
  }
  if (allOf.oneOf != null) {
    return allOf.oneOf.every((elem) => isValidAllOfObject(elem));
  }
  if (allOf.anyOf != null) {
    return allOf.anyOf.every((elem) => isValidAllOfObject(elem));
  }
  return false;
}
function wrapLiteral({ literal, wrapAsNullable, groupName, description, availability, nameOverride, generatedName, title }) {
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.literal({
        nameOverride,
        generatedName,
        title,
        value: literal,
        description,
        availability,
        groupName
      }),
      groupName,
      description,
      availability
    });
  }
  return SchemaWithExample.literal({
    nameOverride,
    generatedName,
    title,
    value: literal,
    groupName,
    description,
    availability
  });
}
function wrapPrimitive({ primitive, wrapAsNullable, groupName, description, availability, generatedName, nameOverride, title }) {
  groupName = typeof groupName === "string" ? [groupName] : groupName;
  if (wrapAsNullable) {
    return SchemaWithExample.nullable({
      nameOverride,
      generatedName,
      title,
      value: SchemaWithExample.primitive({
        nameOverride,
        generatedName,
        title,
        schema: primitive,
        description,
        availability,
        groupName
      }),
      groupName,
      description,
      availability
    });
  }
  return SchemaWithExample.primitive({
    nameOverride,
    generatedName,
    title,
    schema: primitive,
    description,
    availability,
    groupName
  });
}
function getMaybeAllEnumValues({ schemas }) {
  const enumValues = /* @__PURE__ */ new Set();
  for (const schema2 of schemas) {
    if (isReferenceObject(schema2)) {
      return void 0;
    }
    if (schema2.enum != null && isListOfStrings(schema2.enum)) {
      schema2.enum.forEach((val) => enumValues.add(val));
    } else {
      return void 0;
    }
  }
  return Array.from(enumValues);
}
function getDiscriminant({ schemas, context }) {
  const discriminantToVariants = {};
  for (const schema2 of schemas) {
    const possibleDiscriminants = getPossibleDiscriminants({ schema: schema2, context });
    for (const [property4, value] of Object.entries(possibleDiscriminants)) {
      const variants = discriminantToVariants[property4];
      if (variants != null) {
        variants[value] = schema2;
      } else {
        discriminantToVariants[property4] = {
          [value]: schema2
        };
      }
    }
  }
  for (const [discriminant3, variants] of Object.entries(discriminantToVariants)) {
    if (Object.keys(variants).length === schemas.length) {
      return {
        discriminant: discriminant3,
        schemas: variants
      };
    }
  }
  return void 0;
}
function getPossibleDiscriminants({ schema: schema2, context }) {
  const resolvedSchema = isReferenceObject(schema2) ? context.resolveSchemaReference(schema2) : schema2;
  return getPossibleDiscriminantsForSchemaObject({ schema: resolvedSchema, context });
}
function getPossibleDiscriminantsForSchemaObject({ schema: schema2, context }) {
  const possibleDiscrimimants = {};
  if (schema2.anyOf != null) {
    for (const elem of schema2.anyOf) {
      const possibleDiscriminantsForVariant = getPossibleDiscriminants({
        schema: elem,
        context
      });
      for (const [key, value] of Object.entries(possibleDiscriminantsForVariant ?? {})) {
        possibleDiscrimimants[key] = value;
      }
    }
    return possibleDiscrimimants;
  }
  for (const [propertyName, propertySchema] of Object.entries(schema2.properties ?? {})) {
    const resolvedPropertySchema = isReferenceObject(propertySchema) ? context.resolveSchemaReference(propertySchema) : propertySchema;
    if (resolvedPropertySchema.type === "string" && resolvedPropertySchema.enum != null && isListOfStrings(resolvedPropertySchema.enum) && getEnumSet(resolvedPropertySchema.enum).length === 1 && resolvedPropertySchema.enum[0] != null) {
      possibleDiscrimimants[propertyName] = resolvedPropertySchema.enum[0];
    }
    const maybeConstValue = getProperty(resolvedPropertySchema, "const");
    if (resolvedPropertySchema.type === "string" && maybeConstValue != null) {
      possibleDiscrimimants[propertyName] = maybeConstValue;
    }
    if (propertyName === "type" && resolvedPropertySchema.example != null) {
      possibleDiscrimimants[propertyName] = resolvedPropertySchema.example;
    }
  }
  return possibleDiscrimimants;
}
function getEnumSet(enums) {
  if (!enums) {
    return [];
  }
  const set4 = /* @__PURE__ */ new Set();
  enums.forEach((item) => {
    if (typeof item === "string") {
      set4.add(item.toLowerCase());
    } else {
      set4.add(item);
    }
  });
  return Array.from(set4);
}
function getProperty(object3, property4) {
  const extensionValue = object3[property4];
  if (extensionValue != null) {
    return extensionValue;
  }
  return void 0;
}
function getEncoding({ schema: schema2, logger }) {
  const encoding = getFernEncoding({ schema: schema2, logger });
  if (encoding == null) {
    return void 0;
  }
  return convertEncoding(encoding);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/utils/getSchemas.js
function getSchemas(namespace, schemas) {
  let rootSchemas = {};
  let namespacedSchemas = {};
  if (namespace == null) {
    rootSchemas = schemas;
  } else {
    namespacedSchemas = {
      [namespace]: schemas
    };
  }
  return {
    rootSchemas,
    namespacedSchemas
  };
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/asyncapi/AsyncAPIParserContext.js
var MESSAGE_REFERENCE_PREFIX = "#/components/messages/";
var AbstractAsyncAPIV2ParserContext = class {
  logger;
  document;
  taskContext;
  DUMMY;
  options;
  namespace;
  constructor({ document, taskContext, options, namespace }) {
    this.document = document;
    this.taskContext = taskContext;
    this.logger = taskContext.logger;
    this.DUMMY = this;
    this.options = options;
    this.namespace = namespace;
  }
  resolveGroupName(groupName) {
    if (this.namespace != null) {
      return [{ type: "namespace", name: this.namespace }, ...groupName];
    }
    return groupName;
  }
  resolveTags(operationTags, fallback) {
    if (this.namespace == null && operationTags == null && fallback != null) {
      return [fallback];
    }
    const tags = [];
    if (this.namespace != null) {
      const namespaceSegment = {
        type: "namespace",
        name: this.namespace
      };
      tags.push(namespaceSegment);
    }
    return tags.concat(operationTags ?? []);
  }
  resolveSchemaReference(schema2) {
    if (this.document.components == null || this.document.components.schemas == null || !schema2.$ref.startsWith(SCHEMA_REFERENCE_PREFIX)) {
      throw new Error(`Failed to resolve ${schema2.$ref}`);
    }
    const schemaKey = schema2.$ref.substring(SCHEMA_REFERENCE_PREFIX.length);
    const splitSchemaKey = schemaKey.split("/");
    if (splitSchemaKey[0] == null) {
      throw new Error(`${schema2.$ref} is undefined`);
    }
    let resolvedSchema = this.document.components.schemas[splitSchemaKey[0]];
    if (resolvedSchema == null) {
      throw new Error(`${splitSchemaKey[0]} is undefined`);
    }
    if (isReferenceObject(resolvedSchema)) {
      resolvedSchema = this.resolveSchemaReference(resolvedSchema);
    }
    if (splitSchemaKey[1] === "properties" && splitSchemaKey[2] != null) {
      const resolvedProperty = resolvedSchema.properties?.[splitSchemaKey[2]];
      if (resolvedProperty == null) {
        throw new Error(`${schema2.$ref} is undefiened. Property does not exist on object.`);
      } else if (isReferenceObject(resolvedProperty)) {
        resolvedSchema = this.resolveSchemaReference(resolvedProperty);
      } else {
        resolvedSchema = resolvedProperty;
      }
    }
    return resolvedSchema;
  }
  resolveMessageReference(message) {
    if (this.document.components == null || this.document.components.messages == null || !message.$ref.startsWith(MESSAGE_REFERENCE_PREFIX)) {
      throw new Error(`Failed to resolve ${message.$ref}`);
    }
    const messageKey = message.$ref.substring(MESSAGE_REFERENCE_PREFIX.length);
    const resolvedMessage = this.document.components.messages[messageKey];
    if (resolvedMessage == null) {
      throw new Error(`${message.$ref}  is undefined`);
    }
    return resolvedMessage;
  }
  referenceExists(ref) {
    const keys5 = ref.substring(2).split("/").map((key) => key.replace(/~1/g, "/"));
    let resolvedSchema = this.document;
    for (const key of keys5) {
      if (typeof resolvedSchema !== "object" || resolvedSchema == null) {
        return false;
      }
      resolvedSchema = resolvedSchema[key];
    }
    return true;
  }
};
var AsyncAPIV2ParserContext = class extends AbstractAsyncAPIV2ParserContext {
  constructor({ document, taskContext, options, namespace }) {
    super({
      document,
      taskContext,
      options,
      namespace
    });
  }
  markSchemaAsReferencedByNonRequest(schemaId) {
    return;
  }
  markSchemaAsReferencedByRequest(schemaId) {
    return;
  }
  markReferencedByDiscriminatedUnion(schema2, discrminant, times) {
    return;
  }
  markSchemaWithDiscriminantValue(schema2, discrminant, discriminantValue) {
    return;
  }
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/examples/convertToFullExample.js
function convertToFullExample(value) {
  if (typeof value === "string") {
    return FullExample.primitive(PrimitiveExample.string(value));
  } else if (typeof value === "number") {
    if (Number.isInteger(value)) {
      return FullExample.primitive(PrimitiveExample.int(value));
    }
    return FullExample.primitive(PrimitiveExample.double(value));
  } else if (typeof value === "boolean") {
    return FullExample.primitive(PrimitiveExample.boolean(value));
  } else if (Array.isArray(value)) {
    const examples = value.map((example) => convertToFullExample(example));
    if (examples.length === 0) {
      return void 0;
    }
    return FullExample.array(examples.filter((example) => example != null));
  } else if (value != null && typeof value === "object" && Object.keys(value).every((key) => typeof key === "string")) {
    const kvs = [];
    for (const [property4, propertyValue] of Object.entries(value)) {
      const propertyExample = convertToFullExample(propertyValue);
      if (propertyExample != null) {
        kvs.push({
          key: PrimitiveExample.string(property4),
          value: propertyExample
        });
      }
    }
    return FullExample.map(kvs);
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/examples/getFullExample.js
function getFullExampleAsObject(value) {
  if (value != null && typeof value === "object" && Object.keys(value).every((key) => typeof key === "string")) {
    return value;
  }
  return void 0;
}
function getFullExampleAsArray(value) {
  if (value != null && Array.isArray(value)) {
    return value;
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/examples/ExampleTypeFactory.js
var ExampleTypeFactory = class {
  schemas;
  nonRequestReferencedSchemas;
  context;
  constructor(schemas, nonRequestReferencedSchemas, context) {
    this.schemas = schemas;
    this.nonRequestReferencedSchemas = nonRequestReferencedSchemas;
    this.context = context;
  }
  buildExample({ schema: schema2, exampleId, example, options, skipReadonly }) {
    return this.buildExampleHelper({
      schema: schema2,
      visitedSchemaIds: /* @__PURE__ */ new Set(),
      exampleId,
      example,
      // Default maxCheckerDepth to 5
      options: { ...options, maxCheckerDepth: options.maxCheckerDepth ?? 5 },
      depth: 0,
      skipReadonly: skipReadonly ?? false
    });
  }
  buildExampleHelper({ exampleId, example, schema: schema2, depth, visitedSchemaIds, options, skipReadonly }) {
    switch (schema2.type) {
      case "enum":
        if (typeof example === "string" && enumContainsValue({ schema: schema2, value: example })) {
          return FullExample.enum(example);
        }
        return schema2.values[0] != null ? FullExample.enum(schema2.values[0]?.value) : void 0;
      case "literal":
        return FullExample.literal(schema2.value);
      case "nullable": {
        if (example == null && !this.hasExample(schema2.value, 0, visitedSchemaIds, options) && (options.ignoreOptionals || this.exceedsMaxDepth(depth, options))) {
          return void 0;
        }
        const result = this.buildExampleHelper({
          schema: schema2.value,
          visitedSchemaIds,
          exampleId,
          example,
          depth,
          options,
          skipReadonly
        });
        if (result != null && result.type === "array" && result.value.length === 0) {
          return void 0;
        }
        if (result != null && result.type === "map" && result.value.length === 0) {
          return void 0;
        }
        if (result != null && result.type === "object" && Object.keys(result.properties).length === 0) {
          return void 0;
        }
        return result;
      }
      case "optional": {
        if (example == null && !this.hasExample(schema2.value, 0, visitedSchemaIds, options) && (options.ignoreOptionals || this.exceedsMaxDepth(depth, options))) {
          return void 0;
        }
        if (Object.is(example, null)) {
          return void 0;
        }
        const result = this.buildExampleHelper({
          schema: schema2.value,
          visitedSchemaIds,
          exampleId,
          example,
          depth,
          options,
          skipReadonly
        });
        if (result != null && result.type === "array" && result.value.length === 0) {
          return void 0;
        }
        if (result != null && result.type === "map" && result.value.length === 0) {
          return void 0;
        }
        if (result != null && result.type === "object" && Object.keys(result.properties).length === 0) {
          return void 0;
        }
        return result;
      }
      case "primitive": {
        const primitiveExample = this.buildExampleFromPrimitive({ schema: schema2.schema, example, options });
        return FullExample.primitive(primitiveExample);
      }
      case "reference": {
        const referencedSchemaWithExample = this.schemas[schema2.schema];
        if (referencedSchemaWithExample != null && !visitedSchemaIds.has(schema2.schema)) {
          visitedSchemaIds.add(schema2.schema);
          const isInlinedRequest = referencedSchemaWithExample?.type === "object" && !this.nonRequestReferencedSchemas.has(schema2.schema);
          const referencedExample = this.buildExampleHelper({
            example,
            schema: referencedSchemaWithExample,
            exampleId,
            visitedSchemaIds,
            depth,
            options,
            // by default we respect readonly on inlined requests
            skipReadonly: isInlinedRequest || this.context.options.respectReadonlySchemas ? skipReadonly : false
          });
          visitedSchemaIds.delete(schema2.schema);
          return referencedExample;
        }
        return void 0;
      }
      case "oneOf":
        switch (schema2.value.type) {
          case "discriminated": {
            const result = {};
            let allProperties = {};
            let requiredProperties = {};
            const fullExample = getFullExampleAsObject(example);
            const exampleDiscriminant = fullExample?.[schema2.value.discriminantProperty];
            const exampleUnionVariantSchema = schema2.value.schemas[exampleDiscriminant];
            const unionVariants = [];
            const schemaFromExample = this.getDiscriminatedUnionVariantSchema(schema2.value, fullExample);
            if (schemaFromExample != null) {
              unionVariants.push(schemaFromExample);
            }
            unionVariants.push(...Object.entries(schema2.value.schemas));
            for (const unionVariant of unionVariants) {
              if (exampleDiscriminant != null && exampleUnionVariantSchema != null && exampleUnionVariantSchema.type === "object") {
                allProperties = this.getAllProperties(exampleUnionVariantSchema);
                requiredProperties = this.getAllRequiredProperties(exampleUnionVariantSchema);
                result[schema2.value.discriminantProperty] = FullExample.primitive(PrimitiveExample.string(exampleDiscriminant));
                break;
              } else {
                const objectSchema = this.getObjectSchema(unionVariant[1]);
                if (objectSchema == null) {
                  continue;
                }
                allProperties = this.getAllProperties(objectSchema);
                requiredProperties = this.getAllRequiredProperties(objectSchema);
                result[schema2.value.discriminantProperty] = FullExample.primitive(PrimitiveExample.string(unionVariant[0]));
              }
            }
            for (const commonProperty of schema2.value.commonProperties) {
              allProperties[commonProperty.key] = { schema: commonProperty.schema, readonly: false };
              const resolvedSchema = this.getResolvedSchema(commonProperty.schema);
              if (resolvedSchema.type !== "optional" && resolvedSchema.type !== "nullable") {
                requiredProperties[commonProperty.key] = commonProperty.schema;
              }
            }
            for (const [property4, schema3] of Object.entries(allProperties)) {
              const required = property4 in requiredProperties;
              if (required && fullExample?.[property4] != null) {
                const propertyExample = this.buildExampleHelper({
                  schema: schema3.schema,
                  exampleId,
                  example: fullExample[property4],
                  visitedSchemaIds,
                  depth: depth + 1,
                  options,
                  skipReadonly
                });
                if (propertyExample != null) {
                  result[property4] = propertyExample;
                } else {
                  return void 0;
                }
              } else {
                const propertyExample = this.buildExampleHelper({
                  exampleId,
                  schema: schema3.schema,
                  example: fullExample?.[property4],
                  visitedSchemaIds,
                  depth: depth + 1,
                  options,
                  skipReadonly
                });
                if (propertyExample != null) {
                  result[property4] = propertyExample;
                } else if (required) {
                  return void 0;
                }
              }
            }
            return FullExample.oneOf(FullOneOfExample.discriminated(result));
          }
          case "undisciminated": {
            const unionVariantSchema = this.getUnDiscriminatedUnionVariantSchema(schema2.value, example);
            if (unionVariantSchema != null) {
              return this.buildExampleHelper({
                exampleId,
                example,
                schema: unionVariantSchema,
                visitedSchemaIds,
                depth,
                options,
                skipReadonly
              });
            }
            break;
          }
        }
        return void 0;
      case "unknown":
        if (example != null) {
          const fullExample = convertToFullExample(example);
          if (fullExample != null) {
            return FullExample.unknown(fullExample);
          }
        }
        if (options.ignoreOptionals || this.exceedsMaxDepth(depth, options)) {
          return void 0;
        }
        if (options.isParameter) {
          return FullExample.primitive(PrimitiveExample.string(options.name ?? "string"));
        }
        return FullExample.map([
          {
            key: PrimitiveExample.string("key"),
            value: FullExample.primitive(PrimitiveExample.string("value"))
          }
        ]);
      case "array": {
        const fullExample = getFullExampleAsArray(example);
        const itemExamples = [];
        if (fullExample != null && fullExample.length > 0) {
          for (const item of fullExample) {
            const itemExample = this.buildExampleHelper({
              exampleId,
              example: item,
              schema: schema2.value,
              depth: depth + 1,
              visitedSchemaIds,
              options,
              skipReadonly
            });
            if (itemExample != null) {
              itemExamples.push(itemExample);
            }
          }
        } else if (schema2.example != null && schema2.example.length > 0) {
          for (const item of schema2.example) {
            const itemExample = this.buildExampleHelper({
              exampleId,
              example: item,
              schema: schema2.value,
              depth: depth + 1,
              visitedSchemaIds,
              options,
              skipReadonly
            });
            if (itemExample != null) {
              itemExamples.push(itemExample);
            }
          }
        } else {
          const itemExample = this.buildExampleHelper({
            exampleId,
            example: void 0,
            schema: schema2.value,
            depth: depth + 1,
            visitedSchemaIds,
            options,
            skipReadonly
          });
          if (itemExample != null) {
            itemExamples.push(itemExample);
          }
        }
        return FullExample.array(itemExamples);
      }
      case "map": {
        const objectExample = getFullExampleAsObject(example ?? schema2.example);
        if (objectExample != null && Object.entries(objectExample).length > 0) {
          const kvs = [];
          for (const [key, value] of Object.entries(objectExample)) {
            const keyExample2 = this.buildExampleFromPrimitive({
              schema: schema2.key.schema,
              example: key,
              options
            });
            const valueExample2 = this.buildExampleHelper({
              exampleId,
              example: value,
              schema: schema2.value,
              visitedSchemaIds,
              depth: depth + 1,
              options,
              skipReadonly
            });
            if (valueExample2 != null) {
              kvs.push({
                key: keyExample2,
                value: valueExample2
              });
            }
          }
          return FullExample.map(kvs);
        }
        if (schema2.key.schema.type === "string" && schema2.value.type === "unknown") {
          return FullExample.map([
            {
              key: PrimitiveExample.string("key"),
              value: FullExample.unknown(FullExample.primitive(PrimitiveExample.string("value")))
            }
          ]);
        }
        const keyExample = this.buildExampleFromPrimitive({
          schema: schema2.key.schema,
          example: void 0,
          options: {
            ...options,
            // override the name to be "key" for map keys otherwise you can start to get key name
            // nesting since primitive examples use their name e.g. "metadata": {"metadata": {...}}
            name: "key"
          }
        });
        const valueExample = this.buildExampleHelper({
          exampleId,
          example: void 0,
          schema: schema2.value,
          visitedSchemaIds,
          depth: depth + 1,
          options: {
            ...options,
            // override the name to be "value" for map value otherwise you can start to get key name
            // nesting since primitive examples use their name e.g. "metadata": {"metadata": "metadata"}
            name: "value"
          },
          skipReadonly
        });
        if (valueExample != null) {
          return FullExample.map([
            {
              key: keyExample,
              value: valueExample
            }
          ]);
        }
        return FullExample.map([]);
      }
      case "object": {
        const result = {};
        const foundObjectExample = schema2.fullExamples?.find((example2) => example2.name === exampleId) ?? schema2.fullExamples?.find((example2) => example2.name == null) ?? schema2.fullExamples?.[0];
        const fullExample = getFullExampleAsObject(example) ?? (foundObjectExample != null ? getFullExampleAsObject(foundObjectExample.value) : {}) ?? {};
        const allProperties = this.getAllProperties(schema2);
        const requiredProperties = this.getAllRequiredProperties(schema2);
        for (const [property4, schema3] of Object.entries(allProperties)) {
          if (skipReadonly && schema3.readonly) {
            continue;
          }
          const required = property4 in requiredProperties;
          const inExample = Object.keys(fullExample).includes(property4);
          const propertyExample = this.buildExampleHelper({
            schema: schema3.schema,
            exampleId,
            example: fullExample[property4],
            visitedSchemaIds,
            depth: depth + 1,
            options: {
              ...options,
              name: property4
            },
            skipReadonly
          });
          if (required && propertyExample != null) {
            result[property4] = propertyExample;
          } else if (required) {
            return void 0;
          } else if (inExample && propertyExample != null) {
            result[property4] = propertyExample;
          } else if (!options.ignoreOptionals && propertyExample != null) {
            result[property4] = propertyExample;
          }
        }
        return FullExample.object({
          properties: result
        });
      }
      default:
        assertNever(schema2);
    }
  }
  getObjectSchema(schema2) {
    if (schema2.type === "object") {
      return schema2;
    }
    if (schema2.type === "reference") {
      const referenceDeclaration = this.schemas[schema2.schema];
      if (referenceDeclaration != null) {
        return this.getObjectSchema(referenceDeclaration);
      }
    }
    return void 0;
  }
  getDiscriminatedUnionVariantSchema(schema2, fullExample) {
    const discriminantValue = fullExample?.[schema2.discriminantProperty];
    if (discriminantValue == null || typeof discriminantValue !== "string") {
      return Object.entries(schema2.schemas)[0];
    }
    const unionVariantSchema = schema2.schemas[discriminantValue];
    if (unionVariantSchema == null) {
      return Object.entries(schema2.schemas)[0];
    }
    return [discriminantValue, unionVariantSchema];
  }
  getUnDiscriminatedUnionVariantSchema(schema2, fullExample) {
    if (fullExample == null) {
      return schema2.schemas[0];
    }
    const matches = schema2.schemas.map((schema3) => ({
      schema: schema3,
      heuristic: this.calcExampleHeuristic(schema3, fullExample)
    }));
    const sortedMatches = matches.sort((a, b) => b.heuristic - a.heuristic);
    return sortedMatches[0]?.schema;
  }
  // this is not a perfect heuristic, but it's a start. algorithm is as follows:
  // * tally up all properties that are both in the schema and example when traversing recursively
  // * subtract 1 for every property that is in the example but not in the schema.
  // this doesn't account for objects that can have arbitrary properties, and overvalues schemas with more properties.
  calcExampleHeuristic(schema2, fullExample) {
    switch (schema2.type) {
      case "literal": {
        return schema2.value.value === fullExample ? 5 : 0;
      }
      case "enum": {
        return enumContainsValue({ schema: schema2, value: fullExample }) ? 5 : 0;
      }
      case "object": {
        if (!isPlainObject2(fullExample)) {
          return 0;
        }
        const allProperties = this.getAllProperties(schema2);
        let heuristic = 0;
        for (const [property4, schema3] of Object.entries(allProperties)) {
          if (fullExample[property4] != null) {
            heuristic++;
            heuristic += this.calcExampleHeuristic(schema3.schema, fullExample[property4]);
          } else {
            heuristic--;
          }
        }
        return heuristic;
      }
      case "array": {
        if (!Array.isArray(fullExample)) {
          return 0;
        }
        let heuristic = 0;
        for (const item of fullExample) {
          heuristic += this.calcExampleHeuristic(schema2.value, item);
        }
        return heuristic;
      }
      case "map": {
        if (!isPlainObject2(fullExample)) {
          return 0;
        }
        let heuristic = 0;
        for (const [, value] of Object.entries(fullExample)) {
          heuristic += this.calcExampleHeuristic(schema2.value, value);
        }
        return heuristic;
      }
      case "nullable":
      case "optional": {
        return this.calcExampleHeuristic(schema2.value, fullExample);
      }
      case "reference": {
        const resolvedSchema = this.getResolvedSchema(schema2);
        if (resolvedSchema == null) {
          return 0;
        }
        return this.calcExampleHeuristic(resolvedSchema, fullExample);
      }
      case "oneOf": {
        const matches = Object.values(schema2.value.schemas).map((schema3) => this.calcExampleHeuristic(schema3, fullExample));
        return matches.sort((a, b) => b - a)[0] ?? 0;
      }
      case "primitive": {
        if (fullExample == null) {
          return 0;
        }
        const matches = schema2.schema._visit({
          int: () => typeof fullExample === "number",
          int64: () => typeof fullExample === "number",
          uint: () => typeof fullExample === "number",
          uint64: () => typeof fullExample === "number",
          float: () => typeof fullExample === "number",
          double: () => typeof fullExample === "number",
          string: () => typeof fullExample === "string",
          datetime: () => typeof fullExample === "string",
          date: () => typeof fullExample === "string",
          base64: () => typeof fullExample === "string",
          boolean: () => typeof fullExample === "boolean",
          _other: () => true
        });
        return matches ? 1 : -1;
      }
      default:
        return 0;
    }
  }
  hasExample(schema2, depth, visitedSchemaIds = /* @__PURE__ */ new Set(), options) {
    if (this.exceedsMaxCheckerDepth(depth, options)) {
      return false;
    }
    switch (schema2.type) {
      case "array":
        return this.hasExample(schema2.value, depth + 1, visitedSchemaIds, options);
      case "enum":
        return schema2.example != null;
      case "literal":
        return false;
      case "map":
        return schema2.example != null || schema2.key.schema.example != null && this.hasExample(schema2.value, depth + 1, visitedSchemaIds, options);
      case "object": {
        const objectExample = schema2.fullExamples != null && schema2.fullExamples.length > 0;
        if (objectExample) {
          return true;
        }
        for (const property4 of schema2.properties) {
          if (this.hasExample(property4.schema, depth + 1, visitedSchemaIds, options)) {
            return true;
          }
        }
        return false;
      }
      case "primitive":
        return schema2.schema.example != null;
      case "reference": {
        const resolvedSchema = this.schemas[schema2.schema];
        if (resolvedSchema != null && !visitedSchemaIds.has(schema2.schema)) {
          visitedSchemaIds.add(schema2.schema);
          const hasExample = this.hasExample(resolvedSchema, depth, visitedSchemaIds, options);
          visitedSchemaIds.delete(schema2.schema);
          return hasExample;
        }
        return false;
      }
      case "unknown":
        return schema2.example != null;
      case "oneOf":
        return Object.values(schema2.value.schemas).some((schema3) => this.hasExample(schema3, depth, visitedSchemaIds, options));
      default:
        return false;
    }
  }
  exceedsMaxCheckerDepth(depth, options) {
    return depth > (options.maxCheckerDepth ?? 0);
  }
  exceedsMaxDepth(depth, options) {
    return depth > (options.maxDepth ?? 0);
  }
  getAllProperties(object3) {
    let properties = {};
    for (const property4 of object3.properties) {
      properties[property4.key] = { schema: property4.schema, readonly: property4.readonly ?? false };
    }
    for (const allOf of object3.allOf) {
      const allOfSchema = this.schemas[allOf.schema];
      if (allOfSchema == null) {
        continue;
      }
      const resolvedAllOfSchema = this.getResolvedSchema(allOfSchema);
      if (resolvedAllOfSchema.type !== "object") {
        continue;
      }
      properties = {
        ...this.getAllProperties(resolvedAllOfSchema),
        ...properties
      };
    }
    return properties;
  }
  getAllRequiredProperties(object3) {
    let requiredProperties = {};
    for (const property4 of object3.properties) {
      const resolvedSchema = this.getResolvedSchema(property4.schema);
      if (resolvedSchema.type !== "optional" && resolvedSchema.type !== "nullable") {
        requiredProperties[property4.key] = property4.schema;
      }
    }
    for (const allOf of object3.allOf) {
      const allOfSchema = this.schemas[allOf.schema];
      if (allOfSchema == null) {
        continue;
      }
      const resolvedAllOfSchema = this.getResolvedSchema(allOfSchema);
      if (resolvedAllOfSchema.type !== "object") {
        continue;
      }
      requiredProperties = {
        ...this.getAllRequiredProperties(resolvedAllOfSchema),
        ...requiredProperties
      };
    }
    return requiredProperties;
  }
  getResolvedSchema(schema2) {
    while (schema2.type === "reference") {
      const resolvedSchema = this.schemas[schema2.schema];
      if (resolvedSchema == null) {
        throw new Error(`Unexpected error: Failed to resolve schema reference: ${schema2.schema}`);
      }
      schema2 = resolvedSchema;
    }
    return schema2;
  }
  buildExampleFromPrimitive({ example, schema: schema2, options }) {
    switch (schema2.type) {
      case "string":
        if (example != null && typeof example === "string") {
          return PrimitiveExample.string(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.string(schema2.example);
        } else {
          return PrimitiveExample.string(options.name ?? examples_exports.STRING);
        }
      case "base64":
        if (example != null && typeof example === "string") {
          return PrimitiveExample.base64(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.base64(schema2.example);
        } else {
          return PrimitiveExample.base64(examples_exports.BASE64);
        }
      case "boolean":
        if (example != null && typeof example === "boolean") {
          return PrimitiveExample.boolean(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.boolean(schema2.example);
        } else {
          return PrimitiveExample.boolean(examples_exports.BOOLEAN);
        }
      case "date":
        if (example != null && typeof example === "string") {
          return PrimitiveExample.date(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.date(schema2.example);
        } else {
          return PrimitiveExample.date(examples_exports.DATE);
        }
      case "datetime":
        if (example != null && typeof example === "string") {
          return PrimitiveExample.datetime(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.datetime(schema2.example);
        } else {
          return PrimitiveExample.datetime(examples_exports.DATE_TIME);
        }
      case "double":
        if (example != null && typeof example === "number") {
          return PrimitiveExample.double(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.double(schema2.example);
        } else {
          return PrimitiveExample.double(examples_exports.DOUBLE);
        }
      case "float":
        if (example != null && typeof example === "number") {
          return PrimitiveExample.float(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.float(schema2.example);
        } else {
          return PrimitiveExample.float(examples_exports.FLOAT);
        }
      case "int":
        if (example != null && typeof example === "number") {
          return PrimitiveExample.int(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.int(schema2.example);
        } else {
          return PrimitiveExample.int(examples_exports.INT);
        }
      case "int64":
        if (example != null && typeof example === "number") {
          return PrimitiveExample.int64(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.int64(schema2.example);
        } else {
          return PrimitiveExample.int64(examples_exports.INT64);
        }
      case "uint":
        if (example != null && typeof example === "number") {
          return PrimitiveExample.uint(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.uint(schema2.example);
        } else {
          return PrimitiveExample.uint(examples_exports.UINT);
        }
      case "uint64":
        if (example != null && typeof example === "number") {
          return PrimitiveExample.uint64(example);
        } else if (schema2.example != null) {
          return PrimitiveExample.uint64(schema2.example);
        } else {
          return PrimitiveExample.uint64(examples_exports.UINT64);
        }
      default:
        assertNever(schema2);
    }
  }
};
function enumContainsValue({ schema: schema2, value }) {
  return schema2.values.map((enumValue) => {
    return enumValue.value;
  }).includes(value);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/convertSchemaToSchemaWithExample.js
function convertSchemaToSchemaWithExample(schema2) {
  switch (schema2.type) {
    case "object":
      return SchemaWithExample.object({
        allOf: schema2.allOf,
        properties: schema2.properties.map((objectProperty) => convertToObjectProperty2(objectProperty)),
        allOfPropertyConflicts: schema2.allOfPropertyConflicts,
        description: schema2.description,
        generatedName: schema2.generatedName,
        title: schema2.title,
        nameOverride: schema2.nameOverride,
        groupName: schema2.groupName,
        fullExamples: void 0,
        additionalProperties: schema2.additionalProperties,
        availability: schema2.availability,
        source: schema2.source
      });
    case "array":
      return SchemaWithExample.array({
        description: schema2.description,
        availability: schema2.availability,
        value: convertSchemaToSchemaWithExample(schema2.value),
        generatedName: schema2.generatedName,
        title: schema2.title,
        nameOverride: schema2.nameOverride,
        groupName: schema2.groupName,
        example: void 0
      });
    case "enum":
      return SchemaWithExample.enum({
        description: schema2.description,
        availability: schema2.availability,
        generatedName: schema2.generatedName,
        title: schema2.title,
        nameOverride: schema2.nameOverride,
        values: schema2.values,
        default: schema2.default,
        groupName: schema2.groupName,
        example: void 0,
        source: schema2.source
      });
    case "literal":
      return SchemaWithExample.literal({
        description: schema2.description,
        availability: schema2.availability,
        value: schema2.value,
        generatedName: schema2.generatedName,
        title: schema2.title,
        nameOverride: schema2.nameOverride,
        groupName: schema2.groupName
      });
    case "nullable":
      return SchemaWithExample.nullable({
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        description: schema2.description,
        availability: schema2.availability,
        value: convertSchemaToSchemaWithExample(schema2.value),
        groupName: schema2.groupName
      });
    case "optional":
      return SchemaWithExample.optional({
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        description: schema2.description,
        availability: schema2.availability,
        value: convertSchemaToSchemaWithExample(schema2.value),
        groupName: schema2.groupName
      });
    case "primitive":
      return SchemaWithExample.primitive({
        description: schema2.description,
        availability: schema2.availability,
        schema: convertToPrimitiveSchemaValue2(schema2.schema),
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        groupName: schema2.groupName
      });
    case "map":
      return SchemaWithExample.map({
        description: schema2.description,
        availability: schema2.availability,
        key: SchemaWithExample.primitive({
          description: schema2.key.description,
          availability: schema2.key.availability,
          schema: convertToPrimitiveSchemaValue2(schema2.key.schema),
          generatedName: schema2.key.generatedName,
          nameOverride: schema2.key.nameOverride,
          title: schema2.key.title,
          groupName: schema2.groupName
        }),
        value: convertSchemaToSchemaWithExample(schema2.value),
        generatedName: schema2.generatedName,
        nameOverride: schema2.nameOverride,
        title: schema2.title,
        groupName: schema2.groupName,
        encoding: schema2.encoding,
        example: void 0
      });
    case "reference":
      return SchemaWithExample.reference({
        description: schema2.description,
        availability: schema2.availability,
        generatedName: schema2.generatedName,
        title: schema2.title,
        nameOverride: schema2.nameOverride,
        schema: schema2.schema,
        groupName: schema2.groupName,
        source: schema2.source
      });
    case "oneOf":
      return SchemaWithExample.oneOf(convertToOneOf2(schema2.value));
    case "unknown":
      return SchemaWithExample.unknown({
        nameOverride: schema2.nameOverride,
        generatedName: schema2.generatedName,
        title: void 0,
        example: void 0,
        groupName: void 0,
        description: void 0,
        availability: void 0
      });
    default:
      assertNever(schema2);
  }
}
function convertToOneOf2(oneOfSchema) {
  switch (oneOfSchema.type) {
    case "discriminated":
      return OneOfSchemaWithExample.discriminated({
        commonProperties: oneOfSchema.commonProperties.map((commonProperty) => {
          return {
            key: commonProperty.key,
            schema: convertSchemaToSchemaWithExample(commonProperty.schema)
          };
        }),
        description: oneOfSchema.description,
        availability: oneOfSchema.availability,
        discriminantProperty: oneOfSchema.discriminantProperty,
        generatedName: oneOfSchema.generatedName,
        nameOverride: oneOfSchema.nameOverride,
        title: oneOfSchema.title,
        schemas: Object.fromEntries(Object.entries(oneOfSchema.schemas).map(([discriminantValue, schemaWithExample]) => {
          return [discriminantValue, convertSchemaToSchemaWithExample(schemaWithExample)];
        })),
        groupName: oneOfSchema.groupName,
        encoding: oneOfSchema.encoding,
        source: oneOfSchema.source
      });
    case "undisciminated":
      return OneOfSchemaWithExample.undisciminated({
        description: oneOfSchema.description,
        availability: oneOfSchema.availability,
        generatedName: oneOfSchema.generatedName,
        nameOverride: oneOfSchema.nameOverride,
        title: oneOfSchema.title,
        schemas: oneOfSchema.schemas.map((oneOfSchema2) => convertSchemaToSchemaWithExample(oneOfSchema2)),
        groupName: oneOfSchema.groupName,
        encoding: oneOfSchema.encoding,
        source: oneOfSchema.source
      });
    default:
      assertNever(oneOfSchema);
  }
}
function convertToPrimitiveSchemaValue2(primitiveSchema) {
  switch (primitiveSchema.type) {
    case "string":
      return PrimitiveSchemaValueWithExample.string({
        default: primitiveSchema.default,
        pattern: primitiveSchema.pattern,
        format: primitiveSchema.format,
        minLength: primitiveSchema.minLength,
        maxLength: primitiveSchema.maxLength,
        example: void 0
      });
    case "base64":
      return PrimitiveSchemaValueWithExample.base64({
        example: void 0
      });
    case "boolean":
      return PrimitiveSchemaValueWithExample.boolean({
        default: primitiveSchema.default,
        example: void 0
      });
    case "date":
      return PrimitiveSchemaValueWithExample.date({
        example: void 0
      });
    case "datetime":
      return PrimitiveSchemaValueWithExample.datetime({
        example: void 0
      });
    case "double":
      return PrimitiveSchemaValueWithExample.double({
        default: primitiveSchema.default,
        minimum: primitiveSchema.minimum,
        maximum: primitiveSchema.maximum,
        exclusiveMinimum: primitiveSchema.exclusiveMinimum,
        exclusiveMaximum: primitiveSchema.exclusiveMaximum,
        multipleOf: primitiveSchema.multipleOf,
        example: void 0
      });
    case "float":
      return PrimitiveSchemaValueWithExample.float({
        example: void 0
      });
    case "int":
      return PrimitiveSchemaValueWithExample.int({
        default: primitiveSchema.default,
        minimum: primitiveSchema.minimum,
        maximum: primitiveSchema.maximum,
        exclusiveMinimum: primitiveSchema.exclusiveMinimum,
        exclusiveMaximum: primitiveSchema.exclusiveMaximum,
        multipleOf: primitiveSchema.multipleOf,
        example: void 0
      });
    case "int64":
      return PrimitiveSchemaValueWithExample.int64({
        default: primitiveSchema.default,
        example: void 0
      });
    case "uint":
      return PrimitiveSchemaValueWithExample.uint({
        default: void 0,
        example: void 0
      });
    case "uint64":
      return PrimitiveSchemaValueWithExample.uint64({
        default: void 0,
        example: void 0
      });
    default:
      assertNever(primitiveSchema);
  }
}
function convertToObjectProperty2(objectProperty) {
  return {
    conflict: objectProperty.conflict,
    generatedName: objectProperty.generatedName,
    key: objectProperty.key,
    schema: convertSchemaToSchemaWithExample(objectProperty.schema),
    audiences: objectProperty.audiences,
    nameOverride: objectProperty.nameOverride,
    availability: objectProperty.availability,
    readonly: objectProperty.readonly
  };
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/isSchemaRequired.js
function isSchemaRequired3(schema2) {
  return schema2.type !== "optional" && schema2.type !== "nullable";
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/hasIncompleteExample.js
function hasIncompleteExample(example) {
  if (example.type === "full") {
    return example.request == null && example.response == null && example.queryParameters == null && example.pathParameters == null && example.headers == null;
  } else {
    const castExample = example.value;
    return castExample.request == null && castExample.response == null && castExample["query-parameters"] == null && castExample["path-parameters"] == null && castExample.headers == null;
  }
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/ExampleEndpointFactory.js
var ExampleEndpointFactory = class {
  exampleTypeFactory;
  logger;
  schemas;
  constructor(schemas, context) {
    this.schemas = schemas;
    this.exampleTypeFactory = new ExampleTypeFactory(schemas, context.nonRequestReferencedSchemas, context);
    this.logger = context.logger;
  }
  buildEndpointExample(endpoint) {
    this.logger.debug(`Building endpoint example for ${endpoint.method.toUpperCase()} ${endpoint.path}`);
    const requestSchemaIdResponse = getRequestSchema(endpoint.request);
    const responseSchemaIdResponse = getResponseSchema(endpoint.response);
    if (requestSchemaIdResponse?.type === "unsupported" || responseSchemaIdResponse?.type === "unsupported") {
      return [];
    }
    const requestExamples = [];
    if (requestSchemaIdResponse != null && requestSchemaIdResponse.type === "present") {
      const required = this.isSchemaRequired(requestSchemaIdResponse.schema);
      if (requestSchemaIdResponse.examples.length === 0) {
        const example = this.exampleTypeFactory.buildExample({
          skipReadonly: endpoint.method === "POST" || endpoint.method === "PUT",
          schema: requestSchemaIdResponse.schema,
          exampleId: void 0,
          example: void 0,
          options: {
            isParameter: false,
            ignoreOptionals: true
          }
        });
        if (example != null) {
          requestExamples.push([void 0, example]);
        }
      } else {
        for (const { name: exampleId, value: rawExample } of requestSchemaIdResponse.examples) {
          const example = this.exampleTypeFactory.buildExample({
            skipReadonly: endpoint.method === "POST" || endpoint.method === "PUT",
            schema: requestSchemaIdResponse.schema,
            exampleId,
            example: rawExample,
            options: {
              isParameter: false,
              ignoreOptionals: true
            }
          });
          if (example != null) {
            requestExamples.push([exampleId, example]);
          }
        }
      }
      if (required && requestExamples.length === 0) {
        this.logger.warn(`Failed to generate required request example for ${endpoint.method.toUpperCase()} ${endpoint.path}`);
        return [];
      }
    }
    const responseExamples = [];
    if (responseSchemaIdResponse != null && responseSchemaIdResponse.type === "present") {
      const required = this.isSchemaRequired(responseSchemaIdResponse.schema);
      if (responseSchemaIdResponse.examples.length === 0) {
        const example = this.exampleTypeFactory.buildExample({
          skipReadonly: false,
          schema: responseSchemaIdResponse.schema,
          exampleId: void 0,
          example: void 0,
          options: {
            maxDepth: 3,
            isParameter: false,
            ignoreOptionals: false
          }
        });
        if (example != null) {
          if (endpoint.response?.type === "json") {
            responseExamples.push([void 0, EndpointResponseExample.withoutStreaming(example)]);
          } else if (endpoint.response?.type === "streamingJson") {
            responseExamples.push([void 0, EndpointResponseExample.withStreaming([example])]);
          }
        }
      } else {
        for (const { name: exampleId, value: rawExample } of responseSchemaIdResponse.examples) {
          const example = this.exampleTypeFactory.buildExample({
            skipReadonly: false,
            schema: responseSchemaIdResponse.schema,
            exampleId,
            example: rawExample,
            options: {
              maxDepth: 3,
              isParameter: false,
              ignoreOptionals: false
            }
          });
          if (example != null) {
            if (endpoint.response?.type === "json") {
              responseExamples.push([exampleId, EndpointResponseExample.withoutStreaming(example)]);
            } else if (endpoint.response?.type === "streamingJson") {
              responseExamples.push([exampleId, EndpointResponseExample.withStreaming([example])]);
            }
          }
        }
      }
      if (required && responseExamples.length === 0) {
        this.logger.warn(`Failed to generate required response example for ${endpoint.method.toUpperCase()} ${endpoint.path}`);
        return [];
      }
    }
    const pathParameters = [];
    for (const pathParameter of endpoint.pathParameters) {
      const required = this.isSchemaRequired(pathParameter.schema);
      let example = this.exampleTypeFactory.buildExample({
        schema: pathParameter.schema,
        exampleId: void 0,
        example: void 0,
        options: {
          name: pathParameter.name,
          isParameter: true,
          ignoreOptionals: true
        }
      });
      if (example != null && !isExamplePrimitive(example)) {
        this.logger.warn(`Expected a primitive example but got ${example.type} for path parameter ${pathParameter.name} for ${endpoint.method.toUpperCase()} ${endpoint.path}`);
        example = void 0;
      }
      if (required && example == null) {
        return [];
      } else if (example != null) {
        pathParameters.push({
          name: pathParameter.name,
          parameterNameOverride: pathParameter.parameterNameOverride,
          value: example
        });
      }
    }
    const queryParameters = [];
    for (const queryParameter of endpoint.queryParameters) {
      const required = this.isSchemaRequired(queryParameter.schema);
      let example = this.exampleTypeFactory.buildExample({
        schema: queryParameter.schema,
        exampleId: void 0,
        example: void 0,
        options: {
          name: queryParameter.name,
          isParameter: true,
          ignoreOptionals: true
        }
      });
      if (example != null && !isExamplePrimitive(example)) {
        this.logger.warn(`Expected a primitive example but got ${example.type} for query parameter ${queryParameter.name} for ${endpoint.method.toUpperCase()} ${endpoint.path}`);
        example = void 0;
      }
      if (required && example == null) {
        return [];
      } else if (example != null) {
        queryParameters.push({
          name: queryParameter.name,
          value: example
        });
      }
    }
    const headers = [];
    for (const header of endpoint.headers) {
      const required = this.isSchemaRequired(header.schema);
      let example = this.exampleTypeFactory.buildExample({
        schema: header.schema,
        exampleId: void 0,
        example: void 0,
        options: {
          name: header.name,
          isParameter: true,
          ignoreOptionals: true
        }
      });
      if (example != null && !isExamplePrimitive(example)) {
        this.logger.warn(`Expected a primitive example but got ${example.type} for header ${header.name} for ${endpoint.method.toUpperCase()} ${endpoint.path}`);
        example = void 0;
      }
      if (required && example == null) {
        return [];
      } else if (example != null) {
        headers.push({
          name: header.name,
          value: example
        });
      }
    }
    let requestResponsePairs = [];
    if (endpoint.request != null && endpoint.response != null) {
      requestResponsePairs = consolidateRequestResponseExamples(requestExamples, responseExamples);
    } else if (endpoint.request != null) {
      requestResponsePairs = requestExamples.map(([id, example]) => {
        return { id, request: example, response: void 0 };
      });
    } else if (endpoint.response != null) {
      requestResponsePairs = responseExamples.map(([id, example]) => {
        return { id, request: void 0, response: example };
      });
    }
    const codeSamples = endpoint.examples.filter((ex) => hasIncompleteExample(ex)).flatMap((ex) => {
      if (ex.type === "unknown") {
        if (ex.value != null) {
          const samples = ex.value["code-samples"];
          if (samples != null) {
            return this.convertCodeSamples(samples);
          }
        }
        return void 0;
      } else {
        return ex.codeSamples;
      }
    }).filter((ex) => isNonNullish(ex));
    if (requestResponsePairs.length === 0) {
      return [
        EndpointExample.full({
          name: void 0,
          description: void 0,
          pathParameters,
          queryParameters,
          headers,
          request: void 0,
          response: void 0,
          codeSamples
        })
      ];
    }
    return requestResponsePairs.map(({ id: exampleName, request: requestExample, response: responseExample }) => {
      return EndpointExample.full({
        name: exampleName,
        description: void 0,
        pathParameters,
        queryParameters,
        headers,
        request: requestExample,
        response: responseExample,
        codeSamples
      });
    });
  }
  convertCodeSamples(codeSamples) {
    return codeSamples.map((codeSample) => {
      if ("language" in codeSample) {
        return CustomCodeSample.language({
          name: codeSample.name ?? void 0,
          description: codeSample.docs ?? void 0,
          language: codeSample.language,
          code: codeSample.code,
          install: codeSample.install ?? void 0
        });
      } else {
        return CustomCodeSample.sdk({
          name: codeSample.name ?? void 0,
          description: codeSample.docs ?? void 0,
          sdk: codeSample.sdk === "c#" ? SupportedSdkLanguage.Csharp : codeSample.sdk,
          code: codeSample.code
        });
      }
    }).filter(isNonNullish);
  }
  isSchemaRequired(schema2) {
    return isSchemaRequired3(this.getResolvedSchema(schema2));
  }
  getResolvedSchema(schema2) {
    return schema2;
  }
};
function consolidateRequestResponseExamples(requestExamples, responseExamples) {
  const pairs2 = [];
  if (requestExamples.length <= 1) {
    const [requestId, requestExample] = requestExamples[0] ?? [];
    if (responseExamples.length === 0) {
      pairs2.push({
        id: requestId,
        request: requestExample,
        response: void 0
      });
      return pairs2;
    } else {
      for (const [responseId, responseExample] of responseExamples) {
        pairs2.push({
          id: responseId ?? requestId,
          request: requestExample,
          response: responseExample
        });
      }
    }
    return pairs2;
  }
  if (responseExamples.length <= 1) {
    const [responseId, responseExample] = responseExamples[0] ?? [];
    if (responseExamples.length === 0) {
      pairs2.push({
        id: responseId,
        request: void 0,
        response: responseExample
      });
      return pairs2;
    } else {
      for (const [requestId, requestExample] of requestExamples) {
        pairs2.push({
          id: requestId ?? responseId,
          request: requestExample,
          response: responseExample
        });
      }
    }
    return pairs2;
  }
  const visitedResponseIdx = /* @__PURE__ */ new Set();
  for (const [requestId, requestExample] of requestExamples) {
    const fallbackResponseExample = responseExamples.find(([responseId]) => responseId == null)?.[1] ?? responseExamples[0]?.[1];
    if (requestId == null) {
      if (fallbackResponseExample == null) {
        continue;
      }
      pairs2.push({
        id: void 0,
        request: requestExample,
        response: fallbackResponseExample
      });
      continue;
    }
    let paired = false;
    for (let idx = 0; idx < responseExamples.length; idx++) {
      const [responseId, responseExample] = responseExamples[idx];
      if (responseId == null || visitedResponseIdx.has(idx)) {
        continue;
      }
      if (requestId === responseId) {
        pairs2.push({
          id: requestId,
          request: requestExample,
          response: responseExample
        });
        if (responseId != null) {
          visitedResponseIdx.add(idx);
        }
        paired = true;
      }
    }
    if (!paired && fallbackResponseExample != null) {
      pairs2.push({
        id: requestId,
        request: requestExample,
        response: fallbackResponseExample
      });
    }
  }
  for (let idx = 0; idx < responseExamples.length; idx++) {
    if (visitedResponseIdx.has(idx)) {
      continue;
    }
    const [responseId, responseExample] = responseExamples[idx];
    const requestExample = requestExamples.find(([requestId]) => requestId == null)?.[1] ?? requestExamples[0]?.[1];
    if (requestExample != null) {
      pairs2.push({
        id: responseId,
        request: requestExample,
        response: responseExample
      });
    }
  }
  return pairs2;
}
function getRequestSchema(request) {
  if (request == null) {
    return void 0;
  }
  if (request.type === "multipart") {
    return {
      type: "present",
      schema: convertMultipartRequestToSchema(request),
      examples: []
    };
  }
  if (request.type === "json") {
    return { type: "present", schema: request.schema, examples: request.fullExamples ?? [] };
  }
  return { type: "unsupported" };
}
function getResponseSchema(response) {
  if (response == null) {
    return void 0;
  }
  if (response.type !== "json" && response.type !== "streamingJson") {
    return { type: "unsupported" };
  }
  return { type: "present", schema: response.schema, examples: response.fullExamples ?? [] };
}
function isExamplePrimitive(example) {
  switch (example.type) {
    case "primitive":
    case "enum":
    case "literal":
      return true;
    case "unknown":
      return isExamplePrimitive(example);
    case "array":
    case "object":
    case "map":
      return false;
    case "oneOf":
      switch (example.value.type) {
        case "discriminated":
          return false;
        case "undisciminated":
          return isExamplePrimitive(example.value.value);
        default:
          return false;
      }
    default:
      assertNever(example);
  }
}
function convertMultipartRequestToSchema(request) {
  return SchemaWithExample.object({
    properties: request.properties.map((property4) => {
      if (property4.schema.type === "file") {
        return null;
      }
      return {
        key: property4.key,
        // Convert the schema to a schema with example to ensure that the example is generated
        // This is a workaround for the fact that the example is not getting parsed upstream
        // TODO: Fix the example parsing upstream
        schema: convertSchemaToSchemaWithExample(property4.schema.value),
        audiences: [],
        conflict: {},
        generatedName: property4.key,
        nameOverride: void 0,
        availability: void 0,
        readonly: void 0,
        inline: void 0
      };
    }).filter(isNonNullish),
    allOf: [],
    allOfPropertyConflicts: [],
    fullExamples: void 0,
    description: request.description,
    nameOverride: void 0,
    generatedName: "",
    title: void 0,
    groupName: void 0,
    additionalProperties: false,
    availability: void 0,
    source: request.source
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/asyncapi/ExampleWebsocketSessionFactory.js
var ExampleWebsocketSessionFactory = class {
  exampleTypeFactory;
  schemas;
  constructor(schemas, context) {
    this.exampleTypeFactory = new ExampleTypeFactory(schemas, /* @__PURE__ */ new Set(), context);
    this.schemas = schemas;
  }
  buildWebsocketSessionExamplesForExtension({ context, extensionExamples, publish, subscribe, handshake, source, namespace }) {
    const result = [];
    for (const extensionExample of extensionExamples) {
      const queryParameters = [];
      for (const queryParameter of handshake.queryParameters) {
        const required = this.isSchemaRequired(queryParameter.schema);
        let example = this.exampleTypeFactory.buildExample({
          schema: queryParameter.schema,
          exampleId: void 0,
          example: extensionExample.queryParameters?.[queryParameter.name],
          options: {
            name: queryParameter.name,
            isParameter: true,
            ignoreOptionals: true
          }
        });
        if (example != null && !isExamplePrimitive(example)) {
          example = void 0;
        }
        if (required && example == null) {
          continue;
        } else if (example != null) {
          queryParameters.push({
            name: queryParameter.name,
            value: example
          });
        }
      }
      const headers = [];
      for (const header of handshake.headers) {
        const required = this.isSchemaRequired(header.schema);
        let example = this.exampleTypeFactory.buildExample({
          schema: header.schema,
          exampleId: void 0,
          example: extensionExample.headers?.[header.name],
          options: {
            name: header.name,
            isParameter: true,
            ignoreOptionals: true
          }
        });
        if (example != null && !isExamplePrimitive(example)) {
          example = void 0;
        }
        if (required && example == null) {
          continue;
        } else if (example != null) {
          headers.push({
            name: header.name,
            value: example
          });
        }
      }
      const messages = [];
      for (const messageExample of extensionExample.messages) {
        const messageSchema = context.resolveMessageReference({
          $ref: `#/components/messages/${messageExample.messageId}`
        });
        const resolvedSchema = isReferenceObject(messageSchema.payload) ? context.resolveSchemaReference(messageSchema.payload) : messageSchema.payload;
        const example = this.exampleTypeFactory.buildExample({
          schema: convertSchema(resolvedSchema, false, context, [messageExample.messageId], source, namespace),
          exampleId: void 0,
          example: messageExample.value,
          options: {
            isParameter: false,
            ignoreOptionals: true
          }
        });
        if (example != null) {
          messages.push({
            messageType: messageExample.type,
            payload: example,
            description: void 0
          });
        }
      }
      result.push({
        name: extensionExample.summary,
        queryParameters,
        headers,
        description: extensionExample.description,
        messages
      });
    }
    return result;
  }
  buildWebsocketSessionExample({ publish, subscribe, handshake }) {
    const example = {
      name: void 0,
      queryParameters: [],
      headers: [],
      description: void 0,
      messages: []
    };
    const queryParameters = [];
    for (const queryParameter of handshake.queryParameters) {
      const required = this.isSchemaRequired(queryParameter.schema);
      let example2 = this.exampleTypeFactory.buildExample({
        schema: queryParameter.schema,
        exampleId: void 0,
        example: void 0,
        options: {
          name: queryParameter.name,
          isParameter: true,
          ignoreOptionals: true
        }
      });
      if (example2 != null && !isExamplePrimitive(example2)) {
        example2 = void 0;
      }
      if (required && example2 == null) {
        return void 0;
      } else if (example2 != null) {
        queryParameters.push({
          name: queryParameter.name,
          value: example2
        });
      }
    }
    const headers = [];
    for (const header of handshake.headers) {
      const required = this.isSchemaRequired(header.schema);
      let example2 = this.exampleTypeFactory.buildExample({
        schema: header.schema,
        exampleId: void 0,
        example: void 0,
        options: {
          name: header.name,
          isParameter: true,
          ignoreOptionals: true
        }
      });
      if (example2 != null && !isExamplePrimitive(example2)) {
        example2 = void 0;
      }
      if (required && example2 == null) {
        return void 0;
      } else if (example2 != null) {
        headers.push({
          name: header.name,
          value: example2
        });
      }
    }
    if (publish != null) {
      const publishMessageExample = this.exampleTypeFactory.buildExample({
        schema: publish,
        exampleId: void 0,
        example: void 0,
        options: {
          isParameter: false,
          ignoreOptionals: true
        }
      });
      if (publishMessageExample != null) {
        example.messages.push({
          messageType: "publish",
          payload: publishMessageExample,
          description: void 0
        });
      }
    }
    if (subscribe != null) {
      const publishMessageExample = this.exampleTypeFactory.buildExample({
        schema: subscribe,
        exampleId: void 0,
        example: void 0,
        options: {
          isParameter: false,
          ignoreOptionals: true
        }
      });
      if (publishMessageExample != null) {
        example.messages.push({
          messageType: "subscribe",
          payload: publishMessageExample,
          description: void 0
        });
      }
    }
    return example;
  }
  isSchemaRequired(schema2) {
    return isSchemaRequired3(this.getResolvedSchema(schema2));
  }
  getResolvedSchema(schema2) {
    while (schema2.type === "reference") {
      const resolvedSchema = this.schemas[schema2.schema];
      if (resolvedSchema == null) {
        throw new Error(`Unexpected error: Failed to resolve schema reference: ${schema2.schema}`);
      }
      schema2 = resolvedSchema;
    }
    return schema2;
  }
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/asyncapi/fernExtensions.js
var FernAsyncAPIExtension = {
  /**
   * The x-fern-summary allows you to specify a display name for the websocket channel.
   */
  FERN_DISPLAY_NAME: "x-fern-display-name",
  /**
   * The x-fern-examples allows you to specify examples for the websocket session.
   *
   * channels:
   *   /my-channel:
   *      subscribe:
   *        ...
   *
   *      x-fern-examples:
   *       - name: example-1
   *         summary: This is an example of a websocket session
   *         description: This is a description of the example
   *         messages:
   *           - type: publish
   *             messageId: SendMessage
   *             value:
   *               data: "1223233"
   *           - type: subscribe
   *             messageId: ReceiveMessage
   *             value:
   *              data: "12340213"
   */
  FERN_EXAMPLES: "x-fern-examples",
  /**
   * Prepends the configured base path to all of the endpoint paths.
   *
   * x-fern-base-path: /v1
   * servers:
   *   - url: https://api.example.com
   * paths:
   *   /path/to/my/endpoint:
   */
  BASE_PATH: "x-fern-base-path"
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/asyncapi/getFernExamples.js
function getFernExamples(channel) {
  return getExtension(channel, FernAsyncAPIExtension.FERN_EXAMPLES) ?? [];
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/asyncapi/parse.js
function parseAsyncAPI({ document, taskContext, options, source, asyncApiOptions, namespace }) {
  const breadcrumbs = [];
  if (namespace != null) {
    breadcrumbs.push(namespace);
  }
  if (document.tags?.[0] != null) {
    breadcrumbs.push(document.tags[0].name);
  } else if (asyncApiOptions.naming !== "v2") {
    breadcrumbs.push("websocket");
  }
  const context = new AsyncAPIV2ParserContext({
    document,
    taskContext,
    options,
    namespace
  });
  const schemas = {};
  let parsedChannel = void 0;
  for (const [schemaId, schema2] of Object.entries(document.components?.schemas ?? {})) {
    const convertedSchema = convertSchema(schema2, false, context, [schemaId], source, namespace);
    schemas[schemaId] = convertedSchema;
  }
  const exampleFactory = new ExampleWebsocketSessionFactory(schemas, context);
  for (const [channelPath, channel] of Object.entries(document.channels ?? {})) {
    if (channel.bindings?.ws == null) {
      context.logger.error(`Channel ${channelPath} does not have websocket bindings. Skipping.`);
      continue;
    }
    const pathParameters = [];
    if (channel.parameters != null) {
      for (const [name, parameter] of Object.entries(channel.parameters ?? {})) {
        pathParameters.push({
          name,
          description: parameter.description,
          parameterNameOverride: void 0,
          schema: parameter.schema != null ? convertSchema(parameter.schema, false, context, breadcrumbs, source, namespace) : SchemaWithExample.primitive({
            schema: PrimitiveSchemaValueWithExample.string({
              default: void 0,
              pattern: void 0,
              format: void 0,
              maxLength: void 0,
              minLength: void 0,
              example: void 0
            }),
            description: void 0,
            availability: void 0,
            generatedName: "",
            title: void 0,
            groupName: void 0,
            nameOverride: void 0
          }),
          variableReference: void 0,
          availability: convertAvailability3(parameter),
          source
        });
      }
    }
    const headers = [];
    if (channel.bindings.ws.headers != null) {
      const required = channel.bindings.ws.headers.required ?? [];
      for (const [name, schema2] of Object.entries(channel.bindings.ws.headers.properties ?? {})) {
        const resolvedHeader = isReferenceObject(schema2) ? context.resolveSchemaReference(schema2) : schema2;
        headers.push({
          name,
          schema: convertSchema(resolvedHeader, !required.includes(name), context, breadcrumbs, source, namespace),
          description: resolvedHeader.description,
          parameterNameOverride: void 0,
          env: void 0,
          availability: convertAvailability3(resolvedHeader),
          source
        });
      }
    }
    const queryParameters = [];
    if (channel.bindings.ws.query != null) {
      const required = channel.bindings.ws.query.required ?? [];
      for (const [name, schema2] of Object.entries(channel.bindings.ws.query.properties ?? {})) {
        const resolvedQueryParameter = isReferenceObject(schema2) ? context.resolveSchemaReference(schema2) : schema2;
        queryParameters.push({
          name,
          schema: convertSchema(resolvedQueryParameter, !required.includes(name), context, breadcrumbs, source, namespace),
          description: resolvedQueryParameter.description,
          parameterNameOverride: void 0,
          availability: convertAvailability3(resolvedQueryParameter),
          source
        });
      }
    }
    let publishSchema = void 0;
    if (channel.publish != null) {
      publishSchema = convertMessageToSchema({
        generatedName: channel.publish.operationId ?? "PublishEvent",
        event: channel.publish,
        breadcrumbs,
        context,
        source,
        options,
        asyncApiOptions
      });
    }
    let subscribeSchema = void 0;
    if (channel.subscribe != null) {
      subscribeSchema = convertMessageToSchema({
        generatedName: channel.subscribe.operationId ?? "SubscribeEvent",
        event: channel.subscribe,
        breadcrumbs,
        context,
        source,
        options,
        asyncApiOptions
      });
    }
    if (headers.length > 0 || queryParameters.length > 0 || publishSchema != null || subscribeSchema != null) {
      const fernExamples = getFernExamples(channel);
      let examples = [];
      if (fernExamples.length > 0) {
        examples = exampleFactory.buildWebsocketSessionExamplesForExtension({
          context,
          extensionExamples: fernExamples,
          handshake: {
            headers,
            queryParameters
          },
          publish: publishSchema,
          subscribe: subscribeSchema,
          source,
          namespace
        });
      } else {
        const autogenExample = exampleFactory.buildWebsocketSessionExample({
          handshake: {
            headers,
            queryParameters
          },
          publish: publishSchema,
          subscribe: subscribeSchema
        });
        if (autogenExample != null) {
          examples.push(autogenExample);
        }
      }
      const tags = document.tags?.[0]?.name != null ? [document.tags?.[0].name] : void 0;
      parsedChannel = {
        handshake: {
          headers: headers.map((header) => {
            return {
              ...header,
              schema: convertSchemaWithExampleToSchema(header.schema),
              env: header.env
            };
          }),
          queryParameters: queryParameters.map((param) => {
            return {
              ...param,
              schema: convertSchemaWithExampleToSchema(param.schema)
            };
          }),
          pathParameters: pathParameters.map((param) => {
            return {
              ...param,
              parameterNameOverride: void 0,
              schema: convertSchemaWithExampleToSchema(param.schema)
            };
          })
        },
        groupName: context.resolveTags(tags, "Websocket"),
        publish: publishSchema != null ? convertSchemaWithExampleToSchema(publishSchema) : publishSchema,
        subscribe: subscribeSchema != null ? convertSchemaWithExampleToSchema(subscribeSchema) : subscribeSchema,
        summary: getExtension(channel, FernAsyncAPIExtension.FERN_DISPLAY_NAME),
        path: channelPath,
        description: void 0,
        examples,
        source
      };
      break;
    }
  }
  return {
    groupedSchemas: getSchemas(namespace, schemas),
    channel: parsedChannel,
    basePath: getExtension(document, FernAsyncAPIExtension.BASE_PATH)
  };
}
function convertMessageToSchema({ generatedName, event, context, breadcrumbs, source, options, asyncApiOptions }) {
  if (event.message.oneOf != null) {
    const subtypes = [];
    const prefixes = [];
    for (const schema2 of event.message.oneOf) {
      let resolvedSchema;
      let namePrefix = { type: "notFound" };
      if (isReferenceObject(schema2)) {
        const resolvedMessage = context.resolveMessageReference(schema2);
        if (!isReferenceObject(resolvedMessage.payload) && asyncApiOptions.naming === "v2") {
          namePrefix = resolvedMessage.name ? { type: "name", name: resolvedMessage.name } : namePrefix;
          resolvedSchema = {
            ...resolvedMessage.payload,
            title: resolvedMessage.name ?? resolvedMessage.payload.title,
            description: resolvedMessage.name ?? resolvedMessage.payload.description
          };
        } else {
          resolvedSchema = resolvedMessage.payload;
        }
      } else {
        resolvedSchema = schema2;
      }
      prefixes.push(namePrefix);
      subtypes.push(resolvedSchema);
    }
    return convertUndiscriminatedOneOf({
      description: event.description ?? event.message.description,
      availability: convertAvailability3(event.message),
      subtypes,
      nameOverride: event.operationId,
      generatedName,
      title: event.message.title,
      groupName: void 0,
      wrapAsNullable: false,
      breadcrumbs,
      context,
      encoding: void 0,
      source,
      namespace: context.namespace,
      subtypePrefixOverrides: asyncApiOptions.naming === "v2" ? prefixes : []
    });
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernAsyncExtension.js
function getFernAsyncExtension(operation) {
  return getExtension(operation, FernOpenAPIExtension.ASYNC_CONFIG);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernStreamingExtension.js
var REQUEST_PREFIX = "$request.";
function getFernStreamingExtension(operation) {
  const streaming = getExtension(operation, FernOpenAPIExtension.STREAMING);
  if (streaming == null) {
    return void 0;
  }
  if (typeof streaming === "boolean") {
    return streaming ? {
      type: "stream",
      format: "json"
    } : void 0;
  }
  if (streaming["stream-condition"] == null && streaming.format != null) {
    return {
      type: "stream",
      format: streaming.format
    };
  }
  return {
    type: "streamCondition",
    format: streaming.format ?? "json",
    streamDescription: streaming["stream-description"],
    streamConditionProperty: maybeTrimRequestPrefix(streaming["stream-condition"]),
    responseStream: streaming["response-stream"],
    response: streaming.response
  };
}
function maybeTrimRequestPrefix(streamCondition) {
  if (streamCondition.startsWith(REQUEST_PREFIX)) {
    return streamCondition.slice(REQUEST_PREFIX.length);
  }
  return streamCondition;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getPaginationExtension.js
function convertPaginationExtension(pagination) {
  const maybeCursorPagination = pagination;
  if (maybeCursorPagination.cursor != null) {
    return Pagination3.cursor({
      cursor: maybeCursorPagination.cursor,
      nextCursor: maybeCursorPagination.next_cursor,
      results: maybeCursorPagination.results
    });
  }
  const maybeOffsetPagination = pagination;
  return Pagination3.offset({
    offset: maybeOffsetPagination.offset,
    results: maybeOffsetPagination.results,
    step: maybeOffsetPagination.step,
    hasNextPage: maybeOffsetPagination["has-next-page"]
  });
}
function getFernPaginationExtension(document, operation) {
  const pagination = getExtension(operation, FernOpenAPIExtension.PAGINATION);
  if (pagination == null) {
    return void 0;
  }
  if (typeof pagination === "boolean") {
    const topLevelPagination = getExtension(document, FernOpenAPIExtension.PAGINATION);
    if (typeof topLevelPagination === "boolean") {
      throw new Error("Global pagination extension is a boolean, expected an object. Only endpoints may declare a boolean for x-fern-pagination.");
    }
    return topLevelPagination == null ? void 0 : convertPaginationExtension(topLevelPagination);
  }
  return convertPaginationExtension(pagination);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/schema/utils/getReferenceOccurrences.js
function getReferenceOccurrences(document) {
  const contentConflictsRemovedDocument = removeApplicationJsonAndMultipartConflictsFromDocument(document);
  const occurrences = {};
  getReferenceOccurrencesHelper({ obj: contentConflictsRemovedDocument, occurrences, breadcrumbs: [] });
  return occurrences;
}
function getReferenceOccurrencesHelper({ obj, occurrences, breadcrumbs }) {
  if (obj == null) {
    return;
  }
  if (Array.isArray(obj)) {
    for (const element of obj) {
      getReferenceOccurrencesHelper({
        obj: element,
        occurrences,
        breadcrumbs
      });
    }
    return;
  }
  if (typeof obj !== "object") {
    return;
  }
  if (obj.$ref != null && typeof obj.$ref === "string") {
    const refProperty = obj.$ref;
    if (occurrences[refProperty] == null) {
      occurrences[refProperty] = 1;
    } else {
      occurrences[refProperty] += 1;
    }
    return;
  }
  for (const key in obj) {
    getReferenceOccurrencesHelper({
      obj: obj[key],
      occurrences,
      breadcrumbs: [...breadcrumbs, key]
    });
  }
}
function removeApplicationJsonAndMultipartConflictsFromDocument(document) {
  return {
    ...document,
    paths: Object.fromEntries(Object.entries(document.paths ?? {}).map(([path5, pathItem]) => {
      return [
        path5,
        {
          ...pathItem,
          get: pathItem?.get != null ? removeApplicationJsonAndMultipartConflictsFromOperationObject(pathItem.get) : void 0,
          put: pathItem?.put != null ? removeApplicationJsonAndMultipartConflictsFromOperationObject(pathItem.put) : void 0,
          post: pathItem?.post != null ? removeApplicationJsonAndMultipartConflictsFromOperationObject(pathItem.post) : void 0,
          patch: pathItem?.patch != null ? removeApplicationJsonAndMultipartConflictsFromOperationObject(pathItem.patch) : void 0,
          delete: pathItem?.delete != null ? removeApplicationJsonAndMultipartConflictsFromOperationObject(pathItem.delete) : void 0
        }
      ];
    }))
  };
}
function removeApplicationJsonAndMultipartConflictsFromOperationObject(operationObject) {
  return {
    ...operationObject,
    requestBody: operationObject.requestBody != null ? isReferenceObject(operationObject.requestBody) ? operationObject.requestBody : removeApplicationJsonAndMultipartConflictsFromRequestBody(operationObject.requestBody) : void 0
  };
}
function removeApplicationJsonAndMultipartConflictsFromRequestBody(requestBody) {
  let jsonContent;
  let multipartContent;
  for (const mediatype in requestBody.content) {
    const mimetype = MediaType.parse(mediatype);
    if (mimetype == null) {
      continue;
    }
    if (mimetype.isJSON()) {
      jsonContent = requestBody.content[mediatype];
    } else if (mimetype.isMultipart()) {
      multipartContent = requestBody.content[mediatype];
    }
  }
  if (multipartContent != null && jsonContent != null) {
    return {
      ...requestBody,
      content: {
        [MediaType.MULTIPART_FORM_DATA]: multipartContent
      }
    };
  }
  return requestBody;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/AbstractOpenAPIV3ParserContext.js
var PARAMETER_REFERENCE_PREFIX = "#/components/parameters/";
var RESPONSE_REFERENCE_PREFIX = "#/components/responses/";
var EXAMPLES_REFERENCE_PREFIX = "#/components/examples/";
var REQUEST_BODY_REFERENCE_PREFIX = "#/components/requestBodies/";
var AbstractOpenAPIV3ParserContext = class {
  logger;
  document;
  taskContext;
  authHeaders;
  refOccurrences;
  DUMMY;
  options;
  source;
  namespace;
  constructor({ document, taskContext, authHeaders, options, source, namespace }) {
    this.document = document;
    this.logger = taskContext.logger;
    this.taskContext = taskContext;
    this.authHeaders = authHeaders;
    this.refOccurrences = getReferenceOccurrences(document);
    this.options = options;
    this.source = source;
    this.DUMMY = this.getDummy();
    this.namespace = namespace;
  }
  getNumberOfOccurrencesForRef(schema2) {
    return this.refOccurrences[schema2.$ref] ?? 0;
  }
  resolveTagsToTagIds(operationTags) {
    const tags = [];
    if (this.namespace != null) {
      tags.push(this.namespace);
    }
    return tags.concat(operationTags ?? []);
  }
  resolveTags(operationTags) {
    const tags = [];
    if (this.namespace != null) {
      const namespaceSegment = {
        type: "namespace",
        name: this.namespace
      };
      tags.push(namespaceSegment);
    }
    return tags.concat(operationTags ?? []);
  }
  resolveGroupName(groupName) {
    if (this.namespace != null) {
      return [{ type: "namespace", name: this.namespace }, ...groupName];
    }
    return groupName;
  }
  resolveSchemaReference(schema2) {
    const keys5 = schema2.$ref.substring(2).split("/").map((key) => key.replace(/~1/g, "/"));
    let resolvedSchema = this.document;
    for (const key of keys5) {
      if (typeof resolvedSchema !== "object" || resolvedSchema == null) {
        return {
          "x-fern-type": "unknown",
          additionalProperties: true
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
        };
      }
      resolvedSchema = resolvedSchema[key];
    }
    if (resolvedSchema == null) {
      return {
        "x-fern-type": "unknown",
        additionalProperties: true
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
      };
    }
    if (isReferenceObject(resolvedSchema)) {
      resolvedSchema = this.resolveSchemaReference(resolvedSchema);
    }
    return resolvedSchema;
  }
  resolveParameterReference(parameter) {
    if (this.document.components == null || this.document.components.parameters == null || !parameter.$ref.startsWith(PARAMETER_REFERENCE_PREFIX)) {
      throw new Error(`Failed to resolve ${parameter.$ref}`);
    }
    const parameterKey = parameter.$ref.substring(PARAMETER_REFERENCE_PREFIX.length);
    const resolvedParameter = this.document.components.parameters[parameterKey];
    if (resolvedParameter == null) {
      throw new Error(`${parameter.$ref} is undefined`);
    }
    if (isReferenceObject(resolvedParameter)) {
      return this.resolveParameterReference(resolvedParameter);
    }
    return resolvedParameter;
  }
  resolveRequestBodyReference(requestBody) {
    if (this.document.components == null || this.document.components.requestBodies == null || !requestBody.$ref.startsWith(REQUEST_BODY_REFERENCE_PREFIX)) {
      throw new Error(`Failed to resolve ${requestBody.$ref}`);
    }
    const requestBodyKey = requestBody.$ref.substring(REQUEST_BODY_REFERENCE_PREFIX.length);
    const resolvedRequestBody = this.document.components.requestBodies[requestBodyKey];
    if (resolvedRequestBody == null) {
      throw new Error(`${requestBody.$ref} is undefined`);
    }
    if (isReferenceObject(resolvedRequestBody)) {
      return this.resolveRequestBodyReference(resolvedRequestBody);
    }
    return resolvedRequestBody;
  }
  resolveResponseReference(response) {
    if (this.document.components == null || this.document.components.responses == null || !response.$ref.startsWith(RESPONSE_REFERENCE_PREFIX)) {
      throw new Error(`Failed to resolve ${response.$ref}`);
    }
    const parameterKey = response.$ref.substring(RESPONSE_REFERENCE_PREFIX.length);
    const resolvedResponse = this.document.components.responses[parameterKey];
    if (resolvedResponse == null) {
      throw new Error(`${response.$ref} is undefined`);
    }
    if (isReferenceObject(resolvedResponse)) {
      return this.resolveResponseReference(resolvedResponse);
    }
    return resolvedResponse;
  }
  resolveExampleReference(example) {
    if (this.document.components == null || this.document.components.examples == null || !example.$ref.startsWith(EXAMPLES_REFERENCE_PREFIX)) {
      throw new Error(`Failed to resolve ${example.$ref}`);
    }
    const parameterKey = example.$ref.substring(EXAMPLES_REFERENCE_PREFIX.length);
    const resolvedExample = this.document.components.examples[parameterKey];
    if (resolvedExample == null) {
      throw new Error(`${example.$ref} is undefined`);
    }
    if (isReferenceObject(resolvedExample)) {
      return this.resolveExampleReference(resolvedExample);
    }
    return resolvedExample;
  }
  referenceExists(ref) {
    const keys5 = ref.substring(2).split("/").map((key) => key.replace(/~1/g, "/"));
    let resolvedSchema = this.document;
    for (const key of keys5) {
      if (typeof resolvedSchema !== "object" || resolvedSchema == null) {
        return false;
      }
      resolvedSchema = resolvedSchema[key];
    }
    return true;
  }
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/DummyOpenAPIV3ParserContext.js
var DummyOpenAPIV3ParserContext = class extends AbstractOpenAPIV3ParserContext {
  constructor({ document, taskContext, options, source, namespace }) {
    super({
      document,
      taskContext,
      authHeaders: /* @__PURE__ */ new Set(),
      options,
      source,
      namespace
    });
  }
  getDummy() {
    return this;
  }
  markSchemaAsReferencedByNonRequest(_schemaId) {
    return;
  }
  markSchemaAsReferencedByRequest(_schemaId) {
    return;
  }
  getReferencedSchemas() {
    return /* @__PURE__ */ new Set();
  }
  markReferencedByDiscriminatedUnion(_schema, _discrminant, _times) {
    return;
  }
  getReferencesFromDiscriminatedUnion(_schema) {
    return void 0;
  }
  excludeSchema(_schemaId) {
  }
  isSchemaExcluded(_schemaId) {
    return false;
  }
  markSchemaWithDiscriminantValue(_schema, _discrminant, _discriminantValue) {
    return;
  }
  getDiscriminatedUnionMetadata(_schema) {
    return;
  }
};

// ../../../node_modules/.pnpm/zod@3.23.8/node_modules/zod/lib/index.mjs
var util;
(function (util2) {
  util2.assertEqual = (val) => val;
  function assertIs(_arg) {
  }
  util2.assertIs = assertIs;
  function assertNever2(_x) {
    throw new Error();
  }
  util2.assertNever = assertNever2;
  util2.arrayToEnum = (items) => {
    const obj = {};
    for (const item of items) {
      obj[item] = item;
    }
    return obj;
  };
  util2.getValidEnumValues = (obj) => {
    const validKeys = util2.objectKeys(obj).filter((k) => typeof obj[obj[k]] !== "number");
    const filtered = {};
    for (const k of validKeys) {
      filtered[k] = obj[k];
    }
    return util2.objectValues(filtered);
  };
  util2.objectValues = (obj) => {
    return util2.objectKeys(obj).map(function (e) {
      return obj[e];
    });
  };
  util2.objectKeys = typeof Object.keys === "function" ? (obj) => Object.keys(obj) : (object3) => {
    const keys5 = [];
    for (const key in object3) {
      if (Object.prototype.hasOwnProperty.call(object3, key)) {
        keys5.push(key);
      }
    }
    return keys5;
  };
  util2.find = (arr, checker) => {
    for (const item of arr) {
      if (checker(item))
        return item;
    }
    return void 0;
  };
  util2.isInteger = typeof Number.isInteger === "function" ? (val) => Number.isInteger(val) : (val) => typeof val === "number" && isFinite(val) && Math.floor(val) === val;
  function joinValues(array, separator = " | ") {
    return array.map((val) => typeof val === "string" ? `'${val}'` : val).join(separator);
  }
  util2.joinValues = joinValues;
  util2.jsonStringifyReplacer = (_, value) => {
    if (typeof value === "bigint") {
      return value.toString();
    }
    return value;
  };
})(util || (util = {}));
var objectUtil;
(function (objectUtil2) {
  objectUtil2.mergeShapes = (first, second) => {
    return {
      ...first,
      ...second
      // second overwrites first
    };
  };
})(objectUtil || (objectUtil = {}));
var ZodParsedType = util.arrayToEnum([
  "string",
  "nan",
  "number",
  "integer",
  "float",
  "boolean",
  "date",
  "bigint",
  "symbol",
  "function",
  "undefined",
  "null",
  "array",
  "object",
  "unknown",
  "promise",
  "void",
  "never",
  "map",
  "set"
]);
var getParsedType = (data) => {
  const t = typeof data;
  switch (t) {
    case "undefined":
      return ZodParsedType.undefined;
    case "string":
      return ZodParsedType.string;
    case "number":
      return isNaN(data) ? ZodParsedType.nan : ZodParsedType.number;
    case "boolean":
      return ZodParsedType.boolean;
    case "function":
      return ZodParsedType.function;
    case "bigint":
      return ZodParsedType.bigint;
    case "symbol":
      return ZodParsedType.symbol;
    case "object":
      if (Array.isArray(data)) {
        return ZodParsedType.array;
      }
      if (data === null) {
        return ZodParsedType.null;
      }
      if (data.then && typeof data.then === "function" && data.catch && typeof data.catch === "function") {
        return ZodParsedType.promise;
      }
      if (typeof Map !== "undefined" && data instanceof Map) {
        return ZodParsedType.map;
      }
      if (typeof Set !== "undefined" && data instanceof Set) {
        return ZodParsedType.set;
      }
      if (typeof Date !== "undefined" && data instanceof Date) {
        return ZodParsedType.date;
      }
      return ZodParsedType.object;
    default:
      return ZodParsedType.unknown;
  }
};
var ZodIssueCode = util.arrayToEnum([
  "invalid_type",
  "invalid_literal",
  "custom",
  "invalid_union",
  "invalid_union_discriminator",
  "invalid_enum_value",
  "unrecognized_keys",
  "invalid_arguments",
  "invalid_return_type",
  "invalid_date",
  "invalid_string",
  "too_small",
  "too_big",
  "invalid_intersection_types",
  "not_multiple_of",
  "not_finite"
]);
var quotelessJson = (obj) => {
  const json2 = JSON.stringify(obj, null, 2);
  return json2.replace(/"([^"]+)":/g, "$1:");
};
var ZodError = class _ZodError extends Error {
  constructor(issues) {
    super();
    this.issues = [];
    this.addIssue = (sub) => {
      this.issues = [...this.issues, sub];
    };
    this.addIssues = (subs = []) => {
      this.issues = [...this.issues, ...subs];
    };
    const actualProto = new.target.prototype;
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(this, actualProto);
    } else {
      this.__proto__ = actualProto;
    }
    this.name = "ZodError";
    this.issues = issues;
  }
  get errors() {
    return this.issues;
  }
  format(_mapper) {
    const mapper = _mapper || function (issue) {
      return issue.message;
    };
    const fieldErrors = { _errors: [] };
    const processError = (error) => {
      for (const issue of error.issues) {
        if (issue.code === "invalid_union") {
          issue.unionErrors.map(processError);
        } else if (issue.code === "invalid_return_type") {
          processError(issue.returnTypeError);
        } else if (issue.code === "invalid_arguments") {
          processError(issue.argumentsError);
        } else if (issue.path.length === 0) {
          fieldErrors._errors.push(mapper(issue));
        } else {
          let curr = fieldErrors;
          let i = 0;
          while (i < issue.path.length) {
            const el = issue.path[i];
            const terminal = i === issue.path.length - 1;
            if (!terminal) {
              curr[el] = curr[el] || { _errors: [] };
            } else {
              curr[el] = curr[el] || { _errors: [] };
              curr[el]._errors.push(mapper(issue));
            }
            curr = curr[el];
            i++;
          }
        }
      }
    };
    processError(this);
    return fieldErrors;
  }
  static assert(value) {
    if (!(value instanceof _ZodError)) {
      throw new Error(`Not a ZodError: ${value}`);
    }
  }
  toString() {
    return this.message;
  }
  get message() {
    return JSON.stringify(this.issues, util.jsonStringifyReplacer, 2);
  }
  get isEmpty() {
    return this.issues.length === 0;
  }
  flatten(mapper = (issue) => issue.message) {
    const fieldErrors = {};
    const formErrors = [];
    for (const sub of this.issues) {
      if (sub.path.length > 0) {
        fieldErrors[sub.path[0]] = fieldErrors[sub.path[0]] || [];
        fieldErrors[sub.path[0]].push(mapper(sub));
      } else {
        formErrors.push(mapper(sub));
      }
    }
    return { formErrors, fieldErrors };
  }
  get formErrors() {
    return this.flatten();
  }
};
ZodError.create = (issues) => {
  const error = new ZodError(issues);
  return error;
};
var errorMap = (issue, _ctx) => {
  let message;
  switch (issue.code) {
    case ZodIssueCode.invalid_type:
      if (issue.received === ZodParsedType.undefined) {
        message = "Required";
      } else {
        message = `Expected ${issue.expected}, received ${issue.received}`;
      }
      break;
    case ZodIssueCode.invalid_literal:
      message = `Invalid literal value, expected ${JSON.stringify(issue.expected, util.jsonStringifyReplacer)}`;
      break;
    case ZodIssueCode.unrecognized_keys:
      message = `Unrecognized key(s) in object: ${util.joinValues(issue.keys, ", ")}`;
      break;
    case ZodIssueCode.invalid_union:
      message = `Invalid input`;
      break;
    case ZodIssueCode.invalid_union_discriminator:
      message = `Invalid discriminator value. Expected ${util.joinValues(issue.options)}`;
      break;
    case ZodIssueCode.invalid_enum_value:
      message = `Invalid enum value. Expected ${util.joinValues(issue.options)}, received '${issue.received}'`;
      break;
    case ZodIssueCode.invalid_arguments:
      message = `Invalid function arguments`;
      break;
    case ZodIssueCode.invalid_return_type:
      message = `Invalid function return type`;
      break;
    case ZodIssueCode.invalid_date:
      message = `Invalid date`;
      break;
    case ZodIssueCode.invalid_string:
      if (typeof issue.validation === "object") {
        if ("includes" in issue.validation) {
          message = `Invalid input: must include "${issue.validation.includes}"`;
          if (typeof issue.validation.position === "number") {
            message = `${message} at one or more positions greater than or equal to ${issue.validation.position}`;
          }
        } else if ("startsWith" in issue.validation) {
          message = `Invalid input: must start with "${issue.validation.startsWith}"`;
        } else if ("endsWith" in issue.validation) {
          message = `Invalid input: must end with "${issue.validation.endsWith}"`;
        } else {
          util.assertNever(issue.validation);
        }
      } else if (issue.validation !== "regex") {
        message = `Invalid ${issue.validation}`;
      } else {
        message = "Invalid";
      }
      break;
    case ZodIssueCode.too_small:
      if (issue.type === "array")
        message = `Array must contain ${issue.exact ? "exactly" : issue.inclusive ? `at least` : `more than`} ${issue.minimum} element(s)`;
      else if (issue.type === "string")
        message = `String must contain ${issue.exact ? "exactly" : issue.inclusive ? `at least` : `over`} ${issue.minimum} character(s)`;
      else if (issue.type === "number")
        message = `Number must be ${issue.exact ? `exactly equal to ` : issue.inclusive ? `greater than or equal to ` : `greater than `}${issue.minimum}`;
      else if (issue.type === "date")
        message = `Date must be ${issue.exact ? `exactly equal to ` : issue.inclusive ? `greater than or equal to ` : `greater than `}${new Date(Number(issue.minimum))}`;
      else
        message = "Invalid input";
      break;
    case ZodIssueCode.too_big:
      if (issue.type === "array")
        message = `Array must contain ${issue.exact ? `exactly` : issue.inclusive ? `at most` : `less than`} ${issue.maximum} element(s)`;
      else if (issue.type === "string")
        message = `String must contain ${issue.exact ? `exactly` : issue.inclusive ? `at most` : `under`} ${issue.maximum} character(s)`;
      else if (issue.type === "number")
        message = `Number must be ${issue.exact ? `exactly` : issue.inclusive ? `less than or equal to` : `less than`} ${issue.maximum}`;
      else if (issue.type === "bigint")
        message = `BigInt must be ${issue.exact ? `exactly` : issue.inclusive ? `less than or equal to` : `less than`} ${issue.maximum}`;
      else if (issue.type === "date")
        message = `Date must be ${issue.exact ? `exactly` : issue.inclusive ? `smaller than or equal to` : `smaller than`} ${new Date(Number(issue.maximum))}`;
      else
        message = "Invalid input";
      break;
    case ZodIssueCode.custom:
      message = `Invalid input`;
      break;
    case ZodIssueCode.invalid_intersection_types:
      message = `Intersection results could not be merged`;
      break;
    case ZodIssueCode.not_multiple_of:
      message = `Number must be a multiple of ${issue.multipleOf}`;
      break;
    case ZodIssueCode.not_finite:
      message = "Number must be finite";
      break;
    default:
      message = _ctx.defaultError;
      util.assertNever(issue);
  }
  return { message };
};
var overrideErrorMap = errorMap;
function setErrorMap(map2) {
  overrideErrorMap = map2;
}
function getErrorMap() {
  return overrideErrorMap;
}
var makeIssue = (params) => {
  const { data, path: path5, errorMaps, issueData } = params;
  const fullPath = [...path5, ...issueData.path || []];
  const fullIssue = {
    ...issueData,
    path: fullPath
  };
  if (issueData.message !== void 0) {
    return {
      ...issueData,
      path: fullPath,
      message: issueData.message
    };
  }
  let errorMessage = "";
  const maps = errorMaps.filter((m) => !!m).slice().reverse();
  for (const map2 of maps) {
    errorMessage = map2(fullIssue, { data, defaultError: errorMessage }).message;
  }
  return {
    ...issueData,
    path: fullPath,
    message: errorMessage
  };
};
var EMPTY_PATH = [];
function addIssueToContext(ctx, issueData) {
  const overrideMap = getErrorMap();
  const issue = makeIssue({
    issueData,
    data: ctx.data,
    path: ctx.path,
    errorMaps: [
      ctx.common.contextualErrorMap,
      ctx.schemaErrorMap,
      overrideMap,
      overrideMap === errorMap ? void 0 : errorMap
      // then global default map
    ].filter((x) => !!x)
  });
  ctx.common.issues.push(issue);
}
var ParseStatus = class _ParseStatus {
  constructor() {
    this.value = "valid";
  }
  dirty() {
    if (this.value === "valid")
      this.value = "dirty";
  }
  abort() {
    if (this.value !== "aborted")
      this.value = "aborted";
  }
  static mergeArray(status, results) {
    const arrayValue = [];
    for (const s of results) {
      if (s.status === "aborted")
        return INVALID;
      if (s.status === "dirty")
        status.dirty();
      arrayValue.push(s.value);
    }
    return { status: status.value, value: arrayValue };
  }
  static async mergeObjectAsync(status, pairs2) {
    const syncPairs = [];
    for (const pair of pairs2) {
      const key = await pair.key;
      const value = await pair.value;
      syncPairs.push({
        key,
        value
      });
    }
    return _ParseStatus.mergeObjectSync(status, syncPairs);
  }
  static mergeObjectSync(status, pairs2) {
    const finalObject = {};
    for (const pair of pairs2) {
      const { key, value } = pair;
      if (key.status === "aborted")
        return INVALID;
      if (value.status === "aborted")
        return INVALID;
      if (key.status === "dirty")
        status.dirty();
      if (value.status === "dirty")
        status.dirty();
      if (key.value !== "__proto__" && (typeof value.value !== "undefined" || pair.alwaysSet)) {
        finalObject[key.value] = value.value;
      }
    }
    return { status: status.value, value: finalObject };
  }
};
var INVALID = Object.freeze({
  status: "aborted"
});
var DIRTY = (value) => ({ status: "dirty", value });
var OK = (value) => ({ status: "valid", value });
var isAborted = (x) => x.status === "aborted";
var isDirty = (x) => x.status === "dirty";
var isValid = (x) => x.status === "valid";
var isAsync = (x) => typeof Promise !== "undefined" && x instanceof Promise;
function __classPrivateFieldGet(receiver, state, kind, f) {
  if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
  if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
  return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
}
function __classPrivateFieldSet(receiver, state, value, kind, f) {
  if (kind === "m") throw new TypeError("Private method is not writable");
  if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
  if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
  return kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value), value;
}
var errorUtil;
(function (errorUtil2) {
  errorUtil2.errToObj = (message) => typeof message === "string" ? { message } : message || {};
  errorUtil2.toString = (message) => typeof message === "string" ? message : message === null || message === void 0 ? void 0 : message.message;
})(errorUtil || (errorUtil = {}));
var _ZodEnum_cache;
var _ZodNativeEnum_cache;
var ParseInputLazyPath = class {
  constructor(parent, value, path5, key) {
    this._cachedPath = [];
    this.parent = parent;
    this.data = value;
    this._path = path5;
    this._key = key;
  }
  get path() {
    if (!this._cachedPath.length) {
      if (this._key instanceof Array) {
        this._cachedPath.push(...this._path, ...this._key);
      } else {
        this._cachedPath.push(...this._path, this._key);
      }
    }
    return this._cachedPath;
  }
};
var handleResult = (ctx, result) => {
  if (isValid(result)) {
    return { success: true, data: result.value };
  } else {
    if (!ctx.common.issues.length) {
      throw new Error("Validation failed but no issues detected.");
    }
    return {
      success: false,
      get error() {
        if (this._error)
          return this._error;
        const error = new ZodError(ctx.common.issues);
        this._error = error;
        return this._error;
      }
    };
  }
};
function processCreateParams(params) {
  if (!params)
    return {};
  const { errorMap: errorMap2, invalid_type_error, required_error, description } = params;
  if (errorMap2 && (invalid_type_error || required_error)) {
    throw new Error(`Can't use "invalid_type_error" or "required_error" in conjunction with custom error map.`);
  }
  if (errorMap2)
    return { errorMap: errorMap2, description };
  const customMap = (iss, ctx) => {
    var _a, _b;
    const { message } = params;
    if (iss.code === "invalid_enum_value") {
      return { message: message !== null && message !== void 0 ? message : ctx.defaultError };
    }
    if (typeof ctx.data === "undefined") {
      return { message: (_a = message !== null && message !== void 0 ? message : required_error) !== null && _a !== void 0 ? _a : ctx.defaultError };
    }
    if (iss.code !== "invalid_type")
      return { message: ctx.defaultError };
    return { message: (_b = message !== null && message !== void 0 ? message : invalid_type_error) !== null && _b !== void 0 ? _b : ctx.defaultError };
  };
  return { errorMap: customMap, description };
}
var ZodType = class {
  constructor(def) {
    this.spa = this.safeParseAsync;
    this._def = def;
    this.parse = this.parse.bind(this);
    this.safeParse = this.safeParse.bind(this);
    this.parseAsync = this.parseAsync.bind(this);
    this.safeParseAsync = this.safeParseAsync.bind(this);
    this.spa = this.spa.bind(this);
    this.refine = this.refine.bind(this);
    this.refinement = this.refinement.bind(this);
    this.superRefine = this.superRefine.bind(this);
    this.optional = this.optional.bind(this);
    this.nullable = this.nullable.bind(this);
    this.nullish = this.nullish.bind(this);
    this.array = this.array.bind(this);
    this.promise = this.promise.bind(this);
    this.or = this.or.bind(this);
    this.and = this.and.bind(this);
    this.transform = this.transform.bind(this);
    this.brand = this.brand.bind(this);
    this.default = this.default.bind(this);
    this.catch = this.catch.bind(this);
    this.describe = this.describe.bind(this);
    this.pipe = this.pipe.bind(this);
    this.readonly = this.readonly.bind(this);
    this.isNullable = this.isNullable.bind(this);
    this.isOptional = this.isOptional.bind(this);
  }
  get description() {
    return this._def.description;
  }
  _getType(input) {
    return getParsedType(input.data);
  }
  _getOrReturnCtx(input, ctx) {
    return ctx || {
      common: input.parent.common,
      data: input.data,
      parsedType: getParsedType(input.data),
      schemaErrorMap: this._def.errorMap,
      path: input.path,
      parent: input.parent
    };
  }
  _processInputParams(input) {
    return {
      status: new ParseStatus(),
      ctx: {
        common: input.parent.common,
        data: input.data,
        parsedType: getParsedType(input.data),
        schemaErrorMap: this._def.errorMap,
        path: input.path,
        parent: input.parent
      }
    };
  }
  _parseSync(input) {
    const result = this._parse(input);
    if (isAsync(result)) {
      throw new Error("Synchronous parse encountered promise.");
    }
    return result;
  }
  _parseAsync(input) {
    const result = this._parse(input);
    return Promise.resolve(result);
  }
  parse(data, params) {
    const result = this.safeParse(data, params);
    if (result.success)
      return result.data;
    throw result.error;
  }
  safeParse(data, params) {
    var _a;
    const ctx = {
      common: {
        issues: [],
        async: (_a = params === null || params === void 0 ? void 0 : params.async) !== null && _a !== void 0 ? _a : false,
        contextualErrorMap: params === null || params === void 0 ? void 0 : params.errorMap
      },
      path: (params === null || params === void 0 ? void 0 : params.path) || [],
      schemaErrorMap: this._def.errorMap,
      parent: null,
      data,
      parsedType: getParsedType(data)
    };
    const result = this._parseSync({ data, path: ctx.path, parent: ctx });
    return handleResult(ctx, result);
  }
  async parseAsync(data, params) {
    const result = await this.safeParseAsync(data, params);
    if (result.success)
      return result.data;
    throw result.error;
  }
  async safeParseAsync(data, params) {
    const ctx = {
      common: {
        issues: [],
        contextualErrorMap: params === null || params === void 0 ? void 0 : params.errorMap,
        async: true
      },
      path: (params === null || params === void 0 ? void 0 : params.path) || [],
      schemaErrorMap: this._def.errorMap,
      parent: null,
      data,
      parsedType: getParsedType(data)
    };
    const maybeAsyncResult = this._parse({ data, path: ctx.path, parent: ctx });
    const result = await (isAsync(maybeAsyncResult) ? maybeAsyncResult : Promise.resolve(maybeAsyncResult));
    return handleResult(ctx, result);
  }
  refine(check, message) {
    const getIssueProperties = (val) => {
      if (typeof message === "string" || typeof message === "undefined") {
        return { message };
      } else if (typeof message === "function") {
        return message(val);
      } else {
        return message;
      }
    };
    return this._refinement((val, ctx) => {
      const result = check(val);
      const setError = () => ctx.addIssue({
        code: ZodIssueCode.custom,
        ...getIssueProperties(val)
      });
      if (typeof Promise !== "undefined" && result instanceof Promise) {
        return result.then((data) => {
          if (!data) {
            setError();
            return false;
          } else {
            return true;
          }
        });
      }
      if (!result) {
        setError();
        return false;
      } else {
        return true;
      }
    });
  }
  refinement(check, refinementData) {
    return this._refinement((val, ctx) => {
      if (!check(val)) {
        ctx.addIssue(typeof refinementData === "function" ? refinementData(val, ctx) : refinementData);
        return false;
      } else {
        return true;
      }
    });
  }
  _refinement(refinement) {
    return new ZodEffects({
      schema: this,
      typeName: ZodFirstPartyTypeKind.ZodEffects,
      effect: { type: "refinement", refinement }
    });
  }
  superRefine(refinement) {
    return this._refinement(refinement);
  }
  optional() {
    return ZodOptional.create(this, this._def);
  }
  nullable() {
    return ZodNullable.create(this, this._def);
  }
  nullish() {
    return this.nullable().optional();
  }
  array() {
    return ZodArray.create(this, this._def);
  }
  promise() {
    return ZodPromise.create(this, this._def);
  }
  or(option) {
    return ZodUnion.create([this, option], this._def);
  }
  and(incoming) {
    return ZodIntersection.create(this, incoming, this._def);
  }
  transform(transform3) {
    return new ZodEffects({
      ...processCreateParams(this._def),
      schema: this,
      typeName: ZodFirstPartyTypeKind.ZodEffects,
      effect: { type: "transform", transform: transform3 }
    });
  }
  default(def) {
    const defaultValueFunc = typeof def === "function" ? def : () => def;
    return new ZodDefault({
      ...processCreateParams(this._def),
      innerType: this,
      defaultValue: defaultValueFunc,
      typeName: ZodFirstPartyTypeKind.ZodDefault
    });
  }
  brand() {
    return new ZodBranded({
      typeName: ZodFirstPartyTypeKind.ZodBranded,
      type: this,
      ...processCreateParams(this._def)
    });
  }
  catch(def) {
    const catchValueFunc = typeof def === "function" ? def : () => def;
    return new ZodCatch({
      ...processCreateParams(this._def),
      innerType: this,
      catchValue: catchValueFunc,
      typeName: ZodFirstPartyTypeKind.ZodCatch
    });
  }
  describe(description) {
    const This = this.constructor;
    return new This({
      ...this._def,
      description
    });
  }
  pipe(target) {
    return ZodPipeline.create(this, target);
  }
  readonly() {
    return ZodReadonly.create(this);
  }
  isOptional() {
    return this.safeParse(void 0).success;
  }
  isNullable() {
    return this.safeParse(null).success;
  }
};
var cuidRegex = /^c[^\s-]{8,}$/i;
var cuid2Regex = /^[0-9a-z]+$/;
var ulidRegex = /^[0-9A-HJKMNP-TV-Z]{26}$/;
var uuidRegex = /^[0-9a-fA-F]{8}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{12}$/i;
var nanoidRegex = /^[a-z0-9_-]{21}$/i;
var durationRegex = /^[-+]?P(?!$)(?:(?:[-+]?\d+Y)|(?:[-+]?\d+[.,]\d+Y$))?(?:(?:[-+]?\d+M)|(?:[-+]?\d+[.,]\d+M$))?(?:(?:[-+]?\d+W)|(?:[-+]?\d+[.,]\d+W$))?(?:(?:[-+]?\d+D)|(?:[-+]?\d+[.,]\d+D$))?(?:T(?=[\d+-])(?:(?:[-+]?\d+H)|(?:[-+]?\d+[.,]\d+H$))?(?:(?:[-+]?\d+M)|(?:[-+]?\d+[.,]\d+M$))?(?:[-+]?\d+(?:[.,]\d+)?S)?)??$/;
var emailRegex = /^(?!\.)(?!.*\.\.)([A-Z0-9_'+\-\.]*)[A-Z0-9_+-]@([A-Z0-9][A-Z0-9\-]*\.)+[A-Z]{2,}$/i;
var _emojiRegex = `^(\\p{Extended_Pictographic}|\\p{Emoji_Component})+$`;
var emojiRegex;
var ipv4Regex = /^(?:(?:25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])\.){3}(?:25[0-5]|2[0-4][0-9]|1[0-9][0-9]|[1-9][0-9]|[0-9])$/;
var ipv6Regex = /^(([a-f0-9]{1,4}:){7}|::([a-f0-9]{1,4}:){0,6}|([a-f0-9]{1,4}:){1}:([a-f0-9]{1,4}:){0,5}|([a-f0-9]{1,4}:){2}:([a-f0-9]{1,4}:){0,4}|([a-f0-9]{1,4}:){3}:([a-f0-9]{1,4}:){0,3}|([a-f0-9]{1,4}:){4}:([a-f0-9]{1,4}:){0,2}|([a-f0-9]{1,4}:){5}:([a-f0-9]{1,4}:){0,1})([a-f0-9]{1,4}|(((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2}))\.){3}((25[0-5])|(2[0-4][0-9])|(1[0-9]{2})|([0-9]{1,2})))$/;
var base64Regex = /^([0-9a-zA-Z+/]{4})*(([0-9a-zA-Z+/]{2}==)|([0-9a-zA-Z+/]{3}=))?$/;
var dateRegexSource = `((\\d\\d[2468][048]|\\d\\d[13579][26]|\\d\\d0[48]|[02468][048]00|[13579][26]00)-02-29|\\d{4}-((0[13578]|1[02])-(0[1-9]|[12]\\d|3[01])|(0[469]|11)-(0[1-9]|[12]\\d|30)|(02)-(0[1-9]|1\\d|2[0-8])))`;
var dateRegex = new RegExp(`^${dateRegexSource}$`);
function timeRegexSource(args) {
  let regex = `([01]\\d|2[0-3]):[0-5]\\d:[0-5]\\d`;
  if (args.precision) {
    regex = `${regex}\\.\\d{${args.precision}}`;
  } else if (args.precision == null) {
    regex = `${regex}(\\.\\d+)?`;
  }
  return regex;
}
function timeRegex(args) {
  return new RegExp(`^${timeRegexSource(args)}$`);
}
function datetimeRegex(args) {
  let regex = `${dateRegexSource}T${timeRegexSource(args)}`;
  const opts = [];
  opts.push(args.local ? `Z?` : `Z`);
  if (args.offset)
    opts.push(`([+-]\\d{2}:?\\d{2})`);
  regex = `${regex}(${opts.join("|")})`;
  return new RegExp(`^${regex}$`);
}
function isValidIP(ip, version) {
  if ((version === "v4" || !version) && ipv4Regex.test(ip)) {
    return true;
  }
  if ((version === "v6" || !version) && ipv6Regex.test(ip)) {
    return true;
  }
  return false;
}
var ZodString = class _ZodString extends ZodType {
  _parse(input) {
    if (this._def.coerce) {
      input.data = String(input.data);
    }
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.string) {
      const ctx2 = this._getOrReturnCtx(input);
      addIssueToContext(ctx2, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.string,
        received: ctx2.parsedType
      });
      return INVALID;
    }
    const status = new ParseStatus();
    let ctx = void 0;
    for (const check of this._def.checks) {
      if (check.kind === "min") {
        if (input.data.length < check.value) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_small,
            minimum: check.value,
            type: "string",
            inclusive: true,
            exact: false,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "max") {
        if (input.data.length > check.value) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_big,
            maximum: check.value,
            type: "string",
            inclusive: true,
            exact: false,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "length") {
        const tooBig = input.data.length > check.value;
        const tooSmall = input.data.length < check.value;
        if (tooBig || tooSmall) {
          ctx = this._getOrReturnCtx(input, ctx);
          if (tooBig) {
            addIssueToContext(ctx, {
              code: ZodIssueCode.too_big,
              maximum: check.value,
              type: "string",
              inclusive: true,
              exact: true,
              message: check.message
            });
          } else if (tooSmall) {
            addIssueToContext(ctx, {
              code: ZodIssueCode.too_small,
              minimum: check.value,
              type: "string",
              inclusive: true,
              exact: true,
              message: check.message
            });
          }
          status.dirty();
        }
      } else if (check.kind === "email") {
        if (!emailRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "email",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "emoji") {
        if (!emojiRegex) {
          emojiRegex = new RegExp(_emojiRegex, "u");
        }
        if (!emojiRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "emoji",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "uuid") {
        if (!uuidRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "uuid",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "nanoid") {
        if (!nanoidRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "nanoid",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "cuid") {
        if (!cuidRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "cuid",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "cuid2") {
        if (!cuid2Regex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "cuid2",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "ulid") {
        if (!ulidRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "ulid",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "url") {
        try {
          new URL(input.data);
        } catch (_a) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "url",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "regex") {
        check.regex.lastIndex = 0;
        const testResult = check.regex.test(input.data);
        if (!testResult) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "regex",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "trim") {
        input.data = input.data.trim();
      } else if (check.kind === "includes") {
        if (!input.data.includes(check.value, check.position)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: { includes: check.value, position: check.position },
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "toLowerCase") {
        input.data = input.data.toLowerCase();
      } else if (check.kind === "toUpperCase") {
        input.data = input.data.toUpperCase();
      } else if (check.kind === "startsWith") {
        if (!input.data.startsWith(check.value)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: { startsWith: check.value },
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "endsWith") {
        if (!input.data.endsWith(check.value)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: { endsWith: check.value },
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "datetime") {
        const regex = datetimeRegex(check);
        if (!regex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: "datetime",
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "date") {
        const regex = dateRegex;
        if (!regex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: "date",
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "time") {
        const regex = timeRegex(check);
        if (!regex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_string,
            validation: "time",
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "duration") {
        if (!durationRegex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "duration",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "ip") {
        if (!isValidIP(input.data, check.version)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "ip",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "base64") {
        if (!base64Regex.test(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            validation: "base64",
            code: ZodIssueCode.invalid_string,
            message: check.message
          });
          status.dirty();
        }
      } else {
        util.assertNever(check);
      }
    }
    return { status: status.value, value: input.data };
  }
  _regex(regex, validation, message) {
    return this.refinement((data) => regex.test(data), {
      validation,
      code: ZodIssueCode.invalid_string,
      ...errorUtil.errToObj(message)
    });
  }
  _addCheck(check) {
    return new _ZodString({
      ...this._def,
      checks: [...this._def.checks, check]
    });
  }
  email(message) {
    return this._addCheck({ kind: "email", ...errorUtil.errToObj(message) });
  }
  url(message) {
    return this._addCheck({ kind: "url", ...errorUtil.errToObj(message) });
  }
  emoji(message) {
    return this._addCheck({ kind: "emoji", ...errorUtil.errToObj(message) });
  }
  uuid(message) {
    return this._addCheck({ kind: "uuid", ...errorUtil.errToObj(message) });
  }
  nanoid(message) {
    return this._addCheck({ kind: "nanoid", ...errorUtil.errToObj(message) });
  }
  cuid(message) {
    return this._addCheck({ kind: "cuid", ...errorUtil.errToObj(message) });
  }
  cuid2(message) {
    return this._addCheck({ kind: "cuid2", ...errorUtil.errToObj(message) });
  }
  ulid(message) {
    return this._addCheck({ kind: "ulid", ...errorUtil.errToObj(message) });
  }
  base64(message) {
    return this._addCheck({ kind: "base64", ...errorUtil.errToObj(message) });
  }
  ip(options) {
    return this._addCheck({ kind: "ip", ...errorUtil.errToObj(options) });
  }
  datetime(options) {
    var _a, _b;
    if (typeof options === "string") {
      return this._addCheck({
        kind: "datetime",
        precision: null,
        offset: false,
        local: false,
        message: options
      });
    }
    return this._addCheck({
      kind: "datetime",
      precision: typeof (options === null || options === void 0 ? void 0 : options.precision) === "undefined" ? null : options === null || options === void 0 ? void 0 : options.precision,
      offset: (_a = options === null || options === void 0 ? void 0 : options.offset) !== null && _a !== void 0 ? _a : false,
      local: (_b = options === null || options === void 0 ? void 0 : options.local) !== null && _b !== void 0 ? _b : false,
      ...errorUtil.errToObj(options === null || options === void 0 ? void 0 : options.message)
    });
  }
  date(message) {
    return this._addCheck({ kind: "date", message });
  }
  time(options) {
    if (typeof options === "string") {
      return this._addCheck({
        kind: "time",
        precision: null,
        message: options
      });
    }
    return this._addCheck({
      kind: "time",
      precision: typeof (options === null || options === void 0 ? void 0 : options.precision) === "undefined" ? null : options === null || options === void 0 ? void 0 : options.precision,
      ...errorUtil.errToObj(options === null || options === void 0 ? void 0 : options.message)
    });
  }
  duration(message) {
    return this._addCheck({ kind: "duration", ...errorUtil.errToObj(message) });
  }
  regex(regex, message) {
    return this._addCheck({
      kind: "regex",
      regex,
      ...errorUtil.errToObj(message)
    });
  }
  includes(value, options) {
    return this._addCheck({
      kind: "includes",
      value,
      position: options === null || options === void 0 ? void 0 : options.position,
      ...errorUtil.errToObj(options === null || options === void 0 ? void 0 : options.message)
    });
  }
  startsWith(value, message) {
    return this._addCheck({
      kind: "startsWith",
      value,
      ...errorUtil.errToObj(message)
    });
  }
  endsWith(value, message) {
    return this._addCheck({
      kind: "endsWith",
      value,
      ...errorUtil.errToObj(message)
    });
  }
  min(minLength, message) {
    return this._addCheck({
      kind: "min",
      value: minLength,
      ...errorUtil.errToObj(message)
    });
  }
  max(maxLength, message) {
    return this._addCheck({
      kind: "max",
      value: maxLength,
      ...errorUtil.errToObj(message)
    });
  }
  length(len, message) {
    return this._addCheck({
      kind: "length",
      value: len,
      ...errorUtil.errToObj(message)
    });
  }
  /**
   * @deprecated Use z.string().min(1) instead.
   * @see {@link ZodString.min}
   */
  nonempty(message) {
    return this.min(1, errorUtil.errToObj(message));
  }
  trim() {
    return new _ZodString({
      ...this._def,
      checks: [...this._def.checks, { kind: "trim" }]
    });
  }
  toLowerCase() {
    return new _ZodString({
      ...this._def,
      checks: [...this._def.checks, { kind: "toLowerCase" }]
    });
  }
  toUpperCase() {
    return new _ZodString({
      ...this._def,
      checks: [...this._def.checks, { kind: "toUpperCase" }]
    });
  }
  get isDatetime() {
    return !!this._def.checks.find((ch) => ch.kind === "datetime");
  }
  get isDate() {
    return !!this._def.checks.find((ch) => ch.kind === "date");
  }
  get isTime() {
    return !!this._def.checks.find((ch) => ch.kind === "time");
  }
  get isDuration() {
    return !!this._def.checks.find((ch) => ch.kind === "duration");
  }
  get isEmail() {
    return !!this._def.checks.find((ch) => ch.kind === "email");
  }
  get isURL() {
    return !!this._def.checks.find((ch) => ch.kind === "url");
  }
  get isEmoji() {
    return !!this._def.checks.find((ch) => ch.kind === "emoji");
  }
  get isUUID() {
    return !!this._def.checks.find((ch) => ch.kind === "uuid");
  }
  get isNANOID() {
    return !!this._def.checks.find((ch) => ch.kind === "nanoid");
  }
  get isCUID() {
    return !!this._def.checks.find((ch) => ch.kind === "cuid");
  }
  get isCUID2() {
    return !!this._def.checks.find((ch) => ch.kind === "cuid2");
  }
  get isULID() {
    return !!this._def.checks.find((ch) => ch.kind === "ulid");
  }
  get isIP() {
    return !!this._def.checks.find((ch) => ch.kind === "ip");
  }
  get isBase64() {
    return !!this._def.checks.find((ch) => ch.kind === "base64");
  }
  get minLength() {
    let min = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "min") {
        if (min === null || ch.value > min)
          min = ch.value;
      }
    }
    return min;
  }
  get maxLength() {
    let max = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "max") {
        if (max === null || ch.value < max)
          max = ch.value;
      }
    }
    return max;
  }
};
ZodString.create = (params) => {
  var _a;
  return new ZodString({
    checks: [],
    typeName: ZodFirstPartyTypeKind.ZodString,
    coerce: (_a = params === null || params === void 0 ? void 0 : params.coerce) !== null && _a !== void 0 ? _a : false,
    ...processCreateParams(params)
  });
};
function floatSafeRemainder(val, step) {
  const valDecCount = (val.toString().split(".")[1] || "").length;
  const stepDecCount = (step.toString().split(".")[1] || "").length;
  const decCount = valDecCount > stepDecCount ? valDecCount : stepDecCount;
  const valInt = parseInt(val.toFixed(decCount).replace(".", ""));
  const stepInt = parseInt(step.toFixed(decCount).replace(".", ""));
  return valInt % stepInt / Math.pow(10, decCount);
}
var ZodNumber = class _ZodNumber extends ZodType {
  constructor() {
    super(...arguments);
    this.min = this.gte;
    this.max = this.lte;
    this.step = this.multipleOf;
  }
  _parse(input) {
    if (this._def.coerce) {
      input.data = Number(input.data);
    }
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.number) {
      const ctx2 = this._getOrReturnCtx(input);
      addIssueToContext(ctx2, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.number,
        received: ctx2.parsedType
      });
      return INVALID;
    }
    let ctx = void 0;
    const status = new ParseStatus();
    for (const check of this._def.checks) {
      if (check.kind === "int") {
        if (!util.isInteger(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.invalid_type,
            expected: "integer",
            received: "float",
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "min") {
        const tooSmall = check.inclusive ? input.data < check.value : input.data <= check.value;
        if (tooSmall) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_small,
            minimum: check.value,
            type: "number",
            inclusive: check.inclusive,
            exact: false,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "max") {
        const tooBig = check.inclusive ? input.data > check.value : input.data >= check.value;
        if (tooBig) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_big,
            maximum: check.value,
            type: "number",
            inclusive: check.inclusive,
            exact: false,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "multipleOf") {
        if (floatSafeRemainder(input.data, check.value) !== 0) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.not_multiple_of,
            multipleOf: check.value,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "finite") {
        if (!Number.isFinite(input.data)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.not_finite,
            message: check.message
          });
          status.dirty();
        }
      } else {
        util.assertNever(check);
      }
    }
    return { status: status.value, value: input.data };
  }
  gte(value, message) {
    return this.setLimit("min", value, true, errorUtil.toString(message));
  }
  gt(value, message) {
    return this.setLimit("min", value, false, errorUtil.toString(message));
  }
  lte(value, message) {
    return this.setLimit("max", value, true, errorUtil.toString(message));
  }
  lt(value, message) {
    return this.setLimit("max", value, false, errorUtil.toString(message));
  }
  setLimit(kind, value, inclusive, message) {
    return new _ZodNumber({
      ...this._def,
      checks: [
        ...this._def.checks,
        {
          kind,
          value,
          inclusive,
          message: errorUtil.toString(message)
        }
      ]
    });
  }
  _addCheck(check) {
    return new _ZodNumber({
      ...this._def,
      checks: [...this._def.checks, check]
    });
  }
  int(message) {
    return this._addCheck({
      kind: "int",
      message: errorUtil.toString(message)
    });
  }
  positive(message) {
    return this._addCheck({
      kind: "min",
      value: 0,
      inclusive: false,
      message: errorUtil.toString(message)
    });
  }
  negative(message) {
    return this._addCheck({
      kind: "max",
      value: 0,
      inclusive: false,
      message: errorUtil.toString(message)
    });
  }
  nonpositive(message) {
    return this._addCheck({
      kind: "max",
      value: 0,
      inclusive: true,
      message: errorUtil.toString(message)
    });
  }
  nonnegative(message) {
    return this._addCheck({
      kind: "min",
      value: 0,
      inclusive: true,
      message: errorUtil.toString(message)
    });
  }
  multipleOf(value, message) {
    return this._addCheck({
      kind: "multipleOf",
      value,
      message: errorUtil.toString(message)
    });
  }
  finite(message) {
    return this._addCheck({
      kind: "finite",
      message: errorUtil.toString(message)
    });
  }
  safe(message) {
    return this._addCheck({
      kind: "min",
      inclusive: true,
      value: Number.MIN_SAFE_INTEGER,
      message: errorUtil.toString(message)
    })._addCheck({
      kind: "max",
      inclusive: true,
      value: Number.MAX_SAFE_INTEGER,
      message: errorUtil.toString(message)
    });
  }
  get minValue() {
    let min = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "min") {
        if (min === null || ch.value > min)
          min = ch.value;
      }
    }
    return min;
  }
  get maxValue() {
    let max = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "max") {
        if (max === null || ch.value < max)
          max = ch.value;
      }
    }
    return max;
  }
  get isInt() {
    return !!this._def.checks.find((ch) => ch.kind === "int" || ch.kind === "multipleOf" && util.isInteger(ch.value));
  }
  get isFinite() {
    let max = null, min = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "finite" || ch.kind === "int" || ch.kind === "multipleOf") {
        return true;
      } else if (ch.kind === "min") {
        if (min === null || ch.value > min)
          min = ch.value;
      } else if (ch.kind === "max") {
        if (max === null || ch.value < max)
          max = ch.value;
      }
    }
    return Number.isFinite(min) && Number.isFinite(max);
  }
};
ZodNumber.create = (params) => {
  return new ZodNumber({
    checks: [],
    typeName: ZodFirstPartyTypeKind.ZodNumber,
    coerce: (params === null || params === void 0 ? void 0 : params.coerce) || false,
    ...processCreateParams(params)
  });
};
var ZodBigInt = class _ZodBigInt extends ZodType {
  constructor() {
    super(...arguments);
    this.min = this.gte;
    this.max = this.lte;
  }
  _parse(input) {
    if (this._def.coerce) {
      input.data = BigInt(input.data);
    }
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.bigint) {
      const ctx2 = this._getOrReturnCtx(input);
      addIssueToContext(ctx2, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.bigint,
        received: ctx2.parsedType
      });
      return INVALID;
    }
    let ctx = void 0;
    const status = new ParseStatus();
    for (const check of this._def.checks) {
      if (check.kind === "min") {
        const tooSmall = check.inclusive ? input.data < check.value : input.data <= check.value;
        if (tooSmall) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_small,
            type: "bigint",
            minimum: check.value,
            inclusive: check.inclusive,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "max") {
        const tooBig = check.inclusive ? input.data > check.value : input.data >= check.value;
        if (tooBig) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_big,
            type: "bigint",
            maximum: check.value,
            inclusive: check.inclusive,
            message: check.message
          });
          status.dirty();
        }
      } else if (check.kind === "multipleOf") {
        if (input.data % check.value !== BigInt(0)) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.not_multiple_of,
            multipleOf: check.value,
            message: check.message
          });
          status.dirty();
        }
      } else {
        util.assertNever(check);
      }
    }
    return { status: status.value, value: input.data };
  }
  gte(value, message) {
    return this.setLimit("min", value, true, errorUtil.toString(message));
  }
  gt(value, message) {
    return this.setLimit("min", value, false, errorUtil.toString(message));
  }
  lte(value, message) {
    return this.setLimit("max", value, true, errorUtil.toString(message));
  }
  lt(value, message) {
    return this.setLimit("max", value, false, errorUtil.toString(message));
  }
  setLimit(kind, value, inclusive, message) {
    return new _ZodBigInt({
      ...this._def,
      checks: [
        ...this._def.checks,
        {
          kind,
          value,
          inclusive,
          message: errorUtil.toString(message)
        }
      ]
    });
  }
  _addCheck(check) {
    return new _ZodBigInt({
      ...this._def,
      checks: [...this._def.checks, check]
    });
  }
  positive(message) {
    return this._addCheck({
      kind: "min",
      value: BigInt(0),
      inclusive: false,
      message: errorUtil.toString(message)
    });
  }
  negative(message) {
    return this._addCheck({
      kind: "max",
      value: BigInt(0),
      inclusive: false,
      message: errorUtil.toString(message)
    });
  }
  nonpositive(message) {
    return this._addCheck({
      kind: "max",
      value: BigInt(0),
      inclusive: true,
      message: errorUtil.toString(message)
    });
  }
  nonnegative(message) {
    return this._addCheck({
      kind: "min",
      value: BigInt(0),
      inclusive: true,
      message: errorUtil.toString(message)
    });
  }
  multipleOf(value, message) {
    return this._addCheck({
      kind: "multipleOf",
      value,
      message: errorUtil.toString(message)
    });
  }
  get minValue() {
    let min = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "min") {
        if (min === null || ch.value > min)
          min = ch.value;
      }
    }
    return min;
  }
  get maxValue() {
    let max = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "max") {
        if (max === null || ch.value < max)
          max = ch.value;
      }
    }
    return max;
  }
};
ZodBigInt.create = (params) => {
  var _a;
  return new ZodBigInt({
    checks: [],
    typeName: ZodFirstPartyTypeKind.ZodBigInt,
    coerce: (_a = params === null || params === void 0 ? void 0 : params.coerce) !== null && _a !== void 0 ? _a : false,
    ...processCreateParams(params)
  });
};
var ZodBoolean = class extends ZodType {
  _parse(input) {
    if (this._def.coerce) {
      input.data = Boolean(input.data);
    }
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.boolean) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.boolean,
        received: ctx.parsedType
      });
      return INVALID;
    }
    return OK(input.data);
  }
};
ZodBoolean.create = (params) => {
  return new ZodBoolean({
    typeName: ZodFirstPartyTypeKind.ZodBoolean,
    coerce: (params === null || params === void 0 ? void 0 : params.coerce) || false,
    ...processCreateParams(params)
  });
};
var ZodDate = class _ZodDate extends ZodType {
  _parse(input) {
    if (this._def.coerce) {
      input.data = new Date(input.data);
    }
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.date) {
      const ctx2 = this._getOrReturnCtx(input);
      addIssueToContext(ctx2, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.date,
        received: ctx2.parsedType
      });
      return INVALID;
    }
    if (isNaN(input.data.getTime())) {
      const ctx2 = this._getOrReturnCtx(input);
      addIssueToContext(ctx2, {
        code: ZodIssueCode.invalid_date
      });
      return INVALID;
    }
    const status = new ParseStatus();
    let ctx = void 0;
    for (const check of this._def.checks) {
      if (check.kind === "min") {
        if (input.data.getTime() < check.value) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_small,
            message: check.message,
            inclusive: true,
            exact: false,
            minimum: check.value,
            type: "date"
          });
          status.dirty();
        }
      } else if (check.kind === "max") {
        if (input.data.getTime() > check.value) {
          ctx = this._getOrReturnCtx(input, ctx);
          addIssueToContext(ctx, {
            code: ZodIssueCode.too_big,
            message: check.message,
            inclusive: true,
            exact: false,
            maximum: check.value,
            type: "date"
          });
          status.dirty();
        }
      } else {
        util.assertNever(check);
      }
    }
    return {
      status: status.value,
      value: new Date(input.data.getTime())
    };
  }
  _addCheck(check) {
    return new _ZodDate({
      ...this._def,
      checks: [...this._def.checks, check]
    });
  }
  min(minDate, message) {
    return this._addCheck({
      kind: "min",
      value: minDate.getTime(),
      message: errorUtil.toString(message)
    });
  }
  max(maxDate, message) {
    return this._addCheck({
      kind: "max",
      value: maxDate.getTime(),
      message: errorUtil.toString(message)
    });
  }
  get minDate() {
    let min = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "min") {
        if (min === null || ch.value > min)
          min = ch.value;
      }
    }
    return min != null ? new Date(min) : null;
  }
  get maxDate() {
    let max = null;
    for (const ch of this._def.checks) {
      if (ch.kind === "max") {
        if (max === null || ch.value < max)
          max = ch.value;
      }
    }
    return max != null ? new Date(max) : null;
  }
};
ZodDate.create = (params) => {
  return new ZodDate({
    checks: [],
    coerce: (params === null || params === void 0 ? void 0 : params.coerce) || false,
    typeName: ZodFirstPartyTypeKind.ZodDate,
    ...processCreateParams(params)
  });
};
var ZodSymbol = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.symbol) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.symbol,
        received: ctx.parsedType
      });
      return INVALID;
    }
    return OK(input.data);
  }
};
ZodSymbol.create = (params) => {
  return new ZodSymbol({
    typeName: ZodFirstPartyTypeKind.ZodSymbol,
    ...processCreateParams(params)
  });
};
var ZodUndefined = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.undefined) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.undefined,
        received: ctx.parsedType
      });
      return INVALID;
    }
    return OK(input.data);
  }
};
ZodUndefined.create = (params) => {
  return new ZodUndefined({
    typeName: ZodFirstPartyTypeKind.ZodUndefined,
    ...processCreateParams(params)
  });
};
var ZodNull = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.null) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.null,
        received: ctx.parsedType
      });
      return INVALID;
    }
    return OK(input.data);
  }
};
ZodNull.create = (params) => {
  return new ZodNull({
    typeName: ZodFirstPartyTypeKind.ZodNull,
    ...processCreateParams(params)
  });
};
var ZodAny = class extends ZodType {
  constructor() {
    super(...arguments);
    this._any = true;
  }
  _parse(input) {
    return OK(input.data);
  }
};
ZodAny.create = (params) => {
  return new ZodAny({
    typeName: ZodFirstPartyTypeKind.ZodAny,
    ...processCreateParams(params)
  });
};
var ZodUnknown = class extends ZodType {
  constructor() {
    super(...arguments);
    this._unknown = true;
  }
  _parse(input) {
    return OK(input.data);
  }
};
ZodUnknown.create = (params) => {
  return new ZodUnknown({
    typeName: ZodFirstPartyTypeKind.ZodUnknown,
    ...processCreateParams(params)
  });
};
var ZodNever = class extends ZodType {
  _parse(input) {
    const ctx = this._getOrReturnCtx(input);
    addIssueToContext(ctx, {
      code: ZodIssueCode.invalid_type,
      expected: ZodParsedType.never,
      received: ctx.parsedType
    });
    return INVALID;
  }
};
ZodNever.create = (params) => {
  return new ZodNever({
    typeName: ZodFirstPartyTypeKind.ZodNever,
    ...processCreateParams(params)
  });
};
var ZodVoid = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.undefined) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.void,
        received: ctx.parsedType
      });
      return INVALID;
    }
    return OK(input.data);
  }
};
ZodVoid.create = (params) => {
  return new ZodVoid({
    typeName: ZodFirstPartyTypeKind.ZodVoid,
    ...processCreateParams(params)
  });
};
var ZodArray = class _ZodArray extends ZodType {
  _parse(input) {
    const { ctx, status } = this._processInputParams(input);
    const def = this._def;
    if (ctx.parsedType !== ZodParsedType.array) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.array,
        received: ctx.parsedType
      });
      return INVALID;
    }
    if (def.exactLength !== null) {
      const tooBig = ctx.data.length > def.exactLength.value;
      const tooSmall = ctx.data.length < def.exactLength.value;
      if (tooBig || tooSmall) {
        addIssueToContext(ctx, {
          code: tooBig ? ZodIssueCode.too_big : ZodIssueCode.too_small,
          minimum: tooSmall ? def.exactLength.value : void 0,
          maximum: tooBig ? def.exactLength.value : void 0,
          type: "array",
          inclusive: true,
          exact: true,
          message: def.exactLength.message
        });
        status.dirty();
      }
    }
    if (def.minLength !== null) {
      if (ctx.data.length < def.minLength.value) {
        addIssueToContext(ctx, {
          code: ZodIssueCode.too_small,
          minimum: def.minLength.value,
          type: "array",
          inclusive: true,
          exact: false,
          message: def.minLength.message
        });
        status.dirty();
      }
    }
    if (def.maxLength !== null) {
      if (ctx.data.length > def.maxLength.value) {
        addIssueToContext(ctx, {
          code: ZodIssueCode.too_big,
          maximum: def.maxLength.value,
          type: "array",
          inclusive: true,
          exact: false,
          message: def.maxLength.message
        });
        status.dirty();
      }
    }
    if (ctx.common.async) {
      return Promise.all([...ctx.data].map((item, i) => {
        return def.type._parseAsync(new ParseInputLazyPath(ctx, item, ctx.path, i));
      })).then((result2) => {
        return ParseStatus.mergeArray(status, result2);
      });
    }
    const result = [...ctx.data].map((item, i) => {
      return def.type._parseSync(new ParseInputLazyPath(ctx, item, ctx.path, i));
    });
    return ParseStatus.mergeArray(status, result);
  }
  get element() {
    return this._def.type;
  }
  min(minLength, message) {
    return new _ZodArray({
      ...this._def,
      minLength: { value: minLength, message: errorUtil.toString(message) }
    });
  }
  max(maxLength, message) {
    return new _ZodArray({
      ...this._def,
      maxLength: { value: maxLength, message: errorUtil.toString(message) }
    });
  }
  length(len, message) {
    return new _ZodArray({
      ...this._def,
      exactLength: { value: len, message: errorUtil.toString(message) }
    });
  }
  nonempty(message) {
    return this.min(1, message);
  }
};
ZodArray.create = (schema2, params) => {
  return new ZodArray({
    type: schema2,
    minLength: null,
    maxLength: null,
    exactLength: null,
    typeName: ZodFirstPartyTypeKind.ZodArray,
    ...processCreateParams(params)
  });
};
function deepPartialify(schema2) {
  if (schema2 instanceof ZodObject) {
    const newShape = {};
    for (const key in schema2.shape) {
      const fieldSchema = schema2.shape[key];
      newShape[key] = ZodOptional.create(deepPartialify(fieldSchema));
    }
    return new ZodObject({
      ...schema2._def,
      shape: () => newShape
    });
  } else if (schema2 instanceof ZodArray) {
    return new ZodArray({
      ...schema2._def,
      type: deepPartialify(schema2.element)
    });
  } else if (schema2 instanceof ZodOptional) {
    return ZodOptional.create(deepPartialify(schema2.unwrap()));
  } else if (schema2 instanceof ZodNullable) {
    return ZodNullable.create(deepPartialify(schema2.unwrap()));
  } else if (schema2 instanceof ZodTuple) {
    return ZodTuple.create(schema2.items.map((item) => deepPartialify(item)));
  } else {
    return schema2;
  }
}
var ZodObject = class _ZodObject extends ZodType {
  constructor() {
    super(...arguments);
    this._cached = null;
    this.nonstrict = this.passthrough;
    this.augment = this.extend;
  }
  _getCached() {
    if (this._cached !== null)
      return this._cached;
    const shape = this._def.shape();
    const keys5 = util.objectKeys(shape);
    return this._cached = { shape, keys: keys5 };
  }
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.object) {
      const ctx2 = this._getOrReturnCtx(input);
      addIssueToContext(ctx2, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.object,
        received: ctx2.parsedType
      });
      return INVALID;
    }
    const { status, ctx } = this._processInputParams(input);
    const { shape, keys: shapeKeys } = this._getCached();
    const extraKeys = [];
    if (!(this._def.catchall instanceof ZodNever && this._def.unknownKeys === "strip")) {
      for (const key in ctx.data) {
        if (!shapeKeys.includes(key)) {
          extraKeys.push(key);
        }
      }
    }
    const pairs2 = [];
    for (const key of shapeKeys) {
      const keyValidator = shape[key];
      const value = ctx.data[key];
      pairs2.push({
        key: { status: "valid", value: key },
        value: keyValidator._parse(new ParseInputLazyPath(ctx, value, ctx.path, key)),
        alwaysSet: key in ctx.data
      });
    }
    if (this._def.catchall instanceof ZodNever) {
      const unknownKeys = this._def.unknownKeys;
      if (unknownKeys === "passthrough") {
        for (const key of extraKeys) {
          pairs2.push({
            key: { status: "valid", value: key },
            value: { status: "valid", value: ctx.data[key] }
          });
        }
      } else if (unknownKeys === "strict") {
        if (extraKeys.length > 0) {
          addIssueToContext(ctx, {
            code: ZodIssueCode.unrecognized_keys,
            keys: extraKeys
          });
          status.dirty();
        }
      } else if (unknownKeys === "strip");
      else {
        throw new Error(`Internal ZodObject error: invalid unknownKeys value.`);
      }
    } else {
      const catchall = this._def.catchall;
      for (const key of extraKeys) {
        const value = ctx.data[key];
        pairs2.push({
          key: { status: "valid", value: key },
          value: catchall._parse(
            new ParseInputLazyPath(ctx, value, ctx.path, key)
            //, ctx.child(key), value, getParsedType(value)
          ),
          alwaysSet: key in ctx.data
        });
      }
    }
    if (ctx.common.async) {
      return Promise.resolve().then(async () => {
        const syncPairs = [];
        for (const pair of pairs2) {
          const key = await pair.key;
          const value = await pair.value;
          syncPairs.push({
            key,
            value,
            alwaysSet: pair.alwaysSet
          });
        }
        return syncPairs;
      }).then((syncPairs) => {
        return ParseStatus.mergeObjectSync(status, syncPairs);
      });
    } else {
      return ParseStatus.mergeObjectSync(status, pairs2);
    }
  }
  get shape() {
    return this._def.shape();
  }
  strict(message) {
    errorUtil.errToObj;
    return new _ZodObject({
      ...this._def,
      unknownKeys: "strict",
      ...message !== void 0 ? {
        errorMap: (issue, ctx) => {
          var _a, _b, _c, _d;
          const defaultError = (_c = (_b = (_a = this._def).errorMap) === null || _b === void 0 ? void 0 : _b.call(_a, issue, ctx).message) !== null && _c !== void 0 ? _c : ctx.defaultError;
          if (issue.code === "unrecognized_keys")
            return {
              message: (_d = errorUtil.errToObj(message).message) !== null && _d !== void 0 ? _d : defaultError
            };
          return {
            message: defaultError
          };
        }
      } : {}
    });
  }
  strip() {
    return new _ZodObject({
      ...this._def,
      unknownKeys: "strip"
    });
  }
  passthrough() {
    return new _ZodObject({
      ...this._def,
      unknownKeys: "passthrough"
    });
  }
  // const AugmentFactory =
  //   <Def extends ZodObjectDef>(def: Def) =>
  //   <Augmentation extends ZodRawShape>(
  //     augmentation: Augmentation
  //   ): ZodObject<
  //     extendShape<ReturnType<Def["shape"]>, Augmentation>,
  //     Def["unknownKeys"],
  //     Def["catchall"]
  //   > => {
  //     return new ZodObject({
  //       ...def,
  //       shape: () => ({
  //         ...def.shape(),
  //         ...augmentation,
  //       }),
  //     }) as any;
  //   };
  extend(augmentation) {
    return new _ZodObject({
      ...this._def,
      shape: () => ({
        ...this._def.shape(),
        ...augmentation
      })
    });
  }
  /**
   * Prior to zod@1.0.12 there was a bug in the
   * inferred type of merged objects. Please
   * upgrade if you are experiencing issues.
   */
  merge(merging) {
    const merged = new _ZodObject({
      unknownKeys: merging._def.unknownKeys,
      catchall: merging._def.catchall,
      shape: () => ({
        ...this._def.shape(),
        ...merging._def.shape()
      }),
      typeName: ZodFirstPartyTypeKind.ZodObject
    });
    return merged;
  }
  // merge<
  //   Incoming extends AnyZodObject,
  //   Augmentation extends Incoming["shape"],
  //   NewOutput extends {
  //     [k in keyof Augmentation | keyof Output]: k extends keyof Augmentation
  //       ? Augmentation[k]["_output"]
  //       : k extends keyof Output
  //       ? Output[k]
  //       : never;
  //   },
  //   NewInput extends {
  //     [k in keyof Augmentation | keyof Input]: k extends keyof Augmentation
  //       ? Augmentation[k]["_input"]
  //       : k extends keyof Input
  //       ? Input[k]
  //       : never;
  //   }
  // >(
  //   merging: Incoming
  // ): ZodObject<
  //   extendShape<T, ReturnType<Incoming["_def"]["shape"]>>,
  //   Incoming["_def"]["unknownKeys"],
  //   Incoming["_def"]["catchall"],
  //   NewOutput,
  //   NewInput
  // > {
  //   const merged: any = new ZodObject({
  //     unknownKeys: merging._def.unknownKeys,
  //     catchall: merging._def.catchall,
  //     shape: () =>
  //       objectUtil.mergeShapes(this._def.shape(), merging._def.shape()),
  //     typeName: ZodFirstPartyTypeKind.ZodObject,
  //   }) as any;
  //   return merged;
  // }
  setKey(key, schema2) {
    return this.augment({ [key]: schema2 });
  }
  // merge<Incoming extends AnyZodObject>(
  //   merging: Incoming
  // ): //ZodObject<T & Incoming["_shape"], UnknownKeys, Catchall> = (merging) => {
  // ZodObject<
  //   extendShape<T, ReturnType<Incoming["_def"]["shape"]>>,
  //   Incoming["_def"]["unknownKeys"],
  //   Incoming["_def"]["catchall"]
  // > {
  //   // const mergedShape = objectUtil.mergeShapes(
  //   //   this._def.shape(),
  //   //   merging._def.shape()
  //   // );
  //   const merged: any = new ZodObject({
  //     unknownKeys: merging._def.unknownKeys,
  //     catchall: merging._def.catchall,
  //     shape: () =>
  //       objectUtil.mergeShapes(this._def.shape(), merging._def.shape()),
  //     typeName: ZodFirstPartyTypeKind.ZodObject,
  //   }) as any;
  //   return merged;
  // }
  catchall(index) {
    return new _ZodObject({
      ...this._def,
      catchall: index
    });
  }
  pick(mask) {
    const shape = {};
    util.objectKeys(mask).forEach((key) => {
      if (mask[key] && this.shape[key]) {
        shape[key] = this.shape[key];
      }
    });
    return new _ZodObject({
      ...this._def,
      shape: () => shape
    });
  }
  omit(mask) {
    const shape = {};
    util.objectKeys(this.shape).forEach((key) => {
      if (!mask[key]) {
        shape[key] = this.shape[key];
      }
    });
    return new _ZodObject({
      ...this._def,
      shape: () => shape
    });
  }
  /**
   * @deprecated
   */
  deepPartial() {
    return deepPartialify(this);
  }
  partial(mask) {
    const newShape = {};
    util.objectKeys(this.shape).forEach((key) => {
      const fieldSchema = this.shape[key];
      if (mask && !mask[key]) {
        newShape[key] = fieldSchema;
      } else {
        newShape[key] = fieldSchema.optional();
      }
    });
    return new _ZodObject({
      ...this._def,
      shape: () => newShape
    });
  }
  required(mask) {
    const newShape = {};
    util.objectKeys(this.shape).forEach((key) => {
      if (mask && !mask[key]) {
        newShape[key] = this.shape[key];
      } else {
        const fieldSchema = this.shape[key];
        let newField = fieldSchema;
        while (newField instanceof ZodOptional) {
          newField = newField._def.innerType;
        }
        newShape[key] = newField;
      }
    });
    return new _ZodObject({
      ...this._def,
      shape: () => newShape
    });
  }
  keyof() {
    return createZodEnum(util.objectKeys(this.shape));
  }
};
ZodObject.create = (shape, params) => {
  return new ZodObject({
    shape: () => shape,
    unknownKeys: "strip",
    catchall: ZodNever.create(),
    typeName: ZodFirstPartyTypeKind.ZodObject,
    ...processCreateParams(params)
  });
};
ZodObject.strictCreate = (shape, params) => {
  return new ZodObject({
    shape: () => shape,
    unknownKeys: "strict",
    catchall: ZodNever.create(),
    typeName: ZodFirstPartyTypeKind.ZodObject,
    ...processCreateParams(params)
  });
};
ZodObject.lazycreate = (shape, params) => {
  return new ZodObject({
    shape,
    unknownKeys: "strip",
    catchall: ZodNever.create(),
    typeName: ZodFirstPartyTypeKind.ZodObject,
    ...processCreateParams(params)
  });
};
var ZodUnion = class extends ZodType {
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    const options = this._def.options;
    function handleResults(results) {
      for (const result of results) {
        if (result.result.status === "valid") {
          return result.result;
        }
      }
      for (const result of results) {
        if (result.result.status === "dirty") {
          ctx.common.issues.push(...result.ctx.common.issues);
          return result.result;
        }
      }
      const unionErrors = results.map((result) => new ZodError(result.ctx.common.issues));
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_union,
        unionErrors
      });
      return INVALID;
    }
    if (ctx.common.async) {
      return Promise.all(options.map(async (option) => {
        const childCtx = {
          ...ctx,
          common: {
            ...ctx.common,
            issues: []
          },
          parent: null
        };
        return {
          result: await option._parseAsync({
            data: ctx.data,
            path: ctx.path,
            parent: childCtx
          }),
          ctx: childCtx
        };
      })).then(handleResults);
    } else {
      let dirty = void 0;
      const issues = [];
      for (const option of options) {
        const childCtx = {
          ...ctx,
          common: {
            ...ctx.common,
            issues: []
          },
          parent: null
        };
        const result = option._parseSync({
          data: ctx.data,
          path: ctx.path,
          parent: childCtx
        });
        if (result.status === "valid") {
          return result;
        } else if (result.status === "dirty" && !dirty) {
          dirty = { result, ctx: childCtx };
        }
        if (childCtx.common.issues.length) {
          issues.push(childCtx.common.issues);
        }
      }
      if (dirty) {
        ctx.common.issues.push(...dirty.ctx.common.issues);
        return dirty.result;
      }
      const unionErrors = issues.map((issues2) => new ZodError(issues2));
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_union,
        unionErrors
      });
      return INVALID;
    }
  }
  get options() {
    return this._def.options;
  }
};
ZodUnion.create = (types2, params) => {
  return new ZodUnion({
    options: types2,
    typeName: ZodFirstPartyTypeKind.ZodUnion,
    ...processCreateParams(params)
  });
};
var getDiscriminator = (type2) => {
  if (type2 instanceof ZodLazy) {
    return getDiscriminator(type2.schema);
  } else if (type2 instanceof ZodEffects) {
    return getDiscriminator(type2.innerType());
  } else if (type2 instanceof ZodLiteral) {
    return [type2.value];
  } else if (type2 instanceof ZodEnum) {
    return type2.options;
  } else if (type2 instanceof ZodNativeEnum) {
    return util.objectValues(type2.enum);
  } else if (type2 instanceof ZodDefault) {
    return getDiscriminator(type2._def.innerType);
  } else if (type2 instanceof ZodUndefined) {
    return [void 0];
  } else if (type2 instanceof ZodNull) {
    return [null];
  } else if (type2 instanceof ZodOptional) {
    return [void 0, ...getDiscriminator(type2.unwrap())];
  } else if (type2 instanceof ZodNullable) {
    return [null, ...getDiscriminator(type2.unwrap())];
  } else if (type2 instanceof ZodBranded) {
    return getDiscriminator(type2.unwrap());
  } else if (type2 instanceof ZodReadonly) {
    return getDiscriminator(type2.unwrap());
  } else if (type2 instanceof ZodCatch) {
    return getDiscriminator(type2._def.innerType);
  } else {
    return [];
  }
};
var ZodDiscriminatedUnion = class _ZodDiscriminatedUnion extends ZodType {
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.object) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.object,
        received: ctx.parsedType
      });
      return INVALID;
    }
    const discriminator = this.discriminator;
    const discriminatorValue = ctx.data[discriminator];
    const option = this.optionsMap.get(discriminatorValue);
    if (!option) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_union_discriminator,
        options: Array.from(this.optionsMap.keys()),
        path: [discriminator]
      });
      return INVALID;
    }
    if (ctx.common.async) {
      return option._parseAsync({
        data: ctx.data,
        path: ctx.path,
        parent: ctx
      });
    } else {
      return option._parseSync({
        data: ctx.data,
        path: ctx.path,
        parent: ctx
      });
    }
  }
  get discriminator() {
    return this._def.discriminator;
  }
  get options() {
    return this._def.options;
  }
  get optionsMap() {
    return this._def.optionsMap;
  }
  /**
   * The constructor of the discriminated union schema. Its behaviour is very similar to that of the normal z.union() constructor.
   * However, it only allows a union of objects, all of which need to share a discriminator property. This property must
   * have a different value for each object in the union.
   * @param discriminator the name of the discriminator property
   * @param types an array of object schemas
   * @param params
   */
  static create(discriminator, options, params) {
    const optionsMap = /* @__PURE__ */ new Map();
    for (const type2 of options) {
      const discriminatorValues = getDiscriminator(type2.shape[discriminator]);
      if (!discriminatorValues.length) {
        throw new Error(`A discriminator value for key \`${discriminator}\` could not be extracted from all schema options`);
      }
      for (const value of discriminatorValues) {
        if (optionsMap.has(value)) {
          throw new Error(`Discriminator property ${String(discriminator)} has duplicate value ${String(value)}`);
        }
        optionsMap.set(value, type2);
      }
    }
    return new _ZodDiscriminatedUnion({
      typeName: ZodFirstPartyTypeKind.ZodDiscriminatedUnion,
      discriminator,
      options,
      optionsMap,
      ...processCreateParams(params)
    });
  }
};
function mergeValues(a, b) {
  const aType = getParsedType(a);
  const bType = getParsedType(b);
  if (a === b) {
    return { valid: true, data: a };
  } else if (aType === ZodParsedType.object && bType === ZodParsedType.object) {
    const bKeys = util.objectKeys(b);
    const sharedKeys = util.objectKeys(a).filter((key) => bKeys.indexOf(key) !== -1);
    const newObj = { ...a, ...b };
    for (const key of sharedKeys) {
      const sharedValue = mergeValues(a[key], b[key]);
      if (!sharedValue.valid) {
        return { valid: false };
      }
      newObj[key] = sharedValue.data;
    }
    return { valid: true, data: newObj };
  } else if (aType === ZodParsedType.array && bType === ZodParsedType.array) {
    if (a.length !== b.length) {
      return { valid: false };
    }
    const newArray = [];
    for (let index = 0; index < a.length; index++) {
      const itemA = a[index];
      const itemB = b[index];
      const sharedValue = mergeValues(itemA, itemB);
      if (!sharedValue.valid) {
        return { valid: false };
      }
      newArray.push(sharedValue.data);
    }
    return { valid: true, data: newArray };
  } else if (aType === ZodParsedType.date && bType === ZodParsedType.date && +a === +b) {
    return { valid: true, data: a };
  } else {
    return { valid: false };
  }
}
var ZodIntersection = class extends ZodType {
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    const handleParsed = (parsedLeft, parsedRight) => {
      if (isAborted(parsedLeft) || isAborted(parsedRight)) {
        return INVALID;
      }
      const merged = mergeValues(parsedLeft.value, parsedRight.value);
      if (!merged.valid) {
        addIssueToContext(ctx, {
          code: ZodIssueCode.invalid_intersection_types
        });
        return INVALID;
      }
      if (isDirty(parsedLeft) || isDirty(parsedRight)) {
        status.dirty();
      }
      return { status: status.value, value: merged.data };
    };
    if (ctx.common.async) {
      return Promise.all([
        this._def.left._parseAsync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx
        }),
        this._def.right._parseAsync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx
        })
      ]).then(([left, right]) => handleParsed(left, right));
    } else {
      return handleParsed(this._def.left._parseSync({
        data: ctx.data,
        path: ctx.path,
        parent: ctx
      }), this._def.right._parseSync({
        data: ctx.data,
        path: ctx.path,
        parent: ctx
      }));
    }
  }
};
ZodIntersection.create = (left, right, params) => {
  return new ZodIntersection({
    left,
    right,
    typeName: ZodFirstPartyTypeKind.ZodIntersection,
    ...processCreateParams(params)
  });
};
var ZodTuple = class _ZodTuple extends ZodType {
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.array) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.array,
        received: ctx.parsedType
      });
      return INVALID;
    }
    if (ctx.data.length < this._def.items.length) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.too_small,
        minimum: this._def.items.length,
        inclusive: true,
        exact: false,
        type: "array"
      });
      return INVALID;
    }
    const rest = this._def.rest;
    if (!rest && ctx.data.length > this._def.items.length) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.too_big,
        maximum: this._def.items.length,
        inclusive: true,
        exact: false,
        type: "array"
      });
      status.dirty();
    }
    const items = [...ctx.data].map((item, itemIndex) => {
      const schema2 = this._def.items[itemIndex] || this._def.rest;
      if (!schema2)
        return null;
      return schema2._parse(new ParseInputLazyPath(ctx, item, ctx.path, itemIndex));
    }).filter((x) => !!x);
    if (ctx.common.async) {
      return Promise.all(items).then((results) => {
        return ParseStatus.mergeArray(status, results);
      });
    } else {
      return ParseStatus.mergeArray(status, items);
    }
  }
  get items() {
    return this._def.items;
  }
  rest(rest) {
    return new _ZodTuple({
      ...this._def,
      rest
    });
  }
};
ZodTuple.create = (schemas, params) => {
  if (!Array.isArray(schemas)) {
    throw new Error("You must pass an array of schemas to z.tuple([ ... ])");
  }
  return new ZodTuple({
    items: schemas,
    typeName: ZodFirstPartyTypeKind.ZodTuple,
    rest: null,
    ...processCreateParams(params)
  });
};
var ZodRecord = class _ZodRecord extends ZodType {
  get keySchema() {
    return this._def.keyType;
  }
  get valueSchema() {
    return this._def.valueType;
  }
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.object) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.object,
        received: ctx.parsedType
      });
      return INVALID;
    }
    const pairs2 = [];
    const keyType = this._def.keyType;
    const valueType = this._def.valueType;
    for (const key in ctx.data) {
      pairs2.push({
        key: keyType._parse(new ParseInputLazyPath(ctx, key, ctx.path, key)),
        value: valueType._parse(new ParseInputLazyPath(ctx, ctx.data[key], ctx.path, key)),
        alwaysSet: key in ctx.data
      });
    }
    if (ctx.common.async) {
      return ParseStatus.mergeObjectAsync(status, pairs2);
    } else {
      return ParseStatus.mergeObjectSync(status, pairs2);
    }
  }
  get element() {
    return this._def.valueType;
  }
  static create(first, second, third) {
    if (second instanceof ZodType) {
      return new _ZodRecord({
        keyType: first,
        valueType: second,
        typeName: ZodFirstPartyTypeKind.ZodRecord,
        ...processCreateParams(third)
      });
    }
    return new _ZodRecord({
      keyType: ZodString.create(),
      valueType: first,
      typeName: ZodFirstPartyTypeKind.ZodRecord,
      ...processCreateParams(second)
    });
  }
};
var ZodMap = class extends ZodType {
  get keySchema() {
    return this._def.keyType;
  }
  get valueSchema() {
    return this._def.valueType;
  }
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.map) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.map,
        received: ctx.parsedType
      });
      return INVALID;
    }
    const keyType = this._def.keyType;
    const valueType = this._def.valueType;
    const pairs2 = [...ctx.data.entries()].map(([key, value], index) => {
      return {
        key: keyType._parse(new ParseInputLazyPath(ctx, key, ctx.path, [index, "key"])),
        value: valueType._parse(new ParseInputLazyPath(ctx, value, ctx.path, [index, "value"]))
      };
    });
    if (ctx.common.async) {
      const finalMap = /* @__PURE__ */ new Map();
      return Promise.resolve().then(async () => {
        for (const pair of pairs2) {
          const key = await pair.key;
          const value = await pair.value;
          if (key.status === "aborted" || value.status === "aborted") {
            return INVALID;
          }
          if (key.status === "dirty" || value.status === "dirty") {
            status.dirty();
          }
          finalMap.set(key.value, value.value);
        }
        return { status: status.value, value: finalMap };
      });
    } else {
      const finalMap = /* @__PURE__ */ new Map();
      for (const pair of pairs2) {
        const key = pair.key;
        const value = pair.value;
        if (key.status === "aborted" || value.status === "aborted") {
          return INVALID;
        }
        if (key.status === "dirty" || value.status === "dirty") {
          status.dirty();
        }
        finalMap.set(key.value, value.value);
      }
      return { status: status.value, value: finalMap };
    }
  }
};
ZodMap.create = (keyType, valueType, params) => {
  return new ZodMap({
    valueType,
    keyType,
    typeName: ZodFirstPartyTypeKind.ZodMap,
    ...processCreateParams(params)
  });
};
var ZodSet = class _ZodSet extends ZodType {
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.set) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.set,
        received: ctx.parsedType
      });
      return INVALID;
    }
    const def = this._def;
    if (def.minSize !== null) {
      if (ctx.data.size < def.minSize.value) {
        addIssueToContext(ctx, {
          code: ZodIssueCode.too_small,
          minimum: def.minSize.value,
          type: "set",
          inclusive: true,
          exact: false,
          message: def.minSize.message
        });
        status.dirty();
      }
    }
    if (def.maxSize !== null) {
      if (ctx.data.size > def.maxSize.value) {
        addIssueToContext(ctx, {
          code: ZodIssueCode.too_big,
          maximum: def.maxSize.value,
          type: "set",
          inclusive: true,
          exact: false,
          message: def.maxSize.message
        });
        status.dirty();
      }
    }
    const valueType = this._def.valueType;
    function finalizeSet(elements2) {
      const parsedSet = /* @__PURE__ */ new Set();
      for (const element of elements2) {
        if (element.status === "aborted")
          return INVALID;
        if (element.status === "dirty")
          status.dirty();
        parsedSet.add(element.value);
      }
      return { status: status.value, value: parsedSet };
    }
    const elements = [...ctx.data.values()].map((item, i) => valueType._parse(new ParseInputLazyPath(ctx, item, ctx.path, i)));
    if (ctx.common.async) {
      return Promise.all(elements).then((elements2) => finalizeSet(elements2));
    } else {
      return finalizeSet(elements);
    }
  }
  min(minSize, message) {
    return new _ZodSet({
      ...this._def,
      minSize: { value: minSize, message: errorUtil.toString(message) }
    });
  }
  max(maxSize, message) {
    return new _ZodSet({
      ...this._def,
      maxSize: { value: maxSize, message: errorUtil.toString(message) }
    });
  }
  size(size2, message) {
    return this.min(size2, message).max(size2, message);
  }
  nonempty(message) {
    return this.min(1, message);
  }
};
ZodSet.create = (valueType, params) => {
  return new ZodSet({
    valueType,
    minSize: null,
    maxSize: null,
    typeName: ZodFirstPartyTypeKind.ZodSet,
    ...processCreateParams(params)
  });
};
var ZodFunction = class _ZodFunction extends ZodType {
  constructor() {
    super(...arguments);
    this.validate = this.implement;
  }
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.function) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.function,
        received: ctx.parsedType
      });
      return INVALID;
    }
    function makeArgsIssue(args, error) {
      return makeIssue({
        data: args,
        path: ctx.path,
        errorMaps: [
          ctx.common.contextualErrorMap,
          ctx.schemaErrorMap,
          getErrorMap(),
          errorMap
        ].filter((x) => !!x),
        issueData: {
          code: ZodIssueCode.invalid_arguments,
          argumentsError: error
        }
      });
    }
    function makeReturnsIssue(returns, error) {
      return makeIssue({
        data: returns,
        path: ctx.path,
        errorMaps: [
          ctx.common.contextualErrorMap,
          ctx.schemaErrorMap,
          getErrorMap(),
          errorMap
        ].filter((x) => !!x),
        issueData: {
          code: ZodIssueCode.invalid_return_type,
          returnTypeError: error
        }
      });
    }
    const params = { errorMap: ctx.common.contextualErrorMap };
    const fn = ctx.data;
    if (this._def.returns instanceof ZodPromise) {
      const me = this;
      return OK(async function (...args) {
        const error = new ZodError([]);
        const parsedArgs = await me._def.args.parseAsync(args, params).catch((e) => {
          error.addIssue(makeArgsIssue(args, e));
          throw error;
        });
        const result = await Reflect.apply(fn, this, parsedArgs);
        const parsedReturns = await me._def.returns._def.type.parseAsync(result, params).catch((e) => {
          error.addIssue(makeReturnsIssue(result, e));
          throw error;
        });
        return parsedReturns;
      });
    } else {
      const me = this;
      return OK(function (...args) {
        const parsedArgs = me._def.args.safeParse(args, params);
        if (!parsedArgs.success) {
          throw new ZodError([makeArgsIssue(args, parsedArgs.error)]);
        }
        const result = Reflect.apply(fn, this, parsedArgs.data);
        const parsedReturns = me._def.returns.safeParse(result, params);
        if (!parsedReturns.success) {
          throw new ZodError([makeReturnsIssue(result, parsedReturns.error)]);
        }
        return parsedReturns.data;
      });
    }
  }
  parameters() {
    return this._def.args;
  }
  returnType() {
    return this._def.returns;
  }
  args(...items) {
    return new _ZodFunction({
      ...this._def,
      args: ZodTuple.create(items).rest(ZodUnknown.create())
    });
  }
  returns(returnType) {
    return new _ZodFunction({
      ...this._def,
      returns: returnType
    });
  }
  implement(func) {
    const validatedFunc = this.parse(func);
    return validatedFunc;
  }
  strictImplement(func) {
    const validatedFunc = this.parse(func);
    return validatedFunc;
  }
  static create(args, returns, params) {
    return new _ZodFunction({
      args: args ? args : ZodTuple.create([]).rest(ZodUnknown.create()),
      returns: returns || ZodUnknown.create(),
      typeName: ZodFirstPartyTypeKind.ZodFunction,
      ...processCreateParams(params)
    });
  }
};
var ZodLazy = class extends ZodType {
  get schema() {
    return this._def.getter();
  }
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    const lazySchema = this._def.getter();
    return lazySchema._parse({ data: ctx.data, path: ctx.path, parent: ctx });
  }
};
ZodLazy.create = (getter, params) => {
  return new ZodLazy({
    getter,
    typeName: ZodFirstPartyTypeKind.ZodLazy,
    ...processCreateParams(params)
  });
};
var ZodLiteral = class extends ZodType {
  _parse(input) {
    if (input.data !== this._def.value) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        received: ctx.data,
        code: ZodIssueCode.invalid_literal,
        expected: this._def.value
      });
      return INVALID;
    }
    return { status: "valid", value: input.data };
  }
  get value() {
    return this._def.value;
  }
};
ZodLiteral.create = (value, params) => {
  return new ZodLiteral({
    value,
    typeName: ZodFirstPartyTypeKind.ZodLiteral,
    ...processCreateParams(params)
  });
};
function createZodEnum(values, params) {
  return new ZodEnum({
    values,
    typeName: ZodFirstPartyTypeKind.ZodEnum,
    ...processCreateParams(params)
  });
}
var ZodEnum = class _ZodEnum extends ZodType {
  constructor() {
    super(...arguments);
    _ZodEnum_cache.set(this, void 0);
  }
  _parse(input) {
    if (typeof input.data !== "string") {
      const ctx = this._getOrReturnCtx(input);
      const expectedValues = this._def.values;
      addIssueToContext(ctx, {
        expected: util.joinValues(expectedValues),
        received: ctx.parsedType,
        code: ZodIssueCode.invalid_type
      });
      return INVALID;
    }
    if (!__classPrivateFieldGet(this, _ZodEnum_cache, "f")) {
      __classPrivateFieldSet(this, _ZodEnum_cache, new Set(this._def.values), "f");
    }
    if (!__classPrivateFieldGet(this, _ZodEnum_cache, "f").has(input.data)) {
      const ctx = this._getOrReturnCtx(input);
      const expectedValues = this._def.values;
      addIssueToContext(ctx, {
        received: ctx.data,
        code: ZodIssueCode.invalid_enum_value,
        options: expectedValues
      });
      return INVALID;
    }
    return OK(input.data);
  }
  get options() {
    return this._def.values;
  }
  get enum() {
    const enumValues = {};
    for (const val of this._def.values) {
      enumValues[val] = val;
    }
    return enumValues;
  }
  get Values() {
    const enumValues = {};
    for (const val of this._def.values) {
      enumValues[val] = val;
    }
    return enumValues;
  }
  get Enum() {
    const enumValues = {};
    for (const val of this._def.values) {
      enumValues[val] = val;
    }
    return enumValues;
  }
  extract(values, newDef = this._def) {
    return _ZodEnum.create(values, {
      ...this._def,
      ...newDef
    });
  }
  exclude(values, newDef = this._def) {
    return _ZodEnum.create(this.options.filter((opt) => !values.includes(opt)), {
      ...this._def,
      ...newDef
    });
  }
};
_ZodEnum_cache = /* @__PURE__ */ new WeakMap();
ZodEnum.create = createZodEnum;
var ZodNativeEnum = class extends ZodType {
  constructor() {
    super(...arguments);
    _ZodNativeEnum_cache.set(this, void 0);
  }
  _parse(input) {
    const nativeEnumValues = util.getValidEnumValues(this._def.values);
    const ctx = this._getOrReturnCtx(input);
    if (ctx.parsedType !== ZodParsedType.string && ctx.parsedType !== ZodParsedType.number) {
      const expectedValues = util.objectValues(nativeEnumValues);
      addIssueToContext(ctx, {
        expected: util.joinValues(expectedValues),
        received: ctx.parsedType,
        code: ZodIssueCode.invalid_type
      });
      return INVALID;
    }
    if (!__classPrivateFieldGet(this, _ZodNativeEnum_cache, "f")) {
      __classPrivateFieldSet(this, _ZodNativeEnum_cache, new Set(util.getValidEnumValues(this._def.values)), "f");
    }
    if (!__classPrivateFieldGet(this, _ZodNativeEnum_cache, "f").has(input.data)) {
      const expectedValues = util.objectValues(nativeEnumValues);
      addIssueToContext(ctx, {
        received: ctx.data,
        code: ZodIssueCode.invalid_enum_value,
        options: expectedValues
      });
      return INVALID;
    }
    return OK(input.data);
  }
  get enum() {
    return this._def.values;
  }
};
_ZodNativeEnum_cache = /* @__PURE__ */ new WeakMap();
ZodNativeEnum.create = (values, params) => {
  return new ZodNativeEnum({
    values,
    typeName: ZodFirstPartyTypeKind.ZodNativeEnum,
    ...processCreateParams(params)
  });
};
var ZodPromise = class extends ZodType {
  unwrap() {
    return this._def.type;
  }
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    if (ctx.parsedType !== ZodParsedType.promise && ctx.common.async === false) {
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.promise,
        received: ctx.parsedType
      });
      return INVALID;
    }
    const promisified = ctx.parsedType === ZodParsedType.promise ? ctx.data : Promise.resolve(ctx.data);
    return OK(promisified.then((data) => {
      return this._def.type.parseAsync(data, {
        path: ctx.path,
        errorMap: ctx.common.contextualErrorMap
      });
    }));
  }
};
ZodPromise.create = (schema2, params) => {
  return new ZodPromise({
    type: schema2,
    typeName: ZodFirstPartyTypeKind.ZodPromise,
    ...processCreateParams(params)
  });
};
var ZodEffects = class extends ZodType {
  innerType() {
    return this._def.schema;
  }
  sourceType() {
    return this._def.schema._def.typeName === ZodFirstPartyTypeKind.ZodEffects ? this._def.schema.sourceType() : this._def.schema;
  }
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    const effect = this._def.effect || null;
    const checkCtx = {
      addIssue: (arg) => {
        addIssueToContext(ctx, arg);
        if (arg.fatal) {
          status.abort();
        } else {
          status.dirty();
        }
      },
      get path() {
        return ctx.path;
      }
    };
    checkCtx.addIssue = checkCtx.addIssue.bind(checkCtx);
    if (effect.type === "preprocess") {
      const processed = effect.transform(ctx.data, checkCtx);
      if (ctx.common.async) {
        return Promise.resolve(processed).then(async (processed2) => {
          if (status.value === "aborted")
            return INVALID;
          const result = await this._def.schema._parseAsync({
            data: processed2,
            path: ctx.path,
            parent: ctx
          });
          if (result.status === "aborted")
            return INVALID;
          if (result.status === "dirty")
            return DIRTY(result.value);
          if (status.value === "dirty")
            return DIRTY(result.value);
          return result;
        });
      } else {
        if (status.value === "aborted")
          return INVALID;
        const result = this._def.schema._parseSync({
          data: processed,
          path: ctx.path,
          parent: ctx
        });
        if (result.status === "aborted")
          return INVALID;
        if (result.status === "dirty")
          return DIRTY(result.value);
        if (status.value === "dirty")
          return DIRTY(result.value);
        return result;
      }
    }
    if (effect.type === "refinement") {
      const executeRefinement = (acc) => {
        const result = effect.refinement(acc, checkCtx);
        if (ctx.common.async) {
          return Promise.resolve(result);
        }
        if (result instanceof Promise) {
          throw new Error("Async refinement encountered during synchronous parse operation. Use .parseAsync instead.");
        }
        return acc;
      };
      if (ctx.common.async === false) {
        const inner = this._def.schema._parseSync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx
        });
        if (inner.status === "aborted")
          return INVALID;
        if (inner.status === "dirty")
          status.dirty();
        executeRefinement(inner.value);
        return { status: status.value, value: inner.value };
      } else {
        return this._def.schema._parseAsync({ data: ctx.data, path: ctx.path, parent: ctx }).then((inner) => {
          if (inner.status === "aborted")
            return INVALID;
          if (inner.status === "dirty")
            status.dirty();
          return executeRefinement(inner.value).then(() => {
            return { status: status.value, value: inner.value };
          });
        });
      }
    }
    if (effect.type === "transform") {
      if (ctx.common.async === false) {
        const base = this._def.schema._parseSync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx
        });
        if (!isValid(base))
          return base;
        const result = effect.transform(base.value, checkCtx);
        if (result instanceof Promise) {
          throw new Error(`Asynchronous transform encountered during synchronous parse operation. Use .parseAsync instead.`);
        }
        return { status: status.value, value: result };
      } else {
        return this._def.schema._parseAsync({ data: ctx.data, path: ctx.path, parent: ctx }).then((base) => {
          if (!isValid(base))
            return base;
          return Promise.resolve(effect.transform(base.value, checkCtx)).then((result) => ({ status: status.value, value: result }));
        });
      }
    }
    util.assertNever(effect);
  }
};
ZodEffects.create = (schema2, effect, params) => {
  return new ZodEffects({
    schema: schema2,
    typeName: ZodFirstPartyTypeKind.ZodEffects,
    effect,
    ...processCreateParams(params)
  });
};
ZodEffects.createWithPreprocess = (preprocess, schema2, params) => {
  return new ZodEffects({
    schema: schema2,
    effect: { type: "preprocess", transform: preprocess },
    typeName: ZodFirstPartyTypeKind.ZodEffects,
    ...processCreateParams(params)
  });
};
var ZodOptional = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType === ZodParsedType.undefined) {
      return OK(void 0);
    }
    return this._def.innerType._parse(input);
  }
  unwrap() {
    return this._def.innerType;
  }
};
ZodOptional.create = (type2, params) => {
  return new ZodOptional({
    innerType: type2,
    typeName: ZodFirstPartyTypeKind.ZodOptional,
    ...processCreateParams(params)
  });
};
var ZodNullable = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType === ZodParsedType.null) {
      return OK(null);
    }
    return this._def.innerType._parse(input);
  }
  unwrap() {
    return this._def.innerType;
  }
};
ZodNullable.create = (type2, params) => {
  return new ZodNullable({
    innerType: type2,
    typeName: ZodFirstPartyTypeKind.ZodNullable,
    ...processCreateParams(params)
  });
};
var ZodDefault = class extends ZodType {
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    let data = ctx.data;
    if (ctx.parsedType === ZodParsedType.undefined) {
      data = this._def.defaultValue();
    }
    return this._def.innerType._parse({
      data,
      path: ctx.path,
      parent: ctx
    });
  }
  removeDefault() {
    return this._def.innerType;
  }
};
ZodDefault.create = (type2, params) => {
  return new ZodDefault({
    innerType: type2,
    typeName: ZodFirstPartyTypeKind.ZodDefault,
    defaultValue: typeof params.default === "function" ? params.default : () => params.default,
    ...processCreateParams(params)
  });
};
var ZodCatch = class extends ZodType {
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    const newCtx = {
      ...ctx,
      common: {
        ...ctx.common,
        issues: []
      }
    };
    const result = this._def.innerType._parse({
      data: newCtx.data,
      path: newCtx.path,
      parent: {
        ...newCtx
      }
    });
    if (isAsync(result)) {
      return result.then((result2) => {
        return {
          status: "valid",
          value: result2.status === "valid" ? result2.value : this._def.catchValue({
            get error() {
              return new ZodError(newCtx.common.issues);
            },
            input: newCtx.data
          })
        };
      });
    } else {
      return {
        status: "valid",
        value: result.status === "valid" ? result.value : this._def.catchValue({
          get error() {
            return new ZodError(newCtx.common.issues);
          },
          input: newCtx.data
        })
      };
    }
  }
  removeCatch() {
    return this._def.innerType;
  }
};
ZodCatch.create = (type2, params) => {
  return new ZodCatch({
    innerType: type2,
    typeName: ZodFirstPartyTypeKind.ZodCatch,
    catchValue: typeof params.catch === "function" ? params.catch : () => params.catch,
    ...processCreateParams(params)
  });
};
var ZodNaN = class extends ZodType {
  _parse(input) {
    const parsedType = this._getType(input);
    if (parsedType !== ZodParsedType.nan) {
      const ctx = this._getOrReturnCtx(input);
      addIssueToContext(ctx, {
        code: ZodIssueCode.invalid_type,
        expected: ZodParsedType.nan,
        received: ctx.parsedType
      });
      return INVALID;
    }
    return { status: "valid", value: input.data };
  }
};
ZodNaN.create = (params) => {
  return new ZodNaN({
    typeName: ZodFirstPartyTypeKind.ZodNaN,
    ...processCreateParams(params)
  });
};
var BRAND = Symbol("zod_brand");
var ZodBranded = class extends ZodType {
  _parse(input) {
    const { ctx } = this._processInputParams(input);
    const data = ctx.data;
    return this._def.type._parse({
      data,
      path: ctx.path,
      parent: ctx
    });
  }
  unwrap() {
    return this._def.type;
  }
};
var ZodPipeline = class _ZodPipeline extends ZodType {
  _parse(input) {
    const { status, ctx } = this._processInputParams(input);
    if (ctx.common.async) {
      const handleAsync = async () => {
        const inResult = await this._def.in._parseAsync({
          data: ctx.data,
          path: ctx.path,
          parent: ctx
        });
        if (inResult.status === "aborted")
          return INVALID;
        if (inResult.status === "dirty") {
          status.dirty();
          return DIRTY(inResult.value);
        } else {
          return this._def.out._parseAsync({
            data: inResult.value,
            path: ctx.path,
            parent: ctx
          });
        }
      };
      return handleAsync();
    } else {
      const inResult = this._def.in._parseSync({
        data: ctx.data,
        path: ctx.path,
        parent: ctx
      });
      if (inResult.status === "aborted")
        return INVALID;
      if (inResult.status === "dirty") {
        status.dirty();
        return {
          status: "dirty",
          value: inResult.value
        };
      } else {
        return this._def.out._parseSync({
          data: inResult.value,
          path: ctx.path,
          parent: ctx
        });
      }
    }
  }
  static create(a, b) {
    return new _ZodPipeline({
      in: a,
      out: b,
      typeName: ZodFirstPartyTypeKind.ZodPipeline
    });
  }
};
var ZodReadonly = class extends ZodType {
  _parse(input) {
    const result = this._def.innerType._parse(input);
    const freeze = (data) => {
      if (isValid(data)) {
        data.value = Object.freeze(data.value);
      }
      return data;
    };
    return isAsync(result) ? result.then((data) => freeze(data)) : freeze(result);
  }
  unwrap() {
    return this._def.innerType;
  }
};
ZodReadonly.create = (type2, params) => {
  return new ZodReadonly({
    innerType: type2,
    typeName: ZodFirstPartyTypeKind.ZodReadonly,
    ...processCreateParams(params)
  });
};
function custom(check, params = {}, fatal) {
  if (check)
    return ZodAny.create().superRefine((data, ctx) => {
      var _a, _b;
      if (!check(data)) {
        const p = typeof params === "function" ? params(data) : typeof params === "string" ? { message: params } : params;
        const _fatal = (_b = (_a = p.fatal) !== null && _a !== void 0 ? _a : fatal) !== null && _b !== void 0 ? _b : true;
        const p2 = typeof p === "string" ? { message: p } : p;
        ctx.addIssue({ code: "custom", ...p2, fatal: _fatal });
      }
    });
  return ZodAny.create();
}
var late = {
  object: ZodObject.lazycreate
};
var ZodFirstPartyTypeKind;
(function (ZodFirstPartyTypeKind2) {
  ZodFirstPartyTypeKind2["ZodString"] = "ZodString";
  ZodFirstPartyTypeKind2["ZodNumber"] = "ZodNumber";
  ZodFirstPartyTypeKind2["ZodNaN"] = "ZodNaN";
  ZodFirstPartyTypeKind2["ZodBigInt"] = "ZodBigInt";
  ZodFirstPartyTypeKind2["ZodBoolean"] = "ZodBoolean";
  ZodFirstPartyTypeKind2["ZodDate"] = "ZodDate";
  ZodFirstPartyTypeKind2["ZodSymbol"] = "ZodSymbol";
  ZodFirstPartyTypeKind2["ZodUndefined"] = "ZodUndefined";
  ZodFirstPartyTypeKind2["ZodNull"] = "ZodNull";
  ZodFirstPartyTypeKind2["ZodAny"] = "ZodAny";
  ZodFirstPartyTypeKind2["ZodUnknown"] = "ZodUnknown";
  ZodFirstPartyTypeKind2["ZodNever"] = "ZodNever";
  ZodFirstPartyTypeKind2["ZodVoid"] = "ZodVoid";
  ZodFirstPartyTypeKind2["ZodArray"] = "ZodArray";
  ZodFirstPartyTypeKind2["ZodObject"] = "ZodObject";
  ZodFirstPartyTypeKind2["ZodUnion"] = "ZodUnion";
  ZodFirstPartyTypeKind2["ZodDiscriminatedUnion"] = "ZodDiscriminatedUnion";
  ZodFirstPartyTypeKind2["ZodIntersection"] = "ZodIntersection";
  ZodFirstPartyTypeKind2["ZodTuple"] = "ZodTuple";
  ZodFirstPartyTypeKind2["ZodRecord"] = "ZodRecord";
  ZodFirstPartyTypeKind2["ZodMap"] = "ZodMap";
  ZodFirstPartyTypeKind2["ZodSet"] = "ZodSet";
  ZodFirstPartyTypeKind2["ZodFunction"] = "ZodFunction";
  ZodFirstPartyTypeKind2["ZodLazy"] = "ZodLazy";
  ZodFirstPartyTypeKind2["ZodLiteral"] = "ZodLiteral";
  ZodFirstPartyTypeKind2["ZodEnum"] = "ZodEnum";
  ZodFirstPartyTypeKind2["ZodEffects"] = "ZodEffects";
  ZodFirstPartyTypeKind2["ZodNativeEnum"] = "ZodNativeEnum";
  ZodFirstPartyTypeKind2["ZodOptional"] = "ZodOptional";
  ZodFirstPartyTypeKind2["ZodNullable"] = "ZodNullable";
  ZodFirstPartyTypeKind2["ZodDefault"] = "ZodDefault";
  ZodFirstPartyTypeKind2["ZodCatch"] = "ZodCatch";
  ZodFirstPartyTypeKind2["ZodPromise"] = "ZodPromise";
  ZodFirstPartyTypeKind2["ZodBranded"] = "ZodBranded";
  ZodFirstPartyTypeKind2["ZodPipeline"] = "ZodPipeline";
  ZodFirstPartyTypeKind2["ZodReadonly"] = "ZodReadonly";
})(ZodFirstPartyTypeKind || (ZodFirstPartyTypeKind = {}));
var instanceOfType = (cls, params = {
  message: `Input not instance of ${cls.name}`
}) => custom((data) => data instanceof cls, params);
var stringType = ZodString.create;
var numberType = ZodNumber.create;
var nanType = ZodNaN.create;
var bigIntType = ZodBigInt.create;
var booleanType = ZodBoolean.create;
var dateType = ZodDate.create;
var symbolType = ZodSymbol.create;
var undefinedType = ZodUndefined.create;
var nullType = ZodNull.create;
var anyType = ZodAny.create;
var unknownType = ZodUnknown.create;
var neverType = ZodNever.create;
var voidType = ZodVoid.create;
var arrayType = ZodArray.create;
var objectType = ZodObject.create;
var strictObjectType = ZodObject.strictCreate;
var unionType = ZodUnion.create;
var discriminatedUnionType = ZodDiscriminatedUnion.create;
var intersectionType = ZodIntersection.create;
var tupleType = ZodTuple.create;
var recordType = ZodRecord.create;
var mapType = ZodMap.create;
var setType = ZodSet.create;
var functionType = ZodFunction.create;
var lazyType = ZodLazy.create;
var literalType = ZodLiteral.create;
var enumType = ZodEnum.create;
var nativeEnumType = ZodNativeEnum.create;
var promiseType = ZodPromise.create;
var effectsType = ZodEffects.create;
var optionalType = ZodOptional.create;
var nullableType = ZodNullable.create;
var preprocessType = ZodEffects.createWithPreprocess;
var pipelineType = ZodPipeline.create;
var ostring = () => stringType().optional();
var onumber = () => numberType().optional();
var oboolean = () => booleanType().optional();
var coerce = {
  string: (arg) => ZodString.create({ ...arg, coerce: true }),
  number: (arg) => ZodNumber.create({ ...arg, coerce: true }),
  boolean: (arg) => ZodBoolean.create({
    ...arg,
    coerce: true
  }),
  bigint: (arg) => ZodBigInt.create({ ...arg, coerce: true }),
  date: (arg) => ZodDate.create({ ...arg, coerce: true })
};
var NEVER = INVALID;
var z = /* @__PURE__ */ Object.freeze({
  __proto__: null,
  defaultErrorMap: errorMap,
  setErrorMap,
  getErrorMap,
  makeIssue,
  EMPTY_PATH,
  addIssueToContext,
  ParseStatus,
  INVALID,
  DIRTY,
  OK,
  isAborted,
  isDirty,
  isValid,
  isAsync,
  get util() {
    return util;
  },
  get objectUtil() {
    return objectUtil;
  },
  ZodParsedType,
  getParsedType,
  ZodType,
  datetimeRegex,
  ZodString,
  ZodNumber,
  ZodBigInt,
  ZodBoolean,
  ZodDate,
  ZodSymbol,
  ZodUndefined,
  ZodNull,
  ZodAny,
  ZodUnknown,
  ZodNever,
  ZodVoid,
  ZodArray,
  ZodObject,
  ZodUnion,
  ZodDiscriminatedUnion,
  ZodIntersection,
  ZodTuple,
  ZodRecord,
  ZodMap,
  ZodSet,
  ZodFunction,
  ZodLazy,
  ZodLiteral,
  ZodEnum,
  ZodNativeEnum,
  ZodPromise,
  ZodEffects,
  ZodTransformer: ZodEffects,
  ZodOptional,
  ZodNullable,
  ZodDefault,
  ZodCatch,
  ZodNaN,
  BRAND,
  ZodBranded,
  ZodPipeline,
  ZodReadonly,
  custom,
  Schema: ZodType,
  ZodSchema: ZodType,
  late,
  get ZodFirstPartyTypeKind() {
    return ZodFirstPartyTypeKind;
  },
  coerce,
  any: anyType,
  array: arrayType,
  bigint: bigIntType,
  boolean: booleanType,
  date: dateType,
  discriminatedUnion: discriminatedUnionType,
  effect: effectsType,
  "enum": enumType,
  "function": functionType,
  "instanceof": instanceOfType,
  intersection: intersectionType,
  lazy: lazyType,
  literal: literalType,
  map: mapType,
  nan: nanType,
  nativeEnum: nativeEnumType,
  never: neverType,
  "null": nullType,
  nullable: nullableType,
  number: numberType,
  object: objectType,
  oboolean,
  onumber,
  optional: optionalType,
  ostring,
  pipeline: pipelineType,
  preprocess: preprocessType,
  promise: promiseType,
  record: recordType,
  set: setType,
  strictObject: strictObjectType,
  string: stringType,
  symbol: symbolType,
  transformer: effectsType,
  tuple: tupleType,
  "undefined": undefinedType,
  union: unionType,
  unknown: unknownType,
  "void": voidType,
  NEVER,
  ZodIssueCode,
  quotelessJson,
  ZodError
});

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/schemas/RedoclyCodeSampleSchema.js
var RedoclyCodeSampleSchema = z.object({
  lang: z.string(),
  label: z.optional(z.string()),
  source: z.string()
});
var RedoclyCodeSampleArraySchema = z.array(RedoclyCodeSampleSchema);

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/readmeExtensions.js
var ReadmeOpenAPIExtension = {
  /**
   * Migrate from readme extensions to fern IR.
   *
   * https://docs.readme.com/main/docs/openapi-extensions
   */
  README_EXT: "x-readme"
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getReadmeCodeSamples.js
function isReadMeCodeSamples(maybeCodeSamples) {
  if (!Array.isArray(maybeCodeSamples)) {
    return false;
  }
  for (const maybeCodeSample of maybeCodeSamples) {
    if (!isPlainObject2(maybeCodeSample)) {
      return false;
    }
    if (typeof maybeCodeSample.language !== "string" || typeof maybeCodeSample.code !== "string") {
      return false;
    }
  }
  return true;
}
function getRawReadmeCodeSamples(operationObject) {
  const readme = getExtension(operationObject, ReadmeOpenAPIExtension.README_EXT);
  if (!isPlainObject2(readme)) {
    return [];
  }
  const readmeCodeSamples = readme["code-samples"];
  if (!isReadMeCodeSamples(readmeCodeSamples)) {
    return [];
  }
  const customCodeSamples = [];
  for (const codeSample of readmeCodeSamples) {
    customCodeSamples.push({
      name: codeSample.name,
      language: codeSample.language,
      code: codeSample.code,
      install: codeSample.install,
      docs: void 0
    });
  }
  return customCodeSamples;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getExamplesFromExtension.js
function getExamplesFromExtension(operationContext, operationObject, context) {
  const exampleEndpointCalls = getExtension(
    operationObject,
    FernOpenAPIExtension.EXAMPLES
    // RawSchemas.ExampleEndpointCallArraySchema,
    // context.logger,
    // [...operationContext.baseBreadcrumbs, `${operationContext.method} ${operationContext.path}`]
  ) ?? [];
  const validatedExampleEndpointCalls = exampleEndpointCalls.filter((example) => {
    const maybeFernExample = schemas_exports3.serialization.ExampleEndpointCallSchema.parse(example);
    if (!maybeFernExample.ok) {
      context.logger.error(`Failed to parse x-fern-example in ${operationContext.path}/${operationContext.method}`);
    }
    return maybeFernExample.ok;
  });
  const redoclyCodeSamplesKebabCase = getExtensionAndValidate(operationObject, OpenAPIExtension.REDOCLY_CODE_SAMPLES_KEBAB, RedoclyCodeSampleArraySchema, context.logger, [...operationContext.baseBreadcrumbs, `${operationContext.method} ${operationContext.path}`]) ?? [];
  const redoclyCodeSamplesCamelCase = getExtensionAndValidate(operationObject, OpenAPIExtension.REDOCLY_CODE_SAMPLES_CAMEL, RedoclyCodeSampleArraySchema, context.logger, [...operationContext.baseBreadcrumbs, `${operationContext.method} ${operationContext.path}`]) ?? [];
  const redoclyCodeSamples = [
    ...redoclyCodeSamplesCamelCase,
    ...redoclyCodeSamplesKebabCase
  ];
  if (redoclyCodeSamples.length > 0) {
    validatedExampleEndpointCalls.push({
      "code-samples": redoclyCodeSamples.map((value) => ({
        name: value.label ?? value.lang,
        language: value.lang,
        code: value.source,
        install: void 0,
        docs: void 0
      }))
    });
  }
  const readmeCodeSamples = getRawReadmeCodeSamples(operationObject);
  if (readmeCodeSamples.length > 0) {
    validatedExampleEndpointCalls.push({
      "code-samples": readmeCodeSamples
    });
  }
  return validatedExampleEndpointCalls.map(EndpointExample.unknown);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernAvailability.js
function getFernAvailability(operationObject) {
  const availability = getExtension(operationObject, FernOpenAPIExtension.AVAILABILITY);
  if (availability === "ga" || availability === "generally-available") {
    return Availability.GenerallyAvailable;
  } else if (availability === "beta" || availability === "pre-release") {
    return Availability.Beta;
  } else if (availability === "deprecated") {
    return Availability.Deprecated;
  }
  if (operationObject.deprecated) {
    return Availability.Deprecated;
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/convertServer.js
function convertServer(server) {
  return {
    url: getServerUrl({ url: server.url, variables: server.variables ?? {} }),
    description: server.description,
    name: getServerName(server),
    audiences: getExtension(server, FernOpenAPIExtension.AUDIENCES)
  };
}
function getServerUrl({ url, variables }) {
  const valuesToSubstitute = Object.fromEntries(Object.entries(variables).map(([name, declaration]) => {
    return [name, declaration.default];
  }));
  for (const [variable, value] of Object.entries(valuesToSubstitute)) {
    url = url.replace(`{${variable}}`, value);
  }
  return url;
}
function getServerName(server) {
  const name = getExtension(server, [
    FernOpenAPIExtension.SERVER_NAME_V1,
    FernOpenAPIExtension.SERVER_NAME_V2
  ]);
  if (name != null) {
    return name;
  }
  if (server.description?.toLowerCase() === "production") {
    return "Production";
  }
  if (server.description?.toLowerCase() === "sandbox") {
    return "Sandbox";
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getParameterName.js
function getParameterName(parameter) {
  return getExtension(parameter, FernOpenAPIExtension.PARAMETER_NAME);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getVariableReference.js
function getVariableReference(parameter) {
  return getExtension(parameter, FernOpenAPIExtension.SDK_VARIABLE);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/endpoint/convertParameters.js
function convertParameters({ path: path5, httpMethod, parameters, context, requestBreadcrumbs, source }) {
  const convertedParameters = {
    pathParameters: [],
    queryParameters: [],
    headers: []
  };
  for (const parameter of parameters) {
    const shouldIgnore = getExtension(parameter, FernOpenAPIExtension.IGNORE);
    if (shouldIgnore != null && shouldIgnore) {
      context.logger.debug(`${httpMethod.toUpperCase()} ${path5} has a parameter marked with x-fern-ignore. Skipping.`);
      continue;
    }
    const resolvedParameter = isReferenceObject(parameter) ? context.resolveParameterReference(parameter) : parameter;
    const isRequired = resolvedParameter.required ?? false;
    const availability = convertAvailability3(resolvedParameter);
    const parameterBreadcrumbs = [...requestBreadcrumbs, resolvedParameter.name];
    const generatedName = getGeneratedTypeName(parameterBreadcrumbs, context.options.preserveSchemaIds);
    let schema2 = resolvedParameter.schema != null ? convertSchema(resolvedParameter.schema, !isRequired, context, parameterBreadcrumbs, source, context.namespace, false, /* @__PURE__ */ new Set(), getExamplesString({
      schema: resolvedParameter,
      logger: context.logger
    })) : isRequired ? SchemaWithExample.primitive({
      nameOverride: void 0,
      generatedName,
      title: void 0,
      schema: PrimitiveSchemaValueWithExample.string({
        default: void 0,
        pattern: void 0,
        format: void 0,
        minLength: void 0,
        maxLength: void 0,
        example: getExamplesString({
          schema: resolvedParameter,
          logger: context.logger
        })
      }),
      description: void 0,
      availability,
      groupName: void 0
    }) : SchemaWithExample.optional({
      nameOverride: void 0,
      generatedName,
      title: void 0,
      value: SchemaWithExample.primitive({
        nameOverride: void 0,
        generatedName,
        title: void 0,
        schema: PrimitiveSchemaValueWithExample.string({
          default: void 0,
          pattern: void 0,
          format: void 0,
          minLength: void 0,
          maxLength: void 0,
          example: getExamplesString({
            schema: resolvedParameter,
            logger: context.logger
          })
        }),
        description: void 0,
        availability: void 0,
        groupName: void 0
      }),
      description: void 0,
      availability,
      groupName: void 0
    });
    if (resolvedParameter.in === "header" && resolvedParameter.schema != null && !isReferenceObject(resolvedParameter.schema) && // eslint-disable-next-line @typescript-eslint/no-explicit-any
      resolvedParameter.schema.default != null) {
      const defaultValue = resolvedParameter.schema.default;
      if (typeof defaultValue === "string" && defaultValue.length > 0) {
        schema2 = SchemaWithExample.literal({
          nameOverride: void 0,
          generatedName,
          title: void 0,
          value: LiteralSchemaValue.string(defaultValue),
          description: void 0,
          availability,
          groupName: void 0
        });
      }
    }
    const convertedParameter = {
      name: resolvedParameter.name,
      schema: schema2,
      description: resolvedParameter.description,
      parameterNameOverride: getParameterName(resolvedParameter),
      availability,
      source
    };
    if (resolvedParameter.in === "query") {
      convertedParameters.queryParameters.push(convertedParameter);
    } else if (resolvedParameter.in === "path") {
      convertedParameters.pathParameters.push({
        ...convertedParameter,
        variableReference: getVariableReference(resolvedParameter)
      });
    } else if (resolvedParameter.in === "header") {
      if (!HEADERS_TO_SKIP.has(resolvedParameter.name.toLowerCase()) && !context.authHeaders.has(resolvedParameter.name)) {
        convertedParameters.headers.push({ ...convertedParameter, env: void 0 });
      } else {
        context.logger.debug(`Ignoring ${resolvedParameter.name} header, in ${httpMethod.toUpperCase()} ${path5}`);
      }
    } else {
      context.logger.warn(`Skipping ${resolvedParameter.in} parameter, ${resolvedParameter.name}, in ${httpMethod.toUpperCase()} ${path5}`);
    }
  }
  return convertedParameters;
}
var HEADERS_TO_SKIP = /* @__PURE__ */ new Set([
  "user-agent",
  "content-length",
  "content-type",
  "x-forwarded-for",
  "cookie",
  "origin",
  "content-disposition",
  "x-ping-custom-domain"
]);

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/endpoint/getApplicationJsonSchema.js
function getTextEventStreamObject(media, context) {
  for (const contentType of Object.keys(media)) {
    if (contentType.includes("text/event-stream")) {
      const mediaObject = media[contentType];
      if (mediaObject == null) {
        continue;
      }
      const schema2 = mediaObject.schema;
      return {
        contentType,
        schema: schema2 ?? {},
        examples: getExamples2(mediaObject, context)
      };
    }
  }
  return void 0;
}
function getApplicationJsonSchemaMediaObject(media, context) {
  for (const contentType of Object.keys(media)) {
    if (contentType.includes("json") || contentType === "*/*") {
      const mediaObject = media[contentType];
      if (mediaObject == null) {
        continue;
      }
      const schema2 = mediaObject.schema;
      return {
        contentType: !contentType.includes("*") ? contentType : void 0,
        schema: schema2 ?? {},
        examples: getExamples2(mediaObject, context)
      };
    }
  }
  return void 0;
}
function getSchemaMediaObject(media, context) {
  for (const contentType of Object.keys(media)) {
    const mediaObject = media[contentType];
    if (mediaObject == null) {
      continue;
    }
    const schema2 = mediaObject.schema;
    return {
      schema: schema2 ?? {},
      examples: getExamples2(mediaObject, context)
    };
  }
  return void 0;
}
function getExamples2(mediaObject, context) {
  const fullExamples = [];
  if (mediaObject.example != null) {
    fullExamples.push({ name: void 0, value: mediaObject.example, description: void 0 });
  }
  const examples = getExtension(mediaObject, OpenAPIExtension.EXAMPLES);
  if (examples != null && Object.keys(examples).length > 0) {
    fullExamples.push(...Object.entries(examples).map(([name, value]) => {
      return { name: value.summary ?? name, value: value.value, description: value.description };
    }));
  }
  if (mediaObject.examples != null && Object.keys(mediaObject.examples).length > 0) {
    fullExamples.push(...Object.entries(mediaObject.examples).map(([name, example]) => {
      const resolvedExample = isReferenceObject(example) ? context.resolveExampleReference(example) : example;
      return {
        name: resolvedExample.summary ?? name,
        value: resolvedExample.value,
        description: resolvedExample.description
      };
    }));
  }
  return fullExamples;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/endpoint/convertRequest.js
function getApplicationUrlFormEncodedRequest(requestBody, context) {
  for (const [mediaType, mediaTypeObject] of Object.entries(requestBody.content)) {
    if (MediaType.parse(mediaType)?.isURLEncoded()) {
      return {
        schema: mediaTypeObject.schema,
        contentType: mediaType,
        examples: getExamples2(mediaTypeObject, context)
      };
    }
  }
  return void 0;
}
function getMultipartFormDataRequest(requestBody) {
  for (const [mediaType, mediaTypeObject] of Object.entries(requestBody.content)) {
    if (MediaType.parse(mediaType)?.isMultipart()) {
      return { schema: mediaTypeObject.schema, encoding: mediaTypeObject.encoding };
    }
  }
  return void 0;
}
function isOctetStreamRequest(requestBody) {
  for (const mediaType in requestBody.content) {
    if (MediaType.parse(mediaType)?.isOctetStream()) {
      return true;
    }
  }
  return false;
}
function multipartRequestHasFile(multipartSchema, document) {
  const resolvedMultipartSchema = isReferenceObject(multipartSchema) ? resolveSchema(multipartSchema, document) : {
    id: void 0,
    schema: multipartSchema
  };
  return Object.entries(resolvedMultipartSchema.schema.properties ?? {}).find(([_, definition]) => {
    return !isReferenceObject(definition) && definition.type === "string" && definition.format === "binary";
  }) != null;
}
function convertRequest({ requestBody, document, context, requestBreadcrumbs, source, namespace }) {
  const resolvedRequestBody = isReferenceObject(requestBody) ? context.resolveRequestBodyReference(requestBody) : requestBody;
  const multipartFormData = getMultipartFormDataRequest(resolvedRequestBody);
  const multipartSchema = multipartFormData?.schema;
  const multipartEncoding = multipartFormData?.encoding;
  const urlEncodedRequest = getApplicationUrlFormEncodedRequest(resolvedRequestBody, context);
  const jsonMediaObject = getApplicationJsonSchemaMediaObject(resolvedRequestBody.content, context);
  if (urlEncodedRequest != null && urlEncodedRequest.schema != null) {
    const convertedUrlEncodedSchema = convertSchema(urlEncodedRequest.schema, false, context, requestBreadcrumbs, source, namespace);
    return RequestWithExample.json({
      schema: convertedUrlEncodedSchema,
      description: resolvedRequestBody.description,
      contentType: urlEncodedRequest.contentType,
      source,
      fullExamples: urlEncodedRequest.examples,
      additionalProperties: false
    });
  }
  if (isOctetStreamRequest(resolvedRequestBody)) {
    return RequestWithExample.octetStream({
      description: resolvedRequestBody.description,
      source
    });
  }
  if (multipartSchema != null && jsonMediaObject == null || multipartSchema != null && multipartRequestHasFile(multipartSchema, document)) {
    const resolvedMultipartSchema = isReferenceObject(multipartSchema) ? resolveSchema(multipartSchema, document) : {
      id: void 0,
      schema: multipartSchema
    };
    const convertedMultipartSchema = convertSchema(resolvedMultipartSchema.schema, false, context, requestBreadcrumbs, source, namespace);
    const properties = [];
    if (convertedMultipartSchema.type === "object") {
      for (const property4 of convertedMultipartSchema.properties) {
        if (property4.schema.type === "primitive" && property4.schema.schema.type === "string" && property4.schema.schema.format === "binary") {
          properties.push({
            key: property4.key,
            schema: MultipartSchema.file({ isOptional: false, isArray: false }),
            description: property4.schema.description,
            contentType: multipartEncoding != null ? multipartEncoding[property4.key]?.contentType : void 0
          });
          continue;
        }
        if (property4.schema.type === "optional" && property4.schema.value.type === "primitive" && property4.schema.value.schema.type === "string" && property4.schema.value.schema.format === "binary") {
          properties.push({
            key: property4.key,
            schema: MultipartSchema.file({ isOptional: true, isArray: false }),
            description: property4.schema.description,
            contentType: multipartEncoding != null ? multipartEncoding[property4.key]?.contentType : void 0
          });
          continue;
        }
        if (property4.schema.type === "array" && property4.schema.value.type === "primitive" && property4.schema.value.schema.type === "string" && property4.schema.value.schema.format === "binary") {
          properties.push({
            key: property4.key,
            schema: MultipartSchema.file({ isOptional: false, isArray: true }),
            description: property4.schema.description,
            contentType: multipartEncoding != null ? multipartEncoding[property4.key]?.contentType : void 0
          });
          continue;
        }
        if (property4.schema.type === "optional" && property4.schema.value.type === "array" && property4.schema.value.value.type === "primitive" && property4.schema.value.value.schema.type === "string" && property4.schema.value.value.schema.format === "binary") {
          properties.push({
            key: property4.key,
            schema: MultipartSchema.file({ isOptional: true, isArray: true }),
            description: property4.schema.description,
            contentType: multipartEncoding != null ? multipartEncoding[property4.key]?.contentType : void 0
          });
          continue;
        }
        properties.push({
          key: property4.key,
          schema: MultipartSchema.json(property4.schema),
          description: void 0,
          contentType: multipartEncoding != null ? multipartEncoding[property4.key]?.contentType : void 0
        });
      }
    }
    return RequestWithExample.multipart({
      name: isReferenceObject(multipartSchema) && context.getNumberOfOccurrencesForRef(multipartSchema) === 1 ? resolvedMultipartSchema.id : void 0,
      description: resolvedMultipartSchema.schema.description,
      properties,
      source
    });
  }
  if (jsonMediaObject == null) {
    return void 0;
  }
  const requestSchema = convertSchema(jsonMediaObject.schema, false, context, requestBreadcrumbs, source, namespace, true);
  return RequestWithExample.json({
    description: void 0,
    schema: requestSchema,
    contentType: jsonMediaObject.contentType,
    fullExamples: jsonMediaObject.examples,
    additionalProperties: !isReferenceObject(jsonMediaObject.schema) && isAdditionalPropertiesAny(jsonMediaObject.schema.additionalProperties),
    source
  });
}
function resolveSchema(schema2, document) {
  if (!schema2.$ref.startsWith(SCHEMA_REFERENCE_PREFIX)) {
    throw new Error(`Failed to resolve schema reference because of unsupported prefix: ${schema2.$ref}`);
  }
  const schemaId = getSchemaIdFromReference(schema2);
  if (schemaId == null) {
    throw new Error(`Failed to resolve schema reference because missing schema id: ${schema2.$ref}`);
  }
  const resolvedSchema = document.components?.schemas?.[schemaId];
  if (resolvedSchema == null) {
    throw new Error(`Failed to resolve schema reference because missing: ${schema2.$ref}`);
  }
  if (isReferenceObject(resolvedSchema)) {
    return resolveSchema(resolvedSchema, document);
  }
  return {
    id: schemaId,
    schema: resolvedSchema
  };
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/convertToHttpError.js
var ERROR_NAMES_BY_STATUS_CODE = {
  400: "BadRequestError",
  401: "UnauthorizedError",
  402: "PaymentRequiredError",
  403: "ForbiddenError",
  404: "NotFoundError",
  405: "MethodNotAllowedError",
  406: "NotAcceptableError",
  407: "ProxyAuthenticationRequiredError",
  408: "RequestTimeoutError",
  409: "ConflictError",
  410: "GoneError",
  411: "LengthRequiredError",
  412: "PreconditionFailedError",
  413: "ContentTooLargeError",
  414: "URITooLongError",
  415: "UnsupportedMediaTypeError",
  416: "RangeNotSatisfiableError",
  417: "ExpectationFailedError",
  418: "ImATeapotError",
  419: "AuthenticationTimeoutError",
  420: "MethodFailureError",
  421: "MisdirectedRequestError",
  422: "UnprocessableEntityError",
  423: "LockedError",
  424: "FailedDependencyError",
  425: "TooEarlyError",
  426: "UpgradeRequiredError",
  // TODO: 428 should be PreconditionRequiredError
  428: "PreconditionError",
  429: "TooManyRequestsError",
  430: "RequestHeaderFieldsTooLargeError",
  431: "RequestHeaderFieldsTooLargeError",
  444: "NoResponseError",
  449: "RetryWithError",
  450: "BlockedByWindowsParentalControlsError",
  451: "UnavailableForLegalReasonsError",
  498: "InvalidTokenError",
  499: "ClientClosedRequestError",
  500: "InternalServerError",
  501: "NotImplementedError",
  502: "BadGatewayError",
  503: "ServiceUnavailableError",
  504: "GatewayTimeoutError",
  505: "HTTPVersionNotSupportedError",
  506: "VariantAlsoNegotiatesError",
  507: "InsufficientStorageError",
  508: "LoopDetectedError",
  509: "BandwidthLimitExceededError",
  510: "NotExtendedError",
  511: "NetworkAuthenticationRequiredError"
};
var ERROR_NAMES = new Set(Object.values(ERROR_NAMES_BY_STATUS_CODE));

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/endpoint/convertResponse.js
var SUCCESSFUL_STATUS_CODES = ["200", "201", "202", "204"];
function convertResponse({ operationContext, responses, context, responseBreadcrumbs, responseStatusCode, streamFormat, source }) {
  if (responses == null) {
    return { value: void 0, errors: {} };
  }
  const errors = markErrorSchemas({ responses, context, source, namespace: context.namespace });
  let successStatusCodePresent = false;
  let convertedResponse = void 0;
  for (const statusCode of responseStatusCode != null ? [responseStatusCode] : SUCCESSFUL_STATUS_CODES) {
    const response = responses[statusCode];
    if (response == null) {
      continue;
    }
    successStatusCodePresent = true;
    if (convertedResponse == null) {
      convertedResponse = convertResolvedResponse({
        operationContext,
        response,
        context,
        responseBreadcrumbs,
        streamFormat,
        source,
        namespace: context.namespace
      });
    }
  }
  if (convertedResponse == null && !successStatusCodePresent && responses.default != null) {
    convertedResponse = convertResolvedResponse({
      operationContext,
      response: responses.default,
      context,
      responseBreadcrumbs,
      streamFormat,
      source,
      namespace: context.namespace
    });
  }
  if (convertedResponse != null) {
    switch (convertedResponse.type) {
      case "json":
        return {
          value: convertedResponse,
          errors
        };
      case "streamingJson":
      case "streamingSse":
        return {
          value: convertedResponse,
          errors
        };
      case "file":
      case "text":
      case "streamingText":
        return {
          value: convertedResponse,
          errors
        };
      default:
        assertNever(convertedResponse);
    }
  }
  return {
    value: void 0,
    errors
  };
}
function convertResolvedResponse({ operationContext, streamFormat, response, context, responseBreadcrumbs, source, namespace }) {
  const resolvedResponse = isReferenceObject(response) ? context.resolveResponseReference(response) : response;
  if (resolvedResponse.content != null) {
    const isdownloadFile = Object.entries(resolvedResponse.content).find(([_, mediaObject]) => {
      if (mediaObject.schema == null) {
        return false;
      }
      const resolvedSchema = isReferenceObject(mediaObject.schema) ? context.resolveSchemaReference(mediaObject.schema) : mediaObject.schema;
      return resolvedSchema.type === "string" && resolvedSchema.format === "binary";
    });
    if (isdownloadFile) {
      return ResponseWithExample.file({ description: resolvedResponse.description, source });
    }
  }
  const textEventStreamObject = getTextEventStreamObject(resolvedResponse.content ?? {}, context);
  if (textEventStreamObject != null && streamFormat != null) {
    switch (streamFormat) {
      case "json":
        return ResponseWithExample.streamingJson({
          description: resolvedResponse.description,
          responseProperty: getExtension(operationContext.operation, FernOpenAPIExtension.RESPONSE_PROPERTY),
          fullExamples: textEventStreamObject.examples,
          schema: convertSchema(textEventStreamObject.schema, false, context, responseBreadcrumbs, source, namespace),
          source
        });
      case "sse":
        return ResponseWithExample.streamingSse({
          description: resolvedResponse.description,
          responseProperty: void 0,
          schema: convertSchemaWithExampleToSchema(convertSchema(textEventStreamObject.schema, false, context, responseBreadcrumbs, source, namespace)),
          source
        });
    }
  }
  const jsonMediaObject = getApplicationJsonSchemaMediaObject(resolvedResponse.content ?? {}, context);
  if (jsonMediaObject != null) {
    if (streamFormat != null) {
      switch (streamFormat) {
        case "json":
          return ResponseWithExample.streamingJson({
            description: resolvedResponse.description,
            responseProperty: void 0,
            fullExamples: jsonMediaObject.examples,
            schema: convertSchema(jsonMediaObject.schema, false, context, responseBreadcrumbs, source, namespace),
            source
          });
        case "sse":
          return ResponseWithExample.streamingSse({
            description: resolvedResponse.description,
            responseProperty: void 0,
            schema: convertSchemaWithExampleToSchema(convertSchema(jsonMediaObject.schema, false, context, responseBreadcrumbs, source, namespace)),
            source
          });
      }
    }
    return ResponseWithExample.json({
      description: resolvedResponse.description,
      schema: convertSchema(jsonMediaObject.schema, false, context, responseBreadcrumbs, source, namespace),
      responseProperty: getExtension(operationContext.operation, FernOpenAPIExtension.RESPONSE_PROPERTY),
      fullExamples: jsonMediaObject.examples,
      source
    });
  }
  for (const [mediaType, mediaObject] of Object.entries(resolvedResponse.content ?? {})) {
    const mimeType = MediaType.parse(mediaType);
    if (mimeType == null) {
      continue;
    }
    if (mimeType.isOctetStream() || mimeType.isPDF() || mimeType.isAudio() || mimeType.isImage() || mimeType.isVideo()) {
      return ResponseWithExample.file({ description: resolvedResponse.description, source });
    }
    if (mimeType.isPlainText()) {
      const textPlainSchema = mediaObject.schema;
      if (textPlainSchema == null) {
        return ResponseWithExample.text({ description: resolvedResponse.description, source });
      }
      const resolvedTextPlainSchema = isReferenceObject(textPlainSchema) ? context.resolveSchemaReference(textPlainSchema) : textPlainSchema;
      if (resolvedTextPlainSchema.type === "string" && resolvedTextPlainSchema.format === "byte") {
        return ResponseWithExample.file({ description: resolvedResponse.description, source });
      }
      return ResponseWithExample.text({ description: resolvedResponse.description, source });
    }
  }
  return void 0;
}
function markErrorSchemas({ responses, context, source, namespace }) {
  const errors = {};
  for (const [statusCode, response] of Object.entries(responses)) {
    if (statusCode === "default") {
      continue;
    }
    const parsedStatusCode = parseInt(statusCode);
    if (parsedStatusCode < 400 || parsedStatusCode > 600) {
      continue;
    }
    const resolvedResponse = isReferenceObject(response) ? context.resolveResponseReference(response) : response;
    const mediaObject = getSchemaMediaObject(resolvedResponse.content ?? {}, context);
    const errorName = ERROR_NAMES_BY_STATUS_CODE[parsedStatusCode];
    if (errorName == null) {
      context.logger.warn(`No error name found for status code ${statusCode}`);
      continue;
    }
    errors[parsedStatusCode] = {
      statusCode: parsedStatusCode,
      nameOverride: void 0,
      generatedName: errorName,
      description: resolvedResponse.description,
      schema: convertSchema(mediaObject?.schema ?? {}, false, context, [errorName, "Body"], source, namespace),
      fullExamples: mediaObject?.examples,
      source
    };
  }
  return errors;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/operation/convertHttpOperation.js
function convertHttpOperation({ operationContext, context, responseStatusCode, suffix, streamFormat, source }) {
  const { document, operation, path: path5, method, baseBreadcrumbs, sdkMethodName } = operationContext;
  const idempotent = getExtension(operation, FernOpenAPIExtension.IDEMPOTENT);
  const requestNameOverride = getExtension(operation, [
    FernOpenAPIExtension.REQUEST_NAME_V1,
    FernOpenAPIExtension.REQUEST_NAME_V2
  ]);
  const requestBreadcrumbs = [...baseBreadcrumbs, "Request"];
  const convertedParameters = convertParameters({
    parameters: [...operationContext.pathItemParameters, ...operationContext.operationParameters],
    context,
    requestBreadcrumbs,
    path: path5,
    httpMethod: method,
    source
  });
  let convertedRequest = operation.requestBody != null ? convertRequest({
    requestBody: operation.requestBody,
    document,
    context: new DummyOpenAPIV3ParserContext({
      document: context.document,
      taskContext: context.taskContext,
      options: context.options,
      source: context.source,
      namespace: context.namespace
    }),
    requestBreadcrumbs,
    source,
    namespace: context.namespace
  }) : void 0;
  if (endpointHasNonRequestBodyParameters({ context, convertedParameters }) && convertedRequest != null && convertedRequest.type === "json" && convertedRequest.schema.type !== "object" && operation.requestBody != null) {
    convertedRequest = convertRequest({
      requestBody: operation.requestBody,
      document,
      context,
      requestBreadcrumbs: [...requestBreadcrumbs, "Body"],
      source,
      namespace: context.namespace
    });
  } else if (operation.requestBody != null) {
    convertedRequest = convertRequest({
      requestBody: operation.requestBody,
      document,
      context,
      requestBreadcrumbs: [...requestBreadcrumbs],
      source,
      namespace: context.namespace
    });
  }
  const responseBreadcrumbs = [...baseBreadcrumbs, "Response"];
  const convertedResponse = convertResponse({
    operationContext,
    streamFormat,
    responses: operation.responses,
    context,
    responseBreadcrumbs,
    responseStatusCode,
    source
  });
  const availability = getFernAvailability(operation);
  const examples = getExamplesFromExtension(operationContext, operation, context);
  const serverName = getExtension(operation, FernOpenAPIExtension.SERVER_NAME_V2);
  return {
    summary: operation.summary,
    internal: getExtension(operation, OpenAPIExtension.INTERNAL),
    idempotent,
    audiences: getExtension(operation, FernOpenAPIExtension.AUDIENCES) ?? [],
    operationId: operation.operationId != null && suffix != null ? operation.operationId + "_" + suffix : operation.operationId,
    tags: context.resolveTagsToTagIds(operation.tags),
    namespace: context.namespace,
    sdkName: sdkMethodName,
    pathParameters: convertedParameters.pathParameters,
    queryParameters: convertedParameters.queryParameters,
    headers: convertedParameters.headers,
    requestNameOverride: requestNameOverride ?? void 0,
    generatedRequestName: getGeneratedTypeName(requestBreadcrumbs, context.options.preserveSchemaIds),
    request: convertedRequest,
    response: convertedResponse.value,
    errors: convertedResponse.errors,
    server: serverName != null ? [{ name: serverName, url: void 0, audiences: void 0 }] : (operation.servers ?? []).map((server) => convertServer(server)),
    description: operation.description,
    authed: isEndpointAuthed(operation, document),
    availability,
    method,
    path: path5,
    examples,
    pagination: operationContext.pagination,
    source
  };
}
function isEndpointAuthed(operation, document) {
  if (operation.security != null) {
    return Object.keys(operation.security).length > 0;
  }
  if (document.security != null) {
    return Object.keys(document.security).length > 0;
  }
  return false;
}
function endpointHasNonRequestBodyParameters({ context, convertedParameters }) {
  return context.options.inlinePathParameters && convertedParameters.pathParameters.length > 0 || convertedParameters.queryParameters.length > 0 || convertedParameters.headers.length > 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/operation/convertAsyncSyncOperation.js
function convertAsyncSyncOperation({ operationContext, context, asyncExtension, source }) {
  const { operation, pathItemParameters, operationParameters } = operationContext;
  const headerToIgnore = asyncExtension.discriminant.name;
  const headerValue = asyncExtension.discriminant.value;
  const asyncResponseStatusCode = asyncExtension["response-status-code"];
  const filteredPathItemParams = filterParameters({ context, headerToIgnore, parameters: pathItemParameters });
  const filteredOperationParams = filterParameters({ context, headerToIgnore, parameters: operationParameters });
  const syncOperation = convertHttpOperation({
    operationContext: {
      ...operationContext,
      pathItemParameters: filteredPathItemParams,
      operationParameters: filteredOperationParams,
      operation: {
        ...operation,
        responses: Object.fromEntries(Object.entries(operation.responses).filter(([statusCode]) => {
          return parseInt(statusCode) !== asyncResponseStatusCode;
        }))
      }
    },
    context,
    streamFormat: void 0,
    source
  });
  const asyncOperation = convertHttpOperation({
    operationContext: {
      ...operationContext,
      pathItemParameters: filteredPathItemParams,
      operationParameters: filteredOperationParams,
      baseBreadcrumbs: [...operationContext.baseBreadcrumbs, "async"]
    },
    context,
    suffix: "async",
    responseStatusCode: asyncResponseStatusCode,
    streamFormat: void 0,
    source
  });
  asyncOperation.headers.push({
    name: headerToIgnore,
    schema: SchemaWithExample.literal({
      nameOverride: void 0,
      generatedName: getGeneratedTypeName([headerToIgnore], context.options.preserveSchemaIds),
      title: void 0,
      description: void 0,
      availability: void 0,
      value: LiteralSchemaValue.string(headerValue),
      groupName: void 0
    }),
    description: void 0,
    parameterNameOverride: void 0,
    env: void 0,
    availability: void 0,
    source
  });
  return {
    sync: syncOperation,
    async: asyncOperation
  };
}
function filterParameters({ context, headerToIgnore, parameters }) {
  return parameters.filter((parameter) => {
    const resolvedParameter = isReferenceObject(parameter) ? context.resolveParameterReference(parameter) : parameter;
    if (resolvedParameter.in === "header" && resolvedParameter.name === headerToIgnore) {
      return false;
    }
    return true;
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/operation/convertStreamingOperation.js
var STREAM_SUFFIX = "stream";
function convertStreamingOperation({ operationContext, context, streamingExtension }) {
  switch (streamingExtension.type) {
    case "stream": {
      const streamingOperation = convertHttpOperation({
        operationContext,
        context,
        streamFormat: streamingExtension.format,
        source: context.source
      });
      return {
        streaming: streamingOperation,
        nonStreaming: void 0
      };
    }
    case "streamCondition": {
      const streamingRequestBody = getRequestBody({
        context,
        operation: operationContext.operation,
        streamingExtension,
        isStreaming: true
      });
      if (streamingRequestBody?.schemaReference != null) {
        const schemaId = getSchemaIdFromReference(streamingRequestBody.schemaReference);
        if (schemaId != null) {
          context.excludeSchema(schemaId);
        }
      }
      const streamingResponses = getResponses({
        operation: operationContext.operation,
        response: streamingExtension.responseStream
      });
      const streamingOperation = convertHttpOperation({
        operationContext: {
          ...operationContext,
          sdkMethodName: operationContext.sdkMethodName != null ? {
            groupName: operationContext.sdkMethodName.groupName,
            methodName: operationContext.sdkMethodName.methodName + "_" + STREAM_SUFFIX
          } : void 0,
          operation: {
            ...operationContext.operation,
            description: streamingExtension.streamDescription ?? operationContext.operation.description,
            requestBody: streamingRequestBody?.requestBody,
            responses: streamingResponses
          },
          baseBreadcrumbs: [...operationContext.baseBreadcrumbs, STREAM_SUFFIX]
        },
        context,
        streamFormat: streamingExtension.format,
        suffix: STREAM_SUFFIX,
        source: context.source
      });
      streamingOperation.examples = streamingOperation.examples.filter((example) => isStreamingExample(example, context) !== false);
      const nonStreamingRequestBody = getRequestBody({
        context,
        operation: operationContext.operation,
        streamingExtension,
        isStreaming: false
      });
      const nonStreamingResponses = getResponses({
        operation: operationContext.operation,
        response: streamingExtension.response
      });
      const nonStreamingOperation = convertHttpOperation({
        streamFormat: void 0,
        operationContext: {
          ...operationContext,
          operation: {
            ...operationContext.operation,
            requestBody: nonStreamingRequestBody?.requestBody,
            responses: nonStreamingResponses
          }
        },
        context,
        source: context.source
      });
      nonStreamingOperation.examples = nonStreamingOperation.examples.filter((example) => isStreamingExample(example, context) !== true);
      return {
        streaming: streamingOperation,
        nonStreaming: nonStreamingOperation
      };
    }
    default:
      assertNever(streamingExtension);
  }
}
function getRequestBody({ context, operation, streamingExtension, isStreaming }) {
  if (operation.requestBody == null) {
    return void 0;
  }
  const resolvedRequestBody = isReferenceObject(operation.requestBody) ? context.resolveRequestBodyReference(operation.requestBody) : operation.requestBody;
  const jsonMediaObject = getApplicationJsonSchemaMediaObject(resolvedRequestBody.content, context);
  if (jsonMediaObject == null) {
    return void 0;
  }
  const resolvedRequstBodySchema = isReferenceObject(jsonMediaObject.schema) ? context.resolveSchemaReference(jsonMediaObject.schema) : jsonMediaObject.schema;
  if (resolvedRequstBodySchema.allOf == null && resolvedRequstBodySchema.properties == null) {
    return void 0;
  }
  let streamingProperty = resolvedRequstBodySchema.properties?.[streamingExtension.streamConditionProperty];
  if (streamingProperty != null && isReferenceObject(streamingProperty)) {
    streamingProperty = void 0;
  }
  const requestBodySchemaWithLiteralProperty = {
    ...resolvedRequstBodySchema,
    properties: {
      ...resolvedRequstBodySchema.properties,
      [streamingExtension.streamConditionProperty]: {
        type: "boolean",
        "x-fern-boolean-literal": isStreaming,
        ...streamingProperty ?? {}
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
      }
    },
    // Set to undefined because we inline both the streaming and non-streaming request schemas
    // and title would cause conflicting names
    title: void 0,
    required: [...resolvedRequstBodySchema.required ?? [], streamingExtension.streamConditionProperty]
  };
  return {
    requestBody: {
      content: {
        [MediaType.APPLICATION_JSON]: {
          schema: requestBodySchemaWithLiteralProperty
        }
      }
    },
    schemaReference: isReferenceObject(jsonMediaObject.schema) ? jsonMediaObject.schema : void 0
  };
}
function getResponses({ operation, response }) {
  return {
    ...operation.responses,
    "200": {
      description: "",
      content: {
        [MediaType.APPLICATION_JSON]: {
          schema: response
        }
      }
    }
  };
}
function isStreamingExample(example, context) {
  return example._visit({
    unknown: (unknownExample) => {
      const maybeFernExample = schemas_exports3.serialization.ExampleEndpointCallSchema.parse(unknownExample);
      if (!maybeFernExample.ok) {
        return void 0;
      }
      if (maybeFernExample.value.response == null) {
        return void 0;
      }
      return maybeFernExample.value.response.stream != null;
    },
    full: () => void 0,
    _other: () => void 0
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/operation/convertWebhookOperation.js
function convertWebhookOperation({ context, operationContext, source }) {
  const { document, operation, path: path5, method, baseBreadcrumbs, sdkMethodName } = operationContext;
  const payloadBreadcrumbs = [...baseBreadcrumbs, "Payload"];
  const convertedParameters = convertParameters({
    parameters: [...operationContext.pathItemParameters, ...operationContext.operationParameters],
    context,
    requestBreadcrumbs: payloadBreadcrumbs,
    path: path5,
    httpMethod: method,
    source
  });
  if (operation.requestBody == null) {
    context.logger.error(`Skipping webhook ${method.toUpperCase()} ${path5}: Missing a request body`);
    return void 0;
  }
  if (method !== "POST" && method !== "GET") {
    context.logger.error(`Skipping webhook ${method.toUpperCase()} ${path5}: Not POST or GET`);
    return void 0;
  }
  const convertedPayload = convertRequest({
    requestBody: operation.requestBody,
    document,
    context,
    requestBreadcrumbs: [...baseBreadcrumbs, "Payload"],
    source,
    namespace: context.namespace
  });
  if (convertedPayload == null || convertedPayload.type !== "json") {
    context.logger.error(`Skipping webhook ${path5} because non-json request body`);
    return void 0;
  }
  if (operation.operationId == null) {
    context.logger.error(`Skipping webhook ${path5} because no operation id present`);
    return void 0;
  }
  return {
    summary: operation.summary,
    sdkName: sdkMethodName,
    namespace: context.namespace,
    method,
    operationId: operation.operationId,
    tags: context.resolveTagsToTagIds(operation.tags),
    headers: convertedParameters.headers,
    generatedPayloadName: getGeneratedTypeName(payloadBreadcrumbs, context.options.preserveSchemaIds),
    payload: convertedPayload.schema,
    description: operation.description,
    examples: convertWebhookExamples(convertedPayload.fullExamples),
    source
  };
}
function convertWebhookExamples(payloadExamples) {
  if (payloadExamples == null) {
    return [];
  }
  const webhookExampleCalls = [];
  for (const payloadExample of payloadExamples) {
    const fullExample = convertToFullExample(payloadExample.value);
    if (fullExample == null) {
      continue;
    }
    webhookExampleCalls.push({
      description: payloadExample.description,
      name: payloadExample.name,
      payload: fullExample
    });
  }
  return webhookExampleCalls;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/operation/convertOperation.js
function convertOperation({ context, pathItemContext, operation, convertToWebhook }) {
  const shouldIgnore = getExtension(operation, FernOpenAPIExtension.IGNORE);
  if (shouldIgnore != null && shouldIgnore) {
    context.logger.info(`${pathItemContext.method.toUpperCase()} ${pathItemContext.path} is marked with x-fern-ignore. Skipping.`);
    return void 0;
  }
  const sdkMethodName = getSdkGroupAndMethod(operation, context);
  const pagination = getFernPaginationExtension(context.document, operation);
  const operationContext = {
    ...pathItemContext,
    sdkMethodName,
    baseBreadcrumbs: getBaseBreadcrumbs({
      operation,
      sdkMethodName,
      httpMethod: pathItemContext.method,
      path: pathItemContext.path
    }),
    operation,
    operationParameters: operation.parameters ?? [],
    pagination
  };
  if (convertToWebhook) {
    const webhook = convertWebhookOperation({
      context,
      operationContext,
      source: context.source
    });
    return webhook != null ? { type: "webhook", value: webhook } : void 0;
  }
  const streamingExtension = getFernStreamingExtension(operation);
  if (streamingExtension != null) {
    const streamingOperation = convertStreamingOperation({
      context,
      operationContext,
      streamingExtension
    });
    return streamingOperation != null ? {
      type: "streaming",
      streaming: streamingOperation.streaming,
      nonStreaming: streamingOperation.nonStreaming
    } : void 0;
  }
  const asyncExtension = getFernAsyncExtension(operation);
  if (asyncExtension != null) {
    const asyncAndSync = convertAsyncSyncOperation({
      context,
      operationContext,
      asyncExtension,
      source: context.source
    });
    return {
      type: "async",
      async: asyncAndSync.async,
      sync: asyncAndSync.sync
    };
  }
  const convertedHttpOperation = convertHttpOperation({
    context,
    operationContext,
    streamFormat: void 0,
    source: context.source
  });
  return { type: "http", value: convertedHttpOperation };
}
function getSdkGroupAndMethod(operation, context) {
  const sdkMethodName = getExtension(operation, FernOpenAPIExtension.SDK_METHOD_NAME);
  const sdkGroupName = getExtension(operation, FernOpenAPIExtension.SDK_GROUP_NAME) ?? [];
  if (sdkMethodName != null) {
    let groupName = typeof sdkGroupName === "string" ? [sdkGroupName] : sdkGroupName;
    groupName = context.resolveGroupName(groupName);
    return {
      groupName,
      methodName: sdkMethodName
    };
  }
  return void 0;
}
function getBaseBreadcrumbs({ sdkMethodName, operation, httpMethod, path: path5 }) {
  const baseBreadcrumbs = [];
  if (sdkMethodName != null) {
    if (sdkMethodName.groupName.length > 0) {
      const lastGroupName = sdkMethodName.groupName[sdkMethodName.groupName.length - 1];
      if (lastGroupName != null) {
        baseBreadcrumbs.push(typeof lastGroupName === "string" ? lastGroupName : lastGroupName.name);
      }
    }
    baseBreadcrumbs.push(sdkMethodName.methodName);
  } else if (operation.operationId != null) {
    baseBreadcrumbs.push(operation.operationId);
  } else {
    baseBreadcrumbs.push(camelCase_default(`${httpMethod}_${path5.split("/").join("_")}`));
  }
  return baseBreadcrumbs;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/convertPathItem.js
function convertPathItem(path5, pathItemObject, document, context) {
  const result = [];
  const operations = getOperationObjectsFromPathItem(pathItemObject);
  const basePathItemContext = {
    document,
    pathItem: pathItemObject,
    path: path5,
    pathItemParameters: pathItemObject.parameters ?? []
  };
  for (const operation of operations) {
    const convertToWebhook = isWebhook({ operation: operation.operation });
    const convertedOperation = convertOperation({
      context,
      pathItemContext: {
        ...basePathItemContext,
        method: operation.method
      },
      operation: operation.operation,
      convertToWebhook
    });
    if (convertedOperation != null) {
      result.push(convertedOperation);
    }
  }
  return result;
}
function convertPathItemToWebhooks(path5, pathItemObject, document, context) {
  const result = [];
  const operations = getOperationObjectsFromPathItem(pathItemObject);
  const basePathItemContext = {
    document,
    pathItem: pathItemObject,
    path: path5,
    pathItemParameters: pathItemObject.parameters ?? []
  };
  for (const operation of operations) {
    const convertedOperation = convertOperation({
      context,
      pathItemContext: {
        ...basePathItemContext,
        method: operation.method
      },
      operation: operation.operation,
      convertToWebhook: true
    });
    if (convertedOperation != null) {
      result.push(convertedOperation);
    }
  }
  return result;
}
function getOperationObjectsFromPathItem(pathItemObject) {
  const operations = [];
  if (pathItemObject.get != null) {
    operations.push({
      method: HttpMethod2.Get,
      operation: pathItemObject.get
    });
  }
  if (pathItemObject.post != null) {
    operations.push({
      method: HttpMethod2.Post,
      operation: pathItemObject.post
    });
  }
  if (pathItemObject.put != null) {
    operations.push({
      method: HttpMethod2.Put,
      operation: pathItemObject.put
    });
  }
  if (pathItemObject.delete != null) {
    operations.push({
      method: HttpMethod2.Delete,
      operation: pathItemObject.delete
    });
  }
  if (pathItemObject.patch != null) {
    operations.push({
      method: HttpMethod2.Patch,
      operation: pathItemObject.patch
    });
  }
  return operations;
}
function isWebhook({ operation }) {
  return getExtension(operation, [FernOpenAPIExtension.WEBHOOK]) ?? false;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getBasicSecuritySchemeNames.js
function getBasicSecuritySchemeNames(securityScheme) {
  const usernameVariable = getExtension(securityScheme, FernOpenAPIExtension.BASIC_AUTH_USERNAME_VARIABLE_NAME);
  const passwordVariable = getExtension(securityScheme, FernOpenAPIExtension.BASIC_AUTH_PASSWORD_VARIABLE_NAME);
  return {
    usernameVariable,
    passwordVariable
  };
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getSecuritySchemeNameAndEnvvars.js
function getBasicSecuritySchemeNameAndEnvvar(securityScheme) {
  return getExtension(securityScheme, FernOpenAPIExtension.FERN_BASIC_AUTH);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/converters/convertSecurityScheme.js
function convertSecurityScheme(securityScheme, source) {
  if (isReferenceObject(securityScheme)) {
    throw new Error(`Converting referenced security schemes is unsupported: ${JSON.stringify(securityScheme)}`);
  }
  return convertSecuritySchemeHelper(securityScheme, source);
}
function convertSecuritySchemeHelper(securityScheme, source) {
  if (securityScheme.type === "apiKey" && securityScheme.in === "header") {
    const bearerFormat = getExtension(securityScheme, OpenAPIExtension.BEARER_FORMAT);
    const headerNames = getExtension(securityScheme, FernOpenAPIExtension.FERN_HEADER_AUTH);
    return SecurityScheme.header({
      headerName: securityScheme.name,
      prefix: bearerFormat != null ? "Bearer" : headerNames?.prefix,
      headerVariableName: headerNames?.name ?? getExtension(securityScheme, FernOpenAPIExtension.HEADER_VARIABLE_NAME),
      headerEnvVar: headerNames?.env
    });
  } else if (securityScheme.type === "http" && securityScheme.scheme === "bearer") {
    const bearerNames = getExtension(securityScheme, FernOpenAPIExtension.FERN_BEARER_TOKEN);
    return SecurityScheme.bearer({
      tokenVariableName: bearerNames?.name ?? getExtension(securityScheme, FernOpenAPIExtension.BEARER_TOKEN_VARIABLE_NAME),
      tokenEnvVar: bearerNames?.env
    });
  } else if (securityScheme.type === "http" && securityScheme.scheme === "basic") {
    const basicSecuritySchemeNamingAndEnvvar = getBasicSecuritySchemeNameAndEnvvar(securityScheme);
    const basicSecuritySchemeNaming = getBasicSecuritySchemeNames(securityScheme);
    return SecurityScheme.basic({
      usernameVariableName: basicSecuritySchemeNamingAndEnvvar?.username?.name ?? basicSecuritySchemeNaming.usernameVariable,
      usernameEnvVar: basicSecuritySchemeNamingAndEnvvar?.username?.env,
      passwordVariableName: basicSecuritySchemeNamingAndEnvvar?.password?.name ?? basicSecuritySchemeNaming.passwordVariable,
      passwordEnvVar: basicSecuritySchemeNamingAndEnvvar?.password?.env
    });
  } else if (securityScheme.type === "openIdConnect") {
    return SecurityScheme.bearer({
      tokenVariableName: void 0,
      tokenEnvVar: void 0
    });
  } else if (securityScheme.type === "oauth2") {
    return SecurityScheme.oauth({
      scopesEnum: getScopes(securityScheme, source)
    });
  }
  throw new Error(`Failed to convert security scheme ${JSON.stringify(securityScheme)}`);
}
function getScopes(oauthSecurityScheme, source) {
  const scopes = oauthSecurityScheme.flows.authorizationCode?.scopes ?? oauthSecurityScheme.flows.clientCredentials?.scopes ?? oauthSecurityScheme.flows.implicit?.scopes ?? oauthSecurityScheme.flows.password?.scopes;
  if (scopes != null) {
    const schemaWithExample = convertEnum({
      nameOverride: void 0,
      generatedName: "OauthScope",
      title: void 0,
      enumValues: Object.keys(scopes),
      fernEnum: Object.fromEntries(Object.entries(scopes).map(([scope, description]) => {
        return [
          scope,
          {
            description
          }
        ];
      })),
      _default: void 0,
      description: void 0,
      availability: void 0,
      enumVarNames: void 0,
      wrapAsNullable: false,
      groupName: void 0,
      context: void 0,
      source
    });
    const schema2 = convertSchemaWithExampleToSchema(schemaWithExample);
    if (schema2.type === "enum") {
      return schema2;
    }
  }
  return void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernBasePath.js
function getFernBasePath(parameter) {
  return getExtension(parameter, FernOpenAPIExtension.BASE_PATH);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernGroups.js
var XFernGroupsSchema = z.record(z.string(), z.object({
  summary: z.string().optional(),
  description: z.string().optional()
}));
function getFernGroups({ document, context }) {
  return getExtensionAndValidate(document, FernOpenAPIExtension.GROUPS, XFernGroupsSchema, context.logger);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernVersion.js
function getFernVersion({ context, document }) {
  return getExtension(document, FernOpenAPIExtension.FERN_VERSION) ?? void 0;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getGlobalHeaders.js
function getGlobalHeaders(document) {
  const globalHeaders = getExtension(document, FernOpenAPIExtension.FERN_GLOBAL_HEADERS);
  const result = [];
  for (const header of globalHeaders ?? []) {
    result.push({
      ...header,
      schema: header.type != null ? getSchemaFromFernType({
        fernType: header.type,
        description: void 0,
        availability: void 0,
        generatedName: header.name ?? header.header,
        title: void 0,
        groupName: void 0,
        nameOverride: void 0
      }) : void 0
    });
  }
  return result;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getIdempotencyHeaders.js
function getIdempotencyHeaders(document) {
  const idempotencyHeaders = getExtension(document, FernOpenAPIExtension.FERN_IDEMPOTENCY_HEADERS);
  const result = [];
  for (const header of idempotencyHeaders ?? []) {
    result.push({
      ...header,
      schema: header.type != null ? getSchemaFromFernType({
        fernType: header.type,
        description: void 0,
        availability: void 0,
        generatedName: header.name ?? header.header,
        title: void 0,
        groupName: void 0,
        nameOverride: void 0
      }) : void 0
    });
  }
  return result;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getVariableDefinitions.js
function getVariableDefinitions(document, preserveSchemaIds) {
  const variables = getExtension(document, FernOpenAPIExtension.SDK_VARIABLES);
  if (variables == null) {
    return {};
  }
  return Object.fromEntries(Object.entries(variables).map(([variableName, schema2]) => {
    if (schema2.type === "string") {
      return [
        variableName,
        {
          nameOverride: void 0,
          generatedName: getGeneratedTypeName([variableName], preserveSchemaIds),
          title: schema2.title,
          schema: PrimitiveSchemaValue.string({
            default: getDefaultAsString(schema2),
            pattern: schema2.pattern,
            format: schema2.format,
            minLength: schema2.minLength,
            maxLength: schema2.maxLength
          }),
          description: schema2.description,
          availability: void 0,
          groupName: void 0
        }
      ];
    } else {
      throw new Error(`Variable ${variableName} has unsupported schema ${JSON.stringify(schema2)}`);
    }
  }));
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/getWebhookPathsObject.js
var WEBHOOKS = "webhooks";
function getWebhooksPathsObject(document) {
  return getExtension(document, WEBHOOKS) ?? {};
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/OpenAPIV3ParserContext.js
var OpenAPIV3ParserContext = class extends AbstractOpenAPIV3ParserContext {
  nonRequestReferencedSchemas = /* @__PURE__ */ new Set();
  twoOrMoreRequestsReferencedSchemas = /* @__PURE__ */ new Set();
  singleRequestReferencedSchemas = /* @__PURE__ */ new Set();
  discrminatedUnionReferences = {};
  discrminatedUnionMetadata = {};
  schemasToExclude = /* @__PURE__ */ new Set();
  constructor({ document, taskContext, authHeaders, options, source, namespace }) {
    super({
      document,
      taskContext,
      authHeaders,
      options,
      source,
      namespace
    });
  }
  getDummy() {
    return new DummyOpenAPIV3ParserContext({
      document: this.document,
      taskContext: this.taskContext,
      options: this.options,
      source: this.source,
      namespace: this.namespace
    });
  }
  markSchemaAsReferencedByNonRequest(schemaId) {
    this.nonRequestReferencedSchemas.add(schemaId);
  }
  markSchemaAsReferencedByRequest(schemaId) {
    if (this.singleRequestReferencedSchemas.has(schemaId)) {
      this.twoOrMoreRequestsReferencedSchemas.add(schemaId);
    } else {
      this.singleRequestReferencedSchemas.add(schemaId);
    }
  }
  getReferencedSchemas() {
    return /* @__PURE__ */ new Set([...this.nonRequestReferencedSchemas, ...this.twoOrMoreRequestsReferencedSchemas]);
  }
  markReferencedByDiscriminatedUnion(schema2, discrminant, times) {
    const existingReference = this.discrminatedUnionReferences[schema2.$ref];
    if (existingReference != null) {
      existingReference.discriminants.add(discrminant);
      existingReference.numReferences += times;
    } else {
      this.discrminatedUnionReferences[schema2.$ref] = {
        discriminants: /* @__PURE__ */ new Set([discrminant]),
        numReferences: times
      };
    }
  }
  getReferencesFromDiscriminatedUnion(schema2) {
    return this.discrminatedUnionReferences[schema2.$ref];
  }
  markSchemaWithDiscriminantValue(schema2, discrminant, discriminantValue) {
    const existingMetadata = this.discrminatedUnionMetadata[schema2.$ref];
    if (existingMetadata != null) {
      existingMetadata.discriminants.set(discrminant, discriminantValue);
    } else {
      this.discrminatedUnionMetadata[schema2.$ref] = {
        discriminants: /* @__PURE__ */ new Map([[discrminant, discriminantValue]])
      };
    }
  }
  getDiscriminatedUnionMetadata(schema2) {
    return this.discrminatedUnionMetadata[schema2.$ref];
  }
  excludeSchema(schemaId) {
    this.schemasToExclude.add(schemaId);
  }
  isSchemaExcluded(schemaId) {
    return this.schemasToExclude.has(schemaId);
  }
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/extensions/getFernResolutions.js
function getFernResolutions(openapi) {
  return getExtension(openapi, FernOpenAPIExtension.RESOLUTIONS);
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/runResolutions.js
function runResolutions({ openapi }) {
  const resolutions = getFernResolutions(openapi);
  if (resolutions == null) {
    return openapi;
  }
  let replacedReferences = {};
  for (const resolution of resolutions) {
    const schemaReference = `#/components/schemas/${resolution.name}`;
    for (const resolutionPath of resolution.resolutions) {
      openapi = addComponentSchema({ openapi, schemaReference: resolutionPath, schemaName: resolution.name });
      openapi = replaceWithSchemaReference({
        openapi,
        replaceReference: resolutionPath,
        schemaReference,
        replacedReferences
      });
      replacedReferences = {
        ...replacedReferences,
        ...Object.fromEntries(resolution.resolutions.map((resolution2) => [schemaReference, resolution2]))
      };
    }
  }
  return openapi;
}
function addComponentSchema({ openapi, schemaReference, schemaName }) {
  const keys5 = schemaReference.replace("#/", "").split("/").map((key) => key.replace("~1", "/"));
  let value = openapi;
  for (const key of keys5) {
    const nextValue = value[key];
    if (nextValue == null) {
      return openapi;
    }
    value = nextValue;
  }
  if (openapi.components == null) {
    openapi.components = {};
  }
  if (openapi.components.schemas == null) {
    openapi.components.schemas = {};
  }
  openapi.components.schemas[schemaName] = value;
  return openapi;
}
function replaceWithSchemaReference({ openapi, replaceReference, schemaReference, replacedReferences }) {
  const overlappingReference = Object.keys(replacedReferences).filter((replacedReference) => replaceReference.startsWith(replacedReference)).sort((a, b) => b.length - a.length)[0];
  if (overlappingReference != null) {
    const resolvedOverlappingReference = replacedReferences[overlappingReference];
    if (resolvedOverlappingReference != null) {
      const newSchemaReference = schemaReference.replace(overlappingReference, resolvedOverlappingReference);
      return replaceWithSchemaReference({
        openapi,
        replaceReference,
        schemaReference: newSchemaReference,
        replacedReferences: {}
      });
    }
  }
  const keys5 = replaceReference.replace("#/", "").split("/").map((key) => key.replace("~1", "/"));
  let value = openapi;
  for (const key of keys5.slice(0, -1)) {
    const nextValue = value[key];
    if (nextValue == null) {
      return openapi;
    }
    value = nextValue;
  }
  const finalKey = keys5[keys5.length - 1];
  if (finalKey == null) {
    return openapi;
  }
  value[finalKey] = {
    $ref: schemaReference
  };
  return openapi;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v3/generateIr.js
function generateIr({ openApi, taskContext, options, source, namespace }) {
  openApi = runResolutions({ openapi: openApi });
  const securitySchemes = Object.fromEntries(Object.entries(openApi.components?.securitySchemes ?? {}).map(([key, securityScheme]) => {
    const convertedSecurityScheme = convertSecurityScheme(securityScheme, source);
    if (convertedSecurityScheme == null) {
      return [];
    }
    return [key, convertSecurityScheme(securityScheme, source)];
  }));
  const authHeaders = new Set(...Object.entries(securitySchemes).map(([_, securityScheme]) => {
    if (securityScheme.type === "basic" || securityScheme.type === "bearer") {
      return "Authorization";
    } else if (securityScheme.type === "header") {
      return securityScheme.headerName;
    }
    return null;
  }));
  const context = new OpenAPIV3ParserContext({
    document: openApi,
    taskContext,
    authHeaders,
    options,
    source,
    namespace
  });
  const variables = getVariableDefinitions(openApi, options.preserveSchemaIds);
  const globalHeaders = getGlobalHeaders(openApi);
  const idempotencyHeaders = getIdempotencyHeaders(openApi);
  const audiences = options.audiences ?? [];
  const endpointsWithExample = [];
  const webhooksWithExample = [];
  Object.entries(openApi.paths ?? {}).forEach(([path5, pathItem]) => {
    if (pathItem == null) {
      return;
    }
    taskContext.logger.debug(`Converting path ${path5}`);
    const convertedOperations = convertPathItem(path5, pathItem, openApi, context);
    for (const operation of convertedOperations) {
      const operationAudiences = getAudiences2({ operation });
      if (audiences.length > 0 && !audiences.some((audience) => operationAudiences.includes(audience))) {
        continue;
      }
      switch (operation.type) {
        case "async":
          endpointsWithExample.push(operation.sync);
          endpointsWithExample.push(operation.async);
          break;
        case "http":
          endpointsWithExample.push(operation.value);
          break;
        case "streaming":
          endpointsWithExample.push(operation.streaming);
          if (operation.nonStreaming) {
            endpointsWithExample.push(operation.nonStreaming);
          }
          break;
        case "webhook":
          webhooksWithExample.push(operation.value);
          break;
        default:
          assertNever(operation);
      }
    }
  });
  Object.entries(getWebhooksPathsObject(openApi)).forEach(([path5, pathItem]) => {
    if (pathItem == null) {
      return;
    }
    taskContext.logger.debug(`Converting path ${path5}`);
    const convertedWebhooks = convertPathItemToWebhooks(path5, pathItem, openApi, context);
    for (const webhook of convertedWebhooks) {
      const webhookAudiences = getAudiences2({ operation: webhook });
      if (audiences.length > 0 && !audiences.some((audience) => webhookAudiences.includes(audience))) {
        continue;
      }
      webhooksWithExample.push(webhook.value);
    }
  });
  const schemasWithExample = Object.fromEntries(Object.entries(openApi.components?.schemas ?? {}).map(([key, schema2]) => {
    if (!isReferenceObject(schema2)) {
      const ignoreSchema = getExtension(schema2, FernOpenAPIExtension.IGNORE);
      if (ignoreSchema != null && ignoreSchema) {
        return [];
      }
      if (ERROR_NAMES.has(key)) {
        return [
          key,
          convertSchema(
            // eslint-disable-next-line @typescript-eslint/no-explicit-any
            { ...schema2, "x-fern-type-name": `${key}Body` },
            false,
            context,
            [key],
            source,
            namespace
          )
        ];
      }
    }
    return [key, convertSchema(schema2, false, context, [key], source, namespace)];
  }).filter((entry) => entry.length > 0));
  const schemasWithoutDiscriminants = maybeRemoveDiscriminantsFromSchemas(schemasWithExample, context, source);
  const schemasWithDiscriminants = maybeAddBackDiscriminantsFromSchemas(schemasWithoutDiscriminants, context);
  const schemas = {};
  for (const [key, schemaWithExample] of Object.entries(schemasWithDiscriminants)) {
    const schema2 = convertSchemaWithExampleToSchema(schemaWithExample);
    if (context.isSchemaExcluded(key)) {
      continue;
    }
    schemas[key] = schema2;
    taskContext.logger.debug(`Converted schema ${key}`);
  }
  const exampleTypeFactory = new ExampleTypeFactory(schemasWithDiscriminants, context.nonRequestReferencedSchemas, context);
  const webhooks = webhooksWithExample.map((webhookWithExample) => {
    const extensionExamples = webhookWithExample.examples;
    let examples = extensionExamples;
    if (!options.disableExamples && examples.length === 0) {
      const webhookExample = exampleTypeFactory.buildExample({
        schema: webhookWithExample.payload,
        exampleId: void 0,
        example: void 0,
        skipReadonly: false,
        options: {
          ignoreOptionals: false,
          isParameter: false
        }
      });
      if (webhookExample != null) {
        examples = [
          {
            name: void 0,
            description: void 0,
            payload: webhookExample
          }
        ];
      }
    }
    return {
      ...webhookWithExample,
      payload: convertSchemaWithExampleToSchema(webhookWithExample.payload),
      examples
    };
  });
  const exampleEndpointFactory = new ExampleEndpointFactory(schemasWithDiscriminants, context);
  const endpoints = endpointsWithExample.map((endpointWithExample) => {
    const extensionExamples = endpointWithExample.examples;
    let examples = extensionExamples;
    if (!options.disableExamples && (extensionExamples.length === 0 || extensionExamples.every(hasIncompleteExample))) {
      const endpointExample = exampleEndpointFactory.buildEndpointExample(endpointWithExample);
      if (endpointExample.length > 0) {
        examples = [
          ...endpointExample,
          // Remove incomplete examples (codesamples are included in generated examples)
          ...extensionExamples.filter((example) => !hasIncompleteExample(example))
        ];
      }
    }
    const request = endpointWithExample.request;
    const response = endpointWithExample.response;
    return {
      ...endpointWithExample,
      request: request?.type === "json" ? {
        ...request,
        schema: convertSchemaWithExampleToSchema(request.schema)
      } : request,
      response: response?.type === "json" ? {
        ...response,
        schema: convertSchemaWithExampleToSchema(response.schema)
      } : response,
      queryParameters: endpointWithExample.queryParameters.map((queryParameter) => {
        return {
          description: queryParameter.description,
          name: queryParameter.name,
          schema: convertSchemaWithExampleToSchema(queryParameter.schema),
          parameterNameOverride: queryParameter.parameterNameOverride,
          availability: queryParameter.availability,
          source: queryParameter.source
        };
      }),
      pathParameters: endpointWithExample.pathParameters.map((pathParameter) => {
        return {
          description: pathParameter.description,
          name: pathParameter.name,
          schema: convertSchemaWithExampleToSchema(pathParameter.schema),
          parameterNameOverride: pathParameter.parameterNameOverride,
          variableReference: pathParameter.variableReference,
          availability: pathParameter.availability,
          source: pathParameter.source
        };
      }),
      headers: endpointWithExample.headers.map((header) => {
        return {
          description: header.description,
          name: header.name,
          schema: convertSchemaWithExampleToSchema(header.schema),
          parameterNameOverride: header.parameterNameOverride,
          env: header.env,
          availability: header.availability,
          source: header.source
        };
      }),
      examples,
      errors: mapValues_default(endpointWithExample.errors, (error) => {
        const examples2 = error.fullExamples?.map((example) => {
          const fullExample = convertToFullExample(example.value);
          if (fullExample == null) {
            return void 0;
          }
          return {
            name: example.name,
            description: example.description,
            example: fullExample
          };
        }).filter(isNonNullish);
        if (examples2?.length === 0) {
          const generatedExample = exampleTypeFactory.buildExample({
            schema: error.schema,
            example: void 0,
            exampleId: void 0,
            skipReadonly: false,
            options: {
              ignoreOptionals: false,
              isParameter: false
            }
          });
          if (generatedExample != null) {
            examples2.push({
              name: void 0,
              description: void 0,
              example: generatedExample
            });
          }
        }
        return {
          generatedName: error.generatedName,
          nameOverride: error.nameOverride,
          schema: convertSchemaWithExampleToSchema(error.schema),
          description: error.description,
          source: error.source,
          examples: examples2
        };
      })
    };
  });
  const groupInfo = getFernGroups({ document: openApi, context });
  const ir = {
    apiVersion: getFernVersion({
      context,
      document: openApi
    }),
    basePath: getFernBasePath(openApi),
    title: openApi.info.title,
    description: openApi.info.description,
    groups: Object.fromEntries(Object.entries(groupInfo ?? {}).map(([key, value]) => {
      return [key, { summary: value.summary ?? void 0, description: value.description ?? void 0 }];
    })),
    servers: (openApi.servers ?? []).map((server) => convertServer(server)),
    tags: {
      tagsById: Object.fromEntries((openApi.tags ?? []).map((tag) => {
        return [tag.name, { id: tag.name, description: tag.description }];
      })),
      orderedTagIds: openApi.tags?.map((tag) => tag.name)
    },
    endpoints,
    webhooks,
    channel: [],
    groupedSchemas: getSchemas(namespace, schemas),
    securitySchemes,
    hasEndpointsMarkedInternal: endpoints.some((endpoint) => endpoint.internal),
    nonRequestReferencedSchemas: context.getReferencedSchemas(),
    variables,
    globalHeaders,
    idempotencyHeaders
  };
  return ir;
}
function maybeRemoveDiscriminantsFromSchemas(schemas, context, source) {
  const result = {};
  for (const [schemaId, schema2] of Object.entries(schemas)) {
    if (schema2.type !== "object") {
      result[schemaId] = schema2;
      continue;
    }
    const referenceToSchema = {
      $ref: `#/components/schemas/${schemaId}`
    };
    const discriminatedUnionReference = context.getReferencesFromDiscriminatedUnion(referenceToSchema);
    if (discriminatedUnionReference == null) {
      result[schemaId] = schema2;
      continue;
    }
    const schemaWithoutDiscriminants = {
      ...schema2,
      type: "object",
      properties: schema2.properties.filter((objectProperty) => {
        return !discriminatedUnionReference.discriminants.has(objectProperty.key);
      }),
      allOfPropertyConflicts: schema2.allOfPropertyConflicts.filter((allOfPropertyConflict) => {
        return !discriminatedUnionReference.discriminants.has(allOfPropertyConflict.propertyKey);
      }),
      source
    };
    result[schemaId] = schemaWithoutDiscriminants;
    const parentSchemaIds = getAllParentSchemaIds({ schema: schema2, schemas });
    for (const parentSchemaId of [...new Set(parentSchemaIds)]) {
      const parentSchema = result[parentSchemaId] ?? schemas[parentSchemaId];
      if (parentSchema == null || parentSchema.type !== "object") {
        continue;
      }
      result[parentSchemaId] = {
        ...parentSchema,
        type: "object",
        properties: parentSchema.properties.filter((objectProperty) => {
          return !discriminatedUnionReference.discriminants.has(objectProperty.key);
        }),
        allOfPropertyConflicts: parentSchema.allOfPropertyConflicts.filter((allOfPropertyConflict) => {
          return !discriminatedUnionReference.discriminants.has(allOfPropertyConflict.propertyKey);
        })
      };
    }
  }
  return result;
}
function maybeAddBackDiscriminantsFromSchemas(schemas, context) {
  const result = {};
  for (const [schemaId, schema2] of Object.entries(schemas)) {
    if (schema2.type !== "object") {
      result[schemaId] = schema2;
      continue;
    }
    const referenceToSchema = {
      $ref: `#/components/schemas/${schemaId}`
    };
    const metadata = context.getDiscriminatedUnionMetadata(referenceToSchema);
    if (metadata == null) {
      result[schemaId] = schema2;
      continue;
    }
    const propertiesWithDiscriminants = [];
    for (const property4 of schema2.properties) {
      if (metadata.discriminants.has(property4.key)) {
        const discriminantValue = metadata.discriminants.get(property4.key);
        if (discriminantValue != null) {
          propertiesWithDiscriminants.push({
            ...property4,
            schema: SchemaWithExample.literal({
              nameOverride: void 0,
              generatedName: getGeneratedTypeName([schema2.generatedName, discriminantValue], context.options.preserveSchemaIds),
              title: void 0,
              value: LiteralSchemaValue.string(discriminantValue),
              groupName: void 0,
              description: void 0,
              availability: schema2.availability
            })
          });
        }
      } else {
        propertiesWithDiscriminants.push(property4);
      }
    }
    const schemaWithoutDiscriminants = {
      ...schema2,
      type: "object",
      properties: propertiesWithDiscriminants
    };
    result[schemaId] = schemaWithoutDiscriminants;
  }
  return result;
}
function getAllParentSchemaIds({ schema: schema2, schemas }) {
  const result = [];
  for (const allOfSchema of schema2.allOf) {
    result.push(allOfSchema.schema);
    const allOfSchemaDefinition = schemas[allOfSchema.schema];
    if (allOfSchemaDefinition != null && allOfSchemaDefinition.type === "object") {
      result.push(...getAllParentSchemaIds({ schema: allOfSchemaDefinition, schemas }));
    }
  }
  return result;
}
function getAudiences2({ operation }) {
  let endpointAudiences = [];
  switch (operation.type) {
    case "async":
      endpointAudiences = operation.async.audiences;
      break;
    case "http":
      endpointAudiences = operation.value.audiences;
      break;
    case "streaming":
      endpointAudiences = operation.streaming.audiences;
      break;
    case "webhook":
      break;
    default:
      assertNever(operation);
  }
  return endpointAudiences;
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/openapi/v2/generateIr.js
var isBrowser3 = typeof window !== "undefined" && typeof window.document !== "undefined";
async function generateIr2({ openApi, taskContext, options, source, namespace }) {
  if (isBrowser3) {
    throw new Error("Swagger 2.0 is not supported in the browser");
  }
  const swagger2openapi = require("swagger2openapi");
  const conversionResult = await swagger2openapi.convertObj(openApi, {});
  return generateIr({
    openApi: conversionResult.openapi,
    taskContext,
    options,
    source,
    namespace
  });
}

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/options.js
var DEFAULT_PARSE_OPENAPI_SETTINGS = {
  disableExamples: false,
  discriminatedUnionV2: false,
  useTitlesAsName: true,
  audiences: void 0,
  optionalAdditionalProperties: true,
  cooerceEnumsToLiterals: true,
  respectReadonlySchemas: false,
  onlyIncludeReferencedSchemas: false,
  inlinePathParameters: false,
  preserveSchemaIds: false
};

// ../../cli/api-importers/openapi/openapi-ir-parser/lib/parse.js
async function parse({ context, documents, options }) {
  let ir = {
    apiVersion: void 0,
    title: void 0,
    description: void 0,
    basePath: void 0,
    servers: [],
    tags: {
      tagsById: {},
      orderedTagIds: void 0
    },
    hasEndpointsMarkedInternal: false,
    endpoints: [],
    webhooks: [],
    channel: [],
    groupedSchemas: {
      rootSchemas: {},
      namespacedSchemas: {}
    },
    variables: {},
    nonRequestReferencedSchemas: /* @__PURE__ */ new Set(),
    securitySchemes: {},
    globalHeaders: [],
    idempotencyHeaders: [],
    groups: {}
  };
  for (const document of documents) {
    const source = document.source != null ? document.source : Source2.openapi({ file: "<memory>" });
    switch (document.type) {
      case "openapi": {
        if (isOpenApiV3(document.value)) {
          const openapiIr = generateIr({
            taskContext: context,
            openApi: document.value,
            options: getParseOptions({ specSettings: document.settings, overrides: options }),
            source,
            namespace: document.namespace
          });
          ir = merge2(ir, openapiIr);
        } else if (isOpenApiV2(document.value)) {
          const openapiIr = await generateIr2({
            taskContext: context,
            openApi: document.value,
            options: getParseOptions({ specSettings: document.settings }),
            source,
            namespace: document.namespace
          });
          ir = merge2(ir, openapiIr);
        }
        break;
      }
      case "asyncapi": {
        const parsedAsyncAPI = parseAsyncAPI({
          document: document.value,
          taskContext: context,
          options: getParseOptions({ specSettings: document.settings }),
          source,
          asyncApiOptions: getParseAsyncOptions({ specSettings: document.settings }),
          namespace: document.namespace
        });
        if (parsedAsyncAPI.channel != null) {
          ir.channel.push(parsedAsyncAPI.channel);
        }
        if (parsedAsyncAPI.groupedSchemas != null) {
          ir.groupedSchemas = mergeSchemaMaps(ir.groupedSchemas, parsedAsyncAPI.groupedSchemas);
        }
        if (parsedAsyncAPI.basePath != null) {
          ir.basePath = parsedAsyncAPI.basePath;
        }
        break;
      }
      default:
        assertNever(document);
    }
  }
  return ir;
}
function getParseOptions({ specSettings, overrides }) {
  return {
    disableExamples: overrides?.disableExamples ?? DEFAULT_PARSE_OPENAPI_SETTINGS.disableExamples,
    discriminatedUnionV2: overrides?.discriminatedUnionV2 ?? specSettings?.shouldUseUndiscriminatedUnionsWithLiterals ?? DEFAULT_PARSE_OPENAPI_SETTINGS.discriminatedUnionV2,
    useTitlesAsName: overrides?.useTitlesAsName ?? specSettings?.shouldUseTitleAsName ?? DEFAULT_PARSE_OPENAPI_SETTINGS.useTitlesAsName,
    audiences: overrides?.audiences ?? specSettings?.audiences ?? DEFAULT_PARSE_OPENAPI_SETTINGS.audiences,
    optionalAdditionalProperties: overrides?.optionalAdditionalProperties ?? specSettings?.optionalAdditionalProperties ?? DEFAULT_PARSE_OPENAPI_SETTINGS.optionalAdditionalProperties,
    cooerceEnumsToLiterals: overrides?.cooerceEnumsToLiterals ?? specSettings?.cooerceEnumsToLiterals ?? DEFAULT_PARSE_OPENAPI_SETTINGS.cooerceEnumsToLiterals,
    respectReadonlySchemas: overrides?.respectReadonlySchemas ?? specSettings?.respectReadonlySchemas ?? DEFAULT_PARSE_OPENAPI_SETTINGS.respectReadonlySchemas,
    onlyIncludeReferencedSchemas: overrides?.onlyIncludeReferencedSchemas ?? specSettings?.onlyIncludeReferencedSchemas ?? DEFAULT_PARSE_OPENAPI_SETTINGS.onlyIncludeReferencedSchemas,
    inlinePathParameters: overrides?.inlinePathParameters ?? specSettings?.inlinePathParameters ?? DEFAULT_PARSE_OPENAPI_SETTINGS.inlinePathParameters,
    preserveSchemaIds: overrides?.preserveSchemaIds ?? DEFAULT_PARSE_OPENAPI_SETTINGS.preserveSchemaIds
  };
}
function getParseAsyncOptions({ specSettings, overrides }) {
  return {
    naming: overrides?.naming ?? specSettings?.asyncApiNaming ?? DEFAULT_PARSE_ASYNCAPI_SETTINGS.naming
  };
}
function merge2(ir1, ir2) {
  return {
    apiVersion: ir1.apiVersion ?? ir2.apiVersion,
    title: ir1.title ?? ir2.title,
    description: ir1.description ?? ir2.description,
    basePath: ir1.basePath ?? ir2.basePath,
    servers: [...ir1.servers, ...ir2.servers],
    tags: {
      tagsById: {
        ...ir1.tags.tagsById,
        ...ir2.tags.tagsById
      },
      orderedTagIds: ir1.tags.orderedTagIds == null && ir2.tags.orderedTagIds == null ? void 0 : [...ir1.tags.orderedTagIds ?? [], ...ir2.tags.orderedTagIds ?? []]
    },
    hasEndpointsMarkedInternal: ir1.hasEndpointsMarkedInternal || ir2.hasEndpointsMarkedInternal,
    endpoints: [...ir1.endpoints, ...ir2.endpoints],
    webhooks: [...ir1.webhooks, ...ir2.webhooks],
    channel: [...ir1.channel, ...ir2.channel],
    groupedSchemas: mergeSchemaMaps(ir1.groupedSchemas, ir2.groupedSchemas),
    variables: {
      ...ir1.variables,
      ...ir2.variables
    },
    nonRequestReferencedSchemas: /* @__PURE__ */ new Set([...ir1.nonRequestReferencedSchemas, ...ir2.nonRequestReferencedSchemas]),
    securitySchemes: {
      ...ir1.securitySchemes,
      ...ir2.securitySchemes
    },
    globalHeaders: ir1.globalHeaders != null ? [...ir1.globalHeaders, ...ir2.globalHeaders ?? []] : void 0,
    idempotencyHeaders: ir1.idempotencyHeaders != null ? [...ir1.idempotencyHeaders, ...ir2.idempotencyHeaders ?? []] : void 0,
    groups: {
      ...ir1.groups,
      ...ir2.groups
    }
  };
}
function mergeSchemaMaps(schemas1, schemas2) {
  schemas1.rootSchemas = { ...schemas1.rootSchemas, ...schemas2.rootSchemas };
  for (const [namespace, namespaceSchemas] of Object.entries(schemas2.namespacedSchemas)) {
    if (schemas1.namespacedSchemas[namespace] != null) {
      schemas1.namespacedSchemas[namespace] = { ...schemas1.namespacedSchemas[namespace], ...namespaceSchemas };
    } else {
      schemas1.namespacedSchemas[namespace] = namespaceSchemas;
    }
  }
  return schemas1;
}
function isOpenApiV3(openApi) {
  return openApi.openapi != null;
}
function isOpenApiV2(openApi) {
  return openApi.swagger != null;
}

// ../../cli/workspace/commons/lib/openapi/constants.js
var import_openapi_core = __toESM(require_lib2(), 1);
var DEFAULT_OPENAPI_BUNDLE_OPTIONS = {
  config: new import_openapi_core.Config({
    apis: {},
    styleguide: {
      plugins: [FERN_TYPE_EXTENSIONS],
      rules: {
        spec: "warn"
      }
    }
  }, void 0),
  dereference: false,
  removeUnusedComponents: false,
  keepUrlRefs: true
};

// ../../cli/workspace/commons/lib/utils/getAllNamedDefinitionFiles.js
function getAllNamedDefinitionFiles(definition, opts = {}) {
  return {
    ...Object.fromEntries(entries(definition.namedDefinitionFiles).map(([path5, file]) => {
      return [path5, { ...file, defaultUrl: opts.defaultURL }];
    })),
    ...entries(definition.importedDefinitions).reduce((acc, [pathToImportedDefinition, definition2]) => {
      return {
        ...acc,
        ...mapKeys_default(getAllNamedDefinitionFiles(definition2.definition, { defaultURL: definition2.url }), (_file, path5) => join(pathToImportedDefinition, RelativeFilePath.of(path5)))
      };
    }, {})
  };
}

// ../../cli/workspace/commons/lib/utils/getAllPackageMarkers.js
function getAllPackageMarkers(definition, opts = {}) {
  return {
    ...Object.fromEntries(entries(definition.packageMarkers).map(([path5, file]) => {
      return [path5, { ...file, defaultUrl: opts.defaultURL }];
    })),
    ...entries(definition.importedDefinitions).reduce((acc, [pathToImportedDefinition, definition2]) => {
      return {
        ...acc,
        ...mapKeys_default(getAllPackageMarkers(definition2.definition, { defaultURL: definition2.url }), (_file, path5) => join(pathToImportedDefinition, RelativeFilePath.of(path5)))
      };
    }, {})
  };
}

// ../../cli/workspace/commons/lib/utils/getAllDefinitionFiles.js
function getAllDefinitionFiles(definition) {
  return {
    ...getAllPackageMarkers(definition),
    ...getAllNamedDefinitionFiles(definition)
  };
}

// ../../cli/workspace/commons/lib/utils/getDefinitionFile.js
function getDefinitionFile(workspace, relativeFilepath) {
  return getAllDefinitionFiles(workspace.definition)[relativeFilepath]?.contents;
}

// ../../cli/workspace/commons/lib/utils/visitAllDefinitionFiles.js
var import_path2 = __toESM(require("path"), 1);
async function visitAllDefinitionFiles(workspace, visitor) {
  for (const [relativeFilepath, file] of entries(getAllDefinitionFiles(workspace.definition))) {
    await visitor(relativeFilepath, file.contents, {
      isPackageMarker: import_path2.default.basename(relativeFilepath) === FERN_PACKAGE_MARKER_FILENAME,
      defaultUrl: file.defaultUrl
    });
  }
}

// ../../cli/workspace/commons/lib/utils/visitAllPackageMarkers.js
async function visitAllPackageMarkers(workspace, visitor) {
  for (const [relativeFilepath, file] of entries(getAllPackageMarkers(workspace.definition))) {
    await visitor(relativeFilepath, file.contents);
  }
}

// ../../cli/generation/ir-generator/lib/utils/parseInlineType.js
function parseInlineType({ type: type2, file, _default: _default2, validation }) {
  return recursivelyVisitRawTypeReference({
    type: type2,
    _default: _default2,
    validation,
    visitor: {
      primitive: TypeReference2.primitive,
      unknown: TypeReference2.unknown,
      map: ({ keyType, valueType }) => TypeReference2.container(ContainerType.map({ keyType, valueType })),
      list: (valueType) => TypeReference2.container(ContainerType.list(valueType)),
      set: (valueType) => TypeReference2.container(ContainerType.set(valueType)),
      optional: (valueType) => TypeReference2.container(ContainerType.optional(valueType)),
      literal: (literal) => TypeReference2.container(ContainerType.literal(literal)),
      named: (namedType) => TypeReference2.named({
        ...parseTypeName({
          typeName: namedType,
          file
        }),
        default: void 0,
        inline: void 0
      })
    }
  });
}

// ../../cli/generation/ir-generator/lib/FernFileContext.js
function constructRootApiFileContext({ casingsGenerator, rootApiFile }) {
  return constructFernFileContext({
    relativeFilepath: RelativeFilePath.of("."),
    definitionFile: {
      imports: rootApiFile.imports
    },
    casingsGenerator,
    rootApiFile
  });
}
function constructFernFileContext({ defaultUrl, relativeFilepath, definitionFile, casingsGenerator, rootApiFile }) {
  const file = {
    defaultUrl,
    relativeFilepath,
    fernFilepath: convertToFernFilepath({ relativeFilepath, casingsGenerator }),
    imports: mapValues_default(definitionFile.imports ?? {}, RelativeFilePath.of),
    definitionFile,
    parseTypeReference: (type2) => {
      if (typeof type2 === "string") {
        return parseInlineType({ type: type2, _default: void 0, validation: void 0, file });
      }
      return parseInlineType({
        type: type2.type,
        _default: type2.default,
        validation: type2.validation,
        file
      });
    },
    casingsGenerator,
    rootApiFile
  };
  return file;
}

// ../../cli/generation/ir-generator/lib/utils/getAllPropertiesForObject.js
var CASINGS_GENERATOR = constructCasingsGenerator({
  generationLanguage: void 0,
  keywords: void 0,
  smartCasing: false
});
function getAllPropertiesForObject({
  typeName,
  objectDeclaration,
  filepathOfDeclaration,
  definitionFile,
  workspace,
  typeResolver,
  smartCasing,
  // used only for recursive calls
  path: path5 = [],
  seen = {}
}) {
  const properties = [];
  if (typeName != null) {
    const seenAtFilepath = seen[filepathOfDeclaration] ??= /* @__PURE__ */ new Set();
    if (seenAtFilepath.has(typeName)) {
      return properties;
    }
    seenAtFilepath.add(typeName);
  }
  let casingsGenerator = CASINGS_GENERATOR;
  if (smartCasing) {
    casingsGenerator = constructCasingsGenerator({
      generationLanguage: void 0,
      keywords: void 0,
      smartCasing
    });
  }
  const file = constructFernFileContext({
    relativeFilepath: filepathOfDeclaration,
    definitionFile,
    casingsGenerator,
    rootApiFile: workspace.definition.rootApiFile.contents
  });
  if (objectDeclaration.properties != null) {
    for (const [propertyKey, propertyDeclaration] of Object.entries(objectDeclaration.properties)) {
      const propertyType = typeof propertyDeclaration === "string" ? propertyDeclaration : propertyDeclaration.type;
      const resolvedPropertyType = typeResolver.resolveType({ type: propertyType, file });
      if (resolvedPropertyType != null) {
        properties.push({
          wireKey: propertyKey,
          name: getPropertyName({ propertyKey, property: propertyDeclaration }).name,
          filepathOfDeclaration,
          path: path5,
          propertyType,
          resolvedPropertyType,
          isOptional: resolvedPropertyType._type === "container" && resolvedPropertyType.container._type === "optional"
        });
      }
    }
  }
  if (objectDeclaration.extends != null) {
    const extensions = typeof objectDeclaration.extends === "string" ? [objectDeclaration.extends] : objectDeclaration.extends;
    for (const extension of extensions) {
      const resolvedTypeOfExtension = typeResolver.resolveNamedType({
        referenceToNamedType: extension,
        file
      });
      if (resolvedTypeOfExtension?._type === "named" && isRawObjectDefinition(resolvedTypeOfExtension.declaration)) {
        const definitionFile2 = getDefinitionFile(workspace, resolvedTypeOfExtension.filepath);
        if (definitionFile2 != null) {
          properties.push(...getAllPropertiesForObject({
            typeName: resolvedTypeOfExtension.rawName,
            objectDeclaration: resolvedTypeOfExtension.declaration,
            filepathOfDeclaration: resolvedTypeOfExtension.filepath,
            definitionFile: definitionFile2,
            workspace,
            typeResolver,
            smartCasing,
            path: [
              ...path5,
              {
                reference: extension,
                followedVia: "extension"
              },
              ...resolvedTypeOfExtension.objectPath.map((pathItem) => ({
                reference: pathItem.reference,
                followedVia: "alias"
              }))
            ],
            seen
          }));
        }
      }
    }
  }
  return properties;
}

// ../../cli/generation/ir-generator/lib/examples/validateObjectExample.js
function validateObjectExample({ typeName, typeNameForBreadcrumb, rawObject, file, typeResolver, exampleResolver, workspace, example, breadcrumbs, depth }) {
  if (!isPlainObject2(example)) {
    return getViolationsForMisshapenExample(example, "an object");
  }
  const violations = [];
  const allPropertiesForObject = getAllPropertiesForObject({
    typeName,
    objectDeclaration: rawObject,
    typeResolver,
    definitionFile: file.definitionFile,
    workspace,
    filepathOfDeclaration: file.relativeFilepath,
    smartCasing: false
  });
  const allPropertiesByWireKey = keyBy_default(allPropertiesForObject, (property4) => property4.wireKey);
  const requiredProperties = allPropertiesForObject.filter((property4) => !property4.isOptional && property4.resolvedPropertyType._type !== "unknown");
  for (const requiredProperty of requiredProperties) {
    if (requiredProperty.resolvedPropertyType._type === "container" && requiredProperty.resolvedPropertyType.container._type === "literal") {
      continue;
    }
    if (example[requiredProperty.wireKey] == null) {
      const propertyReference = breadcrumbs.length > 0 ? `${breadcrumbs.join(".")}.${requiredProperty.wireKey}` : requiredProperty.wireKey;
      const message = `Example is missing required property "${propertyReference}"`;
      violations.push({
        message
      });
    }
  }
  for (const [exampleKey, exampleValue] of Object.entries(example)) {
    const propertyWithPath = allPropertiesByWireKey[exampleKey];
    if (propertyWithPath == null) {
      violations.push({
        message: `Unexpected property "${exampleKey}"`
      });
    } else {
      const definitionFile = getDefinitionFile(workspace, propertyWithPath.filepathOfDeclaration);
      if (definitionFile == null) {
        throw new Error("Service file does not exist for property: " + propertyWithPath.wireKey);
      }
      violations.push(...validateTypeReferenceExample({
        rawTypeReference: propertyWithPath.propertyType,
        example: exampleValue,
        file: constructFernFileContext({
          relativeFilepath: propertyWithPath.filepathOfDeclaration,
          definitionFile,
          casingsGenerator: file.casingsGenerator,
          rootApiFile: workspace.definition.rootApiFile.contents
        }),
        workspace,
        typeResolver,
        exampleResolver,
        breadcrumbs: [...breadcrumbs, `${exampleKey}`],
        depth: depth + 1
      }));
    }
  }
  return violations;
}

// ../../cli/generation/ir-generator/lib/examples/validateUndiscriminatedUnionExample.js
function validateUndiscriminatedUnionExample({ rawUnion, example, typeResolver, exampleResolver, file, workspace, breadcrumbs, depth }) {
  const violations = [];
  for (const member of rawUnion.union) {
    const violationsForMember = validateTypeReferenceExample({
      rawTypeReference: typeof member === "string" ? member : member.type,
      example,
      typeResolver,
      exampleResolver,
      file,
      workspace,
      breadcrumbs,
      depth: depth + 1
    });
    if (violationsForMember.length === 0) {
      return [];
    } else if (violations.length === 0) {
      violations.push(...violationsForMember);
    }
  }
  return violations;
}

// ../../cli/generation/ir-generator/lib/utils/getAvailability.js
function getAvailability(field) {
  if (typeof field === "string" || field.availability == null) {
    return void 0;
  }
  const rawAvailability = typeof field.availability === "string" ? { status: field.availability } : field.availability;
  return convertAvailability(field.availability);
}

// ../../cli/generation/ir-generator/lib/utils/getDocs.js
function getDocs(field) {
  if (typeof field === "string") {
    return void 0;
  }
  return field.docs;
}

// ../../cli/generation/ir-generator/lib/utils/getDisplayName.js
function getDisplayName2(field) {
  if (typeof field === "string") {
    return void 0;
  }
  return field["display-name"];
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertDiscriminatedUnionTypeDeclaration.js
var DEFAULT_UNION_VALUE_PROPERTY_VALUE = "value";
async function convertDiscriminatedUnionTypeDeclaration({ union: union3, file, typeResolver }) {
  const discriminant3 = getUnionDiscriminant(union3);
  return Type.union({
    discriminant: file.casingsGenerator.generateNameAndWireValue({
      wireValue: discriminant3,
      name: getUnionDiscriminantName(union3).name
    }),
    extends: getExtensionsAsList(union3.extends).map((extended) => parseTypeName({ typeName: extended, file })),
    baseProperties: union3["base-properties"] != null ? await Promise.all(Object.entries(union3["base-properties"]).map(async ([propertyKey, propertyDefinition]) => ({
      ...await convertDeclaration(propertyDefinition),
      name: file.casingsGenerator.generateNameAndWireValue({
        wireValue: propertyKey,
        name: getPropertyName({ propertyKey, property: propertyDefinition }).name
      }),
      valueType: file.parseTypeReference(propertyDefinition)
    }))) : [],
    types: Object.entries(union3.union).map(([unionKey, rawSingleUnionType]) => {
      const rawType = typeof rawSingleUnionType === "string" ? rawSingleUnionType : typeof rawSingleUnionType.type === "string" ? rawSingleUnionType.type : void 0;
      const discriminantValue = file.casingsGenerator.generateNameAndWireValue({
        wireValue: unionKey,
        name: getSingleUnionTypeName({ unionKey, rawSingleUnionType }).name
      });
      const docs = getDocs(rawSingleUnionType);
      if (rawType == null) {
        return {
          discriminantValue,
          docs,
          shape: SingleUnionTypeProperties.noProperties(),
          displayName: void 0,
          availability: void 0
        };
      }
      const parsedValueType = file.parseTypeReference(rawType);
      return {
        discriminantValue,
        shape: getSingleUnionTypeProperties({
          rawSingleUnionType,
          rawValueType: rawType,
          parsedValueType,
          file,
          typeResolver
        }),
        docs: getDocs(rawSingleUnionType),
        displayName: getDisplayName2(rawSingleUnionType),
        availability: getAvailability(rawSingleUnionType)
      };
    })
  });
}
function getUnionDiscriminant(union3) {
  if (union3.discriminant == null) {
    return "type";
  }
  if (typeof union3.discriminant === "string") {
    return union3.discriminant;
  }
  return union3.discriminant.value;
}
function getUnionDiscriminantName(union3) {
  if (union3.discriminant != null && typeof union3.discriminant !== "string" && union3.discriminant.name != null) {
    return {
      name: union3.discriminant.name,
      wasExplicitlySet: true
    };
  }
  return {
    name: getUnionDiscriminant(union3),
    wasExplicitlySet: false
  };
}
function getSingleUnionTypeName({ unionKey, rawSingleUnionType }) {
  if (typeof rawSingleUnionType !== "string" && rawSingleUnionType.name != null) {
    return {
      name: rawSingleUnionType.name,
      wasExplicitlySet: true
    };
  }
  return {
    name: unionKey,
    wasExplicitlySet: false
  };
}
function getSingleUnionTypeProperties({ rawSingleUnionType, rawValueType, parsedValueType, file, typeResolver }) {
  const singlePropertyKey = typeof rawSingleUnionType !== "string" ? rawSingleUnionType.key : void 0;
  const resolvedType = typeResolver.resolveTypeOrThrow({ type: rawValueType, file });
  if (resolvedType._type === "named" && isRawObjectDefinition(resolvedType.declaration) && singlePropertyKey == null) {
    return SingleUnionTypeProperties.samePropertiesAsObject(resolvedType.name);
  }
  return SingleUnionTypeProperties.singleProperty({
    name: file.casingsGenerator.generateNameAndWireValue({
      wireValue: getSinglePropertyKeyValue(singlePropertyKey),
      name: getSinglePropertyKeyName(singlePropertyKey)
    }),
    type: parsedValueType
  });
}
function getSinglePropertyKeyName(rawSingleUnionType) {
  if (rawSingleUnionType != null) {
    if (typeof rawSingleUnionType === "string") {
      return rawSingleUnionType;
    }
    return rawSingleUnionType.name ?? rawSingleUnionType.value;
  }
  return DEFAULT_UNION_VALUE_PROPERTY_VALUE;
}
function getSinglePropertyKeyValue(rawSingleUnionType) {
  if (rawSingleUnionType != null) {
    if (typeof rawSingleUnionType === "string") {
      return rawSingleUnionType;
    }
    return rawSingleUnionType.value;
  }
  return DEFAULT_UNION_VALUE_PROPERTY_VALUE;
}

// ../../cli/generation/ir-generator/lib/examples/validateUnionExample.js
function validateUnionExample({ typeName, rawUnion, example, typeResolver, exampleResolver, file, workspace, breadcrumbs, depth }) {
  if (!isPlainObject2(example)) {
    return getViolationsForMisshapenExample(example, "an object");
  }
  const discriminant3 = getUnionDiscriminant(rawUnion);
  const { [discriminant3]: discriminantValue, ...nonDiscriminantPropertyExamples } = example;
  if (discriminantValue == null) {
    return [
      {
        message: `Missing discriminant property ("${discriminant3}")`
      }
    ];
  }
  if (typeof discriminantValue !== "string") {
    return getViolationsForMisshapenExample(discriminantValue, "a string");
  }
  const singleUnionTypeDefinition = rawUnion.union[discriminantValue];
  if (singleUnionTypeDefinition == null) {
    return [
      {
        message: `Invalid discriminant property: "${discriminantValue}". Allowed discriminant values:
` + Object.keys(rawUnion.union).map((otherDiscriminantValue) => `  - ${otherDiscriminantValue}`).join("\n")
      }
    ];
  }
  if (rawUnion["base-properties"] != null) {
    const example2 = Object.fromEntries(Object.entries(nonDiscriminantPropertyExamples).filter(([key]) => rawUnion["base-properties"]?.[key] != null));
    const basePropertyViolations = validateObjectExample({
      typeName,
      typeNameForBreadcrumb: typeName,
      rawObject: {
        properties: rawUnion["base-properties"]
      },
      file,
      example: example2,
      typeResolver,
      exampleResolver,
      workspace,
      breadcrumbs,
      depth: depth + 1
    });
    if (basePropertyViolations.length > 0) {
      return basePropertyViolations;
    }
  }
  const type2 = typeof singleUnionTypeDefinition === "string" ? singleUnionTypeDefinition : singleUnionTypeDefinition.type;
  if (typeof type2 !== "string") {
    return getRuleViolationForExtraProperties(nonDiscriminantPropertyExamples);
  }
  const resolvedType = typeResolver.resolveType({
    type: type2,
    file
  });
  if (resolvedType == null) {
    return [];
  }
  if (resolvedType._type === "named" && isRawObjectDefinition(resolvedType.declaration)) {
    const example2 = Object.fromEntries(Object.entries(nonDiscriminantPropertyExamples).filter(([key]) => rawUnion["base-properties"]?.[key] == null));
    return validateObjectExample({
      typeName,
      typeNameForBreadcrumb: typeName,
      rawObject: resolvedType.declaration,
      file: resolvedType.file,
      example: example2,
      typeResolver,
      exampleResolver,
      workspace,
      breadcrumbs,
      depth: depth + 1
    });
  }
  const singlePropertyKey = typeof singleUnionTypeDefinition !== "string" && typeof singleUnionTypeDefinition.key === "string" ? singleUnionTypeDefinition.key : void 0;
  if (singlePropertyKey == null) {
    return [];
  }
  const { [singlePropertyKey]: singlePropertyExample, ...extraProperties } = nonDiscriminantPropertyExamples;
  const violations = [];
  if (singlePropertyExample == null) {
    violations.push({
      message: `Missing property "${singlePropertyKey}"`
    });
  } else {
    violations.push(...validateTypeReferenceExample({
      rawTypeReference: type2,
      example: singlePropertyExample,
      typeResolver,
      exampleResolver,
      file,
      workspace,
      breadcrumbs,
      depth: depth + 1
    }));
  }
  violations.push(...getRuleViolationForExtraProperties(extraProperties));
  return violations;
}
function getRuleViolationForExtraProperties(extraProperties) {
  return Object.keys(extraProperties).map((key) => ({
    severity: "error",
    message: `Unexpected property "${key}"`
  }));
}

// ../../cli/generation/ir-generator/lib/examples/validateTypeExample.js
function validateTypeExample({ typeName, typeDeclaration, file, typeResolver, exampleResolver, example, workspace, breadcrumbs, depth }) {
  return visitRawTypeDeclaration(typeDeclaration, {
    alias: (rawAlias) => {
      return validateAliasExample({
        rawAlias,
        file,
        typeResolver,
        exampleResolver,
        example,
        workspace,
        breadcrumbs,
        depth
      });
    },
    enum: (rawEnum) => {
      return validateEnumExample({
        rawEnum,
        example,
        breadcrumbs
      });
    },
    object: (rawObject) => {
      return validateObjectExample({
        typeName,
        typeNameForBreadcrumb: typeName,
        rawObject,
        example,
        file,
        typeResolver,
        exampleResolver,
        workspace,
        breadcrumbs,
        depth
      });
    },
    discriminatedUnion: (rawUnion) => {
      return validateUnionExample({
        typeName,
        rawUnion,
        example,
        file,
        typeResolver,
        exampleResolver,
        workspace,
        breadcrumbs,
        depth
      });
    },
    undiscriminatedUnion: (rawUnion) => {
      return validateUndiscriminatedUnionExample({
        rawUnion,
        example,
        file,
        typeResolver,
        exampleResolver,
        workspace,
        breadcrumbs,
        depth
      });
    }
  });
}

// ../../cli/generation/ir-generator/lib/examples/validateTypeReferenceExample.js
var ISO_8601_REGEX3 = /^([+-]?\d{4}(?!\d{2}\b))((-?)((0[1-9]|1[0-2])(\3([12]\d|0[1-9]|3[01]))?|W([0-4]\d|5[0-2])(-?[1-7])?|(00[1-9]|0[1-9]\d|[12]\d{2}|3([0-5]\d|6[1-6])))([T\s]((([01]\d|2[0-3])((:?)[0-5]\d)?|24:?00)([.,]\d+(?!:))?)?(\17[0-5]\d([.,]\d+)?)?([zZ]|([+-])([01]\d|2[0-3]):?([0-5]\d)?)?)?)?$/;
var UUID_REGEX = /^[0-9a-fA-F]{8}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{4}\b-[0-9a-fA-F]{12}$/;
var RFC_3339_DATE_REGEX = /^\d{4}-\d{2}-\d{2}$/;
var MAX_RECURSION_DEPTH = 128;
function validateTypeReferenceExample({ rawTypeReference, example, typeResolver, exampleResolver, file, workspace, breadcrumbs, depth }) {
  if (depth > MAX_RECURSION_DEPTH) {
    return [
      {
        message: "Example is too deeply nested. This may indicate a circular reference."
      }
    ];
  }
  if (typeof example === "string" && example.startsWith(EXAMPLE_REFERENCE_PREFIX)) {
    const resolvedExpectedType = typeResolver.resolveType({
      type: rawTypeReference,
      file
    });
    if (resolvedExpectedType == null) {
      return [];
    }
    const parsedExampleReference = exampleResolver.parseExampleReference(example);
    if (parsedExampleReference == null) {
      return [];
    }
    const resolvedActualType = typeResolver.resolveNamedType({
      referenceToNamedType: parsedExampleReference.rawTypeReference,
      file
    });
    if (resolvedActualType == null) {
      return [];
    }
    if (areResolvedTypesEquivalent({ expected: resolvedExpectedType, actual: resolvedActualType })) {
      return [];
    } else {
      return [
        {
          message: `Expected example to be: ${rawTypeReference}. Example is ${example}.`
        }
      ];
    }
  }
  return visitRawTypeReference({
    type: rawTypeReference,
    _default: void 0,
    validation: void 0,
    visitor: {
      primitive: (primitiveType) => validatePrimitiveExample({ primitiveType, example }),
      named: (referenceToNamedType) => {
        const declaration = typeResolver.getDeclarationOfNamedType({
          referenceToNamedType,
          file
        });
        if (declaration == null) {
          return [];
        }
        return validateTypeExample({
          typeName: declaration.typeName,
          typeDeclaration: declaration.declaration,
          file: declaration.file,
          example,
          typeResolver,
          exampleResolver,
          workspace,
          breadcrumbs,
          depth: depth + 1
        });
      },
      map: ({ keyType, valueType }) => {
        if (!isPlainObject2(example)) {
          return getViolationsForMisshapenExample(example, "a map");
        }
        return Object.entries(example).flatMap(([exampleKey, exampleValue]) => [
          ...validateTypeReferenceExample({
            rawTypeReference: keyType,
            example: exampleKey,
            typeResolver,
            exampleResolver,
            file,
            workspace,
            breadcrumbs: [...breadcrumbs, exampleKey],
            depth: depth + 1
          }),
          ...validateTypeReferenceExample({
            rawTypeReference: valueType,
            example: exampleValue,
            typeResolver,
            exampleResolver,
            file,
            workspace,
            breadcrumbs: [...breadcrumbs, exampleKey],
            depth: depth + 1
          })
        ]);
      },
      list: (itemType) => {
        if (!Array.isArray(example)) {
          return getViolationsForMisshapenExample(example, "a list");
        }
        return example.flatMap((exampleItem, idx) => validateTypeReferenceExample({
          rawTypeReference: itemType,
          example: exampleItem,
          typeResolver,
          exampleResolver,
          file,
          workspace,
          breadcrumbs: [...breadcrumbs, `${idx}`],
          depth: depth + 1
        }));
      },
      set: (itemType) => {
        if (!Array.isArray(example)) {
          return getViolationsForMisshapenExample(example, "a list");
        }
        const duplicates = getDuplicates(example);
        if (duplicates.length > 0) {
          return [
            {
              severity: "error",
              message: "Set has duplicate elements:\n" + duplicates.map((item) => `  - ${JSON.stringify(item)}`).join("\n")
            }
          ];
        }
        return example.flatMap((exampleItem, idx) => validateTypeReferenceExample({
          rawTypeReference: itemType,
          example: exampleItem,
          typeResolver,
          exampleResolver,
          file,
          workspace,
          breadcrumbs: [...breadcrumbs, `${idx}`],
          depth: depth + 1
        }));
      },
      optional: (itemType) => {
        if (example == null) {
          return [];
        }
        return validateTypeReferenceExample({
          rawTypeReference: itemType,
          example,
          typeResolver,
          exampleResolver,
          file,
          workspace,
          breadcrumbs,
          depth: depth + 1
        });
      },
      unknown: () => {
        return [];
      },
      literal: (expectedLiteral) => {
        switch (expectedLiteral.type) {
          case "boolean":
            return createValidator((e) => e === expectedLiteral.boolean, expectedLiteral.boolean.toString())(example);
          case "string":
            return createValidator((e) => e === expectedLiteral.string, `"${expectedLiteral.string}"`)(example);
          default:
            assertNever(expectedLiteral);
        }
      }
    }
  });
}
function validatePrimitiveExample({ primitiveType, example }) {
  if (primitiveType.v2 != null) {
    return PrimitiveTypeV2._visit(primitiveType.v2, {
      integer: (v2) => validateIntegerWithRules({
        example,
        rules: v2.validation
      }),
      long: () => validateLong(example),
      uint: () => validateUint(example),
      uint64: () => validateUint64(example),
      double: (v2) => validateDoubleWithRules({
        example,
        rules: v2.validation
      }),
      float: () => validateFloat(example),
      boolean: () => validateBoolean(example),
      string: (v2) => validateStringWithRules({
        example,
        rules: v2.validation
      }),
      uuid: () => validateUuid(example),
      date: () => validateDate(example),
      dateTime: () => validateDateTime(example),
      base64: () => validateString(example),
      bigInteger: () => validateString(example),
      _other: () => {
        throw new Error("Unknown primitive type v2: " + primitiveType.v2);
      }
    });
  }
  return PrimitiveTypeV1._visit(primitiveType.v1, {
    integer: () => validateInteger(example),
    long: () => validateLong(example),
    uint: () => validateUint(example),
    uint64: () => validateUint64(example),
    double: () => validateDouble(example),
    float: () => validateFloat(example),
    boolean: () => validateBoolean(example),
    string: () => validateString(example),
    uuid: () => validateUuid(example),
    dateTime: () => validateDateTime(example),
    date: () => validateDate(example),
    base64: () => validateString(example),
    bigInteger: () => validateString(example),
    _other: () => {
      throw new Error("Unknown primitive type: " + primitiveType.v1);
    }
  });
}
function validateIntegerWithRules({ example, rules }) {
  const violations = validateInteger(example);
  if (violations.length > 0 || rules == null) {
    return violations;
  }
  const integer = example;
  if (rules.min != null) {
    if (rules.exclusiveMin && integer <= rules.min || !rules.exclusiveMin && integer < rules.min) {
      return [
        {
          message: `Expected integer to be greater than or equal to ${rules.min}. Example is ${example}.`
        }
      ];
    }
  }
  if (rules.max != null) {
    if (rules.exclusiveMax && integer >= rules.max || !rules.exclusiveMax && integer > rules.max) {
      return [
        {
          message: `Expected integer to be less than or equal to ${rules.max}. Example is ${example}.`
        }
      ];
    }
  }
  if (rules.multipleOf != null) {
    if (integer % rules.multipleOf !== 0) {
      return [
        {
          message: `Expected integer to be a multiple of ${rules.multipleOf}. Example is ${example}.`
        }
      ];
    }
  }
  return [];
}
function validateDoubleWithRules({ example, rules }) {
  const violations = validateDouble(example);
  if (violations.length > 0 || rules == null) {
    return violations;
  }
  const double = example;
  if (rules.min != null) {
    if (rules.exclusiveMin && double <= rules.min || !rules.exclusiveMin && double < rules.min) {
      return [
        {
          message: `Expected double to be greater than or equal to ${rules.min}. Example is ${example}.`
        }
      ];
    }
  }
  if (rules.max != null) {
    if (rules.exclusiveMax && double >= rules.max || !rules.exclusiveMax && double > rules.max) {
      return [
        {
          message: `Expected double to be less than or equal to ${rules.max}. Example is ${example}.`
        }
      ];
    }
  }
  if (rules.multipleOf != null) {
    if (double % rules.multipleOf !== 0) {
      return [
        {
          message: `Expected double to be a multiple of ${rules.multipleOf}. Example is ${example}.`
        }
      ];
    }
  }
  return [];
}
function validateStringWithRules({ example, rules }) {
  const violations = validateString(example);
  if (violations.length > 0 || rules == null) {
    return violations;
  }
  const str2 = example;
  if (rules.minLength != null) {
    if (str2.length < rules.minLength) {
      return [
        {
          message: `Expected string length to be greater than or equal to ${rules.minLength}. Example is ${example}, which is of length ${str2.length}.`
        }
      ];
    }
  }
  if (rules.maxLength != null) {
    if (str2.length > rules.maxLength) {
      return [
        {
          message: `Expected string length to be less than or equal to ${rules.maxLength}. Example is ${example}, which is of length ${str2.length}.`
        }
      ];
    }
  }
  if (rules.pattern != null) {
    const regex = new RegExp(rules.pattern);
    if (!regex.test(str2)) {
      return [
        {
          message: `Expected string to match pattern ${rules.pattern}. Example is ${example}.`
        }
      ];
    }
  }
  return [];
}
var validateString = createValidator((example) => typeof example === "string", "a string");
var validateInteger = createValidator((example) => Number.isInteger(example), "an integer");
var validateUint = createValidator((example) => Number.isInteger(example) && typeof example === "number" && example >= 0, "a uint");
var validateUint64 = createValidator((example) => Number.isInteger(example) && typeof example === "number" && example >= 0, "a uint64");
var validateFloat = createValidator((example) => typeof example === "number", "a float");
var validateDouble = createValidator((example) => typeof example === "number", "a double");
var validateLong = createValidator((example) => Number.isInteger(example), "an integer");
var validateBoolean = createValidator((example) => typeof example === "boolean", "a boolean");
var validateUuid = createValidator((example) => typeof example === "string" && UUID_REGEX.test(example), "a UUID");
var validateDateTime = createValidator((example) => typeof example === "string" && ISO_8601_REGEX3.test(example), "an ISO 8601 timestamp");
var validateDate = createValidator((example) => typeof example === "string" && RFC_3339_DATE_REGEX.test(example) && ISO_8601_REGEX3.test(example), "a date");
function createValidator(validate, expectedTypeIncludingArticle) {
  return (example) => {
    if (validate(example)) {
      return [];
    }
    return getViolationsForMisshapenExample(example, expectedTypeIncludingArticle);
  };
}
function areResolvedTypesEquivalent({ expected, actual }) {
  if (expected._type === "unknown") {
    return true;
  }
  if (expected._type === "primitive") {
    return actual._type === "primitive" && expected.primitive.v1 === actual.primitive.v1;
  }
  if (expected._type === "container") {
    switch (expected.container._type) {
      case "list":
      case "set":
        return actual._type === "container" && actual.container._type === expected.container._type && areResolvedTypesEquivalent({
          expected: expected.container.itemType,
          actual: actual.container.itemType
        });
      case "optional":
        return areResolvedTypesEquivalent({
          expected: expected.container.itemType,
          actual: actual._type === "container" && actual.container._type === "optional" ? actual.container.itemType : actual
        });
      case "map":
        return actual._type === "container" && actual.container._type === expected.container._type && areResolvedTypesEquivalent({
          expected: expected.container.keyType,
          actual: actual.container.keyType
        }) && areResolvedTypesEquivalent({
          expected: expected.container.valueType,
          actual: actual.container.valueType
        });
      case "literal":
        if (actual._type !== "container" || actual.container._type !== expected.container._type) {
          return false;
        }
        return areLiteralTypesEquivalent({
          expected: expected.container.literal,
          actual: actual.container.literal
        });
      default:
        assertNever(expected.container);
    }
  }
  if (expected._type === "named") {
    return actual._type === "named" && actual.filepath === expected.filepath && actual.rawName === expected.rawName;
  }
  assertNever(expected);
}
function areLiteralTypesEquivalent({ expected, actual }) {
  switch (expected.type) {
    case "boolean":
      return actual.type === "boolean" ? expected.boolean === actual.boolean : false;
    case "string":
      return actual.type === "string" ? expected.string === actual.string : false;
    default:
      assertNever(expected);
  }
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertEnumTypeDeclaration.js
async function convertEnumTypeDeclaration({ _enum, file }) {
  const values = await Promise.all(_enum.enum.map(async (value) => {
    return {
      ...await convertDeclaration(value),
      name: file.casingsGenerator.generateNameAndWireValue({
        wireValue: typeof value === "string" ? value : value.value,
        name: getEnumName(value).name,
        opts: {
          casingOverrides: typeof value !== "string" ? value.casing : void 0
        }
      })
    };
  }));
  let defaultValue;
  if (_enum.default != null) {
    defaultValue = values.find((enumValue) => enumValue.name.wireValue === _enum.default);
    if (defaultValue == null) {
      throw new Error(`Default value ${_enum.default} not found in enum values`);
    }
  }
  return {
    default: defaultValue,
    values
  };
}
function getEnumNameFromEnumValue(enumValue, _enum) {
  const maybeEnumDefintion = _enum.enum.find((value) => typeof value === "string" ? false : value.value === enumValue);
  return {
    name: typeof maybeEnumDefintion === "string" ? enumValue : maybeEnumDefintion?.name ?? enumValue,
    wasExplicitlySet: false
  };
}
function getEnumName(enumValue) {
  if (typeof enumValue === "string") {
    return {
      name: enumValue,
      wasExplicitlySet: false
    };
  }
  if (enumValue.name == null) {
    return {
      name: enumValue.value,
      wasExplicitlySet: false
    };
  }
  return {
    name: enumValue.name,
    wasExplicitlySet: true
  };
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertExampleType.js
function convertTypeExample({ typeName, typeDeclaration, example, typeResolver, exampleResolver, fileContainingType, fileContainingExample, workspace }) {
  return visitRawTypeDeclaration(typeDeclaration, {
    alias: (rawAlias) => {
      return ExampleTypeShape.alias({
        value: convertTypeReferenceExample({
          example,
          rawTypeBeingExemplified: typeof rawAlias === "string" ? rawAlias : rawAlias.type,
          fileContainingRawTypeReference: fileContainingType,
          fileContainingExample,
          typeResolver,
          exampleResolver,
          workspace
        })
      });
    },
    object: (rawObject) => {
      return convertObject4({
        typeName,
        rawObject,
        example,
        fileContainingType,
        fileContainingExample,
        typeResolver,
        exampleResolver,
        workspace
      });
    },
    discriminatedUnion: (rawUnion) => {
      const discriminant3 = getUnionDiscriminant(rawUnion);
      if (!isPlainObject2(example)) {
        throw new Error("Example is not an object");
      }
      const discriminantValueForExample = example[discriminant3];
      if (discriminantValueForExample == null) {
        throw new Error("Example is missing discriminant: " + discriminant3);
      }
      if (typeof discriminantValueForExample !== "string") {
        throw new Error("Discriminant value is not a string");
      }
      const rawSingleUnionType = rawUnion.union[discriminantValueForExample];
      if (rawSingleUnionType == null) {
        throw new Error(`${discriminantValueForExample} is not one of the specified discriminant values.`);
      }
      const rawValueType = typeof rawSingleUnionType === "string" ? rawSingleUnionType : typeof rawSingleUnionType.type === "string" ? rawSingleUnionType.type : void 0;
      return ExampleTypeShape.union({
        discriminant: fileContainingExample.casingsGenerator.generateNameAndWireValue({
          name: getUnionDiscriminantName(rawUnion).name,
          wireValue: discriminant3
        }),
        singleUnionType: convertSingleUnionType({
          rawValueType,
          rawSingleUnionType,
          fileContainingType,
          fileContainingExample,
          typeResolver,
          exampleResolver,
          example,
          discriminant: discriminant3,
          discriminantValueForExample,
          workspace
        })
      });
    },
    enum: (rawEnum) => {
      if (typeof example !== "string") {
        throw new Error("Enum example is not a string");
      }
      return ExampleTypeShape.enum({
        value: fileContainingExample.casingsGenerator.generateNameAndWireValue({
          name: getEnumNameFromEnumValue(example, rawEnum).name,
          wireValue: example
        })
      });
    },
    undiscriminatedUnion: (undiscriminatedUnion3) => {
      for (const [index, variant] of undiscriminatedUnion3.union.entries()) {
        const violationsForMember = validateTypeReferenceExample({
          rawTypeReference: typeof variant === "string" ? variant : variant.type,
          example,
          typeResolver,
          exampleResolver,
          file: fileContainingType,
          workspace,
          breadcrumbs: [],
          depth: 0
        });
        if (violationsForMember.length === 0) {
          return ExampleTypeShape.undiscriminatedUnion({
            index,
            singleUnionType: convertTypeReferenceExample({
              example,
              rawTypeBeingExemplified: typeof variant === "string" ? variant : variant.type,
              fileContainingRawTypeReference: fileContainingType,
              fileContainingExample,
              typeResolver,
              exampleResolver,
              workspace
            })
          });
        }
      }
      throw new Error("Example doesn't match any of the undiscriminated unions");
    }
  });
}
function convertTypeReferenceExample({ example, fileContainingExample, rawTypeBeingExemplified, fileContainingRawTypeReference, typeResolver, exampleResolver, workspace }) {
  const { resolvedExample, file: fileContainingResolvedExample } = exampleResolver.resolveExampleOrThrow({
    example,
    file: fileContainingExample
  });
  const jsonExample = exampleResolver.resolveAllReferencesInExampleOrThrow({
    example,
    file: fileContainingExample
  }).resolvedExample;
  const shape = visitRawTypeReference({
    type: rawTypeBeingExemplified,
    _default: void 0,
    validation: void 0,
    visitor: {
      primitive: (primitive) => {
        return convertPrimitiveExample({
          example: resolvedExample,
          typeBeingExemplified: primitive.v1
        });
      },
      map: ({ keyType, valueType }) => {
        if (!isPlainObject2(resolvedExample)) {
          throw new Error("Example is not an object");
        }
        return ExampleTypeReferenceShape.container(ExampleContainer.map({
          map: Object.entries(resolvedExample).map(([key, value]) => ({
            key: convertTypeReferenceExample({
              example: key,
              fileContainingExample: fileContainingResolvedExample,
              rawTypeBeingExemplified: keyType,
              fileContainingRawTypeReference,
              typeResolver,
              exampleResolver,
              workspace
            }),
            value: convertTypeReferenceExample({
              example: value,
              fileContainingExample: fileContainingResolvedExample,
              rawTypeBeingExemplified: valueType,
              fileContainingRawTypeReference,
              typeResolver,
              exampleResolver,
              workspace
            })
          })),
          keyType: fileContainingRawTypeReference.parseTypeReference(keyType),
          valueType: fileContainingRawTypeReference.parseTypeReference(valueType)
        }));
      },
      list: (itemType) => {
        if (!Array.isArray(resolvedExample)) {
          throw new Error("Example is not a list");
        }
        return ExampleTypeReferenceShape.container(ExampleContainer.list({
          list: resolvedExample.map((exampleItem) => convertTypeReferenceExample({
            example: exampleItem,
            fileContainingExample: fileContainingResolvedExample,
            rawTypeBeingExemplified: itemType,
            fileContainingRawTypeReference,
            typeResolver,
            exampleResolver,
            workspace
          })),
          itemType: fileContainingRawTypeReference.parseTypeReference(itemType)
        }));
      },
      set: (itemType) => {
        if (!Array.isArray(resolvedExample)) {
          throw new Error("Example is not a list");
        }
        return ExampleTypeReferenceShape.container(ExampleContainer.set({
          set: resolvedExample.map((exampleItem) => convertTypeReferenceExample({
            example: exampleItem,
            fileContainingExample: fileContainingResolvedExample,
            rawTypeBeingExemplified: itemType,
            fileContainingRawTypeReference,
            typeResolver,
            exampleResolver,
            workspace
          })),
          itemType: fileContainingRawTypeReference.parseTypeReference(itemType)
        }));
      },
      optional: (itemType) => {
        return ExampleTypeReferenceShape.container(ExampleContainer.optional({
          optional: resolvedExample != null ? convertTypeReferenceExample({
            example: resolvedExample,
            fileContainingExample: fileContainingResolvedExample,
            rawTypeBeingExemplified: itemType,
            fileContainingRawTypeReference,
            typeResolver,
            exampleResolver,
            workspace
          }) : void 0,
          valueType: fileContainingRawTypeReference.parseTypeReference(itemType)
        }));
      },
      literal: (literal) => {
        switch (literal.type) {
          case "boolean":
            return ExampleTypeReferenceShape.container(ExampleContainer.literal({ literal: ExamplePrimitive.boolean(literal.boolean) }));
          case "string":
            return ExampleTypeReferenceShape.container(ExampleContainer.literal({
              literal: ExamplePrimitive.string({
                original: literal.string
              })
            }));
          default:
            assertNever(literal);
        }
      },
      named: (named) => {
        const typeDeclaration = typeResolver.getDeclarationOfNamedTypeOrThrow({
          referenceToNamedType: rawTypeBeingExemplified,
          file: fileContainingRawTypeReference
        });
        const parsedReferenceToNamedType = fileContainingRawTypeReference.parseTypeReference(named);
        if (parsedReferenceToNamedType.type !== "named") {
          throw new Error("Type reference is not to a named type.");
        }
        const typeName = {
          typeId: parsedReferenceToNamedType.typeId,
          fernFilepath: parsedReferenceToNamedType.fernFilepath,
          name: parsedReferenceToNamedType.name
        };
        return ExampleTypeReferenceShape.named({
          typeName,
          shape: convertTypeExample({
            typeName,
            typeDeclaration: typeDeclaration.declaration,
            fileContainingType: typeDeclaration.file,
            fileContainingExample: fileContainingResolvedExample,
            example: resolvedExample,
            typeResolver,
            exampleResolver,
            workspace
          })
        });
      },
      unknown: () => {
        return ExampleTypeReferenceShape.unknown(jsonExample);
      }
    }
  });
  return {
    shape,
    jsonExample
  };
}
function convertPrimitiveExample({ example, typeBeingExemplified }) {
  return PrimitiveTypeV1._visit(typeBeingExemplified, {
    string: () => {
      if (typeof example !== "string") {
        throw new Error("Example is not a string");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.string({
        original: example
      }));
    },
    dateTime: () => {
      if (typeof example !== "string") {
        throw new Error("Example is not a string");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.datetime({
        datetime: new Date(example),
        raw: example
      }));
    },
    date: () => {
      if (typeof example !== "string") {
        throw new Error("Example is not a string");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.date(example));
    },
    base64: () => {
      if (typeof example !== "string") {
        throw new Error("Example is not a string");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.string({
        original: example
      }));
    },
    uint: () => {
      if (typeof example !== "number") {
        throw new Error("Example is not a number");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.uint(example));
    },
    uint64: () => {
      if (typeof example !== "number") {
        throw new Error("Example is not a number");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.uint64(example));
    },
    integer: () => {
      if (typeof example !== "number") {
        throw new Error("Example is not a number");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.integer(example));
    },
    float: () => {
      if (typeof example !== "number") {
        throw new Error("Example is not a number");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.float(example));
    },
    double: () => {
      if (typeof example !== "number") {
        throw new Error("Example is not a number");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.double(example));
    },
    long: () => {
      if (typeof example !== "number") {
        throw new Error("Example is not a number");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.long(example));
    },
    boolean: () => {
      if (typeof example !== "boolean") {
        throw new Error("Example is not a boolean");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.boolean(example));
    },
    uuid: () => {
      if (typeof example !== "string") {
        throw new Error("Example is not a string");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.uuid(example));
    },
    bigInteger: () => {
      if (typeof example !== "string") {
        throw new Error("Example is not a string");
      }
      return ExampleTypeReferenceShape.primitive(ExamplePrimitive.string({
        original: example
      }));
    },
    _other: () => {
      throw new Error("Unknown primitive type: " + typeBeingExemplified);
    }
  });
}
function convertObject4({ typeName, rawObject, example, fileContainingType, fileContainingExample, typeResolver, exampleResolver, workspace }) {
  if (!isPlainObject2(example)) {
    throw new Error(`Example is not an object. Got: ${JSON.stringify(example)}`);
  }
  return ExampleTypeShape.object({
    properties: rawObject.properties != null || rawObject.extends != null ? Object.entries(example).reduce((exampleProperties, [wireKey, propertyExample]) => {
      const originalTypeDeclaration = getOriginalTypeDeclarationForProperty({
        typeName,
        wirePropertyKey: wireKey,
        rawObject,
        typeResolver,
        file: fileContainingType
      });
      if (originalTypeDeclaration == null) {
        return exampleProperties;
      }
      const valueExample = convertTypeReferenceExample({
        example: propertyExample,
        fileContainingExample,
        rawTypeBeingExemplified: typeof originalTypeDeclaration.rawPropertyType === "string" ? originalTypeDeclaration.rawPropertyType : originalTypeDeclaration.rawPropertyType.type,
        fileContainingRawTypeReference: originalTypeDeclaration.file,
        typeResolver,
        exampleResolver,
        workspace
      });
      exampleProperties.push({
        name: fileContainingExample.casingsGenerator.generateNameAndWireValue({
          name: getPropertyName({
            propertyKey: wireKey,
            property: originalTypeDeclaration.rawPropertyType
          }).name,
          wireValue: wireKey
        }),
        value: valueExample,
        originalTypeDeclaration: originalTypeDeclaration.typeName
      });
      return exampleProperties;
    }, []) : []
  });
}
function getOriginalTypeDeclarationForProperty({ typeName, wirePropertyKey, rawObject, typeResolver, file }) {
  const rawPropertyType = rawObject.properties?.[wirePropertyKey];
  if (rawPropertyType != null) {
    return { typeName, rawPropertyType, file };
  } else {
    return getOriginalTypeDeclarationForPropertyFromExtensions({
      wirePropertyKey,
      extends_: rawObject.extends,
      typeResolver,
      file
    });
  }
}
function getOriginalTypeDeclarationForPropertyFromExtensions({ wirePropertyKey, extends_, typeResolver, file }) {
  if (extends_ != null) {
    const extendsList = typeof extends_ === "string" ? [extends_] : extends_;
    for (const typeName of extendsList) {
      const resolvedType = typeResolver.resolveNamedTypeOrThrow({
        referenceToNamedType: typeName,
        file
      });
      if (resolvedType._type !== "named" || !isRawObjectDefinition(resolvedType.declaration)) {
        throw new Error("Extension is not of a named object");
      }
      const originalTypeDeclaration = getOriginalTypeDeclarationForProperty({
        wirePropertyKey,
        rawObject: resolvedType.declaration,
        typeResolver,
        typeName: resolvedType.name,
        file: resolvedType.file
      });
      if (originalTypeDeclaration != null) {
        return originalTypeDeclaration;
      }
    }
  }
  return void 0;
}
function convertSingleUnionType({ rawValueType, rawSingleUnionType, fileContainingType, fileContainingExample, typeResolver, exampleResolver, example, discriminant: discriminant3, discriminantValueForExample, workspace }) {
  const wireDiscriminantValue = fileContainingExample.casingsGenerator.generateNameAndWireValue({
    name: getSingleUnionTypeName({ unionKey: discriminantValueForExample, rawSingleUnionType }).name,
    wireValue: discriminantValueForExample
  });
  if (rawValueType == null) {
    return {
      wireDiscriminantValue,
      shape: ExampleSingleUnionTypeProperties.noProperties()
    };
  }
  const parsedSingleUnionTypeProperties = getSingleUnionTypeProperties({
    rawSingleUnionType,
    rawValueType,
    parsedValueType: fileContainingType.parseTypeReference(rawValueType),
    file: fileContainingType,
    typeResolver
  });
  switch (parsedSingleUnionTypeProperties.propertiesType) {
    case "singleProperty": {
      if (!isPlainObject2(example)) {
        throw new Error("Example is not an object");
      }
      return {
        wireDiscriminantValue,
        shape: ExampleSingleUnionTypeProperties.singleProperty(convertTypeReferenceExample({
          example: example[parsedSingleUnionTypeProperties.name.wireValue],
          rawTypeBeingExemplified: rawValueType,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: fileContainingType,
          fileContainingExample,
          workspace
        }))
      };
    }
    case "samePropertiesAsObject": {
      if (!isPlainObject2(example)) {
        throw new Error("Example is not an object");
      }
      const { [discriminant3]: _discriminantValue, ...nonDiscriminantPropertiesFromExample } = example;
      let rawDeclaration = typeResolver.getDeclarationOfNamedTypeOrThrow({
        referenceToNamedType: rawValueType,
        file: fileContainingType
      });
      while (isRawAliasDefinition(rawDeclaration.declaration)) {
        rawDeclaration = typeResolver.getDeclarationOfNamedTypeOrThrow({
          referenceToNamedType: typeof rawDeclaration.declaration === "string" ? rawDeclaration.declaration : rawDeclaration.declaration.type,
          file: fileContainingType
        });
      }
      if (!isRawObjectDefinition(rawDeclaration.declaration)) {
        throw new Error(`${rawValueType} is not an object`);
      }
      const typeName = {
        typeId: parsedSingleUnionTypeProperties.typeId,
        fernFilepath: parsedSingleUnionTypeProperties.fernFilepath,
        name: parsedSingleUnionTypeProperties.name
      };
      return {
        wireDiscriminantValue,
        shape: ExampleSingleUnionTypeProperties.samePropertiesAsObject({
          typeId: IdGenerator.generateTypeId(typeName),
          object: convertObject4({
            rawObject: rawDeclaration.declaration,
            example: nonDiscriminantPropertiesFromExample,
            fileContainingType: rawDeclaration.file,
            fileContainingExample,
            typeResolver,
            exampleResolver,
            typeName,
            workspace
          })
        })
      };
    }
    default:
      assertNever(parsedSingleUnionTypeProperties);
  }
}

// ../../cli/generation/ir-generator/lib/converters/services/convertQueryParameter.js
async function convertQueryParameter({ file, queryParameterKey, queryParameter }) {
  const { name } = getQueryParameterName({ queryParameterKey, queryParameter });
  const valueType = file.parseTypeReference(queryParameter);
  return {
    ...await convertDeclaration(queryParameter),
    name: file.casingsGenerator.generateNameAndWireValue({
      wireValue: queryParameterKey,
      name
    }),
    valueType,
    allowMultiple: typeof queryParameter !== "string" && queryParameter["allow-multiple"] != null ? queryParameter["allow-multiple"] : false
  };
}
function getQueryParameterName({ queryParameterKey, queryParameter }) {
  if (typeof queryParameter !== "string") {
    if (queryParameter.name != null) {
      return { name: queryParameter.name, wasExplicitlySet: true };
    }
  }
  return { name: queryParameterKey, wasExplicitlySet: false };
}

// ../../cli/generation/ir-generator/lib/utils/getEndpointPathParameters.js
function getEndpointPathParameters(endpoint) {
  return typeof endpoint.request !== "string" && endpoint.request?.["path-parameters"] ? endpoint.request?.["path-parameters"] : endpoint["path-parameters"] != null ? endpoint["path-parameters"] : {};
}

// ../../cli/generation/ir-generator/lib/converters/services/convertExampleEndpointCall.js
function hashJSON(obj) {
  const jsonString = JSON.stringify(obj);
  return import_crypto.default.createHash("sha256").update(jsonString).digest("hex");
}
function convertExampleEndpointCall({ service, endpoint, example, typeResolver, errorResolver, exampleResolver, variableResolver, file, workspace }) {
  const convertedPathParameters = convertPathParameters({
    service,
    endpoint,
    example,
    typeResolver,
    exampleResolver,
    variableResolver,
    file,
    workspace
  });
  return {
    id: example.name ?? hashJSON(example),
    name: example.name != null ? file.casingsGenerator.generateName(example.name) : void 0,
    docs: example.docs,
    url: buildUrl({ file, service, endpoint, example, pathParams: convertedPathParameters }),
    ...convertedPathParameters,
    ...convertHeaders({ service, endpoint, example, typeResolver, exampleResolver, file, workspace }),
    queryParameters: example["query-parameters"] != null ? Object.entries(example["query-parameters"]).map(([wireKey, value]) => {
      const queryParameterDeclaration = typeof endpoint.request !== "string" ? endpoint.request?.["query-parameters"]?.[wireKey] : void 0;
      if (queryParameterDeclaration == null) {
        throw new Error(`Query parameter ${wireKey} does not exist`);
      }
      return {
        name: file.casingsGenerator.generateNameAndWireValue({
          name: getQueryParameterName({
            queryParameterKey: wireKey,
            queryParameter: queryParameterDeclaration
          }).name,
          wireValue: wireKey
        }),
        value: convertTypeReferenceExample({
          example: value,
          rawTypeBeingExemplified: typeof queryParameterDeclaration === "string" ? queryParameterDeclaration : queryParameterDeclaration.type,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: file,
          fileContainingExample: file,
          workspace
        }),
        shape: getQueryParamaterDeclationShape({ queryParameter: queryParameterDeclaration })
      };
    }) : [],
    request: convertExampleRequestBody({ endpoint, example, typeResolver, exampleResolver, file, workspace }),
    response: convertExampleResponse({
      endpoint,
      example,
      typeResolver,
      errorResolver,
      exampleResolver,
      file,
      workspace
    })
  };
}
function getQueryParamaterDeclationShape({ queryParameter }) {
  const isAllowMultiple = typeof queryParameter !== "string" && queryParameter["allow-multiple"] != null ? queryParameter["allow-multiple"] : false;
  return isAllowMultiple ? ExampleQueryParameterShape.exploded() : ExampleQueryParameterShape.single();
}
function convertPathParameters({ service, endpoint, example, typeResolver, exampleResolver, variableResolver, file, workspace }) {
  const rootPathParameters = [];
  const servicePathParameters = [];
  const endpointPathParameters = [];
  const buildExamplePathParameter = ({ name, pathParameterDeclaration, examplePathParameter }) => {
    const resolvedPathParameter = resolvePathParameterOrThrow({
      parameter: pathParameterDeclaration,
      variableResolver,
      file
    });
    return {
      name,
      value: convertTypeReferenceExample({
        example: examplePathParameter,
        rawTypeBeingExemplified: resolvedPathParameter.rawType,
        typeResolver,
        exampleResolver,
        fileContainingRawTypeReference: resolvedPathParameter.file,
        fileContainingExample: file,
        workspace
      })
    };
  };
  if (example["path-parameters"] != null) {
    const rawEndpointPathParameters = getEndpointPathParameters(endpoint);
    for (const [key, examplePathParameter] of Object.entries(example["path-parameters"])) {
      const rootPathParameterDeclaration = file.rootApiFile["path-parameters"]?.[key];
      const servicePathParameterDeclaration = service["path-parameters"]?.[key];
      const endpointPathParameterDeclaration = rawEndpointPathParameters[key];
      if (rootPathParameterDeclaration != null) {
        rootPathParameters.push(buildExamplePathParameter({
          name: file.casingsGenerator.generateName(key),
          pathParameterDeclaration: rootPathParameterDeclaration,
          examplePathParameter
        }));
      } else if (endpointPathParameterDeclaration != null) {
        endpointPathParameters.push(buildExamplePathParameter({
          name: file.casingsGenerator.generateName(key),
          pathParameterDeclaration: endpointPathParameterDeclaration,
          examplePathParameter
        }));
      } else if (servicePathParameterDeclaration != null) {
        servicePathParameters.push(buildExamplePathParameter({
          name: file.casingsGenerator.generateName(key),
          pathParameterDeclaration: servicePathParameterDeclaration,
          examplePathParameter
        }));
      } else {
        throw new Error(`Path parameter ${key} does not exist`);
      }
    }
  }
  return {
    rootPathParameters,
    endpointPathParameters,
    servicePathParameters
  };
}
function convertHeaders({ service, endpoint, example, typeResolver, exampleResolver, file, workspace }) {
  const serviceHeaders = [];
  const endpointHeaders = [];
  if (example.headers != null) {
    for (const [wireKey, exampleHeader] of Object.entries(example.headers)) {
      const endpointHeaderDeclaration = typeof endpoint.request !== "string" ? endpoint.request?.headers?.[wireKey] : void 0;
      const serviceHeaderDeclaration = service.headers?.[wireKey];
      if (endpointHeaderDeclaration != null) {
        endpointHeaders.push({
          name: file.casingsGenerator.generateNameAndWireValue({
            name: getHeaderName2({ headerKey: wireKey, header: endpointHeaderDeclaration }).name,
            wireValue: wireKey
          }),
          value: convertTypeReferenceExample({
            example: exampleHeader,
            rawTypeBeingExemplified: typeof endpointHeaderDeclaration === "string" ? endpointHeaderDeclaration : endpointHeaderDeclaration.type,
            typeResolver,
            exampleResolver,
            fileContainingRawTypeReference: file,
            fileContainingExample: file,
            workspace
          })
        });
      } else if (serviceHeaderDeclaration != null) {
        serviceHeaders.push({
          name: file.casingsGenerator.generateNameAndWireValue({
            name: getHeaderName2({ headerKey: wireKey, header: serviceHeaderDeclaration }).name,
            wireValue: wireKey
          }),
          value: convertTypeReferenceExample({
            example: exampleHeader,
            rawTypeBeingExemplified: typeof serviceHeaderDeclaration === "string" ? serviceHeaderDeclaration : serviceHeaderDeclaration.type,
            typeResolver,
            exampleResolver,
            fileContainingRawTypeReference: file,
            fileContainingExample: file,
            workspace
          })
        });
      } else {
        throw new Error(`Header ${wireKey} does not exist`);
      }
    }
  }
  return {
    endpointHeaders,
    serviceHeaders
  };
}
function convertExampleRequestBody({ endpoint, example, typeResolver, exampleResolver, file, workspace }) {
  const requestType = typeof endpoint.request !== "string" ? endpoint.request?.body : endpoint.request;
  if (requestType == null) {
    return void 0;
  }
  if (typeof requestType === "string" && parseBytesRequest(requestType) != null) {
    return void 0;
  }
  if (!isInlineRequestBody(requestType)) {
    return ExampleRequestBody.reference(convertTypeReferenceExample({
      example: example.request,
      rawTypeBeingExemplified: typeof requestType !== "string" ? requestType.type : requestType,
      typeResolver,
      exampleResolver,
      fileContainingRawTypeReference: file,
      fileContainingExample: file,
      workspace
    }));
  }
  if (!example.request) {
    return void 0;
  }
  if (!isPlainObject2(example.request)) {
    throw new Error(`Example is not an object. Got: ${JSON.stringify(example.request)}`);
  }
  const exampleProperties = [];
  for (const [wireKey, propertyExample] of Object.entries(example.request)) {
    const inlinedRequestPropertyDeclaration = requestType.properties?.[wireKey];
    const inilnedRequestPropertyType = typeof inlinedRequestPropertyDeclaration === "string" ? inlinedRequestPropertyDeclaration : inlinedRequestPropertyDeclaration?.type;
    if (inilnedRequestPropertyType != null && parseRawFileType(inilnedRequestPropertyType) != null) {
      continue;
    }
    if (inlinedRequestPropertyDeclaration != null) {
      exampleProperties.push({
        name: file.casingsGenerator.generateNameAndWireValue({
          name: getPropertyName({ propertyKey: wireKey, property: inlinedRequestPropertyDeclaration }).name,
          wireValue: wireKey
        }),
        value: convertTypeReferenceExample({
          example: propertyExample,
          rawTypeBeingExemplified: typeof inlinedRequestPropertyDeclaration !== "string" ? inlinedRequestPropertyDeclaration.type : inlinedRequestPropertyDeclaration,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: file,
          fileContainingExample: file,
          workspace
        }),
        originalTypeDeclaration: void 0
      });
    } else {
      const originalTypeDeclaration = getOriginalTypeDeclarationForPropertyFromExtensions({
        extends_: requestType.extends,
        wirePropertyKey: wireKey,
        typeResolver,
        file
      });
      if (originalTypeDeclaration == null) {
        throw new Error("Could not find original type declaration for property: " + wireKey);
      }
      exampleProperties.push({
        name: file.casingsGenerator.generateNameAndWireValue({
          name: getPropertyName({ propertyKey: wireKey, property: originalTypeDeclaration.rawPropertyType }).name,
          wireValue: wireKey
        }),
        value: convertTypeReferenceExample({
          example: propertyExample,
          rawTypeBeingExemplified: typeof originalTypeDeclaration.rawPropertyType === "string" ? originalTypeDeclaration.rawPropertyType : originalTypeDeclaration.rawPropertyType.type,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: originalTypeDeclaration.file,
          fileContainingExample: file,
          workspace
        }),
        originalTypeDeclaration: originalTypeDeclaration.typeName
      });
    }
  }
  return ExampleRequestBody.inlinedRequestBody({
    jsonExample: exampleResolver.resolveAllReferencesInExampleOrThrow({ example: example.request, file }).resolvedExample,
    properties: exampleProperties
  });
}
function convertExampleResponse({ endpoint, example, typeResolver, errorResolver, exampleResolver, file, workspace }) {
  if (example.response == null) {
    return ExampleResponse.ok(ExampleEndpointSuccessResponse.body(void 0));
  }
  return visitExampleResponseSchema(endpoint, example.response, {
    body: (example2) => {
      if (example2.error != null) {
        const errorDeclaration = errorResolver.getDeclarationOrThrow(example2.error, file);
        return ExampleResponse.error({
          error: parseErrorName({
            errorName: example2.error,
            file
          }),
          body: errorDeclaration.declaration.type != null ? convertTypeReferenceExample({
            example: example2.body,
            rawTypeBeingExemplified: errorDeclaration.declaration.type,
            typeResolver,
            exampleResolver,
            fileContainingRawTypeReference: errorDeclaration.file,
            fileContainingExample: file,
            workspace
          }) : void 0
        });
      }
      return ExampleResponse.ok(ExampleEndpointSuccessResponse.body(convertExampleResponseBody({ endpoint, example: example2, typeResolver, exampleResolver, file, workspace })));
    },
    stream: (example2) => {
      const rawTypeBeingExemplified = typeof endpoint["response-stream"] === "string" ? endpoint["response-stream"] : endpoint["response-stream"]?.type;
      return ExampleResponse.ok(ExampleEndpointSuccessResponse.stream(example2.stream.map((data) => {
        if (rawTypeBeingExemplified == null) {
          return void 0;
        }
        return convertTypeReferenceExample({
          example: data,
          rawTypeBeingExemplified,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: file,
          fileContainingExample: file,
          workspace
        });
      }).filter(isNonNullish)));
    },
    events: (example2) => {
      const rawTypeBeingExemplified = typeof endpoint["response-stream"] === "string" ? endpoint["response-stream"] : endpoint["response-stream"]?.type;
      return ExampleResponse.ok(ExampleEndpointSuccessResponse.sse(example2.stream.map(({ event, data }) => {
        if (rawTypeBeingExemplified == null) {
          return void 0;
        }
        const convertedExample = convertTypeReferenceExample({
          example: data,
          rawTypeBeingExemplified,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: file,
          fileContainingExample: file,
          workspace
        });
        return { event, data: convertedExample };
      }).filter(isNonNullish)));
    }
  });
}
function convertExampleResponseBody({ endpoint, example, typeResolver, exampleResolver, file, workspace }) {
  const responseBodyType = typeof endpoint.response !== "string" ? endpoint.response?.type : endpoint.response;
  if (responseBodyType == null) {
    return void 0;
  }
  if (example.body == null) {
    return void 0;
  }
  return convertTypeReferenceExample({
    example: example.body,
    rawTypeBeingExemplified: responseBodyType,
    typeResolver,
    exampleResolver,
    fileContainingRawTypeReference: file,
    fileContainingExample: file,
    workspace
  });
}
function buildUrl({ file, service, endpoint, example, pathParams }) {
  let url = urlJoin(file.rootApiFile["base-path"] ?? "", service["base-path"], endpoint.path);
  if (example["path-parameters"] != null) {
    for (const parameter of [
      ...pathParams.endpointPathParameters,
      ...pathParams.servicePathParameters,
      ...pathParams.rootPathParameters
    ]) {
      url = url.replaceAll(`{${parameter.name.originalName}}`, `${parameter.value.jsonExample}`);
    }
  }
  url = url.replaceAll("//", "/");
  if (!url.startsWith("/")) {
    url = `/${url}`;
  }
  return url;
}

// ../../cli/generation/ir-generator/lib/converters/services/convertHttpResponse.js
async function convertHttpResponse({ endpoint, file, typeResolver }) {
  const responseBody = await convertHttpResponseBody({
    endpoint,
    file,
    typeResolver
  });
  return {
    body: responseBody,
    statusCode: typeof endpoint.response !== "string" ? endpoint.response?.["status-code"] : void 0
  };
}
async function convertHttpResponseBody({ endpoint, file, typeResolver }) {
  const response = await convertNonStreamHttpResponseBody({
    endpoint,
    file,
    typeResolver
  });
  const streamResponse = await convertStreamHttpResponseBody({
    endpoint,
    file,
    typeResolver
  });
  if (response != null && streamResponse != null) {
    let nonStreamResponse;
    switch (response.type) {
      case "fileDownload": {
        nonStreamResponse = NonStreamHttpResponseBody.fileDownload({ ...response });
        break;
      }
      case "json": {
        nonStreamResponse = NonStreamHttpResponseBody.json({
          ...response.value
        });
        break;
      }
      case "text": {
        nonStreamResponse = NonStreamHttpResponseBody.text({ ...response });
        break;
      }
      default:
        assertNever(response);
    }
    return HttpResponseBody.streamParameter({
      nonStreamResponse,
      streamResponse
    });
  } else if (response != null) {
    return response;
  } else if (streamResponse != null) {
    return HttpResponseBody.streaming(streamResponse);
  }
  return void 0;
}
async function convertNonStreamHttpResponseBody({ endpoint, file, typeResolver }) {
  const { response } = endpoint;
  if (response != null) {
    const docs = typeof response !== "string" ? response.docs : void 0;
    const responseType = typeof response === "string" ? response : response.type;
    if (parseRawFileType(responseType) != null) {
      return HttpResponseBody.fileDownload({
        docs
      });
    } else if (parseRawTextType(responseType) != null) {
      return HttpResponseBody.text({
        docs
      });
    } else {
      return await convertJsonResponse(response, docs, file, typeResolver);
    }
  }
  return void 0;
}
async function convertStreamHttpResponseBody({ endpoint, file, typeResolver }) {
  const { ["response-stream"]: responseStream } = endpoint;
  if (responseStream != null) {
    const docs = typeof responseStream !== "string" ? responseStream.docs : void 0;
    const typeReference = typeof responseStream === "string" ? responseStream : responseStream.type;
    const streamFormat = typeof responseStream === "string" ? "json" : responseStream.format ?? "json";
    if (isRawTextType(typeReference)) {
      return StreamingResponse.text({
        docs
      });
    } else if (typeof responseStream !== "string" && streamFormat === "sse") {
      return StreamingResponse.sse({
        docs,
        payload: file.parseTypeReference(typeReference),
        terminator: typeof responseStream !== "string" ? responseStream.terminator : void 0
      });
    } else {
      return StreamingResponse.json({
        docs,
        payload: file.parseTypeReference(typeReference),
        terminator: typeof responseStream !== "string" ? responseStream.terminator : void 0
      });
    }
  }
  return void 0;
}
async function convertJsonResponse(response, docs, file, typeResolver) {
  const responseBodyType = file.parseTypeReference(response);
  const resolvedType = typeResolver.resolveTypeOrThrow({
    type: typeof response !== "string" ? response.type : response,
    file
  });
  const responseProperty = typeof response !== "string" ? response.property : void 0;
  if (responseProperty != null) {
    return HttpResponseBody.json(JsonResponse.nestedPropertyAsResponse({
      docs,
      responseBodyType,
      responseProperty: await getObjectPropertyFromResolvedType({
        typeResolver,
        file,
        resolvedType,
        property: responseProperty
      })
    }));
  }
  return HttpResponseBody.json(JsonResponse.response({
    docs,
    responseBodyType
  }));
}

// ../../cli/generation/ir-generator/lib/converters/services/convertCursorPagination.js
async function convertCursorPagination({ propertyResolver, file, endpointName, endpointSchema, paginationPropertyComponents }) {
  return Pagination.cursor({
    page: await propertyResolver.resolveRequestPropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.cursor
    }),
    next: await propertyResolver.resolveResponsePropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.next_cursor
    }),
    results: await propertyResolver.resolveResponsePropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.results
    })
  });
}

// ../../cli/generation/ir-generator/lib/converters/services/convertOffsetPagination.js
async function convertOffsetPagination({ propertyResolver, file, endpointName, endpointSchema, paginationPropertyComponents }) {
  return Pagination.offset({
    page: await propertyResolver.resolveRequestPropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.offset
    }),
    results: await propertyResolver.resolveResponsePropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.results
    }),
    step: paginationPropertyComponents.step != null ? await propertyResolver.resolveRequestPropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.step
    }) : void 0,
    hasNextPage: paginationPropertyComponents.hasNextPage != null ? await propertyResolver.resolveResponsePropertyOrThrow({
      file,
      endpoint: endpointName,
      propertyComponents: paginationPropertyComponents.hasNextPage
    }) : void 0
  });
}

// ../../cli/generation/ir-generator/lib/converters/services/convertPaginationUtils.js
function getPaginationPropertyComponents(endpointPagination) {
  if (isRawOffsetPaginationSchema(endpointPagination)) {
    return {
      type: "offset",
      offset: getRequestPropertyComponents(endpointPagination.offset),
      results: getResponsePropertyComponents(endpointPagination.results),
      step: endpointPagination.step != null ? getRequestPropertyComponents(endpointPagination.step) : void 0,
      hasNextPage: endpointPagination["has-next-page"] != null ? getResponsePropertyComponents(endpointPagination["has-next-page"]) : void 0
    };
  }
  return {
    type: "cursor",
    cursor: getRequestPropertyComponents(endpointPagination.cursor),
    next_cursor: getResponsePropertyComponents(endpointPagination.next_cursor),
    results: getResponsePropertyComponents(endpointPagination.results)
  };
}
function isRawOffsetPaginationSchema(rawPaginationSchema) {
  return rawPaginationSchema.offset != null && rawPaginationSchema.results != null;
}

// ../../cli/generation/ir-generator/lib/converters/services/convertPagination.js
async function convertPagination({ propertyResolver, file, endpointName, endpointSchema }) {
  const endpointPagination = typeof endpointSchema.pagination === "boolean" ? file.rootApiFile.pagination : endpointSchema.pagination;
  if (!endpointPagination) {
    return void 0;
  }
  const paginationPropertyComponents = getPaginationPropertyComponents(endpointPagination);
  switch (paginationPropertyComponents.type) {
    case "cursor":
      return await convertCursorPagination({
        propertyResolver,
        file,
        endpointName,
        endpointSchema,
        paginationPropertyComponents
      });
    case "offset":
      return convertOffsetPagination({
        propertyResolver,
        file,
        endpointName,
        endpointSchema,
        paginationPropertyComponents
      });
    default:
      assertNever(paginationPropertyComponents);
  }
}

// ../../cli/generation/ir-generator/lib/converters/convertProtobufFile.js
function convertProtobufFile({ source }) {
  return {
    filepath: source.relativeFilePath,
    packageName: source.packageName,
    options: source.csharpNamespace != null ? {
      csharp: {
        namespace: source.csharpNamespace
      }
    } : void 0
  };
}

// ../../cli/generation/ir-generator/lib/converters/services/convertProtobufService.js
function convertProtobufService({ source, serviceNameOverride }) {
  const serviceName = serviceNameOverride ?? source.serviceName;
  if (serviceName == null) {
    return void 0;
  }
  return {
    file: convertProtobufFile({ source }),
    // Use the global casings generator so that the name is not
    // affected by the user's casing settings (e.g. smart-casing).
    name: CASINGS_GENERATOR.generateName(serviceName)
  };
}

// ../../cli/generation/ir-generator/lib/converters/services/convertTransport.js
async function getTransportForService({ file, serviceDeclaration, sourceResolver }) {
  if (!isRawProtobufSourceSchema(serviceDeclaration.source)) {
    return Transport.http();
  }
  return await createProtobufService(file, serviceDeclaration.source, sourceResolver, serviceDeclaration.transport?.grpc?.["service-name"]);
}
async function getTransportForEndpoint({ file, serviceTransport, endpointDeclaration, sourceResolver }) {
  const isGrpcService = serviceTransport.type === "grpc";
  const isHttpService = serviceTransport.type === "http";
  const isGrpcEndpoint = isRawProtobufSourceSchema(endpointDeclaration.source);
  const isHttpEndpoint = !isGrpcEndpoint;
  if (!isGrpcService) {
    return void 0;
  }
  if (isHttpService && isGrpcEndpoint) {
    throw new Error("Cannot have a grpc endpoint on an http service");
  }
  if (isGrpcService && isHttpEndpoint) {
    return Transport.http();
  }
  if (isGrpcService && isGrpcEndpoint) {
    const protoSource = endpointDeclaration.source;
    const serviceNameOverride = endpointDeclaration.transport?.grpc?.["service-name"];
    if (!serviceNameOverride) {
      return void 0;
    } else {
      return await createProtobufService(file, protoSource, sourceResolver, serviceNameOverride);
    }
  }
  throw new Error(`Internal error; failed to determine endpoint transport for
  ${JSON.stringify(endpointDeclaration)}"`);
}
async function createProtobufService(file, source, sourceResolver, serviceNameOverride) {
  const resolvedSource = await sourceResolver.resolveSourceOrThrow({
    source,
    relativeFilepath: file.relativeFilepath
  });
  if (resolvedSource == null || resolvedSource.type !== "protobuf") {
    throw new Error(`Expected a protobuf source for ${source.proto}.`);
  }
  const protobufService = convertProtobufService({
    source: resolvedSource,
    serviceNameOverride
  });
  if (protobufService == null) {
    throw new Error(`Failed to resolve service name from ${resolvedSource.relativeFilePath}.`);
  }
  return Transport.grpc({
    service: protobufService
  });
}

// ../../cli/generation/ir-generator/lib/converters/services/convertHttpService.js
async function convertHttpService({ rootDefaultUrl, rootPathParameters, serviceDefinition, file, errorResolver, typeResolver, propertyResolver, exampleResolver, variableResolver, sourceResolver, globalErrors, workspace }) {
  const servicePathParameters = await convertPathParameters2({
    pathParameters: serviceDefinition["path-parameters"],
    location: PathParameterLocation.Service,
    file,
    variableResolver
  });
  const transport = await getTransportForService({
    file,
    serviceDeclaration: serviceDefinition,
    sourceResolver
  });
  const serviceName = { fernFilepath: file.fernFilepath };
  const service = {
    availability: convertAvailability(serviceDefinition.availability),
    name: serviceName,
    displayName: serviceDefinition["display-name"] ?? void 0,
    basePath: constructHttpPath(serviceDefinition["base-path"]),
    headers: serviceDefinition.headers != null ? await Promise.all(Object.entries(serviceDefinition.headers).map(([headerKey, header]) => convertHttpHeader({ headerKey, header, file }))) : [],
    pathParameters: servicePathParameters,
    encoding: convertTransportToEncoding(transport, serviceDefinition),
    transport,
    endpoints: await Promise.all(Object.entries(serviceDefinition.endpoints).map(async ([endpointKey, endpoint]) => {
      const endpointPathParameters = await convertPathParameters2({
        pathParameters: getEndpointPathParameters(endpoint),
        location: PathParameterLocation.Endpoint,
        file,
        variableResolver
      });
      const httpEndpoint = {
        ...await convertDeclaration(endpoint),
        id: "",
        name: file.casingsGenerator.generateName(endpointKey),
        displayName: endpoint["display-name"],
        auth: endpoint.auth ?? serviceDefinition.auth,
        idempotent: endpoint.idempotent ?? serviceDefinition.idempotent ?? false,
        baseUrl: endpoint.url ?? serviceDefinition.url ?? rootDefaultUrl,
        method: endpoint.method != null ? convertHttpMethod(endpoint.method) : HttpMethod.Post,
        basePath: endpoint["base-path"] != null ? constructHttpPath(endpoint["base-path"]) : void 0,
        path: constructHttpPath(endpoint.path),
        fullPath: constructHttpPath(endpoint["base-path"] != null ? urlJoin(endpoint["base-path"], endpoint.path) : file.rootApiFile["base-path"] != null ? urlJoin(file.rootApiFile["base-path"], serviceDefinition["base-path"], endpoint.path) : urlJoin(serviceDefinition["base-path"], endpoint.path)),
        pathParameters: endpointPathParameters,
        allPathParameters: endpoint["base-path"] != null ? endpointPathParameters : [...rootPathParameters, ...servicePathParameters, ...endpointPathParameters],
        queryParameters: typeof endpoint.request !== "string" && endpoint.request?.["query-parameters"] != null ? await Promise.all(Object.entries(endpoint.request["query-parameters"]).map(async ([queryParameterKey, queryParameter]) => {
          return await convertQueryParameter({
            file,
            queryParameterKey,
            queryParameter
          });
        })) : [],
        headers: typeof endpoint.request !== "string" && endpoint.request?.headers != null ? await Promise.all(Object.entries(endpoint.request.headers).map(([headerKey, header]) => convertHttpHeader({ headerKey, header, file }))) : [],
        requestBody: convertHttpRequestBody({ request: endpoint.request, file }),
        sdkRequest: await convertHttpSdkRequest({
          service: serviceDefinition,
          request: endpoint.request,
          endpoint,
          endpointKey,
          file,
          typeResolver,
          propertyResolver
        }),
        response: await convertHttpResponse({ endpoint, file, typeResolver }),
        errors: [...convertResponseErrors({ errors: endpoint.errors, file }), ...globalErrors],
        userSpecifiedExamples: endpoint.examples != null ? endpoint.examples.map((example) => {
          return {
            example: convertExampleEndpointCall({
              service: serviceDefinition,
              endpoint,
              example,
              typeResolver,
              errorResolver,
              exampleResolver,
              variableResolver,
              file,
              workspace
            }),
            codeSamples: example["code-samples"]?.map((codeSample) => convertCodeSample({ codeSample, file }))
          };
        }) : [],
        autogeneratedExamples: [],
        pagination: await convertPagination({
          propertyResolver,
          file,
          endpointName: endpointKey,
          endpointSchema: endpoint
        }),
        transport: await getTransportForEndpoint({
          file,
          serviceTransport: transport,
          endpointDeclaration: endpoint,
          sourceResolver
        })
      };
      httpEndpoint.id = IdGenerator.generateEndpointId(serviceName, httpEndpoint);
      return httpEndpoint;
    }))
  };
  return service;
}
async function convertPathParameters2({ pathParameters, location, file, variableResolver }) {
  if (pathParameters == null) {
    return [];
  }
  return await Promise.all(Object.entries(pathParameters).map(([parameterName, parameter]) => convertPathParameter({
    parameterName,
    parameter,
    location,
    file,
    variableResolver
  })));
}
async function convertPathParameter({ parameterName, parameter, location, file, variableResolver }) {
  return {
    ...await convertDeclaration(parameter),
    name: file.casingsGenerator.generateName(parameterName),
    valueType: getPathParameterType({ parameter, variableResolver, file }),
    location,
    variable: isVariablePathParameter(parameter) ? variableResolver.getVariableIdOrThrow(typeof parameter === "string" ? parameter : parameter.variable) : void 0
  };
}
function getPathParameterType({ parameter, variableResolver, file }) {
  const parsed = resolvePathParameterOrThrow({
    parameter,
    variableResolver,
    file
  });
  return parsed.file.parseTypeReference(parsed.rawType);
}
function resolvePathParameterOrThrow({ parameter, variableResolver, file }) {
  const resolved = resolvePathParameter({
    parameter,
    variableResolver,
    file
  });
  if (resolved == null) {
    throw new Error("Cannot resolve path parameter");
  }
  return resolved;
}
function resolvePathParameter({ parameter, variableResolver, file }) {
  if (isVariablePathParameter(parameter)) {
    const variable = typeof parameter === "string" ? parameter : parameter.variable;
    const resolvedVariable = variableResolver.getDeclaration(variable, file);
    if (resolvedVariable == null) {
      return void 0;
    }
    const rawType = typeof resolvedVariable.declaration === "string" ? resolvedVariable.declaration : resolvedVariable.declaration.type;
    return {
      rawType,
      file: resolvedVariable.file
    };
  } else {
    return {
      file,
      rawType: typeof parameter === "string" ? parameter : parameter.type
    };
  }
}
function convertHttpMethod(method) {
  switch (method) {
    case "GET":
      return HttpMethod.Get;
    case "POST":
      return HttpMethod.Post;
    case "PUT":
      return HttpMethod.Put;
    case "PATCH":
      return HttpMethod.Patch;
    case "DELETE":
      return HttpMethod.Delete;
    default:
      assertNever(method);
  }
}
async function convertHttpHeader({ headerKey, header, file }) {
  const { name } = getHeaderName2({ headerKey, header });
  return {
    ...await convertDeclaration(header),
    name: file.casingsGenerator.generateNameAndWireValue({
      wireValue: headerKey,
      name
    }),
    valueType: file.parseTypeReference(header),
    env: typeof header === "string" ? void 0 : header.env
  };
}
function getHeaderName2({ headerKey, header }) {
  if (typeof header !== "string") {
    if (header.name != null) {
      return {
        name: header.name,
        wasExplicitlySet: true
      };
    }
  }
  return {
    name: headerKey,
    wasExplicitlySet: false
  };
}
function convertTransportToEncoding(transport, service) {
  switch (transport.type) {
    case "http":
      return {
        json: {},
        proto: void 0
      };
    case "grpc":
      return {
        json: void 0,
        proto: {}
      };
    default:
      assertNever(transport);
  }
}

// ../../cli/generation/ir-generator/lib/converters/constants.js
function generateFernConstants(casingsGenerator) {
  return {
    errorInstanceIdKey: casingsGenerator.generateNameAndWireValue({
      wireValue: "errorInstanceId",
      name: "errorInstanceId"
    })
  };
}

// ../../cli/generation/ir-generator/lib/utils/isRootFernFilepath.js
function isRootFernFilepath({ fernFilePath }) {
  return fernFilePath.packagePath.length === 0 && fernFilePath.file == null;
}

// ../../cli/generation/ir-generator/lib/converters/convertOAuthRefreshEndpoint.js
async function convertOAuthRefreshEndpoint({ endpointResolver, propertyResolver, file, refreshTokenEndpoint }) {
  const resolvedEndpoint = await endpointResolver.resolveEndpointOrThrow({
    endpoint: refreshTokenEndpoint.endpoint,
    file
  });
  return {
    endpointReference: {
      endpointId: IdGenerator.generateEndpointIdFromResolvedEndpoint(resolvedEndpoint),
      serviceId: IdGenerator.generateServiceIdFromFernFilepath(resolvedEndpoint.file.fernFilepath),
      subpackageId: !isRootFernFilepath({ fernFilePath: resolvedEndpoint.file.fernFilepath }) ? IdGenerator.generateSubpackageId(resolvedEndpoint.file.fernFilepath) : void 0
    },
    requestProperties: {
      refreshToken: await propertyResolver.resolveRequestPropertyOrThrow({
        file,
        endpoint: refreshTokenEndpoint.endpoint,
        propertyComponents: refreshTokenEndpoint.requestProperties.refresh_token
      })
    },
    responseProperties: {
      accessToken: await propertyResolver.resolveResponsePropertyOrThrow({
        file,
        endpoint: refreshTokenEndpoint.endpoint,
        propertyComponents: refreshTokenEndpoint.responseProperties.access_token
      }),
      expiresIn: refreshTokenEndpoint.responseProperties.expires_in != null ? await propertyResolver.resolveResponsePropertyOrThrow({
        file,
        endpoint: refreshTokenEndpoint.endpoint,
        propertyComponents: refreshTokenEndpoint.responseProperties.expires_in
      }) : void 0,
      refreshToken: refreshTokenEndpoint.responseProperties.refresh_token != null ? await propertyResolver.resolveResponsePropertyOrThrow({
        file,
        endpoint: refreshTokenEndpoint.endpoint,
        propertyComponents: refreshTokenEndpoint.responseProperties.refresh_token
      }) : void 0
    }
  };
}

// ../../cli/generation/ir-generator/lib/converters/convertOAuthTokenEndpoint.js
async function convertOAuthTokenEndpoint({ endpointResolver, propertyResolver, file, tokenEndpoint }) {
  const resolvedEndpoint = await endpointResolver.resolveEndpointOrThrow({
    endpoint: tokenEndpoint.endpoint,
    file
  });
  return {
    endpointReference: {
      endpointId: IdGenerator.generateEndpointIdFromResolvedEndpoint(resolvedEndpoint),
      serviceId: IdGenerator.generateServiceIdFromFernFilepath(resolvedEndpoint.file.fernFilepath),
      subpackageId: !isRootFernFilepath({ fernFilePath: resolvedEndpoint.file.fernFilepath }) ? IdGenerator.generateSubpackageId(resolvedEndpoint.file.fernFilepath) : void 0
    },
    requestProperties: {
      clientId: await propertyResolver.resolveRequestPropertyOrThrow({
        file,
        endpoint: tokenEndpoint.endpoint,
        propertyComponents: tokenEndpoint.requestProperties.client_id
      }),
      clientSecret: await propertyResolver.resolveRequestPropertyOrThrow({
        file,
        endpoint: tokenEndpoint.endpoint,
        propertyComponents: tokenEndpoint.requestProperties.client_secret
      }),
      scopes: tokenEndpoint.requestProperties.scopes != null ? await propertyResolver.resolveRequestPropertyOrThrow({
        file,
        endpoint: tokenEndpoint.endpoint,
        propertyComponents: tokenEndpoint.requestProperties.scopes
      }) : void 0
    },
    responseProperties: {
      accessToken: await propertyResolver.resolveResponsePropertyOrThrow({
        file,
        endpoint: tokenEndpoint.endpoint,
        propertyComponents: tokenEndpoint.responseProperties.access_token
      }),
      expiresIn: tokenEndpoint.responseProperties.expires_in != null ? await propertyResolver.resolveResponsePropertyOrThrow({
        file,
        endpoint: tokenEndpoint.endpoint,
        propertyComponents: tokenEndpoint.responseProperties.expires_in
      }) : void 0,
      refreshToken: tokenEndpoint.responseProperties.refresh_token != null ? await propertyResolver.resolveResponsePropertyOrThrow({
        file,
        endpoint: tokenEndpoint.endpoint,
        propertyComponents: tokenEndpoint.responseProperties.refresh_token
      }) : void 0
    }
  };
}

// ../../cli/generation/ir-generator/lib/converters/convertOAuthClientCredentials.js
async function convertOAuthClientCredentials({ propertyResolver, endpointResolver, file, oauthScheme, tokenEndpoint, refreshTokenEndpoint }) {
  const oauthTokenEndpoint = await convertOAuthTokenEndpoint({
    propertyResolver,
    endpointResolver,
    file,
    tokenEndpoint
  });
  if (oauthTokenEndpoint == null) {
    throw new Error("Failed to convert OAuth token endpoint.");
  }
  const refreshEndpoint = refreshTokenEndpoint != null ? await convertOAuthRefreshEndpoint({
    propertyResolver,
    endpointResolver,
    file,
    refreshTokenEndpoint
  }) : void 0;
  return {
    clientIdEnvVar: oauthScheme["client-id-env"],
    clientSecretEnvVar: oauthScheme["client-secret-env"],
    tokenPrefix: oauthScheme["token-prefix"],
    tokenHeader: oauthScheme["token-header"],
    scopes: oauthScheme.scopes,
    tokenEndpoint: oauthTokenEndpoint,
    refreshEndpoint
  };
}

// ../../cli/generation/ir-generator/lib/converters/convertOAuthUtils.js
var DEFAULT_TOKEN_ENDPOINT = {
  requestProperties: {
    type: "access_token",
    client_id: ["client_id"],
    client_secret: ["client_secret"],
    scopes: void 0
  },
  responseProperties: {
    type: "access_token",
    access_token: ["access_token"],
    expires_in: void 0,
    refresh_token: void 0
  }
};
var DEFAULT_REFRESH_TOKEN_ENDPOINT = {
  requestProperties: {
    type: "refresh_token",
    refresh_token: ["refresh_token"]
  },
  responseProperties: {
    type: "access_token",
    access_token: ["access_token"],
    refresh_token: void 0,
    expires_in: void 0
  }
};
function getTokenEndpoint(oauthSchema) {
  return {
    endpoint: oauthSchema["get-token"].endpoint,
    requestProperties: getTokenEndpointRequestProperties({
      requestProperties: oauthSchema["get-token"]?.["request-properties"]
    }),
    responseProperties: getTokenEndpointResponseProperties({
      responseProperties: oauthSchema["get-token"]?.["response-properties"]
    })
  };
}
function getRefreshTokenEndpoint(oauthSchema) {
  if (oauthSchema["refresh-token"] == null) {
    return void 0;
  }
  return {
    endpoint: oauthSchema["refresh-token"].endpoint,
    requestProperties: getRefreshTokenEndpointRequestProperties({
      requestProperties: oauthSchema["refresh-token"]?.["request-properties"]
    }),
    responseProperties: getRefreshTokenEndpointResponseProperties({
      responseProperties: oauthSchema["refresh-token"]?.["response-properties"]
    })
  };
}
function getTokenEndpointRequestProperties({ requestProperties }) {
  if (requestProperties == null) {
    return DEFAULT_TOKEN_ENDPOINT.requestProperties;
  }
  const maybeClientId = requestProperties["client-id"];
  const maybeClientSecret = requestProperties["client-secret"];
  const maybeScopes = requestProperties.scopes;
  return {
    type: "access_token",
    client_id: maybeClientId != null ? getRequestPropertyComponents(maybeClientId) : DEFAULT_TOKEN_ENDPOINT.requestProperties.client_id,
    client_secret: maybeClientSecret != null ? getRequestPropertyComponents(maybeClientSecret) : DEFAULT_TOKEN_ENDPOINT.requestProperties.client_secret,
    scopes: maybeScopes != null ? getRequestPropertyComponents(maybeScopes) : DEFAULT_TOKEN_ENDPOINT.requestProperties.scopes
  };
}
function getTokenEndpointResponseProperties({ responseProperties }) {
  return getTokenEndpointResponsePropertiesWithDefault({
    responseProperties,
    defaultValue: DEFAULT_TOKEN_ENDPOINT.responseProperties
  });
}
function getRefreshTokenEndpointRequestProperties({ requestProperties }) {
  if (requestProperties == null) {
    return DEFAULT_REFRESH_TOKEN_ENDPOINT.requestProperties;
  }
  const maybeRefreshToken = requestProperties["refresh-token"];
  return {
    type: "refresh_token",
    refresh_token: maybeRefreshToken != null ? getRequestPropertyComponents(maybeRefreshToken) : DEFAULT_REFRESH_TOKEN_ENDPOINT.requestProperties.refresh_token
  };
}
function getRefreshTokenEndpointResponseProperties({ responseProperties }) {
  return getTokenEndpointResponsePropertiesWithDefault({
    responseProperties,
    defaultValue: DEFAULT_REFRESH_TOKEN_ENDPOINT.responseProperties
  });
}
function getTokenEndpointResponsePropertiesWithDefault({ responseProperties, defaultValue }) {
  if (responseProperties == null) {
    return defaultValue;
  }
  const maybeAccessToken = responseProperties["access-token"];
  const maybeExpiresIn = responseProperties["expires-in"];
  const maybeRefreshToken = responseProperties["refresh-token"];
  return {
    type: "access_token",
    access_token: maybeAccessToken != null ? getResponsePropertyComponents(maybeAccessToken) : defaultValue.access_token,
    expires_in: maybeExpiresIn != null ? getResponsePropertyComponents(maybeExpiresIn) : defaultValue.expires_in,
    refresh_token: maybeRefreshToken != null ? getResponsePropertyComponents(maybeRefreshToken) : defaultValue.refresh_token
  };
}

// ../../cli/generation/ir-generator/lib/converters/convertApiAuth.js
async function convertApiAuth({ rawApiFileSchema, file, propertyResolver, endpointResolver }) {
  if (rawApiFileSchema.auth == null) {
    return {
      docs: void 0,
      requirement: AuthSchemesRequirement.All,
      schemes: []
    };
  }
  const docs = typeof rawApiFileSchema.auth !== "string" ? rawApiFileSchema.auth.docs : void 0;
  return visitRawApiAuth(rawApiFileSchema.auth, {
    single: async (authScheme) => {
      const schemaReference = await convertSchemeReference({
        reference: authScheme,
        authSchemeDeclarations: rawApiFileSchema["auth-schemes"],
        file,
        propertyResolver,
        endpointResolver
      });
      return {
        docs,
        requirement: AuthSchemesRequirement.All,
        schemes: [schemaReference]
      };
    },
    any: async ({ any: any3 }) => ({
      docs,
      requirement: AuthSchemesRequirement.Any,
      schemes: await Promise.all(any3.map(async (schemeReference) => await convertSchemeReference({
        reference: schemeReference,
        authSchemeDeclarations: rawApiFileSchema["auth-schemes"],
        file,
        propertyResolver,
        endpointResolver
      })))
    })
  });
}
async function convertSchemeReference({ reference, authSchemeDeclarations, file, propertyResolver, endpointResolver }) {
  const convertNamedAuthSchemeReference = (reference2, docs) => {
    const declaration = authSchemeDeclarations?.[reference2];
    if (declaration == null) {
      throw new Error("Unknown auth scheme: " + reference2);
    }
    return visitRawAuthSchemeDeclaration(declaration, {
      header: async (rawHeader) => AuthScheme.header({
        docs,
        name: file.casingsGenerator.generateNameAndWireValue({
          name: rawHeader.name ?? reference2,
          wireValue: rawHeader.header
        }),
        valueType: file.parseTypeReference(rawHeader.type ?? "string"),
        prefix: rawHeader.prefix,
        headerEnvVar: rawHeader.env
      }),
      basic: async (rawScheme) => generateBasicAuth({
        file,
        docs,
        rawScheme
      }),
      bearer: async (rawScheme) => generateBearerAuth({
        file,
        docs,
        rawScheme
      }),
      oauth: async (rawScheme) => await generateOAuth({
        file,
        docs,
        rawScheme,
        propertyResolver,
        endpointResolver
      })
    });
  };
  const scheme = typeof reference === "string" ? reference : reference.scheme;
  switch (scheme) {
    case "bearer":
      return generateBearerAuth({
        file,
        docs: void 0,
        rawScheme: void 0
      });
    case "basic":
      return generateBasicAuth({
        file,
        docs: void 0,
        rawScheme: void 0
      });
    case "oauth":
      return await generateOAuth({
        file,
        docs: void 0,
        rawScheme: void 0,
        propertyResolver,
        endpointResolver
      });
    default:
      return convertNamedAuthSchemeReference(scheme, typeof reference !== "string" ? reference.docs : void 0);
  }
}
function generateBearerAuth({ file, docs, rawScheme }) {
  return AuthScheme.bearer({
    docs,
    token: file.casingsGenerator.generateName(rawScheme?.token?.name ?? "token"),
    tokenEnvVar: rawScheme?.token?.env
  });
}
function generateBasicAuth({ file, docs, rawScheme }) {
  return AuthScheme.basic({
    docs,
    username: file.casingsGenerator.generateName(rawScheme?.username?.name ?? "username"),
    usernameEnvVar: rawScheme?.username?.env,
    password: file.casingsGenerator.generateName(rawScheme?.password?.name ?? "password"),
    passwordEnvVar: rawScheme?.password?.env
  });
}
async function generateOAuth({ file, docs, rawScheme, propertyResolver, endpointResolver }) {
  switch (rawScheme?.type) {
    case "client-credentials":
      return AuthScheme.oauth({
        docs,
        configuration: OAuthConfiguration.clientCredentials(await convertOAuthClientCredentials({
          propertyResolver,
          endpointResolver,
          file,
          oauthScheme: rawScheme,
          tokenEndpoint: getTokenEndpoint(rawScheme),
          refreshTokenEndpoint: getRefreshTokenEndpoint(rawScheme)
        }))
      });
    default:
      throw new Error(`Unknown OAuth type: '${rawScheme?.type}'`);
  }
}

// ../../cli/generation/ir-generator/lib/converters/convertApiVersionScheme.js
async function convertApiVersionScheme({ file, rawApiFileSchema }) {
  if (rawApiFileSchema.version == null) {
    return void 0;
  }
  return ApiVersionScheme.header({
    header: await convertHeader({
      file,
      header: rawApiFileSchema.version.header
    }),
    value: await convertEnum2({
      file,
      versionDeclaration: rawApiFileSchema.version
    })
  });
}
async function convertHeader({ file, header }) {
  if (typeof header === "string") {
    return await convertHttpHeader({
      file,
      headerKey: header,
      header: {
        type: "string"
      }
    });
  }
  return await convertHttpHeader({
    file,
    headerKey: header.value,
    header: {
      type: "string",
      name: header.name,
      env: header.env
    }
  });
}
async function convertEnum2({ file, versionDeclaration }) {
  return await convertEnumTypeDeclaration({
    _enum: {
      default: versionDeclaration.default,
      enum: versionDeclaration.values
    },
    file
  });
}

// ../../cli/generation/ir-generator/lib/converters/convertChannel.js
async function convertChannel({ channel, typeResolver, exampleResolver, variableResolver, file, workspace }) {
  const messages = [];
  for (const [messageId, message] of Object.entries(channel.messages ?? {})) {
    messages.push({
      type: messageId,
      availability: convertAvailability(message.availability),
      docs: message.docs,
      origin: message.origin,
      body: convertMessageSchema({ body: message.body, file }),
      displayName: message["display-name"]
    });
  }
  return {
    availability: convertAvailability(channel.availability),
    path: constructHttpPath(channel.path),
    auth: channel.auth,
    // since there's only 1 channel per file, we can use the file name as the channel's name
    name: file.fernFilepath.file ?? file.casingsGenerator.generateName(channel["display-name"] ?? channel.path),
    displayName: channel["display-name"],
    headers: channel.headers != null ? await Promise.all(Object.entries(channel.headers).map(([headerKey, header]) => convertHttpHeader({ headerKey, header, file }))) : [],
    docs: channel.docs,
    pathParameters: channel["path-parameters"] != null ? await convertPathParameters2({
      pathParameters: channel["path-parameters"],
      location: PathParameterLocation.Endpoint,
      file,
      variableResolver
    }) : [],
    queryParameters: channel["query-parameters"] != null ? await Promise.all(Object.entries(channel["query-parameters"]).map(async ([queryParameterKey, queryParameter]) => {
      const { name } = getQueryParameterName({ queryParameterKey, queryParameter });
      const valueType = file.parseTypeReference(queryParameter);
      return {
        ...await convertDeclaration(queryParameter),
        name: file.casingsGenerator.generateNameAndWireValue({
          wireValue: queryParameterKey,
          name
        }),
        valueType,
        allowMultiple: typeof queryParameter !== "string" && queryParameter["allow-multiple"] != null ? queryParameter["allow-multiple"] : false
      };
    })) : [],
    messages: Object.values(messages),
    examples: (channel.examples ?? []).map((example) => {
      const convertedPathParameters = convertChannelPathParameters({
        channel,
        example,
        typeResolver,
        exampleResolver,
        variableResolver,
        file,
        workspace
      });
      return {
        name: example.name != null ? file.casingsGenerator.generateName(example.name) : void 0,
        docs: example.docs,
        url: buildUrl2({ channel, example, pathParams: convertedPathParameters }),
        ...convertedPathParameters,
        ...convertHeaders2({ channel, example, typeResolver, exampleResolver, file, workspace }),
        queryParameters: example["query-parameters"] != null ? Object.entries(example["query-parameters"]).map(([wireKey, value]) => {
          const queryParameterDeclaration = channel["query-parameters"]?.[wireKey];
          if (queryParameterDeclaration == null) {
            throw new Error(`Query parameter ${wireKey} does not exist`);
          }
          return {
            name: file.casingsGenerator.generateNameAndWireValue({
              name: getQueryParameterName({
                queryParameterKey: wireKey,
                queryParameter: queryParameterDeclaration
              }).name,
              wireValue: wireKey
            }),
            value: convertTypeReferenceExample({
              example: value,
              rawTypeBeingExemplified: typeof queryParameterDeclaration === "string" ? queryParameterDeclaration : queryParameterDeclaration.type,
              typeResolver,
              exampleResolver,
              fileContainingRawTypeReference: file,
              fileContainingExample: file,
              workspace
            }),
            shape: getQueryParamaterDeclationShape2({ queryParameter: queryParameterDeclaration })
          };
        }) : [],
        messages: example.messages.map((messageExample) => {
          const message = channel.messages?.[messageExample.type];
          if (message == null) {
            throw new Error(`Message ${messageExample.type} does not exist`);
          }
          return {
            type: messageExample.type,
            body: convertExampleWebSocketMessageBody({
              message,
              example: messageExample.body,
              typeResolver,
              exampleResolver,
              file,
              workspace
            })
          };
        })
      };
    })
  };
}
function getQueryParamaterDeclationShape2({ queryParameter }) {
  const isAllowMultiple = typeof queryParameter !== "string" && queryParameter["allow-multiple"] != null ? queryParameter["allow-multiple"] : false;
  return isAllowMultiple ? ExampleQueryParameterShape.exploded() : ExampleQueryParameterShape.single();
}
function convertExampleWebSocketMessageBody({ message, example, typeResolver, exampleResolver, file, workspace }) {
  if (!isInlineMessageBody(message.body)) {
    return ExampleWebSocketMessageBody.reference(convertTypeReferenceExample({
      example,
      rawTypeBeingExemplified: typeof message.body !== "string" ? message.body.type : message.body,
      typeResolver,
      exampleResolver,
      fileContainingRawTypeReference: file,
      fileContainingExample: file,
      workspace
    }));
  }
  if (!isPlainObject2(example)) {
    throw new Error("Example must be an object");
  }
  const exampleProperties = [];
  for (const [wireKey, propertyExample] of Object.entries(example)) {
    const inlinedRequestPropertyDeclaration = message.body.properties?.[wireKey];
    if (inlinedRequestPropertyDeclaration != null) {
      exampleProperties.push({
        name: file.casingsGenerator.generateNameAndWireValue({
          name: getPropertyName({ propertyKey: wireKey, property: inlinedRequestPropertyDeclaration }).name,
          wireValue: wireKey
        }),
        value: convertTypeReferenceExample({
          example: propertyExample,
          rawTypeBeingExemplified: typeof inlinedRequestPropertyDeclaration !== "string" ? inlinedRequestPropertyDeclaration.type : inlinedRequestPropertyDeclaration,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: file,
          fileContainingExample: file,
          workspace
        }),
        originalTypeDeclaration: void 0
      });
    } else {
      const originalTypeDeclaration = getOriginalTypeDeclarationForPropertyFromExtensions({
        extends_: message.body.extends,
        wirePropertyKey: wireKey,
        typeResolver,
        file
      });
      if (originalTypeDeclaration == null) {
        throw new Error("Could not find original type declaration for property: " + wireKey);
      }
      exampleProperties.push({
        name: file.casingsGenerator.generateNameAndWireValue({
          name: getPropertyName({ propertyKey: wireKey, property: originalTypeDeclaration.rawPropertyType }).name,
          wireValue: wireKey
        }),
        value: convertTypeReferenceExample({
          example: propertyExample,
          rawTypeBeingExemplified: typeof originalTypeDeclaration.rawPropertyType === "string" ? originalTypeDeclaration.rawPropertyType : originalTypeDeclaration.rawPropertyType.type,
          typeResolver,
          exampleResolver,
          fileContainingRawTypeReference: originalTypeDeclaration.file,
          fileContainingExample: file,
          workspace
        }),
        originalTypeDeclaration: originalTypeDeclaration.typeName
      });
    }
  }
  return ExampleWebSocketMessageBody.inlinedBody({
    jsonExample: exampleResolver.resolveAllReferencesInExampleOrThrow({ example, file }).resolvedExample,
    properties: exampleProperties
  });
}
function convertMessageSchema({ body, file }) {
  if (typeof body === "string") {
    return WebSocketMessageBody.reference({
      docs: void 0,
      bodyType: file.parseTypeReference(body)
    });
  } else if (isReferencedWebhookPayloadSchema(body)) {
    return WebSocketMessageBody.reference({
      docs: void 0,
      bodyType: file.parseTypeReference(body.type)
    });
  } else {
    return WebSocketMessageBody.inlinedBody({
      name: file.casingsGenerator.generateName(body.name),
      extends: getExtensionsAsList(body.extends ?? []).map((extended) => parseTypeName({ typeName: extended, file })),
      properties: []
    });
  }
}
function isReferencedWebhookPayloadSchema(payload) {
  return payload.type != null;
}
function convertChannelPathParameters({ channel, example, typeResolver, exampleResolver, variableResolver, file, workspace }) {
  const pathParameters = [];
  const buildExamplePathParameter = ({ name, pathParameterDeclaration, examplePathParameter }) => {
    const resolvedPathParameter = resolvePathParameterOrThrow({
      parameter: pathParameterDeclaration,
      variableResolver,
      file
    });
    return {
      name,
      value: convertTypeReferenceExample({
        example: examplePathParameter,
        rawTypeBeingExemplified: resolvedPathParameter.rawType,
        typeResolver,
        exampleResolver,
        fileContainingRawTypeReference: resolvedPathParameter.file,
        fileContainingExample: file,
        workspace
      })
    };
  };
  if (example["path-parameters"] != null) {
    const rawEndpointPathParameters = getEndpointPathParameters(channel);
    for (const [key, examplePathParameter] of Object.entries(example["path-parameters"])) {
      const pathParameterDeclaration = rawEndpointPathParameters[key];
      if (pathParameterDeclaration != null) {
        pathParameters.push(buildExamplePathParameter({
          name: file.casingsGenerator.generateName(key),
          pathParameterDeclaration,
          examplePathParameter
        }));
      } else {
        throw new Error(`Path parameter ${key} does not exist`);
      }
    }
  }
  return { pathParameters };
}
function convertHeaders2({ channel, example, typeResolver, exampleResolver, file, workspace }) {
  const headers = [];
  if (example.headers != null) {
    for (const [wireKey, exampleHeader] of Object.entries(example.headers)) {
      const headerDeclaration = channel.headers?.[wireKey];
      if (headerDeclaration != null) {
        headers.push({
          name: file.casingsGenerator.generateNameAndWireValue({
            name: getHeaderName2({ headerKey: wireKey, header: headerDeclaration }).name,
            wireValue: wireKey
          }),
          value: convertTypeReferenceExample({
            example: exampleHeader,
            rawTypeBeingExemplified: typeof headerDeclaration === "string" ? headerDeclaration : headerDeclaration.type,
            typeResolver,
            exampleResolver,
            fileContainingRawTypeReference: file,
            fileContainingExample: file,
            workspace
          })
        });
      } else {
        throw new Error(`Heder ${wireKey} does not exist`);
      }
    }
  }
  return { headers };
}
function buildUrl2({ channel, example, pathParams }) {
  let url = channel.path;
  if (example["path-parameters"] != null) {
    for (const parameter of [...pathParams.pathParameters]) {
      url = url.replaceAll(`{${parameter.name.originalName}}`, `${parameter.value.jsonExample}`);
    }
  }
  return url;
}
function isInlineMessageBody(messageBody) {
  if (typeof messageBody === "string") {
    return false;
  }
  return messageBody.extends != null || messageBody.properties != null;
}

// ../../cli/generation/ir-generator/lib/converters/convertEnvironments.js
function convertEnvironments({ rawApiFileSchema: { "default-environment": defaultEnvironment, environments }, casingsGenerator }) {
  if (environments == null) {
    return void 0;
  }
  const firstEnvironment = Object.values(environments)[0];
  if (firstEnvironment == null) {
    return void 0;
  }
  return {
    defaultEnvironment: defaultEnvironment ?? void 0,
    environments: visitRawEnvironmentDeclaration(firstEnvironment, {
      singleBaseUrl: () => Environments.singleBaseUrl(convertSingleBaseUrlEnvironments({ environments, casingsGenerator })),
      multipleBaseUrls: (firstMultipleBaseUrlsEnvironment) => Environments.multipleBaseUrls(convertMultipleBaseUrlEnvironments({
        baseUrls: Object.keys(firstMultipleBaseUrlsEnvironment.urls),
        environments,
        casingsGenerator
      }))
    })
  };
}
function convertSingleBaseUrlEnvironments({ environments, casingsGenerator }) {
  return {
    environments: Object.entries(environments).map(([environmentName, rawEnvironment]) => visitRawEnvironmentDeclaration(rawEnvironment, {
      singleBaseUrl: (singleBaseUrlEnvironment) => ({
        docs: typeof singleBaseUrlEnvironment === "string" ? void 0 : singleBaseUrlEnvironment.docs,
        id: environmentName,
        name: casingsGenerator.generateName(environmentName),
        url: removeTrailingSlash(typeof singleBaseUrlEnvironment === "string" ? singleBaseUrlEnvironment : singleBaseUrlEnvironment.url)
      }),
      multipleBaseUrls: () => {
        throw new Error(`Environment ${environmentName} has multiple base URLs`);
      }
    }))
  };
}
function convertMultipleBaseUrlEnvironments({ baseUrls, environments, casingsGenerator }) {
  return {
    baseUrls: baseUrls.map((baseUrl) => ({
      id: baseUrl,
      name: casingsGenerator.generateName(baseUrl)
    })),
    environments: Object.entries(environments).map(([environmentName, rawEnvironment]) => visitRawEnvironmentDeclaration(rawEnvironment, {
      multipleBaseUrls: (multipleBaseUrlsEnvironment) => ({
        docs: multipleBaseUrlsEnvironment.docs,
        id: environmentName,
        name: casingsGenerator.generateName(environmentName),
        urls: mapValues_default(multipleBaseUrlsEnvironment.urls, (url) => removeTrailingSlash(url))
      }),
      singleBaseUrl: () => {
        throw new Error(`Environment ${environmentName} does not have multiple base URLs`);
      }
    }))
  };
}
function removeTrailingSlash(url) {
  return url.endsWith("/") ? url.slice(0, -1) : url;
}

// ../../cli/generation/ir-generator/lib/converters/convertErrorDeclaration.js
function convertErrorDeclaration({ errorName, errorDeclaration, file, typeResolver, exampleResolver, workspace }) {
  const examples = [];
  if (errorDeclaration.type != null && errorDeclaration.examples != null) {
    for (const example of errorDeclaration.examples) {
      examples.push({
        name: example.name != null ? file.casingsGenerator.generateName(example.name) : void 0,
        docs: example.docs,
        jsonExample: exampleResolver.resolveAllReferencesInExampleOrThrow({
          example: example.value,
          file
        }).resolvedExample,
        shape: convertTypeReferenceExample({
          example: example.value,
          rawTypeBeingExemplified: errorDeclaration.type,
          fileContainingRawTypeReference: file,
          fileContainingExample: file,
          typeResolver,
          exampleResolver,
          workspace
        })
      });
    }
  }
  return {
    name: parseErrorName({
      errorName,
      file
    }),
    discriminantValue: file.casingsGenerator.generateNameAndWireValue({
      wireValue: errorName,
      name: errorName
    }),
    docs: typeof errorDeclaration !== "string" ? errorDeclaration.docs : void 0,
    statusCode: errorDeclaration["status-code"],
    type: errorDeclaration.type != null ? file.parseTypeReference(errorDeclaration.type) : void 0,
    examples
  };
}

// ../../cli/generation/ir-generator/lib/converters/convertErrorDiscriminationStrategy.js
var ERROR_CONTENT_PROPERTY_NAME = "content";
function convertErrorDiscriminationStrategy(rawStrategy, file) {
  if (rawStrategy == null || rawStrategy.strategy === "status-code") {
    return ErrorDiscriminationStrategy.statusCode();
  }
  switch (rawStrategy.strategy) {
    case "property":
      return ErrorDiscriminationStrategy.property({
        discriminant: file.casingsGenerator.generateNameAndWireValue({
          name: rawStrategy["property-name"],
          wireValue: rawStrategy["property-name"]
        }),
        contentProperty: file.casingsGenerator.generateNameAndWireValue({
          name: ERROR_CONTENT_PROPERTY_NAME,
          wireValue: ERROR_CONTENT_PROPERTY_NAME
        })
      });
    default:
      assertNever(rawStrategy);
  }
}

// ../../cli/generation/ir-generator/lib/converters/convertReadmeConfig.js
function convertReadmeConfig({ readme, services }) {
  const readmeEndpointCache = new ReadmeEndpointCache(services);
  return {
    apiReferenceLink: readme.apiReferenceLink,
    bannerLink: readme.bannerLink,
    introduction: readme.introduction,
    defaultEndpoint: readme.defaultEndpoint != null ? readmeEndpointCache.getEndpointForReadmeOrThrow(readme.defaultEndpoint).id : void 0,
    features: readme.features != null ? Object.fromEntries(Object.entries(readme.features).map(([featureId, endpoints]) => {
      return [
        featureId,
        endpoints.map((endpoint) => readmeEndpointCache.getEndpointForReadmeOrThrow(endpoint).id)
      ];
    })) : void 0
  };
}
var ReadmeEndpointCache = class {
  endpoints = {};
  constructor(services) {
    this.endpoints = this.buildEndpoints(services);
  }
  getEndpointForReadme(readmeEndpoint) {
    const readmeEndpointObject = getReadmeEndpointObject({ endpoint: readmeEndpoint });
    const endpointKey = this.getEndpointKeyForReadmeEndpoint(readmeEndpointObject);
    return this.endpoints[endpointKey];
  }
  getEndpointForReadmeOrThrow(readmeEndpoint) {
    const endpoint = this.getEndpointForReadme(readmeEndpoint);
    if (endpoint == null) {
      throw new Error(`Endpoint not found for ${JSON.stringify(readmeEndpoint)}`);
    }
    return endpoint;
  }
  buildEndpoints(services) {
    const endpoints = {};
    for (const service of Object.values(services)) {
      for (const endpoint of service.endpoints) {
        endpoints[this.getEndpointKeyForHttpEndpoint(endpoint)] = endpoint;
      }
    }
    return endpoints;
  }
  getEndpointKeyForReadmeEndpoint(endpoint) {
    return this.getEndpointKey({
      method: endpoint.method,
      path: endpoint.path,
      stream: endpoint.stream ?? false
    });
  }
  getEndpointKeyForHttpEndpoint(endpoint) {
    return this.getEndpointKey({
      method: endpoint.method,
      path: getFullPathForEndpoint(endpoint),
      stream: endpoint.response?.body?.type === "streaming"
    });
  }
  getEndpointKey({ method, path: path5, stream }) {
    return `${method}|${path5}|${stream}`;
  }
};
function getFullPathForEndpoint(endpoint) {
  let url = "";
  if (endpoint.fullPath.head.length > 0) {
    url = urlJoin(url, endpoint.fullPath.head);
  }
  for (const part of endpoint.fullPath.parts) {
    url = urlJoin(url, "{" + part.pathParameter + "}");
    if (part.tail.length > 0) {
      url = urlJoin(url, part.tail);
    }
  }
  return url.startsWith("/") ? url : `/${url}`;
}
function getReadmeEndpointObject({ endpoint }) {
  if (typeof endpoint === "string") {
    const split = endpoint.split(" ");
    if (split.length !== 2 || split[0] == null || split[1] == null) {
      throw new Error(`invalid endpoint string: ${endpoint}`);
    }
    return {
      method: split[0],
      path: split[1]
    };
  }
  return endpoint;
}

// ../../cli/generation/ir-generator/lib/converters/convertWebhookGroup.js
async function convertWebhookGroup({ webhooks, file, typeResolver, exampleResolver, workspace }) {
  const webhookGroup = [];
  for (const [webhookId, webhook] of Object.entries(webhooks)) {
    webhookGroup.push({
      id: IdGenerator.generateWebhookId(file.fernFilepath, webhookId),
      availability: convertAvailability(webhook.availability),
      displayName: webhook["display-name"],
      docs: webhook.docs,
      method: webhook.method,
      name: file.casingsGenerator.generateName(webhookId),
      headers: webhook.headers != null ? await Promise.all(Object.entries(webhook.headers).map(([headerKey, header]) => convertHttpHeader({ headerKey, header, file }))) : [],
      payload: convertWebhookPayloadSchema({ payload: webhook.payload, file }),
      examples: webhook.examples != null ? convertWebhookExamples2({
        webhook,
        examples: webhook.examples,
        file,
        typeResolver,
        exampleResolver,
        workspace
      }) : void 0
    });
  }
  return webhookGroup;
}
function convertWebhookPayloadSchema({ payload, file }) {
  if (typeof payload === "string") {
    return WebhookPayload.reference({
      docs: void 0,
      payloadType: file.parseTypeReference(payload)
    });
  } else if (isReferencedWebhookPayloadSchema2(payload)) {
    return WebhookPayload.reference({
      docs: void 0,
      payloadType: file.parseTypeReference(payload.type)
    });
  } else {
    return WebhookPayload.inlinedPayload({
      name: file.casingsGenerator.generateName(payload.name),
      extends: getExtensionsAsList(payload.extends).map((extended) => parseTypeName({ typeName: extended, file })),
      properties: payload.properties != null ? Object.entries(payload.properties).map(([propertyKey, propertyDefinition]) => convertInlinedRequestProperty2({
        propertyKey,
        propertyDefinition,
        docs: typeof propertyDefinition !== "string" ? propertyDefinition.docs : void 0,
        availability: typeof propertyDefinition !== "string" ? convertAvailability(propertyDefinition.availability) : void 0,
        file
      })) : []
    });
  }
}
function convertInlinedRequestProperty2({ propertyKey, propertyDefinition, docs, availability, file }) {
  return {
    docs,
    availability,
    name: file.casingsGenerator.generateNameAndWireValue({
      wireValue: propertyKey,
      name: getPropertyName({ propertyKey, property: propertyDefinition }).name
    }),
    valueType: file.parseTypeReference(propertyDefinition)
  };
}
function convertWebhookExamples2({ webhook, examples, file, typeResolver, exampleResolver, workspace }) {
  const typeName = typeof webhook.payload === "string" ? webhook.payload : isReferencedWebhookPayloadSchema2(webhook.payload) ? webhook.payload.type : void 0;
  if (typeName != null) {
    return examples.map((example) => ({
      docs: webhook.docs,
      name: example.name != null ? file.casingsGenerator.generateName(example.name) : void 0,
      payload: convertTypeReferenceExample({
        example: example.payload,
        rawTypeBeingExemplified: typeName,
        fileContainingRawTypeReference: file,
        fileContainingExample: file,
        typeResolver,
        exampleResolver,
        workspace
      })
    }));
  }
  if (!isPlainObject2(webhook.payload)) {
    throw new Error(`Example webhook payload is not an object. Got: ${JSON.stringify(webhook.payload)}`);
  }
  return examples.map((example) => ({
    docs: webhook.docs,
    name: example.name != null ? file.casingsGenerator.generateName(example.name) : void 0,
    payload: convertTypeReferenceExample({
      example: example.payload,
      rawTypeBeingExemplified: "map<string, unknown>",
      fileContainingRawTypeReference: file,
      fileContainingExample: file,
      typeResolver,
      exampleResolver,
      workspace
    })
  }));
}
function isReferencedWebhookPayloadSchema2(payload) {
  return payload.type != null;
}

// ../../cli/generation/ir-generator/lib/utils/getPropertiesByAudience.js
function getPropertiesByAudience(properties) {
  const propertiesByAudience = {};
  for (const [property4, propertyDeclaration] of Object.entries(properties)) {
    if (typeof propertyDeclaration === "string") {
      continue;
    }
    for (const audience of propertyDeclaration.audiences ?? []) {
      if (propertiesByAudience[audience] == null) {
        propertiesByAudience[audience] = /* @__PURE__ */ new Set();
      }
      propertiesByAudience[audience]?.add(property4);
    }
  }
  return propertiesByAudience;
}

// ../../cli/generation/ir-generator/lib/converters/convertProtobufType.js
function convertSourceToProtobufType({ name, source }) {
  return ProtobufType.userDefined({
    file: convertProtobufFile({ source }),
    // Use the global casings generator so that the name is not
    // affected by the user's casing settings (e.g. smart-casing).
    name: CASINGS_GENERATOR.generateName(name)
  });
}
function maybeConvertEncodingToProtobufType({ encoding }) {
  if (encoding.proto != null && encoding.proto.type != null) {
    const wellKnownType = maybeConvertWellKnownProtobufType({ type: encoding.proto.type });
    if (wellKnownType != null) {
      return wellKnownType;
    }
  }
  return void 0;
}
function maybeConvertWellKnownProtobufType({ type: type2 }) {
  switch (type2) {
    case "google.protobuf.Any":
      return ProtobufType.wellKnown(WellKnownProtobufType.any());
    case "google.protobuf.Api":
      return ProtobufType.wellKnown(WellKnownProtobufType.api());
    case "google.protobuf.BoolValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.boolValue());
    case "google.protobuf.BytesValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.bytesValue());
    case "google.protobuf.DoubleValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.doubleValue());
    case "google.protobuf.Duration":
      return ProtobufType.wellKnown(WellKnownProtobufType.duration());
    case "google.protobuf.Empty":
      return ProtobufType.wellKnown(WellKnownProtobufType.empty());
    case "google.protobuf.Enum":
      return ProtobufType.wellKnown(WellKnownProtobufType.enum());
    case "google.protobuf.EnumValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.enumValue());
    case "google.protobuf.Field":
      return ProtobufType.wellKnown(WellKnownProtobufType.field());
    case "google.protobuf.FieldCardinality":
      return ProtobufType.wellKnown(WellKnownProtobufType.fieldCardinality());
    case "google.protobuf.FieldKind":
      return ProtobufType.wellKnown(WellKnownProtobufType.fieldKind());
    case "google.protobuf.FieldMask":
      return ProtobufType.wellKnown(WellKnownProtobufType.fieldMask());
    case "google.protobuf.FloatVlaue":
      return ProtobufType.wellKnown(WellKnownProtobufType.floatValue());
    case "google.protobuf.Int32Value":
      return ProtobufType.wellKnown(WellKnownProtobufType.int32Value());
    case "google.protobuf.Int64Value":
      return ProtobufType.wellKnown(WellKnownProtobufType.int64Value());
    case "google.protobuf.ListValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.listValue());
    case "google.protobuf.Method":
      return ProtobufType.wellKnown(WellKnownProtobufType.method());
    case "google.protobuf.Mixin":
      return ProtobufType.wellKnown(WellKnownProtobufType.mixin());
    case "google.protobuf.NullValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.nullValue());
    case "google.protobuf.Option":
      return ProtobufType.wellKnown(WellKnownProtobufType.option());
    case "google.protobuf.SourceContext":
      return ProtobufType.wellKnown(WellKnownProtobufType.sourceContext());
    case "google.protobuf.StringValue":
      return ProtobufType.wellKnown(WellKnownProtobufType.stringValue());
    case "google.protobuf.Struct":
      return ProtobufType.wellKnown(WellKnownProtobufType.struct());
    case "google.protobuf.Syntax":
      return ProtobufType.wellKnown(WellKnownProtobufType.syntax());
    case "google.protobuf.Timestamp":
      return ProtobufType.wellKnown(WellKnownProtobufType.timestamp());
    case "google.protobuf.Type":
      return ProtobufType.wellKnown(WellKnownProtobufType.type());
    case "google.protobuf.Uint32Value":
      return ProtobufType.wellKnown(WellKnownProtobufType.uint32Value());
    case "google.protobuf.Uint64Value":
      return ProtobufType.wellKnown(WellKnownProtobufType.uint64Value());
    case "google.protobuf.Value":
      return ProtobufType.wellKnown(WellKnownProtobufType.value());
  }
  return void 0;
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertGenericTypeDeclaration.js
async function convertGenericTypeDeclaration({ generic, file, typeResolver }) {
  const genericInstantiation = typeof generic === "string" ? generic : generic.type;
  const maybeGeneric = parseGeneric(genericInstantiation);
  if (maybeGeneric == null) {
    throw new Error(`Invalid generic type definition: ${genericInstantiation}`);
  }
  const resolvedBaseGeneric = typeResolver.getDeclarationOfNamedTypeOrThrow({
    referenceToNamedType: genericInstantiation,
    file
  });
  if (maybeGeneric.arguments && isRawObjectDefinition(resolvedBaseGeneric.declaration)) {
    const genericArgumentDefinitions = parseGeneric(resolvedBaseGeneric.typeName)?.arguments ?? [];
    const newProperties = Object.entries(resolvedBaseGeneric.declaration.properties ?? {}).map(([key, value]) => {
      let maybeReplacedValue = value;
      if (typeof value === "string" && genericArgumentDefinitions?.includes(value)) {
        maybeReplacedValue = maybeGeneric.arguments?.[genericArgumentDefinitions.indexOf(value)] ?? value;
      }
      return [key, maybeReplacedValue];
    });
    return Type.object({
      extends: getExtensionsAsList(resolvedBaseGeneric.declaration.extends).map((extended) => parseTypeName({ typeName: extended, file })),
      properties: await getObjectPropertiesFromRawObjectSchema({ properties: Object.fromEntries(newProperties) }, file),
      extraProperties: resolvedBaseGeneric.declaration["extra-properties"] ?? false,
      extendedProperties: void 0
    });
  }
  throw new Error(`Generic type definition not supported: ${genericInstantiation}`);
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertAliasTypeDeclaration.js
async function convertAliasTypeDeclaration({ alias, file, typeResolver }) {
  const aliasOfStr = typeof alias === "string" ? alias : alias.type;
  if (isGeneric(aliasOfStr)) {
    return await convertGenericTypeDeclaration({ generic: aliasOfStr, file, typeResolver });
  }
  return Type.alias({
    aliasOf: file.parseTypeReference(alias),
    resolvedType: constructResolvedTypeReference({ aliasOf: aliasOfStr, file, typeResolver })
  });
}
function constructResolvedTypeReference({ aliasOf, file, typeResolver }) {
  const resolvedType = typeResolver.resolveTypeOrThrow({ type: aliasOf, file });
  switch (resolvedType._type) {
    case "primitive":
      return ResolvedTypeReference.primitive(resolvedType.originalTypeReference.primitive);
    case "container":
      return ResolvedTypeReference.container(resolvedType.originalTypeReference.container);
    case "unknown":
      return ResolvedTypeReference.unknown();
    case "named": {
      const shapeType = isRawObjectDefinition(resolvedType.declaration) ? ShapeType.Object : isRawDiscriminatedUnionDefinition(resolvedType.declaration) ? ShapeType.Union : isRawEnumDefinition(resolvedType.declaration) ? ShapeType.Enum : isRawUndiscriminatedUnionDefinition(resolvedType.declaration) ? ShapeType.UndiscriminatedUnion : assertNever(resolvedType.declaration);
      return ResolvedTypeReference.named({
        name: resolvedType.name,
        shape: shapeType
      });
    }
  }
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertUndiscriminatedUnionTypeDeclaration.js
function convertUndiscriminatedUnionTypeDeclaration({ union: union3, file }) {
  return Type.undiscriminatedUnion({
    members: union3.union.map((unionMember) => {
      if (typeof unionMember === "string") {
        return {
          docs: void 0,
          type: file.parseTypeReference(unionMember)
        };
      }
      return {
        type: file.parseTypeReference(unionMember),
        docs: unionMember.docs
      };
    })
  });
}

// ../../cli/generation/ir-generator/lib/converters/type-declarations/getReferencedTypesFromRawDeclaration.js
function getObjectRawTypeReferences(objectDeclaration) {
  const types2 = [];
  if (objectDeclaration.extends != null) {
    const extendsArr = typeof objectDeclaration.extends === "string" ? [objectDeclaration.extends] : objectDeclaration.extends;
    types2.push(...extendsArr);
  }
  if (objectDeclaration.properties != null) {
    types2.push(...Object.values(objectDeclaration.properties).map((property4) => typeof property4 === "string" ? property4 : property4.type));
  }
  return types2;
}
function getReferencedTypesFromRawDeclaration({ typeDeclaration, file, typeResolver, seenTypeNames = new SeenTypeNamesImpl() }) {
  const rawTypeReferences = visitRawTypeDeclaration(typeDeclaration, {
    alias: (aliasDeclaration) => {
      const aliasTypeReference = typeof aliasDeclaration === "string" ? aliasDeclaration : aliasDeclaration.type;
      const parsedGeneric = parseGeneric(aliasTypeReference);
      if (parsedGeneric != null) {
        const rawTypeReferences2 = new Set(parsedGeneric.arguments ?? []);
        const resolvedBaseGeneric = typeResolver.getDeclarationOfNamedTypeOrThrow({
          referenceToNamedType: aliasTypeReference,
          file
        });
        const resolvedBaseGenericArguments = parseGeneric(resolvedBaseGeneric.typeName)?.arguments;
        if (isRawObjectDefinition(resolvedBaseGeneric.declaration)) {
          const underlyingObjectRawTypeReferences = getObjectRawTypeReferences(resolvedBaseGeneric.declaration);
          if (resolvedBaseGenericArguments) {
            underlyingObjectRawTypeReferences.filter((typeReference) => !resolvedBaseGenericArguments.includes(typeReference)).forEach((type2) => rawTypeReferences2.add(type2));
          }
        }
        return Array.from(rawTypeReferences2);
      }
      return [aliasTypeReference];
    },
    object: (objectDeclaration) => getObjectRawTypeReferences(objectDeclaration),
    discriminatedUnion: (unionDeclaration) => {
      const types2 = [];
      if (unionDeclaration["base-properties"] != null) {
        types2.push(...Object.values(unionDeclaration["base-properties"]).map((property4) => typeof property4 === "string" ? property4 : property4.type));
      }
      types2.push(...Object.values(unionDeclaration.union).reduce((types3, singleUnionType) => {
        const rawType = typeof singleUnionType === "string" ? singleUnionType : singleUnionType.type;
        if (typeof rawType === "string") {
          types3.push(rawType);
        }
        return types3;
      }, []));
      return types2;
    },
    undiscriminatedUnion: (unionDeclaration) => {
      return Object.values(unionDeclaration.union).reduce((types2, unionMember) => {
        const rawType = typeof unionMember === "string" ? unionMember : unionMember.type;
        if (typeof rawType === "string") {
          types2.push(rawType);
        }
        return types2;
      }, []);
    },
    enum: () => []
  });
  const referencedTypes = [];
  for (const rawTypeReference of rawTypeReferences) {
    const rawNames = recursivelyVisitRawTypeReference({
      type: rawTypeReference,
      _default: void 0,
      validation: void 0,
      visitor: {
        primitive: () => [],
        map: ({ keyType, valueType }) => [...keyType, ...valueType],
        list: (valueType) => valueType,
        optional: (valueType) => valueType,
        set: (valueType) => valueType,
        named: (name) => [name],
        literal: () => [],
        unknown: () => []
      }
    });
    for (const rawName of rawNames) {
      const parsedTypeName = parseTypeName({ typeName: rawName, file });
      if (!seenTypeNames.hasTypeNameBeenSeen(parsedTypeName)) {
        seenTypeNames.addTypeName(parsedTypeName);
        referencedTypes.push(parsedTypeName);
        const maybeDeclaration = typeResolver.getDeclarationOfNamedTypeOrThrow({
          referenceToNamedType: rawName,
          file
        });
        if (isGeneric(maybeDeclaration.typeName)) {
          continue;
        }
        referencedTypes.push(...getReferencedTypesFromRawDeclaration({
          typeDeclaration: maybeDeclaration.declaration,
          file: maybeDeclaration.file,
          typeResolver,
          seenTypeNames
        }));
      }
    }
  }
  return referencedTypes;
}
var SeenTypeNamesImpl = class {
  cache = /* @__PURE__ */ new Set();
  addTypeName(typeName) {
    this.cache.add(this.computeCacheKey(typeName));
  }
  hasTypeNameBeenSeen(typeName) {
    return this.cache.has(this.computeCacheKey(typeName));
  }
  computeCacheKey(typeName) {
    return typeName.fernFilepath.allParts.map((part) => part.originalName).join("/") + ":" + typeName.name.originalName;
  }
};

// ../../cli/generation/ir-generator/lib/converters/type-declarations/convertTypeDeclaration.js
async function convertTypeDeclaration({ typeName, typeDeclaration, file, typeResolver, exampleResolver, sourceResolver, workspace }) {
  const declaration = await convertDeclaration(typeDeclaration);
  const declaredTypeName = parseTypeName({
    typeName,
    file
  });
  const referencedTypes = getReferencedTypesFromRawDeclaration({ typeDeclaration, file, typeResolver });
  let propertiesByAudience = {};
  if (isRawObjectDefinition(typeDeclaration)) {
    propertiesByAudience = getPropertiesByAudience(typeDeclaration.properties ?? {});
  }
  const source = await convertTypeDeclarationSource({
    file,
    typeDeclaration,
    typeName,
    sourceResolver
  });
  return {
    propertiesByAudience,
    typeDeclaration: {
      ...declaration,
      inline: getInline2(typeDeclaration),
      name: declaredTypeName,
      shape: await convertType({ typeDeclaration, file, typeResolver }),
      referencedTypes: new Set(referencedTypes.map((referencedType) => referencedType.typeId)),
      encoding: convertTypeDeclarationEncoding({ typeDeclaration, source }),
      source,
      userProvidedExamples: typeof typeDeclaration !== "string" && typeDeclaration.examples != null ? typeDeclaration.examples.map((example) => ({
        name: example.name != null ? file.casingsGenerator.generateName(example.name) : void 0,
        docs: example.docs,
        jsonExample: exampleResolver.resolveAllReferencesInExampleOrThrow({
          example: example.value,
          file
        }).resolvedExample,
        shape: convertTypeExample({
          typeName: declaredTypeName,
          example: example.value,
          typeResolver,
          exampleResolver,
          typeDeclaration,
          fileContainingType: file,
          fileContainingExample: file,
          workspace
        })
      })) : [],
      autogeneratedExamples: []
    },
    descendantFilepaths: new Set(referencedTypes.map((referencedType) => referencedType.fernFilepath))
  };
}
async function convertType({ typeDeclaration, file, typeResolver }) {
  return await visitRawTypeDeclaration(typeDeclaration, {
    alias: (alias) => convertAliasTypeDeclaration({ alias, file, typeResolver }),
    object: (object3) => convertObjectTypeDeclaration({ object: object3, file }),
    discriminatedUnion: (union3) => convertDiscriminatedUnionTypeDeclaration({ union: union3, file, typeResolver }),
    undiscriminatedUnion: (union3) => convertUndiscriminatedUnionTypeDeclaration({ union: union3, file }),
    enum: async (enum_3) => Type.enum(await convertEnumTypeDeclaration({ _enum: enum_3, file }))
  });
}
async function convertTypeDeclarationSource({ file, typeDeclaration, typeName, sourceResolver }) {
  if (typeof typeDeclaration === "string" || typeDeclaration.source == null && typeDeclaration.encoding == null) {
    return void 0;
  }
  if (typeDeclaration.encoding != null) {
    const maybeProtobufType = maybeConvertEncodingToProtobufType({
      encoding: typeDeclaration.encoding
    });
    if (maybeProtobufType != null) {
      return Source.proto(maybeProtobufType);
    }
  }
  if (typeDeclaration.source == null) {
    return void 0;
  }
  const resolvedSource = await sourceResolver.resolveSourceOrThrow({
    source: typeDeclaration.source,
    relativeFilepath: file.relativeFilepath
  });
  if (resolvedSource == null || resolvedSource.type !== "protobuf") {
    return void 0;
  }
  return Source.proto(convertSourceToProtobufType({
    source: resolvedSource,
    name: typeName
  }));
}
function convertTypeDeclarationEncoding({ typeDeclaration, source }) {
  if (typeof typeDeclaration !== "string" && typeDeclaration.encoding != null) {
    return convertEncoding2(typeDeclaration.encoding);
  }
  return convertSourceToEncoding(source);
}
function convertEncoding2(encodingSchema) {
  return encodingSchema.proto != null ? {
    json: void 0,
    proto: {}
  } : {
    json: {},
    proto: void 0
  };
}
function convertSourceToEncoding(source) {
  return source != null && source.type === "proto" ? {
    json: void 0,
    proto: {}
  } : {
    json: {},
    proto: void 0
  };
}
function getInline2(typeDeclaration) {
  if (typeof typeDeclaration === "string") {
    return void 0;
  }
  if ("inline" in typeDeclaration) {
    return typeDeclaration.inline;
  }
  return void 0;
}

// ../../cli/task-context/lib/LoggableFernCliError.js
var LoggableFernCliError = class _LoggableFernCliError extends Error {
  log;
  constructor(log) {
    super();
    this.log = log;
    Object.setPrototypeOf(this, _LoggableFernCliError.prototype);
  }
};

// ../../cli/generation/ir-generator/lib/utils/getTypeDeclaration.js
function getTypeDeclaration(typeId, types2) {
  const maybeTypeDeclaration = types2[typeId];
  if (maybeTypeDeclaration == null) {
    throw new LoggableFernCliError(`Illegal Error: Failed to load type declaration for type ${typeId}`);
  }
  return maybeTypeDeclaration;
}

// ../../cli/generation/ir-generator/lib/extended-properties/addExtendedPropertiesToIr.js
function addExtendedPropertiesToIr(ir) {
  return {
    types: Object.fromEntries(Object.entries(ir.types).map(([typeId, typeDeclaration]) => {
      return [typeId, addExtendedPropertiesToType({ typeDeclaration, ir })];
    })),
    services: Object.fromEntries(Object.entries(ir.services).map(([serviceId, serviceDeclration]) => {
      return [
        serviceId,
        {
          ...serviceDeclration,
          endpoints: serviceDeclration.endpoints.map((endpoint) => {
            return addExtendedPropertiesToEndpoint({ endpoint, ir });
          })
        }
      ];
    }))
  };
}
function addExtendedPropertiesToEndpoint({ endpoint, ir }) {
  if (endpoint.requestBody?.type !== "inlinedRequestBody") {
    return endpoint;
  }
  return {
    ...endpoint,
    requestBody: {
      ...endpoint.requestBody,
      extendedProperties: endpoint.requestBody.extends.flatMap((extended) => getExtendedPropertiesForDeclaredTypeName(extended, ir))
    }
  };
}
function addExtendedPropertiesToType({ typeDeclaration, ir }) {
  switch (typeDeclaration.shape.type) {
    case "object":
      return {
        ...typeDeclaration,
        shape: {
          ...typeDeclaration.shape,
          extendedProperties: typeDeclaration.shape.extends.flatMap((extended) => getExtendedPropertiesForDeclaredTypeName(extended, ir))
        }
      };
  }
  return typeDeclaration;
}
function getExtendedPropertiesForDeclaredTypeName(declaredTypeName, ir) {
  const objectTypeDeclaration = getObjectTypeDeclarationFromTypeId(declaredTypeName.typeId, ir);
  return getAllPropertiesForObject2({ objectTypeDeclaration, ir });
}
function getObjectTypeDeclarationFromTypeId(typeId, ir) {
  const typeDeclaration = getTypeDeclaration(typeId, ir.types);
  switch (typeDeclaration.shape.type) {
    case "object":
      return typeDeclaration.shape;
    case "alias": {
      if (typeDeclaration.shape.resolvedType.type === "named") {
        return getObjectTypeDeclarationFromTypeId(typeDeclaration.shape.resolvedType.name.typeId, ir);
      }
    }
  }
  throw new LoggableFernCliError(`Unexpected error: ${typeId} is extended but has shape ${typeDeclaration.shape.type}`);
}
function getAllPropertiesForObject2({ objectTypeDeclaration, ir }) {
  const extendedProperties = objectTypeDeclaration.extends.flatMap((extended) => {
    const extendedObjectDeclaration = getObjectTypeDeclarationFromTypeId(extended.typeId, ir);
    return getAllPropertiesForObject2({ objectTypeDeclaration: extendedObjectDeclaration, ir });
  });
  return [...objectTypeDeclaration.properties, ...extendedProperties];
}

// ../../cli/generation/ir-generator/lib/filtered-ir/FilteredIr.js
var FilteredIrImpl = class {
  environments = /* @__PURE__ */ new Set();
  types = /* @__PURE__ */ new Set();
  properties;
  errors = /* @__PURE__ */ new Set();
  services = /* @__PURE__ */ new Set();
  endpoints = /* @__PURE__ */ new Set();
  requestProperties;
  queryParameters;
  webhooks = /* @__PURE__ */ new Set();
  webhookPayloadProperties;
  subpackages = /* @__PURE__ */ new Set();
  constructor({ types: types2, properties, errors, environments, services, endpoints, webhooks, subpackages, queryParameters, requestProperties, webhookPayloadProperties }) {
    this.environments = environments;
    this.types = types2;
    this.properties = properties;
    this.errors = errors;
    this.services = services;
    this.endpoints = endpoints;
    this.webhooks = webhooks;
    this.webhookPayloadProperties = webhookPayloadProperties;
    this.subpackages = subpackages;
    this.requestProperties = requestProperties;
    this.queryParameters = queryParameters;
  }
  hasTypeId(typeId) {
    return this.types.has(typeId);
  }
  hasErrorId(errorId) {
    return this.errors.has(errorId);
  }
  hasServiceId(serviceId) {
    return this.services.has(serviceId);
  }
  hasSubpackageId(subpackageId) {
    return this.subpackages.has(subpackageId);
  }
  hasType(type2) {
    const typeId = IdGenerator.generateTypeId(type2.name);
    return this.types.has(typeId);
  }
  hasProperty(typeId, property4) {
    const properties = this.properties[typeId];
    if (properties == null) {
      return true;
    }
    return properties.has(property4);
  }
  hasError(error) {
    const errorId = IdGenerator.generateErrorId(error.name);
    return this.errors.has(errorId);
  }
  hasService(service) {
    const serviceId = IdGenerator.generateServiceId(service.name);
    return this.services.has(serviceId);
  }
  hasEnvironmentId(environmentId) {
    return this.environments.has(environmentId);
  }
  hasEndpoint(endpoint) {
    return this.endpoints.has(endpoint.id);
  }
  hasRequestProperty(endpoint, property4) {
    const properties = this.requestProperties[endpoint];
    if (properties == null) {
      return true;
    }
    return properties.has(property4);
  }
  hasQueryParameter(endpoint, parameter) {
    const parameters = this.queryParameters[endpoint];
    if (parameters == null) {
      return true;
    }
    return parameters.has(parameter);
  }
  hasSubpackage(subpackageId) {
    return this.subpackages.has(subpackageId);
  }
  hasWebhook(webhook) {
    if (webhook.id) {
      return this.webhooks.has(webhook.id);
    }
    return true;
  }
  hasWebhookPayloadProperty(webhookId, property4) {
    const properties = this.webhookPayloadProperties[webhookId];
    if (properties == null) {
      return true;
    }
    return properties.has(property4);
  }
};

// ../../cli/generation/ir-generator/lib/filtered-ir/IrGraph.js
var IrGraph = class {
  types = {};
  properties = {};
  queryParameters = {};
  requestProperties = {};
  webhookProperties = {};
  errors = {};
  endpoints = {};
  webhooks = {};
  audiences;
  typesReferencedByService = {};
  environmentsNeededForAudience = /* @__PURE__ */ new Set();
  typesNeededForAudience = /* @__PURE__ */ new Set();
  servicesNeededForAudience = /* @__PURE__ */ new Set();
  endpointsNeededForAudience = /* @__PURE__ */ new Set();
  webhooksNeededForAudience = /* @__PURE__ */ new Set();
  subpackagesNeededForAudience = /* @__PURE__ */ new Set();
  constructor(audiences) {
    this.audiences = audiencesFromConfig(audiences);
  }
  addType({ declaredTypeName, descendantTypeIds, descendantFilepaths, descendantTypeIdsByAudience, propertiesByAudience }) {
    const typeId = IdGenerator.generateTypeId(declaredTypeName);
    const typeNode = {
      typeId,
      allDescendants: descendantTypeIds,
      descendantsByAudience: descendantTypeIdsByAudience,
      referencedSubpackages: descendantFilepaths
    };
    this.types[typeId] = typeNode;
    if (this.typesReferencedByService[typeId] == null) {
      this.typesReferencedByService[typeId] = /* @__PURE__ */ new Set();
    }
    this.properties[typeId] = {
      typeId,
      propertiesByAudience
    };
  }
  markTypeForAudiences(declaredTypeName, audiences) {
    const typeId = IdGenerator.generateTypeId(declaredTypeName);
    if (this.hasAudience(audiences)) {
      this.typesNeededForAudience.add(typeId);
      this.addSubpackages(declaredTypeName.fernFilepath);
      this.types[typeId]?.referencedSubpackages.forEach((fernFilePath) => {
        this.addSubpackages(fernFilePath);
      });
    }
  }
  markEnvironmentForAudiences(environment, audiences, ignoreAudiences) {
    if (environment) {
      if (this.hasAudience(audiences) || ignoreAudiences) {
        this.environmentsNeededForAudience.add(environment.id);
      }
    }
  }
  getTypesReferencedByService() {
    for (const endpoint of Object.values(this.endpoints)) {
      for (const typeId of endpoint.referencedTypes) {
        this.markTypeForService(typeId, endpoint.serviceId);
      }
    }
    return this.typesReferencedByService;
  }
  addError(errorDeclaration) {
    const errorId = IdGenerator.generateErrorId(errorDeclaration.name);
    const referencedTypes = /* @__PURE__ */ new Set();
    const referencedSubpackages = /* @__PURE__ */ new Set();
    if (errorDeclaration.type != null) {
      populateReferencesFromTypeReference(errorDeclaration.type, referencedTypes, referencedSubpackages);
    }
    const errorNode = {
      errorId,
      referencedTypes,
      referencedSubpackages
    };
    this.errors[errorId] = errorNode;
  }
  addEndpoint(service, httpEndpoint, rawEndpoint) {
    const serviceId = IdGenerator.generateServiceId(service.name);
    const endpointId = httpEndpoint.id;
    const referencedTypes = /* @__PURE__ */ new Set();
    const referencedErrors = /* @__PURE__ */ new Set();
    const referencedSubpackages = /* @__PURE__ */ new Set();
    for (const header of [...service.headers, ...httpEndpoint.headers]) {
      populateReferencesFromTypeReference(header.valueType, referencedTypes, referencedSubpackages);
    }
    for (const pathParameter of [...service.pathParameters, ...httpEndpoint.pathParameters]) {
      populateReferencesFromTypeReference(pathParameter.valueType, referencedTypes, referencedSubpackages);
    }
    for (const queryParameter of httpEndpoint.queryParameters) {
      populateReferencesFromTypeReference(queryParameter.valueType, referencedTypes, referencedSubpackages);
    }
    if (rawEndpoint != null && rawEndpoint.request != null && typeof rawEndpoint.request !== "string") {
      const parametersByAudience = getPropertiesByAudience(rawEndpoint.request["query-parameters"] ?? {});
      this.queryParameters[endpointId] = {
        endpointId,
        parametersByAudience
      };
    }
    if (httpEndpoint.requestBody != null) {
      HttpRequestBody._visit(httpEndpoint.requestBody, {
        inlinedRequestBody: (inlinedRequestBody) => {
          for (const extension of inlinedRequestBody.extends) {
            populateReferencesFromTypeName(extension, referencedTypes, referencedSubpackages);
          }
          for (const property4 of inlinedRequestBody.properties) {
            populateReferencesFromTypeReference(property4.valueType, referencedTypes, referencedSubpackages);
          }
          if (rawEndpoint != null && typeof rawEndpoint.request === "object" && typeof rawEndpoint.request.body === "object" && isInlineRequestBody(rawEndpoint.request.body)) {
            const propertiesByAudience = getPropertiesByAudience(rawEndpoint.request.body.properties ?? {});
            this.requestProperties[endpointId] = {
              endpointId,
              propertiesByAudience
            };
          }
        },
        reference: ({ requestBodyType }) => {
          populateReferencesFromTypeReference(requestBodyType, referencedTypes, referencedSubpackages);
        },
        fileUpload: ({ properties }) => {
          for (const property4 of properties) {
            FileUploadRequestProperty._visit(property4, {
              file: noop,
              bodyProperty: ({ valueType }) => {
                populateReferencesFromTypeReference(valueType, referencedTypes, referencedSubpackages);
              },
              _other: () => {
                throw new Error("Unknown FileUploadRequestProperty: " + property4.type);
              }
            });
          }
        },
        bytes: () => {
          return;
        },
        _other: () => {
          throw new Error("Unknown HttpRequestBody: " + httpEndpoint.requestBody?.type);
        }
      });
    }
    if (httpEndpoint.response?.body != null) {
      HttpResponseBody._visit(httpEndpoint.response.body, {
        fileDownload: noop,
        json: (jsonResponse) => {
          populateReferencesFromTypeReference(jsonResponse.responseBodyType, referencedTypes, referencedSubpackages);
        },
        streaming: (streamingResponse) => {
          streamingResponse._visit({
            sse: (sse) => populateReferencesFromTypeReference(sse.payload, referencedTypes, referencedSubpackages),
            json: (json2) => populateReferencesFromTypeReference(json2.payload, referencedTypes, referencedSubpackages),
            text: noop,
            _other: () => {
              throw new Error("Unknown streamingResponse type: " + streamingResponse.type);
            }
          });
        },
        streamParameter: (response) => {
          response.streamResponse._visit({
            sse: (sse) => populateReferencesFromTypeReference(sse.payload, referencedTypes, referencedSubpackages),
            json: (json2) => populateReferencesFromTypeReference(json2.payload, referencedTypes, referencedSubpackages),
            text: noop,
            _other: () => {
              throw new Error("Unknown streamingResponse type: " + response.streamResponse.type);
            }
          });
          if (response.nonStreamResponse.type === "json") {
            populateReferencesFromTypeReference(response.nonStreamResponse.value.responseBodyType, referencedTypes, referencedSubpackages);
          }
        },
        text: noop,
        _other: () => {
          throw new Error("Unknown HttpResponse: " + httpEndpoint.response?.body?.type);
        }
      });
    }
    httpEndpoint.errors.forEach((responseError) => {
      referencedErrors.add(IdGenerator.generateErrorId(responseError.error));
      referencedSubpackages.add(responseError.error.fernFilepath);
    });
    this.endpoints[endpointId] = {
      endpointId,
      serviceId,
      referencedTypes,
      referencedErrors,
      referencedSubpackages
    };
  }
  markEndpointForAudience(declaredServiceName, httpEndpoints, audiences) {
    if (this.hasAudience(audiences)) {
      const serviceId = IdGenerator.generateServiceId(declaredServiceName);
      this.servicesNeededForAudience.add(serviceId);
      httpEndpoints.forEach((httpEndpoint) => {
        const endpointId = httpEndpoint.id;
        this.endpointsNeededForAudience.add(endpointId);
        this.endpoints[endpointId]?.referencedSubpackages.forEach((fernFilePath) => {
          this.addSubpackages(fernFilePath);
        });
      });
      this.servicesNeededForAudience.add(serviceId);
      this.addSubpackages(declaredServiceName.fernFilepath);
    }
  }
  addWebhook(file, webhook, rawWebhook) {
    const webhookId = webhook.id;
    if (webhookId == null) {
      return;
    }
    const referencedTypes = /* @__PURE__ */ new Set();
    const referencedSubpackages = /* @__PURE__ */ new Set();
    if (webhook.payload != null) {
      WebhookPayload._visit(webhook.payload, {
        inlinedPayload: (inlinedPayload) => {
          for (const extension of inlinedPayload.extends) {
            populateReferencesFromTypeName(extension, referencedTypes, referencedSubpackages);
          }
          for (const property4 of inlinedPayload.properties) {
            populateReferencesFromTypeReference(property4.valueType, referencedTypes, referencedSubpackages);
          }
          if (rawWebhook?.payload != null && typeof rawWebhook.payload === "object" && !isReferencedWebhookPayloadSchema2(rawWebhook.payload)) {
            const propertiesByAudience = getPropertiesByAudience(rawWebhook.payload.properties ?? {});
            this.webhookProperties[webhookId] = {
              webhookId,
              propertiesByAudience
            };
          }
        },
        reference: ({ payloadType }) => {
          populateReferencesFromTypeReference(payloadType, referencedTypes, referencedSubpackages);
        },
        _other: () => {
          throw new Error("Unknown WebhookPayload: " + webhook.payload?.type);
        }
      });
    }
    referencedSubpackages.add(file.fernFilepath);
    this.webhooks[webhookId] = {
      webhookId,
      referencedTypes,
      referencedSubpackages
    };
  }
  markWebhookForAudiences(file, webhook, audiences) {
    const webhookId = webhook.id;
    if (webhookId == null) {
      return;
    }
    if (this.hasAudience(audiences)) {
      this.webhooksNeededForAudience.add(webhookId);
      this.addSubpackages(file.fernFilepath);
    }
  }
  build() {
    const typeIds = /* @__PURE__ */ new Set();
    const errorIds = /* @__PURE__ */ new Set();
    for (const endpointId of this.endpointsNeededForAudience.keys()) {
      const endpointNode = this.getEndpointNode(endpointId);
      for (const errorId of endpointNode.referencedErrors) {
        if (errorIds.has(errorId)) {
          continue;
        }
        errorIds.add(errorId);
        const errorNode = this.getErrorNode(errorId);
        this.addReferencedTypes(typeIds, errorNode.referencedTypes);
      }
      this.addReferencedTypes(typeIds, endpointNode.referencedTypes);
    }
    this.addReferencedTypes(typeIds, this.typesNeededForAudience);
    for (const webhookId of this.webhooksNeededForAudience.keys()) {
      const webhookNode = this.getWebhookNode(webhookId);
      this.addReferencedTypes(typeIds, webhookNode.referencedTypes);
    }
    const properties = {};
    const requestProperties = {};
    const queryParameters = {};
    const webhookPayloadProperties = {};
    if (this.audiences.type === "filtered") {
      for (const [typeId, typePropertiesNode] of Object.entries(this.properties)) {
        if (!typeIds.has(typeId)) {
          continue;
        }
        const propertiesForTypeId = /* @__PURE__ */ new Set();
        for (const audience of this.audiences.audiences) {
          const propertiesForAudience = typePropertiesNode.propertiesByAudience[audience];
          if (propertiesForAudience != null) {
            propertiesForAudience.forEach((property4) => {
              propertiesForTypeId.add(property4);
            });
          }
        }
        if (propertiesForTypeId.size > 0) {
          properties[typeId] = propertiesForTypeId;
        }
        properties[typeId] = propertiesForTypeId.size > 0 ? propertiesForTypeId : void 0;
      }
      for (const [endpointId, requestPropertiesNode] of Object.entries(this.requestProperties)) {
        if (!this.endpointsNeededForAudience.has(endpointId)) {
          continue;
        }
        const propertiesForEndpoint = /* @__PURE__ */ new Set();
        for (const audience of this.audiences.audiences) {
          const propertiesForAudience = requestPropertiesNode.propertiesByAudience[audience];
          if (propertiesForAudience != null) {
            propertiesForAudience.forEach((property4) => {
              propertiesForEndpoint.add(property4);
            });
          }
        }
        requestProperties[endpointId] = propertiesForEndpoint.size > 0 ? propertiesForEndpoint : void 0;
      }
      for (const [endpointId, queryParametersNode] of Object.entries(this.queryParameters)) {
        if (!this.endpointsNeededForAudience.has(endpointId)) {
          continue;
        }
        const parametersForEndpoint = /* @__PURE__ */ new Set();
        for (const audience of this.audiences.audiences) {
          const parametersByAudience = queryParametersNode.parametersByAudience[audience];
          if (parametersByAudience != null) {
            parametersByAudience.forEach((parameter) => {
              parametersForEndpoint.add(parameter);
            });
          }
        }
        queryParameters[endpointId] = parametersForEndpoint.size > 0 ? parametersForEndpoint : void 0;
      }
      for (const [webhookId, webhookPaylodPropertiesNode] of Object.entries(this.webhookProperties)) {
        if (!this.webhooksNeededForAudience.has(webhookId)) {
          continue;
        }
        const propertiesForWebhook = /* @__PURE__ */ new Set();
        for (const audience of this.audiences.audiences) {
          const propertiesForAudience = webhookPaylodPropertiesNode.propertiesByAudience[audience];
          if (propertiesForAudience != null) {
            propertiesForAudience.forEach((property4) => {
              propertiesForWebhook.add(property4);
            });
          }
        }
        webhookPayloadProperties[webhookId] = propertiesForWebhook.size > 0 ? propertiesForWebhook : void 0;
      }
    }
    return new FilteredIrImpl({
      types: typeIds,
      properties,
      errors: errorIds,
      requestProperties,
      queryParameters,
      environments: this.environmentsNeededForAudience,
      services: this.servicesNeededForAudience,
      endpoints: this.endpointsNeededForAudience,
      webhooks: this.webhooksNeededForAudience,
      webhookPayloadProperties,
      subpackages: this.subpackagesNeededForAudience
    });
  }
  markTypeForService(typeId, serviceId) {
    const types2 = this.typesReferencedByService[typeId] ??= /* @__PURE__ */ new Set();
    if (types2.has(serviceId)) {
      return;
    }
    types2.add(serviceId);
    const typeNode = this.getTypeNode(typeId);
    for (const descendantTypeId of typeNode.allDescendants) {
      this.markTypeForService(descendantTypeId, serviceId);
    }
  }
  addReferencedTypes(types2, typesToAdd) {
    for (const typeId of typesToAdd) {
      if (types2.has(typeId)) {
        continue;
      }
      types2.add(typeId);
      const typeNode = this.getTypeNode(typeId);
      if (this.audiences.type === "filtered") {
        for (const audienceId of this.audiences.audiences) {
          const descendantsForAudience = typeNode.descendantsByAudience[audienceId];
          if (descendantsForAudience != null) {
            descendantsForAudience.forEach((descendantTypeId) => {
              types2.add(descendantTypeId);
            });
          } else {
            typeNode.allDescendants.forEach((descendantTypeId) => {
              types2.add(descendantTypeId);
            });
            break;
          }
        }
      } else {
        typeNode.allDescendants.forEach((descendantTypeId) => {
          types2.add(descendantTypeId);
        });
      }
    }
  }
  getTypeNode(typeId) {
    const typeNode = this.types[typeId];
    if (typeNode == null) {
      throw new Error(`Failed to find type node with id ${typeId}`);
    }
    return typeNode;
  }
  getErrorNode(errorId) {
    const errorNode = this.errors[errorId];
    if (errorNode == null) {
      throw new Error(`Failed to find error node with id ${errorId}`);
    }
    return errorNode;
  }
  getEndpointNode(endpointId) {
    const endpointNode = this.endpoints[endpointId];
    if (endpointNode == null) {
      throw new Error(`Failed to find endpoint node with id ${endpointId}`);
    }
    return endpointNode;
  }
  getWebhookNode(webhookId) {
    const webhookNode = this.webhooks[webhookId];
    if (webhookNode == null) {
      throw new Error(`Failed to find webhook node with id ${webhookId}`);
    }
    return webhookNode;
  }
  hasNoAudiences() {
    return this.audiences.type === "none";
  }
  hasAudience(audiences) {
    const configuredAudiences = this.audiences;
    switch (configuredAudiences.type) {
      case "none":
        return true;
      case "filtered":
        return audiences.some((audienceId) => configuredAudiences.audiences.has(audienceId));
      default:
        assertNever(configuredAudiences);
    }
  }
  addSubpackages(fernFilePath) {
    for (let i = 1; i <= fernFilePath.allParts.length; ++i) {
      const packageFilePath = {
        ...fernFilePath,
        allParts: fernFilePath.allParts.slice(0, i)
      };
      this.subpackagesNeededForAudience.add(IdGenerator.generateSubpackageId(packageFilePath));
    }
  }
};
function audiencesFromConfig(configAudiences) {
  switch (configAudiences.type) {
    case "all":
      return { type: "none" };
    case "select":
      return { type: "filtered", audiences: new Set(configAudiences.audiences) };
    default:
      assertNever(configAudiences);
  }
}
function populateReferencesFromTypeReference(typeReference, referencedTypes, referencedSubpackages) {
  TypeReference2._visit(typeReference, {
    container: (containerType) => {
      populateReferencesFromContainer(containerType, referencedTypes, referencedSubpackages);
    },
    named: (declaredTypeName) => {
      populateReferencesFromTypeName(declaredTypeName, referencedTypes, referencedSubpackages);
    },
    primitive: noop,
    unknown: noop,
    _other: noop
  });
}
function populateReferencesFromTypeName(typeName, referencedTypes, referencedSubpackages) {
  referencedTypes.add(IdGenerator.generateTypeId(typeName));
  referencedSubpackages.add(typeName.fernFilepath);
}
function populateReferencesFromContainer(containerType, referencedTypes, referencedSubpackages) {
  ContainerType._visit(containerType, {
    list: (listType) => {
      populateReferencesFromTypeReference(listType, referencedTypes, referencedSubpackages);
    },
    map: (mapType2) => {
      populateReferencesFromTypeReference(mapType2.keyType, referencedTypes, referencedSubpackages);
      populateReferencesFromTypeReference(mapType2.valueType, referencedTypes, referencedSubpackages);
    },
    optional: (optionalType2) => {
      populateReferencesFromTypeReference(optionalType2, referencedTypes, referencedSubpackages);
    },
    set: (setType2) => {
      populateReferencesFromTypeReference(setType2, referencedTypes, referencedSubpackages);
    },
    literal: noop,
    _other: noop
  });
}

// ../../cli/generation/ir-generator/lib/filterExamples.js
function filterExampleSingleUnionTypeProperties({ filteredIr, singleUnionTypeProperties }) {
  return singleUnionTypeProperties._visit({
    samePropertiesAsObject: (s) => {
      const filteredObject = filteredIr.hasTypeId(s.typeId) ? {
        ...s,
        object: {
          properties: s.object.properties.filter((p) => filteredIr.hasProperty(p.originalTypeDeclaration.typeId, p.name.wireValue)).map((p) => ({
            ...p,
            value: filterExampleTypeReference({ filteredIr, exampleTypeReference: p.value })
          })).filter((p) => p.value !== void 0)
        }
      } : void 0;
      return filteredObject !== void 0 ? ExampleSingleUnionTypeProperties.samePropertiesAsObject(filteredObject) : void 0;
    },
    singleProperty: (s) => {
      const filteredProperty = filterExampleTypeReference({ filteredIr, exampleTypeReference: s });
      return filteredProperty !== void 0 ? ExampleSingleUnionTypeProperties.singleProperty(filteredProperty) : void 0;
    },
    noProperties: () => singleUnionTypeProperties,
    _other: () => {
      throw new Error("Received unknown type for example.");
    }
  });
}
function filterExampleTypeReference({ filteredIr, exampleTypeReference }) {
  return exampleTypeReference.shape._visit({
    primitive: () => exampleTypeReference,
    container: (c) => c._visit({
      list: (l) => ({
        ...exampleTypeReference,
        shape: ExampleTypeReferenceShape.container(ExampleContainer.list({
          ...l,
          list: l.list.map((t) => filterExampleTypeReference({ filteredIr, exampleTypeReference: t })).filter((t) => t !== void 0)
        }))
      }),
      set: (s) => ({
        ...exampleTypeReference,
        shape: ExampleTypeReferenceShape.container(ExampleContainer.set({
          ...s,
          set: s.set.map((t) => filterExampleTypeReference({ filteredIr, exampleTypeReference: t })).filter((t) => t !== void 0)
        }))
      }),
      optional: (o) => {
        const filteredOptionalTypReference = o.optional != null ? filterExampleTypeReference({ filteredIr, exampleTypeReference: o.optional }) : void 0;
        return filteredOptionalTypReference != null ? {
          ...exampleTypeReference,
          shape: ExampleTypeReferenceShape.container(ExampleContainer.optional({
            optional: filteredOptionalTypReference,
            valueType: o.valueType
          }))
        } : void 0;
      },
      map: (m) => ({
        ...exampleTypeReference,
        shape: ExampleTypeReferenceShape.container(ExampleContainer.map({
          ...m,
          map: m.map.map((v) => {
            const filteredKey = filterExampleTypeReference({
              filteredIr,
              exampleTypeReference: v.key
            });
            const filteredValue = filterExampleTypeReference({
              filteredIr,
              exampleTypeReference: v.value
            });
            return filteredKey !== void 0 && filteredValue !== void 0 ? { key: filteredKey, value: filteredValue } : void 0;
          }).filter((t) => t !== void 0)
        }))
      }),
      // This is just a primitive, don't do anything
      literal: () => exampleTypeReference,
      _other: () => {
        throw new Error("Received unknown type for example.");
      }
    }),
    // If the type is allowed filter it's properties and return
    // Otherwise just return null
    named: (n) => filteredIr.hasTypeId(n.typeName.typeId) ? n.shape._visit({
      alias: (a) => {
        const filteredAlias = filterExampleTypeReference({
          filteredIr,
          exampleTypeReference: a.value
        });
        return filteredAlias !== void 0 ? {
          ...exampleTypeReference,
          shape: ExampleTypeReferenceShape.named({
            ...n,
            shape: ExampleTypeShape.alias({ ...a, value: filteredAlias })
          })
        } : void 0;
      },
      enum: (e) => ({
        ...exampleTypeReference,
        shape: ExampleTypeReferenceShape.named({ ...n, shape: ExampleTypeShape.enum(e) })
      }),
      object: (o) => ({
        ...exampleTypeReference,
        shape: ExampleTypeReferenceShape.named({
          ...n,
          shape: ExampleTypeShape.object({
            ...o,
            properties: o.properties.filter((p) => filteredIr.hasProperty(p.originalTypeDeclaration.typeId, p.name.wireValue)).map((p) => ({
              ...p,
              value: filterExampleTypeReference({
                filteredIr,
                exampleTypeReference: p.value
              })
            })).filter((p) => p.value !== void 0)
          })
        })
      }),
      union: (u) => {
        const filteredUnion = filterExampleSingleUnionTypeProperties({
          filteredIr,
          singleUnionTypeProperties: u.singleUnionType.shape
        });
        return filteredUnion !== void 0 ? {
          ...exampleTypeReference,
          shape: ExampleTypeReferenceShape.named({
            ...n,
            shape: ExampleTypeShape.union({
              ...u,
              singleUnionType: { ...u.singleUnionType, shape: filteredUnion }
            })
          })
        } : void 0;
      },
      undiscriminatedUnion: (u) => {
        const filteredUnion = filterExampleTypeReference({
          filteredIr,
          exampleTypeReference: u.singleUnionType
        });
        return filteredUnion !== void 0 ? {
          ...exampleTypeReference,
          shape: ExampleTypeReferenceShape.named({
            ...n,
            shape: ExampleTypeShape.undiscriminatedUnion({
              ...u,
              singleUnionType: filteredUnion
            })
          })
        } : void 0;
      },
      _other: () => {
        throw new Error("Received unknown type for example.");
      }
    }) : void 0,
    unknown: () => exampleTypeReference,
    _other: () => exampleTypeReference
  });
}
function filterExamplePathParameters({ filteredIr, pathParameters }) {
  return pathParameters.map((param) => {
    const filteredParam = filterExampleTypeReference({ filteredIr, exampleTypeReference: param.value });
    return filteredParam !== void 0 ? {
      ...param,
      value: filteredParam
    } : void 0;
  }).filter((param) => param !== void 0);
}
function filterExampleQueryParameters({ filteredIr, queryParameters }) {
  return queryParameters.map((queryParameter) => {
    const filteredQueryParameter = filterExampleTypeReference({
      filteredIr,
      exampleTypeReference: queryParameter.value
    });
    return filteredQueryParameter !== void 0 ? {
      ...queryParameter,
      value: filteredQueryParameter
    } : void 0;
  }).filter((queryParameter) => queryParameter !== void 0);
}
function filterExampleHeader({ filteredIr, headers }) {
  return headers.map((header) => {
    const filteredHeader = filterExampleTypeReference({ filteredIr, exampleTypeReference: header.value });
    return filteredHeader !== void 0 ? {
      ...header,
      value: filteredHeader
    } : void 0;
  }).filter((header) => header !== void 0);
}
function filterExampleRequestBody({ filteredIr, requestBody }) {
  return requestBody._visit({
    inlinedRequestBody: (inlined) => {
      return {
        ...requestBody,
        properties: inlined.properties.filter((p) => p.originalTypeDeclaration ? filteredIr.hasProperty(p.originalTypeDeclaration.typeId, p.name.wireValue) : true).map((property4) => {
          const filteredProperty = filterExampleTypeReference({
            filteredIr,
            exampleTypeReference: property4.value
          });
          return filteredProperty !== void 0 ? {
            ...property4,
            value: filteredProperty
          } : void 0;
        }).filter((property4) => property4 !== void 0)
      };
    },
    reference: (reference) => {
      const filteredReference = filterExampleTypeReference({ filteredIr, exampleTypeReference: reference });
      return filteredReference !== void 0 ? ExampleRequestBody.reference(filteredReference) : void 0;
    },
    _other: () => {
      throw new Error("Received unknown type for example.");
    }
  });
}
function filterExampleResponse({ filteredIr, response }) {
  return response._visit({
    ok: (ok) => ok._visit({
      body: (exampleTypeReference) => ExampleResponse.ok(ExampleEndpointSuccessResponse.body(exampleTypeReference != null ? filterExampleTypeReference({ filteredIr, exampleTypeReference }) : void 0)),
      stream: (stream) => ExampleResponse.ok(ExampleEndpointSuccessResponse.stream(stream.map((exampleTypeReference) => filterExampleTypeReference({ filteredIr, exampleTypeReference })).filter(isNonNullish))),
      sse: (events) => ExampleResponse.ok(ExampleEndpointSuccessResponse.sse(events.map(({ event, data }) => {
        const filteredData = filterExampleTypeReference({
          filteredIr,
          exampleTypeReference: data
        });
        return filteredData !== void 0 ? { event, data: filteredData } : void 0;
      }).filter(isNonNullish))),
      _other: ({ type: type2 }) => {
        throw new Error(`Received unknown type for OK example: ${type2}`);
      }
    }),
    error: ({ error, body }) => ExampleResponse.error({
      error,
      body: body != null ? filterExampleTypeReference({ filteredIr, exampleTypeReference: body }) : void 0
    }),
    _other: ({ type: type2 }) => {
      throw new Error(`Received unknown type for example: ${type2}`);
    }
  });
}
function filterEndpointExample({ filteredIr, example }) {
  return {
    ...example,
    rootPathParameters: filterExamplePathParameters({ filteredIr, pathParameters: example.rootPathParameters }),
    servicePathParameters: filterExamplePathParameters({
      filteredIr,
      pathParameters: example.servicePathParameters
    }),
    endpointPathParameters: filterExamplePathParameters({
      filteredIr,
      pathParameters: example.endpointPathParameters
    }),
    serviceHeaders: filterExampleHeader({ filteredIr, headers: example.serviceHeaders }),
    endpointHeaders: filterExampleHeader({ filteredIr, headers: example.endpointHeaders }),
    queryParameters: filterExampleQueryParameters({ filteredIr, queryParameters: example.queryParameters }),
    request: example.request !== void 0 ? filterExampleRequestBody({ filteredIr, requestBody: example.request }) : void 0,
    response: filterExampleResponse({ filteredIr, response: example.response })
  };
}
function filterExampleType({ filteredIr, exampleType }) {
  return exampleType.shape._visit({
    alias: (a) => {
      const filteredAlias = filterExampleTypeReference({ filteredIr, exampleTypeReference: a.value });
      return filteredAlias !== void 0 ? { ...exampleType, shape: ExampleTypeShape.alias({ ...a, value: filteredAlias }) } : void 0;
    },
    enum: () => exampleType,
    object: (o) => ({
      ...exampleType,
      shape: ExampleTypeShape.object({
        ...o,
        properties: o.properties.filter((p) => filteredIr.hasProperty(p.originalTypeDeclaration.typeId, p.name.wireValue)).map((p) => ({
          ...p,
          value: filterExampleTypeReference({ filteredIr, exampleTypeReference: p.value })
        })).filter((p) => p.value !== void 0)
      })
    }),
    union: (u) => {
      const filteredUnion = filterExampleSingleUnionTypeProperties({
        filteredIr,
        singleUnionTypeProperties: u.singleUnionType.shape
      });
      return filteredUnion !== void 0 ? {
        ...exampleType,
        shape: ExampleTypeShape.union({
          ...u,
          singleUnionType: { ...u.singleUnionType, shape: filteredUnion }
        })
      } : void 0;
    },
    undiscriminatedUnion: (u) => {
      const filteredUnion = filterExampleTypeReference({ filteredIr, exampleTypeReference: u.singleUnionType });
      return filteredUnion !== void 0 ? {
        ...exampleType,
        shape: ExampleTypeShape.undiscriminatedUnion({
          ...u,
          singleUnionType: filteredUnion
        })
      } : void 0;
    },
    _other: () => {
      throw new Error("Received unknown type for example.");
    }
  });
}

// ../../cli/generation/ir-generator/lib/PackageTreeGenerator.js
var PackageTreeGenerator = class {
  subpackages = {};
  rootPackage = {
    docs: void 0,
    fernFilepath: {
      allParts: [],
      packagePath: [],
      file: void 0
    },
    websocket: void 0,
    service: void 0,
    types: [],
    errors: [],
    subpackages: [],
    webhooks: void 0,
    navigationConfig: void 0
  };
  addPackageRedirection({ from, to }) {
    const package_ = this.getPackageForFernFilepath(from);
    if (package_.navigationConfig != null) {
      throw new Error("Found duplicate navigationConfig for package");
    }
    package_.navigationConfig = {
      pointsTo: IdGenerator.generateSubpackageId(to)
    };
  }
  addDocs(fernFilepath, docs) {
    const package_ = this.getPackageForFernFilepath(fernFilepath);
    if (package_.docs != null) {
      throw new Error("Found duplicate docs for package");
    }
    package_.docs = docs;
  }
  addSubpackage(fernFilepath) {
    this.getPackageForFernFilepath(fernFilepath);
  }
  addType(typeId, type2) {
    this.getPackageForFernFilepath(type2.name.fernFilepath).types.push(typeId);
  }
  addError(errorId, error) {
    this.getPackageForFernFilepath(error.name.fernFilepath).errors.push(errorId);
  }
  addService(serviceId, service) {
    const package_ = this.getPackageForFernFilepath(service.name.fernFilepath);
    if (package_.service != null) {
      throw new Error("Found duplicate service for " + serviceId);
    }
    package_.service = serviceId;
  }
  addWebhookGroup(webhookGroupId, fernFilepath) {
    const package_ = this.getPackageForFernFilepath(fernFilepath);
    if (package_.webhooks != null) {
      throw new Error("Found duplicate webhook group for " + webhookGroupId);
    }
    package_.webhooks = webhookGroupId;
  }
  addWebSocketChannel(websocketChannelId, fernFilepath) {
    const package_ = this.getPackageForFernFilepath(fernFilepath);
    if (package_.webhooks != null) {
      throw new Error("Found duplicate webhook group for " + websocketChannelId);
    }
    package_.websocket = websocketChannelId;
  }
  build(filteredIr) {
    if (filteredIr != null) {
      Object.entries(this.subpackages).forEach(([subpackageId, subpackage]) => {
        if (!filteredIr.hasSubpackageId(subpackageId)) {
          delete this.subpackages[subpackageId];
        } else {
          this.subpackages[subpackageId] = {
            ...subpackage,
            types: subpackage.types.filter((typeId) => filteredIr.hasTypeId(typeId)),
            errors: subpackage.errors.filter((errorId) => filteredIr.hasErrorId(errorId)),
            service: subpackage.service != null ? filteredIr.hasServiceId(subpackage.service) ? subpackage.service : void 0 : void 0,
            subpackages: subpackage.subpackages.filter((subpackageId2) => filteredIr.hasSubpackageId(subpackageId2))
          };
        }
      });
      this.rootPackage = {
        ...this.rootPackage,
        types: this.rootPackage.types.filter((typeId) => filteredIr.hasTypeId(typeId)),
        errors: this.rootPackage.errors.filter((errorId) => filteredIr.hasErrorId(errorId)),
        service: this.rootPackage.service != null ? filteredIr.hasServiceId(this.rootPackage.service) ? this.rootPackage.service : void 0 : void 0,
        subpackages: this.rootPackage.subpackages.filter((subpackageId) => filteredIr.hasSubpackageId(subpackageId)),
        webhooks: this.rootPackage.webhooks != null ? this.rootPackage.webhooks : void 0
      };
    }
    const allSubpackagesWithEndpoints = new Set(this.getAllChildrenWithEndpoints(this.rootPackage));
    return {
      subpackages: mapValues_default(this.subpackages, (subpackage, subpackageId) => ({
        ...subpackage,
        hasEndpointsInTree: allSubpackagesWithEndpoints.has(subpackageId)
      })),
      rootPackage: {
        ...this.rootPackage,
        hasEndpointsInTree: allSubpackagesWithEndpoints.size > 0 || this.rootPackage.service != null
      }
    };
  }
  sortRootPackage(subpackagesInOrder) {
    if (!isEqualIgnoreOrder(this.rootPackage.subpackages, subpackagesInOrder)) {
      throw new Error("Sorted subpackages differ from unsorted packages in root");
    }
    this.rootPackage.subpackages = subpackagesInOrder;
  }
  sortSubpackage(subpackageId, subpackagesInOrder) {
    const subpackage = this.subpackages[subpackageId];
    if (subpackage == null) {
      throw new Error("Subpackage does not exist: " + subpackageId);
    }
    if (!isEqualIgnoreOrder(subpackage.subpackages, subpackagesInOrder)) {
      throw new Error("Sorted subpackages differ from unsorted packages");
    }
    subpackage.subpackages = subpackagesInOrder;
  }
  getAllSubpackagesWithEndpoints(root2) {
    const subpackage = this.subpackages[root2];
    if (subpackage == null) {
      throw new Error("Subpackage does not exist: " + root2);
    }
    const subpackagesWithEndpoints = this.getAllChildrenWithEndpoints(subpackage);
    if (subpackagesWithEndpoints.length > 0 || subpackage.service != null) {
      subpackagesWithEndpoints.push(root2);
    }
    return subpackagesWithEndpoints;
  }
  getAllChildrenWithEndpoints(package_) {
    return package_.subpackages.flatMap((child) => {
      return [...this.getAllSubpackagesWithEndpoints(child)];
    });
  }
  getPackageForFernFilepath(fernFilepath, index = 0, parent = this.rootPackage) {
    const nextPart = fernFilepath.allParts[index];
    if (nextPart == null) {
      return parent;
    }
    const subpackagesInParent = parent.subpackages.map((subpackageId) => {
      const subpackage = this.subpackages[subpackageId];
      if (subpackage == null) {
        throw new Error("Subpackage ID is invalid: " + subpackageId);
      }
      return subpackage;
    });
    const nextIndex = index + 1;
    const fernFilepathForNextParent = {
      allParts: fernFilepath.allParts.slice(0, nextIndex),
      packagePath: fernFilepath.packagePath.slice(0, nextIndex),
      file: nextIndex === fernFilepath.allParts.length ? fernFilepath.file : void 0
    };
    let nextParent = subpackagesInParent.find((subpackage) => subpackage.name.originalName === nextPart.originalName);
    if (nextParent == null) {
      const newParentId = IdGenerator.generateSubpackageId(fernFilepathForNextParent);
      const newParent = {
        docs: void 0,
        fernFilepath: fernFilepathForNextParent,
        name: nextPart,
        service: void 0,
        types: [],
        errors: [],
        subpackages: [],
        navigationConfig: void 0,
        webhooks: void 0,
        websocket: void 0
      };
      this.subpackages[newParentId] = newParent;
      parent.subpackages.push(newParentId);
      nextParent = newParent;
    }
    return this.getPackageForFernFilepath(fernFilepath, nextIndex, nextParent);
  }
};
function isEqualIgnoreOrder(a, b) {
  if (a.length !== b.length) {
    return false;
  }
  const aSet = new Set(a);
  for (const bElement of b) {
    if (!aSet.has(bElement)) {
      return false;
    }
  }
  return true;
}

// ../../cli/generation/ir-generator/lib/utils/parseReferenceToEndpointName.js
function parseReferenceToEndpointName({ reference, referencedIn, imports }) {
  const [firstPart, secondPart, ...rest] = reference.split(".");
  if (firstPart == null || rest.length > 0) {
    return void 0;
  }
  if (secondPart == null) {
    return {
      endpointName: firstPart,
      relativeFilepath: referencedIn
    };
  }
  const importAlias = firstPart;
  const importPath = imports[importAlias];
  if (importPath == null) {
    return void 0;
  }
  return {
    endpointName: secondPart,
    relativeFilepath: getResolvedPathOfImportedFile({ referencedIn, importPath })
  };
}

// ../../cli/generation/ir-generator/lib/resolvers/EndpointResolver.js
var EndpointResolverImpl = class {
  workspace;
  constructor(workspace) {
    this.workspace = workspace;
  }
  async resolveEndpointOrThrow({ endpoint, file }) {
    const resolvedEndpoint = await this.resolveEndpoint({ endpoint, file });
    if (resolvedEndpoint == null) {
      throw new Error("Cannot resolve endpoint: " + endpoint + " in file " + file.relativeFilepath);
    }
    return resolvedEndpoint;
  }
  async resolveEndpointByMethodAndPath({ method, path: path5 }) {
    let result = void 0;
    await visitAllDefinitionFiles(this.workspace, async (relativeFilepath, file, metadata) => {
      const context = constructFernFileContext({
        relativeFilepath,
        definitionFile: file,
        casingsGenerator: CASINGS_GENERATOR,
        rootApiFile: this.workspace.definition.rootApiFile.contents,
        defaultUrl: metadata.defaultUrl
      });
      for (const [endpointId, endpointDeclaration] of Object.entries(file.service?.endpoints ?? {})) {
        if (endpointDeclaration.method === method && endpointDeclaration.path === path5) {
          result = {
            endpointId,
            endpoint: endpointDeclaration,
            file: context
          };
        }
      }
    });
    await visitAllPackageMarkers(this.workspace, async (relativeFilepath, packageMarker) => {
      const context = constructFernFileContext({
        relativeFilepath,
        definitionFile: packageMarker,
        casingsGenerator: CASINGS_GENERATOR,
        rootApiFile: this.workspace.definition.rootApiFile.contents
      });
      for (const [endpointId, endpointDeclaration] of Object.entries(packageMarker.service?.endpoints ?? {})) {
        if (endpointDeclaration.method === method && endpointDeclaration.path === path5) {
          result = {
            endpointId,
            endpoint: endpointDeclaration,
            file: context
          };
        }
      }
    });
    return result;
  }
  async resolveEndpoint({ endpoint, file }) {
    const referenceParser = new HttpEndpointReferenceParser();
    const parsedEndpointReference = referenceParser.tryParse(endpoint);
    if (parsedEndpointReference != null) {
      return await this.resolveEndpointByMethodAndPath(parsedEndpointReference);
    }
    const maybeDeclaration = this.getDeclarationOfEndpoint({
      referenceToEndpoint: endpoint,
      file
    });
    if (maybeDeclaration == null) {
      return void 0;
    }
    const maybeEndpoint = maybeDeclaration.file.definitionFile.service?.endpoints?.[maybeDeclaration.endpointName];
    if (maybeEndpoint == null) {
      return void 0;
    }
    return {
      endpointId: maybeDeclaration.endpointName,
      endpoint: maybeEndpoint,
      file: maybeDeclaration.file
    };
  }
  getDeclarationOfEndpoint({ referenceToEndpoint, file }) {
    const parsedReference = parseReferenceToEndpointName({
      reference: referenceToEndpoint,
      referencedIn: file.relativeFilepath,
      imports: file.imports
    });
    if (parsedReference == null) {
      return void 0;
    }
    const definitionFile = getDefinitionFile(this.workspace, parsedReference.relativeFilepath);
    if (definitionFile == null) {
      return void 0;
    }
    const declaration = definitionFile.service?.endpoints?.[parsedReference.endpointName];
    if (declaration == null) {
      return void 0;
    }
    return {
      endpointName: parsedReference.endpointName,
      file: constructFernFileContext({
        relativeFilepath: parsedReference.relativeFilepath,
        definitionFile,
        casingsGenerator: file.casingsGenerator,
        rootApiFile: this.workspace.definition.rootApiFile.contents
      })
    };
  }
};

// ../../cli/generation/ir-generator/lib/resolvers/ErrorResolver.js
var ErrorResolverImpl = class {
  workspace;
  constructor(workspace) {
    this.workspace = workspace;
  }
  getDeclarationOrThrow(referenceToError, file) {
    const declaration = this.getDeclaration(referenceToError, file);
    if (declaration == null) {
      throw new Error("Error does not exist: " + referenceToError);
    }
    return declaration;
  }
  getDeclaration(referenceToError, file) {
    const parsedReference = parseReferenceToTypeName({
      reference: referenceToError,
      referencedIn: file.relativeFilepath,
      imports: file.imports
    });
    if (parsedReference == null) {
      return void 0;
    }
    const definitionFile = getDefinitionFile(this.workspace, parsedReference.relativeFilepath);
    if (definitionFile == null) {
      return void 0;
    }
    const declaration = definitionFile.errors?.[parsedReference.typeName];
    if (declaration == null) {
      return void 0;
    }
    return {
      declaration,
      file: constructFernFileContext({
        definitionFile,
        relativeFilepath: parsedReference.relativeFilepath,
        casingsGenerator: file.casingsGenerator,
        rootApiFile: this.workspace.definition.rootApiFile.contents
      })
    };
  }
};

// ../../cli/generation/ir-generator/lib/resolvers/ExampleResolver.js
var ExampleResolverImpl = class {
  typeResolver;
  constructor(typeResolver) {
    this.typeResolver = typeResolver;
  }
  resolveAllReferencesInExample({ example, file }) {
    if (typeof example === "string") {
      const resolvedExample = this.resolveExample({
        example,
        file
      });
      if (resolvedExample == null || typeof resolvedExample.resolvedExample === "string") {
        return resolvedExample;
      }
      return this.resolveAllReferencesInExample({
        example: resolvedExample.resolvedExample,
        file: resolvedExample.file
      });
    } else if (isPlainObject2(example)) {
      const newExample = {};
      for (const [exampleKey, exampleValue] of Object.entries(example)) {
        const resolvedExampleValue = this.resolveAllReferencesInExample({ example: exampleValue, file });
        if (resolvedExampleValue == null) {
          return void 0;
        }
        newExample[exampleKey] = resolvedExampleValue.resolvedExample;
      }
      return { resolvedExample: newExample };
    } else if (Array.isArray(example)) {
      const newExample = [];
      for (const exampleItem of example) {
        const resolvedExampleItem = this.resolveAllReferencesInExample({ example: exampleItem, file });
        if (resolvedExampleItem == null) {
          return void 0;
        }
        newExample.push(resolvedExampleItem.resolvedExample);
      }
      return { resolvedExample: newExample };
    }
    return { resolvedExample: example };
  }
  resolveAllReferencesInExampleOrThrow({ example, file }) {
    const resolvedExample = this.resolveAllReferencesInExample({ example, file });
    if (resolvedExample == null) {
      throw new Error("Failed to resolve examples");
    }
    return resolvedExample;
  }
  resolveExample({ example, file }) {
    if (typeof example !== "string") {
      return {
        resolvedExample: example,
        file
      };
    }
    if (example.startsWith(`\\${EXAMPLE_REFERENCE_PREFIX}`)) {
      return {
        // remove backslash
        resolvedExample: example.slice(1),
        file
      };
    }
    if (!example.startsWith(EXAMPLE_REFERENCE_PREFIX)) {
      return {
        resolvedExample: example,
        file
      };
    }
    const parsedExampleReference = this.parseExampleReference(example);
    if (parsedExampleReference == null) {
      return void 0;
    }
    const typeDeclaration = this.typeResolver.getDeclarationOfNamedType({
      referenceToNamedType: parsedExampleReference.rawTypeReference,
      file
    });
    if (typeDeclaration == null || typeof typeDeclaration.declaration === "string" || typeDeclaration.declaration.examples == null) {
      return void 0;
    }
    const resolvedExample = typeDeclaration.declaration.examples.find((otherExample) => otherExample.name === parsedExampleReference.exampleName);
    if (resolvedExample == null) {
      return void 0;
    }
    return this.resolveExample({ example: resolvedExample.value, file: typeDeclaration.file });
  }
  resolveExampleOrThrow({ example, file }) {
    const resolvedExample = this.resolveExample({ example, file });
    if (resolvedExample == null) {
      throw new Error("Cannot resolve example: " + example);
    }
    return resolvedExample;
  }
  parseExampleReference(exampleReference) {
    const [first, second, third, ...rest] = exampleReference.split(".");
    if (first == null || second == null || rest.length > 0) {
      return void 0;
    }
    if (third == null) {
      return {
        rawTypeReference: first.slice(EXAMPLE_REFERENCE_PREFIX.length),
        exampleName: second
      };
    }
    return {
      rawTypeReference: `${first}.${second}`.slice(EXAMPLE_REFERENCE_PREFIX.length),
      exampleName: third
    };
  }
};

// ../../cli/generation/ir-generator/lib/resolvers/PropertyResolver.js
var PropertyResolverImpl = class {
  typeResolver;
  endpointResolver;
  constructor(typeResolver, endpointResolver) {
    this.typeResolver = typeResolver;
    this.endpointResolver = endpointResolver;
    this.typeResolver = typeResolver;
    this.endpointResolver = endpointResolver;
  }
  async resolveRequestPropertyOrThrow({ file, endpoint, propertyComponents }) {
    const resolvedRequestProperty = await this.resolveRequestProperty({ file, endpoint, propertyComponents });
    if (resolvedRequestProperty == null) {
      throw new Error("Cannot resolve request property from endpoint: " + endpoint + " in file " + file.relativeFilepath);
    }
    return resolvedRequestProperty;
  }
  async resolveRequestProperty({ file, endpoint, propertyComponents }) {
    const resolvedEndpoint = await this.endpointResolver.resolveEndpointOrThrow({
      endpoint,
      file
    });
    if (resolvedEndpoint.endpoint.request == null) {
      return void 0;
    }
    if (typeof resolvedEndpoint.endpoint.request !== "string") {
      return this.resolveRequestPropertyFromInlinedRequest({
        typeResolver: this.typeResolver,
        file: resolvedEndpoint.file,
        requestType: resolvedEndpoint.endpoint.request,
        propertyComponents
      });
    }
    const objectProperty = await this.resolveObjectProperty({
      file: resolvedEndpoint.file,
      typeName: resolvedEndpoint.endpoint.request,
      propertyComponents
    });
    if (objectProperty == null) {
      return void 0;
    }
    return {
      propertyPath: await this.propertyPathFromPropertyComponents({
        propertyComponents,
        file
      }),
      property: RequestPropertyValue.body(objectProperty)
    };
  }
  async resolveResponsePropertyOrThrow({ file, endpoint, propertyComponents }) {
    const resolvedResponseProperty = await this.resolveResponseProperty({ file, endpoint, propertyComponents });
    if (resolvedResponseProperty == null) {
      throw new Error("Cannot resolve response property from endpoint: " + endpoint + " in file " + file.relativeFilepath);
    }
    return resolvedResponseProperty;
  }
  async resolveResponseProperty({ file, endpoint, propertyComponents }) {
    const resolvedEndpoint = await this.endpointResolver.resolveEndpointOrThrow({
      endpoint,
      file
    });
    const objectProperty = await this.resolveObjectProperty({
      file: resolvedEndpoint.file,
      typeName: (typeof resolvedEndpoint.endpoint.response !== "string" ? resolvedEndpoint.endpoint.response?.type : resolvedEndpoint.endpoint.response) ?? "",
      propertyComponents
    });
    if (objectProperty == null) {
      return void 0;
    }
    return {
      propertyPath: await this.propertyPathFromPropertyComponents({
        propertyComponents,
        file
      }),
      property: objectProperty
    };
  }
  async resolveRequestPropertyFromInlinedRequest({ typeResolver, file, requestType, propertyComponents }) {
    if (propertyComponents.length === 1) {
      const queryParameterKey = propertyComponents[0] ?? "";
      const queryParameter = typeof requestType["query-parameters"] != null ? requestType["query-parameters"]?.[queryParameterKey] : void 0;
      if (queryParameter != null) {
        return {
          property: RequestPropertyValue.query(await convertQueryParameter({
            file,
            queryParameterKey,
            queryParameter
          })),
          propertyPath: void 0
        };
      }
    }
    return this.resolveRequestPropertyFromInlinedRequestBody({
      typeResolver,
      file,
      requestType,
      propertyComponents
    });
  }
  async resolveRequestPropertyFromInlinedRequestBody({ typeResolver, file, requestType, propertyComponents }) {
    if (requestType.body == null) {
      return void 0;
    }
    if (typeof requestType.body === "string") {
      const objectProperty2 = await this.resolveObjectProperty({
        file,
        typeName: requestType.body,
        propertyComponents
      });
      if (objectProperty2 == null) {
        return void 0;
      }
      return {
        propertyPath: await this.propertyPathFromPropertyComponents({
          propertyComponents,
          file
        }),
        property: RequestPropertyValue.body(objectProperty2)
      };
    }
    if (isInlineRequestBody(requestType.body)) {
      const objectProperty2 = await getNestedObjectPropertyFromObjectSchema({
        typeResolver,
        file,
        objectSchema: requestType.body,
        propertyComponents
      });
      if (objectProperty2 == null) {
        return void 0;
      }
      return {
        propertyPath: await this.propertyPathFromPropertyComponents({
          propertyComponents,
          file
        }),
        property: RequestPropertyValue.body(objectProperty2)
      };
    }
    const objectProperty = await this.resolveObjectProperty({
      file,
      typeName: requestType.body.type,
      propertyComponents
    });
    if (objectProperty == null) {
      return void 0;
    }
    return {
      propertyPath: await this.propertyPathFromPropertyComponents({
        propertyComponents,
        file
      }),
      property: RequestPropertyValue.body(objectProperty)
    };
  }
  async resolveObjectProperty({ file, typeName, propertyComponents }) {
    const resolvedType = this.typeResolver.resolveTypeOrThrow({
      type: typeName,
      file
    });
    return await getNestedObjectPropertyFromResolvedType({
      typeResolver: this.typeResolver,
      file: maybeFileFromResolvedType(resolvedType) ?? file,
      resolvedType,
      propertyComponents
    });
  }
  async propertyPathFromPropertyComponents({ propertyComponents, file }) {
    if (propertyComponents.length <= 1) {
      return [];
    }
    return propertyComponents.slice(0, -1).map((property4) => file.casingsGenerator.generateName(property4));
  }
};

// ../../cli/generation/ir-generator/lib/resolvers/TypeResolver.js
var TypeResolverImpl = class {
  workspace;
  constructor(workspace) {
    this.workspace = workspace;
  }
  resolveTypeOrThrow({ type: type2, file }) {
    const resolvedType = this.resolveType({ type: type2, file });
    if (resolvedType == null) {
      throw new Error("Cannot resolve type: " + type2 + " in file " + file.relativeFilepath);
    }
    return resolvedType;
  }
  getDeclarationOfNamedTypeOrThrow({ referenceToNamedType, file }) {
    const declaration = this.getDeclarationOfNamedType({ referenceToNamedType, file });
    if (declaration == null) {
      throw new Error("Cannot find declaration of type: " + referenceToNamedType + " in file " + file.relativeFilepath);
    }
    return declaration;
  }
  getDeclarationOfNamedType({ referenceToNamedType, file }) {
    const parsedReference = parseReferenceToTypeName({
      reference: referenceToNamedType,
      referencedIn: file.relativeFilepath,
      imports: file.imports
    });
    if (parsedReference == null) {
      return void 0;
    }
    const definitionFile = getDefinitionFile(this.workspace, parsedReference.relativeFilepath);
    if (definitionFile == null) {
      return void 0;
    }
    const declaration = definitionFile.types?.[parsedReference.typeName];
    if (declaration == null) {
      const parsedGeneric = parseGeneric(parsedReference.typeName);
      if (parsedGeneric != null) {
        for (const type2 of Object.keys(definitionFile.types ?? {}) ?? []) {
          if (parsedGeneric.name && type2.startsWith(parsedGeneric.name) && type2.endsWith(">")) {
            const genericDeclaration = definitionFile.types?.[type2];
            return genericDeclaration != null ? {
              typeName: type2,
              declaration: genericDeclaration,
              file: constructFernFileContext({
                relativeFilepath: parsedReference.relativeFilepath,
                definitionFile,
                casingsGenerator: file.casingsGenerator,
                rootApiFile: this.workspace.definition.rootApiFile.contents
              })
            } : void 0;
          }
        }
      }
      return void 0;
    }
    return {
      typeName: parsedReference.typeName,
      declaration,
      file: constructFernFileContext({
        relativeFilepath: parsedReference.relativeFilepath,
        definitionFile,
        casingsGenerator: file.casingsGenerator,
        rootApiFile: this.workspace.definition.rootApiFile.contents
      })
    };
  }
  resolveType({ type: type2, file, objectPath = [] }) {
    return recursivelyVisitRawTypeReference({
      type: type2,
      _default: void 0,
      validation: void 0,
      visitor: {
        primitive: (primitive) => ({
          _type: "primitive",
          primitive,
          originalTypeReference: TypeReference2.primitive(primitive)
        }),
        unknown: () => ({ _type: "unknown", originalTypeReference: TypeReference2.unknown() }),
        map: ({ keyType, valueType }) => keyType != null && valueType != null ? {
          _type: "container",
          container: {
            _type: "map",
            keyType,
            valueType
          },
          originalTypeReference: TypeReference2.container(ContainerType.map({
            keyType: keyType.originalTypeReference,
            valueType: valueType.originalTypeReference
          }))
        } : void 0,
        list: (itemType) => itemType != null ? {
          _type: "container",
          container: {
            _type: "list",
            itemType
          },
          originalTypeReference: TypeReference2.container(ContainerType.list(itemType.originalTypeReference))
        } : void 0,
        optional: (itemType) => itemType != null ? {
          _type: "container",
          container: {
            _type: "optional",
            itemType
          },
          originalTypeReference: TypeReference2.container(ContainerType.optional(itemType.originalTypeReference))
        } : void 0,
        set: (itemType) => itemType != null ? {
          _type: "container",
          container: {
            _type: "set",
            itemType
          },
          originalTypeReference: TypeReference2.container(ContainerType.set(itemType.originalTypeReference))
        } : void 0,
        literal: (literal) => ({
          _type: "container",
          container: {
            _type: "literal",
            literal
          },
          originalTypeReference: TypeReference2.container(ContainerType.literal(literal))
        }),
        named: (referenceToNamedType) => {
          const maybeDeclaration = this.getDeclarationOfNamedType({
            referenceToNamedType,
            file
          });
          if (maybeDeclaration == null) {
            return void 0;
          }
          const newObjectPathItem = {
            typeName: maybeDeclaration.typeName,
            file: maybeDeclaration.file.relativeFilepath,
            reference: referenceToNamedType
          };
          if (objectPath.some((pathItem) => pathItem.file === newObjectPathItem.file && pathItem.typeName === newObjectPathItem.typeName)) {
            return void 0;
          }
          return this.resolveNamedTypeFromDeclaration({
            referenceToNamedType,
            referencedIn: file,
            rawDeclaration: maybeDeclaration,
            objectPath: [...objectPath, newObjectPathItem]
          });
        }
      }
    });
  }
  resolveNamedTypeOrThrow({ referenceToNamedType, file }) {
    const resolvedType = this.resolveNamedType({ referenceToNamedType, file });
    if (resolvedType == null) {
      throw new Error("Cannot resolve type: " + referenceToNamedType);
    }
    return resolvedType;
  }
  resolveNamedType({ referenceToNamedType, file }) {
    const maybeDeclaration = this.getDeclarationOfNamedType({
      referenceToNamedType,
      file
    });
    if (maybeDeclaration == null) {
      return void 0;
    }
    return this.resolveNamedTypeFromDeclaration({
      referenceToNamedType,
      referencedIn: file,
      rawDeclaration: maybeDeclaration
    });
  }
  resolveNamedTypeFromDeclaration({ referenceToNamedType, referencedIn, rawDeclaration, objectPath = [] }) {
    const { declaration, file: fileOfResolvedDeclaration } = rawDeclaration;
    if (isRawAliasDefinition(declaration)) {
      return this.resolveType({
        type: typeof declaration === "string" ? declaration : declaration.type,
        file: fileOfResolvedDeclaration,
        objectPath
      });
    }
    const parsedTypeReference = parseInlineType({
      type: referenceToNamedType,
      _default: void 0,
      validation: void 0,
      file: referencedIn
    });
    if (parsedTypeReference.type !== "named") {
      return void 0;
    }
    const definitionFile = getDefinitionFile(this.workspace, fileOfResolvedDeclaration.relativeFilepath);
    if (definitionFile == null) {
      return void 0;
    }
    return {
      _type: "named",
      rawName: rawDeclaration.typeName,
      name: parsedTypeReference,
      declaration,
      filepath: fileOfResolvedDeclaration.relativeFilepath,
      objectPath,
      originalTypeReference: parsedTypeReference,
      file: fileOfResolvedDeclaration
    };
  }
};

// ../../cli/generation/ir-generator/lib/resolvers/VariableResolver.js
var VariableResolverImpl = class _VariableResolverImpl {
  static VARIABLE_PREFIX = "$";
  getDeclarationOrThrow(referenceToVariable, file) {
    const declaration = this.getDeclaration(referenceToVariable, file);
    if (declaration == null) {
      throw new Error("Variable does not exist: " + referenceToVariable);
    }
    return declaration;
  }
  getDeclaration(referenceToVariable, file) {
    if (!referenceToVariable.startsWith(_VariableResolverImpl.VARIABLE_PREFIX)) {
      return void 0;
    }
    const declaration = file.rootApiFile.variables?.[referenceToVariable.substring(1)];
    if (declaration == null) {
      return void 0;
    }
    return {
      declaration,
      file: constructRootApiFileContext({
        casingsGenerator: file.casingsGenerator,
        rootApiFile: file.rootApiFile
      })
    };
  }
  getVariableIdOrThrow(referenceToVariable) {
    const variableId = this.getVariableId(referenceToVariable);
    if (variableId == null) {
      throw new Error("Variable reference does not start with " + _VariableResolverImpl.VARIABLE_PREFIX);
    }
    return variableId;
  }
  getVariableId(referenceToVariable) {
    if (!referenceToVariable.startsWith(_VariableResolverImpl.VARIABLE_PREFIX)) {
      return void 0;
    }
    return referenceToVariable.substring(_VariableResolverImpl.VARIABLE_PREFIX.length);
  }
};

// ../../cli/generation/ir-generator/lib/utils/getEnvironmentsByAudience.js
function getAudienceForEnvironment(environmentId, rawEnvironments) {
  if (rawEnvironments) {
    for (const [envId, environment] of Object.entries(rawEnvironments)) {
      if (typeof environment !== "string" && envId === environmentId) {
        return environment.audiences;
      }
    }
  }
  return void 0;
}

// ../../cli/generation/ir-generator/lib/examples/generator/generatePrimitiveExample.js
function generatePrimitiveExample({ fieldName, primitiveType }) {
  switch (primitiveType.v1) {
    case "STRING": {
      return generatePrimitiveStringExample({
        fieldName,
        validation: maybeStringValidation2(primitiveType.v2)
      });
    }
    case "BASE_64": {
      return { type: "success", example: ExamplePrimitive.base64(examples_exports.BASE64), jsonExample: examples_exports.BASE64 };
    }
    case "BOOLEAN": {
      return {
        type: "success",
        example: ExamplePrimitive.boolean(examples_exports.BOOLEAN),
        jsonExample: examples_exports.BOOLEAN
      };
    }
    case "DATE": {
      return { type: "success", example: ExamplePrimitive.date(examples_exports.DATE), jsonExample: examples_exports.DATE };
    }
    case "DATE_TIME": {
      return {
        type: "success",
        example: ExamplePrimitive.datetime({
          datetime: new Date(examples_exports.DATE_TIME),
          raw: examples_exports.DATE_TIME
        }),
        jsonExample: examples_exports.DATE_TIME
      };
    }
    case "DOUBLE": {
      return generatePrimitiveDoubleExample({
        fieldName,
        validation: maybeDoubleValidation(primitiveType.v2)
      });
    }
    case "FLOAT": {
      return { type: "success", example: ExamplePrimitive.float(examples_exports.FLOAT), jsonExample: examples_exports.FLOAT };
    }
    case "INTEGER": {
      return generatePrimitiveIntegerExample({
        fieldName,
        validation: maybeIntegerValidation(primitiveType.v2)
      });
    }
    case "UINT_64": {
      return { type: "success", example: ExamplePrimitive.uint64(examples_exports.INT64), jsonExample: examples_exports.INT64 };
    }
    case "UINT": {
      return { type: "success", example: ExamplePrimitive.uint(examples_exports.UINT), jsonExample: examples_exports.UINT };
    }
    case "BIG_INTEGER": {
      return {
        type: "success",
        example: ExamplePrimitive.bigInteger(examples_exports.INT64.toString()),
        jsonExample: `${examples_exports.INT64}`
      };
    }
    case "LONG": {
      return { type: "success", example: ExamplePrimitive.long(examples_exports.INT64), jsonExample: examples_exports.INT64 };
    }
    case "UUID": {
      return { type: "success", example: ExamplePrimitive.uuid(examples_exports.UUID), jsonExample: examples_exports.UUID };
    }
    default:
      assertNever(primitiveType.v1);
  }
}
function maybeStringValidation2(v2) {
  if (v2?.type === "string") {
    const stringType2 = v2;
    return stringType2.validation;
  }
  return void 0;
}
function maybeDoubleValidation(v2) {
  if (v2?.type === "double") {
    const doubleType = v2;
    return doubleType.validation;
  }
  return void 0;
}
function maybeIntegerValidation(v2) {
  if (v2?.type === "integer") {
    const integerType = v2;
    return integerType.validation;
  }
  return void 0;
}
function getStringExampleOfLength(length) {
  if (length <= examples_exports.SAMPLE_STRINGS.length) {
    const sampleString = examples_exports.SAMPLE_STRINGS[length - 1];
    if (sampleString) {
      return sampleString;
    } else {
      throw new Error(`Unexpected undefined value in SAMPLE_STRINGS at index ${length - 1}`);
    }
  }
  return examples_exports.SAMPLE_STRINGS[examples_exports.SAMPLE_STRINGS.length - 1] + ".".repeat(length - examples_exports.SAMPLE_STRINGS.length);
}
function generatePrimitiveStringExample({ fieldName, validation }) {
  if (validation) {
    const minLength = validation.minLength;
    const maxLength = validation.maxLength;
    if (minLength) {
      const minLengthExample = getStringExampleOfLength(minLength);
      return {
        type: "success",
        example: ExamplePrimitive.string({ original: minLengthExample }),
        jsonExample: minLengthExample
      };
    } else if (maxLength) {
      const maxLengthExample = getStringExampleOfLength(maxLength);
      return {
        type: "success",
        example: ExamplePrimitive.string({ original: maxLengthExample }),
        jsonExample: maxLengthExample
      };
    }
  }
  const jsonExample = fieldName ?? examples_exports.STRING;
  return { type: "success", example: ExamplePrimitive.string({ original: jsonExample }), jsonExample };
}
function generatePrimitiveDoubleExample({ fieldName, validation }) {
  if (validation) {
    const maximum = validation.max;
    const minimum = validation.min;
    if (maximum) {
      return { type: "success", example: ExamplePrimitive.double(maximum), jsonExample: maximum };
    } else if (minimum) {
      return { type: "success", example: ExamplePrimitive.double(minimum), jsonExample: minimum };
    }
  }
  return { type: "success", example: ExamplePrimitive.double(examples_exports.DOUBLE), jsonExample: examples_exports.DOUBLE };
}
function generatePrimitiveIntegerExample({ fieldName, validation }) {
  if (validation) {
    const maximum = validation.max;
    const minimum = validation.min;
    if (maximum) {
      return { type: "success", example: ExamplePrimitive.integer(maximum), jsonExample: maximum };
    } else if (minimum) {
      return { type: "success", example: ExamplePrimitive.integer(minimum), jsonExample: minimum };
    }
  }
  return { type: "success", example: ExamplePrimitive.integer(examples_exports.INT), jsonExample: examples_exports.INT };
}

// ../../cli/generation/ir-generator/lib/examples/generator/generateContainerExample.js
function generateContainerExample({ fieldName, containerType, maxDepth, currentDepth, typeDeclarations, skipOptionalProperties }) {
  if (currentDepth >= maxDepth) {
    return generateEmptyContainerExample({ containerType });
  }
  switch (containerType.type) {
    case "list": {
      const example = generateTypeReferenceExample({
        fieldName,
        typeReference: containerType.list,
        maxDepth,
        currentDepth: currentDepth + 1,
        typeDeclarations,
        skipOptionalProperties
      });
      if (example.type === "failure") {
        return generateEmptyContainerExample({ containerType });
      }
      return {
        type: "success",
        example: ExampleContainer.list({
          list: [example.example, example.example],
          itemType: containerType.list
        }),
        jsonExample: [example.jsonExample, example.jsonExample]
      };
    }
    case "literal": {
      return {
        type: "success",
        example: ExampleContainer.literal({
          literal: containerType.literal._visit({
            boolean: (value) => ExamplePrimitive.boolean(value),
            string: (value) => ExamplePrimitive.string({ original: value }),
            _other: () => {
              throw new Error("Encountered unknown literal type");
            }
          })
        }),
        jsonExample: containerType.literal._visit({
          boolean: (value) => value,
          string: (value) => value,
          _other: () => {
            throw new Error("Encountered unknown literal type");
          }
        })
      };
    }
    case "optional": {
      if (skipOptionalProperties) {
        return generateEmptyContainerExample({ containerType });
      }
      const example = generateTypeReferenceExample({
        fieldName,
        typeReference: containerType.optional,
        maxDepth,
        currentDepth: currentDepth + 1,
        typeDeclarations,
        skipOptionalProperties
      });
      if (example.type === "failure") {
        return generateEmptyContainerExample({ containerType });
      }
      return {
        type: "success",
        example: ExampleContainer.optional({
          optional: example.example,
          valueType: containerType.optional
        }),
        jsonExample: example.jsonExample
      };
    }
    case "set": {
      const example = generateTypeReferenceExample({
        fieldName,
        typeReference: containerType.set,
        maxDepth,
        currentDepth: currentDepth + 1,
        typeDeclarations,
        skipOptionalProperties
      });
      if (example.type === "failure") {
        return generateEmptyContainerExample({ containerType });
      }
      return {
        type: "success",
        example: ExampleContainer.set({
          set: [example.example],
          itemType: containerType.set
        }),
        jsonExample: [example.jsonExample]
      };
    }
    case "map": {
      const keyExample = generateTypeReferenceExample({
        fieldName,
        typeReference: containerType.keyType,
        maxDepth,
        currentDepth: currentDepth + 1,
        typeDeclarations,
        skipOptionalProperties
      });
      const valueExample = generateTypeReferenceExample({
        fieldName,
        typeReference: containerType.valueType,
        maxDepth,
        currentDepth: currentDepth + 1,
        typeDeclarations,
        skipOptionalProperties
      });
      if (keyExample.type === "failure" || valueExample.type === "failure") {
        return generateEmptyContainerExample({ containerType });
      }
      return {
        type: "success",
        example: ExampleContainer.map({
          map: [
            {
              key: keyExample.example,
              value: valueExample.example
            }
          ],
          keyType: containerType.keyType,
          valueType: containerType.valueType
        }),
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        jsonExample: { [keyExample.jsonExample]: valueExample.jsonExample }
      };
    }
    default:
      assertNever(containerType);
  }
}
function generateEmptyContainerExample({ containerType }) {
  switch (containerType.type) {
    case "list": {
      return {
        type: "success",
        example: ExampleContainer.list({
          list: [],
          itemType: containerType.list
        }),
        jsonExample: []
      };
    }
    case "literal": {
      return {
        type: "success",
        example: ExampleContainer.literal({
          literal: containerType.literal._visit({
            boolean: (value) => ExamplePrimitive.boolean(value),
            string: (value) => ExamplePrimitive.string({ original: value }),
            _other: () => {
              throw new Error("Encountered unknown literal type");
            }
          })
        }),
        jsonExample: containerType.literal._visit({
          boolean: (value) => value,
          string: (value) => value,
          _other: () => {
            throw new Error("Encountered unknown literal type");
          }
        })
      };
    }
    case "optional": {
      return {
        type: "success",
        example: ExampleContainer.optional({
          optional: void 0,
          valueType: containerType.optional
        }),
        jsonExample: void 0
      };
    }
    case "set": {
      return {
        type: "success",
        example: ExampleContainer.set({
          set: [],
          itemType: containerType.set
        }),
        jsonExample: []
      };
    }
    case "map": {
      return {
        type: "success",
        example: ExampleContainer.map({
          map: [],
          keyType: containerType.keyType,
          valueType: containerType.valueType
        }),
        jsonExample: {}
      };
    }
    default:
      assertNever(containerType);
  }
}

// ../../cli/generation/ir-generator/lib/examples/generator/isTypeReferenceOptional.js
function isOptional({ typeReference, typeDeclarations }) {
  if (typeReference.type === "container" && typeReference.container.type === "optional") {
    return true;
  }
  if (typeReference.type === "named") {
    const typeDeclaration = typeDeclarations[typeReference.typeId];
    if (typeDeclaration?.shape.type === "alias" && typeDeclaration?.shape.resolvedType.type === "container" && typeDeclaration?.shape.resolvedType.container.type === "optional") {
      return true;
    }
  }
  return false;
}

// ../../cli/generation/ir-generator/lib/examples/generator/generateTypeDeclarationExample.js
function generateTypeDeclarationExample({ fieldName, typeDeclarations, typeDeclaration, maxDepth, currentDepth, skipOptionalProperties }) {
  switch (typeDeclaration.shape.type) {
    case "alias": {
      const generatedExample = generateTypeReferenceExample({
        fieldName,
        typeDeclarations,
        typeReference: typeDeclaration.shape.aliasOf,
        maxDepth,
        currentDepth,
        skipOptionalProperties
      });
      if (generatedExample.type === "failure") {
        return generatedExample;
      }
      const { example, jsonExample } = generatedExample;
      return {
        type: "success",
        example: ExampleTypeShape.alias({
          value: example
        }),
        jsonExample
      };
    }
    case "enum": {
      const enumValue = typeDeclaration.shape.values[0];
      if (enumValue == null) {
        return { type: "failure", message: "No enum values present" };
      }
      return {
        type: "success",
        example: ExampleTypeShape.enum({
          value: enumValue.name
        }),
        jsonExample: enumValue.name.wireValue
      };
    }
    case "object": {
      const objectExample = generateObjectDeclarationExample({
        fieldName,
        typeDeclaration,
        objectTypeDeclaration: typeDeclaration.shape,
        typeDeclarations,
        currentDepth,
        maxDepth,
        skipOptionalProperties
      });
      if (objectExample.type === "failure") {
        return objectExample;
      }
      const { example, jsonExample } = objectExample;
      return {
        type: "success",
        example: ExampleTypeShape.object(example),
        jsonExample
      };
    }
    case "undiscriminatedUnion": {
      let i = 0;
      for (const variant of typeDeclaration.shape.members) {
        const variantExample = generateTypeReferenceExample({
          fieldName,
          typeReference: variant.type,
          typeDeclarations,
          currentDepth: currentDepth + 1,
          maxDepth,
          skipOptionalProperties
        });
        if (variantExample.type === "failure") {
          ++i;
          continue;
        }
        const { example, jsonExample } = variantExample;
        return {
          type: "success",
          example: ExampleTypeShape.undiscriminatedUnion({
            index: i,
            singleUnionType: example
          }),
          jsonExample
        };
      }
      break;
    }
    case "union": {
      const discriminant3 = typeDeclaration.shape.discriminant;
      for (const variant of typeDeclaration.shape.types) {
        const variantExample = variant.shape._visit({
          noProperties: () => {
            return {
              type: "success",
              example: ExampleTypeShape.union({
                discriminant: discriminant3,
                singleUnionType: {
                  wireDiscriminantValue: variant.discriminantValue,
                  shape: ExampleSingleUnionTypeProperties.noProperties()
                }
              }),
              jsonExample: {
                [discriminant3.wireValue]: variant.discriminantValue.wireValue
              }
            };
          },
          samePropertiesAsObject: (samePropertiesAsObject) => {
            const typeDeclaration2 = typeDeclarations[samePropertiesAsObject.typeId];
            if (typeDeclaration2 == null) {
              throw new Error(`Failed to find type declaration with id ${samePropertiesAsObject.typeId}`);
            }
            if (typeDeclaration2.shape.type !== "object") {
              throw new Error(`Same properties as object union is not an object ${typeDeclaration2.shape.type}`);
            }
            const objectExample = generateObjectDeclarationExample({
              currentDepth,
              maxDepth,
              fieldName,
              objectTypeDeclaration: typeDeclaration2.shape,
              typeDeclaration: typeDeclaration2,
              typeDeclarations,
              skipOptionalProperties
            });
            if (objectExample.type === "failure") {
              return objectExample;
            }
            const { example, jsonExample } = objectExample;
            return {
              type: "success",
              example: ExampleTypeShape.union({
                discriminant: discriminant3,
                singleUnionType: {
                  wireDiscriminantValue: variant.discriminantValue,
                  shape: ExampleSingleUnionTypeProperties.samePropertiesAsObject({
                    typeId: typeDeclaration2.name.typeId,
                    object: example
                  })
                }
              }),
              jsonExample: {
                [discriminant3.wireValue]: variant.discriminantValue.wireValue,
                ...typeof jsonExample === "object" ? jsonExample : {}
              }
            };
          },
          singleProperty: (value) => {
            const singlePropertyExample = generateTypeReferenceExample({
              currentDepth: currentDepth + 1,
              maxDepth,
              fieldName,
              typeReference: value.type,
              typeDeclarations,
              skipOptionalProperties
            });
            if (singlePropertyExample.type === "failure") {
              return singlePropertyExample;
            }
            const { example, jsonExample } = singlePropertyExample;
            return {
              type: "success",
              example: ExampleTypeShape.union({
                discriminant: discriminant3,
                singleUnionType: {
                  wireDiscriminantValue: variant.discriminantValue,
                  shape: ExampleSingleUnionTypeProperties.singleProperty(example)
                }
              }),
              jsonExample: {
                [discriminant3.wireValue]: variant.discriminantValue.wireValue,
                [value.name.wireValue]: jsonExample
              }
            };
          },
          _other: () => {
            throw new Error("Encountered unknown union type");
          }
        });
        if (variantExample.type === "failure") {
          continue;
        }
        return variantExample;
      }
    }
  }
  return { type: "failure", message: "Failed to generate example for type reference" };
}
function generateObjectDeclarationExample({ fieldName, typeDeclaration, objectTypeDeclaration, typeDeclarations, maxDepth, currentDepth, skipOptionalProperties }) {
  const jsonExample = {};
  const properties = [];
  for (const property4 of [
    ...objectTypeDeclaration.properties ?? [],
    ...objectTypeDeclaration.extendedProperties ?? []
  ]) {
    const propertyExample = generateTypeReferenceExample({
      fieldName: property4.name.wireValue,
      typeReference: property4.valueType,
      typeDeclarations,
      currentDepth: currentDepth + 1,
      maxDepth,
      skipOptionalProperties
    });
    if (propertyExample.type === "failure" && !isOptional({ typeDeclarations, typeReference: property4.valueType })) {
      return {
        type: "failure",
        message: `Failed to generate required property ${property4.name.wireValue} b/c ${propertyExample.message}`
      };
    } else if (propertyExample.type === "failure") {
      continue;
    }
    const { example, jsonExample: propertyJsonExample } = propertyExample;
    properties.push({
      name: property4.name,
      originalTypeDeclaration: typeDeclaration.name,
      value: example
    });
    jsonExample[property4.name.wireValue] = propertyJsonExample;
  }
  return {
    type: "success",
    example: ExampleTypeShape.object({
      properties
    }),
    jsonExample
  };
}

// ../../cli/generation/ir-generator/lib/examples/generator/generateTypeReferenceExample.js
function generateTypeReferenceExample({ fieldName, typeReference, typeDeclarations, maxDepth, currentDepth, skipOptionalProperties }) {
  if (currentDepth > maxDepth) {
    return { type: "failure", message: "Exceeded max depth" };
  }
  switch (typeReference.type) {
    case "named": {
      const typeDeclaration = typeDeclarations[typeReference.typeId];
      if (typeDeclaration == null) {
        throw new Error(`Failed to find type declaration with id ${typeReference.typeId}`);
      }
      const generatedExample = generateTypeDeclarationExample({
        fieldName,
        typeDeclaration,
        typeDeclarations,
        maxDepth,
        currentDepth,
        skipOptionalProperties
      });
      if (generatedExample.type === "failure") {
        return generatedExample;
      }
      const { example, jsonExample } = generatedExample;
      return {
        type: "success",
        example: {
          jsonExample,
          shape: ExampleTypeReferenceShape.named({
            shape: example,
            typeName: typeDeclaration.name
          })
        },
        jsonExample
      };
    }
    case "container": {
      const generatedExample = generateContainerExample({
        fieldName,
        containerType: typeReference.container,
        typeDeclarations,
        maxDepth,
        currentDepth,
        skipOptionalProperties
      });
      if (generatedExample.type === "failure") {
        const { example: example2, jsonExample: jsonExample2 } = generateEmptyContainerExample({
          containerType: typeReference.container
        });
        return {
          type: "success",
          example: {
            jsonExample: jsonExample2,
            shape: ExampleTypeReferenceShape.container(example2)
          },
          jsonExample: jsonExample2
        };
      }
      const { example, jsonExample } = generatedExample;
      return {
        type: "success",
        example: {
          jsonExample,
          shape: ExampleTypeReferenceShape.container(example)
        },
        jsonExample
      };
    }
    case "primitive": {
      const { jsonExample, example } = generatePrimitiveExample({
        fieldName,
        primitiveType: typeReference.primitive
      });
      return {
        type: "success",
        example: {
          jsonExample,
          shape: ExampleTypeReferenceShape.primitive(example)
        },
        jsonExample
      };
    }
    case "unknown": {
      const jsonExample = { key: "value" };
      return {
        type: "success",
        example: {
          jsonExample,
          shape: ExampleTypeReferenceShape.unknown(jsonExample)
        },
        jsonExample
      };
    }
  }
}

// ../../cli/generation/ir-generator/lib/examples/generator/generateSuccessEndpointExample.js
var import_object_hash = __toESM(require_object_hash(), 1);
function generateEndpointExample({ ir, endpoint, service, typeDeclarations, skipOptionalRequestProperties, generationResponse }) {
  const result = {
    name: void 0,
    endpointHeaders: [],
    endpointPathParameters: [],
    queryParameters: [],
    servicePathParameters: [],
    serviceHeaders: [],
    rootPathParameters: [],
    request: void 0,
    response: ExampleResponse.ok(ExampleEndpointSuccessResponse.body(void 0)),
    docs: void 0
  };
  const pathParameterGroups = [
    {
      params: endpoint.pathParameters,
      add: (example) => result.endpointPathParameters.push(example)
    },
    {
      params: service.pathParameters,
      add: (example) => result.servicePathParameters.push(example)
    },
    {
      params: ir.pathParameters,
      add: (example) => result.rootPathParameters.push(example)
    }
  ];
  for (const group of pathParameterGroups) {
    for (const pathParameter of group.params) {
      const generatedExample = generateTypeReferenceExample({
        fieldName: pathParameter.name.originalName,
        currentDepth: 0,
        maxDepth: 1,
        typeDeclarations,
        typeReference: pathParameter.valueType,
        skipOptionalProperties: skipOptionalRequestProperties
      });
      if (generatedExample.type === "failure") {
        return generatedExample;
      }
      const { example } = generatedExample;
      group.add({
        name: pathParameter.name,
        value: example
      });
    }
  }
  for (const queryParameter of endpoint.queryParameters) {
    if (skipOptionalRequestProperties && isOptional({ typeDeclarations, typeReference: queryParameter.valueType })) {
      continue;
    }
    const generatedExample = generateTypeReferenceExample({
      fieldName: queryParameter.name.name.originalName,
      currentDepth: 0,
      maxDepth: 1,
      typeDeclarations,
      typeReference: queryParameter.valueType,
      skipOptionalProperties: skipOptionalRequestProperties
    });
    if (generatedExample.type === "failure") {
      return generatedExample;
    }
    const { example } = generatedExample;
    result.queryParameters.push({
      name: queryParameter.name,
      shape: queryParameter.allowMultiple ? ExampleQueryParameterShape.exploded() : ExampleQueryParameterShape.single(),
      value: example
    });
  }
  const headerGroup = [
    {
      params: endpoint.headers,
      add: (example) => result.endpointHeaders.push(example)
    },
    {
      params: service.headers,
      add: (example) => result.serviceHeaders.push(example)
    }
  ];
  for (const group of headerGroup) {
    for (const header of group.params) {
      if (skipOptionalRequestProperties && isOptional({ typeDeclarations, typeReference: header.valueType })) {
        continue;
      }
      const generatedExample = generateTypeReferenceExample({
        fieldName: header.name.name.originalName,
        currentDepth: 0,
        maxDepth: 1,
        typeDeclarations,
        typeReference: header.valueType,
        skipOptionalProperties: skipOptionalRequestProperties
      });
      if (generatedExample.type === "failure") {
        return generatedExample;
      }
      const { example } = generatedExample;
      group.add({
        name: header.name,
        value: example
      });
    }
  }
  if (endpoint.requestBody != null) {
    switch (endpoint.requestBody.type) {
      case "bytes":
        return { type: "failure", message: "Bytes request unsupported" };
      case "fileUpload":
        return { type: "failure", message: "File upload unsupported" };
      case "inlinedRequestBody": {
        const jsonExample = {};
        const properties = [];
        for (const property4 of [
          ...endpoint.requestBody.properties ?? [],
          ...endpoint.requestBody.extendedProperties ?? []
        ]) {
          const propertyExample = generateTypeReferenceExample({
            fieldName: property4.name.wireValue,
            typeReference: property4.valueType,
            typeDeclarations,
            currentDepth: 1,
            maxDepth: 10,
            skipOptionalProperties: skipOptionalRequestProperties
          });
          if (propertyExample.type === "failure" && !isOptional({ typeDeclarations, typeReference: property4.valueType })) {
            return {
              type: "failure",
              message: `Failed to generate required property ${property4.name.wireValue} b/c ${propertyExample.message}`
            };
          } else if (propertyExample.type === "failure") {
            continue;
          }
          const { example, jsonExample: propertyJsonExample } = propertyExample;
          properties.push({
            name: property4.name,
            originalTypeDeclaration: void 0,
            value: example
          });
          jsonExample[property4.name.wireValue] = propertyJsonExample;
        }
        result.request = ExampleRequestBody.inlinedRequestBody({
          jsonExample,
          properties
        });
        break;
      }
      case "reference": {
        const generatedExample = generateTypeReferenceExample({
          currentDepth: 0,
          maxDepth: 10,
          typeDeclarations,
          typeReference: endpoint.requestBody.requestBodyType,
          skipOptionalProperties: skipOptionalRequestProperties
        });
        if (generatedExample.type === "failure") {
          return generatedExample;
        }
        const { example } = generatedExample;
        result.request = ExampleRequestBody.reference(example);
        break;
      }
      default:
        assertNever(endpoint.requestBody);
    }
  }
  if (generationResponse.type === "success" && endpoint.response?.body != null) {
    switch (endpoint.response.body.type) {
      case "fileDownload":
        return { type: "failure", message: "File download unsupported" };
      case "json": {
        const generatedExample = generateTypeReferenceExample({
          currentDepth: 0,
          maxDepth: 10,
          typeDeclarations,
          typeReference: endpoint.response.body.value.responseBodyType,
          skipOptionalProperties: false
        });
        if (generatedExample.type === "failure") {
          return generatedExample;
        }
        const { example, jsonExample } = generatedExample;
        result.response = ExampleResponse.ok(ExampleEndpointSuccessResponse.body({ ...example, jsonExample }));
        break;
      }
      case "streamParameter":
        return { type: "failure", message: "Stream parameter unsupported" };
      case "streaming":
        return { type: "failure", message: "Streaming unsupported" };
      case "text":
        return { type: "failure", message: "Text unsupported" };
      default:
        assertNever(endpoint.response.body);
    }
  } else if (generationResponse.type === "error") {
    if (generationResponse.declaration.type == null) {
      result.response = ExampleResponse.error({
        body: void 0,
        error: generationResponse.declaration.name
      });
    } else {
      const generatedExample = generateTypeReferenceExample({
        currentDepth: 0,
        maxDepth: 10,
        typeDeclarations,
        typeReference: generationResponse.declaration.type,
        skipOptionalProperties: skipOptionalRequestProperties
      });
      if (generatedExample.type === "failure") {
        return generatedExample;
      }
      const { example } = generatedExample;
      result.response = ExampleResponse.error({
        body: example,
        error: generationResponse.declaration.name
      });
    }
  }
  return {
    type: "success",
    example: {
      id: (0, import_object_hash.default)(result),
      url: getUrlForExample(endpoint, result),
      ...result
    },
    jsonExample: void 0
    // dummmy
  };
}
function getUrlForExample(endpoint, example) {
  const pathParameters = {};
  [...example.rootPathParameters, ...example.servicePathParameters, ...example.endpointPathParameters].forEach((examplePathParameter) => {
    const value = examplePathParameter.value.jsonExample;
    const stringValue = typeof value === "string" ? value : JSON.stringify(value);
    pathParameters[examplePathParameter.name.originalName] = stringValue;
  });
  const url = endpoint.fullPath.head + endpoint.fullPath.parts.map((pathPart) => pathParameters[pathPart.pathParameter] + pathPart.tail).join("");
  return url.startsWith("/") || url === "" ? url : `/${url}`;
}

// ../../cli/generation/ir-generator/lib/dynamic-snippets/version.js
var Version = "1.0.0";

// ../../cli/generation/ir-generator/lib/dynamic-snippets/DynamicSnippetsConverter.js
var DynamicSnippetsConverter = class {
  ir;
  auth;
  constructor(ir) {
    this.ir = ir;
    this.auth = this.convertAuth(ir.auth);
  }
  convert() {
    return {
      version: Version,
      types: this.convertNamedTypes(),
      headers: this.convertHeaders(),
      endpoints: this.convertEndpoints()
    };
  }
  convertNamedTypes() {
    return Object.fromEntries(Object.entries(this.ir.types).map(([typeId, typeDeclaration]) => [
      typeId,
      this.convertTypeDeclaration(typeDeclaration)
    ]));
  }
  convertHeaders() {
    return this.convertWireValueParameters({ wireValueParameters: this.ir.headers });
  }
  convertEndpoints() {
    const endpoints = this.getAllHttpEndpoints();
    return Object.fromEntries(endpoints.map((endpoint) => [endpoint.id, this.convertEndpoint(endpoint)]));
  }
  convertEndpoint(endpoint) {
    return {
      auth: this.auth,
      declaration: this.convertDeclaration({ name: endpoint.name, fernFilepath: endpoint.fernFilepath }),
      location: this.convertEndpointLocation({ endpoint }),
      request: this.convertRequest({ endpoint }),
      response: dynamic_exports.Response.json()
    };
  }
  convertRequest({ endpoint }) {
    const pathParameters = this.convertPathParameters({ pathParameters: endpoint.allPathParameters });
    if (endpoint.sdkRequest == null && endpoint.requestBody == null) {
      return dynamic_exports.Request.body({ pathParameters, body: void 0 });
    }
    if (endpoint.sdkRequest == null) {
      throw new Error(`Internal error; endpoint "${endpoint.id}" has a request body but no SDK request`);
    }
    switch (endpoint.sdkRequest.shape.type) {
      case "justRequestBody":
        return dynamic_exports.Request.body({
          pathParameters,
          body: this.convertReferencedRequestBodyType({ body: endpoint.sdkRequest.shape.value })
        });
      case "wrapper":
        return this.convertInlinedRequest({
          fernFilepath: endpoint.fernFilepath,
          wrapper: endpoint.sdkRequest.shape,
          pathParameters,
          queryParameters: this.convertQueryParameters({ queryParameters: endpoint.queryParameters }),
          headers: this.convertWireValueParameters({
            wireValueParameters: [...endpoint.serviceHeaders, ...endpoint.headers]
          }),
          body: endpoint.requestBody
        });
      default:
        assertNever(endpoint.sdkRequest.shape);
    }
  }
  convertReferencedRequestBodyType({ body }) {
    switch (body.type) {
      case "bytes":
        return dynamic_exports.ReferencedRequestBodyType.bytes();
      case "typeReference":
        return dynamic_exports.ReferencedRequestBodyType.typeReference(this.convertTypeReference(body.requestBodyType));
      default:
        assertNever(body);
    }
  }
  convertInlinedRequest({ fernFilepath, wrapper, pathParameters, queryParameters, headers, body }) {
    return dynamic_exports.Request.inlined({
      declaration: this.convertDeclaration({ name: wrapper.wrapperName, fernFilepath }),
      pathParameters,
      queryParameters,
      headers,
      body: body != null ? this.convertInlinedRequestBody({ wrapper, body }) : void 0,
      metadata: this.convertInlinedRequestMetadata({ wrapper })
    });
  }
  convertInlinedRequestMetadata({ wrapper }) {
    return {
      includePathParameters: wrapper.includePathParameters ?? false,
      onlyPathParameters: wrapper.onlyPathParameters ?? false
    };
  }
  convertInlinedRequestBody({ wrapper, body }) {
    switch (body.type) {
      case "inlinedRequestBody": {
        const properties = [...body.extendedProperties ?? [], ...body.properties];
        return dynamic_exports.InlinedRequestBody.properties(this.convertWireValueParameters({ wireValueParameters: properties }));
      }
      case "reference":
        return dynamic_exports.InlinedRequestBody.referenced({
          bodyKey: wrapper.bodyKey,
          bodyType: dynamic_exports.ReferencedRequestBodyType.typeReference(this.convertTypeReference(body.requestBodyType))
        });
      case "bytes":
        return dynamic_exports.InlinedRequestBody.referenced({
          bodyKey: wrapper.bodyKey,
          bodyType: dynamic_exports.ReferencedRequestBodyType.bytes()
        });
      case "fileUpload":
        return this.convertFileUploadRequestBody({ properties: body.properties });
      default:
        assertNever(body);
    }
  }
  convertFileUploadRequestBody({ properties }) {
    return dynamic_exports.InlinedRequestBody.fileUpload({
      properties: this.convertFileUploadRequestBodyProperties({ properties })
    });
  }
  convertFileUploadRequestBodyProperties({ properties }) {
    return properties.map((property4) => {
      switch (property4.type) {
        case "file":
          return this.convertFileUploadRequestBodyFileProperty({ fileProperty: property4.value });
        case "bodyProperty":
          return dynamic_exports.FileUploadRequestBodyProperty.bodyProperty({
            name: property4.name,
            typeReference: this.convertTypeReference(property4.valueType)
          });
        default:
          assertNever(property4);
      }
    });
  }
  convertFileUploadRequestBodyFileProperty({ fileProperty }) {
    switch (fileProperty.type) {
      case "file":
        return dynamic_exports.FileUploadRequestBodyProperty.file(fileProperty.key);
      case "fileArray":
        return dynamic_exports.FileUploadRequestBodyProperty.fileArray(fileProperty.key);
      default:
        assertNever(fileProperty);
    }
  }
  convertPathParameters({ pathParameters }) {
    return pathParameters.map((pathParameter) => ({
      name: {
        name: pathParameter.name,
        wireValue: pathParameter.name.originalName
      },
      typeReference: this.convertTypeReference(pathParameter.valueType)
    }));
  }
  convertWireValueParameters({ wireValueParameters }) {
    return wireValueParameters.map((parameter) => ({
      name: {
        name: parameter.name.name,
        wireValue: parameter.name.wireValue
      },
      typeReference: this.convertTypeReference(parameter.valueType)
    }));
  }
  convertQueryParameters({ queryParameters }) {
    const parameters = [];
    for (const queryParameter of queryParameters) {
      let typeReference = this.convertTypeReference(queryParameter.valueType);
      if (queryParameter.allowMultiple) {
        typeReference = dynamic_exports.TypeReference.list(typeReference);
      }
      parameters.push({
        name: {
          name: queryParameter.name.name,
          wireValue: queryParameter.name.wireValue
        },
        typeReference
      });
    }
    return parameters;
  }
  convertTypeReference(typeReference) {
    switch (typeReference.type) {
      case "container":
        return this.convertContainerType(typeReference.container);
      case "named":
        return this.convertNamedType(typeReference);
      case "primitive":
        return this.convertPrimitiveType(typeReference.primitive);
      case "unknown":
        return this.convertUnknownType();
      default:
        assertNever(typeReference);
    }
  }
  convertContainerType(container) {
    switch (container.type) {
      case "list":
        return dynamic_exports.TypeReference.list(this.convertTypeReference(container.list));
      case "map":
        return dynamic_exports.TypeReference.map({
          key: this.convertTypeReference(container.keyType),
          value: this.convertTypeReference(container.valueType)
        });
      case "optional":
        return dynamic_exports.TypeReference.optional(this.convertTypeReference(container.optional));
      case "set":
        return dynamic_exports.TypeReference.set(this.convertTypeReference(container.set));
      case "literal":
        return dynamic_exports.TypeReference.literal(this.convertLiteral(container.literal));
      default:
        assertNever(container);
    }
  }
  convertNamedType(named) {
    return dynamic_exports.TypeReference.named(named.typeId);
  }
  convertTypeDeclaration(typeDeclaration) {
    const declaration = this.convertDeclaration(typeDeclaration.name);
    switch (typeDeclaration.shape.type) {
      case "alias":
        return this.convertAlias({ declaration, alias: typeDeclaration.shape });
      case "enum":
        return this.convertEnum({ declaration, enum_: typeDeclaration.shape });
      case "object":
        return this.convertObject({ declaration, object: typeDeclaration.shape });
      case "union":
        return this.convertDiscriminatedUnion({ declaration, union: typeDeclaration.shape });
      case "undiscriminatedUnion":
        return this.convertUndiscriminatedUnion({ declaration, union: typeDeclaration.shape });
      default:
        assertNever(typeDeclaration.shape);
    }
  }
  convertAlias({ declaration, alias }) {
    return dynamic_exports.NamedType.alias({
      declaration,
      typeReference: this.convertTypeReference(alias.aliasOf)
    });
  }
  convertEnum({ declaration, enum_: enum_3 }) {
    return dynamic_exports.NamedType.enum({
      declaration,
      values: enum_3.values.map((value) => value.name)
    });
  }
  convertObject({ declaration, object: object3 }) {
    const properties = [...object3.extendedProperties ?? [], ...object3.properties];
    return this.convertObjectProperties({
      declaration,
      properties
    });
  }
  convertObjectProperties({ declaration, properties }) {
    return dynamic_exports.NamedType.object({
      declaration,
      properties: this.convertWireValueParameters({ wireValueParameters: properties })
    });
  }
  convertDiscriminatedUnion({ declaration, union: union3 }) {
    const inheritedProperties = [...this.resolveProperties(union3.extends), ...union3.baseProperties];
    return dynamic_exports.NamedType.discriminatedUnion({
      declaration,
      discriminant: union3.discriminant,
      types: Object.fromEntries(union3.types.map((unionType2) => [
        unionType2.discriminantValue.wireValue,
        this.convertDiscriminatedUnionType({
          inheritedProperties,
          discriminantValue: unionType2.discriminantValue,
          singleUnionTypeProperties: unionType2.shape
        })
      ]))
    });
  }
  convertDiscriminatedUnionType({ inheritedProperties, discriminantValue, singleUnionTypeProperties }) {
    switch (singleUnionTypeProperties.propertiesType) {
      case "samePropertiesAsObject":
        return this.convertDiscriminatedUnionTypeObject({
          inheritedProperties,
          discriminantValue,
          declaredTypeName: singleUnionTypeProperties
        });
      case "singleProperty":
        return this.convertDiscriminatedUnionTypeSingleProperty({
          inheritedProperties,
          discriminantValue,
          singleUnionTypeProperty: singleUnionTypeProperties
        });
      case "noProperties":
        return this.convertDiscriminatedUnionTypeNoProperties({
          inheritedProperties,
          discriminantValue
        });
      default:
        assertNever(singleUnionTypeProperties);
    }
  }
  convertDiscriminatedUnionTypeObject({ inheritedProperties, discriminantValue, declaredTypeName }) {
    return dynamic_exports.SingleDiscriminatedUnionType.samePropertiesAsObject({
      typeId: declaredTypeName.typeId,
      discriminantValue,
      properties: this.convertWireValueParameters({ wireValueParameters: inheritedProperties })
    });
  }
  convertDiscriminatedUnionTypeSingleProperty({ inheritedProperties, discriminantValue, singleUnionTypeProperty }) {
    return dynamic_exports.SingleDiscriminatedUnionType.singleProperty({
      typeReference: this.convertTypeReference(singleUnionTypeProperty.type),
      discriminantValue,
      properties: inheritedProperties.length > 0 ? this.convertWireValueParameters({ wireValueParameters: inheritedProperties }) : void 0
    });
  }
  convertDiscriminatedUnionTypeNoProperties({ inheritedProperties, discriminantValue }) {
    return dynamic_exports.SingleDiscriminatedUnionType.noProperties({
      discriminantValue,
      properties: inheritedProperties.length > 0 ? this.convertWireValueParameters({ wireValueParameters: inheritedProperties }) : void 0
    });
  }
  convertUndiscriminatedUnion({ declaration, union: union3 }) {
    return dynamic_exports.NamedType.undiscriminatedUnion({
      declaration,
      types: union3.members.map((member) => this.convertTypeReference(member.type))
    });
  }
  convertLiteral(literal) {
    switch (literal.type) {
      case "boolean":
        return dynamic_exports.LiteralType.boolean(literal.boolean);
      case "string":
        return dynamic_exports.LiteralType.string(literal.string);
      default:
        assertNever(literal);
    }
  }
  convertPrimitiveType(primitive) {
    return dynamic_exports.TypeReference.primitive(primitive.v1);
  }
  convertUnknownType() {
    return dynamic_exports.TypeReference.unknown();
  }
  convertAuth(auth) {
    if (auth.schemes[0] == null) {
      return void 0;
    }
    const scheme = auth.schemes[0];
    switch (scheme.type) {
      case "basic":
        return dynamic_exports.Auth.basic(scheme);
      case "bearer":
        return dynamic_exports.Auth.bearer(scheme);
      case "header":
        return dynamic_exports.Auth.header({
          header: {
            name: scheme.name,
            typeReference: this.convertTypeReference(scheme.valueType)
          }
        });
      case "oauth":
        return void 0;
      default:
        assertNever(scheme);
    }
  }
  convertDeclaration({ name, fernFilepath }) {
    return {
      name,
      fernFilepath
    };
  }
  convertEndpointLocation({ endpoint }) {
    return {
      method: endpoint.method,
      path: this.getFullPathForEndpoint(endpoint)
    };
  }
  getAllHttpEndpoints() {
    return Object.values(this.ir.services).flatMap((service) => service.endpoints.map((endpoint) => ({
      ...endpoint,
      serviceHeaders: service.headers,
      fernFilepath: service.name.fernFilepath
    })));
  }
  resolveProperties(declaredTypeNames) {
    const properties = [];
    for (const declaredTypeName of declaredTypeNames) {
      const typeDeclaration = this.resolveObjectTypeOrThrow(declaredTypeName.typeId);
      properties.push(...this.resolveProperties(typeDeclaration.extends));
      properties.push(...typeDeclaration.properties);
    }
    return Object.values(properties);
  }
  resolveObjectTypeOrThrow(typeId) {
    const typeDeclaration = this.ir.types[typeId];
    if (typeDeclaration == null) {
      throw new Error(`Internal error; type "${typeId}" not found`);
    }
    if (typeDeclaration.shape.type !== "object") {
      throw new Error(`Internal error; type "${typeId}" is not an object`);
    }
    return typeDeclaration.shape;
  }
  getFullPathForEndpoint(endpoint) {
    let url = "";
    if (endpoint.fullPath.head.length > 0) {
      url = urlJoin(url, endpoint.fullPath.head);
    }
    for (const part of endpoint.fullPath.parts) {
      url = urlJoin(url, "{" + part.pathParameter + "}");
      if (part.tail.length > 0) {
        url = urlJoin(url, part.tail);
      }
    }
    return url.startsWith("/") ? url : `/${url}`;
  }
};

// ../../cli/generation/ir-generator/lib/dynamic-snippets/convertIrToDynamicSnippetsIr.js
async function convertIrToDynamicSnippetsIr(ir) {
  const converter = new DynamicSnippetsConverter(ir);
  return converter.convert();
}

// ../../cli/generation/ir-generator/lib/generateIntermediateRepresentation.js
async function generateIntermediateRepresentation({ workspace, generationLanguage, keywords, smartCasing, disableExamples, audiences, readme, packageName, version, context, fdrApiDefinitionId, includeOptionalRequestPropertyExamples, sourceResolver }) {
  const casingsGenerator = constructCasingsGenerator({ generationLanguage, keywords, smartCasing });
  const irGraph = new IrGraph(audiences);
  const rootApiFileContext = constructRootApiFileContext({
    casingsGenerator,
    rootApiFile: workspace.definition.rootApiFile.contents
  });
  const globalErrors = (workspace.definition.rootApiFile.contents.errors ?? []).map((referenceToError) => {
    const errorName = parseErrorName({
      errorName: referenceToError,
      file: rootApiFileContext
    });
    return { error: errorName, docs: void 0 };
  });
  const typeResolver = new TypeResolverImpl(workspace);
  const endpointResolver = new EndpointResolverImpl(workspace);
  const propertyResolver = new PropertyResolverImpl(typeResolver, endpointResolver);
  const errorResolver = new ErrorResolverImpl(workspace);
  const exampleResolver = new ExampleResolverImpl(typeResolver);
  const variableResolver = new VariableResolverImpl();
  const intermediateRepresentation = {
    fdrApiDefinitionId,
    apiVersion: await convertApiVersionScheme({
      file: rootApiFileContext,
      rawApiFileSchema: workspace.definition.rootApiFile.contents
    }),
    apiName: casingsGenerator.generateName(workspace.definition.rootApiFile.contents.name),
    apiDisplayName: workspace.definition.rootApiFile.contents["display-name"],
    apiDocs: await formatDocs(workspace.definition.rootApiFile.contents.docs),
    auth: await convertApiAuth({
      rawApiFileSchema: workspace.definition.rootApiFile.contents,
      file: rootApiFileContext,
      propertyResolver,
      endpointResolver
    }),
    headers: workspace.definition.rootApiFile.contents.headers != null ? await Promise.all(Object.entries(workspace.definition.rootApiFile.contents.headers).map(([headerKey, header]) => convertHttpHeader({ headerKey, header, file: rootApiFileContext }))) : [],
    idempotencyHeaders: workspace.definition.rootApiFile.contents["idempotency-headers"] != null ? await Promise.all(Object.entries(workspace.definition.rootApiFile.contents["idempotency-headers"]).map(([headerKey, header]) => convertHttpHeader({ headerKey, header, file: rootApiFileContext }))) : [],
    types: {},
    errors: {},
    services: {},
    constants: generateFernConstants(casingsGenerator),
    environments: convertEnvironments({
      casingsGenerator,
      rawApiFileSchema: workspace.definition.rootApiFile.contents
    }),
    errorDiscriminationStrategy: convertErrorDiscriminationStrategy(workspace.definition.rootApiFile.contents["error-discrimination"], rootApiFileContext),
    basePath: workspace.definition.rootApiFile.contents["base-path"] != null ? constructHttpPath(workspace.definition.rootApiFile.contents["base-path"]) : void 0,
    pathParameters: await convertPathParameters2({
      pathParameters: workspace.definition.rootApiFile.contents["path-parameters"],
      file: rootApiFileContext,
      location: PathParameterLocation.Root,
      variableResolver
    }),
    variables: workspace.definition.rootApiFile.contents.variables != null ? Object.entries(workspace.definition.rootApiFile.contents.variables).map(([key, variable]) => ({
      docs: typeof variable !== "string" ? variable.docs : void 0,
      id: key,
      name: rootApiFileContext.casingsGenerator.generateName(key),
      type: rootApiFileContext.parseTypeReference(variable)
    })) : [],
    serviceTypeReferenceInfo: {
      typesReferencedOnlyByService: {},
      sharedTypes: []
    },
    webhookGroups: {},
    websocketChannels: {},
    readmeConfig: void 0,
    sourceConfig: void 0,
    publishConfig: void 0,
    dynamic: void 0
  };
  const packageTreeGenerator = new PackageTreeGenerator();
  const visitDefinitionFile = async (file) => {
    packageTreeGenerator.addSubpackage(file.fernFilepath);
    await visitObject(file.definitionFile, {
      imports: noop,
      docs: (docs) => {
        if (docs != null) {
          packageTreeGenerator.addDocs(file.fernFilepath, docs);
        }
      },
      types: async (types3) => {
        if (types3 == null) {
          return;
        }
        for (const [typeName, typeDeclaration] of Object.entries(types3)) {
          if (isGeneric(typeName)) {
            continue;
          }
          const convertedTypeDeclarationWithFilepaths = await convertTypeDeclaration({
            typeName,
            typeDeclaration,
            file,
            typeResolver,
            exampleResolver,
            sourceResolver,
            workspace
          });
          const convertedTypeDeclaration = convertedTypeDeclarationWithFilepaths.typeDeclaration;
          if (disableExamples) {
            convertedTypeDeclaration.userProvidedExamples = [];
            convertedTypeDeclaration.autogeneratedExamples = [];
          }
          const subpackageFilepaths = convertedTypeDeclarationWithFilepaths.descendantFilepaths;
          const typeId = IdGenerator.generateTypeId(convertedTypeDeclaration.name);
          intermediateRepresentation.types[typeId] = convertedTypeDeclaration;
          packageTreeGenerator.addType(typeId, convertedTypeDeclaration);
          irGraph.addType({
            declaredTypeName: convertedTypeDeclaration.name,
            descendantTypeIds: convertedTypeDeclaration.referencedTypes,
            descendantTypeIdsByAudience: {},
            propertiesByAudience: convertedTypeDeclarationWithFilepaths.propertiesByAudience,
            descendantFilepaths: subpackageFilepaths
          });
          irGraph.markTypeForAudiences(convertedTypeDeclaration.name, getAudiences(typeDeclaration));
        }
      },
      errors: (errors) => {
        if (errors == null) {
          return;
        }
        const errorDiscriminationSchema = workspace.definition.rootApiFile.contents["error-discrimination"];
        if (errorDiscriminationSchema == null) {
          throw new Error("error-discrimination is missing in api.yml but there are declared errors.");
        }
        for (const [errorName, errorDeclaration] of Object.entries(errors)) {
          const convertedErrorDeclaration = convertErrorDeclaration({
            errorName,
            errorDeclaration,
            file,
            typeResolver,
            exampleResolver,
            workspace
          });
          const errorId = IdGenerator.generateErrorId(convertedErrorDeclaration.name);
          intermediateRepresentation.errors[errorId] = convertedErrorDeclaration;
          packageTreeGenerator.addError(errorId, convertedErrorDeclaration);
          irGraph.addError(convertedErrorDeclaration);
        }
      },
      service: async (service) => {
        if (service == null) {
          return;
        }
        const convertedHttpService = await convertHttpService({
          rootDefaultUrl: file.defaultUrl ?? workspace.definition.rootApiFile.contents["default-url"],
          rootPathParameters: intermediateRepresentation.pathParameters,
          serviceDefinition: service,
          file,
          errorResolver,
          typeResolver,
          propertyResolver,
          exampleResolver,
          sourceResolver,
          globalErrors,
          variableResolver,
          workspace
        });
        const serviceId = IdGenerator.generateServiceId(convertedHttpService.name);
        intermediateRepresentation.services[serviceId] = convertedHttpService;
        packageTreeGenerator.addService(serviceId, convertedHttpService);
        const convertedEndpoints = {};
        convertedHttpService.endpoints.forEach((httpEndpoint) => {
          if (disableExamples) {
            httpEndpoint.autogeneratedExamples = [];
            httpEndpoint.userSpecifiedExamples = [];
          }
          const rawEndpointSchema = service.endpoints[httpEndpoint.name.originalName];
          irGraph.addEndpoint(convertedHttpService, httpEndpoint, rawEndpointSchema);
          convertedEndpoints[httpEndpoint.name.originalName] = httpEndpoint;
        });
        if (service.audiences != null) {
          irGraph.markEndpointForAudience(convertedHttpService.name, convertedHttpService.endpoints, service.audiences);
        }
        Object.entries(service.endpoints).map(([endpointId, endpoint]) => {
          const convertedEndpoint = convertedEndpoints[endpointId];
          if (convertedEndpoint != null && endpoint.audiences != null) {
            irGraph.markEndpointForAudience(convertedHttpService.name, [convertedEndpoint], endpoint.audiences);
          }
        });
      },
      webhooks: async (webhooks) => {
        if (webhooks == null) {
          return;
        }
        const webhookGroupId = IdGenerator.generateWebhookGroupId(file.fernFilepath);
        const convertedWebhookGroup = await convertWebhookGroup({
          webhooks,
          file,
          typeResolver,
          exampleResolver,
          workspace
        });
        const webhooksByOriginalName = {};
        for (const convertedWebhook of convertedWebhookGroup) {
          webhooksByOriginalName[convertedWebhook.name.originalName] = convertedWebhook;
        }
        Object.entries(webhooks).forEach(([key, webhook]) => {
          const irWebhook = webhooksByOriginalName[key];
          if (irWebhook != null) {
            irGraph.addWebhook(file, irWebhook, webhook);
            if (webhook.audiences != null) {
              irGraph.markWebhookForAudiences(file, irWebhook, webhook.audiences);
            }
          }
        });
        intermediateRepresentation.webhookGroups[webhookGroupId] = convertedWebhookGroup;
        packageTreeGenerator.addWebhookGroup(webhookGroupId, file.fernFilepath);
      },
      channel: async (channel) => {
        if (channel == null) {
          return;
        }
        const websocketChannelId = IdGenerator.generateWebSocketChannelId(file.fernFilepath);
        const websocketChannel = await convertChannel({
          channel,
          file,
          variableResolver,
          typeResolver,
          exampleResolver,
          workspace
        });
        if (intermediateRepresentation.websocketChannels != null) {
          intermediateRepresentation.websocketChannels[websocketChannelId] = websocketChannel;
          packageTreeGenerator.addWebSocketChannel(websocketChannelId, file.fernFilepath);
        }
      }
    });
  };
  await visitAllDefinitionFiles(workspace, async (relativeFilepath, file, metadata) => {
    await visitDefinitionFile(constructFernFileContext({
      relativeFilepath,
      definitionFile: file,
      casingsGenerator,
      rootApiFile: workspace.definition.rootApiFile.contents,
      defaultUrl: metadata.defaultUrl
    }));
  });
  await visitAllPackageMarkers(workspace, async (relativeFilepath, packageMarker) => {
    if (packageMarker.navigation == null) {
      return;
    }
    if (typeof packageMarker.navigation === "string") {
      packageTreeGenerator.addPackageRedirection({
        from: convertToFernFilepath({ relativeFilepath, casingsGenerator }),
        to: convertToFernFilepath({
          relativeFilepath: join(dirname(relativeFilepath), RelativeFilePath.of(packageMarker.navigation)),
          casingsGenerator
        })
      });
    } else {
      const childrenInOrder = packageMarker.navigation.map((childFilepath) => {
        return IdGenerator.generateSubpackageId(convertToFernFilepath({
          relativeFilepath: join(dirname(relativeFilepath), RelativeFilePath.of(childFilepath)),
          casingsGenerator
        }));
      });
      if (relativeFilepath === FERN_PACKAGE_MARKER_FILENAME) {
        packageTreeGenerator.sortRootPackage(childrenInOrder);
      } else {
        packageTreeGenerator.sortSubpackage(IdGenerator.generateSubpackageId(convertToFernFilepath({
          relativeFilepath,
          casingsGenerator
        })), childrenInOrder);
      }
    }
  });
  intermediateRepresentation.serviceTypeReferenceInfo = computeServiceTypeReferenceInfo(irGraph);
  const intermediateRepresentationWithGeneratedExamples = disableExamples ? intermediateRepresentation : injectAutogeneratedExamples(intermediateRepresentation, context, !includeOptionalRequestPropertyExamples);
  const workspaceDefinitionRootApiFileContents = workspace.definition.rootApiFile.contents;
  const environments = convertEnvironments({
    casingsGenerator,
    rawApiFileSchema: workspaceDefinitionRootApiFileContents
  });
  const ignoreAudiences = environments?.environments._visit({
    singleBaseUrl: (value) => {
      return value.environments.filter((environment) => {
        return getAudienceForEnvironment(environment.id, workspaceDefinitionRootApiFileContents.environments) != null;
      }).length === 0;
    },
    multipleBaseUrls: (value) => {
      return value.environments.filter((environment) => {
        return getAudienceForEnvironment(environment.id, workspaceDefinitionRootApiFileContents.environments) != null;
      }).length === 0;
    },
    _other: () => false
  });
  environments?.environments.environments.forEach((environment) => {
    irGraph.markEnvironmentForAudiences(environment, getAudienceForEnvironment(environment.id, workspaceDefinitionRootApiFileContents.environments) ?? [], ignoreAudiences);
  });
  const filteredIr = !irGraph.hasNoAudiences() ? irGraph.build() : void 0;
  const intermediateRepresentationForAudiences = filterIntermediateRepresentationForAudiences(intermediateRepresentationWithGeneratedExamples, filteredIr);
  const isAuthMandatory = workspace.definition.rootApiFile.contents.auth != null && Object.values(intermediateRepresentationForAudiences.services).every((service) => {
    return service.endpoints.every((endpoint) => endpoint.auth);
  });
  const hasStreamingEndpoints = Object.values(intermediateRepresentationForAudiences.services).some((service) => {
    return service.endpoints.some((endpoint) => endpoint.response?.body?.type === "streaming");
  });
  const hasPaginatedEndpoints = Object.values(intermediateRepresentationForAudiences.services).some((service) => {
    return service.endpoints.some((endpoint) => endpoint.pagination != null);
  });
  const hasFileDownloadEndpoints = Object.values(intermediateRepresentationForAudiences.services).some((service) => {
    return service.endpoints.some((endpoint) => endpoint.response?.body?.type === "fileDownload");
  });
  const sdkConfig = {
    isAuthMandatory,
    hasStreamingEndpoints,
    hasPaginatedEndpoints,
    hasFileDownloadEndpoints,
    platformHeaders: {
      language: "X-Fern-Language",
      sdkName: "X-Fern-SDK-Name",
      sdkVersion: "X-Fern-SDK-Version",
      userAgent: version != null && packageName != null ? {
        header: "User-Agent",
        value: `${packageName}/${version}`
      } : void 0
    }
  };
  const readmeConfig = readme != null ? convertReadmeConfig({ readme, services: intermediateRepresentation.services }) : void 0;
  const { types: types2, services } = addExtendedPropertiesToIr(intermediateRepresentationForAudiences);
  const finalIR = {
    ...intermediateRepresentationForAudiences,
    ...packageTreeGenerator.build(filteredIr),
    types: types2,
    services,
    sdkConfig,
    readmeConfig
  };
  return {
    ...finalIR,
    dynamic: await convertIrToDynamicSnippetsIr(finalIR)
  };
}
function injectAutogeneratedExamples(ir, context, skipOptionalRequestProperties) {
  for (const [_, service] of Object.entries(ir.services)) {
    for (const endpoint of service.endpoints) {
      context.logger.debug(`Generating example for ${endpoint.id}`);
      const generatedExample = generateEndpointExample({
        ir,
        service,
        endpoint,
        typeDeclarations: ir.types,
        skipOptionalRequestProperties: skipOptionalRequestProperties ?? true,
        generationResponse: { type: "success" }
      });
      if (generatedExample.type === "failure") {
        context.logger.debug(`Failed to generate example for ${endpoint.id}. ${generatedExample.message}`);
        continue;
      }
      const { example } = generatedExample;
      endpoint.autogeneratedExamples = [{ example }];
    }
  }
  return ir;
}
function computeServiceTypeReferenceInfo(irGraph) {
  const typesReferencedOnlyByService = {};
  const sharedTypes = [];
  const typesReferencedByService = irGraph.getTypesReferencedByService();
  for (const [typeId, serviceIds] of Object.entries(typesReferencedByService)) {
    if (serviceIds.size === 1) {
      const serviceId = serviceIds.values().next().value;
      if (typesReferencedOnlyByService[serviceId] === void 0) {
        typesReferencedOnlyByService[serviceId] = [];
      }
      typesReferencedOnlyByService[serviceId]?.push(typeId);
      continue;
    }
    sharedTypes.push(typeId);
  }
  return {
    typesReferencedOnlyByService,
    sharedTypes
  };
}
function filterIntermediateRepresentationForAudiences(intermediateRepresentation, filteredIr) {
  if (filteredIr == null) {
    return intermediateRepresentation;
  }
  const filteredTypes = pickBy_default(intermediateRepresentation.types, (type2) => filteredIr.hasType(type2));
  const filteredTypesAndProperties = Object.fromEntries(Object.entries(filteredTypes).map(([typeId, typeDeclaration]) => {
    const filteredProperties = [];
    typeDeclaration.userProvidedExamples = typeDeclaration.userProvidedExamples.map((example) => filterExampleType({ filteredIr, exampleType: example })).filter((ex) => ex !== void 0);
    if (typeDeclaration.shape.type === "object") {
      for (const property4 of typeDeclaration.shape.properties) {
        const hasProperty = filteredIr.hasProperty(typeId, property4.name.wireValue);
        if (hasProperty) {
          filteredProperties.push(property4);
        }
      }
      return [
        typeId,
        {
          ...typeDeclaration,
          shape: Type.object({
            ...typeDeclaration.shape,
            properties: filteredProperties
          })
        }
      ];
    }
    return [typeId, typeDeclaration];
  }));
  const filteredWebhookGroups = Object.fromEntries(Object.entries(intermediateRepresentation.webhookGroups).map(([webhookGroupId, webhookGroup]) => {
    const filteredWebhooks = webhookGroup.filter((webhook) => filteredIr.hasWebhook(webhook)).map((webhook) => {
      const webhookId = webhook.id;
      if (webhook.payload.type === "inlinedPayload" && webhookId != null) {
        webhook.payload = {
          ...webhook.payload,
          properties: webhook.payload.properties.filter((property4) => {
            return filteredIr.hasWebhookPayloadProperty(webhookId, property4.name.wireValue);
          })
        };
      }
      return webhook;
    });
    return [webhookGroupId, filteredWebhooks];
  }));
  const filteredEnvironmentsConfig = intermediateRepresentation.environments;
  if (filteredEnvironmentsConfig) {
    switch (filteredEnvironmentsConfig.environments.type) {
      case "singleBaseUrl": {
        filteredEnvironmentsConfig.environments.environments = filteredEnvironmentsConfig.environments.environments.filter((environment) => filteredIr.hasEnvironmentId(environment.id));
        break;
      }
      case "multipleBaseUrls": {
        filteredEnvironmentsConfig.environments.environments = filteredEnvironmentsConfig.environments.environments.filter((environment) => filteredIr.hasEnvironmentId(environment.id));
        break;
      }
    }
    if (filteredEnvironmentsConfig.defaultEnvironment) {
      if (!filteredIr.hasEnvironmentId(filteredEnvironmentsConfig.defaultEnvironment)) {
        filteredEnvironmentsConfig.defaultEnvironment = void 0;
      }
    }
  }
  return {
    ...intermediateRepresentation,
    environments: filteredEnvironmentsConfig,
    types: filteredTypesAndProperties,
    errors: pickBy_default(intermediateRepresentation.errors, (error) => filteredIr.hasError(error)),
    services: mapValues_default(pickBy_default(intermediateRepresentation.services, (httpService) => filteredIr.hasService(httpService)), (httpService) => ({
      ...httpService,
      endpoints: httpService.endpoints.filter((httpEndpoint) => filteredIr.hasEndpoint(httpEndpoint)).map((httpEndpoint) => {
        httpEndpoint.autogeneratedExamples = httpEndpoint.autogeneratedExamples.map((autogenerated) => {
          return {
            ...autogenerated,
            example: filterEndpointExample({ filteredIr, example: autogenerated.example })
          };
        });
        httpEndpoint.userSpecifiedExamples = httpEndpoint.userSpecifiedExamples.map((userSpecified) => {
          return {
            ...userSpecified,
            example: userSpecified.example != null ? filterEndpointExample({ filteredIr, example: userSpecified.example }) : void 0
          };
        });
        if (httpEndpoint.queryParameters.length > 0) {
          httpEndpoint.queryParameters = httpEndpoint.queryParameters.filter((queryParameter) => {
            return filteredIr.hasQueryParameter(httpEndpoint.id, queryParameter.name.wireValue);
          });
        }
        if (httpEndpoint.requestBody?.type === "inlinedRequestBody") {
          return {
            ...httpEndpoint,
            requestBody: {
              ...httpEndpoint.requestBody,
              properties: httpEndpoint.requestBody.properties.filter((property4) => {
                return filteredIr.hasRequestProperty(httpEndpoint.id, property4.name.wireValue);
              })
            }
          };
        }
        return httpEndpoint;
      })
    })),
    webhookGroups: filteredWebhookGroups,
    serviceTypeReferenceInfo: filterServiceTypeReferenceInfoForAudiences(intermediateRepresentation.serviceTypeReferenceInfo, filteredIr)
  };
}
function filterServiceTypeReferenceInfoForAudiences(serviceTypeReferenceInfo, filteredIr) {
  if (filteredIr == null) {
    return serviceTypeReferenceInfo;
  }
  const filteredTypesReferencedOnlyByService = {};
  Object.entries(serviceTypeReferenceInfo.typesReferencedOnlyByService).forEach(([key, values]) => {
    if (filteredIr.hasServiceId(key)) {
      filteredTypesReferencedOnlyByService[key] = values.filter((value) => filteredIr.hasTypeId(value));
    }
  });
  return {
    sharedTypes: serviceTypeReferenceInfo.sharedTypes.filter((typeId) => filteredIr.hasTypeId(typeId)),
    typesReferencedOnlyByService: filteredTypesReferencedOnlyByService
  };
}

// ../../cli/generation/source-resolver/lib/NopSourceResolver.js
var NopSourceResolver = class {
  async resolveSource({ source }) {
    return void 0;
  }
  async resolveSourceOrThrow({ source }) {
    return void 0;
  }
};

// src/utils/NopLogger.ts
var NopLogger = class {
  disable() {
  }
  enable() {
  }
  debug(...args) {
  }
  info(...args) {
  }
  warn(...args) {
  }
  error(...args) {
  }
  log(level, ...args) {
  }
};

// src/utils/createTaskContext.ts
function createTaskContext() {
  const context = {
    logger: new NopLogger(),
    takeOverTerminal: async (run) => {
    },
    failAndThrow: (_message, _error) => {
      throw new Error("unimplemented");
    },
    failWithoutThrowing: (_message, _error) => {
    },
    getResult: () => 0 /* Success */,
    addInteractiveTask: () => {
      throw new Error("unimplemented");
    },
    runInteractiveTask: async (_params, _run) => {
      return false;
    },
    instrumentPostHogEvent: async (_event) => {
    }
  };
  return context;
}

// ../../cli/workspace/browser-compatible-fern-workspace/lib/InMemoryOpenAPILoader.js
var import_openapi_core2 = __toESM(require_lib2(), 1);
var InMemoryOpenAPILoader = class {
  async loadDocument(spec) {
    return {
      type: "openapi",
      value: await this.loadParsedOpenAPI({
        openapi: spec.parsed,
        overrides: spec.overrides
      }),
      settings: spec.settings
    };
  }
  async loadParsedOpenAPI({ openapi, overrides }) {
    const parsed = await this.parseOpenAPI({
      parsed: openapi
    });
    if (overrides != null) {
      const merged = await mergeWithOverrides({ data: parsed, overrides });
      return await this.parseOpenAPI({
        parsed: merged
      });
    }
    return parsed;
  }
  async parseOpenAPI({ parsed }) {
    const result = await (0, import_openapi_core2.bundle)({
      ...DEFAULT_OPENAPI_BUNDLE_OPTIONS,
      doc: {
        source: new import_openapi_core2.Source("<memory>", "<openapi>"),
        parsed
      }
    });
    return result.bundle.parsed;
  }
};

// ../../cli/workspace/browser-compatible-fern-workspace/lib/OpenAPIWorkspace.js
var IN_MEMORY_ABSOLUTE_FILEPATH = AbsoluteFilePath.of("/<memory>");
var DEFAULT_WORKSPACE_ARGS = {
  absoluteFilePath: IN_MEMORY_ABSOLUTE_FILEPATH,
  cliVersion: "<unknown>",
  workspaceName: "anonymous"
};
var OpenAPIWorkspace = class extends BaseOpenAPIWorkspace {
  spec;
  loader;
  constructor({ spec, generatorsConfiguration }) {
    super({
      ...DEFAULT_WORKSPACE_ARGS,
      generatorsConfiguration,
      respectReadonlySchemas: spec.settings?.respectReadonlySchemas ?? false,
      onlyIncludeReferencedSchemas: spec.settings?.onlyIncludeReferencedSchemas ?? false,
      inlinePathParameters: spec.settings?.inlinePathParameters ?? false,
      objectQueryParameters: spec.settings?.objectQueryParameters ?? false
    });
    this.spec = spec;
    this.loader = new InMemoryOpenAPILoader();
  }
  async getOpenAPIIr({ context }, settings) {
    const optionOverrides = getOptionsOverridesFromSettings(settings);
    const document = await this.loader.loadDocument(this.spec);
    return await parse({
      context,
      documents: [document],
      options: {
        ...optionOverrides,
        respectReadonlySchemas: this.respectReadonlySchemas,
        onlyIncludeReferencedSchemas: this.onlyIncludeReferencedSchemas
      }
    });
  }
  getAbsoluteFilePaths() {
    return [];
  }
};

// src/utils/convertAPIToWorkspace.ts
async function convertAPIToWorkspace({
  context,
  api,
  generatorsConfiguration,
  settings
}) {
  switch (api.type) {
    case "openapi": {
      const openapi = new OpenAPIWorkspace({
        spec: {
          parsed: api.openapi,
          overrides: api.overrides
        },
        generatorsConfiguration
      });
      return await openapi.toFernWorkspace({ context }, settings);
    }
  }
}

// src/generateDynamicIR.ts
async function generateDynamicIR({
  api,
  language,
  generatorsConfiguration,
  settings,
  audiences,
  keywords,
  smartCasing
}) {
  const context = createTaskContext();
  const workspace = await convertAPIToWorkspace({ context, api, generatorsConfiguration, settings });
  const ir = await generateIntermediateRepresentation({
    context,
    workspace,
    generationLanguage: language,
    audiences: audiences ?? { type: "all" },
    keywords,
    sourceResolver: new NopSourceResolver(),
    smartCasing: smartCasing ?? false,
    disableExamples: true,
    version: void 0,
    packageName: void 0,
    readme: void 0
  });
  if (ir.dynamic == null) {
    throw new Error("Internal error; failed to generate dynamic intermediate representation");
  }
  return ir.dynamic;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  generateDynamicIR
});
/*! Bundled license information:

uri-js/dist/es5/uri.all.js:
  (** @license URI.js v4.4.1 (c) 2011 Gary Court. License: http://github.com/garycourt/uri-js *)

lodash-es/lodash.js:
  (**
   * @license
   * Lodash (Custom Build) <https://lodash.com/>
   * Build: `lodash modularize exports="es" -o ./`
   * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
   * Released under MIT license <https://lodash.com/license>
   * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
   * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
   *)

js-yaml/dist/js-yaml.mjs:
  (*! js-yaml 4.1.0 https://github.com/nodeca/js-yaml @license MIT *)
*/
